c--- routines computing the three-jet matrix elements
c--- required to construct the cross section in sig.f

      subroutine tjmeRR(y,z,AR,BR,CR,DR,ER,FR)
      implicit none
      real*8 y,z
      real*8 t
      real*8 AR,BR,CR,DR,ER,FR
      real*8 zeta2,zeta3,zeta4,pi
      integer nmax
      real*8 HZ1,HZ2,HZ3,HZ4,GYZ1,GYZ2,GYZ3,GYZ4
      dimension HZ1(0:1),HZ2(0:1,0:1),HZ3(0:1,0:1,0:1), 
     $          HZ4(0:1,0:1,0:1,0:1), 
     $          GYZ1(0:3),GYZ2(0:3,0:3),GYZ3(0:3,0:3,0:3), 
     $          GYZ4(0:3,0:3,0:3,0:3)       
      parameter (zeta2=1.64493406684822644d0)
      parameter (zeta3=1.20205690315959429d0)
      parameter (zeta4=1.08232323371113819d0)
      parameter (pi=3.141592653589793238d0)
      
      nmax = 4
      call tdhpl(y,z,nmax,GYZ1,GYZ2,GYZ3,GYZ4,HZ1,HZ2,HZ3,HZ4)
      t = y/z+z/y+2./y/z-2./y-2./z

      AR = 0.
     &
      AR = AR + y**(-1) * (
     &     + 68./3.
     &     )
      AR = AR + z*(1-y)**(-2) * (
     &     - 68./3.*GYZ1(0)
     &     )
      AR = AR + z*(1-y)**(-1) * (
     &     - 68./3.
     &     - 68*GYZ1(0)
     &     )
      AR = AR + (1-y)**(-1) * (
     &     + 272./3.*GYZ1(0)
     &     )
      AR = AR + t*zeta2 * (
     &     - 190./9.
     &     + 25./12.*GYZ1(0)
     &     - 6*GYZ1(2)
     &     + 25./12.*HZ1(0)
     &     + 6*HZ1(1)
     &     )
      AR = AR + t*zeta3 * (
     &     - 863./18.
     &     + 8*GYZ1(2)
     &     - 8*HZ1(1)
     &     )
      AR = AR + t*zeta4 * (
     &     - 27./4.
     &     )
      AR = AR + t * (
     &     + 467951./2592.
     &     - 12745./216.*GYZ1(0)
     &     - 68./3.*GYZ1(0)*HZ1(0)
     &     + 29./8.*GYZ1(2)
     &     + 68./3.*GYZ2(1,0)
     &     - 12745./216.*HZ1(0)
     &     - 29./8.*HZ1(1)
     &     - 68./3.*HZ2(1,0)
     &     )

      BR = 0.
     &
      BR = BR + y**(-1)*z * (
     &     + 136./3.*GYZ1(2)*HZ1(0)
     &     + 136./3.*GYZ1(3)*HZ1(1)
     &     - 136./3.*GYZ2(3,2)
     &     )
      BR = BR + y**(-1) * (
     &     + 79./6.
     &     - 272./3.*GYZ1(2)*HZ1(0)
     &     - 272./3.*GYZ1(3)*HZ1(1)
     &     + 272./3.*GYZ2(3,2)
     &     )
      BR = BR + z*(1-y)**(-2) * (
     &     + 193./6.*GYZ1(0)
     &     )
      BR = BR + z*(1-y)**(-1) * (
     &     + 193./6.
     &     + 193./2.*GYZ1(0)
     &     )
      BR = BR + (1-y)**(-1) * (
     &     - 250./3.*GYZ1(0)
     &     )
      BR = BR + (y+z)**(-2) * (
     &     - 136./3.*GYZ1(2)
     &     + 136./3.*HZ1(1)
     &     )
      BR = BR + (y+z)**(-1) * (
     &     - 136./3.
     &     )
      BR = BR + t*zeta2 * (
     &     + 181./12.
     &     - 1./4.*GYZ1(2)
     &     + 1./4.*HZ1(1)
     &     )
      BR = BR + t*zeta3 * (
     &     + 515./36.
     &     - GYZ1(2)
     &     + HZ1(1)
     &     )
      BR = BR + t*zeta4 * (
     &     + 5./8.
     &     )
      BR = BR + t * (
     &     - 10501./324.
     &     + 95./6.*GYZ1(0)
     &     + 19./2.*GYZ1(0)*HZ1(0)
     &     - 68./3.*GYZ1(0)*HZ1(1)
     &     + 5389./108.*GYZ1(2)
     &     + 68./3.*GYZ1(2)*HZ1(0)
     &     + 136./3.*GYZ1(3)*HZ1(1)
     &     + 68./3.*GYZ2(0,2)
     &     - 193./6.*GYZ2(1,0)
     &     + 68./3.*GYZ2(2,0)
     &     - 136./3.*GYZ2(3,2)
     &     + 95./6.*HZ1(0)
     &     - 5389./108.*HZ1(1)
     &     + 68./3.*HZ2(0,1)
     &     )
      BR = BR + t * (
     &     + 19./2.*HZ2(1,0)
     &     )
      BR = BR - 68./3.*GYZ1(0)
     &     - 136./3.*GYZ1(0)*HZ1(1)
     &     + 136./3.*GYZ1(2)
     &     + 136./3.*GYZ1(2)*HZ1(0)
     &     + 272./3.*GYZ1(3)*HZ1(1)
     &     + 136./3.*GYZ2(0,2)
     &     - 136./3.*GYZ2(1,0)
     &     + 136./3.*GYZ2(2,0)
     &     - 272./3.*GYZ2(3,2)
     &     - 68./3.*HZ1(0)
     &     - 136./3.*HZ1(1)
     &     + 136./3.*HZ2(0,1)
     &

      CR = 0.
     &
      CR = CR + y**(-1)*z * (
     &     - 19*GYZ1(2)*HZ1(0)
     &     - 19*GYZ1(3)*HZ1(1)
     &     + 19*GYZ2(3,2)
     &     )
      CR = CR + y**(-1) * (
     &     - 19./2.
     &     + 38*GYZ1(2)*HZ1(0)
     &     + 38*GYZ1(3)*HZ1(1)
     &     - 38*GYZ2(3,2)
     &     )
      CR = CR + z*(1-y)**(-2) * (
     &     - 19./2.*GYZ1(0)
     &     )
      CR = CR + z*(1-y)**(-1) * (
     &     - 19./2.
     &     - 57./2.*GYZ1(0)
     &     )
      CR = CR + (1-y)**(-1) * (
     &     + 19*GYZ1(0)
     &     )
      CR = CR + (y+z)**(-2) * (
     &     + 19*GYZ1(2)
     &     - 19*HZ1(1)
     &     )
      CR = CR + (y+z)**(-1) * (
     &     + 19
     &     )
      CR = CR + t*zeta2 * (
     &     - 29./4.
     &     + 3*GYZ1(2)
     &     - 3*HZ1(1)
     &     )
      CR = CR + t*zeta3 * (
     &     + 15./2.
     &     - 6*GYZ1(2)
     &     + 6*HZ1(1)
     &     )
      CR = CR + t*zeta4 * (
     &     + 11./2.
     &     )
      CR = CR + t * (
     &     - 517./32.
     &     + 19./2.*GYZ1(0)*HZ1(1)
     &     - 117./8.*GYZ1(2)
     &     - 19./2.*GYZ1(2)*HZ1(0)
     &     - 19*GYZ1(3)*HZ1(1)
     &     - 19./2.*GYZ2(0,2)
     &     + 19./2.*GYZ2(1,0)
     &     - 19./2.*GYZ2(2,0)
     &     + 19*GYZ2(3,2)
     &     + 117./8.*HZ1(1)
     &     - 19./2.*HZ2(0,1)
     &     )
      CR = CR + 19./2.*GYZ1(0)
     &     + 19*GYZ1(0)*HZ1(1)
     &     - 19*GYZ1(2)
     &     - 19*GYZ1(2)*HZ1(0)
     &     - 38*GYZ1(3)*HZ1(1)
     &     - 19*GYZ2(0,2)
     &     + 19*GYZ2(1,0)
     &     - 19*GYZ2(2,0)
     &     + 38*GYZ2(3,2)
     &     + 19./2.*HZ1(0)
     &     + 19*HZ1(1)
     &     - 19*HZ2(0,1)
     &

      DR = 0.
     &
      DR = DR + y**(-1) * (
     &     - 2
     &     )
      DR = DR + z*(1-y)**(-2) * (
     &     + 2*GYZ1(0)
     &     )
      DR = DR + z*(1-y)**(-1) * (
     &     + 2
     &     + 6*GYZ1(0)
     &     )
      DR = DR + (1-y)**(-1) * (
     &     - 8*GYZ1(0)
     &     )
      DR = DR + t*zeta2 * (
     &     + 25./36.
     &     + 1./6.*GYZ1(0)
     &     + 1./6.*HZ1(0)
     &     )
      DR = DR + t*zeta3 * (
     &     + 43./9.
     &     )
      DR = DR + t * (
     &     - 1355./27.
     &     + 35./3.*GYZ1(0)
     &     + 2*GYZ1(0)*HZ1(0)
     &     - 2*GYZ2(1,0)
     &     + 35./3.*HZ1(0)
     &     + 2*HZ2(1,0)
     &     )

      ER = 0.
     &
      ER = ER + y**(-1)*z * (
     &     - 4*GYZ1(2)*HZ1(0)
     &     - 4*GYZ1(3)*HZ1(1)
     &     + 4*GYZ2(3,2)
     &     )
      ER = ER + y**(-1) * (
     &     - 2
     &     + 8*GYZ1(2)*HZ1(0)
     &     + 8*GYZ1(3)*HZ1(1)
     &     - 8*GYZ2(3,2)
     &     )
      ER = ER + z*(1-y)**(-2) * (
     &     - 2*GYZ1(0)
     &     )
      ER = ER + z*(1-y)**(-1) * (
     &     - 2
     &     - 6*GYZ1(0)
     &     )
      ER = ER + (1-y)**(-1) * (
     &     + 4*GYZ1(0)
     &     )
      ER = ER + (y+z)**(-2) * (
     &     + 4*GYZ1(2)
     &     - 4*HZ1(1)
     &     )
      ER = ER + (y+z)**(-1) * (
     &     + 4
     &     )
      ER = ER + t*zeta2 * (
     &     + 7./6.
     &     - 1./2.*GYZ1(2)
     &     + 1./2.*HZ1(1)
     &     )
      ER = ER + t*zeta3 * (
     &     - 73./18.
     &     )
      ER = ER + t * (
     &     + 2189./162.
     &     - 11./6.*GYZ1(0)
     &     + 2*GYZ1(0)*HZ1(1)
     &     - 154./27.*GYZ1(2)
     &     - 2*GYZ1(2)*HZ1(0)
     &     - 4*GYZ1(3)*HZ1(1)
     &     - 2*GYZ2(0,2)
     &     + 2*GYZ2(1,0)
     &     - 2*GYZ2(2,0)
     &     + 4*GYZ2(3,2)
     &     - 11./6.*HZ1(0)
     &     + 154./27.*HZ1(1)
     &     - 2*HZ2(0,1)
     &     )
      ER = ER + 2*GYZ1(0)
     &     + 4*GYZ1(0)*HZ1(1)
     &     - 4*GYZ1(2)
     &     - 4*GYZ1(2)*HZ1(0)
     &     - 8*GYZ1(3)*HZ1(1)
     &     - 4*GYZ2(0,2)
     &     + 4*GYZ2(1,0)
     &     - 4*GYZ2(2,0)
     &     + 8*GYZ2(3,2)
     &     + 2*HZ1(0)
     &     + 4*HZ1(1)
     &     - 4*HZ2(0,1)
     &

      FR = 0.
     &
      FR = FR + t*zeta2 * (
     &     + 1./6.
     &     )
      FR = FR + t * (
     &     + 182./81.
     &     - 13./27.*GYZ1(0)
     &     - 1./18.*GYZ1(0)*HZ1(0)
     &     + 1./18.*GYZ2(0,0)
     &     - 13./27.*HZ1(0)
     &     + 1./18.*HZ2(0,0)
     &     )

      return
      end

      subroutine tjme20(y,z,A20,B20,C20,D20,E20,F20,G20)
      implicit none
      real*8 y,z
      real*8 t
      real*8 A20,B20,C20,D20,E20,F20,G20
      real*8 zeta2,zeta3,zeta4
      integer nmax
      real*8 HZ1,HZ2,HZ3,HZ4,GYZ1,GYZ2,GYZ3,GYZ4
      dimension HZ1(0:1),HZ2(0:1,0:1),HZ3(0:1,0:1,0:1), 
     $          HZ4(0:1,0:1,0:1,0:1), 
     $          GYZ1(0:3),GYZ2(0:3,0:3),GYZ3(0:3,0:3,0:3), 
     $          GYZ4(0:3,0:3,0:3,0:3)       
      parameter (zeta2=1.64493406684822644d0)
      parameter (zeta3=1.20205690315959429d0)
      parameter (zeta4=1.08232323371113819d0)
      
      nmax = 4
      call tdhpl(y,z,nmax,GYZ1,GYZ2,GYZ3,GYZ4,HZ1,HZ2,HZ3,HZ4)
      t = y/z+z/y+2./y/z-2./y-2./z

      A20 = 0.
     +
      A20 = A20 + y**(-1)*z*zeta2 * (
     +     + 1
     +     - 6*GYZ1(1)
     +     + 3*HZ1(0)
     +     )
      A20 = A20 + y**(-1)*z*zeta3 * (
     +     - 6
     +     )
      A20 = A20 + y**(-1)*z * (
     +     + 13./4.*GYZ2(1,0)
     +     - 3*GYZ2(1,0)*HZ1(0)
     +     + 6*GYZ3(1,1,0)
     +     + 2./3.*HZ1(0)
     +     + 13./4.*HZ2(1,0)
     +     - 3*HZ3(0,1,0)
     +     )
      A20 = A20 + y**(-1)*(y+z)**(-1) * (
     +     + 17./2.*GYZ2(1,0)
     +     + 17./2.*HZ2(1,0)
     +     )
      A20 = A20 + y**(-1)*zeta2 * (
     +     - 2
     +     + 8*GYZ1(1)
     +     - 4*HZ1(0)
     +     )
      A20 = A20 + y**(-1)*zeta3 * (
     +     + 8
     +     )
      A20 = A20 + y**(-1) * (
     +     + 457./36.
     +     - 16./3.*GYZ1(0)
     +     - GYZ1(0)*HZ1(0)
     +     - 13./2.*GYZ2(1,0)
     +     + 4*GYZ2(1,0)*HZ1(0)
     +     - 8*GYZ3(1,1,0)
     +     - 7./3.*HZ1(0)
     +     )
      A20 = A20 + y**(-1) * (
     +     - 17./2.*HZ2(1,0)
     +     + 4*HZ3(0,1,0)
     +     )
      A20 = A20 + z*(1.-y)**(-2)*zeta2 * (
     +     - 1./6.
     +     + 3*GYZ1(0)
     +     - 2*GYZ1(1)
     +     - GYZ1(2)
     +     + HZ1(0)
     +     + HZ1(1)
     +     )
      A20 = A20 + z*(1.-y)**(-2)*zeta3 * (
     +     + 1
     +     )
      A20 = A20 + z*(1.-y)**(-2) * (
     +     - 355./36.*GYZ1(0)
     +     + 5./3.*GYZ1(0)*HZ1(0)
     +     + GYZ1(0)*HZ2(1,0)
     +     - GYZ1(2)*HZ2(1,0)
     +     + 15./2.*GYZ2(0,0)
     +     + 2*GYZ2(0,0)*HZ1(0)
     +     + 1./6.*GYZ2(1,0)
     +     )
      A20 = A20 + z*(1.-y)**(-2) * (
     +     - GYZ2(2,0)*HZ1(0)
     +     - 3*GYZ3(0,1,0)
     +     - 2*GYZ3(1,0,0)
     +     + 2*GYZ3(1,1,0)
     +     + GYZ3(2,1,0)
     +     + HZ3(0,1,0)
     +     + HZ3(1,1,0)
     +     )
      A20 = A20 + z*(1.-y)**(-1)*zeta2 * (
     +     - 11./2.
     +     + 9*GYZ1(0)
     +     - 6*GYZ1(1)
     +     - 3*GYZ1(2)
     +     + 3*HZ1(0)
     +     + 3*HZ1(1)
     +     )
      A20 = A20 + z*(1.-y)**(-1)*zeta3 * (
     +     + 3
     +     )
      A20 = A20 + z*(1.-y)**(-1) * (
     +     - 277./36.
     +     - 205./12.*GYZ1(0)
     +     + 6*GYZ1(0)*HZ1(0)
     +     + 3*GYZ1(0)*HZ2(1,0)
     +     - 3*GYZ1(2)*HZ2(1,0)
     +     + 33./2.*GYZ2(0,0)
     +     + 6*GYZ2(0,0)*HZ1(0)
     +     )
      A20 = A20 + z*(1.-y)**(-1) * (
     +     + 11./2.*GYZ2(1,0)
     +     - 3*GYZ2(2,0)*HZ1(0)
     +     - 9*GYZ3(0,1,0)
     +     - 6*GYZ3(1,0,0)
     +     + 6*GYZ3(1,1,0)
     +     + 3*GYZ3(2,1,0)
     +     + 5./3.*HZ1(0)
     +     )
      A20 = A20 + z*(1.-y)**(-1) * (
     +     + HZ2(1,0)
     +     + 3*HZ3(0,1,0)
     +     + 3*HZ3(1,1,0)
     +     )
      A20 = A20 + z*(y+z)**(-3)*zeta2 * (
     +     - 33*GYZ1(2)
     +     + 33*HZ1(1)
     +     )
      A20 = A20 + z*(y+z)**(-3) * (
     +     + 33*GYZ1(0)*HZ2(1,0)
     +     - 33*GYZ1(2)*HZ2(1,0)
     +     - 33*GYZ2(1,0)
     +     - 33*GYZ2(2,0)*HZ1(0)
     +     + 33*GYZ3(0,1,0)
     +     + 33*GYZ3(2,1,0)
     +     - 33*HZ2(1,0)
     +     )
      A20 = A20 + z*(y+z)**(-3) * (
     +     - 33*HZ3(0,1,0)
     +     + 33*HZ3(1,1,0)
     +     )
      A20 = A20 + z*(y+z)**(-2)*zeta2 * (
     +     - 33
     +     + 22*GYZ1(2)
     +     - 22*HZ1(1)
     +     )
      A20 = A20 + z*(y+z)**(-2) * (
     +     - 33./2.*GYZ1(0)
     +     - 33*GYZ1(0)*HZ1(0)
     +     - 22*GYZ1(0)*HZ2(1,0)
     +     + 22*GYZ1(2)*HZ2(1,0)
     +     + 55*GYZ2(1,0)
     +     + 22*GYZ2(2,0)*HZ1(0)
     +     - 22*GYZ3(0,1,0)
     +     )
      A20 = A20 + z*(y+z)**(-2) * (
     +     - 22*GYZ3(2,1,0)
     +     + 33./2.*HZ1(0)
     +     - 11*HZ2(1,0)
     +     + 22*HZ3(0,1,0)
     +     - 22*HZ3(1,1,0)
     +     )
      A20 = A20 + z*(y+z)**(-1)*zeta2 * (
     +     + 11./2.
     +     )
      A20 = A20 + z*(y+z)**(-1) * (
     +     + 11./2.*GYZ1(0)
     +     + 11./2.*GYZ1(0)*HZ1(0)
     +     - 11./2.*GYZ2(1,0)
     +     - 11./2.*HZ1(0)
     +     + 11./2.*HZ2(1,0)
     +     )
      A20 = A20 + z**2*(y+z)**(-4)*zeta2 * (
     +     + 33*GYZ1(2)
     +     - 33*HZ1(1)
     +     )
      A20 = A20 + z**2*(y+z)**(-4) * (
     +     - 33*GYZ1(0)*HZ2(1,0)
     +     + 33*GYZ1(2)*HZ2(1,0)
     +     + 33*GYZ2(2,0)*HZ1(0)
     +     - 33*GYZ3(0,1,0)
     +     - 33*GYZ3(2,1,0)
     +     + 33*HZ3(0,1,0)
     +     - 33*HZ3(1,1,0)
     +     )
      A20 = A20 + z**2*(y+z)**(-3)*zeta2 * (
     +     + 33
     +     - 22*GYZ1(2)
     +     + 22*HZ1(1)
     +     )
      A20 = A20 + z**2*(y+z)**(-3) * (
     +     + 33*GYZ1(0)*HZ1(0)
     +     + 22*GYZ1(0)*HZ2(1,0)
     +     - 22*GYZ1(2)*HZ2(1,0)
     +     - 33*GYZ2(1,0)
     +     - 22*GYZ2(2,0)*HZ1(0)
     +     + 22*GYZ3(0,1,0)
     +     + 22*GYZ3(2,1,0)
     +     )
      A20 = A20 + z**2*(y+z)**(-3) * (
     +     + 33*HZ2(1,0)
     +     - 22*HZ3(0,1,0)
     +     + 22*HZ3(1,1,0)
     +     )
      A20 = A20 + z**2*(y+z)**(-2)*zeta2 * (
     +     - 11./2.
     +     )
      A20 = A20 + z**2*(y+z)**(-2) * (
     +     - 11./2.*GYZ1(0)*HZ1(0)
     +     + 11./2.*GYZ2(1,0)
     +     - 11./2.*HZ2(1,0)
     +     )
      A20 = A20 + (1.-y)**(-1)*zeta2 * (
     +     + 23./3.
     +     - 12*GYZ1(0)
     +     + 8*GYZ1(1)
     +     + 4*GYZ1(2)
     +     - 4*HZ1(0)
     +     - 4*HZ1(1)
     +     )
      A20 = A20 + (1.-y)**(-1)*zeta3 * (
     +     - 4
     +     )
      A20 = A20 + (1.-y)**(-1) * (
     +     + 515./18.*GYZ1(0)
     +     - 20./3.*GYZ1(0)*HZ1(0)
     +     - 4*GYZ1(0)*HZ2(1,0)
     +     + 4*GYZ1(2)*HZ2(1,0)
     +     - 24*GYZ2(0,0)
     +     - 8*GYZ2(0,0)*HZ1(0)
     +     - 23./3.*GYZ2(1,0)
     +     )
      A20 = A20 + (1.-y)**(-1) * (
     +     + 4*GYZ2(2,0)*HZ1(0)
     +     + 12*GYZ3(0,1,0)
     +     + 8*GYZ3(1,0,0)
     +     - 8*GYZ3(1,1,0)
     +     - 4*GYZ3(2,1,0)
     +     - HZ2(1,0)
     +     - 4*HZ3(0,1,0)
     +     )
      A20 = A20 + (1.-y)**(-1) * (
     +     - 4*HZ3(1,1,0)
     +     )
      A20 = A20 + (y+z)**(-2)*zeta2 * (
     +     + 14*GYZ1(2)
     +     - 14*HZ1(1)
     +     )
      A20 = A20 + (y+z)**(-2) * (
     +     - 14*GYZ1(0)*HZ2(1,0)
     +     + 14*GYZ1(2)*HZ2(1,0)
     +     + 14*GYZ2(2,0)*HZ1(0)
     +     - 14*GYZ3(0,1,0)
     +     - 14*GYZ3(2,1,0)
     +     + 14*HZ3(0,1,0)
     +     - 14*HZ3(1,1,0)
     +     )
      A20 = A20 + (y+z)**(-1)*zeta2 * (
     +     + 14
     +     - 7*GYZ1(2)
     +     + 7*HZ1(1)
     +     )
      A20 = A20 + (y+z)**(-1) * (
     +     - 11./2.
     +     + 11./4.*GYZ1(0)
     +     + 14*GYZ1(0)*HZ1(0)
     +     + 7*GYZ1(0)*HZ2(1,0)
     +     - 7*GYZ1(2)*HZ2(1,0)
     +     - 14*GYZ2(1,0)
     +     - 7*GYZ2(2,0)*HZ1(0)
     +     )
      A20 = A20 + (y+z)**(-1) * (
     +     + 7*GYZ3(0,1,0)
     +     + 7*GYZ3(2,1,0)
     +     + 11./4.*HZ1(0)
     +     + 14*HZ2(1,0)
     +     - 7*HZ3(0,1,0)
     +     + 7*HZ3(1,1,0)
     +     )
      A20 = A20 + t*zeta2 * (
     +     - 1045./36.
     +     + 49./12.*GYZ1(0)
     +     + 3*GYZ1(0)*HZ1(0)
     +     + 11./3.*GYZ1(1)
     +     - GYZ1(1)*HZ1(0)
     +     - GYZ1(1)*HZ1(1)
     +     - 31./6.*GYZ1(2)
     +     )
      A20 = A20 + t*zeta2 * (
     +     + GYZ1(2)*HZ1(0)
     +     + 2*GYZ1(2)*HZ1(1)
     +     - 2*GYZ1(3)*HZ1(1)
     +     - 2*GYZ2(0,1)
     +     - 2*GYZ2(0,2)
     +     - 3*GYZ2(1,0)
     +     + 2*GYZ2(1,1)
     +     )
      A20 = A20 + t*zeta2 * (
     +     + GYZ2(1,2)
     +     + GYZ2(2,0)
     +     - 2*GYZ2(2,1)
     +     + 2*GYZ2(3,2)
     +     + 49./12.*HZ1(0)
     +     + 3./2.*HZ1(1)
     +     + 2*HZ2(0,1)
     +     )
      A20 = A20 + t*zeta2 * (
     +     + 2*HZ2(1,0)
     +     + HZ2(1,1)
     +     )
      A20 = A20 + t*zeta3 * (
     +     + 199./9.
     +     - GYZ1(0)
     +     - GYZ1(1)
     +     - 4*GYZ1(2)
     +     - HZ1(0)
     +     + 5*HZ1(1)
     +     )
      A20 = A20 + t*zeta4 * (
     +     + 11
     +     )
      A20 = A20 + t * (
     +     - 99931./2592.
     +     + 38./27.*GYZ1(0)
     +     - 2./3.*GYZ1(0)*HZ1(0)
     +     + 7*GYZ1(0)*HZ2(0,0)
     +     + 16./3.*GYZ1(0)*HZ2(1,0)
     +     + GYZ1(0)*HZ3(0,1,0)
     +     + 2*GYZ1(0)*HZ3(1,0,0)
     +     )
      A20 = A20 + t * (
     +     - GYZ1(1)*HZ3(0,1,0)
     +     - GYZ1(1)*HZ3(1,1,0)
     +     - 31./6.*GYZ1(2)*HZ2(1,0)
     +     - GYZ1(2)*HZ3(0,1,0)
     +     + 2*GYZ1(2)*HZ3(1,1,0)
     +     + 2*GYZ1(3)*HZ3(0,1,0)
     +     - 2*GYZ1(3)*HZ3(1,1,0)
     +     )
      A20 = A20 + t * (
     +     + 80./9.*GYZ2(0,0)
     +     + 7*GYZ2(0,0)*HZ1(0)
     +     + 2*GYZ2(0,0)*HZ2(0,0)
     +     - 2*GYZ2(0,2)*HZ2(1,0)
     +     + 365./72.*GYZ2(1,0)
     +     - 1./6.*GYZ2(1,0)*HZ1(0)
     +     - GYZ2(1,0)*HZ2(1,0)
     +     )
      A20 = A20 + t * (
     +     + GYZ2(1,2)*HZ2(1,0)
     +     - 31./6.*GYZ2(2,0)*HZ1(0)
     +     + GYZ2(2,0)*HZ2(1,0)
     +     - 2*GYZ2(3,0)*HZ2(1,0)
     +     + 2*GYZ2(3,2)*HZ2(1,0)
     +     - 14./3.*GYZ3(0,1,0)
     +     - GYZ3(0,1,0)*HZ1(0)
     +     )
      A20 = A20 + t * (
     +     - 2*GYZ3(0,2,0)*HZ1(0)
     +     - 7*GYZ3(1,0,0)
     +     - 2*GYZ3(1,0,0)*HZ1(0)
     +     - 11./3.*GYZ3(1,1,0)
     +     + GYZ3(1,2,0)*HZ1(0)
     +     + 31./6.*GYZ3(2,1,0)
     +     - GYZ3(2,1,0)*HZ1(0)
     +     )
      A20 = A20 + t * (
     +     + 2*GYZ3(3,2,0)*HZ1(0)
     +     - 2*GYZ4(0,0,1,0)
     +     + 2*GYZ4(0,1,1,0)
     +     + 2*GYZ4(0,2,1,0)
     +     + 3*GYZ4(1,0,1,0)
     +     + 2*GYZ4(1,1,0,0)
     +     - 2*GYZ4(1,1,1,0)
     +     )
      A20 = A20 + t * (
     +     - GYZ4(1,2,1,0)
     +     + GYZ4(2,0,1,0)
     +     + 2*GYZ4(2,1,1,0)
     +     - 2*GYZ4(3,0,1,0)
     +     - 2*GYZ4(3,2,1,0)
     +     + 38./27.*HZ1(0)
     +     + 80./9.*HZ2(0,0)
     +     )
      A20 = A20 + t * (
     +     - 365./72.*HZ2(1,0)
     +     + 14./3.*HZ3(0,1,0)
     +     + 7*HZ3(1,0,0)
     +     + 3./2.*HZ3(1,1,0)
     +     + 4*HZ4(0,0,1,0)
     +     + 2*HZ4(0,1,1,0)
     +     + 4*HZ4(1,0,1,0)
     +     )
      A20 = A20 + t * (
     +     + 2*HZ4(1,1,0,0)
     +     + HZ4(1,1,1,0)
     +     )
      A20 = A20 + zeta2 * (
     +     - 7
     +     )
      A20 = A20 + 1./2.
     +     - 7*GYZ1(0)*HZ1(0)
     +     + 7*GYZ2(1,0)
     +     - 7*HZ2(1,0)
     +

      B20 = 0.
     +
      B20 = B20 + y**(-2)*z * (
     +     - 3*GYZ1(2)*HZ1(0)
     +     - 3*GYZ1(3)*HZ1(1)
     +     + 3*GYZ2(3,2)
     +     )
      B20 = B20 + y**(-2)*z**2 * (
     +     + GYZ1(2)*HZ1(0)
     +     + GYZ1(3)*HZ1(1)
     +     - GYZ2(3,2)
     +     )
      B20 = B20 + y**(-2) * (
     +     + 2*GYZ1(2)*HZ1(0)
     +     + 2*GYZ1(3)*HZ1(1)
     +     - 2*GYZ2(3,2)
     +     )
      B20 = B20 + y**(-1)*z*zeta2 * (
     +     + 12*GYZ1(1)
     +     + 1./3.*GYZ1(2)
     +     - 8*GYZ1(2)*HZ1(0)
     +     - 4*GYZ1(2)*HZ1(1)
     +     + 2*GYZ2(0,2)
     +     + 4*GYZ2(2,1)
     +     + 4*GYZ2(2,2)
     +     )
      B20 = B20 + y**(-1)*z*zeta2 * (
     +     + HZ1(0)
     +     + 7*HZ1(1)
     +     )
      B20 = B20 + y**(-1)*z*zeta3 * (
     +     - 3
     +     - 10*GYZ1(2)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     + GYZ1(0)*HZ1(1)
     +     + 152./9.*GYZ1(2)*HZ1(0)
     +     - 4*GYZ1(2)*HZ2(0,0)
     +     + GYZ1(2)*HZ2(0,1)
     +     + 19./3.*GYZ1(2)*HZ2(1,0)
     +     + 6*GYZ1(2)*HZ3(0,0,1)
     +     - 4*GYZ1(2)*HZ3(0,1,0)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     - 2*GYZ1(2)*HZ3(1,0,0)
     +     - 2*GYZ1(2)*HZ3(1,0,1)
     +     - 6*GYZ1(2)*HZ3(1,1,0)
     +     + 143./9.*GYZ1(3)*HZ1(1)
     +     + 2./3.*GYZ1(3)*HZ2(0,1)
     +     - 26./3.*GYZ1(3)*HZ2(1,0)
     +     + 28./3.*GYZ1(3)*HZ2(1,1)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     - 8*GYZ1(3)*HZ3(0,0,1)
     +     + 2*GYZ1(3)*HZ3(0,1,0)
     +     + 2*GYZ1(3)*HZ3(1,1,0)
     +     - GYZ2(0,2)
     +     - 1./3.*GYZ2(0,2)*HZ1(0)
     +     - 2*GYZ2(0,2)*HZ2(0,0)
     +     + 2*GYZ2(0,2)*HZ2(0,1)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     + 4*GYZ2(0,2)*HZ2(1,0)
     +     - 1./3.*GYZ2(0,3)*HZ1(1)
     +     - 4*GYZ2(0,3)*HZ2(0,1)
     +     - 2*GYZ2(0,3)*HZ2(1,0)
     +     + 2*GYZ2(0,3)*HZ2(1,1)
     +     + GYZ2(1,0)
     +     + 6*GYZ2(1,0)*HZ1(0)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     + 3*GYZ2(1,0)*HZ1(1)
     +     - GYZ2(2,0)
     +     - 19./3.*GYZ2(2,0)*HZ1(0)
     +     - 2*GYZ2(2,0)*HZ2(0,0)
     +     - 2*GYZ2(2,0)*HZ2(0,1)
     +     - 2*GYZ2(2,0)*HZ2(1,0)
     +     - 28./3.*GYZ2(2,2)*HZ1(0)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     - 2*GYZ2(2,2)*HZ2(0,0)
     +     + 4*GYZ2(2,2)*HZ2(1,0)
     +     - 25./3.*GYZ2(2,3)*HZ1(1)
     +     + 6*GYZ2(2,3)*HZ2(0,1)
     +     - 2*GYZ2(2,3)*HZ2(1,0)
     +     + 8./3.*GYZ2(3,0)*HZ1(1)
     +     + 2*GYZ2(3,0)*HZ2(0,1)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     - 143./9.*GYZ2(3,2)
     +     + 26./3.*GYZ2(3,2)*HZ1(0)
     +     - 28./3.*GYZ2(3,2)*HZ1(1)
     +     - 2*GYZ2(3,2)*HZ2(1,0)
     +     + 28./3.*GYZ2(3,3)*HZ1(1)
     +     - 12*GYZ2(3,3)*HZ2(0,1)
     +     - 4*GYZ2(3,3)*HZ2(1,1)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     + 3*GYZ3(0,1,0)
     +     + 4*GYZ3(0,2,0)*HZ1(0)
     +     - 2*GYZ3(0,2,2)*HZ1(0)
     +     + 4*GYZ3(0,3,0)*HZ1(1)
     +     + 1./3.*GYZ3(0,3,2)
     +     + 2*GYZ3(0,3,2)*HZ1(0)
     +     - 2*GYZ3(0,3,2)*HZ1(1)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     - 2*GYZ3(0,3,3)*HZ1(1)
     +     - 3*GYZ3(1,0,2)
     +     - 12*GYZ3(1,1,0)
     +     - 3*GYZ3(1,2,0)
     +     - 2*GYZ3(2,0,3)*HZ1(1)
     +     + 6*GYZ3(2,1,0)
     +     + 2*GYZ3(2,2,0)*HZ1(0)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     - 2*GYZ3(2,3,0)*HZ1(1)
     +     + 25./3.*GYZ3(2,3,2)
     +     + 2*GYZ3(2,3,2)*HZ1(0)
     +     + 8*GYZ3(2,3,3)*HZ1(1)
     +     - 8./3.*GYZ3(3,0,2)
     +     - 2*GYZ3(3,0,2)*HZ1(0)
     +     - 8./3.*GYZ3(3,2,0)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     + 28./3.*GYZ3(3,2,2)
     +     + 4*GYZ3(3,2,2)*HZ1(0)
     +     + 4*GYZ3(3,2,3)*HZ1(1)
     +     + 4*GYZ3(3,3,0)*HZ1(1)
     +     - 28./3.*GYZ3(3,3,2)
     +     + 4*GYZ3(3,3,2)*HZ1(1)
     +     - 12*GYZ3(3,3,3)*HZ1(1)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     - 4*GYZ4(0,3,0,2)
     +     - 4*GYZ4(0,3,2,0)
     +     + 2*GYZ4(0,3,2,2)
     +     + 2*GYZ4(0,3,3,2)
     +     + 2*GYZ4(2,0,1,0)
     +     + 2*GYZ4(2,0,3,2)
     +     - 4*GYZ4(2,1,1,0)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     - 2*GYZ4(2,2,1,0)
     +     + 2*GYZ4(2,3,0,2)
     +     + 2*GYZ4(2,3,2,0)
     +     - 8*GYZ4(2,3,3,2)
     +     + 2*GYZ4(3,0,1,0)
     +     + 2*GYZ4(3,2,1,0)
     +     - 4*GYZ4(3,2,3,2)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     - 4*GYZ4(3,3,0,2)
     +     - 4*GYZ4(3,3,2,0)
     +     - 4*GYZ4(3,3,2,2)
     +     + 12*GYZ4(3,3,3,2)
     +     - 4*HZ1(0)
     +     - HZ2(0,1)
     +     - HZ3(0,0,1)
     +     )
      B20 = B20 + y**(-1)*z * (
     +     + HZ3(0,1,0)
     +     - 4*HZ3(1,0,1)
     +     - 2*HZ3(1,1,0)
     +     )
      B20 = B20 + y**(-1)*z**2 * (
     +     + 2*GYZ1(2)*HZ1(0)
     +     + 2*GYZ1(3)*HZ1(1)
     +     - 2*GYZ2(3,2)
     +     )
      B20 = B20 + y**(-1)*(y+z)**(-1) * (
     +     + 2*GYZ1(0)*HZ1(1)
     +     + 2*GYZ1(2)*HZ1(0)
     +     + 6*GYZ1(2)*HZ2(1,0)
     +     - 6*GYZ1(3)*HZ2(0,1)
     +     - 6*GYZ1(3)*HZ2(1,0)
     +     - 2*GYZ2(0,2)
     +     - 6*GYZ2(0,2)*HZ1(0)
     +     )
      B20 = B20 + y**(-1)*(y+z)**(-1) * (
     +     - 6*GYZ2(0,3)*HZ1(1)
     +     + 2*GYZ2(1,0)
     +     - 2*GYZ2(2,0)
     +     + 6*GYZ2(3,0)*HZ1(1)
     +     + 6*GYZ2(3,2)*HZ1(0)
     +     + 6*GYZ3(0,1,0)
     +     + 6*GYZ3(0,3,2)
     +     )
      B20 = B20 + y**(-1)*(y+z)**(-1) * (
     +     + 6*GYZ3(2,1,0)
     +     - 6*GYZ3(3,0,2)
     +     - 6*GYZ3(3,2,0)
     +     - 2*HZ2(0,1)
     +     - 6*HZ3(1,1,0)
     +     )
      B20 = B20 + y**(-1)*zeta2 * (
     +     - 2
     +     - 16*GYZ1(1)
     +     - 14./3.*GYZ1(2)
     +     + 16*GYZ1(2)*HZ1(0)
     +     + 8*GYZ1(2)*HZ1(1)
     +     - 4*GYZ2(0,2)
     +     - 8*GYZ2(2,1)
     +     )
      B20 = B20 + y**(-1)*zeta2 * (
     +     - 8*GYZ2(2,2)
     +     + 2*HZ1(0)
     +     - 10*HZ1(1)
     +     )
      B20 = B20 + y**(-1)*zeta3 * (
     +     - 6
     +     + 20*GYZ1(2)
     +     )
      B20 = B20 + y**(-1) * (
     +     + 139./9.
     +     - 16./3.*GYZ1(0)
     +     - GYZ1(0)*HZ1(0)
     +     - 3*GYZ1(0)*HZ1(1)
     +     - 5./2.*GYZ1(2)
     +     - 250./9.*GYZ1(2)*HZ1(0)
     +     + 16*GYZ1(2)*HZ2(0,0)
     +     )
      B20 = B20 + y**(-1) * (
     +     - 56./3.*GYZ1(2)*HZ2(1,0)
     +     - 12*GYZ1(2)*HZ3(0,0,1)
     +     + 8*GYZ1(2)*HZ3(0,1,0)
     +     + 4*GYZ1(2)*HZ3(1,0,0)
     +     + 4*GYZ1(2)*HZ3(1,0,1)
     +     + 12*GYZ1(2)*HZ3(1,1,0)
     +     - 214./9.*GYZ1(3)*HZ1(1)
     +     )
      B20 = B20 + y**(-1) * (
     +     + 14./3.*GYZ1(3)*HZ2(0,1)
     +     + 70./3.*GYZ1(3)*HZ2(1,0)
     +     - 44./3.*GYZ1(3)*HZ2(1,1)
     +     + 16*GYZ1(3)*HZ3(0,0,1)
     +     - 4*GYZ1(3)*HZ3(0,1,0)
     +     - 4*GYZ1(3)*HZ3(1,1,0)
     +     + 3*GYZ2(0,2)
     +     )
      B20 = B20 + y**(-1) * (
     +     + 32./3.*GYZ2(0,2)*HZ1(0)
     +     + 4*GYZ2(0,2)*HZ2(0,0)
     +     - 4*GYZ2(0,2)*HZ2(0,1)
     +     - 8*GYZ2(0,2)*HZ2(1,0)
     +     + 32./3.*GYZ2(0,3)*HZ1(1)
     +     + 8*GYZ2(0,3)*HZ2(0,1)
     +     + 4*GYZ2(0,3)*HZ2(1,0)
     +     )
      B20 = B20 + y**(-1) * (
     +     - 4*GYZ2(0,3)*HZ2(1,1)
     +     - 2*GYZ2(1,0)
     +     - 8*GYZ2(1,0)*HZ1(0)
     +     - 2*GYZ2(1,0)*HZ1(1)
     +     + 3*GYZ2(2,0)
     +     + 32./3.*GYZ2(2,0)*HZ1(0)
     +     + 4*GYZ2(2,0)*HZ2(0,0)
     +     )
      B20 = B20 + y**(-1) * (
     +     + 4*GYZ2(2,0)*HZ2(0,1)
     +     + 4*GYZ2(2,0)*HZ2(1,0)
     +     + 44./3.*GYZ2(2,2)*HZ1(0)
     +     + 4*GYZ2(2,2)*HZ2(0,0)
     +     - 8*GYZ2(2,2)*HZ2(1,0)
     +     + 44./3.*GYZ2(2,3)*HZ1(1)
     +     - 12*GYZ2(2,3)*HZ2(0,1)
     +     )
      B20 = B20 + y**(-1) * (
     +     + 4*GYZ2(2,3)*HZ2(1,0)
     +     - 10./3.*GYZ2(3,0)*HZ1(1)
     +     - 4*GYZ2(3,0)*HZ2(0,1)
     +     + 214./9.*GYZ2(3,2)
     +     - 70./3.*GYZ2(3,2)*HZ1(0)
     +     + 44./3.*GYZ2(3,2)*HZ1(1)
     +     + 4*GYZ2(3,2)*HZ2(1,0)
     +     )
      B20 = B20 + y**(-1) * (
     +     - 56./3.*GYZ2(3,3)*HZ1(1)
     +     + 24*GYZ2(3,3)*HZ2(0,1)
     +     + 8*GYZ2(3,3)*HZ2(1,1)
     +     - 6*GYZ3(0,1,0)
     +     - 8*GYZ3(0,2,0)*HZ1(0)
     +     + 4*GYZ3(0,2,2)*HZ1(0)
     +     - 8*GYZ3(0,3,0)*HZ1(1)
     +     )
      B20 = B20 + y**(-1) * (
     +     - 32./3.*GYZ3(0,3,2)
     +     - 4*GYZ3(0,3,2)*HZ1(0)
     +     + 4*GYZ3(0,3,2)*HZ1(1)
     +     + 4*GYZ3(0,3,3)*HZ1(1)
     +     + 2*GYZ3(1,0,2)
     +     + 16*GYZ3(1,1,0)
     +     + 2*GYZ3(1,2,0)
     +     )
      B20 = B20 + y**(-1) * (
     +     + 4*GYZ3(2,0,3)*HZ1(1)
     +     - 12*GYZ3(2,1,0)
     +     - 4*GYZ3(2,2,0)*HZ1(0)
     +     + 4*GYZ3(2,3,0)*HZ1(1)
     +     - 44./3.*GYZ3(2,3,2)
     +     - 4*GYZ3(2,3,2)*HZ1(0)
     +     - 16*GYZ3(2,3,3)*HZ1(1)
     +     )
      B20 = B20 + y**(-1) * (
     +     + 10./3.*GYZ3(3,0,2)
     +     + 4*GYZ3(3,0,2)*HZ1(0)
     +     + 10./3.*GYZ3(3,2,0)
     +     - 44./3.*GYZ3(3,2,2)
     +     - 8*GYZ3(3,2,2)*HZ1(0)
     +     - 8*GYZ3(3,2,3)*HZ1(1)
     +     - 8*GYZ3(3,3,0)*HZ1(1)
     +     )
      B20 = B20 + y**(-1) * (
     +     + 56./3.*GYZ3(3,3,2)
     +     - 8*GYZ3(3,3,2)*HZ1(1)
     +     + 24*GYZ3(3,3,3)*HZ1(1)
     +     + 8*GYZ4(0,3,0,2)
     +     + 8*GYZ4(0,3,2,0)
     +     - 4*GYZ4(0,3,2,2)
     +     - 4*GYZ4(0,3,3,2)
     +     )
      B20 = B20 + y**(-1) * (
     +     - 4*GYZ4(2,0,1,0)
     +     - 4*GYZ4(2,0,3,2)
     +     + 8*GYZ4(2,1,1,0)
     +     + 4*GYZ4(2,2,1,0)
     +     - 4*GYZ4(2,3,0,2)
     +     - 4*GYZ4(2,3,2,0)
     +     + 16*GYZ4(2,3,3,2)
     +     )
      B20 = B20 + y**(-1) * (
     +     - 4*GYZ4(3,0,1,0)
     +     - 4*GYZ4(3,2,1,0)
     +     + 8*GYZ4(3,2,3,2)
     +     + 8*GYZ4(3,3,0,2)
     +     + 8*GYZ4(3,3,2,0)
     +     + 8*GYZ4(3,3,2,2)
     +     - 24*GYZ4(3,3,3,2)
     +     )
      B20 = B20 + y**(-1) * (
     +     + 19./3.*HZ1(0)
     +     + 5./2.*HZ1(1)
     +     + 4*HZ2(0,1)
     +     - 2*HZ2(1,0)
     +     - 2*HZ3(0,0,1)
     +     + 2*HZ3(0,1,0)
     +     + 4*HZ3(1,0,1)
     +     )
      B20 = B20 + y**(-1) * (
     +     + 8*HZ3(1,1,0)
     +     )
      B20 = B20 + z*(1.-y)**(-2)*zeta2 * (
     +     - 22./3.
     +     - 4*GYZ1(0)
     +     + 4*GYZ1(1)
     +     + 9*GYZ1(2)
     +     - 9*HZ1(0)
     +     - 9*HZ1(1)
     +     )
      B20 = B20 + z*(1.-y)**(-2)*zeta3 * (
     +     + 25
     +     )
      B20 = B20 + z*(1.-y)**(-2) * (
     +     + 37./9.*GYZ1(0)
     +     + 4./3.*GYZ1(0)*HZ1(0)
     +     + 9./2.*GYZ1(0)*HZ1(1)
     +     - GYZ1(0)*HZ2(0,1)
     +     - GYZ1(0)*HZ2(1,0)
     +     - 9*GYZ1(2)*HZ2(0,1)
     +     + 9*GYZ1(2)*HZ2(1,0)
     +     )
      B20 = B20 + z*(1.-y)**(-2) * (
     +     + 4*GYZ1(3)*HZ1(1)
     +     - 5*GYZ2(0,0)
     +     - GYZ2(0,0)*HZ1(0)
     +     + 3*GYZ2(0,0)*HZ1(1)
     +     - 9./2.*GYZ2(0,2)
     +     - 8*GYZ2(0,2)*HZ1(0)
     +     - 9*GYZ2(0,3)*HZ1(1)
     +     )
      B20 = B20 + z*(1.-y)**(-2) * (
     +     + 10./3.*GYZ2(1,0)
     +     - 9./2.*GYZ2(2,0)
     +     + GYZ2(2,0)*HZ1(0)
     +     - 9*GYZ2(2,3)*HZ1(1)
     +     - 4*GYZ2(3,2)
     +     - 3*GYZ3(0,0,2)
     +     + 5*GYZ3(0,1,0)
     +     )
      B20 = B20 + z*(1.-y)**(-2) * (
     +     - 3*GYZ3(0,2,0)
     +     + 9*GYZ3(0,3,2)
     +     + 4*GYZ3(1,0,0)
     +     - 4*GYZ3(1,1,0)
     +     - 3*GYZ3(2,0,0)
     +     + 9*GYZ3(2,3,2)
     +     + 4*HZ2(0,1)
     +     )
      B20 = B20 + z*(1.-y)**(-2) * (
     +     - 4*HZ2(1,0)
     +     + 9*HZ3(0,0,1)
     +     - 9*HZ3(0,1,0)
     +     + 9*HZ3(1,0,1)
     +     - 9*HZ3(1,1,0)
     +     )
      B20 = B20 + z*(1.-y)**(-1)*zeta2 * (
     +     - 12*GYZ1(0)
     +     + 12*GYZ1(1)
     +     + 3*GYZ1(2)
     +     - 3*HZ1(0)
     +     - 3*HZ1(1)
     +     )
      B20 = B20 + z*(1.-y)**(-1)*zeta3 * (
     +     + 3
     +     )
      B20 = B20 + z*(1.-y)**(-1) * (
     +     + 31./9.
     +     + 22./3.*GYZ1(0)
     +     - 6*GYZ1(0)*HZ1(0)
     +     + 11./2.*GYZ1(0)*HZ1(1)
     +     - 3*GYZ1(0)*HZ2(0,1)
     +     - 3*GYZ1(0)*HZ2(1,0)
     +     - 13./2.*GYZ1(2)
     +     )
      B20 = B20 + z*(1.-y)**(-1) * (
     +     - 8*GYZ1(2)*HZ1(0)
     +     - 3*GYZ1(2)*HZ2(0,1)
     +     + 3*GYZ1(2)*HZ2(1,0)
     +     - 9*GYZ1(3)*HZ1(1)
     +     - 11*GYZ2(0,0)
     +     - 3*GYZ2(0,0)*HZ1(0)
     +     + 9*GYZ2(0,0)*HZ1(1)
     +     )
      B20 = B20 + z*(1.-y)**(-1) * (
     +     - 11./2.*GYZ2(0,2)
     +     - 3*GYZ2(0,3)*HZ1(1)
     +     + GYZ2(1,0)
     +     - 11./2.*GYZ2(2,0)
     +     + 3*GYZ2(2,0)*HZ1(0)
     +     - 3*GYZ2(2,3)*HZ1(1)
     +     + 9*GYZ2(3,2)
     +     )
      B20 = B20 + z*(1.-y)**(-1) * (
     +     - 9*GYZ3(0,0,2)
     +     + 15*GYZ3(0,1,0)
     +     - 9*GYZ3(0,2,0)
     +     + 3*GYZ3(0,3,2)
     +     + 12*GYZ3(1,0,0)
     +     - 12*GYZ3(1,1,0)
     +     - 9*GYZ3(2,0,0)
     +     )
      B20 = B20 + z*(1.-y)**(-1) * (
     +     + 3*GYZ3(2,3,2)
     +     + 10./3.*HZ1(0)
     +     + 13./2.*HZ1(1)
     +     - HZ2(0,1)
     +     - HZ2(1,0)
     +     + 3*HZ3(0,0,1)
     +     - 3*HZ3(0,1,0)
     +     )
      B20 = B20 + z*(1.-y)**(-1) * (
     +     + 3*HZ3(1,0,1)
     +     - 3*HZ3(1,1,0)
     +     )
      B20 = B20 + z*(y+z)**(-3)*zeta2 * (
     +     + 12*GYZ1(2)
     +     - 12*HZ1(1)
     +     )
      B20 = B20 + z*(y+z)**(-3) * (
     +     - 12*GYZ1(0)*HZ2(1,0)
     +     + 12*GYZ1(2)*HZ2(1,0)
     +     + 12*GYZ2(1,0)
     +     + 12*GYZ2(2,0)*HZ1(0)
     +     - 12*GYZ3(0,1,0)
     +     - 12*GYZ3(2,1,0)
     +     + 12*HZ2(1,0)
     +     )
      B20 = B20 + z*(y+z)**(-3) * (
     +     + 12*HZ3(0,1,0)
     +     - 12*HZ3(1,1,0)
     +     )
      B20 = B20 + z*(y+z)**(-2)*zeta2 * (
     +     + 12
     +     - 8*GYZ1(2)
     +     + 8*HZ1(1)
     +     )
      B20 = B20 + z*(y+z)**(-2) * (
     +     + 6*GYZ1(0)
     +     + 12*GYZ1(0)*HZ1(0)
     +     + 8*GYZ1(0)*HZ2(1,0)
     +     - 8*GYZ1(2)*HZ2(1,0)
     +     - 20*GYZ2(1,0)
     +     - 8*GYZ2(2,0)*HZ1(0)
     +     + 8*GYZ3(0,1,0)
     +     )
      B20 = B20 + z*(y+z)**(-2) * (
     +     + 8*GYZ3(2,1,0)
     +     - 6*HZ1(0)
     +     + 4*HZ2(1,0)
     +     - 8*HZ3(0,1,0)
     +     + 8*HZ3(1,1,0)
     +     )
      B20 = B20 + z*(y+z)**(-1)*zeta2 * (
     +     - 2
     +     )
      B20 = B20 + z*(y+z)**(-1) * (
     +     - 2*GYZ1(0)
     +     - 2*GYZ1(0)*HZ1(0)
     +     + 2*GYZ2(1,0)
     +     + 2*HZ1(0)
     +     - 2*HZ2(1,0)
     +     )
      B20 = B20 + z**2*(1.-y)**(-3)*zeta2 * (
     +     - 4*GYZ1(2)
     +     + 4*HZ1(0)
     +     + 4*HZ1(1)
     +     )
      B20 = B20 + z**2*(1.-y)**(-3)*zeta3 * (
     +     - 12
     +     )
      B20 = B20 + z**2*(1.-y)**(-3) * (
     +     + 4*GYZ1(2)*HZ2(0,1)
     +     - 4*GYZ1(2)*HZ2(1,0)
     +     + 4*GYZ2(0,2)*HZ1(0)
     +     + 4*GYZ2(0,3)*HZ1(1)
     +     + 4*GYZ2(2,3)*HZ1(1)
     +     - 4*GYZ3(0,3,2)
     +     - 4*GYZ3(2,3,2)
     +     )
      B20 = B20 + z**2*(1.-y)**(-3) * (
     +     - 4*HZ3(0,0,1)
     +     + 4*HZ3(0,1,0)
     +     - 4*HZ3(1,0,1)
     +     + 4*HZ3(1,1,0)
     +     )
      B20 = B20 + z**2*(1.-y)**(-2) * (
     +     + 4*GYZ1(2)*HZ1(0)
     +     + 4*GYZ1(3)*HZ1(1)
     +     - 4*GYZ2(3,2)
     +     )
      B20 = B20 + z**2*(1.-y)**(-1) * (
     +     + 2*GYZ1(2)*HZ1(0)
     +     + 2*GYZ1(3)*HZ1(1)
     +     - 2*GYZ2(3,2)
     +     )
      B20 = B20 + z**2*(y+z)**(-4)*zeta2 * (
     +     - 12*GYZ1(2)
     +     + 12*HZ1(1)
     +     )
      B20 = B20 + z**2*(y+z)**(-4) * (
     +     + 12*GYZ1(0)*HZ2(1,0)
     +     - 12*GYZ1(2)*HZ2(1,0)
     +     - 12*GYZ2(2,0)*HZ1(0)
     +     + 12*GYZ3(0,1,0)
     +     + 12*GYZ3(2,1,0)
     +     - 12*HZ3(0,1,0)
     +     + 12*HZ3(1,1,0)
     +     )
      B20 = B20 + z**2*(y+z)**(-3)*zeta2 * (
     +     - 12
     +     + 8*GYZ1(2)
     +     - 8*HZ1(1)
     +     )
      B20 = B20 + z**2*(y+z)**(-3) * (
     +     - 12*GYZ1(0)*HZ1(0)
     +     - 8*GYZ1(0)*HZ2(1,0)
     +     + 8*GYZ1(2)*HZ2(1,0)
     +     + 12*GYZ2(1,0)
     +     + 8*GYZ2(2,0)*HZ1(0)
     +     - 8*GYZ3(0,1,0)
     +     - 8*GYZ3(2,1,0)
     +     )
      B20 = B20 + z**2*(y+z)**(-3) * (
     +     - 12*HZ2(1,0)
     +     + 8*HZ3(0,1,0)
     +     - 8*HZ3(1,1,0)
     +     )
      B20 = B20 + z**2*(y+z)**(-2)*zeta2 * (
     +     + 2
     +     )
      B20 = B20 + z**2*(y+z)**(-2) * (
     +     + 2*GYZ1(0)*HZ1(0)
     +     - 2*GYZ2(1,0)
     +     + 2*HZ2(1,0)
     +     )
      B20 = B20 + (1.-y-z)**(-1)*zeta2 * (
     +     + 1
     +     )
      B20 = B20 + (1.-y-z)**(-1) * (
     +     + GYZ1(0)*HZ1(0)
     +     - GYZ2(1,0)
     +     + HZ2(1,0)
     +     )
      B20 = B20 + (1.-y)**(-1)*zeta2 * (
     +     + 20./3.
     +     + 8*GYZ1(0)
     +     - 14*GYZ1(1)
     +     - 6*GYZ1(2)
     +     + 8*HZ1(0)
     +     + 6*HZ1(1)
     +     )
      B20 = B20 + (1.-y)**(-1)*zeta3 * (
     +     - 26
     +     )
      B20 = B20 + (1.-y)**(-1) * (
     +     + 55./9.*GYZ1(0)
     +     + 7./3.*GYZ1(0)*HZ1(0)
     +     - 2*GYZ1(0)*HZ1(1)
     +     + 4*GYZ1(0)*HZ2(0,1)
     +     + 10*GYZ1(2)*HZ2(0,1)
     +     - 6*GYZ1(2)*HZ2(1,0)
     +     - 7*GYZ1(3)*HZ1(1)
     +     )
      B20 = B20 + (1.-y)**(-1) * (
     +     + 12*GYZ2(0,0)
     +     + 2*GYZ2(0,0)*HZ1(0)
     +     - 8*GYZ2(0,0)*HZ1(1)
     +     + 2*GYZ2(0,2)
     +     + 6*GYZ2(0,2)*HZ1(0)
     +     + 10*GYZ2(0,3)*HZ1(1)
     +     + 1./3.*GYZ2(1,0)
     +     )
      B20 = B20 + (1.-y)**(-1) * (
     +     - 2*GYZ2(1,0)*HZ1(0)
     +     + 2*GYZ2(2,0)
     +     + 10*GYZ2(2,3)*HZ1(1)
     +     + 7*GYZ2(3,2)
     +     + 8*GYZ3(0,0,2)
     +     - 12*GYZ3(0,1,0)
     +     + 8*GYZ3(0,2,0)
     +     )
      B20 = B20 + (1.-y)**(-1) * (
     +     - 10*GYZ3(0,3,2)
     +     - 10*GYZ3(1,0,0)
     +     + 14*GYZ3(1,1,0)
     +     + 8*GYZ3(2,0,0)
     +     - 4*GYZ3(2,1,0)
     +     - 10*GYZ3(2,3,2)
     +     - 7*HZ2(0,1)
     +     )
      B20 = B20 + (1.-y)**(-1) * (
     +     + 7*HZ2(1,0)
     +     - 10*HZ3(0,0,1)
     +     + 6*HZ3(0,1,0)
     +     - 10*HZ3(1,0,1)
     +     + 6*HZ3(1,1,0)
     +     )
      B20 = B20 + (y+z)**(-2) * (
     +     - 3*GYZ1(0)*HZ1(1)
     +     + 2*GYZ1(0)*HZ2(0,1)
     +     + 2*GYZ1(0)*HZ2(1,1)
     +     - 230./9.*GYZ1(2)
     +     + 3*GYZ1(2)*HZ1(0)
     +     - 34./3.*GYZ1(2)*HZ1(1)
     +     + 4*GYZ1(2)*HZ2(0,1)
     +     )
      B20 = B20 + (y+z)**(-2) * (
     +     - 2*GYZ1(2)*HZ2(1,0)
     +     + 22./3.*GYZ1(3)*HZ1(1)
     +     - 10*GYZ1(3)*HZ2(0,1)
     +     + 2*GYZ1(3)*HZ2(1,0)
     +     - 4*GYZ1(3)*HZ2(1,1)
     +     + 3*GYZ2(0,2)
     +     - 2*GYZ2(0,2)*HZ1(1)
     +     )
      B20 = B20 + (y+z)**(-2) * (
     +     + 2*GYZ2(0,3)*HZ1(1)
     +     + 3*GYZ2(2,0)
     +     - 2*GYZ2(2,0)*HZ1(1)
     +     + 34./3.*GYZ2(2,2)
     +     + 2*GYZ2(2,2)*HZ1(0)
     +     + 6*GYZ2(2,3)*HZ1(1)
     +     + 2*GYZ2(3,0)*HZ1(1)
     +     )
      B20 = B20 + (y+z)**(-2) * (
     +     - 22./3.*GYZ2(3,2)
     +     - 2*GYZ2(3,2)*HZ1(0)
     +     + 4*GYZ2(3,2)*HZ1(1)
     +     - 12*GYZ2(3,3)*HZ1(1)
     +     + 2*GYZ3(0,2,2)
     +     - 2*GYZ3(0,3,2)
     +     + 2*GYZ3(2,0,2)
     +     )
      B20 = B20 + (y+z)**(-2) * (
     +     + 2*GYZ3(2,2,0)
     +     - 6*GYZ3(2,3,2)
     +     - 2*GYZ3(3,0,2)
     +     - 2*GYZ3(3,2,0)
     +     - 4*GYZ3(3,2,2)
     +     + 12*GYZ3(3,3,2)
     +     + 230./9.*HZ1(1)
     +     )
      B20 = B20 + (y+z)**(-2) * (
     +     + 13./3.*HZ2(0,1)
     +     - 3*HZ2(1,0)
     +     + 34./3.*HZ2(1,1)
     +     - 8*HZ3(0,0,1)
     +     + 2*HZ3(0,1,0)
     +     - 2*HZ3(0,1,1)
     +     - 4*HZ3(1,0,1)
     +     )
      B20 = B20 + (y+z)**(-2) * (
     +     + 2*HZ3(1,1,0)
     +     )
      B20 = B20 + (y+z)**(-1)*zeta2 * (
     +     + GYZ1(2)
     +     - HZ1(1)
     +     )
      B20 = B20 + (y+z)**(-1) * (
     +     - 170./9.
     +     + 2*GYZ1(0)*HZ1(1)
     +     - GYZ1(0)*HZ2(1,0)
     +     + 41./3.*GYZ1(2)
     +     - 2*GYZ1(2)*HZ1(0)
     +     + GYZ1(2)*HZ2(1,0)
     +     - 10*GYZ1(3)*HZ1(1)
     +     )
      B20 = B20 + (y+z)**(-1) * (
     +     - 2*GYZ2(0,2)
     +     - 2*GYZ2(2,0)
     +     + GYZ2(2,0)*HZ1(0)
     +     + 10*GYZ2(3,2)
     +     - GYZ3(0,1,0)
     +     - GYZ3(2,1,0)
     +     - 41./3.*HZ1(1)
     +     )
      B20 = B20 + (y+z)**(-1) * (
     +     - 8*HZ2(0,1)
     +     + 2*HZ2(1,0)
     +     + HZ3(0,1,0)
     +     - HZ3(1,1,0)
     +     )
      B20 = B20 + t*zeta2 * (
     +     - 115./12.
     +     + 3*GYZ1(0)*HZ1(1)
     +     - 13./6.*GYZ1(1)
     +     - GYZ1(1)*HZ1(0)
     +     - GYZ1(1)*HZ1(1)
     +     + 19./12.*GYZ1(2)
     +     - 2*GYZ1(2)*HZ1(0)
     +     )
      B20 = B20 + t*zeta2 * (
     +     - 4*GYZ1(2)*HZ1(1)
     +     + 4*GYZ2(0,1)
     +     - 3*GYZ2(0,2)
     +     + 3*GYZ2(1,0)
     +     - 4*GYZ2(1,1)
     +     + GYZ2(1,2)
     +     - 2*GYZ2(2,0)
     +     )
      B20 = B20 + t*zeta2 * (
     +     + 4*GYZ2(2,2)
     +     + 7./12.*HZ1(1)
     +     - HZ2(0,1)
     +     - HZ2(1,0)
     +     + HZ2(1,1)
     +     )
      B20 = B20 + t*zeta3 * (
     +     - 119./36.
     +     + 3*GYZ1(1)
     +     - 5*GYZ1(2)
     +     + 2*HZ1(1)
     +     )
      B20 = B20 + t*zeta4 * (
     +     - 5./8.
     +     )
      B20 = B20 + t * (
     +     + 15251./648.
     +     - 20./3.*GYZ1(0)
     +     - 4*GYZ1(0)*HZ1(0)
     +     - 13./9.*GYZ1(0)*HZ1(1)
     +     - 13./6.*GYZ1(0)*HZ2(0,1)
     +     + 19./6.*GYZ1(0)*HZ2(1,0)
     +     - 11./3.*GYZ1(0)*HZ2(1,1)
     +     )
      B20 = B20 + t * (
     +     - 2*GYZ1(0)*HZ3(0,0,1)
     +     - GYZ1(0)*HZ3(0,1,0)
     +     + GYZ1(0)*HZ3(1,0,1)
     +     + 2*GYZ1(0)*HZ3(1,1,0)
     +     + GYZ1(1)*HZ3(0,0,1)
     +     - GYZ1(1)*HZ3(0,1,0)
     +     + GYZ1(1)*HZ3(1,0,1)
     +     )
      B20 = B20 + t * (
     +     - GYZ1(1)*HZ3(1,1,0)
     +     - 17./54.*GYZ1(2)
     +     + 13./9.*GYZ1(2)*HZ1(0)
     +     + 11./2.*GYZ1(2)*HZ1(1)
     +     - 7*GYZ1(2)*HZ2(0,0)
     +     - 31./6.*GYZ1(2)*HZ2(0,1)
     +     + 13./6.*GYZ1(2)*HZ2(1,0)
     +     )
      B20 = B20 + t * (
     +     + 4*GYZ1(2)*HZ3(0,0,1)
     +     - 4*GYZ1(2)*HZ3(0,1,0)
     +     - 2*GYZ1(2)*HZ3(1,0,0)
     +     - 3*GYZ1(2)*HZ3(1,0,1)
     +     - 7*GYZ1(2)*HZ3(1,1,0)
     +     + 71./9.*GYZ1(3)*HZ1(1)
     +     - 7./6.*GYZ1(3)*HZ2(0,1)
     +     )
      B20 = B20 + t * (
     +     - 11./2.*GYZ1(3)*HZ2(1,0)
     +     + 22./3.*GYZ1(3)*HZ2(1,1)
     +     - 8*GYZ1(3)*HZ3(0,0,1)
     +     + 2*GYZ1(3)*HZ3(0,1,0)
     +     - 2*GYZ1(3)*HZ3(0,1,1)
     +     - 2*GYZ1(3)*HZ3(1,0,1)
     +     + 2*GYZ1(3)*HZ3(1,1,0)
     +     )
      B20 = B20 + t * (
     +     + 7*GYZ2(0,0)*HZ1(1)
     +     + 2*GYZ2(0,0)*HZ2(0,1)
     +     + 2*GYZ2(0,0)*HZ2(1,0)
     +     + 13./9.*GYZ2(0,2)
     +     - 10./3.*GYZ2(0,2)*HZ1(0)
     +     + 11./3.*GYZ2(0,2)*HZ1(1)
     +     - 2*GYZ2(0,2)*HZ2(0,0)
     +     )
      B20 = B20 + t * (
     +     + GYZ2(0,2)*HZ2(0,1)
     +     - 11./2.*GYZ2(0,3)*HZ1(1)
     +     - 2*GYZ2(0,3)*HZ2(0,1)
     +     - 4*GYZ2(0,3)*HZ2(1,0)
     +     + 2*GYZ2(0,3)*HZ2(1,1)
     +     + 1./18.*GYZ2(1,0)
     +     + 1./6.*GYZ2(1,0)*HZ1(0)
     +     )
      B20 = B20 + t * (
     +     - 3./2.*GYZ2(1,0)*HZ1(1)
     +     + GYZ2(1,0)*HZ2(0,1)
     +     + GYZ2(1,0)*HZ2(1,0)
     +     - GYZ2(1,2)*HZ2(0,1)
     +     + GYZ2(1,2)*HZ2(1,0)
     +     + 13./9.*GYZ2(2,0)
     +     - 10./3.*GYZ2(2,0)*HZ1(0)
     +     )
      B20 = B20 + t * (
     +     + 11./3.*GYZ2(2,0)*HZ1(1)
     +     - 2*GYZ2(2,0)*HZ2(0,0)
     +     - 3*GYZ2(2,0)*HZ2(0,1)
     +     - 3*GYZ2(2,0)*HZ2(1,0)
     +     - 11./2.*GYZ2(2,2)
     +     - 11./3.*GYZ2(2,2)*HZ1(0)
     +     + 4*GYZ2(2,2)*HZ2(1,0)
     +     )
      B20 = B20 + t * (
     +     - 53./6.*GYZ2(2,3)*HZ1(1)
     +     + 6*GYZ2(2,3)*HZ2(0,1)
     +     - 2*GYZ2(2,3)*HZ2(1,0)
     +     - 11./2.*GYZ2(3,0)*HZ1(1)
     +     + 2*GYZ2(3,0)*HZ2(0,1)
     +     + 2*GYZ2(3,0)*HZ2(1,1)
     +     - 71./9.*GYZ2(3,2)
     +     )
      B20 = B20 + t * (
     +     + 11./2.*GYZ2(3,2)*HZ1(0)
     +     - 22./3.*GYZ2(3,2)*HZ1(1)
     +     + 2*GYZ2(3,2)*HZ2(0,1)
     +     - 2*GYZ2(3,2)*HZ2(1,0)
     +     + 13./3.*GYZ2(3,3)*HZ1(1)
     +     - 10*GYZ2(3,3)*HZ2(0,1)
     +     + 2*GYZ2(3,3)*HZ2(1,0)
     +     )
      B20 = B20 + t * (
     +     - 4*GYZ2(3,3)*HZ2(1,1)
     +     - 7*GYZ3(0,0,2)
     +     + 2*GYZ3(0,0,3)*HZ1(1)
     +     + 37./6.*GYZ3(0,1,0)
     +     + GYZ3(0,1,0)*HZ1(0)
     +     - GYZ3(0,1,0)*HZ1(1)
     +     - 7*GYZ3(0,2,0)
     +     )
      B20 = B20 + t * (
     +     - 11./3.*GYZ3(0,2,2)
     +     - 2*GYZ3(0,2,2)*HZ1(0)
     +     - GYZ3(0,2,3)*HZ1(1)
     +     + 4*GYZ3(0,3,0)*HZ1(1)
     +     + 11./2.*GYZ3(0,3,2)
     +     + 4*GYZ3(0,3,2)*HZ1(0)
     +     - 2*GYZ3(0,3,2)*HZ1(1)
     +     )
      B20 = B20 + t * (
     +     + 2*GYZ3(0,3,3)*HZ1(1)
     +     + 7*GYZ3(1,0,0)
     +     + 2*GYZ3(1,0,0)*HZ1(0)
     +     - 2*GYZ3(1,0,0)*HZ1(1)
     +     + 3./2.*GYZ3(1,0,2)
     +     - 2*GYZ3(1,0,2)*HZ1(0)
     +     - GYZ3(1,0,3)*HZ1(1)
     +     )
      B20 = B20 + t * (
     +     + 13./6.*GYZ3(1,1,0)
     +     + 3./2.*GYZ3(1,2,0)
     +     - GYZ3(1,2,0)*HZ1(0)
     +     - GYZ3(1,2,3)*HZ1(1)
     +     - 7*GYZ3(2,0,0)
     +     - 2*GYZ3(2,0,0)*HZ1(0)
     +     - 11./3.*GYZ3(2,0,2)
     +     )
      B20 = B20 + t * (
     +     + GYZ3(2,0,2)*HZ1(0)
     +     - 2*GYZ3(2,0,3)*HZ1(1)
     +     + 3./2.*GYZ3(2,1,0)
     +     + GYZ3(2,1,0)*HZ1(0)
     +     + 3*GYZ3(2,1,0)*HZ1(1)
     +     - 11./3.*GYZ3(2,2,0)
     +     + 2*GYZ3(2,2,0)*HZ1(0)
     +     )
      B20 = B20 + t * (
     +     - 2*GYZ3(2,3,0)*HZ1(1)
     +     + 53./6.*GYZ3(2,3,2)
     +     + 2*GYZ3(2,3,2)*HZ1(0)
     +     + 8*GYZ3(2,3,3)*HZ1(1)
     +     + 11./2.*GYZ3(3,0,2)
     +     - 2*GYZ3(3,0,2)*HZ1(1)
     +     + 2*GYZ3(3,0,3)*HZ1(1)
     +     )
      B20 = B20 + t * (
     +     + 11./2.*GYZ3(3,2,0)
     +     - 2*GYZ3(3,2,0)*HZ1(1)
     +     + 22./3.*GYZ3(3,2,2)
     +     + 2*GYZ3(3,2,2)*HZ1(0)
     +     + 4*GYZ3(3,2,3)*HZ1(1)
     +     + 2*GYZ3(3,3,0)*HZ1(1)
     +     - 13./3.*GYZ3(3,3,2)
     +     )
      B20 = B20 + t * (
     +     - 2*GYZ3(3,3,2)*HZ1(0)
     +     + 4*GYZ3(3,3,2)*HZ1(1)
     +     - 12*GYZ3(3,3,3)*HZ1(1)
     +     + 2*GYZ4(0,0,1,0)
     +     - 2*GYZ4(0,0,3,2)
     +     + GYZ4(0,1,0,2)
     +     - 4*GYZ4(0,1,1,0)
     +     )
      B20 = B20 + t * (
     +     + GYZ4(0,1,2,0)
     +     + 3*GYZ4(0,2,1,0)
     +     + GYZ4(0,2,3,2)
     +     - 4*GYZ4(0,3,0,2)
     +     - 4*GYZ4(0,3,2,0)
     +     + 2*GYZ4(0,3,2,2)
     +     - 2*GYZ4(0,3,3,2)
     +     )
      B20 = B20 + t * (
     +     + 2*GYZ4(1,0,0,2)
     +     - 4*GYZ4(1,0,1,0)
     +     + 2*GYZ4(1,0,2,0)
     +     + GYZ4(1,0,3,2)
     +     - 4*GYZ4(1,1,0,0)
     +     + 4*GYZ4(1,1,1,0)
     +     + 2*GYZ4(1,2,0,0)
     +     )
      B20 = B20 + t * (
     +     + GYZ4(1,2,3,2)
     +     + 2*GYZ4(2,0,1,0)
     +     + 2*GYZ4(2,0,3,2)
     +     + 2*GYZ4(2,1,0,0)
     +     - 3*GYZ4(2,1,0,2)
     +     - 3*GYZ4(2,1,2,0)
     +     - 4*GYZ4(2,2,1,0)
     +     )
      B20 = B20 + t * (
     +     + 2*GYZ4(2,3,0,2)
     +     + 2*GYZ4(2,3,2,0)
     +     - 8*GYZ4(2,3,3,2)
     +     + 2*GYZ4(3,0,2,2)
     +     - 2*GYZ4(3,0,3,2)
     +     + 2*GYZ4(3,2,0,2)
     +     + 2*GYZ4(3,2,2,0)
     +     )
      B20 = B20 + t * (
     +     - 4*GYZ4(3,2,3,2)
     +     - 2*GYZ4(3,3,0,2)
     +     - 2*GYZ4(3,3,2,0)
     +     - 4*GYZ4(3,3,2,2)
     +     + 12*GYZ4(3,3,3,2)
     +     - 20./3.*HZ1(0)
     +     + 17./54.*HZ1(1)
     +     )
      B20 = B20 + t * (
     +     + 58./9.*HZ2(0,1)
     +     - 3./2.*HZ2(1,0)
     +     - 11./2.*HZ2(1,1)
     +     + 1./3.*HZ3(0,0,1)
     +     - 14./3.*HZ3(0,1,0)
     +     + 11./3.*HZ3(0,1,1)
     +     + 20./3.*HZ3(1,0,1)
     +     )
      B20 = B20 + t * (
     +     + 3./2.*HZ3(1,1,0)
     +     + 4*HZ4(0,0,1,0)
     +     + 2*HZ4(0,1,1,0)
     +     - HZ4(1,0,0,1)
     +     + 2*HZ4(1,0,1,0)
     +     + 2*HZ4(1,1,0,1)
     +     + 3*HZ4(1,1,1,0)
     +     )
      B20 = B20 + zeta2 * (
     +     + 11./3.
     +     + 3*GYZ1(0)
     +     + 8*GYZ1(0)*HZ1(1)
     +     - 10./3.*GYZ1(1)
     +     + 2*GYZ1(1)*HZ1(1)
     +     + 2./3.*GYZ1(2)
     +     - 8*GYZ1(2)*HZ1(0)
     +     )
      B20 = B20 + zeta2 * (
     +     - 12*GYZ1(2)*HZ1(1)
     +     + 4*GYZ2(0,1)
     +     - 2*GYZ2(0,2)
     +     + 8*GYZ2(1,0)
     +     - 2*GYZ2(1,1)
     +     - 2*GYZ2(1,2)
     +     - 8*GYZ2(2,0)
     +     )
      B20 = B20 + zeta2 * (
     +     + 4*GYZ2(2,1)
     +     + 8*GYZ2(2,2)
     +     + 3*HZ1(0)
     +     + 8./3.*HZ1(1)
     +     - 2*HZ2(0,1)
     +     + 8*HZ2(1,1)
     +     )
      B20 = B20 + zeta3 * (
     +     + 16
     +     + 10*GYZ1(1)
     +     - 20*GYZ1(2)
     +     + 10*HZ1(1)
     +     )
      B20 = B20 - 94./9.*GYZ1(0)
     +     + 13./3.*GYZ1(0)*HZ1(0)
     +     - 295./18.*GYZ1(0)*HZ1(1)
     +     + GYZ1(0)*HZ2(0,0)
     +     - 10./3.*GYZ1(0)*HZ2(0,1)
     +     + 28./3.*GYZ1(0)*HZ2(1,0)
     +     - 25./3.*GYZ1(0)*HZ2(1,1)
     +     - 4*GYZ1(0)*HZ3(0,1,0)
     +
      B20 = B20 + 2*GYZ1(0)*HZ3(0,1,1)
     +     + 2*GYZ1(0)*HZ3(1,0,1)
     +     + 2*GYZ1(0)*HZ3(1,1,0)
     +     + 2*GYZ1(1)*HZ3(0,0,1)
     +     + 2*GYZ1(1)*HZ3(0,1,0)
     +     + 2*GYZ1(1)*HZ3(1,0,1)
     +     + 2*GYZ1(1)*HZ3(1,1,0)
     +     + 188./9.*GYZ1(2)
     +
      B20 = B20 + 295./18.*GYZ1(2)*HZ1(0)
     +     + 34./3.*GYZ1(2)*HZ1(1)
     +     - 6*GYZ1(2)*HZ2(0,0)
     +     - 37./3.*GYZ1(2)*HZ2(0,1)
     +     + 1./3.*GYZ1(2)*HZ2(1,0)
     +     + 10*GYZ1(2)*HZ3(0,0,1)
     +     - 8*GYZ1(2)*HZ3(0,1,0)
     +     - 2*GYZ1(2)*HZ3(1,0,0)
     +
      B20 = B20 - 2*GYZ1(2)*HZ3(1,0,1)
     +     - 12*GYZ1(2)*HZ3(1,1,0)
     +     + 292./9.*GYZ1(3)*HZ1(1)
     +     + 32./3.*GYZ1(3)*HZ2(0,1)
     +     - 12*GYZ1(3)*HZ2(1,0)
     +     + 50./3.*GYZ1(3)*HZ2(1,1)
     +     - 16*GYZ1(3)*HZ3(0,0,1)
     +     + 4*GYZ1(3)*HZ3(0,1,0)
     +
      B20 = B20 - 4*GYZ1(3)*HZ3(0,1,1)
     +     - 4*GYZ1(3)*HZ3(1,0,1)
     +     + 4*GYZ1(3)*HZ3(1,1,0)
     +     + 2*GYZ2(0,0)
     +     + GYZ2(0,0)*HZ1(0)
     +     + 6*GYZ2(0,0)*HZ1(1)
     +     + 2*GYZ2(0,0)*HZ2(0,1)
     +     + 2*GYZ2(0,0)*HZ2(1,0)
     +
      B20 = B20 - 2*GYZ2(0,0)*HZ2(1,1)
     +     + 295./18.*GYZ2(0,2)
     +     - 26./3.*GYZ2(0,2)*HZ1(0)
     +     + 25./3.*GYZ2(0,2)*HZ1(1)
     +     - 2*GYZ2(0,2)*HZ2(0,0)
     +     + 6*GYZ2(0,2)*HZ2(1,0)
     +     - 12*GYZ2(0,3)*HZ1(1)
     +     - 4*GYZ2(0,3)*HZ2(0,1)
     +
      B20 = B20 - 8*GYZ2(0,3)*HZ2(1,0)
     +     + 4*GYZ2(0,3)*HZ2(1,1)
     +     - 155./9.*GYZ2(1,0)
     +     + 22./3.*GYZ2(1,0)*HZ1(0)
     +     + 4*GYZ2(1,0)*HZ2(1,0)
     +     - 2*GYZ2(1,2)*HZ2(0,1)
     +     - 2*GYZ2(1,2)*HZ2(1,0)
     +     + 295./18.*GYZ2(2,0)
     +
      B20 = B20 - 50./3.*GYZ2(2,0)*HZ1(0)
     +     + 25./3.*GYZ2(2,0)*HZ1(1)
     +     - 2*GYZ2(2,0)*HZ2(0,0)
     +     - 4*GYZ2(2,0)*HZ2(0,1)
     +     - 4*GYZ2(2,0)*HZ2(1,0)
     +     - 34./3.*GYZ2(2,2)
     +     - 25./3.*GYZ2(2,2)*HZ1(0)
     +     - 2*GYZ2(2,2)*HZ2(0,0)
     +
      B20 = B20 + 6*GYZ2(2,2)*HZ2(1,0)
     +     - 62./3.*GYZ2(2,3)*HZ1(1)
     +     + 12*GYZ2(2,3)*HZ2(0,1)
     +     - 4*GYZ2(2,3)*HZ2(1,0)
     +     - 12*GYZ2(3,0)*HZ1(1)
     +     + 4*GYZ2(3,0)*HZ2(0,1)
     +     + 4*GYZ2(3,0)*HZ2(1,1)
     +     - 292./9.*GYZ2(3,2)
     +
      B20 = B20 + 12*GYZ2(3,2)*HZ1(0)
     +     - 50./3.*GYZ2(3,2)*HZ1(1)
     +     + 4*GYZ2(3,2)*HZ2(0,1)
     +     - 4*GYZ2(3,2)*HZ2(1,0)
     +     + 68./3.*GYZ2(3,3)*HZ1(1)
     +     - 20*GYZ2(3,3)*HZ2(0,1)
     +     + 4*GYZ2(3,3)*HZ2(1,0)
     +     - 8*GYZ2(3,3)*HZ2(1,1)
     +
      B20 = B20 - 6*GYZ3(0,0,2)
     +     - 4*GYZ3(0,0,2)*HZ1(0)
     +     + 2*GYZ3(0,0,2)*HZ1(1)
     +     - 2*GYZ3(0,0,3)*HZ1(1)
     +     + 1./3.*GYZ3(0,1,0)
     +     + 2*GYZ3(0,1,0)*HZ1(0)
     +     - 6*GYZ3(0,2,0)
     +     + 2*GYZ3(0,2,0)*HZ1(0)
     +
      B20 = B20 + 2*GYZ3(0,2,0)*HZ1(1)
     +     - 25./3.*GYZ3(0,2,2)
     +     - 2*GYZ3(0,2,2)*HZ1(0)
     +     - 2*GYZ3(0,2,3)*HZ1(1)
     +     + 8*GYZ3(0,3,0)*HZ1(1)
     +     + 12*GYZ3(0,3,2)
     +     + 8*GYZ3(0,3,2)*HZ1(0)
     +     - 4*GYZ3(0,3,2)*HZ1(1)
     +
      B20 = B20 + 4*GYZ3(0,3,3)*HZ1(1)
     +     + 5*GYZ3(1,0,0)
     +     + 2*GYZ3(1,0,0)*HZ1(0)
     +     - 4*GYZ3(1,0,0)*HZ1(1)
     +     - 2*GYZ3(1,0,2)*HZ1(0)
     +     - 2*GYZ3(1,0,3)*HZ1(1)
     +     + 10./3.*GYZ3(1,1,0)
     +     + 2*GYZ3(1,1,0)*HZ1(0)
     +
      B20 = B20 - 4*GYZ3(1,2,0)*HZ1(0)
     +     - 2*GYZ3(1,2,3)*HZ1(1)
     +     - 6*GYZ3(2,0,0)
     +     - 2*GYZ3(2,0,0)*HZ1(0)
     +     + 2*GYZ3(2,0,0)*HZ1(1)
     +     - 25./3.*GYZ3(2,0,2)
     +     - 4*GYZ3(2,0,3)*HZ1(1)
     +     + 8*GYZ3(2,1,0)
     +
      B20 = B20 + 2*GYZ3(2,1,0)*HZ1(1)
     +     - 25./3.*GYZ3(2,2,0)
     +     + 4*GYZ3(2,2,0)*HZ1(0)
     +     - 4*GYZ3(2,3,0)*HZ1(1)
     +     + 62./3.*GYZ3(2,3,2)
     +     + 4*GYZ3(2,3,2)*HZ1(0)
     +     + 16*GYZ3(2,3,3)*HZ1(1)
     +     + 12*GYZ3(3,0,2)
     +
      B20 = B20 - 4*GYZ3(3,0,2)*HZ1(1)
     +     + 4*GYZ3(3,0,3)*HZ1(1)
     +     + 12*GYZ3(3,2,0)
     +     - 4*GYZ3(3,2,0)*HZ1(1)
     +     + 50./3.*GYZ3(3,2,2)
     +     + 4*GYZ3(3,2,2)*HZ1(0)
     +     + 8*GYZ3(3,2,3)*HZ1(1)
     +     + 4*GYZ3(3,3,0)*HZ1(1)
     +
      B20 = B20 - 68./3.*GYZ3(3,3,2)
     +     - 4*GYZ3(3,3,2)*HZ1(0)
     +     + 8*GYZ3(3,3,2)*HZ1(1)
     +     - 24*GYZ3(3,3,3)*HZ1(1)
     +     + 6*GYZ4(0,0,1,0)
     +     - 2*GYZ4(0,0,2,2)
     +     + 2*GYZ4(0,0,3,2)
     +     - 4*GYZ4(0,1,1,0)
     +
      B20 = B20 - 2*GYZ4(0,2,0,2)
     +     + 4*GYZ4(0,2,1,0)
     +     - 2*GYZ4(0,2,2,0)
     +     + 2*GYZ4(0,2,3,2)
     +     - 8*GYZ4(0,3,0,2)
     +     - 8*GYZ4(0,3,2,0)
     +     + 4*GYZ4(0,3,2,2)
     +     - 4*GYZ4(0,3,3,2)
     +
      B20 = B20 + 4*GYZ4(1,0,0,2)
     +     - 8*GYZ4(1,0,1,0)
     +     + 4*GYZ4(1,0,2,0)
     +     + 2*GYZ4(1,0,3,2)
     +     - 6*GYZ4(1,1,0,0)
     +     + 2*GYZ4(1,1,1,0)
     +     + 4*GYZ4(1,2,0,0)
     +     + 4*GYZ4(1,2,1,0)
     +
      B20 = B20 + 2*GYZ4(1,2,3,2)
     +     - 2*GYZ4(2,0,0,2)
     +     + 6*GYZ4(2,0,1,0)
     +     - 2*GYZ4(2,0,2,0)
     +     + 4*GYZ4(2,0,3,2)
     +     + 4*GYZ4(2,1,0,0)
     +     - 2*GYZ4(2,1,0,2)
     +     - 4*GYZ4(2,1,1,0)
     +
      B20 = B20 - 2*GYZ4(2,1,2,0)
     +     - 2*GYZ4(2,2,0,0)
     +     - 6*GYZ4(2,2,1,0)
     +     + 4*GYZ4(2,3,0,2)
     +     + 4*GYZ4(2,3,2,0)
     +     - 16*GYZ4(2,3,3,2)
     +     + 4*GYZ4(3,0,2,2)
     +     - 4*GYZ4(3,0,3,2)
     +
      B20 = B20 + 4*GYZ4(3,2,0,2)
     +     + 4*GYZ4(3,2,2,0)
     +     - 8*GYZ4(3,2,3,2)
     +     - 4*GYZ4(3,3,0,2)
     +     - 4*GYZ4(3,3,2,0)
     +     - 8*GYZ4(3,3,2,2)
     +     + 24*GYZ4(3,3,3,2)
     +     - 94./9.*HZ1(0)
     +
      B20 = B20 - 188./9.*HZ1(1)
     +     + 2*HZ2(0,0)
     +     + 289./18.*HZ2(0,1)
     +     + 5./6.*HZ2(1,0)
     +     - 34./3.*HZ2(1,1)
     +     + 14./3.*HZ3(0,0,1)
     +     - 19./3.*HZ3(0,1,0)
     +     + 25./3.*HZ3(0,1,1)
     +
      B20 = B20 + HZ3(1,0,0)
     +     + 37./3.*HZ3(1,0,1)
     +     + 3*HZ3(1,1,0)
     +     - 6*HZ4(0,0,0,1)
     +     + 6*HZ4(0,0,1,0)
     +     - 2*HZ4(0,0,1,1)
     +     - 4*HZ4(0,1,0,1)
     +     + 2*HZ4(0,1,1,0)
     +
      B20 = B20 - 4*HZ4(1,0,0,1)
     +     + 4*HZ4(1,0,1,0)
     +     + 6*HZ4(1,1,1,0)
     +

      C20 = 0.
     +
      C20 = C20 + y**(-2)*z * (
     +     + 6*GYZ1(2)*HZ1(0)
     +     + 6*GYZ1(3)*HZ1(1)
     +     - 6*GYZ2(3,2)
     +     )
      C20 = C20 + y**(-2)*z**2 * (
     +     - 2*GYZ1(2)*HZ1(0)
     +     - 2*GYZ1(3)*HZ1(1)
     +     + 2*GYZ2(3,2)
     +     )
      C20 = C20 + y**(-2) * (
     +     - 4*GYZ1(2)*HZ1(0)
     +     - 4*GYZ1(3)*HZ1(1)
     +     + 4*GYZ2(3,2)
     +     )
      C20 = C20 + y**(-1)*z*zeta2 * (
     +     - 1
     +     + GYZ1(2)
     +     + 10*GYZ1(2)*HZ1(0)
     +     + 6*GYZ1(2)*HZ1(1)
     +     + 10*GYZ1(3)*HZ1(1)
     +     + 2*GYZ2(2,0)
     +     + 4*GYZ2(2,1)
     +     )
      C20 = C20 + y**(-1)*z*zeta2 * (
     +     - 16*GYZ2(2,2)
     +     - 10*GYZ2(3,2)
     +     + 4*HZ1(0)
     +     + HZ1(1)
     +     )
      C20 = C20 + y**(-1)*z*zeta3 * (
     +     - 9
     +     - 4*GYZ1(2)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     - 17./4.*GYZ1(0)*HZ1(1)
     +     + 3./2.*GYZ1(0)*HZ2(1,1)
     +     + 9./4.*GYZ1(2)*HZ1(0)
     +     - 7./2.*GYZ1(2)*HZ2(0,1)
     +     + GYZ1(2)*HZ2(1,0)
     +     + 8*GYZ1(2)*HZ3(0,1,0)
     +     + 10*GYZ1(2)*HZ3(1,0,0)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     - 4*GYZ1(2)*HZ3(1,0,1)
     +     + 2*GYZ1(2)*HZ3(1,1,0)
     +     + 13./2.*GYZ1(3)*HZ1(1)
     +     + 7./2.*GYZ1(3)*HZ2(0,1)
     +     - 23./2.*GYZ1(3)*HZ2(1,0)
     +     - 3*GYZ1(3)*HZ2(1,1)
     +     - 10*GYZ1(3)*HZ3(0,1,0)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     + 2*GYZ1(3)*HZ3(0,1,1)
     +     + 2*GYZ1(3)*HZ3(1,0,1)
     +     + 6*GYZ1(3)*HZ3(1,1,0)
     +     + 17./4.*GYZ2(0,2)
     +     - 5./2.*GYZ2(0,2)*HZ1(0)
     +     - 3./2.*GYZ2(0,2)*HZ1(1)
     +     - 5./2.*GYZ2(0,3)*HZ1(1)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     - 15./2.*GYZ2(1,0)
     +     + 3*GYZ2(1,0)*HZ1(0)
     +     + 6*GYZ2(1,0)*HZ1(1)
     +     + 17./4.*GYZ2(2,0)
     +     - 6*GYZ2(2,0)*HZ1(0)
     +     - 3./2.*GYZ2(2,0)*HZ1(1)
     +     + 10*GYZ2(2,0)*HZ2(0,0)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     - 2*GYZ2(2,0)*HZ2(0,1)
     +     + 3./2.*GYZ2(2,2)*HZ1(0)
     +     + 4*GYZ2(2,2)*HZ2(0,0)
     +     + 6*GYZ2(2,2)*HZ2(0,1)
     +     - 10*GYZ2(2,2)*HZ2(1,0)
     +     - 2*GYZ2(2,3)*HZ1(1)
     +     + 9./2.*GYZ2(3,0)*HZ1(1)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     + 10*GYZ2(3,0)*HZ2(1,0)
     +     - 2*GYZ2(3,0)*HZ2(1,1)
     +     - 13./2.*GYZ2(3,2)
     +     + 23./2.*GYZ2(3,2)*HZ1(0)
     +     + 3*GYZ2(3,2)*HZ1(1)
     +     - 2*GYZ2(3,2)*HZ2(0,1)
     +     - 6*GYZ2(3,2)*HZ2(1,0)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     + 15*GYZ2(3,3)*HZ1(1)
     +     - 6*GYZ2(3,3)*HZ2(0,1)
     +     + 6*GYZ2(3,3)*HZ2(1,1)
     +     + 9./2.*GYZ3(0,1,0)
     +     + 3./2.*GYZ3(0,2,2)
     +     + 5./2.*GYZ3(0,3,2)
     +     - 6*GYZ3(1,0,2)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     - 6*GYZ3(1,2,0)
     +     + 3./2.*GYZ3(2,0,2)
     +     - 2*GYZ3(2,0,2)*HZ1(0)
     +     - 4*GYZ3(2,0,3)*HZ1(1)
     +     + 9./2.*GYZ3(2,1,0)
     +     + 3./2.*GYZ3(2,2,0)
     +     - 10*GYZ3(2,2,0)*HZ1(0)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     + 6*GYZ3(2,2,3)*HZ1(1)
     +     + 2*GYZ3(2,3,2)
     +     - 9./2.*GYZ3(3,0,2)
     +     + 2*GYZ3(3,0,2)*HZ1(1)
     +     - 9./2.*GYZ3(3,2,0)
     +     - 10*GYZ3(3,2,0)*HZ1(0)
     +     + 2*GYZ3(3,2,0)*HZ1(1)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     - 3*GYZ3(3,2,2)
     +     - 4*GYZ3(3,2,2)*HZ1(0)
     +     - 6*GYZ3(3,2,3)*HZ1(1)
     +     + 6*GYZ3(3,3,0)*HZ1(1)
     +     - 15*GYZ3(3,3,2)
     +     - 6*GYZ3(3,3,2)*HZ1(1)
     +     - 6*GYZ3(3,3,3)*HZ1(1)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     - 12*GYZ4(2,0,1,0)
     +     + 4*GYZ4(2,0,3,2)
     +     - 4*GYZ4(2,1,1,0)
     +     + 12*GYZ4(2,2,1,0)
     +     - 6*GYZ4(2,2,3,2)
     +     + 16*GYZ4(3,0,1,0)
     +     - 2*GYZ4(3,0,2,2)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     - 2*GYZ4(3,2,0,2)
     +     + 16*GYZ4(3,2,1,0)
     +     - 2*GYZ4(3,2,2,0)
     +     + 6*GYZ4(3,2,3,2)
     +     - 6*GYZ4(3,3,0,2)
     +     - 6*GYZ4(3,3,2,0)
     +     + 6*GYZ4(3,3,2,2)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     + 6*GYZ4(3,3,3,2)
     +     - HZ1(0)
     +     + 17./4.*HZ2(0,1)
     +     - 13./4.*HZ2(1,0)
     +     - HZ3(0,0,1)
     +     - 2*HZ3(0,1,0)
     +     - 3./2.*HZ3(0,1,1)
     +     )
      C20 = C20 + y**(-1)*z * (
     +     - 5./2.*HZ3(1,0,1)
     +     - 5*HZ3(1,1,0)
     +     )
      C20 = C20 + y**(-1)*z**2 * (
     +     - 2*GYZ1(2)*HZ1(0)
     +     - 2*GYZ1(3)*HZ1(1)
     +     + 2*GYZ2(3,2)
     +     )
      C20 = C20 + y**(-1)*(y+z)**(-1) * (
     +     - 17./2.*GYZ1(0)*HZ1(1)
     +     + 3*GYZ1(0)*HZ2(1,1)
     +     - 17./2.*GYZ1(2)*HZ1(0)
     +     + 3*GYZ1(2)*HZ2(0,1)
     +     + 12*GYZ1(2)*HZ2(1,0)
     +     - 9*GYZ1(3)*HZ2(0,1)
     +     - 9*GYZ1(3)*HZ2(1,0)
     +     )
      C20 = C20 + y**(-1)*(y+z)**(-1) * (
     +     + 17./2.*GYZ2(0,2)
     +     - 9*GYZ2(0,2)*HZ1(0)
     +     - 3*GYZ2(0,2)*HZ1(1)
     +     - 9*GYZ2(0,3)*HZ1(1)
     +     - 17*GYZ2(1,0)
     +     + 17./2.*GYZ2(2,0)
     +     - 3*GYZ2(2,0)*HZ1(1)
     +     )
      C20 = C20 + y**(-1)*(y+z)**(-1) * (
     +     - 3*GYZ2(2,2)*HZ1(0)
     +     + 9*GYZ2(3,0)*HZ1(1)
     +     + 9*GYZ2(3,2)*HZ1(0)
     +     + 9*GYZ3(0,1,0)
     +     + 3*GYZ3(0,2,2)
     +     + 9*GYZ3(0,3,2)
     +     + 3*GYZ3(2,0,2)
     +     )
      C20 = C20 + y**(-1)*(y+z)**(-1) * (
     +     + 9*GYZ3(2,1,0)
     +     + 3*GYZ3(2,2,0)
     +     - 9*GYZ3(3,0,2)
     +     - 9*GYZ3(3,2,0)
     +     + 17./2.*HZ2(0,1)
     +     - 17./2.*HZ2(1,0)
     +     - 3*HZ3(0,1,1)
     +     )
      C20 = C20 + y**(-1)*(y+z)**(-1) * (
     +     - 3*HZ3(1,0,1)
     +     - 12*HZ3(1,1,0)
     +     )
      C20 = C20 + y**(-1)*zeta2 * (
     +     + 2*GYZ1(1)
     +     - 12*GYZ1(2)
     +     - 8*GYZ1(2)*HZ1(0)
     +     - 12*GYZ1(2)*HZ1(1)
     +     - 8*GYZ1(3)*HZ1(1)
     +     - 4*GYZ2(2,0)
     +     - 8*GYZ2(2,1)
     +     )
      C20 = C20 + y**(-1)*zeta2 * (
     +     + 20*GYZ2(2,2)
     +     + 8*GYZ2(3,2)
     +     + 2*HZ1(1)
     +     )
      C20 = C20 + y**(-1)*zeta3 * (
     +     - 2
     +     + 20*GYZ1(2)
     +     )
      C20 = C20 + y**(-1) * (
     +     + 19./4.
     +     + 15./2.*GYZ1(0)*HZ1(1)
     +     - 3*GYZ1(0)*HZ2(1,1)
     +     + 1./2.*GYZ1(2)
     +     + 13./2.*GYZ1(2)*HZ1(0)
     +     + 9*GYZ1(2)*HZ2(0,1)
     +     - 14*GYZ1(2)*HZ2(1,0)
     +     )
      C20 = C20 + y**(-1) * (
     +     - 4*GYZ1(2)*HZ3(0,1,0)
     +     - 8*GYZ1(2)*HZ3(1,0,0)
     +     + 8*GYZ1(2)*HZ3(1,0,1)
     +     - 4*GYZ1(2)*HZ3(1,1,0)
     +     - 7*GYZ1(3)*HZ2(0,1)
     +     + 27*GYZ1(3)*HZ2(1,0)
     +     + 6*GYZ1(3)*HZ2(1,1)
     +     )
      C20 = C20 + y**(-1) * (
     +     + 8*GYZ1(3)*HZ3(0,1,0)
     +     - 4*GYZ1(3)*HZ3(0,1,1)
     +     - 4*GYZ1(3)*HZ3(1,0,1)
     +     - 15./2.*GYZ2(0,2)
     +     + 17*GYZ2(0,2)*HZ1(0)
     +     + 3*GYZ2(0,2)*HZ1(1)
     +     + 17*GYZ2(0,3)*HZ1(1)
     +     )
      C20 = C20 + y**(-1) * (
     +     + 15*GYZ2(1,0)
     +     - 4*GYZ2(1,0)*HZ1(0)
     +     - 6*GYZ2(1,0)*HZ1(1)
     +     - 15./2.*GYZ2(2,0)
     +     + 10*GYZ2(2,0)*HZ1(0)
     +     + 3*GYZ2(2,0)*HZ1(1)
     +     - 8*GYZ2(2,0)*HZ2(0,0)
     +     )
      C20 = C20 + y**(-1) * (
     +     + 4*GYZ2(2,0)*HZ2(0,1)
     +     - 3*GYZ2(2,2)*HZ1(0)
     +     - 8*GYZ2(2,2)*HZ2(0,0)
     +     - 12*GYZ2(2,2)*HZ2(0,1)
     +     + 8*GYZ2(2,2)*HZ2(1,0)
     +     + 6*GYZ2(2,3)*HZ1(1)
     +     - 5*GYZ2(3,0)*HZ1(1)
     +     )
      C20 = C20 + y**(-1) * (
     +     - 8*GYZ2(3,0)*HZ2(1,0)
     +     + 4*GYZ2(3,0)*HZ2(1,1)
     +     - 27*GYZ2(3,2)*HZ1(0)
     +     - 6*GYZ2(3,2)*HZ1(1)
     +     + 4*GYZ2(3,2)*HZ2(0,1)
     +     - 34*GYZ2(3,3)*HZ1(1)
     +     + 12*GYZ2(3,3)*HZ2(0,1)
     +     )
      C20 = C20 + y**(-1) * (
     +     - 12*GYZ2(3,3)*HZ2(1,1)
     +     - 9*GYZ3(0,1,0)
     +     - 3*GYZ3(0,2,2)
     +     - 17*GYZ3(0,3,2)
     +     + 6*GYZ3(1,0,2)
     +     - 2*GYZ3(1,1,0)
     +     + 6*GYZ3(1,2,0)
     +     )
      C20 = C20 + y**(-1) * (
     +     - 3*GYZ3(2,0,2)
     +     + 4*GYZ3(2,0,2)*HZ1(0)
     +     + 8*GYZ3(2,0,3)*HZ1(1)
     +     - 9*GYZ3(2,1,0)
     +     - 3*GYZ3(2,2,0)
     +     + 8*GYZ3(2,2,0)*HZ1(0)
     +     - 12*GYZ3(2,2,3)*HZ1(1)
     +     )
      C20 = C20 + y**(-1) * (
     +     - 6*GYZ3(2,3,2)
     +     + 5*GYZ3(3,0,2)
     +     - 4*GYZ3(3,0,2)*HZ1(1)
     +     + 5*GYZ3(3,2,0)
     +     + 8*GYZ3(3,2,0)*HZ1(0)
     +     - 4*GYZ3(3,2,0)*HZ1(1)
     +     + 6*GYZ3(3,2,2)
     +     )
      C20 = C20 + y**(-1) * (
     +     + 8*GYZ3(3,2,2)*HZ1(0)
     +     + 12*GYZ3(3,2,3)*HZ1(1)
     +     - 12*GYZ3(3,3,0)*HZ1(1)
     +     + 34*GYZ3(3,3,2)
     +     + 12*GYZ3(3,3,2)*HZ1(1)
     +     + 12*GYZ3(3,3,3)*HZ1(1)
     +     + 12*GYZ4(2,0,1,0)
     +     )
      C20 = C20 + y**(-1) * (
     +     - 8*GYZ4(2,0,3,2)
     +     + 8*GYZ4(2,1,1,0)
     +     - 12*GYZ4(2,2,1,0)
     +     + 12*GYZ4(2,2,3,2)
     +     - 20*GYZ4(3,0,1,0)
     +     + 4*GYZ4(3,0,2,2)
     +     + 4*GYZ4(3,2,0,2)
     +     )
      C20 = C20 + y**(-1) * (
     +     - 20*GYZ4(3,2,1,0)
     +     + 4*GYZ4(3,2,2,0)
     +     - 12*GYZ4(3,2,3,2)
     +     + 12*GYZ4(3,3,0,2)
     +     + 12*GYZ4(3,3,2,0)
     +     - 12*GYZ4(3,3,2,2)
     +     - 12*GYZ4(3,3,3,2)
     +     )
      C20 = C20 + y**(-1) * (
     +     + 2*HZ1(0)
     +     - 1./2.*HZ1(1)
     +     - 13./2.*HZ2(0,1)
     +     + 13./2.*HZ2(1,0)
     +     - 2*HZ3(0,0,1)
     +     + 4*HZ3(0,1,0)
     +     + 3*HZ3(0,1,1)
     +     )
      C20 = C20 + y**(-1) * (
     +     + HZ3(1,0,1)
     +     + 14*HZ3(1,1,0)
     +     )
      C20 = C20 + z*(1.-y)**(-2)*zeta2 * (
     +     + 15./2.
     +     + GYZ1(0)
     +     - 2*GYZ1(1)
     +     - 7*GYZ1(2)
     +     + 7*HZ1(0)
     +     + 7*HZ1(1)
     +     )
      C20 = C20 + z*(1.-y)**(-2)*zeta3 * (
     +     - 23
     +     )
      C20 = C20 + z*(1.-y)**(-2) * (
     +     + 23./4.*GYZ1(0)
     +     + 3*GYZ1(0)*HZ1(0)
     +     + 3./2.*GYZ1(0)*HZ1(1)
     +     + GYZ1(0)*HZ2(0,1)
     +     + 8*GYZ1(2)*HZ2(0,1)
     +     - 7*GYZ1(2)*HZ2(1,0)
     +     - 4*GYZ1(3)*HZ1(1)
     +     )
      C20 = C20 + z*(1.-y)**(-2) * (
     +     - 5./2.*GYZ2(0,0)
     +     + GYZ2(0,0)*HZ1(0)
     +     - GYZ2(0,0)*HZ1(1)
     +     - 3./2.*GYZ2(0,2)
     +     + 7*GYZ2(0,2)*HZ1(0)
     +     + 8*GYZ2(0,3)*HZ1(1)
     +     - 7./2.*GYZ2(1,0)
     +     )
      C20 = C20 + z*(1.-y)**(-2) * (
     +     - 3./2.*GYZ2(2,0)
     +     + 8*GYZ2(2,3)*HZ1(1)
     +     + 4*GYZ2(3,2)
     +     + GYZ3(0,0,2)
     +     - 2*GYZ3(0,1,0)
     +     + GYZ3(0,2,0)
     +     - 8*GYZ3(0,3,2)
     +     )
      C20 = C20 + z*(1.-y)**(-2) * (
     +     - 2*GYZ3(1,0,0)
     +     + 2*GYZ3(1,1,0)
     +     + GYZ3(2,0,0)
     +     - GYZ3(2,1,0)
     +     - 8*GYZ3(2,3,2)
     +     - 4*HZ2(0,1)
     +     + 4*HZ2(1,0)
     +     )
      C20 = C20 + z*(1.-y)**(-2) * (
     +     - 8*HZ3(0,0,1)
     +     + 7*HZ3(0,1,0)
     +     - 8*HZ3(1,0,1)
     +     + 7*HZ3(1,1,0)
     +     )
      C20 = C20 + z*(1.-y)**(-1)*zeta2 * (
     +     + 11./2.
     +     + 3*GYZ1(0)
     +     - 6*GYZ1(1)
     +     - 9*GYZ1(2)
     +     + 9*HZ1(0)
     +     + 9*HZ1(1)
     +     )
      C20 = C20 + z*(1.-y)**(-1)*zeta3 * (
     +     - 33
     +     )
      C20 = C20 + z*(1.-y)**(-1) * (
     +     + 17./4.
     +     + 39./4.*GYZ1(0)
     +     - 11./2.*GYZ1(0)*HZ1(1)
     +     + 3*GYZ1(0)*HZ2(0,1)
     +     + 1./2.*GYZ1(2)
     +     + 7*GYZ1(2)*HZ1(0)
     +     + 12*GYZ1(2)*HZ2(0,1)
     +     )
      C20 = C20 + z*(1.-y)**(-1) * (
     +     - 9*GYZ1(2)*HZ2(1,0)
     +     + 8*GYZ1(3)*HZ1(1)
     +     - 11./2.*GYZ2(0,0)
     +     + 3*GYZ2(0,0)*HZ1(0)
     +     - 3*GYZ2(0,0)*HZ1(1)
     +     + 11./2.*GYZ2(0,2)
     +     + 9*GYZ2(0,2)*HZ1(0)
     +     )
      C20 = C20 + z*(1.-y)**(-1) * (
     +     + 12*GYZ2(0,3)*HZ1(1)
     +     - 13./2.*GYZ2(1,0)
     +     + 11./2.*GYZ2(2,0)
     +     + 12*GYZ2(2,3)*HZ1(1)
     +     - 8*GYZ2(3,2)
     +     + 3*GYZ3(0,0,2)
     +     - 6*GYZ3(0,1,0)
     +     )
      C20 = C20 + z*(1.-y)**(-1) * (
     +     + 3*GYZ3(0,2,0)
     +     - 12*GYZ3(0,3,2)
     +     - 6*GYZ3(1,0,0)
     +     + 6*GYZ3(1,1,0)
     +     + 3*GYZ3(2,0,0)
     +     - 3*GYZ3(2,1,0)
     +     - 12*GYZ3(2,3,2)
     +     )
      C20 = C20 + z*(1.-y)**(-1) * (
     +     + HZ1(0)
     +     - 1./2.*HZ1(1)
     +     + HZ2(0,1)
     +     - 12*HZ3(0,0,1)
     +     + 9*HZ3(0,1,0)
     +     - 12*HZ3(1,0,1)
     +     + 9*HZ3(1,1,0)
     +     )
      C20 = C20 + z*(y+z)**(-3)*zeta2 * (
     +     + 36*GYZ1(2)
     +     - 36*HZ1(1)
     +     )
      C20 = C20 + z*(y+z)**(-3) * (
     +     - 36*GYZ1(0)*HZ2(1,0)
     +     + 36*GYZ1(2)*HZ2(1,0)
     +     + 36*GYZ2(1,0)
     +     + 36*GYZ2(2,0)*HZ1(0)
     +     - 36*GYZ3(0,1,0)
     +     - 36*GYZ3(2,1,0)
     +     + 36*HZ2(1,0)
     +     )
      C20 = C20 + z*(y+z)**(-3) * (
     +     + 36*HZ3(0,1,0)
     +     - 36*HZ3(1,1,0)
     +     )
      C20 = C20 + z*(y+z)**(-2)*zeta2 * (
     +     + 36
     +     - 24*GYZ1(2)
     +     + 24*HZ1(1)
     +     )
      C20 = C20 + z*(y+z)**(-2) * (
     +     + 18*GYZ1(0)
     +     + 36*GYZ1(0)*HZ1(0)
     +     + 24*GYZ1(0)*HZ2(1,0)
     +     - 24*GYZ1(2)*HZ2(1,0)
     +     - 60*GYZ2(1,0)
     +     - 24*GYZ2(2,0)*HZ1(0)
     +     + 24*GYZ3(0,1,0)
     +     )
      C20 = C20 + z*(y+z)**(-2) * (
     +     + 24*GYZ3(2,1,0)
     +     - 18*HZ1(0)
     +     + 12*HZ2(1,0)
     +     - 24*HZ3(0,1,0)
     +     + 24*HZ3(1,1,0)
     +     )
      C20 = C20 + z*(y+z)**(-1)*zeta2 * (
     +     - 6
     +     )
      C20 = C20 + z*(y+z)**(-1) * (
     +     - 6*GYZ1(0)
     +     - 6*GYZ1(0)*HZ1(0)
     +     + 6*GYZ2(1,0)
     +     + 6*HZ1(0)
     +     - 6*HZ2(1,0)
     +     )
      C20 = C20 + z**2*(1.-y)**(-3)*zeta2 * (
     +     + 4*GYZ1(2)
     +     - 4*HZ1(0)
     +     - 4*HZ1(1)
     +     )
      C20 = C20 + z**2*(1.-y)**(-3)*zeta3 * (
     +     + 12
     +     )
      C20 = C20 + z**2*(1.-y)**(-3) * (
     +     - 4*GYZ1(2)*HZ2(0,1)
     +     + 4*GYZ1(2)*HZ2(1,0)
     +     - 4*GYZ2(0,2)*HZ1(0)
     +     - 4*GYZ2(0,3)*HZ1(1)
     +     - 4*GYZ2(2,3)*HZ1(1)
     +     + 4*GYZ3(0,3,2)
     +     + 4*GYZ3(2,3,2)
     +     )
      C20 = C20 + z**2*(1.-y)**(-3) * (
     +     + 4*HZ3(0,0,1)
     +     - 4*HZ3(0,1,0)
     +     + 4*HZ3(1,0,1)
     +     - 4*HZ3(1,1,0)
     +     )
      C20 = C20 + z**2*(1.-y)**(-2) * (
     +     - 4*GYZ1(2)*HZ1(0)
     +     - 4*GYZ1(3)*HZ1(1)
     +     + 4*GYZ2(3,2)
     +     )
      C20 = C20 + z**2*(1.-y)**(-1) * (
     +     - 2*GYZ1(2)*HZ1(0)
     +     - 2*GYZ1(3)*HZ1(1)
     +     + 2*GYZ2(3,2)
     +     )
      C20 = C20 + z**2*(y+z)**(-4)*zeta2 * (
     +     - 36*GYZ1(2)
     +     + 36*HZ1(1)
     +     )
      C20 = C20 + z**2*(y+z)**(-4) * (
     +     + 36*GYZ1(0)*HZ2(1,0)
     +     - 36*GYZ1(2)*HZ2(1,0)
     +     - 36*GYZ2(2,0)*HZ1(0)
     +     + 36*GYZ3(0,1,0)
     +     + 36*GYZ3(2,1,0)
     +     - 36*HZ3(0,1,0)
     +     + 36*HZ3(1,1,0)
     +     )
      C20 = C20 + z**2*(y+z)**(-3)*zeta2 * (
     +     - 36
     +     + 24*GYZ1(2)
     +     - 24*HZ1(1)
     +     )
      C20 = C20 + z**2*(y+z)**(-3) * (
     +     - 36*GYZ1(0)*HZ1(0)
     +     - 24*GYZ1(0)*HZ2(1,0)
     +     + 24*GYZ1(2)*HZ2(1,0)
     +     + 36*GYZ2(1,0)
     +     + 24*GYZ2(2,0)*HZ1(0)
     +     - 24*GYZ3(0,1,0)
     +     - 24*GYZ3(2,1,0)
     +     )
      C20 = C20 + z**2*(y+z)**(-3) * (
     +     - 36*HZ2(1,0)
     +     + 24*HZ3(0,1,0)
     +     - 24*HZ3(1,1,0)
     +     )
      C20 = C20 + z**2*(y+z)**(-2)*zeta2 * (
     +     + 6
     +     )
      C20 = C20 + z**2*(y+z)**(-2) * (
     +     + 6*GYZ1(0)*HZ1(0)
     +     - 6*GYZ2(1,0)
     +     + 6*HZ2(1,0)
     +     )
      C20 = C20 + (1.-y-z)**(-1)*zeta2 * (
     +     - 2
     +     )
      C20 = C20 + (1.-y-z)**(-1) * (
     +     - 2*GYZ1(0)*HZ1(0)
     +     + 2*GYZ2(1,0)
     +     - 2*HZ2(1,0)
     +     )
      C20 = C20 + (1.-y)**(-1)*zeta2 * (
     +     - 6
     +     + 2*GYZ1(0)
     +     + 8*GYZ1(1)
     +     + 4*GYZ1(2)
     +     - 8*HZ1(0)
     +     - 4*HZ1(1)
     +     )
      C20 = C20 + (1.-y)**(-1)*zeta3 * (
     +     + 32
     +     )
      C20 = C20 + (1.-y)**(-1) * (
     +     - 5./2.*GYZ1(0)
     +     + 3*GYZ1(0)*HZ1(0)
     +     - GYZ1(0)*HZ1(1)
     +     - 2*GYZ1(0)*HZ2(0,1)
     +     + 4*GYZ1(0)*HZ2(1,0)
     +     - 10*GYZ1(2)*HZ2(0,1)
     +     + 4*GYZ1(2)*HZ2(1,0)
     +     )
      C20 = C20 + (1.-y)**(-1) * (
     +     + 6*GYZ1(3)*HZ1(1)
     +     - 2*GYZ2(0,0)
     +     + 2*GYZ2(0,0)*HZ1(0)
     +     + 2*GYZ2(0,0)*HZ1(1)
     +     + GYZ2(0,2)
     +     - 8*GYZ2(0,2)*HZ1(0)
     +     - 10*GYZ2(0,3)*HZ1(1)
     +     )
      C20 = C20 + (1.-y)**(-1) * (
     +     + 4*GYZ2(1,0)*HZ1(0)
     +     + GYZ2(2,0)
     +     - 4*GYZ2(2,0)*HZ1(0)
     +     - 10*GYZ2(2,3)*HZ1(1)
     +     - 6*GYZ2(3,2)
     +     - 2*GYZ3(0,0,2)
     +     - 2*GYZ3(0,2,0)
     +     )
      C20 = C20 + (1.-y)**(-1) * (
     +     + 10*GYZ3(0,3,2)
     +     - 8*GYZ3(1,1,0)
     +     - 2*GYZ3(2,0,0)
     +     + 6*GYZ3(2,1,0)
     +     + 10*GYZ3(2,3,2)
     +     + 6*HZ2(0,1)
     +     - 5*HZ2(1,0)
     +     )
      C20 = C20 + (1.-y)**(-1) * (
     +     + 10*HZ3(0,0,1)
     +     - 4*HZ3(0,1,0)
     +     + 10*HZ3(1,0,1)
     +     - 4*HZ3(1,1,0)
     +     )
      C20 = C20 + (y+z)**(-2)*zeta2 * (
     +     - 22*GYZ1(2)
     +     + 22*HZ1(1)
     +     )
      C20 = C20 + (y+z)**(-2) * (
     +     - 3./2.*GYZ1(0)*HZ1(1)
     +     + 22*GYZ1(0)*HZ2(1,0)
     +     - GYZ1(0)*HZ2(1,1)
     +     - 27./2.*GYZ1(2)
     +     + 3./2.*GYZ1(2)*HZ1(0)
     +     + 3*GYZ1(2)*HZ1(1)
     +     - GYZ1(2)*HZ2(0,1)
     +     )
      C20 = C20 + (y+z)**(-2) * (
     +     - 22*GYZ1(2)*HZ2(1,0)
     +     + 3*GYZ1(3)*HZ1(1)
     +     - GYZ1(3)*HZ2(0,1)
     +     + GYZ1(3)*HZ2(1,0)
     +     + 2*GYZ1(3)*HZ2(1,1)
     +     + 3./2.*GYZ2(0,2)
     +     + GYZ2(0,2)*HZ1(0)
     +     )
      C20 = C20 + (y+z)**(-2) * (
     +     + GYZ2(0,2)*HZ1(1)
     +     + GYZ2(0,3)*HZ1(1)
     +     + 3./2.*GYZ2(2,0)
     +     - 22*GYZ2(2,0)*HZ1(0)
     +     + GYZ2(2,0)*HZ1(1)
     +     - 3*GYZ2(2,2)
     +     - GYZ2(2,2)*HZ1(0)
     +     )
      C20 = C20 + (y+z)**(-2) * (
     +     - 2*GYZ2(2,3)*HZ1(1)
     +     + GYZ2(3,0)*HZ1(1)
     +     - 3*GYZ2(3,2)
     +     - GYZ2(3,2)*HZ1(0)
     +     - 2*GYZ2(3,2)*HZ1(1)
     +     - 2*GYZ2(3,3)*HZ1(1)
     +     + 23*GYZ3(0,1,0)
     +     )
      C20 = C20 + (y+z)**(-2) * (
     +     - GYZ3(0,2,2)
     +     - GYZ3(0,3,2)
     +     - GYZ3(2,0,2)
     +     + 23*GYZ3(2,1,0)
     +     - GYZ3(2,2,0)
     +     + 2*GYZ3(2,3,2)
     +     - GYZ3(3,0,2)
     +     )
      C20 = C20 + (y+z)**(-2) * (
     +     - GYZ3(3,2,0)
     +     + 2*GYZ3(3,2,2)
     +     + 2*GYZ3(3,3,2)
     +     + 27./2.*HZ1(1)
     +     + 3./2.*HZ2(0,1)
     +     - 3./2.*HZ2(1,0)
     +     - 3*HZ2(1,1)
     +     )
      C20 = C20 + (y+z)**(-2) * (
     +     - 22*HZ3(0,1,0)
     +     + HZ3(0,1,1)
     +     + HZ3(1,0,1)
     +     + 22*HZ3(1,1,0)
     +     )
      C20 = C20 + (y+z)**(-1)*zeta2 * (
     +     - 22
     +     + 6*GYZ1(2)
     +     - 6*HZ1(1)
     +     )
      C20 = C20 + (y+z)**(-1) * (
     +     - 17./2.
     +     - 5./2.*GYZ1(0)
     +     - 22*GYZ1(0)*HZ1(0)
     +     + 2*GYZ1(0)*HZ1(1)
     +     - 6*GYZ1(0)*HZ2(1,0)
     +     - 2*GYZ1(2)
     +     - 2*GYZ1(2)*HZ1(0)
     +     )
      C20 = C20 + (y+z)**(-1) * (
     +     - 2*GYZ1(2)*HZ1(1)
     +     + 6*GYZ1(2)*HZ2(1,0)
     +     - 4*GYZ1(3)*HZ1(1)
     +     - 2*GYZ2(0,2)
     +     + 23*GYZ2(1,0)
     +     - 2*GYZ2(2,0)
     +     + 6*GYZ2(2,0)*HZ1(0)
     +     )
      C20 = C20 + (y+z)**(-1) * (
     +     + 2*GYZ2(2,2)
     +     + 4*GYZ2(3,2)
     +     - 6*GYZ3(0,1,0)
     +     - 6*GYZ3(2,1,0)
     +     - 5./2.*HZ1(0)
     +     + 2*HZ1(1)
     +     - 2*HZ2(0,1)
     +     )
      C20 = C20 + (y+z)**(-1) * (
     +     - 21*HZ2(1,0)
     +     + 2*HZ2(1,1)
     +     + 6*HZ3(0,1,0)
     +     - 6*HZ3(1,1,0)
     +     )
      C20 = C20 + t*zeta2 * (
     +     + 29./4.
     +     - 9./2.*GYZ1(1)
     +     + 3*GYZ1(2)
     +     + 2*GYZ1(2)*HZ1(1)
     +     - 2*GYZ2(0,1)
     +     + 2*GYZ2(0,2)
     +     + 2*GYZ2(1,1)
     +     )
      C20 = C20 + t*zeta2 * (
     +     + 2*GYZ2(2,1)
     +     - 4*GYZ2(2,2)
     +     + 3./2.*HZ1(1)
     +     )
      C20 = C20 + t*zeta3 * (
     +     - 15./2.
     +     + 4*GYZ1(1)
     +     - 2*GYZ1(2)
     +     - 2*HZ1(1)
     +     )
      C20 = C20 + t*zeta4 * (
     +     - 11./2.
     +     )
      C20 = C20 + t * (
     +     + 255./32.
     +     - 15./8.*GYZ1(0)*HZ1(1)
     +     + 9./4.*GYZ1(0)*HZ2(1,1)
     +     - 2*GYZ1(0)*HZ3(0,1,1)
     +     - GYZ1(0)*HZ3(1,0,1)
     +     + GYZ1(1)*HZ3(0,0,1)
     +     + GYZ1(1)*HZ3(1,0,1)
     +     )
      C20 = C20 + t * (
     +     + 13./2.*GYZ1(2)
     +     + 15./8.*GYZ1(2)*HZ1(0)
     +     - 9./4.*GYZ1(2)*HZ1(1)
     +     + 3./4.*GYZ1(2)*HZ2(0,1)
     +     + 3*GYZ1(2)*HZ2(1,0)
     +     - 2*GYZ1(2)*HZ3(0,0,1)
     +     - GYZ1(2)*HZ3(0,1,0)
     +     )
      C20 = C20 + t * (
     +     - 3*GYZ1(2)*HZ3(1,0,1)
     +     - GYZ1(2)*HZ3(1,1,0)
     +     + 15./4.*GYZ1(3)*HZ1(1)
     +     + 21./4.*GYZ1(3)*HZ2(0,1)
     +     - 21./4.*GYZ1(3)*HZ2(1,0)
     +     - 9./2.*GYZ1(3)*HZ2(1,1)
     +     + 2*GYZ1(3)*HZ3(0,1,1)
     +     )
      C20 = C20 + t * (
     +     + 2*GYZ1(3)*HZ3(1,0,1)
     +     + 2*GYZ2(0,0)*HZ2(1,1)
     +     + 15./8.*GYZ2(0,2)
     +     - 21./4.*GYZ2(0,2)*HZ1(0)
     +     - 9./4.*GYZ2(0,2)*HZ1(1)
     +     + GYZ2(0,2)*HZ2(0,1)
     +     + 2*GYZ2(0,2)*HZ2(1,0)
     +     )
      C20 = C20 + t * (
     +     - 21./4.*GYZ2(0,3)*HZ1(1)
     +     - 2*GYZ2(0,3)*HZ2(1,0)
     +     - 2*GYZ2(0,3)*HZ2(1,1)
     +     - 7./2.*GYZ2(1,0)
     +     - GYZ2(1,0)*HZ2(0,1)
     +     - GYZ2(1,2)*HZ2(0,1)
     +     + 15./8.*GYZ2(2,0)
     +     )
      C20 = C20 + t * (
     +     - 9./4.*GYZ2(2,0)*HZ1(1)
     +     + GYZ2(2,0)*HZ2(0,1)
     +     + 9./4.*GYZ2(2,2)
     +     + 9./4.*GYZ2(2,2)*HZ1(0)
     +     + 2*GYZ2(2,2)*HZ2(0,0)
     +     + 4*GYZ2(2,2)*HZ2(0,1)
     +     + 3*GYZ2(2,3)*HZ1(1)
     +     )
      C20 = C20 + t * (
     +     - 21./4.*GYZ2(3,0)*HZ1(1)
     +     - 2*GYZ2(3,0)*HZ2(1,1)
     +     - 15./4.*GYZ2(3,2)
     +     + 21./4.*GYZ2(3,2)*HZ1(0)
     +     + 9./2.*GYZ2(3,2)*HZ1(1)
     +     - 2*GYZ2(3,2)*HZ2(0,1)
     +     + 21./2.*GYZ2(3,3)*HZ1(1)
     +     )
      C20 = C20 + t * (
     +     - 2*GYZ2(3,3)*HZ2(0,1)
     +     + 2*GYZ2(3,3)*HZ2(1,0)
     +     + 4*GYZ2(3,3)*HZ2(1,1)
     +     - 2*GYZ3(0,0,2)*HZ1(0)
     +     - 2*GYZ3(0,0,2)*HZ1(1)
     +     - 2*GYZ3(0,0,3)*HZ1(1)
     +     - 21./4.*GYZ3(0,1,0)
     +     )
      C20 = C20 + t * (
     +     + GYZ3(0,1,0)*HZ1(1)
     +     - 2*GYZ3(0,2,0)*HZ1(1)
     +     + 9./4.*GYZ3(0,2,2)
     +     + GYZ3(0,2,3)*HZ1(1)
     +     + 21./4.*GYZ3(0,3,2)
     +     + 2*GYZ3(0,3,2)*HZ1(0)
     +     + 2*GYZ3(0,3,2)*HZ1(1)
     +     )
      C20 = C20 + t * (
     +     + 2*GYZ3(0,3,3)*HZ1(1)
     +     + 2*GYZ3(1,0,0)*HZ1(1)
     +     - GYZ3(1,0,3)*HZ1(1)
     +     + 9./2.*GYZ3(1,1,0)
     +     - GYZ3(1,2,3)*HZ1(1)
     +     - 2*GYZ3(2,0,0)*HZ1(1)
     +     + 9./4.*GYZ3(2,0,2)
     +     )
      C20 = C20 + t * (
     +     - GYZ3(2,0,2)*HZ1(0)
     +     - 21./4.*GYZ3(2,1,0)
     +     - GYZ3(2,1,0)*HZ1(1)
     +     + 9./4.*GYZ3(2,2,0)
     +     + 4*GYZ3(2,2,3)*HZ1(1)
     +     - 3*GYZ3(2,3,2)
     +     + 21./4.*GYZ3(3,0,2)
     +     )
      C20 = C20 + t * (
     +     + 2*GYZ3(3,0,2)*HZ1(0)
     +     + 2*GYZ3(3,0,2)*HZ1(1)
     +     + 2*GYZ3(3,0,3)*HZ1(1)
     +     + 21./4.*GYZ3(3,2,0)
     +     + 2*GYZ3(3,2,0)*HZ1(1)
     +     - 9./2.*GYZ3(3,2,2)
     +     - 2*GYZ3(3,2,2)*HZ1(0)
     +     )
      C20 = C20 + t * (
     +     - 4*GYZ3(3,2,3)*HZ1(1)
     +     + 2*GYZ3(3,3,0)*HZ1(1)
     +     - 21./2.*GYZ3(3,3,2)
     +     - 2*GYZ3(3,3,2)*HZ1(0)
     +     - 4*GYZ3(3,3,2)*HZ1(1)
     +     - 4*GYZ3(3,3,3)*HZ1(1)
     +     + 2*GYZ4(0,0,2,2)
     +     )
      C20 = C20 + t * (
     +     + 2*GYZ4(0,0,3,2)
     +     - GYZ4(0,1,0,2)
     +     + 2*GYZ4(0,1,1,0)
     +     - GYZ4(0,1,2,0)
     +     + 2*GYZ4(0,2,0,2)
     +     - GYZ4(0,2,1,0)
     +     + 2*GYZ4(0,2,2,0)
     +     )
      C20 = C20 + t * (
     +     - GYZ4(0,2,3,2)
     +     - 2*GYZ4(0,3,2,2)
     +     - 2*GYZ4(0,3,3,2)
     +     - 2*GYZ4(1,0,0,2)
     +     + GYZ4(1,0,1,0)
     +     - 2*GYZ4(1,0,2,0)
     +     + GYZ4(1,0,3,2)
     +     )
      C20 = C20 + t * (
     +     + 2*GYZ4(1,1,0,0)
     +     - 2*GYZ4(1,1,1,0)
     +     - 2*GYZ4(1,2,0,0)
     +     + GYZ4(1,2,1,0)
     +     + GYZ4(1,2,3,2)
     +     + 2*GYZ4(2,0,0,2)
     +     - GYZ4(2,0,1,0)
     +     )
      C20 = C20 + t * (
     +     + 2*GYZ4(2,0,2,0)
     +     - 2*GYZ4(2,1,0,0)
     +     + GYZ4(2,1,0,2)
     +     - 2*GYZ4(2,1,1,0)
     +     + GYZ4(2,1,2,0)
     +     + 2*GYZ4(2,2,0,0)
     +     - 4*GYZ4(2,2,3,2)
     +     )
      C20 = C20 + t * (
     +     + 2*GYZ4(3,0,1,0)
     +     - 2*GYZ4(3,0,2,2)
     +     - 2*GYZ4(3,0,3,2)
     +     - 2*GYZ4(3,2,0,2)
     +     + 2*GYZ4(3,2,1,0)
     +     - 2*GYZ4(3,2,2,0)
     +     + 4*GYZ4(3,2,3,2)
     +     )
      C20 = C20 + t * (
     +     - 2*GYZ4(3,3,0,2)
     +     - 2*GYZ4(3,3,2,0)
     +     + 4*GYZ4(3,3,2,2)
     +     + 4*GYZ4(3,3,3,2)
     +     - 13./2.*HZ1(1)
     +     + 15./8.*HZ2(0,1)
     +     + 13./8.*HZ2(1,0)
     +     )
      C20 = C20 + t * (
     +     + 9./4.*HZ2(1,1)
     +     - 9./4.*HZ3(0,1,1)
     +     - 3./4.*HZ3(1,0,1)
     +     + 3./2.*HZ3(1,1,0)
     +     + 2*HZ4(0,0,1,1)
     +     + 2*HZ4(0,1,0,1)
     +     + 2*HZ4(0,1,1,0)
     +     )
      C20 = C20 + t * (
     +     + HZ4(1,0,0,1)
     +     + 2*HZ4(1,1,0,1)
     +     + 2*HZ4(1,1,1,0)
     +     )
      C20 = C20 + zeta2 * (
     +     + 9
     +     - 7*GYZ1(0)
     +     - 4*GYZ1(0)*HZ1(1)
     +     - 10*GYZ1(1)
     +     - 2*GYZ1(1)*HZ1(0)
     +     - 6*GYZ1(1)*HZ1(1)
     +     + 34*GYZ1(2)
     +     )
      C20 = C20 + zeta2 * (
     +     + 6*GYZ1(2)*HZ1(0)
     +     + 12*GYZ1(2)*HZ1(1)
     +     + 8*GYZ1(3)*HZ1(1)
     +     - 4*GYZ2(0,1)
     +     + 8*GYZ2(0,2)
     +     - 4*GYZ2(1,0)
     +     + 6*GYZ2(1,2)
     +     )
      C20 = C20 + zeta2 * (
     +     + 6*GYZ2(2,0)
     +     + 8*GYZ2(2,1)
     +     - 20*GYZ2(2,2)
     +     - 8*GYZ2(3,2)
     +     - 7*HZ1(0)
     +     - 24*HZ1(1)
     +     + 4*HZ2(0,1)
     +     )
      C20 = C20 + zeta2 * (
     +     - 2*HZ2(1,0)
     +     - 6*HZ2(1,1)
     +     )
      C20 = C20 + zeta3 * (
     +     + 10
     +     + 10*GYZ1(1)
     +     - 20*GYZ1(2)
     +     + 10*HZ1(1)
     +     )
      C20 = C20 - 1./2.
     +     - 29./4.*GYZ1(0)
     +     + 10*GYZ1(0)*HZ1(0)
     +     + GYZ1(0)*HZ1(1)
     +     - 5*GYZ1(0)*HZ2(0,0)
     +     - 2*GYZ1(0)*HZ2(0,1)
     +     - 9*GYZ1(0)*HZ2(1,0)
     +     + 5*GYZ1(0)*HZ2(1,1)
     +
      C20 = C20 + 4*GYZ1(0)*HZ3(0,1,0)
     +     - 4*GYZ1(0)*HZ3(0,1,1)
     +     - 2*GYZ1(0)*HZ3(1,0,1)
     +     - 4*GYZ1(0)*HZ3(1,1,0)
     +     + 4*GYZ1(1)*HZ3(0,0,1)
     +     - 6*GYZ1(1)*HZ3(0,1,0)
     +     + 4*GYZ1(1)*HZ3(1,0,1)
     +     - 6*GYZ1(1)*HZ3(1,1,0)
     +
      C20 = C20 + 29./2.*GYZ1(2)
     +     - GYZ1(2)*HZ1(0)
     +     - GYZ1(2)*HZ1(1)
     +     - GYZ1(2)*HZ2(0,0)
     +     - 13*GYZ1(2)*HZ2(0,1)
     +     + 20*GYZ1(2)*HZ2(1,0)
     +     - 4*GYZ1(2)*HZ3(0,0,1)
     +     + 8*GYZ1(2)*HZ3(0,1,0)
     +
      C20 = C20 + 4*GYZ1(2)*HZ3(1,0,0)
     +     - 10*GYZ1(2)*HZ3(1,0,1)
     +     + 4*GYZ1(2)*HZ3(1,1,0)
     +     - GYZ1(3)*HZ1(1)
     +     + 21*GYZ1(3)*HZ2(0,1)
     +     - 13*GYZ1(3)*HZ2(1,0)
     +     - 10*GYZ1(3)*HZ2(1,1)
     +     - 8*GYZ1(3)*HZ3(0,1,0)
     +
      C20 = C20 + 6*GYZ1(3)*HZ3(0,1,1)
     +     + 6*GYZ1(3)*HZ3(1,0,1)
     +     + 8*GYZ1(3)*HZ3(1,1,0)
     +     + 5*GYZ2(0,0)
     +     - 5*GYZ2(0,0)*HZ1(0)
     +     + GYZ2(0,0)*HZ1(1)
     +     - 4*GYZ2(0,0)*HZ2(1,0)
     +     + 4*GYZ2(0,0)*HZ2(1,1)
     +
      C20 = C20 - GYZ2(0,2)
     +     - 11*GYZ2(0,2)*HZ1(0)
     +     - 5*GYZ2(0,2)*HZ1(1)
     +     + 2*GYZ2(0,2)*HZ2(0,1)
     +     + 8*GYZ2(0,2)*HZ2(1,0)
     +     - 13*GYZ2(0,3)*HZ1(1)
     +     - 6*GYZ2(0,3)*HZ2(1,0)
     +     - 6*GYZ2(0,3)*HZ2(1,1)
     +
      C20 = C20 - 14*GYZ2(1,0)
     +     + GYZ2(1,0)*HZ1(0)
     +     + 6*GYZ2(1,0)*HZ1(1)
     +     - 2*GYZ2(1,0)*HZ2(0,1)
     +     - 4*GYZ2(1,0)*HZ2(1,0)
     +     - 4*GYZ2(1,2)*HZ2(0,1)
     +     + 6*GYZ2(1,2)*HZ2(1,0)
     +     - GYZ2(2,0)
     +
      C20 = C20 + 8*GYZ2(2,0)*HZ1(0)
     +     - 5*GYZ2(2,0)*HZ1(1)
     +     + 4*GYZ2(2,0)*HZ2(0,0)
     +     + 4*GYZ2(2,0)*HZ2(1,0)
     +     + GYZ2(2,2)
     +     + 5*GYZ2(2,2)*HZ1(0)
     +     + 4*GYZ2(2,2)*HZ2(0,0)
     +     + 12*GYZ2(2,2)*HZ2(0,1)
     +
      C20 = C20 - 10*GYZ2(2,2)*HZ2(1,0)
     +     - 8*GYZ2(2,3)*HZ1(1)
     +     - 13*GYZ2(3,0)*HZ1(1)
     +     + 8*GYZ2(3,0)*HZ2(1,0)
     +     - 6*GYZ2(3,0)*HZ2(1,1)
     +     + GYZ2(3,2)
     +     + 13*GYZ2(3,2)*HZ1(0)
     +     + 10*GYZ2(3,2)*HZ1(1)
     +
      C20 = C20 - 6*GYZ2(3,2)*HZ2(0,1)
     +     - 8*GYZ2(3,2)*HZ2(1,0)
     +     + 34*GYZ2(3,3)*HZ1(1)
     +     - 6*GYZ2(3,3)*HZ2(0,1)
     +     + 6*GYZ2(3,3)*HZ2(1,0)
     +     + 12*GYZ2(3,3)*HZ2(1,1)
     +     - GYZ3(0,0,2)
     +     - 6*GYZ3(0,0,2)*HZ1(0)
     +
      C20 = C20 - 4*GYZ3(0,0,2)*HZ1(1)
     +     - 6*GYZ3(0,0,3)*HZ1(1)
     +     - 5*GYZ3(0,1,0)
     +     + 2*GYZ3(0,1,0)*HZ1(1)
     +     - GYZ3(0,2,0)
     +     + 4*GYZ3(0,2,0)*HZ1(0)
     +     - 4*GYZ3(0,2,0)*HZ1(1)
     +     + 5*GYZ3(0,2,2)
     +
      C20 = C20 + 2*GYZ3(0,2,2)*HZ1(0)
     +     + 4*GYZ3(0,2,3)*HZ1(1)
     +     + 13*GYZ3(0,3,2)
     +     + 6*GYZ3(0,3,2)*HZ1(0)
     +     + 6*GYZ3(0,3,2)*HZ1(1)
     +     + 6*GYZ3(0,3,3)*HZ1(1)
     +     + 6*GYZ3(1,0,0)
     +     - 4*GYZ3(1,0,0)*HZ1(0)
     +
      C20 = C20 + 4*GYZ3(1,0,0)*HZ1(1)
     +     - 6*GYZ3(1,0,2)
     +     - 2*GYZ3(1,0,2)*HZ1(0)
     +     - 4*GYZ3(1,0,3)*HZ1(1)
     +     + 10*GYZ3(1,1,0)
     +     - 4*GYZ3(1,1,0)*HZ1(0)
     +     - 6*GYZ3(1,2,0)
     +     + 4*GYZ3(1,2,0)*HZ1(0)
     +
      C20 = C20 - 4*GYZ3(1,2,3)*HZ1(1)
     +     - GYZ3(2,0,0)
     +     + 4*GYZ3(2,0,0)*HZ1(0)
     +     - 4*GYZ3(2,0,0)*HZ1(1)
     +     + 5*GYZ3(2,0,2)
     +     - 25*GYZ3(2,1,0)
     +     + 4*GYZ3(2,1,0)*HZ1(0)
     +     - 2*GYZ3(2,1,0)*HZ1(1)
     +
      C20 = C20 + 5*GYZ3(2,2,0)
     +     - 8*GYZ3(2,2,0)*HZ1(0)
     +     + 12*GYZ3(2,2,3)*HZ1(1)
     +     + 8*GYZ3(2,3,2)
     +     + 13*GYZ3(3,0,2)
     +     + 6*GYZ3(3,0,2)*HZ1(0)
     +     + 6*GYZ3(3,0,2)*HZ1(1)
     +     + 6*GYZ3(3,0,3)*HZ1(1)
     +
      C20 = C20 + 13*GYZ3(3,2,0)
     +     - 8*GYZ3(3,2,0)*HZ1(0)
     +     + 6*GYZ3(3,2,0)*HZ1(1)
     +     - 10*GYZ3(3,2,2)
     +     - 6*GYZ3(3,2,2)*HZ1(0)
     +     - 12*GYZ3(3,2,3)*HZ1(1)
     +     + 6*GYZ3(3,3,0)*HZ1(1)
     +     - 34*GYZ3(3,3,2)
     +
      C20 = C20 - 6*GYZ3(3,3,2)*HZ1(0)
     +     - 12*GYZ3(3,3,2)*HZ1(1)
     +     - 12*GYZ3(3,3,3)*HZ1(1)
     +     - 4*GYZ4(0,0,1,0)
     +     + 4*GYZ4(0,0,2,2)
     +     + 6*GYZ4(0,0,3,2)
     +     - 2*GYZ4(0,1,0,2)
     +     + 4*GYZ4(0,1,1,0)
     +
      C20 = C20 - 2*GYZ4(0,1,2,0)
     +     + 4*GYZ4(0,2,0,2)
     +     - 6*GYZ4(0,2,1,0)
     +     + 4*GYZ4(0,2,2,0)
     +     - 4*GYZ4(0,2,3,2)
     +     - 6*GYZ4(0,3,2,2)
     +     - 6*GYZ4(0,3,3,2)
     +     - 4*GYZ4(1,0,0,2)
     +
      C20 = C20 + 6*GYZ4(1,0,1,0)
     +     - 4*GYZ4(1,0,2,0)
     +     + 4*GYZ4(1,0,3,2)
     +     + 8*GYZ4(1,1,0,0)
     +     - 4*GYZ4(1,2,0,0)
     +     - 2*GYZ4(1,2,1,0)
     +     + 4*GYZ4(1,2,3,2)
     +     + 4*GYZ4(2,0,0,2)
     +
      C20 = C20 - 12*GYZ4(2,0,1,0)
     +     + 4*GYZ4(2,0,2,0)
     +     - 8*GYZ4(2,1,0,0)
     +     + 2*GYZ4(2,1,0,2)
     +     - 8*GYZ4(2,1,1,0)
     +     + 2*GYZ4(2,1,2,0)
     +     + 4*GYZ4(2,2,0,0)
     +     + 10*GYZ4(2,2,1,0)
     +
      C20 = C20 - 12*GYZ4(2,2,3,2)
     +     + 14*GYZ4(3,0,1,0)
     +     - 6*GYZ4(3,0,2,2)
     +     - 6*GYZ4(3,0,3,2)
     +     - 6*GYZ4(3,2,0,2)
     +     + 14*GYZ4(3,2,1,0)
     +     - 6*GYZ4(3,2,2,0)
     +     + 12*GYZ4(3,2,3,2)
     +
      C20 = C20 - 6*GYZ4(3,3,0,2)
     +     - 6*GYZ4(3,3,2,0)
     +     + 12*GYZ4(3,3,2,2)
     +     + 12*GYZ4(3,3,3,2)
     +     - 29./4.*HZ1(0)
     +     - 29./2.*HZ1(1)
     +     + 5*HZ2(0,0)
     +     + 15*HZ2(1,0)
     +
      C20 = C20 + HZ2(1,1)
     +     + 9*HZ3(0,0,1)
     +     - 7*HZ3(0,1,0)
     +     - 5*HZ3(0,1,1)
     +     - 5*HZ3(1,0,0)
     +     + 7*HZ3(1,0,1)
     +     - 16*HZ3(1,1,0)
     +     - 4*HZ4(0,0,1,0)
     +
      C20 = C20 + 4*HZ4(0,0,1,1)
     +     + 4*HZ4(0,1,0,1)
     +     + 8*HZ4(0,1,1,0)
     +     + 4*HZ4(1,0,0,1)
     +     - 6*HZ4(1,0,1,0)
     +     + 6*HZ4(1,1,0,1)
     +     - 2*HZ4(1,1,1,0)
     +

      D20 = 0.
     +
      D20 = D20 + y**(-1)*z * (
     +     - GYZ2(1,0)
     +     - 2./3.*HZ1(0)
     +     - HZ2(1,0)
     +     )
      D20 = D20 + y**(-1)*(y+z)**(-1) * (
     +     - 2*GYZ2(1,0)
     +     - 2*HZ2(1,0)
     +     )
      D20 = D20 + y**(-1) * (
     +     - 37./9.
     +     + 5./6.*GYZ1(0)
     +     + 2*GYZ2(1,0)
     +     + 5./6.*HZ1(0)
     +     + 2*HZ2(1,0)
     +     )
      D20 = D20 + z*(1.-y)**(-2)*zeta2 * (
     +     + 2./3.
     +     )
      D20 = D20 + z*(1.-y)**(-2) * (
     +     + 25./9.*GYZ1(0)
     +     - 1./6.*GYZ1(0)*HZ1(0)
     +     - GYZ2(0,0)
     +     - 2./3.*GYZ2(1,0)
     +     )
      D20 = D20 + z*(1.-y)**(-1)*zeta2 * (
     +     + 2
     +     )
      D20 = D20 + z*(1.-y)**(-1) * (
     +     + 19./9.
     +     + 29./6.*GYZ1(0)
     +     - 1./2.*GYZ1(0)*HZ1(0)
     +     - 3*GYZ2(0,0)
     +     - 2*GYZ2(1,0)
     +     - 1./6.*HZ1(0)
     +     )
      D20 = D20 + z*(y+z)**(-3)*zeta2 * (
     +     + 12*GYZ1(2)
     +     - 12*HZ1(1)
     +     )
      D20 = D20 + z*(y+z)**(-3) * (
     +     - 12*GYZ1(0)*HZ2(1,0)
     +     + 12*GYZ1(2)*HZ2(1,0)
     +     + 12*GYZ2(1,0)
     +     + 12*GYZ2(2,0)*HZ1(0)
     +     - 12*GYZ3(0,1,0)
     +     - 12*GYZ3(2,1,0)
     +     + 12*HZ2(1,0)
     +     )
      D20 = D20 + z*(y+z)**(-3) * (
     +     + 12*HZ3(0,1,0)
     +     - 12*HZ3(1,1,0)
     +     )
      D20 = D20 + z*(y+z)**(-2)*zeta2 * (
     +     + 12
     +     - 8*GYZ1(2)
     +     + 8*HZ1(1)
     +     )
      D20 = D20 + z*(y+z)**(-2) * (
     +     + 6*GYZ1(0)
     +     + 12*GYZ1(0)*HZ1(0)
     +     + 8*GYZ1(0)*HZ2(1,0)
     +     - 8*GYZ1(2)*HZ2(1,0)
     +     - 20*GYZ2(1,0)
     +     - 8*GYZ2(2,0)*HZ1(0)
     +     + 8*GYZ3(0,1,0)
     +     )
      D20 = D20 + z*(y+z)**(-2) * (
     +     + 8*GYZ3(2,1,0)
     +     - 6*HZ1(0)
     +     + 4*HZ2(1,0)
     +     - 8*HZ3(0,1,0)
     +     + 8*HZ3(1,1,0)
     +     )
      D20 = D20 + z*(y+z)**(-1)*zeta2 * (
     +     - 2
     +     )
      D20 = D20 + z*(y+z)**(-1) * (
     +     - 2*GYZ1(0)
     +     - 2*GYZ1(0)*HZ1(0)
     +     + 2*GYZ2(1,0)
     +     + 2*HZ1(0)
     +     - 2*HZ2(1,0)
     +     )
      D20 = D20 + z**2*(y+z)**(-4)*zeta2 * (
     +     - 12*GYZ1(2)
     +     + 12*HZ1(1)
     +     )
      D20 = D20 + z**2*(y+z)**(-4) * (
     +     + 12*GYZ1(0)*HZ2(1,0)
     +     - 12*GYZ1(2)*HZ2(1,0)
     +     - 12*GYZ2(2,0)*HZ1(0)
     +     + 12*GYZ3(0,1,0)
     +     + 12*GYZ3(2,1,0)
     +     - 12*HZ3(0,1,0)
     +     + 12*HZ3(1,1,0)
     +     )
      D20 = D20 + z**2*(y+z)**(-3)*zeta2 * (
     +     - 12
     +     + 8*GYZ1(2)
     +     - 8*HZ1(1)
     +     )
      D20 = D20 + z**2*(y+z)**(-3) * (
     +     - 12*GYZ1(0)*HZ1(0)
     +     - 8*GYZ1(0)*HZ2(1,0)
     +     + 8*GYZ1(2)*HZ2(1,0)
     +     + 12*GYZ2(1,0)
     +     + 8*GYZ2(2,0)*HZ1(0)
     +     - 8*GYZ3(0,1,0)
     +     - 8*GYZ3(2,1,0)
     +     )
      D20 = D20 + z**2*(y+z)**(-3) * (
     +     - 12*HZ2(1,0)
     +     + 8*HZ3(0,1,0)
     +     - 8*HZ3(1,1,0)
     +     )
      D20 = D20 + z**2*(y+z)**(-2)*zeta2 * (
     +     + 2
     +     )
      D20 = D20 + z**2*(y+z)**(-2) * (
     +     + 2*GYZ1(0)*HZ1(0)
     +     - 2*GYZ2(1,0)
     +     + 2*HZ2(1,0)
     +     )
      D20 = D20 + (1.-y)**(-1)*zeta2 * (
     +     - 8./3.
     +     )
      D20 = D20 + (1.-y)**(-1) * (
     +     - 70./9.*GYZ1(0)
     +     + 2./3.*GYZ1(0)*HZ1(0)
     +     + 4*GYZ2(0,0)
     +     + 8./3.*GYZ2(1,0)
     +     )
      D20 = D20 + (y+z)**(-2)*zeta2 * (
     +     - 4*GYZ1(2)
     +     + 4*HZ1(1)
     +     )
      D20 = D20 + (y+z)**(-2) * (
     +     + 4*GYZ1(0)*HZ2(1,0)
     +     - 4*GYZ1(2)*HZ2(1,0)
     +     - 4*GYZ2(2,0)*HZ1(0)
     +     + 4*GYZ3(0,1,0)
     +     + 4*GYZ3(2,1,0)
     +     - 4*HZ3(0,1,0)
     +     + 4*HZ3(1,1,0)
     +     )
      D20 = D20 + (y+z)**(-1)*zeta2 * (
     +     - 4
     +     + 2*GYZ1(2)
     +     - 2*HZ1(1)
     +     )
      D20 = D20 + (y+z)**(-1) * (
     +     + 2
     +     - GYZ1(0)
     +     - 4*GYZ1(0)*HZ1(0)
     +     - 2*GYZ1(0)*HZ2(1,0)
     +     + 2*GYZ1(2)*HZ2(1,0)
     +     + 4*GYZ2(1,0)
     +     + 2*GYZ2(2,0)*HZ1(0)
     +     )
      D20 = D20 + (y+z)**(-1) * (
     +     - 2*GYZ3(0,1,0)
     +     - 2*GYZ3(2,1,0)
     +     - HZ1(0)
     +     - 4*HZ2(1,0)
     +     + 2*HZ3(0,1,0)
     +     - 2*HZ3(1,1,0)
     +     )
      D20 = D20 + t*zeta2 * (
     +     + 431./36.
     +     - 1./3.*GYZ1(0)
     +     - 2./3.*GYZ1(1)
     +     + 2./3.*GYZ1(2)
     +     - 1./3.*HZ1(0)
     +     )
      D20 = D20 + t*zeta3 * (
     +     - 19./9.
     +     )
      D20 = D20 + t * (
     +     + 4345./648.
     +     + 31./18.*GYZ1(0)
     +     + 5./9.*GYZ1(0)*HZ1(0)
     +     - GYZ1(0)*HZ2(0,0)
     +     - 5./6.*GYZ1(0)*HZ2(1,0)
     +     + 2./3.*GYZ1(2)*HZ2(1,0)
     +     - 41./18.*GYZ2(0,0)
     +     )
      D20 = D20 + t * (
     +     - GYZ2(0,0)*HZ1(0)
     +     - 29./18.*GYZ2(1,0)
     +     + 1./6.*GYZ2(1,0)*HZ1(0)
     +     + 2./3.*GYZ2(2,0)*HZ1(0)
     +     + 1./6.*GYZ3(0,1,0)
     +     + GYZ3(1,0,0)
     +     + 2./3.*GYZ3(1,1,0)
     +     )
      D20 = D20 + t * (
     +     - 2./3.*GYZ3(2,1,0)
     +     + 31./18.*HZ1(0)
     +     - 41./18.*HZ2(0,0)
     +     + 29./18.*HZ2(1,0)
     +     - 1./6.*HZ3(0,1,0)
     +     - HZ3(1,0,0)
     +     )
      D20 = D20 + zeta2 * (
     +     + 2
     +     )
      D20 = D20 + 2*GYZ1(0)*HZ1(0)
     +     - 2*GYZ2(1,0)
     +     + 2*HZ2(1,0)
     +

      E20 = 0.
     +
      E20 = E20 + y**(-1)*z*zeta2 * (
     +     - 4./3.*GYZ1(2)
     +     )
      E20 = E20 + y**(-1)*z * (
     +     - GYZ1(0)*HZ1(1)
     +     - 47./9.*GYZ1(2)*HZ1(0)
     +     + 2*GYZ1(2)*HZ2(0,0)
     +     - 4./3.*GYZ1(2)*HZ2(1,0)
     +     - 38./9.*GYZ1(3)*HZ1(1)
     +     + 1./3.*GYZ1(3)*HZ2(0,1)
     +     + 5./3.*GYZ1(3)*HZ2(1,0)
     +     )
      E20 = E20 + y**(-1)*z * (
     +     - 4./3.*GYZ1(3)*HZ2(1,1)
     +     + GYZ2(0,2)
     +     + 1./3.*GYZ2(0,2)*HZ1(0)
     +     + 1./3.*GYZ2(0,3)*HZ1(1)
     +     + GYZ2(2,0)
     +     + 1./3.*GYZ2(2,0)*HZ1(0)
     +     + 4./3.*GYZ2(2,2)*HZ1(0)
     +     )
      E20 = E20 + y**(-1)*z * (
     +     + 4./3.*GYZ2(2,3)*HZ1(1)
     +     + 1./3.*GYZ2(3,0)*HZ1(1)
     +     + 38./9.*GYZ2(3,2)
     +     - 5./3.*GYZ2(3,2)*HZ1(0)
     +     + 4./3.*GYZ2(3,2)*HZ1(1)
     +     - 4./3.*GYZ2(3,3)*HZ1(1)
     +     - 1./3.*GYZ3(0,3,2)
     +     )
      E20 = E20 + y**(-1)*z * (
     +     - 4./3.*GYZ3(2,3,2)
     +     - 1./3.*GYZ3(3,0,2)
     +     - 1./3.*GYZ3(3,2,0)
     +     - 4./3.*GYZ3(3,2,2)
     +     + 4./3.*GYZ3(3,3,2)
     +     + HZ2(0,1)
     +     + HZ2(1,0)
     +     )
      E20 = E20 + y**(-1)*(y+z)**(-1) * (
     +     - 2*GYZ1(0)*HZ1(1)
     +     - 2*GYZ1(2)*HZ1(0)
     +     + 2*GYZ2(0,2)
     +     + 2*GYZ2(2,0)
     +     + 2*HZ2(0,1)
     +     + 2*HZ2(1,0)
     +     )
      E20 = E20 + y**(-1)*zeta2 * (
     +     + 8./3.*GYZ1(2)
     +     )
      E20 = E20 + y**(-1) * (
     +     - 19./9.
     +     + 5./6.*GYZ1(0)
     +     + 2*GYZ1(0)*HZ1(1)
     +     + 94./9.*GYZ1(2)*HZ1(0)
     +     - 4*GYZ1(2)*HZ2(0,0)
     +     + 8./3.*GYZ1(2)*HZ2(1,0)
     +     + 76./9.*GYZ1(3)*HZ1(1)
     +     )
      E20 = E20 + y**(-1) * (
     +     - 2./3.*GYZ1(3)*HZ2(0,1)
     +     - 10./3.*GYZ1(3)*HZ2(1,0)
     +     + 8./3.*GYZ1(3)*HZ2(1,1)
     +     - 2*GYZ2(0,2)
     +     - 2./3.*GYZ2(0,2)*HZ1(0)
     +     - 2./3.*GYZ2(0,3)*HZ1(1)
     +     - 2*GYZ2(2,0)
     +     )
      E20 = E20 + y**(-1) * (
     +     - 2./3.*GYZ2(2,0)*HZ1(0)
     +     - 8./3.*GYZ2(2,2)*HZ1(0)
     +     - 8./3.*GYZ2(2,3)*HZ1(1)
     +     - 2./3.*GYZ2(3,0)*HZ1(1)
     +     - 76./9.*GYZ2(3,2)
     +     + 10./3.*GYZ2(3,2)*HZ1(0)
     +     - 8./3.*GYZ2(3,2)*HZ1(1)
     +     )
      E20 = E20 + y**(-1) * (
     +     + 8./3.*GYZ2(3,3)*HZ1(1)
     +     + 2./3.*GYZ3(0,3,2)
     +     + 8./3.*GYZ3(2,3,2)
     +     + 2./3.*GYZ3(3,0,2)
     +     + 2./3.*GYZ3(3,2,0)
     +     + 8./3.*GYZ3(3,2,2)
     +     - 8./3.*GYZ3(3,3,2)
     +     )
      E20 = E20 + y**(-1) * (
     +     + 1./6.*HZ1(0)
     +     - 2*HZ2(0,1)
     +     - 2*HZ2(1,0)
     +     )
      E20 = E20 + z*(1.-y)**(-2)*zeta2 * (
     +     - 2./3.
     +     )
      E20 = E20 + z*(1.-y)**(-2) * (
     +     - 25./9.*GYZ1(0)
     +     + 1./6.*GYZ1(0)*HZ1(0)
     +     + GYZ2(0,0)
     +     + 2./3.*GYZ2(1,0)
     +     )
      E20 = E20 + z*(1.-y)**(-1)*zeta2 * (
     +     - 2
     +     )
      E20 = E20 + z*(1.-y)**(-1) * (
     +     - 19./9.
     +     - 29./6.*GYZ1(0)
     +     + 1./2.*GYZ1(0)*HZ1(0)
     +     + 3*GYZ2(0,0)
     +     + 2*GYZ2(1,0)
     +     + 1./6.*HZ1(0)
     +     )
      E20 = E20 + (1.-y)**(-1)*zeta2 * (
     +     + 4./3.
     +     )
      E20 = E20 + (1.-y)**(-1) * (
     +     + 38./9.*GYZ1(0)
     +     - 1./3.*GYZ1(0)*HZ1(0)
     +     - 2*GYZ2(0,0)
     +     - 4./3.*GYZ2(1,0)
     +     )
      E20 = E20 + (y+z)**(-2) * (
     +     + GYZ1(0)*HZ1(1)
     +     + 26./9.*GYZ1(2)
     +     - GYZ1(2)*HZ1(0)
     +     + 4./3.*GYZ1(2)*HZ1(1)
     +     - 4./3.*GYZ1(3)*HZ1(1)
     +     - GYZ2(0,2)
     +     - GYZ2(2,0)
     +     )
      E20 = E20 + (y+z)**(-2) * (
     +     - 4./3.*GYZ2(2,2)
     +     + 4./3.*GYZ2(3,2)
     +     - 26./9.*HZ1(1)
     +     - 1./3.*HZ2(0,1)
     +     + HZ2(1,0)
     +     - 4./3.*HZ2(1,1)
     +     )
      E20 = E20 + (y+z)**(-1) * (
     +     + 38./9.
     +     - GYZ1(0)
     +     + 4./3.*GYZ1(2)
     +     - HZ1(0)
     +     - 4./3.*HZ1(1)
     +     )
      E20 = E20 + t*zeta2 * (
     +     - 7./6.
     +     + 2./3.*GYZ1(1)
     +     - 5./6.*GYZ1(2)
     +     + 1./6.*HZ1(1)
     +     )
      E20 = E20 + t*zeta3 * (
     +     + 1./18.
     +     )
      E20 = E20 + t * (
     +     - 4085./648.
     +     + 2./3.*GYZ1(0)
     +     + 49./36.*GYZ1(0)*HZ1(1)
     +     + 2./3.*GYZ1(0)*HZ2(0,1)
     +     - 1./6.*GYZ1(0)*HZ2(1,0)
     +     + 2./3.*GYZ1(0)*HZ2(1,1)
     +     - 17./27.*GYZ1(2)
     +     )
      E20 = E20 + t * (
     +     - 49./36.*GYZ1(2)*HZ1(0)
     +     - GYZ1(2)*HZ1(1)
     +     + GYZ1(2)*HZ2(0,0)
     +     + 2./3.*GYZ1(2)*HZ2(0,1)
     +     - 2./3.*GYZ1(2)*HZ2(1,0)
     +     - 29./9.*GYZ1(3)*HZ1(1)
     +     - 1./3.*GYZ1(3)*HZ2(0,1)
     +     )
      E20 = E20 + t * (
     +     + GYZ1(3)*HZ2(1,0)
     +     - 4./3.*GYZ1(3)*HZ2(1,1)
     +     - GYZ2(0,0)*HZ1(1)
     +     - 49./36.*GYZ2(0,2)
     +     + 1./3.*GYZ2(0,2)*HZ1(0)
     +     - 2./3.*GYZ2(0,2)*HZ1(1)
     +     + GYZ2(0,3)*HZ1(1)
     +     )
      E20 = E20 + t * (
     +     + 19./9.*GYZ2(1,0)
     +     - 1./6.*GYZ2(1,0)*HZ1(0)
     +     - 49./36.*GYZ2(2,0)
     +     + 1./3.*GYZ2(2,0)*HZ1(0)
     +     - 2./3.*GYZ2(2,0)*HZ1(1)
     +     + GYZ2(2,2)
     +     + 2./3.*GYZ2(2,2)*HZ1(0)
     +     )
      E20 = E20 + t * (
     +     + 4./3.*GYZ2(2,3)*HZ1(1)
     +     + GYZ2(3,0)*HZ1(1)
     +     + 29./9.*GYZ2(3,2)
     +     - GYZ2(3,2)*HZ1(0)
     +     + 4./3.*GYZ2(3,2)*HZ1(1)
     +     - 4./3.*GYZ2(3,3)*HZ1(1)
     +     + GYZ3(0,0,2)
     +     )
      E20 = E20 + t * (
     +     - 1./6.*GYZ3(0,1,0)
     +     + GYZ3(0,2,0)
     +     + 2./3.*GYZ3(0,2,2)
     +     - GYZ3(0,3,2)
     +     - GYZ3(1,0,0)
     +     - 2./3.*GYZ3(1,1,0)
     +     + GYZ3(2,0,0)
     +     )
      E20 = E20 + t * (
     +     + 2./3.*GYZ3(2,0,2)
     +     + 2./3.*GYZ3(2,2,0)
     +     - 4./3.*GYZ3(2,3,2)
     +     - GYZ3(3,0,2)
     +     - GYZ3(3,2,0)
     +     - 4./3.*GYZ3(3,2,2)
     +     + 4./3.*GYZ3(3,3,2)
     +     )
      E20 = E20 + t * (
     +     + 2./3.*HZ1(0)
     +     + 17./27.*HZ1(1)
     +     - 67./36.*HZ2(0,1)
     +     - 3./4.*HZ2(1,0)
     +     + HZ2(1,1)
     +     - 1./3.*HZ3(0,0,1)
     +     + 1./6.*HZ3(0,1,0)
     +     )
      E20 = E20 + t * (
     +     - 2./3.*HZ3(0,1,1)
     +     - 2./3.*HZ3(1,0,1)
     +     )
      E20 = E20 + zeta2 * (
     +     + 4./3.
     +     + 4./3.*GYZ1(1)
     +     - 8./3.*GYZ1(2)
     +     + 4./3.*HZ1(1)
     +     )
      E20 = E20 + 19./9.*GYZ1(0)
     +     - 1./3.*GYZ1(0)*HZ1(0)
     +     + 29./9.*GYZ1(0)*HZ1(1)
     +     + 4./3.*GYZ1(0)*HZ2(0,1)
     +     - 1./3.*GYZ1(0)*HZ2(1,0)
     +     + 4./3.*GYZ1(0)*HZ2(1,1)
     +     - 38./9.*GYZ1(2)
     +     - 29./9.*GYZ1(2)*HZ1(0)
     +
      E20 = E20 - 4./3.*GYZ1(2)*HZ1(1)
     +     + 2*GYZ1(2)*HZ2(0,0)
     +     + 4./3.*GYZ1(2)*HZ2(0,1)
     +     - 4./3.*GYZ1(2)*HZ2(1,0)
     +     - 64./9.*GYZ1(3)*HZ1(1)
     +     - 2./3.*GYZ1(3)*HZ2(0,1)
     +     + 2*GYZ1(3)*HZ2(1,0)
     +     - 8./3.*GYZ1(3)*HZ2(1,1)
     +
      E20 = E20 - GYZ2(0,0)
     +     - 2*GYZ2(0,0)*HZ1(1)
     +     - 29./9.*GYZ2(0,2)
     +     + 2./3.*GYZ2(0,2)*HZ1(0)
     +     - 4./3.*GYZ2(0,2)*HZ1(1)
     +     + 2*GYZ2(0,3)*HZ1(1)
     +     + 32./9.*GYZ2(1,0)
     +     - 1./3.*GYZ2(1,0)*HZ1(0)
     +
      E20 = E20 - 29./9.*GYZ2(2,0)
     +     + 2./3.*GYZ2(2,0)*HZ1(0)
     +     - 4./3.*GYZ2(2,0)*HZ1(1)
     +     + 4./3.*GYZ2(2,2)
     +     + 4./3.*GYZ2(2,2)*HZ1(0)
     +     + 8./3.*GYZ2(2,3)*HZ1(1)
     +     + 2*GYZ2(3,0)*HZ1(1)
     +     + 64./9.*GYZ2(3,2)
     +
      E20 = E20 - 2*GYZ2(3,2)*HZ1(0)
     +     + 8./3.*GYZ2(3,2)*HZ1(1)
     +     - 8./3.*GYZ2(3,3)*HZ1(1)
     +     + 2*GYZ3(0,0,2)
     +     - 1./3.*GYZ3(0,1,0)
     +     + 2*GYZ3(0,2,0)
     +     + 4./3.*GYZ3(0,2,2)
     +     - 2*GYZ3(0,3,2)
     +
      E20 = E20 - 2*GYZ3(1,0,0)
     +     - 4./3.*GYZ3(1,1,0)
     +     + 2*GYZ3(2,0,0)
     +     + 4./3.*GYZ3(2,0,2)
     +     + 4./3.*GYZ3(2,2,0)
     +     - 8./3.*GYZ3(2,3,2)
     +     - 2*GYZ3(3,0,2)
     +     - 2*GYZ3(3,2,0)
     +
      E20 = E20 - 8./3.*GYZ3(3,2,2)
     +     + 8./3.*GYZ3(3,3,2)
     +     + 19./9.*HZ1(0)
     +     + 38./9.*HZ1(1)
     +     - HZ2(0,0)
     +     - 35./9.*HZ2(0,1)
     +     - 1./3.*HZ2(1,0)
     +     + 4./3.*HZ2(1,1)
     +
      E20 = E20 - 2./3.*HZ3(0,0,1)
     +     + 1./3.*HZ3(0,1,0)
     +     - 4./3.*HZ3(0,1,1)
     +     - 4./3.*HZ3(1,0,1)
     +
c (4.23) of hep-ph/0112081
      F20 = 0.
     +
      F20 = F20 + t*zeta2 * (
     +     - 17./18.
     +     )
      F20 = F20 + t * (
     +     - 5./27.*GYZ1(0)
     +     + 1./36.*GYZ1(0)*HZ1(0)
     +     + 5./36.*GYZ2(0,0)
     +     - 5./27.*HZ1(0)
     +     + 5./36.*HZ2(0,0)
     +     )

      G20 = 0.
     +
      G20 = G20 + y**(-2)*z * (
     +     - 9*GYZ1(2)*HZ1(0)
     +     - 9*GYZ1(3)*HZ1(1)
     +     + 9*GYZ2(3,2)
     +     )
      G20 = G20 + y**(-2)*z**2 * (
     +     + 3*GYZ1(2)*HZ1(0)
     +     + 3*GYZ1(3)*HZ1(1)
     +     - 3*GYZ2(3,2)
     +     )
      G20 = G20 + y**(-2) * (
     +     + 6*GYZ1(2)*HZ1(0)
     +     + 6*GYZ1(3)*HZ1(1)
     +     - 6*GYZ2(3,2)
     +     )
      G20 = G20 + y**(-1)*z*zeta2 * (
     +     - 4./3.*GYZ1(1)
     +     - 4./3.*GYZ1(2)
     +     + 8*GYZ1(2)*HZ1(1)
     +     + 8*GYZ2(2,0)
     +     - 8*GYZ2(2,2)
     +     )
      G20 = G20 + y**(-1)*z*zeta3 * (
     +     - 24*GYZ1(2)
     +     )
      G20 = G20 + y**(-1)*z * (
     +     - 4./3.*GYZ1(0)*HZ2(1,1)
     +     - 6*GYZ1(2)*HZ1(0)
     +     - 8./3.*GYZ1(2)*HZ2(0,1)
     +     - 4*GYZ1(2)*HZ2(1,0)
     +     + 8*GYZ1(2)*HZ3(0,0,1)
     +     - 8*GYZ1(2)*HZ3(1,0,1)
     +     - 6*GYZ1(3)*HZ1(1)
     +     )
      G20 = G20 + y**(-1)*z * (
     +     + 8./3.*GYZ1(3)*HZ2(1,0)
     +     - 8./3.*GYZ1(3)*HZ2(1,1)
     +     + 8*GYZ1(3)*HZ3(0,1,1)
     +     + 8*GYZ1(3)*HZ3(1,0,1)
     +     + 4./3.*GYZ2(0,2)*HZ1(1)
     +     - 4./3.*GYZ2(1,0)*HZ1(0)
     +     - 4./3.*GYZ2(1,0)*HZ1(1)
     +     )
      G20 = G20 + y**(-1)*z * (
     +     - 4./3.*GYZ2(2,0)*HZ1(0)
     +     + 4./3.*GYZ2(2,0)*HZ1(1)
     +     - 8*GYZ2(2,0)*HZ2(0,1)
     +     + 4*GYZ2(2,2)*HZ1(0)
     +     + 8*GYZ2(2,2)*HZ2(0,1)
     +     + 4./3.*GYZ2(2,3)*HZ1(1)
     +     - 8./3.*GYZ2(3,0)*HZ1(1)
     +     )
      G20 = G20 + y**(-1)*z * (
     +     - 8*GYZ2(3,0)*HZ2(1,1)
     +     + 6*GYZ2(3,2)
     +     - 8./3.*GYZ2(3,2)*HZ1(0)
     +     + 8./3.*GYZ2(3,2)*HZ1(1)
     +     - 8*GYZ2(3,2)*HZ2(0,1)
     +     - 8./3.*GYZ2(3,3)*HZ1(1)
     +     - 8*GYZ2(3,3)*HZ2(0,1)
     +     )
      G20 = G20 + y**(-1)*z * (
     +     + 8*GYZ2(3,3)*HZ2(1,1)
     +     - 4./3.*GYZ3(0,2,2)
     +     + 4./3.*GYZ3(1,0,2)
     +     + 4./3.*GYZ3(1,1,0)
     +     + 4./3.*GYZ3(1,2,0)
     +     - 4./3.*GYZ3(2,0,2)
     +     - 8*GYZ3(2,0,3)*HZ1(1)
     +     )
      G20 = G20 + y**(-1)*z * (
     +     - 4./3.*GYZ3(2,2,0)
     +     + 8*GYZ3(2,2,3)*HZ1(1)
     +     - 4./3.*GYZ3(2,3,2)
     +     + 8./3.*GYZ3(3,0,2)
     +     + 8*GYZ3(3,0,2)*HZ1(1)
     +     + 8./3.*GYZ3(3,2,0)
     +     + 8*GYZ3(3,2,0)*HZ1(1)
     +     )
      G20 = G20 + y**(-1)*z * (
     +     - 8./3.*GYZ3(3,2,2)
     +     - 8*GYZ3(3,2,3)*HZ1(1)
     +     + 8*GYZ3(3,3,0)*HZ1(1)
     +     + 8./3.*GYZ3(3,3,2)
     +     - 8*GYZ3(3,3,2)*HZ1(1)
     +     - 8*GYZ3(3,3,3)*HZ1(1)
     +     - 8*GYZ4(2,0,1,0)
     +     )
      G20 = G20 + y**(-1)*z * (
     +     + 8*GYZ4(2,0,3,2)
     +     + 8*GYZ4(2,2,1,0)
     +     - 8*GYZ4(2,2,3,2)
     +     + 8*GYZ4(3,0,1,0)
     +     - 8*GYZ4(3,0,2,2)
     +     - 8*GYZ4(3,2,0,2)
     +     + 8*GYZ4(3,2,1,0)
     +     )
      G20 = G20 + y**(-1)*z * (
     +     - 8*GYZ4(3,2,2,0)
     +     + 8*GYZ4(3,2,3,2)
     +     - 8*GYZ4(3,3,0,2)
     +     - 8*GYZ4(3,3,2,0)
     +     + 8*GYZ4(3,3,2,2)
     +     + 8*GYZ4(3,3,3,2)
     +     - 3*HZ1(0)
     +     )
      G20 = G20 + y**(-1)*z * (
     +     + 4./3.*HZ3(0,1,1)
     +     + 4./3.*HZ3(1,0,1)
     +     + 4./3.*HZ3(1,1,0)
     +     )
      G20 = G20 + y**(-1)*z**2 * (
     +     + 3*GYZ1(2)*HZ1(0)
     +     + 3*GYZ1(3)*HZ1(1)
     +     - 3*GYZ2(3,2)
     +     )
      G20 = G20 + y**(-1)*(1.-y-z)**(-1)*zeta2 * (
     +     + 4./3.*GYZ1(1)
     +     )
      G20 = G20 + y**(-1)*(1.-y-z)**(-1) * (
     +     - 4./3.*GYZ1(3)*HZ2(1,0)
     +     + 4./3.*GYZ2(1,0)*HZ1(0)
     +     + 4./3.*GYZ2(1,0)*HZ1(1)
     +     + 4./3.*GYZ2(3,0)*HZ1(1)
     +     + 4./3.*GYZ2(3,2)*HZ1(0)
     +     + 4./3.*GYZ2(3,3)*HZ1(1)
     +     - 4./3.*GYZ3(1,0,2)
     +     )
      G20 = G20 + y**(-1)*(1.-y-z)**(-1) * (
     +     - 4./3.*GYZ3(1,1,0)
     +     - 4./3.*GYZ3(1,2,0)
     +     - 4./3.*GYZ3(3,0,2)
     +     - 4./3.*GYZ3(3,2,0)
     +     - 4./3.*GYZ3(3,3,2)
     +     )
      G20 = G20 + y**(-1)*(1.-z)**(-1)*zeta2 * (
     +     + 4./3.*GYZ1(1)
     +     )
      G20 = G20 + y**(-1)*(1.-z)**(-1) * (
     +     - 4./3.*GYZ1(3)*HZ2(1,0)
     +     + 4./3.*GYZ2(1,0)*HZ1(0)
     +     + 4./3.*GYZ2(1,0)*HZ1(1)
     +     + 4./3.*GYZ2(3,0)*HZ1(1)
     +     + 4./3.*GYZ2(3,2)*HZ1(0)
     +     + 4./3.*GYZ2(3,3)*HZ1(1)
     +     - 4./3.*GYZ3(1,0,2)
     +     )
      G20 = G20 + y**(-1)*(1.-z)**(-1) * (
     +     - 4./3.*GYZ3(1,1,0)
     +     - 4./3.*GYZ3(1,2,0)
     +     - 4./3.*GYZ3(3,0,2)
     +     - 4./3.*GYZ3(3,2,0)
     +     - 4./3.*GYZ3(3,3,2)
     +     )
      G20 = G20 + y**(-1)*(y+z)**(-1) * (
     +     - 8./3.*GYZ1(0)*HZ2(1,1)
     +     - 8./3.*GYZ1(2)*HZ2(0,1)
     +     - 8./3.*GYZ1(2)*HZ2(1,0)
     +     + 8./3.*GYZ2(0,2)*HZ1(1)
     +     + 8./3.*GYZ2(2,0)*HZ1(1)
     +     + 8./3.*GYZ2(2,2)*HZ1(0)
     +     - 8./3.*GYZ3(0,2,2)
     +     )
      G20 = G20 + y**(-1)*(y+z)**(-1) * (
     +     - 8./3.*GYZ3(2,0,2)
     +     - 8./3.*GYZ3(2,2,0)
     +     + 8./3.*HZ3(0,1,1)
     +     + 8./3.*HZ3(1,0,1)
     +     + 8./3.*HZ3(1,1,0)
     +     )
      G20 = G20 + y**(-1)*zeta2 * (
     +     + 2./3.*GYZ1(1)
     +     + 2./3.*GYZ1(2)
     +     - 4*GYZ1(2)*HZ1(1)
     +     - 4*GYZ2(2,0)
     +     + 4*GYZ2(2,2)
     +     )
      G20 = G20 + y**(-1)*zeta3 * (
     +     + 12*GYZ1(2)
     +     )
      G20 = G20 + y**(-1) * (
     +     + 8./3.*GYZ1(0)*HZ2(1,1)
     +     - 3*GYZ1(2)
     +     + 11./3.*GYZ1(2)*HZ1(0)
     +     + 4./3.*GYZ1(2)*HZ2(0,1)
     +     + 2*GYZ1(2)*HZ2(1,0)
     +     - 4*GYZ1(2)*HZ3(0,0,1)
     +     + 4*GYZ1(2)*HZ3(1,0,1)
     +     )
      G20 = G20 + y**(-1) * (
     +     + 11./3.*GYZ1(3)*HZ1(1)
     +     + 2*GYZ1(3)*HZ2(0,1)
     +     + 2./3.*GYZ1(3)*HZ2(1,0)
     +     + 4./3.*GYZ1(3)*HZ2(1,1)
     +     - 4*GYZ1(3)*HZ3(0,1,1)
     +     - 4*GYZ1(3)*HZ3(1,0,1)
     +     + 2*GYZ2(0,2)*HZ1(0)
     +     )
      G20 = G20 + y**(-1) * (
     +     - 8./3.*GYZ2(0,2)*HZ1(1)
     +     + 2*GYZ2(0,3)*HZ1(1)
     +     + 2./3.*GYZ2(1,0)*HZ1(0)
     +     + 2./3.*GYZ2(1,0)*HZ1(1)
     +     - 4./3.*GYZ2(2,0)*HZ1(0)
     +     - 8./3.*GYZ2(2,0)*HZ1(1)
     +     + 4*GYZ2(2,0)*HZ2(0,1)
     +     )
      G20 = G20 + y**(-1) * (
     +     - 4*GYZ2(2,2)*HZ1(0)
     +     - 4*GYZ2(2,2)*HZ2(0,1)
     +     - 8./3.*GYZ2(2,3)*HZ1(1)
     +     - 2./3.*GYZ2(3,0)*HZ1(1)
     +     + 4*GYZ2(3,0)*HZ2(1,1)
     +     - 11./3.*GYZ2(3,2)
     +     - 2./3.*GYZ2(3,2)*HZ1(0)
     +     )
      G20 = G20 + y**(-1) * (
     +     - 4./3.*GYZ2(3,2)*HZ1(1)
     +     + 4*GYZ2(3,2)*HZ2(0,1)
     +     + 4./3.*GYZ2(3,3)*HZ1(1)
     +     + 4*GYZ2(3,3)*HZ2(0,1)
     +     - 4*GYZ2(3,3)*HZ2(1,1)
     +     + 8./3.*GYZ3(0,2,2)
     +     - 2*GYZ3(0,3,2)
     +     )
      G20 = G20 + y**(-1) * (
     +     - 2./3.*GYZ3(1,0,2)
     +     - 2./3.*GYZ3(1,1,0)
     +     - 2./3.*GYZ3(1,2,0)
     +     + 8./3.*GYZ3(2,0,2)
     +     + 4*GYZ3(2,0,3)*HZ1(1)
     +     + 8./3.*GYZ3(2,2,0)
     +     - 4*GYZ3(2,2,3)*HZ1(1)
     +     )
      G20 = G20 + y**(-1) * (
     +     + 8./3.*GYZ3(2,3,2)
     +     + 2./3.*GYZ3(3,0,2)
     +     - 4*GYZ3(3,0,2)*HZ1(1)
     +     + 2./3.*GYZ3(3,2,0)
     +     - 4*GYZ3(3,2,0)*HZ1(1)
     +     + 4./3.*GYZ3(3,2,2)
     +     + 4*GYZ3(3,2,3)*HZ1(1)
     +     )
      G20 = G20 + y**(-1) * (
     +     - 4*GYZ3(3,3,0)*HZ1(1)
     +     - 4./3.*GYZ3(3,3,2)
     +     + 4*GYZ3(3,3,2)*HZ1(1)
     +     + 4*GYZ3(3,3,3)*HZ1(1)
     +     + 4*GYZ4(2,0,1,0)
     +     - 4*GYZ4(2,0,3,2)
     +     - 4*GYZ4(2,2,1,0)
     +     )
      G20 = G20 + y**(-1) * (
     +     + 4*GYZ4(2,2,3,2)
     +     - 4*GYZ4(3,0,1,0)
     +     + 4*GYZ4(3,0,2,2)
     +     + 4*GYZ4(3,2,0,2)
     +     - 4*GYZ4(3,2,1,0)
     +     + 4*GYZ4(3,2,2,0)
     +     - 4*GYZ4(3,2,3,2)
     +     )
      G20 = G20 + y**(-1) * (
     +     + 4*GYZ4(3,3,0,2)
     +     + 4*GYZ4(3,3,2,0)
     +     - 4*GYZ4(3,3,2,2)
     +     - 4*GYZ4(3,3,3,2)
     +     + 6*HZ1(0)
     +     + 3*HZ1(1)
     +     - 8./3.*HZ3(0,1,1)
     +     )
      G20 = G20 + y**(-1) * (
     +     - 8./3.*HZ3(1,0,1)
     +     - 8./3.*HZ3(1,1,0)
     +     )
      G20 = G20 + z*(1.-y-z)**(-1)*zeta2 * (
     +     - 4./3.*GYZ1(1)
     +     - 4./3.*HZ1(1)
     +     )
      G20 = G20 + z*(1.-y-z)**(-1) * (
     +     - 4./3.*GYZ1(0)*HZ2(0,1)
     +     - 4./3.*GYZ1(0)*HZ2(1,0)
     +     + 8./3.*GYZ1(3)*HZ2(0,1)
     +     + 8./3.*GYZ1(3)*HZ2(1,0)
     +     + 4./3.*GYZ2(0,2)*HZ1(0)
     +     - 4./3.*GYZ2(1,0)*HZ1(0)
     +     - 4./3.*GYZ2(1,0)*HZ1(1)
     +     )
      G20 = G20 + z*(1.-y-z)**(-1) * (
     +     - 8./3.*GYZ2(3,0)*HZ1(1)
     +     - 8./3.*GYZ2(3,2)*HZ1(0)
     +     - 4./3.*GYZ3(0,1,0)
     +     + 4./3.*GYZ3(1,0,2)
     +     + 4./3.*GYZ3(1,1,0)
     +     + 4./3.*GYZ3(1,2,0)
     +     + 8./3.*GYZ3(3,0,2)
     +     )
      G20 = G20 + z*(1.-y-z)**(-1) * (
     +     + 8./3.*GYZ3(3,2,0)
     +     + 8./3.*HZ3(0,0,1)
     +     + 4./3.*HZ3(0,1,0)
     +     - 4./3.*HZ3(1,0,1)
     +     - 8./3.*HZ3(1,1,0)
     +     )
      G20 = G20 + z*(1.-y)**(-2)*zeta2 * (
     +     - 6
     +     + 2*GYZ1(2)
     +     - 2*HZ1(0)
     +     - 2*HZ1(1)
     +     )
      G20 = G20 + z*(1.-y)**(-2)*zeta3 * (
     +     + 6
     +     )
      G20 = G20 + z*(1.-y)**(-2) * (
     +     - 2*GYZ1(2)*HZ2(0,1)
     +     + 2*GYZ1(2)*HZ2(1,0)
     +     + 6*GYZ1(3)*HZ1(1)
     +     - 2*GYZ2(0,2)*HZ1(0)
     +     - 2*GYZ2(0,3)*HZ1(1)
     +     - 2*GYZ2(2,3)*HZ1(1)
     +     - 6*GYZ2(3,2)
     +     )
      G20 = G20 + z*(1.-y)**(-2) * (
     +     + 2*GYZ3(0,3,2)
     +     + 2*GYZ3(2,3,2)
     +     + 6*HZ2(0,1)
     +     - 6*HZ2(1,0)
     +     + 2*HZ3(0,0,1)
     +     - 2*HZ3(0,1,0)
     +     + 2*HZ3(1,0,1)
     +     )
      G20 = G20 + z*(1.-y)**(-2) * (
     +     - 2*HZ3(1,1,0)
     +     )
      G20 = G20 + z*(1.-y)**(-1) * (
     +     - 3*GYZ1(2)
     +     - 2*GYZ1(2)*HZ1(0)
     +     - 2*GYZ1(3)*HZ1(1)
     +     + 2*GYZ2(3,2)
     +     + 3*HZ1(0)
     +     + 3*HZ1(1)
     +     )
      G20 = G20 + z*(y+z)**(-3) * (
     +     - 8*GYZ1(0)*HZ1(1)
     +     + 8./3.*GYZ1(0)*HZ2(1,1)
     +     - 8*GYZ1(2)*HZ1(0)
     +     + 8./3.*GYZ1(2)*HZ2(0,1)
     +     + 8./3.*GYZ1(2)*HZ2(1,0)
     +     + 8*GYZ2(0,2)
     +     - 8./3.*GYZ2(0,2)*HZ1(1)
     +     )
      G20 = G20 + z*(y+z)**(-3) * (
     +     + 8*GYZ2(2,0)
     +     - 8./3.*GYZ2(2,0)*HZ1(1)
     +     - 8./3.*GYZ2(2,2)*HZ1(0)
     +     + 8./3.*GYZ3(0,2,2)
     +     + 8./3.*GYZ3(2,0,2)
     +     + 8./3.*GYZ3(2,2,0)
     +     + 8*HZ2(0,1)
     +     )
      G20 = G20 + z*(y+z)**(-3) * (
     +     + 8*HZ2(1,0)
     +     - 8./3.*HZ3(0,1,1)
     +     - 8./3.*HZ3(1,0,1)
     +     - 8./3.*HZ3(1,1,0)
     +     )
      G20 = G20 + z*(y+z)**(-2) * (
     +     + 8*GYZ1(0)
     +     + 16./3.*GYZ1(0)*HZ1(1)
     +     - 4./3.*GYZ1(0)*HZ2(1,1)
     +     + 16./3.*GYZ1(2)*HZ1(0)
     +     - 4./3.*GYZ1(2)*HZ2(0,1)
     +     - 4./3.*GYZ1(2)*HZ2(1,0)
     +     - 16./3.*GYZ2(0,2)
     +     )
      G20 = G20 + z*(y+z)**(-2) * (
     +     + 4./3.*GYZ2(0,2)*HZ1(1)
     +     - 16./3.*GYZ2(2,0)
     +     + 4./3.*GYZ2(2,0)*HZ1(1)
     +     + 4./3.*GYZ2(2,2)*HZ1(0)
     +     - 4./3.*GYZ3(0,2,2)
     +     - 4./3.*GYZ3(2,0,2)
     +     - 4./3.*GYZ3(2,2,0)
     +     )
      G20 = G20 + z*(y+z)**(-2) * (
     +     - 8*HZ1(0)
     +     - 16./3.*HZ2(0,1)
     +     - 16./3.*HZ2(1,0)
     +     + 4./3.*HZ3(0,1,1)
     +     + 4./3.*HZ3(1,0,1)
     +     + 4./3.*HZ3(1,1,0)
     +     )
      G20 = G20 + z*(y+z)**(-1) * (
     +     - 8./3.*GYZ1(0)
     +     + 8./3.*GYZ1(0)*HZ2(1,1)
     +     + 8./3.*GYZ1(2)*HZ2(0,1)
     +     + 8./3.*GYZ1(2)*HZ2(1,0)
     +     - 8./3.*GYZ2(0,2)*HZ1(1)
     +     - 8./3.*GYZ2(2,0)*HZ1(1)
     +     - 8./3.*GYZ2(2,2)*HZ1(0)
     +     )
      G20 = G20 + z*(y+z)**(-1) * (
     +     + 8./3.*GYZ3(0,2,2)
     +     + 8./3.*GYZ3(2,0,2)
     +     + 8./3.*GYZ3(2,2,0)
     +     + 8./3.*HZ1(0)
     +     - 8./3.*HZ3(0,1,1)
     +     - 8./3.*HZ3(1,0,1)
     +     - 8./3.*HZ3(1,1,0)
     +     )
      G20 = G20 + z**2*(1.-y)**(-3)*zeta2 * (
     +     - 6*GYZ1(2)
     +     + 6*HZ1(0)
     +     + 6*HZ1(1)
     +     )
      G20 = G20 + z**2*(1.-y)**(-3)*zeta3 * (
     +     - 18
     +     )
      G20 = G20 + z**2*(1.-y)**(-3) * (
     +     + 6*GYZ1(2)*HZ2(0,1)
     +     - 6*GYZ1(2)*HZ2(1,0)
     +     + 6*GYZ2(0,2)*HZ1(0)
     +     + 6*GYZ2(0,3)*HZ1(1)
     +     + 6*GYZ2(2,3)*HZ1(1)
     +     - 6*GYZ3(0,3,2)
     +     - 6*GYZ3(2,3,2)
     +     )
      G20 = G20 + z**2*(1.-y)**(-3) * (
     +     - 6*HZ3(0,0,1)
     +     + 6*HZ3(0,1,0)
     +     - 6*HZ3(1,0,1)
     +     + 6*HZ3(1,1,0)
     +     )
      G20 = G20 + z**2*(1.-y)**(-2) * (
     +     + 6*GYZ1(2)*HZ1(0)
     +     + 6*GYZ1(3)*HZ1(1)
     +     - 6*GYZ2(3,2)
     +     )
      G20 = G20 + z**2*(1.-y)**(-1) * (
     +     + 3*GYZ1(2)*HZ1(0)
     +     + 3*GYZ1(3)*HZ1(1)
     +     - 3*GYZ2(3,2)
     +     )
      G20 = G20 + (1.-y-z)**(-1)*(1.-y)**(-1)*zeta2 * (
     +     - 4./3.*HZ1(1)
     +     )
      G20 = G20 + (1.-y-z)**(-1)*(1.-y)**(-1) * (
     +     - 4./3.*GYZ1(0)*HZ2(0,1)
     +     - 4./3.*GYZ1(0)*HZ2(1,0)
     +     + 8./3.*GYZ1(3)*HZ2(0,1)
     +     + 4./3.*GYZ1(3)*HZ2(1,0)
     +     + 4./3.*GYZ2(0,2)*HZ1(0)
     +     - 4./3.*GYZ2(3,0)*HZ1(1)
     +     - 4./3.*GYZ2(3,2)*HZ1(0)
     +     )
      G20 = G20 + (1.-y-z)**(-1)*(1.-y)**(-1) * (
     +     + 4./3.*GYZ2(3,3)*HZ1(1)
     +     - 4./3.*GYZ3(0,1,0)
     +     + 4./3.*GYZ3(3,0,2)
     +     + 4./3.*GYZ3(3,2,0)
     +     - 4./3.*GYZ3(3,3,2)
     +     + 8./3.*HZ3(0,0,1)
     +     + 4./3.*HZ3(0,1,0)
     +     )
      G20 = G20 + (1.-y-z)**(-1)*(1.-y)**(-1) * (
     +     - 4./3.*HZ3(1,0,1)
     +     - 8./3.*HZ3(1,1,0)
     +     )
      G20 = G20 + (1.-y-z)**(-1)*zeta2 * (
     +     + 4./3.
     +     - GYZ1(1)
     +     + HZ1(1)
     +     )
      G20 = G20 + (1.-y-z)**(-1) * (
     +     + 4./3.*GYZ1(0)*HZ1(0)
     +     + GYZ1(0)*HZ2(0,1)
     +     + GYZ1(0)*HZ2(1,0)
     +     - 2*GYZ1(3)*HZ2(0,1)
     +     - GYZ2(0,2)*HZ1(0)
     +     - 4./3.*GYZ2(1,0)
     +     - GYZ2(1,0)*HZ1(0)
     +     )
      G20 = G20 + (1.-y-z)**(-1) * (
     +     - GYZ2(1,0)*HZ1(1)
     +     - 2*GYZ2(3,3)*HZ1(1)
     +     + GYZ3(0,1,0)
     +     + GYZ3(1,0,2)
     +     + GYZ3(1,1,0)
     +     + GYZ3(1,2,0)
     +     + 2*GYZ3(3,3,2)
     +     )
      G20 = G20 + (1.-y-z)**(-1) * (
     +     + 4./3.*HZ2(1,0)
     +     - 2*HZ3(0,0,1)
     +     - HZ3(0,1,0)
     +     + HZ3(1,0,1)
     +     + 2*HZ3(1,1,0)
     +     )
      G20 = G20 + (1.-y)**(-1)*zeta2 * (
     +     - 3
     +     - 4*GYZ1(2)
     +     + 4*HZ1(0)
     +     + 4*HZ1(1)
     +     )
      G20 = G20 + (1.-y)**(-1)*zeta3 * (
     +     - 12
     +     )
      G20 = G20 + (1.-y)**(-1) * (
     +     + 3*GYZ1(0)
     +     - GYZ1(0)*HZ1(0)
     +     - GYZ1(0)*HZ1(1)
     +     + 4*GYZ1(2)*HZ2(0,1)
     +     - 4*GYZ1(2)*HZ2(1,0)
     +     + GYZ1(3)*HZ1(1)
     +     + GYZ2(0,2)
     +     )
      G20 = G20 + (1.-y)**(-1) * (
     +     + 4*GYZ2(0,2)*HZ1(0)
     +     + 4*GYZ2(0,3)*HZ1(1)
     +     + 2*GYZ2(1,0)
     +     + GYZ2(2,0)
     +     + 4*GYZ2(2,3)*HZ1(1)
     +     - GYZ2(3,2)
     +     - 4*GYZ3(0,3,2)
     +     )
      G20 = G20 + (1.-y)**(-1) * (
     +     - 4*GYZ3(2,3,2)
     +     + HZ2(0,1)
     +     - HZ2(1,0)
     +     - 4*HZ3(0,0,1)
     +     + 4*HZ3(0,1,0)
     +     - 4*HZ3(1,0,1)
     +     + 4*HZ3(1,1,0)
     +     )
      G20 = G20 + (y+z)**(-2)*zeta2 * (
     +     + 2*GYZ1(2)
     +     - 2*HZ1(1)
     +     )
      G20 = G20 + (y+z)**(-2) * (
     +     + 2*GYZ1(0)*HZ1(1)
     +     - 2*GYZ1(0)*HZ2(1,0)
     +     - 2*GYZ1(0)*HZ2(1,1)
     +     - 8*GYZ1(2)
     +     - 2*GYZ1(2)*HZ1(0)
     +     - 8./3.*GYZ1(2)*HZ1(1)
     +     - 2*GYZ1(2)*HZ2(0,1)
     +     )
      G20 = G20 + (y+z)**(-2) * (
     +     + 2*GYZ1(2)*HZ2(1,0)
     +     - 4*GYZ1(3)*HZ1(1)
     +     - 2*GYZ1(3)*HZ2(0,1)
     +     + 2*GYZ1(3)*HZ2(1,0)
     +     + 4*GYZ1(3)*HZ2(1,1)
     +     - 2*GYZ2(0,2)
     +     + 2*GYZ2(0,2)*HZ1(0)
     +     )
      G20 = G20 + (y+z)**(-2) * (
     +     + 2*GYZ2(0,2)*HZ1(1)
     +     + 2*GYZ2(0,3)*HZ1(1)
     +     - 2*GYZ2(2,0)
     +     + 2*GYZ2(2,0)*HZ1(0)
     +     + 2*GYZ2(2,0)*HZ1(1)
     +     + 8./3.*GYZ2(2,2)
     +     - 2*GYZ2(2,2)*HZ1(0)
     +     )
      G20 = G20 + (y+z)**(-2) * (
     +     - 4*GYZ2(2,3)*HZ1(1)
     +     + 2*GYZ2(3,0)*HZ1(1)
     +     + 4*GYZ2(3,2)
     +     - 2*GYZ2(3,2)*HZ1(0)
     +     - 4*GYZ2(3,2)*HZ1(1)
     +     - 4*GYZ2(3,3)*HZ1(1)
     +     - 2*GYZ3(0,2,2)
     +     )
      G20 = G20 + (y+z)**(-2) * (
     +     - 2*GYZ3(0,3,2)
     +     - 2*GYZ3(2,0,2)
     +     - 2*GYZ3(2,2,0)
     +     + 4*GYZ3(2,3,2)
     +     - 2*GYZ3(3,0,2)
     +     - 2*GYZ3(3,2,0)
     +     + 4*GYZ3(3,2,2)
     +     )
      G20 = G20 + (y+z)**(-2) * (
     +     + 4*GYZ3(3,3,2)
     +     + 8*HZ1(1)
     +     - 2*HZ2(0,1)
     +     + 2*HZ2(1,0)
     +     + 8./3.*HZ2(1,1)
     +     + 2*HZ3(0,1,0)
     +     + 2*HZ3(0,1,1)
     +     )
      G20 = G20 + (y+z)**(-2) * (
     +     + 2*HZ3(1,0,1)
     +     - 2*HZ3(1,1,0)
     +     )
      G20 = G20 + (y+z)**(-1)*zeta2 * (
     +     + 2
     +     - GYZ1(2)
     +     + HZ1(1)
     +     )
      G20 = G20 + (y+z)**(-1) * (
     +     - 4*GYZ1(0)
     +     + 2*GYZ1(0)*HZ1(0)
     +     + 4*GYZ1(0)*HZ1(1)
     +     + GYZ1(0)*HZ2(1,0)
     +     + 32./3.*GYZ1(2)
     +     - 4*GYZ1(2)*HZ1(0)
     +     - 8./3.*GYZ1(2)*HZ1(1)
     +     )
      G20 = G20 + (y+z)**(-1) * (
     +     - GYZ1(2)*HZ2(1,0)
     +     - 10*GYZ1(3)*HZ1(1)
     +     - 4*GYZ2(0,2)
     +     - 4*GYZ2(2,0)
     +     - GYZ2(2,0)*HZ1(0)
     +     + 8./3.*GYZ2(2,2)
     +     + 10*GYZ2(3,2)
     +     )
      G20 = G20 + (y+z)**(-1) * (
     +     + GYZ3(0,1,0)
     +     + GYZ3(2,1,0)
     +     - 4*HZ1(0)
     +     - 32./3.*HZ1(1)
     +     - 6*HZ2(0,1)
     +     + 4*HZ2(1,0)
     +     + 8./3.*HZ2(1,1)
     +     )
      G20 = G20 + (y+z)**(-1) * (
     +     - HZ3(0,1,0)
     +     + HZ3(1,1,0)
     +     )
      G20 = G20 + t*zeta2 * (
     +     + 2./3.*GYZ1(1)
     +     - 2./3.*GYZ1(2)
     +     )
      G20 = G20 + t * (
     +     + 2./3.*GYZ1(0)*HZ2(1,1)
     +     + 3./2.*GYZ1(2)
     +     - 2./3.*GYZ1(2)*HZ2(1,0)
     +     - 4./3.*GYZ1(3)*HZ2(1,1)
     +     - 2./3.*GYZ2(0,2)*HZ1(1)
     +     + 2./3.*GYZ2(1,0)*HZ1(0)
     +     + 2./3.*GYZ2(1,0)*HZ1(1)
     +     )
      G20 = G20 + t * (
     +     - 2./3.*GYZ2(2,0)*HZ1(0)
     +     - 2./3.*GYZ2(2,0)*HZ1(1)
     +     + 2./3.*GYZ2(2,2)*HZ1(0)
     +     + 2./3.*GYZ2(2,3)*HZ1(1)
     +     + 4./3.*GYZ2(3,2)*HZ1(1)
     +     + 2./3.*GYZ3(0,2,2)
     +     - 2./3.*GYZ3(1,0,2)
     +     )
      G20 = G20 + t * (
     +     - 2./3.*GYZ3(1,1,0)
     +     - 2./3.*GYZ3(1,2,0)
     +     + 2./3.*GYZ3(2,0,2)
     +     + 2./3.*GYZ3(2,2,0)
     +     - 2./3.*GYZ3(2,3,2)
     +     - 4./3.*GYZ3(3,2,2)
     +     - 3./2.*HZ1(1)
     +     )
      G20 = G20 + t * (
     +     - 2./3.*HZ3(0,1,1)
     +     - 2./3.*HZ3(1,0,1)
     +     - 2./3.*HZ3(1,1,0)
     +     )
      G20 = G20 + zeta2 * (
     +     + 25./3.
     +     - 4*GYZ1(0)
     +     + 1./3.*GYZ1(1)
     +     - 2*GYZ1(1)*HZ1(0)
     +     - 2*GYZ1(1)*HZ1(1)
     +     + 22./3.*GYZ1(2)
     +     + 2*GYZ1(2)*HZ1(0)
     +     )
      G20 = G20 + zeta2 * (
     +     + 4*GYZ1(2)*HZ1(1)
     +     + 2*GYZ2(1,2)
     +     + 2*GYZ2(2,0)
     +     - 4*GYZ2(2,2)
     +     - 4*HZ1(0)
     +     - 23./3.*HZ1(1)
     +     - 2*HZ2(1,0)
     +     )
      G20 = G20 + zeta2 * (
     +     - 2*HZ2(1,1)
     +     )
      G20 = G20 + zeta3 * (
     +     + 24
     +     + 6*GYZ1(1)
     +     - 12*GYZ1(2)
     +     + 6*HZ1(1)
     +     )
      G20 = G20 - 5./3.*GYZ1(0)
     +     + 1./3.*GYZ1(0)*HZ1(0)
     +     - 5./3.*GYZ1(0)*HZ1(1)
     +     + 13./3.*GYZ1(0)*HZ2(0,1)
     +     - 2./3.*GYZ1(0)*HZ2(1,0)
     +     + 11./3.*GYZ1(0)*HZ2(1,1)
     +     + 2*GYZ1(1)*HZ3(0,0,1)
     +     - 2*GYZ1(1)*HZ3(0,1,0)
     +
      G20 = G20 + 2*GYZ1(1)*HZ3(1,0,1)
     +     - 2*GYZ1(1)*HZ3(1,1,0)
     +     + 10./3.*GYZ1(2)
     +     + 5./3.*GYZ1(2)*HZ1(0)
     +     + 16./3.*GYZ1(2)*HZ1(1)
     +     - 3*GYZ1(2)*HZ2(0,1)
     +     + 13./3.*GYZ1(2)*HZ2(1,0)
     +     + 2*GYZ1(2)*HZ3(0,1,0)
     +
      G20 = G20 - 4*GYZ1(2)*HZ3(1,0,1)
     +     + 2*GYZ1(2)*HZ3(1,1,0)
     +     - 2*GYZ1(3)*HZ1(1)
     +     + 7./3.*GYZ1(3)*HZ2(0,1)
     +     - 3*GYZ1(3)*HZ2(1,0)
     +     - 22./3.*GYZ1(3)*HZ2(1,1)
     +     + 2*GYZ1(3)*HZ3(0,1,1)
     +     + 2*GYZ1(3)*HZ3(1,0,1)
     +
      G20 = G20 + 5./3.*GYZ2(0,2)
     +     - 22./3.*GYZ2(0,2)*HZ1(0)
     +     - 11./3.*GYZ2(0,2)*HZ1(1)
     +     - 3*GYZ2(0,3)*HZ1(1)
     +     - 2*GYZ2(0,3)*HZ2(1,0)
     +     - 2*GYZ2(0,3)*HZ2(1,1)
     +     - 2*GYZ2(1,0)
     +     - 2./3.*GYZ2(1,0)*HZ1(0)
     +
      G20 = G20 - 2./3.*GYZ2(1,0)*HZ1(1)
     +     - 2*GYZ2(1,2)*HZ2(0,1)
     +     + 2*GYZ2(1,2)*HZ2(1,0)
     +     + 5./3.*GYZ2(2,0)
     +     + 4./3.*GYZ2(2,0)*HZ1(0)
     +     - 11./3.*GYZ2(2,0)*HZ1(1)
     +     - 2*GYZ2(2,0)*HZ2(0,1)
     +     - 16./3.*GYZ2(2,2)
     +
      G20 = G20 + 11./3.*GYZ2(2,2)*HZ1(0)
     +     + 4*GYZ2(2,2)*HZ2(0,1)
     +     - 2*GYZ2(2,2)*HZ2(1,0)
     +     + 2./3.*GYZ2(2,3)*HZ1(1)
     +     - 3*GYZ2(3,0)*HZ1(1)
     +     - 2*GYZ2(3,0)*HZ2(1,1)
     +     + 2*GYZ2(3,2)
     +     + 3*GYZ2(3,2)*HZ1(0)
     +
      G20 = G20 + 22./3.*GYZ2(3,2)*HZ1(1)
     +     - 2*GYZ2(3,2)*HZ2(0,1)
     +     + 16./3.*GYZ2(3,3)*HZ1(1)
     +     - 2*GYZ2(3,3)*HZ2(0,1)
     +     + 2*GYZ2(3,3)*HZ2(1,0)
     +     + 4*GYZ2(3,3)*HZ2(1,1)
     +     - 2*GYZ3(0,0,2)*HZ1(0)
     +     - 2*GYZ3(0,0,3)*HZ1(1)
     +
      G20 = G20 + 1./3.*GYZ3(0,1,0)
     +     + 11./3.*GYZ3(0,2,2)
     +     + 2*GYZ3(0,2,2)*HZ1(0)
     +     + 2*GYZ3(0,2,3)*HZ1(1)
     +     + 3*GYZ3(0,3,2)
     +     + 2*GYZ3(0,3,2)*HZ1(0)
     +     + 2*GYZ3(0,3,2)*HZ1(1)
     +     + 2*GYZ3(0,3,3)*HZ1(1)
     +
      G20 = G20 + 2./3.*GYZ3(1,0,2)
     +     - 2*GYZ3(1,0,2)*HZ1(0)
     +     - 2*GYZ3(1,0,3)*HZ1(1)
     +     - 1./3.*GYZ3(1,1,0)
     +     + 2./3.*GYZ3(1,2,0)
     +     - 2*GYZ3(1,2,3)*HZ1(1)
     +     + 11./3.*GYZ3(2,0,2)
     +     + 2*GYZ3(2,0,2)*HZ1(0)
     +
      G20 = G20 - 8*GYZ3(2,1,0)
     +     + 11./3.*GYZ3(2,2,0)
     +     + 4*GYZ3(2,2,3)*HZ1(1)
     +     - 2./3.*GYZ3(2,3,2)
     +     + 3*GYZ3(3,0,2)
     +     + 2*GYZ3(3,0,2)*HZ1(0)
     +     + 2*GYZ3(3,0,2)*HZ1(1)
     +     + 2*GYZ3(3,0,3)*HZ1(1)
     +
      G20 = G20 + 3*GYZ3(3,2,0)
     +     + 2*GYZ3(3,2,0)*HZ1(1)
     +     - 22./3.*GYZ3(3,2,2)
     +     - 2*GYZ3(3,2,2)*HZ1(0)
     +     - 4*GYZ3(3,2,3)*HZ1(1)
     +     + 2*GYZ3(3,3,0)*HZ1(1)
     +     - 16./3.*GYZ3(3,3,2)
     +     - 2*GYZ3(3,3,2)*HZ1(0)
     +
      G20 = G20 - 4*GYZ3(3,3,2)*HZ1(1)
     +     - 4*GYZ3(3,3,3)*HZ1(1)
     +     + 2*GYZ4(0,0,3,2)
     +     - 2*GYZ4(0,2,3,2)
     +     - 2*GYZ4(0,3,2,2)
     +     - 2*GYZ4(0,3,3,2)
     +     + 2*GYZ4(1,0,3,2)
     +     + 2*GYZ4(1,2,3,2)
     +
      G20 = G20 - 2*GYZ4(2,0,1,0)
     +     + 2*GYZ4(2,2,1,0)
     +     - 4*GYZ4(2,2,3,2)
     +     + 2*GYZ4(3,0,1,0)
     +     - 2*GYZ4(3,0,2,2)
     +     - 2*GYZ4(3,0,3,2)
     +     - 2*GYZ4(3,2,0,2)
     +     + 2*GYZ4(3,2,1,0)
     +
      G20 = G20 - 2*GYZ4(3,2,2,0)
     +     + 4*GYZ4(3,2,3,2)
     +     - 2*GYZ4(3,3,0,2)
     +     - 2*GYZ4(3,3,2,0)
     +     + 4*GYZ4(3,3,2,2)
     +     + 4*GYZ4(3,3,3,2)
     +     - 5./3.*HZ1(0)
     +     - 10./3.*HZ1(1)
     +
      G20 = G20 - 11./3.*HZ2(0,1)
     +     + 1./3.*HZ2(1,0)
     +     - 16./3.*HZ2(1,1)
     +     - 2./3.*HZ3(0,0,1)
     +     - 10./3.*HZ3(0,1,0)
     +     - 11./3.*HZ3(0,1,1)
     +     + 11./3.*HZ3(1,0,1)
     +     - 4*HZ3(1,1,0)
     +
      G20 = G20 + 2*HZ4(1,0,0,1)
     +     - 2*HZ4(1,0,1,0)
     +     + 2*HZ4(1,1,0,1)
     +     - 2*HZ4(1,1,1,0)
     +
      return
      end


      subroutine tjme11(y,z,A11,B11,C11,D11,E11,F11)
      implicit none
      real*8 y,z
      real*8 t
      real*8 A11,B11,C11,D11,E11,F11
      real*8 zeta2,zeta3,zeta4
      integer nmax
      real*8 HZ1,HZ2,HZ3,HZ4,GYZ1,GYZ2,GYZ3,GYZ4
      dimension HZ1(0:1),HZ2(0:1,0:1),HZ3(0:1,0:1,0:1), 
     $          HZ4(0:1,0:1,0:1,0:1), 
     $          GYZ1(0:3),GYZ2(0:3,0:3),GYZ3(0:3,0:3,0:3), 
     $          GYZ4(0:3,0:3,0:3,0:3)       
      parameter (zeta2=1.64493406684822644d0)
      parameter (zeta3=1.20205690315959429d0)
      parameter (zeta4=1.08232323371113819d0)
      
      nmax = 4
      call tdhpl(y,z,nmax,GYZ1,GYZ2,GYZ3,GYZ4,HZ1,HZ2,HZ3,HZ4)
      t = y/z+z/y+2./y/z-2./y-2./z

      A11 = 0.
     +
      A11 = A11 + y**(-1)*z * (
     +     + 1./4.
     +     )
      A11 = A11 + y**(-1)*zeta2 * (
     +     - 1
     +     )
      A11 = A11 + y**(-1) * (
     +     - 4
     +     - 5./3.*GYZ1(0)
     +     - GYZ1(0)*HZ1(0)
     +     + GYZ2(1,0)
     +     - 5./3.*HZ1(0)
     +     - HZ2(1,0)
     +     )
      A11 = A11 + z*(1.-y)**(-2)*zeta2 * (
     +     + GYZ1(0)
     +     )
      A11 = A11 + z*(1.-y)**(-2) * (
     +     + 7./2.*GYZ1(0)
     +     + 5./3.*GYZ1(0)*HZ1(0)
     +     + GYZ1(0)*HZ2(1,0)
     +     + 23./6.*GYZ2(0,0)
     +     + 2*GYZ2(0,0)*HZ1(0)
     +     - GYZ3(0,1,0)
     +     - 2*GYZ3(1,0,0)
     +     )
      A11 = A11 + z*(1.-y)**(-1)*zeta2 * (
     +     + 1
     +     + 3*GYZ1(0)
     +     )
      A11 = A11 + z*(1.-y)**(-1) * (
     +     + 7./2.
     +     + 73./6.*GYZ1(0)
     +     + 6*GYZ1(0)*HZ1(0)
     +     + 3*GYZ1(0)*HZ2(1,0)
     +     + 11./2.*GYZ2(0,0)
     +     + 6*GYZ2(0,0)*HZ1(0)
     +     - GYZ2(1,0)
     +     )
      A11 = A11 + z*(1.-y)**(-1) * (
     +     - 3*GYZ3(0,1,0)
     +     - 6*GYZ3(1,0,0)
     +     + 5./3.*HZ1(0)
     +     + HZ2(1,0)
     +     )
      A11 = A11 + (1.-y)**(-1)*zeta2 * (
     +     - 4*GYZ1(0)
     +     )
      A11 = A11 + (1.-y)**(-1) * (
     +     - 14*GYZ1(0)
     +     - 20./3.*GYZ1(0)*HZ1(0)
     +     - 4*GYZ1(0)*HZ2(1,0)
     +     - 28./3.*GYZ2(0,0)
     +     - 8*GYZ2(0,0)*HZ1(0)
     +     + 4*GYZ3(0,1,0)
     +     + 8*GYZ3(1,0,0)
     +     )
      A11 = A11 + t*zeta2 * (
     +     + 169./12.
     +     + 5./3.*GYZ1(0)
     +     + GYZ1(0)*HZ1(0)
     +     - GYZ2(1,0)
     +     + 5./3.*HZ1(0)
     +     + HZ2(1,0)
     +     )
      A11 = A11 + t*zeta4 * (
     +     + 5./4.
     +     )
      A11 = A11 + t * (
     +     + 8
     +     + 20./3.*GYZ1(0)
     +     + 61./9.*GYZ1(0)*HZ1(0)
     +     + 10./3.*GYZ1(0)*HZ2(0,0)
     +     + 5./3.*GYZ1(0)*HZ2(1,0)
     +     + GYZ1(0)*HZ3(0,1,0)
     +     + 2*GYZ1(0)*HZ3(1,0,0)
     +     )
      A11 = A11 + t * (
     +     + 25./9.*GYZ2(0,0)
     +     + 10./3.*GYZ2(0,0)*HZ1(0)
     +     + 2*GYZ2(0,0)*HZ2(0,0)
     +     - 4*GYZ2(1,0)
     +     - 5./3.*GYZ2(1,0)*HZ1(0)
     +     - GYZ2(1,0)*HZ2(1,0)
     +     - 5./3.*GYZ3(0,1,0)
     +     )
      A11 = A11 + t * (
     +     - GYZ3(0,1,0)*HZ1(0)
     +     - 10./3.*GYZ3(1,0,0)
     +     - 2*GYZ3(1,0,0)*HZ1(0)
     +     + GYZ4(1,0,1,0)
     +     + 2*GYZ4(1,1,0,0)
     +     + 20./3.*HZ1(0)
     +     + 25./9.*HZ2(0,0)
     +     )
      A11 = A11 + t * (
     +     + 4*HZ2(1,0)
     +     + 5./3.*HZ3(0,1,0)
     +     + 10./3.*HZ3(1,0,0)
     +     + HZ4(1,0,1,0)
     +     + 2*HZ4(1,1,0,0)
     +     )
      A11 = A11 + 1./2.
     +

      B11 = 0.
     +
      B11 = B11 + y**(-1)*z*zeta2 * (
     +     - 2*GYZ1(2)*HZ1(0)
     +     - 2*GYZ1(3)*HZ1(1)
     +     + 2*GYZ2(3,2)
     +     )
      B11 = B11 + y**(-1)*z * (
     +     + 1./2.
     +     - 7*GYZ1(2)*HZ1(0)
     +     - 2./3.*GYZ1(2)*HZ2(0,0)
     +     - 2*GYZ1(2)*HZ3(0,1,0)
     +     - 4*GYZ1(2)*HZ3(1,0,0)
     +     - 7*GYZ1(3)*HZ1(1)
     +     - 1./3.*GYZ1(3)*HZ2(0,1)
     +     )
      B11 = B11 + y**(-1)*z * (
     +     - 1./3.*GYZ1(3)*HZ2(1,0)
     +     - 2*GYZ1(3)*HZ3(1,0,1)
     +     - 4*GYZ1(3)*HZ3(1,1,0)
     +     - 10./3.*GYZ2(0,2)*HZ1(0)
     +     - 4*GYZ2(0,2)*HZ2(0,0)
     +     - 10./3.*GYZ2(0,3)*HZ1(1)
     +     - 2*GYZ2(0,3)*HZ2(0,1)
     +     )
      B11 = B11 + y**(-1)*z * (
     +     - 2*GYZ2(0,3)*HZ2(1,0)
     +     - 10./3.*GYZ2(2,0)*HZ1(0)
     +     - 4*GYZ2(2,0)*HZ2(0,0)
     +     - 10./3.*GYZ2(3,0)*HZ1(1)
     +     - 2*GYZ2(3,0)*HZ2(0,1)
     +     - 2*GYZ2(3,0)*HZ2(1,0)
     +     + 7*GYZ2(3,2)
     +     )
      B11 = B11 + y**(-1)*z * (
     +     + 1./3.*GYZ2(3,2)*HZ1(0)
     +     + 2*GYZ2(3,2)*HZ2(1,0)
     +     + 10./3.*GYZ3(0,3,2)
     +     + 2*GYZ3(0,3,2)*HZ1(0)
     +     + 2*GYZ3(1,0,2)*HZ1(0)
     +     + 2*GYZ3(1,0,3)*HZ1(1)
     +     + 2*GYZ3(1,2,0)*HZ1(0)
     +     )
      B11 = B11 + y**(-1)*z * (
     +     + 2*GYZ3(1,3,0)*HZ1(1)
     +     + 2*GYZ3(2,1,0)*HZ1(0)
     +     + 10./3.*GYZ3(3,0,2)
     +     + 2*GYZ3(3,0,2)*HZ1(0)
     +     + 2*GYZ3(3,1,0)*HZ1(1)
     +     + 10./3.*GYZ3(3,2,0)
     +     + 2*GYZ3(3,2,0)*HZ1(0)
     +     )
      B11 = B11 + y**(-1)*z * (
     +     - 2*GYZ4(1,0,3,2)
     +     - 2*GYZ4(1,3,0,2)
     +     - 2*GYZ4(1,3,2,0)
     +     - 2*GYZ4(3,1,0,2)
     +     - 2*GYZ4(3,1,2,0)
     +     - 2*GYZ4(3,2,1,0)
     +     )
      B11 = B11 + y**(-1)*zeta2 * (
     +     - 1
     +     + 4*GYZ1(2)*HZ1(0)
     +     + 4*GYZ1(3)*HZ1(1)
     +     - 4*GYZ2(3,2)
     +     )
      B11 = B11 + y**(-1) * (
     +     - 5./3.*GYZ1(0)
     +     - GYZ1(0)*HZ1(0)
     +     - GYZ1(0)*HZ1(1)
     +     + 3./2.*GYZ1(2)
     +     + 15*GYZ1(2)*HZ1(0)
     +     + 16./3.*GYZ1(2)*HZ2(0,0)
     +     + 4*GYZ1(2)*HZ3(0,1,0)
     +     )
      B11 = B11 + y**(-1) * (
     +     + 8*GYZ1(2)*HZ3(1,0,0)
     +     + 16*GYZ1(3)*HZ1(1)
     +     + 8./3.*GYZ1(3)*HZ2(0,1)
     +     + 8./3.*GYZ1(3)*HZ2(1,0)
     +     + 4*GYZ1(3)*HZ3(1,0,1)
     +     + 8*GYZ1(3)*HZ3(1,1,0)
     +     + GYZ2(0,2)
     +     )
      B11 = B11 + y**(-1) * (
     +     + 20./3.*GYZ2(0,2)*HZ1(0)
     +     + 8*GYZ2(0,2)*HZ2(0,0)
     +     + 20./3.*GYZ2(0,3)*HZ1(1)
     +     + 4*GYZ2(0,3)*HZ2(0,1)
     +     + 4*GYZ2(0,3)*HZ2(1,0)
     +     + GYZ2(2,0)
     +     + 20./3.*GYZ2(2,0)*HZ1(0)
     +     )
      B11 = B11 + y**(-1) * (
     +     + 8*GYZ2(2,0)*HZ2(0,0)
     +     + 20./3.*GYZ2(3,0)*HZ1(1)
     +     + 4*GYZ2(3,0)*HZ2(0,1)
     +     + 4*GYZ2(3,0)*HZ2(1,0)
     +     - 16*GYZ2(3,2)
     +     - 8./3.*GYZ2(3,2)*HZ1(0)
     +     - 4*GYZ2(3,2)*HZ2(1,0)
     +     )
      B11 = B11 + y**(-1) * (
     +     - 20./3.*GYZ3(0,3,2)
     +     - 4*GYZ3(0,3,2)*HZ1(0)
     +     - 4*GYZ3(1,0,2)*HZ1(0)
     +     - 4*GYZ3(1,0,3)*HZ1(1)
     +     - 4*GYZ3(1,2,0)*HZ1(0)
     +     - 4*GYZ3(1,3,0)*HZ1(1)
     +     - 4*GYZ3(2,1,0)*HZ1(0)
     +     )
      B11 = B11 + y**(-1) * (
     +     - 20./3.*GYZ3(3,0,2)
     +     - 4*GYZ3(3,0,2)*HZ1(0)
     +     - 4*GYZ3(3,1,0)*HZ1(1)
     +     - 20./3.*GYZ3(3,2,0)
     +     - 4*GYZ3(3,2,0)*HZ1(0)
     +     + 4*GYZ4(1,0,3,2)
     +     + 4*GYZ4(1,3,0,2)
     +     )
      B11 = B11 + y**(-1) * (
     +     + 4*GYZ4(1,3,2,0)
     +     + 4*GYZ4(3,1,0,2)
     +     + 4*GYZ4(3,1,2,0)
     +     + 4*GYZ4(3,2,1,0)
     +     - 5./3.*HZ1(0)
     +     - 3./2.*HZ1(1)
     +     + HZ2(0,1)
     +     )
      B11 = B11 + y**(-1) * (
     +     - HZ2(1,0)
     +     )
      B11 = B11 + z*(1.-y)**(-2)*zeta2 * (
     +     - GYZ1(0)
     +     )
      B11 = B11 + z*(1.-y)**(-2) * (
     +     - 7*GYZ1(0)
     +     - 5./3.*GYZ1(0)*HZ1(0)
     +     + 3./2.*GYZ1(0)*HZ1(1)
     +     - GYZ1(0)*HZ2(0,1)
     +     - GYZ1(0)*HZ2(1,0)
     +     - 13./3.*GYZ2(0,0)
     +     - 2*GYZ2(0,0)*HZ1(0)
     +     )
      B11 = B11 + z*(1.-y)**(-2) * (
     +     + 2*GYZ2(0,0)*HZ1(1)
     +     - 3./2.*GYZ2(0,2)
     +     - GYZ2(0,2)*HZ1(0)
     +     - 2*GYZ2(0,3)*HZ1(1)
     +     - 3./2.*GYZ2(2,0)
     +     - GYZ2(2,0)*HZ1(0)
     +     - 2*GYZ2(3,0)*HZ1(1)
     +     )
      B11 = B11 + z*(1.-y)**(-2) * (
     +     - 2*GYZ3(0,0,2)
     +     + 2*GYZ3(0,1,0)
     +     - 2*GYZ3(0,2,0)
     +     + 2*GYZ3(0,3,2)
     +     + 4*GYZ3(1,0,0)
     +     - 2*GYZ3(2,0,0)
     +     + 2*GYZ3(3,0,2)
     +     )
      B11 = B11 + z*(1.-y)**(-2) * (
     +     + 2*GYZ3(3,2,0)
     +     )
      B11 = B11 + z*(1.-y)**(-1)*zeta2 * (
     +     - 1
     +     - 3*GYZ1(0)
     +     )
      B11 = B11 + z*(1.-y)**(-1) * (
     +     - 7
     +     - 68./3.*GYZ1(0)
     +     - 6*GYZ1(0)*HZ1(0)
     +     + 11./2.*GYZ1(0)*HZ1(1)
     +     - 3*GYZ1(0)*HZ2(0,1)
     +     - 3*GYZ1(0)*HZ2(1,0)
     +     - 3./2.*GYZ1(2)
     +     )
      B11 = B11 + z*(1.-y)**(-1) * (
     +     - GYZ1(2)*HZ1(0)
     +     - 2*GYZ1(3)*HZ1(1)
     +     - GYZ2(0,0)
     +     - 6*GYZ2(0,0)*HZ1(0)
     +     + 6*GYZ2(0,0)*HZ1(1)
     +     - 11./2.*GYZ2(0,2)
     +     - 3*GYZ2(0,2)*HZ1(0)
     +     )
      B11 = B11 + z*(1.-y)**(-1) * (
     +     - 6*GYZ2(0,3)*HZ1(1)
     +     + 2*GYZ2(1,0)
     +     - 11./2.*GYZ2(2,0)
     +     - 3*GYZ2(2,0)*HZ1(0)
     +     - 6*GYZ2(3,0)*HZ1(1)
     +     + 2*GYZ2(3,2)
     +     - 6*GYZ3(0,0,2)
     +     )
      B11 = B11 + z*(1.-y)**(-1) * (
     +     + 6*GYZ3(0,1,0)
     +     - 6*GYZ3(0,2,0)
     +     + 6*GYZ3(0,3,2)
     +     + 12*GYZ3(1,0,0)
     +     - 6*GYZ3(2,0,0)
     +     + 6*GYZ3(3,0,2)
     +     + 6*GYZ3(3,2,0)
     +     )
      B11 = B11 + z*(1.-y)**(-1) * (
     +     - 5./3.*HZ1(0)
     +     + 3./2.*HZ1(1)
     +     - HZ2(0,1)
     +     - HZ2(1,0)
     +     )
      B11 = B11 + (1.-y)**(-2)*(y+z)**(-2) * (
     +     - GYZ1(0)*HZ1(1)
     +     + GYZ2(0,2)
     +     + GYZ2(2,0)
     +     )
      B11 = B11 + (1.-y)**(-2)*(y+z)**(-1) * (
     +     + GYZ1(0)
     +     + 2*GYZ1(0)*HZ1(1)
     +     - 2*GYZ2(0,2)
     +     - 2*GYZ2(2,0)
     +     )
      B11 = B11 + (1.-y)**(-2) * (
     +     - GYZ1(0)
     +     - GYZ1(0)*HZ1(1)
     +     + GYZ2(0,2)
     +     + GYZ2(2,0)
     +     )
      B11 = B11 + (1.-y)**(-1)*(y+z)**(-2) * (
     +     - 2*GYZ1(0)*HZ1(1)
     +     + GYZ1(2)
     +     + 2*GYZ2(0,2)
     +     + 2*GYZ2(2,0)
     +     - HZ1(1)
     +     )
      B11 = B11 + (1.-y)**(-1)*(y+z)**(-1) * (
     +     + 1
     +     + 2*GYZ1(0)
     +     + 2*GYZ1(0)*HZ1(1)
     +     - 2*GYZ1(2)
     +     - 2*GYZ2(0,2)
     +     - 2*GYZ2(2,0)
     +     + 2*HZ1(1)
     +     )
      B11 = B11 + (1.-y)**(-1)*zeta2 * (
     +     + 2*GYZ1(0)
     +     )
      B11 = B11 + (1.-y)**(-1) * (
     +     - 1
     +     + 22*GYZ1(0)
     +     + 10./3.*GYZ1(0)*HZ1(0)
     +     - 6*GYZ1(0)*HZ1(1)
     +     + 2*GYZ1(0)*HZ2(0,1)
     +     + 2*GYZ1(0)*HZ2(1,0)
     +     + GYZ1(2)
     +     )
      B11 = B11 + (1.-y)**(-1) * (
     +     + 14./3.*GYZ2(0,0)
     +     + 4*GYZ2(0,0)*HZ1(0)
     +     - 4*GYZ2(0,0)*HZ1(1)
     +     + 6*GYZ2(0,2)
     +     + 4*GYZ2(0,2)*HZ1(0)
     +     + 6*GYZ2(0,3)*HZ1(1)
     +     + 6*GYZ2(2,0)
     +     )
      B11 = B11 + (1.-y)**(-1) * (
     +     + 4*GYZ2(2,0)*HZ1(0)
     +     + 6*GYZ2(3,0)*HZ1(1)
     +     + 4*GYZ3(0,0,2)
     +     - 4*GYZ3(0,1,0)
     +     + 4*GYZ3(0,2,0)
     +     - 6*GYZ3(0,3,2)
     +     - 8*GYZ3(1,0,0)
     +     )
      B11 = B11 + (1.-y)**(-1) * (
     +     + 4*GYZ3(2,0,0)
     +     - 6*GYZ3(3,0,2)
     +     - 6*GYZ3(3,2,0)
     +     - HZ1(1)
     +     )
      B11 = B11 + (y+z)**(-2)*zeta2 * (
     +     + 2*GYZ1(2)
     +     - 2*HZ1(1)
     +     )
      B11 = B11 + (y+z)**(-2) * (
     +     - 11./6.*GYZ1(0)*HZ1(1)
     +     - 2*GYZ1(0)*HZ2(0,1)
     +     - 2*GYZ1(0)*HZ2(1,0)
     +     + 7*GYZ1(2)
     +     + 11./6.*GYZ1(2)*HZ1(0)
     +     + 2*GYZ1(2)*HZ2(1,0)
     +     + 11./6.*GYZ2(0,2)
     +     )
      B11 = B11 + (y+z)**(-2) * (
     +     + 2*GYZ2(0,2)*HZ1(0)
     +     + 2*GYZ2(1,0)*HZ1(1)
     +     + 11./6.*GYZ2(2,0)
     +     + 2*GYZ2(2,0)*HZ1(0)
     +     - 2*GYZ3(1,0,2)
     +     - 2*GYZ3(1,2,0)
     +     - 2*GYZ3(2,1,0)
     +     )
      B11 = B11 + (y+z)**(-2) * (
     +     - 7*HZ1(1)
     +     - 11./6.*HZ2(0,1)
     +     - 11./6.*HZ2(1,0)
     +     - 2*HZ3(1,0,1)
     +     - 4*HZ3(1,1,0)
     +     )
      B11 = B11 + (y+z)**(-1)*zeta2 * (
     +     + 2
     +     )
      B11 = B11 + (y+z)**(-1) * (
     +     + 7
     +     + 11./6.*GYZ1(0)
     +     + 2*GYZ1(0)*HZ1(0)
     +     - 2*GYZ2(1,0)
     +     + 11./6.*HZ1(0)
     +     + 2*HZ2(1,0)
     +     )
      B11 = B11 + t*zeta2 * (
     +     - 4
     +     + GYZ1(0)*HZ1(1)
     +     - 3./2.*GYZ1(2)
     +     - GYZ1(2)*HZ1(0)
     +     - 2*GYZ1(3)*HZ1(1)
     +     - GYZ2(0,2)
     +     + GYZ2(1,0)
     +     )
      B11 = B11 + t*zeta2 * (
     +     - GYZ2(2,0)
     +     + 2*GYZ2(3,2)
     +     + 3./2.*HZ1(1)
     +     - HZ2(0,1)
     +     )
      B11 = B11 + t * (
     +     - 16
     +     - 20./3.*GYZ1(0)
     +     - 4*GYZ1(0)*HZ1(0)
     +     + 13./2.*GYZ1(0)*HZ1(1)
     +     + 3./2.*GYZ1(0)*HZ2(0,1)
     +     + 19./6.*GYZ1(0)*HZ2(1,0)
     +     - 2*GYZ1(0)*HZ3(0,0,1)
     +     )
      B11 = B11 + t * (
     +     - GYZ1(0)*HZ3(0,1,0)
     +     + GYZ1(0)*HZ3(1,0,1)
     +     + 2*GYZ1(0)*HZ3(1,1,0)
     +     - 6*GYZ1(2)
     +     - 13./2.*GYZ1(2)*HZ1(0)
     +     - 10./3.*GYZ1(2)*HZ2(0,0)
     +     - 3./2.*GYZ1(2)*HZ2(1,0)
     +     )
      B11 = B11 + t * (
     +     - GYZ1(2)*HZ3(0,1,0)
     +     - 2*GYZ1(2)*HZ3(1,0,0)
     +     - 8*GYZ1(3)*HZ1(1)
     +     - 10./3.*GYZ1(3)*HZ2(0,1)
     +     - 10./3.*GYZ1(3)*HZ2(1,0)
     +     - 2*GYZ1(3)*HZ3(1,0,1)
     +     - 4*GYZ1(3)*HZ3(1,1,0)
     +     )
      B11 = B11 + t * (
     +     + 10./3.*GYZ2(0,0)*HZ1(1)
     +     + 2*GYZ2(0,0)*HZ2(0,1)
     +     + 2*GYZ2(0,0)*HZ2(1,0)
     +     - 13./2.*GYZ2(0,2)
     +     - 29./6.*GYZ2(0,2)*HZ1(0)
     +     - 2*GYZ2(0,2)*HZ2(0,0)
     +     - GYZ2(0,2)*HZ2(1,0)
     +     )
      B11 = B11 + t * (
     +     - 10./3.*GYZ2(0,3)*HZ1(1)
     +     - 2*GYZ2(0,3)*HZ2(0,1)
     +     - 2*GYZ2(0,3)*HZ2(1,0)
     +     + 8*GYZ2(1,0)
     +     + 5./3.*GYZ2(1,0)*HZ1(0)
     +     - 3./2.*GYZ2(1,0)*HZ1(1)
     +     + GYZ2(1,0)*HZ2(0,1)
     +     )
      B11 = B11 + t * (
     +     + GYZ2(1,0)*HZ2(1,0)
     +     - 13./2.*GYZ2(2,0)
     +     - 29./6.*GYZ2(2,0)*HZ1(0)
     +     - 2*GYZ2(2,0)*HZ2(0,0)
     +     - GYZ2(2,0)*HZ2(1,0)
     +     - 10./3.*GYZ2(3,0)*HZ1(1)
     +     - 2*GYZ2(3,0)*HZ2(0,1)
     +     )
      B11 = B11 + t * (
     +     - 2*GYZ2(3,0)*HZ2(1,0)
     +     + 8*GYZ2(3,2)
     +     + 10./3.*GYZ2(3,2)*HZ1(0)
     +     + 2*GYZ2(3,2)*HZ2(1,0)
     +     - 10./3.*GYZ3(0,0,2)
     +     - 2*GYZ3(0,0,2)*HZ1(0)
     +     + 5./3.*GYZ3(0,1,0)
     +     )
      B11 = B11 + t * (
     +     + GYZ3(0,1,0)*HZ1(0)
     +     - GYZ3(0,1,0)*HZ1(1)
     +     - 10./3.*GYZ3(0,2,0)
     +     - 2*GYZ3(0,2,0)*HZ1(0)
     +     + 10./3.*GYZ3(0,3,2)
     +     + 2*GYZ3(0,3,2)*HZ1(0)
     +     + 10./3.*GYZ3(1,0,0)
     +     )
      B11 = B11 + t * (
     +     + 2*GYZ3(1,0,0)*HZ1(0)
     +     - 2*GYZ3(1,0,0)*HZ1(1)
     +     + 3./2.*GYZ3(1,0,2)
     +     + GYZ3(1,0,2)*HZ1(0)
     +     + 2*GYZ3(1,0,3)*HZ1(1)
     +     + 3./2.*GYZ3(1,2,0)
     +     + GYZ3(1,2,0)*HZ1(0)
     +     )
      B11 = B11 + t * (
     +     + 2*GYZ3(1,3,0)*HZ1(1)
     +     - 10./3.*GYZ3(2,0,0)
     +     - 2*GYZ3(2,0,0)*HZ1(0)
     +     + 3./2.*GYZ3(2,1,0)
     +     + GYZ3(2,1,0)*HZ1(0)
     +     + 10./3.*GYZ3(3,0,2)
     +     + 2*GYZ3(3,0,2)*HZ1(0)
     +     )
      B11 = B11 + t * (
     +     + 2*GYZ3(3,1,0)*HZ1(1)
     +     + 10./3.*GYZ3(3,2,0)
     +     + 2*GYZ3(3,2,0)*HZ1(0)
     +     + GYZ4(0,1,0,2)
     +     + GYZ4(0,1,2,0)
     +     + GYZ4(0,2,1,0)
     +     + 2*GYZ4(1,0,0,2)
     +     )
      B11 = B11 + t * (
     +     - 2*GYZ4(1,0,1,0)
     +     + 2*GYZ4(1,0,2,0)
     +     - 2*GYZ4(1,0,3,2)
     +     - 4*GYZ4(1,1,0,0)
     +     + 2*GYZ4(1,2,0,0)
     +     - 2*GYZ4(1,3,0,2)
     +     - 2*GYZ4(1,3,2,0)
     +     )
      B11 = B11 + t * (
     +     + GYZ4(2,0,1,0)
     +     + 2*GYZ4(2,1,0,0)
     +     - 2*GYZ4(3,1,0,2)
     +     - 2*GYZ4(3,1,2,0)
     +     - 2*GYZ4(3,2,1,0)
     +     - 20./3.*HZ1(0)
     +     + 6*HZ1(1)
     +     )
      B11 = B11 + t * (
     +     - 3./2.*HZ2(0,1)
     +     - 3./2.*HZ2(1,0)
     +     - 10./3.*HZ3(0,0,1)
     +     - 5./3.*HZ3(0,1,0)
     +     + 3./2.*HZ3(1,0,1)
     +     + 3*HZ3(1,1,0)
     +     - HZ4(0,1,0,1)
     +     )
      B11 = B11 + t * (
     +     - 2*HZ4(0,1,1,0)
     +     - 2*HZ4(1,0,0,1)
     +     - HZ4(1,0,1,0)
     +     )
      B11 = B11 + zeta2 * (
     +     + GYZ1(0)
     +     + 2*GYZ1(0)*HZ1(1)
     +     - 2*GYZ1(2)
     +     - 2*GYZ1(2)*HZ1(0)
     +     - 4*GYZ1(3)*HZ1(1)
     +     - 2*GYZ2(0,2)
     +     + 2*GYZ2(1,0)
     +     )
      B11 = B11 + zeta2 * (
     +     - 2*GYZ2(2,0)
     +     + 4*GYZ2(3,2)
     +     + HZ1(0)
     +     + 2*HZ1(1)
     +     - 2*HZ2(0,1)
     +     )
      B11 = B11 + 7./2.*GYZ1(0)
     +     + 10./3.*GYZ1(0)*HZ1(0)
     +     + 53./6.*GYZ1(0)*HZ1(1)
     +     + 2*GYZ1(0)*HZ2(0,0)
     +     + 5*GYZ1(0)*HZ2(0,1)
     +     + 19./3.*GYZ1(0)*HZ2(1,0)
     +     - 4*GYZ1(0)*HZ3(0,0,1)
     +     - 2*GYZ1(0)*HZ3(0,1,0)
     +
      B11 = B11 + 2*GYZ1(0)*HZ3(1,0,1)
     +     + 4*GYZ1(0)*HZ3(1,1,0)
     +     - 7*GYZ1(2)
     +     - 53./6.*GYZ1(2)*HZ1(0)
     +     - 2./3.*GYZ1(2)*HZ2(0,0)
     +     - 2*GYZ1(2)*HZ2(1,0)
     +     - 2*GYZ1(2)*HZ3(0,1,0)
     +     - 4*GYZ1(2)*HZ3(1,0,0)
     +
      B11 = B11 - 14*GYZ1(3)*HZ1(1)
     +     - 11./3.*GYZ1(3)*HZ2(0,1)
     +     - 11./3.*GYZ1(3)*HZ2(1,0)
     +     - 4*GYZ1(3)*HZ3(1,0,1)
     +     - 8*GYZ1(3)*HZ3(1,1,0)
     +     + 1./3.*GYZ2(0,0)
     +     + 2*GYZ2(0,0)*HZ1(0)
     +     + 2./3.*GYZ2(0,0)*HZ1(1)
     +
      B11 = B11 + 4*GYZ2(0,0)*HZ2(0,1)
     +     + 4*GYZ2(0,0)*HZ2(1,0)
     +     - 53./6.*GYZ2(0,2)
     +     - 26./3.*GYZ2(0,2)*HZ1(0)
     +     - 4*GYZ2(0,2)*HZ2(0,0)
     +     - 2*GYZ2(0,2)*HZ2(1,0)
     +     - 11./3.*GYZ2(0,3)*HZ1(1)
     +     - 4*GYZ2(0,3)*HZ2(0,1)
     +
      B11 = B11 - 4*GYZ2(0,3)*HZ2(1,0)
     +     + 7*GYZ2(1,0)
     +     + 7./3.*GYZ2(1,0)*HZ1(0)
     +     - 2*GYZ2(1,0)*HZ1(1)
     +     + 2*GYZ2(1,0)*HZ2(0,1)
     +     + 2*GYZ2(1,0)*HZ2(1,0)
     +     - 53./6.*GYZ2(2,0)
     +     - 26./3.*GYZ2(2,0)*HZ1(0)
     +
      B11 = B11 - 4*GYZ2(2,0)*HZ2(0,0)
     +     - 2*GYZ2(2,0)*HZ2(1,0)
     +     - 11./3.*GYZ2(3,0)*HZ1(1)
     +     - 4*GYZ2(3,0)*HZ2(0,1)
     +     - 4*GYZ2(3,0)*HZ2(1,0)
     +     + 14*GYZ2(3,2)
     +     + 11./3.*GYZ2(3,2)*HZ1(0)
     +     + 4*GYZ2(3,2)*HZ2(1,0)
     +
      B11 = B11 - 2./3.*GYZ3(0,0,2)
     +     - 4*GYZ3(0,0,2)*HZ1(0)
     +     - 2./3.*GYZ3(0,1,0)
     +     + 2*GYZ3(0,1,0)*HZ1(0)
     +     - 2*GYZ3(0,1,0)*HZ1(1)
     +     - 2./3.*GYZ3(0,2,0)
     +     - 4*GYZ3(0,2,0)*HZ1(0)
     +     + 11./3.*GYZ3(0,3,2)
     +
      B11 = B11 + 4*GYZ3(0,3,2)*HZ1(0)
     +     - 4./3.*GYZ3(1,0,0)
     +     + 4*GYZ3(1,0,0)*HZ1(0)
     +     - 4*GYZ3(1,0,0)*HZ1(1)
     +     + 2*GYZ3(1,0,2)
     +     + 2*GYZ3(1,0,2)*HZ1(0)
     +     + 4*GYZ3(1,0,3)*HZ1(1)
     +     + 2*GYZ3(1,2,0)
     +
      B11 = B11 + 2*GYZ3(1,2,0)*HZ1(0)
     +     + 4*GYZ3(1,3,0)*HZ1(1)
     +     - 2./3.*GYZ3(2,0,0)
     +     - 4*GYZ3(2,0,0)*HZ1(0)
     +     + 2*GYZ3(2,1,0)
     +     + 2*GYZ3(2,1,0)*HZ1(0)
     +     + 11./3.*GYZ3(3,0,2)
     +     + 4*GYZ3(3,0,2)*HZ1(0)
     +
      B11 = B11 + 4*GYZ3(3,1,0)*HZ1(1)
     +     + 11./3.*GYZ3(3,2,0)
     +     + 4*GYZ3(3,2,0)*HZ1(0)
     +     + 2*GYZ4(0,1,0,2)
     +     + 2*GYZ4(0,1,2,0)
     +     + 2*GYZ4(0,2,1,0)
     +     + 4*GYZ4(1,0,0,2)
     +     - 4*GYZ4(1,0,1,0)
     +
      B11 = B11 + 4*GYZ4(1,0,2,0)
     +     - 4*GYZ4(1,0,3,2)
     +     - 8*GYZ4(1,1,0,0)
     +     + 4*GYZ4(1,2,0,0)
     +     - 4*GYZ4(1,3,0,2)
     +     - 4*GYZ4(1,3,2,0)
     +     + 2*GYZ4(2,0,1,0)
     +     + 4*GYZ4(2,1,0,0)
     +
      B11 = B11 - 4*GYZ4(3,1,0,2)
     +     - 4*GYZ4(3,1,2,0)
     +     - 4*GYZ4(3,2,1,0)
     +     + 7./2.*HZ1(0)
     +     + 7*HZ1(1)
     +     + 1./3.*HZ2(0,0)
     +     - 31./6.*HZ2(0,1)
     +     + 11./6.*HZ2(1,0)
     +
      B11 = B11 - 20./3.*HZ3(0,0,1)
     +     - 7./3.*HZ3(0,1,0)
     +     + 2*HZ3(1,0,0)
     +     + 2*HZ3(1,0,1)
     +     + 4*HZ3(1,1,0)
     +     - 2*HZ4(0,1,0,1)
     +     - 4*HZ4(0,1,1,0)
     +     - 4*HZ4(1,0,0,1)
     +
      B11 = B11 - 2*HZ4(1,0,1,0)
     +

      C11 = 0.
     +
      C11 = C11 + y**(-3)*z * (
     +     + 4*GYZ2(2,2)*HZ2(0,0)
     +     + 2*GYZ2(2,3)*HZ2(0,1)
     +     + 2*GYZ2(2,3)*HZ2(1,0)
     +     + 2*GYZ2(3,2)*HZ2(0,1)
     +     + 2*GYZ2(3,2)*HZ2(1,0)
     +     + 4*GYZ2(3,3)*HZ2(1,1)
     +     - 2*GYZ3(2,3,2)*HZ1(0)
     +     )
      C11 = C11 + y**(-3)*z * (
     +     - 4*GYZ3(3,2,2)*HZ1(0)
     +     - 2*GYZ3(3,2,3)*HZ1(1)
     +     - 4*GYZ3(3,3,2)*HZ1(1)
     +     + 2*GYZ4(3,2,3,2)
     +     + 4*GYZ4(3,3,2,2)
     +     )
      C11 = C11 + y**(-3)*z**2 * (
     +     - 8*GYZ2(2,2)*HZ2(0,0)
     +     - 4*GYZ2(2,3)*HZ2(0,1)
     +     - 4*GYZ2(2,3)*HZ2(1,0)
     +     - 4*GYZ2(3,2)*HZ2(0,1)
     +     - 4*GYZ2(3,2)*HZ2(1,0)
     +     - 8*GYZ2(3,3)*HZ2(1,1)
     +     + 4*GYZ3(2,3,2)*HZ1(0)
     +     )
      C11 = C11 + y**(-3)*z**2 * (
     +     + 8*GYZ3(3,2,2)*HZ1(0)
     +     + 4*GYZ3(3,2,3)*HZ1(1)
     +     + 8*GYZ3(3,3,2)*HZ1(1)
     +     - 4*GYZ4(3,2,3,2)
     +     - 8*GYZ4(3,3,2,2)
     +     )
      C11 = C11 + y**(-3)*z**3 * (
     +     + 4*GYZ2(2,2)*HZ2(0,0)
     +     + 2*GYZ2(2,3)*HZ2(0,1)
     +     + 2*GYZ2(2,3)*HZ2(1,0)
     +     + 2*GYZ2(3,2)*HZ2(0,1)
     +     + 2*GYZ2(3,2)*HZ2(1,0)
     +     + 4*GYZ2(3,3)*HZ2(1,1)
     +     - 2*GYZ3(2,3,2)*HZ1(0)
     +     )
      C11 = C11 + y**(-3)*z**3 * (
     +     - 4*GYZ3(3,2,2)*HZ1(0)
     +     - 2*GYZ3(3,2,3)*HZ1(1)
     +     - 4*GYZ3(3,3,2)*HZ1(1)
     +     + 2*GYZ4(3,2,3,2)
     +     + 4*GYZ4(3,3,2,2)
     +     )
      C11 = C11 + y**(-2)*z * (
     +     + 4*GYZ1(2)*HZ2(0,0)
     +     + 4*GYZ1(2)*HZ2(0,1)
     +     + 4*GYZ1(2)*HZ2(1,0)
     +     + 2*GYZ1(3)*HZ2(0,1)
     +     + 2*GYZ1(3)*HZ2(1,0)
     +     + 8*GYZ1(3)*HZ2(1,1)
     +     - 8*GYZ2(2,2)*HZ1(0)
     +     )
      C11 = C11 + y**(-2)*z * (
     +     - 24*GYZ2(2,2)*HZ2(0,0)
     +     - 4*GYZ2(2,3)*HZ1(1)
     +     - 12*GYZ2(2,3)*HZ2(0,1)
     +     - 12*GYZ2(2,3)*HZ2(1,0)
     +     - 2*GYZ2(3,2)*HZ1(0)
     +     - 8*GYZ2(3,2)*HZ1(1)
     +     - 12*GYZ2(3,2)*HZ2(0,1)
     +     )
      C11 = C11 + y**(-2)*z * (
     +     - 12*GYZ2(3,2)*HZ2(1,0)
     +     - 24*GYZ2(3,3)*HZ2(1,1)
     +     + 4*GYZ3(2,3,2)
     +     + 12*GYZ3(2,3,2)*HZ1(0)
     +     + 8*GYZ3(3,2,2)
     +     + 24*GYZ3(3,2,2)*HZ1(0)
     +     + 12*GYZ3(3,2,3)*HZ1(1)
     +     )
      C11 = C11 + y**(-2)*z * (
     +     + 24*GYZ3(3,3,2)*HZ1(1)
     +     - 12*GYZ4(3,2,3,2)
     +     - 24*GYZ4(3,3,2,2)
     +     )
      C11 = C11 + y**(-2)*z**2 * (
     +     - 4*GYZ1(2)*HZ2(0,0)
     +     - 2*GYZ1(2)*HZ2(0,1)
     +     - 2*GYZ1(2)*HZ2(1,0)
     +     - 2*GYZ1(3)*HZ2(0,1)
     +     - 2*GYZ1(3)*HZ2(1,0)
     +     - 4*GYZ1(3)*HZ2(1,1)
     +     + 4*GYZ2(2,2)*HZ1(0)
     +     )
      C11 = C11 + y**(-2)*z**2 * (
     +     + 16*GYZ2(2,2)*HZ2(0,0)
     +     + 2*GYZ2(2,3)*HZ1(1)
     +     + 8*GYZ2(2,3)*HZ2(0,1)
     +     + 8*GYZ2(2,3)*HZ2(1,0)
     +     + 2*GYZ2(3,2)*HZ1(0)
     +     + 4*GYZ2(3,2)*HZ1(1)
     +     + 8*GYZ2(3,2)*HZ2(0,1)
     +     )
      C11 = C11 + y**(-2)*z**2 * (
     +     + 8*GYZ2(3,2)*HZ2(1,0)
     +     + 16*GYZ2(3,3)*HZ2(1,1)
     +     - 2*GYZ3(2,3,2)
     +     - 8*GYZ3(2,3,2)*HZ1(0)
     +     - 4*GYZ3(3,2,2)
     +     - 16*GYZ3(3,2,2)*HZ1(0)
     +     - 8*GYZ3(3,2,3)*HZ1(1)
     +     )
      C11 = C11 + y**(-2)*z**2 * (
     +     - 16*GYZ3(3,3,2)*HZ1(1)
     +     + 8*GYZ4(3,2,3,2)
     +     + 16*GYZ4(3,3,2,2)
     +     )
      C11 = C11 + y**(-2) * (
     +     - 2*GYZ1(2)*HZ2(0,1)
     +     - 2*GYZ1(2)*HZ2(1,0)
     +     - 4*GYZ1(3)*HZ2(1,1)
     +     + 4*GYZ2(2,2)*HZ1(0)
     +     + 8*GYZ2(2,2)*HZ2(0,0)
     +     + 2*GYZ2(2,3)*HZ1(1)
     +     + 4*GYZ2(2,3)*HZ2(0,1)
     +     )
      C11 = C11 + y**(-2) * (
     +     + 4*GYZ2(2,3)*HZ2(1,0)
     +     + 4*GYZ2(3,2)*HZ1(1)
     +     + 4*GYZ2(3,2)*HZ2(0,1)
     +     + 4*GYZ2(3,2)*HZ2(1,0)
     +     + 8*GYZ2(3,3)*HZ2(1,1)
     +     - 2*GYZ3(2,3,2)
     +     - 4*GYZ3(2,3,2)*HZ1(0)
     +     )
      C11 = C11 + y**(-2) * (
     +     - 4*GYZ3(3,2,2)
     +     - 8*GYZ3(3,2,2)*HZ1(0)
     +     - 4*GYZ3(3,2,3)*HZ1(1)
     +     - 8*GYZ3(3,3,2)*HZ1(1)
     +     + 4*GYZ4(3,2,3,2)
     +     + 8*GYZ4(3,3,2,2)
     +     )
      C11 = C11 + y**(-1)*z * (
     +     + 1./4.
     +     + 5*GYZ1(2)*HZ1(0)
     +     - GYZ1(2)*HZ1(1)
     +     - 14*GYZ1(2)*HZ2(0,0)
     +     - 7*GYZ1(2)*HZ2(0,1)
     +     - 7*GYZ1(2)*HZ2(1,0)
     +     + 4*GYZ1(2)*HZ3(0,0,1)
     +     )
      C11 = C11 + y**(-1)*z * (
     +     + 2*GYZ1(2)*HZ3(0,1,0)
     +     + 7*GYZ1(3)*HZ1(1)
     +     - 7*GYZ1(3)*HZ2(0,1)
     +     - 7*GYZ1(3)*HZ2(1,0)
     +     - 14*GYZ1(3)*HZ2(1,1)
     +     + 4*GYZ1(3)*HZ3(0,1,1)
     +     + 2*GYZ1(3)*HZ3(1,0,1)
     +     )
      C11 = C11 + y**(-1)*z * (
     +     - 2*GYZ2(0,2)*HZ2(0,1)
     +     - 2*GYZ2(0,2)*HZ2(1,0)
     +     - 4*GYZ2(0,3)*HZ2(1,1)
     +     - 2*GYZ2(2,0)*HZ2(0,1)
     +     - 2*GYZ2(2,0)*HZ2(1,0)
     +     + GYZ2(2,2)
     +     + 14*GYZ2(2,2)*HZ1(0)
     +     )
      C11 = C11 + y**(-1)*z * (
     +     + 24*GYZ2(2,2)*HZ2(0,0)
     +     + 7*GYZ2(2,3)*HZ1(1)
     +     + 14*GYZ2(2,3)*HZ2(0,1)
     +     + 14*GYZ2(2,3)*HZ2(1,0)
     +     - 4*GYZ2(3,0)*HZ2(1,1)
     +     - 7*GYZ2(3,2)
     +     + 7*GYZ2(3,2)*HZ1(0)
     +     )
      C11 = C11 + y**(-1)*z * (
     +     + 14*GYZ2(3,2)*HZ1(1)
     +     + 12*GYZ2(3,2)*HZ2(0,1)
     +     + 14*GYZ2(3,2)*HZ2(1,0)
     +     + 32*GYZ2(3,3)*HZ2(1,1)
     +     + 4*GYZ3(0,2,2)*HZ1(0)
     +     + 2*GYZ3(0,2,3)*HZ1(1)
     +     + 4*GYZ3(0,3,2)*HZ1(1)
     +     )
      C11 = C11 + y**(-1)*z * (
     +     - 2*GYZ3(1,0,2)*HZ1(0)
     +     - 2*GYZ3(1,0,3)*HZ1(1)
     +     - 2*GYZ3(1,2,0)*HZ1(0)
     +     - 2*GYZ3(1,3,0)*HZ1(1)
     +     + 4*GYZ3(2,0,2)*HZ1(0)
     +     + 2*GYZ3(2,0,3)*HZ1(1)
     +     - 2*GYZ3(2,1,0)*HZ1(0)
     +     )
      C11 = C11 + y**(-1)*z * (
     +     + 4*GYZ3(2,2,0)*HZ1(0)
     +     + 2*GYZ3(2,3,0)*HZ1(1)
     +     - 7*GYZ3(2,3,2)
     +     - 14*GYZ3(2,3,2)*HZ1(0)
     +     + 4*GYZ3(3,0,2)*HZ1(1)
     +     - 2*GYZ3(3,1,0)*HZ1(1)
     +     + 4*GYZ3(3,2,0)*HZ1(1)
     +     )
      C11 = C11 + y**(-1)*z * (
     +     - 14*GYZ3(3,2,2)
     +     - 28*GYZ3(3,2,2)*HZ1(0)
     +     - 16*GYZ3(3,2,3)*HZ1(1)
     +     - 32*GYZ3(3,3,2)*HZ1(1)
     +     - 2*GYZ4(0,2,3,2)
     +     - 4*GYZ4(0,3,2,2)
     +     + 2*GYZ4(1,0,3,2)
     +     )
      C11 = C11 + y**(-1)*z * (
     +     + 2*GYZ4(1,3,0,2)
     +     + 2*GYZ4(1,3,2,0)
     +     - 2*GYZ4(2,0,3,2)
     +     - 2*GYZ4(2,3,0,2)
     +     - 2*GYZ4(2,3,2,0)
     +     - 4*GYZ4(3,0,2,2)
     +     + 2*GYZ4(3,1,0,2)
     +     )
      C11 = C11 + y**(-1)*z * (
     +     + 2*GYZ4(3,1,2,0)
     +     - 4*GYZ4(3,2,0,2)
     +     + 2*GYZ4(3,2,1,0)
     +     - 4*GYZ4(3,2,2,0)
     +     + 16*GYZ4(3,2,3,2)
     +     + 32*GYZ4(3,3,2,2)
     +     + 2*HZ2(0,0)
     +     )
      C11 = C11 + y**(-1)*z * (
     +     + 2*HZ2(0,1)
     +     + 2*HZ2(1,0)
     +     + HZ2(1,1)
     +     )
      C11 = C11 + y**(-1) * (
     +     + 4
     +     - GYZ1(0)*HZ1(1)
     +     + 3./2.*GYZ1(2)
     +     - 13*GYZ1(2)*HZ1(0)
     +     + 2*GYZ1(2)*HZ1(1)
     +     + 8*GYZ1(2)*HZ2(0,0)
     +     + 10*GYZ1(2)*HZ2(0,1)
     +     )
      C11 = C11 + y**(-1) * (
     +     + 10*GYZ1(2)*HZ2(1,0)
     +     - 8*GYZ1(2)*HZ3(0,0,1)
     +     - 4*GYZ1(2)*HZ3(0,1,0)
     +     - 14*GYZ1(3)*HZ1(1)
     +     + 4*GYZ1(3)*HZ2(0,1)
     +     + 4*GYZ1(3)*HZ2(1,0)
     +     + 20*GYZ1(3)*HZ2(1,1)
     +     )
      C11 = C11 + y**(-1) * (
     +     - 8*GYZ1(3)*HZ3(0,1,1)
     +     - 4*GYZ1(3)*HZ3(1,0,1)
     +     + GYZ2(0,2)
     +     + 4*GYZ2(0,2)*HZ2(0,1)
     +     + 4*GYZ2(0,2)*HZ2(1,0)
     +     + 8*GYZ2(0,3)*HZ2(1,1)
     +     - GYZ2(1,0)
     +     )
      C11 = C11 + y**(-1) * (
     +     + GYZ2(2,0)
     +     + 4*GYZ2(2,0)*HZ2(0,1)
     +     + 4*GYZ2(2,0)*HZ2(1,0)
     +     - 2*GYZ2(2,2)
     +     - 20*GYZ2(2,2)*HZ1(0)
     +     - 24*GYZ2(2,2)*HZ2(0,0)
     +     - 10*GYZ2(2,3)*HZ1(1)
     +     )
      C11 = C11 + y**(-1) * (
     +     - 16*GYZ2(2,3)*HZ2(0,1)
     +     - 16*GYZ2(2,3)*HZ2(1,0)
     +     + 8*GYZ2(3,0)*HZ2(1,1)
     +     + 14*GYZ2(3,2)
     +     - 4*GYZ2(3,2)*HZ1(0)
     +     - 20*GYZ2(3,2)*HZ1(1)
     +     - 12*GYZ2(3,2)*HZ2(0,1)
     +     )
      C11 = C11 + y**(-1) * (
     +     - 16*GYZ2(3,2)*HZ2(1,0)
     +     - 40*GYZ2(3,3)*HZ2(1,1)
     +     - 8*GYZ3(0,2,2)*HZ1(0)
     +     - 4*GYZ3(0,2,3)*HZ1(1)
     +     - 8*GYZ3(0,3,2)*HZ1(1)
     +     + 4*GYZ3(1,0,2)*HZ1(0)
     +     + 4*GYZ3(1,0,3)*HZ1(1)
     +     )
      C11 = C11 + y**(-1) * (
     +     + 4*GYZ3(1,2,0)*HZ1(0)
     +     + 4*GYZ3(1,3,0)*HZ1(1)
     +     - 8*GYZ3(2,0,2)*HZ1(0)
     +     - 4*GYZ3(2,0,3)*HZ1(1)
     +     + 4*GYZ3(2,1,0)*HZ1(0)
     +     - 8*GYZ3(2,2,0)*HZ1(0)
     +     - 4*GYZ3(2,3,0)*HZ1(1)
     +     )
      C11 = C11 + y**(-1) * (
     +     + 10*GYZ3(2,3,2)
     +     + 16*GYZ3(2,3,2)*HZ1(0)
     +     - 8*GYZ3(3,0,2)*HZ1(1)
     +     + 4*GYZ3(3,1,0)*HZ1(1)
     +     - 8*GYZ3(3,2,0)*HZ1(1)
     +     + 20*GYZ3(3,2,2)
     +     + 32*GYZ3(3,2,2)*HZ1(0)
     +     )
      C11 = C11 + y**(-1) * (
     +     + 20*GYZ3(3,2,3)*HZ1(1)
     +     + 40*GYZ3(3,3,2)*HZ1(1)
     +     + 4*GYZ4(0,2,3,2)
     +     + 8*GYZ4(0,3,2,2)
     +     - 4*GYZ4(1,0,3,2)
     +     - 4*GYZ4(1,3,0,2)
     +     - 4*GYZ4(1,3,2,0)
     +     )
      C11 = C11 + y**(-1) * (
     +     + 4*GYZ4(2,0,3,2)
     +     + 4*GYZ4(2,3,0,2)
     +     + 4*GYZ4(2,3,2,0)
     +     + 8*GYZ4(3,0,2,2)
     +     - 4*GYZ4(3,1,0,2)
     +     - 4*GYZ4(3,1,2,0)
     +     + 8*GYZ4(3,2,0,2)
     +     )
      C11 = C11 + y**(-1) * (
     +     - 4*GYZ4(3,2,1,0)
     +     + 8*GYZ4(3,2,2,0)
     +     - 20*GYZ4(3,2,3,2)
     +     - 40*GYZ4(3,3,2,2)
     +     - 3./2.*HZ1(1)
     +     - HZ2(0,1)
     +     - 2*HZ2(1,0)
     +     )
      C11 = C11 + y**(-1) * (
     +     - 2*HZ2(1,1)
     +     )
      C11 = C11 + z*(1.-y)**(-2) * (
     +     + 7./2.*GYZ1(0)
     +     - 3./2.*GYZ1(0)*HZ1(1)
     +     + GYZ1(0)*HZ2(0,1)
     +     + 1./2.*GYZ2(0,0)
     +     - 2*GYZ2(0,0)*HZ1(1)
     +     + 3./2.*GYZ2(0,2)
     +     + GYZ2(0,2)*HZ1(0)
     +     )
      C11 = C11 + z*(1.-y)**(-2) * (
     +     + 2*GYZ2(0,3)*HZ1(1)
     +     + 3./2.*GYZ2(2,0)
     +     + GYZ2(2,0)*HZ1(0)
     +     + 2*GYZ2(3,0)*HZ1(1)
     +     + 2*GYZ3(0,0,2)
     +     - GYZ3(0,1,0)
     +     + 2*GYZ3(0,2,0)
     +     )
      C11 = C11 + z*(1.-y)**(-2) * (
     +     - 2*GYZ3(0,3,2)
     +     - 2*GYZ3(1,0,0)
     +     + 2*GYZ3(2,0,0)
     +     - 2*GYZ3(3,0,2)
     +     - 2*GYZ3(3,2,0)
     +     )
      C11 = C11 + z*(1.-y)**(-1) * (
     +     + 7./2.
     +     + 21./2.*GYZ1(0)
     +     - 11./2.*GYZ1(0)*HZ1(1)
     +     + 3*GYZ1(0)*HZ2(0,1)
     +     + 3./2.*GYZ1(2)
     +     + GYZ1(2)*HZ1(0)
     +     + 2*GYZ1(3)*HZ1(1)
     +     )
      C11 = C11 + z*(1.-y)**(-1) * (
     +     - 9./2.*GYZ2(0,0)
     +     - 6*GYZ2(0,0)*HZ1(1)
     +     + 11./2.*GYZ2(0,2)
     +     + 3*GYZ2(0,2)*HZ1(0)
     +     + 6*GYZ2(0,3)*HZ1(1)
     +     - GYZ2(1,0)
     +     + 11./2.*GYZ2(2,0)
     +     )
      C11 = C11 + z*(1.-y)**(-1) * (
     +     + 3*GYZ2(2,0)*HZ1(0)
     +     + 6*GYZ2(3,0)*HZ1(1)
     +     - 2*GYZ2(3,2)
     +     + 6*GYZ3(0,0,2)
     +     - 3*GYZ3(0,1,0)
     +     + 6*GYZ3(0,2,0)
     +     - 6*GYZ3(0,3,2)
     +     )
      C11 = C11 + z*(1.-y)**(-1) * (
     +     - 6*GYZ3(1,0,0)
     +     + 6*GYZ3(2,0,0)
     +     - 6*GYZ3(3,0,2)
     +     - 6*GYZ3(3,2,0)
     +     - 3./2.*HZ1(1)
     +     + HZ2(0,1)
     +     )
      C11 = C11 + (1.-y)**(-2)*(y+z)**(-2) * (
     +     + GYZ1(0)*HZ1(1)
     +     - GYZ2(0,2)
     +     - GYZ2(2,0)
     +     )
      C11 = C11 + (1.-y)**(-2)*(y+z)**(-1) * (
     +     - GYZ1(0)
     +     - 2*GYZ1(0)*HZ1(1)
     +     + 2*GYZ2(0,2)
     +     + 2*GYZ2(2,0)
     +     )
      C11 = C11 + (1.-y)**(-2) * (
     +     + GYZ1(0)
     +     + GYZ1(0)*HZ1(1)
     +     - GYZ2(0,2)
     +     - GYZ2(2,0)
     +     )
      C11 = C11 + (1.-y)**(-1)*(y+z)**(-2) * (
     +     - GYZ1(2)
     +     + HZ1(1)
     +     )
      C11 = C11 + (1.-y)**(-1)*(y+z)**(-1) * (
     +     - 1
     +     + 2*GYZ1(2)
     +     - 2*HZ1(1)
     +     )
      C11 = C11 + (1.-y)**(-1) * (
     +     + 1
     +     - 8*GYZ1(0)
     +     + 3*GYZ1(0)*HZ1(1)
     +     - GYZ1(2)
     +     - 2*GYZ2(0,0)
     +     - 3*GYZ2(0,2)
     +     - 2*GYZ2(0,2)*HZ1(0)
     +     )
      C11 = C11 + (1.-y)**(-1) * (
     +     - 2*GYZ2(0,3)*HZ1(1)
     +     - 3*GYZ2(2,0)
     +     - 2*GYZ2(2,0)*HZ1(0)
     +     - 2*GYZ2(3,0)*HZ1(1)
     +     + 2*GYZ3(0,3,2)
     +     + 2*GYZ3(3,0,2)
     +     + 2*GYZ3(3,2,0)
     +     )
      C11 = C11 + (1.-y)**(-1) * (
     +     + HZ1(1)
     +     )
      C11 = C11 + (y+z)**(-2) * (
     +     - 1./2.*GYZ1(0)*HZ1(1)
     +     - 2*GYZ1(0)*HZ2(1,1)
     +     - 7*GYZ1(2)
     +     + 1./2.*GYZ1(2)*HZ1(0)
     +     + 4*GYZ1(2)*HZ1(1)
     +     + GYZ1(2)*HZ2(1,0)
     +     + 4*GYZ1(3)*HZ2(1,1)
     +     )
      C11 = C11 + (y+z)**(-2) * (
     +     + 1./2.*GYZ2(0,2)
     +     + 2*GYZ2(0,2)*HZ1(1)
     +     - GYZ2(1,0)*HZ1(1)
     +     + 1./2.*GYZ2(2,0)
     +     + 2*GYZ2(2,0)*HZ1(1)
     +     - 4*GYZ2(2,2)
     +     - 2*GYZ2(2,2)*HZ1(0)
     +     )
      C11 = C11 + (y+z)**(-2) * (
     +     - 2*GYZ2(2,3)*HZ1(1)
     +     - 4*GYZ2(3,2)*HZ1(1)
     +     - 2*GYZ3(0,2,2)
     +     + GYZ3(1,0,2)
     +     + GYZ3(1,2,0)
     +     - 2*GYZ3(2,0,2)
     +     + GYZ3(2,1,0)
     +     )
      C11 = C11 + (y+z)**(-2) * (
     +     - 2*GYZ3(2,2,0)
     +     + 2*GYZ3(2,3,2)
     +     + 4*GYZ3(3,2,2)
     +     + 7*HZ1(1)
     +     - 1./2.*HZ2(0,1)
     +     - 1./2.*HZ2(1,0)
     +     - 4*HZ2(1,1)
     +     )
      C11 = C11 + (y+z)**(-2) * (
     +     + 2*HZ3(0,1,1)
     +     + HZ3(1,0,1)
     +     )
      C11 = C11 + (y+z)**(-1) * (
     +     - 7
     +     + 1./2.*GYZ1(0)
     +     + GYZ1(0)*HZ1(1)
     +     - 3*GYZ1(2)
     +     - GYZ1(2)*HZ1(0)
     +     - 2*GYZ1(3)*HZ1(1)
     +     - GYZ2(0,2)
     +     )
      C11 = C11 + (y+z)**(-1) * (
     +     + GYZ2(1,0)
     +     - GYZ2(2,0)
     +     + 2*GYZ2(3,2)
     +     + 1./2.*HZ1(0)
     +     + 3*HZ1(1)
     +     - HZ2(0,1)
     +     )
      C11 = C11 + t * (
     +     + 8
     +     - 4*GYZ1(0)*HZ1(1)
     +     + 3*GYZ1(0)*HZ2(1,1)
     +     - 2*GYZ1(0)*HZ3(0,1,1)
     +     - GYZ1(0)*HZ3(1,0,1)
     +     + 6*GYZ1(2)
     +     + 4*GYZ1(2)*HZ1(0)
     +     )
      C11 = C11 + t * (
     +     - 11./4.*GYZ1(2)*HZ1(1)
     +     - 3./2.*GYZ1(2)*HZ2(1,0)
     +     + 2*GYZ1(2)*HZ3(0,0,1)
     +     + GYZ1(2)*HZ3(0,1,0)
     +     + 8*GYZ1(3)*HZ1(1)
     +     - 6*GYZ1(3)*HZ2(1,1)
     +     + 4*GYZ1(3)*HZ3(0,1,1)
     +     )
      C11 = C11 + t * (
     +     + 2*GYZ1(3)*HZ3(1,0,1)
     +     + 2*GYZ2(0,0)*HZ2(1,1)
     +     + 4*GYZ2(0,2)
     +     - 3*GYZ2(0,2)*HZ1(1)
     +     - GYZ2(0,2)*HZ2(1,0)
     +     - 4*GYZ2(0,3)*HZ2(1,1)
     +     - 4*GYZ2(1,0)
     +     )
      C11 = C11 + t * (
     +     + 3./2.*GYZ2(1,0)*HZ1(1)
     +     - GYZ2(1,0)*HZ2(0,1)
     +     + 4*GYZ2(2,0)
     +     - 3*GYZ2(2,0)*HZ1(1)
     +     - GYZ2(2,0)*HZ2(1,0)
     +     + 11./4.*GYZ2(2,2)
     +     + 3*GYZ2(2,2)*HZ1(0)
     +     )
      C11 = C11 + t * (
     +     + 2*GYZ2(2,2)*HZ2(0,0)
     +     + 3*GYZ2(2,3)*HZ1(1)
     +     + 2*GYZ2(2,3)*HZ2(0,1)
     +     + 2*GYZ2(2,3)*HZ2(1,0)
     +     - 4*GYZ2(3,0)*HZ2(1,1)
     +     - 8*GYZ2(3,2)
     +     + 6*GYZ2(3,2)*HZ1(1)
     +     )
      C11 = C11 + t * (
     +     + 2*GYZ2(3,2)*HZ2(1,0)
     +     + 8*GYZ2(3,3)*HZ2(1,1)
     +     - 2*GYZ3(0,0,2)*HZ1(1)
     +     + GYZ3(0,1,0)*HZ1(1)
     +     - 2*GYZ3(0,2,0)*HZ1(1)
     +     + 3*GYZ3(0,2,2)
     +     + 2*GYZ3(0,2,2)*HZ1(0)
     +     )
      C11 = C11 + t * (
     +     + 2*GYZ3(0,2,3)*HZ1(1)
     +     + 4*GYZ3(0,3,2)*HZ1(1)
     +     + 2*GYZ3(1,0,0)*HZ1(1)
     +     - 3./2.*GYZ3(1,0,2)
     +     - GYZ3(1,0,2)*HZ1(0)
     +     - 2*GYZ3(1,0,3)*HZ1(1)
     +     - 3./2.*GYZ3(1,2,0)
     +     )
      C11 = C11 + t * (
     +     - GYZ3(1,2,0)*HZ1(0)
     +     - 2*GYZ3(1,3,0)*HZ1(1)
     +     - 2*GYZ3(2,0,0)*HZ1(1)
     +     + 3*GYZ3(2,0,2)
     +     + 2*GYZ3(2,0,2)*HZ1(0)
     +     + 2*GYZ3(2,0,3)*HZ1(1)
     +     - 3./2.*GYZ3(2,1,0)
     +     )
      C11 = C11 + t * (
     +     - GYZ3(2,1,0)*HZ1(0)
     +     + 3*GYZ3(2,2,0)
     +     + 2*GYZ3(2,2,0)*HZ1(0)
     +     + 2*GYZ3(2,3,0)*HZ1(1)
     +     - 3*GYZ3(2,3,2)
     +     - 2*GYZ3(2,3,2)*HZ1(0)
     +     + 4*GYZ3(3,0,2)*HZ1(1)
     +     )
      C11 = C11 + t * (
     +     - 2*GYZ3(3,1,0)*HZ1(1)
     +     + 4*GYZ3(3,2,0)*HZ1(1)
     +     - 6*GYZ3(3,2,2)
     +     - 4*GYZ3(3,2,2)*HZ1(0)
     +     - 4*GYZ3(3,2,3)*HZ1(1)
     +     - 8*GYZ3(3,3,2)*HZ1(1)
     +     + 2*GYZ4(0,0,2,2)
     +     )
      C11 = C11 + t * (
     +     - GYZ4(0,1,0,2)
     +     - GYZ4(0,1,2,0)
     +     + 2*GYZ4(0,2,0,2)
     +     - GYZ4(0,2,1,0)
     +     + 2*GYZ4(0,2,2,0)
     +     - 2*GYZ4(0,2,3,2)
     +     - 4*GYZ4(0,3,2,2)
     +     )
      C11 = C11 + t * (
     +     - 2*GYZ4(1,0,0,2)
     +     + GYZ4(1,0,1,0)
     +     - 2*GYZ4(1,0,2,0)
     +     + 2*GYZ4(1,0,3,2)
     +     + 2*GYZ4(1,1,0,0)
     +     - 2*GYZ4(1,2,0,0)
     +     + 2*GYZ4(1,3,0,2)
     +     )
      C11 = C11 + t * (
     +     + 2*GYZ4(1,3,2,0)
     +     + 2*GYZ4(2,0,0,2)
     +     - GYZ4(2,0,1,0)
     +     + 2*GYZ4(2,0,2,0)
     +     - 2*GYZ4(2,0,3,2)
     +     - 2*GYZ4(2,1,0,0)
     +     + 2*GYZ4(2,2,0,0)
     +     )
      C11 = C11 + t * (
     +     - 2*GYZ4(2,3,0,2)
     +     - 2*GYZ4(2,3,2,0)
     +     - 4*GYZ4(3,0,2,2)
     +     + 2*GYZ4(3,1,0,2)
     +     + 2*GYZ4(3,1,2,0)
     +     - 4*GYZ4(3,2,0,2)
     +     + 2*GYZ4(3,2,1,0)
     +     )
      C11 = C11 + t * (
     +     - 4*GYZ4(3,2,2,0)
     +     + 4*GYZ4(3,2,3,2)
     +     + 8*GYZ4(3,3,2,2)
     +     - 6*HZ1(1)
     +     + 4*HZ2(0,1)
     +     + 11./4.*HZ2(1,1)
     +     - 3*HZ3(0,1,1)
     +     )
      C11 = C11 + t * (
     +     - 3./2.*HZ3(1,0,1)
     +     + 2*HZ4(0,0,1,1)
     +     + HZ4(0,1,0,1)
     +     )
      C11 = C11 - 1./2.
     +     - 7./2.*GYZ1(0)
     +     - 4*GYZ1(0)*HZ1(1)
     +     - 3*GYZ1(0)*HZ2(0,1)
     +     + GYZ1(0)*HZ2(1,0)
     +     + 10*GYZ1(0)*HZ2(1,1)
     +     - 8*GYZ1(0)*HZ3(0,1,1)
     +     - 4*GYZ1(0)*HZ3(1,0,1)
     +
      C11 = C11 + 7*GYZ1(2)
     +     + 4*GYZ1(2)*HZ1(0)
     +     - 6*GYZ1(2)*HZ1(1)
     +     - 8*GYZ1(2)*HZ2(0,0)
     +     - 5*GYZ1(2)*HZ2(1,0)
     +     + 8*GYZ1(2)*HZ3(0,0,1)
     +     + 4*GYZ1(2)*HZ3(0,1,0)
     +     + 14*GYZ1(3)*HZ1(1)
     +
      C11 = C11 - 5*GYZ1(3)*HZ2(0,1)
     +     - 5*GYZ1(3)*HZ2(1,0)
     +     - 20*GYZ1(3)*HZ2(1,1)
     +     + 16*GYZ1(3)*HZ3(0,1,1)
     +     + 8*GYZ1(3)*HZ3(1,0,1)
     +     + 3*GYZ2(0,0)
     +     + 8*GYZ2(0,0)*HZ1(1)
     +     + 8*GYZ2(0,0)*HZ2(1,1)
     +
      C11 = C11 + 4*GYZ2(0,2)
     +     - 2*GYZ2(0,2)*HZ1(0)
     +     - 10*GYZ2(0,2)*HZ1(1)
     +     - 4*GYZ2(0,2)*HZ2(1,0)
     +     - 5*GYZ2(0,3)*HZ1(1)
     +     - 16*GYZ2(0,3)*HZ2(1,1)
     +     - 7*GYZ2(1,0)
     +     + GYZ2(1,0)*HZ1(0)
     +
      C11 = C11 + 5*GYZ2(1,0)*HZ1(1)
     +     - 4*GYZ2(1,0)*HZ2(0,1)
     +     + 4*GYZ2(2,0)
     +     - 2*GYZ2(2,0)*HZ1(0)
     +     - 10*GYZ2(2,0)*HZ1(1)
     +     - 4*GYZ2(2,0)*HZ2(1,0)
     +     + 6*GYZ2(2,2)
     +     + 10*GYZ2(2,2)*HZ1(0)
     +
      C11 = C11 + 8*GYZ2(2,2)*HZ2(0,0)
     +     + 10*GYZ2(2,3)*HZ1(1)
     +     + 8*GYZ2(2,3)*HZ2(0,1)
     +     + 8*GYZ2(2,3)*HZ2(1,0)
     +     - 5*GYZ2(3,0)*HZ1(1)
     +     - 16*GYZ2(3,0)*HZ2(1,1)
     +     - 14*GYZ2(3,2)
     +     + 5*GYZ2(3,2)*HZ1(0)
     +
      C11 = C11 + 20*GYZ2(3,2)*HZ1(1)
     +     + 8*GYZ2(3,2)*HZ2(1,0)
     +     + 32*GYZ2(3,3)*HZ2(1,1)
     +     - 8*GYZ3(0,0,2)
     +     - 8*GYZ3(0,0,2)*HZ1(1)
     +     + 4*GYZ3(0,1,0)
     +     + 4*GYZ3(0,1,0)*HZ1(1)
     +     - 8*GYZ3(0,2,0)
     +
      C11 = C11 - 8*GYZ3(0,2,0)*HZ1(1)
     +     + 10*GYZ3(0,2,2)
     +     + 8*GYZ3(0,2,2)*HZ1(0)
     +     + 8*GYZ3(0,2,3)*HZ1(1)
     +     + 5*GYZ3(0,3,2)
     +     + 16*GYZ3(0,3,2)*HZ1(1)
     +     + 8*GYZ3(1,0,0)
     +     + 8*GYZ3(1,0,0)*HZ1(1)
     +
      C11 = C11 - 5*GYZ3(1,0,2)
     +     - 4*GYZ3(1,0,2)*HZ1(0)
     +     - 8*GYZ3(1,0,3)*HZ1(1)
     +     - 5*GYZ3(1,2,0)
     +     - 4*GYZ3(1,2,0)*HZ1(0)
     +     - 8*GYZ3(1,3,0)*HZ1(1)
     +     - 8*GYZ3(2,0,0)
     +     - 8*GYZ3(2,0,0)*HZ1(1)
     +
      C11 = C11 + 10*GYZ3(2,0,2)
     +     + 8*GYZ3(2,0,2)*HZ1(0)
     +     + 8*GYZ3(2,0,3)*HZ1(1)
     +     - 5*GYZ3(2,1,0)
     +     - 4*GYZ3(2,1,0)*HZ1(0)
     +     + 10*GYZ3(2,2,0)
     +     + 8*GYZ3(2,2,0)*HZ1(0)
     +     + 8*GYZ3(2,3,0)*HZ1(1)
     +
      C11 = C11 - 10*GYZ3(2,3,2)
     +     - 8*GYZ3(2,3,2)*HZ1(0)
     +     + 5*GYZ3(3,0,2)
     +     + 16*GYZ3(3,0,2)*HZ1(1)
     +     - 8*GYZ3(3,1,0)*HZ1(1)
     +     + 5*GYZ3(3,2,0)
     +     + 16*GYZ3(3,2,0)*HZ1(1)
     +     - 20*GYZ3(3,2,2)
     +
      C11 = C11 - 16*GYZ3(3,2,2)*HZ1(0)
     +     - 16*GYZ3(3,2,3)*HZ1(1)
     +     - 32*GYZ3(3,3,2)*HZ1(1)
     +     + 8*GYZ4(0,0,2,2)
     +     - 4*GYZ4(0,1,0,2)
     +     - 4*GYZ4(0,1,2,0)
     +     + 8*GYZ4(0,2,0,2)
     +     - 4*GYZ4(0,2,1,0)
     +
      C11 = C11 + 8*GYZ4(0,2,2,0)
     +     - 8*GYZ4(0,2,3,2)
     +     - 16*GYZ4(0,3,2,2)
     +     - 8*GYZ4(1,0,0,2)
     +     + 4*GYZ4(1,0,1,0)
     +     - 8*GYZ4(1,0,2,0)
     +     + 8*GYZ4(1,0,3,2)
     +     + 8*GYZ4(1,1,0,0)
     +
      C11 = C11 - 8*GYZ4(1,2,0,0)
     +     + 8*GYZ4(1,3,0,2)
     +     + 8*GYZ4(1,3,2,0)
     +     + 8*GYZ4(2,0,0,2)
     +     - 4*GYZ4(2,0,1,0)
     +     + 8*GYZ4(2,0,2,0)
     +     - 8*GYZ4(2,0,3,2)
     +     - 8*GYZ4(2,1,0,0)
     +
      C11 = C11 + 8*GYZ4(2,2,0,0)
     +     - 8*GYZ4(2,3,0,2)
     +     - 8*GYZ4(2,3,2,0)
     +     - 16*GYZ4(3,0,2,2)
     +     + 8*GYZ4(3,1,0,2)
     +     + 8*GYZ4(3,1,2,0)
     +     - 16*GYZ4(3,2,0,2)
     +     + 8*GYZ4(3,2,1,0)
     +
      C11 = C11 - 16*GYZ4(3,2,2,0)
     +     + 16*GYZ4(3,2,3,2)
     +     + 32*GYZ4(3,3,2,2)
     +     - 7./2.*HZ1(0)
     +     - 7*HZ1(1)
     +     + 3*HZ2(0,0)
     +     + 10*HZ2(0,1)
     +     + 3*HZ2(1,0)
     +
      C11 = C11 + 6*HZ2(1,1)
     +     - 2*HZ3(0,0,1)
     +     - HZ3(0,1,0)
     +     - 10*HZ3(0,1,1)
     +     - 5*HZ3(1,0,1)
     +     + 8*HZ4(0,0,1,1)
     +     + 4*HZ4(0,1,0,1)
     +

      D11 = 0.
     +
      D11 = D11 + y**(-1) * (
     +     + 1./6.*GYZ1(0)
     +     + 1./6.*HZ1(0)
     +     )
      D11 = D11 + z*(1.-y)**(-2) * (
     +     - 1./6.*GYZ1(0)*HZ1(0)
     +     - 1./3.*GYZ2(0,0)
     +     )
      D11 = D11 + z*(1.-y)**(-1) * (
     +     - 1./6.*GYZ1(0)
     +     - 1./2.*GYZ1(0)*HZ1(0)
     +     - GYZ2(0,0)
     +     - 1./6.*HZ1(0)
     +     )
      D11 = D11 + (1.-y)**(-1) * (
     +     + 2./3.*GYZ1(0)*HZ1(0)
     +     + 4./3.*GYZ2(0,0)
     +     )
      D11 = D11 + t*zeta2 * (
     +     - 11./3.
     +     - 1./6.*GYZ1(0)
     +     - 1./6.*HZ1(0)
     +     )
      D11 = D11 + t * (
     +     - 2./3.*GYZ1(0)
     +     - 5./9.*GYZ1(0)*HZ1(0)
     +     - 1./3.*GYZ1(0)*HZ2(0,0)
     +     - 1./6.*GYZ1(0)*HZ2(1,0)
     +     - 5./9.*GYZ2(0,0)
     +     - 1./3.*GYZ2(0,0)*HZ1(0)
     +     + 1./6.*GYZ2(1,0)*HZ1(0)
     +     )
      D11 = D11 + t * (
     +     + 1./6.*GYZ3(0,1,0)
     +     + 1./3.*GYZ3(1,0,0)
     +     - 2./3.*HZ1(0)
     +     - 5./9.*HZ2(0,0)
     +     - 1./6.*HZ3(0,1,0)
     +     - 1./3.*HZ3(1,0,0)
     +     )

      E11 = 0.
     +
      E11 = E11 + y**(-1)*z * (
     +     + 2./3.*GYZ1(2)*HZ2(0,0)
     +     + 1./3.*GYZ1(3)*HZ2(0,1)
     +     + 1./3.*GYZ1(3)*HZ2(1,0)
     +     + 1./3.*GYZ2(0,2)*HZ1(0)
     +     + 1./3.*GYZ2(0,3)*HZ1(1)
     +     + 1./3.*GYZ2(2,0)*HZ1(0)
     +     + 1./3.*GYZ2(3,0)*HZ1(1)
     +     )
      E11 = E11 + y**(-1)*z * (
     +     - 1./3.*GYZ2(3,2)*HZ1(0)
     +     - 1./3.*GYZ3(0,3,2)
     +     - 1./3.*GYZ3(3,0,2)
     +     - 1./3.*GYZ3(3,2,0)
     +     )
      E11 = E11 + y**(-1) * (
     +     + 1./6.*GYZ1(0)
     +     - 4./3.*GYZ1(2)*HZ2(0,0)
     +     - 2./3.*GYZ1(3)*HZ2(0,1)
     +     - 2./3.*GYZ1(3)*HZ2(1,0)
     +     - 2./3.*GYZ2(0,2)*HZ1(0)
     +     - 2./3.*GYZ2(0,3)*HZ1(1)
     +     - 2./3.*GYZ2(2,0)*HZ1(0)
     +     )
      E11 = E11 + y**(-1) * (
     +     - 2./3.*GYZ2(3,0)*HZ1(1)
     +     + 2./3.*GYZ2(3,2)*HZ1(0)
     +     + 2./3.*GYZ3(0,3,2)
     +     + 2./3.*GYZ3(3,0,2)
     +     + 2./3.*GYZ3(3,2,0)
     +     + 1./6.*HZ1(0)
     +     )
      E11 = E11 + z*(1.-y)**(-2) * (
     +     + 1./6.*GYZ1(0)*HZ1(0)
     +     + 1./3.*GYZ2(0,0)
     +     )
      E11 = E11 + z*(1.-y)**(-1) * (
     +     + 1./6.*GYZ1(0)
     +     + 1./2.*GYZ1(0)*HZ1(0)
     +     + GYZ2(0,0)
     +     + 1./6.*HZ1(0)
     +     )
      E11 = E11 + (1.-y)**(-1) * (
     +     - 1./3.*GYZ1(0)*HZ1(0)
     +     - 2./3.*GYZ2(0,0)
     +     )
      E11 = E11 + (y+z)**(-2) * (
     +     + 1./3.*GYZ1(0)*HZ1(1)
     +     - 1./3.*GYZ1(2)*HZ1(0)
     +     - 1./3.*GYZ2(0,2)
     +     - 1./3.*GYZ2(2,0)
     +     + 1./3.*HZ2(0,1)
     +     + 1./3.*HZ2(1,0)
     +     )
      E11 = E11 + (y+z)**(-1) * (
     +     - 1./3.*GYZ1(0)
     +     - 1./3.*HZ1(0)
     +     )
      E11 = E11 + t * (
     +     + 2./3.*GYZ1(0)
     +     - 1./4.*GYZ1(0)*HZ1(1)
     +     - 1./6.*GYZ1(0)*HZ2(1,0)
     +     + 1./4.*GYZ1(2)*HZ1(0)
     +     + 1./3.*GYZ1(2)*HZ2(0,0)
     +     + 1./3.*GYZ1(3)*HZ2(0,1)
     +     + 1./3.*GYZ1(3)*HZ2(1,0)
     +     )
      E11 = E11 + t * (
     +     - 1./3.*GYZ2(0,0)*HZ1(1)
     +     + 1./4.*GYZ2(0,2)
     +     + 1./3.*GYZ2(0,2)*HZ1(0)
     +     + 1./3.*GYZ2(0,3)*HZ1(1)
     +     - 1./6.*GYZ2(1,0)*HZ1(0)
     +     + 1./4.*GYZ2(2,0)
     +     + 1./3.*GYZ2(2,0)*HZ1(0)
     +     )
      E11 = E11 + t * (
     +     + 1./3.*GYZ2(3,0)*HZ1(1)
     +     - 1./3.*GYZ2(3,2)*HZ1(0)
     +     + 1./3.*GYZ3(0,0,2)
     +     - 1./6.*GYZ3(0,1,0)
     +     + 1./3.*GYZ3(0,2,0)
     +     - 1./3.*GYZ3(0,3,2)
     +     - 1./3.*GYZ3(1,0,0)
     +     )
      E11 = E11 + t * (
     +     + 1./3.*GYZ3(2,0,0)
     +     - 1./3.*GYZ3(3,0,2)
     +     - 1./3.*GYZ3(3,2,0)
     +     + 2./3.*HZ1(0)
     +     - 1./4.*HZ2(0,1)
     +     - 1./4.*HZ2(1,0)
     +     + 1./3.*HZ3(0,0,1)
     +     )
      E11 = E11 + t * (
     +     + 1./6.*HZ3(0,1,0)
     +     )
      E11 = E11 - 1./3.*GYZ1(0)*HZ1(0)
     +     - 1./3.*GYZ1(0)*HZ1(1)
     +     - 1./3.*GYZ1(0)*HZ2(1,0)
     +     + 1./3.*GYZ1(2)*HZ1(0)
     +     + 2./3.*GYZ1(2)*HZ2(0,0)
     +     + 2./3.*GYZ1(3)*HZ2(0,1)
     +     + 2./3.*GYZ1(3)*HZ2(1,0)
     +     - 1./3.*GYZ2(0,0)
     +
      E11 = E11 - 2./3.*GYZ2(0,0)*HZ1(1)
     +     + 1./3.*GYZ2(0,2)
     +     + 2./3.*GYZ2(0,2)*HZ1(0)
     +     + 2./3.*GYZ2(0,3)*HZ1(1)
     +     - 1./3.*GYZ2(1,0)*HZ1(0)
     +     + 1./3.*GYZ2(2,0)
     +     + 2./3.*GYZ2(2,0)*HZ1(0)
     +     + 2./3.*GYZ2(3,0)*HZ1(1)
     +
      E11 = E11 - 2./3.*GYZ2(3,2)*HZ1(0)
     +     + 2./3.*GYZ3(0,0,2)
     +     - 1./3.*GYZ3(0,1,0)
     +     + 2./3.*GYZ3(0,2,0)
     +     - 2./3.*GYZ3(0,3,2)
     +     - 2./3.*GYZ3(1,0,0)
     +     + 2./3.*GYZ3(2,0,0)
     +     - 2./3.*GYZ3(3,0,2)
     +
      E11 = E11 - 2./3.*GYZ3(3,2,0)
     +     - 1./3.*HZ2(0,0)
     +     - 1./3.*HZ2(0,1)
     +     - 1./3.*HZ2(1,0)
     +     + 2./3.*HZ3(0,0,1)
     +     + 1./3.*HZ3(0,1,0)
     +
      F11 = 0.
     +
      F11 = F11 + t*zeta2 * (
     +     + 1./3.
     +     )
      F11 = F11 + t * (
     +     + 1./36.*GYZ1(0)*HZ1(0)
     +     + 1./36.*GYZ2(0,0)
     +     + 1./36.*HZ2(0,0)
     +     )

      return
      end
