c---- routines to compute the virtual one-loop matrix elements
c---- described in hep-ph/9609474 and hep-ph/9706297

      subroutine setup(s12,s13,s14,s23,s24,s34)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      integer i,j,k,l
      common/ps/p1,p2,p3,p4
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)
      common/Lsa/Lc0a(12,12),Lc1a(12,14),Lc2a(12,14),Lc3a(12,14),
     . Lcd0a(8,12,8),Lcd1a(8,12,8),Lcd2a(8,12,8),Lcd3a(8,12,8),
     . Ld0a(8,12,12),Ld1sa(8,12,12),Ld2sa(8,12,12),Ld3sa(8,12,12),
     . Ld1a(8,12,12),Ld21a(8,12,12),Ld22a(8,12,12),
     . Ld24a(8,12,12),Ld311a(8,12,12),Ld314a(8,12,12),Ld322a(8,12,12),
     . Ld344a(8,12,12),Le1a(8,8,8,8)

      common/newas12/Ld21as12(8,12,12),Ld22as12(8,12,12),
     .Ld24as12(8,12,12),Ld311as12(8,12,12),
     .Ld314as12(8,12,12),Ld322as12(8,12,12)
      common/newas23/Ld21as23(8,12,12),Ld22as23(8,12,12),
     .Ld24as23(8,12,12),Ld311as23(8,12,12),
     .Ld314as23(8,12,12),Ld322as23(8,12,12)
      dimension pp(4) 

*
* set integers pi such that pij = pi+pj, pijk=pi+pj+pk
* the pointers pp(i) (i=1..4) point to these integers
*
* p12 = 3, p13 = 5, p14 = 9, p23 = 6, p24 = 10, p34 = 12
* p123 = 7, p124 = 11, p134 = 13, p234 = 14
*
      p1=1
      p2=2
      p3=4
      p4=8
      pp(1)=p1
      pp(2)=p2
      pp(3)=p3
      pp(4)=p4

      do i=1,8
      do j=1,8
      s(i,j)=0d0
      enddo
      enddo
      s(p1,p2)=s12
      s(p1,p3)=s13
      s(p1,p4)=s14
      s(p2,p3)=s23
      s(p2,p4)=s24
      s(p3,p4)=s34
      sijkl=s12+s13+s14+s23+s24+s34
      do i=1,7
      do j=i+1,8
      s(j,i)=s(i,j)
      enddo
      enddo

*
* set up massless Lc's and Lcd's
*
      do l=1,4
      do j=1,3
      do k=j+1,4
      if(j.eq.l.or.k.eq.l)goto 10
      pl=pp(l)
      pj=pp(j)
      pk=pp(k)
      pjk=pj+pk
      sjk=s(pj,pk)
      pi=15-pl-pj-pk
      pijk=pi+pj+pk
      pjkl=pjk+pl
      sjkl=sjk+s(pj,pl)+s(pk,pl)
      Lc1(pl,pjk)=xlc1(sjk,sjkl)
      Lc2(pl,pjk)=xlc2(sjk,sjkl,Lc1(pl,pjk))
      Lc3(pl,pjk)=xlc3(sjk,sjkl,Lc2(pl,pjk))
      Lc1a(pl,pjk)=1d0/sjk
      Lc2a(pl,pjk)=1d0/2d0/sjk
      Lc3a(pl,pjk)=1d0/3d0/sjk
      sijk=s(pj,pk)+s(pi,pj)+s(pi,pk)
      sijkl=sjkl+s(pi,pj)+s(pi,pk)+s(pi,pl)
      Lc1(pl,pijk)=xlc1(sijk,sijkl)
      Lc2(pl,pijk)=xlc2(sijk,sijkl,Lc1(pl,pijk))
      Lc3(pl,pijk)=xlc3(sijk,sijkl,Lc2(pl,pijk))
      Lc1a(pl,pijk)=1d0/sijk
      Lc2a(pl,pijk)=1d0/2d0/sijk
      Lc3a(pl,pijk)=1d0/3d0/sijk

      Lcd0(pi,pjk,pl)=xlcd0(sjk,sijk,sjkl,sijkl)
      Lcd1(pi,pjk,pl)=
     .       xlcdn(sjk,sijk,sjkl,sijkl,Lc1(pl,pijk),Lc1(pl,pjk))
      Lcd2(pi,pjk,pl)=
     .       xlcdn(sjk,sijk,sjkl,sijkl,Lc2(pl,pijk),Lc2(pl,pjk))
      Lcd3(pi,pjk,pl)=
     .       xlcdn(sjk,sijk,sjkl,sijkl,Lc3(pl,pijk),Lc3(pl,pjk))


   10 continue
      enddo
      enddo
      enddo

*
* set up massive Lc's
*
      do i=1,3
      do j=i+1,4
      do k=1,3
      do l=k+1,4
      if(i.eq.k.or.i.eq.l.or.j.eq.k.or.j.eq.l)goto 20
      pi=pp(i)
      pj=pp(j)
      pk=pp(k)
      pl=pp(l)
      pij=pi+pj
      sij=s(pi,pj)
      pkl=pk+pl
      skl=s(pk,pl)
      if(pij.gt.pkl)goto 20
      lambda2=d2(sijkl,sij,skl)

      Lc0(pij,pkl)=xlc0(sij,skl,sijkl,lambda2)
      Lc0(pkl,pij)=Lc0(pij,pkl) 
      Lc1(pij,pkl)=xlc1m(sij,skl,sijkl,lambda2,Lc0(pij,pkl))
      Lc1(pkl,pij)=xlc1m(skl,sij,sijkl,lambda2,Lc0(pkl,pij))
      Lc2(pij,pkl)=xlc2m(sij,skl,sijkl,lambda2,Lc0(pij,pkl),
     . Lc1(pij,pkl),Lc1(pkl,pij))
      Lc2(pkl,pij)=Lc2(pij,pkl)
      Lc3(pij,pkl)=xlc3m(sij,skl,sijkl,lambda2,Lc0(pij,pkl),
     . Lc1(pij,pkl))
      Lc3(pkl,pij)=xlc3m(skl,sij,sijkl,lambda2,Lc0(pkl,pij),
     . Lc1(pkl,pij))

      Lc0a(pij,pkl)=xlc0a(sij,skl,sijkl)
      Lc0a(pkl,pij)=Lc0a(pij,pkl) 
      Lc1a(pij,pkl)=xlc1ma(sij,skl,sijkl,Lc0a(pij,pkl))
      Lc1a(pkl,pij)=xlc1ma(skl,sij,sijkl,Lc0a(pkl,pij))
      Lc3a(pij,pkl)=xlc3ma(sij,skl,sijkl,Lc1a(pij,pkl))
      Lc3a(pkl,pij)=xlc3ma(skl,sij,sijkl,Lc1a(pkl,pij))
      Lc2a(pij,pkl)=xlc2ma(sij,skl,sijkl,Lc3a(pij,pkl),
     . Lc1a(pij,pkl),Lc1a(pkl,pij))
      Lc2(pkl,pij)=Lc2(pij,pkl)

      Lc1s(pij,pkl)=(Lc1(pij,pkl)*skl+Lc1(pkl,pij)*sij)/2d0
      Lc1s(pkl,pij)=Lc1s(pij,pkl)
      Lc2s(pij,pkl)=xlc2s(sij,skl,sijkl,lambda2,Lc1s(pij,pkl))
      Lc2s(pkl,pij)=Lc2s(pij,pkl)
      Lc3s(pij,pkl)=xlc3s(sij,skl,sijkl,lambda2,Lc2s(pij,pkl))
      Lc3s(pkl,pij)=Lc3s(pij,pkl)
      Lc4s(pij,pkl)=xlc4s(sij,skl,sijkl,lambda2,Lc3s(pij,pkl))
      Lc4s(pkl,pij)=Lc4s(pij,pkl)


   20 continue
      enddo
      enddo
      enddo
      enddo

*
* set up massless Ld's
*
      do i=1,3
      do j=1,4
      do k=i+1,4
      if(i.eq.j.or.i.eq.k.or.j.eq.k)goto 30
      pi=pp(i)
      pj=pp(j)
      pk=pp(k)
      sij=s(pi,pj)
      sjk=s(pj,pk)
      sijk=sij+sjk+s(pi,pk)

      Ld0(pi,pj,pk)=xld0(sij,sjk,sijk)
      Ld1s(pi,pj,pk)=xld1s(sij,sjk,sijk,Ld0(pi,pj,pk))
      Ld2s(pi,pj,pk)=xld2s(sij,sjk,sijk,Ld1s(pi,pj,pk))
      Ld3s(pi,pj,pk)=xld3s(sij,sjk,sijk,Ld2s(pi,pj,pk))
      Ld0(pk,pj,pi)=Ld0(pi,pj,pk)
      Ld1s(pk,pj,pi)=Ld1s(pi,pj,pk)
      Ld2s(pk,pj,pi)=Ld2s(pi,pj,pk)
      Ld3s(pk,pj,pi)=Ld3s(pi,pj,pk)

      Ld0a(pi,pj,pk)=0
      Ld1sa(pi,pj,pk)=xld1sa(sij,sjk,sijk)
      Ld2sa(pi,pj,pk)=xld2sa(sij,sjk,sijk)
      Ld3sa(pi,pj,pk)=xld3sa(sij,sjk,sijk)
      Ld0a(pk,pj,pi)=Ld0a(pi,pj,pk)
      Ld1sa(pk,pj,pi)=Ld1sa(pi,pj,pk)
      Ld2sa(pk,pj,pi)=Ld2sa(pi,pj,pk)
      Ld3sa(pk,pj,pi)=Ld3sa(pi,pj,pk)

   30 continue
      enddo
      enddo
      enddo

c     **** set up new functions and their approximations ***

      do i=1,4
      do j=1,4
      do k=1,4
      if(i.eq.j.or.i.eq.k.or.j.eq.k)goto 35
      pi=pp(i)
      pj=pp(j)
      pk=pp(k)
      pij=pi+pj
      pjk=pj+pk
      sij=s(pi,pj)
      sjk=s(pj,pk)
      sijk=sij+sjk+s(pi,pk)

      Ld1(pi,pj,pk)=-Ld1s(pi,pj,pk)
      Ld21(pi,pj,pk)=xld21(sij,sjk,sijk,Ld2s(pi,pj,pk)
     .,Lc1(pi,pjk))
      Ld311(pi,pj,pk)=xld311(sij,sjk,sijk,Ld3s(pi,pj,pk)
     .,Lc2(pi,pjk),Lc1(pi,pjk))
      Ld314(pi,pj,pk)=xld314(sij,sjk,sijk,Ld3s(pi,pj,pk)
     .,Lc1(pi,pjk),Lc1(pk,pij))
    
      Ld1a(pi,pj,pk)=-Ld1sa(pi,pj,pk)
      Ld21a(pi,pj,pk)=xld21(sij,sjk,sijk,Ld2sa(pi,pj,pk)
     .,Lc1(pi,pj+pk))
      Ld311a(pi,pj,pk)=xld311(sij,sjk,sijk,Ld3sa(pi,pj,pk)
     .,Lc2(pi,pj+pk),Lc1(pi,pj+pk))
      Ld314a(pi,pj,pk)=xld314(sij,sjk,sijk,Ld3sa(pi,pj,pk)
     .,Lc1(pi,pj+pk),Lc1(pk,pi+pj))

      Ld21as12(pi,pj,pk)=xld21as12(sij,sjk,sijk,Ld1(pi,pj,pk))
      Ld311as12(pi,pj,pk)=xld311as12(sij,sjk,sijk
     .,Ld1(pi,pj,pk))


   35 continue
      enddo
      enddo
      enddo
*
* set up massive Ld's ( *including opposite box* )
*
      do i=1,4
      do j=1,4
      do k=1,3
      if(i.eq.j.or.i.eq.k.or.j.eq.k)goto 40
      pi=pp(i)
      pj=pp(j)
      pk=pp(k)
      pl=15-pi-pj-pk
      if(pl.lt.pk)goto 40
      pij=pi+pj
      pkl=pk+pl
      pijk=pij+pk
      pjkl=pj+pkl
      sij=s(pi,pj)
      skl=s(pk,pl)
      sikl=s(pi,pk)+s(pi,pl)+skl
      sjkl=s(pj,pk)+s(pj,pl)+skl

      Ld0(pi,pkl,pj)=xld0opp(skl,sikl,sjkl,sijkl)
      Ld1(pi,pkl,pj)=xld1opp(skl,sikl,sjkl,sijkl,Ld0(pi,pkl,pj))
      Ld21(pi,pkl,pj)=xld21opp(skl,sikl,sjkl,sijkl,Ld1(pi,pkl,pj),
     .Lc1(pi,pjkl),Lc1(pi,pkl))

      Ld0(pi,pj,pkl)=xld0m(sij,sjkl,skl,sijkl)
      Ld1s(pi,pj,pkl)=
     .      xld1sm(sij,sjkl,skl,sijkl,Ld0(pi,pj,pkl),Lc0(pij,pkl))
      Ld2s(pi,pj,pkl)=
     .      xld2sm(sij,sjkl,skl,sijkl,Ld1s(pi,pj,pkl),Lc1s(pij,pkl))
      Ld3s(pi,pj,pkl)=
     .      xld3sm(sij,sjkl,skl,sijkl,Ld2s(pi,pj,pkl),Lc2s(pij,pkl))
      
      Ld0a(pi,pj,pkl)=xld0ma(sij,sjkl,skl,sijkl,Lc0(pkl,pij))
      Ld1sa(pi,pj,pkl)=xld1sma(sij,sjkl,skl,sijkl,Lc1s(pkl,pij))
      Ld2sa(pi,pj,pkl)=xld2sma(sij,sjkl,skl,sijkl,Lc2s(pkl,pij))
      Ld3sa(pi,pj,pkl)=xld3sma(sij,sjkl,skl,sijkl,Lc3s(pkl,pij))
      
      Ld1(pi,pj,pkl)=-(Ld1s(pi,pj,pkl)+Lc0(pij,pkl))
      Ld21(pi,pj,pkl)=xld21m(sij,sjkl,skl,sijkl,Ld2s(pi,pj,pkl),
     .Lc1s(pkl,pij),Lc1(pij,pkl))
      Ld22(pi,pj,pkl)=xld22m(sij,sjkl,skl,sijkl,Ld2s(pi,pj,pkl),
     .Lc1s(pkl,pij),Lc1(pj,pkl),Lc1(pij,pkl))
      Ld24(pi,pj,pkl)=xld24m(sij,sjkl,skl,sijkl,Ld2s(pi,pj,pkl),
     .Lc1s(pkl,pij),Lc1(pi,pjkl),Lc1(pij,pkl))
      Ld311(pi,pj,pkl)=xld311m(sij,sjkl,skl,sijkl,Ld3s(pi,pj,pkl),
     .Lc2s(pkl,pij),Lc3(pij,pkl),Lc2(pkl,pij))
      Ld314(pi,pj,pkl)=xld314m(sij,sjkl,skl,sijkl,Ld3s(pi,pj,pkl),
     .Lc2s(pkl,pij),Lc3(pij,pkl),Lc2(pkl,pij),Lc1(pi,pjkl))
      Ld322(pi,pj,pkl)=xld322m(sij,sjkl,skl,sijkl,Ld3s(pi,pj,pkl),
     .Lc2s(pkl,pij),Lc3(pij,pkl),Lc2(pj,pkl),Lc1(pi,pjkl),
     .Lc2(pkl,pij),Lc1(pj,pkl))
      Ld344(pi,pj,pkl)=xld344m(sij,sjkl,skl,sijkl,Ld3s(pi,pj,pkl),
     .Lc2s(pkl,pij),Lc2(pkl,pij),Lc3(pij,pkl),Lc1(pi,pjkl),
     .Lc2(pi,pjkl))
      
      Ld1a(pi,pj,pkl)=-(Ld1sa(pi,pj,pkl)+Lc0(pij,pkl))
      Ld21a(pi,pj,pkl)=xld21m(sij,sjkl,skl,sijkl,Ld2sa(pi,pj,pkl),
     .Lc1s(pkl,pij),Lc1(pij,pkl))
      Ld22a(pi,pj,pkl)=xld22m(sij,sjkl,skl,sijkl,Ld2sa(pi,pj,pkl),
     .Lc1s(pkl,pij),Lc1(pj,pkl),Lc1(pij,pkl))
      Ld24a(pi,pj,pkl)=xld24m(sij,sjkl,skl,sijkl,Ld2sa(pi,pj,pkl),
     .Lc1s(pkl,pij),Lc1(pi,pjkl),Lc1(pij,pkl))
      Ld311a(pi,pj,pkl)=xld311m(sij,sjkl,skl,sijkl,Ld3sa(pi,pj,pkl),
     .Lc2s(pkl,pij),Lc3(pij,pkl),Lc2(pkl,pij))
      Ld314a(pi,pj,pkl)=xld314m(sij,sjkl,skl,sijkl,Ld3sa(pi,pj,pkl),
     .Lc2s(pkl,pij),Lc3(pij,pkl),Lc2(pkl,pij),Lc1(pi,pjkl))
      Ld322a(pi,pj,pkl)=xld322m(sij,sjkl,skl,sijkl,Ld3sa(pi,pj,pkl),
     .Lc2s(pkl,pij),Lc3(pij,pkl),Lc2(pj,pkl),Lc1(pi,pjkl),
     .Lc2(pkl,pij),Lc1(pj,pkl))
      Ld344a(pi,pj,pkl)=xld344m(sij,sjkl,skl,sijkl,Ld3sa(pi,pj,pkl),
     .Lc2s(pkl,pij),Lc2(pkl,pij),Lc3(pij,pkl),Lc1(pi,pjkl),
     .Lc2(pi,pjkl))


   40 continue
      enddo
      enddo
      enddo

*
* setup Le1
*
      do i=1,3
      do l=i+1,4
      do j=1,4
      if(i.eq.j.or.i.eq.l.or.j.eq.l)goto 50
      pi=pp(i)
      pj=pp(j)
      pl=pp(l)
      pk=15-pi-pj-pl
      pij=pi+pj
      pkl=pk+pl
      sjk=s(pj,pk)
      sijk=s(pi,pj)+s(pi,pk)+sjk
      sjkl=sjk+s(pj,pl)+s(pk,pl)
      Le1(pi,pj,pk,pl)=(Ld0(pi,pj,pk)+Ld0(pl,pk,pij)
     . -Ld0(pj,pk,pl)-Ld0(pi,pj,pkl))/(sijk*sjkl-sjk*sijkl)
      Le1(pl,pk,pj,pi)=-Le1(pi,pj,pk,pl)


   50 continue
      enddo
      enddo
      enddo
      return
      end

      function xld0(s12,s23,s123)
      implicit real*8(a-z)
      parameter(zeta2 =  1.644934066848226d0)
      xld0=li2(1d0-s12/s123)+li2(1d0-s23/s123)
     .      +log(s12/s123)*log(s23/s123)-zeta2
      return
      end
      function xld1s(s12,s23,s123,rld0)
      implicit real*8(a-z)
      xld1s=-rld0/(s123-s12-s23)
      return
      end
      function xld1sa(s12,s23,s123)
      implicit real*8(a-z)
      xld1sa=-(s12*log(s123/s12)+s23*log(s123/s23))/s12/s23
      return
      end
      function xld2s(s12,s23,s123,rld1)
      implicit real*8(a-z)
      xld2s=-(s12*s23*rld1+s12*log(s123/s12)
     .        +s23*log(s123/s23))/6d0/(s123-s12-s23)
      return
      end
      function xld2sa(s12,s23,s123)
      implicit real*8(a-z)
      xld2sa=-(s12**2*log(s123/s12)
     .     +s23**2*log(s123/s23)+s12*s23)
     .     /12d0/s12/s23
      return
      end
      function xld21(s12,s23,s123,rld2,rlc1)
      implicit real*8(a-z)
      xld21=-(6*rld2+s23*rlc1)/s12
      return
      end
      function xld21as12(s12,s23,s123,rld1)
      implicit real*8(a-z)
      xld21as12=log(s123/s12)/(s123-s12-s23)
     .        +log(s123/s23)*s23/(s123-s12-s23)**2
     .        +rld1*s23/(s123-s12-s23)
      return
      end
      function xld3s(s12,s23,s123,rld2)
      implicit real*8(a-z)
      xld3s=-(s12*s23*rld2+s12**2/12d0*log(s123/s12)
     .      +s23**2/12d0*log(s123/s23)+s12*s23/12d0)
     .      /10d0/(s123-s12-s23)
      return
      end
      function xld3sa(s12,s23,s123)
      implicit real*8(a-z)
      xld3sa=-(s12**3*log(s123/s12)
     .     +s23**3*log(s123/s23)
     .     +s12*s23*(s123+s12+s23)/4d0)/180d0/s12/s23
      return
      end
      function xld311(s12,s23,s123,rld3,rlc2,rlc1)
      implicit real*8(a-z)
      xld311=-(60d0*rld3+s23**2*rlc1/2d0
     .        +s12*s23*rlc2/2d0)/s12**2
      return
      end
      function xld311as12(s12,s23,s123,rld1)
      implicit real*8(a-z)
      xld311as12=log(s123/s12)*(-s23/(s123-s12-s23)**2
     .         +1d0/2d0/(s123-s12-s23))
     .        -3d0/2d0*log(s123/s23)*s23**2/(s123-s12-s23)**3
     .        +s23/(s123-s12-s23)**2/2d0
     .        -rld1*s23**2/(s123-s12-s23)**2
      return
      end
      function xld314(s12,s23,s123,rld3,rlc1a,rlc1b)
      implicit real*8(a-z)
      xld314=-(60*rld3+s23**2*rlc1a/2d0
     .        +s12**2*rlc1b/2d0)/s12/s23
      return
      end      
      function xld0opp(s23,s123,s234,s1234)
      implicit real*8(a-z)
      xld0opp=-li2(1d0-s23/s123)-li2(1d0-s23/s234)
     .+li2(1d0-s123/s1234)+li2(1d0-s234/s1234)
     .+li2(1d0-s23*s1234/s123/s234)+log(s123/s1234)*log(s234/s1234)
      return
      end
      function xld1opp(s23,s123,s234,s1234,rld0)
      implicit real*8(a-z)
      xld1opp=rld0/(s1234+s23-s123-s234)
      return
      end
      function xld21opp(s23,s123,s234,s1234,rld1,rlc1a,rlc1b)
      implicit real*8(a-z)
      xld21opp=((s23-s234)*rld1+s234*rlc1a-s23*rlc1b
     .          +log(s1234/s123))/(s1234+s23-s123-s234)
      return
      end
      function xld0m(s12,s234,s34,s1234)
      implicit real*8(a-z)
      xld0m=li2(1d0-s234/s1234)-li2(1d0-s34/s234)
     .    +0.5d0*log(s234**2/s1234/s34)*log(s12/s1234)
      return
      end
      function xld0ma(s12,s234,s34,s1234,lc0)
      implicit real*8(a-z)
      xld0ma=-(s1234+s34-s12-2*s34*s1234/s234)*lc0/2d0
      return
      end
      function xld1sm(s12,s234,s34,s1234,rld0,rlc0)
      implicit real*8(a-z)
      xld1sm=-s234/((s1234-s234)*(s234-s34)-s12*s234)
     . *(rld0+(s1234+s34-s12-2d0*s1234*s34/s234)*rlc0/2d0)
      return
      end
      function xld1sma(s12,s234,s34,s1234,rlc1s)
      implicit real*8(a-z)
      xld1sma=-((s1234+s34-s12-2d0*s34*s1234/s234)*rlc1s
     .+s12/2d0*log(s1234/s12)+s234*log(s1234/s234)
     .-s34/2d0*log(s1234/s34))/s234/s12
      return
      end
      function xld2sm(s12,s234,s34,s1234,rld1,rlc1s)
      implicit real*8(a-z)
      xld2sm=-s234/6d0/((s1234-s234)*(s234-s34)-s12*s234)
     . *(s12*s234*rld1
     .   +(s1234+s34-s12-2d0*s1234*s34/s234)*rlc1s 
     .   +s12/2d0*log(s1234/s12)+s234*log(s1234/s234)
     .   -s34/2d0*log(s1234/s34))
      return
      end
      function xld2sma(s12,s234,s34,s1234,rlc2s)
      implicit real*8(a-z)
      xld2sma=-((s1234+s34-s12-2d0*s34*s1234/s234)*rlc2s
     .+s12**2/2d0*log(s1234/s12)+s234**2*log(s1234/s234)
     .-s34**2/2d0*log(s1234/s34)+s234*s12)/12d0/s234/s12
      return
      end
      function xld21m(s12,s234,s34,s1234,rld2,rlc1s,rlc1)
      implicit real*8(a-z)
      xld21m=-2d0/s234*(3d0*rld2+rlc1s)-rlc1
      return
      end
      function xld22m(s12,s234,s34,s1234,rld2,rlc1s,rlc1m,rlc1)
      implicit real*8(a-z)
      xld22m=2d0/s234/s12*(s1234-s234)*(3d0*rld2+rlc1s)
     .        -s234/s12*rlc1m+s1234/s12*rlc1
      return
      end
      function xld24m(s12,s234,s34,s1234,rld2,rlc1s,rlc1m,rlc1)
      implicit real*8(a-z)
      xld24m=2d0/s234/s12*(s34-s234)*(3d0*rld2+rlc1s)
     .        -s234/s12*rlc1m+s34/s12*rlc1
      return
      end
      function xld2m4a123(s12,s123,s34,s1234,rlc1s,rlc1m,rlc1)
      implicit real*8(a-z)
      xld2m4a123=(2d0*(s34-s12-s1234)*rlc1s+s34*log(s1234/s34)
     .         -s12*log(s1234/s12))/4d0/s12/s1234*2d0*(s12-s123)/s34
     .         -s123/s34*rlc1m+s12/s34*rlc1
      return
      end
      function xld2m4a34(s12,s123,s34,s1234,rld1,rlc0,rlc1m)
      implicit real*8(a-z)
      xld2m4a34=-s123/(s1234-s123)/(s1234-s12)*log(s34/s1234)
     .          -s12*s123/(s1234-s123)/(s1234-s12)*rlc0
     .	 	+s123/(s1234-s123)*rld1
     .		+s123**2/(s1234-s123)/(s123-s12)*rlc1m
     .		+s12*s123/(s1234-s12)**2/(s1234-s123)
     .            /(s123-s12)*(s12-2d0*s123+s1234)*log(s12/s1234)
      return
      end
      function xld3sm(s12,s234,s34,s1234,rld2,rlc2s)
      implicit real*8(a-z)
      xld3sm=-s234/10d0/((s1234-s234)*(s234-s34)-s12*s234)
     . *(s12*s234*rld2
     .   +(s1234+s34-s12-2d0*s1234*s34/s234)*rlc2s 
     .   +s12**2/24d0*log(s1234/s12)+s234**2/12d0*log(s1234/s234)
     .   -s34**2/24d0*log(s1234/s34)+s12*s234/12d0)
      return
      end
      function xld3sma(s12,s234,s34,s1234,rlc3s)
      implicit real*8(a-z)
      xld3sma=-((s1234+s34-s12-2d0*s34*s1234/s234)*rlc3s
     .+s12**3/2d0*log(s1234/s12)+s234**3*log(s1234/s234)
     .-s34**3/2d0*log(s1234/s34)
     .+s12*s234*(s1234+s234+s12+s34)/4d0)/180d0/s234/s12
      return
      end
      function xld311m(s12,s234,s34,s1234,rld3,rlc2s,rlc3,
     .rlc2)
      implicit real*8(a-z)
      xld311m=-(12/s234**2*(5d0*rld3+rlc2s)
     .         +(s234+s34)/s234*rlc3+s12/s234*rlc2)
      return
      end
      function xld314m(s12,s234,s34,s1234,rld3,rlc2s,rlc3,
     .                 rlc2,rlc1m)
      implicit real*8(a-z)
      xld314m=12*(s34-s234)/s234**2/s12*(5d0*rld3+rlc2s)
     .	    +s34**2/s234/s12*rlc3-(s234-s34)/s234*rlc2
     .          -s234/2d0/s12*rlc1m
      return
      end
      function xld322m(s12,s234,s34,s1234,rld3,rlc2s,rlc3,rlc2m,
     .                 rlc1a,rlc2,rlc1b)
      implicit real*8(a-z)
      xld322m=-(12*(s1234-s234)**2/s234**2/s12**2*(5d0*rld3+rlc2s)
     .          +s1234*(s234*s1234+s34*s1234-2d0*s34*s234)
     .           /s234/s12**2*rlc3-s234/2d0/s12*rlc2m
     .	    +s234*(s234-s1234)/2d0/s12**2*rlc1a
     .          +s1234*(s1234-2d0*s234)/s234/s12*rlc2
     .	    +(s34*s234+s234*s12-s234*s1234)/2d0/s12**2*rlc1b)
      return
      end
      function xld344m(s12,s234,s34,s1234,rld3,rlc2s,rlc2,rlc3,
     .                 rlc1m,rlc2m)
      implicit real*8(a-z)
      xld344m=-(12*(s234-s34)**2/s234**2/s12**2*(5d0*rld3+rlc2s)
     .          +s34*(s34-2d0*s234)/s234/s12*rlc2
     .	    +s34**2*(s34-s234)/s234/s12**2*rlc3
     .          +s234*(s234-s34)/2d0/s12**2*rlc1m
     .          +s234/2d0/s12*rlc2m)
      return
      end
      function xld3m22a34(s12,s123,s34,s1234,rld1,rlc0,rlc1m)
      implicit real*8(a-z)
      xld3m22a34=(s123*(s12**2+s12*s1234-2d0*s123*s1234)/
     . (s12-s1234)**2/2d0
     . +(s12**2-s123*s1234)*s123*s1234/(s12-s1234)**2*rlc0
     . -s123**2*rld1+3d0/2d0*s123**3/(s12-s123)*rlc1m
     . +s123*(s12**2+s12*s1234+s12*s123-3d0*s123*s1234)/2d0/
     . (s12-s1234)**2*log(s34/s1234)
     . -s123*(3d0*s123**2*s1234**2-15d0*s1234*s12**2*s123
     .  +4d0*s1234*s12*s123**2+5d0*s1234*s12**3+3d0*s12**3*s123
     .  +s12**4-s12**2*s123**2)/2d0
     .   /(s12-s123)/(s12-s1234)**3*log(s12/s1234))/(s12-s123)**2
      return
      end
      function xlcd0(s23,s123,s234,s1234)
      implicit real*8(a-z)
      xlcd0=log(s123*s234/s23/s1234)/(s123*s234-s23*s1234)
      return
      end
      function xlcdn(s23,s123,s234,s1234,rlcna,rlcnb)
      implicit real*8(a-z)
      xlcdn=(s123*rlcna-s23*rlcnb)/(s123*s234-s23*s1234)
      return
      end
      function xlc1(s23,s123)
      implicit real*8(a-z)
      xlc1=log(s123/s23)/(s123-s23)
      return
      end
      function xlc2(s23,s123,rlc1)
      implicit real*8(a-z)
      xlc2=-(s23*rlc1-1d0)/(s123-s23)
      return
      end
      function xlc3(s23,s123,rlc2)
      implicit real*8(a-z)
      xlc3=-(s23*rlc2-0.5d0)/(s123-s23)
      return
      end
      function xlc0(s12,s34,s1234,lambda2)
      implicit real*8(a-z)
      lambda=sqrt(lambda2)
      ap=(s1234+s34-s12+lambda)/2d0/s1234
      am=(s1234+s34-s12-lambda)/2d0/s1234
      xlc0=(log(ap*am)*log((1d0-ap)/(1d0-am))
     .           +2d0*li2(ap)-2d0*li2(am))/lambda
      return
      end
      function xlc0a(s12,s34,s1234)
      implicit real*8(a-z)    
      xlc0a=1d0/2d0/s12/s34/s1234*(s12*(s1234+s34-s12)*
     .  log(s1234/s12)+s34*(s1234+s12-s34)*log(s1234/s34))
      return
      end
      function xlc1m(s12,s34,s1234,lambda2,rlc0)
      implicit real*8(a-z)
      xlc1m=-(s12*(s1234-s12+s34)*rlc0
     .  -(s1234-s12-s34)*log(s1234/s34) 
     .  -2d0*s12*log(s1234/s12))/lambda2 
      return
      end
      function xlc1ma(s12,s34,s1234,rlc0)
      implicit real*8(a-z)
      xlc1ma=1d0/3d0/s12/(s1234+s34-s12)*((s1234-s34)*
     . log(s1234/s34)+2*s12-s12**2*rlc0)
      return
      end
      function xlc2m(s12,s34,s1234,lambda2,rlc0,rlc1a,rlc1b)
      implicit real*8(a-z)
      xlc2m=-(2d0*s34*(s1234+s12-s34)*rlc1a
     .  +s12*(s1234+s34-s12)*rlc1b-s12*s34*rlc0
     .  -s34*log(s1234/s34)+s12+s34-s1234)/2d0/lambda2
      return
      end
      function xlc2ma(s12,s34,s1234,rlc3,rlc1a,rlc1b)
      implicit real*8(a-z)
      xlc2ma=1d0/6d0/s34/(s1234+s12-s34)*(-4d0*s34*
     . (s1234+s12-s34)*rlc3+s1234-s34+3d0*s12*s34*rlc1a
     . -s12**2*rlc1b+s34*log(s1234/s34))
      return
      end
      function xlc3m(s12,s34,s1234,lambda2,rlc0,rlc1)
      implicit real*8(a-z)
      xlc3m=-(3d0*s12*(s1234+s34-s12)*rlc1+s12**2*rlc0
     .       -(s1234-s34)*log(s1234/s34)-2d0*s12)/2d0/lambda2
      return
      end
      function xlc3ma(s12,s34,s1234,rlc1)
      implicit real*8(a-z)
      xlc3ma=1d0/5d0/s12/(s1234+s34-s12)*((s1234-s34)*
     . log(s1234/s34)+s12-2d0*s12**2*rlc1)
      return
      end
      function xlc2s(s12,s34,s1234,lambda2,rlc1s)
      implicit real*8(a-z)
      xlc2s=-(2d0*s1234*s12*s34*rlc1s-s1234*s12*s34/3d0
     .   -(s12**2*(s1234+s34-s12)*log(s1234/s12)
     .   +s34**2*(s1234+s12-s34)*log(s1234/s34))/6d0)/4d0/lambda2
      return
      end
      function xlc3s(s12,s34,s1234,lambda2,rlc2s)
      implicit real*8(a-z)
      xlc3s=-(2d0*s1234*s12*s34*rlc2s
     .  -s1234*s12*s34*(s12+s34+s1234)/120d0
     .  -(s12**3*(s1234+s34-s12)*log(s1234/s12)
     .  +s34**3*(s1234+s12-s34)*log(s1234/s34))/60d0)/6d0/lambda2
      return
      end
      function xlc4s(s12,s34,s1234,lambda2,rlc3s)
      implicit real*8(a-z)
      xlc4s=-(2d0*s1234*s12*s34*rlc3s
     . -s1234*s12*s34*(s12**2+s34**2+s1234**2+s12*s34+s12*s1234
     . +s34*s1234)*2d0/840d0/9d0
     . -(s12**4*(s1234+s34-s12)*log(s1234/s12)
     . +s34**4*(s1234+s12-s34)*log(s1234/s34))/840d0)/8d0/lambda2
      return
      end
      function d2(a,b,c)
      implicit real*8(a-z)
      d2=a**2+b**2+c**2-2d0*(a*b+a*c+b*c)
      return
      end
  
c
c real dilogarithm function  0 <= x <= 1
c
      function li2(x)
      implicit real*8(a-z)
      parameter(a1 = -0.250000000000000d0)
      parameter(a2 = -0.111111111111111d0)
      parameter(a3 = -0.010000000000000d0)
      parameter(a4 = -0.0170068027210884d0)
      parameter(a5 = -0.0194444444444444d0)
      parameter(a6 = -0.0206611570247934d0)
      parameter(a7 = -0.0214173006480699d0)
      parameter(a8 = -0.0219488663772311d0)
      parameter(a9 = -0.0220893589994137d0)
      parameter(a10 = -0.0229303207720760d0)
      parameter(zeta2 =  1.644934066848226d0)
      li2=0d0
      if(x.gt.1.d0)then
        write(*,*)' argument greater than 1 passed to li2'
        li2=0d0
        return
      elseif(x.lt.0.d0)then
        write(*,*)' argument less than 0 passed to li2'
        li2=0d0
        return
      elseif(x.eq.1.d0)then
        li2=zeta2
        return
      elseif(x.eq.0.d0)then
        li2=0d0
        return
      elseif(x.gt.0.5d0)then
        y=1d0-x
        z=-log(1d0-y)
        z2=z*z
        li2=-z*(1d0+a1*z*(1d0+a2*z*(1d0+a3*z2*(1d0+a4*z2*
     1 (1d0+a5*z2*(1d0+a6*z2*(1d0+a7*z2*(1d0+a8*z2*(1d0+a9*z2*
     2 (1d0+a10*z2))))))))))
     3 +zeta2-log(x)*log(1.d0-x)
       return
      elseif(x.le.0.5d0)then
        y=x
        z=-log(1d0-y)
        z2=z*z
        li2=z*(1d0+a1*z*(1d0+a2*z*(1d0+a3*z2*(1d0+a4*z2*
     1 (1d0+a5*z2*(1d0+a6*z2*(1d0+a7*z2*(1d0+a8*z2*(1d0+a9*z2*
     2 (1d0+a10*z2))))))))))
        return
      endif
      return
      end
      function LA(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)

      LA=LAa(p1,p2,p3,p4)+LAb(p1,p2,p3,p4)+LAc(p1,p2,p3,p4)
     .  +LAd(p1,p2,p3,p4)+LAe(p1,p2,p3,p4)

      return
      end

      function LAa(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LA=0d0

      LA = LA + S13**(-1)*S23**(-1)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 8*s13**4*s23*s24*S14**(-1)*S24**(-1) - 8*s13**4*s24**2*
     +    S14**(-1)*S24**(-1) + 8*s13**3*s14*s23*s24*S14**(-1)*
     +    S24**(-1) - 8*s13**3*s14*s24**2*S14**(-1)*S24**(-1) + 8*
     +    s13**3*s23*s24*s34*S14**(-1)*S24**(-1) - 8*s13**3*s24**2*s34*
     +    S14**(-1)*S24**(-1) - 8*s13**2*s23*s24**3*S14**(-1)*S24**(-1)
     +     - 8*s13**2*s24**4*S14**(-1)*S24**(-1) - 8*s13**2*s24**3*s34*
     +    S14**(-1)*S24**(-1) - 8*s13*s14**3*s23**2*S14**(-1)*S24**(-1)
     +     - 8*s14**4*s23**2*S14**(-1)*S24**(-1) - 8*s14**3*s23**2*s34*
     +    S14**(-1)*S24**(-1) )

      LA = LA + S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 120*
     +    s12**3*s14*S24**(-1) + 232*s12**3 - 16*s12**2*s14 - 16*s12*
     +    s14*s24 )

      LA = LA + S13**(-1)*S23**(-1)*S234**(-1) * ( 8*s12**3*S14**(-1)
     +     + 120*s12**3*S24**(-1) + 4*s12**2*s14*S24**(-1) + 128*s12**2
     +     - 8*s12*s14**2*S24**(-1) + 48*s12*s14 - 44*s12*s24 + 4*s14*
     +    s24 )

      LA = LA + S13**(-1)*S23**(-1)*S134**(-1) * (  - 112*s12**3*
     +    S24**(-1) + 4*s12**2*s24*S14**(-1) + 112*s12**2 - 44*s12*s14
     +     - 8*s12*s24**2*S14**(-1) + 48*s12*s24 + 4*s14*s24 )

      LA = LA + S13**(-1)*S23**(-1) * ( 112*s12**3*S14**(-1)*S24**(-1)
     +     + 32*s12**2*s34*S14**(-1)*S24**(-1) + 116*s12**2*S14**(-1)
     +     + 116*s12**2*S24**(-1) + 52*s12*s14*S24**(-1) + 52*s12*s24*
     +    S14**(-1) - 16*s12*s34*S14**(-1) - 16*s12*s34*S24**(-1) + 64*
     +    s12 + 16*s14*s34*S24**(-1) + 20*s14 + 16*s24*s34*S14**(-1) + 
     +    20*s24 )

      LA = LA + S13**(-1)*S34**(-1)*S234**(-1) * (  - 16*s12*s14 - 16*
     +    s14**2 + 8*s14*s23 )

      LA = LA + S13**(-1)*S34**(-1) * ( 28*s12*s14*S24**(-1) + 28*s12*
     +    s23*S24**(-1) + 16*s14**2*S24**(-1) + 16*s14*s23*S24**(-1) + 
     +    16*s23**2*S24**(-1) + 8*s23 )

      LA = LA + S13**(-1)*S234**(-1)*S134**(-1) * ( 232*s12**3*
     +    S24**(-1) + 248*s12**2*s14*S24**(-1) + 176*s12*s14*s23*
     +    S24**(-1) - 56*s12*s14 + 48*s14**2*s23*S24**(-1) + 48*s14**2
     +     - 128*s14*s23 - 72*s14*s24 )

      LA = LA + S13**(-1)*S234**(-1) * ( 8*s12**3*S14**(-1)*S24**(-1)
     +     - 20*s12**2*S24**(-1) + 136*s12*s14*S24**(-1) + 16*s12*s23*
     +    S14**(-1) + 16*s12*s24*S14**(-1) + 40*s12 + 32*s14**2*
     +    S24**(-1) - 112*s14 - 4*s23**2*S24**(-1) - 4*s23 - 8*s24 )

      LA = LA + S13**(-1)*S134**(-1) * ( 4*s12**2*s23*S14**(-1)*
     +    S24**(-1) - 8*s12**2*S14**(-1) + 228*s12**2*S24**(-1) - 8*s12
     +    *s23**2*S14**(-1)*S24**(-1) - 8*s12*s23*S14**(-1) + 136*s12*
     +    s23*S24**(-1) - 8*s12*s24*S14**(-1) + 8*s12 - 4*s14**2*
     +    S24**(-1) + 48*s14*s23*S24**(-1) + 12*s14 + 32*s23**2*
     +    S24**(-1) - 12*s23 + 4*s24 )

      LA = LA + S13**(-1)*S134**(-2) * (  - 64*s12*s14 - 64*s14*s23 - 
     +    64*s14*s24 )

      LA = LA + S13**(-1) * ( 24 + 116*s12**2*S14**(-1)*S24**(-1) + 52*
     +    s12*s23*S14**(-1)*S24**(-1) - 16*s12*s34*S14**(-1)*S24**(-1)
     +     + 112*s12*S14**(-1) + 120*s12*S24**(-1) + 120*s14*S24**(-1)
     +     + 16*s23*s34*S14**(-1)*S24**(-1) + 120*s23*S24**(-1) + 32*
     +    s34*S14**(-1) + 48*s34*S24**(-1) )

      LA = LA + S23**(-1)*S34**(-1)*S134**(-1) * (  - 16*s12*s24 + 8*
     +    s13*s24 - 16*s24**2 )

      LA = LA + S23**(-1)*S34**(-1) * ( 28*s12*s13*S14**(-1) + 28*s12*
     +    s24*S14**(-1) + 16*s13**2*S14**(-1) + 16*s13*s24*S14**(-1) + 
     +    8*s13 + 16*s24**2*S14**(-1) )

      LA = LA + S23**(-1)*S234**(-1)*S134**(-1) * (  - 120*s12**3*s13*
     +    S14**(-1)*S24**(-1) + 232*s12**3*S14**(-1) - 240*s12**3*
     +    S24**(-1) + 248*s12**2*s13*S14**(-1) + 232*s12**2 + 176*s12*
     +    s13*s24*S14**(-1) - 216*s12*s13 - 216*s12*s14 + 160*s12*s24
     +     + 48*s13**2*s24*S14**(-1) - 56*s13**2 - 56*s13*s14 + 24*s13*
     +    s24 - 24*s14*s24 )

      LA = LA + S23**(-1)*S234**(-1) * ( 120*s12**3*S14**(-1)*S24**(-1)
     +     + 4*s12**2*s13*S14**(-1)*S24**(-1) - 20*s12**2*S14**(-1) - 8
     +    *s12**2*S24**(-1) - 8*s12*s13**2*S14**(-1)*S24**(-1) + 136*
     +    s12*s13*S14**(-1) - 8*s12*s13*S24**(-1) - 8*s12*s14*S24**(-1)
     +     + 224*s12 + 32*s13**2*S14**(-1) + 44*s13 + 4*s14 - 4*s24**2*
     +    S14**(-1) - 36*s24 )

      LA = LA + S23**(-1)*S234**(-2) * (  - 64*s12*s24 - 64*s13*s24 - 
     +    64*s14*s24 )

      LA = LA + S23**(-1)*S134**(-1) * (  - 112*s12**3*S14**(-1)*
     +    S24**(-1) + 228*s12**2*S14**(-1) + 16*s12*s13*S24**(-1) + 16*
     +    s12*s14*S24**(-1) + 136*s12*s24*S14**(-1) - 176*s12 - 4*
     +    s13**2*S14**(-1) + 48*s13*s24*S14**(-1) - 60*s13 - 8*s14 + 32
     +    *s24**2*S14**(-1) - 64*s24 )

      LA = LA + S23**(-1) * ( 24 + 116*s12**2*S14**(-1)*S24**(-1) + 52*
     +    s12*s13*S14**(-1)*S24**(-1) - 16*s12*s34*S14**(-1)*S24**(-1)
     +     + 120*s12*S14**(-1) + 112*s12*S24**(-1) + 16*s13*s34*
     +    S14**(-1)*S24**(-1) + 120*s13*S14**(-1) + 120*s24*S14**(-1)
     +     + 48*s34*S14**(-1) + 32*s34*S24**(-1) )

      LA = LA + S34**(-1)*S234**(-1) * (  - 16*s12*s13*S14**(-1) - 32*
     +    s12 - 24*s13**2*S14**(-1) - 8*s13*s23*S14**(-1) - 36*s13 - 36
     +    *s14 )

      LA = LA + S34**(-1)*S134**(-1) * (  - 16*s12*s23*S24**(-1) - 32*
     +    s12 - 8*s13*s23*S24**(-1) - 24*s23**2*S24**(-1) - 36*s23 - 36
     +    *s24 )

      LA = LA + S34**(-1) * (  - 64 + 8*s13*S14**(-1) + 8*s14*S24**(-1)
     +     + 8*s23*S24**(-1) + 8*s24*S14**(-1) )

      LA = LA + S234**(-1)*S134**(-1) * ( 232*s12**3*S14**(-1)*
     +    S24**(-1) - 16*s12**2*s13*S14**(-1)*S24**(-1) + 232*s12**2*
     +    S24**(-1) - 16*s12*s13*s23*S14**(-1)*S24**(-1) - 56*s12*s13*
     +    S14**(-1) - 216*s12*s13*S24**(-1) - 216*s12*s14*S24**(-1) + 
     +    160*s12*s23*S24**(-1) + 176*s12 + 48*s13**2*S14**(-1) + 56*
     +    s13**2*S24**(-1) + 56*s13*s14*S24**(-1) - 72*s13*s23*
     +    S14**(-1) - 80*s13*s23*S24**(-1) - 128*s13*s24*S14**(-1) + 
     +    152*s13 - 32*s14*s23*S24**(-1) + 152*s14 - 200*s23 - 200*s24
     +     )

      LA = LA + S234**(-1) * (  - 152 + 128*s12**2*S14**(-1)*S24**(-1)
     +     + 48*s12*s13*S14**(-1)*S24**(-1) - 44*s12*s23*S14**(-1)*
     +    S24**(-1) + 40*s12*S14**(-1) + 224*s12*S24**(-1) + 4*s13*s23*
     +    S14**(-1)*S24**(-1) - 120*s13*S14**(-1) - 52*s13*S24**(-1) - 
     +    12*s14*S24**(-1) - 8*s23*S14**(-1) - 36*s23*S24**(-1) - 4*s24
     +    *S14**(-1) )

      LA = LA + S234**(-2) * (  - 64*s12*s23*S24**(-1) - 64*s13*s23*
     +    S24**(-1) - 64*s14*s23*S24**(-1) )

      LA = LA + S134**(-1) * ( 152 + 112*s12**2*S14**(-1)*S24**(-1) - 
     +    44*s12*s13*S14**(-1)*S24**(-1) + 48*s12*s23*S14**(-1)*
     +    S24**(-1) + 8*s12*S14**(-1) - 176*s12*S24**(-1) + 4*s13*s23*
     +    S14**(-1)*S24**(-1) + 12*s13*S14**(-1) + 48*s13*S24**(-1) - 4
     +    *s14*S24**(-1) + 4*s23*S14**(-1) - 72*s23*S24**(-1) - 12*s24*
     +    S14**(-1) )

      LA = LA + S134**(-2) * (  - 64*s12*s13*S14**(-1) - 64*s13*s23*
     +    S14**(-1) - 64*s13*s24*S14**(-1) )

      LA = LA + log(s13**(-1)*s134)*S13**(-1)*S23**(-1)*S34**(-1)*
     + S234**(-1)*S134**(-1) * (  - 28*s12*s13**2*s23*s24**2*S14**(-1)*
     +    S24**(-1) - 28*s12*s13**2*s24**3*S14**(-1)*S24**(-1) - 28*s12
     +    *s13**2*s24**2*s34*S14**(-1)*S24**(-1) - 24*s13**3*s23*s24**2
     +    *S14**(-1)*S24**(-1) - 32*s13**3*s24**3*S14**(-1)*S24**(-1)
     +     - 24*s13**3*s24**2*s34*S14**(-1)*S24**(-1) - 16*s13**2*
     +    s23**2*s24**2*S14**(-1)*S24**(-1) - 16*s13**2*s23*s24**3*
     +    S14**(-1)*S24**(-1) - 16*s13**2*s23*s24**2*s34*S14**(-1)*
     +    S24**(-1) )

      LA = LA + log(s13**(-1)*s134)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 12*s12**3 + 16*s12**2*s14 - 8*s12*s14*s24 )

      LA = LA + log(s13**(-1)*s134)*S13**(-1)*S23**(-1)*S234**(-1) * ( 
     +    16*s12**2*s14*S24**(-1) - 16*s12**2 - 8*s12*s14**2*S24**(-1)
     +     - 8*s12*s14 )

      LA = LA + log(s13**(-1)*s134)*S13**(-1)*S23**(-1)*S134**(-1) * ( 
     +    24*s12*s14 )

      LA = LA + log(s13**(-1)*s134)*S13**(-1)*S23**(-1) * (  - 8*s12*
     +    s14*S24**(-1) )

      LA = LA + log(s13**(-1)*s134)*S13**(-1)*S34**(-1) * (  - 22*s12*
     +    s23*S24**(-1) - 16*s14*s23*S24**(-1) - 4*s23**2*S24**(-1) )

      LA = LA + log(s13**(-1)*s134)*S13**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 12*s12**3*S24**(-1) + 16*s12**2*s14*S24**(-1) + 14*s12*
     +    s14*s23*S24**(-1) - 8*s14**2*s23*S24**(-1) - 8*s14**2 )

      LA = LA + log(s13**(-1)*s134)*S13**(-1)*S234**(-1) * (  - 16*
     +    s12**2*S24**(-1) + 8*s12*s14*S24**(-1) )

      LA = LA + log(s13**(-1)*s134)*S13**(-1)*S134**(-1) * (  - 12*
     +    s12**3*S14**(-1)*S24**(-1) + 16*s12**2*s23*S14**(-1)*
     +    S24**(-1) + 24*s12**2*S24**(-1) + 24*s12*s14*S24**(-1) + 4*
     +    s12*s23**2*S14**(-1)*S24**(-1) + 14*s12*s23*S24**(-1) + 16*
     +    s12 + 16*s14*s23*S24**(-1) + 16*s14 + 8*s23**2*S24**(-1) + 24
     +    *s23 + 24*s24 )

      LA = LA + log(s13**(-1)*s134)*S13**(-1)*S134**(-2) * (  - 24*s12*
     +    s14 - 24*s14*s23 - 24*s14*s24 )

      LA = LA + log(s13**(-1)*s134)*S13**(-1) * ( 24*s12**2*S14**(-1)*
     +    S24**(-1) + 4*s12*s23*S14**(-1)*S24**(-1) + 8*s12*S14**(-1) )

      LA = LA + log(s13**(-1)*s134)*S23**(-1)*S34**(-1)*S134**(-1) * ( 
     +    4*s12**2 + 24*s12*s13 + 8*s12*s24 + 12*s13**2 - 32*s13*s24 + 
     +    8*s24**2 )

      LA = LA + log(s13**(-1)*s134)*S23**(-1)*S34**(-1) * ( 28*s12**2*
     +    S14**(-1) + 8*s12*s13*S14**(-1) - 8*s12*s24*S14**(-1) + 32*
     +    s12 - 12*s13**2*S14**(-1) - 8*s24**2*S14**(-1) )

      LA = LA + log(s13**(-1)*s134)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * ( 32*s12**2*s13*S24**(-1) + 32*s12**2*s14*S24**(-1) + 16*s12*
     +    s13**2*S24**(-1) + 16*s12*s13*s14*S24**(-1) + 20*s12*s13 + 24
     +    *s12*s14 - 8*s12*s24 - 20*s13**2 - 32*s13*s14 - 24*s13*s24 - 
     +    24*s14*s24 )

      LA = LA + log(s13**(-1)*s134)*S23**(-1)*S234**(-1) * (  - 20*s12*
     +    s13*S24**(-1) - 8*s12*s14*S24**(-1) - 40*s12 - 24*s14 )

      LA = LA + log(s13**(-1)*s134)*S23**(-1)*S134**(-1) * ( 8*s12**2*
     +    S14**(-1) - 32*s12*s13*S24**(-1) - 32*s12*s14*S24**(-1) + 16*
     +    s12*s24*S14**(-1) + 88*s12 + 32*s13 + 24*s14 + 8*s24**2*
     +    S14**(-1) )

      LA = LA + log(s13**(-1)*s134)*S23**(-1) * (  - 16*s12*S14**(-1) )

      LA = LA + log(s13**(-1)*s134)*S34**(-1)*S134**(-1) * ( 52*s12 + 
     +    32*s13 + 18*s23 - 16*s24 )

      LA = LA + log(s13**(-1)*s134)*S34**(-1) * ( 32 - 16*s23*S24**(-1)
     +     + 16*s24*S14**(-1) )

      LA = LA + log(s13**(-1)*s134)*S234**(-1)*S134**(-1) * ( 32*s12**2
     +    *S24**(-1) + 24*s12*s13*S24**(-1) + 12*s12*s14*S24**(-1) + 14
     +    *s12*s23*S24**(-1) - 16*s12 + 24*s13**2*S24**(-1) + 24*s13*
     +    s14*S24**(-1) - 32*s13 - 8*s14*s23*S24**(-1) - 8*s14 - 6*s23
     +     )

      LA = LA + log(s13**(-1)*s134)*S234**(-1) * (  - 8 + 8*s12*
     +    S24**(-1) - 24*s13*S24**(-1) + 16*s23*S24**(-1) )

      LA = LA + log(s13**(-1)*s134)*S134**(-1) * ( 16 - 4*s12*s23*
     +    S14**(-1)*S24**(-1) + 16*s12*S14**(-1) + 48*s12*S24**(-1) + 
     +    12*s13*S14**(-1) + 24*s13*S24**(-1) - 12*s23*S14**(-1) + 40*
     +    s23*S24**(-1) - 8*s24*S14**(-1) )

      LA = LA + log(s13**(-1)*s134)*S134**(-2) * ( 16*s12 + 16*s23 + 16
     +    *s24 )

      LA = LA + log(s13**(-1)*s134) * ( 36*s12*S14**(-1)*S24**(-1) )

      LA = LA + log(s14**(-1)*s134)*S13**(-1)*S23**(-1)*S34**(-1)*
     + S234**(-1)*S134**(-1) * ( 8*s13*s14*s23**4*S14**(-1)*S24**(-1)
     +     + 8*s13*s14*s23**3*s24*S14**(-1)*S24**(-1) + 8*s13*s14*
     +    s23**3*s34*S14**(-1)*S24**(-1) )

      LA = LA + log(s14**(-1)*s134)*S13**(-1)*S23**(-1)*S134**(-1) * ( 
     +     - 12*s12**3*S14**(-1) + 16*s12**2*s24*S14**(-1) + 4*s12*
     +    s24**2*S14**(-1) - 4*s12*s24 )

      LA = LA + log(s14**(-1)*s134)*S13**(-1)*S23**(-1) * ( 24*s12**2*
     +    S14**(-1) + 4*s12*s24*S14**(-1) + 36*s12 )

      LA = LA + log(s14**(-1)*s134)*S13**(-1)*S34**(-1) * ( 28*s12**2*
     +    S24**(-1) + 8*s12*s14*S24**(-1) - 8*s12*s23*S24**(-1) - 12*
     +    s14**2*S24**(-1) - 8*s23**2*S24**(-1) + 16*s23 )

      LA = LA + log(s14**(-1)*s134)*S13**(-1)*S134**(-1) * ( 8*s12**2*
     +    S24**(-1) + 16*s12*s23*S24**(-1) + 16*s12 + 12*s14 + 8*s23**2
     +    *S24**(-1) - 8*s23 - 12*s24 )

      LA = LA + log(s14**(-1)*s134)*S13**(-1) * ( 8*s12*S14**(-1) - 16*
     +    s12*S24**(-1) )

      LA = LA + log(s14**(-1)*s134)*S23**(-1)*S34**(-1) * (  - 22*s12*
     +    s24*S14**(-1) - 16*s13*s24*S14**(-1) - 4*s24**2*S14**(-1) - 
     +    16*s24 )

      LA = LA + log(s14**(-1)*s134)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 12*s12**3*S14**(-1) + 16*s12**2*s13*S14**(-1) + 32*
     +    s12**2*s13*S24**(-1) + 32*s12**2*s14*S24**(-1) + 32*s12**2 - 
     +    16*s12*s13**2*S24**(-1) - 16*s12*s13*s14*S24**(-1) + 14*s12*
     +    s13*s24*S14**(-1) + 28*s12*s13 + 40*s12*s14 + 14*s12*s24 - 8*
     +    s13**2*s24*S14**(-1) - 24*s13**2 - 24*s13*s14 + 16*s13*s24 + 
     +    24*s14*s24 )

      LA = LA + log(s14**(-1)*s134)*S23**(-1)*S234**(-1) * ( 16*s12**2*
     +    s13*S14**(-1)*S24**(-1) - 16*s12**2*S14**(-1) - 8*s12*s13**2*
     +    S14**(-1)*S24**(-1) + 8*s12*s13*S14**(-1) + 8*s12*s13*
     +    S24**(-1) - 4*s12*s14*S24**(-1) + 8*s12 + 24*s13 + 16*s24 )

      LA = LA + log(s14**(-1)*s134)*S23**(-1)*S134**(-1) * ( 24*s12**2*
     +    S14**(-1) + 24*s12*s13*S14**(-1) - 48*s12*s13*S24**(-1) - 48*
     +    s12*s14*S24**(-1) + 14*s12*s24*S14**(-1) + 48*s12 + 16*s13*
     +    s24*S14**(-1) - 24*s13 + 8*s24**2*S14**(-1) + 40*s24 )

      LA = LA + log(s14**(-1)*s134)*S23**(-1) * (  - 8*s12*s13*
     +    S14**(-1)*S24**(-1) )

      LA = LA + log(s14**(-1)*s134)*S34**(-1)*S134**(-1) * ( 4*s12**2*
     +    S24**(-1) - 24*s12*s13*S24**(-1) - 20*s12*s23*S24**(-1) + 52*
     +    s12 + 12*s13**2*S24**(-1) + 80*s13*s23*S24**(-1) - 32*s13 - 
     +    32*s23 + 18*s24 )

      LA = LA + log(s14**(-1)*s134)*S34**(-1) * ( 64 + 56*s12*S24**(-1)
     +     - 12*s13*S24**(-1) + 12*s14*S24**(-1) - 56*s23*S24**(-1) )

      LA = LA + log(s14**(-1)*s134)*S234**(-1)*S134**(-1) * (  - 12*
     +    s12**3*S14**(-1)*S24**(-1) + 16*s12**2*s13*S14**(-1)*
     +    S24**(-1) - 8*s12*s13*s23*S14**(-1)*S24**(-1) + 40*s12*s13*
     +    S24**(-1) + 36*s12*s14*S24**(-1) - 8*s12*s23*S24**(-1) - 16*
     +    s12 - 8*s13**2*S14**(-1) + 20*s13**2*S24**(-1) + 8*s13*s14*
     +    S24**(-1) - 44*s13*s23*S24**(-1) - 10*s13 - 44*s14*s23*
     +    S24**(-1) - 34*s14 + 6*s23 )

      LA = LA + log(s14**(-1)*s134)*S234**(-1) * (  - 2 - 16*s12**2*
     +    S14**(-1)*S24**(-1) - 8*s12*s13*S14**(-1)*S24**(-1) - 40*s12*
     +    S24**(-1) - 44*s13*S24**(-1) - 20*s14*S24**(-1) )

      LA = LA + log(s14**(-1)*s134)*S134**(-1) * (  - 22 + 24*s12*s13*
     +    S14**(-1)*S24**(-1) + 16*s12*S14**(-1) + 64*s12*S24**(-1) + 
     +    16*s13*S14**(-1) + 56*s13*S24**(-1) + 40*s14*S24**(-1) + 24*
     +    s23*S14**(-1) + 56*s23*S24**(-1) + 24*s24*S14**(-1) )

      LA = LA + log(s14**(-1)*s134)*S134**(-2) * (  - 24*s12*s13*
     +    S14**(-1) + 16*s12 - 24*s13*s23*S14**(-1) - 24*s13*s24*
     +    S14**(-1) + 16*s23 + 16*s24 )

      LA = LA + log(s23**(-1)*s234)*S13**(-1)*S23**(-1)*S34**(-1)*
     + S234**(-1)*S134**(-1) * (  - 44*s12*s13*s14**2*s23**2*S14**(-1)*
     +    S24**(-1) - 44*s12*s14**3*s23**2*S14**(-1)*S24**(-1) - 44*s12
     +    *s14**2*s23**2*s34*S14**(-1)*S24**(-1) - 16*s13**2*s14**2*
     +    s23**2*S14**(-1)*S24**(-1) - 16*s13*s14**3*s23**2*S14**(-1)*
     +    S24**(-1) - 24*s13*s14**2*s23**3*S14**(-1)*S24**(-1) - 16*s13
     +    *s14**2*s23**2*s34*S14**(-1)*S24**(-1) - 32*s14**3*s23**3*
     +    S14**(-1)*S24**(-1) - 24*s14**2*s23**3*s34*S14**(-1)*
     +    S24**(-1) )

      LA = LA + log(s23**(-1)*s234)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 12*s12**3 + 16*s12**2*s14 - 8*s12*s14*s24 )

      LA = LA + log(s23**(-1)*s234)*S13**(-1)*S23**(-1)*S234**(-1) * ( 
     +     - 16*s12**2 + 24*s12*s24 )

      LA = LA + log(s23**(-1)*s234)*S13**(-1)*S23**(-1)*S134**(-1) * ( 
     +    16*s12**2*s24*S14**(-1) - 8*s12*s24**2*S14**(-1) - 8*s12*s24
     +     )

      LA = LA + log(s23**(-1)*s234)*S13**(-1)*S23**(-1) * (  - 8*s12*
     +    s24*S14**(-1) )

      LA = LA + log(s23**(-1)*s234)*S13**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 28*s12**2 + 8*s12*s14 - 8*s12*s23 + 8*s14**2 - 32*s14*s23
     +     + 12*s23**2 )

      LA = LA + log(s23**(-1)*s234)*S13**(-1)*S34**(-1) * ( 28*s12**2*
     +    S24**(-1) - 8*s12*s14*S24**(-1) + 8*s12*s23*S24**(-1) - 8*
     +    s14**2*S24**(-1) - 12*s23**2*S24**(-1) )

      LA = LA + log(s23**(-1)*s234)*S13**(-1)*S234**(-1)*S134**(-1)
     +  * ( 48*s12**2 + 48*s12*s14 + 44*s12*s23 - 56*s14*s23 - 24*s14*
     +    s24 + 12*s23**2 )

      LA = LA + log(s23**(-1)*s234)*S13**(-1)*S234**(-1) * (  - 32*
     +    s12**2*S14**(-1) + 8*s12**2*S24**(-1) + 16*s12*s14*S24**(-1)
     +     - 48*s12*s23*S14**(-1) - 32*s12*s24*S14**(-1) + 64*s12 + 8*
     +    s14**2*S24**(-1) + 64*s23 + 24*s24 )

      LA = LA + log(s23**(-1)*s234)*S13**(-1)*S134**(-1) * ( 32*s12**2*
     +    S14**(-1) - 4*s12*s23*S14**(-1) - 8*s12*s24*S14**(-1) + 16*
     +    s12 - 32*s23 - 24*s24 )

      LA = LA + log(s23**(-1)*s234)*S13**(-1) * (  - 16*s12*S24**(-1) )

      LA = LA + log(s23**(-1)*s234)*S23**(-1)*S34**(-1) * (  - 22*s12*
     +    s13*S14**(-1) - 4*s13**2*S14**(-1) - 16*s13*s24*S14**(-1) )

      LA = LA + log(s23**(-1)*s234)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 12*s12**3*S14**(-1) + 16*s12**2*s13*S14**(-1) + 32*
     +    s12**2 + 14*s12*s13*s24*S14**(-1) - 6*s12*s13 - 6*s12*s14 + 6
     +    *s12*s24 - 8*s13**2*s24*S14**(-1) - 16*s13*s24 - 8*s14*s24 )

      LA = LA + log(s23**(-1)*s234)*S23**(-1)*S234**(-1) * (  - 12*
     +    s12**3*S14**(-1)*S24**(-1) + 16*s12**2*s13*S14**(-1)*
     +    S24**(-1) + 8*s12**2*S14**(-1) + 4*s12*s13**2*S14**(-1)*
     +    S24**(-1) + 14*s12*s13*S14**(-1) + 24*s12*s24*S14**(-1) + 22*
     +    s12 + 8*s13**2*S14**(-1) + 24*s13*s24*S14**(-1) + 24*s13 + 24
     +    *s14 + 24*s24 )

      LA = LA + log(s23**(-1)*s234)*S23**(-1)*S234**(-2) * (  - 24*s12*
     +    s24 - 24*s13*s24 - 24*s14*s24 )

      LA = LA + log(s23**(-1)*s234)*S23**(-1)*S134**(-1) * ( 8*s12*s24*
     +    S14**(-1) - 6*s12 - 8*s13*s24*S14**(-1) - 8*s24 )

      LA = LA + log(s23**(-1)*s234)*S23**(-1) * ( 24*s12**2*S14**(-1)*
     +    S24**(-1) + 4*s12*s13*S14**(-1)*S24**(-1) + 8*s12*S24**(-1) )

      LA = LA + log(s23**(-1)*s234)*S34**(-1)*S234**(-1) * ( 44*s12 + 
     +    18*s13 - 16*s14 + 32*s23 )

      LA = LA + log(s23**(-1)*s234)*S34**(-1) * ( 32 - 16*s13*S14**(-1)
     +     + 16*s14*S24**(-1) )

      LA = LA + log(s23**(-1)*s234)*S234**(-1)*S134**(-1) * ( 48*s12**2
     +    *S14**(-1) + 26*s12*s13*S14**(-1) + 28*s12*s23*S14**(-1) + 82
     +    *s12 - 8*s13**2*S14**(-1) + 32*s13*s23*S14**(-1) + 8*s13*s24*
     +    S14**(-1) + 2*s13 + 16*s14 - 56*s23 - 16*s24 )

      LA = LA + log(s23**(-1)*s234)*S234**(-1) * (  - 4*s12*s13*
     +    S14**(-1)*S24**(-1) + 36*s12*S14**(-1) + 16*s12*S24**(-1) + 
     +    48*s13*S14**(-1) - 12*s13*S24**(-1) - 8*s14*S24**(-1) + 12*
     +    s23*S24**(-1) )

      LA = LA + log(s23**(-1)*s234)*S234**(-2) * ( 16*s12 + 16*s13 + 16
     +    *s14 )

      LA = LA + log(s23**(-1)*s234)*S134**(-1) * ( 8 + 20*s12*S14**(-1)
     +     + 8*s13*S14**(-1) )

      LA = LA + log(s23**(-1)*s234) * ( 36*s12*S14**(-1)*S24**(-1) )

      LA = LA + log(s24**(-1)*s234)*S13**(-1)*S23**(-1)*S34**(-1)*
     + S234**(-1)*S134**(-1) * ( 44*s12*s13**3*s23*s24*S14**(-1)*
     +    S24**(-1) - 44*s12*s13**3*s24**2*S14**(-1)*S24**(-1) + 44*s12
     +    *s13**2*s14*s23*s24*S14**(-1)*S24**(-1) - 44*s12*s13**2*s14*
     +    s24**2*S14**(-1)*S24**(-1) + 44*s12*s13**2*s23*s24*s34*
     +    S14**(-1)*S24**(-1) - 44*s12*s13**2*s24**2*s34*S14**(-1)*
     +    S24**(-1) + 16*s13**4*s23*s24*S14**(-1)*S24**(-1) - 8*s13**4*
     +    s24**2*S14**(-1)*S24**(-1) + 32*s13**3*s14*s23*s24*S14**(-1)*
     +    S24**(-1) - 24*s13**3*s14*s24**2*S14**(-1)*S24**(-1) - 32*
     +    s13**3*s23**2*s24*S14**(-1)*S24**(-1) + 32*s13**3*s23*s24**2*
     +    S14**(-1)*S24**(-1) + 16*s13**3*s23*s24*s34*S14**(-1)*
     +    S24**(-1) - 32*s13**3*s24**3*S14**(-1)*S24**(-1) - 8*s13**3*
     +    s24**2*s34*S14**(-1)*S24**(-1) + 16*s13**2*s14**2*s23*s24*
     +    S14**(-1)*S24**(-1) - 16*s13**2*s14**2*s24**2*S14**(-1)*
     +    S24**(-1) - 24*s13**2*s14*s23**2*s24*S14**(-1)*S24**(-1) + 24
     +    *s13**2*s14*s23*s24**2*S14**(-1)*S24**(-1) + 16*s13**2*s14*
     +    s23*s24*s34*S14**(-1)*S24**(-1) )

      LA = LA + log(s24**(-1)*s234)*S13**(-1)*S23**(-1)*S34**(-1)*
     + S234**(-1)*S134**(-1) * (  - 24*s13**2*s14*s24**3*S14**(-1)*
     +    S24**(-1) - 16*s13**2*s14*s24**2*s34*S14**(-1)*S24**(-1) - 24
     +    *s13**2*s23**2*s24*s34*S14**(-1)*S24**(-1) + 24*s13**2*s23*
     +    s24**2*s34*S14**(-1)*S24**(-1) - 24*s13**2*s24**3*s34*
     +    S14**(-1)*S24**(-1) )

      LA = LA + log(s24**(-1)*s234)*S13**(-1)*S23**(-1)*S234**(-1) * ( 
     +     - 12*s12**3*S24**(-1) + 16*s12**2*s14*S24**(-1) + 4*s12*
     +    s14**2*S24**(-1) - 4*s12*s14 )

      LA = LA + log(s24**(-1)*s234)*S13**(-1)*S23**(-1) * ( 24*s12**2*
     +    S24**(-1) + 4*s12*s14*S24**(-1) + 36*s12 )

      LA = LA + log(s24**(-1)*s234)*S13**(-1)*S34**(-1) * (  - 22*s12*
     +    s14*S24**(-1) - 4*s14**2*S24**(-1) - 16*s14*s23*S24**(-1) - 
     +    16*s14 )

      LA = LA + log(s24**(-1)*s234)*S13**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 12*s12**3*S24**(-1) + 16*s12**2*s14*S24**(-1) + 48*
     +    s12**2 + 14*s12*s14*s23*S24**(-1) + 54*s12*s14 - 28*s12*s23
     +     - 8*s14**2*s23*S24**(-1) - 8*s14**2 + 8*s14*s23 + 32*s14*s24
     +     )

      LA = LA + log(s24**(-1)*s234)*S13**(-1)*S234**(-1) * (  - 32*
     +    s12**2*S14**(-1) + 8*s12**2*S24**(-1) + 14*s12*s14*S24**(-1)
     +     - 32*s12*s23*S14**(-1) + 24*s12*s23*S24**(-1) - 48*s12*s24*
     +    S14**(-1) + 8*s12 + 8*s14**2*S24**(-1) + 24*s14*s23*S24**(-1)
     +     + 48*s14 )

      LA = LA + log(s24**(-1)*s234)*S13**(-1)*S134**(-1) * ( 16*s12**2*
     +    s23*S14**(-1)*S24**(-1) + 32*s12**2*S14**(-1) - 8*s12*s23**2*
     +    S14**(-1)*S24**(-1) - 8*s12*s23*S14**(-1) + 8*s12*s23*
     +    S24**(-1) - 4*s12*s24*S14**(-1) + 48*s12 - 8*s14*s23*
     +    S24**(-1) + 8*s14 )

      LA = LA + log(s24**(-1)*s234)*S13**(-1) * (  - 8*s12*s23*
     +    S14**(-1)*S24**(-1) )

      LA = LA + log(s24**(-1)*s234)*S23**(-1)*S34**(-1) * ( 28*s12**2*
     +    S14**(-1) - 8*s12*s13*S14**(-1) + 8*s12*s24*S14**(-1) - 8*
     +    s13**2*S14**(-1) + 16*s13 - 12*s24**2*S14**(-1) )

      LA = LA + log(s24**(-1)*s234)*S23**(-1)*S234**(-1) * ( 8*s12**2*
     +    S14**(-1) + 16*s12*s13*S14**(-1) + 16*s12 + 8*s13**2*
     +    S14**(-1) - 8*s13 - 12*s14 + 12*s24 )

      LA = LA + log(s24**(-1)*s234)*S23**(-1) * (  - 16*s12*S14**(-1)
     +     + 8*s12*S24**(-1) )

      LA = LA + log(s24**(-1)*s234)*S34**(-1)*S234**(-1) * (  - 28*
     +    s12**2*S14**(-1) - 36*s12*s13*S14**(-1) + 8*s12*s23*S14**(-1)
     +     + 44*s12 + 80*s13*s23*S14**(-1) - 32*s13 + 18*s14 + 12*
     +    s23**2*S14**(-1) - 32*s23 )

      LA = LA + log(s24**(-1)*s234)*S34**(-1) * ( 64 - 8*s12*S14**(-1)
     +     - 56*s13*S14**(-1) - 12*s23*S14**(-1) + 12*s24*S14**(-1) )

      LA = LA + log(s24**(-1)*s234)*S234**(-1)*S134**(-1) * (  - 12*
     +    s12**3*S14**(-1)*S24**(-1) + 16*s12**2*s13*S14**(-1)*
     +    S24**(-1) + 48*s12**2*S14**(-1) + 32*s12**2*S24**(-1) - 8*s12
     +    *s13*s23*S14**(-1)*S24**(-1) + 92*s12*s13*S14**(-1) - 6*s12*
     +    s13*S24**(-1) - 6*s12*s14*S24**(-1) - 44*s12*s23*S14**(-1) + 
     +    6*s12*s23*S24**(-1) + 154*s12 - 36*s13*s23*S14**(-1) - 8*s13*
     +    s23*S24**(-1) - 44*s13*s24*S14**(-1) - 16*s13 - 16*s14*s23*
     +    S24**(-1) - 30*s14 + 12*s23**2*S14**(-1) + 4*s23 - 12*s24 )

      LA = LA + log(s24**(-1)*s234)*S234**(-1) * (  - 16*s12**2*
     +    S14**(-1)*S24**(-1) + 24*s12*s23*S14**(-1)*S24**(-1) + 28*s12
     +    *S14**(-1) + 22*s12*S24**(-1) + 56*s13*S14**(-1) + 24*s13*
     +    S24**(-1) + 24*s14*S24**(-1) + 48*s23*S14**(-1) + 24*s23*
     +    S24**(-1) + 40*s24*S14**(-1) )

      LA = LA + log(s24**(-1)*s234)*S234**(-2) * (  - 24*s12*s23*
     +    S24**(-1) + 16*s12 - 24*s13*s23*S24**(-1) + 16*s13 - 24*s14*
     +    s23*S24**(-1) + 16*s14 )

      LA = LA + log(s24**(-1)*s234)*S134**(-1) * (  - 24 - 8*s12*s23*
     +    S14**(-1)*S24**(-1) + 60*s12*S14**(-1) - 6*s12*S24**(-1) - 36
     +    *s23*S14**(-1) - 8*s23*S24**(-1) - 20*s24*S14**(-1) )

      LA = LA + log(s34**(-1)*s234)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 24*s12**3*s14*S24**(-1) + 16*s12**3 + 52*s12**2*
     +    s14 + 16*s12*s14*s24 )

      LA = LA + log(s34**(-1)*s234)*S13**(-1)*S23**(-1)*S234**(-1) * ( 
     +     - 24*s12**3*S24**(-1) - 16*s12**2 + 8*s12*s14 - 32*s12*s24 )

      LA = LA + log(s34**(-1)*s234)*S13**(-1)*S23**(-1)*S134**(-1) * ( 
     +    28*s12**2*s14*S24**(-1) + 16*s12**2 + 40*s12*s14 + 16*s12*s24
     +     )

      LA = LA + log(s34**(-1)*s234)*S13**(-1)*S23**(-1) * (  - 16*
     +    s12**2*S24**(-1) + 8*s12*s14*S24**(-1) - 16*s12*s34*S24**(-1)
     +     + 48*s12 )

      LA = LA + log(s34**(-1)*s234)*S13**(-1)*S234**(-1)*S134**(-1)
     +  * ( 16*s12**3*S24**(-1) + 52*s12**2*s14*S24**(-1) + 38*s12*s14*
     +    s23*S24**(-1) + 118*s12*s14 - 8*s14*s23 - 24*s14*s24 )

      LA = LA + log(s34**(-1)*s234)*S13**(-1)*S234**(-1) * (  - 32*
     +    s12**2*S24**(-1) - 10*s12*s14*S24**(-1) - 40*s12*s23*
     +    S24**(-1) - 72*s12 - 16*s14*s23*S24**(-1) - 16*s14 - 8*s23 - 
     +    8*s24 )

      LA = LA + log(s34**(-1)*s234)*S13**(-1)*S134**(-1) * ( 16*s12**2*
     +    S24**(-1) - 14*s12*s14*S24**(-1) + 16*s12*s23*S24**(-1) + 16*
     +    s12 + 48*s14 )

      LA = LA + log(s34**(-1)*s234)*S13**(-1) * ( 48*s12*S24**(-1) - 16
     +    *s14*S24**(-1) + 32*s34*S24**(-1) )

      LA = LA + log(s34**(-1)*s234)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * ( 24*s12**3*s13*S14**(-1)*S24**(-1) + 16*s12**3*S14**(-1) + 
     +    48*s12**3*S24**(-1) + 52*s12**2*s13*S14**(-1) + 104*s12**2 + 
     +    38*s12*s13*s24*S14**(-1) - 10*s12*s13 - 10*s12*s14 + 54*s12*
     +    s24 )

      LA = LA + log(s34**(-1)*s234)*S23**(-1)*S234**(-1) * (  - 24*
     +    s12**3*S14**(-1)*S24**(-1) - 16*s12**2*S14**(-1) - 2*s12*s13*
     +    S14**(-1) - 24*s12*s24*S14**(-1) + 6*s12 - 16*s13*s24*
     +    S14**(-1) + 8*s13 - 24*s14 + 48*s24 )

      LA = LA + log(s34**(-1)*s234)*S23**(-1)*S234**(-2) * ( 40*s12*s24
     +     + 40*s13*s24 + 40*s14*s24 )

      LA = LA + log(s34**(-1)*s234)*S23**(-1)*S134**(-1) * ( 28*s12**2*
     +    s13*S14**(-1)*S24**(-1) + 16*s12**2*S14**(-1) + 56*s12**2*
     +    S24**(-1) - 14*s12*s13*S14**(-1) + 16*s12*s24*S14**(-1) + 26*
     +    s12 )

      LA = LA + log(s34**(-1)*s234)*S23**(-1) * ( 16 - 32*s12**2*
     +    S14**(-1)*S24**(-1) + 32*s12*S14**(-1) + 32*s12*S24**(-1) - 
     +    16*s13*S14**(-1) - 32*s34*S14**(-1) )

      LA = LA + log(s34**(-1)*s234)*S234**(-1)*S134**(-1) * ( 16*s12**3
     +    *S14**(-1)*S24**(-1) + 52*s12**2*s13*S14**(-1)*S24**(-1) + 
     +    104*s12**2*S24**(-1) + 16*s12*s13*s23*S14**(-1)*S24**(-1) + 
     +    118*s12*s13*S14**(-1) - 10*s12*s13*S24**(-1) - 10*s12*s14*
     +    S24**(-1) + 54*s12*s23*S24**(-1) + 172*s12 - 16*s13*s23*
     +    S14**(-1) - 16*s13 - 16*s14 - 24*s23 - 24*s24 )

      LA = LA + log(s34**(-1)*s234)*S234**(-1) * ( 24 + 16*s12*s13*
     +    S14**(-1)*S24**(-1) - 16*s12*s23*S14**(-1)*S24**(-1) - 40*s12
     +    *S14**(-1) + 6*s12*S24**(-1) - 16*s13*S14**(-1) - 24*s13*
     +    S24**(-1) + 8*s14*S24**(-1) - 8*s23*S14**(-1) + 56*s23*
     +    S24**(-1) - 8*s24*S14**(-1) )

      LA = LA + log(s34**(-1)*s234)*S234**(-2) * ( 40*s12*s23*S24**(-1)
     +     - 16*s12 + 40*s13*s23*S24**(-1) - 16*s13 + 40*s14*s23*
     +    S24**(-1) - 16*s14 )

      LA = LA + log(s34**(-1)*s234)*S134**(-1) * ( 32 + 16*s12**2*
     +    S14**(-1)*S24**(-1) + 40*s12*s13*S14**(-1)*S24**(-1) + 16*s12
     +    *s23*S14**(-1)*S24**(-1) + 16*s12*S14**(-1) + 26*s12*
     +    S24**(-1) + 32*s13*S14**(-1) )

      LA = LA + log(s34**(-1)*s234) * ( 32*s12*S14**(-1)*S24**(-1) - 8*
     +    S14**(-1) + 24*S24**(-1) )

      LA = LA + log(s34**(-1)*s134)*S13**(-1)*S23**(-1)*S34**(-1) * ( 
     +     - 32*s12**2 - 32*s12*s14 - 32*s12*s24 - 32*s14**2 + 16*s14*
     +    s24 - 32*s24**2 )

      LA = LA + log(s34**(-1)*s134)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 12*s12**2*s14 - 16*s12*s14*s24 )

      LA = LA + log(s34**(-1)*s134)*S13**(-1)*S23**(-1)*S234**(-1) * ( 
     +     - 24*s12**3*S14**(-1) + 28*s12**2*s24*S14**(-1) - 4*s12**2
     +     - 16*s12*s14 + 16*s12*s24 - 24*s14*s24 )

      LA = LA + log(s34**(-1)*s134)*S13**(-1)*S23**(-1)*S134**(-1) * ( 
     +     - 28*s12**2 - 24*s12*s14 - 8*s12*s24 - 24*s14*s24 )

      LA = LA + log(s34**(-1)*s134)*S13**(-1)*S23**(-1) * (  - 16*
     +    s12**2*S14**(-1) - 8*s12*s24*S14**(-1) - 16*s12*s34*S14**(-1)
     +     - 48*s12 - 32*s14 - 32*s24 - 32*s34 )

      LA = LA + log(s34**(-1)*s134)*S13**(-1)*S34**(-1) * (  - 16*s12*
     +    s14*S24**(-1) - 16*s12*s23*S24**(-1) - 64*s12 - 4*s14**2*
     +    S24**(-1) + 32*s14*s23*S24**(-1) + 16*s14 - 4*s23**2*
     +    S24**(-1) - 74*s23 - 64*s24 )

      LA = LA + log(s34**(-1)*s134)*S13**(-1)*S234**(-1)*S134**(-1)
     +  * ( 4*s12**2*s14*S24**(-1) + 22*s12*s14*s23*S24**(-1) - 100*s12
     +    *s14 + 24*s14**2*s23*S24**(-1) + 24*s14**2 - 30*s14*s23 + 4*
     +    s14*s24 )

      LA = LA + log(s34**(-1)*s134)*S13**(-1)*S234**(-1) * (  - 24*
     +    s12**3*S14**(-1)*S24**(-1) + 44*s12**2*s23*S14**(-1)*
     +    S24**(-1) + 72*s12**2*S14**(-1) - 4*s12**2*S24**(-1) + 24*s12
     +    *s14*S24**(-1) + 58*s12*s23*S24**(-1) + 100*s12 + 4*s14**2*
     +    S24**(-1) + 20*s14*s23*S24**(-1) - 12*s14 )

      LA = LA + log(s34**(-1)*s134)*S13**(-1)*S134**(-1) * ( 4*s12**2*
     +    S24**(-1) + 48*s12*s14*S24**(-1) - 10*s12*s23*S24**(-1) + 20*
     +    s12 + 28*s14*s23*S24**(-1) - 12*s14 + 4*s23**2*S24**(-1) + 42
     +    *s23 + 32*s24 )

      LA = LA + log(s34**(-1)*s134)*S13**(-1) * (  - 64 - 32*s12**2*
     +    S14**(-1)*S24**(-1) - 16*s12*S14**(-1) - 192*s12*S24**(-1) - 
     +    32*s14*S24**(-1) - 48*s23*S24**(-1) - 24*s34*S24**(-1) )

      LA = LA + log(s34**(-1)*s134)*S23**(-1)*S34**(-1) * (  - 16*s12*
     +    s13*S14**(-1) - 16*s12*s24*S14**(-1) - 64*s12 - 4*s13**2*
     +    S14**(-1) + 32*s13*s24*S14**(-1) - 74*s13 - 64*s14 - 4*s24**2
     +    *S14**(-1) + 16*s24 )

      LA = LA + log(s34**(-1)*s134)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * ( 8*s12**3*S14**(-1) + 20*s12**2*s13*S14**(-1) + 8*s12**2 + 
     +    22*s12*s13*s24*S14**(-1) - 8*s12*s13 - 8*s12*s14 + 6*s12*s24
     +     + 24*s13**2*s24*S14**(-1) - 18*s13**2 - 18*s13*s14 + 28*s13*
     +    s24 + 4*s14*s24 )

      LA = LA + log(s34**(-1)*s134)*S23**(-1)*S234**(-1) * (  - 20*
     +    s12**2*S14**(-1) + 24*s12*s13*S14**(-1) + 58*s12*s24*
     +    S14**(-1) + 56*s12 + 4*s13**2*S14**(-1) + 20*s13*s24*
     +    S14**(-1) + 52*s13 + 56*s14 - 36*s24 )

      LA = LA + log(s34**(-1)*s134)*S23**(-1)*S234**(-2) * (  - 40*s12*
     +    s24 - 40*s13*s24 - 40*s14*s24 )

      LA = LA + log(s34**(-1)*s134)*S23**(-1)*S134**(-1) * ( 4*s12**2*
     +    S14**(-1) + 32*s12*s13*S14**(-1) - 2*s12*s24*S14**(-1) - 8*
     +    s12 + 28*s13*s24*S14**(-1) - 26*s13 - 8*s14 + 4*s24**2*
     +    S14**(-1) - 4*s24 )

      LA = LA + log(s34**(-1)*s134)*S23**(-1) * (  - 80 - 176*s12*
     +    S14**(-1) - 48*s12*S24**(-1) - 32*s13*S14**(-1) - 48*s24*
     +    S14**(-1) + 40*s34*S14**(-1) )

      LA = LA + log(s34**(-1)*s134)*S34**(-1)*S234**(-1) * ( 128*s12 + 
     +    128*s13 + 128*s14 )

      LA = LA + log(s34**(-1)*s134)*S34**(-1)*S134**(-1) * ( 128*s12 + 
     +    128*s23 + 128*s24 )

      LA = LA + log(s34**(-1)*s134)*S34**(-1) * ( 160 - 32*s12**2*
     +    S14**(-1)*S24**(-1) - 32*s12*s13*S14**(-1)*S24**(-1) - 32*s12
     +    *s23*S14**(-1)*S24**(-1) - 64*s12*S14**(-1) - 64*s12*
     +    S24**(-1) - 32*s13**2*S14**(-1)*S24**(-1) + 16*s13*s23*
     +    S14**(-1)*S24**(-1) + 16*s13*S14**(-1) - 64*s13*S24**(-1) - 
     +    74*s14*S24**(-1) - 32*s23**2*S14**(-1)*S24**(-1) - 64*s23*
     +    S14**(-1) + 16*s23*S24**(-1) - 74*s24*S14**(-1) )

      LA = LA + log(s34**(-1)*s134)*S234**(-1)*S134**(-1) * ( 8*s12**3*
     +    S14**(-1)*S24**(-1) - 28*s12**2*s13*S14**(-1)*S24**(-1) - 24*
     +    s12**2*S24**(-1) - 16*s12*s13*s23*S14**(-1)*S24**(-1) - 100*
     +    s12*s13*S14**(-1) - 8*s12*s13*S24**(-1) - 8*s12*s14*S24**(-1)
     +     + 6*s12*s23*S24**(-1) - 136*s12 + 24*s13**2*S14**(-1) + 18*
     +    s13**2*S24**(-1) + 18*s13*s14*S24**(-1) + 4*s13*s23*S14**(-1)
     +     - 6*s13*s23*S24**(-1) - 30*s13*s24*S14**(-1) + 134*s13 + 18*
     +    s14*s23*S24**(-1) + 134*s14 - 26*s23 - 26*s24 )

      LA = LA + log(s34**(-1)*s134)*S234**(-1) * (  - 88 + 12*s12**2*
     +    S14**(-1)*S24**(-1) - 16*s12*s13*S14**(-1)*S24**(-1) + 16*s12
     +    *s23*S14**(-1)*S24**(-1) + 100*s12*S14**(-1) + 56*s12*
     +    S24**(-1) - 24*s13*s23*S14**(-1)*S24**(-1) - 12*s13*S14**(-1)
     +     + 38*s13*S24**(-1) + 34*s14*S24**(-1) - 52*s23*S24**(-1) )

      LA = LA + log(s34**(-1)*s134)*S234**(-2) * (  - 40*s12*s23*
     +    S24**(-1) - 16*s12 - 40*s13*s23*S24**(-1) - 16*s13 - 40*s14*
     +    s23*S24**(-1) - 16*s14 )

      LA = LA + log(s34**(-1)*s134)*S134**(-1) * ( 48 - 28*s12**2*
     +    S14**(-1)*S24**(-1) - 8*s12*s13*S14**(-1)*S24**(-1) - 16*s12*
     +    s23*S14**(-1)*S24**(-1) + 20*s12*S14**(-1) + 24*s12*S24**(-1)
     +     - 24*s13*s23*S14**(-1)*S24**(-1) - 4*s13*S14**(-1) + 10*s13*
     +    S24**(-1) - 8*s14*S24**(-1) + 32*s23*S14**(-1) - 4*s23*
     +    S24**(-1) + 42*s24*S14**(-1) )

      LA = LA + log(s34**(-1)*s134)*S134**(-2) * (  - 32*s12 - 32*s23
     +     - 32*s24 )

      LA = LA + log(s34**(-1)*s134) * (  - 64*s12*S14**(-1)*S24**(-1)
     +     - 32*s13*S14**(-1)*S24**(-1) - 32*s23*S14**(-1)*S24**(-1) - 
     +    32*s34*S14**(-1)*S24**(-1) - 56*S14**(-1) - 88*S24**(-1) )

      LA = LA + log(s234**(-1)*s1234)*S13**(-1)*S23**(-1)*S34**(-1)
     +  * ( 32*s12**2 + 32*s12*s14 + 32*s12*s24 + 32*s14**2 - 16*s14*
     +    s24 + 32*s24**2 )

      LA = LA + log(s234**(-1)*s1234)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s12**3 + 16*s12**2*s14 + 16*s12*s14*s24 )

      LA = LA + log(s234**(-1)*s1234)*S13**(-1)*S23**(-1)*S234**(-1)
     +  * (  - 12*s12**3*S24**(-1) + 16*s12**2*s14*S24**(-1) + 4*s12*
     +    s14**2*S24**(-1) + 12*s12*s14 - 16*s12*s24 + 24*s14*s24 )

      LA = LA + log(s234**(-1)*s1234)*S13**(-1)*S23**(-1)*S134**(-1)
     +  * (  - 48*s12**2*s24*S14**(-1) + 32*s12**2 - 4*s12*s14 + 80*s12
     +    *s24 - 32*s14*s24 + 4*s24**2 )

      LA = LA + log(s234**(-1)*s1234)*S13**(-1)*S23**(-1) * (  - 64*
     +    s12**2*s34*S14**(-1)*S24**(-1) - 96*s12**2*S14**(-1) + 24*
     +    s12**2*S24**(-1) + 4*s12*s14*S24**(-1) - 4*s12*s24*S14**(-1)
     +     - 16*s12*s34**2*S14**(-1)*S24**(-1) - 32*s12*s34*S14**(-1)
     +     + 48*s12*s34*S24**(-1) + 176*s12 - 48*s14*s34*S24**(-1) - 32
     +    *s14 + 72*s24 + 32*s34**2*S24**(-1) + 100*s34 )

      LA = LA + log(s234**(-1)*s1234)*S13**(-1)*S34**(-1) * ( 16*s12*
     +    s14*S24**(-1) + 64*s12 + 4*s14**2*S24**(-1) - 48*s14*s23*
     +    S24**(-1) - 16*s14 + 64*s23 + 64*s24 )

      LA = LA + log(s234**(-1)*s1234)*S13**(-1)*S234**(-1)*S134**(-1)
     +  * ( 16*s12**3*S24**(-1) + 16*s12**2*s14*S24**(-1) + 8*s12*s14*
     +    s23*S24**(-1) + 88*s12*s14 - 12*s14**2*s23*S24**(-1) - 12*
     +    s14**2 - 16*s14*s24 )

      LA = LA + log(s234**(-1)*s1234)*S13**(-1)*S234**(-1) * (  - 16*
     +    s12**2*S24**(-1) - 40*s12*s14*S24**(-1) - 40*s12*s23*
     +    S24**(-1) - 56*s12 - 4*s14**2*S24**(-1) - 16*s14*s23*
     +    S24**(-1) )

      LA = LA + log(s234**(-1)*s1234)*S13**(-1)*S134**(-1) * (  - 48*
     +    s12**2*s23*S14**(-1)*S24**(-1) - 64*s12**2*S14**(-1) + 32*
     +    s12**2*S24**(-1) - 60*s12*s14*S24**(-1) + 12*s12*s23*
     +    S14**(-1) + 48*s12*s23*S24**(-1) + 12*s12*s24*S14**(-1) + 44*
     +    s12 + 32*s14**2*S24**(-1) - 40*s14*s23*S24**(-1) - 56*s14 - 8
     +    *s23**2*S24**(-1) - 4*s23 + 28*s24 )

      LA = LA + log(s234**(-1)*s1234)*S13**(-1) * ( 168 - 96*s12**2*
     +    S14**(-1)*S24**(-1) - 4*s12*s23*S14**(-1)*S24**(-1) - 32*s12*
     +    s34*S14**(-1)*S24**(-1) - 24*s12*S14**(-1) + 252*s12*
     +    S24**(-1) - 48*s14*S24**(-1) + 100*s23*S24**(-1) + 88*s34*
     +    S24**(-1) )

      LA = LA + log(s234**(-1)*s1234)*S23**(-1)*S34**(-1) * ( 16*s12*
     +    s13*S14**(-1) + 64*s12 + 4*s13**2*S14**(-1) - 48*s13*s24*
     +    S14**(-1) + 74*s13 + 64*s14 - 32*s24 )

      LA = LA + log(s234**(-1)*s1234)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * ( 16*s12**3*S14**(-1) + 16*s12**2*s13*S14**(-1) + 32*s12**2
     +     + 8*s12*s13*s24*S14**(-1) + 8*s12*s13 + 8*s12*s14 + 24*s12*
     +    s24 - 12*s13**2*s24*S14**(-1) + 18*s13**2 + 18*s13*s14 - 12*
     +    s13*s24 )

      LA = LA + log(s234**(-1)*s1234)*S23**(-1)*S234**(-1) * (  - 12*
     +    s12**3*S14**(-1)*S24**(-1) + 16*s12**2*s13*S14**(-1)*
     +    S24**(-1) - 16*s12**2*S14**(-1) + 4*s12*s13**2*S14**(-1)*
     +    S24**(-1) - 40*s12*s13*S14**(-1) - 40*s12*s24*S14**(-1) - 32*
     +    s12 - 4*s13**2*S14**(-1) - 16*s13*s24*S14**(-1) - 44*s13 - 68
     +    *s14 + 60*s24 )

      LA = LA + log(s234**(-1)*s1234)*S23**(-1)*S234**(-2) * ( 40*s12*
     +    s24 + 40*s13*s24 + 40*s14*s24 )

      LA = LA + log(s234**(-1)*s1234)*S23**(-1)*S134**(-1) * ( 32*
     +    s12**2*S14**(-1) - 60*s12*s13*S14**(-1) + 48*s12*s24*
     +    S14**(-1) - 48*s12 + 32*s13**2*S14**(-1) - 40*s13*s24*
     +    S14**(-1) + 98*s13 + 48*s14 - 8*s24**2*S14**(-1) - 72*s24 )

      LA = LA + log(s234**(-1)*s1234)*S23**(-1) * (  - 72 + 24*s12**2*
     +    S14**(-1)*S24**(-1) + 4*s12*s13*S14**(-1)*S24**(-1) + 48*s12*
     +    s34*S14**(-1)*S24**(-1) + 252*s12*S14**(-1) + 64*s12*
     +    S24**(-1) - 48*s13*s34*S14**(-1)*S24**(-1) - 48*s13*S14**(-1)
     +     + 100*s24*S14**(-1) + 32*s34**2*S14**(-1)*S24**(-1) + 24*s34
     +    *S14**(-1) - 96*s34*S24**(-1) )

      LA = LA + log(s234**(-1)*s1234)*S34**(-1)*S234**(-1) * (  - 128*
     +    s12 - 128*s13 - 128*s14 )

      LA = LA + log(s234**(-1)*s1234)*S34**(-1)*S134**(-1) * (  - 128*
     +    s12 - 128*s23 - 128*s24 )

      LA = LA + log(s234**(-1)*s1234)*S34**(-1) * (  - 160 + 32*s12**2*
     +    S14**(-1)*S24**(-1) + 32*s12*s13*S14**(-1)*S24**(-1) + 32*s12
     +    *s23*S14**(-1)*S24**(-1) + 64*s12*S14**(-1) + 64*s12*
     +    S24**(-1) + 32*s13**2*S14**(-1)*S24**(-1) - 16*s13*s23*
     +    S14**(-1)*S24**(-1) - 16*s13*S14**(-1) + 64*s13*S24**(-1) + 
     +    74*s14*S24**(-1) + 32*s23**2*S14**(-1)*S24**(-1) + 64*s23*
     +    S14**(-1) - 32*s23*S24**(-1) + 64*s24*S14**(-1) )

      LA = LA + log(s234**(-1)*s1234)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3*S14**(-1)*S24**(-1) + 16*s12**2*s13*S14**(-1)*
     +    S24**(-1) + 32*s12**2*S24**(-1) + 16*s12*s13*s23*S14**(-1)*
     +    S24**(-1) + 88*s12*s13*S14**(-1) + 8*s12*s13*S24**(-1) + 8*
     +    s12*s14*S24**(-1) + 24*s12*s23*S24**(-1) + 112*s12 - 12*
     +    s13**2*S14**(-1) - 18*s13**2*S24**(-1) - 18*s13*s14*S24**(-1)
     +     - 16*s13*s23*S14**(-1) + 18*s13*s23*S24**(-1) - 58*s13 + 6*
     +    s14*s23*S24**(-1) - 58*s14 - 16*s23 - 16*s24 )

      LA = LA + log(s234**(-1)*s1234)*S234**(-1) * ( 8 + 12*s12*s13*
     +    S14**(-1)*S24**(-1) - 16*s12*s23*S14**(-1)*S24**(-1) - 56*s12
     +    *S14**(-1) - 32*s12*S24**(-1) + 24*s13*s23*S14**(-1)*
     +    S24**(-1) - 50*s13*S24**(-1) - 26*s14*S24**(-1) + 68*s23*
     +    S24**(-1) )

      LA = LA + log(s234**(-1)*s1234)*S234**(-2) * ( 40*s12*s23*
     +    S24**(-1) + 16*s12 + 40*s13*s23*S24**(-1) + 16*s13 + 40*s14*
     +    s23*S24**(-1) + 16*s14 )

      LA = LA + log(s234**(-1)*s1234)*S134**(-1) * (  - 176 + 32*s12**2
     +    *S14**(-1)*S24**(-1) - 4*s12*s13*S14**(-1)*S24**(-1) + 80*s12
     +    *s23*S14**(-1)*S24**(-1) + 44*s12*S14**(-1) - 48*s12*
     +    S24**(-1) - 32*s13*s23*S14**(-1)*S24**(-1) - 64*s13*S14**(-1)
     +     + 30*s13*S24**(-1) + 80*s14*S24**(-1) + 4*s23**2*S14**(-1)*
     +    S24**(-1) + 28*s23*S14**(-1) - 72*s23*S24**(-1) - 4*s24*
     +    S14**(-1) )

      LA = LA + log(s234**(-1)*s1234) * ( 176*s12*S14**(-1)*S24**(-1)
     +     - 32*s13*S14**(-1)*S24**(-1) + 72*s23*S14**(-1)*S24**(-1) + 
     +    100*s34*S14**(-1)*S24**(-1) + 160*S14**(-1) - 64*S24**(-1) )

      LA = LA + log(s134**(-1)*s1234)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12**3 - 16*s12**2*s14 - 16*s12*s14*s24 )

      LA = LA + log(s134**(-1)*s1234)*S13**(-1)*S23**(-1)*S234**(-1)
     +  * (  - 48*s12**2*s14*S24**(-1) + 16*s12**2 + 48*s12*s14 + 4*s12
     +    *s24 + 4*s14**2 - 56*s14*s24 )

      LA = LA + log(s134**(-1)*s1234)*S13**(-1)*S23**(-1)*S134**(-1)
     +  * (  - 12*s12**3*S14**(-1) + 16*s12**2*s24*S14**(-1) - 16*
     +    s12**2 - 8*s12*s14 + 4*s12*s24**2*S14**(-1) - 20*s12*s24 )

      LA = LA + log(s134**(-1)*s1234)*S13**(-1)*S23**(-1) * (  - 64*
     +    s12**2*s34*S14**(-1)*S24**(-1) + 24*s12**2*S14**(-1) - 96*
     +    s12**2*S24**(-1) - 4*s12*s14*S24**(-1) + 4*s12*s24*S14**(-1)
     +     - 16*s12*s34**2*S14**(-1)*S24**(-1) + 48*s12*s34*S14**(-1)
     +     - 32*s12*s34*S24**(-1) + 80*s12 + 40*s14 - 48*s24*s34*
     +    S14**(-1) - 64*s24 + 32*s34**2*S14**(-1) + 68*s34 )

      LA = LA + log(s134**(-1)*s1234)*S13**(-1)*S34**(-1) * (  - 16*s12
     +    *s14*S24**(-1) - 4*s14**2*S24**(-1) - 16*s14*s23*S24**(-1) - 
     +    16*s14 )

      LA = LA + log(s134**(-1)*s1234)*S13**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12**3*S24**(-1) - 16*s12**2*s14*S24**(-1) - 8*s12*
     +    s14*s23*S24**(-1) - 88*s12*s14 + 12*s14**2*s23*S24**(-1) + 12
     +    *s14**2 + 16*s14*s24 )

      LA = LA + log(s134**(-1)*s1234)*S13**(-1)*S234**(-1) * ( 32*
     +    s12**2*S24**(-1) + 56*s12*s14*S24**(-1) + 12*s12*s23*
     +    S24**(-1) + 16*s12 - 4*s14**2*S24**(-1) - 8*s14*s23*S24**(-1)
     +     - 72*s14 + 32*s23**2*S24**(-1) + 80*s23 + 48*s24 )

      LA = LA + log(s134**(-1)*s1234)*S13**(-1)*S134**(-1) * (  - 12*
     +    s12**3*S14**(-1)*S24**(-1) + 16*s12**2*s23*S14**(-1)*
     +    S24**(-1) - 16*s12**2*S24**(-1) + 32*s12*s14*S24**(-1) + 4*
     +    s12*s23**2*S14**(-1)*S24**(-1) - 32*s12*s23*S24**(-1) + 8*s12
     +     + 16*s14*s23*S24**(-1) - 12*s14 + 8*s23 - 12*s24 )

      LA = LA + log(s134**(-1)*s1234)*S13**(-1) * (  - 152 + 24*s12**2*
     +    S14**(-1)*S24**(-1) + 4*s12*s23*S14**(-1)*S24**(-1) + 48*s12*
     +    s34*S14**(-1)*S24**(-1) + 16*s12*S14**(-1) + 28*s12*S24**(-1)
     +     + 68*s14*S24**(-1) - 48*s23*s34*S14**(-1)*S24**(-1) - 80*s23
     +    *S24**(-1) + 32*s34**2*S14**(-1)*S24**(-1) - 96*s34*S14**(-1)
     +     + 32*s34*S24**(-1) )

      LA = LA + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1) * (  - 16*s12
     +    *s13*S14**(-1) - 4*s13**2*S14**(-1) - 16*s13*s24*S14**(-1) - 
     +    10*s13 )

      LA = LA + log(s134**(-1)*s1234)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12**3*S14**(-1) - 16*s12**2*s13*S14**(-1) - 32*
     +    s12**2 - 8*s12*s13*s24*S14**(-1) - 8*s12*s13 - 8*s12*s14 - 24
     +    *s12*s24 + 12*s13**2*s24*S14**(-1) - 18*s13**2 - 18*s13*s14
     +     + 12*s13*s24 )

      LA = LA + log(s134**(-1)*s1234)*S23**(-1)*S234**(-1) * (  - 48*
     +    s12**2*s13*S14**(-1)*S24**(-1) + 32*s12**2*S14**(-1) - 64*
     +    s12**2*S24**(-1) + 56*s12*s13*S14**(-1) + 12*s12*s13*
     +    S24**(-1) + 12*s12*s14*S24**(-1) + 12*s12*s24*S14**(-1) + 84*
     +    s12 - 4*s13**2*S14**(-1) - 8*s13*s24*S14**(-1) + 48*s13 + 84*
     +    s14 + 32*s24**2*S14**(-1) - 128*s24 )

      LA = LA + log(s134**(-1)*s1234)*S23**(-1)*S234**(-2) * (  - 40*
     +    s12*s24 - 40*s13*s24 - 40*s14*s24 )

      LA = LA + log(s134**(-1)*s1234)*S23**(-1)*S134**(-1) * (  - 16*
     +    s12**2*S14**(-1) + 32*s12*s13*S14**(-1) - 32*s12*s24*
     +    S14**(-1) + 8*s12 + 16*s13*s24*S14**(-1) - 18*s13 )

      LA = LA + log(s134**(-1)*s1234)*S23**(-1) * ( 88 - 96*s12**2*
     +    S14**(-1)*S24**(-1) - 4*s12*s13*S14**(-1)*S24**(-1) - 32*s12*
     +    s34*S14**(-1)*S24**(-1) + 28*s12*S14**(-1) - 72*s12*S24**(-1)
     +     + 68*s13*S14**(-1) - 80*s24*S14**(-1) + 96*s34*S14**(-1) )

      LA = LA + log(s134**(-1)*s1234)*S34**(-1) * (  - 16*s13*S14**(-1)
     +     - 10*s14*S24**(-1) )

      LA = LA + log(s134**(-1)*s1234)*S234**(-1)*S134**(-1) * (  - 16*
     +    s12**3*S14**(-1)*S24**(-1) - 16*s12**2*s13*S14**(-1)*
     +    S24**(-1) - 32*s12**2*S24**(-1) - 16*s12*s13*s23*S14**(-1)*
     +    S24**(-1) - 88*s12*s13*S14**(-1) - 8*s12*s13*S24**(-1) - 8*
     +    s12*s14*S24**(-1) - 24*s12*s23*S24**(-1) - 112*s12 + 12*
     +    s13**2*S14**(-1) + 18*s13**2*S24**(-1) + 18*s13*s14*S24**(-1)
     +     + 16*s13*s23*S14**(-1) - 18*s13*s23*S24**(-1) + 58*s13 - 6*
     +    s14*s23*S24**(-1) + 58*s14 + 16*s23 + 16*s24 )

      LA = LA + log(s134**(-1)*s1234)*S234**(-1) * (  - 224 + 16*s12**2
     +    *S14**(-1)*S24**(-1) + 48*s12*s13*S14**(-1)*S24**(-1) + 4*s12
     +    *s23*S14**(-1)*S24**(-1) + 16*s12*S14**(-1) + 84*s12*
     +    S24**(-1) + 4*s13**2*S14**(-1)*S24**(-1) - 56*s13*s23*
     +    S14**(-1)*S24**(-1) - 72*s13*S14**(-1) + 66*s13*S24**(-1) + 
     +    30*s14*S24**(-1) + 48*s23*S14**(-1) - 136*s23*S24**(-1) + 80*
     +    s24*S14**(-1) )

      LA = LA + log(s134**(-1)*s1234)*S234**(-2) * (  - 40*s12*s23*
     +    S24**(-1) - 16*s12 - 40*s13*s23*S24**(-1) - 16*s13 - 40*s14*
     +    s23*S24**(-1) - 16*s14 )

      LA = LA + log(s134**(-1)*s1234)*S134**(-1) * (  - 40 - 16*s12**2*
     +    S14**(-1)*S24**(-1) - 8*s12*s13*S14**(-1)*S24**(-1) - 20*s12*
     +    s23*S14**(-1)*S24**(-1) + 8*s12*S14**(-1) + 8*s12*S24**(-1)
     +     - 4*s13*S14**(-1) + 18*s13*S24**(-1) - 12*s23*S14**(-1) + 8*
     +    s24*S14**(-1) )

      LA = LA + log(s134**(-1)*s1234) * ( 80*s12*S14**(-1)*S24**(-1) + 
     +    40*s13*S14**(-1)*S24**(-1) - 64*s23*S14**(-1)*S24**(-1) + 68*
     +    s34*S14**(-1)*S24**(-1) - 144*S14**(-1) + 80*S24**(-1) )

      LAa=-LA
      
      return
      end

      function LAb(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LA=0d0

      LA = LA + Lc0(p13,p24)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * ( 16*s12**4*s14*S24**(-1) - 16*s12**4 )

      LA = LA + Lc0(p13,p24)*S13**(-1)*S23**(-1)*S234**(-1) * (  - 32*
     +    s12**4*S24**(-1) + 64*s12**3*s14*S24**(-1) - 16*s12**2*s14**2
     +    *S24**(-1) )

      LA = LA + Lc0(p13,p24)*S13**(-1)*S23**(-1)*S134**(-1) * ( 16*
     +    s12**4*S24**(-1) )

      LA = LA + Lc0(p13,p24)*S13**(-1)*S23**(-1) * (  - 16*s12**4*
     +    S14**(-1)*S24**(-1) + 48*s12**3*s34*S14**(-1)*S24**(-1) - 16*
     +    s12**3*S14**(-1) + 80*s12**3*S24**(-1) - 48*s12**2*s14*
     +    S24**(-1) - 8*s12**2*s24*S14**(-1) + 40*s12**2*s34*S14**(-1)
     +     - 16*s12**2*s34*S24**(-1) + 88*s12**2 - 8*s12*s14**2*
     +    S24**(-1) - 24*s12*s14 + 8*s12*s24*s34*S14**(-1) + 8*s12*s24
     +     - 16*s12*s34 )

      LA = LA + Lc0(p13,p24)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 16*
     +    s12**4*S24**(-1) )

      LA = LA + Lc0(p13,p24)*S13**(-1)*S234**(-1) * (  - 32*s12**3*
     +    S24**(-1) + 48*s12**2*s14*S24**(-1) + 8*s12**2*s23*S24**(-1)
     +     + 32*s12**2 + 32*s12*s14**2*S24**(-1) - 32*s12*s14*s23*
     +    S24**(-1) - 40*s12*s14 - 8*s12*s24 + 8*s14**3*S24**(-1) - 16*
     +    s14**2 + 8*s14*s24 )

      LA = LA + Lc0(p13,p24)*S13**(-1)*S134**(-1) * (  - 16*s12**4*
     +    S14**(-1)*S24**(-1) + 64*s12**3*s23*S14**(-1)*S24**(-1) + 16*
     +    s12**3*S14**(-1) - 32*s12**3*S24**(-1) + 8*s12**2*s14*
     +    S24**(-1) - 16*s12**2*s23**2*S14**(-1)*S24**(-1) - 32*s12**2*
     +    s23*S14**(-1) + 48*s12**2*s23*S24**(-1) + 8*s12**2 - 32*s12*
     +    s14*s23*S24**(-1) - 8*s12*s14 - 8*s12*s23**2*S14**(-1) + 32*
     +    s12*s23**2*S24**(-1) + 8*s12*s23 + 8*s12*s24 - 24*s14*s23 - 
     +    16*s14*s24 + 8*s23**3*S24**(-1) )

      LA = LA + Lc0(p13,p24)*S13**(-1) * ( 80*s12**3*S14**(-1)*
     +    S24**(-1) - 48*s12**2*s23*S14**(-1)*S24**(-1) - 16*s12**2*s34
     +    *S14**(-1)*S24**(-1) - 32*s12**2*S14**(-1) + 160*s12**2*
     +    S24**(-1) + 104*s12*s14*S24**(-1) - 8*s12*s23**2*S14**(-1)*
     +    S24**(-1) - 16*s12*s23*S14**(-1) + 104*s12*s23*S24**(-1) - 8*
     +    s12*s24*S14**(-1) + 8*s12*s34*S14**(-1) + 40*s12*s34*
     +    S24**(-1) + 120*s12 + 32*s14**2*S24**(-1) + 48*s14*s23*
     +    S24**(-1) + 24*s14*s34*S24**(-1) - 24*s14 + 32*s23**2*
     +    S24**(-1) + 24*s23*s34*S24**(-1) + 16*s23 + 8*s24 + 8*s34**2*
     +    S24**(-1) )

      LA = LA + Lc0(p13,p24)*S23**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**4*s13*S14**(-1)*S24**(-1) - 16*s12**4*S14**(-1) + 32*
     +    s12**4*S24**(-1) )

      LA = LA + Lc0(p13,p24)*S23**(-1)*S234**(-1) * (  - 16*s12**4*
     +    S14**(-1)*S24**(-1) + 16*s12**3*S24**(-1) - 32*s12**2*s14*
     +    S24**(-1) + 96*s12**2 + 16*s12*s13 - 8*s12*s14**2*S24**(-1)
     +     - 88*s12*s14 + 56*s12*s24 + 8*s13*s24 + 8*s14**2 - 16*s14*
     +    s24 + 8*s24**2 )

      LA = LA + Lc0(p13,p24)*S23**(-1)*S134**(-1) * ( 16*s12**4*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Lc0(p13,p24)*S23**(-1) * (  - 16*s12**3*S14**(-1)*
     +    S24**(-1) - 8*s12**2*s13*S14**(-1)*S24**(-1) + 40*s12**2*s34*
     +    S14**(-1)*S24**(-1) - 32*s12**2*S24**(-1) + 8*s12*s13*s34*
     +    S14**(-1)*S24**(-1) - 8*s12*s13*S24**(-1) - 16*s12*s14*
     +    S24**(-1) + 16*s12*s34*S14**(-1) + 8*s12*s34*S24**(-1) - 80*
     +    s12 - 24*s13 - 16*s24 )

      LA = LA + Lc0(p13,p24)*S234**(-1)*S134**(-1) * (  - 16*s12**4*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Lc0(p13,p24)*S234**(-1) * ( 8*s12**2*S24**(-1) + 8*s12*
     +    s13*S24**(-1) + 8*s12*s14*S24**(-1) - 8*s12*s23*S24**(-1) + 
     +    72*s12 - 16*s13*s23*S24**(-1) + 24*s13 - 24*s14*s23*S24**(-1)
     +     - 24*s14 )

      LA = LA + Lc0(p13,p24)*S134**(-1) * ( 96*s12**2*S14**(-1) + 32*
     +    s12**2*S24**(-1) + 56*s12*s13*S14**(-1) - 8*s12*s13*S24**(-1)
     +     - 88*s12*s23*S14**(-1) - 40*s12*s23*S24**(-1) + 16*s12*s24*
     +    S14**(-1) + 72*s12 + 8*s13**2*S14**(-1) - 16*s13*s23*
     +    S14**(-1) + 8*s13*s23*S24**(-1) + 8*s13*s24*S14**(-1) + 8*
     +    s23**2*S14**(-1) - 16*s23**2*S24**(-1) - 24*s23 + 24*s24 )

      LA = LA + Lc0(p13,p24) * ( 88*s12**2*S14**(-1)*S24**(-1) + 8*s12*
     +    s13*S14**(-1)*S24**(-1) - 24*s12*s23*S14**(-1)*S24**(-1) - 16
     +    *s12*s34*S14**(-1)*S24**(-1) - 80*s12*S14**(-1) + 120*s12*
     +    S24**(-1) - 16*s13*S14**(-1) + 8*s13*S24**(-1) + 16*s14*
     +    S24**(-1) - 24*s23*S24**(-1) - 24*s24*S14**(-1) )

      LA = LA + Lc0(p14,p23)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * ( 16*s12**4*s14*S24**(-1) - 16*s12**4 )

      LA = LA + Lc0(p14,p23)*S13**(-1)*S23**(-1)*S234**(-1) * (  - 16*
     +    s12**4*S24**(-1) )

      LA = LA + Lc0(p14,p23)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 16*
     +    s12**4*S14**(-1) + 16*s12**4*S24**(-1) + 64*s12**3*s24*
     +    S14**(-1) - 16*s12**2*s24**2*S14**(-1) )

      LA = LA + Lc0(p14,p23)*S13**(-1)*S23**(-1) * (  - 16*s12**4*
     +    S14**(-1)*S24**(-1) + 48*s12**3*s34*S14**(-1)*S24**(-1) + 80*
     +    s12**3*S14**(-1) - 16*s12**3*S24**(-1) - 8*s12**2*s14*
     +    S24**(-1) - 48*s12**2*s24*S14**(-1) - 16*s12**2*s34*S14**(-1)
     +     + 40*s12**2*s34*S24**(-1) + 88*s12**2 + 8*s12*s14*s34*
     +    S24**(-1) + 8*s12*s14 - 8*s12*s24**2*S14**(-1) - 24*s12*s24
     +     - 16*s12*s34 )

      LA = LA + Lc0(p14,p23)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 16*
     +    s12**4*S24**(-1) )

      LA = LA + Lc0(p14,p23)*S13**(-1)*S134**(-1) * ( 16*s12**3*
     +    S14**(-1) - 32*s12**2*s24*S14**(-1) + 96*s12**2 + 56*s12*s14
     +     + 16*s12*s23 - 8*s12*s24**2*S14**(-1) - 88*s12*s24 + 8*
     +    s14**2 + 8*s14*s23 - 16*s14*s24 + 8*s24**2 )

      LA = LA + Lc0(p14,p23)*S13**(-1) * (  - 16*s12**3*S14**(-1)*
     +    S24**(-1) - 8*s12**2*s23*S14**(-1)*S24**(-1) + 40*s12**2*s34*
     +    S14**(-1)*S24**(-1) - 32*s12**2*S14**(-1) + 8*s12*s23*s34*
     +    S14**(-1)*S24**(-1) - 8*s12*s23*S14**(-1) - 16*s12*s24*
     +    S14**(-1) + 8*s12*s34*S14**(-1) + 16*s12*s34*S24**(-1) - 80*
     +    s12 - 16*s14 - 24*s23 )

      LA = LA + Lc0(p14,p23)*S23**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**4*s13*S14**(-1)*S24**(-1) - 16*s12**4*S14**(-1) + 32*
     +    s12**4*S24**(-1) )

      LA = LA + Lc0(p14,p23)*S23**(-1)*S234**(-1) * (  - 32*s12**4*
     +    S14**(-1)*S24**(-1) + 64*s12**3*s13*S14**(-1)*S24**(-1) - 32*
     +    s12**3*S14**(-1) + 16*s12**3*S24**(-1) - 16*s12**2*s13**2*
     +    S14**(-1)*S24**(-1) + 48*s12**2*s13*S14**(-1) - 32*s12**2*s13
     +    *S24**(-1) + 8*s12**2*s24*S14**(-1) + 8*s12**2 + 32*s12*
     +    s13**2*S14**(-1) - 8*s12*s13**2*S24**(-1) - 32*s12*s13*s24*
     +    S14**(-1) + 8*s12*s13 + 8*s12*s14 - 8*s12*s24 + 8*s13**3*
     +    S14**(-1) - 24*s13*s24 - 16*s14*s24 )

      LA = LA + Lc0(p14,p23)*S23**(-1)*S134**(-1) * ( 16*s12**4*
     +    S14**(-1)*S24**(-1) - 32*s12**3*S14**(-1) + 8*s12**2*s13*
     +    S14**(-1) + 48*s12**2*s24*S14**(-1) + 32*s12**2 - 32*s12*s13*
     +    s24*S14**(-1) - 8*s12*s14 + 32*s12*s24**2*S14**(-1) - 40*s12*
     +    s24 + 8*s14*s24 + 8*s24**3*S14**(-1) - 16*s24**2 )

      LA = LA + Lc0(p14,p23)*S23**(-1) * ( 80*s12**3*S14**(-1)*
     +    S24**(-1) - 48*s12**2*s13*S14**(-1)*S24**(-1) - 16*s12**2*s34
     +    *S14**(-1)*S24**(-1) + 160*s12**2*S14**(-1) - 32*s12**2*
     +    S24**(-1) - 8*s12*s13**2*S14**(-1)*S24**(-1) + 104*s12*s13*
     +    S14**(-1) - 16*s12*s13*S24**(-1) - 8*s12*s14*S24**(-1) + 104*
     +    s12*s24*S14**(-1) + 40*s12*s34*S14**(-1) + 8*s12*s34*
     +    S24**(-1) + 120*s12 + 32*s13**2*S14**(-1) + 48*s13*s24*
     +    S14**(-1) + 24*s13*s34*S14**(-1) + 16*s13 + 8*s14 + 32*s24**2
     +    *S14**(-1) + 24*s24*s34*S14**(-1) - 24*s24 + 8*s34**2*
     +    S14**(-1) )

      LA = LA + Lc0(p14,p23)*S234**(-1)*S134**(-1) * (  - 16*s12**4*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Lc0(p14,p23)*S234**(-1) * ( 32*s12**2*S14**(-1) + 96*
     +    s12**2*S24**(-1) - 40*s12*s13*S14**(-1) - 88*s12*s13*
     +    S24**(-1) + 16*s12*s14*S24**(-1) - 8*s12*s23*S14**(-1) + 56*
     +    s12*s23*S24**(-1) + 72*s12 - 16*s13**2*S14**(-1) + 8*s13**2*
     +    S24**(-1) + 8*s13*s23*S14**(-1) - 16*s13*s23*S24**(-1) - 24*
     +    s13 + 8*s14*s23*S24**(-1) + 24*s14 + 8*s23**2*S24**(-1) )

      LA = LA + Lc0(p14,p23)*S134**(-1) * ( 8*s12**2*S14**(-1) - 8*s12*
     +    s13*S14**(-1) + 8*s12*s23*S14**(-1) + 8*s12*s24*S14**(-1) + 
     +    72*s12 - 16*s13*s23*S14**(-1) - 24*s13*s24*S14**(-1) + 24*s23
     +     - 24*s24 )

      LA = LA + Lc0(p14,p23) * ( 88*s12**2*S14**(-1)*S24**(-1) - 24*s12
     +    *s13*S14**(-1)*S24**(-1) + 8*s12*s23*S14**(-1)*S24**(-1) - 16
     +    *s12*s34*S14**(-1)*S24**(-1) + 120*s12*S14**(-1) - 80*s12*
     +    S24**(-1) - 24*s13*S14**(-1) - 24*s14*S24**(-1) + 8*s23*
     +    S14**(-1) - 16*s23*S24**(-1) + 16*s24*S14**(-1) )

      LA = LA + Lc1(p1,p34)*S13**(-1)*S23**(-1)*S34*S234**(-1)*
     + S134**(-1) * (  - 8*s12**3 )

      LA = LA + Lc1(p1,p34)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 8*s12**3*s14 + 8*s12**3*S14 - 16*s12**2*s24**2 )

      LA = LA + Lc1(p1,p34)*S13**(-1)*S23**(-1)*S234**(-1) * ( 8*s12**3
     +    *s24*S14**(-1) + 8*s12**3 )

      LA = LA + Lc1(p1,p34)*S13**(-1)*S23**(-1)*S134**(-1) * ( 16*
     +    s12**2*s24 - 16*s12**2*s34 + 8*s12*s24*s34 + 16*s12*s34**2 )

      LA = LA + Lc1(p1,p34)*S13**(-1)*S23**(-1) * (  - 8*s12**3*
     +    S14**(-1) )

      LA = LA + Lc1(p1,p34)*S13**(-1)*S34*S234**(-1)*S134**(-1) * (  - 
     +    8*s12**3*S24**(-1) )

      LA = LA + Lc1(p1,p34)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 8*
     +    s12**3*s14*S24**(-1) + 8*s12**3*S14*S24**(-1) + 16*s12**2*
     +    s23**2*S24**(-1) + 16*s12**2*s23 - 16*s12**2*s24 )

      LA = LA + Lc1(p1,p34)*S13**(-1)*S234**(-1) * ( 8*s12**3*s23*
     +    S14**(-1)*S24**(-1) + 16*s12**3*S14**(-1) + 8*s12**3*
     +    S24**(-1) )

      LA = LA + Lc1(p1,p34)*S13**(-1)*S134**(-1) * (  - 16*s12**2*s23*
     +    S24**(-1) + 16*s12**2*s34*S24**(-1) - 8*s12*s23*s34*S24**(-1)
     +     - 16*s12*s34**2*S24**(-1) )

      LA = LA + Lc1(p1,p34)*S13**(-1) * (  - 8*s12**3*S14**(-1)*
     +    S24**(-1) )

      LA = LA + Lc1(p1,p34)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 24*
     +    s12*s24**2 + 8*s13*s24**2 )

      LA = LA + Lc1(p1,p34)*S23**(-1)*S134**(-1) * ( 24*s12*s24 + 8*s12
     +    *s34 - 8*s13*s24 - 16*s24*s34 + 8*s34**2 )

      LA = LA + Lc1(p1,p34)*S234**(-1)*S134**(-1) * (  - 24*s12*s23**2*
     +    S24**(-1) + 24*s12*s23 + 24*s12*s24 - 8*s13*s23**2*S24**(-1)
     +     - 8*s13*s23 + 8*s13*s24 )

      LA = LA + Lc1(p1,p34)*S134**(-1) * ( 24*s12*s23*S24**(-1) + 8*s12
     +    *s34*S24**(-1) - 16*s12 + 8*s13*s23*S24**(-1) - 16*s23*s34*
     +    S24**(-1) + 16*s23 + 16*s24 + 8*s34**2*S24**(-1) + 32*s34 )

      LA = LA + Lc1(p1,p234)*S13**(-1)*S23**(-1)*S134**(-1) * ( 60*
     +    s14**2*s24 - 8*s14*s24**2 )

      LA = LA + Lc1(p1,p234)*S13**(-1)*S23**(-1) * ( 48*s14**2*s34*
     +    S24**(-1) + 64*s14**2 - 64*s14*s24 - 48*s14*s34**2*S24**(-1)
     +     - 104*s14*s34 )

      LA = LA + Lc1(p1,p234)*S13**(-1)*S134**(-1) * (  - 36*s14**3*
     +    S24**(-1) + 32*s14**2*s23*S24**(-1) + 88*s14**2 + 4*s14*
     +    s23**2*S24**(-1) - 36*s14*s23 - 68*s14*s24 )

      LA = LA + Lc1(p1,p234)*S13**(-1) * ( 84*s14**2*S24**(-1) - 56*s14
     +    *s23*S24**(-1) - 96*s14*s34*S24**(-1) - 144*s14 )

      LA = LA + Lc1(p1,p234)*S23**(-1)*S234**(-1) * (  - 8*s13*s24 )

      LA = LA + Lc1(p1,p234)*S23**(-1)*S134**(-1) * (  - 36*s13**3*
     +    S14**(-1) + 32*s13**2*s24*S14**(-1) - 128*s13**2 - 148*s13*
     +    s14 + 4*s13*s24**2*S14**(-1) + 112*s13*s24 - 56*s14**2 + 124*
     +    s14*s24 + 12*s24**2 )

      LA = LA + Lc1(p1,p234)*S23**(-1) * ( 48*s13**2*s34*S14**(-1)*
     +    S24**(-1) + 84*s13**2*S14**(-1) - 24*s13*s24*S14**(-1) - 48*
     +    s13*s34**2*S14**(-1)*S24**(-1) - 96*s13*s34*S14**(-1) + 144*
     +    s13*s34*S24**(-1) + 284*s13 + 144*s14*s34*S24**(-1) + 232*s14
     +     - 56*s24 - 96*s34**2*S24**(-1) - 172*s34 )

      LA = LA + Lc1(p1,p234)*S234**(-1) * ( 8*s13*s23*S24**(-1) )

      LA = LA + Lc1(p1,p234)*S134**(-1) * ( 60*s13**2*s23*S14**(-1)*
     +    S24**(-1) + 88*s13**2*S14**(-1) - 56*s13**2*S24**(-1) - 148*
     +    s13*s14*S24**(-1) - 8*s13*s23**2*S14**(-1)*S24**(-1) - 76*s13
     +    *s23*S14**(-1) + 124*s13*s23*S24**(-1) - 44*s13*s24*S14**(-1)
     +     + 272*s13 - 128*s14**2*S24**(-1) + 112*s14*s23*S24**(-1) + 
     +    272*s14 + 12*s23**2*S24**(-1) - 88*s23 - 88*s24 )

      LA = LA + Lc1(p1,p234) * (  - 304 + 64*s13**2*S14**(-1)*S24**(-1)
     +     - 64*s13*s23*S14**(-1)*S24**(-1) - 104*s13*s34*S14**(-1)*
     +    S24**(-1) - 96*s13*S14**(-1) + 232*s13*S24**(-1) + 284*s14*
     +    S24**(-1) - 88*s23*S24**(-1) - 172*s34*S24**(-1) )

      LA = LA + Lc1(p2,p34)*S13**(-1)*S23**(-1)*S34*S234**(-1)*
     + S134**(-1) * (  - 8*s12**3 )

      LA = LA + Lc1(p2,p34)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 8*s12**3*s14 )

      LA = LA + Lc1(p2,p34)*S13**(-1)*S23**(-1)*S234**(-1) * ( 8*s12**3
     +     - 16*s12**2*s34 - 8*s12*s14*s34 + 16*s12*s34**2 )

      LA = LA + Lc1(p2,p34)*S13**(-1)*S23**(-1)*S134**(-1) * ( 8*s12**3
     +    *s14*S24**(-1) )

      LA = LA + Lc1(p2,p34)*S13**(-1)*S23**(-1) * (  - 8*s12**3*
     +    S24**(-1) )

      LA = LA + Lc1(p2,p34)*S13**(-1)*S234**(-1)*S134**(-1) * ( 24*s12*
     +    s14**2 + 8*s14**2*s23 )

      LA = LA + Lc1(p2,p34)*S13**(-1)*S234**(-1) * (  - 24*s12*s14 + 8*
     +    s12*s34 - 8*s14*s23 - 16*s14*s34 + 8*s34**2 )

      LA = LA + Lc1(p2,p34)*S23**(-1)*S34*S234**(-1)*S134**(-1) * (  - 
     +    8*s12**3*S14**(-1) )

      LA = LA + Lc1(p2,p34)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 8*
     +    s12**3*s13*S14**(-1) - 16*s12**3 )

      LA = LA + Lc1(p2,p34)*S23**(-1)*S234**(-1) * ( 8*s12**3*S14**(-1)
     +     + 16*s12**2*s34*S14**(-1) + 8*s12*s13*s34*S14**(-1) - 16*s12
     +    *s34**2*S14**(-1) )

      LA = LA + Lc1(p2,p34)*S23**(-1)*S134**(-1) * ( 8*s12**3*s13*
     +    S14**(-1)*S24**(-1) + 16*s12**3*S24**(-1) )

      LA = LA + Lc1(p2,p34)*S23**(-1) * (  - 8*s12**3*S14**(-1)*
     +    S24**(-1) )

      LA = LA + Lc1(p2,p34)*S234**(-1)*S134**(-1) * ( 24*s12*s13**2*
     +    S14**(-1) + 40*s12*s13 + 40*s12*s14 - 8*s13**2*s23*S14**(-1)
     +     - 8*s13*s23 + 8*s14*s23 )

      LA = LA + Lc1(p2,p34)*S234**(-1) * (  - 24*s12*s13*S14**(-1) + 8*
     +    s12*s34*S14**(-1) + 16*s12 + 8*s13*s23*S14**(-1) - 16*s13*s34
     +    *S14**(-1) + 16*s13 + 16*s14 + 8*s34**2*S14**(-1) + 32*s34 )

      LA = LA + Lc1(p2,p134)*S13**(-1)*S23**(-1)*S234**(-1) * (  - 8*
     +    s14**2*s24 + 60*s14*s24**2 )

      LA = LA + Lc1(p2,p134)*S13**(-1)*S23**(-1) * (  - 64*s14*s24 + 48
     +    *s24**2*s34*S14**(-1) + 64*s24**2 - 48*s24*s34**2*S14**(-1)
     +     - 104*s24*s34 )

      LA = LA + Lc1(p2,p134)*S13**(-1)*S234**(-1) * ( 4*s14**2*s23*
     +    S24**(-1) + 12*s14**2 + 32*s14*s23**2*S24**(-1) + 112*s14*s23
     +     + 124*s14*s24 - 36*s23**3*S24**(-1) - 128*s23**2 - 148*s23*
     +    s24 - 56*s24**2 )

      LA = LA + Lc1(p2,p134)*S13**(-1)*S134**(-1) * (  - 8*s14*s23 )

      LA = LA + Lc1(p2,p134)*S13**(-1) * (  - 24*s14*s23*S24**(-1) - 56
     +    *s14 + 48*s23**2*s34*S14**(-1)*S24**(-1) + 84*s23**2*
     +    S24**(-1) - 48*s23*s34**2*S14**(-1)*S24**(-1) + 144*s23*s34*
     +    S14**(-1) - 96*s23*s34*S24**(-1) + 284*s23 + 144*s24*s34*
     +    S14**(-1) + 232*s24 - 96*s34**2*S14**(-1) - 172*s34 )

      LA = LA + Lc1(p2,p134)*S23**(-1)*S234**(-1) * ( 4*s13**2*s24*
     +    S14**(-1) + 32*s13*s24**2*S14**(-1) - 36*s13*s24 - 68*s14*s24
     +     - 36*s24**3*S14**(-1) + 88*s24**2 )

      LA = LA + Lc1(p2,p134)*S23**(-1) * (  - 56*s13*s24*S14**(-1) + 84
     +    *s24**2*S14**(-1) - 96*s24*s34*S14**(-1) - 144*s24 )

      LA = LA + Lc1(p2,p134)*S234**(-1) * (  - 8*s13**2*s23*S14**(-1)*
     +    S24**(-1) + 12*s13**2*S14**(-1) + 60*s13*s23**2*S14**(-1)*
     +    S24**(-1) + 124*s13*s23*S14**(-1) - 76*s13*s23*S24**(-1) + 
     +    112*s13*s24*S14**(-1) - 88*s13 - 44*s14*s23*S24**(-1) - 88*
     +    s14 - 56*s23**2*S14**(-1) + 88*s23**2*S24**(-1) - 148*s23*s24
     +    *S14**(-1) + 272*s23 - 128*s24**2*S14**(-1) + 272*s24 )

      LA = LA + Lc1(p2,p134)*S134**(-1) * ( 8*s13*s23*S14**(-1) )

      LA = LA + Lc1(p2,p134) * (  - 304 - 64*s13*s23*S14**(-1)*
     +    S24**(-1) - 104*s13*S14**(-1) + 64*s23**2*S14**(-1)*S24**(-1)
     +     - 104*s23*s34*S14**(-1)*S24**(-1) + 232*s23*S14**(-1) - 112*
     +    s23*S24**(-1) + 284*s24*S14**(-1) - 172*s34*S14**(-1) )

      LA = LA + Lc1(p3,p14)*S13**(-1)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 28*s12*s14**3*s23**3*S14**(-1)*S24**(-1) - 28*
     +    s12*s14**3*s23**2*s24*S14**(-1)*S24**(-1) - 8*s13**2*s14*
     +    s23**4*S14**(-1)*S24**(-1) - 8*s13**2*s14*s23**3*s24*
     +    S14**(-1)*S24**(-1) + 8*s13*s14**2*s23**4*S14**(-1)*S24**(-1)
     +     + 8*s13*s14**2*s23**3*s24*S14**(-1)*S24**(-1) - 24*s14**4*
     +    s23**3*S14**(-1)*S24**(-1) - 24*s14**4*s23**2*s24*S14**(-1)*
     +    S24**(-1) - 16*s14**3*s23**3*s24*S14**(-1)*S24**(-1) - 16*
     +    s14**3*s23**2*s24**2*S14**(-1)*S24**(-1) )

      LA = LA + Lc1(p3,p14)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * ( 28*s12*s13*s14*s23**3*S14**(-1)*S24**(-1) + 28*s12*s13*s14*
     +    s23**2*s24*S14**(-1)*S24**(-1) + 28*s12*s13*s14*s23**2*s34*
     +    S14**(-1)*S24**(-1) - 28*s12*s14**3*s23**2*S14**(-1)*
     +    S24**(-1) - 28*s12*s14**2*s23**3*S14**(-1)*S24**(-1) - 28*s12
     +    *s14**2*s23**2*s24*S14**(-1)*S24**(-1) - 28*s12*s14**2*s23**2
     +    *s34*S14**(-1)*S24**(-1) - 32*s13**2*s14*s23**3*S14**(-1)*
     +    S24**(-1) - 24*s13**2*s14*s23**2*s24*S14**(-1)*S24**(-1) - 24
     +    *s13**2*s14*s23**2*s34*S14**(-1)*S24**(-1) + 32*s13*s14**2*
     +    s23**3*S14**(-1)*S24**(-1) + 24*s13*s14**2*s23**2*s24*
     +    S14**(-1)*S24**(-1) + 24*s13*s14**2*s23**2*s34*S14**(-1)*
     +    S24**(-1) + 16*s13*s14*s23**3*s24*S14**(-1)*S24**(-1) + 16*
     +    s13*s14*s23**2*s24**2*S14**(-1)*S24**(-1) + 16*s13*s14*s23**2
     +    *s24*s34*S14**(-1)*S24**(-1) - 24*s14**4*s23**2*S14**(-1)*
     +    S24**(-1) - 24*s14**3*s23**3*S14**(-1)*S24**(-1) - 40*s14**3*
     +    s23**2*s24*S14**(-1)*S24**(-1) - 24*s14**3*s23**2*s34*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Lc1(p3,p14)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 16*s14**2*s23**3*s24*S14**(-1)*S24**(-1) - 16*s14**2*
     +    s23**2*s24**2*S14**(-1)*S24**(-1) - 16*s14**2*s23**2*s24*s34*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Lc1(p3,p14)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 12*
     +    s12**3 - 32*s12**2*s13**2*S24**(-1) - 32*s12**2*s13*s14*
     +    S24**(-1) + 28*s12**2*s13 + 44*s12**2*s14 + 16*s12*s13**3*
     +    S24**(-1) + 16*s12*s13**2*s14*S24**(-1) - 76*s12*s13**2 - 88*
     +    s12*s13*s14 + 64*s12*s13*s24 + 64*s12*s14*s24 + 24*s13**3 + 
     +    24*s13**2*s14 - 28*s13**2*s24 + 12*s13*s14*s24 + 40*s14**2*
     +    s24 )

      LA = LA + Lc1(p3,p14)*S23**(-1)*S234**(-1) * ( 32*s12**2*s13*
     +    S24**(-1) + 4*s12**2 - 16*s12*s13**2*S24**(-1) + 60*s12*s13
     +     + 28*s12*s14 - 4*s12*s24 - 24*s13**2 + 4*s13*s24 - 16*s14*
     +    s24 + 4*s24**2 )

      LA = LA + Lc1(p3,p14)*S23**(-1)*S134**(-1) * ( 4*s12**2*s13*
     +    S14**(-1) - 32*s12**2*s13*S24**(-1) - 32*s12**2*s14*S24**(-1)
     +     + 8*s12**2 + 16*s12*s13**2*S24**(-1) - 40*s12*s13*s14*
     +    S24**(-1) + 8*s12*s13*s24*S14**(-1) - 32*s12*s13 - 56*s12*
     +    s14**2*S24**(-1) - 8*s12*s14 + 32*s12*s24 + 24*s13**2 + 4*s13
     +    *s24**2*S14**(-1) + 24*s13*s24 + 48*s14*s24 + 12*s24**2 )

      LA = LA + Lc1(p3,p14)*S23**(-1) * (  - 4*s12**2*S14**(-1) + 40*
     +    s12*s14*S24**(-1) - 8*s12*s24*S14**(-1) - 28*s12 - 4*s24**2*
     +    S14**(-1) - 28*s24 )

      LA = LA + Lc1(p3,p14)*S34**(-1)*S134**(-1) * (  - 4*s12**2*s13*
     +    S24**(-1) + 24*s12*s13**2*S24**(-1) + 48*s12*s13*s23*
     +    S24**(-1) - 52*s12*s13 - 12*s13**3*S24**(-1) - 112*s13**2*s23
     +    *S24**(-1) + 32*s13**2 + 60*s13*s23 - 18*s13*s24 )

      LA = LA + Lc1(p3,p14)*S34**(-1) * ( 4*s12**2*S24**(-1) - 24*s12*
     +    s13*S24**(-1) + 24*s12*s14*S24**(-1) - 20*s12*s23*S24**(-1)
     +     + 52*s12 + 12*s13**2*S24**(-1) - 12*s13*s14*S24**(-1) + 88*
     +    s13*s23*S24**(-1) - 32*s13 + 12*s14**2*S24**(-1) - 64*s14*s23
     +    *S24**(-1) + 32*s14 + 8*s23**2*S24**(-1) - 44*s23 + 18*s24 )

      LA = LA + Lc1(p3,p14)*S234**(-1)*S134**(-1) * (  - 12*s12**3*
     +    S24**(-1) + 32*s12**2*s13*S24**(-1) + 16*s12**2*s14*S24**(-1)
     +     - 76*s12*s13**2*S24**(-1) - 72*s12*s13*s14*S24**(-1) + 60*
     +    s12*s13*s23*S24**(-1) + 116*s12*s13 + 60*s12*s14*s23*
     +    S24**(-1) + 116*s12*s14 + 8*s13**3*S24**(-1) + 20*s13**2*s14*
     +    S24**(-1) - 8*s13**2*s23*S24**(-1) - 22*s13**2 - 36*s13*s14*
     +    s23*S24**(-1) + 14*s13*s14 - 10*s13*s23 - 16*s13*s24 - 28*
     +    s14**2*s23*S24**(-1) + 12*s14**2 + 28*s14*s23 - 16*s14*s24 )

      LA = LA + Lc1(p3,p14)*S234**(-1) * ( 60*s12*s13*S24**(-1) + 12*
     +    s12*s14*S24**(-1) + 4*s12 - 8*s13**2*S24**(-1) - 12*s13*s14*
     +    S24**(-1) - 10*s13 + 12*s14**2*S24**(-1) + 24*s14*s23*
     +    S24**(-1) - 16*s14 + 10*s24 )

      LA = LA + Lc1(p3,p14)*S134**(-1) * (  - 36*s12**2*S24**(-1) + 24*
     +    s12*s13*S14**(-1) - 12*s12*s13*S24**(-1) + 4*s12*s14*
     +    S24**(-1) + 12*s12*s23*S24**(-1) - 80*s12 - 4*s13**2*
     +    S24**(-1) + 48*s13*s14*S24**(-1) + 24*s13*s23*S14**(-1) - 88*
     +    s13*s23*S24**(-1) + 24*s13*s24*S14**(-1) + 82*s13 + 32*s14**2
     +    *S24**(-1) + 72*s14*s23*S24**(-1) - 56*s14 - 8*s23**2*
     +    S24**(-1) + 36*s23 - 24*s24 )

      LA = LA + Lc1(p3,p14) * (  - 40 - 24*s12*S14**(-1) - 24*s12*
     +    S24**(-1) - 24*s14*S24**(-1) - 24*s23*S14**(-1) - 24*s24*
     +    S14**(-1) )

      LA = LA + Lc1(p3,p24)*S13**2*S23**2*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 8*S14**(-1) )

      LA = LA + Lc1(p3,p24)*S13**2*S23*S34**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 8*S14**(-1)*S24 )

      LA = LA + Lc1(p3,p24)*S13**2*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +    8*S14**(-1)*S24**2 )

      LA = LA + Lc1(p3,p24)*S13**(-1)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 44*s12*s13**3*s24**3*S14**(-1)*S24**(-1) - 44*
     +    s12*s13**2*s14*s24**3*S14**(-1)*S24**(-1) - 8*s13**4*s23**2*
     +    s24*S14**(-1)*S24**(-1) + 8*s13**4*s23*s24**2*S14**(-1)*
     +    S24**(-1) + 8*s13**4*s24**3*S14**(-1)*S24**(-1) - 8*s13**3*
     +    s14*s23**2*s24*S14**(-1)*S24**(-1) + 8*s13**3*s14*s23*s24**2*
     +    S14**(-1)*S24**(-1) - 8*s13**3*s14*s24**3*S14**(-1)*S24**(-1)
     +     - 24*s13**3*s24**4*S14**(-1)*S24**(-1) + 8*s13**3*s24**3*s34
     +    *S14**(-1)*S24**(-1) - 16*s13**2*s14**2*s24**3*S14**(-1)*
     +    S24**(-1) - 24*s13**2*s14*s24**4*S14**(-1)*S24**(-1) )

      LA = LA + Lc1(p3,p24)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 44*s12*s13**2*s24**3*S14**(-1)*S24**(-1) - 8*s13**4*s23*
     +    s24*S14**(-1)*S24**(-1) + 8*s13**4*s24**2*S14**(-1)*S24**(-1)
     +     - 8*s13**3*s14*s23*s24*S14**(-1)*S24**(-1) + 8*s13**3*s14*
     +    s24**2*S14**(-1)*S24**(-1) - 8*s13**3*s23*s24*s34*S14**(-1)*
     +    S24**(-1) + 8*s13**3*s24**3*S14**(-1)*S24**(-1) + 8*s13**3*
     +    s24**2*s34*S14**(-1)*S24**(-1) - 16*s13**2*s14*s24**3*
     +    S14**(-1)*S24**(-1) - 24*s13**2*s24**4*S14**(-1)*S24**(-1) )

      LA = LA + Lc1(p3,p24)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 12*
     +    s12**3 - 4*s12**2*s14 + 48*s12**2*s24 + 4*s12*s14**2 + 32*s12
     +    *s14*s24 + 28*s12*s24**2 - 4*s14**3 + 20*s14**2*s24 + 24*s14*
     +    s24**2 )

      LA = LA + Lc1(p3,p24)*S13**(-1)*S234**(-1) * (  - 32*s12**2*s24*
     +    S14**(-1) - 4*s12**2*s34*S24**(-1) + 8*s12**2 - 8*s12*s14*s34
     +    *S24**(-1) + 20*s12*s14 - 16*s12*s24**2*S14**(-1) + 40*s12*
     +    s24*s34*S14**(-1) - 8*s12*s24 - 28*s12*s34 - 4*s14**2*s34*
     +    S24**(-1) + 12*s14**2 + 4*s14*s24 - 28*s14*s34 )

      LA = LA + Lc1(p3,p24)*S34**(-1)*S234**(-1) * (  - 28*s12**2*s24*
     +    S14**(-1) + 8*s12*s13*s24*S14**(-1) - 8*s12*s24**2*S14**(-1)
     +     + 44*s12*s24 + 8*s13**2*s24*S14**(-1) - 40*s13*s24**2*
     +    S14**(-1) - 28*s13*s24 + 18*s14*s24 + 12*s24**3*S14**(-1) + 
     +    32*s24**2 )

      LA = LA + Lc1(p3,p24)*S234**(-1)*S134**(-1) * (  - 12*s12**3*
     +    S14**(-1) + 48*s12**2*s13*S14**(-1) + 48*s12**2*s24*S14**(-1)
     +     + 44*s12**2 + 128*s12*s13*s24*S14**(-1) + 20*s12*s13 + 24*
     +    s12*s14 + 44*s12*s24**2*S14**(-1) + 120*s12*s24 - 24*s13**2*
     +    s24*S14**(-1) - 10*s13*s14 - 16*s13*s24**2*S14**(-1) + 20*s13
     +    *s24 - 14*s14**2 + 26*s14*s24 + 12*s24**3*S14**(-1) - 16*
     +    s24**2 )

      LA = LA + Lc1(p3,p24)*S234**(-1) * (  - 32*s12**2*S14**(-1) - 8*
     +    s12*s13*S14**(-1) + 16*s12*s24*S14**(-1) - 24*s12*s34*
     +    S14**(-1) - 24*s12*s34*S24**(-1) - 64*s12 + 32*s13*s24*
     +    S14**(-1) - 24*s13*s34*S24**(-1) - 32*s13 - 24*s14*s34*
     +    S24**(-1) - 20*s14 + 32*s24**2*S14**(-1) - 24*s24*s34*
     +    S14**(-1) - 80*s24 - 40*s34 )

      LA = LA + Lc1(p4,p13)*S13**2*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 8*S24**2 )

      LA = LA + Lc1(p4,p13)*S13**(-1)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 28*s12*s13**3*s23*s24**2*S14**(-1)*S24**(-1)
     +     - 28*s12*s13**3*s24**3*S14**(-1)*S24**(-1) - 24*s13**4*s23*
     +    s24**2*S14**(-1)*S24**(-1) - 24*s13**4*s24**3*S14**(-1)*
     +    S24**(-1) - 16*s13**3*s23**2*s24**2*S14**(-1)*S24**(-1) - 8*
     +    s13**3*s23*s24**3*S14**(-1)*S24**(-1) + 8*s13**3*s24**4*
     +    S14**(-1)*S24**(-1) + 8*s13**3*s24**3*s34*S14**(-1)*S24**(-1)
     +     )

      LA = LA + Lc1(p4,p13)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 28*s12*s13**3*s24**2*S14**(-1)*S24**(-1) - 24*s13**4*
     +    s24**2*S14**(-1)*S24**(-1) - 16*s13**3*s23*s24**2*S14**(-1)*
     +    S24**(-1) + 8*s13**3*s24**3*S14**(-1)*S24**(-1) )

      LA = LA + Lc1(p4,p13)*S13**(-1)*S134**(-1) * (  - 4*s12**2*s34*
     +    S24**(-1) - 8*s12*s23*s34*S24**(-1) - 24*s12*s34 - 4*s23**2*
     +    s34*S24**(-1) - 24*s23*s34 - 24*s24*s34 )

      LA = LA + Lc1(p4,p13)*S23**(-1)*S34**(-1)*S134**(-1) * ( 4*s12**2
     +    *s13 + 24*s12*s13**2 + 8*s12*s13*s24 + 12*s13**3 - 40*s13**2*
     +    s24 + 8*s13*s24**2 )

      LA = LA + Lc1(p4,p13)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 12*
     +    s12**3 + 16*s12**2*s13 + 12*s12*s13**2 + 48*s12*s13*s24 + 12*
     +    s13**3 - 16*s13**2*s24 - 24*s13*s24**2 )

      LA = LA + Lc1(p4,p13)*S23**(-1)*S134**(-1) * (  - 32*s12**2*s13*
     +    S24**(-1) - 32*s12**2 - 16*s12*s13**2*S24**(-1) + 40*s12*s13*
     +    s34*S24**(-1) + 16*s12*s13 - 8*s12*s24 - 24*s12*s34 + 32*
     +    s13**2 + 32*s13*s24 - 24*s13*s34 )

      LA = LA + Lc1(p4,p13)*S34**(-1)*S134**(-1) * ( 52*s12*s13 + 32*
     +    s13**2 + 18*s13*s23 - 28*s13*s24 )

      LA = LA + Lc1(p4,p13)*S234**(-1)*S134**(-1) * (  - 12*s12**3*
     +    S24**(-1) + 48*s12**2*s13*S24**(-1) - 4*s12**2*s23*S24**(-1)
     +     - 4*s12**2 + 28*s12*s13**2*S24**(-1) + 32*s12*s13*s23*
     +    S24**(-1) + 80*s12*s13 + 4*s12*s23**2*S24**(-1) - 4*s12*s24
     +     + 24*s13**2*s23*S24**(-1) - 16*s13**2 + 20*s13*s23**2*
     +    S24**(-1) + 26*s13*s23 + 20*s13*s24 - 4*s23**3*S24**(-1) - 14
     +    *s23**2 - 10*s23*s24 )

      LA = LA + Lc1(p4,p13)*S134**(-1) * ( 8*s12**2*S24**(-1) - 8*s12*
     +    s13*S24**(-1) + 20*s12*s23*S24**(-1) - 28*s12*s34*S24**(-1)
     +     - 48*s12 + 4*s13*s23*S24**(-1) - 80*s13 + 12*s23**2*
     +    S24**(-1) - 28*s23*s34*S24**(-1) - 20*s23 - 32*s24 - 40*s34 )

      LA = LA + Lc1(p4,p23)*S13**(-1)*S23**2*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 8*S14**2 )

      LA = LA + Lc1(p4,p23)*S13**(-1)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 44*s12*s13*s14**2*s23**3*S14**(-1)*S24**(-1)
     +     - 44*s12*s14**3*s23**3*S14**(-1)*S24**(-1) - 16*s13**2*
     +    s14**2*s23**3*S14**(-1)*S24**(-1) - 8*s13*s14**3*s23**3*
     +    S14**(-1)*S24**(-1) - 24*s13*s14**2*s23**4*S14**(-1)*
     +    S24**(-1) + 8*s14**4*s23**3*S14**(-1)*S24**(-1) - 24*s14**3*
     +    s23**4*S14**(-1)*S24**(-1) + 8*s14**3*s23**3*s34*S14**(-1)*
     +    S24**(-1) )

      LA = LA + Lc1(p4,p23)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 44*s12*s14**2*s23**3*S14**(-1)*S24**(-1) - 16*s13*s14**2
     +    *s23**3*S14**(-1)*S24**(-1) + 8*s14**3*s23**3*S14**(-1)*
     +    S24**(-1) - 24*s14**2*s23**4*S14**(-1)*S24**(-1) )

      LA = LA + Lc1(p4,p23)*S13**(-1)*S34**(-1)*S234**(-1) * (  - 28*
     +    s12**2*s23 + 8*s12*s14*s23 - 8*s12*s23**2 + 8*s14**2*s23 - 40
     +    *s14*s23**2 + 12*s23**3 )

      LA = LA + Lc1(p4,p23)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 12*
     +    s12**3 + 48*s12**2*s14 + 48*s12**2*s23 + 128*s12*s14*s23 + 44
     +    *s12*s23**2 - 40*s14*s23**2 - 24*s14*s23*s24 + 12*s23**3 )

      LA = LA + Lc1(p4,p23)*S13**(-1)*S234**(-1) * (  - 32*s12**2*s23*
     +    S14**(-1) - 32*s12**2 - 8*s12*s14 - 56*s12*s23**2*S14**(-1)
     +     - 40*s12*s23*s24*S14**(-1) + 40*s12*s23 + 24*s12*s24 + 8*s14
     +    *s23 + 56*s23**2 + 24*s23*s24 )

      LA = LA + Lc1(p4,p23)*S13**(-1)*S134**(-1) * ( 24*s14*s23 )

      LA = LA + Lc1(p4,p23)*S13**(-1) * ( 40*s12*s23*S14**(-1) - 24*s12
     +     - 24*s23 )

      LA = LA + Lc1(p4,p23)*S23**(-1)*S234**(-1) * ( 4*s12**2*s24*
     +    S14**(-1) + 8*s12*s13*s24*S14**(-1) + 24*s12*s24 + 4*s13**2*
     +    s24*S14**(-1) + 24*s13*s24 + 24*s14*s24 )

      LA = LA + Lc1(p4,p23)*S23**(-1) * (  - 4*s12**2*S14**(-1) - 8*s12
     +    *s13*S14**(-1) - 24*s12 - 4*s13**2*S14**(-1) - 24*s13 - 24*
     +    s14 )

      LA = LA + Lc1(p4,p23)*S34**(-1)*S234**(-1) * ( 44*s12*s23 + 18*
     +    s13*s23 - 28*s14*s23 + 32*s23**2 )

      LA = LA + Lc1(p4,p23)*S234**(-1)*S134**(-1) * (  - 12*s12**3*
     +    S14**(-1) - 4*s12**2*s13*S14**(-1) + 48*s12**2*s23*S14**(-1)
     +     + 44*s12**2 + 36*s12*s13*s23*S14**(-1) + 4*s12*s13*s24*
     +    S14**(-1) + 16*s12*s13 + 16*s12*s14 + 28*s12*s23**2*S14**(-1)
     +     + 124*s12*s23 + 4*s12*s24 - 4*s13**2*s23*S14**(-1) - 4*
     +    s13**2*s24*S14**(-1) - 6*s13**2 - 6*s13*s14 + 44*s13*s23**2*
     +    S14**(-1) + 20*s13*s23*s24*S14**(-1) + 6*s13*s23 - 4*s13*s24
     +     + 48*s14*s23 - 20*s23**2 - 4*s23*s24 )

      LA = LA + Lc1(p4,p23)*S234**(-1) * ( 12*s12**2*S14**(-1) + 32*s12
     +    *s13*S14**(-1) + 20*s12*s23*S14**(-1) + 28*s12*s24*S14**(-1)
     +     - 36*s12 + 12*s13**2*S14**(-1) + 52*s13*s23*S14**(-1) + 28*
     +    s13*s24*S14**(-1) - 8*s14 - 44*s23 + 40*s24 )

      LA = LA + Lc1(p4,p23)*S134**(-1) * (  - 4*s12*s13*S14**(-1) - 4*
     +    s12 + 4*s13**2*S14**(-1) - 20*s13*s23*S14**(-1) + 4*s13 + 4*
     +    s23 )

      LA = LA + Lc1(p4,p23) * (  - 40 - 28*s12*S14**(-1) - 28*s13*
     +    S14**(-1) )

      LA = LA + Lc1(p13,p24)*S13**(-1)*S23**(-1)*S234**(-1) * ( 16*
     +    s12**4*S24**(-1) - 64*s12**3*s14*S24**(-1) + 32*s12**3 + 24*
     +    s12**2*s14**2*S24**(-1) + 48*s12**2*s14 - 12*s12**2*s24 - 8*
     +    s12*s14**3*S24**(-1) + 16*s12*s14**2 - 8*s12*s14*s24 )

      LA = LA + Lc1(p13,p24)*S13**(-1)*S23**(-1) * (  - 24*s12**3*s34*
     +    S14**(-1)*S24**(-1) + 56*s12**3*S14**(-1) - 120*s12**3*
     +    S24**(-1) - 8*s12**2*s14*S24**(-1) + 4*s12**2*s24*S14**(-1)
     +     + 8*s12**2*s34*S14**(-1) - 16*s12**2*s34*S24**(-1) + 8*
     +    s12**2 - 16*s12*s14**2*S24**(-1) - 8*s12*s14*s34*S24**(-1) - 
     +    16*s12*s14 + 8*s12*s24*s34*S14**(-1) + 16*s12*s24 - 16*s12*
     +    s34 )

      LA = LA + Lc1(p13,p24)*S13**(-1)*S234**(-1) * ( 48*s12**3*
     +    S24**(-1) + 24*s12**2*s14*S24**(-1) - 12*s12**2 + 72*s12*
     +    s14**2*S24**(-1) + 32*s12*s14*s23*S24**(-1) + 4*s12*s14 + 16*
     +    s14**2*s23*S24**(-1) )

      LA = LA + Lc1(p13,p24)*S13**(-1)*S134**(-1) * ( 32*s12**2*s23**2*
     +    S14**(-1)*S24**(-1) + 24*s12**2*s23*S14**(-1) - 44*s12**2 - 
     +    16*s12*s14 - 8*s12*s23**3*S14**(-1)*S24**(-1) + 8*s12*s23**2*
     +    S14**(-1) + 32*s12*s23**2*S24**(-1) - 36*s12*s23 - 4*s12*s24
     +     + 8*s14*s23**2*S24**(-1) - 16*s14*s23 - 16*s14*s24 - 16*
     +    s23**3*S24**(-1) - 16*s23**2 )

      LA = LA + Lc1(p13,p24)*S13**(-1) * ( 32*s12**2*s23*S14**(-1)*
     +    S24**(-1) + 112*s12**2*S14**(-1) - 64*s12**2*S24**(-1) + 32*
     +    s12*s14*S24**(-1) + 8*s12*s23*s34*S14**(-1)*S24**(-1) + 32*
     +    s12*s23*S14**(-1) + 32*s12*s23*S24**(-1) + 4*s12*s24*
     +    S14**(-1) + 16*s12*s34*S14**(-1) + 16*s12 - 16*s14 - 16*
     +    s23**2*S24**(-1) - 8*s23 )

      LA = LA + Lc1(p13,p24)*S23**(-1)*S234**(-1) * (  - 8*s12**3*
     +    S24**(-1) + 16*s12**2*s14*S24**(-1) - 40*s12**2 + 8*s12*
     +    s14**2*S24**(-1) + 16*s12*s14 + 16*s12*s24 + 16*s13*s24 + 8*
     +    s14**2 - 16*s14*s24 + 8*s24**2 )

      LA = LA + Lc1(p13,p24)*S23**(-1) * (  - 8*s12**2*s34*S14**(-1)*
     +    S24**(-1) - 20*s12**2*S14**(-1) - 8*s12*s13*S14**(-1) + 16*
     +    s12*s34*S14**(-1) - 8*s12*s34*S24**(-1) - 12*s12 - 8*s13 + 8*
     +    s14 - 16*s24 )

      LA = LA + Lc1(p13,p24)*S234**(-1) * ( 8*s12*s23*S24**(-1) - 28*
     +    s12 + 8*s13 + 8*s14*s23*S24**(-1) - 32*s14 )

      LA = LA + Lc1(p13,p24)*S134**(-1) * (  - 76*s12**2*S14**(-1) - 32
     +    *s12*s23*S14**(-1) + 8*s12*s24*S14**(-1) - 40*s12 + 32*s13*
     +    s24*S14**(-1) - 8*s13 + 24*s23**2*S14**(-1) + 8*s23**2*
     +    S24**(-1) + 16*s23*s24*S14**(-1) - 8*s23 + 24*s24 )

      LA = LA + Lc1(p13,p24) * ( 16 - 16*s12*s23*S14**(-1)*S24**(-1) + 
     +    16*s12*S14**(-1) - 16*s12*S24**(-1) - 16*s23*S24**(-1) - 24*
     +    s24*S14**(-1) )

      LA = LA + Lc1(p14,p23)*S13**(-1)*S23**(-1)*S134**(-1) * ( 32*
     +    s12**2*s24**2*S14**(-1) - 8*s12*s24**3*S14**(-1) )

      LA = LA + Lc1(p14,p23)*S13**(-1)*S23**(-1) * (  - 24*s12**3*s34*
     +    S14**(-1)*S24**(-1) + 32*s12**2*s24*S14**(-1) - 8*s12**2*s34*
     +    S24**(-1) + 8*s12*s24*s34*S14**(-1) - 16*s12*s24 )

      LA = LA + Lc1(p14,p23)*S13**(-1)*S134**(-1) * ( 24*s12**2*s24*
     +    S14**(-1) - 76*s12**2 + 8*s12*s23 + 8*s12*s24**2*S14**(-1) - 
     +    32*s12*s24 + 32*s14*s23 + 16*s23*s24 + 24*s24**2 )

      LA = LA + Lc1(p14,p23)*S13**(-1) * ( 56*s12**3*S14**(-1)*
     +    S24**(-1) + 4*s12**2*s23*S14**(-1)*S24**(-1) + 8*s12**2*s34*
     +    S14**(-1)*S24**(-1) + 112*s12**2*S14**(-1) - 20*s12**2*
     +    S24**(-1) - 8*s12*s14*S24**(-1) + 8*s12*s23*s34*S14**(-1)*
     +    S24**(-1) + 4*s12*s23*S14**(-1) + 32*s12*s24*S14**(-1) + 16*
     +    s12*s34*S14**(-1) + 16*s12*s34*S24**(-1) + 16*s12 - 24*s23 )

      LA = LA + Lc1(p14,p23)*S23**(-1)*S234**(-1) * ( 16*s12**4*
     +    S14**(-1)*S24**(-1) - 64*s12**3*s13*S14**(-1)*S24**(-1) + 48*
     +    s12**3*S14**(-1) - 8*s12**3*S24**(-1) + 24*s12**2*s13**2*
     +    S14**(-1)*S24**(-1) + 24*s12**2*s13*S14**(-1) + 16*s12**2*s13
     +    *S24**(-1) - 8*s12*s13**3*S14**(-1)*S24**(-1) + 72*s12*s13**2
     +    *S14**(-1) + 8*s12*s13**2*S24**(-1) + 32*s12*s13*s24*
     +    S14**(-1) + 8*s12*s24 + 16*s13**2*s24*S14**(-1) + 8*s13*s24 )

      LA = LA + Lc1(p14,p23)*S23**(-1)*S134**(-1) * ( 32*s12*s24**2*
     +    S14**(-1) + 8*s13*s24**2*S14**(-1) - 16*s24**3*S14**(-1) + 8*
     +    s24**2 )

      LA = LA + Lc1(p14,p23)*S23**(-1) * (  - 120*s12**3*S14**(-1)*
     +    S24**(-1) - 8*s12**2*s13*S14**(-1)*S24**(-1) - 16*s12**2*s34*
     +    S14**(-1)*S24**(-1) - 64*s12**2*S14**(-1) - 16*s12*s13**2*
     +    S14**(-1)*S24**(-1) - 8*s12*s13*s34*S14**(-1)*S24**(-1) + 32*
     +    s12*s13*S14**(-1) + 32*s12*s24*S14**(-1) - 8*s12*s34*
     +    S24**(-1) - 16*s12 - 16*s24**2*S14**(-1) - 16*s24 )

      LA = LA + Lc1(p14,p23)*S234**(-1) * ( 32*s12**3*S14**(-1)*
     +    S24**(-1) + 48*s12**2*s13*S14**(-1)*S24**(-1) - 12*s12**2*s23
     +    *S14**(-1)*S24**(-1) - 12*s12**2*S14**(-1) - 40*s12**2*
     +    S24**(-1) + 16*s12*s13**2*S14**(-1)*S24**(-1) - 8*s12*s13*s23
     +    *S14**(-1)*S24**(-1) + 4*s12*s13*S14**(-1) + 16*s12*s13*
     +    S24**(-1) + 16*s12*s23*S24**(-1) - 28*s12 + 8*s13**2*
     +    S24**(-1) - 16*s13*s23*S24**(-1) - 32*s13 + 16*s14*s23*
     +    S24**(-1) + 8*s14 + 8*s23**2*S24**(-1) )

      LA = LA + Lc1(p14,p23)*S134**(-1) * (  - 44*s12**2*S14**(-1) - 16
     +    *s12*s13*S14**(-1) - 4*s12*s23*S14**(-1) - 36*s12*s24*
     +    S14**(-1) - 40*s12 - 16*s13*s23*S14**(-1) - 16*s13*s24*
     +    S14**(-1) - 8*s14 + 24*s23 - 16*s24**2*S14**(-1) - 8*s24 )

      LA = LA + Lc1(p14,p23) * ( 16 + 8*s12**2*S14**(-1)*S24**(-1) - 16
     +    *s12*s13*S14**(-1)*S24**(-1) + 16*s12*s23*S14**(-1)*S24**(-1)
     +     - 16*s12*s34*S14**(-1)*S24**(-1) + 16*s12*S14**(-1) - 12*s12
     +    *S24**(-1) - 16*s13*S14**(-1) + 8*s13*S24**(-1) - 8*s14*
     +    S24**(-1) - 16*s23*S24**(-1) - 8*s24*S14**(-1) )

      LA = LA + Lc1(p23,p14)*S13**(-1)*S23**(-1)*S134**(-1) * ( 16*
     +    s12**4*S14**(-1) - 64*s12**3*s24*S14**(-1) + 32*s12**3 - 12*
     +    s12**2*s14 + 24*s12**2*s24**2*S14**(-1) + 48*s12**2*s24 - 8*
     +    s12*s14*s24 - 8*s12*s24**3*S14**(-1) + 16*s12*s24**2 )

      LA = LA + Lc1(p23,p14)*S13**(-1)*S23**(-1) * (  - 24*s12**3*s34*
     +    S14**(-1)*S24**(-1) - 120*s12**3*S14**(-1) + 56*s12**3*
     +    S24**(-1) + 4*s12**2*s14*S24**(-1) - 8*s12**2*s24*S14**(-1)
     +     - 16*s12**2*s34*S14**(-1) + 8*s12**2*s34*S24**(-1) + 8*
     +    s12**2 + 8*s12*s14*s34*S24**(-1) + 16*s12*s14 - 16*s12*s24**2
     +    *S14**(-1) - 8*s12*s24*s34*S14**(-1) - 16*s12*s24 - 16*s12*
     +    s34 )

      LA = LA + Lc1(p23,p14)*S13**(-1)*S134**(-1) * (  - 8*s12**3*
     +    S14**(-1) + 16*s12**2*s24*S14**(-1) - 40*s12**2 + 16*s12*s14
     +     + 8*s12*s24**2*S14**(-1) + 16*s12*s24 + 8*s14**2 + 16*s14*
     +    s23 - 16*s14*s24 + 8*s24**2 )

      LA = LA + Lc1(p23,p14)*S13**(-1) * (  - 8*s12**2*s34*S14**(-1)*
     +    S24**(-1) - 20*s12**2*S24**(-1) - 8*s12*s23*S24**(-1) - 8*s12
     +    *s34*S14**(-1) + 16*s12*s34*S24**(-1) - 12*s12 - 16*s14 - 8*
     +    s23 + 8*s24 )

      LA = LA + Lc1(p23,p14)*S23**(-1)*S234**(-1) * ( 32*s12**2*s13**2*
     +    S14**(-1)*S24**(-1) + 24*s12**2*s13*S24**(-1) - 44*s12**2 - 8
     +    *s12*s13**3*S14**(-1)*S24**(-1) + 32*s12*s13**2*S14**(-1) + 8
     +    *s12*s13**2*S24**(-1) - 36*s12*s13 - 4*s12*s14 - 16*s12*s24
     +     - 16*s13**3*S14**(-1) + 8*s13**2*s24*S14**(-1) - 16*s13**2
     +     - 16*s13*s24 - 16*s14*s24 )

      LA = LA + Lc1(p23,p14)*S23**(-1)*S134**(-1) * ( 48*s12**3*
     +    S14**(-1) + 24*s12**2*s24*S14**(-1) - 12*s12**2 + 32*s12*s13*
     +    s24*S14**(-1) + 72*s12*s24**2*S14**(-1) + 4*s12*s24 + 16*s13*
     +    s24**2*S14**(-1) )

      LA = LA + Lc1(p23,p14)*S23**(-1) * ( 32*s12**2*s13*S14**(-1)*
     +    S24**(-1) - 64*s12**2*S14**(-1) + 112*s12**2*S24**(-1) + 8*
     +    s12*s13*s34*S14**(-1)*S24**(-1) + 32*s12*s13*S14**(-1) + 32*
     +    s12*s13*S24**(-1) + 4*s12*s14*S24**(-1) + 32*s12*s24*
     +    S14**(-1) + 16*s12*s34*S24**(-1) + 16*s12 - 16*s13**2*
     +    S14**(-1) - 8*s13 - 16*s24 )

      LA = LA + Lc1(p23,p14)*S234**(-1) * (  - 76*s12**2*S24**(-1) - 32
     +    *s12*s13*S24**(-1) + 8*s12*s14*S24**(-1) - 40*s12 + 8*s13**2*
     +    S14**(-1) + 24*s13**2*S24**(-1) + 16*s13*s14*S24**(-1) - 8*
     +    s13 + 32*s14*s23*S24**(-1) + 24*s14 - 8*s23 )

      LA = LA + Lc1(p23,p14)*S134**(-1) * ( 8*s12*s13*S14**(-1) - 28*
     +    s12 + 8*s13*s24*S14**(-1) + 8*s23 - 32*s24 )

      LA = LA + Lc1(p23,p14) * ( 16 - 16*s12*s13*S14**(-1)*S24**(-1) - 
     +    16*s12*S14**(-1) + 16*s12*S24**(-1) - 16*s13*S14**(-1) - 24*
     +    s14*S24**(-1) )

      LA = LA + Lc1(p24,p13)*S13**(-1)*S23**(-1)*S234**(-1) * ( 32*
     +    s12**2*s14**2*S24**(-1) - 8*s12*s14**3*S24**(-1) )

      LA = LA + Lc1(p24,p13)*S13**(-1)*S23**(-1) * (  - 24*s12**3*s34*
     +    S14**(-1)*S24**(-1) + 32*s12**2*s14*S24**(-1) - 8*s12**2*s34*
     +    S14**(-1) + 8*s12*s14*s34*S24**(-1) - 16*s12*s14 )

      LA = LA + Lc1(p24,p13)*S13**(-1)*S234**(-1) * ( 32*s12*s14**2*
     +    S24**(-1) - 16*s14**3*S24**(-1) + 8*s14**2*s23*S24**(-1) + 8*
     +    s14**2 )

      LA = LA + Lc1(p24,p13)*S13**(-1)*S134**(-1) * ( 16*s12**4*
     +    S14**(-1)*S24**(-1) - 64*s12**3*s23*S14**(-1)*S24**(-1) - 8*
     +    s12**3*S14**(-1) + 48*s12**3*S24**(-1) + 24*s12**2*s23**2*
     +    S14**(-1)*S24**(-1) + 16*s12**2*s23*S14**(-1) + 24*s12**2*s23
     +    *S24**(-1) + 32*s12*s14*s23*S24**(-1) + 8*s12*s14 - 8*s12*
     +    s23**3*S14**(-1)*S24**(-1) + 8*s12*s23**2*S14**(-1) + 72*s12*
     +    s23**2*S24**(-1) + 16*s14*s23**2*S24**(-1) + 8*s14*s23 )

      LA = LA + Lc1(p24,p13)*S13**(-1) * (  - 120*s12**3*S14**(-1)*
     +    S24**(-1) - 8*s12**2*s23*S14**(-1)*S24**(-1) - 16*s12**2*s34*
     +    S14**(-1)*S24**(-1) - 64*s12**2*S24**(-1) + 32*s12*s14*
     +    S24**(-1) - 16*s12*s23**2*S14**(-1)*S24**(-1) - 8*s12*s23*s34
     +    *S14**(-1)*S24**(-1) + 32*s12*s23*S24**(-1) - 8*s12*s34*
     +    S14**(-1) - 16*s12 - 16*s14**2*S24**(-1) - 16*s14 )

      LA = LA + Lc1(p24,p13)*S23**(-1)*S234**(-1) * ( 24*s12**2*s14*
     +    S24**(-1) - 76*s12**2 + 8*s12*s13 + 8*s12*s14**2*S24**(-1) - 
     +    32*s12*s14 + 16*s13*s14 + 32*s13*s24 + 24*s14**2 )

      LA = LA + Lc1(p24,p13)*S23**(-1) * ( 56*s12**3*S14**(-1)*
     +    S24**(-1) + 4*s12**2*s13*S14**(-1)*S24**(-1) + 8*s12**2*s34*
     +    S14**(-1)*S24**(-1) - 20*s12**2*S14**(-1) + 112*s12**2*
     +    S24**(-1) + 8*s12*s13*s34*S14**(-1)*S24**(-1) + 4*s12*s13*
     +    S24**(-1) + 32*s12*s14*S24**(-1) - 8*s12*s24*S14**(-1) + 16*
     +    s12*s34*S14**(-1) + 16*s12*s34*S24**(-1) + 16*s12 - 24*s13 )

      LA = LA + Lc1(p24,p13)*S234**(-1) * (  - 44*s12**2*S24**(-1) - 4*
     +    s12*s13*S24**(-1) - 36*s12*s14*S24**(-1) - 16*s12*s23*
     +    S24**(-1) - 40*s12 - 16*s13*s23*S24**(-1) + 24*s13 - 16*
     +    s14**2*S24**(-1) - 16*s14*s23*S24**(-1) - 8*s14 - 8*s24 )

      LA = LA + Lc1(p24,p13)*S134**(-1) * ( 32*s12**3*S14**(-1)*
     +    S24**(-1) - 12*s12**2*s13*S14**(-1)*S24**(-1) + 48*s12**2*s23
     +    *S14**(-1)*S24**(-1) - 40*s12**2*S14**(-1) - 12*s12**2*
     +    S24**(-1) - 8*s12*s13*s23*S14**(-1)*S24**(-1) + 16*s12*s13*
     +    S14**(-1) + 16*s12*s23**2*S14**(-1)*S24**(-1) + 16*s12*s23*
     +    S14**(-1) + 4*s12*s23*S24**(-1) - 28*s12 + 8*s13**2*S14**(-1)
     +     - 16*s13*s23*S14**(-1) + 16*s13*s24*S14**(-1) + 8*s23**2*
     +    S14**(-1) - 32*s23 + 8*s24 )

      LA = LA + Lc1(p24,p13) * ( 16 + 8*s12**2*S14**(-1)*S24**(-1) + 16
     +    *s12*s13*S14**(-1)*S24**(-1) - 16*s12*s23*S14**(-1)*S24**(-1)
     +     - 16*s12*s34*S14**(-1)*S24**(-1) - 12*s12*S14**(-1) + 16*s12
     +    *S24**(-1) - 16*s13*S14**(-1) - 8*s14*S24**(-1) + 8*s23*
     +    S14**(-1) - 16*s23*S24**(-1) - 8*s24*S14**(-1) )

      LA = LA + Lc2(p1,p234)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 4*
     +    s14**2*s24 )

      LA = LA + Lc2(p1,p234)*S13**(-1)*S23**(-1) * (  - 16*s14**2*s34*
     +    S24**(-1) - 20*s14**2 )

      LA = LA + Lc2(p1,p234)*S13**(-1)*S134**(-1) * ( 4*s14**3*
     +    S24**(-1) - 4*s14**2*s23*S24**(-1) - 4*s14**2 )

      LA = LA + Lc2(p1,p234)*S13**(-1) * (  - 16*s14**2*S24**(-1) )

      LA = LA + Lc2(p1,p234)*S23**(-1)*S134**(-1) * ( 4*s13**3*
     +    S14**(-1) - 4*s13**2*s24*S14**(-1) + 16*s13**2 + 20*s13*s14
     +     - 12*s13*s24 + 8*s14**2 - 8*s14*s24 )

      LA = LA + Lc2(p1,p234)*S23**(-1) * (  - 16*s13**2*s34*S14**(-1)*
     +    S24**(-1) - 16*s13**2*S14**(-1) - 48*s13*s34*S24**(-1) - 48*
     +    s13 - 48*s14*s34*S24**(-1) - 44*s14 )

      LA = LA + Lc2(p1,p234)*S134**(-1) * (  - 4*s13**2*s23*S14**(-1)*
     +    S24**(-1) - 4*s13**2*S14**(-1) + 8*s13**2*S24**(-1) + 20*s13*
     +    s14*S24**(-1) - 8*s13*s23*S24**(-1) + 16*s14**2*S24**(-1) - 
     +    12*s14*s23*S24**(-1) )

      LA = LA + Lc2(p1,p234) * (  - 20*s13**2*S14**(-1)*S24**(-1) - 44*
     +    s13*S24**(-1) - 48*s14*S24**(-1) )

      LA = LA + Lc2(p2,p134)*S13**(-1)*S23**(-1)*S234**(-1) * (  - 4*
     +    s14*s24**2 )

      LA = LA + Lc2(p2,p134)*S13**(-1)*S23**(-1) * (  - 16*s24**2*s34*
     +    S14**(-1) - 20*s24**2 )

      LA = LA + Lc2(p2,p134)*S13**(-1)*S234**(-1) * (  - 4*s14*s23**2*
     +    S24**(-1) - 12*s14*s23 - 8*s14*s24 + 4*s23**3*S24**(-1) + 16*
     +    s23**2 + 20*s23*s24 + 8*s24**2 )

      LA = LA + Lc2(p2,p134)*S13**(-1) * (  - 16*s23**2*s34*S14**(-1)*
     +    S24**(-1) - 16*s23**2*S24**(-1) - 48*s23*s34*S14**(-1) - 48*
     +    s23 - 48*s24*s34*S14**(-1) - 44*s24 )

      LA = LA + Lc2(p2,p134)*S23**(-1)*S234**(-1) * (  - 4*s13*s24**2*
     +    S14**(-1) + 4*s24**3*S14**(-1) - 4*s24**2 )

      LA = LA + Lc2(p2,p134)*S23**(-1) * (  - 16*s24**2*S14**(-1) )

      LA = LA + Lc2(p2,p134)*S234**(-1) * (  - 4*s13*s23**2*S14**(-1)*
     +    S24**(-1) - 8*s13*s23*S14**(-1) - 12*s13*s24*S14**(-1) + 8*
     +    s23**2*S14**(-1) - 4*s23**2*S24**(-1) + 20*s23*s24*S14**(-1)
     +     + 16*s24**2*S14**(-1) )

      LA = LA + Lc2(p2,p134) * (  - 20*s23**2*S14**(-1)*S24**(-1) - 44*
     +    s23*S14**(-1) - 48*s24*S14**(-1) )

      LA = LA + Lc2(p3,p14)*S13**(-1)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 8*s14**3*s23**4*S14**(-1)*S24**(-1) - 8*s14**3
     +    *s23**3*s24*S14**(-1)*S24**(-1) )

      LA = LA + Lc2(p3,p14)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * ( 8*s13*s14*s23**4*S14**(-1)*S24**(-1) + 8*s13*s14*s23**3*s24
     +    *S14**(-1)*S24**(-1) + 8*s13*s14*s23**3*s34*S14**(-1)*
     +    S24**(-1) - 8*s14**3*s23**3*S14**(-1)*S24**(-1) - 8*s14**2*
     +    s23**4*S14**(-1)*S24**(-1) - 8*s14**2*s23**3*s24*S14**(-1)*
     +    S24**(-1) - 8*s14**2*s23**3*s34*S14**(-1)*S24**(-1) )

      LA = LA + Lc2(p3,p14)*S23**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s12**2*s13 + 8*s12**2*s14 + 20*s12*s13**2 + 20*s12*s13*s14 - 
     +    16*s12*s13*s24 - 16*s12*s14*s24 - 4*s13**2*s24 - 20*s13*s14*
     +    s24 - 16*s14**2*s24 )

      LA = LA + Lc2(p3,p14)*S23**(-1)*S234**(-1) * (  - 8*s12**2 - 20*
     +    s12*s13 - 4*s12*s24 + 4*s13*s24 + 16*s14*s24 + 4*s24**2 )

      LA = LA + Lc2(p3,p14)*S23**(-1)*S134**(-1) * (  - 4*s12**2*s13*
     +    S14**(-1) - 4*s12**2 + 8*s12*s13*s14*S24**(-1) - 8*s12*s13*
     +    s24*S14**(-1) + 16*s12*s13 + 8*s12*s14**2*S24**(-1) + 16*s12*
     +    s14 - 8*s12*s24 - 4*s13*s24**2*S14**(-1) - 8*s13*s24 - 8*s14*
     +    s24 - 4*s24**2 )

      LA = LA + Lc2(p3,p14)*S23**(-1) * ( 4*s12**2*S14**(-1) - 8*s12*
     +    s14*S24**(-1) + 8*s12*s24*S14**(-1) + 4*s12 + 4*s24**2*
     +    S14**(-1) + 4*s24 )

      LA = LA + Lc2(p3,p14)*S34**(-1)*S134**(-1) * ( 8*s13**2*s23*
     +    S24**(-1) + 16*s13*s23**2*S24**(-1) - 12*s13*s23 )

      LA = LA + Lc2(p3,p14)*S34**(-1) * (  - 8*s13*s23*S24**(-1) + 8*
     +    s14*s23*S24**(-1) - 8*s23**2*S24**(-1) + 12*s23 )

      LA = LA + Lc2(p3,p14)*S234**(-1)*S134**(-1) * ( 4*s12**2*s13*
     +    S24**(-1) + 4*s12**2*s14*S24**(-1) + 12*s12*s13**2*S24**(-1)
     +     + 12*s12*s13*s14*S24**(-1) - 20*s12*s13*s23*S24**(-1) - 40*
     +    s12*s13 - 20*s12*s14*s23*S24**(-1) - 32*s12*s14 + 4*s13**3*
     +    S24**(-1) + 4*s13**2*s14*S24**(-1) - 4*s13**2*s23*S24**(-1)
     +     + 8*s13**2 + 4*s13*s14*s23*S24**(-1) + 8*s13*s14 - 20*s13*
     +    s23 - 20*s13*s24 + 8*s14**2*s23*S24**(-1) - 8*s14**2 - 20*s14
     +    *s23 - 20*s14*s24 )

      LA = LA + Lc2(p3,p14)*S234**(-1) * (  - 4*s12**2*S24**(-1) - 12*
     +    s12*s13*S24**(-1) + 8*s12*s23*S24**(-1) + 8*s12 - 4*s13**2*
     +    S24**(-1) - 12*s13 - 4*s14*s23*S24**(-1) + 4*s14 + 8*s23 + 12
     +    *s24 )

      LA = LA + Lc2(p3,p14)*S134**(-1) * (  - 4*s12**2*S24**(-1) + 4*
     +    s12*s13*S14**(-1) + 24*s12*s13*S24**(-1) + 16*s12*s14*
     +    S24**(-1) - 4*s12*s23*S24**(-1) + 12*s12 + 4*s13**2*S24**(-1)
     +     + 8*s13*s23*S14**(-1) + 8*s13*s23*S24**(-1) + 4*s13*s24*
     +    S14**(-1) + 32*s13 + 8*s14**2*S24**(-1) + 48*s14 + 8*s23**2*
     +    S24**(-1) - 4*s23 + 16*s24 )

      LA = LA + Lc2(p3,p14) * (  - 20 - 4*s12*S14**(-1) - 12*s12*
     +    S24**(-1) - 8*s23*S14**(-1) - 4*s24*S14**(-1) )

      LA = LA + Lc2(p3,p24)*S13**(-1)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 8*s13**4*s24**3*S14**(-1)*S24**(-1) - 8*s13**3
     +    *s14*s24**3*S14**(-1)*S24**(-1) )

      LA = LA + Lc2(p3,p24)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 8*s13**3*s24**3*S14**(-1)*S24**(-1) )

      LA = LA + Lc2(p3,p24)*S13**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s12**2*s14 + 4*s12*s14**2 - 20*s12*s14*s24 - 4*s14**3 - 12*
     +    s14**2*s24 )

      LA = LA + Lc2(p3,p24)*S13**(-1)*S234**(-1) * ( 4*s12**2*s34*
     +    S24**(-1) - 8*s12**2 + 8*s12*s14*s34*S24**(-1) - 4*s12*s14 - 
     +    8*s12*s24*s34*S14**(-1) + 20*s12*s24 + 4*s12*s34 + 4*s14**2*
     +    s34*S24**(-1) + 4*s14**2 + 12*s14*s24 + 4*s14*s34 )

      LA = LA + Lc2(p3,p24)*S34**(-1)*S234**(-1) * ( 8*s13*s24**2*
     +    S14**(-1) + 12*s13*s24 )

      LA = LA + Lc2(p3,p24)*S234**(-1)*S134**(-1) * ( 4*s12**2*s13*
     +    S14**(-1) + 12*s12**2 - 8*s12*s13**2*S14**(-1) - 12*s12*s13*
     +    s24*S14**(-1) - 16*s12*s13 - 4*s12*s14 - 24*s12*s24 + 4*
     +    s13**2*s24*S14**(-1) - 8*s13**2 - 20*s13*s14 + 4*s13*s24**2*
     +    S14**(-1) - 12*s13*s24 - 16*s14**2 - 28*s14*s24 - 4*s24**2 )

      LA = LA + Lc2(p3,p24)*S234**(-1) * (  - 8*s12**2*S14**(-1) + 4*
     +    s12*s13*S14**(-1) + 4*s12*s24*S14**(-1) - 12*s12*s34*
     +    S14**(-1) - 4*s12*s34*S24**(-1) + 16*s12 + 4*s13*s24*
     +    S14**(-1) - 8*s13*s34*S24**(-1) + 8*s13 - 4*s14*s34*S24**(-1)
     +     + 24*s14 + 8*s24**2*S14**(-1) + 32*s24 - 20*s34 )

      LA = LA + Lc2(p4,p13)*S13**(-1)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 8*s13**3*s23*s24**3*S14**(-1)*S24**(-1) - 8*
     +    s13**3*s24**4*S14**(-1)*S24**(-1) )

      LA = LA + Lc2(p4,p13)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 8*s13**3*s24**3*S14**(-1)*S24**(-1) )

      LA = LA + Lc2(p4,p13)*S13**(-1)*S134**(-1) * ( 4*s12**2*s34*
     +    S24**(-1) + 8*s12*s23*s34*S24**(-1) - 4*s12*s34 + 4*s23**2*
     +    s34*S24**(-1) - 4*s23*s34 - 8*s24*s34 )

      LA = LA + Lc2(p4,p13)*S23**(-1)*S34**(-1)*S134**(-1) * ( 8*s13**2
     +    *s24 )

      LA = LA + Lc2(p4,p13)*S23**(-1)*S234**(-1)*S134**(-1) * ( 4*
     +    s12**2*s24 - 12*s12*s13*s24 - 8*s12*s24**2 + 4*s13**2*s24 + 4
     +    *s13*s24**2 )

      LA = LA + Lc2(p4,p13)*S23**(-1)*S134**(-1) * (  - 8*s12**2 - 8*
     +    s12*s13*s34*S24**(-1) + 4*s12*s13 + 4*s12*s24 - 12*s12*s34 + 
     +    8*s13**2 + 4*s13*s24 )

      LA = LA + Lc2(p4,p13)*S34**(-1)*S134**(-1) * ( 12*s13*s24 )

      LA = LA + Lc2(p4,p13)*S234**(-1)*S134**(-1) * ( 8*s12**2*s23*
     +    S24**(-1) + 12*s12**2 - 20*s12*s13*s23*S24**(-1) - 24*s12*s13
     +     + 4*s12*s23**2*S24**(-1) - 4*s12*s23 - 16*s12*s24 - 4*s13**2
     +     - 12*s13*s23**2*S24**(-1) - 28*s13*s23 - 12*s13*s24 - 4*
     +    s23**3*S24**(-1) - 16*s23**2 - 20*s23*s24 - 8*s24**2 )

      LA = LA + Lc2(p4,p13)*S134**(-1) * (  - 8*s12**2*S24**(-1) + 20*
     +    s12*s13*S24**(-1) - 4*s12*s23*S24**(-1) + 4*s12*s34*S24**(-1)
     +     + 16*s12 + 12*s13*s23*S24**(-1) + 32*s13 + 4*s23**2*
     +    S24**(-1) + 4*s23*s34*S24**(-1) + 24*s23 + 8*s24 - 20*s34 )

      LA = LA + Lc2(p4,p23)*S13**(-1)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 8*s13*s14**3*s23**3*S14**(-1)*S24**(-1) - 8*
     +    s14**4*s23**3*S14**(-1)*S24**(-1) )

      LA = LA + Lc2(p4,p23)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 8*s14**3*s23**3*S14**(-1)*S24**(-1) )

      LA = LA + Lc2(p4,p23)*S13**(-1)*S34**(-1)*S234**(-1) * ( 8*s14*
     +    s23**2 )

      LA = LA + Lc2(p4,p23)*S13**(-1)*S234**(-1)*S134**(-1) * ( 4*
     +    s12**2*s14 - 20*s12*s14*s23 - 8*s12*s14*s24 + 8*s14*s23**2 + 
     +    4*s14*s23*s24 )

      LA = LA + Lc2(p4,p23)*S13**(-1)*S234**(-1) * (  - 8*s12**2 - 4*
     +    s12*s14 + 8*s12*s23**2*S14**(-1) + 8*s12*s23*s24*S14**(-1) + 
     +    16*s12*s23 + 12*s12*s24 + 8*s14*s23 + 8*s23**2 )

      LA = LA + Lc2(p4,p23)*S13**(-1)*S134**(-1) * ( 8*s12*s14 - 4*s14*
     +    s23 )

      LA = LA + Lc2(p4,p23)*S13**(-1) * (  - 8*s12*s23*S14**(-1) - 12*
     +    s12 )

      LA = LA + Lc2(p4,p23)*S23**(-1)*S234**(-1) * (  - 4*s12**2*s24*
     +    S14**(-1) - 8*s12*s13*s24*S14**(-1) + 4*s12*s24 - 4*s13**2*
     +    s24*S14**(-1) + 4*s13*s24 + 8*s14*s24 )

      LA = LA + Lc2(p4,p23)*S23**(-1) * ( 4*s12**2*S14**(-1) + 8*s12*
     +    s13*S14**(-1) - 4*s12 + 4*s13**2*S14**(-1) - 4*s13 - 8*s14 )

      LA = LA + Lc2(p4,p23)*S34**(-1)*S234**(-1) * ( 12*s14*s23 )

      LA = LA + Lc2(p4,p23)*S234**(-1)*S134**(-1) * ( 8*s12**2*s13*
     +    S14**(-1) + 12*s12**2 - 16*s12*s13*s23*S14**(-1) + 4*s12*s13*
     +    s24*S14**(-1) - 4*s12*s13 - 4*s12*s14 - 28*s12*s23 - 4*s12*
     +    s24 - 4*s13**2*s23*S14**(-1) - 4*s13**2*s24*S14**(-1) - 12*
     +    s13*s23**2*S14**(-1) - 12*s13*s23*s24*S14**(-1) - 20*s13*s23
     +     - 12*s13*s24 - 16*s14*s23 - 8*s14*s24 - 12*s23**2 - 8*s23*
     +    s24 )

      LA = LA + Lc2(p4,p23)*S234**(-1) * (  - 12*s12**2*S14**(-1) - 8*
     +    s12*s13*S14**(-1) + 16*s12*s23*S14**(-1) - 4*s12*s24*
     +    S14**(-1) + 16*s12 - 4*s13**2*S14**(-1) - 4*s13*s23*S14**(-1)
     +     - 4*s13*s24*S14**(-1) + 16*s13 + 8*s14 + 44*s23 + 20*s24 )

      LA = LA + Lc2(p4,p23)*S134**(-1) * (  - 4*s12*s13*S14**(-1) + 4*
     +    s12 + 4*s13**2*S14**(-1) + 12*s13*s23*S14**(-1) + 12*s13 + 8*
     +    s14 + 8*s23 )

      LA = LA + Lc2(p4,p23) * (  - 20 + 4*s12*S14**(-1) + 4*s13*
     +    S14**(-1) )

      LA = LA + Lc2(p13,p24)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12**4*s14*S24**(-1) + 16*s12**4 )

      LA = LA + Lc2(p13,p24)*S13**(-1)*S23**(-1)*S234**(-1) * ( 16*
     +    s12**4*S24**(-1) + 24*s12**3*s14*S24**(-1) - 8*s12**3 - 96*
     +    s12**2*s14**2*S24**(-1) - 8*s12**2*s14 + 16*s12*s14**3*
     +    S24**(-1) )

      LA = LA + Lc2(p13,p24)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 16*
     +    s12**4*S24**(-1) )

      LA = LA + Lc2(p13,p24)*S13**(-1)*S23**(-1) * ( 16*s12**4*
     +    S14**(-1)*S24**(-1) + 16*s12**3*s34*S14**(-1)*S24**(-1) + 56*
     +    s12**3*S24**(-1) - 80*s12**2*s14*S24**(-1) - 16*s12**2*s34*
     +    S14**(-1) + 16*s12**2*s34*S24**(-1) + 16*s12*s14**2*S24**(-1)
     +     )

      LA = LA + Lc2(p13,p24)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**4*S24**(-1) )

      LA = LA + Lc2(p13,p24)*S13**(-1)*S234**(-1) * (  - 8*s12**3*
     +    S24**(-1) + 8*s12**2*s14*S24**(-1) - 8*s12**2*s23*S24**(-1)
     +     - 8*s12**2 - 104*s12*s14**2*S24**(-1) - 16*s12*s14*s23*
     +    S24**(-1) - 8*s12*s14 + 16*s14**3*S24**(-1) - 8*s14**2*s23*
     +    S24**(-1) )

      LA = LA + Lc2(p13,p24)*S13**(-1)*S134**(-1) * ( 24*s12**3*s23*
     +    S14**(-1)*S24**(-1) + 24*s12**3*S14**(-1) - 8*s12**3*
     +    S24**(-1) - 8*s12**2*s14*S24**(-1) - 96*s12**2*s23**2*
     +    S14**(-1)*S24**(-1) - 48*s12**2*s23*S14**(-1) + 8*s12**2*s23*
     +    S24**(-1) + 64*s12**2 - 16*s12*s14*s23*S24**(-1) + 24*s12*s14
     +     + 16*s12*s23**3*S14**(-1)*S24**(-1) - 104*s12*s23**2*
     +    S24**(-1) + 8*s12*s23 - 8*s14*s23**2*S24**(-1) + 24*s14*s23
     +     + 16*s23**3*S24**(-1) + 16*s23**2 )

      LA = LA + Lc2(p13,p24)*S13**(-1) * ( 56*s12**3*S14**(-1)*
     +    S24**(-1) - 80*s12**2*s23*S14**(-1)*S24**(-1) + 16*s12**2*s34
     +    *S14**(-1)*S24**(-1) - 96*s12**2*S14**(-1) + 96*s12**2*
     +    S24**(-1) - 80*s12*s14*S24**(-1) + 16*s12*s23**2*S14**(-1)*
     +    S24**(-1) - 24*s12*s23*S14**(-1) - 80*s12*s23*S24**(-1) - 16*
     +    s12*s34*S14**(-1) + 16*s12*s34*S24**(-1) - 64*s12 + 16*s14**2
     +    *S24**(-1) + 16*s23**2*S24**(-1) + 8*s23 )

      LA = LA + Lc2(p13,p24)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 16*
     +    s12**4*s13*S14**(-1)*S24**(-1) + 16*s12**4*S14**(-1) - 32*
     +    s12**4*S24**(-1) )

      LA = LA + Lc2(p13,p24)*S23**(-1)*S234**(-1) * ( 16*s12**4*
     +    S14**(-1)*S24**(-1) + 24*s12**3*S24**(-1) - 48*s12**2*s14*
     +    S24**(-1) + 48*s12**2 - 16*s12*s13 + 48*s12*s14 - 24*s12*s24
     +     - 16*s13*s14 + 16*s13*s24 )

      LA = LA + Lc2(p13,p24)*S23**(-1)*S134**(-1) * (  - 16*s12**4*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Lc2(p13,p24)*S23**(-1) * (  - 16*s12**2*s34*S14**(-1)*
     +    S24**(-1) + 80*s12**2*S14**(-1) - 96*s12**2*S24**(-1) - 8*s12
     +    *s13*S14**(-1) - 24*s12*s14*S24**(-1) - 8*s12*s24*S14**(-1)
     +     + 16*s12*s34*S14**(-1) - 16*s12*s34*S24**(-1) + 80*s12 - 8*
     +    s13 )

      LA = LA + Lc2(p13,p24)*S234**(-1)*S134**(-1) * ( 16*s12**4*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Lc2(p13,p24)*S234**(-1) * ( 64*s12**2*S24**(-1) + 8*s12
     +    *s14*S24**(-1) + 24*s12*s23*S24**(-1) + 24*s12 + 8*s13 + 16*
     +    s14**2*S24**(-1) + 24*s14*s23*S24**(-1) + 24*s14 - 16*s24 )

      LA = LA + Lc2(p13,p24)*S134**(-1) * (  - 8*s12**3*S14**(-1)*
     +    S24**(-1) - 8*s12**2*s23*S14**(-1)*S24**(-1) + 48*s12**2*
     +    S14**(-1) - 8*s12**2*S24**(-1) - 24*s12*s13*S14**(-1) + 48*
     +    s12*s23*S14**(-1) - 8*s12*s23*S24**(-1) - 16*s12*s24*
     +    S14**(-1) + 24*s12 + 16*s13*s24*S14**(-1) - 16*s13 - 16*s23*
     +    s24*S14**(-1) + 24*s23 + 8*s24 )

      LA = LA + Lc2(p13,p24) * ( 64 + 80*s12*S14**(-1) - 64*s12*
     +    S24**(-1) + 8*s14*S24**(-1) - 8*s24*S14**(-1) )

      LA = LA + Lc2(p14,p23)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12**4*s14*S24**(-1) + 16*s12**4 )

      LA = LA + Lc2(p14,p23)*S13**(-1)*S23**(-1)*S234**(-1) * ( 16*
     +    s12**4*S24**(-1) )

      LA = LA + Lc2(p14,p23)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 16*
     +    s12**4*S24**(-1) + 24*s12**3*s24*S14**(-1) - 8*s12**3 - 96*
     +    s12**2*s24**2*S14**(-1) - 8*s12**2*s24 + 16*s12*s24**3*
     +    S14**(-1) )

      LA = LA + Lc2(p14,p23)*S13**(-1)*S23**(-1) * ( 16*s12**4*
     +    S14**(-1)*S24**(-1) + 16*s12**3*s34*S14**(-1)*S24**(-1) + 56*
     +    s12**3*S14**(-1) - 80*s12**2*s24*S14**(-1) + 16*s12**2*s34*
     +    S14**(-1) - 16*s12**2*s34*S24**(-1) + 16*s12*s24**2*S14**(-1)
     +     )

      LA = LA + Lc2(p14,p23)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**4*S24**(-1) )

      LA = LA + Lc2(p14,p23)*S13**(-1)*S134**(-1) * ( 24*s12**3*
     +    S14**(-1) - 48*s12**2*s24*S14**(-1) + 48*s12**2 - 24*s12*s14
     +     - 16*s12*s23 + 48*s12*s24 + 16*s14*s23 - 16*s23*s24 )

      LA = LA + Lc2(p14,p23)*S13**(-1) * (  - 16*s12**2*s34*S14**(-1)*
     +    S24**(-1) - 96*s12**2*S14**(-1) + 80*s12**2*S24**(-1) - 8*s12
     +    *s14*S24**(-1) - 8*s12*s23*S24**(-1) - 24*s12*s24*S14**(-1)
     +     - 16*s12*s34*S14**(-1) + 16*s12*s34*S24**(-1) + 80*s12 - 8*
     +    s23 )

      LA = LA + Lc2(p14,p23)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 16*
     +    s12**4*s13*S14**(-1)*S24**(-1) + 16*s12**4*S14**(-1) - 32*
     +    s12**4*S24**(-1) )

      LA = LA + Lc2(p14,p23)*S23**(-1)*S234**(-1) * ( 16*s12**4*
     +    S14**(-1)*S24**(-1) + 24*s12**3*s13*S14**(-1)*S24**(-1) - 8*
     +    s12**3*S14**(-1) + 24*s12**3*S24**(-1) - 96*s12**2*s13**2*
     +    S14**(-1)*S24**(-1) + 8*s12**2*s13*S14**(-1) - 48*s12**2*s13*
     +    S24**(-1) - 8*s12**2*s24*S14**(-1) + 64*s12**2 + 16*s12*
     +    s13**3*S14**(-1)*S24**(-1) - 104*s12*s13**2*S14**(-1) - 16*
     +    s12*s13*s24*S14**(-1) + 8*s12*s13 + 24*s12*s24 + 16*s13**3*
     +    S14**(-1) - 8*s13**2*s24*S14**(-1) + 16*s13**2 + 24*s13*s24 )

      LA = LA + Lc2(p14,p23)*S23**(-1)*S134**(-1) * (  - 16*s12**4*
     +    S14**(-1)*S24**(-1) - 8*s12**3*S14**(-1) - 8*s12**2*s13*
     +    S14**(-1) + 8*s12**2*s24*S14**(-1) - 8*s12**2 - 16*s12*s13*
     +    s24*S14**(-1) - 104*s12*s24**2*S14**(-1) - 8*s12*s24 - 8*s13*
     +    s24**2*S14**(-1) + 16*s24**3*S14**(-1) )

      LA = LA + Lc2(p14,p23)*S23**(-1) * ( 56*s12**3*S14**(-1)*
     +    S24**(-1) - 80*s12**2*s13*S14**(-1)*S24**(-1) + 16*s12**2*s34
     +    *S14**(-1)*S24**(-1) + 96*s12**2*S14**(-1) - 96*s12**2*
     +    S24**(-1) + 16*s12*s13**2*S14**(-1)*S24**(-1) - 80*s12*s13*
     +    S14**(-1) - 24*s12*s13*S24**(-1) - 80*s12*s24*S14**(-1) + 16*
     +    s12*s34*S14**(-1) - 16*s12*s34*S24**(-1) - 64*s12 + 16*s13**2
     +    *S14**(-1) + 8*s13 + 16*s24**2*S14**(-1) )

      LA = LA + Lc2(p14,p23)*S234**(-1)*S134**(-1) * ( 16*s12**4*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Lc2(p14,p23)*S234**(-1) * (  - 8*s12**3*S14**(-1)*
     +    S24**(-1) - 8*s12**2*s13*S14**(-1)*S24**(-1) - 8*s12**2*
     +    S14**(-1) + 48*s12**2*S24**(-1) - 8*s12*s13*S14**(-1) + 48*
     +    s12*s13*S24**(-1) - 16*s12*s14*S24**(-1) - 24*s12*s23*
     +    S24**(-1) + 24*s12 - 16*s13*s14*S24**(-1) + 24*s13 + 16*s14*
     +    s23*S24**(-1) + 8*s14 - 16*s23 )

      LA = LA + Lc2(p14,p23)*S134**(-1) * ( 64*s12**2*S14**(-1) + 24*
     +    s12*s13*S14**(-1) + 8*s12*s24*S14**(-1) + 24*s12 + 24*s13*s24
     +    *S14**(-1) - 16*s14 + 8*s23 + 16*s24**2*S14**(-1) + 24*s24 )

      LA = LA + Lc2(p14,p23) * ( 64 - 64*s12*S14**(-1) + 80*s12*
     +    S24**(-1) - 8*s14*S24**(-1) + 8*s24*S14**(-1) )

      LAb=-LA
      
      return
      end

      function LAc(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LA=0d0

      LA = LA + Lc3(p13,p24)*S13**(-1)*S23**(-1)*S234**(-1) * (  - 8*
     +    s12**4*S24**(-1) + 24*s12**3*s14*S24**(-1) - 16*s12**3 - 24*
     +    s12**2*s14**2*S24**(-1) - 32*s12**2*s14 + 8*s12**2*s24 + 8*
     +    s12*s14**3*S24**(-1) - 16*s12*s14**2 + 8*s12*s14*s24 )

      LA = LA + Lc3(p13,p24)*S13**(-1)*S23**(-1) * ( 8*s12**3*s34*
     +    S14**(-1)*S24**(-1) - 32*s12**3*S14**(-1) + 48*s12**3*
     +    S24**(-1) + 16*s12**2*s24*S14**(-1) - 16*s12**2*s34*S14**(-1)
     +     + 16*s12**2*s34*S24**(-1) - 64*s12**2 + 16*s12*s14**2*
     +    S24**(-1) + 8*s12*s14*s34*S24**(-1) - 32*s12*s14 + 8*s12*s24*
     +    s34*S14**(-1) + 16*s12*s24 - 16*s12*s34 )

      LA = LA + Lc3(p13,p24)*S13**(-1)*S234**(-1) * (  - 24*s12**3*
     +    S24**(-1) - 16*s12**2*s14*S24**(-1) - 8*s12**2*s23*S24**(-1)
     +     - 56*s12*s14**2*S24**(-1) - 16*s12*s14*s23*S24**(-1) - 8*
     +    s14**2*s23*S24**(-1) )

      LA = LA + Lc3(p13,p24)*S13**(-1)*S134**(-1) * (  - 24*s12**2*
     +    s23**2*S14**(-1)*S24**(-1) + 8*s12**2 + 8*s12*s14 + 32*s12*
     +    s23**3*S14**(-1)*S24**(-1) + 48*s12*s23**2*S14**(-1) - 24*s12
     +    *s23**2*S24**(-1) + 24*s12*s23*s24*S14**(-1) + 8*s12*s23 - 24
     +    *s12*s24 + 8*s14*s23 - 16*s14*s24 + 32*s23**3*S24**(-1) + 48*
     +    s23**2 + 16*s23*s24 )

      LA = LA + Lc3(p13,p24)*S13**(-1) * (  - 24*s12**2*s23*S14**(-1)*
     +    S24**(-1) - 32*s12**2*S14**(-1) + 32*s12**2*S24**(-1) - 32*
     +    s12*s14*S24**(-1) + 32*s12*s23**2*S14**(-1)*S24**(-1) + 48*
     +    s12*s23*S14**(-1) - 24*s12*s23*S24**(-1) + 40*s12*s24*
     +    S14**(-1) - 48*s12 - 16*s14 + 32*s23**2*S24**(-1) + 48*s23 + 
     +    24*s24 )

      LA = LA + Lc3(p13,p24)*S23**(-1)*S234**(-1) * ( 8*s12**2 + 16*s12
     +    *s14 - 16*s12*s24 + 8*s14**2 - 16*s14*s24 + 8*s24**2 )

      LA = LA + Lc3(p13,p24)*S23**(-1) * ( 8*s12**2*S14**(-1) - 16*s12*
     +    s24*S14**(-1) + 16*s12 + 8*s14 - 16*s24 )

      LA = LA + Lc3(p13,p24)*S234**(-1) * (  - 8*s12 - 8*s14 )

      LA = LA + Lc3(p13,p24)*S134**(-1) * ( 16*s12**2*S14**(-1) - 32*
     +    s12*s24*S14**(-1) + 24*s12 + 8*s14 + 8*s24**2*S14**(-1) - 24*
     +    s24 )

      LA = LA + Lc3(p14,p23)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 24*
     +    s12**2*s24**2*S14**(-1) + 32*s12*s24**3*S14**(-1) )

      LA = LA + Lc3(p14,p23)*S13**(-1)*S23**(-1) * ( 8*s12**3*s34*
     +    S14**(-1)*S24**(-1) - 24*s12**2*s24*S14**(-1) + 32*s12*s24**2
     +    *S14**(-1) )

      LA = LA + Lc3(p14,p23)*S13**(-1)*S134**(-1) * ( 16*s12**2 + 24*
     +    s12*s23*s24*S14**(-1) - 32*s12*s23 + 48*s12*s24**2*S14**(-1)
     +     + 8*s23**2 )

      LA = LA + Lc3(p14,p23)*S13**(-1) * (  - 32*s12**3*S14**(-1)*
     +    S24**(-1) + 16*s12**2*s23*S14**(-1)*S24**(-1) - 16*s12**2*s34
     +    *S14**(-1)*S24**(-1) - 32*s12**2*S14**(-1) + 8*s12**2*
     +    S24**(-1) + 8*s12*s23*s34*S14**(-1)*S24**(-1) + 40*s12*s23*
     +    S14**(-1) - 16*s12*s23*S24**(-1) + 48*s12*s24*S14**(-1) )

      LA = LA + Lc3(p14,p23)*S23**(-1)*S234**(-1) * (  - 8*s12**4*
     +    S14**(-1)*S24**(-1) + 24*s12**3*s13*S14**(-1)*S24**(-1) - 24*
     +    s12**3*S14**(-1) - 24*s12**2*s13**2*S14**(-1)*S24**(-1) - 16*
     +    s12**2*s13*S14**(-1) - 8*s12**2*s24*S14**(-1) + 8*s12*s13**3*
     +    S14**(-1)*S24**(-1) - 56*s12*s13**2*S14**(-1) - 16*s12*s13*
     +    s24*S14**(-1) - 8*s13**2*s24*S14**(-1) )

      LA = LA + Lc3(p14,p23)*S23**(-1)*S134**(-1) * (  - 24*s12*s24**2*
     +    S14**(-1) + 32*s24**3*S14**(-1) )

      LA = LA + Lc3(p14,p23)*S23**(-1) * ( 48*s12**3*S14**(-1)*
     +    S24**(-1) + 16*s12**2*s34*S14**(-1)*S24**(-1) + 32*s12**2*
     +    S14**(-1) + 16*s12*s13**2*S14**(-1)*S24**(-1) + 8*s12*s13*s34
     +    *S14**(-1)*S24**(-1) - 32*s12*s13*S14**(-1) - 24*s12*s24*
     +    S14**(-1) + 32*s24**2*S14**(-1) )

      LA = LA + Lc3(p14,p23)*S234**(-1) * (  - 16*s12**3*S14**(-1)*
     +    S24**(-1) - 32*s12**2*s13*S14**(-1)*S24**(-1) + 8*s12**2*s23*
     +    S14**(-1)*S24**(-1) + 8*s12**2*S24**(-1) - 16*s12*s13**2*
     +    S14**(-1)*S24**(-1) + 8*s12*s13*s23*S14**(-1)*S24**(-1) + 16*
     +    s12*s13*S24**(-1) - 16*s12*s23*S24**(-1) - 8*s12 + 8*s13**2*
     +    S24**(-1) - 16*s13*s23*S24**(-1) - 8*s13 + 8*s23**2*S24**(-1)
     +     )

      LA = LA + Lc3(p14,p23)*S134**(-1) * ( 8*s12**2*S14**(-1) + 8*s12*
     +    s13*S14**(-1) - 24*s12*s23*S14**(-1) + 8*s12*s24*S14**(-1) + 
     +    24*s12 - 16*s13*s23*S14**(-1) + 8*s13*s24*S14**(-1) + 8*s13
     +     + 16*s23*s24*S14**(-1) - 24*s23 + 48*s24**2*S14**(-1) )

      LA = LA + Lc3(p14,p23) * (  - 64*s12**2*S14**(-1)*S24**(-1) - 32*
     +    s12*s13*S14**(-1)*S24**(-1) + 16*s12*s23*S14**(-1)*S24**(-1)
     +     - 16*s12*s34*S14**(-1)*S24**(-1) - 48*s12*S14**(-1) + 16*s12
     +    *S24**(-1) - 16*s13*S14**(-1) + 8*s13*S24**(-1) + 24*s23*
     +    S14**(-1) - 16*s23*S24**(-1) + 48*s24*S14**(-1) )

      LA = LA + Lc3(p23,p14)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 8*
     +    s12**4*S14**(-1) + 24*s12**3*s24*S14**(-1) - 16*s12**3 + 8*
     +    s12**2*s14 - 24*s12**2*s24**2*S14**(-1) - 32*s12**2*s24 + 8*
     +    s12*s14*s24 + 8*s12*s24**3*S14**(-1) - 16*s12*s24**2 )

      LA = LA + Lc3(p23,p14)*S13**(-1)*S23**(-1) * ( 8*s12**3*s34*
     +    S14**(-1)*S24**(-1) + 48*s12**3*S14**(-1) - 32*s12**3*
     +    S24**(-1) + 16*s12**2*s14*S24**(-1) + 16*s12**2*s34*S14**(-1)
     +     - 16*s12**2*s34*S24**(-1) - 64*s12**2 + 8*s12*s14*s34*
     +    S24**(-1) + 16*s12*s14 + 16*s12*s24**2*S14**(-1) + 8*s12*s24*
     +    s34*S14**(-1) - 32*s12*s24 - 16*s12*s34 )

      LA = LA + Lc3(p23,p14)*S13**(-1)*S134**(-1) * ( 8*s12**2 - 16*s12
     +    *s14 + 16*s12*s24 + 8*s14**2 - 16*s14*s24 + 8*s24**2 )

      LA = LA + Lc3(p23,p14)*S13**(-1) * ( 8*s12**2*S24**(-1) - 16*s12*
     +    s14*S24**(-1) + 16*s12 - 16*s14 + 8*s24 )

      LA = LA + Lc3(p23,p14)*S23**(-1)*S234**(-1) * (  - 24*s12**2*
     +    s13**2*S14**(-1)*S24**(-1) + 8*s12**2 + 32*s12*s13**3*
     +    S14**(-1)*S24**(-1) - 24*s12*s13**2*S14**(-1) + 48*s12*s13**2
     +    *S24**(-1) + 24*s12*s13*s14*S24**(-1) + 8*s12*s13 - 24*s12*
     +    s14 + 8*s12*s24 + 32*s13**3*S14**(-1) + 48*s13**2 + 16*s13*
     +    s14 + 8*s13*s24 - 16*s14*s24 )

      LA = LA + Lc3(p23,p14)*S23**(-1)*S134**(-1) * (  - 24*s12**3*
     +    S14**(-1) - 8*s12**2*s13*S14**(-1) - 16*s12**2*s24*S14**(-1)
     +     - 16*s12*s13*s24*S14**(-1) - 56*s12*s24**2*S14**(-1) - 8*s13
     +    *s24**2*S14**(-1) )

      LA = LA + Lc3(p23,p14)*S23**(-1) * (  - 24*s12**2*s13*S14**(-1)*
     +    S24**(-1) + 32*s12**2*S14**(-1) - 32*s12**2*S24**(-1) + 32*
     +    s12*s13**2*S14**(-1)*S24**(-1) - 24*s12*s13*S14**(-1) + 48*
     +    s12*s13*S24**(-1) + 40*s12*s14*S24**(-1) - 32*s12*s24*
     +    S14**(-1) - 48*s12 + 32*s13**2*S14**(-1) + 48*s13 + 24*s14 - 
     +    16*s24 )

      LA = LA + Lc3(p23,p14)*S234**(-1) * ( 16*s12**2*S24**(-1) - 32*
     +    s12*s14*S24**(-1) + 24*s12 + 8*s14**2*S24**(-1) - 24*s14 + 8*
     +    s24 )

      LA = LA + Lc3(p23,p14)*S134**(-1) * (  - 8*s12 - 8*s24 )

      LA = LA + Lc3(p24,p13)*S13**(-1)*S23**(-1)*S234**(-1) * (  - 24*
     +    s12**2*s14**2*S24**(-1) + 32*s12*s14**3*S24**(-1) )

      LA = LA + Lc3(p24,p13)*S13**(-1)*S23**(-1) * ( 8*s12**3*s34*
     +    S14**(-1)*S24**(-1) - 24*s12**2*s14*S24**(-1) + 32*s12*s14**2
     +    *S24**(-1) )

      LA = LA + Lc3(p24,p13)*S13**(-1)*S234**(-1) * (  - 24*s12*s14**2*
     +    S24**(-1) + 32*s14**3*S24**(-1) )

      LA = LA + Lc3(p24,p13)*S13**(-1)*S134**(-1) * (  - 8*s12**4*
     +    S14**(-1)*S24**(-1) + 24*s12**3*s23*S14**(-1)*S24**(-1) - 24*
     +    s12**3*S24**(-1) - 8*s12**2*s14*S24**(-1) - 24*s12**2*s23**2*
     +    S14**(-1)*S24**(-1) - 16*s12**2*s23*S24**(-1) - 16*s12*s14*
     +    s23*S24**(-1) + 8*s12*s23**3*S14**(-1)*S24**(-1) - 56*s12*
     +    s23**2*S24**(-1) - 8*s14*s23**2*S24**(-1) )

      LA = LA + Lc3(p24,p13)*S13**(-1) * ( 48*s12**3*S14**(-1)*
     +    S24**(-1) + 16*s12**2*s34*S14**(-1)*S24**(-1) + 32*s12**2*
     +    S24**(-1) - 24*s12*s14*S24**(-1) + 16*s12*s23**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s23*s34*S14**(-1)*S24**(-1) - 32*s12*s23*
     +    S24**(-1) + 32*s14**2*S24**(-1) )

      LA = LA + Lc3(p24,p13)*S23**(-1)*S234**(-1) * ( 16*s12**2 + 24*
     +    s12*s13*s14*S24**(-1) - 32*s12*s13 + 48*s12*s14**2*S24**(-1)
     +     + 8*s13**2 )

      LA = LA + Lc3(p24,p13)*S23**(-1) * (  - 32*s12**3*S14**(-1)*
     +    S24**(-1) + 16*s12**2*s13*S14**(-1)*S24**(-1) - 16*s12**2*s34
     +    *S14**(-1)*S24**(-1) + 8*s12**2*S14**(-1) - 32*s12**2*
     +    S24**(-1) + 8*s12*s13*s34*S14**(-1)*S24**(-1) - 16*s12*s13*
     +    S14**(-1) + 40*s12*s13*S24**(-1) + 48*s12*s14*S24**(-1) )

      LA = LA + Lc3(p24,p13)*S234**(-1) * ( 8*s12**2*S24**(-1) - 24*s12
     +    *s13*S24**(-1) + 8*s12*s14*S24**(-1) + 8*s12*s23*S24**(-1) + 
     +    24*s12 + 16*s13*s14*S24**(-1) - 16*s13*s23*S24**(-1) - 24*s13
     +     + 48*s14**2*S24**(-1) + 8*s14*s23*S24**(-1) + 8*s23 )

      LA = LA + Lc3(p24,p13)*S134**(-1) * (  - 16*s12**3*S14**(-1)*
     +    S24**(-1) + 8*s12**2*s13*S14**(-1)*S24**(-1) - 32*s12**2*s23*
     +    S14**(-1)*S24**(-1) + 8*s12**2*S14**(-1) + 8*s12*s13*s23*
     +    S14**(-1)*S24**(-1) - 16*s12*s13*S14**(-1) - 16*s12*s23**2*
     +    S14**(-1)*S24**(-1) + 16*s12*s23*S14**(-1) - 8*s12 + 8*s13**2
     +    *S14**(-1) - 16*s13*s23*S14**(-1) + 8*s23**2*S14**(-1) - 8*
     +    s23 )

      LA = LA + Lc3(p24,p13) * (  - 64*s12**2*S14**(-1)*S24**(-1) + 16*
     +    s12*s13*S14**(-1)*S24**(-1) - 32*s12*s23*S14**(-1)*S24**(-1)
     +     - 16*s12*s34*S14**(-1)*S24**(-1) + 16*s12*S14**(-1) - 48*s12
     +    *S24**(-1) - 16*s13*S14**(-1) + 24*s13*S24**(-1) + 48*s14*
     +    S24**(-1) + 8*s23*S14**(-1) - 16*s23*S24**(-1) )

      LA = LA + Lcd0(p1,p34,p2)*S13**(-1)*S23**(-1)*S34**(-1) * ( 32*
     +    s12**2*s14*s24 + 32*s12*s14**2*s24 + 32*s12*s14*s24**2 + 32*
     +    s14**3*s24 - 16*s14**2*s24**2 + 32*s14*s24**3 )

      LA = LA + Lcd0(p1,p34,p2)*S13**(-1)*S23**(-1)*S234**(-1) * ( 24*
     +    s12*s14*s24**2 + 24*s14**2*s24**2 )

      LA = LA + Lcd0(p1,p34,p2)*S13**(-1)*S23**(-1)*S134**(-1) * ( 24*
     +    s12*s14**2*s24 + 24*s14**2*s24**2 )

      LA = LA + Lcd0(p1,p34,p2)*S13**(-1)*S23**(-1) * (  - 32*s12**3 - 
     +    32*s12**2*s14 - 32*s12**2*s24 - 32*s12**2*s34 - 32*s12*s14**2
     +     - 32*s12*s14*s34 - 32*s12*s24**2 - 32*s12*s24*s34 - 32*s12*
     +    s34**2 + 32*s14**2*s24 + 32*s14*s24**2 + 32*s14*s24*s34 )

      LA = LA + Lcd0(p1,p34,p2)*S13**(-1)*S34**(-1) * ( 32*s12**2*s14
     +     + 32*s12*s14**2 + 64*s12*s14*s23 + 96*s12*s14*s24 + 32*
     +    s14**3 - 64*s14**2*s23**2*S24**(-1) - 96*s14**2*s23 - 48*
     +    s14**2*s24 + 64*s14*s23**2 + 128*s14*s23*s24 + 96*s14*s24**2
     +     )

      LA = LA + Lcd0(p1,p34,p2)*S13**(-1)*S234**(-1) * (  - 8*s12*s14*
     +    s23 + 16*s12*s14*s24 - 8*s14**2*s23 + 16*s14**2*s24 )

      LA = LA + Lcd0(p1,p34,p2)*S13**(-1)*S134**(-1) * (  - 32*s12**2*
     +    s14 - 64*s12*s14*s23 - 64*s12*s14*s24 - 8*s14**2*s23 + 24*
     +    s14**2*s24 - 32*s14*s23**2 - 64*s14*s23*s24 - 32*s14*s24**2 )

      LA = LA + Lcd0(p1,p34,p2)*S13**(-1) * (  - 128*s12**2*s34*
     +    S24**(-1) - 32*s12**2 + 192*s12*s14*s23*S24**(-1) - 64*s12*
     +    s14*s34*S24**(-1) + 200*s12*s14 - 64*s12*s23*s34*S24**(-1) - 
     +    32*s12*s23 - 32*s12*s24 + 8*s12*s34**2*S24**(-1) - 72*s12*s34
     +     + 64*s14**2*s23*S24**(-1) + 96*s14**2 + 64*s14*s23**2*
     +    S24**(-1) - 40*s14*s23*s34*S24**(-1) + 144*s14*s23 + 104*s14*
     +    s24 + 16*s14*s34 )

      LA = LA + Lcd0(p1,p34,p2)*S23**(-1)*S34**(-1) * ( 32*s12**2*s24
     +     + 64*s12*s13*s24 + 96*s12*s14*s24 + 32*s12*s24**2 - 64*
     +    s13**2*s24**2*S14**(-1) + 64*s13**2*s24 + 128*s13*s14*s24 - 
     +    96*s13*s24**2 + 96*s14**2*s24 - 48*s14*s24**2 + 32*s24**3 )

      LA = LA + Lcd0(p1,p34,p2)*S23**(-1)*S234**(-1) * (  - 32*s12**2*
     +    s24 - 64*s12*s13*s24 - 64*s12*s14*s24 - 32*s13**2*s24 - 64*
     +    s13*s14*s24 - 8*s13*s24**2 - 32*s14**2*s24 + 24*s14*s24**2 )

      LA = LA + Lcd0(p1,p34,p2)*S23**(-1)*S134**(-1) * (  - 8*s12*s13*
     +    s24 + 16*s12*s14*s24 - 8*s13*s24**2 + 16*s14*s24**2 )

      LA = LA + Lcd0(p1,p34,p2)*S23**(-1) * (  - 128*s12**2*s34*
     +    S14**(-1) - 32*s12**2 + 192*s12*s13*s24*S14**(-1) - 64*s12*
     +    s13*s34*S14**(-1) - 32*s12*s13 - 32*s12*s14 - 64*s12*s24*s34*
     +    S14**(-1) + 200*s12*s24 + 8*s12*s34**2*S14**(-1) - 72*s12*s34
     +     + 64*s13**2*s24*S14**(-1) + 64*s13*s24**2*S14**(-1) - 40*s13
     +    *s24*s34*S14**(-1) + 144*s13*s24 + 104*s14*s24 + 96*s24**2 + 
     +    16*s24*s34 )

      LA = LA + Lcd0(p1,p34,p2)*S34**(-1) * ( 32*s12**2*s13*s23*
     +    S14**(-1)*S24**(-1) + 32*s12**2*s13*S14**(-1) + 32*s12**2*s23
     +    *S24**(-1) + 64*s12**2 + 32*s12*s13**2*s23*S14**(-1)*
     +    S24**(-1) + 32*s12*s13**2*S14**(-1) + 32*s12*s13*s23**2*
     +    S14**(-1)*S24**(-1) + 96*s12*s13*s23*S14**(-1) + 96*s12*s13*
     +    s23*S24**(-1) + 64*s12*s13*s24*S14**(-1) + 32*s12*s13 + 64*
     +    s12*s14*s23*S24**(-1) + 32*s12*s14 + 32*s12*s23**2*S24**(-1)
     +     + 32*s12*s23 + 32*s12*s24 + 32*s13**3*s23*S14**(-1)*
     +    S24**(-1) + 32*s13**3*S14**(-1) - 16*s13**2*s23**2*S14**(-1)*
     +    S24**(-1) - 48*s13**2*s23*S14**(-1) + 96*s13**2*s23*S24**(-1)
     +     - 96*s13**2*s24*S14**(-1) + 32*s13**2 + 128*s13*s14*s23*
     +    S24**(-1) + 32*s13*s23**3*S14**(-1)*S24**(-1) + 96*s13*s23**2
     +    *S14**(-1) - 48*s13*s23**2*S24**(-1) + 128*s13*s23*s24*
     +    S14**(-1) - 240*s13*s23 + 64*s13*s24**2*S14**(-1) - 288*s13*
     +    s24 + 64*s14**2*s23*S24**(-1) + 32*s14**2 - 96*s14*s23**2*
     +    S24**(-1) - 288*s14*s23 - 240*s14*s24 + 32*s23**3*S24**(-1)
     +     + 32*s23**2 )

      LA = LA + Lcd0(p1,p34,p2)*S34**(-1) * ( 32*s24**2 )

      LA = LA + Lcd0(p1,p34,p2)*S234**(-1) * (  - 32*s12**2*s23*
     +    S24**(-1) + 64*s12**2 + 24*s12*s13*s23**2*S14**(-1)*S24**(-1)
     +     + 16*s12*s13*s23*S14**(-1) - 64*s12*s13*s23*S24**(-1) - 8*
     +    s12*s13*s24*S14**(-1) + 128*s12*s13 - 64*s12*s14*s23*
     +    S24**(-1) + 128*s12*s14 - 32*s12*s23 - 32*s12*s24 + 24*s13**2
     +    *s23**2*S14**(-1)*S24**(-1) + 16*s13**2*s23*S14**(-1) - 32*
     +    s13**2*s23*S24**(-1) - 8*s13**2*s24*S14**(-1) + 64*s13**2 - 
     +    64*s13*s14*s23*S24**(-1) + 128*s13*s14 + 24*s13*s23**2*
     +    S24**(-1) - 8*s13*s23 - 40*s13*s24 - 32*s14**2*s23*S24**(-1)
     +     + 64*s14**2 - 8*s14*s23**2*S24**(-1) - 40*s14*s23 - 8*s14*
     +    s24 )

      LA = LA + Lcd0(p1,p34,p2)*S134**(-1) * (  - 32*s12**2*s13*
     +    S14**(-1) + 64*s12**2 + 24*s12*s13**2*s23*S14**(-1)*S24**(-1)
     +     - 64*s12*s13*s23*S14**(-1) + 16*s12*s13*s23*S24**(-1) - 64*
     +    s12*s13*s24*S14**(-1) - 32*s12*s13 - 8*s12*s14*s23*S24**(-1)
     +     - 32*s12*s14 + 128*s12*s23 + 128*s12*s24 + 24*s13**2*s23**2*
     +    S14**(-1)*S24**(-1) + 24*s13**2*s23*S14**(-1) - 8*s13**2*s24*
     +    S14**(-1) - 32*s13*s23**2*S14**(-1) + 16*s13*s23**2*S24**(-1)
     +     - 64*s13*s23*s24*S14**(-1) - 8*s13*s23 - 32*s13*s24**2*
     +    S14**(-1) - 40*s13*s24 - 8*s14*s23**2*S24**(-1) - 40*s14*s23
     +     - 8*s14*s24 + 64*s23**2 + 128*s23*s24 + 64*s24**2 )

      LA = LA + Lcd0(p1,p34,p2) * (  - 32*s12**3*S14**(-1)*S24**(-1) - 
     +    32*s12**2*s13*S14**(-1)*S24**(-1) - 32*s12**2*s23*S14**(-1)*
     +    S24**(-1) - 32*s12**2*s34*S14**(-1)*S24**(-1) - 32*s12**2*
     +    S14**(-1) - 32*s12**2*S24**(-1) - 32*s12*s13**2*S14**(-1)*
     +    S24**(-1) - 32*s12*s13*s34*S14**(-1)*S24**(-1) + 200*s12*s13*
     +    S14**(-1) - 32*s12*s13*S24**(-1) - 32*s12*s14*S24**(-1) - 32*
     +    s12*s23**2*S14**(-1)*S24**(-1) - 32*s12*s23*s34*S14**(-1)*
     +    S24**(-1) - 32*s12*s23*S14**(-1) + 200*s12*s23*S24**(-1) - 32
     +    *s12*s24*S14**(-1) - 32*s12*s34**2*S14**(-1)*S24**(-1) - 72*
     +    s12*s34*S14**(-1) - 72*s12*s34*S24**(-1) + 544*s12 + 32*
     +    s13**2*s23*S14**(-1)*S24**(-1) + 96*s13**2*S14**(-1) + 32*s13
     +    *s23**2*S14**(-1)*S24**(-1) + 32*s13*s23*s34*S14**(-1)*
     +    S24**(-1) + 104*s13*s23*S14**(-1) + 104*s13*s23*S24**(-1) + 
     +    144*s13*s24*S14**(-1) + 16*s13*s34*S14**(-1) + 232*s13 + 144*
     +    s14*s23*S24**(-1) + 232*s14 + 96*s23**2*S24**(-1) + 16*s23*
     +    s34*S24**(-1) + 232*s23 + 232*s24 + 144*s34 )

      LA = LA + Lcd1(p1,p34,p2)*S13**(-1)*S134**(-1) * ( 8*s14*s23**2
     +     + 8*s14*s23*s24 )

      LA = LA + Lcd1(p1,p34,p2)*S13**(-1) * (  - 32*s14*s23**2*
     +    S24**(-1) - 40*s14*s23 )

      LA = LA + Lcd1(p1,p34,p2)*S234**(-1) * ( 8*s13*s23**2*S24**(-1)
     +     - 8*s13*s24 + 8*s14*s23**2*S24**(-1) - 8*s14*s24 )

      LA = LA + Lcd1(p1,p34,p2)*S134**(-1) * (  - 8*s13*s23**2*
     +    S14**(-1) - 8*s13*s23*s24*S14**(-1) )

      LA = LA + Lcd1(p1,p34,p2) * ( 48*s13*s23*S14**(-1) + 40*s13*s24*
     +    S14**(-1) - 32*s23**2*S24**(-1) + 8*s23 + 40*s24 )

      LA = LA + Lcd1(p2,p34,p1)*S23**(-1)*S234**(-1) * ( 8*s13**2*s24
     +     + 8*s13*s14*s24 )

      LA = LA + Lcd1(p2,p34,p1)*S23**(-1) * (  - 32*s13**2*s24*
     +    S14**(-1) - 40*s13*s24 )

      LA = LA + Lcd1(p2,p34,p1)*S234**(-1) * (  - 8*s13**2*s23*
     +    S24**(-1) - 8*s13*s14*s23*S24**(-1) )

      LA = LA + Lcd1(p2,p34,p1)*S134**(-1) * ( 8*s13**2*s23*S14**(-1)
     +     + 8*s13**2*s24*S14**(-1) - 8*s14*s23 - 8*s14*s24 )

      LA = LA + Lcd1(p2,p34,p1) * (  - 48*s13**2*S14**(-1) + 32*s13*s23
     +    *S24**(-1) - 8*s13 + 24*s14*s23*S24**(-1) + 40*s14 )

      LA = LA + Ld0(p1,p3,p4)*S13**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2 + 16*s12*s14 + 16*s12*s24 + 8*s14**2 + 8*s24**2 )

      LA = LA + Ld0(p1,p3,p4)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12**3*s14*S24**(-1) + 48*s12**3 )

      LA = LA + Ld0(p1,p3,p4)*S13**(-1)*S23**(-1)*S234**(-1) * ( 16*
     +    s12**3*S24**(-1) + 32*s12**2 + 16*s12*s14 - 16*s12*s24 )

      LA = LA + Ld0(p1,p3,p4)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 16*
     +    s12**3*S24**(-1) + 32*s12**2 - 16*s12*s14 + 16*s12*s24 )

      LA = LA + Ld0(p1,p3,p4)*S13**(-1)*S23**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) + 16*s12**2*S14**(-1) + 16*s12**2*
     +    S24**(-1) + 8*s12*s14*S24**(-1) + 8*s12*s24*S14**(-1) + 32*
     +    s12 )

      LA = LA + Ld0(p1,p3,p4)*S13**(-1)*S34**(-1) * ( 16*s12**2*
     +    S24**(-1) + 16*s12*s14*S24**(-1) + 16*s12*s23*S24**(-1) + 48*
     +    s12 + 8*s14**2*S24**(-1) + 16*s14 + 8*s23**2*S24**(-1) + 32*
     +    s23 + 24*s24 )

      LA = LA + Ld0(p1,p3,p4)*S13**(-1)*S234**(-1)*S134**(-1) * ( 48*
     +    s12**3*S24**(-1) + 32*s12**2*s14*S24**(-1) + 24*s12*s14*s23*
     +    S24**(-1) + 8*s14**2*s23*S24**(-1) + 8*s14**2 - 16*s14*s23 - 
     +    8*s14*s24 )

      LA = LA + Ld0(p1,p3,p4)*S13**(-1)*S234**(-1) * ( 16*s12**2*
     +    S24**(-1) + 32*s12*s14*S24**(-1) - 8*s12*s23*S24**(-1) - 16*
     +    s12 + 8*s14**2*S24**(-1) - 16*s14 )

      LA = LA + Ld0(p1,p3,p4)*S13**(-1)*S134**(-1) * ( 32*s12**2*
     +    S24**(-1) + 32*s12*s23*S24**(-1) + 8*s12 + 8*s14*s23*
     +    S24**(-1) + 8*s23**2*S24**(-1) - 8*s23 )

      LA = LA + Ld0(p1,p3,p4)*S13**(-1)*S134**(-2) * (  - 16*s12*s14 - 
     +    16*s14*s23 - 16*s14*s24 )

      LA = LA + Ld0(p1,p3,p4)*S13**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s23*S14**(-1)*S24**(-1) + 16*s12*S14**(-1)
     +     + 16*s12*S24**(-1) + 16*s14*S24**(-1) + 16*s23*S24**(-1) + 8
     +    *s34*S24**(-1) )

      LA = LA + Ld0(p1,p3,p4)*S23**(-1)*S34**(-1)*S134**(-1) * (  - 32*
     +    s12**2 - 32*s12*s13 - 32*s12*s24 - 16*s13**2 - 32*s13*s24 - 
     +    16*s24**2 )

      LA = LA + Ld0(p1,p3,p4)*S23**(-1)*S34**(-1) * (  - 32*s12**2*
     +    S14**(-1) - 32*s12*s13*S14**(-1) - 32*s12*s24*S14**(-1) - 32*
     +    s12 - 16*s13**2*S14**(-1) - 32*s13 - 16*s14 - 16*s24**2*
     +    S14**(-1) + 16*s24 )

      LA = LA + Ld0(p1,p3,p4)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**3*s13*S14**(-1)*S24**(-1) + 16*s12**3*S14**(-1) - 32*
     +    s12**3*S24**(-1) + 64*s12**2 + 48*s12*s13 + 16*s13**2 )

      LA = LA + Ld0(p1,p3,p4)*S23**(-1)*S234**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) + 56*s12 + 24*s13 + 24*s14 - 16*s24 )

      LA = LA + Ld0(p1,p3,p4)*S23**(-1)*S134**(-1) * (  - 16*s12**3*
     +    S14**(-1)*S24**(-1) + 16*s12 - 16*s24 )

      LA = LA + Ld0(p1,p3,p4)*S23**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s13*S14**(-1)*S24**(-1) - 16*s12*S14**(-1)
     +     + 16*s12*S24**(-1) )

      LA = LA + Ld0(p1,p3,p4)*S34**(-1)*S234**(-1)*S134**(-1) * ( 64*
     +    s12*s13 )

      LA = LA + Ld0(p1,p3,p4)*S34**(-1)*S234**(-1) * (  - 32*s12 + 32*
     +    s13 - 32*s14 )

      LA = LA + Ld0(p1,p3,p4)*S34**(-1)*S134**(-1) * ( 32*s12**2*
     +    S24**(-1) - 32*s12*s13*S24**(-1) + 32*s12*s23*S24**(-1) - 32*
     +    s12 + 16*s13**2*S24**(-1) - 32*s13*s23*S24**(-1) + 64*s13 + 
     +    16*s23**2*S24**(-1) - 32*s23 - 32*s24 )

      LA = LA + Ld0(p1,p3,p4)*S34**(-1)*S134**(-2) * ( 64*s12*s13 + 64*
     +    s13*s23 + 64*s13*s24 )

      LA = LA + Ld0(p1,p3,p4)*S34**(-1) * (  - 48 - 16*s12**2*S14**(-1)
     +    *S24**(-1) - 16*s12*s13*S14**(-1)*S24**(-1) - 16*s12*s23*
     +    S14**(-1)*S24**(-1) - 80*s12*S14**(-1) + 48*s12*S24**(-1) - 8
     +    *s13**2*S14**(-1)*S24**(-1) - 32*s13*S14**(-1) - 8*s13*
     +    S24**(-1) + 32*s14*S24**(-1) - 8*s23**2*S14**(-1)*S24**(-1)
     +     - 40*s23*S14**(-1) + 16*s23*S24**(-1) - 48*s24*S14**(-1) )

      LA = LA + Ld0(p1,p3,p4)*S234**(-1)*S134**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) - 32*s12**2*S24**(-1) - 32*s12*s13*
     +    S24**(-1) - 80*s12*s14*S24**(-1) + 24*s12*s23*S24**(-1) + 64*
     +    s12 + 24*s13**2*S24**(-1) + 40*s13*s14*S24**(-1) - 24*s13*s23
     +    *S24**(-1) - 40*s13 - 16*s14*s23*S24**(-1) + 16*s14 + 32*s23
     +     - 8*s24 )

      LA = LA + Ld0(p1,p3,p4)*S234**(-1) * ( 24 + 24*s12*S24**(-1) - 40
     +    *s13*S24**(-1) - 24*s14*S24**(-1) + 8*s23*S24**(-1) )

      LA = LA + Ld0(p1,p3,p4)*S134**(-1) * ( 8 + 80*s12*S14**(-1) - 80*
     +    s12*S24**(-1) + 32*s13*S14**(-1) + 40*s13*S24**(-1) + 8*s23*
     +    S14**(-1) - 24*s23*S24**(-1) + 32*s24*S14**(-1) )

      LA = LA + Ld0(p1,p3,p4)*S134**(-2) * ( 32*s12*s13*S14**(-1) + 16*
     +    s12 + 32*s13*s23*S14**(-1) + 32*s13*s24*S14**(-1) + 16*s23 + 
     +    16*s24 )

      LA = LA + Ld0(p1,p3,p24)*S13**(-1)*S23**(-1)*S34**(-1) * (  - 16*
     +    s12**2 - 16*s12*s14 - 16*s12*s24 - 8*s14**2 - 8*s24**2 )

      LA = LA + Ld0(p1,p3,p24)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12**3*s14*S24**(-1) + 16*s12**3 )

      LA = LA + Ld0(p1,p3,p24)*S13**(-1)*S23**(-1)*S234**(-1) * ( 16*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p1,p3,p24)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 16
     +    *s12**3*S24**(-1) )

      LA = LA + Ld0(p1,p3,p24)*S13**(-1)*S23**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) + 16*s12**2*S14**(-1) + 16*s12**2*
     +    S24**(-1) + 8*s12*s14*S24**(-1) + 8*s12*s24*S14**(-1) )

      LA = LA + Ld0(p1,p3,p24)*S13**(-1)*S34**(-1)*S234**(-1) * ( 32*
     +    s12**2 + 32*s12*s14 + 32*s12*s23 + 16*s14**2 + 32*s14*s23 + 
     +    16*s23**2 )

      LA = LA + Ld0(p1,p3,p24)*S13**(-1)*S34**(-1) * (  - 16*s14 )

      LA = LA + Ld0(p1,p3,p24)*S13**(-1)*S234**(-1)*S134**(-1) * ( 48*
     +    s12**3*S24**(-1) + 64*s12**2*s14*S24**(-1) - 64*s12**2 + 48*
     +    s12*s14*s23*S24**(-1) - 48*s12*s23 + 16*s14**2*s23*S24**(-1)
     +     + 16*s14**2 - 32*s14*s23 - 16*s14*s24 - 16*s23**2 )

      LA = LA + Ld0(p1,p3,p24)*S13**(-1)*S234**(-1) * ( 48*s12*s14*
     +    S24**(-1) - 16*s12 + 16*s14**2*S24**(-1) - 16*s14 )

      LA = LA + Ld0(p1,p3,p24)*S13**(-1)*S134**(-1) * ( 32*s12**3*
     +    S14**(-1)*S24**(-1) + 64*s12**2*S24**(-1) + 64*s12*s23*
     +    S24**(-1) - 8*s12 + 16*s14*s23*S24**(-1) + 16*s14 + 16*s23**2
     +    *S24**(-1) + 8*s23 - 8*s24 )

      LA = LA + Ld0(p1,p3,p24)*S13**(-1) * (  - 16*s12**2*S14**(-1)*
     +    S24**(-1) - 8*s12*s23*S14**(-1)*S24**(-1) + 32*s12*S24**(-1)
     +     + 16*s14*S24**(-1) + 16*s23*S24**(-1) + 8*s34*S24**(-1) )

      LA = LA + Ld0(p1,p3,p24)*S23**(-1)*S34**(-1) * (  - 32*s12 - 16*
     +    s13 - 16*s14 - 16*s24 )

      LA = LA + Ld0(p1,p3,p24)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**3*s13*S14**(-1)*S24**(-1) + 16*s12**3*S14**(-1) - 32*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p1,p3,p24)*S23**(-1)*S234**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) - 8*s12 - 8*s13 - 8*s14 )

      LA = LA + Ld0(p1,p3,p24)*S23**(-1)*S134**(-1) * (  - 16*s12**3*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Ld0(p1,p3,p24)*S23**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s13*S14**(-1)*S24**(-1) + 16*s12*S14**(-1)
     +     + 16*s12*S24**(-1) )

      LA = LA + Ld0(p1,p3,p24)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    64*s12*s23 )

      LA = LA + Ld0(p1,p3,p24)*S34**(-1)*S234**(-1) * (  - 32*s12**2*
     +    S14**(-1) - 32*s12*s13*S14**(-1) + 32*s12*s23*S14**(-1) + 32*
     +    s12 - 16*s13**2*S14**(-1) + 32*s13*s23*S14**(-1) + 32*s13 + 
     +    32*s14 - 16*s23**2*S14**(-1) - 64*s23 )

      LA = LA + Ld0(p1,p3,p24)*S34**(-1)*S234**(-2) * (  - 64*s12*s23
     +     - 64*s13*s23 - 64*s14*s23 )

      LA = LA + Ld0(p1,p3,p24)*S34**(-1)*S134**(-1) * ( 32*s12 - 32*s23
     +     + 32*s24 )

      LA = LA + Ld0(p1,p3,p24)*S34**(-1) * ( 32 + 16*s12**2*S14**(-1)*
     +    S24**(-1) + 16*s12*s13*S14**(-1)*S24**(-1) + 16*s12*s23*
     +    S14**(-1)*S24**(-1) - 32*s12*S14**(-1) + 32*s12*S24**(-1) + 8
     +    *s13**2*S14**(-1)*S24**(-1) - 16*s13*S14**(-1) + 16*s13*
     +    S24**(-1) + 16*s14*S24**(-1) + 8*s23**2*S14**(-1)*S24**(-1)
     +     + 16*s23*S14**(-1) + 16*s23*S24**(-1) - 16*s24*S14**(-1) )

      LA = LA + Ld0(p1,p3,p24)*S234**(-1)*S134**(-1) * ( 48*s12**3*
     +    S14**(-1)*S24**(-1) + 64*s12**2*S14**(-1) + 64*s12**2*
     +    S24**(-1) + 48*s12*s13*S14**(-1) - 48*s12*s13*S24**(-1) - 48*
     +    s12*s14*S24**(-1) - 48*s12*s23*S14**(-1) + 48*s12*s23*
     +    S24**(-1) + 48*s12 + 16*s13**2*S24**(-1) + 16*s13*s14*
     +    S24**(-1) - 16*s13*s23*S14**(-1) - 16*s13*s23*S24**(-1) + 16*
     +    s13*s24*S14**(-1) - 32*s13 + 16*s14 + 16*s23**2*S14**(-1) + 
     +    16*s23 )

      LA = LA + Ld0(p1,p3,p24)*S234**(-1) * (  - 32 + 32*s12**2*
     +    S14**(-1)*S24**(-1) + 16*s12*s13*S14**(-1)*S24**(-1) - 16*s12
     +    *s23*S14**(-1)*S24**(-1) + 72*s12*S24**(-1) + 16*s13*
     +    S14**(-1) - 8*s13*S24**(-1) + 8*s14*S24**(-1) - 32*s23*
     +    S24**(-1) )

      LA = LA + Ld0(p1,p3,p24)*S234**(-2) * (  - 32*s12*s23*S24**(-1)
     +     - 32*s12 - 32*s13*s23*S24**(-1) - 32*s13 - 32*s14*s23*
     +    S24**(-1) - 32*s14 )

      LA = LA + Ld0(p1,p3,p24)*S134**(-1) * (  - 8*s12*S14**(-1) - 48*
     +    s12*S24**(-1) - 16*s13*S14**(-1) + 16*s13*S24**(-1) + 8*s23*
     +    S14**(-1) - 16*s23*S24**(-1) - 8*s24*S14**(-1) )

      LA = LA + Ld0(p1,p3,p24) * (  - 32*s12*S14**(-1)*S24**(-1) )

      LA = LA + Ld0(p1,p4,p3)*S13**(-1)*S23**(-1)*S34**(-1) * (  - 16*
     +    s12**2 - 16*s12*s14 - 16*s12*s24 - 8*s14**2 - 8*s24**2 )

      LA = LA + Ld0(p1,p4,p3)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12**3*s14*S24**(-1) + 16*s12**3 )

      LA = LA + Ld0(p1,p4,p3)*S13**(-1)*S23**(-1)*S234**(-1) * ( 16*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p1,p4,p3)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 16*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p1,p4,p3)*S13**(-1)*S23**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) + 16*s12**2*S14**(-1) + 16*s12**2*
     +    S24**(-1) + 8*s12*s14*S24**(-1) + 8*s12*s24*S14**(-1) )

      LA = LA + Ld0(p1,p4,p3)*S13**(-1)*S34**(-1) * (  - 32*s12**2*
     +    S24**(-1) - 32*s12*s14*S24**(-1) - 32*s12*s23*S24**(-1) - 80*
     +    s12 - 16*s14**2*S24**(-1) - 32*s14 - 16*s23**2*S24**(-1) - 48
     +    *s23 - 40*s24 )

      LA = LA + Ld0(p1,p4,p3)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p1,p4,p3)*S13**(-1)*S134**(-1) * ( 80*s12 + 32*s14
     +     + 32*s23 + 8*s24 )

      LA = LA + Ld0(p1,p4,p3)*S13**(-1)*S134**(-2) * ( 32*s12*s14 + 32*
     +    s14*s23 + 32*s14*s24 )

      LA = LA + Ld0(p1,p4,p3)*S13**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s23*S14**(-1)*S24**(-1) + 16*s12*S14**(-1)
     +     - 16*s12*S24**(-1) )

      LA = LA + Ld0(p1,p4,p3)*S23**(-1)*S34**(-1)*S134**(-1) * ( 32*
     +    s12**2 + 32*s12*s13 + 32*s12*s24 + 16*s13**2 + 32*s13*s24 + 
     +    16*s24**2 )

      LA = LA + Ld0(p1,p4,p3)*S23**(-1)*S34**(-1) * ( 16*s12**2*
     +    S14**(-1) + 16*s12*s13*S14**(-1) + 16*s12*s24*S14**(-1) + 16*
     +    s12 + 8*s13**2*S14**(-1) + 16*s13 + 8*s14 + 8*s24**2*
     +    S14**(-1) - 16*s24 )

      LA = LA + Ld0(p1,p4,p3)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**3*s13*S14**(-1)*S24**(-1) + 48*s12**3*S14**(-1) - 32*
     +    s12**3*S24**(-1) + 32*s12**2*s13*S14**(-1) - 32*s12**2 + 24*
     +    s12*s13*s24*S14**(-1) - 80*s12*s13 - 32*s12*s14 + 24*s12*s24
     +     + 8*s13**2*s24*S14**(-1) - 24*s13**2 - 8*s13*s14 + 8*s13*s24
     +     )

      LA = LA + Ld0(p1,p4,p3)*S23**(-1)*S234**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) + 16*s12**2*S14**(-1) + 32*s12*s13*
     +    S14**(-1) - 8*s12*s24*S14**(-1) + 24*s12 + 8*s13**2*S14**(-1)
     +     - 16*s14 + 8*s24 )

      LA = LA + Ld0(p1,p4,p3)*S23**(-1)*S134**(-1) * (  - 16*s12**3*
     +    S14**(-1)*S24**(-1) + 32*s12**2*S14**(-1) + 32*s12*s24*
     +    S14**(-1) - 48*s12 + 8*s13*s24*S14**(-1) - 8*s13 + 8*s24**2*
     +    S14**(-1) + 8*s24 )

      LA = LA + Ld0(p1,p4,p3)*S23**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s13*S14**(-1)*S24**(-1) + 16*s12*S14**(-1)
     +     + 16*s12*S24**(-1) + 16*s13*S14**(-1) + 16*s24*S14**(-1) + 8
     +    *s34*S14**(-1) )

      LA = LA + Ld0(p1,p4,p3)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 64
     +    *s12*s13 )

      LA = LA + Ld0(p1,p4,p3)*S34**(-1)*S234**(-1) * ( 32*s12 - 32*s13
     +     + 32*s14 )

      LA = LA + Ld0(p1,p4,p3)*S34**(-1)*S134**(-1) * (  - 32*s12**2*
     +    S24**(-1) + 32*s12*s13*S24**(-1) - 32*s12*s23*S24**(-1) + 32*
     +    s12 - 16*s13**2*S24**(-1) + 32*s13*s23*S24**(-1) - 64*s13 - 
     +    16*s23**2*S24**(-1) + 32*s23 + 32*s24 )

      LA = LA + Ld0(p1,p4,p3)*S34**(-1)*S134**(-2) * (  - 64*s12*s13 - 
     +    64*s13*s23 - 64*s13*s24 )

      LA = LA + Ld0(p1,p4,p3)*S34**(-1) * ( 16 + 16*s12**2*S14**(-1)*
     +    S24**(-1) + 16*s12*s13*S14**(-1)*S24**(-1) + 16*s12*s23*
     +    S14**(-1)*S24**(-1) + 48*s12*S14**(-1) - 64*s12*S24**(-1) + 8
     +    *s13**2*S14**(-1)*S24**(-1) + 16*s13*S14**(-1) - 48*s14*
     +    S24**(-1) + 8*s23**2*S14**(-1)*S24**(-1) + 24*s23*S14**(-1)
     +     - 16*s23*S24**(-1) + 32*s24*S14**(-1) )

      LA = LA + Ld0(p1,p4,p3)*S234**(-1)*S134**(-1) * ( 48*s12**3*
     +    S14**(-1)*S24**(-1) + 64*s12**2*S24**(-1) + 48*s12*s14*
     +    S24**(-1) + 8*s13**2*S14**(-1) - 16*s13**2*S24**(-1) - 32*s13
     +    *s14*S24**(-1) - 8*s13*s23*S14**(-1) + 16*s13*s23*S24**(-1)
     +     - 16*s13*s24*S14**(-1) + 104*s13 + 16*s14*s23*S24**(-1) + 48
     +    *s14 - 56*s23 - 16*s24 )

      LA = LA + Ld0(p1,p4,p3)*S234**(-1) * (  - 24 + 32*s12**2*
     +    S14**(-1)*S24**(-1) + 16*s12*s13*S14**(-1)*S24**(-1) - 16*s12
     +    *s23*S14**(-1)*S24**(-1) - 16*s12*S14**(-1) + 56*s12*
     +    S24**(-1) - 16*s13*S14**(-1) + 40*s13*S24**(-1) + 40*s14*
     +    S24**(-1) - 16*s23*S24**(-1) )

      LA = LA + Ld0(p1,p4,p3)*S134**(-1) * (  - 8 + 32*s12**2*S14**(-1)
     +    *S24**(-1) - 16*s12*s13*S14**(-1)*S24**(-1) + 16*s12*s23*
     +    S14**(-1)*S24**(-1) + 8*s12*S14**(-1) + 48*s12*S24**(-1) - 32
     +    *s13*S24**(-1) + 16*s23*S24**(-1) - 8*s24*S14**(-1) )

      LA = LA + Ld0(p1,p4,p3)*S134**(-2) * (  - 16*s12*s13*S14**(-1) - 
     +    48*s12 - 16*s13*s23*S14**(-1) - 16*s13*s24*S14**(-1) - 48*s23
     +     - 48*s24 )

      LA = LA + Ld0(p1,p4,p3) * ( 32*s12*S14**(-1)*S24**(-1) )

      LA = LA + Ld0(p1,p4,p23)*S13**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2 + 16*s12*s14 + 16*s12*s24 + 8*s14**2 + 8*s24**2 )

      LA = LA + Ld0(p1,p4,p23)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12**3*s14*S24**(-1) + 48*s12**3 )

      LA = LA + Ld0(p1,p4,p23)*S13**(-1)*S23**(-1)*S234**(-1) * ( 16*
     +    s12**3*S24**(-1) + 32*s12**2 + 16*s12*s14 - 16*s12*s24 )

      LA = LA + Ld0(p1,p4,p23)*S13**(-1)*S23**(-1)*S134**(-1) * ( 32*
     +    s12**3*S14**(-1) - 16*s12**3*S24**(-1) )

      LA = LA + Ld0(p1,p4,p23)*S13**(-1)*S23**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) - 16*s12**2*S14**(-1) + 16*s12**2*
     +    S24**(-1) + 8*s12*s14*S24**(-1) - 8*s12*s24*S14**(-1) - 32*
     +    s12 )

      LA = LA + Ld0(p1,p4,p23)*S13**(-1)*S34**(-1)*S234**(-1) * (  - 32
     +    *s12**2 - 32*s12*s14 - 32*s12*s23 - 16*s14**2 - 32*s14*s23 - 
     +    16*s23**2 )

      LA = LA + Ld0(p1,p4,p23)*S13**(-1)*S34**(-1) * ( 16*s14 )

      LA = LA + Ld0(p1,p4,p23)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3*S24**(-1) + 64*s12**2 + 48*s12*s23 + 16*s23**2 )

      LA = LA + Ld0(p1,p4,p23)*S13**(-1)*S234**(-1) * ( 16*s12 - 16*s14
     +     )

      LA = LA + Ld0(p1,p4,p23)*S13**(-1)*S134**(-1) * (  - 56*s12 - 16*
     +    s14 - 24*s23 + 24*s24 )

      LA = LA + Ld0(p1,p4,p23)*S13**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s23*S14**(-1)*S24**(-1) + 16*s12*S24**(-1)
     +     )

      LA = LA + Ld0(p1,p4,p23)*S23**(-1)*S34**(-1) * ( 32*s12 + 16*s13
     +     + 16*s14 + 16*s24 )

      LA = LA + Ld0(p1,p4,p23)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**3*s13*S14**(-1)*S24**(-1) + 48*s12**3*S14**(-1) - 32*
     +    s12**3*S24**(-1) + 64*s12**2*s13*S14**(-1) + 64*s12**2 + 48*
     +    s12*s13*s24*S14**(-1) - 48*s12*s13 - 48*s12*s14 + 48*s12*s24
     +     + 16*s13**2*s24*S14**(-1) - 16*s13**2 - 16*s13*s14 + 16*s13*
     +    s24 )

      LA = LA + Ld0(p1,p4,p23)*S23**(-1)*S234**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) + 48*s12*s13*S14**(-1) + 72*s12 + 16*
     +    s13**2*S14**(-1) + 24*s13 + 8*s14 - 32*s24 )

      LA = LA + Ld0(p1,p4,p23)*S23**(-1)*S234**(-2) * (  - 32*s12*s24
     +     - 32*s13*s24 - 32*s14*s24 )

      LA = LA + Ld0(p1,p4,p23)*S23**(-1)*S134**(-1) * (  - 16*s12**3*
     +    S14**(-1)*S24**(-1) + 64*s12**2*S14**(-1) + 64*s12*s24*
     +    S14**(-1) - 48*s12 + 16*s13*s24*S14**(-1) - 16*s13 + 16*
     +    s24**2*S14**(-1) - 16*s24 )

      LA = LA + Ld0(p1,p4,p23)*S23**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s13*S14**(-1)*S24**(-1) + 32*s12*S14**(-1)
     +     + 16*s12*S24**(-1) + 16*s13*S14**(-1) + 16*s24*S14**(-1) + 8
     +    *s34*S14**(-1) )

      LA = LA + Ld0(p1,p4,p23)*S34**(-1)*S234**(-1)*S134**(-1) * ( 64*
     +    s12*s23 )

      LA = LA + Ld0(p1,p4,p23)*S34**(-1)*S234**(-1) * ( 32*s12**2*
     +    S14**(-1) + 32*s12*s13*S14**(-1) - 32*s12*s23*S14**(-1) - 32*
     +    s12 + 16*s13**2*S14**(-1) - 32*s13*s23*S14**(-1) - 32*s13 - 
     +    32*s14 + 16*s23**2*S14**(-1) + 64*s23 )

      LA = LA + Ld0(p1,p4,p23)*S34**(-1)*S234**(-2) * ( 64*s12*s23 + 64
     +    *s13*s23 + 64*s14*s23 )

      LA = LA + Ld0(p1,p4,p23)*S34**(-1)*S134**(-1) * (  - 32*s12 + 32*
     +    s23 - 32*s24 )

      LA = LA + Ld0(p1,p4,p23)*S34**(-1) * (  - 32 - 16*s12**2*
     +    S14**(-1)*S24**(-1) - 16*s12*s13*S14**(-1)*S24**(-1) - 16*s12
     +    *s23*S14**(-1)*S24**(-1) + 32*s12*S14**(-1) - 32*s12*
     +    S24**(-1) - 8*s13**2*S14**(-1)*S24**(-1) + 16*s13*S14**(-1)
     +     - 16*s13*S24**(-1) - 16*s14*S24**(-1) - 8*s23**2*S14**(-1)*
     +    S24**(-1) - 16*s23*S14**(-1) - 16*s23*S24**(-1) + 16*s24*
     +    S14**(-1) )

      LA = LA + Ld0(p1,p4,p23)*S234**(-1)*S134**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) - 64*s12**2*S14**(-1) - 48*s12*s13*
     +    S14**(-1) + 48*s12*s23*S14**(-1) + 16*s12 + 16*s13**2*
     +    S14**(-1) - 48*s13*s24*S14**(-1) + 96*s13 + 48*s14 - 16*
     +    s23**2*S14**(-1) - 64*s23 - 48*s24 )

      LA = LA + Ld0(p1,p4,p23)*S234**(-1) * (  - 32 - 8*s12*S24**(-1)
     +     - 48*s13*S14**(-1) - 8*s13*S24**(-1) - 8*s14*S24**(-1) )

      LA = LA + Ld0(p1,p4,p23)*S234**(-2) * ( 32*s12 + 32*s13 + 32*s14
     +     )

      LA = LA + Ld0(p1,p4,p23)*S134**(-1) * ( 64 - 56*s12*S14**(-1) + 
     +    16*s13*S14**(-1) + 8*s23*S14**(-1) - 8*s24*S14**(-1) )

      LA = LA + Ld0(p1,p34,p2)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**3*s14*S24**(-1) + 32*s12**3 )

      LA = LA + Ld0(p1,p34,p2)*S13**(-1)*S23**(-1)*S234**(-1) * ( 32*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p1,p34,p2)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 32
     +    *s12**3*S24**(-1) )

      LA = LA + Ld0(p1,p34,p2)*S13**(-1)*S23**(-1) * ( 32*s12**3*
     +    S14**(-1)*S24**(-1) + 32*s12**2*S14**(-1) + 32*s12**2*
     +    S24**(-1) + 16*s12*s14*S24**(-1) + 16*s12*s24*S14**(-1) )

      LA = LA + Ld0(p1,p34,p2)*S13**(-1)*S234**(-1)*S134**(-1) * ( 32*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p1,p34,p2)*S13**(-1) * ( 32*s12**2*S14**(-1)*
     +    S24**(-1) + 16*s12*s23*S14**(-1)*S24**(-1) + 32*s12*S14**(-1)
     +     )

      LA = LA + Ld0(p1,p34,p2)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    32*s12**3*s13*S14**(-1)*S24**(-1) + 32*s12**3*S14**(-1) - 64*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p1,p34,p2)*S23**(-1)*S234**(-1) * ( 32*s12**3*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Ld0(p1,p34,p2)*S23**(-1)*S134**(-1) * (  - 32*s12**3*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Ld0(p1,p34,p2)*S23**(-1) * ( 32*s12**2*S14**(-1)*
     +    S24**(-1) + 16*s12*s13*S14**(-1)*S24**(-1) + 32*s12*S24**(-1)
     +     )

      LA = LA + Ld0(p1,p34,p2)*S234**(-1)*S134**(-1) * ( 32*s12**3*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Ld0(p2,p3,p4)*S13**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2 + 16*s12*s14 + 16*s12*s24 + 8*s14**2 + 8*s24**2 )

      LA = LA + Ld0(p2,p3,p4)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12**3*s14*S24**(-1) + 48*s12**3 )

      LA = LA + Ld0(p2,p3,p4)*S13**(-1)*S23**(-1)*S234**(-1) * ( 16*
     +    s12**3*S24**(-1) + 32*s12**2 + 16*s12*s14 - 16*s12*s24 )

      LA = LA + Ld0(p2,p3,p4)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 16*
     +    s12**3*S24**(-1) + 32*s12**2 - 16*s12*s14 + 16*s12*s24 )

      LA = LA + Ld0(p2,p3,p4)*S13**(-1)*S23**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) + 16*s12**2*S14**(-1) + 16*s12**2*
     +    S24**(-1) + 8*s12*s14*S24**(-1) + 8*s12*s24*S14**(-1) + 32*
     +    s12 )

      LA = LA + Ld0(p2,p3,p4)*S13**(-1)*S34**(-1)*S234**(-1) * (  - 32*
     +    s12**2 - 32*s12*s14 - 32*s12*s23 - 16*s14**2 - 32*s14*s23 - 
     +    16*s23**2 )

      LA = LA + Ld0(p2,p3,p4)*S13**(-1)*S34**(-1) * (  - 32*s12**2*
     +    S24**(-1) - 32*s12*s14*S24**(-1) - 32*s12*s23*S24**(-1) - 32*
     +    s12 - 16*s14**2*S24**(-1) + 16*s14 - 16*s23**2*S24**(-1) - 32
     +    *s23 - 16*s24 )

      LA = LA + Ld0(p2,p3,p4)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3*S24**(-1) + 64*s12**2 + 48*s12*s23 + 16*s23**2 )

      LA = LA + Ld0(p2,p3,p4)*S13**(-1)*S234**(-1) * ( 16*s12 - 16*s14
     +     )

      LA = LA + Ld0(p2,p3,p4)*S13**(-1)*S134**(-1) * ( 56*s12 - 16*s14
     +     + 24*s23 + 24*s24 )

      LA = LA + Ld0(p2,p3,p4)*S13**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s23*S14**(-1)*S24**(-1) + 16*s12*S14**(-1)
     +     - 16*s12*S24**(-1) )

      LA = LA + Ld0(p2,p3,p4)*S23**(-1)*S34**(-1) * ( 16*s12**2*
     +    S14**(-1) + 16*s12*s13*S14**(-1) + 16*s12*s24*S14**(-1) + 48*
     +    s12 + 8*s13**2*S14**(-1) + 32*s13 + 24*s14 + 8*s24**2*
     +    S14**(-1) + 16*s24 )

      LA = LA + Ld0(p2,p3,p4)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**3*s13*S14**(-1)*S24**(-1) + 48*s12**3*S14**(-1) - 32*
     +    s12**3*S24**(-1) + 32*s12**2*s13*S14**(-1) + 32*s12**2 + 24*
     +    s12*s13*s24*S14**(-1) - 24*s12*s13 - 24*s12*s14 + 24*s12*s24
     +     + 8*s13**2*s24*S14**(-1) - 8*s13**2 - 8*s13*s14 + 8*s13*s24
     +     )

      LA = LA + Ld0(p2,p3,p4)*S23**(-1)*S234**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) + 32*s12*s13*S14**(-1) + 32*s12 + 8*
     +    s13**2*S14**(-1) - 8*s24 )

      LA = LA + Ld0(p2,p3,p4)*S23**(-1)*S234**(-2) * (  - 16*s12*s24 - 
     +    16*s13*s24 - 16*s14*s24 )

      LA = LA + Ld0(p2,p3,p4)*S23**(-1)*S134**(-1) * (  - 16*s12**3*
     +    S14**(-1)*S24**(-1) + 48*s12**2*S14**(-1) - 8*s12*s13*
     +    S14**(-1) + 32*s12*s24*S14**(-1) - 40*s12 + 8*s13*s24*
     +    S14**(-1) - 8*s13 + 8*s24**2*S14**(-1) - 8*s24 )

      LA = LA + Ld0(p2,p3,p4)*S23**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s13*S14**(-1)*S24**(-1) + 16*s12*S14**(-1)
     +     + 16*s12*S24**(-1) + 16*s13*S14**(-1) + 16*s24*S14**(-1) + 8
     +    *s34*S14**(-1) )

      LA = LA + Ld0(p2,p3,p4)*S34**(-1)*S234**(-1)*S134**(-1) * ( 64*
     +    s12*s23 )

      LA = LA + Ld0(p2,p3,p4)*S34**(-1)*S234**(-1) * ( 32*s12**2*
     +    S14**(-1) + 32*s12*s13*S14**(-1) - 32*s12*s23*S14**(-1) - 32*
     +    s12 + 16*s13**2*S14**(-1) - 32*s13*s23*S14**(-1) - 32*s13 - 
     +    32*s14 + 16*s23**2*S14**(-1) + 64*s23 )

      LA = LA + Ld0(p2,p3,p4)*S34**(-1)*S234**(-2) * ( 64*s12*s23 + 64*
     +    s13*s23 + 64*s14*s23 )

      LA = LA + Ld0(p2,p3,p4)*S34**(-1)*S134**(-1) * (  - 32*s12 + 32*
     +    s23 - 32*s24 )

      LA = LA + Ld0(p2,p3,p4)*S34**(-1) * (  - 48 - 16*s12**2*S14**(-1)
     +    *S24**(-1) - 16*s12*s13*S14**(-1)*S24**(-1) - 16*s12*s23*
     +    S14**(-1)*S24**(-1) + 48*s12*S14**(-1) - 80*s12*S24**(-1) - 8
     +    *s13**2*S14**(-1)*S24**(-1) + 16*s13*S14**(-1) - 40*s13*
     +    S24**(-1) - 48*s14*S24**(-1) - 8*s23**2*S14**(-1)*S24**(-1)
     +     - 8*s23*S14**(-1) - 32*s23*S24**(-1) + 32*s24*S14**(-1) )

      LA = LA + Ld0(p2,p3,p4)*S234**(-1)*S134**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) - 64*s12**2*S14**(-1) - 56*s12*s13*
     +    S14**(-1) + 48*s12*s23*S14**(-1) + 8*s12 + 8*s13**2*S14**(-1)
     +     + 8*s13*s23*S14**(-1) - 32*s13*s24*S14**(-1) + 88*s13 + 32*
     +    s14 - 16*s23**2*S14**(-1) - 40*s23 - 32*s24 )

      LA = LA + Ld0(p2,p3,p4)*S234**(-1) * (  - 32 + 80*s12*S24**(-1)
     +     - 32*s13*S14**(-1) + 8*s13*S24**(-1) + 32*s14*S24**(-1) + 32
     +    *s23*S24**(-1) )

      LA = LA + Ld0(p2,p3,p4)*S234**(-2) * ( 32*s12*s23*S24**(-1) + 16*
     +    s12 + 32*s13*s23*S24**(-1) + 16*s13 + 32*s14*s23*S24**(-1) + 
     +    16*s14 )

      LA = LA + Ld0(p2,p3,p4)*S134**(-1) * ( 64 - 56*s12*S14**(-1) + 16
     +    *s13*S14**(-1) - 24*s24*S14**(-1) )

      LA = LA + Ld0(p2,p3,p14)*S13**(-1)*S23**(-1)*S34**(-1) * (  - 16*
     +    s12**2 - 16*s12*s14 - 16*s12*s24 - 8*s14**2 - 8*s24**2 )

      LA = LA + Ld0(p2,p3,p14)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12**3*s14*S24**(-1) + 16*s12**3 )

      LA = LA + Ld0(p2,p3,p14)*S13**(-1)*S23**(-1)*S234**(-1) * ( 16*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p2,p3,p14)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 16
     +    *s12**3*S24**(-1) )

      LA = LA + Ld0(p2,p3,p14)*S13**(-1)*S23**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) + 16*s12**2*S14**(-1) + 16*s12**2*
     +    S24**(-1) + 8*s12*s14*S24**(-1) + 8*s12*s24*S14**(-1) )

      LA = LA + Ld0(p2,p3,p14)*S13**(-1)*S34**(-1) * (  - 32*s12 - 16*
     +    s14 - 16*s23 - 16*s24 )

      LA = LA + Ld0(p2,p3,p14)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p2,p3,p14)*S13**(-1)*S134**(-1) * (  - 8*s12 - 8*
     +    s23 - 8*s24 )

      LA = LA + Ld0(p2,p3,p14)*S13**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s23*S14**(-1)*S24**(-1) + 16*s12*S14**(-1)
     +     + 16*s12*S24**(-1) )

      LA = LA + Ld0(p2,p3,p14)*S23**(-1)*S34**(-1)*S134**(-1) * ( 32*
     +    s12**2 + 32*s12*s13 + 32*s12*s24 + 16*s13**2 + 32*s13*s24 + 
     +    16*s24**2 )

      LA = LA + Ld0(p2,p3,p14)*S23**(-1)*S34**(-1) * (  - 16*s24 )

      LA = LA + Ld0(p2,p3,p14)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**3*s13*S14**(-1)*S24**(-1) + 48*s12**3*S14**(-1) - 32*
     +    s12**3*S24**(-1) + 64*s12**2*s13*S14**(-1) + 48*s12*s13*s24*
     +    S14**(-1) - 96*s12*s13 - 48*s12*s14 + 48*s12*s24 + 16*s13**2*
     +    s24*S14**(-1) - 32*s13**2 - 16*s13*s14 + 16*s13*s24 )

      LA = LA + Ld0(p2,p3,p14)*S23**(-1)*S234**(-1) * ( 48*s12**3*
     +    S14**(-1)*S24**(-1) + 64*s12*s13*S14**(-1) + 40*s12 + 16*
     +    s13**2*S14**(-1) + 24*s13 - 8*s14 )

      LA = LA + Ld0(p2,p3,p14)*S23**(-1)*S134**(-1) * (  - 16*s12**3*
     +    S14**(-1)*S24**(-1) + 64*s12**2*S14**(-1) + 48*s12*s24*
     +    S14**(-1) - 64*s12 + 16*s13*s24*S14**(-1) - 16*s13 + 16*
     +    s24**2*S14**(-1) )

      LA = LA + Ld0(p2,p3,p14)*S23**(-1) * (  - 16*s12**2*S14**(-1)*
     +    S24**(-1) - 8*s12*s13*S14**(-1)*S24**(-1) + 32*s12*S14**(-1)
     +     + 16*s13*S14**(-1) + 16*s24*S14**(-1) + 8*s34*S14**(-1) )

      LA = LA + Ld0(p2,p3,p14)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    64*s12*s13 )

      LA = LA + Ld0(p2,p3,p14)*S34**(-1)*S234**(-1) * ( 32*s12 - 32*s13
     +     + 32*s14 )

      LA = LA + Ld0(p2,p3,p14)*S34**(-1)*S134**(-1) * (  - 32*s12**2*
     +    S24**(-1) + 32*s12*s13*S24**(-1) - 32*s12*s23*S24**(-1) + 32*
     +    s12 - 16*s13**2*S24**(-1) + 32*s13*s23*S24**(-1) - 64*s13 - 
     +    16*s23**2*S24**(-1) + 32*s23 + 32*s24 )

      LA = LA + Ld0(p2,p3,p14)*S34**(-1)*S134**(-2) * (  - 64*s12*s13
     +     - 64*s13*s23 - 64*s13*s24 )

      LA = LA + Ld0(p2,p3,p14)*S34**(-1) * ( 32 + 16*s12**2*S14**(-1)*
     +    S24**(-1) + 16*s12*s13*S14**(-1)*S24**(-1) + 16*s12*s23*
     +    S14**(-1)*S24**(-1) + 32*s12*S14**(-1) - 32*s12*S24**(-1) + 8
     +    *s13**2*S14**(-1)*S24**(-1) + 16*s13*S14**(-1) + 16*s13*
     +    S24**(-1) - 16*s14*S24**(-1) + 8*s23**2*S14**(-1)*S24**(-1)
     +     + 16*s23*S14**(-1) - 16*s23*S24**(-1) + 16*s24*S14**(-1) )

      LA = LA + Ld0(p2,p3,p14)*S234**(-1)*S134**(-1) * ( 48*s12**3*
     +    S14**(-1)*S24**(-1) + 64*s12**2*S24**(-1) + 48*s12*s14*
     +    S24**(-1) + 16*s13**2*S14**(-1) - 16*s13**2*S24**(-1) - 32*
     +    s13*s14*S24**(-1) - 16*s13*s23*S14**(-1) + 16*s13*s23*
     +    S24**(-1) - 32*s13*s24*S14**(-1) + 112*s13 + 16*s14*s23*
     +    S24**(-1) + 32*s14 - 48*s23 - 32*s24 )

      LA = LA + Ld0(p2,p3,p14)*S234**(-1) * (  - 32 - 56*s12*S24**(-1)
     +     - 32*s13*S14**(-1) + 40*s13*S24**(-1) - 8*s14*S24**(-1) - 16
     +    *s23*S24**(-1) )

      LA = LA + Ld0(p2,p3,p14)*S134**(-1) * ( 32*s12**2*S14**(-1)*
     +    S24**(-1) - 16*s12*s13*S14**(-1)*S24**(-1) + 16*s12*s23*
     +    S14**(-1)*S24**(-1) + 24*s12*S14**(-1) + 48*s12*S24**(-1) - 
     +    16*s13*S14**(-1) - 32*s13*S24**(-1) + 8*s23*S14**(-1) + 16*
     +    s23*S24**(-1) + 8*s24*S14**(-1) )

      LA = LA + Ld0(p2,p3,p14)*S134**(-2) * (  - 32*s12*s13*S14**(-1)
     +     - 32*s12 - 32*s13*s23*S14**(-1) - 32*s13*s24*S14**(-1) - 32*
     +    s23 - 32*s24 )

      LA = LA + Ld0(p2,p3,p14) * (  - 32*s12*S14**(-1)*S24**(-1) )

      LA = LA + Ld0(p2,p4,p3)*S13**(-1)*S23**(-1)*S34**(-1) * (  - 16*
     +    s12**2 - 16*s12*s14 - 16*s12*s24 - 8*s14**2 - 8*s24**2 )

      LA = LA + Ld0(p2,p4,p3)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12**3*s14*S24**(-1) + 16*s12**3 )

      LA = LA + Ld0(p2,p4,p3)*S13**(-1)*S23**(-1)*S234**(-1) * ( 16*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p2,p4,p3)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 16*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p2,p4,p3)*S13**(-1)*S23**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) + 16*s12**2*S14**(-1) + 16*s12**2*
     +    S24**(-1) + 8*s12*s14*S24**(-1) + 8*s12*s24*S14**(-1) )

      LA = LA + Ld0(p2,p4,p3)*S13**(-1)*S34**(-1)*S234**(-1) * ( 32*
     +    s12**2 + 32*s12*s14 + 32*s12*s23 + 16*s14**2 + 32*s14*s23 + 
     +    16*s23**2 )

      LA = LA + Ld0(p2,p4,p3)*S13**(-1)*S34**(-1) * ( 16*s12**2*
     +    S24**(-1) + 16*s12*s14*S24**(-1) + 16*s12*s23*S24**(-1) + 16*
     +    s12 + 8*s14**2*S24**(-1) - 16*s14 + 8*s23**2*S24**(-1) + 16*
     +    s23 + 8*s24 )

      LA = LA + Ld0(p2,p4,p3)*S13**(-1)*S234**(-1)*S134**(-1) * ( 48*
     +    s12**3*S24**(-1) + 32*s12**2*s14*S24**(-1) - 64*s12**2 + 24*
     +    s12*s14*s23*S24**(-1) - 8*s12*s14 - 48*s12*s23 + 8*s14**2*s23
     +    *S24**(-1) + 8*s14**2 - 16*s14*s23 - 8*s14*s24 - 16*s23**2 )

      LA = LA + Ld0(p2,p4,p3)*S13**(-1)*S234**(-1) * ( 32*s12*s14*
     +    S24**(-1) - 16*s12 + 8*s14**2*S24**(-1) )

      LA = LA + Ld0(p2,p4,p3)*S13**(-1)*S134**(-1) * ( 48*s12**2*
     +    S24**(-1) - 8*s12*s14*S24**(-1) + 32*s12*s23*S24**(-1) - 8*
     +    s12 + 8*s14*s23*S24**(-1) + 16*s14 + 8*s23**2*S24**(-1) - 8*
     +    s23 - 16*s24 )

      LA = LA + Ld0(p2,p4,p3)*S13**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s23*S14**(-1)*S24**(-1) + 16*s12*S14**(-1)
     +     + 16*s12*S24**(-1) + 16*s14*S24**(-1) + 16*s23*S24**(-1) + 8
     +    *s34*S24**(-1) )

      LA = LA + Ld0(p2,p4,p3)*S23**(-1)*S34**(-1) * (  - 32*s12**2*
     +    S14**(-1) - 32*s12*s13*S14**(-1) - 32*s12*s24*S14**(-1) - 80*
     +    s12 - 16*s13**2*S14**(-1) - 48*s13 - 40*s14 - 16*s24**2*
     +    S14**(-1) - 32*s24 )

      LA = LA + Ld0(p2,p4,p3)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**3*s13*S14**(-1)*S24**(-1) + 16*s12**3*S14**(-1) - 32*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p2,p4,p3)*S23**(-1)*S234**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) + 80*s12 + 32*s13 + 8*s14 + 32*s24 )

      LA = LA + Ld0(p2,p4,p3)*S23**(-1)*S234**(-2) * ( 32*s12*s24 + 32*
     +    s13*s24 + 32*s14*s24 )

      LA = LA + Ld0(p2,p4,p3)*S23**(-1)*S134**(-1) * (  - 16*s12**3*
     +    S14**(-1)*S24**(-1) )

      LA = LA + Ld0(p2,p4,p3)*S23**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s13*S14**(-1)*S24**(-1) - 16*s12*S14**(-1)
     +     + 16*s12*S24**(-1) )

      LA = LA + Ld0(p2,p4,p3)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 64
     +    *s12*s23 )

      LA = LA + Ld0(p2,p4,p3)*S34**(-1)*S234**(-1) * (  - 32*s12**2*
     +    S14**(-1) - 32*s12*s13*S14**(-1) + 32*s12*s23*S14**(-1) + 32*
     +    s12 - 16*s13**2*S14**(-1) + 32*s13*s23*S14**(-1) + 32*s13 + 
     +    32*s14 - 16*s23**2*S14**(-1) - 64*s23 )

      LA = LA + Ld0(p2,p4,p3)*S34**(-1)*S234**(-2) * (  - 64*s12*s23 - 
     +    64*s13*s23 - 64*s14*s23 )

      LA = LA + Ld0(p2,p4,p3)*S34**(-1)*S134**(-1) * ( 32*s12 - 32*s23
     +     + 32*s24 )

      LA = LA + Ld0(p2,p4,p3)*S34**(-1) * ( 16 + 16*s12**2*S14**(-1)*
     +    S24**(-1) + 16*s12*s13*S14**(-1)*S24**(-1) + 16*s12*s23*
     +    S14**(-1)*S24**(-1) - 64*s12*S14**(-1) + 48*s12*S24**(-1) + 8
     +    *s13**2*S14**(-1)*S24**(-1) - 16*s13*S14**(-1) + 24*s13*
     +    S24**(-1) + 32*s14*S24**(-1) + 8*s23**2*S14**(-1)*S24**(-1)
     +     + 16*s23*S24**(-1) - 48*s24*S14**(-1) )

      LA = LA + Ld0(p2,p4,p3)*S234**(-1)*S134**(-1) * ( 48*s12**3*
     +    S14**(-1)*S24**(-1) + 64*s12**2*S14**(-1) + 32*s12**2*
     +    S24**(-1) + 48*s12*s13*S14**(-1) - 24*s12*s13*S24**(-1) - 24*
     +    s12*s14*S24**(-1) - 48*s12*s23*S14**(-1) + 24*s12*s23*
     +    S24**(-1) + 40*s12 + 8*s13**2*S24**(-1) + 8*s13*s14*S24**(-1)
     +     - 16*s13*s23*S14**(-1) - 8*s13*s23*S24**(-1) + 16*s13*s24*
     +    S14**(-1) - 24*s13 + 32*s14 + 16*s23**2*S14**(-1) + 16*s23 + 
     +    8*s24 )

      LA = LA + Ld0(p2,p4,p3)*S234**(-1) * (  - 48 + 32*s12**2*
     +    S14**(-1)*S24**(-1) + 16*s12*s13*S14**(-1)*S24**(-1) - 16*s12
     +    *s23*S14**(-1)*S24**(-1) + 32*s12*S24**(-1) + 16*s13*
     +    S14**(-1) - 8*s13*S24**(-1) - 8*s14*S24**(-1) - 8*s23*
     +    S24**(-1) )

      LA = LA + Ld0(p2,p4,p3)*S234**(-2) * (  - 16*s12*s23*S24**(-1) - 
     +    48*s12 - 16*s13*s23*S24**(-1) - 48*s13 - 16*s14*s23*S24**(-1)
     +     - 48*s14 )

      LA = LA + Ld0(p2,p4,p3)*S134**(-1) * ( 16 + 32*s12**2*S14**(-1)*
     +    S24**(-1) - 16*s12*s13*S14**(-1)*S24**(-1) + 16*s12*s23*
     +    S14**(-1)*S24**(-1) + 104*s12*S14**(-1) - 40*s12*S24**(-1) - 
     +    16*s13*S14**(-1) + 8*s13*S24**(-1) + 8*s23*S14**(-1) - 8*s23*
     +    S24**(-1) + 40*s24*S14**(-1) )

      LA = LA + Ld0(p2,p4,p3) * ( 32*s12*S14**(-1)*S24**(-1) )

      LA = LA + Ld0(p2,p4,p13)*S13**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2 + 16*s12*s14 + 16*s12*s24 + 8*s14**2 + 8*s24**2 )

      LA = LA + Ld0(p2,p4,p13)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12**3*s14*S24**(-1) + 48*s12**3 )

      LA = LA + Ld0(p2,p4,p13)*S13**(-1)*S23**(-1)*S234**(-1) * ( 48*
     +    s12**3*S24**(-1) )

      LA = LA + Ld0(p2,p4,p13)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 16
     +    *s12**3*S24**(-1) + 32*s12**2 - 16*s12*s14 + 16*s12*s24 )

      LA = LA + Ld0(p2,p4,p13)*S13**(-1)*S23**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) + 16*s12**2*S14**(-1) - 16*s12**2*
     +    S24**(-1) - 8*s12*s14*S24**(-1) + 8*s12*s24*S14**(-1) - 32*
     +    s12 )

      LA = LA + Ld0(p2,p4,p13)*S13**(-1)*S34**(-1) * ( 32*s12 + 16*s14
     +     + 16*s23 + 16*s24 )

      LA = LA + Ld0(p2,p4,p13)*S13**(-1)*S234**(-1)*S134**(-1) * ( 48*
     +    s12**3*S24**(-1) + 64*s12**2*s14*S24**(-1) + 48*s12*s14*s23*
     +    S24**(-1) + 16*s14**2*s23*S24**(-1) + 16*s14**2 - 32*s14*s23
     +     - 16*s14*s24 )

      LA = LA + Ld0(p2,p4,p13)*S13**(-1)*S234**(-1) * ( 64*s12*s14*
     +    S24**(-1) + 16*s14**2*S24**(-1) - 32*s14 )

      LA = LA + Ld0(p2,p4,p13)*S13**(-1)*S134**(-1) * ( 64*s12**2*
     +    S24**(-1) + 48*s12*s23*S24**(-1) + 24*s12 + 16*s14*s23*
     +    S24**(-1) - 16*s14 + 16*s23**2*S24**(-1) + 8*s23 + 8*s24 )

      LA = LA + Ld0(p2,p4,p13)*S13**(-1)*S134**(-2) * (  - 32*s12*s14
     +     - 32*s14*s23 - 32*s14*s24 )

      LA = LA + Ld0(p2,p4,p13)*S13**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s23*S14**(-1)*S24**(-1) + 16*s12*S14**(-1)
     +     + 32*s12*S24**(-1) + 16*s14*S24**(-1) + 16*s23*S24**(-1) + 8
     +    *s34*S24**(-1) )

      LA = LA + Ld0(p2,p4,p13)*S23**(-1)*S34**(-1)*S134**(-1) * (  - 32
     +    *s12**2 - 32*s12*s13 - 32*s12*s24 - 16*s13**2 - 32*s13*s24 - 
     +    16*s24**2 )

      LA = LA + Ld0(p2,p4,p13)*S23**(-1)*S34**(-1) * ( 16*s24 )

      LA = LA + Ld0(p2,p4,p13)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**3*s13*S14**(-1)*S24**(-1) + 16*s12**3*S14**(-1) - 32*
     +    s12**3*S24**(-1) + 64*s12**2 + 48*s12*s13 + 16*s13**2 )

      LA = LA + Ld0(p2,p4,p13)*S23**(-1)*S234**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) - 56*s12 - 24*s13 + 24*s14 - 16*s24 )

      LA = LA + Ld0(p2,p4,p13)*S23**(-1)*S134**(-1) * (  - 16*s12**3*
     +    S14**(-1)*S24**(-1) + 16*s12 - 16*s24 )

      LA = LA + Ld0(p2,p4,p13)*S23**(-1) * ( 16*s12**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s13*S14**(-1)*S24**(-1) + 16*s12*S14**(-1)
     +     )

      LA = LA + Ld0(p2,p4,p13)*S34**(-1)*S234**(-1)*S134**(-1) * ( 64*
     +    s12*s13 )

      LA = LA + Ld0(p2,p4,p13)*S34**(-1)*S234**(-1) * (  - 32*s12 + 32*
     +    s13 - 32*s14 )

      LA = LA + Ld0(p2,p4,p13)*S34**(-1)*S134**(-1) * ( 32*s12**2*
     +    S24**(-1) - 32*s12*s13*S24**(-1) + 32*s12*s23*S24**(-1) - 32*
     +    s12 + 16*s13**2*S24**(-1) - 32*s13*s23*S24**(-1) + 64*s13 + 
     +    16*s23**2*S24**(-1) - 32*s23 - 32*s24 )

      LA = LA + Ld0(p2,p4,p13)*S34**(-1)*S134**(-2) * ( 64*s12*s13 + 64
     +    *s13*s23 + 64*s13*s24 )

      LA = LA + Ld0(p2,p4,p13)*S34**(-1) * (  - 32 - 16*s12**2*
     +    S14**(-1)*S24**(-1) - 16*s12*s13*S14**(-1)*S24**(-1) - 16*s12
     +    *s23*S14**(-1)*S24**(-1) - 32*s12*S14**(-1) + 32*s12*
     +    S24**(-1) - 8*s13**2*S14**(-1)*S24**(-1) - 16*s13*S14**(-1)
     +     - 16*s13*S24**(-1) + 16*s14*S24**(-1) - 8*s23**2*S14**(-1)*
     +    S24**(-1) - 16*s23*S14**(-1) + 16*s23*S24**(-1) - 16*s24*
     +    S14**(-1) )

      LA = LA + Ld0(p2,p4,p13)*S234**(-1)*S134**(-1) * ( 16*s12**3*
     +    S14**(-1)*S24**(-1) - 48*s12*s13*S24**(-1) - 96*s12*s14*
     +    S24**(-1) + 48*s12*s23*S24**(-1) + 64*s12 + 32*s13**2*
     +    S24**(-1) + 48*s13*s14*S24**(-1) - 32*s13*s23*S24**(-1) - 48*
     +    s13 - 16*s14*s23*S24**(-1) + 32*s14 - 16*s24 )

      LA = LA + Ld0(p2,p4,p13)*S234**(-1) * ( 40*s12*S24**(-1) - 40*s13
     +    *S24**(-1) - 8*s14*S24**(-1) )

      LA = LA + Ld0(p2,p4,p13)*S134**(-1) * ( 32 - 8*s12*S14**(-1) - 96
     +    *s12*S24**(-1) + 48*s13*S24**(-1) - 8*s23*S14**(-1) - 32*s23*
     +    S24**(-1) - 8*s24*S14**(-1) )

      LA = LA + Ld0(p2,p4,p13)*S134**(-2) * ( 32*s12 + 32*s23 + 32*s24
     +     )

      LAc=-LA
      
      return
      end

      function LAd(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LA=0d0

      LA = LA + Ld1(p1,p3,p4)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12**3*s14 + 16*s12**3*s34 - 16*s12**2*s14**2 - 16*
     +    s12**2*s14*s24 - 16*s12**2*s14*s34 + 16*s12**2*s34**2 - 8*s12
     +    *s14**3 - 16*s12*s14**2*s34 - 8*s12*s14*s24**2 - 16*s12*s14*
     +    s24*s34 - 16*s12*s14*s34**2 )

      LA = LA + Ld1(p1,p3,p4)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**3*s14*S24**(-1) + 16*s12**3*s34*S24**(-1) - 16*s12**2*
     +    s14**2*S24**(-1) - 16*s12**2*s14 - 8*s12**2*s23*s34*S24**(-1)
     +     + 8*s12**2*s34**2*S24**(-1) - 8*s12**2*s34 - 8*s12*s14**3*
     +    S24**(-1) + 16*s12*s14**2*s23*S24**(-1) + 16*s12*s14**2 - 2*
     +    s12*s14*s23**2*S24**(-1) + 8*s12*s14*s23*s34*S24**(-1) - 18*
     +    s12*s14*s23 - 24*s12*s14*s24 + 8*s12*s14*s34**2*S24**(-1) - 8
     +    *s12*s14*s34 )

      LA = LA + Ld1(p1,p3,p4)*S23**(-1)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 16*s12**2*s13*s24 + 16*s12**2*s14*s24 + 16*s12*s13**2*
     +    s24**2*S14**(-1) + 16*s12*s13**2*s24 + 32*s12*s13*s14*s24 + 
     +    32*s12*s13*s24**2 + 16*s12*s14**2*s24 + 16*s12*s14*s24**2 + 
     +    16*s13**3*s24**2*S14**(-1) + 8*s13**3*s24 + 24*s13**2*s14*s24
     +     + 32*s13**2*s24**2 + 24*s13*s14**2*s24 + 16*s13*s14*s24**2
     +     + 8*s13*s24**3 + 8*s14**3*s24 + 8*s14*s24**3 )

      LA = LA + Ld1(p1,p3,p4)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**3 - 16*s12**2*s13*s24*S14**(-1) - 16*s12**2*s13*s34*
     +    S14**(-1) - 16*s12**2*s13 - 32*s12**2*s14 - 24*s12**2*s24*s34
     +    *S14**(-1) - 48*s12**2*s24 - 24*s12**2*s34**2*S14**(-1) + 16*
     +    s12**2*s34 - 16*s12*s13**2*s34*S14**(-1) - 8*s12*s13**2 - 24*
     +    s12*s13*s14 + 24*s12*s13*s24**2*S14**(-1) + 8*s12*s13*s24*s34
     +    *S14**(-1) - 48*s12*s13*s24 - 16*s12*s13*s34**2*S14**(-1) - 
     +    24*s12*s14**2 - 24*s12*s14*s34 - 8*s12*s24**2*s34*S14**(-1)
     +     - 8*s12*s24**2 - 8*s12*s24*s34**2*S14**(-1) - 24*s12*s24*s34
     +     + 16*s12*s34**2 + 16*s13**3*s24*S14**(-1) + 16*s13**2*s24**2
     +    *S14**(-1) + 16*s13**2*s24*s34*S14**(-1) + 24*s13*s14*s24 + 8
     +    *s13*s24**3*S14**(-1) + 8*s13*s24**2*s34*S14**(-1) + 8*s13*
     +    s24**2 - 16*s13*s24*s34 + 16*s14**2*s24 + 16*s14*s24**2 + 16*
     +    s14*s24*s34 )

      LA = LA + Ld1(p1,p3,p4)*S34**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**2*s13 + 16*s12**2*s14 + 16*s12*s13**2*s24*S14**(-1) + 16
     +    *s12*s13**2 + 32*s12*s13*s14 + 32*s12*s13*s23 + 64*s12*s13*
     +    s24 + 16*s12*s14**2 + 32*s12*s14*s23 + 48*s12*s14*s24 + 16*
     +    s13**3*s24*S14**(-1) + 8*s13**3 + 24*s13**2*s14 + 16*s13**2*
     +    s23*s24*S14**(-1) + 16*s13**2*s23 + 16*s13**2*s24**2*
     +    S14**(-1) + 48*s13**2*s24 + 24*s13*s14**2 + 32*s13*s14*s23 + 
     +    48*s13*s14*s24 + 10*s13*s23**2 + 42*s13*s23*s24 + 40*s13*
     +    s24**2 + 8*s14**3 + 16*s14**2*s23 + 16*s14**2*s24 + 10*s14*
     +    s23**2 + 26*s14*s23*s24 + 24*s14*s24**2 )

      LA = LA + Ld1(p1,p3,p4)*S234**(-1)*S134**(-1) * (  - 16*s12**3*
     +    S24**(-1) - 16*s12**2*s13*S14**(-1) - 16*s12**2*s13*S24**(-1)
     +     - 32*s12**2*s14*S24**(-1) - 24*s12**2*s34*S14**(-1) - 16*
     +    s12**2*s34*S24**(-1) - 48*s12**2 - 16*s12*s13**2*S14**(-1) - 
     +    8*s12*s13**2*S24**(-1) - 24*s12*s13*s14*S24**(-1) + 16*s12*
     +    s13*s23*S24**(-1) + 24*s12*s13*s24*S14**(-1) - 16*s12*s13*s34
     +    *S14**(-1) - 16*s12*s13*s34*S24**(-1) - 24*s12*s14**2*
     +    S24**(-1) + 32*s12*s14*s23*S24**(-1) - 24*s12*s14*s34*
     +    S24**(-1) + 16*s12*s14 - 2*s12*s23**2*S24**(-1) + 16*s12*s23*
     +    s34*S14**(-1) - 26*s12*s23 + 8*s12*s24*s34*S14**(-1) - 32*s12
     +    *s24 + 16*s12*s34**2*S14**(-1) - 16*s12*s34**2*S24**(-1) - 32
     +    *s12*s34 + 32*s13**2*s24*S14**(-1) + 16*s13**2 + 24*s13*s14
     +     + 32*s13*s23 + 8*s13*s24**2*S14**(-1) + 24*s13*s24 + 16*s13*
     +    s34 + 8*s14*s23 + 40*s14*s24 - 8*s14*s34 )

      LA = LA + Ld1(p1,p3,p24)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12**4*s34**2*S14**(-1)*S24**(-1) - 16*
     +    s12**4*s34*S24**(-1) - 32*s12**3*s14*s34*S24**(-1) + 16*
     +    s12**3*s34**3*S14**(-1)*S24**(-1) - 16*s12**3*s34**2*
     +    S24**(-1) - 24*s12**2*s14**2*s34*S24**(-1) - 24*s12**2*s14*
     +    s34**2*S24**(-1) - 16*s12**2*s14*s34 + 8*s12**2*s34**3*
     +    S14**(-1) - 8*s12**2*s34**2 - 8*s12*s14**3*s34*S24**(-1) - 8*
     +    s12*s14**2*s34**2*S24**(-1) - 8*s12*s14*s24*s34 - 8*s12*s24*
     +    s34**2 )

      LA = LA + Ld1(p1,p3,p24)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    32*s12**4*s23*S14**(-1)*S24**(-1) - 48*s12**4*s34*S14**(-1)*
     +    S24**(-1) - 32*s12**4*S24**(-1) - 80*s12**3*s14*S24**(-1) + 
     +    64*s12**3*s23**2*S14**(-1)*S24**(-1) + 144*s12**3*s23*s34*
     +    S14**(-1)*S24**(-1) + 64*s12**3*s23*S14**(-1) + 16*s12**3*s23
     +    *S24**(-1) + 96*s12**3*s34**2*S14**(-1)*S24**(-1) + 48*s12**3
     +    *s34*S14**(-1) - 16*s12**3*s34*S24**(-1) + 32*s12**3 - 80*
     +    s12**2*s14**2*S24**(-1) + 16*s12**2*s14*s23*S24**(-1) - 40*
     +    s12**2*s14*s34*S24**(-1) - 16*s12**2*s23**3*S14**(-1)*
     +    S24**(-1) - 48*s12**2*s23**2*s34*S14**(-1)*S24**(-1) - 32*
     +    s12**2*s23**2*S14**(-1) - 16*s12**2*s23**2*S24**(-1) - 16*
     +    s12**2*s23*s24*S14**(-1) - 48*s12**2*s23*s34**2*S14**(-1)*
     +    S24**(-1) - 48*s12**2*s23*s34*S14**(-1) + 16*s12**2*s23 - 16*
     +    s12**2*s34**3*S14**(-1)*S24**(-1) + 16*s12**2*s34**2*
     +    S24**(-1) - 40*s12*s14**3*S24**(-1) - 24*s12*s14**2*s23*
     +    S24**(-1) - 48*s12*s14**2*s34*S24**(-1) - 16*s12*s14**2 - 48*
     +    s12*s14*s23**2*S24**(-1) )

      LA = LA + Ld1(p1,p3,p24)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    56*s12*s14*s23*s34*S24**(-1) - 8*s12*s14*s34**2*S24**(-1) + 8
     +    *s12*s14*s34 + 16*s12*s34**2 - 8*s14**4*S24**(-1) - 8*s14**3*
     +    s23*S24**(-1) - 8*s14**3*s34*S24**(-1) - 8*s14**2*s23**2*
     +    S24**(-1) - 8*s14**2*s23*s34*S24**(-1) - 8*s14**2*s24 - 8*s14
     +    *s23*s34 - 8*s14*s24*s34 )

      LA = LA + Ld1(p1,p3,p24)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**4*s34*S14**(-1)*S24**(-1) - 16*s12**3*s13*s34*
     +    S14**(-1)*S24**(-1) + 16*s12**3*s13*S14**(-1) + 16*s12**3*s34
     +    *S14**(-1) - 48*s12**3*s34*S24**(-1) + 16*s12**3 - 8*s12**2*
     +    s13**2*s34*S14**(-1)*S24**(-1) + 16*s12**2*s13**2*S14**(-1)
     +     + 8*s12**2*s13*s34**2*S14**(-1)*S24**(-1) - 40*s12**2*s13*
     +    s34*S24**(-1) + 64*s12**2*s13 - 56*s12**2*s14*s34*S24**(-1)
     +     + 48*s12**2*s14 - 16*s12**2*s24 + 16*s12**2*s34**3*S14**(-1)
     +    *S24**(-1) - 8*s12**2*s34**2*S14**(-1) - 16*s12**2*s34**2*
     +    S24**(-1) + 16*s12**2*s34 + 8*s12*s13**3*S14**(-1) - 8*s12*
     +    s13**2*s34*S14**(-1) - 8*s12*s13**2*s34*S24**(-1) + 56*s12*
     +    s13**2 - 24*s12*s13*s14*s34*S24**(-1) + 88*s12*s13*s14 - 8*
     +    s12*s13*s24*s34*S14**(-1) - 16*s12*s13*s24 - 16*s12*s13*
     +    s34**2*S14**(-1) - 8*s12*s13*s34**2*S24**(-1) + 16*s12*s13*
     +    s34 - 24*s12*s14**2*s34*S24**(-1) + 40*s12*s14**2 - 16*s12*
     +    s14*s34**2*S24**(-1) + 24*s12*s14*s34 - 8*s12*s24*s34**2*
     +    S14**(-1) )

      LA = LA + Ld1(p1,p3,p24)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12*s34**2 + 8*s13**3 + 24*s13**2*s14 + 8*s13**2*s34 + 24*
     +    s13*s14**2 + 16*s13*s14*s34 + 8*s13*s24**2 + 16*s13*s24*s34
     +     + 8*s14**3 + 8*s14**2*s34 + 8*s14*s24**2 + 8*s24**2*s34 )

      LA = LA + Ld1(p1,p3,p24)*S23**(-1)*S234**(-2)*S134**(-1) * (  - 
     +    16*s12**2*s13*s24 - 16*s12**2*s14*s24 + 16*s12**2*s24**2 - 32
     +    *s12*s13**2*s24 - 48*s12*s13*s14*s24 + 32*s12*s13*s24**2 - 16
     +    *s12*s14**2*s24 + 16*s12*s14*s24**2 - 16*s13**3*s24 - 32*
     +    s13**2*s14*s24 + 16*s13**2*s24**2 - 16*s13*s14**2*s24 + 16*
     +    s13*s14*s24**2 )

      LA = LA + Ld1(p1,p3,p24)*S234**(-1)*S134**(-1) * (  - 32*s12**4*
     +    S14**(-1)*S24**(-1) - 32*s12**3*s13*S14**(-1)*S24**(-1) + 96*
     +    s12**3*s23*S14**(-1)*S24**(-1) + 64*s12**3*s34*S14**(-1)*
     +    S24**(-1) + 48*s12**3*S14**(-1) - 112*s12**3*S24**(-1) - 16*
     +    s12**2*s13**2*S14**(-1)*S24**(-1) + 112*s12**2*s13*s23*
     +    S14**(-1)*S24**(-1) + 88*s12**2*s13*s34*S14**(-1)*S24**(-1)
     +     - 88*s12**2*s13*S24**(-1) - 152*s12**2*s14*S24**(-1) - 32*
     +    s12**2*s23**2*S14**(-1)*S24**(-1) + 64*s12**2*s23*s34*
     +    S14**(-1)*S24**(-1) + 48*s12**2*s23*S14**(-1) + 216*s12**2*
     +    s23*S24**(-1) - 16*s12**2*s24*S14**(-1) + 88*s12**2*s34**2*
     +    S14**(-1)*S24**(-1) + 48*s12**2*s34*S14**(-1) + 96*s12**2*s34
     +    *S24**(-1) + 40*s12**2 - 40*s12*s13**2*S14**(-1) - 16*s12*
     +    s13**2*S24**(-1) - 72*s12*s13*s14*S24**(-1) + 144*s12*s13*s23
     +    *S24**(-1) - 48*s12*s13*s24*S14**(-1) - 40*s12*s13*s34*
     +    S14**(-1) + 64*s12*s13*s34*S24**(-1) - 56*s12*s13 - 96*s12*
     +    s14**2*S24**(-1) + 168*s12*s14*s23*S24**(-1) + 24*s12*s14*s34
     +    *S24**(-1) )

      LA = LA + Ld1(p1,p3,p24)*S234**(-1)*S134**(-1) * ( 16*s12*s14 - 
     +    96*s12*s23**2*S14**(-1) - 48*s12*s23*s24*S14**(-1) - 120*s12*
     +    s23*s34*S14**(-1) + 144*s12*s23*s34*S24**(-1) + 96*s12*s23 - 
     +    24*s12*s34**2*S14**(-1) + 88*s12*s34**2*S24**(-1) + 56*s12*
     +    s34 - 8*s13**2*s14*S24**(-1) - 40*s13**2 - 24*s13*s14**2*
     +    S24**(-1) + 40*s13*s14*s23*S24**(-1) - 8*s13*s14*s34*
     +    S24**(-1) - 40*s13*s14 + 24*s13*s23*s24*S14**(-1) - 8*s13*s23
     +     + 24*s13*s24*s34*S14**(-1) - 16*s13*s24 - 40*s13*s34 - 24*
     +    s14**3*S24**(-1) + 40*s14**2*s23*S24**(-1) - 16*s14**2*s34*
     +    S24**(-1) + 8*s14**2 + 8*s14*s23**2*S24**(-1) + 40*s14*s23*
     +    s34*S24**(-1) + 24*s14*s23 - 8*s14*s24 - 8*s14*s34 - 24*
     +    s23**2 - 24*s23*s34 + 8*s24*s34 )

      LA = LA + Ld1(p1,p3,p24)*S234**(-2)*S134**(-1) * ( 8*s12**2*s13*
     +    s23*S24**(-1) + 8*s12**2*s13 + 8*s12**2*s14*s23*S24**(-1) + 8
     +    *s12**2*s14 - 8*s12**2*s23**2*S24**(-1) - 16*s12**2*s23 + 8*
     +    s12**2*s24 + 8*s12*s13**2*s23*S24**(-1) + 24*s12*s13*s14*s23*
     +    S24**(-1) + 24*s12*s13*s14 - 8*s12*s13*s23**2*S24**(-1) - 8*
     +    s12*s13*s23 + 32*s12*s13*s24 + 16*s12*s14**2*s23*S24**(-1) + 
     +    24*s12*s14**2 - 16*s12*s14*s23**2*S24**(-1) - 40*s12*s14*s23
     +     - 8*s12*s14*s24 - 8*s13**3 + 8*s13**2*s14*s23*S24**(-1) + 8*
     +    s13**2*s23 + 24*s13**2*s24 + 16*s13*s14**2*s23*S24**(-1) + 24
     +    *s13*s14**2 - 8*s13*s14*s23**2*S24**(-1) - 16*s13*s14*s23 + 8
     +    *s13*s14*s24 + 8*s14**3*s23*S24**(-1) + 16*s14**3 - 8*s14**2*
     +    s23**2*S24**(-1) - 24*s14**2*s23 - 16*s14**2*s24 )

      LA = LA + Ld1(p1,p4,p3)*S13**(-1)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 16*s12*s14**2*s23**2*S24**(-1) + 16*s12*s14**2*s23 + 16*
     +    s14**3*s23**2*S24**(-1) + 16*s14**3*s23 + 16*s14**2*s23**2 + 
     +    16*s14**2*s23*s24 )

      LA = LA + Ld1(p1,p4,p3)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**2*s14*s23*S24**(-1) - 16*s12**2*s14*s34*S24**(-1) - 16*
     +    s12**2*s14 - 24*s12**2*s23*s34*S24**(-1) - 24*s12**2*s34**2*
     +    S24**(-1) - 24*s12**2*s34 - 16*s12*s14**2*s34*S24**(-1) - 16*
     +    s12*s14**2 + 24*s12*s14*s23**2*S24**(-1) + 8*s12*s14*s23*s34*
     +    S24**(-1) + 24*s12*s14*s23 - 16*s12*s14*s34**2*S24**(-1) - 16
     +    *s12*s14*s34 - 8*s12*s23**2*s34*S24**(-1) - 8*s12*s23*s34**2*
     +    S24**(-1) + 8*s12*s23*s34 + 16*s12*s24*s34 + 16*s12*s34**2 + 
     +    16*s14**3*s23*S24**(-1) + 16*s14**2*s23**2*S24**(-1) + 16*
     +    s14**2*s23*s34*S24**(-1) + 32*s14**2*s23 + 8*s14*s23**3*
     +    S24**(-1) + 8*s14*s23**2*s34*S24**(-1) + 8*s14*s23**2 )

      LA = LA + Ld1(p1,p4,p3)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**3*s13*S14**(-1) + 16*s12**3*s34*S14**(-1) - 16*s12**3
     +     - 16*s12**2*s13**2*S14**(-1) - 32*s12**2*s13 - 16*s12**2*s14
     +     - 8*s12**2*s24*s34*S14**(-1) + 8*s12**2*s34**2*S14**(-1) - 
     +    16*s12**2*s34 - 8*s12*s13**3*S14**(-1) + 16*s12*s13**2*s24*
     +    S14**(-1) - 24*s12*s13**2 - 24*s12*s13*s14 - 2*s12*s13*s24**2
     +    *S14**(-1) + 8*s12*s13*s24*s34*S14**(-1) + 32*s12*s13*s24 + 8
     +    *s12*s13*s34**2*S14**(-1) - 24*s12*s13*s34 - 8*s12*s14**2 + 
     +    16*s12*s14*s24 - 16*s12*s14*s34 - 2*s12*s24**2 - 16*s12*
     +    s34**2 )

      LA = LA + Ld1(p1,p4,p3)*S34**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**2*s13*s23*S24**(-1) + 16*s12**2*s13 + 16*s12**2*s14*s23*
     +    S24**(-1) + 16*s12**2*s14 + 16*s12*s13**2*s23*S24**(-1) + 16*
     +    s12*s13**2 + 32*s12*s13*s14*s23*S24**(-1) + 32*s12*s13*s14 + 
     +    16*s12*s13*s23**2*S24**(-1) + 48*s12*s13*s23 + 32*s12*s13*s24
     +     + 16*s12*s14**2*s23*S24**(-1) + 16*s12*s14**2 + 32*s12*s14*
     +    s23**2*S24**(-1) + 64*s12*s14*s23 + 32*s12*s14*s24 + 8*s13**3
     +    *s23*S24**(-1) + 8*s13**3 + 24*s13**2*s14*s23*S24**(-1) + 24*
     +    s13**2*s14 + 16*s13**2*s23 + 16*s13**2*s24 + 24*s13*s14**2*
     +    s23*S24**(-1) + 24*s13*s14**2 + 16*s13*s14*s23**2*S24**(-1)
     +     + 48*s13*s14*s23 + 32*s13*s14*s24 + 8*s13*s23**3*S24**(-1)
     +     + 24*s13*s23**2 + 26*s13*s23*s24 + 10*s13*s24**2 + 8*s14**3*
     +    s23*S24**(-1) + 8*s14**3 + 32*s14**2*s23**2*S24**(-1) + 48*
     +    s14**2*s23 + 16*s14**2*s24 + 8*s14*s23**3*S24**(-1) + 40*s14*
     +    s23**2 + 42*s14*s23*s24 + 10*s14*s24**2 )

      LA = LA + Ld1(p1,p4,p3)*S234**(-1)*S134**(-1) * (  - 16*s12**3*
     +    s13*S14**(-1)*S24**(-1) + 16*s12**3*s34*S14**(-1)*S24**(-1)
     +     - 16*s12**3*S24**(-1) - 16*s12**2*s13**2*S14**(-1)*S24**(-1)
     +     - 16*s12**2*s13*s23*S14**(-1)*S24**(-1) - 16*s12**2*s13*s34*
     +    S14**(-1)*S24**(-1) - 16*s12**2*s13*S14**(-1) - 32*s12**2*s13
     +    *S24**(-1) - 16*s12**2*s14*S24**(-1) - 48*s12**2*s23*
     +    S24**(-1) + 16*s12**2*s34**2*S14**(-1)*S24**(-1) - 8*s12**2*
     +    s34*S14**(-1) + 16*s12**2*s34*S24**(-1) - 48*s12**2 - 8*s12*
     +    s13**3*S14**(-1)*S24**(-1) - 16*s12*s13**2*s34*S14**(-1)*
     +    S24**(-1) + 16*s12*s13**2*S14**(-1) - 24*s12*s13**2*S24**(-1)
     +     - 24*s12*s13*s14*S24**(-1) - 8*s12*s13*s23**2*S14**(-1)*
     +    S24**(-1) - 16*s12*s13*s23*s34*S14**(-1)*S24**(-1) - 24*s12*
     +    s13*s23*S14**(-1) - 18*s12*s13*s24*S14**(-1) - 16*s12*s13*
     +    s34**2*S14**(-1)*S24**(-1) - 8*s12*s13*s34*S14**(-1) - 24*s12
     +    *s13*s34*S24**(-1) + 16*s12*s13 - 8*s12*s14**2*S24**(-1) - 48
     +    *s12*s14*s23*S24**(-1) - 8*s12*s23**2*S24**(-1) - 24*s12*s23*
     +    s34*S24**(-1) )

      LA = LA + Ld1(p1,p4,p3)*S234**(-1)*S134**(-1) * (  - 32*s12*s23
     +     - 26*s12*s24 + 16*s12*s34**2*S24**(-1) - 32*s12*s34 + 16*
     +    s13**2*s23*S24**(-1) + 24*s13*s14*s23*S24**(-1) + 24*s13*s14
     +     + 16*s13*s23**2*S24**(-1) + 16*s13*s23*s34*S24**(-1) + 40*
     +    s13*s23 + 8*s13*s24 - 8*s13*s34 + 16*s14**2 + 8*s14*s23**2*
     +    S24**(-1) - 16*s14*s23*s34*S24**(-1) + 24*s14*s23 + 32*s14*
     +    s24 + 16*s14*s34 )

      LA = LA + Ld1(p1,p4,p23)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**4*s24*S14**(-1) - 16*s12**4*s34**2*
     +    S14**(-1)*S24**(-1) - 48*s12**4*s34*S14**(-1) - 16*s12**4*s34
     +    *S24**(-1) - 32*s12**4 - 16*s12**3*s14*s34*S24**(-1) - 32*
     +    s12**3*s14 + 64*s12**3*s24**2*S14**(-1) + 144*s12**3*s24*s34*
     +    S14**(-1) + 96*s12**3*s24 + 16*s12**3*s34**3*S14**(-1)*
     +    S24**(-1) + 96*s12**3*s34**2*S14**(-1) + 64*s12**3*s34 - 8*
     +    s12**2*s14**2*s34*S24**(-1) - 16*s12**2*s14**2 + 112*s12**2*
     +    s14*s24 + 8*s12**2*s14*s34**2*S24**(-1) + 88*s12**2*s14*s34
     +     - 16*s12**2*s24**3*S14**(-1) - 48*s12**2*s24**2*s34*
     +    S14**(-1) - 32*s12**2*s24**2 - 48*s12**2*s24*s34**2*S14**(-1)
     +     + 64*s12**2*s24*s34 - 16*s12**2*s34**3*S14**(-1) + 16*s12**2
     +    *s34**3*S24**(-1) + 88*s12**2*s34**2 )

      LA = LA + Ld1(p1,p4,p23)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3*s14*S24**(-1) + 64*s12**3*s24*S14**(-1) + 48*s12**3*
     +    s34*S14**(-1) + 16*s12**3*s34*S24**(-1) + 48*s12**3 + 16*
     +    s12**2*s14**2*S24**(-1) - 16*s12**2*s23*s24*S14**(-1) - 16*
     +    s12**2*s23 - 32*s12**2*s24**2*S14**(-1) - 48*s12**2*s24*s34*
     +    S14**(-1) + 48*s12**2*s24 + 8*s12**2*s34**3*S14**(-1)*
     +    S24**(-1) - 8*s12**2*s34**2*S24**(-1) + 48*s12**2*s34 + 8*s12
     +    *s14**3*S24**(-1) - 8*s12*s14**2*s34*S24**(-1) - 40*s12*
     +    s14**2 - 8*s12*s14*s23*s34*S24**(-1) - 48*s12*s14*s23 - 16*
     +    s12*s14*s34**2*S24**(-1) - 40*s12*s14*s34 - 48*s12*s23*s24 - 
     +    8*s12*s23*s34**2*S24**(-1) - 96*s12*s24**2 - 120*s12*s24*s34
     +     - 24*s12*s34**2 + 24*s14*s23*s24 + 24*s14*s23*s34 )

      LA = LA + Ld1(p1,p4,p23)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**4*s34*S14**(-1)*S24**(-1) - 32*s12**4*S14**(-1) - 32*
     +    s12**3*s13*s34*S14**(-1)*S24**(-1) - 80*s12**3*s13*S14**(-1)
     +     + 16*s12**3*s24*S14**(-1) - 16*s12**3*s34**2*S14**(-1)*
     +    S24**(-1) - 16*s12**3*s34*S14**(-1) - 48*s12**3*s34*S24**(-1)
     +     - 112*s12**3 - 24*s12**2*s13**2*s34*S14**(-1)*S24**(-1) - 80
     +    *s12**2*s13**2*S14**(-1) + 16*s12**2*s13*s24*S14**(-1) - 24*
     +    s12**2*s13*s34**2*S14**(-1)*S24**(-1) - 40*s12**2*s13*s34*
     +    S14**(-1) - 56*s12**2*s13*s34*S24**(-1) - 152*s12**2*s13 - 40
     +    *s12**2*s14*s34*S24**(-1) - 88*s12**2*s14 - 16*s12**2*s24**2*
     +    S14**(-1) + 216*s12**2*s24 + 16*s12**2*s34**2*S14**(-1) - 16*
     +    s12**2*s34**2*S24**(-1) + 96*s12**2*s34 - 8*s12*s13**3*s34*
     +    S14**(-1)*S24**(-1) - 40*s12*s13**3*S14**(-1) - 24*s12*s13**2
     +    *s24*S14**(-1) - 8*s12*s13**2*s34**2*S14**(-1)*S24**(-1) - 48
     +    *s12*s13**2*s34*S14**(-1) - 24*s12*s13**2*s34*S24**(-1) - 96*
     +    s12*s13**2 - 24*s12*s13*s14*s34*S24**(-1) - 72*s12*s13*s14 - 
     +    48*s12*s13*s24**2*S14**(-1) )

      LA = LA + Ld1(p1,p4,p23)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    56*s12*s13*s24*s34*S14**(-1) + 168*s12*s13*s24 - 8*s12*s13*
     +    s34**2*S14**(-1) - 16*s12*s13*s34**2*S24**(-1) + 24*s12*s13*
     +    s34 - 8*s12*s14**2*s34*S24**(-1) - 16*s12*s14**2 + 144*s12*
     +    s14*s24 - 8*s12*s14*s34**2*S24**(-1) + 64*s12*s14*s34 + 144*
     +    s12*s24*s34 + 88*s12*s34**2 - 8*s13**4*S14**(-1) - 8*s13**3*
     +    s24*S14**(-1) - 8*s13**3*s34*S14**(-1) - 24*s13**3 - 24*
     +    s13**2*s14 - 8*s13**2*s24**2*S14**(-1) - 8*s13**2*s24*s34*
     +    S14**(-1) + 40*s13**2*s24 - 16*s13**2*s34 - 8*s13*s14**2 + 40
     +    *s13*s14*s24 - 8*s13*s14*s34 + 8*s13*s24**2 + 40*s13*s24*s34
     +     )

      LA = LA + Ld1(p1,p4,p23)*S23**(-1)*S234**(-2)*S134**(-1) * ( 8*
     +    s12**2*s13*s24 + 8*s12**2*s14*s24 - 8*s12**2*s24**2 + 16*s12*
     +    s13**2*s24 + 24*s12*s13*s14*s24 - 16*s12*s13*s24**2 + 8*s12*
     +    s14**2*s24 - 8*s12*s14*s24**2 + 8*s13**3*s24 + 16*s13**2*s14*
     +    s24 - 8*s13**2*s24**2 + 8*s13*s14**2*s24 - 8*s13*s14*s24**2 )

      LA = LA + Ld1(p1,p4,p23)*S234**(-1)*S134**(-1) * ( 32*s12**3*
     +    S14**(-1) + 16*s12**3*S24**(-1) - 16*s12**2*s13*s34*S14**(-1)
     +    *S24**(-1) + 48*s12**2*s13*S24**(-1) + 64*s12**2*s14*
     +    S24**(-1) - 16*s12**2*s23*S24**(-1) + 16*s12**2*s24*S14**(-1)
     +     - 8*s12**2*s34**2*S14**(-1)*S24**(-1) + 16*s12**2*s34*
     +    S24**(-1) + 40*s12**2 - 16*s12*s13**2*S14**(-1) + 40*s12*
     +    s13**2*S24**(-1) + 88*s12*s13*s14*S24**(-1) - 8*s12*s13*s23*
     +    s34*S14**(-1)*S24**(-1) + 8*s12*s13*s34*S14**(-1) + 24*s12*
     +    s13*s34*S24**(-1) + 16*s12*s13 + 56*s12*s14**2*S24**(-1) - 16
     +    *s12*s14*s23*S24**(-1) + 16*s12*s14*s34*S24**(-1) - 56*s12*
     +    s14 - 8*s12*s23*s34**2*S14**(-1)*S24**(-1) + 96*s12*s24 + 16*
     +    s12*s34**2*S14**(-1) - 16*s12*s34**2*S24**(-1) + 56*s12*s34
     +     + 8*s13**3*S24**(-1) + 24*s13**2*s14*S24**(-1) - 8*s13**2*
     +    s23*S14**(-1) + 8*s13**2*s34*S24**(-1) + 8*s13**2 + 24*s13*
     +    s14**2*S24**(-1) + 16*s13*s14*s34*S24**(-1) - 40*s13*s14 + 8*
     +    s13*s23**2*S24**(-1) - 8*s13*s23*s34*S14**(-1) - 8*s13*s23 - 
     +    8*s13*s24*s34*S14**(-1) )

      LA = LA + Ld1(p1,p4,p23)*S234**(-1)*S134**(-1) * ( 24*s13*s24 - 8
     +    *s13*s34 + 8*s14**3*S24**(-1) + 8*s14**2*s34*S24**(-1) - 40*
     +    s14**2 + 8*s14*s23**2*S24**(-1) + 16*s14*s23*s34*S24**(-1) - 
     +    16*s14*s23 - 8*s14*s24 - 40*s14*s34 + 8*s23**2*s34*S24**(-1)
     +     + 8*s23*s34 - 24*s24**2 - 24*s24*s34 )

      LA = LA + Ld1(p1,p4,p23)*S234**(-2)*S134**(-1) * (  - 16*s12**2*
     +    s13*s23*S24**(-1) + 8*s12**2*s13 - 16*s12**2*s14*s23*
     +    S24**(-1) + 8*s12**2*s14 + 16*s12**2*s23**2*S24**(-1) + 8*
     +    s12**2*s23 - 16*s12**2*s24 - 16*s12*s13**2*s23*S24**(-1) + 24
     +    *s12*s13**2 - 48*s12*s13*s14*s23*S24**(-1) + 24*s12*s13*s14
     +     + 16*s12*s13*s23**2*S24**(-1) - 8*s12*s13*s23 - 40*s12*s13*
     +    s24 - 32*s12*s14**2*s23*S24**(-1) + 32*s12*s14*s23**2*
     +    S24**(-1) + 32*s12*s14*s23 - 8*s12*s14*s24 + 16*s13**3 - 16*
     +    s13**2*s14*s23*S24**(-1) + 24*s13**2*s14 - 16*s13**2*s23 - 24
     +    *s13**2*s24 - 32*s13*s14**2*s23*S24**(-1) + 16*s13*s14*s23**2
     +    *S24**(-1) + 8*s13*s14*s23 - 16*s13*s14*s24 - 16*s14**3*s23*
     +    S24**(-1) - 8*s14**3 + 16*s14**2*s23**2*S24**(-1) + 24*s14**2
     +    *s23 + 8*s14**2*s24 )

      LA = LA + Ld1(p2,p3,p4)*S13**(-1)*S23**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12**3*s24 + 16*s12**3*s34 - 16*s12**2*s14*s24 - 16*
     +    s12**2*s24**2 - 16*s12**2*s24*s34 + 16*s12**2*s34**2 - 8*s12*
     +    s14**2*s24 - 16*s12*s14*s24*s34 - 8*s12*s24**3 - 16*s12*
     +    s24**2*s34 - 16*s12*s24*s34**2 )

      LA = LA + Ld1(p2,p3,p4)*S13**(-1)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 16*s12**2*s14*s23 + 16*s12**2*s14*s24 + 16*s12*s14**2*
     +    s23**2*S24**(-1) + 32*s12*s14**2*s23 + 16*s12*s14**2*s24 + 16
     +    *s12*s14*s23**2 + 32*s12*s14*s23*s24 + 16*s12*s14*s24**2 + 8*
     +    s14**3*s23 + 8*s14**3*s24 + 16*s14**2*s23**3*S24**(-1) + 32*
     +    s14**2*s23**2 + 16*s14**2*s23*s24 + 8*s14*s23**3 + 24*s14*
     +    s23**2*s24 + 24*s14*s23*s24**2 + 8*s14*s24**3 )

      LA = LA + Ld1(p2,p3,p4)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**3 - 16*s12**2*s14*s23*S24**(-1) - 24*s12**2*s14*s34*
     +    S24**(-1) - 48*s12**2*s14 - 16*s12**2*s23*s34*S24**(-1) - 16*
     +    s12**2*s23 - 32*s12**2*s24 - 24*s12**2*s34**2*S24**(-1) + 16*
     +    s12**2*s34 + 24*s12*s14**2*s23*S24**(-1) - 8*s12*s14**2*s34*
     +    S24**(-1) - 8*s12*s14**2 + 8*s12*s14*s23*s34*S24**(-1) - 48*
     +    s12*s14*s23 - 8*s12*s14*s34**2*S24**(-1) - 24*s12*s14*s34 - 
     +    16*s12*s23**2*s34*S24**(-1) - 8*s12*s23**2 - 24*s12*s23*s24
     +     - 16*s12*s23*s34**2*S24**(-1) - 24*s12*s24**2 - 24*s12*s24*
     +    s34 + 16*s12*s34**2 + 8*s14**3*s23*S24**(-1) + 16*s14**2*
     +    s23**2*S24**(-1) + 8*s14**2*s23*s34*S24**(-1) + 8*s14**2*s23
     +     + 16*s14**2*s24 + 16*s14*s23**3*S24**(-1) + 16*s14*s23**2*
     +    s34*S24**(-1) + 24*s14*s23*s24 - 16*s14*s23*s34 + 16*s14*
     +    s24**2 + 16*s14*s24*s34 )

      LA = LA + Ld1(p2,p3,p4)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**3*s24*S14**(-1) + 16*s12**3*s34*S14**(-1) - 8*s12**2*
     +    s13*s34*S14**(-1) - 16*s12**2*s24**2*S14**(-1) - 16*s12**2*
     +    s24 + 8*s12**2*s34**2*S14**(-1) - 8*s12**2*s34 - 2*s12*s13**2
     +    *s24*S14**(-1) + 16*s12*s13*s24**2*S14**(-1) + 8*s12*s13*s24*
     +    s34*S14**(-1) - 18*s12*s13*s24 - 24*s12*s14*s24 - 8*s12*
     +    s24**3*S14**(-1) + 16*s12*s24**2 + 8*s12*s24*s34**2*S14**(-1)
     +     - 8*s12*s24*s34 )

      LA = LA + Ld1(p2,p3,p4)*S34**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**2*s23 + 16*s12**2*s24 + 32*s12*s13*s23 + 32*s12*s13*s24
     +     + 16*s12*s14*s23**2*S24**(-1) + 64*s12*s14*s23 + 48*s12*s14*
     +    s24 + 16*s12*s23**2 + 32*s12*s23*s24 + 16*s12*s24**2 + 10*
     +    s13**2*s23 + 10*s13**2*s24 + 16*s13*s14*s23**2*S24**(-1) + 42
     +    *s13*s14*s23 + 26*s13*s14*s24 + 16*s13*s23**2 + 32*s13*s23*
     +    s24 + 16*s13*s24**2 + 16*s14**2*s23**2*S24**(-1) + 40*s14**2*
     +    s23 + 24*s14**2*s24 + 16*s14*s23**3*S24**(-1) + 48*s14*s23**2
     +     + 48*s14*s23*s24 + 16*s14*s24**2 + 8*s23**3 + 24*s23**2*s24
     +     + 24*s23*s24**2 + 8*s24**3 )

      LA = LA + Ld1(p2,p3,p4)*S234**(-1)*S134**(-1) * (  - 16*s12**3*
     +    S14**(-1) - 16*s12**2*s23*S14**(-1) - 16*s12**2*s23*S24**(-1)
     +     - 32*s12**2*s24*S14**(-1) - 16*s12**2*s34*S14**(-1) - 24*
     +    s12**2*s34*S24**(-1) - 48*s12**2 - 2*s12*s13**2*S14**(-1) + 
     +    16*s12*s13*s23*S14**(-1) + 32*s12*s13*s24*S14**(-1) + 16*s12*
     +    s13*s34*S24**(-1) - 26*s12*s13 + 24*s12*s14*s23*S24**(-1) + 8
     +    *s12*s14*s34*S24**(-1) - 32*s12*s14 - 8*s12*s23**2*S14**(-1)
     +     - 16*s12*s23**2*S24**(-1) - 24*s12*s23*s24*S14**(-1) - 16*
     +    s12*s23*s34*S14**(-1) - 16*s12*s23*s34*S24**(-1) - 24*s12*
     +    s24**2*S14**(-1) - 24*s12*s24*s34*S14**(-1) + 16*s12*s24 - 16
     +    *s12*s34**2*S14**(-1) + 16*s12*s34**2*S24**(-1) - 32*s12*s34
     +     + 32*s13*s23 + 8*s13*s24 + 8*s14**2*s23*S24**(-1) + 32*s14*
     +    s23**2*S24**(-1) + 24*s14*s23 + 40*s14*s24 + 16*s23**2 + 24*
     +    s23*s24 + 16*s23*s34 - 8*s24*s34 )

      LA = LA + Ld1(p2,p3,p14)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12**4*s34**2*S14**(-1)*S24**(-1) - 16*
     +    s12**4*s34*S14**(-1) - 32*s12**3*s24*s34*S14**(-1) + 16*
     +    s12**3*s34**3*S14**(-1)*S24**(-1) - 16*s12**3*s34**2*
     +    S14**(-1) - 24*s12**2*s24**2*s34*S14**(-1) - 24*s12**2*s24*
     +    s34**2*S14**(-1) - 16*s12**2*s24*s34 + 8*s12**2*s34**3*
     +    S24**(-1) - 8*s12**2*s34**2 - 8*s12*s14*s24*s34 - 8*s12*s14*
     +    s34**2 - 8*s12*s24**3*s34*S14**(-1) - 8*s12*s24**2*s34**2*
     +    S14**(-1) )

      LA = LA + Ld1(p2,p3,p14)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**4*s34*S14**(-1)*S24**(-1) - 16*s12**3*s23*s34*
     +    S14**(-1)*S24**(-1) + 16*s12**3*s23*S24**(-1) - 48*s12**3*s34
     +    *S14**(-1) + 16*s12**3*s34*S24**(-1) + 16*s12**3 - 16*s12**2*
     +    s14 - 8*s12**2*s23**2*s34*S14**(-1)*S24**(-1) + 16*s12**2*
     +    s23**2*S24**(-1) + 8*s12**2*s23*s34**2*S14**(-1)*S24**(-1) - 
     +    40*s12**2*s23*s34*S14**(-1) + 64*s12**2*s23 - 56*s12**2*s24*
     +    s34*S14**(-1) + 48*s12**2*s24 + 16*s12**2*s34**3*S14**(-1)*
     +    S24**(-1) - 16*s12**2*s34**2*S14**(-1) - 8*s12**2*s34**2*
     +    S24**(-1) + 16*s12**2*s34 - 8*s12*s14*s23*s34*S24**(-1) - 16*
     +    s12*s14*s23 - 8*s12*s14*s34**2*S24**(-1) + 8*s12*s23**3*
     +    S24**(-1) - 8*s12*s23**2*s34*S14**(-1) - 8*s12*s23**2*s34*
     +    S24**(-1) + 56*s12*s23**2 - 24*s12*s23*s24*s34*S14**(-1) + 88
     +    *s12*s23*s24 - 8*s12*s23*s34**2*S14**(-1) - 16*s12*s23*s34**2
     +    *S24**(-1) + 16*s12*s23*s34 - 24*s12*s24**2*s34*S14**(-1) + 
     +    40*s12*s24**2 - 16*s12*s24*s34**2*S14**(-1) + 24*s12*s24*s34
     +     - 16*s12*s34**2 )

      LA = LA + Ld1(p2,p3,p14)*S13**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s14**2*s23 + 8*s14**2*s24 + 8*s14**2*s34 + 16*s14*s23*s34 + 8
     +    *s23**3 + 24*s23**2*s24 + 8*s23**2*s34 + 24*s23*s24**2 + 16*
     +    s23*s24*s34 + 8*s24**3 + 8*s24**2*s34 )

      LA = LA + Ld1(p2,p3,p14)*S13**(-1)*S234**(-1)*S134**(-2) * ( 16*
     +    s12**2*s14**2 - 16*s12**2*s14*s23 - 16*s12**2*s14*s24 + 32*
     +    s12*s14**2*s23 + 16*s12*s14**2*s24 - 32*s12*s14*s23**2 - 48*
     +    s12*s14*s23*s24 - 16*s12*s14*s24**2 + 16*s14**2*s23**2 + 16*
     +    s14**2*s23*s24 - 16*s14*s23**3 - 32*s14*s23**2*s24 - 16*s14*
     +    s23*s24**2 )

      LA = LA + Ld1(p2,p3,p14)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    32*s12**4*s13*S14**(-1)*S24**(-1) - 48*s12**4*s34*S14**(-1)*
     +    S24**(-1) - 32*s12**4*S14**(-1) + 64*s12**3*s13**2*S14**(-1)*
     +    S24**(-1) + 144*s12**3*s13*s34*S14**(-1)*S24**(-1) + 16*
     +    s12**3*s13*S14**(-1) + 64*s12**3*s13*S24**(-1) - 80*s12**3*
     +    s24*S14**(-1) + 96*s12**3*s34**2*S14**(-1)*S24**(-1) - 16*
     +    s12**3*s34*S14**(-1) + 48*s12**3*s34*S24**(-1) + 32*s12**3 - 
     +    16*s12**2*s13**3*S14**(-1)*S24**(-1) - 48*s12**2*s13**2*s34*
     +    S14**(-1)*S24**(-1) - 16*s12**2*s13**2*S14**(-1) - 32*s12**2*
     +    s13**2*S24**(-1) - 16*s12**2*s13*s14*S24**(-1) + 16*s12**2*
     +    s13*s24*S14**(-1) - 48*s12**2*s13*s34**2*S14**(-1)*S24**(-1)
     +     - 48*s12**2*s13*s34*S24**(-1) + 16*s12**2*s13 - 80*s12**2*
     +    s24**2*S14**(-1) - 40*s12**2*s24*s34*S14**(-1) - 16*s12**2*
     +    s34**3*S14**(-1)*S24**(-1) + 16*s12**2*s34**2*S14**(-1) - 48*
     +    s12*s13**2*s24*S14**(-1) - 24*s12*s13*s24**2*S14**(-1) - 56*
     +    s12*s13*s24*s34*S14**(-1) - 40*s12*s24**3*S14**(-1) - 48*s12*
     +    s24**2*s34*S14**(-1) )

      LA = LA + Ld1(p2,p3,p14)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12*s24**2 - 8*s12*s24*s34**2*S14**(-1) + 8*s12*s24*s34 + 
     +    16*s12*s34**2 - 8*s13**2*s24**2*S14**(-1) - 8*s13*s24**3*
     +    S14**(-1) - 8*s13*s24**2*s34*S14**(-1) - 8*s13*s24*s34 - 8*
     +    s14*s24**2 - 8*s14*s24*s34 - 8*s24**4*S14**(-1) - 8*s24**3*
     +    s34*S14**(-1) )

      LA = LA + Ld1(p2,p3,p14)*S234**(-1)*S134**(-1) * (  - 32*s12**4*
     +    S14**(-1)*S24**(-1) + 96*s12**3*s13*S14**(-1)*S24**(-1) - 32*
     +    s12**3*s23*S14**(-1)*S24**(-1) + 64*s12**3*s34*S14**(-1)*
     +    S24**(-1) - 112*s12**3*S14**(-1) + 48*s12**3*S24**(-1) - 32*
     +    s12**2*s13**2*S14**(-1)*S24**(-1) + 112*s12**2*s13*s23*
     +    S14**(-1)*S24**(-1) + 64*s12**2*s13*s34*S14**(-1)*S24**(-1)
     +     + 216*s12**2*s13*S14**(-1) + 48*s12**2*s13*S24**(-1) - 16*
     +    s12**2*s14*S24**(-1) - 16*s12**2*s23**2*S14**(-1)*S24**(-1)
     +     + 88*s12**2*s23*s34*S14**(-1)*S24**(-1) - 88*s12**2*s23*
     +    S14**(-1) - 152*s12**2*s24*S14**(-1) + 88*s12**2*s34**2*
     +    S14**(-1)*S24**(-1) + 96*s12**2*s34*S14**(-1) + 48*s12**2*s34
     +    *S24**(-1) + 40*s12**2 - 96*s12*s13**2*S24**(-1) - 48*s12*s13
     +    *s14*S24**(-1) + 144*s12*s13*s23*S14**(-1) + 168*s12*s13*s24*
     +    S14**(-1) + 144*s12*s13*s34*S14**(-1) - 120*s12*s13*s34*
     +    S24**(-1) + 96*s12*s13 - 48*s12*s14*s23*S24**(-1) - 16*s12*
     +    s23**2*S14**(-1) - 40*s12*s23**2*S24**(-1) - 72*s12*s23*s24*
     +    S14**(-1) )

      LA = LA + Ld1(p2,p3,p14)*S234**(-1)*S134**(-1) * ( 64*s12*s23*s34
     +    *S14**(-1) - 40*s12*s23*s34*S24**(-1) - 56*s12*s23 - 96*s12*
     +    s24**2*S14**(-1) + 24*s12*s24*s34*S14**(-1) + 16*s12*s24 + 88
     +    *s12*s34**2*S14**(-1) - 24*s12*s34**2*S24**(-1) + 56*s12*s34
     +     + 8*s13**2*s24*S14**(-1) - 24*s13**2 + 24*s13*s14*s23*
     +    S24**(-1) + 40*s13*s23*s24*S14**(-1) - 8*s13*s23 + 40*s13*
     +    s24**2*S14**(-1) + 40*s13*s24*s34*S14**(-1) + 24*s13*s24 - 24
     +    *s13*s34 + 24*s14*s23*s34*S24**(-1) - 16*s14*s23 - 8*s14*s24
     +     + 8*s14*s34 - 8*s23**2*s24*S14**(-1) - 40*s23**2 - 24*s23*
     +    s24**2*S14**(-1) - 8*s23*s24*s34*S14**(-1) - 40*s23*s24 - 40*
     +    s23*s34 - 24*s24**3*S14**(-1) - 16*s24**2*s34*S14**(-1) + 8*
     +    s24**2 - 8*s24*s34 )

      LA = LA + Ld1(p2,p3,p14)*S234**(-1)*S134**(-2) * (  - 8*s12**2*
     +    s13**2*S14**(-1) + 8*s12**2*s13*s23*S14**(-1) + 8*s12**2*s13*
     +    s24*S14**(-1) - 16*s12**2*s13 + 8*s12**2*s14 + 8*s12**2*s23
     +     + 8*s12**2*s24 - 8*s12*s13**2*s23*S14**(-1) - 16*s12*s13**2*
     +    s24*S14**(-1) + 8*s12*s13*s23**2*S14**(-1) + 24*s12*s13*s23*
     +    s24*S14**(-1) - 8*s12*s13*s23 + 16*s12*s13*s24**2*S14**(-1)
     +     - 40*s12*s13*s24 + 32*s12*s14*s23 - 8*s12*s14*s24 + 24*s12*
     +    s23*s24 + 24*s12*s24**2 - 8*s13**2*s23*s24*S14**(-1) - 8*
     +    s13**2*s24**2*S14**(-1) + 8*s13*s23**2*s24*S14**(-1) + 8*s13*
     +    s23**2 + 16*s13*s23*s24**2*S14**(-1) - 16*s13*s23*s24 + 8*s13
     +    *s24**3*S14**(-1) - 24*s13*s24**2 + 24*s14*s23**2 + 8*s14*s23
     +    *s24 - 16*s14*s24**2 - 8*s23**3 + 24*s23*s24**2 + 16*s24**3 )

      LA = LA + Ld1(p2,p4,p3)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**3*s23*S24**(-1) + 16*s12**3*s34*S24**(-1) - 16*s12**3
     +     - 8*s12**2*s14*s34*S24**(-1) - 16*s12**2*s23**2*S24**(-1) - 
     +    32*s12**2*s23 - 16*s12**2*s24 + 8*s12**2*s34**2*S24**(-1) - 
     +    16*s12**2*s34 - 2*s12*s14**2*s23*S24**(-1) - 2*s12*s14**2 + 
     +    16*s12*s14*s23**2*S24**(-1) + 8*s12*s14*s23*s34*S24**(-1) + 
     +    32*s12*s14*s23 + 16*s12*s14*s24 - 8*s12*s23**3*S24**(-1) - 24
     +    *s12*s23**2 - 24*s12*s23*s24 + 8*s12*s23*s34**2*S24**(-1) - 
     +    24*s12*s23*s34 - 8*s12*s24**2 - 16*s12*s24*s34 - 16*s12*
     +    s34**2 )

      LA = LA + Ld1(p2,p4,p3)*S23**(-1)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 16*s12*s13**2*s24**2*S14**(-1) + 16*s12*s13*s24**2 + 16*
     +    s13**2*s24**3*S14**(-1) + 16*s13**2*s24**2 + 16*s13*s14*
     +    s24**2 + 16*s13*s24**3 )

      LA = LA + Ld1(p2,p4,p3)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**2*s13*s24*S14**(-1) - 24*s12**2*s13*s34*S14**(-1) - 16*
     +    s12**2*s24*s34*S14**(-1) - 16*s12**2*s24 - 24*s12**2*s34**2*
     +    S14**(-1) - 24*s12**2*s34 + 24*s12*s13**2*s24*S14**(-1) - 8*
     +    s12*s13**2*s34*S14**(-1) + 8*s12*s13*s24*s34*S14**(-1) + 24*
     +    s12*s13*s24 - 8*s12*s13*s34**2*S14**(-1) + 8*s12*s13*s34 + 16
     +    *s12*s14*s34 - 16*s12*s24**2*s34*S14**(-1) - 16*s12*s24**2 - 
     +    16*s12*s24*s34**2*S14**(-1) - 16*s12*s24*s34 + 16*s12*s34**2
     +     + 8*s13**3*s24*S14**(-1) + 16*s13**2*s24**2*S14**(-1) + 8*
     +    s13**2*s24*s34*S14**(-1) + 8*s13**2*s24 + 16*s13*s24**3*
     +    S14**(-1) + 16*s13*s24**2*s34*S14**(-1) + 32*s13*s24**2 )

      LA = LA + Ld1(p2,p4,p3)*S34**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**2*s13*s23*S14**(-1) + 16*s12**2*s13*s24*S14**(-1) + 16*
     +    s12**2*s23 + 16*s12**2*s24 + 16*s12*s13**2*s23*S14**(-1) + 32
     +    *s12*s13**2*s24*S14**(-1) + 16*s12*s13*s23**2*S14**(-1) + 32*
     +    s12*s13*s23*s24*S14**(-1) + 48*s12*s13*s23 + 16*s12*s13*
     +    s24**2*S14**(-1) + 64*s12*s13*s24 + 32*s12*s14*s23 + 32*s12*
     +    s14*s24 + 16*s12*s23**2 + 32*s12*s23*s24 + 16*s12*s24**2 + 8*
     +    s13**3*s23*S14**(-1) + 8*s13**3*s24*S14**(-1) + 16*s13**2*s23
     +    *s24*S14**(-1) + 24*s13**2*s23 + 32*s13**2*s24**2*S14**(-1)
     +     + 40*s13**2*s24 + 26*s13*s14*s23 + 42*s13*s14*s24 + 8*s13*
     +    s23**3*S14**(-1) + 24*s13*s23**2*s24*S14**(-1) + 16*s13*
     +    s23**2 + 24*s13*s23*s24**2*S14**(-1) + 48*s13*s23*s24 + 8*s13
     +    *s24**3*S14**(-1) + 48*s13*s24**2 + 10*s14**2*s23 + 10*s14**2
     +    *s24 + 16*s14*s23**2 + 32*s14*s23*s24 + 16*s14*s24**2 + 8*
     +    s23**3 + 24*s23**2*s24 + 24*s23*s24**2 + 8*s24**3 )

      LA = LA + Ld1(p2,p4,p3)*S234**(-1)*S134**(-1) * (  - 16*s12**3*
     +    s23*S14**(-1)*S24**(-1) + 16*s12**3*s34*S14**(-1)*S24**(-1)
     +     - 16*s12**3*S14**(-1) - 16*s12**2*s13*s23*S14**(-1)*
     +    S24**(-1) - 48*s12**2*s13*S14**(-1) - 16*s12**2*s23**2*
     +    S14**(-1)*S24**(-1) - 16*s12**2*s23*s34*S14**(-1)*S24**(-1)
     +     - 32*s12**2*s23*S14**(-1) - 16*s12**2*s23*S24**(-1) - 16*
     +    s12**2*s24*S14**(-1) + 16*s12**2*s34**2*S14**(-1)*S24**(-1)
     +     + 16*s12**2*s34*S14**(-1) - 8*s12**2*s34*S24**(-1) - 48*
     +    s12**2 - 8*s12*s13**2*s23*S14**(-1)*S24**(-1) - 8*s12*s13**2*
     +    S14**(-1) - 16*s12*s13*s23*s34*S14**(-1)*S24**(-1) - 24*s12*
     +    s13*s23*S24**(-1) - 48*s12*s13*s24*S14**(-1) - 24*s12*s13*s34
     +    *S14**(-1) - 32*s12*s13 - 18*s12*s14*s23*S24**(-1) - 26*s12*
     +    s14 - 8*s12*s23**3*S14**(-1)*S24**(-1) - 16*s12*s23**2*s34*
     +    S14**(-1)*S24**(-1) - 24*s12*s23**2*S14**(-1) + 16*s12*s23**2
     +    *S24**(-1) - 24*s12*s23*s24*S14**(-1) - 16*s12*s23*s34**2*
     +    S14**(-1)*S24**(-1) - 24*s12*s23*s34*S14**(-1) - 8*s12*s23*
     +    s34*S24**(-1) )

      LA = LA + Ld1(p2,p4,p3)*S234**(-1)*S134**(-1) * ( 16*s12*s23 - 8*
     +    s12*s24**2*S14**(-1) + 16*s12*s34**2*S14**(-1) - 32*s12*s34
     +     + 16*s13**2*s23*S14**(-1) + 8*s13**2*s24*S14**(-1) + 16*s13*
     +    s23**2*S14**(-1) + 24*s13*s23*s24*S14**(-1) + 16*s13*s23*s34*
     +    S14**(-1) + 40*s13*s23 - 16*s13*s24*s34*S14**(-1) + 24*s13*
     +    s24 + 8*s14*s23 + 32*s14*s24 + 24*s23*s24 - 8*s23*s34 + 16*
     +    s24**2 + 16*s24*s34 )

      LA = LA + Ld1(p2,p4,p13)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**4*s14*S24**(-1) - 16*s12**4*s34**2*
     +    S14**(-1)*S24**(-1) - 16*s12**4*s34*S14**(-1) - 48*s12**4*s34
     +    *S24**(-1) - 32*s12**4 + 64*s12**3*s14**2*S24**(-1) + 144*
     +    s12**3*s14*s34*S24**(-1) + 96*s12**3*s14 - 16*s12**3*s24*s34*
     +    S14**(-1) - 32*s12**3*s24 + 16*s12**3*s34**3*S14**(-1)*
     +    S24**(-1) + 96*s12**3*s34**2*S24**(-1) + 64*s12**3*s34 - 16*
     +    s12**2*s14**3*S24**(-1) - 48*s12**2*s14**2*s34*S24**(-1) - 32
     +    *s12**2*s14**2 + 112*s12**2*s14*s24 - 48*s12**2*s14*s34**2*
     +    S24**(-1) + 64*s12**2*s14*s34 - 8*s12**2*s24**2*s34*S14**(-1)
     +     - 16*s12**2*s24**2 + 8*s12**2*s24*s34**2*S14**(-1) + 88*
     +    s12**2*s24*s34 + 16*s12**2*s34**3*S14**(-1) - 16*s12**2*
     +    s34**3*S24**(-1) + 88*s12**2*s34**2 )

      LA = LA + Ld1(p2,p4,p13)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**4*s34*S14**(-1)*S24**(-1) - 32*s12**4*S24**(-1) + 16*
     +    s12**3*s14*S24**(-1) - 32*s12**3*s23*s34*S14**(-1)*S24**(-1)
     +     - 80*s12**3*s23*S24**(-1) - 16*s12**3*s34**2*S14**(-1)*
     +    S24**(-1) - 48*s12**3*s34*S14**(-1) - 16*s12**3*s34*S24**(-1)
     +     - 112*s12**3 - 16*s12**2*s14**2*S24**(-1) + 16*s12**2*s14*
     +    s23*S24**(-1) + 216*s12**2*s14 - 24*s12**2*s23**2*s34*
     +    S14**(-1)*S24**(-1) - 80*s12**2*s23**2*S24**(-1) - 24*s12**2*
     +    s23*s34**2*S14**(-1)*S24**(-1) - 56*s12**2*s23*s34*S14**(-1)
     +     - 40*s12**2*s23*s34*S24**(-1) - 152*s12**2*s23 - 40*s12**2*
     +    s24*s34*S14**(-1) - 88*s12**2*s24 - 16*s12**2*s34**2*
     +    S14**(-1) + 16*s12**2*s34**2*S24**(-1) + 96*s12**2*s34 - 48*
     +    s12*s14**2*s23*S24**(-1) - 24*s12*s14*s23**2*S24**(-1) - 56*
     +    s12*s14*s23*s34*S24**(-1) + 168*s12*s14*s23 + 144*s12*s14*s24
     +     + 144*s12*s14*s34 - 8*s12*s23**3*s34*S14**(-1)*S24**(-1) - 
     +    40*s12*s23**3*S24**(-1) - 8*s12*s23**2*s34**2*S14**(-1)*
     +    S24**(-1) )

      LA = LA + Ld1(p2,p4,p13)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    24*s12*s23**2*s34*S14**(-1) - 48*s12*s23**2*s34*S24**(-1) - 
     +    96*s12*s23**2 - 24*s12*s23*s24*s34*S14**(-1) - 72*s12*s23*s24
     +     - 16*s12*s23*s34**2*S14**(-1) - 8*s12*s23*s34**2*S24**(-1)
     +     + 24*s12*s23*s34 - 8*s12*s24**2*s34*S14**(-1) - 16*s12*
     +    s24**2 - 8*s12*s24*s34**2*S14**(-1) + 64*s12*s24*s34 + 88*s12
     +    *s34**2 - 8*s14**2*s23**2*S24**(-1) + 8*s14**2*s23 - 8*s14*
     +    s23**3*S24**(-1) - 8*s14*s23**2*s34*S24**(-1) + 40*s14*s23**2
     +     + 40*s14*s23*s24 + 40*s14*s23*s34 - 8*s23**4*S24**(-1) - 8*
     +    s23**3*s34*S24**(-1) - 24*s23**3 - 24*s23**2*s24 - 16*s23**2*
     +    s34 - 8*s23*s24**2 - 8*s23*s24*s34 )

      LA = LA + Ld1(p2,p4,p13)*S13**(-1)*S234**(-1)*S134**(-2) * (  - 8
     +    *s12**2*s14**2 + 8*s12**2*s14*s23 + 8*s12**2*s14*s24 - 16*s12
     +    *s14**2*s23 - 8*s12*s14**2*s24 + 16*s12*s14*s23**2 + 24*s12*
     +    s14*s23*s24 + 8*s12*s14*s24**2 - 8*s14**2*s23**2 - 8*s14**2*
     +    s23*s24 + 8*s14*s23**3 + 16*s14*s23**2*s24 + 8*s14*s23*s24**2
     +     )

      LA = LA + Ld1(p2,p4,p13)*S23**(-1)*S234**(-1)*S134**(-1) * ( 64*
     +    s12**3*s14*S24**(-1) + 16*s12**3*s24*S14**(-1) + 16*s12**3*
     +    s34*S14**(-1) + 48*s12**3*s34*S24**(-1) + 48*s12**3 - 16*
     +    s12**2*s13*s14*S24**(-1) - 16*s12**2*s13 - 32*s12**2*s14**2*
     +    S24**(-1) - 48*s12**2*s14*s34*S24**(-1) + 48*s12**2*s14 + 16*
     +    s12**2*s24**2*S14**(-1) + 8*s12**2*s34**3*S14**(-1)*S24**(-1)
     +     - 8*s12**2*s34**2*S14**(-1) + 48*s12**2*s34 - 48*s12*s13*s14
     +     - 8*s12*s13*s24*s34*S14**(-1) - 48*s12*s13*s24 - 8*s12*s13*
     +    s34**2*S14**(-1) - 96*s12*s14**2 - 120*s12*s14*s34 + 8*s12*
     +    s24**3*S14**(-1) - 8*s12*s24**2*s34*S14**(-1) - 40*s12*s24**2
     +     - 16*s12*s24*s34**2*S14**(-1) - 40*s12*s24*s34 - 24*s12*
     +    s34**2 + 24*s13*s14*s24 + 24*s13*s24*s34 )

      LA = LA + Ld1(p2,p4,p13)*S234**(-1)*S134**(-1) * ( 16*s12**3*
     +    S14**(-1) + 32*s12**3*S24**(-1) - 16*s12**2*s13*S14**(-1) + 
     +    16*s12**2*s14*S24**(-1) - 16*s12**2*s23*s34*S14**(-1)*
     +    S24**(-1) + 48*s12**2*s23*S14**(-1) + 64*s12**2*s24*S14**(-1)
     +     - 8*s12**2*s34**2*S14**(-1)*S24**(-1) + 16*s12**2*s34*
     +    S14**(-1) + 40*s12**2 - 8*s12*s13*s23*s34*S14**(-1)*S24**(-1)
     +     - 16*s12*s13*s24*S14**(-1) - 8*s12*s13*s34**2*S14**(-1)*
     +    S24**(-1) + 96*s12*s14 + 40*s12*s23**2*S14**(-1) - 16*s12*
     +    s23**2*S24**(-1) + 88*s12*s23*s24*S14**(-1) + 24*s12*s23*s34*
     +    S14**(-1) + 8*s12*s23*s34*S24**(-1) + 16*s12*s23 + 56*s12*
     +    s24**2*S14**(-1) + 16*s12*s24*s34*S14**(-1) - 56*s12*s24 - 16
     +    *s12*s34**2*S14**(-1) + 16*s12*s34**2*S24**(-1) + 56*s12*s34
     +     + 8*s13**2*s23*S14**(-1) + 8*s13**2*s24*S14**(-1) + 8*s13**2
     +    *s34*S14**(-1) - 8*s13*s23**2*S24**(-1) - 8*s13*s23*s34*
     +    S24**(-1) - 8*s13*s23 + 16*s13*s24*s34*S14**(-1) - 16*s13*s24
     +     + 8*s13*s34 - 24*s14**2 - 8*s14*s23*s34*S24**(-1) + 24*s14*
     +    s23 )

      LA = LA + Ld1(p2,p4,p13)*S234**(-1)*S134**(-1) * (  - 8*s14*s24
     +     - 24*s14*s34 + 8*s23**3*S14**(-1) + 24*s23**2*s24*S14**(-1)
     +     + 8*s23**2*s34*S14**(-1) + 8*s23**2 + 24*s23*s24**2*
     +    S14**(-1) + 16*s23*s24*s34*S14**(-1) - 40*s23*s24 - 8*s23*s34
     +     + 8*s24**3*S14**(-1) + 8*s24**2*s34*S14**(-1) - 40*s24**2 - 
     +    40*s24*s34 )

      LA = LA + Ld1(p2,p4,p13)*S234**(-1)*S134**(-2) * ( 16*s12**2*
     +    s13**2*S14**(-1) - 16*s12**2*s13*s23*S14**(-1) - 16*s12**2*
     +    s13*s24*S14**(-1) + 8*s12**2*s13 - 16*s12**2*s14 + 8*s12**2*
     +    s23 + 8*s12**2*s24 + 16*s12*s13**2*s23*S14**(-1) + 32*s12*
     +    s13**2*s24*S14**(-1) - 16*s12*s13*s23**2*S14**(-1) - 48*s12*
     +    s13*s23*s24*S14**(-1) - 8*s12*s13*s23 - 32*s12*s13*s24**2*
     +    S14**(-1) + 32*s12*s13*s24 - 40*s12*s14*s23 - 8*s12*s14*s24
     +     + 24*s12*s23**2 + 24*s12*s23*s24 + 16*s13**2*s23*s24*
     +    S14**(-1) + 16*s13**2*s24**2*S14**(-1) - 16*s13*s23**2*s24*
     +    S14**(-1) - 16*s13*s23**2 - 32*s13*s23*s24**2*S14**(-1) + 8*
     +    s13*s23*s24 - 16*s13*s24**3*S14**(-1) + 24*s13*s24**2 - 24*
     +    s14*s23**2 - 16*s14*s23*s24 + 8*s14*s24**2 + 16*s23**3 + 24*
     +    s23**2*s24 - 8*s24**3 )

      LA = LA + Ld21(p1,p3,p4)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s12**3*s14 - 8*s12**3*s34 + 16*s12**2*s14**2
     +     + 16*s12**2*s14*s34 )

      LA = LA + Ld21(p1,p3,p4)*S13**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 6*s12*s14**2*s23**2*S24**(-1) + 6*s12*s14**2*s23
     +     )

      LA = LA + Ld21(p1,p3,p4)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3*s14*S24**(-1) - 8*s12**3*s34*S24**(-1) + 16*s12**2*
     +    s14**2*S24**(-1) - 8*s12**2*s14*s23*S24**(-1) + 8*s12**2*s14*
     +    s34*S24**(-1) - 8*s12**2*s14 )

      LA = LA + Ld21(p1,p3,p4)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s13*s24 - 32*s12**2*s14*s24 - 16*s12
     +    *s13**2*s24**2*S14**(-1) - 32*s12*s13**2*s24 - 64*s12*s13*s14
     +    *s24 - 16*s12*s13*s24**2 - 32*s12*s14**2*s24 )

      LA = LA + Ld21(p1,p3,p4)*S23**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3 + 8*s12**2*s13*s24*S14**(-1) + 8*s12**2*s13*s34*
     +    S14**(-1) + 16*s12**2*s13 + 32*s12**2*s14 + 8*s12**2*s24*s34*
     +    S14**(-1) + 24*s12**2*s24 + 8*s12**2*s34**2*S14**(-1) - 16*
     +    s12*s13**2*s24*S14**(-1) - 16*s12*s13*s24**2*S14**(-1) - 16*
     +    s12*s13*s24*s34*S14**(-1) - 32*s12*s14*s24 )

      LA = LA + Ld21(p1,p3,p4)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    32*s12**2*s13 - 32*s12**2*s14 - 16*s12*s13**2*s24*S14**(-1)
     +     - 32*s12*s13**2 - 64*s12*s13*s14 - 20*s12*s13*s23 - 36*s12*
     +    s13*s24 - 32*s12*s14**2 + 6*s12*s14*s23**2*S24**(-1) - 14*s12
     +    *s14*s23 - 20*s12*s14*s24 )

      LA = LA + Ld21(p1,p3,p4)*S234**(-1)*S134**(-1) * ( 16*s12**3*
     +    S24**(-1) + 8*s12**2*s13*S14**(-1) + 16*s12**2*s13*S24**(-1)
     +     + 32*s12**2*s14*S24**(-1) - 8*s12**2*s23*S24**(-1) + 8*
     +    s12**2*s34*S14**(-1) + 16*s12**2*s34*S24**(-1) + 16*s12**2 - 
     +    16*s12*s13*s24*S14**(-1) - 32*s12*s13 - 16*s12*s14 )

      LA = LA + Ld21(p1,p3,p24)*S13**(-1)*S234**(-1)*S134**(-1) * ( 24*
     +    s12**2*s23**3*S14**(-1)*S24**(-1) + 48*s12**2*s23**2*s34*
     +    S14**(-1)*S24**(-1) + 48*s12**2*s23**2*S14**(-1) + 24*s12**2*
     +    s23**2*S24**(-1) + 24*s12**2*s23*s24*S14**(-1) + 24*s12**2*
     +    s23*s34**2*S14**(-1)*S24**(-1) + 72*s12**2*s23*s34*S14**(-1)
     +     + 24*s12**2*s23*s34*S24**(-1) + 48*s12**2*s23 + 24*s12**2*
     +    s24*s34*S14**(-1) + 24*s12**2*s24 + 24*s12**2*s34**2*
     +    S14**(-1) + 24*s12**2*s34 + 24*s12*s14*s23**2*S24**(-1) + 24*
     +    s12*s14*s23*s34*S24**(-1) + 48*s12*s14*s23 + 24*s12*s14*s24
     +     + 24*s12*s14*s34 + 24*s12*s23**3*S24**(-1) + 48*s12*s23**2*
     +    s34*S24**(-1) + 48*s12*s23**2 + 24*s12*s23*s24 + 24*s12*s23*
     +    s34**2*S24**(-1) + 72*s12*s23*s34 + 24*s12*s24*s34 + 24*s12*
     +    s34**2 )

      LA = LA + Ld21(p1,p3,p24)*S23**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**2*s13*s24*S14**(-1) + 16*s12**2*s24*s34*S14**(-1) + 16*
     +    s12**2*s24 + 16*s12*s13**2*s24*S14**(-1) + 8*s12*s13*s24*s34*
     +    S14**(-1) + 32*s12*s13*s24 + 16*s12*s14*s24 - 8*s12*s24*
     +    s34**2*S14**(-1) + 8*s12*s24*s34 + 16*s13**2*s24 + 16*s13*s14
     +    *s24 + 8*s13*s24**2 + 16*s13*s24*s34 + 8*s14*s24**2 + 8*
     +    s24**2*s34 )

      LA = LA + Ld21(p1,p3,p24)*S234**(-1)*S134**(-1) * ( 16*s12**2*s13
     +    *s23*S14**(-1)*S24**(-1) + 32*s12**2*s13*S14**(-1) + 40*
     +    s12**2*s23**2*S14**(-1)*S24**(-1) + 40*s12**2*s23*s34*
     +    S14**(-1)*S24**(-1) + 80*s12**2*s23*S14**(-1) + 16*s12**2*s23
     +    *S24**(-1) + 40*s12**2*s24*S14**(-1) + 56*s12**2*s34*
     +    S14**(-1) + 32*s12**2 + 16*s12*s13**2*s23*S14**(-1)*S24**(-1)
     +     + 32*s12*s13**2*S14**(-1) - 16*s12*s13*s23**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s13*s23*s34*S14**(-1)*S24**(-1) - 32*s12*
     +    s13*s23*S14**(-1) + 32*s12*s13*s23*S24**(-1) - 16*s12*s13*s24
     +    *S14**(-1) + 16*s12*s13*s34*S14**(-1) + 64*s12*s13 + 16*s12*
     +    s14*s23*S24**(-1) + 32*s12*s14 - 8*s12*s23**3*S14**(-1)*
     +    S24**(-1) - 16*s12*s23**2*s34*S14**(-1)*S24**(-1) - 24*s12*
     +    s23**2*S14**(-1) + 24*s12*s23**2*S24**(-1) - 24*s12*s23*s24*
     +    S14**(-1) - 8*s12*s23*s34**2*S14**(-1)*S24**(-1) - 32*s12*s23
     +    *s34*S14**(-1) + 32*s12*s23*s34*S24**(-1) + 48*s12*s23 - 8*
     +    s12*s24**2*S14**(-1) - 16*s12*s24*s34*S14**(-1) + 24*s12*s24
     +     - 16*s12*s34**2*S14**(-1) )

      LA = LA + Ld21(p1,p3,p24)*S234**(-1)*S134**(-1) * ( 40*s12*s34 + 
     +    16*s13**2*s23*S24**(-1) + 32*s13**2 + 16*s13*s14*s23*
     +    S24**(-1) + 32*s13*s14 - 24*s13*s23**2*S14**(-1) - 8*s13*
     +    s23**2*S24**(-1) - 48*s13*s23*s24*S14**(-1) + 16*s13*s23*s34*
     +    S24**(-1) - 8*s13*s23 - 24*s13*s24**2*S14**(-1) + 8*s13*s24
     +     + 32*s13*s34 - 8*s14*s23**2*S24**(-1) - 8*s14*s23 + 8*s14*
     +    s24 + 8*s23*s34 + 16*s24*s34 )

      LA = LA + Ld21(p1,p4,p3)*S13**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12*s14**2*s23**2*S24**(-1) - 16*s12*s14**2
     +    *s23 )

      LA = LA + Ld21(p1,p4,p3)*S13**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s12**2*s14*s23*S24**(-1) + 8*s12**2*s14*s34*S24**(-1) + 8*
     +    s12**2*s14 + 8*s12**2*s23*s34*S24**(-1) + 8*s12**2*s34**2*
     +    S24**(-1) + 8*s12**2*s34 - 16*s12*s14**2*s23*S24**(-1) - 16*
     +    s12*s14*s23**2*S24**(-1) - 16*s12*s14*s23*s34*S24**(-1) - 16*
     +    s12*s14*s23 )

      LA = LA + Ld21(p1,p4,p3)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 6*s12*s13**2*s24**2*S14**(-1) + 6*s12*s13*s24**2
     +     )

      LA = LA + Ld21(p1,p4,p3)*S23**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3*s13*S14**(-1) - 8*s12**3*s34*S14**(-1) + 16*s12**3 + 
     +    16*s12**2*s13**2*S14**(-1) - 8*s12**2*s13*s24*S14**(-1) + 8*
     +    s12**2*s13*s34*S14**(-1) + 32*s12**2*s13 + 16*s12**2*s14 - 8*
     +    s12**2*s24 + 16*s12**2*s34 )

      LA = LA + Ld21(p1,p4,p3)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    32*s12**2*s13*s23*S24**(-1) - 32*s12**2*s13 - 32*s12**2*s14*
     +    s23*S24**(-1) - 32*s12**2*s14 - 32*s12*s13**2*s23*S24**(-1)
     +     + 6*s12*s13**2*s24*S14**(-1) - 32*s12*s13**2 - 64*s12*s13*
     +    s14*s23*S24**(-1) - 64*s12*s13*s14 - 20*s12*s13*s23 - 14*s12*
     +    s13*s24 - 32*s12*s14**2*s23*S24**(-1) - 32*s12*s14**2 - 16*
     +    s12*s14*s23**2*S24**(-1) - 36*s12*s14*s23 - 20*s12*s14*s24 )

      LA = LA + Ld21(p1,p4,p3)*S234**(-1)*S134**(-1) * ( 16*s12**3*s13*
     +    S14**(-1)*S24**(-1) - 8*s12**3*s34*S14**(-1)*S24**(-1) + 16*
     +    s12**3*S24**(-1) + 16*s12**2*s13**2*S14**(-1)*S24**(-1) + 16*
     +    s12**2*s13*s34*S14**(-1)*S24**(-1) - 8*s12**2*s13*S14**(-1)
     +     + 32*s12**2*s13*S24**(-1) + 16*s12**2*s14*S24**(-1) + 24*
     +    s12**2*s23*S24**(-1) + 16*s12**2 - 32*s12*s13*s23*S24**(-1)
     +     - 16*s12*s13 - 32*s12*s14 )

      LA = LA + Ld21(p1,p4,p23)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s12**2*s14*s24 + 24*s12**2*s24**3*S14**(-1) + 
     +    48*s12**2*s24**2*s34*S14**(-1) + 40*s12**2*s24**2 + 24*s12**2
     +    *s24*s34**2*S14**(-1) + 40*s12**2*s24*s34 + 16*s12*s14**2*s24
     +     - 16*s12*s14*s24**2 + 8*s12*s14*s24*s34 - 8*s12*s24**3 - 16*
     +    s12*s24**2*s34 - 8*s12*s24*s34**2 )

      LA = LA + Ld21(p1,p4,p23)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**2*s14*s23*S24**(-1) + 32*s12**2*s14 + 24*s12**2*s23*s24*
     +    S14**(-1) + 24*s12**2*s23*s34*S14**(-1) + 16*s12**2*s23*s34*
     +    S24**(-1) + 40*s12**2*s23 + 48*s12**2*s24**2*S14**(-1) + 72*
     +    s12**2*s24*s34*S14**(-1) + 80*s12**2*s24 + 24*s12**2*s34**2*
     +    S14**(-1) + 56*s12**2*s34 + 16*s12*s14**2*s23*S24**(-1) + 32*
     +    s12*s14**2 + 8*s12*s14*s23*s34*S24**(-1) - 16*s12*s14*s23 - 
     +    32*s12*s14*s24 + 16*s12*s14*s34 - 8*s12*s23**2 - 24*s12*s23*
     +    s24 - 8*s12*s23*s34**2*S24**(-1) - 16*s12*s23*s34 - 24*s12*
     +    s24**2 - 32*s12*s24*s34 - 16*s12*s34**2 - 24*s14*s23**2 - 48*
     +    s14*s23*s24 - 24*s14*s24**2 )

      LA = LA + Ld21(p1,p4,p23)*S23**(-1)*S234**(-1)*S134**(-1) * ( 24*
     +    s12**2*s24**2*S14**(-1) + 24*s12**2*s24*s34*S14**(-1) + 16*
     +    s12**2*s24 + 24*s12*s13*s24**2*S14**(-1) + 24*s12*s13*s24*s34
     +    *S14**(-1) + 16*s12*s13*s24 + 32*s12*s14*s24 + 24*s12*s24**3*
     +    S14**(-1) + 48*s12*s24**2*s34*S14**(-1) + 24*s12*s24**2 + 24*
     +    s12*s24*s34**2*S14**(-1) + 32*s12*s24*s34 + 16*s13*s14*s24 - 
     +    8*s13*s24**2 + 16*s14**2*s24 - 8*s14*s24**2 + 16*s14*s24*s34
     +     )

      LA = LA + Ld21(p1,p4,p23)*S234**(-1)*S134**(-1) * ( 24*s12**2*s23
     +    *S14**(-1) + 16*s12**2*s23*S24**(-1) + 48*s12**2*s24*
     +    S14**(-1) + 24*s12**2*s34*S14**(-1) + 32*s12**2 + 24*s12*s13*
     +    s23*S14**(-1) + 16*s12*s13*s23*S24**(-1) + 48*s12*s13*s24*
     +    S14**(-1) + 24*s12*s13*s34*S14**(-1) + 32*s12*s13 + 32*s12*
     +    s14*s23*S24**(-1) + 64*s12*s14 + 24*s12*s23*s24*S14**(-1) + 
     +    24*s12*s23*s34*S14**(-1) + 8*s12*s23*s34*S24**(-1) + 24*s12*
     +    s23 + 48*s12*s24**2*S14**(-1) + 72*s12*s24*s34*S14**(-1) + 48
     +    *s12*s24 + 24*s12*s34**2*S14**(-1) + 40*s12*s34 + 16*s13*s14*
     +    s23*S24**(-1) + 32*s13*s14 + 8*s13*s23**2*S24**(-1) + 8*s13*
     +    s23 - 8*s13*s24 + 16*s14**2*s23*S24**(-1) + 32*s14**2 + 8*s14
     +    *s23**2*S24**(-1) + 16*s14*s23*s34*S24**(-1) + 8*s14*s23 - 8*
     +    s14*s24 + 32*s14*s34 + 8*s23**2*s34*S24**(-1) + 16*s23*s34 + 
     +    8*s24*s34 )

      LA = LA + Ld21(p2,p3,p4)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s12**3*s24 - 8*s12**3*s34 + 16*s12**2*s24**2
     +     + 16*s12**2*s24*s34 )

      LA = LA + Ld21(p2,p3,p4)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3 + 8*s12**2*s14*s23*S24**(-1) + 8*s12**2*s14*s34*
     +    S24**(-1) + 8*s12**2*s14 + 8*s12**2*s23*s34*S24**(-1) + 16*
     +    s12**2*s23 + 32*s12**2*s24 + 8*s12**2*s34**2*S24**(-1) )

      LA = LA + Ld21(p2,p3,p4)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 6*s12*s13**2*s24**2*S14**(-1) + 6*s12*s13*s24**2
     +     )

      LA = LA + Ld21(p2,p3,p4)*S23**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3*s24*S14**(-1) - 8*s12**3*s34*S14**(-1) - 8*s12**2*s13*
     +    s24*S14**(-1) + 16*s12**2*s24**2*S14**(-1) + 8*s12**2*s24*s34
     +    *S14**(-1) - 8*s12**2*s24 )

      LA = LA + Ld21(p2,p3,p4)*S34**(-1)*S234**(-1)*S134**(-1) * ( 6*
     +    s12*s13**2*s24*S14**(-1) - 12*s12*s13*s23 - 6*s12*s13*s24 - 
     +    12*s12*s14*s23 - 12*s12*s14*s24 )

      LA = LA + Ld21(p2,p3,p4)*S234**(-1)*S134**(-1) * ( 16*s12**3*
     +    S14**(-1) - 8*s12**2*s13*S14**(-1) + 16*s12**2*s23*S14**(-1)
     +     + 8*s12**2*s23*S24**(-1) + 32*s12**2*s24*S14**(-1) + 16*
     +    s12**2*s34*S14**(-1) + 8*s12**2*s34*S24**(-1) )

      LA = LA + Ld21(p2,p3,p14)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**2*s14*s23*S24**(-1) + 16*s12**2*s14*s34*S24**(-1) + 16*
     +    s12**2*s14 + 16*s12*s14*s23**2*S24**(-1) + 8*s12*s14*s23*s34*
     +    S24**(-1) + 32*s12*s14*s23 + 16*s12*s14*s24 - 8*s12*s14*
     +    s34**2*S24**(-1) + 8*s12*s14*s34 + 8*s14**2*s23 + 8*s14**2*
     +    s24 + 8*s14**2*s34 + 16*s14*s23**2 + 16*s14*s23*s24 + 16*s14*
     +    s23*s34 )

      LA = LA + Ld21(p2,p3,p14)*S23**(-1)*S234**(-1)*S134**(-1) * ( 24*
     +    s12**2*s13**3*S14**(-1)*S24**(-1) + 48*s12**2*s13**2*s34*
     +    S14**(-1)*S24**(-1) + 24*s12**2*s13**2*S14**(-1) + 48*s12**2*
     +    s13**2*S24**(-1) + 24*s12**2*s13*s14*S24**(-1) + 24*s12**2*
     +    s13*s34**2*S14**(-1)*S24**(-1) + 24*s12**2*s13*s34*S14**(-1)
     +     + 72*s12**2*s13*s34*S24**(-1) + 48*s12**2*s13 + 24*s12**2*
     +    s14*s34*S24**(-1) + 24*s12**2*s14 + 24*s12**2*s34**2*
     +    S24**(-1) + 24*s12**2*s34 + 24*s12*s13**3*S14**(-1) + 24*s12*
     +    s13**2*s24*S14**(-1) + 48*s12*s13**2*s34*S14**(-1) + 48*s12*
     +    s13**2 + 24*s12*s13*s14 + 24*s12*s13*s24*s34*S14**(-1) + 48*
     +    s12*s13*s24 + 24*s12*s13*s34**2*S14**(-1) + 72*s12*s13*s34 + 
     +    24*s12*s14*s24 + 24*s12*s14*s34 + 24*s12*s24*s34 + 24*s12*
     +    s34**2 )

      LA = LA + Ld21(p2,p3,p14)*S234**(-1)*S134**(-1) * ( 40*s12**2*
     +    s13**2*S14**(-1)*S24**(-1) + 16*s12**2*s13*s23*S14**(-1)*
     +    S24**(-1) + 40*s12**2*s13*s34*S14**(-1)*S24**(-1) + 16*s12**2
     +    *s13*S14**(-1) + 80*s12**2*s13*S24**(-1) + 40*s12**2*s14*
     +    S24**(-1) + 32*s12**2*s23*S24**(-1) + 56*s12**2*s34*S24**(-1)
     +     + 32*s12**2 - 8*s12*s13**3*S14**(-1)*S24**(-1) - 16*s12*
     +    s13**2*s23*S14**(-1)*S24**(-1) - 16*s12*s13**2*s34*S14**(-1)*
     +    S24**(-1) + 24*s12*s13**2*S14**(-1) - 24*s12*s13**2*S24**(-1)
     +     - 24*s12*s13*s14*S24**(-1) + 16*s12*s13*s23**2*S14**(-1)*
     +    S24**(-1) + 8*s12*s13*s23*s34*S14**(-1)*S24**(-1) + 32*s12*
     +    s13*s23*S14**(-1) - 32*s12*s13*s23*S24**(-1) + 16*s12*s13*s24
     +    *S14**(-1) - 8*s12*s13*s34**2*S14**(-1)*S24**(-1) + 32*s12*
     +    s13*s34*S14**(-1) - 32*s12*s13*s34*S24**(-1) + 48*s12*s13 - 8
     +    *s12*s14**2*S24**(-1) - 16*s12*s14*s23*S24**(-1) - 16*s12*s14
     +    *s34*S24**(-1) + 24*s12*s14 + 32*s12*s23**2*S24**(-1) + 16*
     +    s12*s23*s34*S24**(-1) + 64*s12*s23 + 32*s12*s24 - 16*s12*
     +    s34**2*S24**(-1) )

      LA = LA + Ld21(p2,p3,p14)*S234**(-1)*S134**(-1) * ( 40*s12*s34 - 
     +    8*s13**2*s23*S14**(-1) - 24*s13**2*s23*S24**(-1) - 8*s13**2*
     +    s24*S14**(-1) - 48*s13*s14*s23*S24**(-1) + 16*s13*s23**2*
     +    S14**(-1) + 16*s13*s23*s24*S14**(-1) + 16*s13*s23*s34*
     +    S14**(-1) - 8*s13*s23 - 8*s13*s24 + 8*s13*s34 - 24*s14**2*s23
     +    *S24**(-1) + 8*s14*s23 + 8*s14*s24 + 16*s14*s34 + 32*s23**2
     +     + 32*s23*s24 + 32*s23*s34 )

      LA = LA + Ld21(p2,p4,p3)*S13**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 6*s12*s14**2*s23**2*S24**(-1) + 6*s12*s14**2*s23
     +     )

      LA = LA + Ld21(p2,p4,p3)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3*s23*S24**(-1) - 8*s12**3*s34*S24**(-1) + 16*s12**3 - 8
     +    *s12**2*s14*s23*S24**(-1) - 8*s12**2*s14 + 16*s12**2*s23**2*
     +    S24**(-1) + 8*s12**2*s23*s34*S24**(-1) + 32*s12**2*s23 + 16*
     +    s12**2*s24 + 16*s12**2*s34 )

      LA = LA + Ld21(p2,p4,p3)*S23**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s12**2*s13*s24*S14**(-1) + 8*s12**2*s13*s34*S14**(-1) + 8*
     +    s12**2*s24*s34*S14**(-1) + 8*s12**2*s24 + 8*s12**2*s34**2*
     +    S14**(-1) + 8*s12**2*s34 )

      LA = LA + Ld21(p2,p4,p3)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    12*s12*s13*s23 - 12*s12*s13*s24 + 6*s12*s14*s23**2*S24**(-1)
     +     - 6*s12*s14*s23 - 12*s12*s14*s24 )

      LA = LA + Ld21(p2,p4,p3)*S234**(-1)*S134**(-1) * ( 16*s12**3*s23*
     +    S14**(-1)*S24**(-1) - 8*s12**3*s34*S14**(-1)*S24**(-1) + 16*
     +    s12**3*S14**(-1) + 8*s12**2*s13*S14**(-1) + 16*s12**2*s23**2*
     +    S14**(-1)*S24**(-1) + 16*s12**2*s23*s34*S14**(-1)*S24**(-1)
     +     + 32*s12**2*s23*S14**(-1) - 8*s12**2*s23*S24**(-1) + 16*
     +    s12**2*s24*S14**(-1) )

      LA = LA + Ld21(p2,p4,p13)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 24*s12**2*s14**3*S24**(-1) + 48*s12**2*s14**2*s34
     +    *S24**(-1) + 40*s12**2*s14**2 + 16*s12**2*s14*s24 + 24*s12**2
     +    *s14*s34**2*S24**(-1) + 40*s12**2*s14*s34 - 8*s12*s14**3 - 16
     +    *s12*s14**2*s24 - 16*s12*s14**2*s34 + 16*s12*s14*s24**2 + 8*
     +    s12*s14*s24*s34 - 8*s12*s14*s34**2 )

      LA = LA + Ld21(p2,p4,p13)*S13**(-1)*S234**(-1)*S134**(-1) * ( 24*
     +    s12**2*s14**2*S24**(-1) + 24*s12**2*s14*s34*S24**(-1) + 16*
     +    s12**2*s14 + 24*s12*s14**3*S24**(-1) + 24*s12*s14**2*s23*
     +    S24**(-1) + 48*s12*s14**2*s34*S24**(-1) + 24*s12*s14**2 + 24*
     +    s12*s14*s23*s34*S24**(-1) + 16*s12*s14*s23 + 32*s12*s14*s24
     +     + 24*s12*s14*s34**2*S24**(-1) + 32*s12*s14*s34 - 8*s14**2*
     +    s23 - 8*s14**2*s24 + 16*s14*s23*s24 + 16*s14*s24**2 + 16*s14*
     +    s24*s34 )

      LA = LA + Ld21(p2,p4,p13)*S23**(-1)*S234**(-1)*S134**(-1) * ( 24*
     +    s12**2*s13*s14*S24**(-1) + 16*s12**2*s13*s24*S14**(-1) + 16*
     +    s12**2*s13*s34*S14**(-1) + 24*s12**2*s13*s34*S24**(-1) + 40*
     +    s12**2*s13 + 48*s12**2*s14**2*S24**(-1) + 72*s12**2*s14*s34*
     +    S24**(-1) + 80*s12**2*s14 + 32*s12**2*s24 + 24*s12**2*s34**2*
     +    S24**(-1) + 56*s12**2*s34 - 8*s12*s13**2 - 24*s12*s13*s14 + 
     +    16*s12*s13*s24**2*S14**(-1) + 8*s12*s13*s24*s34*S14**(-1) - 
     +    16*s12*s13*s24 - 8*s12*s13*s34**2*S14**(-1) - 16*s12*s13*s34
     +     - 24*s12*s14**2 - 32*s12*s14*s24 - 32*s12*s14*s34 + 32*s12*
     +    s24**2 + 16*s12*s24*s34 - 16*s12*s34**2 - 24*s13**2*s24 - 48*
     +    s13*s14*s24 - 24*s14**2*s24 )

      LA = LA + Ld21(p2,p4,p13)*S234**(-1)*S134**(-1) * ( 16*s12**2*s13
     +    *S14**(-1) + 24*s12**2*s13*S24**(-1) + 48*s12**2*s14*
     +    S24**(-1) + 24*s12**2*s34*S24**(-1) + 32*s12**2 + 24*s12*s13*
     +    s14*S24**(-1) + 16*s12*s13*s23*S14**(-1) + 24*s12*s13*s23*
     +    S24**(-1) + 32*s12*s13*s24*S14**(-1) + 8*s12*s13*s34*
     +    S14**(-1) + 24*s12*s13*s34*S24**(-1) + 24*s12*s13 + 48*s12*
     +    s14**2*S24**(-1) + 48*s12*s14*s23*S24**(-1) + 72*s12*s14*s34*
     +    S24**(-1) + 48*s12*s14 + 24*s12*s23*s34*S24**(-1) + 32*s12*
     +    s23 + 64*s12*s24 + 24*s12*s34**2*S24**(-1) + 40*s12*s34 + 8*
     +    s13**2*s23*S14**(-1) + 8*s13**2*s24*S14**(-1) + 8*s13**2*s34*
     +    S14**(-1) + 16*s13*s23*s24*S14**(-1) + 8*s13*s23 + 16*s13*
     +    s24**2*S14**(-1) + 16*s13*s24*s34*S14**(-1) + 8*s13*s24 + 16*
     +    s13*s34 - 8*s14*s23 - 8*s14*s24 + 8*s14*s34 + 32*s23*s24 + 32
     +    *s24**2 + 32*s24*s34 )

      LA = LA + Ld21(p3,p4,p1)*S13**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 8*s14**2*s23**3*S24**(-1) + 8*s14**2*s23**2 )

      LA = LA + Ld21(p3,p4,p1)*S13**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s14**2*s23**2*S24**(-1) + 8*s14*s23**3*S24**(-1) + 8*s14*
     +    s23**2*s34*S24**(-1) + 8*s14*s23**2 )

      LA = LA + Ld21(p3,p4,p1)*S34**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12*s13*s23**2*S24**(-1) + 16*s12*s13*s23 + 16*s12*s14*s23**2
     +    *S24**(-1) + 16*s12*s14*s23 + 16*s13**2*s23**2*S24**(-1) - 6*
     +    s13**2*s23*s24*S14**(-1) + 16*s13**2*s23 - 6*s13**2*s24**2*
     +    S14**(-1) + 32*s13*s14*s23**2*S24**(-1) + 32*s13*s14*s23 + 16
     +    *s13*s23**2 + 10*s13*s23*s24 - 6*s13*s24**2 + 16*s14**2*
     +    s23**2*S24**(-1) + 16*s14**2*s23 + 8*s14*s23**3*S24**(-1) + 
     +    24*s14*s23**2 + 16*s14*s23*s24 )

      LA = LA + Ld21(p3,p4,p1)*S234**(-1)*S134**(-1) * ( 12*s12*s13*s23
     +    *S14**(-1) + 12*s12*s13*s24*S14**(-1) - 8*s12*s23**2*
     +    S24**(-1) + 4*s12*s23 + 12*s12*s24 + 16*s13*s23**2*S24**(-1)
     +     + 8*s13*s23 + 16*s14*s23 )

      LA = LA + Ld21(p3,p4,p2)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 8*s13**3*s24**2*S14**(-1) + 8*s13**2*s24**2 )

      LA = LA + Ld21(p3,p4,p2)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12*s13**2*s24*S14**(-1) - 16*s12*s13**2*s34*S14**(-1) - 
     +    16*s12*s13*s24*s34*S14**(-1) - 16*s12*s13*s24 - 16*s12*s13*
     +    s34**2*S14**(-1) - 16*s12*s13*s34 + 8*s13**3*s24*S14**(-1) + 
     +    8*s13**2*s24**2*S14**(-1) + 8*s13**2*s24*s34*S14**(-1) + 8*
     +    s13**2*s24 )

      LA = LA + Ld21(p3,p4,p2)*S34**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12*s13**2*s23*S14**(-1) + 16*s12*s13**2*s24*S14**(-1) + 16*
     +    s12*s13*s23 + 16*s12*s13*s24 + 8*s13**3*s24*S14**(-1) + 16*
     +    s13**2*s23**2*S14**(-1) + 32*s13**2*s23*s24*S14**(-1) + 16*
     +    s13**2*s23 + 16*s13**2*s24**2*S14**(-1) + 24*s13**2*s24 - 6*
     +    s13*s14*s23**2*S24**(-1) + 10*s13*s14*s23 + 16*s13*s14*s24 + 
     +    16*s13*s23**2 + 32*s13*s23*s24 + 16*s13*s24**2 - 6*s14**2*
     +    s23**2*S24**(-1) - 6*s14**2*s23 )

      LA = LA + Ld21(p3,p4,p2)*S234**(-1)*S134**(-1) * (  - 32*s12**2*
     +    s13*s23*S14**(-1)*S24**(-1) + 16*s12**2*s13*s34*S14**(-1)*
     +    S24**(-1) - 32*s12**2*s13*S14**(-1) - 32*s12**2*s23*S24**(-1)
     +     + 16*s12**2*s34*S24**(-1) - 32*s12**2 - 24*s12*s13**2*
     +    S14**(-1) - 32*s12*s13*s23**2*S14**(-1)*S24**(-1) - 32*s12*
     +    s13*s23*s34*S14**(-1)*S24**(-1) - 64*s12*s13*s23*S14**(-1) + 
     +    4*s12*s13*s23*S24**(-1) - 32*s12*s13*s24*S14**(-1) - 20*s12*
     +    s13 + 4*s12*s14*s23*S24**(-1) + 4*s12*s14 - 32*s12*s23**2*
     +    S24**(-1) - 16*s12*s23*s34*S24**(-1) - 64*s12*s23 - 32*s12*
     +    s24 - 32*s12*s34 + 16*s13**2*s23*S14**(-1) + 8*s13*s23 + 16*
     +    s13*s24 )

      LA = LA + Ld21(p4,p3,p1)*S13**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 6*s14**2*s23**2 - 6*s14**2*s23*s24 )

      LA = LA + Ld21(p4,p3,p1)*S13**(-1)*S234**(-1)*S134**(-1) * ( 12*
     +    s12*s14*s23 + 12*s12*s14*s24 )

      LA = LA + Ld21(p4,p3,p1)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s12*s13*s24**2 + 16*s12*s14*s24**2 + 8*s13**2*
     +    s24**3*S14**(-1) + 16*s13**2*s24**2 + 32*s13*s14*s24**2 + 8*
     +    s13*s24**3 + 16*s14**2*s24**2 )

      LA = LA + Ld21(p4,p3,p1)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 8
     +    *s12*s24**2 + 8*s13**2*s24**2*S14**(-1) + 8*s13*s24**3*
     +    S14**(-1) + 8*s13*s24**2*s34*S14**(-1) + 16*s14*s24**2 )

      LA = LA + Ld21(p4,p3,p1)*S34**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12*s13*s24 + 16*s12*s14*s24 + 8*s13**2*s24**2*S14**(-1) + 16
     +    *s13**2*s24 + 32*s13*s14*s24 + 16*s13*s23*s24 + 24*s13*s24**2
     +     + 16*s14**2*s24 - 6*s14*s23**2 + 10*s14*s23*s24 + 16*s14*
     +    s24**2 )

      LA = LA + Ld21(p4,p3,p1)*S234**(-1)*S134**(-1) * ( 12*s12*s23 + 4
     +    *s12*s24 + 8*s13*s24**2*S14**(-1) + 16*s13*s24 + 8*s14*s24 )

      LA = LA + Ld21(p4,p3,p2)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s14*s24 + 16*s12**2*s14*s34 - 32*s12
     +    *s14*s24**2 - 32*s12*s14*s24*s34 )

      LA = LA + Ld21(p4,p3,p2)*S13**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s12*s14**2*s23 + 16*s12*s14**2*s24 + 8*s14**3*
     +    s23**2*S24**(-1) + 8*s14**3*s23 + 16*s14**2*s23**2 + 32*
     +    s14**2*s23*s24 + 16*s14**2*s24**2 )

      LA = LA + Ld21(p4,p3,p2)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    32*s12**2*s14 - 16*s12*s14**2*s23*S24**(-1) - 16*s12*s14**2*
     +    s34*S24**(-1) - 24*s12*s14**2 - 16*s12*s14*s23*s34*S24**(-1)
     +     - 32*s12*s14*s23 - 64*s12*s14*s24 - 16*s12*s14*s34**2*
     +    S24**(-1) + 8*s14**3*s23*S24**(-1) + 8*s14**2*s23**2*
     +    S24**(-1) + 8*s14**2*s23*s34*S24**(-1) + 16*s14**2*s24 )

      LA = LA + Ld21(p4,p3,p2)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 6*s13**2*s24**2 - 6*s13*s14*s24**2 )

      LA = LA + Ld21(p4,p3,p2)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    32*s12**2*s24 + 16*s12**2*s34 + 4*s12*s13*s24 + 4*s12*s14*s24
     +     - 32*s12*s24**2 - 16*s12*s24*s34 )

      LA = LA + Ld21(p4,p3,p2)*S34**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12*s14*s23 + 16*s12*s14*s24 - 6*s13**2*s24 + 16*s13*s14*s23
     +     + 10*s13*s14*s24 + 8*s14**2*s23**2*S24**(-1) + 24*s14**2*s23
     +     + 16*s14**2*s24 + 16*s14*s23**2 + 32*s14*s23*s24 + 16*s14*
     +    s24**2 )

      LA = LA + Ld21(p4,p3,p2)*S234**(-1)*S134**(-1) * (  - 32*s12**2
     +     + 4*s12*s13 - 16*s12*s14*s23*S24**(-1) - 16*s12*s14*s34*
     +    S24**(-1) - 20*s12*s14 - 32*s12*s23 - 64*s12*s24 - 32*s12*s34
     +     + 8*s14**2*s23*S24**(-1) + 16*s14*s23 + 8*s14*s24 )

      LAd=-LA
      
      return
      end

      function LAe(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LA=0d0

      LA = LA + Ld22(p1,p3,p24)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**3*s23**2*S14**(-1)*S24**(-1) - 16*s12**3*s23*s34*
     +    S14**(-1)*S24**(-1) - 16*s12**3*s23*S24**(-1) - 32*s12**2*s14
     +    *s23*S24**(-1) + 32*s12**2*s23**3*S14**(-1)*S24**(-1) + 64*
     +    s12**2*s23**2*s34*S14**(-1)*S24**(-1) + 32*s12**2*s23**2*
     +    S14**(-1) + 8*s12**2*s23**2*S24**(-1) + 32*s12**2*s23*s34**2*
     +    S14**(-1)*S24**(-1) + 24*s12**2*s23*s34*S14**(-1) + 24*s12**2
     +    *s23 - 16*s12*s14**2*s23*S24**(-1) + 32*s12*s14*s23**2*
     +    S24**(-1) + 16*s12*s14*s23*s34*S24**(-1) + 16*s12*s14*s23 + 
     +    32*s12*s23**3*S24**(-1) + 64*s12*s23**2*s34*S24**(-1) + 32*
     +    s12*s23**2 + 32*s12*s23*s34**2*S24**(-1) + 16*s12*s23*s34 + 8
     +    *s14**2*s23**2*S24**(-1) - 8*s14**2*s23 - 8*s14*s23*s34 )

      LA = LA + Ld22(p1,p3,p24)*S234**(-1)*S134**(-1) * (  - 16*s12**3*
     +    s23*S14**(-1)*S24**(-1) + 32*s12**2*s13*S14**(-1) + 56*s12**2
     +    *s23**2*S14**(-1)*S24**(-1) + 32*s12**2*s23*s34*S14**(-1)*
     +    S24**(-1) + 56*s12**2*s23*S14**(-1) - 32*s12**2*s23*S24**(-1)
     +     + 32*s12**2*s34*S14**(-1) + 32*s12**2 + 16*s12*s13**2*s23*
     +    S14**(-1)*S24**(-1) + 32*s12*s13**2*S14**(-1) - 16*s12*s13*
     +    s23**2*S14**(-1)*S24**(-1) + 8*s12*s13*s23*s34*S14**(-1)*
     +    S24**(-1) - 32*s12*s13*s23*S14**(-1) + 16*s12*s13*s34*
     +    S14**(-1) + 64*s12*s13 - 32*s12*s14*s23*S24**(-1) + 32*s12*
     +    s14 - 8*s12*s23**3*S14**(-1)*S24**(-1) - 16*s12*s23**2*s34*
     +    S14**(-1)*S24**(-1) + 48*s12*s23**2*S24**(-1) - 16*s12*s23*
     +    s24*S14**(-1) - 8*s12*s23*s34**2*S14**(-1)*S24**(-1) - 32*s12
     +    *s23*s34*S14**(-1) + 8*s12*s23*s34*S24**(-1) + 16*s12*s23 - 
     +    16*s12*s34**2*S14**(-1) + 16*s12*s34 + 16*s13**2*s23*
     +    S24**(-1) + 32*s13**2 + 32*s13*s14 - 24*s13*s23**2*S14**(-1)
     +     - 8*s13*s23**2*S24**(-1) - 48*s13*s23*s24*S14**(-1) + 16*s13
     +    *s23*s34*S24**(-1) )

      LA = LA + Ld22(p1,p3,p24)*S234**(-1)*S134**(-1) * (  - 8*s13*s23
     +     + 16*s13*s24 + 32*s13*s34 - 16*s14**2*s23*S24**(-1) - 16*s14
     +    *s23*s34*S24**(-1) - 16*s14*s23 + 16*s14*s24 + 24*s23**2 + 8*
     +    s23*s34 + 16*s24*s34 )

      LA = LA + Ld22(p1,p4,p23)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12**3*s24**2*S14**(-1) - 16*s12**3*s24*s34
     +    *S14**(-1) - 16*s12**3*s24 + 32*s12**2*s24**3*S14**(-1) + 64*
     +    s12**2*s24**2*s34*S14**(-1) + 56*s12**2*s24**2 + 32*s12**2*
     +    s24*s34**2*S14**(-1) + 32*s12**2*s24*s34 + 16*s12*s14**2*s24
     +     - 16*s12*s14*s24**2 + 8*s12*s14*s24*s34 - 8*s12*s24**3 - 16*
     +    s12*s24**2*s34 - 8*s12*s24*s34**2 )

      LA = LA + Ld22(p1,p4,p23)*S13**(-1)*S234**(-1)*S134**(-1) * ( 32*
     +    s12**2*s14 + 32*s12**2*s24**2*S14**(-1) + 24*s12**2*s24*s34*
     +    S14**(-1) + 56*s12**2*s24 + 32*s12**2*s34 + 32*s12*s14**2 - 
     +    32*s12*s14*s24 + 16*s12*s14*s34 - 16*s12*s23*s24 - 32*s12*s24
     +    *s34 - 16*s12*s34**2 - 48*s14*s23*s24 - 24*s14*s24**2 )

      LA = LA + Ld22(p1,p4,p23)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**3*s24*S14**(-1) - 32*s12**2*s13*s24*S14**(-1) + 8*
     +    s12**2*s24**2*S14**(-1) - 32*s12**2*s24 - 16*s12*s13**2*s24*
     +    S14**(-1) + 32*s12*s13*s24**2*S14**(-1) + 16*s12*s13*s24*s34*
     +    S14**(-1) - 32*s12*s13*s24 + 32*s12*s24**3*S14**(-1) + 64*s12
     +    *s24**2*s34*S14**(-1) + 48*s12*s24**2 + 32*s12*s24*s34**2*
     +    S14**(-1) + 8*s12*s24*s34 + 8*s13**2*s24**2*S14**(-1) - 16*
     +    s13**2*s24 - 16*s13*s24*s34 + 16*s14**2*s24 - 8*s14*s24**2 + 
     +    16*s14*s24*s34 )

      LA = LA + Ld22(p1,p4,p23)*S234**(-1)*S134**(-1) * ( 24*s12**2*s24
     +    *S14**(-1) + 32*s12**2 + 16*s12*s13*s24*S14**(-1) + 32*s12*
     +    s13 + 64*s12*s14 + 32*s12*s24**2*S14**(-1) + 16*s12*s24*s34*
     +    S14**(-1) + 16*s12*s24 + 16*s12*s34 - 8*s13**2*s24*S14**(-1)
     +     + 32*s13*s14 + 16*s13*s23 - 8*s13*s24*s34*S14**(-1) - 16*s13
     +    *s24 + 32*s14**2 + 16*s14*s23 - 8*s14*s24 + 32*s14*s34 + 16*
     +    s23*s34 + 24*s24**2 + 8*s24*s34 )

      LA = LA + Ld22(p2,p3,p14)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**3*s13**2*S14**(-1)*S24**(-1) - 16*s12**3*s13*s34*
     +    S14**(-1)*S24**(-1) - 16*s12**3*s13*S14**(-1) + 32*s12**2*
     +    s13**3*S14**(-1)*S24**(-1) + 64*s12**2*s13**2*s34*S14**(-1)*
     +    S24**(-1) + 8*s12**2*s13**2*S14**(-1) + 32*s12**2*s13**2*
     +    S24**(-1) - 32*s12**2*s13*s24*S14**(-1) + 32*s12**2*s13*
     +    s34**2*S14**(-1)*S24**(-1) + 24*s12**2*s13*s34*S24**(-1) + 24
     +    *s12**2*s13 + 32*s12*s13**3*S14**(-1) + 32*s12*s13**2*s24*
     +    S14**(-1) + 64*s12*s13**2*s34*S14**(-1) + 32*s12*s13**2 - 16*
     +    s12*s13*s24**2*S14**(-1) + 16*s12*s13*s24*s34*S14**(-1) + 16*
     +    s12*s13*s24 + 32*s12*s13*s34**2*S14**(-1) + 16*s12*s13*s34 + 
     +    8*s13**2*s24**2*S14**(-1) - 8*s13*s24**2 - 8*s13*s24*s34 )

      LA = LA + Ld22(p2,p3,p14)*S234**(-1)*S134**(-1) * (  - 16*s12**3*
     +    s13*S14**(-1)*S24**(-1) + 56*s12**2*s13**2*S14**(-1)*
     +    S24**(-1) + 32*s12**2*s13*s34*S14**(-1)*S24**(-1) - 32*s12**2
     +    *s13*S14**(-1) + 56*s12**2*s13*S24**(-1) + 32*s12**2*s23*
     +    S24**(-1) + 32*s12**2*s34*S24**(-1) + 32*s12**2 - 8*s12*
     +    s13**3*S14**(-1)*S24**(-1) - 16*s12*s13**2*s23*S14**(-1)*
     +    S24**(-1) - 16*s12*s13**2*s34*S14**(-1)*S24**(-1) + 48*s12*
     +    s13**2*S14**(-1) - 16*s12*s13*s14*S24**(-1) + 16*s12*s13*
     +    s23**2*S14**(-1)*S24**(-1) + 8*s12*s13*s23*s34*S14**(-1)*
     +    S24**(-1) - 32*s12*s13*s23*S24**(-1) - 32*s12*s13*s24*
     +    S14**(-1) - 8*s12*s13*s34**2*S14**(-1)*S24**(-1) + 8*s12*s13*
     +    s34*S14**(-1) - 32*s12*s13*s34*S24**(-1) + 16*s12*s13 + 32*
     +    s12*s23**2*S24**(-1) + 16*s12*s23*s34*S24**(-1) + 64*s12*s23
     +     + 32*s12*s24 - 16*s12*s34**2*S24**(-1) + 16*s12*s34 - 8*
     +    s13**2*s23*S14**(-1) - 24*s13**2*s23*S24**(-1) + 24*s13**2 - 
     +    48*s13*s14*s23*S24**(-1) + 16*s13*s23**2*S14**(-1) + 16*s13*
     +    s23*s34*S14**(-1) )

      LA = LA + Ld22(p2,p3,p14)*S234**(-1)*S134**(-1) * (  - 8*s13*s23
     +     - 16*s13*s24**2*S14**(-1) - 16*s13*s24*s34*S14**(-1) - 16*
     +    s13*s24 + 8*s13*s34 + 16*s14*s23 + 16*s14*s24 + 16*s14*s34 + 
     +    32*s23**2 + 32*s23*s24 + 32*s23*s34 )

      LA = LA + Ld22(p2,p4,p13)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12**3*s14**2*S24**(-1) - 16*s12**3*s14*s34
     +    *S24**(-1) - 16*s12**3*s14 + 32*s12**2*s14**3*S24**(-1) + 64*
     +    s12**2*s14**2*s34*S24**(-1) + 56*s12**2*s14**2 + 32*s12**2*
     +    s14*s34**2*S24**(-1) + 32*s12**2*s14*s34 - 8*s12*s14**3 - 16*
     +    s12*s14**2*s24 - 16*s12*s14**2*s34 + 16*s12*s14*s24**2 + 8*
     +    s12*s14*s24*s34 - 8*s12*s14*s34**2 )

      LA = LA + Ld22(p2,p4,p13)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**3*s14*S24**(-1) + 8*s12**2*s14**2*S24**(-1) - 32*
     +    s12**2*s14*s23*S24**(-1) - 32*s12**2*s14 + 32*s12*s14**3*
     +    S24**(-1) + 32*s12*s14**2*s23*S24**(-1) + 64*s12*s14**2*s34*
     +    S24**(-1) + 48*s12*s14**2 - 16*s12*s14*s23**2*S24**(-1) + 16*
     +    s12*s14*s23*s34*S24**(-1) - 32*s12*s14*s23 + 32*s12*s14*
     +    s34**2*S24**(-1) + 8*s12*s14*s34 + 8*s14**2*s23**2*S24**(-1)
     +     - 8*s14**2*s24 - 16*s14*s23**2 - 16*s14*s23*s34 + 16*s14*
     +    s24**2 + 16*s14*s24*s34 )

      LA = LA + Ld22(p2,p4,p13)*S23**(-1)*S234**(-1)*S134**(-1) * ( 32*
     +    s12**2*s14**2*S24**(-1) + 24*s12**2*s14*s34*S24**(-1) + 56*
     +    s12**2*s14 + 32*s12**2*s24 + 32*s12**2*s34 - 16*s12*s13*s14
     +     - 32*s12*s14*s24 - 32*s12*s14*s34 + 32*s12*s24**2 + 16*s12*
     +    s24*s34 - 16*s12*s34**2 - 48*s13*s14*s24 - 24*s14**2*s24 )

      LA = LA + Ld22(p2,p4,p13)*S234**(-1)*S134**(-1) * ( 24*s12**2*s14
     +    *S24**(-1) + 32*s12**2 + 32*s12*s14**2*S24**(-1) + 16*s12*s14
     +    *s23*S24**(-1) + 16*s12*s14*s34*S24**(-1) + 16*s12*s14 + 32*
     +    s12*s23 + 64*s12*s24 + 16*s12*s34 + 16*s13*s23 + 16*s13*s24
     +     + 16*s13*s34 + 24*s14**2 - 8*s14*s23**2*S24**(-1) - 8*s14*
     +    s23*s34*S24**(-1) - 16*s14*s23 - 8*s14*s24 + 8*s14*s34 + 32*
     +    s23*s24 + 32*s24**2 + 32*s24*s34 )

      LA = LA + Ld24(p1,p3,p24)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s12**4*s34**2*S14**(-1)*S24**(-1) + 16*s12**4*
     +    s34*S24**(-1) + 16*s12**3*s14*s34*S24**(-1) - 8*s12**3*s34**3
     +    *S14**(-1)*S24**(-1) + 8*s12**3*s34**2*S24**(-1) + 8*s12**2*
     +    s14*s34 + 8*s12**2*s34**2 )

      LA = LA + Ld24(p1,p3,p24)*S13**(-1)*S234**(-1)*S134**(-1) * ( 48*
     +    s12**4*s23*S14**(-1)*S24**(-1) + 64*s12**4*s34*S14**(-1)*
     +    S24**(-1) + 48*s12**4*S24**(-1) + 80*s12**3*s14*S24**(-1) - 
     +    48*s12**3*s23**2*S14**(-1)*S24**(-1) - 104*s12**3*s23*s34*
     +    S14**(-1)*S24**(-1) - 48*s12**3*s23*S14**(-1) + 8*s12**3*s23*
     +    S24**(-1) - 64*s12**3*s34**2*S14**(-1)*S24**(-1) - 32*s12**3*
     +    s34*S14**(-1) + 32*s12**3*s34*S24**(-1) - 24*s12**3 + 32*
     +    s12**2*s14**2*S24**(-1) - 48*s12**2*s14*s23*S24**(-1) - 16*
     +    s12**2*s14*s34*S24**(-1) - 40*s12**2*s23**2*S24**(-1) - 80*
     +    s12**2*s23*s34*S24**(-1) - 40*s12**2*s23 - 40*s12**2*s34**2*
     +    S24**(-1) - 16*s12*s14**2*s23*S24**(-1) + 16*s12*s14**2 + 16*
     +    s12*s14*s34 )

      LA = LA + Ld24(p1,p3,p24)*S23**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**4*s34*S14**(-1)*S24**(-1) + 16*s12**3*s13*s34*S14**(-1)*
     +    S24**(-1) - 32*s12**3*s13*S14**(-1) + 8*s12**3*s34**2*
     +    S14**(-1)*S24**(-1) - 32*s12**3*s34*S14**(-1) + 32*s12**3*s34
     +    *S24**(-1) - 32*s12**3 - 32*s12**2*s13**2*S14**(-1) - 16*
     +    s12**2*s13*s34*S14**(-1) + 16*s12**2*s13*s34*S24**(-1) - 64*
     +    s12**2*s13 + 16*s12**2*s14*s34*S24**(-1) - 32*s12**2*s14 + 16
     +    *s12**2*s34**2*S14**(-1) + 16*s12**2*s34**2*S24**(-1) - 8*
     +    s12**2*s34 - 32*s12*s13**2 - 32*s12*s13*s14 - 16*s12*s13*s24
     +     - 32*s12*s13*s34 - 16*s12*s14*s24 - 16*s12*s24*s34 )

      LA = LA + Ld24(p1,p3,p24)*S234**(-1)*S134**(-1) * ( 48*s12**4*
     +    S14**(-1)*S24**(-1) + 48*s12**3*s13*S14**(-1)*S24**(-1) - 72*
     +    s12**3*s23*S14**(-1)*S24**(-1) - 16*s12**3*s34*S14**(-1)*
     +    S24**(-1) - 56*s12**3*S14**(-1) + 128*s12**3*S24**(-1) + 32*
     +    s12**2*s13*S14**(-1) + 80*s12**2*s13*S24**(-1) + 112*s12**2*
     +    s14*S24**(-1) - 56*s12**2*s23*S14**(-1) - 80*s12**2*s23*
     +    S24**(-1) + 16*s12**2*s24*S14**(-1) + 8*s12**2*s34*S14**(-1)
     +     + 32*s12**2*s34*S24**(-1) + 32*s12*s13*s14*S24**(-1) + 48*
     +    s12*s13*s24*S14**(-1) + 16*s12*s13 + 32*s12*s14**2*S24**(-1)
     +     - 16*s12*s14*s23*S24**(-1) + 32*s12*s14*s34*S24**(-1) + 32*
     +    s12*s14 - 48*s12*s23 )

      LA = LA + Ld24(p1,p4,p23)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 48*s12**4*s24*S14**(-1) + 16*s12**4*s34**2*
     +    S14**(-1)*S24**(-1) + 64*s12**4*s34*S14**(-1) + 16*s12**4*s34
     +    *S24**(-1) + 48*s12**4 + 16*s12**3*s14*s34*S24**(-1) + 48*
     +    s12**3*s14 - 48*s12**3*s24**2*S14**(-1) - 104*s12**3*s24*s34*
     +    S14**(-1) - 72*s12**3*s24 - 8*s12**3*s34**3*S14**(-1)*
     +    S24**(-1) - 64*s12**3*s34**2*S14**(-1) + 8*s12**3*s34**2*
     +    S24**(-1) - 16*s12**3*s34 )

      LA = LA + Ld24(p1,p4,p23)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    32*s12**3*s14*S24**(-1) - 48*s12**3*s24*S14**(-1) - 32*s12**3
     +    *s34*S14**(-1) - 32*s12**3*s34*S24**(-1) - 56*s12**3 - 32*
     +    s12**2*s14**2*S24**(-1) - 16*s12**2*s14*s34*S24**(-1) + 32*
     +    s12**2*s14 + 16*s12**2*s23 - 56*s12**2*s24 + 16*s12**2*s34**2
     +    *S24**(-1) + 8*s12**2*s34 + 48*s12*s14*s23 )

      LA = LA + Ld24(p1,p4,p23)*S23**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**4*s34*S14**(-1)*S24**(-1) + 48*s12**4*S14**(-1) + 16*
     +    s12**3*s13*s34*S14**(-1)*S24**(-1) + 80*s12**3*s13*S14**(-1)
     +     + 8*s12**3*s24*S14**(-1) + 8*s12**3*s34**2*S14**(-1)*
     +    S24**(-1) + 32*s12**3*s34*S14**(-1) + 32*s12**3*s34*S24**(-1)
     +     + 128*s12**3 + 32*s12**2*s13**2*S14**(-1) - 48*s12**2*s13*
     +    s24*S14**(-1) - 16*s12**2*s13*s34*S14**(-1) + 16*s12**2*s13*
     +    s34*S24**(-1) + 112*s12**2*s13 + 16*s12**2*s14*s34*S24**(-1)
     +     + 80*s12**2*s14 - 40*s12**2*s24**2*S14**(-1) - 80*s12**2*s24
     +    *s34*S14**(-1) - 80*s12**2*s24 - 40*s12**2*s34**2*S14**(-1)
     +     + 16*s12**2*s34**2*S24**(-1) + 32*s12**2*s34 - 16*s12*s13**2
     +    *s24*S14**(-1) + 32*s12*s13**2 + 32*s12*s13*s14 - 16*s12*s13*
     +    s24 + 32*s12*s13*s34 )

      LA = LA + Ld24(p1,p4,p23)*S234**(-1)*S134**(-1) * (  - 24*s12**3*
     +    S14**(-1) - 32*s12**3*S24**(-1) + 8*s12**2*s13*s34*S14**(-1)*
     +    S24**(-1) - 32*s12**2*s13*S24**(-1) - 64*s12**2*s14*S24**(-1)
     +     - 40*s12**2*s24*S14**(-1) + 8*s12**2*s34**2*S14**(-1)*
     +    S24**(-1) - 8*s12**2*s34*S24**(-1) + 16*s12*s13**2*S14**(-1)
     +     - 32*s12*s13*s14*S24**(-1) - 16*s12*s13*s23*S24**(-1) + 16*
     +    s12*s13*s34*S14**(-1) + 32*s12*s13 - 32*s12*s14**2*S24**(-1)
     +     - 16*s12*s14*s23*S24**(-1) - 32*s12*s14*s34*S24**(-1) + 16*
     +    s12*s14 - 16*s12*s23*s34*S24**(-1) - 48*s12*s24 )

      LA = LA + Ld24(p2,p3,p14)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s12**4*s34**2*S14**(-1)*S24**(-1) + 16*s12**4*
     +    s34*S14**(-1) + 16*s12**3*s24*s34*S14**(-1) - 8*s12**3*s34**3
     +    *S14**(-1)*S24**(-1) + 8*s12**3*s34**2*S14**(-1) + 8*s12**2*
     +    s24*s34 + 8*s12**2*s34**2 )

      LA = LA + Ld24(p2,p3,p14)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**4*s34*S14**(-1)*S24**(-1) + 16*s12**3*s23*s34*S14**(-1)*
     +    S24**(-1) - 32*s12**3*s23*S24**(-1) + 8*s12**3*s34**2*
     +    S14**(-1)*S24**(-1) + 32*s12**3*s34*S14**(-1) - 32*s12**3*s34
     +    *S24**(-1) - 32*s12**3 - 32*s12**2*s23**2*S24**(-1) + 16*
     +    s12**2*s23*s34*S14**(-1) - 16*s12**2*s23*s34*S24**(-1) - 64*
     +    s12**2*s23 + 16*s12**2*s24*s34*S14**(-1) - 32*s12**2*s24 + 16
     +    *s12**2*s34**2*S14**(-1) + 16*s12**2*s34**2*S24**(-1) - 8*
     +    s12**2*s34 - 16*s12*s14*s23 - 16*s12*s14*s24 - 16*s12*s14*s34
     +     - 32*s12*s23**2 - 32*s12*s23*s24 - 32*s12*s23*s34 )

      LA = LA + Ld24(p2,p3,p14)*S23**(-1)*S234**(-1)*S134**(-1) * ( 48*
     +    s12**4*s13*S14**(-1)*S24**(-1) + 64*s12**4*s34*S14**(-1)*
     +    S24**(-1) + 48*s12**4*S14**(-1) - 48*s12**3*s13**2*S14**(-1)*
     +    S24**(-1) - 104*s12**3*s13*s34*S14**(-1)*S24**(-1) + 8*s12**3
     +    *s13*S14**(-1) - 48*s12**3*s13*S24**(-1) + 80*s12**3*s24*
     +    S14**(-1) - 64*s12**3*s34**2*S14**(-1)*S24**(-1) + 32*s12**3*
     +    s34*S14**(-1) - 32*s12**3*s34*S24**(-1) - 24*s12**3 - 40*
     +    s12**2*s13**2*S14**(-1) - 48*s12**2*s13*s24*S14**(-1) - 80*
     +    s12**2*s13*s34*S14**(-1) - 40*s12**2*s13 + 32*s12**2*s24**2*
     +    S14**(-1) - 16*s12**2*s24*s34*S14**(-1) - 40*s12**2*s34**2*
     +    S14**(-1) - 16*s12*s13*s24**2*S14**(-1) + 16*s12*s24**2 + 16*
     +    s12*s24*s34 )

      LA = LA + Ld24(p2,p3,p14)*S234**(-1)*S134**(-1) * ( 48*s12**4*
     +    S14**(-1)*S24**(-1) - 72*s12**3*s13*S14**(-1)*S24**(-1) + 48*
     +    s12**3*s23*S14**(-1)*S24**(-1) - 16*s12**3*s34*S14**(-1)*
     +    S24**(-1) + 128*s12**3*S14**(-1) - 56*s12**3*S24**(-1) - 80*
     +    s12**2*s13*S14**(-1) - 56*s12**2*s13*S24**(-1) + 16*s12**2*
     +    s14*S24**(-1) + 80*s12**2*s23*S14**(-1) + 32*s12**2*s23*
     +    S24**(-1) + 112*s12**2*s24*S14**(-1) + 32*s12**2*s34*
     +    S14**(-1) + 8*s12**2*s34*S24**(-1) - 16*s12*s13*s24*S14**(-1)
     +     - 48*s12*s13 + 48*s12*s14*s23*S24**(-1) + 32*s12*s23*s24*
     +    S14**(-1) + 16*s12*s23 + 32*s12*s24**2*S14**(-1) + 32*s12*s24
     +    *s34*S14**(-1) + 32*s12*s24 )

      LA = LA + Ld24(p2,p4,p13)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 48*s12**4*s14*S24**(-1) + 16*s12**4*s34**2*
     +    S14**(-1)*S24**(-1) + 16*s12**4*s34*S14**(-1) + 64*s12**4*s34
     +    *S24**(-1) + 48*s12**4 - 48*s12**3*s14**2*S24**(-1) - 104*
     +    s12**3*s14*s34*S24**(-1) - 72*s12**3*s14 + 16*s12**3*s24*s34*
     +    S14**(-1) + 48*s12**3*s24 - 8*s12**3*s34**3*S14**(-1)*
     +    S24**(-1) + 8*s12**3*s34**2*S14**(-1) - 64*s12**3*s34**2*
     +    S24**(-1) - 16*s12**3*s34 )

      LA = LA + Ld24(p2,p4,p13)*S13**(-1)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**4*s34*S14**(-1)*S24**(-1) + 48*s12**4*S24**(-1) + 8*
     +    s12**3*s14*S24**(-1) + 16*s12**3*s23*s34*S14**(-1)*S24**(-1)
     +     + 80*s12**3*s23*S24**(-1) + 8*s12**3*s34**2*S14**(-1)*
     +    S24**(-1) + 32*s12**3*s34*S14**(-1) + 32*s12**3*s34*S24**(-1)
     +     + 128*s12**3 - 40*s12**2*s14**2*S24**(-1) - 48*s12**2*s14*
     +    s23*S24**(-1) - 80*s12**2*s14*s34*S24**(-1) - 80*s12**2*s14
     +     + 32*s12**2*s23**2*S24**(-1) + 16*s12**2*s23*s34*S14**(-1)
     +     - 16*s12**2*s23*s34*S24**(-1) + 112*s12**2*s23 + 16*s12**2*
     +    s24*s34*S14**(-1) + 80*s12**2*s24 + 16*s12**2*s34**2*
     +    S14**(-1) - 40*s12**2*s34**2*S24**(-1) + 32*s12**2*s34 - 16*
     +    s12*s14*s23**2*S24**(-1) - 16*s12*s14*s23 + 32*s12*s23**2 + 
     +    32*s12*s23*s24 + 32*s12*s23*s34 )

      LA = LA + Ld24(p2,p4,p13)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    48*s12**3*s14*S24**(-1) - 32*s12**3*s24*S14**(-1) - 32*s12**3
     +    *s34*S14**(-1) - 32*s12**3*s34*S24**(-1) - 56*s12**3 + 16*
     +    s12**2*s13 - 56*s12**2*s14 - 32*s12**2*s24**2*S14**(-1) - 16*
     +    s12**2*s24*s34*S14**(-1) + 32*s12**2*s24 + 16*s12**2*s34**2*
     +    S14**(-1) + 8*s12**2*s34 + 48*s12*s13*s24 )

      LA = LA + Ld24(p2,p4,p13)*S234**(-1)*S134**(-1) * (  - 32*s12**3*
     +    S14**(-1) - 24*s12**3*S24**(-1) - 40*s12**2*s14*S24**(-1) + 8
     +    *s12**2*s23*s34*S14**(-1)*S24**(-1) - 32*s12**2*s23*S14**(-1)
     +     - 64*s12**2*s24*S14**(-1) + 8*s12**2*s34**2*S14**(-1)*
     +    S24**(-1) - 8*s12**2*s34*S14**(-1) - 16*s12*s13*s23*S14**(-1)
     +     - 16*s12*s13*s24*S14**(-1) - 16*s12*s13*s34*S14**(-1) - 48*
     +    s12*s14 + 16*s12*s23**2*S24**(-1) - 32*s12*s23*s24*S14**(-1)
     +     + 16*s12*s23*s34*S24**(-1) + 32*s12*s23 - 32*s12*s24**2*
     +    S14**(-1) - 32*s12*s24*s34*S14**(-1) + 16*s12*s24 )

      LA = LA + Ld311(p1,p3,p4)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 8*s12**3*s14 )

      LA = LA + Ld311(p1,p3,p4)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    8*s12**3*s14*S24**(-1) )

      LA = LA + Ld311(p1,p3,p4)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    8*s12**3 )

      LA = LA + Ld311(p1,p3,p4)*S234**(-1)*S134**(-1) * (  - 8*s12**3*
     +    S24**(-1) )

      LA = LA + Ld311(p1,p3,p24)*S13**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 24*s12**2*s23**3*S14**(-1)*S24**(-1) - 24*s12**2*s23**2*
     +    s34*S14**(-1)*S24**(-1) - 48*s12**2*s23**2*S14**(-1) - 24*
     +    s12**2*s23**2*S24**(-1) - 24*s12**2*s23*s24*S14**(-1) - 48*
     +    s12**2*s23*s34*S14**(-1) - 48*s12**2*s23 - 24*s12**2*s24*s34*
     +    S14**(-1) - 24*s12**2*s24 - 48*s12*s14*s23**2*S24**(-1) - 96*
     +    s12*s14*s23 - 48*s12*s14*s24 - 48*s12*s23**3*S24**(-1) - 48*
     +    s12*s23**2*s34*S24**(-1) - 96*s12*s23**2 - 48*s12*s23*s24 - 
     +    96*s12*s23*s34 - 48*s12*s24*s34 - 24*s14**2*s23**2*S24**(-1)
     +     - 48*s14**2*s23 - 24*s14**2*s24 - 24*s14*s23**3*S24**(-1) - 
     +    24*s14*s23**2*s34*S24**(-1) - 48*s14*s23**2 - 24*s14*s23*s24
     +     - 48*s14*s23*s34 - 24*s14*s24*s34 )

      LA = LA + Ld311(p1,p3,p24)*S23**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s12*s13*s24**2*S14**(-1) + 8*s12*s24**2*s34*S14**(-1) + 8*s12
     +    *s24**2 + 8*s13*s24**2 + 8*s14*s24**2 + 8*s24**2*s34 )

      LA = LA + Ld311(p1,p3,p24)*S234**(-1)*S134**(-1) * (  - 24*s12**2
     +    *s23**2*S14**(-1)*S24**(-1) - 48*s12**2*s23*S14**(-1) - 24*
     +    s12**2*s24*S14**(-1) - 16*s12*s13*s23**2*S14**(-1)*S24**(-1)
     +     - 24*s12*s13*s23*S14**(-1) - 16*s12*s23**3*S14**(-1)*
     +    S24**(-1) - 16*s12*s23**2*s34*S14**(-1)*S24**(-1) - 24*s12*
     +    s23**2*S14**(-1) - 64*s12*s23**2*S24**(-1) - 24*s12*s23*s34*
     +    S14**(-1) - 120*s12*s23 + 8*s12*s24**2*S14**(-1) - 48*s12*s24
     +     - 16*s13*s23**2*S24**(-1) - 24*s13*s23 - 40*s14*s23**2*
     +    S24**(-1) - 72*s14*s23 - 24*s14*s24 - 16*s23**3*S24**(-1) - 
     +    16*s23**2*s34*S24**(-1) - 24*s23**2 - 24*s23*s34 + 8*s24**2 )

      LA = LA + Ld311(p1,p4,p3)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    8*s12**3*s13*S14**(-1) - 8*s12**3 )

      LA = LA + Ld311(p1,p4,p3)*S234**(-1)*S134**(-1) * (  - 8*s12**3*
     +    s13*S14**(-1)*S24**(-1) - 8*s12**3*S24**(-1) )

      LA = LA + Ld311(p1,p4,p23)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 24*s12**2*s24**3*S14**(-1) - 24*s12**2*s24**2*
     +    s34*S14**(-1) - 24*s12**2*s24**2 - 16*s12*s14*s24**2 - 16*s12
     +    *s24**3 - 16*s12*s24**2*s34 )

      LA = LA + Ld311(p1,p4,p23)*S13**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 24*s12**2*s23*s24*S14**(-1) - 24*s12**2*s23*s34*S14**(-1)
     +     - 24*s12**2*s23 - 48*s12**2*s24**2*S14**(-1) - 48*s12**2*s24
     +    *s34*S14**(-1) - 48*s12**2*s24 + 8*s12*s14*s23**2*S24**(-1)
     +     - 24*s12*s14*s24 + 8*s12*s23**2*s34*S24**(-1) + 8*s12*s23**2
     +     - 24*s12*s24**2 - 24*s12*s24*s34 )

      LA = LA + Ld311(p1,p4,p23)*S23**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 24*s12**2*s24**2*S14**(-1) - 48*s12*s13*s24**2*S14**(-1)
     +     - 48*s12*s24**3*S14**(-1) - 48*s12*s24**2*s34*S14**(-1) - 64
     +    *s12*s24**2 - 24*s13**2*s24**2*S14**(-1) - 24*s13*s24**3*
     +    S14**(-1) - 24*s13*s24**2*s34*S14**(-1) - 40*s13*s24**2 - 16*
     +    s14*s24**2 - 16*s24**3 - 16*s24**2*s34 )

      LA = LA + Ld311(p1,p4,p23)*S234**(-1)*S134**(-1) * (  - 24*s12**2
     +    *s23*S14**(-1) - 48*s12**2*s24*S14**(-1) - 48*s12*s13*s23*
     +    S14**(-1) - 96*s12*s13*s24*S14**(-1) + 8*s12*s23**2*S24**(-1)
     +     - 48*s12*s23*s24*S14**(-1) - 48*s12*s23*s34*S14**(-1) - 48*
     +    s12*s23 - 96*s12*s24**2*S14**(-1) - 96*s12*s24*s34*S14**(-1)
     +     - 120*s12*s24 - 24*s13**2*s23*S14**(-1) - 48*s13**2*s24*
     +    S14**(-1) + 8*s13*s23**2*S24**(-1) - 24*s13*s23*s24*S14**(-1)
     +     - 24*s13*s23*s34*S14**(-1) - 24*s13*s23 - 48*s13*s24**2*
     +    S14**(-1) - 48*s13*s24*s34*S14**(-1) - 72*s13*s24 + 8*s14*
     +    s23**2*S24**(-1) - 24*s14*s24 + 8*s23**2*s34*S24**(-1) + 8*
     +    s23**2 - 24*s24**2 - 24*s24*s34 )

      LA = LA + Ld311(p2,p3,p4)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 8*s12**3*s24 )

      LA = LA + Ld311(p2,p3,p4)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    8*s12**3 )

      LA = LA + Ld311(p2,p3,p4)*S23**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    8*s12**3*s24*S14**(-1) )

      LA = LA + Ld311(p2,p3,p4)*S234**(-1)*S134**(-1) * (  - 8*s12**3*
     +    S14**(-1) )

      LA = LA + Ld311(p2,p3,p14)*S13**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s12*s14**2*s23*S24**(-1) + 8*s12*s14**2*s34*S24**(-1) + 8*s12
     +    *s14**2 + 8*s14**2*s23 + 8*s14**2*s24 + 8*s14**2*s34 )

      LA = LA + Ld311(p2,p3,p14)*S23**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 24*s12**2*s13**3*S14**(-1)*S24**(-1) - 24*s12**2*s13**2*
     +    s34*S14**(-1)*S24**(-1) - 24*s12**2*s13**2*S14**(-1) - 48*
     +    s12**2*s13**2*S24**(-1) - 24*s12**2*s13*s14*S24**(-1) - 48*
     +    s12**2*s13*s34*S24**(-1) - 48*s12**2*s13 - 24*s12**2*s14*s34*
     +    S24**(-1) - 24*s12**2*s14 - 48*s12*s13**3*S14**(-1) - 48*s12*
     +    s13**2*s24*S14**(-1) - 48*s12*s13**2*s34*S14**(-1) - 96*s12*
     +    s13**2 - 48*s12*s13*s14 - 96*s12*s13*s24 - 96*s12*s13*s34 - 
     +    48*s12*s14*s24 - 48*s12*s14*s34 - 24*s13**3*s24*S14**(-1) - 
     +    24*s13**2*s24**2*S14**(-1) - 24*s13**2*s24*s34*S14**(-1) - 48
     +    *s13**2*s24 - 24*s13*s14*s24 - 48*s13*s24**2 - 48*s13*s24*s34
     +     - 24*s14*s24**2 - 24*s14*s24*s34 )

      LA = LA + Ld311(p2,p3,p14)*S234**(-1)*S134**(-1) * (  - 24*s12**2
     +    *s13**2*S14**(-1)*S24**(-1) - 48*s12**2*s13*S24**(-1) - 24*
     +    s12**2*s14*S24**(-1) - 16*s12*s13**3*S14**(-1)*S24**(-1) - 16
     +    *s12*s13**2*s23*S14**(-1)*S24**(-1) - 16*s12*s13**2*s34*
     +    S14**(-1)*S24**(-1) - 64*s12*s13**2*S14**(-1) - 24*s12*s13**2
     +    *S24**(-1) - 24*s12*s13*s23*S24**(-1) - 24*s12*s13*s34*
     +    S24**(-1) - 120*s12*s13 + 8*s12*s14**2*S24**(-1) - 48*s12*s14
     +     - 16*s13**3*S14**(-1) - 16*s13**2*s23*S14**(-1) - 40*s13**2*
     +    s24*S14**(-1) - 16*s13**2*s34*S14**(-1) - 24*s13**2 - 24*s13*
     +    s23 - 72*s13*s24 - 24*s13*s34 + 8*s14**2 - 24*s14*s24 )

      LA = LA + Ld311(p2,p4,p3)*S13**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    8*s12**3*s23*S24**(-1) - 8*s12**3 )

      LA = LA + Ld311(p2,p4,p3)*S234**(-1)*S134**(-1) * (  - 8*s12**3*
     +    s23*S14**(-1)*S24**(-1) - 8*s12**3*S14**(-1) )

      LA = LA + Ld311(p2,p4,p13)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 24*s12**2*s14**3*S24**(-1) - 24*s12**2*s14**2*
     +    s34*S24**(-1) - 24*s12**2*s14**2 - 16*s12*s14**3 - 16*s12*
     +    s14**2*s24 - 16*s12*s14**2*s34 )

      LA = LA + Ld311(p2,p4,p13)*S13**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 24*s12**2*s14**2*S24**(-1) - 48*s12*s14**3*S24**(-1) - 48*
     +    s12*s14**2*s23*S24**(-1) - 48*s12*s14**2*s34*S24**(-1) - 64*
     +    s12*s14**2 - 24*s14**3*s23*S24**(-1) - 16*s14**3 - 24*s14**2*
     +    s23**2*S24**(-1) - 24*s14**2*s23*s34*S24**(-1) - 40*s14**2*
     +    s23 - 16*s14**2*s24 - 16*s14**2*s34 )

      LA = LA + Ld311(p2,p4,p13)*S23**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 24*s12**2*s13*s14*S24**(-1) - 24*s12**2*s13*s34*S24**(-1)
     +     - 24*s12**2*s13 - 48*s12**2*s14**2*S24**(-1) - 48*s12**2*s14
     +    *s34*S24**(-1) - 48*s12**2*s14 + 8*s12*s13**2*s24*S14**(-1)
     +     + 8*s12*s13**2*s34*S14**(-1) + 8*s12*s13**2 - 24*s12*s14**2
     +     - 24*s12*s14*s24 - 24*s12*s14*s34 )

      LA = LA + Ld311(p2,p4,p13)*S234**(-1)*S134**(-1) * (  - 24*s12**2
     +    *s13*S24**(-1) - 48*s12**2*s14*S24**(-1) + 8*s12*s13**2*
     +    S14**(-1) - 48*s12*s13*s14*S24**(-1) - 48*s12*s13*s23*
     +    S24**(-1) - 48*s12*s13*s34*S24**(-1) - 48*s12*s13 - 96*s12*
     +    s14**2*S24**(-1) - 96*s12*s14*s23*S24**(-1) - 96*s12*s14*s34*
     +    S24**(-1) - 120*s12*s14 + 8*s13**2*s23*S14**(-1) + 8*s13**2*
     +    s24*S14**(-1) + 8*s13**2*s34*S14**(-1) + 8*s13**2 - 24*s13*
     +    s14*s23*S24**(-1) - 24*s13*s23**2*S24**(-1) - 24*s13*s23*s34*
     +    S24**(-1) - 24*s13*s23 - 48*s14**2*s23*S24**(-1) - 24*s14**2
     +     - 48*s14*s23**2*S24**(-1) - 48*s14*s23*s34*S24**(-1) - 72*
     +    s14*s23 - 24*s14*s24 - 24*s14*s34 )

      LA = LA + Ld311(p3,p4,p1)*S34**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s13*s23**3*S24**(-1) + 8*s13*s23**2 + 8*s14*s23**3*S24**(-1)
     +     + 8*s14*s23**2 )

      LA = LA + Ld311(p3,p4,p2)*S34**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s13**3*s23*S14**(-1) + 8*s13**3*s24*S14**(-1) + 8*s13**2*s23
     +     + 8*s13**2*s24 )

      LA = LA + Ld311(p4,p3,p1)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 8*s13*s24**3 + 8*s14*s24**3 )

      LA = LA + Ld311(p4,p3,p1)*S34**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s13*s24**2 + 8*s14*s24**2 )

      LA = LA + Ld311(p4,p3,p2)*S13**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 8*s14**3*s23 + 8*s14**3*s24 )

      LA = LA + Ld311(p4,p3,p2)*S34**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s14**2*s23 + 8*s14**2*s24 )

      LA = LA + Ld314(p1,p3,p4)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 24*s12**2*s14*s24 )

      LA = LA + Ld314(p1,p3,p4)*S13**(-1)*S234**(-1)*S134**(-1) * ( 24*
     +    s12**2*s14 )

      LA = LA + Ld314(p1,p3,p4)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 24*s12*s13*s24**2 - 24*s12*s14*s24**2 )

      LA = LA + Ld314(p1,p3,p4)*S23**(-1)*S234**(-1)*S134**(-1) * ( 24*
     +    s12**2*s24 )

      LA = LA + Ld314(p1,p3,p4)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    24*s12*s13*s24 - 24*s12*s14*s24 )

      LA = LA + Ld314(p1,p3,p4)*S234**(-1)*S134**(-1) * ( 24*s12**2 )

      LA = LA + Ld314(p1,p3,p24)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 24*s12**3*s34**2*S14**(-1) + 24*s12**3*s34 + 24*
     +    s12**2*s14*s34 + 24*s12**2*s34**2 )

      LA = LA + Ld314(p1,p3,p24)*S13**(-1)*S234**(-1)*S134**(-1) * ( 72
     +    *s12**3*s23**2*S14**(-1)*S24**(-1) + 96*s12**3*s23*s34*
     +    S14**(-1)*S24**(-1) + 72*s12**3*s23*S14**(-1) + 72*s12**3*s23
     +    *S24**(-1) + 24*s12**3*s34**2*S14**(-1)*S24**(-1) + 96*s12**3
     +    *s34*S14**(-1) + 24*s12**3*s34*S24**(-1) + 72*s12**3 + 120*
     +    s12**2*s14*s23*S24**(-1) + 24*s12**2*s14*s34*S24**(-1) + 120*
     +    s12**2*s14 + 120*s12**2*s23**2*S24**(-1) + 144*s12**2*s23*s34
     +    *S24**(-1) + 120*s12**2*s23 + 24*s12**2*s34**2*S24**(-1) + 
     +    144*s12**2*s34 + 48*s12*s14**2*s23*S24**(-1) + 48*s12*s14**2
     +     + 48*s12*s14*s23**2*S24**(-1) + 48*s12*s14*s23*s34*S24**(-1)
     +     + 48*s12*s14*s23 + 48*s12*s14*s34 )

      LA = LA + Ld314(p1,p3,p24)*S23**(-1)*S234**(-1)*S134**(-1) * ( 24
     +    *s12**3*s34*S14**(-1) - 24*s12**2*s13*s24*S14**(-1) - 24*
     +    s12**2*s24*s34*S14**(-1) - 24*s12**2*s24 + 24*s12**2*s34 - 24
     +    *s12*s13*s24 - 24*s12*s14*s24 - 24*s12*s24*s34 )

      LA = LA + Ld314(p1,p3,p24)*S234**(-1)*S134**(-1) * ( 72*s12**3*
     +    s23*S14**(-1)*S24**(-1) + 24*s12**3*s34*S14**(-1)*S24**(-1)
     +     + 72*s12**3*S14**(-1) + 24*s12**2*s13*s23*S14**(-1)*
     +    S24**(-1) + 24*s12**2*s23**2*S14**(-1)*S24**(-1) + 24*s12**2*
     +    s23*s34*S14**(-1)*S24**(-1) + 144*s12**2*s23*S24**(-1) - 24*
     +    s12**2*s24*S14**(-1) + 24*s12**2*s34*S24**(-1) + 120*s12**2
     +     + 24*s12*s13*s23*S24**(-1) + 72*s12*s14*s23*S24**(-1) + 48*
     +    s12*s14 + 24*s12*s23**2*S24**(-1) + 24*s12*s23*s34*S24**(-1)
     +     - 24*s12*s24 )

      LA = LA + Ld314(p1,p4,p3)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    24*s12*s13*s23**2*S24**(-1) - 24*s12*s13*s23 - 24*s12*s14*
     +    s23**2*S24**(-1) - 24*s12*s14*s23 )

      LA = LA + Ld314(p1,p4,p3)*S234**(-1)*S134**(-1) * ( 24*s12**2*s13
     +    *s23*S14**(-1)*S24**(-1) + 24*s12**2*s13*S14**(-1) + 24*
     +    s12**2*s23*S24**(-1) + 24*s12**2 )

      LA = LA + Ld314(p1,p4,p23)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 72*s12**3*s24**2*S14**(-1) + 96*s12**3*s24*s34*
     +    S14**(-1) + 72*s12**3*s24 + 24*s12**3*s34**2*S14**(-1) + 24*
     +    s12**3*s34 + 24*s12**2*s14*s24 + 24*s12**2*s24**2 + 24*s12**2
     +    *s24*s34 )

      LA = LA + Ld314(p1,p4,p23)*S13**(-1)*S234**(-1)*S134**(-1) * ( 72
     +    *s12**3*s24*S14**(-1) + 24*s12**3*s34**2*S14**(-1)*S24**(-1)
     +     + 96*s12**3*s34*S14**(-1) + 24*s12**3*s34*S24**(-1) + 72*
     +    s12**3 - 24*s12**2*s14*s23*S24**(-1) - 24*s12**2*s23*s34*
     +    S24**(-1) - 24*s12**2*s23 )

      LA = LA + Ld314(p1,p4,p23)*S23**(-1)*S234**(-1)*S134**(-1) * ( 72
     +    *s12**3*s24*S14**(-1) + 24*s12**3*s34*S14**(-1) + 120*s12**2*
     +    s13*s24*S14**(-1) + 24*s12**2*s13*s34*S14**(-1) + 120*s12**2*
     +    s24**2*S14**(-1) + 144*s12**2*s24*s34*S14**(-1) + 144*s12**2*
     +    s24 + 24*s12**2*s34**2*S14**(-1) + 24*s12**2*s34 + 48*s12*
     +    s13**2*s24*S14**(-1) + 48*s12*s13*s24**2*S14**(-1) + 48*s12*
     +    s13*s24*s34*S14**(-1) + 72*s12*s13*s24 + 24*s12*s14*s24 + 24*
     +    s12*s24**2 + 24*s12*s24*s34 )

      LA = LA + Ld314(p1,p4,p23)*S234**(-1)*S134**(-1) * ( 24*s12**3*
     +    s34*S14**(-1)*S24**(-1) + 72*s12**3*S14**(-1) + 24*s12**2*s13
     +    *s34*S14**(-1)*S24**(-1) + 120*s12**2*s13*S14**(-1) - 24*
     +    s12**2*s23*S24**(-1) + 120*s12**2*s24*S14**(-1) + 24*s12**2*
     +    s34**2*S14**(-1)*S24**(-1) + 144*s12**2*s34*S14**(-1) + 24*
     +    s12**2*s34*S24**(-1) + 120*s12**2 + 48*s12*s13**2*S14**(-1)
     +     - 24*s12*s13*s23*S24**(-1) + 48*s12*s13*s24*S14**(-1) + 48*
     +    s12*s13*s34*S14**(-1) + 48*s12*s13 - 24*s12*s14*s23*S24**(-1)
     +     - 24*s12*s23*s34*S24**(-1) - 24*s12*s23 )

      LA = LA + Ld314(p2,p3,p4)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 24*s12**2*s14*s24 )

      LA = LA + Ld314(p2,p3,p4)*S13**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 24*s12*s14**2*s23 - 24*s12*s14**2*s24 )

      LA = LA + Ld314(p2,p3,p4)*S13**(-1)*S234**(-1)*S134**(-1) * ( 24*
     +    s12**2*s14 )

      LA = LA + Ld314(p2,p3,p4)*S23**(-1)*S234**(-1)*S134**(-1) * ( 24*
     +    s12**2*s24 )

      LA = LA + Ld314(p2,p3,p4)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    24*s12*s14*s23 - 24*s12*s14*s24 )

      LA = LA + Ld314(p2,p3,p4)*S234**(-1)*S134**(-1) * ( 24*s12**2 )

      LA = LA + Ld314(p2,p3,p14)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 24*s12**3*s34**2*S24**(-1) + 24*s12**3*s34 + 24*
     +    s12**2*s24*s34 + 24*s12**2*s34**2 )

      LA = LA + Ld314(p2,p3,p14)*S13**(-1)*S234**(-1)*S134**(-1) * ( 24
     +    *s12**3*s34*S24**(-1) - 24*s12**2*s14*s23*S24**(-1) - 24*
     +    s12**2*s14*s34*S24**(-1) - 24*s12**2*s14 + 24*s12**2*s34 - 24
     +    *s12*s14*s23 - 24*s12*s14*s24 - 24*s12*s14*s34 )

      LA = LA + Ld314(p2,p3,p14)*S23**(-1)*S234**(-1)*S134**(-1) * ( 72
     +    *s12**3*s13**2*S14**(-1)*S24**(-1) + 96*s12**3*s13*s34*
     +    S14**(-1)*S24**(-1) + 72*s12**3*s13*S14**(-1) + 72*s12**3*s13
     +    *S24**(-1) + 24*s12**3*s34**2*S14**(-1)*S24**(-1) + 24*s12**3
     +    *s34*S14**(-1) + 96*s12**3*s34*S24**(-1) + 72*s12**3 + 120*
     +    s12**2*s13**2*S14**(-1) + 120*s12**2*s13*s24*S14**(-1) + 144*
     +    s12**2*s13*s34*S14**(-1) + 120*s12**2*s13 + 24*s12**2*s24*s34
     +    *S14**(-1) + 120*s12**2*s24 + 24*s12**2*s34**2*S14**(-1) + 
     +    144*s12**2*s34 + 48*s12*s13**2*s24*S14**(-1) + 48*s12*s13*
     +    s24**2*S14**(-1) + 48*s12*s13*s24*s34*S14**(-1) + 48*s12*s13*
     +    s24 + 48*s12*s24**2 + 48*s12*s24*s34 )

      LA = LA + Ld314(p2,p3,p14)*S234**(-1)*S134**(-1) * ( 72*s12**3*
     +    s13*S14**(-1)*S24**(-1) + 24*s12**3*s34*S14**(-1)*S24**(-1)
     +     + 72*s12**3*S24**(-1) + 24*s12**2*s13**2*S14**(-1)*S24**(-1)
     +     + 24*s12**2*s13*s23*S14**(-1)*S24**(-1) + 24*s12**2*s13*s34*
     +    S14**(-1)*S24**(-1) + 144*s12**2*s13*S14**(-1) - 24*s12**2*
     +    s14*S24**(-1) + 24*s12**2*s34*S14**(-1) + 120*s12**2 + 24*s12
     +    *s13**2*S14**(-1) + 24*s12*s13*s23*S14**(-1) + 72*s12*s13*s24
     +    *S14**(-1) + 24*s12*s13*s34*S14**(-1) - 24*s12*s14 + 48*s12*
     +    s24 )

      LA = LA + Ld314(p2,p4,p3)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    24*s12*s13**2*s23*S14**(-1) - 24*s12*s13**2*s24*S14**(-1) - 
     +    24*s12*s13*s23 - 24*s12*s13*s24 )

      LA = LA + Ld314(p2,p4,p3)*S234**(-1)*S134**(-1) * ( 24*s12**2*s13
     +    *s23*S14**(-1)*S24**(-1) + 24*s12**2*s13*S14**(-1) + 24*
     +    s12**2*s23*S24**(-1) + 24*s12**2 )

      LA = LA + Ld314(p2,p4,p13)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * ( 72*s12**3*s14**2*S24**(-1) + 96*s12**3*s14*s34*
     +    S24**(-1) + 72*s12**3*s14 + 24*s12**3*s34**2*S24**(-1) + 24*
     +    s12**3*s34 + 24*s12**2*s14**2 + 24*s12**2*s14*s24 + 24*s12**2
     +    *s14*s34 )

      LA = LA + Ld314(p2,p4,p13)*S13**(-1)*S234**(-1)*S134**(-1) * ( 72
     +    *s12**3*s14*S24**(-1) + 24*s12**3*s34*S24**(-1) + 120*s12**2*
     +    s14**2*S24**(-1) + 120*s12**2*s14*s23*S24**(-1) + 144*s12**2*
     +    s14*s34*S24**(-1) + 144*s12**2*s14 + 24*s12**2*s23*s34*
     +    S24**(-1) + 24*s12**2*s34**2*S24**(-1) + 24*s12**2*s34 + 48*
     +    s12*s14**2*s23*S24**(-1) + 24*s12*s14**2 + 48*s12*s14*s23**2*
     +    S24**(-1) + 48*s12*s14*s23*s34*S24**(-1) + 72*s12*s14*s23 + 
     +    24*s12*s14*s24 + 24*s12*s14*s34 )

      LA = LA + Ld314(p2,p4,p13)*S23**(-1)*S234**(-1)*S134**(-1) * ( 72
     +    *s12**3*s14*S24**(-1) + 24*s12**3*s34**2*S14**(-1)*S24**(-1)
     +     + 24*s12**3*s34*S14**(-1) + 96*s12**3*s34*S24**(-1) + 72*
     +    s12**3 - 24*s12**2*s13*s24*S14**(-1) - 24*s12**2*s13*s34*
     +    S14**(-1) - 24*s12**2*s13 )

      LA = LA + Ld314(p2,p4,p13)*S234**(-1)*S134**(-1) * ( 24*s12**3*
     +    s34*S14**(-1)*S24**(-1) + 72*s12**3*S24**(-1) - 24*s12**2*s13
     +    *S14**(-1) + 120*s12**2*s14*S24**(-1) + 24*s12**2*s23*s34*
     +    S14**(-1)*S24**(-1) + 120*s12**2*s23*S24**(-1) + 24*s12**2*
     +    s34**2*S14**(-1)*S24**(-1) + 24*s12**2*s34*S14**(-1) + 144*
     +    s12**2*s34*S24**(-1) + 120*s12**2 - 24*s12*s13*s23*S14**(-1)
     +     - 24*s12*s13*s24*S14**(-1) - 24*s12*s13*s34*S14**(-1) - 24*
     +    s12*s13 + 48*s12*s14*s23*S24**(-1) + 48*s12*s23**2*S24**(-1)
     +     + 48*s12*s23*s34*S24**(-1) + 48*s12*s23 )

      LA = LA + Ld322(p1,p3,p24)*S13**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 32*s12**2*s23**3*S14**(-1)*S24**(-1) - 56*s12**2*s23**2*
     +    s34*S14**(-1)*S24**(-1) - 32*s12**2*s23**2*S24**(-1) - 24*
     +    s12**2*s23*s34**2*S14**(-1)*S24**(-1) - 24*s12**2*s23*s34*
     +    S24**(-1) - 40*s12*s14*s23**2*S24**(-1) - 24*s12*s14*s23*s34*
     +    S24**(-1) - 40*s12*s23**3*S24**(-1) - 64*s12*s23**2*s34*
     +    S24**(-1) - 24*s12*s23*s34**2*S24**(-1) - 8*s14**2*s23**2*
     +    S24**(-1) - 8*s14*s23**3*S24**(-1) - 8*s14*s23**2*s34*
     +    S24**(-1) )

      LA = LA + Ld322(p1,p3,p24)*S234**(-1)*S134**(-1) * (  - 32*s12**2
     +    *s23**2*S14**(-1)*S24**(-1) - 24*s12**2*s23*s34*S14**(-1)*
     +    S24**(-1) + 16*s12*s13*s23**2*S14**(-1)*S24**(-1) + 24*s12*
     +    s13*s23*S14**(-1) + 16*s12*s23**3*S14**(-1)*S24**(-1) + 16*
     +    s12*s23**2*s34*S14**(-1)*S24**(-1) + 24*s12*s23**2*S14**(-1)
     +     - 24*s12*s23**2*S24**(-1) + 24*s12*s23*s34*S14**(-1) - 24*
     +    s12*s23*s34*S24**(-1) + 24*s12*s23 + 16*s13*s23**2*S24**(-1)
     +     + 24*s13*s23 + 8*s14*s23**2*S24**(-1) + 24*s14*s23 + 16*
     +    s23**3*S24**(-1) + 16*s23**2*s34*S24**(-1) + 24*s23**2 + 24*
     +    s23*s34 )

      LA = LA + Ld322(p1,p4,p23)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s24**3*S14**(-1) - 56*s12**2*s24**2*
     +    s34*S14**(-1) - 32*s12**2*s24**2 - 24*s12**2*s24*s34**2*
     +    S14**(-1) - 24*s12**2*s24*s34 + 16*s12*s14*s24**2 + 16*s12*
     +    s24**3 + 16*s12*s24**2*s34 )

      LA = LA + Ld322(p1,p4,p23)*S13**(-1)*S234**(-1)*S134**(-1) * ( 24
     +    *s12*s14*s24 + 24*s12*s24**2 + 24*s12*s24*s34 )

      LA = LA + Ld322(p1,p4,p23)*S23**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 32*s12**2*s24**2*S14**(-1) - 24*s12**2*s24*s34*S14**(-1)
     +     - 40*s12*s13*s24**2*S14**(-1) - 24*s12*s13*s24*s34*S14**(-1)
     +     - 40*s12*s24**3*S14**(-1) - 64*s12*s24**2*s34*S14**(-1) - 24
     +    *s12*s24**2 - 24*s12*s24*s34**2*S14**(-1) - 24*s12*s24*s34 - 
     +    8*s13**2*s24**2*S14**(-1) - 8*s13*s24**3*S14**(-1) - 8*s13*
     +    s24**2*s34*S14**(-1) + 8*s13*s24**2 + 16*s14*s24**2 + 16*
     +    s24**3 + 16*s24**2*s34 )

      LA = LA + Ld322(p1,p4,p23)*S234**(-1)*S134**(-1) * ( 24*s12*s24
     +     + 24*s13*s24 + 24*s14*s24 + 24*s24**2 + 24*s24*s34 )

      LA = LA + Ld322(p2,p3,p14)*S23**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 32*s12**2*s13**3*S14**(-1)*S24**(-1) - 56*s12**2*s13**2*
     +    s34*S14**(-1)*S24**(-1) - 32*s12**2*s13**2*S14**(-1) - 24*
     +    s12**2*s13*s34**2*S14**(-1)*S24**(-1) - 24*s12**2*s13*s34*
     +    S14**(-1) - 40*s12*s13**3*S14**(-1) - 40*s12*s13**2*s24*
     +    S14**(-1) - 64*s12*s13**2*s34*S14**(-1) - 24*s12*s13*s24*s34*
     +    S14**(-1) - 24*s12*s13*s34**2*S14**(-1) - 8*s13**3*s24*
     +    S14**(-1) - 8*s13**2*s24**2*S14**(-1) - 8*s13**2*s24*s34*
     +    S14**(-1) )

      LA = LA + Ld322(p2,p3,p14)*S234**(-1)*S134**(-1) * (  - 32*s12**2
     +    *s13**2*S14**(-1)*S24**(-1) - 24*s12**2*s13*s34*S14**(-1)*
     +    S24**(-1) + 16*s12*s13**3*S14**(-1)*S24**(-1) + 16*s12*s13**2
     +    *s23*S14**(-1)*S24**(-1) + 16*s12*s13**2*s34*S14**(-1)*
     +    S24**(-1) - 24*s12*s13**2*S14**(-1) + 24*s12*s13**2*S24**(-1)
     +     + 24*s12*s13*s23*S24**(-1) - 24*s12*s13*s34*S14**(-1) + 24*
     +    s12*s13*s34*S24**(-1) + 24*s12*s13 + 16*s13**3*S14**(-1) + 16
     +    *s13**2*s23*S14**(-1) + 8*s13**2*s24*S14**(-1) + 16*s13**2*
     +    s34*S14**(-1) + 24*s13**2 + 24*s13*s23 + 24*s13*s24 + 24*s13*
     +    s34 )

      LA = LA + Ld322(p2,p4,p13)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s14**3*S24**(-1) - 56*s12**2*s14**2*
     +    s34*S24**(-1) - 32*s12**2*s14**2 - 24*s12**2*s14*s34**2*
     +    S24**(-1) - 24*s12**2*s14*s34 + 16*s12*s14**3 + 16*s12*s14**2
     +    *s24 + 16*s12*s14**2*s34 )

      LA = LA + Ld322(p2,p4,p13)*S13**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 32*s12**2*s14**2*S24**(-1) - 24*s12**2*s14*s34*S24**(-1)
     +     - 40*s12*s14**3*S24**(-1) - 40*s12*s14**2*s23*S24**(-1) - 64
     +    *s12*s14**2*s34*S24**(-1) - 24*s12*s14**2 - 24*s12*s14*s23*
     +    s34*S24**(-1) - 24*s12*s14*s34**2*S24**(-1) - 24*s12*s14*s34
     +     - 8*s14**3*s23*S24**(-1) + 16*s14**3 - 8*s14**2*s23**2*
     +    S24**(-1) - 8*s14**2*s23*s34*S24**(-1) + 8*s14**2*s23 + 16*
     +    s14**2*s24 + 16*s14**2*s34 )

      LA = LA + Ld322(p2,p4,p13)*S23**(-1)*S234**(-1)*S134**(-1) * ( 24
     +    *s12*s14**2 + 24*s12*s14*s24 + 24*s12*s14*s34 )

      LA = LA + Ld322(p2,p4,p13)*S234**(-1)*S134**(-1) * ( 24*s12*s14
     +     + 24*s14**2 + 24*s14*s23 + 24*s14*s24 + 24*s14*s34 )

      LA = LA + Ld344(p1,p3,p24)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 8*s12**4*s34**2*S14**(-1)*S24**(-1) - 8*s12**4
     +    *s34*S24**(-1) - 8*s12**3*s14*s34*S24**(-1) - 8*s12**3*s34**2
     +    *S24**(-1) )

      LA = LA + Ld344(p1,p3,p24)*S13**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 32*s12**4*s23*S14**(-1)*S24**(-1) - 40*s12**4*s34*
     +    S14**(-1)*S24**(-1) - 32*s12**4*S24**(-1) - 56*s12**3*s14*
     +    S24**(-1) - 56*s12**3*s23*S24**(-1) - 64*s12**3*s34*S24**(-1)
     +     - 24*s12**2*s14**2*S24**(-1) - 24*s12**2*s14*s23*S24**(-1)
     +     - 24*s12**2*s14*s34*S24**(-1) )

      LA = LA + Ld344(p1,p3,p24)*S23**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 8*s12**4*s34*S14**(-1)*S24**(-1) - 8*s12**3*s34*S24**(-1)
     +     )

      LA = LA + Ld344(p1,p3,p24)*S234**(-1)*S134**(-1) * (  - 32*s12**4
     +    *S14**(-1)*S24**(-1) - 24*s12**3*s13*S14**(-1)*S24**(-1) - 24
     +    *s12**3*s23*S14**(-1)*S24**(-1) - 24*s12**3*s34*S14**(-1)*
     +    S24**(-1) - 80*s12**3*S24**(-1) - 24*s12**2*s13*S24**(-1) - 
     +    48*s12**2*s14*S24**(-1) - 24*s12**2*s23*S24**(-1) - 24*s12**2
     +    *s34*S24**(-1) )

      LA = LA + Ld344(p1,p4,p23)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**4*s24*S14**(-1) - 8*s12**4*s34**2*
     +    S14**(-1)*S24**(-1) - 40*s12**4*s34*S14**(-1) - 8*s12**4*s34*
     +    S24**(-1) - 32*s12**4 - 24*s12**3*s14 - 24*s12**3*s24 - 24*
     +    s12**3*s34 )

      LA = LA + Ld344(p1,p4,p23)*S23**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 8*s12**4*s34*S14**(-1)*S24**(-1) - 32*s12**4*S14**(-1) - 8
     +    *s12**3*s13*s34*S14**(-1)*S24**(-1) - 56*s12**3*s13*S14**(-1)
     +     - 56*s12**3*s24*S14**(-1) - 8*s12**3*s34**2*S14**(-1)*
     +    S24**(-1) - 64*s12**3*s34*S14**(-1) - 8*s12**3*s34*S24**(-1)
     +     - 80*s12**3 - 24*s12**2*s13**2*S14**(-1) - 24*s12**2*s13*s24
     +    *S14**(-1) - 24*s12**2*s13*s34*S14**(-1) - 48*s12**2*s13 - 24
     +    *s12**2*s14 - 24*s12**2*s24 - 24*s12**2*s34 )

      LA = LA + Ld344(p2,p3,p14)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 8*s12**4*s34**2*S14**(-1)*S24**(-1) - 8*s12**4
     +    *s34*S14**(-1) - 8*s12**3*s24*s34*S14**(-1) - 8*s12**3*s34**2
     +    *S14**(-1) )

      LA = LA + Ld344(p2,p3,p14)*S13**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 8*s12**4*s34*S14**(-1)*S24**(-1) - 8*s12**3*s34*S14**(-1)
     +     )

      LA = LA + Ld344(p2,p3,p14)*S23**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 32*s12**4*s13*S14**(-1)*S24**(-1) - 40*s12**4*s34*
     +    S14**(-1)*S24**(-1) - 32*s12**4*S14**(-1) - 56*s12**3*s13*
     +    S14**(-1) - 56*s12**3*s24*S14**(-1) - 64*s12**3*s34*S14**(-1)
     +     - 24*s12**2*s13*s24*S14**(-1) - 24*s12**2*s24**2*S14**(-1)
     +     - 24*s12**2*s24*s34*S14**(-1) )

      LA = LA + Ld344(p2,p3,p14)*S234**(-1)*S134**(-1) * (  - 32*s12**4
     +    *S14**(-1)*S24**(-1) - 24*s12**3*s13*S14**(-1)*S24**(-1) - 24
     +    *s12**3*s23*S14**(-1)*S24**(-1) - 24*s12**3*s34*S14**(-1)*
     +    S24**(-1) - 80*s12**3*S14**(-1) - 24*s12**2*s13*S14**(-1) - 
     +    24*s12**2*s23*S14**(-1) - 48*s12**2*s24*S14**(-1) - 24*s12**2
     +    *s34*S14**(-1) )

      LA = LA + Ld344(p2,p4,p13)*S13**(-1)*S23**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**4*s14*S24**(-1) - 8*s12**4*s34**2*
     +    S14**(-1)*S24**(-1) - 8*s12**4*s34*S14**(-1) - 40*s12**4*s34*
     +    S24**(-1) - 32*s12**4 - 24*s12**3*s14 - 24*s12**3*s24 - 24*
     +    s12**3*s34 )

      LA = LA + Ld344(p2,p4,p13)*S13**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 8*s12**4*s34*S14**(-1)*S24**(-1) - 32*s12**4*S24**(-1) - 
     +    56*s12**3*s14*S24**(-1) - 8*s12**3*s23*s34*S14**(-1)*
     +    S24**(-1) - 56*s12**3*s23*S24**(-1) - 8*s12**3*s34**2*
     +    S14**(-1)*S24**(-1) - 8*s12**3*s34*S14**(-1) - 64*s12**3*s34*
     +    S24**(-1) - 80*s12**3 - 24*s12**2*s14*s23*S24**(-1) - 24*
     +    s12**2*s14 - 24*s12**2*s23**2*S24**(-1) - 24*s12**2*s23*s34*
     +    S24**(-1) - 48*s12**2*s23 - 24*s12**2*s24 - 24*s12**2*s34 )

      LA = LA + Le1(p1,p3,p4,p2)*S13**(-1)*S23**(-1)*S34**(-1) * (  - 
     +    16*s12**2*s14*s24 - 16*s12*s14**2*s24 - 16*s12*s14*s24**2 - 8
     +    *s14**3*s24 - 8*s14*s24**3 )

      LA = LA + Le1(p1,p3,p4,p2)*S13**(-1)*S23**(-1) * ( 16*s12**3 + 16
     +    *s12**2*s14 + 16*s12**2*s24 + 8*s12*s14**2 + 8*s12*s24**2 )

      LA = LA + Le1(p1,p3,p4,p2)*S13**(-1)*S34**(-1) * (  - 32*s12*s14*
     +    s24 - 16*s14**2*s24 - 16*s14*s23*s24 - 16*s14*s24**2 )

      LA = LA + Le1(p1,p3,p4,p2)*S13**(-1)*S134**(-1) * (  - 8*s12*s14*
     +    s24 - 8*s14*s23*s24 - 8*s14*s24**2 )

      LA = LA + Le1(p1,p3,p4,p2)*S13**(-1) * ( 16*s12**2 + 32*s12*s14
     +     + 8*s12*s23 + 16*s12*s24 + 16*s14**2 + 16*s14*s23 + 8*s14*
     +    s34 )

      LA = LA + Le1(p1,p3,p4,p2)*S23**(-1)*S34**(-1) * (  - 32*s12*s14*
     +    s24 - 16*s13*s14*s24 - 16*s14**2*s24 - 16*s14*s24**2 )

      LA = LA + Le1(p1,p3,p4,p2)*S23**(-1)*S234**(-1) * (  - 8*s12*s14*
     +    s24 - 8*s13*s14*s24 - 8*s14**2*s24 )

      LA = LA + Le1(p1,p3,p4,p2)*S23**(-1) * ( 16*s12**2 + 8*s12*s13 + 
     +    16*s12*s14 + 16*s12*s24 )

      LA = LA + Le1(p1,p3,p4,p2)*S34**(-1)*S234**(-1) * (  - 32*s12*s13
     +    *s23 - 32*s12*s14*s23 - 32*s13**2*s23 - 64*s13*s14*s23 - 32*
     +    s14**2*s23 )

      LA = LA + Le1(p1,p3,p4,p2)*S34**(-1)*S134**(-1) * (  - 32*s12*s13
     +    *s23 - 32*s12*s13*s24 - 32*s13*s23**2 - 64*s13*s23*s24 - 32*
     +    s13*s24**2 )

      LA = LA + Le1(p1,p3,p4,p2)*S34**(-1) * ( 16*s12**2*s13*s23*
     +    S14**(-1)*S24**(-1) + 16*s12*s13**2*s23*S14**(-1)*S24**(-1)
     +     + 16*s12*s13*s23**2*S14**(-1)*S24**(-1) + 32*s12*s13*s23*
     +    S14**(-1) + 32*s12*s13*s23*S24**(-1) + 16*s12*s13 + 16*s12*
     +    s14 + 16*s12*s23 + 16*s12*s24 + 8*s13**3*s23*S14**(-1)*
     +    S24**(-1) + 16*s13**2*s23*S14**(-1) + 16*s13**2*s23*S24**(-1)
     +     + 8*s13**2 + 16*s13*s14*s23*S24**(-1) + 32*s13*s14 + 8*s13*
     +    s23**3*S14**(-1)*S24**(-1) + 16*s13*s23**2*S14**(-1) + 16*s13
     +    *s23**2*S24**(-1) + 16*s13*s23*s24*S14**(-1) + 24*s14**2 + 8*
     +    s23**2 + 32*s23*s24 + 24*s24**2 )

      LA = LA + Le1(p1,p3,p4,p2)*S234**(-1) * ( 8*s12*s13*s23*S24**(-1)
     +     + 8*s12*s13 - 40*s12*s14 + 8*s13**2*s23*S24**(-1) + 8*s13**2
     +     + 8*s13*s14*s23*S24**(-1) - 32*s13*s14 - 40*s14**2 )

      LA = LA + Le1(p1,p3,p4,p2)*S134**(-1) * ( 8*s12*s13*s23*S14**(-1)
     +     + 8*s12*s23 - 40*s12*s24 + 8*s13*s23**2*S14**(-1) + 8*s13*
     +    s23*s24*S14**(-1) + 8*s23**2 - 32*s23*s24 - 40*s24**2 )

      LA = LA + Le1(p1,p3,p4,p2) * (  - 16*s12**3*S14**(-1)*S24**(-1)
     +     - 16*s12**2*s13*S14**(-1)*S24**(-1) - 16*s12**2*s23*
     +    S14**(-1)*S24**(-1) - 16*s12**2*S14**(-1) - 16*s12**2*
     +    S24**(-1) - 8*s12*s13**2*S14**(-1)*S24**(-1) - 16*s12*s13*
     +    S14**(-1) - 16*s12*s13*S24**(-1) - 8*s12*s14*S24**(-1) - 8*
     +    s12*s23**2*S14**(-1)*S24**(-1) - 16*s12*s23*S14**(-1) - 32*
     +    s12*s23*S24**(-1) - 8*s12*s24*S14**(-1) - 16*s14*s23*
     +    S24**(-1) - 16*s23**2*S24**(-1) - 8*s23*s34*S24**(-1) )

      LA = LA + Le1(p1,p4,p3,p2)*S13**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2*s14*s24 + 16*s12*s14**2*s24 + 16*s12*s14*s24**2 + 8*
     +    s14**3*s24 + 8*s14*s24**3 )

      LA = LA + Le1(p1,p4,p3,p2)*S13**(-1)*S23**(-1) * (  - 16*s12**3
     +     - 16*s12**2*s14 - 16*s12**2*s24 - 8*s12*s14**2 - 8*s12*
     +    s24**2 )

      LA = LA + Le1(p1,p4,p3,p2)*S13**(-1)*S34**(-1) * ( 32*s12*s14*s24
     +     + 16*s14**2*s24 + 16*s14*s23*s24 + 16*s14*s24**2 )

      LA = LA + Le1(p1,p4,p3,p2)*S13**(-1)*S134**(-1) * ( 8*s12*s14*s24
     +     + 8*s14*s23*s24 + 8*s14*s24**2 )

      LA = LA + Le1(p1,p4,p3,p2)*S13**(-1) * (  - 16*s12**2 - 16*s12*
     +    s14 - 8*s12*s23 - 16*s12*s24 )

      LA = LA + Le1(p1,p4,p3,p2)*S23**(-1)*S34**(-1) * ( 32*s12*s14*s24
     +     + 16*s13*s14*s24 + 16*s14**2*s24 + 16*s14*s24**2 )

      LA = LA + Le1(p1,p4,p3,p2)*S23**(-1)*S234**(-1) * ( 8*s12*s14*s24
     +     + 8*s13*s14*s24 + 8*s14**2*s24 )

      LA = LA + Le1(p1,p4,p3,p2)*S23**(-1) * (  - 16*s12**2 - 8*s12*s13
     +     - 16*s12*s14 - 32*s12*s24 - 16*s13*s24 - 16*s24**2 - 8*s24*
     +    s34 )

      LA = LA + Le1(p1,p4,p3,p2)*S34**(-1)*S234**(-1) * ( 32*s12*s13*
     +    s23 + 32*s12*s14*s23 + 32*s13**2*s23 + 64*s13*s14*s23 + 32*
     +    s14**2*s23 )

      LA = LA + Le1(p1,p4,p3,p2)*S34**(-1)*S134**(-1) * ( 32*s12*s13*
     +    s23 + 32*s12*s13*s24 + 32*s13*s23**2 + 64*s13*s23*s24 + 32*
     +    s13*s24**2 )

      LA = LA + Le1(p1,p4,p3,p2)*S34**(-1) * (  - 16*s12**2*s13*s23*
     +    S14**(-1)*S24**(-1) - 16*s12*s13**2*s23*S14**(-1)*S24**(-1)
     +     - 16*s12*s13*s23**2*S14**(-1)*S24**(-1) - 32*s12*s13*s23*
     +    S14**(-1) - 32*s12*s13*s23*S24**(-1) - 16*s12*s13 - 16*s12*
     +    s14 - 16*s12*s23 - 16*s12*s24 - 8*s13**3*s23*S14**(-1)*
     +    S24**(-1) - 16*s13**2*s23*S14**(-1) - 16*s13**2*s23*S24**(-1)
     +     - 8*s13**2 - 16*s13*s14*s23*S24**(-1) - 32*s13*s14 - 8*s13*
     +    s23**3*S14**(-1)*S24**(-1) - 16*s13*s23**2*S14**(-1) - 16*s13
     +    *s23**2*S24**(-1) - 16*s13*s23*s24*S14**(-1) - 24*s14**2 - 8*
     +    s23**2 - 32*s23*s24 - 24*s24**2 )

      LA = LA + Le1(p1,p4,p3,p2)*S234**(-1) * (  - 8*s12*s13*s23*
     +    S24**(-1) - 8*s12*s13 + 40*s12*s14 - 8*s13**2*s23*S24**(-1)
     +     - 8*s13**2 - 8*s13*s14*s23*S24**(-1) + 32*s13*s14 + 40*
     +    s14**2 )

      LA = LA + Le1(p1,p4,p3,p2)*S134**(-1) * (  - 8*s12*s13*s23*
     +    S14**(-1) - 8*s12*s23 + 40*s12*s24 - 8*s13*s23**2*S14**(-1)
     +     - 8*s13*s23*s24*S14**(-1) - 8*s23**2 + 32*s23*s24 + 40*
     +    s24**2 )

      LA = LA + Le1(p1,p4,p3,p2) * ( 16*s12**3*S14**(-1)*S24**(-1) + 16
     +    *s12**2*s13*S14**(-1)*S24**(-1) + 16*s12**2*s23*S14**(-1)*
     +    S24**(-1) + 16*s12**2*S14**(-1) + 16*s12**2*S24**(-1) + 8*s12
     +    *s13**2*S14**(-1)*S24**(-1) + 32*s12*s13*S14**(-1) + 16*s12*
     +    s13*S24**(-1) + 8*s12*s14*S24**(-1) + 8*s12*s23**2*S14**(-1)*
     +    S24**(-1) + 16*s12*s23*S14**(-1) + 16*s12*s23*S24**(-1) + 8*
     +    s12*s24*S14**(-1) + 16*s13**2*S14**(-1) + 16*s13*s24*
     +    S14**(-1) + 8*s13*s34*S14**(-1) )

      LA = LA + 64*s12*S14**(-1)*S24**(-1) + 20*s13*S14**(-1)*S24**(-1)
     +     + 20*s23*S14**(-1)*S24**(-1) + 24*S14**(-1) + 24*S24**(-1)

      LAe=-LA
   
      return
      end
      
      
      function LA34(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)

      LA34=LA34a(p1,p2,p3,p4)+LA34b(p1,p2,p3,p4)

      return
      end

      function LA34a(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LA34=0d0

      LA34 = LA34 + S34**(-1)*S234**(-1)*S134**(-1) * (  - 512*s12**2
     +     + 16*s12*s13 - 256*s12*s23 - 120*s13**2 + 240*s13*s23 - 120*
     +    s23**2 )

      LA34 = LA34 + S34**(-1)*S234**(-1) * (  - 4*s12**2*s14*S13**(-1)*
     +    S24**(-1) + 368./3.*s12**2*S13**(-1) + 4*s12**2*S24**(-1) + 8
     +    *s12*s14**2*S13**(-1)*S24**(-1) + 108*s12*s14*S13**(-1) + 8*
     +    s12*s14*S24**(-1) + 124*s12*s23*S13**(-1) - 1484./3.*s12 - 52
     +    *s13 + 112./3.*s14**2*S13**(-1) + 124*s14*s23*S13**(-1) - 596.
     +    /3.*s14 + 60*s23**2*S13**(-1) - 124*s23 )

      LA34 = LA34 + S34**(-1)*S234**(-2) * (  - 8*s12*s23 - 8*s13*s23
     +     - 8*s14*s23 )

      LA34 = LA34 + S34**(-1)*S134**(-1) * (  - 4*s12**2*s23*S13**(-1)*
     +    S24**(-1) + 4*s12**2*S13**(-1) + 368./3.*s12**2*S24**(-1) - 
     +    124*s12*s13*S24**(-1) + 8*s12*s23**2*S13**(-1)*S24**(-1) + 8*
     +    s12*s23*S13**(-1) + 308./3.*s12*s23*S24**(-1) - 492*s12 + 60*
     +    s13**2*S24**(-1) - 124*s13*s23*S24**(-1) + 76*s13 + 32*s23**2
     +    *S24**(-1) - 1000./3.*s23 - 544./3.*s24 )

      LA34 = LA34 + S34**(-1)*S134**(-2) * ( 232*s12*s13 + 232*s13*s23
     +     + 232*s13*s24 )

      LA34 = LA34 + S34**(-1) * (  - 112 + 388./3.*s12**2*S13**(-1)*
     +    S24**(-1) + 136*s12*s14*S13**(-1)*S24**(-1) + 136*s12*s23*
     +    S13**(-1)*S24**(-1) + 248*s12*S13**(-1) + 372*s12*S24**(-1)
     +     + 52*s13*S24**(-1) + 224./3.*s14**2*S13**(-1)*S24**(-1) - 12
     +    *s14*s23*S13**(-1)*S24**(-1) - 36*s14*S13**(-1) + 244*s14*
     +    S24**(-1) + 224./3.*s23**2*S13**(-1)*S24**(-1) + 184*s23*
     +    S13**(-1) + 88*s23*S24**(-1) + 112*s24*S13**(-1) )

      LA34 = LA34 + S34**(-2)*S234**(-1)*S134**(-1) * (  - 256*s12*s13*
     +    s23 )

      LA34 = LA34 + S34**(-2)*S234**(-1) * ( 16./3.*s12*s14*s23*
     +    S13**(-1) + 16./3.*s12*s23 - 704./3.*s13*s23 + 16./3.*s14**2*
     +    s23*S13**(-1) + 32./3.*s14*s23 + 120*s23**2 )

      LA34 = LA34 + S34**(-2)*S234**(-2) * ( 112*s12*s23**2 + 112*s13*
     +    s23**2 + 112*s14*s23**2 )

      LA34 = LA34 + S34**(-2)*S134**(-1) * (  - 16./3.*s12*s13*s23*
     +    S24**(-1) - 16./3.*s12*s13 + 120*s13**2 - 16./3.*s13*s23**2*
     +    S24**(-1) - 752./3.*s13*s23 - 16./3.*s13*s24 )

      LA34 = LA34 + S34**(-2)*S134**(-2) * ( 112*s12*s13**2 + 112*
     +    s13**2*s23 + 112*s13**2*s24 )

      LA34 = LA34 + S34**(-2) * (  - 16./3.*s12*s14*s23*S13**(-1)*
     +    S24**(-1) + 16./3.*s12*s23*S24**(-1) - 16./3.*s13 - 16./3.*
     +    s14**2*s23*S13**(-1)*S24**(-1) - 16./3.*s14*s23**2*S13**(-1)*
     +    S24**(-1) + 16./3.*s23**2*S24**(-1) + 32./3.*s23 )

      LA34 = LA34 + S234**(-1)*S134**(-1) * ( 128*s12**3*S13**(-1)*
     +    S24**(-1) + 252*s12**2*s14*S13**(-1)*S24**(-1) + 4*s12**2*s34
     +    *S13**(-1)*S24**(-1) - 260*s12**2*S13**(-1) - 8*s12**2*
     +    S24**(-1) - 188*s12*s13*S24**(-1) + 176*s12*s14*s23*S13**(-1)
     +    *S24**(-1) - 24*s12*s14*S13**(-1) - 372*s12*s14*S24**(-1) - 
     +    184*s12*s23*S13**(-1) + 176*s12*s23*S24**(-1) + 320*s12 + 112
     +    *s13**2*S24**(-1) + 172*s13*s14*S24**(-1) - 132*s13*s23*
     +    S24**(-1) - 108*s13 + 48*s14**2*s23*S13**(-1)*S24**(-1) + 48*
     +    s14**2*S13**(-1) - 124*s14*s23*S13**(-1) - 84*s14*s23*
     +    S24**(-1) - 64*s14*s24*S13**(-1) + 100*s14 - 60*s23**2*
     +    S13**(-1) + 52*s23 - 64*s24 )

      LA34 = LA34 + S234**(-1) * (  - 104 - 56./3.*s12**2*S13**(-1)*
     +    S24**(-1) + 416./3.*s12*s14*S13**(-1)*S24**(-1) - 44*s12*
     +    S13**(-1) + 32*s12*S24**(-1) - 168*s13*S24**(-1) + 100./3.*
     +    s14**2*S13**(-1)*S24**(-1) - 52*s14*S13**(-1) - 136*s14*
     +    S24**(-1) - 4*s23**2*S13**(-1)*S24**(-1) - 20*s23*S13**(-1)
     +     + 12*s23*S24**(-1) - 8*s24*S13**(-1) )

      LA34 = LA34 + S234**(-2) * (  - 64*s12*s23*S24**(-1) - 64*s13*s23
     +    *S24**(-1) - 64*s14*s23*S24**(-1) )

      LA34 = LA34 + S134**(-1) * ( 52 + 700./3.*s12**2*S13**(-1)*
     +    S24**(-1) + 416./3.*s12*s23*S13**(-1)*S24**(-1) - 156*s12*
     +    S13**(-1) - 360*s12*S24**(-1) + 168*s13*S24**(-1) - 4*s14**2*
     +    S13**(-1)*S24**(-1) + 48*s14*s23*S13**(-1)*S24**(-1) + 60*s14
     +    *S13**(-1) - 16*s14*S24**(-1) + 100./3.*s23**2*S13**(-1)*
     +    S24**(-1) - 76*s23*S13**(-1) - 120*s23*S24**(-1) - 56*s24*
     +    S13**(-1) )

      LA34 = LA34 + S134**(-2) * (  - 64*s12*s14*S13**(-1) + 120*s12 - 
     +    64*s14*s23*S13**(-1) - 64*s14*s24*S13**(-1) + 120*s23 + 120*
     +    s24 )

      LA34 = LA34 + log(s13**(-1)*s134)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 32*s12**2 + 16*s12*s13 + 16*s12*s23 - 12*s13**2 + 32*s13*
     +    s23 + 6*s23**2 )

      LA34 = LA34 + log(s13**(-1)*s134)*S34**(-1)*S234**(-1) * (  - 16*
     +    s12**2*s14*S13**(-1)*S24**(-1) - 32*s12**2*S24**(-1) + 4*s12*
     +    s13*S24**(-1) + 8*s12*s14**2*S13**(-1)*S24**(-1) + 16*s12*s14
     +    *S13**(-1) + 8*s12*s14*S24**(-1) + 6*s12*s23*S13**(-1) + 36*
     +    s12 + 32*s13 + 24*s14 )

      LA34 = LA34 + log(s13**(-1)*s134)*S34**(-1)*S134**(-1) * ( 12*
     +    s12**3*S13**(-1)*S24**(-1) - 16*s12**2*s23*S13**(-1)*
     +    S24**(-1) - 4*s12*s23**2*S13**(-1)*S24**(-1) - 12*s12*s23*
     +    S24**(-1) - 40*s12 - 8*s24 )

      LA34 = LA34 + log(s13**(-1)*s134)*S34**(-1)*S134**(-2) * ( 40*s12
     +    *s13 + 40*s13*s23 + 40*s13*s24 )

      LA34 = LA34 + log(s13**(-1)*s134)*S34**(-1) * ( 16 + 12*s12**2*
     +    S13**(-1)*S24**(-1) - 16*s12*s14*S13**(-1)*S24**(-1) - 14*s12
     +    *s23*S13**(-1)*S24**(-1) + 8*s12*S13**(-1) - 4*s12*S24**(-1)
     +     - 16*s14*s23*S13**(-1)*S24**(-1) - 4*s23**2*S13**(-1)*
     +    S24**(-1) - 16*s23*S24**(-1) )

      LA34 = LA34 + log(s13**(-1)*s134)*S234**(-1)*S134**(-1) * (  - 12
     +    *s12**3*S13**(-1)*S24**(-1) + 16*s12**2*s14*S13**(-1)*
     +    S24**(-1) + 64*s12**2*S24**(-1) + 40*s12*s13*S24**(-1) + 14*
     +    s12*s14*s23*S13**(-1)*S24**(-1) - 8*s12*s14*S13**(-1) + 12*
     +    s12*s14*S24**(-1) - 6*s12*s23*S13**(-1) + 14*s12*s23*
     +    S24**(-1) + 4*s12 + 24*s13**2*S24**(-1) + 24*s13*s14*
     +    S24**(-1) - 88*s13 - 8*s14**2*s23*S13**(-1)*S24**(-1) - 8*
     +    s14**2*S13**(-1) + 8*s14*s23*S13**(-1) - 8*s14*s23*S24**(-1)
     +     + 8*s14*s24*S13**(-1) - 40*s14 + 32*s23 + 8*s24 )

      LA34 = LA34 + log(s13**(-1)*s134)*S234**(-1) * ( 8 - 16*s12**2*
     +    S13**(-1)*S24**(-1) + 8*s12*s14*S13**(-1)*S24**(-1) + 8*s12*
     +    S24**(-1) - 24*s13*S24**(-1) + 8*s14*S13**(-1) + 16*s23*
     +    S24**(-1) )

      LA34 = LA34 + log(s13**(-1)*s134)*S134**(-1) * (  - 16 + 24*
     +    s12**2*S13**(-1)*S24**(-1) + 24*s12*s14*S13**(-1)*S24**(-1)
     +     + 14*s12*s23*S13**(-1)*S24**(-1) + 16*s12*S13**(-1) + 80*s12
     +    *S24**(-1) + 88*s13*S24**(-1) + 16*s14*s23*S13**(-1)*
     +    S24**(-1) - 8*s14*S13**(-1) + 32*s14*S24**(-1) + 8*s23**2*
     +    S13**(-1)*S24**(-1) + 24*s23*S13**(-1) + 40*s23*S24**(-1) + 
     +    24*s24*S13**(-1) )

      LA34 = LA34 + log(s13**(-1)*s134)*S134**(-2) * (  - 24*s12*s14*
     +    S13**(-1) + 40*s12 - 24*s14*s23*S13**(-1) - 24*s14*s24*
     +    S13**(-1) + 40*s23 + 40*s24 )

      LA34 = LA34 + log(s24**(-1)*s234)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 8*s12*s13 + 16*s12*s23 + 6*s13**2 + 32*s13*s23 - 12*s23**2
     +     )

      LA34 = LA34 + log(s24**(-1)*s234)*S34**(-1)*S234**(-1) * ( 12*
     +    s12**3*S13**(-1)*S24**(-1) - 16*s12**2*s14*S13**(-1)*
     +    S24**(-1) - 4*s12*s14**2*S13**(-1)*S24**(-1) - 12*s12*s14*
     +    S13**(-1) + 8*s12 + 26*s13 + 46*s14 - 32*s23 )

      LA34 = LA34 + log(s24**(-1)*s234)*S34**(-1)*S234**(-2) * (  - 40*
     +    s12*s23 - 40*s13*s23 - 40*s14*s23 )

      LA34 = LA34 + log(s24**(-1)*s234)*S34**(-1)*S134**(-1) * (  - 16*
     +    s12**2*s23*S13**(-1)*S24**(-1) - 32*s12**2*S13**(-1) - 6*s12*
     +    s13*S24**(-1) + 8*s12*s23**2*S13**(-1)*S24**(-1) + 8*s12*s23*
     +    S13**(-1) + 16*s12*s23*S24**(-1) + 4*s12*s24*S13**(-1) - 12*
     +    s12 - 32*s13 + 36*s23 + 20*s24 )

      LA34 = LA34 + log(s24**(-1)*s234)*S34**(-1) * ( 48 + 12*s12**2*
     +    S13**(-1)*S24**(-1) - 14*s12*s14*S13**(-1)*S24**(-1) - 16*s12
     +    *s23*S13**(-1)*S24**(-1) - 4*s12*S13**(-1) + 14*s12*S24**(-1)
     +     - 4*s14**2*S13**(-1)*S24**(-1) - 16*s14*s23*S13**(-1)*
     +    S24**(-1) - 16*s14*S13**(-1) )

      LA34 = LA34 + log(s24**(-1)*s234)*S234**(-1)*S134**(-1) * (  - 12
     +    *s12**3*S13**(-1)*S24**(-1) + 16*s12**2*s14*S13**(-1)*
     +    S24**(-1) + 48*s12**2*S13**(-1) + 16*s12**2*S24**(-1) - 22*
     +    s12*s13*S24**(-1) + 14*s12*s14*s23*S13**(-1)*S24**(-1) + 54*
     +    s12*s14*S13**(-1) - 28*s12*s14*S24**(-1) - 28*s12*s23*
     +    S13**(-1) + 14*s12*s23*S24**(-1) + 122*s12 - 70*s13 - 8*
     +    s14**2*s23*S13**(-1)*S24**(-1) - 8*s14**2*S13**(-1) + 8*s14*
     +    s23*S13**(-1) - 8*s14*s23*S24**(-1) + 32*s14*s24*S13**(-1) - 
     +    98*s14 + 72*s23 + 32*s24 )

      LA34 = LA34 + log(s24**(-1)*s234)*S234**(-1) * ( 68 + 8*s12**2*
     +    S13**(-1)*S24**(-1) + 14*s12*s14*S13**(-1)*S24**(-1) + 24*s12
     +    *s23*S13**(-1)*S24**(-1) + 40*s12*S13**(-1) + 38*s12*
     +    S24**(-1) + 24*s13*S24**(-1) + 8*s14**2*S13**(-1)*S24**(-1)
     +     + 24*s14*s23*S13**(-1)*S24**(-1) + 48*s14*S13**(-1) + 24*s14
     +    *S24**(-1) + 32*s23*S13**(-1) + 64*s24*S13**(-1) )

      LA34 = LA34 + log(s24**(-1)*s234)*S234**(-2) * (  - 24*s12*s23*
     +    S24**(-1) - 24*s13*s23*S24**(-1) - 24*s14*s23*S24**(-1) )

      LA34 = LA34 + log(s24**(-1)*s234)*S134**(-1) * (  - 108 + 8*s12*
     +    s23*S13**(-1)*S24**(-1) + 48*s12*S13**(-1) - 28*s12*S24**(-1)
     +     - 8*s14*s23*S13**(-1)*S24**(-1) + 8*s14*S13**(-1) )

      LA34 = LA34 + log(s34**(-1)*s234)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 64*s12**2 - 96*s12*s13 - 64*s12*s23 - 24*s13**2 + 32*s13
     +    *s23 - 32*s23**2 )

      LA34 = LA34 + log(s34**(-1)*s234)*S34**(-1)*S234**(-1) * ( 16*
     +    s12**2*S13**(-1) + 16*s12*s14*S13**(-1) + 16*s12*s23*
     +    S13**(-1) - 128*s12 - 136*s13 + 16*s14**2*S13**(-1) + 8*s14*
     +    s23*S13**(-1) - 48*s14 + 16*s23**2*S13**(-1) + 136*s23 )

      LA34 = LA34 + log(s34**(-1)*s234)*S34**(-1)*S234**(-2) * ( 104*
     +    s12*s23 + 104*s13*s23 + 104*s14*s23 )

      LA34 = LA34 + log(s34**(-1)*s234)*S34**(-1)*S134**(-1) * (  - 64*
     +    s12 - 32*s13 - 64*s23 - 32*s24 )

      LA34 = LA34 + log(s34**(-1)*s234)*S34**(-1) * (  - 120 + 16*s12*
     +    s14*S13**(-1)*S24**(-1) + 16*s12*S13**(-1) + 32*s12*S24**(-1)
     +     + 20*s13*S24**(-1) + 4*s14**2*S13**(-1)*S24**(-1) + 8*s14*
     +    s23*S13**(-1)*S24**(-1) + 56*s14*S13**(-1) + 24*s14*S24**(-1)
     +     + 16*s23*S13**(-1) + 48*s23*S24**(-1) + 16*s24*S13**(-1) )

      LA34 = LA34 + log(s34**(-1)*s234)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * (  - 64*s12*s13*s23 )

      LA34 = LA34 + log(s34**(-1)*s234)*S34**(-2)*S234**(-1) * (  - 64*
     +    s13*s23 + 64*s23**2 )

      LA34 = LA34 + log(s34**(-1)*s234)*S34**(-2)*S234**(-2) * ( 112*
     +    s12*s23**2 + 112*s13*s23**2 + 112*s14*s23**2 )

      LA34 = LA34 + log(s34**(-1)*s234)*S34**(-2)*S134**(-1) * (  - 64*
     +    s13*s23 )

      LA34 = LA34 + log(s34**(-1)*s234)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3*S13**(-1)*S24**(-1) + 40*s12**2*s14*S13**(-1)*
     +    S24**(-1) - 40*s12**2*s34*S13**(-1)*S24**(-1) - 32*s12**2*
     +    S13**(-1) + 40*s12**2*S24**(-1) - 22*s12*s13*S24**(-1) - 8*
     +    s12*s14**2*S13**(-1)*S24**(-1) + 38*s12*s14*s23*S13**(-1)*
     +    S24**(-1) + 16*s12*s14*s24*S13**(-1)*S24**(-1) - 24*s12*s14*
     +    s34*S13**(-1)*S24**(-1) + 22*s12*s14*S13**(-1) - 40*s12*s14*
     +    S24**(-1) - 32*s12*s23*S13**(-1) + 38*s12*s23*S24**(-1) + 16*
     +    s12*s24*s34*S13**(-1)*S24**(-1) + 16*s12*s24*S24**(-1) - 16*
     +    s12*s34**2*S13**(-1)*S24**(-1) - 16*s12*s34*S24**(-1) + 102*
     +    s12 + 88*s13 - 44*s14*s23*S13**(-1) - 44*s14*s24*S13**(-1) + 
     +    92*s14 - 16*s23**2*S13**(-1) - 92*s23 - 44*s24 )

      LA34 = LA34 + log(s34**(-1)*s234)*S234**(-1) * ( 4 - 24*s12**2*
     +    S13**(-1)*S24**(-1) + 6*s12*s14*S13**(-1)*S24**(-1) - 16*s12*
     +    s23*S13**(-1)*S24**(-1) - 24*s12*S13**(-1) - 34*s12*S24**(-1)
     +     - 28*s13*S24**(-1) + 8*s14**2*S13**(-1)*S24**(-1) + 8*s14*
     +    s23*S13**(-1)*S24**(-1) - 4*s14*S13**(-1) - 12*s14*S24**(-1)
     +     + 4*s23*S13**(-1) - 48*s23*S24**(-1) - 12*s24*S13**(-1) )

      LA34 = LA34 + log(s34**(-1)*s234)*S234**(-2) * (  - 28*s12*s23*
     +    S24**(-1) + 68*s12 - 28*s13*s23*S24**(-1) + 68*s13 - 28*s14*
     +    s23*S24**(-1) + 68*s14 )

      LA34 = LA34 + log(s34**(-1)*s234)*S134**(-1) * ( 100 + 16*s12**2*
     +    S13**(-1)*S24**(-1) - 14*s12*s14*S13**(-1)*S24**(-1) + 16*s12
     +    *s23*S13**(-1)*S24**(-1) - 16*s12*S13**(-1) + 18*s12*
     +    S24**(-1) + 4*s14*S13**(-1) - 16*s23*S13**(-1) - 16*s24*
     +    S13**(-1) )

      LA34 = LA34 + log(s34**(-1)*s234) * ( 16*s12*S13**(-1)*S24**(-1)
     +     - 16*s14*S13**(-1)*S24**(-1) - 4*s34*S13**(-1)*S24**(-1) - 4
     +    *S13**(-1) + 24*S24**(-1) )

      LA34 = LA34 + log(s34**(-1)*s134)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 64*s12**2 + 64*s12*s13 + 32*s12*s23 + 32*s13**2 + 32*s13*
     +    s23 + 40*s23**2 )

      LA34 = LA34 + log(s34**(-1)*s134)*S34**(-1)*S234**(-1) * (  - 16*
     +    s12**2*S13**(-1) - 16*s12*s14*S13**(-1) + 96*s12 + 84*s13 - 
     +    16*s14**2*S13**(-1) - 40*s14*s23*S13**(-1) + 28*s14 + 2*
     +    s23**2*S13**(-1) - 88*s23 )

      LA34 = LA34 + log(s34**(-1)*s134)*S34**(-1)*S234**(-2) * (  - 64*
     +    s12*s23 - 64*s13*s23 - 64*s14*s23 )

      LA34 = LA34 + log(s34**(-1)*s134)*S34**(-1)*S134**(-1) * (  - 16*
     +    s12*s13*S24**(-1) + 96*s12 + 18*s13**2*S24**(-1) + 32*s13*s23
     +    *S24**(-1) + 112*s13 + 68*s23 + 100*s24 )

      LA34 = LA34 + log(s34**(-1)*s134)*S34**(-1)*S134**(-2) * ( 56*s12
     +    *s13 + 56*s13*s23 + 56*s13*s24 )

      LA34 = LA34 + log(s34**(-1)*s134)*S34**(-1) * ( 88 - 16*s12**2*
     +    S13**(-1)*S24**(-1) - 32*s12*s14*S13**(-1)*S24**(-1) - 16*s12
     +    *s23*S13**(-1)*S24**(-1) - 48*s12*S13**(-1) - 48*s12*
     +    S24**(-1) - 70*s13*S24**(-1) - 20*s14**2*S13**(-1)*S24**(-1)
     +     + 24*s14*s23*S13**(-1)*S24**(-1) - 8*s14*S13**(-1) - 38*s14*
     +    S24**(-1) - 16*s23**2*S13**(-1)*S24**(-1) - 48*s23*S13**(-1)
     +     + 32*s23*S24**(-1) - 48*s24*S13**(-1) )

      LA34 = LA34 + log(s34**(-1)*s134)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * ( 64*s12*s13*s23 )

      LA34 = LA34 + log(s34**(-1)*s134)*S34**(-2)*S234**(-1) * (  - 64*
     +    s12*s23 - 64*s14*s23 - 64*s23**2 )

      LA34 = LA34 + log(s34**(-1)*s134)*S34**(-2)*S234**(-2) * (  - 64*
     +    s12*s23**2 - 64*s13*s23**2 - 64*s14*s23**2 )

      LA34 = LA34 + log(s34**(-1)*s134)*S34**(-2)*S134**(-1) * ( 64*s12
     +    *s13 + 128*s13*s23 + 64*s13*s24 )

      LA34 = LA34 + log(s34**(-1)*s134)*S34**(-2)*S134**(-2) * ( 48*s12
     +    *s13**2 + 48*s13**2*s23 + 48*s13**2*s24 )

      LA34 = LA34 + log(s34**(-1)*s134)*S34**(-2) * ( 64*s13 - 64*s23 )

      LA34 = LA34 + log(s34**(-1)*s134)*S234**(-1)*S134**(-1) * (  - 16
     +    *s12**3*S13**(-1)*S24**(-1) + 48*s12**2*s14*S13**(-1)*
     +    S24**(-1) + 48*s12**2*S24**(-1) - 120*s12*s13*S24**(-1) + 22*
     +    s12*s14*s23*S13**(-1)*S24**(-1) - 56*s12*s14*S13**(-1) - 128*
     +    s12*s14*S24**(-1) - 10*s12*s23*S13**(-1) + 22*s12*s23*
     +    S24**(-1) + 184*s12 + 78*s13**2*S24**(-1) + 96*s13*s14*
     +    S24**(-1) - 54*s13*s23*S24**(-1) - 78*s13 + 24*s14**2*s23*
     +    S13**(-1)*S24**(-1) + 24*s14**2*S13**(-1) - 8*s14*s23*
     +    S13**(-1) - 30*s14*s23*S24**(-1) + 20*s14*s24*S13**(-1) - 38*
     +    s14 - 2*s23**2*S13**(-1) + 92*s23 + 20*s24 )

      LA34 = LA34 + log(s34**(-1)*s134)*S234**(-1) * ( 4 - 48*s12**2*
     +    S13**(-1)*S24**(-1) + 24*s12*s14*S13**(-1)*S24**(-1) + 34*s12
     +    *s23*S13**(-1)*S24**(-1) + 40*s12*S13**(-1) + 176*s12*
     +    S24**(-1) - 34*s13*S24**(-1) + 4*s14**2*S13**(-1)*S24**(-1)
     +     - 4*s14*s23*S13**(-1)*S24**(-1) - 44*s14*S13**(-1) + 10*s14*
     +    S24**(-1) + 16*s23*S24**(-1) )

      LA34 = LA34 + log(s34**(-1)*s134)*S234**(-2) * ( 28*s12*s23*
     +    S24**(-1) - 68*s12 + 28*s13*s23*S24**(-1) - 68*s13 + 28*s14*
     +    s23*S24**(-1) - 68*s14 )

      LA34 = LA34 + log(s34**(-1)*s134)*S134**(-1) * ( 8 + 48*s12*s14*
     +    S13**(-1)*S24**(-1) + 6*s12*s23*S13**(-1)*S24**(-1) + 32*s12*
     +    S13**(-1) - 80*s12*S24**(-1) + 64*s13*S24**(-1) + 28*s14*s23*
     +    S13**(-1)*S24**(-1) - 4*s14*S13**(-1) - 16*s14*S24**(-1) + 12
     +    *s23**2*S13**(-1)*S24**(-1) + 32*s23*S13**(-1) - 40*s23*
     +    S24**(-1) + 32*s24*S13**(-1) )

      LA34 = LA34 + log(s34**(-1)*s134)*S134**(-2) * ( 8*s12 + 8*s23 + 
     +    8*s24 )

      LA34 = LA34 + log(s34**(-1)*s134) * (  - 160*s12*S13**(-1)*
     +    S24**(-1) - 32*s14*S13**(-1)*S24**(-1) - 48*s23*S13**(-1)*
     +    S24**(-1) - 48*s34*S13**(-1)*S24**(-1) - 24*S13**(-1) - 32*
     +    S24**(-1) )

      LA34 = LA34 + log(s234**(-1)*s1234)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 64*s12**2 - 64*s12*s13 - 64*s12*s23 - 32*
     +    s13**2 - 32*s23**2 )

      LA34 = LA34 + log(s234**(-1)*s1234)*S34**(-1)*S234**(-1) * ( 12*
     +    s12**3*S13**(-1)*S24**(-1) - 16*s12**2*s14*S13**(-1)*
     +    S24**(-1) + 16*s12**2*S13**(-1) - 4*s12*s14**2*S13**(-1)*
     +    S24**(-1) + 4*s12*s14*S13**(-1) + 16*s12*s23*S13**(-1) - 136*
     +    s12 - 92*s13 + 16*s14**2*S13**(-1) + 56*s14*s23*S13**(-1) - 
     +    16*s14 + 16*s23**2*S13**(-1) + 108*s23 )

      LA34 = LA34 + log(s234**(-1)*s1234)*S34**(-1)*S234**(-2) * ( 64*
     +    s12*s23 + 64*s13*s23 + 64*s14*s23 )

      LA34 = LA34 + log(s234**(-1)*s1234)*S34**(-1)*S134**(-1) * ( 48*
     +    s12**2*s23*S13**(-1)*S24**(-1) + 32*s12**2*S13**(-1) + 16*s12
     +    *s13*S24**(-1) - 8*s12*s23*S13**(-1) - 32*s12*s23*S24**(-1)
     +     - 4*s12*s24*S13**(-1) - 156*s12 - 18*s13**2*S24**(-1) - 20*
     +    s13 - 12*s23**2*S24**(-1) - 212*s23 - 148*s24 )

      LA34 = LA34 + log(s234**(-1)*s1234)*S34**(-1) * (  - 120 + 28*
     +    s12**2*S13**(-1)*S24**(-1) + 40*s12*s14*S13**(-1)*S24**(-1)
     +     + 44*s12*S13**(-1) + 56*s12*S24**(-1) + 70*s13*S24**(-1) + 
     +    20*s14**2*S13**(-1)*S24**(-1) + 24*s14*s23*S13**(-1)*
     +    S24**(-1) + 72*s14*S13**(-1) + 38*s14*S24**(-1) + 24*s23**2*
     +    S13**(-1)*S24**(-1) + 64*s23*S13**(-1) + 48*s23*S24**(-1) + 
     +    56*s24*S13**(-1) )

      LA34 = LA34 + log(s234**(-1)*s1234)*S34**(-2)*S234**(-1)*
     + S134**(-1) * (  - 64*s12*s13*s23 )

      LA34 = LA34 + log(s234**(-1)*s1234)*S34**(-2)*S234**(-1) * ( 64*
     +    s12*s23 + 64*s14*s23 + 64*s23**2 )

      LA34 = LA34 + log(s234**(-1)*s1234)*S34**(-2)*S234**(-2) * ( 64*
     +    s12*s23**2 + 64*s13*s23**2 + 64*s14*s23**2 )

      LA34 = LA34 + log(s234**(-1)*s1234)*S34**(-2)*S134**(-1) * (  - 
     +    64*s12*s13 - 128*s13*s23 - 64*s13*s24 )

      LA34 = LA34 + log(s234**(-1)*s1234)*S34**(-2) * (  - 64*s13 + 64*
     +    s23 )

      LA34 = LA34 + log(s234**(-1)*s1234)*S234**(-1)*S134**(-1) * ( 16*
     +    s12**3*S13**(-1)*S24**(-1) + 16*s12**2*s14*S13**(-1)*
     +    S24**(-1) - 32*s12**2*S13**(-1) + 16*s12**2*S24**(-1) + 8*s12
     +    *s13*S24**(-1) + 8*s12*s14*s23*S13**(-1)*S24**(-1) + 56*s12*
     +    s14*S13**(-1) + 16*s12*s14*S24**(-1) - 32*s12*s23*S13**(-1)
     +     + 8*s12*s23*S24**(-1) - 8*s12 - 30*s13**2*S24**(-1) - 48*s13
     +    *s14*S24**(-1) + 30*s13*s23*S24**(-1) + 62*s13 - 12*s14**2*
     +    s23*S13**(-1)*S24**(-1) - 12*s14**2*S13**(-1) - 16*s14*s23*
     +    S13**(-1) + 18*s14*s23*S24**(-1) - 32*s14*s24*S13**(-1) + 66*
     +    s14 - 16*s23**2*S13**(-1) - 64*s23 - 32*s24 )

      LA34 = LA34 + log(s234**(-1)*s1234)*S234**(-1) * ( 8 - 16*s12**2*
     +    S13**(-1)*S24**(-1) - 40*s12*s14*S13**(-1)*S24**(-1) - 16*s12
     +    *s23*S13**(-1)*S24**(-1) - 40*s12*S13**(-1) - 72*s12*
     +    S24**(-1) - 14*s13*S24**(-1) - 4*s14**2*S13**(-1)*S24**(-1)
     +     + 8*s14*s23*S13**(-1)*S24**(-1) + 32*s14*S13**(-1) - 10*s14*
     +    S24**(-1) - 24*s23*S24**(-1) )

      LA34 = LA34 + log(s234**(-1)*s1234)*S234**(-2) * (  - 28*s12*s23*
     +    S24**(-1) + 68*s12 - 28*s13*s23*S24**(-1) + 68*s13 - 28*s14*
     +    s23*S24**(-1) + 68*s14 )

      LA34 = LA34 + log(s234**(-1)*s1234)*S134**(-1) * (  - 12 + 32*
     +    s12**2*S13**(-1)*S24**(-1) - 60*s12*s14*S13**(-1)*S24**(-1)
     +     + 48*s12*s23*S13**(-1)*S24**(-1) - 16*s12*S13**(-1) + 20*s12
     +    *S24**(-1) - 48*s13*S24**(-1) + 32*s14**2*S13**(-1)*S24**(-1)
     +     - 40*s14*s23*S13**(-1)*S24**(-1) - 24*s14*S13**(-1) + 48*s14
     +    *S24**(-1) - 8*s23**2*S13**(-1)*S24**(-1) - 48*s23*S13**(-1)
     +     - 32*s23*S24**(-1) - 40*s24*S13**(-1) )

      LA34 = LA34 + log(s234**(-1)*s1234) * ( 108*s12*S13**(-1)*
     +    S24**(-1) + 48*s14*S13**(-1)*S24**(-1) + 32*s23*S13**(-1)*
     +    S24**(-1) + 40*s34*S13**(-1)*S24**(-1) - 8*S13**(-1) + 112*
     +    S24**(-1) )

      LA34 = LA34 + log(s134**(-1)*s1234)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 64*s12**2 + 64*s12*s13 + 64*s12*s23 + 32*s13**2
     +     + 32*s23**2 )

      LA34 = LA34 + log(s134**(-1)*s1234)*S34**(-1)*S234**(-1) * ( 48*
     +    s12**2*s14*S13**(-1)*S24**(-1) - 16*s12**2*S13**(-1) + 32*
     +    s12**2*S24**(-1) - 4*s12*s13*S24**(-1) - 48*s12*s14*S13**(-1)
     +     - 8*s12*s14*S24**(-1) - 16*s12*s23*S13**(-1) + 68*s12 + 32*
     +    s13 - 28*s14**2*S13**(-1) - 40*s14*s23*S13**(-1) - 56*s14 - 
     +    16*s23**2*S13**(-1) - 68*s23 )

      LA34 = LA34 + log(s134**(-1)*s1234)*S34**(-1)*S234**(-2) * (  - 
     +    64*s12*s23 - 64*s13*s23 - 64*s14*s23 )

      LA34 = LA34 + log(s134**(-1)*s1234)*S34**(-1)*S134**(-1) * ( 12*
     +    s12**3*S13**(-1)*S24**(-1) - 16*s12**2*s23*S13**(-1)*
     +    S24**(-1) - 16*s12*s13*S24**(-1) - 4*s12*s23**2*S13**(-1)*
     +    S24**(-1) - 12*s12*s23*S24**(-1) + 24*s12 + 18*s13**2*
     +    S24**(-1) - 16*s13*s23*S24**(-1) - 20*s13 + 76*s23 + 24*s24 )

      LA34 = LA34 + log(s134**(-1)*s1234)*S34**(-1) * ( 136 + 12*s12**2
     +    *S13**(-1)*S24**(-1) - 32*s12*s14*S13**(-1)*S24**(-1) + 8*s12
     +    *s23*S13**(-1)*S24**(-1) - 8*s12*S13**(-1) - 20*s12*S24**(-1)
     +     - 30*s13*S24**(-1) + 4*s14**2*S13**(-1)*S24**(-1) + 40*s14*
     +    s23*S13**(-1)*S24**(-1) + 56*s14*S13**(-1) + 10*s14*S24**(-1)
     +     - 16*s23*S13**(-1) + 32*s23*S24**(-1) - 16*s24*S13**(-1) )

      LA34 = LA34 + log(s134**(-1)*s1234)*S34**(-2)*S234**(-1)*
     + S134**(-1) * ( 64*s12*s13*s23 )

      LA34 = LA34 + log(s134**(-1)*s1234)*S34**(-2)*S234**(-1) * ( 64*
     +    s13*s23 - 64*s23**2 )

      LA34 = LA34 + log(s134**(-1)*s1234)*S34**(-2)*S234**(-2) * (  - 
     +    64*s12*s23**2 - 64*s13*s23**2 - 64*s14*s23**2 )

      LA34 = LA34 + log(s134**(-1)*s1234)*S34**(-2)*S134**(-1) * ( 64*
     +    s13*s23 )

      LA34 = LA34 + log(s134**(-1)*s1234)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12**3*S13**(-1)*S24**(-1) - 16*s12**2*s14*S13**(-1)*
     +    S24**(-1) + 32*s12**2*S13**(-1) - 16*s12**2*S24**(-1) - 8*s12
     +    *s13*S24**(-1) - 8*s12*s14*s23*S13**(-1)*S24**(-1) - 56*s12*
     +    s14*S13**(-1) - 16*s12*s14*S24**(-1) + 32*s12*s23*S13**(-1)
     +     - 8*s12*s23*S24**(-1) + 8*s12 + 30*s13**2*S24**(-1) + 48*s13
     +    *s14*S24**(-1) - 30*s13*s23*S24**(-1) - 62*s13 + 12*s14**2*
     +    s23*S13**(-1)*S24**(-1) + 12*s14**2*S13**(-1) + 16*s14*s23*
     +    S13**(-1) - 18*s14*s23*S24**(-1) + 32*s14*s24*S13**(-1) - 66*
     +    s14 + 16*s23**2*S13**(-1) + 64*s23 + 32*s24 )

      LA34 = LA34 + log(s134**(-1)*s1234)*S234**(-1) * (  - 60 + 32*
     +    s12**2*S13**(-1)*S24**(-1) + 56*s12*s14*S13**(-1)*S24**(-1)
     +     - 12*s12*s23*S13**(-1)*S24**(-1) + 28*s12*S13**(-1) + 64*s12
     +    *S24**(-1) - 10*s13*S24**(-1) - 4*s14**2*S13**(-1)*S24**(-1)
     +     - 32*s14*s23*S13**(-1)*S24**(-1) - 64*s14*S13**(-1) - 22*s14
     +    *S24**(-1) + 32*s23**2*S13**(-1)*S24**(-1) + 48*s23*S13**(-1)
     +     + 8*s23*S24**(-1) )

      LA34 = LA34 + log(s134**(-1)*s1234)*S234**(-2) * ( 28*s12*s23*
     +    S24**(-1) - 68*s12 + 28*s13*s23*S24**(-1) - 68*s13 + 28*s14*
     +    s23*S24**(-1) - 68*s14 )

      LA34 = LA34 + log(s134**(-1)*s1234)*S134**(-1) * (  - 80 - 16*
     +    s12**2*S13**(-1)*S24**(-1) + 32*s12*s14*S13**(-1)*S24**(-1)
     +     - 32*s12*s23*S13**(-1)*S24**(-1) + 8*s12*S13**(-1) - 32*s12*
     +    S24**(-1) + 48*s13*S24**(-1) + 16*s14*s23*S13**(-1)*S24**(-1)
     +     + 8*s14*S13**(-1) + 16*s23*S13**(-1) - 16*s23*S24**(-1) + 16
     +    *s24*S13**(-1) )

      LA34 = LA34 + log(s134**(-1)*s1234) * (  - 52*s12*S13**(-1)*
     +    S24**(-1) + 16*s23*S13**(-1)*S24**(-1) - 4*s34*S13**(-1)*
     +    S24**(-1) + 64*S13**(-1) - 56*S24**(-1) )

      LA34 = LA34 + Lc0(p13,p24)*S34**(-1)*S234**(-1) * ( 16*s12**4*
     +    S13**(-1)*S24**(-1) - 64*s12**3*s14*S13**(-1)*S24**(-1) - 32*
     +    s12**3*S13**(-1) - 16*s12**3*S24**(-1) + 16*s12**2*s14**2*
     +    S13**(-1)*S24**(-1) + 48*s12**2*s14*S13**(-1) + 32*s12**2*s14
     +    *S24**(-1) - 24*s12**2*s23*S13**(-1) - 88*s12**2 - 8*s12*s13
     +     + 32*s12*s14**2*S13**(-1) + 8*s12*s14**2*S24**(-1) + 8*s12*
     +    s14*s23*S13**(-1) + 96*s12*s14 - 8*s12*s23**2*S13**(-1) - 24*
     +    s12*s23 - 32*s13*s23 + 8*s14**3*S13**(-1) + 16*s14**2*s23*
     +    S13**(-1) - 8*s14**2 + 8*s14*s23**2*S13**(-1) - 16*s14*s23 - 
     +    8*s23**2 )

      LA34 = LA34 + Lc0(p13,p24)*S34**(-1)*S134**(-1) * ( 16*s12**4*
     +    S13**(-1)*S24**(-1) - 64*s12**3*s23*S13**(-1)*S24**(-1) - 16*
     +    s12**3*S13**(-1) - 32*s12**3*S24**(-1) + 24*s12**2*s13*
     +    S24**(-1) + 16*s12**2*s23**2*S13**(-1)*S24**(-1) + 32*s12**2*
     +    s23*S13**(-1) + 48*s12**2*s23*S24**(-1) - 88*s12**2 - 8*s12*
     +    s13**2*S24**(-1) - 8*s12*s13*s23*S24**(-1) + 24*s12*s13 + 8*
     +    s12*s23**2*S13**(-1) + 32*s12*s23**2*S24**(-1) + 96*s12*s23
     +     - 8*s12*s24 + 8*s13**2*s23*S24**(-1) - 8*s13**2 - 16*s13*
     +    s23**2*S24**(-1) + 16*s13*s23 + 32*s13*s24 + 8*s23**3*
     +    S24**(-1) - 8*s23**2 )

      LA34 = LA34 + Lc0(p13,p24)*S34**(-1) * ( 80*s12**3*S13**(-1)*
     +    S24**(-1) - 8*s12**2*s14*S13**(-1)*S24**(-1) - 8*s12**2*s23*
     +    S13**(-1)*S24**(-1) + 8*s12**2*S13**(-1) - 16*s12**2*
     +    S24**(-1) + 8*s12*s13*S24**(-1) + 16*s12*s14**2*S13**(-1)*
     +    S24**(-1) - 16*s12*s14*s23*S13**(-1)*S24**(-1) + 8*s12*s14*
     +    S13**(-1) + 16*s12*s23**2*S13**(-1)*S24**(-1) + 8*s12*s23*
     +    S13**(-1) + 16*s12*s23*S24**(-1) - 64*s12 + 24*s13 + 8*s14*
     +    s23*S13**(-1) + 16*s14*s23*S24**(-1) + 8*s14*s24*S13**(-1) - 
     +    24*s14 + 16*s23**2*S24**(-1) - 32*s23 - 16*s24 )

      LA34 = LA34 + Lc0(p13,p24)*S234**(-1) * (  - 32*s12**3*S13**(-1)*
     +    S24**(-1) + 48*s12**2*s14*S13**(-1)*S24**(-1) + 8*s12**2*s23*
     +    S13**(-1)*S24**(-1) + 8*s12**2*S24**(-1) + 8*s12*s13*
     +    S24**(-1) + 32*s12*s14**2*S13**(-1)*S24**(-1) - 32*s12*s14*
     +    s23*S13**(-1)*S24**(-1) + 8*s12*s14*S24**(-1) - 8*s12*s23*
     +    S13**(-1) - 8*s12*s23*S24**(-1) + 56*s12 - 16*s13*s23*
     +    S24**(-1) + 8*s13 + 8*s14**3*S13**(-1)*S24**(-1) + 8*s14*s23*
     +    S13**(-1) - 24*s14*s23*S24**(-1) - 16*s14 - 8*s23 + 8*s24 )

      LA34 = LA34 + Lc0(p13,p24)*S134**(-1) * (  - 32*s12**3*S13**(-1)*
     +    S24**(-1) + 8*s12**2*s14*S13**(-1)*S24**(-1) + 48*s12**2*s23*
     +    S13**(-1)*S24**(-1) + 8*s12**2*S13**(-1) + 24*s12**2*
     +    S24**(-1) - 8*s12*s13*S24**(-1) - 32*s12*s14*s23*S13**(-1)*
     +    S24**(-1) - 8*s12*s14*S13**(-1) + 32*s12*s23**2*S13**(-1)*
     +    S24**(-1) + 8*s12*s23*S13**(-1) - 8*s12*s23*S24**(-1) + 8*s12
     +    *s24*S13**(-1) + 80*s12 + 8*s13*s23*S24**(-1) - 24*s14*s23*
     +    S13**(-1) - 16*s14*s24*S13**(-1) + 8*s23**3*S13**(-1)*
     +    S24**(-1) - 16*s23**2*S24**(-1) + 40*s24 )

      LA34 = LA34 + Lc0(p13,p24) * (  - 32 + 16*s12**2*S13**(-1)*
     +    S24**(-1) + 72*s12*s14*S13**(-1)*S24**(-1) + 72*s12*s23*
     +    S13**(-1)*S24**(-1) + 40*s12*s34*S13**(-1)*S24**(-1) + 24*
     +    s14**2*S13**(-1)*S24**(-1) + 48*s14*s23*S13**(-1)*S24**(-1)
     +     + 24*s14*s34*S13**(-1)*S24**(-1) - 8*s14*S13**(-1) + 24*
     +    s23**2*S13**(-1)*S24**(-1) + 24*s23*s34*S13**(-1)*S24**(-1)
     +     - 8*s23*S24**(-1) + 8*s34**2*S13**(-1)*S24**(-1) )

      LA34 = LA34 + Lc1(p1,p34)*S34**(-1)*S234**(-1)*S134**(-1) * ( 64*
     +    s12*s13*s23 )

      LA34 = LA34 + Lc1(p1,p34)*S34**(-1)*S134**(-1) * (  - 24*s12*s13
     +     - 96*s13**2 + 32*s13*s23 - 48*s13*s24 )

      LA34 = LA34 + Lc1(p1,p34)*S34**(-2)*S134**(-1) * (  - 48*s12*
     +    s13**2 - 48*s13**2*s23 - 48*s13**2*s24 )

      LA34 = LA34 + Lc1(p1,p34)*S234**(-1)*S134**(-1) * ( 32*s12**3*s23
     +    *S13**(-1)*S24**(-1) + 32*s12**3*S13**(-1) - 28*s12**2*s23**2
     +    *S13**(-1)*S24**(-1) - 72*s12**2*s23*S13**(-1) - 64*s12**2*
     +    s23*S24**(-1) - 44*s12**2*s24*S13**(-1) + 64*s12**2 + 48*s12*
     +    s13*s23*S24**(-1) + 48*s12*s13 + 40*s12*s23**2*S24**(-1) + 28
     +    *s12*s23 - 52*s12*s24 - 16*s13**2*s23*S24**(-1) + 16*s13**2
     +     - 12*s13*s23**2*S24**(-1) - 24*s13*s23 + 4*s13*s24 )

      LA34 = LA34 + Lc1(p1,p34)*S134**(-1) * (  - 32*s12**3*S13**(-1)*
     +    S24**(-1) + 28*s12**2*s23*S13**(-1)*S24**(-1) - 44*s12**2*s34
     +    *S13**(-1)*S24**(-1) + 44*s12**2*S13**(-1) + 32*s12**2*
     +    S24**(-1) - 16*s12*s13*S24**(-1) - 8*s12*s23*s34*S13**(-1)*
     +    S24**(-1) - 68*s12*s23*S24**(-1) - 16*s12*s34**2*S13**(-1)*
     +    S24**(-1) + 56*s12*s34*S24**(-1) + 80*s12 + 60*s13*s23*
     +    S24**(-1) - 20*s13*s34*S24**(-1) + 24*s13 - 12*s23**2*
     +    S24**(-1) - 8*s23*s34*S24**(-1) + 16*s23 + 16*s34**2*
     +    S24**(-1) + 16*s34 )

      LA34 = LA34 + Lc1(p1,p234)*S34**(-1)*S234**(-1) * (  - 16*s13*s23
     +     )

      LA34 = LA34 + Lc1(p1,p234)*S34**(-1)*S134**(-1) * (  - 16*s13**2*
     +    s23*S24**(-1) + 48*s13**2 + 16*s13*s23**2*S24**(-1) + 52*s13*
     +    s23 + 68*s13*s24 )

      LA34 = LA34 + Lc1(p1,p234)*S34**(-1) * (  - 80*s13*s23*S24**(-1)
     +     - 56*s13 - 48*s14**2*s23*S13**(-1)*S24**(-1) - 64*s14**2*
     +    S13**(-1) + 28*s14*s23**2*S13**(-1)*S24**(-1) + 72*s14*s23*
     +    S13**(-1) - 144*s14*s23*S24**(-1) + 44*s14*s24*S13**(-1) - 80
     +    *s14 + 24*s23**2*S24**(-1) + 108*s23 + 64*s24 )

      LA34 = LA34 + Lc1(p1,p234)*S34**(-2)*S134**(-1) * ( 16*s13**2*s23
     +     + 16*s13**2*s24 )

      LA34 = LA34 + Lc1(p1,p234)*S34**(-2) * (  - 16*s13*s23 )

      LA34 = LA34 + Lc1(p1,p234)*S234**(-1) * (  - 8*s13*s23*S24**(-1)
     +     - 32*s13 )

      LA34 = LA34 + Lc1(p1,p234)*S134**(-1) * (  - 56*s13*s14*S24**(-1)
     +     + 44*s13*s23*S24**(-1) + 72*s13 - 36*s14**3*S13**(-1)*
     +    S24**(-1) + 32*s14**2*s23*S13**(-1)*S24**(-1) + 64*s14**2*
     +    S13**(-1) - 92*s14**2*S24**(-1) + 4*s14*s23**2*S13**(-1)*
     +    S24**(-1) - 8*s14*s23*S13**(-1) + 80*s14*s23*S24**(-1) - 12*
     +    s14*s24*S13**(-1) + 68*s14 + 8*s23**2*S24**(-1) - 52*s23 - 8*
     +    s24 )

      LA34 = LA34 + Lc1(p1,p234) * (  - 48*s13*S24**(-1) - 12*s14**2*
     +    S13**(-1)*S24**(-1) + 48*s14*s23*S13**(-1)*S24**(-1) + 16*s14
     +    *s34*S13**(-1)*S24**(-1) + 48*s14*S13**(-1) - 40*s14*
     +    S24**(-1) + 8*s23*S24**(-1) + 32*s34*S24**(-1) )

      LA34 = LA34 + Lc1(p2,p34)*S34**(-1)*S234**(-1)*S134**(-1) * ( 64*
     +    s12*s13*s23 )

      LA34 = LA34 + Lc1(p2,p34)*S34**(-1)*S234**(-1) * (  - 8*s12*s23
     +     + 64*s13*s23 - 16*s14*s23 - 96*s23**2 )

      LA34 = LA34 + Lc1(p2,p34)*S34**(-2)*S234**(-1) * (  - 48*s12*
     +    s23**2 - 48*s13*s23**2 - 48*s14*s23**2 )

      LA34 = LA34 + Lc1(p2,p34)*S234**(-1)*S134**(-1) * (  - 32*s12**3*
     +    s34*S13**(-1)*S24**(-1) - 16*s12**2*s14*s34*S13**(-1)*
     +    S24**(-1) - 64*s12**2*s14*S13**(-1) - 44*s12**2*s34**2*
     +    S13**(-1)*S24**(-1) - 16*s12**2*s34*S24**(-1) + 64*s12**2 - 
     +    16*s12*s13 - 8*s12*s14**2*s34*S13**(-1)*S24**(-1) + 28*s12*
     +    s14**2*S13**(-1) - 48*s12*s14*s23*S13**(-1) - 24*s12*s14*
     +    s34**2*S13**(-1)*S24**(-1) - 8*s12*s14*s34*S24**(-1) + 4*s12*
     +    s14 + 16*s12*s23 - 16*s12*s34**3*S13**(-1)*S24**(-1) - 16*s12
     +    *s34**2*S24**(-1) + 4*s13*s23 + 4*s14**2*s23*S13**(-1) - 16*
     +    s14*s23**2*S13**(-1) + 24*s14*s23 + 16*s23**2 )

      LA34 = LA34 + Lc1(p2,p34)*S234**(-1) * ( 32*s12**2*S13**(-1) - 56
     +    *s12*s14*S13**(-1) + 16*s12*s23*S13**(-1) + 52*s12*s34*
     +    S13**(-1) + 92*s12 - 4*s13 - 12*s14**2*S13**(-1) - 52*s14*s23
     +    *S13**(-1) + 12*s14 + 20*s23*s34*S13**(-1) + 16*s23 + 12*
     +    s34**2*S13**(-1) + 8*s34 )

      LA34 = LA34 + Lc1(p2,p134)*S34**(-1)*S234**(-1) * ( 12*s13*s23 - 
     +    16*s14**2*s23*S13**(-1) - 16*s14*s23**2*S13**(-1) + 28*s14*
     +    s23 + 48*s23**2 )

      LA34 = LA34 + Lc1(p2,p134)*S34**(-1)*S134**(-1) * (  - 16*s13*s23
     +     )

      LA34 = LA34 + Lc1(p2,p134)*S34**(-1) * (  - 4*s13*s23*S24**(-1)
     +     + 60*s13 + 28*s14**2*s23*S13**(-1)*S24**(-1) + 72*s14**2*
     +    S13**(-1) - 48*s14*s23**2*S13**(-1)*S24**(-1) - 128*s14*s23*
     +    S13**(-1) + 8*s14*s23*S24**(-1) - 112*s14*s24*S13**(-1) + 136
     +    *s14 - 96*s23**2*S24**(-1) - 120*s23 - 64*s24 )

      LA34 = LA34 + Lc1(p2,p134)*S34**(-2)*S234**(-1) * ( 16*s13*s23**2
     +     + 16*s14*s23**2 )

      LA34 = LA34 + Lc1(p2,p134)*S34**(-2) * ( 48*s13*s23 )

      LA34 = LA34 + Lc1(p2,p134)*S234**(-1) * ( 12*s13*s23*S24**(-1) - 
     +    28*s13 + 4*s14**2*s23*S13**(-1)*S24**(-1) - 8*s14**2*
     +    S13**(-1) + 32*s14*s23**2*S13**(-1)*S24**(-1) + 64*s14*s23*
     +    S13**(-1) + 16*s14*s23*S24**(-1) + 60*s14*s24*S13**(-1) - 56*
     +    s14 - 36*s23**3*S13**(-1)*S24**(-1) - 92*s23**2*S13**(-1) + 
     +    64*s23**2*S24**(-1) - 56*s23*s24*S13**(-1) + 116*s23 + 24*s24
     +     )

      LA34 = LA34 + Lc1(p2,p134)*S134**(-1) * ( 24*s14*s23*S13**(-1) )

      LA34 = LA34 + Lc1(p2,p134) * ( 64 + 8*s14*s23*S13**(-1)*S24**(-1)
     +     + 92*s14*S13**(-1) - 12*s23**2*S13**(-1)*S24**(-1) + 16*s23*
     +    s34*S13**(-1)*S24**(-1) - 40*s23*S13**(-1) - 28*s23*S24**(-1)
     +     - 48*s24*S13**(-1) + 32*s34*S13**(-1) )

      LA34 = LA34 + Lc1(p3,p24)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    40*s12*s13*s24 - 16*s12*s24**2 + 38*s13**2*s24 - 24*s13*
     +    s24**2 - 12*s24**3 )

      LA34 = LA34 + Lc1(p3,p24)*S34**(-1)*S234**(-1) * ( 8*s12*s24 - 54
     +    *s13*s24 + 2*s14*s24 - 8*s24**2 )

      LA34 = LA34 + Lc1(p3,p24)*S234**(-1)*S134**(-1) * (  - 12*s12**3*
     +    S13**(-1) - 4*s12**2*s14*S13**(-1) + 48*s12**2*s24*S13**(-1)
     +     + 48*s12**2 + 4*s12*s14**2*S13**(-1) + 32*s12*s14*s24*
     +    S13**(-1) + 20*s12*s14 + 28*s12*s24**2*S13**(-1) + 88*s12*s24
     +     + 14*s13*s24 - 4*s14**3*S13**(-1) + 20*s14**2*s24*S13**(-1)
     +     - 10*s14**2 + 24*s14*s24**2*S13**(-1) + 6*s14*s24 - 40*
     +    s24**2 )

      LA34 = LA34 + Lc1(p3,p24)*S234**(-1) * (  - 4*s12**2*s34*
     +    S13**(-1)*S24**(-1) + 8*s12**2*S13**(-1) - 8*s12*s14*s34*
     +    S13**(-1)*S24**(-1) + 20*s12*s14*S13**(-1) + 24*s12*s24*
     +    S13**(-1) - 28*s12*s34*S13**(-1) - 24*s12*s34*S24**(-1) - 44*
     +    s12 - 24*s13*s34*S24**(-1) - 48*s13 - 4*s14**2*s34*S13**(-1)*
     +    S24**(-1) + 12*s14**2*S13**(-1) + 4*s14*s24*S13**(-1) - 28*
     +    s14*s34*S13**(-1) - 24*s14*s34*S24**(-1) - 32*s14 + 32*s24**2
     +    *S13**(-1) - 40*s24*s34*S13**(-1) - 44*s24 - 16*s34 )

      LA34 = LA34 + Lc1(p4,p13)*S34**(-1)*S234**(-1)*S134**(-1) * ( 32*
     +    s12**2*s13 + 16*s12*s13**2 - 12*s13**3 + 24*s13**2*s23 + 38*
     +    s13*s23**2 )

      LA34 = LA34 + Lc1(p4,p13)*S34**(-1)*S134**(-1) * ( 16*s12*s13 - 
     +    32*s13**2 - 36*s13*s23 - 16*s13*s24 )

      LA34 = LA34 + Lc1(p4,p13)*S234**(-1)*S134**(-1) * (  - 12*s12**3*
     +    S24**(-1) + 48*s12**2*s13*S24**(-1) - 4*s12**2*s23*S24**(-1)
     +     + 28*s12*s13**2*S24**(-1) + 32*s12*s13*s23*S24**(-1) + 48*
     +    s12*s13 + 4*s12*s23**2*S24**(-1) - 4*s12*s23 + 24*s13**2*s23*
     +    S24**(-1) - 16*s13**2 + 20*s13*s23**2*S24**(-1) + 44*s13*s23
     +     - 24*s13*s24 - 4*s23**3*S24**(-1) - 10*s23**2 )

      LA34 = LA34 + Lc1(p4,p13)*S134**(-1) * (  - 4*s12**2*s34*
     +    S13**(-1)*S24**(-1) + 8*s12**2*S24**(-1) + 24*s12*s13*
     +    S24**(-1) - 8*s12*s23*s34*S13**(-1)*S24**(-1) + 20*s12*s23*
     +    S24**(-1) - 24*s12*s34*S13**(-1) - 28*s12*s34*S24**(-1) - 28*
     +    s12 + 32*s13**2*S24**(-1) + 4*s13*s23*S24**(-1) - 40*s13*s34*
     +    S24**(-1) - 44*s13 - 4*s23**2*s34*S13**(-1)*S24**(-1) + 12*
     +    s23**2*S24**(-1) - 24*s23*s34*S13**(-1) - 28*s23*s34*
     +    S24**(-1) - 32*s23 - 24*s24*s34*S13**(-1) - 48*s24 - 16*s34 )

      LA34 = LA34 + Lc1(p13,p24)*S34**(-1)*S234**(-1) * (  - 16*s12**4*
     +    S13**(-1)*S24**(-1) + 64*s12**3*s14*S13**(-1)*S24**(-1) + 16*
     +    s12**3*S13**(-1) + 8*s12**3*S24**(-1) - 24*s12**2*s14**2*
     +    S13**(-1)*S24**(-1) - 24*s12**2*s14*S13**(-1) - 16*s12**2*s14
     +    *S24**(-1) + 40*s12**2 + 8*s12*s14**3*S13**(-1)*S24**(-1) + 
     +    56*s12*s14**2*S13**(-1) - 8*s12*s14**2*S24**(-1) + 20*s12*s14
     +    *s23*S13**(-1) - 16*s12*s14 + 52*s12*s23 + 8*s13*s23 + 16*
     +    s14**2*s23*S13**(-1) - 8*s14**2 + 24*s14*s23 - 8*s23**2 )

      LA34 = LA34 + Lc1(p13,p24)*S34**(-1)*S134**(-1) * (  - 32*s12**2*
     +    s23**2*S13**(-1)*S24**(-1) - 24*s12**2*s23*S13**(-1) + 32*
     +    s12**2 - 24*s12*s13 + 8*s12*s23**3*S13**(-1)*S24**(-1) - 8*
     +    s12*s23**2*S13**(-1) + 32*s12*s23**2*S24**(-1) - 4*s12*s23 - 
     +    12*s12*s24 - 8*s13**2 + 8*s13*s23 + 8*s13*s24 - 16*s23**3*
     +    S24**(-1) - 40*s23**2 - 16*s23*s24 )

      LA34 = LA34 + Lc1(p13,p24)*S34**(-1) * (  - 32*s12**3*S13**(-1)*
     +    S24**(-1) + 8*s12**2*s14*S13**(-1)*S24**(-1) - 16*s12**2*s23*
     +    S13**(-1)*S24**(-1) + 12*s12**2*S13**(-1) - 56*s12*s14**2*
     +    S13**(-1)*S24**(-1) - 32*s12*s14*s23*S13**(-1)*S24**(-1) + 8*
     +    s12*s14*S13**(-1) - 32*s12*s23**2*S13**(-1)*S24**(-1) + 4*s12
     +    *s23*S13**(-1) - 8*s12*s23*S24**(-1) + 4*s12 - 16*s14**2*s23*
     +    S13**(-1)*S24**(-1) + 8*s14*s23*S13**(-1) - 8*s14*s23*
     +    S24**(-1) + 8*s14*s24*S13**(-1) + 16*s23**3*S13**(-1)*
     +    S24**(-1) + 16*s23**2*S13**(-1) - 16*s24 )

      LA34 = LA34 + Lc1(p13,p24)*S234**(-1) * ( 48*s12**3*S13**(-1)*
     +    S24**(-1) + 24*s12**2*s14*S13**(-1)*S24**(-1) - 12*s12**2*
     +    S13**(-1) + 72*s12*s14**2*S13**(-1)*S24**(-1) + 32*s12*s14*
     +    s23*S13**(-1)*S24**(-1) - 8*s12*s14*S13**(-1) + 8*s12*s23*
     +    S24**(-1) + 16*s12 + 16*s13 + 16*s14**2*s23*S13**(-1)*
     +    S24**(-1) + 8*s14*s23*S24**(-1) - 16*s14 - 8*s23 + 8*s24 )

      LA34 = LA34 + Lc1(p13,p24)*S134**(-1) * (  - 44*s12**2*S13**(-1)
     +     - 16*s12*s14*S13**(-1) + 32*s12*s23**2*S13**(-1)*S24**(-1)
     +     - 36*s12*s23*S13**(-1) - 4*s12*s24*S13**(-1) - 24*s12 - 8*
     +    s13 + 8*s14*s23**2*S13**(-1)*S24**(-1) - 16*s14*s23*S13**(-1)
     +     - 16*s14*s24*S13**(-1) - 16*s23**3*S13**(-1)*S24**(-1) - 16*
     +    s23**2*S13**(-1) + 8*s23 + 40*s24 )

      LA34 = LA34 + Lc1(p13,p24) * ( 8 + 8*s12**2*S13**(-1)*S24**(-1)
     +     + 8*s12*s14*S13**(-1)*S24**(-1) - 12*s12*S13**(-1) - 8*s14*
     +    S13**(-1) )

      LA34 = LA34 + Lc1(p24,p13)*S34**(-1)*S234**(-1) * (  - 32*s12**2*
     +    s14**2*S13**(-1)*S24**(-1) - 24*s12**2*s14*S24**(-1) + 32*
     +    s12**2 - 12*s12*s13 + 8*s12*s14**3*S13**(-1)*S24**(-1) + 32*
     +    s12*s14**2*S13**(-1) - 8*s12*s14**2*S24**(-1) - 4*s12*s14 + 
     +    24*s12*s23 - 16*s13*s14 - 8*s13*s23 - 16*s14**3*S13**(-1) - 
     +    40*s14**2 - 8*s14*s23 - 8*s23**2 )

      LA34 = LA34 + Lc1(p24,p13)*S34**(-1)*S134**(-1) * (  - 16*s12**4*
     +    S13**(-1)*S24**(-1) + 64*s12**3*s23*S13**(-1)*S24**(-1) + 8*
     +    s12**3*S13**(-1) + 16*s12**3*S24**(-1) - 24*s12**2*s23**2*
     +    S13**(-1)*S24**(-1) - 16*s12**2*s23*S13**(-1) - 24*s12**2*s23
     +    *S24**(-1) + 40*s12**2 - 20*s12*s13*s23*S24**(-1) - 52*s12*
     +    s13 + 8*s12*s23**3*S13**(-1)*S24**(-1) - 8*s12*s23**2*
     +    S13**(-1) + 56*s12*s23**2*S24**(-1) - 16*s12*s23 - 8*s13**2
     +     - 16*s13*s23**2*S24**(-1) - 24*s13*s23 - 8*s13*s24 - 8*
     +    s23**2 )

      LA34 = LA34 + Lc1(p24,p13)*S34**(-1) * (  - 32*s12**3*S13**(-1)*
     +    S24**(-1) - 16*s12**2*s14*S13**(-1)*S24**(-1) + 8*s12**2*s23*
     +    S13**(-1)*S24**(-1) + 12*s12**2*S24**(-1) - 32*s12*s14**2*
     +    S13**(-1)*S24**(-1) - 32*s12*s14*s23*S13**(-1)*S24**(-1) - 8*
     +    s12*s14*S13**(-1) + 4*s12*s14*S24**(-1) - 56*s12*s23**2*
     +    S13**(-1)*S24**(-1) + 28*s12*s23*S24**(-1) + 32*s12 + 8*s13*
     +    s23*S24**(-1) + 16*s14**3*S13**(-1)*S24**(-1) + 16*s14**2*
     +    S24**(-1) - 16*s14*s23**2*S13**(-1)*S24**(-1) - 8*s14*s23*
     +    S13**(-1) + 8*s14*s23*S24**(-1) + 16*s23**2*S24**(-1) + 32*
     +    s23 )

      LA34 = LA34 + Lc1(p24,p13)*S234**(-1) * (  - 44*s12**2*S24**(-1)
     +     - 4*s12*s13*S24**(-1) + 32*s12*s14**2*S13**(-1)*S24**(-1) - 
     +    36*s12*s14*S24**(-1) - 16*s12*s23*S24**(-1) - 16*s13*s23*
     +    S24**(-1) + 32*s13 - 16*s14**3*S13**(-1)*S24**(-1) + 8*s14**2
     +    *s23*S13**(-1)*S24**(-1) - 16*s14**2*S24**(-1) - 16*s14*s23*
     +    S24**(-1) - 8*s23 )

      LA34 = LA34 + Lc1(p24,p13)*S134**(-1) * ( 48*s12**3*S13**(-1)*
     +    S24**(-1) + 24*s12**2*s23*S13**(-1)*S24**(-1) - 12*s12**2*
     +    S24**(-1) + 32*s12*s14*s23*S13**(-1)*S24**(-1) + 8*s12*s14*
     +    S13**(-1) + 72*s12*s23**2*S13**(-1)*S24**(-1) - 28*s12*s23*
     +    S24**(-1) - 36*s12 + 16*s14*s23**2*S13**(-1)*S24**(-1) + 8*
     +    s14*s23*S13**(-1) - 16*s23**2*S24**(-1) - 40*s23 + 8*s24 )

      LA34 = LA34 + Lc1(p24,p13) * ( 8 + 8*s12**2*S13**(-1)*S24**(-1)
     +     + 8*s12*s23*S13**(-1)*S24**(-1) - 12*s12*S24**(-1) - 8*s23*
     +    S24**(-1) )

      LA34 = LA34 + Lc2(p1,p34)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12*s13*s23 )

      LA34 = LA34 + Lc2(p1,p34)*S34**(-1)*S134**(-1) * ( 16*s12*s13 + 
     +    24*s13**2 + 4*s13*s23 + 4*s13*s24 )

      LA34 = LA34 + Lc2(p1,p34)*S34**(-2)*S134**(-1) * ( 16*s12*s13**2
     +     + 8*s13**2*s23 + 8*s13**2*s24 )

      LA34 = LA34 + Lc2(p1,p34)*S234**(-1)*S134**(-1) * (  - 8*s12**3*
     +    s23*S13**(-1)*S24**(-1) - 8*s12**3*S13**(-1) + 16*s12**2*s23*
     +    S24**(-1) - 16*s12**2 - 12*s12*s13*s23*S24**(-1) - 12*s12*s13
     +     + 4*s13**2*s23*S24**(-1) - 4*s13**2 )

      LA34 = LA34 + Lc2(p1,p34)*S134**(-1) * ( 8*s12**3*S13**(-1)*
     +    S24**(-1) + 4*s12**2*s34*S13**(-1)*S24**(-1) - 8*s12**2*
     +    S24**(-1) + 4*s12*s13*S24**(-1) + 4*s12*s23*S24**(-1) - 8*s12
     +    *s34*S24**(-1) - 8*s12 - 8*s13*s23*S24**(-1) + 4*s13*s34*
     +    S24**(-1) + 8*s13 )

      LA34 = LA34 + Lc2(p1,p234)*S34**(-1)*S234**(-1) * (  - 16*s13**2
     +     )

      LA34 = LA34 + Lc2(p1,p234)*S34**(-1)*S134**(-1) * ( 4*s13**2*s23*
     +    S24**(-1) - 12*s13**2 + 8*s13*s23 + 8*s13*s24 )

      LA34 = LA34 + Lc2(p1,p234)*S34**(-1) * ( 8*s13**2*S24**(-1) - 16*
     +    s13*s23*S24**(-1) - 24*s13 + 12*s14**2*s23*S13**(-1)*
     +    S24**(-1) + 16*s14**2*S13**(-1) + 24*s14*s23*S24**(-1) + 8*
     +    s14 )

      LA34 = LA34 + Lc2(p1,p234)*S34**(-2)*S134**(-1) * ( 16*s13**2*s23
     +     + 16*s13**2*s24 )

      LA34 = LA34 + Lc2(p1,p234)*S34**(-2) * ( 16*s13**2 )

      LA34 = LA34 + Lc2(p1,p234)*S234**(-1) * (  - 8*s13**2*S24**(-1) )

      LA34 = LA34 + Lc2(p1,p234)*S134**(-1) * ( 8*s13*s14*S24**(-1) - 8
     +    *s13 + 4*s14**3*S13**(-1)*S24**(-1) - 4*s14**2*s23*S13**(-1)*
     +    S24**(-1) - 8*s14**2*S13**(-1) + 12*s14**2*S24**(-1) - 8*s14*
     +    s23*S24**(-1) + 8*s14 )

      LA34 = LA34 + Lc2(p1,p234) * ( 12*s13*S24**(-1) + 8*s14**2*
     +    S13**(-1)*S24**(-1) + 16*s14*S24**(-1) )

      LA34 = LA34 + Lc2(p2,p34)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    16*s12*s13*s23 )

      LA34 = LA34 + Lc2(p2,p34)*S34**(-1)*S234**(-1) * (  - 4*s13*s23
     +     - 4*s14*s23 + 24*s23**2 )

      LA34 = LA34 + Lc2(p2,p34)*S34**(-2)*S234**(-1) * ( 16*s12*s23**2
     +     + 8*s13*s23**2 + 8*s14*s23**2 )

      LA34 = LA34 + Lc2(p2,p34)*S234**(-1)*S134**(-1) * ( 8*s12**3*s34*
     +    S13**(-1)*S24**(-1) + 4*s12**2*s14*s34*S13**(-1)*S24**(-1) + 
     +    16*s12**2*s14*S13**(-1) + 4*s12**2*s34**2*S13**(-1)*S24**(-1)
     +     + 4*s12**2*s34*S24**(-1) - 16*s12**2 + 12*s12*s14*s23*
     +    S13**(-1) - 4*s12*s23 + 4*s14*s23**2*S13**(-1) - 4*s23**2 )

      LA34 = LA34 + Lc2(p2,p34)*S234**(-1) * (  - 8*s12**2*S13**(-1) + 
     +    4*s12*s14*S13**(-1) - 4*s12*s23*S13**(-1) - 8*s12*s34*
     +    S13**(-1) - 8*s12 + 8*s14*s23*S13**(-1) - 4*s23*s34*S13**(-1)
     +     - 8*s23 )

      LA34 = LA34 + Lc2(p2,p134)*S34**(-1)*S234**(-1) * (  - 8*s13*s23
     +     + 4*s14*s23**2*S13**(-1) - 8*s14*s23 - 12*s23**2 )

      LA34 = LA34 + Lc2(p2,p134)*S34**(-1)*S134**(-1) * (  - 16*s23**2
     +     )

      LA34 = LA34 + Lc2(p2,p134)*S34**(-1) * ( 8*s13*s23*S24**(-1) - 24
     +    *s14*s23**2*S13**(-1)*S24**(-1) + 16*s14*s23*S13**(-1) + 8*
     +    s14*s23*S24**(-1) + 20*s14*s24*S13**(-1) + 8*s23**2*S13**(-1)
     +     - 8*s23**2*S24**(-1) + 16*s23 + 8*s24 )

      LA34 = LA34 + Lc2(p2,p134)*S34**(-2)*S234**(-1) * ( 16*s13*s23**2
     +     + 16*s14*s23**2 )

      LA34 = LA34 + Lc2(p2,p134)*S34**(-2) * ( 16*s23**2 )

      LA34 = LA34 + Lc2(p2,p134)*S234**(-1) * (  - 8*s13*s23*S24**(-1)
     +     - 4*s14*s23**2*S13**(-1)*S24**(-1) - 4*s14*s23*S13**(-1) - 8
     +    *s14*s23*S24**(-1) - 4*s14*s24*S13**(-1) + 4*s23**3*S13**(-1)
     +    *S24**(-1) + 12*s23**2*S13**(-1) - 8*s23**2*S24**(-1) + 8*s23
     +    *s24*S13**(-1) - 4*s23 + 4*s24 )

      LA34 = LA34 + Lc2(p2,p134)*S134**(-1) * (  - 8*s23**2*S13**(-1) )

      LA34 = LA34 + Lc2(p2,p134) * ( 8*s23**2*S13**(-1)*S24**(-1) + 16*
     +    s23*S13**(-1) + 12*s24*S13**(-1) )

      LA34 = LA34 + Lc2(p3,p24)*S34**(-1)*S234**(-1)*S134**(-1) * ( 8*
     +    s12*s13*s24 - 8*s13*s24**2 )

      LA34 = LA34 + Lc2(p3,p24)*S34**(-1)*S234**(-1) * (  - 4*s13*s24 )

      LA34 = LA34 + Lc2(p3,p24)*S234**(-1)*S134**(-1) * ( 8*s12**2*s14*
     +    S13**(-1) + 4*s12**2 - 8*s12*s13 + 4*s12*s14**2*S13**(-1) - 
     +    20*s12*s14*s24*S13**(-1) - 8*s12*s14 - 4*s12*s24 - 8*s13*s14
     +     + 4*s13*s24 - 4*s14**3*S13**(-1) - 12*s14**2*s24*S13**(-1)
     +     - 12*s14**2 - 16*s14*s24 - 4*s24**2 )

      LA34 = LA34 + Lc2(p3,p24)*S234**(-1) * ( 4*s12**2*s34*S13**(-1)*
     +    S24**(-1) - 8*s12**2*S13**(-1) + 8*s12*s14*s34*S13**(-1)*
     +    S24**(-1) - 4*s12*s14*S13**(-1) + 20*s12*s24*S13**(-1) + 4*
     +    s12*s34*S13**(-1) - 4*s12*s34*S24**(-1) + 12*s12 - 8*s13*s34*
     +    S24**(-1) - 4*s13 + 4*s14**2*s34*S13**(-1)*S24**(-1) + 4*
     +    s14**2*S13**(-1) + 12*s14*s24*S13**(-1) + 4*s14*s34*S13**(-1)
     +     - 4*s14*s34*S24**(-1) + 12*s14 + 8*s24*s34*S13**(-1) + 4*s24
     +     - 8*s34 )

      LA34 = LA34 + Lc2(p4,p13)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    8*s12*s13*s23 + 8*s13**2*s23 )

      LA34 = LA34 + Lc2(p4,p13)*S34**(-1)*S134**(-1) * ( 8*s12*s13 - 8*
     +    s13**2 - 4*s13*s24 )

      LA34 = LA34 + Lc2(p4,p13)*S234**(-1)*S134**(-1) * ( 8*s12**2*s23*
     +    S24**(-1) + 4*s12**2 - 20*s12*s13*s23*S24**(-1) - 12*s12*s13
     +     + 4*s12*s23**2*S24**(-1) - 8*s12*s23 - 8*s12*s24 + 4*s13**2
     +     - 12*s13*s23**2*S24**(-1) - 16*s13*s23 + 4*s13*s24 - 4*
     +    s23**3*S24**(-1) - 12*s23**2 - 8*s23*s24 )

      LA34 = LA34 + Lc2(p4,p13)*S134**(-1) * ( 4*s12**2*s34*S13**(-1)*
     +    S24**(-1) - 8*s12**2*S24**(-1) + 20*s12*s13*S24**(-1) + 8*s12
     +    *s23*s34*S13**(-1)*S24**(-1) - 4*s12*s23*S24**(-1) - 4*s12*
     +    s34*S13**(-1) + 4*s12*s34*S24**(-1) + 12*s12 + 12*s13*s23*
     +    S24**(-1) + 8*s13*s34*S24**(-1) + 4*s13 + 4*s23**2*s34*
     +    S13**(-1)*S24**(-1) + 4*s23**2*S24**(-1) - 4*s23*s34*
     +    S13**(-1) + 4*s23*s34*S24**(-1) + 12*s23 - 8*s24*s34*
     +    S13**(-1) - 4*s24 - 8*s34 )

      LA34 = LA34 + Lc2(p13,p24)*S34**(-1)*S234**(-1) * (  - 24*s12**3*
     +    s14*S13**(-1)*S24**(-1) - 24*s12**3*S24**(-1) + 96*s12**2*
     +    s14**2*S13**(-1)*S24**(-1) + 16*s12**2*s14*S13**(-1) + 48*
     +    s12**2*s14*S24**(-1) + 16*s12**2 + 16*s12*s13 - 16*s12*s14**3
     +    *S13**(-1)*S24**(-1) - 104*s12*s14**2*S13**(-1) - 8*s12*s14*
     +    s23*S13**(-1) - 40*s12*s14 - 24*s12*s23 + 16*s13*s14 + 8*s13*
     +    s23 + 16*s14**3*S13**(-1) - 8*s14**2*s23*S13**(-1) + 16*
     +    s14**2 - 16*s23**2 )

      LA34 = LA34 + Lc2(p13,p24)*S34**(-1)*S134**(-1) * (  - 24*s12**3*
     +    s23*S13**(-1)*S24**(-1) - 24*s12**3*S13**(-1) + 96*s12**2*
     +    s23**2*S13**(-1)*S24**(-1) + 48*s12**2*s23*S13**(-1) + 16*
     +    s12**2*s23*S24**(-1) + 16*s12**2 + 8*s12*s13*s23*S24**(-1) + 
     +    24*s12*s13 - 16*s12*s23**3*S13**(-1)*S24**(-1) - 104*s12*
     +    s23**2*S24**(-1) - 40*s12*s23 + 16*s12*s24 - 16*s13**2 + 8*
     +    s13*s23**2*S24**(-1) - 8*s13*s24 + 16*s23**3*S24**(-1) + 16*
     +    s23**2 + 16*s23*s24 )

      LA34 = LA34 + Lc2(p13,p24)*S34**(-1) * ( 8*s12**3*S13**(-1)*
     +    S24**(-1) - 8*s12**2*s14*S13**(-1)*S24**(-1) - 8*s12**2*s23*
     +    S13**(-1)*S24**(-1) - 40*s12**2*S13**(-1) - 40*s12**2*
     +    S24**(-1) + 104*s12*s14**2*S13**(-1)*S24**(-1) + 24*s12*s14*
     +    s23*S13**(-1)*S24**(-1) - 16*s12*s14*S13**(-1) + 16*s12*s14*
     +    S24**(-1) + 104*s12*s23**2*S13**(-1)*S24**(-1) + 16*s12*s23*
     +    S13**(-1) - 24*s12*s23*S24**(-1) + 16*s12 + 8*s13 - 16*s14**3
     +    *S13**(-1)*S24**(-1) + 8*s14**2*s23*S13**(-1)*S24**(-1) - 16*
     +    s14**2*S24**(-1) + 8*s14*s23**2*S13**(-1)*S24**(-1) - 16*s14*
     +    s23*S13**(-1) - 16*s14*s23*S24**(-1) - 16*s23**3*S13**(-1)*
     +    S24**(-1) - 16*s23**2*S13**(-1) - 8*s23**2*S24**(-1) + 16*s23
     +     )

      LA34 = LA34 + Lc2(p13,p24)*S234**(-1) * (  - 8*s12**3*S13**(-1)*
     +    S24**(-1) + 8*s12**2*s14*S13**(-1)*S24**(-1) - 8*s12**2*s23*
     +    S13**(-1)*S24**(-1) + 64*s12**2*S24**(-1) - 104*s12*s14**2*
     +    S13**(-1)*S24**(-1) - 16*s12*s14*s23*S13**(-1)*S24**(-1) + 8*
     +    s12*s14*S24**(-1) + 24*s12*s23*S24**(-1) - 24*s12 + 16*s13 + 
     +    16*s14**3*S13**(-1)*S24**(-1) - 8*s14**2*s23*S13**(-1)*
     +    S24**(-1) + 16*s14**2*S24**(-1) + 24*s14*s23*S24**(-1) - 16*
     +    s23 )

      LA34 = LA34 + Lc2(p13,p24)*S134**(-1) * (  - 8*s12**3*S13**(-1)*
     +    S24**(-1) - 8*s12**2*s14*S13**(-1)*S24**(-1) + 8*s12**2*s23*
     +    S13**(-1)*S24**(-1) + 64*s12**2*S13**(-1) - 16*s12*s14*s23*
     +    S13**(-1)*S24**(-1) + 24*s12*s14*S13**(-1) - 104*s12*s23**2*
     +    S13**(-1)*S24**(-1) + 8*s12*s23*S13**(-1) + 8*s12*s23*
     +    S24**(-1) - 16*s13 - 8*s14*s23**2*S13**(-1)*S24**(-1) + 24*
     +    s14*s23*S13**(-1) + 16*s23**3*S13**(-1)*S24**(-1) + 16*s23**2
     +    *S13**(-1) + 8*s23**2*S24**(-1) + 8*s24 )

      LA34 = LA34 + Lc2(p13,p24) * ( 8 + 8*s12**2*S13**(-1)*S24**(-1)
     +     + 8*s12*s14*S13**(-1)*S24**(-1) + 8*s12*s23*S13**(-1)*
     +    S24**(-1) + 8*s14*s23*S13**(-1)*S24**(-1) )

      LA34 = LA34 + Lc3(p13,p24)*S34**(-1)*S234**(-1) * ( 8*s12**4*
     +    S13**(-1)*S24**(-1) - 24*s12**3*s14*S13**(-1)*S24**(-1) - 8*
     +    s12**3*S13**(-1) + 24*s12**2*s14**2*S13**(-1)*S24**(-1) + 16*
     +    s12**2*s14*S13**(-1) - 8*s12**2 - 8*s12*s14**3*S13**(-1)*
     +    S24**(-1) - 40*s12*s14**2*S13**(-1) - 8*s12*s14*s23*S13**(-1)
     +     - 16*s12*s14 - 8*s12*s23 - 8*s14**2*s23*S13**(-1) - 8*s14**2
     +     - 8*s14*s23 - 8*s23**2 )

      LA34 = LA34 + Lc3(p13,p24)*S34**(-1)*S134**(-1) * ( 24*s12**2*
     +    s23**2*S13**(-1)*S24**(-1) - 8*s12**2 + 16*s12*s13 - 32*s12*
     +    s23**3*S13**(-1)*S24**(-1) - 48*s12*s23**2*S13**(-1) - 24*s12
     +    *s23**2*S24**(-1) - 24*s12*s23*s24*S13**(-1) + 8*s12*s23 + 8*
     +    s12*s24 - 8*s13**2 - 8*s13*s23 - 8*s13*s24 + 32*s23**3*
     +    S24**(-1) + 48*s23**2 + 16*s23*s24 - 8*s24**2 )

      LA34 = LA34 + Lc3(p13,p24)*S34**(-1) * ( 16*s12**3*S13**(-1)*
     +    S24**(-1) + 8*s12**2*s23*S13**(-1)*S24**(-1) - 8*s12**2*
     +    S13**(-1) + 48*s12*s14**2*S13**(-1)*S24**(-1) + 16*s12*s14*
     +    s23*S13**(-1)*S24**(-1) - 8*s12*s14*S13**(-1) + 24*s12*s23**2
     +    *S13**(-1)*S24**(-1) - 8*s12*s23*S13**(-1) + 8*s12*s24*
     +    S13**(-1) - 8*s12 + 8*s13 + 8*s14**2*s23*S13**(-1)*S24**(-1)
     +     - 8*s14*s23*S13**(-1) + 8*s14*s24*S13**(-1) - 32*s23**3*
     +    S13**(-1)*S24**(-1) - 48*s23**2*S13**(-1) - 16*s23*s24*
     +    S13**(-1) + 16*s23 )

      LA34 = LA34 + Lc3(p13,p24)*S234**(-1) * (  - 24*s12**3*S13**(-1)*
     +    S24**(-1) - 16*s12**2*s14*S13**(-1)*S24**(-1) - 8*s12**2*s23*
     +    S13**(-1)*S24**(-1) + 8*s12**2*S13**(-1) - 56*s12*s14**2*
     +    S13**(-1)*S24**(-1) - 16*s12*s14*s23*S13**(-1)*S24**(-1) + 8*
     +    s12*s14*S13**(-1) - 16*s12 - 8*s14**2*s23*S13**(-1)*S24**(-1)
     +     - 16*s14 - 8*s23 + 8*s24 )

      LA34 = LA34 + Lc3(p13,p24)*S134**(-1) * ( 8*s12**2*S13**(-1) + 8*
     +    s12*s14*S13**(-1) - 24*s12*s23**2*S13**(-1)*S24**(-1) + 8*s12
     +    *s23*S13**(-1) - 24*s12*s24*S13**(-1) + 16*s12 - 8*s13 + 8*
     +    s14*s23*S13**(-1) - 16*s14*s24*S13**(-1) + 8*s14 + 32*s23**3*
     +    S13**(-1)*S24**(-1) + 48*s23**2*S13**(-1) + 16*s23*s24*
     +    S13**(-1) - 8*s23 - 8*s24 )

      LA34 = LA34 + Lc3(p13,p24) * (  - 8*s12*S13**(-1) - 8*s14*
     +    S13**(-1) )

      LA34 = LA34 + Lc3(p24,p13)*S34**(-1)*S234**(-1) * ( 24*s12**2*
     +    s14**2*S13**(-1)*S24**(-1) - 8*s12**2 - 24*s12*s13*s14*
     +    S24**(-1) + 8*s12*s13 - 32*s12*s14**3*S13**(-1)*S24**(-1) - 
     +    24*s12*s14**2*S13**(-1) - 48*s12*s14**2*S24**(-1) + 8*s12*s14
     +     - 16*s12*s23 - 8*s13**2 + 16*s13*s14 + 8*s13*s23 + 32*s14**3
     +    *S13**(-1) + 48*s14**2 + 8*s14*s23 - 8*s23**2 )

      LA34 = LA34 + Lc3(p24,p13)*S34**(-1)*S134**(-1) * ( 8*s12**4*
     +    S13**(-1)*S24**(-1) - 24*s12**3*s23*S13**(-1)*S24**(-1) - 8*
     +    s12**3*S24**(-1) + 24*s12**2*s23**2*S13**(-1)*S24**(-1) + 16*
     +    s12**2*s23*S24**(-1) - 8*s12**2 + 8*s12*s13*s23*S24**(-1) + 8
     +    *s12*s13 - 8*s12*s23**3*S13**(-1)*S24**(-1) - 40*s12*s23**2*
     +    S24**(-1) - 16*s12*s23 - 8*s13**2 + 8*s13*s23**2*S24**(-1) + 
     +    8*s13*s23 - 8*s23**2 )

      LA34 = LA34 + Lc3(p24,p13)*S34**(-1) * ( 16*s12**3*S13**(-1)*
     +    S24**(-1) + 8*s12**2*s14*S13**(-1)*S24**(-1) - 8*s12**2*
     +    S24**(-1) + 8*s12*s13*S24**(-1) + 24*s12*s14**2*S13**(-1)*
     +    S24**(-1) + 16*s12*s14*s23*S13**(-1)*S24**(-1) - 8*s12*s14*
     +    S24**(-1) + 48*s12*s23**2*S13**(-1)*S24**(-1) - 16*s12*s23*
     +    S24**(-1) - 16*s13*s14*S24**(-1) + 8*s13*s23*S24**(-1) - 32*
     +    s14**3*S13**(-1)*S24**(-1) - 48*s14**2*S24**(-1) + 8*s14*
     +    s23**2*S13**(-1)*S24**(-1) - 8*s14*s23*S24**(-1) - 8*s23**2*
     +    S24**(-1) )

      LA34 = LA34 + Lc3(p24,p13)*S234**(-1) * ( 8*s12**2*S24**(-1) - 24
     +    *s12*s13*S24**(-1) - 24*s12*s14**2*S13**(-1)*S24**(-1) + 8*
     +    s12*s14*S24**(-1) + 8*s12*s23*S24**(-1) + 16*s13*s14*
     +    S24**(-1) - 16*s13*s23*S24**(-1) + 32*s14**3*S13**(-1)*
     +    S24**(-1) + 48*s14**2*S24**(-1) + 8*s14*s23*S24**(-1) )

      LA34 = LA34 + Lc3(p24,p13)*S134**(-1) * (  - 24*s12**3*S13**(-1)*
     +    S24**(-1) - 8*s12**2*s14*S13**(-1)*S24**(-1) - 16*s12**2*s23*
     +    S13**(-1)*S24**(-1) + 8*s12**2*S24**(-1) - 16*s12*s14*s23*
     +    S13**(-1)*S24**(-1) - 56*s12*s23**2*S13**(-1)*S24**(-1) + 16*
     +    s12*s23*S24**(-1) - 8*s12 - 8*s14*s23**2*S13**(-1)*S24**(-1)
     +     + 8*s23**2*S24**(-1) - 8*s23 )

      LA34 = LA34 + Lc3(p24,p13) * (  - 8*s12*S24**(-1) - 8*s23*
     +    S24**(-1) )

      LA34a=-LA34

      return
      end

      function LA34b(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LA34=0d0

      LA34 = LA34 + Lcd0(p1,p34,p2)*S34**(-1)*S234**(-1) * (  - 64*
     +    s12**2*s23 - 128*s12*s13*s23 - 128*s12*s14*s23 - 64*s13**2*
     +    s23 - 128*s13*s14*s23 + 16*s13*s23**2 - 64*s14**2*s23 + 16*
     +    s14*s23**2 )

      LA34 = LA34 + Lcd0(p1,p34,p2)*S34**(-1)*S134**(-1) * ( 64*s12**2*
     +    s13 + 128*s12*s13*s23 + 128*s12*s13*s24 + 16*s13**2*s23 + 16*
     +    s13**2*s24 + 64*s13*s23**2 + 128*s13*s23*s24 + 64*s13*s24**2
     +     )

      LA34 = LA34 + Lcd0(p1,p34,p2)*S34**(-1) * ( 16*s12**2*s14*s23*
     +    S13**(-1)*S24**(-1) + 16*s12**2*s14*S13**(-1) + 16*s12**2*s23
     +    *S24**(-1) + 16*s12**2 + 32*s12*s13*s23*S24**(-1) + 96*s12*
     +    s13 + 16*s12*s14**2*s23*S13**(-1)*S24**(-1) + 16*s12*s14**2*
     +    S13**(-1) + 16*s12*s14*s23**2*S13**(-1)*S24**(-1) + 48*s12*
     +    s14*s23*S13**(-1) + 48*s12*s14*s23*S24**(-1) + 32*s12*s14*s24
     +    *S13**(-1) + 48*s12*s14 + 16*s12*s23**2*S24**(-1) - 80*s12*
     +    s23 - 32*s12*s24 + 32*s13**2*s23*S24**(-1) + 32*s13**2 + 64*
     +    s13*s14*s23*S24**(-1) + 64*s13*s14 - 112*s13*s23**2*S24**(-1)
     +     - 224*s13*s23 - 112*s13*s24 + 16*s14**3*s23*S13**(-1)*
     +    S24**(-1) + 16*s14**3*S13**(-1) - 32*s14**2*s23**2*S13**(-1)*
     +    S24**(-1) - 32*s14**2*s23*S13**(-1) + 48*s14**2*s23*S24**(-1)
     +     - 48*s14**2*s24*S13**(-1) + 48*s14**2 + 16*s14*s23**3*
     +    S13**(-1)*S24**(-1) + 48*s14*s23**2*S13**(-1) - 96*s14*s23**2
     +    *S24**(-1) + 64*s14*s23*s24*S13**(-1) - 144*s14*s23 + 32*s14*
     +    s24**2*S13**(-1) - 64*s14*s24 + 16*s23**3*S24**(-1) - 16*
     +    s23**2 )

      LA34 = LA34 + Lcd0(p1,p34,p2)*S34**(-1) * (  - 64*s23*s24 - 32*
     +    s24**2 )

      LA34 = LA34 + Lcd0(p1,p34,p2)*S34**(-2) * (  - 64*s12*s13*s24 + 
     +    64*s12*s14*s23 - 64*s13**2*s24 + 64*s13*s14*s23 - 64*s13*s14*
     +    s24 - 64*s13*s23*s24 - 64*s13*s24**2 + 64*s14**2*s23 + 64*s14
     +    *s23**2 + 64*s14*s23*s24 )

      LA34 = LA34 + Lcd0(p1,p34,p2)*S234**(-1) * (  - 16*s12**2*s23*
     +    S24**(-1) - 16*s12**2 - 32*s12*s13*s23*S24**(-1) - 32*s12*s13
     +     - 8*s12*s14*s23*S13**(-1) - 32*s12*s14*s23*S24**(-1) + 24*
     +    s12*s14*s24*S13**(-1) - 32*s12*s14 + 24*s12*s23**2*S24**(-1)
     +     - 16*s12*s23 - 24*s12*s24 - 16*s13**2*s23*S24**(-1) - 16*
     +    s13**2 - 32*s13*s14*s23*S24**(-1) - 32*s13*s14 + 40*s13*
     +    s23**2*S24**(-1) - 24*s13*s23 - 56*s13*s24 - 8*s14**2*s23*
     +    S13**(-1) - 16*s14**2*s23*S24**(-1) + 24*s14**2*s24*S13**(-1)
     +     - 16*s14**2 + 48*s14*s23**2*S24**(-1) - 8*s14*s23 )

      LA34 = LA34 + Lcd0(p1,p34,p2)*S134**(-1) * (  - 16*s12**2*s14*
     +    S13**(-1) + 48*s12**2 + 24*s12*s13*s23*S24**(-1) - 24*s12*s13
     +     + 24*s12*s14**2*S13**(-1) - 32*s12*s14*s23*S13**(-1) - 8*s12
     +    *s14*s23*S24**(-1) - 32*s12*s14*s24*S13**(-1) - 16*s12*s14 + 
     +    96*s12*s23 + 96*s12*s24 + 24*s13*s23**2*S24**(-1) - 40*s13*
     +    s24 + 48*s14**2*s23*S13**(-1) + 24*s14**2*s24*S13**(-1) - 16*
     +    s14*s23**2*S13**(-1) - 8*s14*s23**2*S24**(-1) - 32*s14*s23*
     +    s24*S13**(-1) - 8*s14*s23 - 16*s14*s24**2*S13**(-1) - 24*s14*
     +    s24 + 48*s23**2 + 96*s23*s24 + 48*s24**2 )

      LA34 = LA34 + Lcd0(p1,p34,p2) * (  - 16*s12**3*S13**(-1)*
     +    S24**(-1) - 16*s12**2*s14*S13**(-1)*S24**(-1) - 16*s12**2*s23
     +    *S13**(-1)*S24**(-1) - 96*s12**2*s34*S13**(-1)*S24**(-1) - 16
     +    *s12**2*S13**(-1) - 16*s12**2*S24**(-1) - 16*s12*s13*
     +    S24**(-1) - 16*s12*s14**2*S13**(-1)*S24**(-1) + 128*s12*s14*
     +    s23*S13**(-1)*S24**(-1) - 64*s12*s14*s34*S13**(-1)*S24**(-1)
     +     + 80*s12*s14*S13**(-1) - 16*s12*s14*S24**(-1) - 16*s12*
     +    s23**2*S13**(-1)*S24**(-1) - 64*s12*s23*s34*S13**(-1)*
     +    S24**(-1) - 16*s12*s23*S13**(-1) + 144*s12*s23*S24**(-1) - 16
     +    *s12*s24*S13**(-1) - 52*s12*s34**2*S13**(-1)*S24**(-1) - 40*
     +    s12*s34*S13**(-1) - 40*s12*s34*S24**(-1) + 224*s12 + 56*s13*
     +    s23*S24**(-1) + 16*s13 + 64*s14**2*s23*S13**(-1)*S24**(-1) + 
     +    48*s14**2*S13**(-1) + 64*s14*s23**2*S13**(-1)*S24**(-1) + 92*
     +    s14*s23*s34*S13**(-1)*S24**(-1) + 96*s14*s23*S13**(-1) + 160*
     +    s14*s23*S24**(-1) + 40*s14*s24*S13**(-1) + 40*s14*s34*
     +    S13**(-1) + 136*s14 + 112*s23**2*S24**(-1) + 200*s23*s34*
     +    S24**(-1) )

      LA34 = LA34 + Lcd0(p1,p34,p2) * ( 152*s23 + 16*s24 + 116*s34 )

      LA34 = LA34 + Lcd1(p1,p34,p2)*S34**(-1)*S234**(-1) * (  - 32*s13*
     +    s23**2 - 32*s14*s23**2 )

      LA34 = LA34 + Lcd1(p1,p34,p2)*S34**(-1)*S134**(-1) * ( 16*s13*
     +    s23**2 + 16*s13*s23*s24 )

      LA34 = LA34 + Lcd1(p1,p34,p2)*S34**(-1) * ( 48*s13*s23**2*
     +    S24**(-1) + 40*s13*s23 - 16*s14**2*s23*S13**(-1) + 16*s14*
     +    s23**2*S13**(-1) + 64*s14*s23**2*S24**(-1) + 32*s14*s23*s24*
     +    S13**(-1) + 40*s14*s23 + 32*s23**3*S24**(-1) + 24*s23**2 + 24
     +    *s23*s24 )

      LA34 = LA34 + Lcd1(p1,p34,p2)*S34**(-2) * (  - 64*s13*s23**2 - 48
     +    *s13*s23*s24 - 16*s14*s23**2 )

      LA34 = LA34 + Lcd1(p1,p34,p2)*S234**(-1) * (  - 32*s13*s23**2*
     +    S24**(-1) - 16*s13*s23 - 32*s14*s23**2*S24**(-1) - 16*s14*s23
     +     )

      LA34 = LA34 + Lcd1(p1,p34,p2)*S134**(-1) * (  - 32*s14*s23**2*
     +    S13**(-1) - 24*s14*s23*s24*S13**(-1) + 8*s23**2 )

      LA34 = LA34 + Lcd1(p1,p34,p2) * ( 76*s14*s23**2*S13**(-1)*
     +    S24**(-1) + 32*s14*s23*S13**(-1) + 100*s23**2*S24**(-1) + 64*
     +    s23 )

      LA34 = LA34 + Lcd1(p2,p34,p1)*S34**(-1)*S234**(-1) * ( 16*s13**2*
     +    s23 + 16*s13*s14*s23 )

      LA34 = LA34 + Lcd1(p2,p34,p1)*S34**(-1)*S134**(-1) * (  - 32*
     +    s13**2*s23 - 32*s13**2*s24 )

      LA34 = LA34 + Lcd1(p2,p34,p1)*S34**(-1) * (  - 16*s13**2*s23*
     +    S24**(-1) - 72*s13**2 + 16*s13*s14*s23*S24**(-1) - 24*s13*s14
     +     + 32*s13*s23**2*S24**(-1) + 8*s13*s23 - 40*s13*s24 + 16*
     +    s14**2*s23*S24**(-1) + 16*s14**2 + 16*s14*s23**2*S24**(-1) - 
     +    32*s14*s24 )

      LA34 = LA34 + Lcd1(p2,p34,p1)*S34**(-2) * (  - 16*s13**2*s24 + 16
     +    *s13*s14*s23 )

      LA34 = LA34 + Lcd1(p2,p34,p1)*S234**(-1) * ( 40*s13**2 + 8*s13*
     +    s14*s23*S24**(-1) + 32*s13*s14 )

      LA34 = LA34 + Lcd1(p2,p34,p1)*S134**(-1) * ( 8*s13*s23 + 8*s13*
     +    s24 + 8*s14*s23 + 8*s14*s24 )

      LA34 = LA34 + Lcd1(p2,p34,p1) * ( 116*s13*s23*S24**(-1) + 108*s13
     +     + 72*s14*s23*S24**(-1) + 48*s14 )

      LA34 = LA34 + Lcd2(p1,p34,p2)*S34**(-1)*S234**(-1) * ( 16*s13*
     +    s23**2 + 16*s14*s23**2 )

      LA34 = LA34 + Lcd2(p1,p34,p2)*S34**(-1)*S134**(-1) * ( 16*s23**3
     +     + 16*s23**2*s24 )

      LA34 = LA34 + Lcd2(p1,p34,p2)*S34**(-1) * (  - 8*s13*s23**2*
     +    S24**(-1) + 36*s14*s23**3*S13**(-1)*S24**(-1) + 40*s14*s23**2
     +    *S13**(-1) - 8*s14*s23**2*S24**(-1) - 8*s23**3*S13**(-1) + 24
     +    *s23**3*S24**(-1) - 8*s23**2*s24*S13**(-1) + 28*s23**2 )

      LA34 = LA34 + Lcd2(p1,p34,p2)*S34**(-2) * (  - 16*s13*s23**2 - 16
     +    *s14*s23**2 - 16*s23**3 - 16*s23**2*s24 )

      LA34 = LA34 + Lcd2(p1,p34,p2)*S234**(-1) * ( 8*s13*s23**2*
     +    S24**(-1) + 8*s14*s23**2*S24**(-1) )

      LA34 = LA34 + Lcd2(p1,p34,p2)*S134**(-1) * ( 8*s23**3*S13**(-1)
     +     + 8*s23**2*s24*S13**(-1) )

      LA34 = LA34 + Lcd2(p2,p34,p1)*S34**(-1)*S234**(-1) * ( 16*s13**3
     +     + 16*s13**2*s14 )

      LA34 = LA34 + Lcd2(p2,p34,p1)*S34**(-1)*S134**(-1) * ( 16*s13**2*
     +    s23 + 16*s13**2*s24 )

      LA34 = LA34 + Lcd2(p2,p34,p1)*S34**(-1) * (  - 8*s13**3*S24**(-1)
     +     - 8*s13**2*s14*S24**(-1) + 32*s13**2*s23*S24**(-1) + 44*
     +    s13**2 + 28*s13*s14*s23*S24**(-1) + 40*s13*s14 - 8*s13*s23 - 
     +    8*s13*s24 )

      LA34 = LA34 + Lcd2(p2,p34,p1)*S34**(-2) * (  - 16*s13**3 - 16*
     +    s13**2*s14 - 16*s13**2*s23 - 16*s13**2*s24 )

      LA34 = LA34 + Lcd2(p2,p34,p1)*S234**(-1) * ( 8*s13**3*S24**(-1)
     +     + 8*s13**2*s14*S24**(-1) )

      LA34 = LA34 + Lcd2(p2,p34,p1)*S134**(-1) * ( 8*s13*s23 + 8*s13*
     +    s24 )

      LA34 = LA34 + Ld0(p1,p3,p4)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 128*s12**2 - 64*s12*s23 - 32*s13**2 + 48*s13*s23 - 48*
     +    s23**2 )

      LA34 = LA34 + Ld0(p1,p3,p4)*S34**(-1)*S234**(-1) * ( 16*s12**2*
     +    S13**(-1) + 16*s12*s14*S13**(-1) + 16*s12*s23*S13**(-1) - 112
     +    *s12 - 24*s13 + 8*s14**2*S13**(-1) + 16*s14*s23*S13**(-1) - 
     +    48*s14 + 8*s23**2*S13**(-1) - 64*s23 )

      LA34 = LA34 + Ld0(p1,p3,p4)*S34**(-1)*S134**(-1) * ( 32*s12**2*
     +    S24**(-1) - 32*s12*s13*S24**(-1) + 32*s12*s23*S24**(-1) - 160
     +    *s12 + 16*s13**2*S24**(-1) - 32*s13*s23*S24**(-1) + 32*s13 + 
     +    16*s23**2*S24**(-1) - 64*s23 - 80*s24 )

      LA34 = LA34 + Ld0(p1,p3,p4)*S34**(-1)*S134**(-2) * ( 64*s12*s13
     +     + 64*s13*s23 + 64*s13*s24 )

      LA34 = LA34 + Ld0(p1,p3,p4)*S34**(-1) * (  - 16 + 32*s12**2*
     +    S13**(-1)*S24**(-1) + 32*s12*s14*S13**(-1)*S24**(-1) + 32*s12
     +    *s23*S13**(-1)*S24**(-1) + 64*s12*S13**(-1) + 80*s12*
     +    S24**(-1) + 16*s13*S24**(-1) + 16*s14**2*S13**(-1)*S24**(-1)
     +     + 16*s14*S13**(-1) + 56*s14*S24**(-1) + 16*s23**2*S13**(-1)*
     +    S24**(-1) + 48*s23*S13**(-1) + 16*s23*S24**(-1) + 24*s24*
     +    S13**(-1) )

      LA34 = LA34 + Ld0(p1,p3,p4)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 64*s12*s13*s23 )

      LA34 = LA34 + Ld0(p1,p3,p4)*S34**(-2)*S234**(-1) * ( 32*s12*s23
     +     - 32*s13*s23 + 32*s14*s23 )

      LA34 = LA34 + Ld0(p1,p3,p4)*S34**(-2)*S134**(-1) * (  - 32*s12*
     +    s13 + 64*s13**2 - 96*s13*s23 - 32*s13*s24 )

      LA34 = LA34 + Ld0(p1,p3,p4)*S34**(-2)*S134**(-2) * ( 64*s12*
     +    s13**2 + 64*s13**2*s23 + 64*s13**2*s24 )

      LA34 = LA34 + Ld0(p1,p3,p4)*S34**(-2) * (  - 32*s13 + 32*s23 )

      LA34 = LA34 + Ld0(p1,p3,p4)*S234**(-1)*S134**(-1) * ( 32*s12**3*
     +    S13**(-1)*S24**(-1) + 32*s12**2*s14*S13**(-1)*S24**(-1) - 32*
     +    s12**2*S13**(-1) - 32*s12**2*S24**(-1) - 32*s12*s13*S24**(-1)
     +     + 24*s12*s14*s23*S13**(-1)*S24**(-1) - 80*s12*s14*S24**(-1)
     +     - 24*s12*s23*S13**(-1) + 24*s12*s23*S24**(-1) + 80*s12 + 24*
     +    s13**2*S24**(-1) + 40*s13*s14*S24**(-1) - 24*s13*s23*
     +    S24**(-1) - 32*s13 + 8*s14**2*s23*S13**(-1)*S24**(-1) + 8*
     +    s14**2*S13**(-1) - 16*s14*s23*S13**(-1) - 16*s14*s23*
     +    S24**(-1) - 8*s14*s24*S13**(-1) + 16*s14 - 8*s23**2*S13**(-1)
     +     + 16*s23 - 8*s24 )

      LA34 = LA34 + Ld0(p1,p3,p4)*S234**(-1) * (  - 24 + 16*s12**2*
     +    S13**(-1)*S24**(-1) + 32*s12*s14*S13**(-1)*S24**(-1) - 8*s12*
     +    s23*S13**(-1)*S24**(-1) - 16*s12*S13**(-1) + 24*s12*S24**(-1)
     +     - 40*s13*S24**(-1) + 8*s14**2*S13**(-1)*S24**(-1) - 8*s14*
     +    S13**(-1) - 24*s14*S24**(-1) + 8*s23*S24**(-1) )

      LA34 = LA34 + Ld0(p1,p3,p4)*S134**(-1) * ( 8 + 32*s12**2*
     +    S13**(-1)*S24**(-1) + 32*s12*s23*S13**(-1)*S24**(-1) - 24*s12
     +    *S13**(-1) - 80*s12*S24**(-1) + 40*s13*S24**(-1) + 8*s14*s23*
     +    S13**(-1)*S24**(-1) + 8*s14*S13**(-1) + 8*s23**2*S13**(-1)*
     +    S24**(-1) - 16*s23*S13**(-1) - 24*s23*S24**(-1) - 8*s24*
     +    S13**(-1) )

      LA34 = LA34 + Ld0(p1,p3,p4)*S134**(-2) * (  - 16*s12*s14*
     +    S13**(-1) + 32*s12 - 16*s14*s23*S13**(-1) - 16*s14*s24*
     +    S13**(-1) + 32*s23 + 32*s24 )

      LA34 = LA34 + Ld0(p1,p3,p4) * ( 16*s12*S13**(-1)*S24**(-1) + 16*
     +    s14*S13**(-1)*S24**(-1) + 16*s23*S13**(-1)*S24**(-1) + 8*s34*
     +    S13**(-1)*S24**(-1) )

      LA34 = LA34 + Ld0(p1,p3,p24)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 128*s12**2 - 64*s12*s23 - 32*s13**2 + 64*s13*s23 - 32*
     +    s23**2 )

      LA34 = LA34 + Ld0(p1,p3,p24)*S34**(-1)*S234**(-1) * ( 32*s12**2*
     +    S13**(-1) + 32*s12*s14*S13**(-1) + 32*s12*s23*S13**(-1) - 112
     +    *s12 + 16*s14**2*S13**(-1) + 32*s14*s23*S13**(-1) - 32*s14 + 
     +    16*s23**2*S13**(-1) - 32*s23 )

      LA34 = LA34 + Ld0(p1,p3,p24)*S34**(-1)*S134**(-1) * (  - 32*
     +    s12**3*S13**(-1)*S24**(-1) + 64*s12**2*S24**(-1) - 48*s12*s13
     +    *S24**(-1) + 64*s12*s23*S24**(-1) + 32*s12 + 16*s13**2*
     +    S24**(-1) - 32*s13*s23*S24**(-1) + 16*s23**2*S24**(-1) - 32*
     +    s23 + 32*s24 )

      LA34 = LA34 + Ld0(p1,p3,p24)*S34**(-1) * (  - 16 - 48*s12**2*
     +    S13**(-1)*S24**(-1) - 32*s12*s14*S13**(-1)*S24**(-1) - 16*s12
     +    *s23*S13**(-1)*S24**(-1) + 64*s12*S24**(-1) - 8*s13*S24**(-1)
     +     - 8*s14**2*S13**(-1)*S24**(-1) - 16*s14*S13**(-1) + 24*s14*
     +    S24**(-1) - 8*s23**2*S13**(-1)*S24**(-1) - 8*s23*S13**(-1) + 
     +    48*s23*S24**(-1) + 8*s24*S13**(-1) )

      LA34 = LA34 + Ld0(p1,p3,p24)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 64*s12*s13*s23 )

      LA34 = LA34 + Ld0(p1,p3,p24)*S34**(-2)*S234**(-1) * (  - 32*s12*
     +    s23 - 96*s13*s23 - 32*s14*s23 + 64*s23**2 )

      LA34 = LA34 + Ld0(p1,p3,p24)*S34**(-2)*S234**(-2) * ( 64*s12*
     +    s23**2 + 64*s13*s23**2 + 64*s14*s23**2 )

      LA34 = LA34 + Ld0(p1,p3,p24)*S34**(-2)*S134**(-1) * ( 32*s12*s13
     +     - 32*s13*s23 + 32*s13*s24 )

      LA34 = LA34 + Ld0(p1,p3,p24)*S34**(-2) * ( 32*s13 - 32*s23 )

      LA34 = LA34 + Ld0(p1,p3,p24)*S234**(-1)*S134**(-1) * ( 32*s12**3*
     +    S13**(-1)*S24**(-1) + 64*s12**2*s14*S13**(-1)*S24**(-1) - 64*
     +    s12**2*S13**(-1) - 48*s12*s13*S24**(-1) + 48*s12*s14*s23*
     +    S13**(-1)*S24**(-1) - 96*s12*s14*S24**(-1) - 48*s12*s23*
     +    S13**(-1) + 48*s12*s23*S24**(-1) + 96*s12 + 32*s13**2*
     +    S24**(-1) + 48*s13*s14*S24**(-1) - 32*s13*s23*S24**(-1) - 32*
     +    s13 + 16*s14**2*s23*S13**(-1)*S24**(-1) + 16*s14**2*S13**(-1)
     +     - 32*s14*s23*S13**(-1) - 16*s14*s23*S24**(-1) - 16*s14*s24*
     +    S13**(-1) + 32*s14 - 16*s23**2*S13**(-1) + 16*s23 - 16*s24 )

      LA34 = LA34 + Ld0(p1,p3,p24)*S234**(-1) * (  - 32 + 48*s12*s14*
     +    S13**(-1)*S24**(-1) - 16*s12*S13**(-1) + 24*s12*S24**(-1) - 
     +    40*s13*S24**(-1) + 16*s14**2*S13**(-1)*S24**(-1) - 16*s14*
     +    S13**(-1) - 24*s14*S24**(-1) - 16*s23*S24**(-1) )

      LA34 = LA34 + Ld0(p1,p3,p24)*S234**(-2) * (  - 32*s12*s23*
     +    S24**(-1) - 32*s13*s23*S24**(-1) - 32*s14*s23*S24**(-1) )

      LA34 = LA34 + Ld0(p1,p3,p24)*S134**(-1) * ( 16 + 64*s12**2*
     +    S13**(-1)*S24**(-1) + 64*s12*s23*S13**(-1)*S24**(-1) - 8*s12*
     +    S13**(-1) - 96*s12*S24**(-1) + 48*s13*S24**(-1) + 16*s14*s23*
     +    S13**(-1)*S24**(-1) + 16*s14*S13**(-1) + 16*s23**2*S13**(-1)*
     +    S24**(-1) + 8*s23*S13**(-1) - 32*s23*S24**(-1) - 8*s24*
     +    S13**(-1) )

      LA34 = LA34 + Ld0(p1,p3,p24) * ( 32*s12*S13**(-1)*S24**(-1) + 16*
     +    s14*S13**(-1)*S24**(-1) + 16*s23*S13**(-1)*S24**(-1) + 8*s34*
     +    S13**(-1)*S24**(-1) )

      LA34 = LA34 + Ld0(p1,p34,p2)*S34**(-1) * ( 32*s12**2*S13**(-1)*
     +    S24**(-1) + 32*s12*s14*S13**(-1)*S24**(-1) + 32*s12*s23*
     +    S13**(-1)*S24**(-1) + 32*s12*S13**(-1) + 32*s12*S24**(-1) + 
     +    16*s13*S24**(-1) + 16*s14**2*S13**(-1)*S24**(-1) + 32*s14*
     +    S24**(-1) + 16*s23**2*S13**(-1)*S24**(-1) + 32*s23*S13**(-1)
     +     + 16*s24*S13**(-1) )

      LA34 = LA34 + Ld0(p2,p4,p3)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 128*s12**2 - 64*s12*s23 - 48*s13**2 + 48*s13*s23 - 32*
     +    s23**2 )

      LA34 = LA34 + Ld0(p2,p4,p3)*S34**(-1)*S234**(-1) * ( 32*s12**2*
     +    S13**(-1) + 32*s12*s14*S13**(-1) + 32*s12*s23*S13**(-1) - 192
     +    *s12 - 64*s13 + 16*s14**2*S13**(-1) + 32*s14*s23*S13**(-1) - 
     +    80*s14 + 16*s23**2*S13**(-1) + 48*s23 )

      LA34 = LA34 + Ld0(p2,p4,p3)*S34**(-1)*S234**(-2) * ( 64*s12*s23
     +     + 64*s13*s23 + 64*s14*s23 )

      LA34 = LA34 + Ld0(p2,p4,p3)*S34**(-1)*S134**(-1) * ( 16*s12**2*
     +    S24**(-1) - 16*s12*s13*S24**(-1) + 16*s12*s23*S24**(-1) - 80*
     +    s12 + 8*s13**2*S24**(-1) - 16*s13*s23*S24**(-1) + 16*s13 + 8*
     +    s23**2*S24**(-1) - 48*s23 - 24*s24 )

      LA34 = LA34 + Ld0(p2,p4,p3)*S34**(-1) * (  - 64 + 32*s12**2*
     +    S13**(-1)*S24**(-1) + 32*s12*s14*S13**(-1)*S24**(-1) + 32*s12
     +    *s23*S13**(-1)*S24**(-1) + 48*s12*S13**(-1) + 80*s12*
     +    S24**(-1) + 16*s13*S24**(-1) + 16*s14**2*S13**(-1)*S24**(-1)
     +     - 16*s14*S13**(-1) + 56*s14*S24**(-1) + 16*s23**2*S13**(-1)*
     +    S24**(-1) + 40*s23*S13**(-1) + 32*s23*S24**(-1) + 32*s24*
     +    S13**(-1) )

      LA34 = LA34 + Ld0(p2,p4,p3)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 64*s12*s13*s23 )

      LA34 = LA34 + Ld0(p2,p4,p3)*S34**(-2)*S234**(-1) * (  - 32*s12*
     +    s23 - 96*s13*s23 - 32*s14*s23 + 64*s23**2 )

      LA34 = LA34 + Ld0(p2,p4,p3)*S34**(-2)*S234**(-2) * ( 64*s12*
     +    s23**2 + 64*s13*s23**2 + 64*s14*s23**2 )

      LA34 = LA34 + Ld0(p2,p4,p3)*S34**(-2)*S134**(-1) * ( 32*s12*s13
     +     - 32*s13*s23 + 32*s13*s24 )

      LA34 = LA34 + Ld0(p2,p4,p3)*S34**(-2) * ( 32*s13 - 32*s23 )

      LA34 = LA34 + Ld0(p2,p4,p3)*S234**(-1)*S134**(-1) * ( 32*s12**3*
     +    S13**(-1)*S24**(-1) + 32*s12**2*s14*S13**(-1)*S24**(-1) - 64*
     +    s12**2*S13**(-1) - 24*s12*s13*S24**(-1) + 24*s12*s14*s23*
     +    S13**(-1)*S24**(-1) - 8*s12*s14*S13**(-1) - 48*s12*s14*
     +    S24**(-1) - 48*s12*s23*S13**(-1) + 24*s12*s23*S24**(-1) + 72*
     +    s12 + 16*s13**2*S24**(-1) + 24*s13*s14*S24**(-1) - 16*s13*s23
     +    *S24**(-1) - 40*s13 + 8*s14**2*s23*S13**(-1)*S24**(-1) + 8*
     +    s14**2*S13**(-1) - 16*s14*s23*S13**(-1) - 8*s14*s23*S24**(-1)
     +     - 8*s14*s24*S13**(-1) + 48*s14 - 16*s23**2*S13**(-1) + 8*s23
     +     - 8*s24 )

      LA34 = LA34 + Ld0(p2,p4,p3)*S234**(-1) * ( 8 + 32*s12*s14*
     +    S13**(-1)*S24**(-1) - 16*s12*S13**(-1) - 24*s13*S24**(-1) + 8
     +    *s14**2*S13**(-1)*S24**(-1) - 24*s14*S24**(-1) )

      LA34 = LA34 + Ld0(p2,p4,p3)*S234**(-2) * (  - 16*s12*s23*
     +    S24**(-1) + 32*s12 - 16*s13*s23*S24**(-1) + 32*s13 - 16*s14*
     +    s23*S24**(-1) + 32*s14 )

      LA34 = LA34 + Ld0(p2,p4,p3)*S134**(-1) * ( 24 + 48*s12**2*
     +    S13**(-1)*S24**(-1) - 8*s12*s14*S13**(-1)*S24**(-1) + 32*s12*
     +    s23*S13**(-1)*S24**(-1) - 8*s12*S13**(-1) - 56*s12*S24**(-1)
     +     + 24*s13*S24**(-1) + 8*s14*s23*S13**(-1)*S24**(-1) + 16*s14*
     +    S13**(-1) + 8*s23**2*S13**(-1)*S24**(-1) - 8*s23*S13**(-1) - 
     +    16*s23*S24**(-1) - 16*s24*S13**(-1) )

      LA34 = LA34 + Ld0(p2,p4,p3) * ( 16*s12*S13**(-1)*S24**(-1) + 16*
     +    s14*S13**(-1)*S24**(-1) + 16*s23*S13**(-1)*S24**(-1) + 8*s34*
     +    S13**(-1)*S24**(-1) )

      LA34 = LA34 + Ld0(p2,p4,p13)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 128*s12**2 - 64*s12*s23 - 32*s13**2 + 64*s13*s23 - 32*
     +    s23**2 )

      LA34 = LA34 + Ld0(p2,p4,p13)*S34**(-1)*S234**(-1) * (  - 32*
     +    s12**3*S13**(-1)*S24**(-1) + 64*s12**2*S13**(-1) + 64*s12*s14
     +    *S13**(-1) + 48*s12*s23*S13**(-1) + 32*s13 + 16*s14**2*
     +    S13**(-1) + 32*s14*s23*S13**(-1) - 32*s14 + 16*s23**2*
     +    S13**(-1) - 64*s23 )

      LA34 = LA34 + Ld0(p2,p4,p13)*S34**(-1)*S134**(-1) * ( 32*s12**2*
     +    S24**(-1) - 32*s12*s13*S24**(-1) + 32*s12*s23*S24**(-1) - 144
     +    *s12 + 16*s13**2*S24**(-1) - 32*s13*s23*S24**(-1) + 96*s13 + 
     +    16*s23**2*S24**(-1) - 96*s23 - 64*s24 )

      LA34 = LA34 + Ld0(p2,p4,p13)*S34**(-1)*S134**(-2) * ( 128*s12*s13
     +     + 128*s13*s23 + 128*s13*s24 )

      LA34 = LA34 + Ld0(p2,p4,p13)*S34**(-1) * (  - 48 - 48*s12**2*
     +    S13**(-1)*S24**(-1) - 16*s12*s14*S13**(-1)*S24**(-1) - 32*s12
     +    *s23*S13**(-1)*S24**(-1) + 16*s12*S13**(-1) + 32*s12*
     +    S24**(-1) - 8*s13*S24**(-1) - 8*s14**2*S13**(-1)*S24**(-1) + 
     +    16*s14*S13**(-1) + 8*s14*S24**(-1) - 8*s23**2*S13**(-1)*
     +    S24**(-1) + 8*s23*S13**(-1) + 16*s23*S24**(-1) + 8*s24*
     +    S13**(-1) )

      LA34 = LA34 + Ld0(p2,p4,p13)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 64*s12*s13*s23 )

      LA34 = LA34 + Ld0(p2,p4,p13)*S34**(-2)*S234**(-1) * ( 32*s12*s23
     +     - 32*s13*s23 + 32*s14*s23 )

      LA34 = LA34 + Ld0(p2,p4,p13)*S34**(-2)*S134**(-1) * (  - 32*s12*
     +    s13 + 64*s13**2 - 96*s13*s23 - 32*s13*s24 )

      LA34 = LA34 + Ld0(p2,p4,p13)*S34**(-2)*S134**(-2) * ( 64*s12*
     +    s13**2 + 64*s13**2*s23 + 64*s13**2*s24 )

      LA34 = LA34 + Ld0(p2,p4,p13)*S34**(-2) * (  - 32*s13 + 32*s23 )

      LA34 = LA34 + Ld0(p2,p4,p13)*S234**(-1)*S134**(-1) * ( 32*s12**3*
     +    S13**(-1)*S24**(-1) + 64*s12**2*s14*S13**(-1)*S24**(-1) - 64*
     +    s12**2*S13**(-1) - 48*s12*s13*S24**(-1) + 48*s12*s14*s23*
     +    S13**(-1)*S24**(-1) - 96*s12*s14*S24**(-1) - 48*s12*s23*
     +    S13**(-1) + 48*s12*s23*S24**(-1) + 96*s12 + 32*s13**2*
     +    S24**(-1) + 48*s13*s14*S24**(-1) - 32*s13*s23*S24**(-1) - 32*
     +    s13 + 16*s14**2*s23*S13**(-1)*S24**(-1) + 16*s14**2*S13**(-1)
     +     - 32*s14*s23*S13**(-1) - 16*s14*s23*S24**(-1) - 16*s14*s24*
     +    S13**(-1) + 32*s14 - 16*s23**2*S13**(-1) + 16*s23 - 16*s24 )

      LA34 = LA34 + Ld0(p2,p4,p13)*S234**(-1) * (  - 32 + 64*s12*s14*
     +    S13**(-1)*S24**(-1) + 40*s12*S24**(-1) - 40*s13*S24**(-1) + 
     +    16*s14**2*S13**(-1)*S24**(-1) - 16*s14*S13**(-1) - 8*s14*
     +    S24**(-1) )

      LA34 = LA34 + Ld0(p2,p4,p13)*S134**(-1) * ( 48 + 64*s12**2*
     +    S13**(-1)*S24**(-1) + 48*s12*s23*S13**(-1)*S24**(-1) - 24*s12
     +    *S13**(-1) - 96*s12*S24**(-1) + 48*s13*S24**(-1) + 16*s14*s23
     +    *S13**(-1)*S24**(-1) + 16*s23**2*S13**(-1)*S24**(-1) - 8*s23*
     +    S13**(-1) - 32*s23*S24**(-1) - 8*s24*S13**(-1) )

      LA34 = LA34 + Ld0(p2,p4,p13)*S134**(-2) * (  - 32*s12*s14*
     +    S13**(-1) + 64*s12 - 32*s14*s23*S13**(-1) - 32*s14*s24*
     +    S13**(-1) + 64*s23 + 64*s24 )

      LA34 = LA34 + Ld0(p2,p4,p13) * ( 32*s12*S13**(-1)*S24**(-1) + 16*
     +    s14*S13**(-1)*S24**(-1) + 16*s23*S13**(-1)*S24**(-1) + 8*s34*
     +    S13**(-1)*S24**(-1) )

      LA34 = LA34 + Ld1(p1,p3,p4)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +    16*s12**2*s13 + 16*s12**2*s14 + 16*s12*s13**2 + 32*s12*s13*
     +    s14 + 32*s12*s13*s23 + 64*s12*s13*s24 + 16*s12*s14**2 + 32*
     +    s12*s14*s23 + 8*s13**3 + 24*s13**2*s14 + 16*s13**2*s23 + 48*
     +    s13**2*s24 + 24*s13*s14**2 + 32*s13*s14*s23 + 16*s13*s14*s24
     +     + 10*s13*s23**2 + 64*s13*s23*s24 + 24*s13*s24**2 + 8*s14**3
     +     + 16*s14**2*s23 - 16*s14**2*s24 + 10*s14*s23**2 + 8*s14*
     +    s24**2 )

      LA34 = LA34 + Ld1(p1,p3,p4)*S234**(-1)*S134**(-1) * (  - 16*
     +    s12**3*s14*S13**(-1)*S24**(-1) + 16*s12**3*s34*S13**(-1)*
     +    S24**(-1) - 16*s12**3*S24**(-1) - 16*s12**2*s13*S24**(-1) - 
     +    16*s12**2*s14**2*S13**(-1)*S24**(-1) - 32*s12**2*s14*
     +    S24**(-1) - 8*s12**2*s23*s34*S13**(-1)*S24**(-1) + 8*s12**2*
     +    s34**2*S13**(-1)*S24**(-1) - 8*s12**2*s34*S13**(-1) - 16*
     +    s12**2*s34*S24**(-1) - 80*s12**2 - 8*s12*s13**2*S24**(-1) - 
     +    24*s12*s13*s14*S24**(-1) + 16*s12*s13*s23*S24**(-1) - 16*s12*
     +    s13*s34*S24**(-1) - 32*s12*s13 - 8*s12*s14**3*S13**(-1)*
     +    S24**(-1) + 16*s12*s14**2*s23*S13**(-1)*S24**(-1) + 16*s12*
     +    s14**2*S13**(-1) - 24*s12*s14**2*S24**(-1) - 2*s12*s14*s23**2
     +    *S13**(-1)*S24**(-1) + 8*s12*s14*s23*s34*S13**(-1)*S24**(-1)
     +     - 16*s12*s14*s23*S13**(-1) + 32*s12*s14*s23*S24**(-1) - 8*
     +    s12*s14*s24*S13**(-1) + 8*s12*s14*s34**2*S13**(-1)*S24**(-1)
     +     + 8*s12*s14*s34*S13**(-1) - 24*s12*s14*s34*S24**(-1) - 16*
     +    s12*s14 - 2*s12*s23**2*S24**(-1) - 24*s12*s23 - 16*s12*s24 - 
     +    16*s12*s34**2*S24**(-1) )

      LA34 = LA34 + Ld1(p1,p3,p4)*S234**(-1)*S134**(-1) * (  - 64*s12*
     +    s34 + 16*s13**2 + 24*s13*s14 + 32*s13*s23 + 56*s13*s24 + 16*
     +    s13*s34 + 8*s14*s23 - 8*s14*s24 - 8*s14*s34 )

      LA34 = LA34 + Ld1(p1,p3,p24)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +    32*s12**4*s23*S13**(-1)*S24**(-1) + 80*s12**3*s14*s23*
     +    S13**(-1)*S24**(-1) - 64*s12**3*s23**2*S13**(-1)*S24**(-1) - 
     +    64*s12**3*s23*S13**(-1) - 16*s12**3 + 16*s12**2*s13*s23*
     +    S24**(-1) + 80*s12**2*s14**2*s23*S13**(-1)*S24**(-1) - 48*
     +    s12**2*s14*s23**2*S13**(-1)*S24**(-1) - 48*s12**2*s14*s23*
     +    S13**(-1) + 16*s12**2*s14*s23*S24**(-1) - 32*s12**2*s14 + 16*
     +    s12**2*s23**3*S13**(-1)*S24**(-1) + 32*s12**2*s23**2*
     +    S13**(-1) - 32*s12**2*s23**2*S24**(-1) + 16*s12**2*s23*s24*
     +    S13**(-1) - 80*s12**2*s23 + 16*s12**2*s24 + 24*s12*s13*s14*
     +    s23*S24**(-1) + 48*s12*s13*s23 + 48*s12*s13*s24 + 40*s12*
     +    s14**3*s23*S13**(-1)*S24**(-1) + 24*s12*s14**2*s23*S24**(-1)
     +     - 24*s12*s14**2 - 48*s12*s14*s23**2*S24**(-1) - 48*s12*s14*
     +    s23 + 96*s12*s23**2 + 48*s12*s23*s24 + 8*s13**3 + 8*s13**2*
     +    s14 - 16*s13**2*s24 + 8*s13*s14**2*s23*S24**(-1) + 32*s13*s14
     +    *s23 - 24*s13*s23*s24 + 8*s14**4*s23*S13**(-1)*S24**(-1) + 8*
     +    s14**3*s23*S24**(-1) )

      LA34 = LA34 + Ld1(p1,p3,p24)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 8*s14**3 - 16*s14**2*s23**2*S24**(-1) + 24*s14*s23**2 )

      LA34 = LA34 + Ld1(p1,p3,p24)*S34**(-1)*S234**(-2)*S134**(-1) * ( 
     +     - 16*s12**2*s13*s23 - 16*s12**2*s14*s23 - 24*s12*s13**2*s23
     +     - 48*s12*s13*s14*s23 - 24*s12*s14**2*s23 - 8*s13**3*s23 - 24
     +    *s13**2*s14*s23 - 24*s13*s14**2*s23 - 8*s14**3*s23 )

      LA34 = LA34 + Ld1(p1,p3,p24)*S234**(-1)*S134**(-1) * ( 16*s12**4*
     +    S13**(-1)*S24**(-1) + 32*s12**3*s14*S13**(-1)*S24**(-1) - 48*
     +    s12**3*s23*S13**(-1)*S24**(-1) - 16*s12**3*S13**(-1) + 16*
     +    s12**2*s13*S24**(-1) + 24*s12**2*s14**2*S13**(-1)*S24**(-1)
     +     + 16*s12**2*s14*s34*S13**(-1)*S24**(-1) + 16*s12**2*s14*
     +    S24**(-1) - 16*s12**2*s23**2*S13**(-1)*S24**(-1) - 48*s12**2*
     +    s23*s34*S13**(-1)*S24**(-1) + 16*s12**2*s23*S13**(-1) - 24*
     +    s12**2*s23*S24**(-1) - 16*s12**2*s34**2*S13**(-1)*S24**(-1)
     +     - 64*s12**2 + 8*s12*s13**2*S24**(-1) + 24*s12*s13*s14*
     +    S24**(-1) + 24*s12*s13*s23*S24**(-1) + 16*s12*s13*s34*
     +    S24**(-1) + 8*s12*s14**3*S13**(-1)*S24**(-1) + 16*s12*s14**2*
     +    s23*S13**(-1)*S24**(-1) + 16*s12*s14**2*S24**(-1) - 48*s12*
     +    s14*s23**2*S13**(-1)*S24**(-1) - 56*s12*s14*s23*s34*S13**(-1)
     +    *S24**(-1) - 8*s12*s14*s23*S24**(-1) - 8*s12*s14*s34**2*
     +    S13**(-1)*S24**(-1) + 8*s12*s14*s34*S13**(-1) + 8*s12*s14*s34
     +    *S24**(-1) - 32*s12*s14 + 16*s12*s23*s34*S24**(-1) + 168*s12*
     +    s23 )

      LA34 = LA34 + Ld1(p1,p3,p24)*S234**(-1)*S134**(-1) * ( 8*s12*
     +    s34**2*S24**(-1) + 56*s12*s34 - 16*s13**2 + 16*s13*s14*s23*
     +    S24**(-1) - 8*s13*s14 - 40*s13*s24 - 8*s13*s34 - 8*s14**2*
     +    s23**2*S13**(-1)*S24**(-1) - 8*s14**2*s23*s34*S13**(-1)*
     +    S24**(-1) + 8*s14**2*s23*S13**(-1) + 8*s14**2*s23*S24**(-1)
     +     + 8*s14*s23*s34*S24**(-1) + 48*s14*s23 - 8*s14*s24 + 8*s14*
     +    s34 )

      LA34 = LA34 + Ld1(p1,p3,p24)*S234**(-2)*S134**(-1) * ( 8*s12**2*
     +    s13*s23*S24**(-1) - 16*s12**2*s13 + 8*s12**2*s14*s23*
     +    S24**(-1) - 16*s12**2*s14 - 8*s12**2*s23**2*S24**(-1) - 8*
     +    s12**2*s23 + 16*s12**2*s24 + 8*s12*s13**2*s23*S24**(-1) - 32*
     +    s12*s13**2 + 24*s12*s13*s14*s23*S24**(-1) - 48*s12*s13*s14 - 
     +    8*s12*s13*s23**2*S24**(-1) + 32*s12*s13*s24 + 16*s12*s14**2*
     +    s23*S24**(-1) - 16*s12*s14**2 - 16*s12*s14*s23**2*S24**(-1)
     +     - 24*s12*s14*s23 + 16*s12*s14*s24 - 16*s13**3 + 8*s13**2*s14
     +    *s23*S24**(-1) - 32*s13**2*s14 + 8*s13**2*s23 + 16*s13**2*s24
     +     + 16*s13*s14**2*s23*S24**(-1) - 16*s13*s14**2 - 8*s13*s14*
     +    s23**2*S24**(-1) - 8*s13*s14*s23 + 16*s13*s14*s24 + 8*s14**3*
     +    s23*S24**(-1) - 8*s14**2*s23**2*S24**(-1) - 16*s14**2*s23 )

      LA34 = LA34 + Ld1(p2,p4,p3)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +    16*s12**2*s23 + 16*s12**2*s24 + 64*s12*s13*s24 + 32*s12*s14*
     +    s23 + 32*s12*s14*s24 + 16*s12*s23**2 + 32*s12*s23*s24 + 16*
     +    s12*s24**2 + 8*s13**2*s23 + 24*s13**2*s24 + 64*s13*s14*s24 - 
     +    16*s13*s23**2 + 16*s13*s23*s24 + 48*s13*s24**2 + 10*s14**2*
     +    s23 + 10*s14**2*s24 + 16*s14*s23**2 + 32*s14*s23*s24 + 16*s14
     +    *s24**2 + 8*s23**3 + 24*s23**2*s24 + 24*s23*s24**2 + 8*s24**3
     +     )

      LA34 = LA34 + Ld1(p2,p4,p3)*S234**(-1)*S134**(-1) * (  - 16*
     +    s12**3*s23*S13**(-1)*S24**(-1) + 16*s12**3*s34*S13**(-1)*
     +    S24**(-1) - 16*s12**3*S13**(-1) - 8*s12**2*s14*s34*S13**(-1)*
     +    S24**(-1) - 16*s12**2*s23**2*S13**(-1)*S24**(-1) - 32*s12**2*
     +    s23*S13**(-1) - 16*s12**2*s24*S13**(-1) + 8*s12**2*s34**2*
     +    S13**(-1)*S24**(-1) - 16*s12**2*s34*S13**(-1) - 8*s12**2*s34*
     +    S24**(-1) - 80*s12**2 - 8*s12*s13*s23*S24**(-1) - 16*s12*s13
     +     - 2*s12*s14**2*s23*S13**(-1)*S24**(-1) - 2*s12*s14**2*
     +    S13**(-1) + 16*s12*s14*s23**2*S13**(-1)*S24**(-1) + 8*s12*s14
     +    *s23*s34*S13**(-1)*S24**(-1) + 32*s12*s14*s23*S13**(-1) - 16*
     +    s12*s14*s23*S24**(-1) + 16*s12*s14*s24*S13**(-1) - 24*s12*s14
     +     - 8*s12*s23**3*S13**(-1)*S24**(-1) - 24*s12*s23**2*S13**(-1)
     +     + 16*s12*s23**2*S24**(-1) - 24*s12*s23*s24*S13**(-1) + 8*s12
     +    *s23*s34**2*S13**(-1)*S24**(-1) - 24*s12*s23*s34*S13**(-1) + 
     +    8*s12*s23*s34*S24**(-1) - 16*s12*s23 - 8*s12*s24**2*S13**(-1)
     +     - 16*s12*s24*s34*S13**(-1) - 32*s12*s24 - 16*s12*s34**2*
     +    S13**(-1) )

      LA34 = LA34 + Ld1(p2,p4,p3)*S234**(-1)*S134**(-1) * (  - 64*s12*
     +    s34 - 8*s13*s23 + 56*s13*s24 + 8*s14*s23 + 32*s14*s24 + 24*
     +    s23*s24 - 8*s23*s34 + 16*s24**2 + 16*s24*s34 )

      LA34 = LA34 + Ld1(p2,p4,p13)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +    32*s12**4*s14*S13**(-1)*S24**(-1) - 64*s12**3*s14**2*
     +    S13**(-1)*S24**(-1) + 80*s12**3*s14*s23*S13**(-1)*S24**(-1)
     +     - 64*s12**3*s14*S24**(-1) - 16*s12**3 + 16*s12**2*s13*s14*
     +    S24**(-1) + 16*s12**2*s13 + 16*s12**2*s14**3*S13**(-1)*
     +    S24**(-1) - 48*s12**2*s14**2*s23*S13**(-1)*S24**(-1) - 32*
     +    s12**2*s14**2*S13**(-1) + 32*s12**2*s14**2*S24**(-1) + 80*
     +    s12**2*s14*s23**2*S13**(-1)*S24**(-1) + 16*s12**2*s14*s23*
     +    S13**(-1) - 48*s12**2*s14*s23*S24**(-1) + 16*s12**2*s14*s24*
     +    S13**(-1) - 80*s12**2*s14 - 48*s12**2*s23 - 16*s12**2*s24 + 
     +    48*s12*s13*s14 + 48*s12*s13*s24 - 48*s12*s14**2*s23*S13**(-1)
     +     + 96*s12*s14**2 + 40*s12*s14*s23**3*S13**(-1)*S24**(-1) + 24
     +    *s12*s14*s23**2*S13**(-1) + 24*s12*s14*s23*s24*S13**(-1) - 48
     +    *s12*s14*s23 + 48*s12*s14*s24 - 48*s12*s23**2 - 48*s12*s23*
     +    s24 - 24*s12*s24**2 - 24*s13*s14*s24 - 16*s13*s24**2 - 16*
     +    s14**2*s23**2*S13**(-1) + 24*s14**2*s23 + 8*s14*s23**4*
     +    S13**(-1)*S24**(-1) )

      LA34 = LA34 + Ld1(p2,p4,p13)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +    8*s14*s23**3*S13**(-1) + 8*s14*s23**2*s24*S13**(-1) + 32*s14*
     +    s23*s24 - 16*s23**3 - 24*s23**2*s24 - 16*s23*s24**2 )

      LA34 = LA34 + Ld1(p2,p4,p13)*S34**(-1)*S234**(-1)*S134**(-2) * ( 
     +    16*s12**2*s13*s23 + 16*s12**2*s13*s24 + 24*s12*s13*s23**2 + 
     +    48*s12*s13*s23*s24 + 24*s12*s13*s24**2 + 8*s13*s23**3 + 24*
     +    s13*s23**2*s24 + 24*s13*s23*s24**2 + 8*s13*s24**3 )

      LA34 = LA34 + Ld1(p2,p4,p13)*S234**(-1)*S134**(-1) * ( 16*s12**4*
     +    S13**(-1)*S24**(-1) - 48*s12**3*s14*S13**(-1)*S24**(-1) + 32*
     +    s12**3*s23*S13**(-1)*S24**(-1) - 16*s12**3*S24**(-1) - 16*
     +    s12**2*s14**2*S13**(-1)*S24**(-1) - 48*s12**2*s14*s34*
     +    S13**(-1)*S24**(-1) - 24*s12**2*s14*S13**(-1) + 16*s12**2*s14
     +    *S24**(-1) + 24*s12**2*s23**2*S13**(-1)*S24**(-1) + 16*s12**2
     +    *s23*s34*S13**(-1)*S24**(-1) + 16*s12**2*s23*S13**(-1) + 16*
     +    s12**2*s24*S13**(-1) - 16*s12**2*s34**2*S13**(-1)*S24**(-1)
     +     - 64*s12**2 - 48*s12*s14**2*s23*S13**(-1)*S24**(-1) + 16*s12
     +    *s14*s23**2*S13**(-1)*S24**(-1) - 56*s12*s14*s23*s34*
     +    S13**(-1)*S24**(-1) - 8*s12*s14*s23*S13**(-1) + 24*s12*s14*
     +    s24*S13**(-1) + 16*s12*s14*s34*S13**(-1) + 168*s12*s14 + 8*
     +    s12*s23**3*S13**(-1)*S24**(-1) + 16*s12*s23**2*S13**(-1) + 24
     +    *s12*s23*s24*S13**(-1) - 8*s12*s23*s34**2*S13**(-1)*S24**(-1)
     +     + 8*s12*s23*s34*S13**(-1) + 8*s12*s23*s34*S24**(-1) - 32*s12
     +    *s23 + 8*s12*s24**2*S13**(-1) + 16*s12*s24*s34*S13**(-1) + 8*
     +    s12*s34**2*S13**(-1) )

      LA34 = LA34 + Ld1(p2,p4,p13)*S234**(-1)*S134**(-1) * ( 56*s12*s34
     +     - 8*s13*s23 - 40*s13*s24 - 8*s14**2*s23**2*S13**(-1)*
     +    S24**(-1) - 8*s14*s23**2*s34*S13**(-1)*S24**(-1) + 8*s14*
     +    s23**2*S13**(-1) + 8*s14*s23**2*S24**(-1) + 16*s14*s23*s24*
     +    S13**(-1) + 8*s14*s23*s34*S13**(-1) + 48*s14*s23 - 8*s23*s24
     +     + 8*s23*s34 - 16*s24**2 - 8*s24*s34 )

      LA34 = LA34 + Ld1(p2,p4,p13)*S234**(-1)*S134**(-2) * ( 16*s12**2*
     +    s13 - 8*s12**2*s14**2*S13**(-1) + 8*s12**2*s14*s23*S13**(-1)
     +     + 8*s12**2*s14*s24*S13**(-1) - 8*s12**2*s14 + 16*s12*s13*s23
     +     + 32*s12*s13*s24 - 16*s12*s14**2*s23*S13**(-1) - 8*s12*
     +    s14**2*s24*S13**(-1) + 16*s12*s14*s23**2*S13**(-1) + 24*s12*
     +    s14*s23*s24*S13**(-1) - 24*s12*s14*s23 + 8*s12*s14*s24**2*
     +    S13**(-1) + 8*s12*s23**2 - 8*s12*s24**2 + 16*s13*s23*s24 + 16
     +    *s13*s24**2 - 8*s14**2*s23**2*S13**(-1) - 8*s14**2*s23*s24*
     +    S13**(-1) + 8*s14*s23**3*S13**(-1) + 16*s14*s23**2*s24*
     +    S13**(-1) - 16*s14*s23**2 + 8*s14*s23*s24**2*S13**(-1) - 8*
     +    s14*s23*s24 + 8*s14*s24**2 + 8*s23**3 + 8*s23**2*s24 - 8*s23*
     +    s24**2 - 8*s24**3 )

      LA34 = LA34 + Ld21(p1,p3,p4)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +     - 32*s12**2*s13 - 32*s12**2*s14 - 32*s12*s13**2 - 64*s12*s13
     +    *s14 - 20*s12*s13*s23 - 48*s12*s13*s24 + 6*s12*s14**2*s23**2*
     +    S13**(-1)*S24**(-1) - 32*s12*s14**2 + 6*s12*s14*s23**2*
     +    S24**(-1) - 20*s12*s14*s23 + 16*s12*s14*s24 )

      LA34 = LA34 + Ld21(p1,p3,p4)*S234**(-1)*S134**(-1) * ( 16*s12**3*
     +    s14*S13**(-1)*S24**(-1) - 8*s12**3*s34*S13**(-1)*S24**(-1) + 
     +    16*s12**3*S24**(-1) + 16*s12**2*s13*S24**(-1) + 16*s12**2*
     +    s14**2*S13**(-1)*S24**(-1) - 8*s12**2*s14*s23*S13**(-1)*
     +    S24**(-1) + 8*s12**2*s14*s34*S13**(-1)*S24**(-1) - 8*s12**2*
     +    s14*S13**(-1) + 32*s12**2*s14*S24**(-1) - 8*s12**2*s23*
     +    S24**(-1) + 16*s12**2*s34*S24**(-1) + 40*s12**2 - 32*s12*s13
     +     - 16*s12*s14 )

      LA34 = LA34 + Ld21(p1,p3,p24)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 24*s12**2*s23**3*S13**(-1)*S24**(-1) - 48*s12**2*s23**2*
     +    S13**(-1) - 16*s12**2*s23**2*S24**(-1) - 24*s12**2*s23*s24*
     +    S13**(-1) - 32*s12**2*s23 - 16*s12**2*s24 - 24*s12*s14*s23**3
     +    *S13**(-1)*S24**(-1) - 48*s12*s14*s23**2*S13**(-1) - 16*s12*
     +    s14*s23**2*S24**(-1) - 24*s12*s14*s23*s24*S13**(-1) - 32*s12*
     +    s14*s23 - 16*s12*s14*s24 + 8*s12*s23**3*S24**(-1) + 24*s12*
     +    s23**2 + 24*s12*s23*s24 + 8*s12*s24**2 + 24*s13*s23**2 + 48*
     +    s13*s23*s24 + 24*s13*s24**2 )

      LA34 = LA34 + Ld21(p1,p3,p24)*S234**(-1)*S134**(-1) * (  - 24*
     +    s12**2*s23**2*S13**(-1)*S24**(-1) - 24*s12**2*s23*S13**(-1)
     +     - 24*s12*s14*s23**2*S13**(-1)*S24**(-1) - 24*s12*s14*s23*
     +    S13**(-1) - 8*s14*s23**2*S24**(-1) - 16*s14*s23 - 8*s14*s24 )

      LA34 = LA34 + Ld21(p2,p4,p3)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +    6*s12*s14**2*s23**2*S13**(-1)*S24**(-1) + 6*s12*s14**2*s23*
     +    S13**(-1) - 12*s12*s14*s23 - 12*s12*s14*s24 )

      LA34 = LA34 + Ld21(p2,p4,p3)*S234**(-1)*S134**(-1) * ( 16*s12**3*
     +    s23*S13**(-1)*S24**(-1) - 8*s12**3*s34*S13**(-1)*S24**(-1) + 
     +    16*s12**3*S13**(-1) - 8*s12**2*s14*s23*S13**(-1)*S24**(-1) - 
     +    8*s12**2*s14*S13**(-1) + 16*s12**2*s23**2*S13**(-1)*S24**(-1)
     +     + 8*s12**2*s23*s34*S13**(-1)*S24**(-1) + 32*s12**2*s23*
     +    S13**(-1) - 8*s12**2*s23*S24**(-1) + 16*s12**2*s24*S13**(-1)
     +     + 16*s12**2*s34*S13**(-1) + 24*s12**2 )

      LA34 = LA34 + Ld21(p2,p4,p13)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 24*s12**2*s13*s14*S24**(-1) - 16*s12**2*s13 - 24*s12**2*
     +    s14**3*S13**(-1)*S24**(-1) - 16*s12**2*s14**2*S13**(-1) - 48*
     +    s12**2*s14**2*S24**(-1) - 32*s12**2*s14 + 8*s12*s13**2 - 24*
     +    s12*s13*s14*s23*S24**(-1) + 24*s12*s13*s14 - 16*s12*s13*s23
     +     - 24*s12*s14**3*s23*S13**(-1)*S24**(-1) + 8*s12*s14**3*
     +    S13**(-1) - 16*s12*s14**2*s23*S13**(-1) - 48*s12*s14**2*s23*
     +    S24**(-1) + 24*s12*s14**2 - 32*s12*s14*s23 + 24*s13**2*s24 + 
     +    48*s13*s14*s24 + 24*s14**2*s24 )

      LA34 = LA34 + Ld21(p2,p4,p13)*S234**(-1)*S134**(-1) * (  - 24*
     +    s12**2*s14**2*S13**(-1)*S24**(-1) - 24*s12**2*s14*S24**(-1)
     +     - 24*s12*s14**2*s23*S13**(-1)*S24**(-1) - 24*s12*s14*s23*
     +    S24**(-1) - 8*s13*s23 - 8*s14**2*s23*S13**(-1) - 16*s14*s23 )

      LA34 = LA34 + Ld21(p3,p4,p2)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +    16*s12*s13*s23 + 16*s12*s13*s24 - 8*s13**2*s23 + 24*s13**2*
     +    s24 + 16*s13*s14*s23 + 16*s13*s14*s24 + 16*s13*s23**2 + 32*
     +    s13*s23*s24 + 16*s13*s24**2 - 6*s14**2*s23**2*S24**(-1) - 6*
     +    s14**2*s23 )

      LA34 = LA34 + Ld21(p3,p4,p2)*S234**(-1)*S134**(-1) * (  - 32*
     +    s12**2*s23*S24**(-1) + 16*s12**2*s34*S24**(-1) - 32*s12**2 + 
     +    16*s12*s13*s23*S24**(-1) - 56*s12*s13 + 4*s12*s14*s23*
     +    S24**(-1) + 4*s12*s14 - 32*s12*s23**2*S24**(-1) - 16*s12*s23*
     +    s34*S24**(-1) - 64*s12*s23 - 32*s12*s24 - 32*s12*s34 + 8*s13*
     +    s23 + 16*s13*s24 )

      LA34 = LA34 + Ld21(p4,p3,p1)*S34**(-1)*S234**(-1)*S134**(-1) * ( 
     +    16*s12*s13*s24 + 16*s12*s14*s24 + 16*s13**2*s24 + 32*s13*s14*
     +    s24 + 16*s13*s23*s24 + 24*s13*s24**2 - 6*s14**2*s23**2*
     +    S13**(-1) + 16*s14**2*s24 - 6*s14*s23**2 + 16*s14*s23*s24 - 8
     +    *s14*s24**2 )

      LA34 = LA34 + Ld21(p4,p3,p1)*S234**(-1)*S134**(-1) * ( 12*s12*s14
     +    *s23*S13**(-1) + 12*s12*s23 - 8*s12*s24 + 16*s13*s24 + 8*s14*
     +    s24 )

      LA34 = LA34 + Ld22(p1,p3,p24)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 16*s12**3*s23**2*S13**(-1)*S24**(-1) + 32*s12**2*s14*s23**2
     +    *S13**(-1)*S24**(-1) - 32*s12**2*s23**3*S13**(-1)*S24**(-1)
     +     - 32*s12**2*s23**2*S13**(-1) - 16*s12**2*s23**2*S24**(-1) - 
     +    32*s12**2*s23 + 16*s12*s14**2*s23**2*S13**(-1)*S24**(-1) - 32
     +    *s12*s14*s23**3*S13**(-1)*S24**(-1) - 32*s12*s14*s23**2*
     +    S13**(-1) - 16*s12*s14*s23**2*S24**(-1) - 32*s12*s14*s23 + 8*
     +    s12*s23**3*S24**(-1) + 16*s12*s23*s24 + 24*s13*s23**2 + 48*
     +    s13*s23*s24 - 24*s14*s23**2 )

      LA34 = LA34 + Ld22(p1,p3,p24)*S234**(-1)*S134**(-1) * (  - 24*
     +    s12**2*s23**2*S13**(-1)*S24**(-1) - 16*s12*s14*s23**2*
     +    S13**(-1)*S24**(-1) + 8*s14**2*s23**2*S13**(-1)*S24**(-1) - 8
     +    *s14*s23**2*S24**(-1) - 16*s14*s23 )

      LA34 = LA34 + Ld22(p2,p4,p13)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 16*s12**3*s14**2*S13**(-1)*S24**(-1) - 32*s12**2*s14**3*
     +    S13**(-1)*S24**(-1) + 32*s12**2*s14**2*s23*S13**(-1)*
     +    S24**(-1) - 16*s12**2*s14**2*S13**(-1) - 32*s12**2*s14**2*
     +    S24**(-1) - 32*s12**2*s14 + 16*s12*s13*s14 - 32*s12*s14**3*
     +    s23*S13**(-1)*S24**(-1) + 8*s12*s14**3*S13**(-1) + 16*s12*
     +    s14**2*s23**2*S13**(-1)*S24**(-1) - 16*s12*s14**2*s23*
     +    S13**(-1) - 32*s12*s14**2*s23*S24**(-1) - 32*s12*s14*s23 + 48
     +    *s13*s14*s24 - 24*s14**2*s23 + 24*s14**2*s24 )

      LA34 = LA34 + Ld22(p2,p4,p13)*S234**(-1)*S134**(-1) * (  - 24*
     +    s12**2*s14**2*S13**(-1)*S24**(-1) - 16*s12*s14**2*s23*
     +    S13**(-1)*S24**(-1) + 8*s14**2*s23**2*S13**(-1)*S24**(-1) - 8
     +    *s14**2*s23*S13**(-1) - 16*s14*s23 )

      LA34 = LA34 + Ld24(p1,p3,p24)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 48*s12**4*s23*S13**(-1)*S24**(-1) - 80*s12**3*s14*s23*
     +    S13**(-1)*S24**(-1) + 48*s12**3*s23**2*S13**(-1)*S24**(-1) + 
     +    48*s12**3*s23*S13**(-1) + 32*s12**3 - 32*s12**2*s14**2*s23*
     +    S13**(-1)*S24**(-1) + 40*s12**2*s14*s23**2*S13**(-1)*
     +    S24**(-1) + 40*s12**2*s14*s23*S13**(-1) + 32*s12**2*s14 + 56*
     +    s12**2*s23 - 16*s12**2*s24 - 48*s12*s13*s24 + 48*s12*s14*s23
     +     )

      LA34 = LA34 + Ld24(p1,p3,p24)*S234**(-1)*S134**(-1) * (  - 16*
     +    s12**4*S13**(-1)*S24**(-1) - 16*s12**3*s14*S13**(-1)*
     +    S24**(-1) + 32*s12**3*s23*S13**(-1)*S24**(-1) + 8*s12**3*
     +    S13**(-1) - 8*s12**2*s14*s34*S13**(-1)*S24**(-1) + 24*s12**2
     +     - 16*s12*s14**2*s23*S13**(-1)*S24**(-1) + 16*s12*s14 )

      LA34 = LA34 + Ld24(p2,p4,p13)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 48*s12**4*s14*S13**(-1)*S24**(-1) + 48*s12**3*s14**2*
     +    S13**(-1)*S24**(-1) - 80*s12**3*s14*s23*S13**(-1)*S24**(-1)
     +     + 48*s12**3*s14*S24**(-1) + 32*s12**3 - 16*s12**2*s13 + 40*
     +    s12**2*s14**2*s23*S13**(-1)*S24**(-1) - 32*s12**2*s14*s23**2*
     +    S13**(-1)*S24**(-1) + 40*s12**2*s14*s23*S24**(-1) + 56*s12**2
     +    *s14 + 32*s12**2*s23 - 48*s12*s13*s24 + 48*s12*s14*s23 )

      LA34 = LA34 + Ld24(p2,p4,p13)*S234**(-1)*S134**(-1) * (  - 16*
     +    s12**4*S13**(-1)*S24**(-1) + 32*s12**3*s14*S13**(-1)*
     +    S24**(-1) - 16*s12**3*s23*S13**(-1)*S24**(-1) + 8*s12**3*
     +    S24**(-1) - 8*s12**2*s23*s34*S13**(-1)*S24**(-1) + 24*s12**2
     +     - 16*s12*s14*s23**2*S13**(-1)*S24**(-1) + 16*s12*s23 )

      LA34 = LA34 + Ld311(p1,p3,p4)*S234**(-1)*S134**(-1) * (  - 8*
     +    s12**3*s14*S13**(-1)*S24**(-1) - 8*s12**3*S24**(-1) )

      LA34 = LA34 + Ld311(p1,p3,p24)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 24*s12**2*s23**3*S13**(-1)*S24**(-1) + 48*s12**2*s23**2*
     +    S13**(-1) + 24*s12**2*s23*s24*S13**(-1) + 48*s12*s14*s23**3*
     +    S13**(-1)*S24**(-1) + 96*s12*s14*s23**2*S13**(-1) + 48*s12*
     +    s14*s23*s24*S13**(-1) + 16*s12*s23**3*S24**(-1) + 24*s12*
     +    s23**2 - 8*s12*s24**2 + 24*s14**2*s23**3*S13**(-1)*S24**(-1)
     +     + 48*s14**2*s23**2*S13**(-1) + 24*s14**2*s23*s24*S13**(-1)
     +     + 16*s14*s23**3*S24**(-1) + 24*s14*s23**2 - 8*s14*s24**2 )

      LA34 = LA34 + Ld311(p2,p4,p3)*S234**(-1)*S134**(-1) * (  - 8*
     +    s12**3*s23*S13**(-1)*S24**(-1) - 8*s12**3*S13**(-1) )

      LA34 = LA34 + Ld311(p2,p4,p13)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 24*s12**2*s13*s14*S24**(-1) + 24*s12**2*s14**3*S13**(-1)*
     +    S24**(-1) + 48*s12**2*s14**2*S24**(-1) - 8*s12*s13**2 + 48*
     +    s12*s13*s14*s23*S24**(-1) + 48*s12*s14**3*s23*S13**(-1)*
     +    S24**(-1) + 16*s12*s14**3*S13**(-1) + 96*s12*s14**2*s23*
     +    S24**(-1) + 24*s12*s14**2 - 8*s13**2*s23 + 24*s13*s14*s23**2*
     +    S24**(-1) + 24*s14**3*s23**2*S13**(-1)*S24**(-1) + 16*s14**3*
     +    s23*S13**(-1) + 48*s14**2*s23**2*S24**(-1) + 24*s14**2*s23 )

      LA34 = LA34 + Ld311(p3,p4,p2)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 8*s13**2*s23 + 8*s13**2*s24 )

      LA34 = LA34 + Ld311(p4,p3,p1)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 8*s13*s24**2 + 8*s14*s24**2 )

      LA34 = LA34 + Ld314(p1,p3,p4)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 24*s12*s13*s24 - 24*s12*s14*s24 )

      LA34 = LA34 + Ld314(p1,p3,p4)*S234**(-1)*S134**(-1) * ( 24*s12**2
     +    *s14*S13**(-1) + 24*s12**2 )

      LA34 = LA34 + Ld314(p1,p3,p24)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 72*s12**3*s23**2*S13**(-1)*S24**(-1) - 72*s12**3*s23*
     +    S13**(-1) - 120*s12**2*s14*s23**2*S13**(-1)*S24**(-1) - 120*
     +    s12**2*s14*s23*S13**(-1) - 24*s12**2*s23**2*S24**(-1) + 24*
     +    s12**2*s24 - 48*s12*s14**2*s23**2*S13**(-1)*S24**(-1) - 48*
     +    s12*s14**2*s23*S13**(-1) - 24*s12*s14*s23**2*S24**(-1) + 24*
     +    s12*s14*s24 )

      LA34 = LA34 + Ld314(p1,p3,p24)*S234**(-1)*S134**(-1) * (  - 24*
     +    s12**3*s23*S13**(-1)*S24**(-1) - 24*s12**3*S13**(-1) - 24*
     +    s12**2*s14*s23*S13**(-1)*S24**(-1) - 24*s12**2*s14*S13**(-1)
     +     )

      LA34 = LA34 + Ld314(p2,p4,p3)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 24*s12*s13*s23 - 24*s12*s13*s24 )

      LA34 = LA34 + Ld314(p2,p4,p3)*S234**(-1)*S134**(-1) * ( 24*s12**2
     +    *s23*S24**(-1) + 24*s12**2 )

      LA34 = LA34 + Ld314(p2,p4,p13)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * (  - 72*s12**3*s14**2*S13**(-1)*S24**(-1) - 72*s12**3*s14*
     +    S24**(-1) + 24*s12**2*s13 - 120*s12**2*s14**2*s23*S13**(-1)*
     +    S24**(-1) - 24*s12**2*s14**2*S13**(-1) - 120*s12**2*s14*s23*
     +    S24**(-1) + 24*s12*s13*s23 - 48*s12*s14**2*s23**2*S13**(-1)*
     +    S24**(-1) - 24*s12*s14**2*s23*S13**(-1) - 48*s12*s14*s23**2*
     +    S24**(-1) )

      LA34 = LA34 + Ld314(p2,p4,p13)*S234**(-1)*S134**(-1) * (  - 24*
     +    s12**3*s14*S13**(-1)*S24**(-1) - 24*s12**3*S24**(-1) - 24*
     +    s12**2*s14*s23*S13**(-1)*S24**(-1) - 24*s12**2*s23*S24**(-1)
     +     )

      LA34 = LA34 + Ld322(p1,p3,p24)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 32*s12**2*s23**3*S13**(-1)*S24**(-1) + 40*s12*s14*s23**3*
     +    S13**(-1)*S24**(-1) - 16*s12*s23**3*S24**(-1) - 24*s12*s23**2
     +     + 8*s14**2*s23**3*S13**(-1)*S24**(-1) - 16*s14*s23**3*
     +    S24**(-1) - 24*s14*s23**2 )

      LA34 = LA34 + Ld322(p1,p3,p24)*S234**(-1)*S134**(-1) * ( 24*
     +    s12**2*s23**2*S13**(-1)*S24**(-1) + 24*s12*s14*s23**2*
     +    S13**(-1)*S24**(-1) )

      LA34 = LA34 + Ld322(p2,p4,p13)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 32*s12**2*s14**3*S13**(-1)*S24**(-1) + 40*s12*s14**3*s23*
     +    S13**(-1)*S24**(-1) - 16*s12*s14**3*S13**(-1) - 24*s12*s14**2
     +     + 8*s14**3*s23**2*S13**(-1)*S24**(-1) - 16*s14**3*s23*
     +    S13**(-1) - 24*s14**2*s23 )

      LA34 = LA34 + Ld322(p2,p4,p13)*S234**(-1)*S134**(-1) * ( 24*
     +    s12**2*s14**2*S13**(-1)*S24**(-1) + 24*s12*s14**2*s23*
     +    S13**(-1)*S24**(-1) )

      LA34 = LA34 + Ld344(p1,p3,p24)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 32*s12**4*s23*S13**(-1)*S24**(-1) + 56*s12**3*s14*s23*
     +    S13**(-1)*S24**(-1) + 24*s12**3*s23*S24**(-1) + 24*s12**2*
     +    s14**2*s23*S13**(-1)*S24**(-1) + 24*s12**2*s14*s23*S24**(-1)
     +     )

      LA34 = LA34 + Ld344(p1,p3,p24)*S234**(-1)*S134**(-1) * ( 8*s12**4
     +    *S13**(-1)*S24**(-1) + 8*s12**3*s14*S13**(-1)*S24**(-1) )

      LA34 = LA34 + Ld344(p2,p4,p13)*S34**(-1)*S234**(-1)*S134**(-1)
     +  * ( 32*s12**4*s14*S13**(-1)*S24**(-1) + 56*s12**3*s14*s23*
     +    S13**(-1)*S24**(-1) + 24*s12**3*s14*S13**(-1) + 24*s12**2*s14
     +    *s23**2*S13**(-1)*S24**(-1) + 24*s12**2*s14*s23*S13**(-1) )

      LA34 = LA34 + Ld344(p2,p4,p13)*S234**(-1)*S134**(-1) * ( 8*s12**4
     +    *S13**(-1)*S24**(-1) + 8*s12**3*s23*S13**(-1)*S24**(-1) )

      LA34 = LA34 + Le1(p1,p3,p4,p2)*S34**(-1)*S234**(-1) * ( 32*s12*
     +    s14*s23 + 32*s13*s14*s23 + 32*s14**2*s23 )

      LA34 = LA34 + Le1(p1,p3,p4,p2)*S34**(-1)*S134**(-1) * (  - 32*s12
     +    *s13*s23 - 64*s12*s13*s24 - 32*s13*s23**2 - 96*s13*s23*s24 - 
     +    64*s13*s24**2 )

      LA34 = LA34 + Le1(p1,p3,p4,p2)*S34**(-1) * ( 16*s12**2*s14*
     +    S13**(-1) - 16*s12**2*s23*S24**(-1) + 16*s12*s14**2*S13**(-1)
     +     + 16*s12*s14*s23*S13**(-1) - 16*s12*s14*s23*S24**(-1) - 16*
     +    s12*s23**2*S24**(-1) + 32*s12*s24 - 8*s13**2*s23*S24**(-1) - 
     +    8*s13*s14*s23*S24**(-1) + 8*s13*s14 + 16*s13*s23**2*S24**(-1)
     +     + 16*s13*s23 + 8*s14**3*S13**(-1) - 8*s14**2*s23*S24**(-1)
     +     - 16*s14**2*s24*S13**(-1) + 8*s14**2 + 8*s14*s23**2*
     +    S13**(-1) + 8*s14*s23*s24*S13**(-1) + 8*s14*s24**2*S13**(-1)
     +     - 16*s14*s24 - 8*s23**3*S24**(-1) - 8*s23**2 + 24*s23*s24 + 
     +    32*s24**2 )

      LA34 = LA34 + Le1(p1,p3,p4,p2)*S34**(-2)*S234**(-1) * ( 32*s12*
     +    s13*s23**2 + 32*s12*s14*s23**2 + 32*s13**2*s23**2 + 64*s13*
     +    s14*s23**2 + 32*s14**2*s23**2 )

      LA34 = LA34 + Le1(p1,p3,p4,p2)*S34**(-2)*S134**(-1) * (  - 32*s12
     +    *s13**2*s23 - 32*s12*s13**2*s24 - 32*s13**2*s23**2 - 64*
     +    s13**2*s23*s24 - 32*s13**2*s24**2 )

      LA34 = LA34 + Le1(p1,p3,p4,p2)*S34**(-2) * ( 32*s12*s13*s24 - 32*
     +    s12*s14*s23 - 32*s13**2*s23 - 32*s13*s14*s23 + 32*s13*s14*s24
     +     + 32*s13*s23**2 + 32*s13*s23*s24 + 32*s13*s24**2 - 32*s14**2
     +    *s23 - 32*s14*s23*s24 )

      LA34 = LA34 + Le1(p1,p3,p4,p2)*S234**(-1) * ( 8*s12*s13*s23*
     +    S24**(-1) - 8*s12*s14 + 8*s13**2*s23*S24**(-1) + 8*s13*s14*
     +    s23*S24**(-1) - 8*s13*s14 - 8*s14**2 )

      LA34 = LA34 + Le1(p1,p3,p4,p2)*S134**(-1) * (  - 8*s12*s14*s24*
     +    S13**(-1) + 8*s12*s23 - 32*s12*s24 - 8*s14*s23*s24*S13**(-1)
     +     - 8*s14*s24**2*S13**(-1) + 8*s23**2 - 24*s23*s24 - 32*s24**2
     +     )

      LA34 = LA34 + Le1(p1,p3,p4,p2) * ( 32*s12*s14*S13**(-1) - 32*s12*
     +    s23*S24**(-1) + 16*s14**2*S13**(-1) + 16*s14*s23*S13**(-1) - 
     +    16*s14*s23*S24**(-1) + 8*s14*s34*S13**(-1) - 16*s23**2*
     +    S24**(-1) - 8*s23*s34*S24**(-1) )

      LA34 = LA34 + 184*s12*S13**(-1)*S24**(-1) + 96*s14*S13**(-1)*
     +    S24**(-1) + 96*s23*S13**(-1)*S24**(-1) + 48*s34*S13**(-1)*
     +    S24**(-1) - 12*S13**(-1) - 16*S24**(-1)

      LA34b=-LA34

      return
      end
      
      
      function LB(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)

      LB=LBa(p1,p2,p3,p4)+LBb(p1,p2,p3,p4)+LBc(p1,p2,p3,p4)
     .  +LBd(p1,p2,p3,p4)+LBe(p1,p2,p3,p4)+LBf(p1,p2,p3,p4)
     .  +LBg(p1,p2,p3,p4)+LBh(p1,p2,p3,p4)+LBi(p1,p2,p3,p4)

      return
      end

      function LBa(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      SF=(s13*s24-s14*s23)/2d0/s34

      LB=0d0

      LB = LB + S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1) * ( 144*s12**3*
     +    s34**2 + 32*s12**2*s34**3 )

      LB = LB + S13**(-1)*S14**(-1)*S23**(-1) * ( 8*s12**3*s24 + 152*
     +    s12**3*s34 - 4*s12**2*s24**2 + 164*s12**2*s24*s34 + 148*
     +    s12**2*s34**2 + 68*s12*s24**2*s34 + 40*s12*s24*s34**2 - 16*
     +    s12*s34**3 - 4*s24**3*s34 + 8*s24**2*s34**2 + 16*s24*s34**3 )

      LB = LB + S13**(-1)*S14**(-1)*S24**(-1) * ( 8*s12**3*s23 + 152*
     +    s12**3*s34 - 4*s12**2*s23**2 + 164*s12**2*s23*s34 + 148*
     +    s12**2*s34**2 + 68*s12*s23**2*s34 + 40*s12*s23*s34**2 - 16*
     +    s12*s34**3 - 4*s23**3*s34 + 8*s23**2*s34**2 + 16*s23*s34**3 )

      LB = LB + S13**(-1)*S14**(-1)*S134**(-1) * (  - 64*s12*s23*s34**2
     +     - 64*s12*s24*s34**2 - 64*s12*s34**3 - 64*s23**2*s34**2 - 128
     +    *s23*s24*s34**2 - 64*s23*s34**3 - 64*s24**2*s34**2 - 64*s24*
     +    s34**3 )

      LB = LB + S13**(-1)*S14**(-1) * ( 16*s12**3 + 12*s12**2*s23 + 12*
     +    s12**2*s24 + 352*s12**2*s34 + 4*s12*s23**2 + 8*s12*s23*s24 + 
     +    320*s12*s23*s34 + 4*s12*s24**2 + 320*s12*s24*s34 + 192*s12*
     +    s34**2 + 72*s23**2*s34 + 152*s23*s24*s34 + 112*s23*s34**2 + 
     +    72*s24**2*s34 + 112*s24*s34**2 + 32*s34**3 )

      LB = LB + S13**(-1)*S23**(-1)*S24**(-1) * ( 8*s12**3*s14 + 152*
     +    s12**3*s34 + 92*s12**2*s14**2 + 260*s12**2*s14*s34 + 212*
     +    s12**2*s34**2 + 68*s12*s14**2*s34 + 64*s12*s14*s34**2 - 16*
     +    s12*s34**3 - 4*s14**3*s34 + 8*s14**2*s34**2 + 16*s14*s34**3 )

      LB = LB + S13**(-1)*S23**(-1) * ( 272*s12**3 + 200*s12**2*s14 + 
     +    296*s12**2*s24 + 520*s12**2*s34 + 128*s12*s14**2 - 32*s12*s14
     +    *s24 + 140*s12*s14*s34 + 128*s12*s24**2 + 128*s12*s24*s34 + 
     +    16*s12*s34**2 + 32*s14**2*s24 + 20*s14**2*s34 + 32*s14*s24**2
     +     + 80*s14*s24*s34 + 36*s14*s34**2 + 20*s24**2*s34 + 32*s24*
     +    s34**2 )

      LB = LB + S13**(-1)*S24**(-1) * ( 272*s12**3 + 360*s12**2*s14 + 
     +    420*s12**2*s23 + 548*s12**2*s34 + 428*s12*s14**2 + 308*s12*
     +    s14*s23 + 556*s12*s14*s34 + 264*s12*s23**2 + 416*s12*s23*s34
     +     + 176*s12*s34**2 + 72*s14**3 + 228*s14**2*s23 + 224*s14**2*
     +    s34 + 184*s14*s23**2 + 488*s14*s23*s34 + 264*s14*s34**2 + 72*
     +    s23**3 + 232*s23**2*s34 + 264*s23*s34**2 + 80*s34**3 )

      LB = LB + S13**(-1) * ( 716*s12**2 + 168*s12*s14 + 408*s12*s23 + 
     +    272*s12*s24 + 348*s12*s34 + 140*s14**2 + 56*s14*s23 - 16*s14*
     +    s24 + 176*s14*s34 + 8*s23**2 - 144*s23*s24 + 164*s23*s34 - 80
     +    *s24**2 + 8*s24*s34 + 160*s34**2 )

      LB = LB + S14**(-1)*S23**(-1)*S24**(-1) * ( 8*s12**3*s13 + 152*
     +    s12**3*s34 + 92*s12**2*s13**2 + 260*s12**2*s13*s34 + 212*
     +    s12**2*s34**2 + 68*s12*s13**2*s34 + 64*s12*s13*s34**2 - 16*
     +    s12*s34**3 - 4*s13**3*s34 + 8*s13**2*s34**2 + 16*s13*s34**3 )

      LB = LB + S14**(-1)*S23**(-1) * ( 272*s12**3 + 360*s12**2*s13 + 
     +    420*s12**2*s24 + 548*s12**2*s34 + 428*s12*s13**2 + 308*s12*
     +    s13*s24 + 556*s12*s13*s34 + 264*s12*s24**2 + 416*s12*s24*s34
     +     + 176*s12*s34**2 + 72*s13**3 + 228*s13**2*s24 + 224*s13**2*
     +    s34 + 184*s13*s24**2 + 488*s13*s24*s34 + 264*s13*s34**2 + 72*
     +    s24**3 + 232*s24**2*s34 + 264*s24*s34**2 + 80*s34**3 )

      LB = LB + S14**(-1)*S24**(-1) * ( 272*s12**3 + 200*s12**2*s13 + 
     +    296*s12**2*s23 + 520*s12**2*s34 + 128*s12*s13**2 - 32*s12*s13
     +    *s23 + 140*s12*s13*s34 + 128*s12*s23**2 + 128*s12*s23*s34 + 
     +    16*s12*s34**2 + 32*s13**2*s23 + 20*s13**2*s34 + 32*s13*s23**2
     +     + 80*s13*s23*s34 + 36*s13*s34**2 + 20*s23**2*s34 + 32*s23*
     +    s34**2 )

      LB = LB + S14**(-1)*S134**(-1) * (  - 128*s12*s13*s23 - 128*s12*
     +    s13*s24 - 128*s12*s13*s34 - 128*s12*s23*s34 - 128*s12*s24*s34
     +     - 128*s12*s34**2 - 128*s13*s23**2 - 256*s13*s23*s24 - 128*
     +    s13*s23*s34 - 128*s13*s24**2 - 128*s13*s24*s34 - 128*s23**2*
     +    s34 - 256*s23*s24*s34 - 128*s23*s34**2 - 128*s24**2*s34 - 128
     +    *s24*s34**2 )

      LB = LB + S14**(-1) * ( 716*s12**2 + 168*s12*s13 + 400*s12*s23 + 
     +    536*s12*s24 + 476*s12*s34 + 140*s13**2 - 16*s13*s23 + 56*s13*
     +    s24 + 176*s13*s34 + 48*s23**2 + 112*s23*s24 + 136*s23*s34 + 
     +    136*s24**2 + 292*s24*s34 + 160*s34**2 )

      LB = LB + S23**(-1)*S24**(-1)*S234**(-1) * (  - 64*s12*s13*s34**2
     +     - 64*s12*s14*s34**2 - 64*s12*s34**3 - 64*s13**2*s34**2 - 128
     +    *s13*s14*s34**2 - 64*s13*s34**3 - 64*s14**2*s34**2 - 64*s14*
     +    s34**3 )

      LB = LB + S23**(-1)*S24**(-1) * ( 16*s12**3 + 72*s12**2*s13 + 72*
     +    s12**2*s14 + 320*s12**2*s34 + 168*s12*s13**2 + 272*s12*s13*
     +    s14 + 400*s12*s13*s34 + 168*s12*s14**2 + 400*s12*s14*s34 + 
     +    272*s12*s34**2 + 44*s13**2*s14 + 56*s13**2*s34 + 44*s13*
     +    s14**2 + 136*s13*s14*s34 + 116*s13*s34**2 + 56*s14**2*s34 + 
     +    116*s14*s34**2 + 32*s34**3 )

      LB = LB + S23**(-1) * ( 632*s12**2 + 436*s12*s13 + 152*s12*s14 + 
     +    216*s12*s24 + 256*s12*s34 + 48*s13**2 - 72*s13*s14 + 80*s13*
     +    s24 + 144*s13*s34 - 72*s14**2 - 48*s14*s24 + 116*s24**2 + 156
     +    *s24*s34 + 160*s34**2 )

      LB = LB + S24**(-1)*S234**(-1) * (  - 128*s12*s13*s23 - 128*s12*
     +    s13*s34 - 128*s12*s14*s23 - 128*s12*s14*s34 - 128*s12*s23*s34
     +     - 128*s12*s34**2 - 128*s13**2*s23 - 128*s13**2*s34 - 256*s13
     +    *s14*s23 - 256*s13*s14*s34 - 128*s13*s23*s34 - 128*s13*s34**2
     +     - 128*s14**2*s23 - 128*s14**2*s34 - 128*s14*s23*s34 - 128*
     +    s14*s34**2 )

      LB = LB + S24**(-1) * ( 632*s12**2 + 280*s12*s13 + 564*s12*s14 + 
     +    216*s12*s23 + 384*s12*s34 + 56*s13**2 + 184*s13*s14 - 48*s13*
     +    s23 + 128*s13*s34 + 176*s14**2 + 80*s14*s23 + 272*s14*s34 + 
     +    116*s23**2 + 156*s23*s34 + 160*s34**2 )

      LB = LB + log(s12**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * ( 96*s12**4*s34 + 1008*s12**3*s34**2 + 16*s12**2*
     +    s34**3 )

      LB = LB + log(s12**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1) * ( 
     +    144*s12**3*s24 + 1152*s12**3*s34 + 64*s12**2*s24**2 + 1344*
     +    s12**2*s24*s34 + 160*s12**2*s34**2 + 176*s12*s24**3 + 400*s12
     +    *s24**2*s34 + 80*s12*s24*s34**2 + 32*s24**4 + 16*s24**3*s34 )

      LB = LB + log(s12**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1) * ( 
     +    144*s12**3*s23 + 960*s12**3*s34 + 16*s12**2*s23**2 + 128*
     +    s12**2*s23*s34 - 240*s12**2*s34**2 + 16*s12*s23**2*s34 + 16*
     +    s12*s23*s34**2 )

      LB = LB + log(s12**(-1)*s1234)*S13**(-1)*S14**(-1) * ( 192*s12**3
     +     + 336*s12**2*s23 + 384*s12**2*s24 + 1408*s12**2*s34 + 144*
     +    s12*s23**2 + 512*s12*s23*s24 + 144*s12*s23*s34 + 480*s12*
     +    s24**2 + 448*s12*s24*s34 + 64*s12*s34**2 + 32*s23**3 + 112*
     +    s23**2*s24 + 16*s23**2*s34 + 160*s23*s24**2 + 48*s23*s24*s34
     +     - 16*s23*s34**2 + 112*s24**3 + 48*s24**2*s34 - 16*s24*s34**2
     +     )

      LB = LB + log(s12**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1) * ( 
     +    160*s12**3*s14 - 288*s12**3*s34 + 672*s12**2*s14*s34 - 656*
     +    s12**2*s34**2 - 64*s12*s14**2*s34 - 64*s12*s14*s34**2 )

      LB = LB + log(s12**(-1)*s1234)*S13**(-1)*S23**(-1) * (  - 240*
     +    s12**3 + 144*s12**2*s24 + 1680*s12**2*s34 + 176*s12*s14**2 + 
     +    368*s12*s14*s24 + 432*s12*s14*s34 + 432*s12*s24**2 + 656*s12*
     +    s24*s34 - 64*s12*s34**2 + 16*s14**3 + 112*s14**2*s24 - 16*
     +    s14**2*s34 + 192*s14*s24**2 + 128*s24**3 + 32*s24**2*s34 )

      LB = LB + log(s12**(-1)*s1234)*S13**(-1)*S24**(-1) * (  - 336*
     +    s12**3 + 192*s12**2*s14 + 16*s12**2*s23 + 688*s12**2*s34 + 
     +    112*s12*s14**2 + 80*s12*s14*s23 + 144*s12*s14*s34 + 48*s12*
     +    s23**2 - 192*s12*s23*s34 - 16*s14**3 + 48*s14**2*s23 - 32*
     +    s14**2*s34 + 16*s14*s23**2 - 16*s14*s23*s34 + 16*s14*s34**2
     +     - 32*s23**3 + 16*s23**2*s34 + 16*s23*s34**2 )

      LB = LB + log(s12**(-1)*s1234)*S13**(-1) * (  - 80*s12**2 + 368*
     +    s12*s14 + 336*s12*s23 + 704*s12*s24 + 192*s12*s34 + 112*
     +    s14**2 + 128*s14*s23 + 288*s14*s24 - 16*s14*s34 + 192*s23*s24
     +     - 16*s23*s34 + 288*s24**2 + 16*s24*s34 - 48*s34**2 )

      LB = LB + log(s12**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1) * ( 
     +    160*s12**3*s13 - 864*s12**3*s34 + 160*s12**2*s13*s34 - 80*
     +    s12**2*s34**2 )

      LB = LB + log(s12**(-1)*s1234)*S14**(-1)*S23**(-1) * (  - 336*
     +    s12**3 + 192*s12**2*s13 - 176*s12**2*s24 - 688*s12**2*s34 - 
     +    64*s12*s13**2 + 112*s12*s13*s24 + 128*s12*s13*s34 - 144*s12*
     +    s24**2 - 224*s12*s24*s34 + 48*s12*s34**2 - 16*s13**2*s24 - 16
     +    *s13**2*s34 + 32*s13*s24**2 + 16*s13*s24*s34 + 16*s13*s34**2
     +     - 32*s24**3 - 16*s24*s34**2 )

      LB = LB + log(s12**(-1)*s1234)*S14**(-1)*S24**(-1) * (  - 240*
     +    s12**3 - 48*s12**2*s23 - 208*s12**2*s34 + 16*s12*s13*s34 + 16
     +    *s12*s34**2 )

      LB = LB + log(s12**(-1)*s1234)*S14**(-1) * (  - 464*s12**2 + 32*
     +    s12*s13 - 176*s12*s23 - 304*s12*s24 - 112*s12*s34 + 32*s13*
     +    s23 + 48*s13*s24 + 48*s13*s34 - 32*s23**2 - 80*s23*s24 - 16*
     +    s23*s34 - 80*s24**2 - 32*s24*s34 + 16*s34**2 )

      LB = LB + log(s12**(-1)*s1234)*S23**(-1)*S24**(-1) * ( 320*s12**3
     +     + 96*s12**2*s13 + 96*s12**2*s14 + 128*s12**2*s34 - 80*s12*
     +    s13**2 - 64*s12*s13*s14 - 160*s12*s13*s34 - 80*s12*s14**2 - 
     +    96*s12*s14*s34 + 16*s12*s34**2 - 16*s13**2*s14 - 16*s13**2*
     +    s34 - 16*s13*s14**2 - 48*s13*s14*s34 - 16*s13*s34**2 - 16*
     +    s14**2*s34 - 16*s14*s34**2 )

      LB = LB + log(s12**(-1)*s1234)*S23**(-1) * ( 192*s12**2 + 272*s12
     +    *s13 + 80*s12*s14 - 176*s12*s24 + 64*s12*s34 - 32*s13**2 + 32
     +    *s13*s14 + 64*s13*s24 + 16*s13*s34 - 16*s14**2 - 96*s14*s24
     +     + 32*s14*s34 - 96*s24**2 - 32*s24*s34 + 16*s34**2 )

      LB = LB + log(s12**(-1)*s1234)*S24**(-1) * ( 192*s12**2 + 256*s12
     +    *s13 + 96*s12*s14 + 32*s12*s23 + 240*s12*s34 + 16*s13*s14 + 
     +    16*s13*s34 - 16*s14**2 - 16*s14*s23 + 32*s14*s34 + 32*s23**2
     +     + 16*s23*s34 + 16*s34**2 )

      LB = LB + log(s12**(-1)*s1234)*SF*S13**(-1)*S14**(-1)*S23**(-1)
     +  * ( 96*s12**2*s24 )

      LB = LB + log(s12**(-1)*s1234)*SF*S13**(-1)*S14**(-1)*S24**(-1)
     +  * (  - 96*s12**2*s23 )

      LB = LB + log(s12**(-1)*s1234)*SF*S13**(-1)*S23**(-1)*S24**(-1)
     +  * ( 192*s12**2*s14 )

      LB = LB + log(s12**(-1)*s1234)*SF*S13**(-1)*S23**(-1) * ( 64*s12*
     +    s14 + 32*s12*s24 )

      LB = LB + log(s12**(-1)*s1234)*SF*S13**(-1)*S24**(-1) * ( 128*s12
     +    *s14 - 64*s12*s23 )

      LB = LB + log(s12**(-1)*s1234)*SF*S13**(-1) * (  - 32*s12 )

      LB = LB + log(s12**(-1)*s1234)*SF*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 192*s12**2*s13 )

      LB = LB + log(s12**(-1)*s1234)*SF*S14**(-1)*S23**(-1) * (  - 128*
     +    s12*s13 + 64*s12*s24 )

      LB = LB + log(s12**(-1)*s1234)*SF*S14**(-1)*S24**(-1) * (  - 64*
     +    s12*s13 - 32*s12*s23 )

      LB = LB + log(s12**(-1)*s1234)*SF*S14**(-1) * ( 32*s12 )

      LB = LB + log(s12**(-1)*s1234)*SF*S23**(-1) * (  - 64*s12 )

      LB = LB + log(s12**(-1)*s1234)*SF*S24**(-1) * ( 64*s12 )

      LB = LB + log(s12**(-1)*s1234) * (  - 192*s12 + 32*s13 - 80*s14
     +     - 112*s24 )

      LB = LB + log(s13**(-1)*s134)*S13**(-1)*S14**(-1)*S134**(-1) * ( 
     +     - 24*s12*s23*s34**2 - 24*s12*s24*s34**2 - 24*s12*s34**3 - 24
     +    *s23**2*s34**2 - 48*s23*s24*s34**2 - 24*s23*s34**3 - 24*
     +    s24**2*s34**2 - 24*s24*s34**3 )

      LB = LB + log(s13**(-1)*s134)*S14**(-1)*S134**(-1) * (  - 8*s12*
     +    s13*s23 - 8*s12*s13*s24 - 8*s12*s13*s34 - 32*s12*s23*s34 - 32
     +    *s12*s24*s34 - 32*s12*s34**2 - 8*s13*s23**2 - 16*s13*s23*s24
     +     - 8*s13*s23*s34 - 8*s13*s24**2 - 8*s13*s24*s34 - 32*s23**2*
     +    s34 - 64*s23*s24*s34 - 32*s23*s34**2 - 32*s24**2*s34 - 32*s24
     +    *s34**2 )

      LB = LB + log(s13**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1) * ( 
     +     - 4*s12**3*s23 - 4*s12**3*s34 - 16*s12**2*s23**2 - 4*s12**2*
     +    s23*s34 + 12*s12**2*s34**2 + 12*s12*s23**3 + 32*s12*s23**2*
     +    s34 + 20*s12*s23*s34**2 + 4*s23**3*s34 + 4*s23**2*s34**2 )

      LB = LB + log(s13**(-1)*s1234)*S13**(-1)*S14**(-1) * (  - 4*
     +    s12**3 - 8*s12**2*s23 + 8*s12**2*s24 + 20*s12**2*s34 + 4*s12*
     +    s23**2 - 8*s12*s23*s24 + 12*s12*s23*s34 + 4*s23**2*s34 )

      LB = LB + log(s13**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1) * ( 
     +    8*s12**3*s14 + 8*s12**3*s34 - 24*s12**2*s14**2 - 48*s12**2*
     +    s14*s34 - 24*s12**2*s34**2 + 8*s12*s14**2*s34 + 8*s12*s14*
     +    s34**2 )

      LB = LB + log(s13**(-1)*s1234)*S13**(-1)*S23**(-1) * ( 8*s12**2*
     +    s14 + 8*s12**2*s34 + 8*s12*s14**2 - 8*s12*s14*s24 )

      LB = LB + log(s13**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 16*s12**2*
     +    s23 + 16*s12**2*s34 + 8*s12*s14**2 - 8*s12*s14*s23 + 8*s12*
     +    s14*s34 - 28*s12*s23**2 - 28*s12*s23*s34 + 4*s14*s23**2 - 4*
     +    s23**3 - 4*s23**2*s34 )

      LB = LB + log(s13**(-1)*s1234)*S13**(-1) * ( 16*s12**2 - 8*s12*
     +    s14 - 28*s12*s23 - 4*s23**2 )

      LB = LB + log(s13**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1) * ( 
     +     - 24*s12**3*s13 - 16*s12**3*s34 + 4*s12**2*s13**2 + 40*
     +    s12**2*s13*s34 + 36*s12**2*s34**2 + 20*s12*s13*s34**2 )

      LB = LB + log(s13**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 8*s12**3
     +     + 40*s12**2*s13 + 44*s12**2*s34 + 72*s12*s13**2 - 36*s12*s13
     +    *s24 + 12*s12*s13*s34 + 32*s12*s24*s34 + 40*s12*s34**2 + 12*
     +    s13**3 + 16*s13**2*s24 + 24*s13**2*s34 + 8*s13*s24**2 + 24*
     +    s13*s34**2 )

      LB = LB + log(s13**(-1)*s1234)*S14**(-1)*S24**(-1) * ( 80*s12**2*
     +    s13 + 12*s12**2*s23 + 48*s12**2*s34 + 32*s12*s13**2 + 76*s12*
     +    s13*s23 + 64*s12*s13*s34 + 20*s12*s23*s34 + 24*s12*s34**2 + 8
     +    *s13**2*s23 - 4*s13**2*s34 - 8*s13*s23**2 + 8*s13*s23*s34 + 8
     +    *s13*s34**2 - 8*s23**3 + 8*s23**2*s34 + 16*s23*s34**2 )

      LB = LB + log(s13**(-1)*s1234)*S14**(-1) * ( 12*s12**2 + 80*s12*
     +    s13 + 40*s12*s23 + 40*s12*s24 + 112*s12*s34 + 12*s13*s23 + 76
     +    *s13*s24 + 84*s13*s34 + 20*s23**2 + 44*s23*s24 + 4*s23*s34 + 
     +    16*s24**2 - 16*s24*s34 - 24*s34**2 )

      LB = LB + log(s13**(-1)*s1234)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3 + 40*s12**2*s13 + 12*s12**2*s14 + 40*s12**2*s34 + 40*
     +    s12*s13**2 + 72*s12*s13*s14 + 48*s12*s13*s34 + 32*s12*s14**2
     +     + 48*s12*s14*s34 + 24*s12*s34**2 )

      LB = LB + log(s13**(-1)*s1234)*S23**(-1) * ( 8*s12**2 + 92*s12*
     +    s13 + 32*s12*s14 + 48*s12*s34 + 12*s13**2 + 40*s13*s24 + 32*
     +    s13*s34 + 8*s14*s24 + 8*s14*s34 + 8*s24**2 + 16*s24*s34 + 8*
     +    s34**2 )

      LB = LB + log(s13**(-1)*s1234)*S24**(-1) * ( 72*s12**2 + 80*s12*
     +    s13 + 56*s12*s14 + 60*s12*s23 + 92*s12*s34 + 8*s13**2 + 8*s13
     +    *s14 - 4*s13*s23 - 4*s13*s34 - 12*s14*s23 - 8*s14*s34 - 12*
     +    s23**2 - 12*s23*s34 )

      LB = LB + log(s13**(-1)*s1234)*SF*S13**(-1)*S24**(-1) * ( 16*s12*
     +    s23 - 8*s23**2 )

      LB = LB + log(s13**(-1)*s1234)*SF*S13**(-1) * ( 16*s12 - 8*s23 )

      LB = LB + log(s13**(-1)*s1234)*SF*S14**(-1)*S23**(-1) * (  - 16*
     +    s12*s24 )

      LB = LB + log(s13**(-1)*s1234)*SF*S14**(-1)*S24**(-1) * ( 16*s12*
     +    s23 - 8*s23**2 )

      LB = LB + log(s13**(-1)*s1234)*SF*S14**(-1) * ( 8*s23 + 16*s24 )

      LB = LB + log(s13**(-1)*s1234) * ( 56*s12 + 4*s13 + 16*s14 + 4*
     +    s23 + 32*s24 + 24*s34 )

      LB = LB + log(s14**(-1)*s134)*S14**(-1)*S134**(-1) * (  - 8*s12*
     +    s13*s23 - 8*s12*s13*s24 - 8*s12*s13*s34 + 16*s12*s23*s34 + 16
     +    *s12*s24*s34 + 16*s12*s34**2 - 8*s13*s23**2 - 16*s13*s23*s24
     +     - 8*s13*s23*s34 - 8*s13*s24**2 - 8*s13*s24*s34 + 16*s23**2*
     +    s34 + 32*s23*s24*s34 + 16*s23*s34**2 + 16*s24**2*s34 + 16*s24
     +    *s34**2 )

      LB = LB + log(s14**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1) * ( 
     +     - 4*s12**3*s24 - 4*s12**3*s34 - 16*s12**2*s24**2 - 4*s12**2*
     +    s24*s34 + 12*s12**2*s34**2 + 12*s12*s24**3 + 32*s12*s24**2*
     +    s34 + 20*s12*s24*s34**2 + 4*s24**3*s34 + 4*s24**2*s34**2 )

      LB = LB + log(s14**(-1)*s1234)*S13**(-1)*S14**(-1) * (  - 4*
     +    s12**3 + 8*s12**2*s23 - 8*s12**2*s24 + 20*s12**2*s34 - 8*s12*
     +    s23*s24 - 24*s12*s23*s34 + 4*s12*s24**2 - 12*s12*s24*s34 - 24
     +    *s12*s34**2 - 24*s23**2*s34 - 48*s23*s24*s34 - 24*s23*s34**2
     +     - 20*s24**2*s34 - 24*s24*s34**2 )

      LB = LB + log(s14**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1) * ( 
     +     - 24*s12**3*s14 - 16*s12**3*s34 + 4*s12**2*s14**2 + 40*
     +    s12**2*s14*s34 + 36*s12**2*s34**2 + 20*s12*s14*s34**2 )

      LB = LB + log(s14**(-1)*s1234)*S13**(-1)*S23**(-1) * ( 80*s12**2*
     +    s14 + 12*s12**2*s24 + 48*s12**2*s34 + 32*s12*s14**2 + 76*s12*
     +    s14*s24 + 64*s12*s14*s34 + 20*s12*s24*s34 + 24*s12*s34**2 + 8
     +    *s14**2*s24 - 4*s14**2*s34 - 8*s14*s24**2 + 8*s14*s24*s34 + 8
     +    *s14*s34**2 - 8*s24**3 + 8*s24**2*s34 + 16*s24*s34**2 )

      LB = LB + log(s14**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 8*s12**3
     +     + 40*s12**2*s14 + 44*s12**2*s34 + 72*s12*s14**2 - 36*s12*s14
     +    *s23 + 12*s12*s14*s34 + 32*s12*s23*s34 + 40*s12*s34**2 + 12*
     +    s14**3 + 16*s14**2*s23 + 24*s14**2*s34 + 8*s14*s23**2 + 24*
     +    s14*s34**2 )

      LB = LB + log(s14**(-1)*s1234)*S13**(-1) * ( 12*s12**2 + 80*s12*
     +    s14 + 32*s12*s23 + 32*s12*s24 + 104*s12*s34 + 76*s14*s23 + 12
     +    *s14*s24 + 84*s14*s34 + 8*s23**2 + 28*s23*s24 - 24*s23*s34 + 
     +    12*s24**2 - 4*s24*s34 - 24*s34**2 )

      LB = LB + log(s14**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1) * ( 
     +    8*s12**3*s13 + 8*s12**3*s34 - 24*s12**2*s13**2 - 48*s12**2*
     +    s13*s34 - 24*s12**2*s34**2 + 8*s12*s13**2*s34 + 8*s12*s13*
     +    s34**2 )

      LB = LB + log(s14**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 16*s12**2*
     +    s24 + 16*s12**2*s34 + 8*s12*s13**2 - 8*s12*s13*s24 + 8*s12*
     +    s13*s34 - 28*s12*s24**2 - 28*s12*s24*s34 + 4*s13*s24**2 - 4*
     +    s24**3 - 4*s24**2*s34 )

      LB = LB + log(s14**(-1)*s1234)*S14**(-1)*S24**(-1) * ( 8*s12**2*
     +    s13 + 8*s12**2*s34 + 8*s12*s13**2 - 8*s12*s13*s23 )

      LB = LB + log(s14**(-1)*s1234)*S14**(-1) * ( 16*s12**2 - 8*s12*
     +    s13 + 8*s12*s23 - 20*s12*s24 + 8*s12*s34 + 8*s23**2 + 16*s23*
     +    s24 + 8*s23*s34 + 4*s24**2 + 8*s24*s34 )

      LB = LB + log(s14**(-1)*s1234)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3 + 12*s12**2*s13 + 40*s12**2*s14 + 40*s12**2*s34 + 32*
     +    s12*s13**2 + 72*s12*s13*s14 + 48*s12*s13*s34 + 40*s12*s14**2
     +     + 48*s12*s14*s34 + 24*s12*s34**2 )

      LB = LB + log(s14**(-1)*s1234)*S23**(-1) * ( 72*s12**2 + 56*s12*
     +    s13 + 80*s12*s14 + 60*s12*s24 + 92*s12*s34 + 8*s13*s14 - 12*
     +    s13*s24 - 8*s13*s34 + 8*s14**2 - 4*s14*s24 - 4*s14*s34 - 12*
     +    s24**2 - 12*s24*s34 )

      LB = LB + log(s14**(-1)*s1234)*S24**(-1) * ( 8*s12**2 + 32*s12*
     +    s13 + 92*s12*s14 + 48*s12*s34 + 8*s13*s23 + 8*s13*s34 + 12*
     +    s14**2 + 40*s14*s23 + 32*s14*s34 + 8*s23**2 + 16*s23*s34 + 8*
     +    s34**2 )

      LB = LB + log(s14**(-1)*s1234)*SF*S13**(-1)*S23**(-1) * (  - 16*
     +    s12*s24 + 8*s24**2 )

      LB = LB + log(s14**(-1)*s1234)*SF*S13**(-1)*S24**(-1) * ( 16*s12*
     +    s23 )

      LB = LB + log(s14**(-1)*s1234)*SF*S13**(-1) * (  - 16*s23 - 8*s24
     +     )

      LB = LB + log(s14**(-1)*s1234)*SF*S14**(-1)*S23**(-1) * (  - 16*
     +    s12*s24 + 8*s24**2 )

      LB = LB + log(s14**(-1)*s1234)*SF*S14**(-1) * (  - 16*s12 + 8*s24
     +     )

      LB = LB + log(s14**(-1)*s1234) * ( 56*s12 + 16*s13 + 4*s14 + 32*
     +    s23 + 4*s24 + 24*s34 )

      LB = LB + log(s23**(-1)*s234)*S23**(-1)*S24**(-1)*S234**(-1) * ( 
     +     - 24*s12*s13*s34**2 - 24*s12*s14*s34**2 - 24*s12*s34**3 - 24
     +    *s13**2*s34**2 - 48*s13*s14*s34**2 - 24*s13*s34**3 - 24*
     +    s14**2*s34**2 - 24*s14*s34**3 )

      LB = LB + log(s23**(-1)*s234)*S24**(-1)*S234**(-1) * (  - 8*s12*
     +    s13*s23 - 32*s12*s13*s34 - 8*s12*s14*s23 - 32*s12*s14*s34 - 8
     +    *s12*s23*s34 - 32*s12*s34**2 - 8*s13**2*s23 - 32*s13**2*s34
     +     - 16*s13*s14*s23 - 64*s13*s14*s34 - 8*s13*s23*s34 - 32*s13*
     +    s34**2 - 8*s14**2*s23 - 32*s14**2*s34 - 8*s14*s23*s34 - 32*
     +    s14*s34**2 )

      LB = LB + log(s23**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1) * ( 
     +    8*s12**3*s24 + 8*s12**3*s34 - 24*s12**2*s24**2 - 48*s12**2*
     +    s24*s34 - 24*s12**2*s34**2 + 8*s12*s24**2*s34 + 8*s12*s24*
     +    s34**2 )

      LB = LB + log(s23**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1) * ( 
     +     - 24*s12**3*s23 - 16*s12**3*s34 + 4*s12**2*s23**2 + 40*
     +    s12**2*s23*s34 + 36*s12**2*s34**2 + 20*s12*s23*s34**2 )

      LB = LB + log(s23**(-1)*s1234)*S13**(-1)*S14**(-1) * (  - 8*
     +    s12**3 + 40*s12**2*s23 + 12*s12**2*s24 + 40*s12**2*s34 + 40*
     +    s12*s23**2 + 72*s12*s23*s24 + 48*s12*s23*s34 + 32*s12*s24**2
     +     + 48*s12*s24*s34 + 24*s12*s34**2 )

      LB = LB + log(s23**(-1)*s1234)*S13**(-1)*S23**(-1) * ( 8*s12**2*
     +    s24 + 8*s12**2*s34 - 8*s12*s14*s24 + 8*s12*s24**2 )

      LB = LB + log(s23**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 8*s12**3
     +     + 40*s12**2*s23 + 44*s12**2*s34 - 36*s12*s14*s23 + 16*s12*
     +    s14*s34 + 72*s12*s23**2 + 12*s12*s23*s34 + 40*s12*s34**2 + 8*
     +    s14**2*s23 + 16*s14*s23**2 + 12*s23**3 + 24*s23**2*s34 + 24*
     +    s23*s34**2 )

      LB = LB + log(s23**(-1)*s1234)*S13**(-1) * ( 8*s12**2 + 92*s12*
     +    s23 + 32*s12*s24 + 48*s12*s34 + 8*s14**2 + 40*s14*s23 + 8*s14
     +    *s24 + 16*s14*s34 + 12*s23**2 + 32*s23*s34 + 8*s24*s34 + 8*
     +    s34**2 )

      LB = LB + log(s23**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1) * ( 
     +     - 4*s12**3*s13 - 4*s12**3*s34 - 16*s12**2*s13**2 - 4*s12**2*
     +    s13*s34 + 12*s12**2*s34**2 + 12*s12*s13**3 + 32*s12*s13**2*
     +    s34 + 20*s12*s13*s34**2 + 4*s13**3*s34 + 4*s13**2*s34**2 )

      LB = LB + log(s23**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 16*s12**2*
     +    s13 + 16*s12**2*s34 - 28*s12*s13**2 - 8*s12*s13*s24 - 28*s12*
     +    s13*s34 + 8*s12*s24**2 + 8*s12*s24*s34 - 4*s13**3 + 4*s13**2*
     +    s24 - 4*s13**2*s34 )

      LB = LB + log(s23**(-1)*s1234)*S14**(-1)*S24**(-1) * ( 12*s12**2*
     +    s13 + 80*s12**2*s23 + 48*s12**2*s34 + 76*s12*s13*s23 + 20*s12
     +    *s13*s34 + 32*s12*s23**2 + 64*s12*s23*s34 + 24*s12*s34**2 - 8
     +    *s13**3 - 8*s13**2*s23 + 8*s13**2*s34 + 8*s13*s23**2 + 8*s13*
     +    s23*s34 + 16*s13*s34**2 - 4*s23**2*s34 + 8*s23*s34**2 )

      LB = LB + log(s23**(-1)*s1234)*S14**(-1) * ( 72*s12**2 + 60*s12*
     +    s13 + 80*s12*s23 + 56*s12*s24 + 92*s12*s34 - 12*s13**2 - 4*
     +    s13*s23 - 12*s13*s24 - 12*s13*s34 + 8*s23**2 + 8*s23*s24 - 4*
     +    s23*s34 - 8*s24*s34 )

      LB = LB + log(s23**(-1)*s1234)*S23**(-1)*S24**(-1) * (  - 4*
     +    s12**3 - 8*s12**2*s13 + 8*s12**2*s14 + 20*s12**2*s34 + 4*s12*
     +    s13**2 - 8*s12*s13*s14 + 12*s12*s13*s34 + 4*s13**2*s34 )

      LB = LB + log(s23**(-1)*s1234)*S23**(-1) * ( 16*s12**2 - 28*s12*
     +    s13 - 8*s12*s24 - 4*s13**2 )

      LB = LB + log(s23**(-1)*s1234)*S24**(-1) * ( 12*s12**2 + 40*s12*
     +    s13 + 40*s12*s14 + 80*s12*s23 + 112*s12*s34 + 20*s13**2 + 44*
     +    s13*s14 + 12*s13*s23 + 4*s13*s34 + 16*s14**2 + 76*s14*s23 - 
     +    16*s14*s34 + 84*s23*s34 - 24*s34**2 )

      LB = LB + log(s23**(-1)*s1234)*SF*S13**(-1)*S24**(-1) * ( 16*s12*
     +    s14 )

      LB = LB + log(s23**(-1)*s1234)*SF*S14**(-1)*S23**(-1) * (  - 16*
     +    s12*s13 + 8*s13**2 )

      LB = LB + log(s23**(-1)*s1234)*SF*S14**(-1)*S24**(-1) * (  - 16*
     +    s12*s13 + 8*s13**2 )

      LB = LB + log(s23**(-1)*s1234)*SF*S23**(-1) * (  - 16*s12 + 8*s13
     +     )

      LB = LB + log(s23**(-1)*s1234)*SF*S24**(-1) * (  - 8*s13 - 16*s14
     +     )

      LB = LB + log(s23**(-1)*s1234) * ( 56*s12 + 4*s13 + 32*s14 + 4*
     +    s23 + 16*s24 + 24*s34 )

      LB = LB + log(s24**(-1)*s234)*S24**(-1)*S234**(-1) * (  - 8*s12*
     +    s13*s23 + 16*s12*s13*s34 - 8*s12*s14*s23 + 16*s12*s14*s34 - 8
     +    *s12*s23*s34 + 16*s12*s34**2 - 8*s13**2*s23 + 16*s13**2*s34
     +     - 16*s13*s14*s23 + 32*s13*s14*s34 - 8*s13*s23*s34 + 16*s13*
     +    s34**2 - 8*s14**2*s23 + 16*s14**2*s34 - 8*s14*s23*s34 + 16*
     +    s14*s34**2 )

      LB = LB + log(s24**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1) * ( 
     +     - 24*s12**3*s24 - 16*s12**3*s34 + 4*s12**2*s24**2 + 40*
     +    s12**2*s24*s34 + 36*s12**2*s34**2 + 20*s12*s24*s34**2 )

      LB = LB + log(s24**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1) * ( 
     +    8*s12**3*s23 + 8*s12**3*s34 - 24*s12**2*s23**2 - 48*s12**2*
     +    s23*s34 - 24*s12**2*s34**2 + 8*s12*s23**2*s34 + 8*s12*s23*
     +    s34**2 )

      LB = LB + log(s24**(-1)*s1234)*S13**(-1)*S14**(-1) * (  - 8*
     +    s12**3 + 12*s12**2*s23 + 40*s12**2*s24 + 40*s12**2*s34 + 32*
     +    s12*s23**2 + 72*s12*s23*s24 + 48*s12*s23*s34 + 40*s12*s24**2
     +     + 48*s12*s24*s34 + 24*s12*s34**2 )

      LB = LB + log(s24**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1) * ( 
     +     - 4*s12**3*s14 - 4*s12**3*s34 - 16*s12**2*s14**2 - 4*s12**2*
     +    s14*s34 + 12*s12**2*s34**2 + 12*s12*s14**3 + 32*s12*s14**2*
     +    s34 + 20*s12*s14*s34**2 + 4*s14**3*s34 + 4*s14**2*s34**2 )

      LB = LB + log(s24**(-1)*s1234)*S13**(-1)*S23**(-1) * ( 12*s12**2*
     +    s14 + 80*s12**2*s24 + 48*s12**2*s34 + 76*s12*s14*s24 + 20*s12
     +    *s14*s34 + 32*s12*s24**2 + 64*s12*s24*s34 + 24*s12*s34**2 - 8
     +    *s14**3 - 8*s14**2*s24 + 8*s14**2*s34 + 8*s14*s24**2 + 8*s14*
     +    s24*s34 + 16*s14*s34**2 - 4*s24**2*s34 + 8*s24*s34**2 )

      LB = LB + log(s24**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 16*s12**2*
     +    s14 + 16*s12**2*s34 - 28*s12*s14**2 - 8*s12*s14*s23 - 28*s12*
     +    s14*s34 + 8*s12*s23**2 + 8*s12*s23*s34 - 4*s14**3 + 4*s14**2*
     +    s23 - 4*s14**2*s34 )

      LB = LB + log(s24**(-1)*s1234)*S13**(-1) * ( 72*s12**2 + 60*s12*
     +    s14 + 56*s12*s23 + 80*s12*s24 + 92*s12*s34 - 12*s14**2 - 12*
     +    s14*s23 - 4*s14*s24 - 12*s14*s34 + 8*s23*s24 - 8*s23*s34 + 8*
     +    s24**2 - 4*s24*s34 )

      LB = LB + log(s24**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 8*s12**3
     +     + 40*s12**2*s24 + 44*s12**2*s34 - 36*s12*s13*s24 + 16*s12*
     +    s13*s34 + 72*s12*s24**2 + 12*s12*s24*s34 + 40*s12*s34**2 + 8*
     +    s13**2*s24 + 16*s13*s24**2 + 12*s24**3 + 24*s24**2*s34 + 24*
     +    s24*s34**2 )

      LB = LB + log(s24**(-1)*s1234)*S14**(-1)*S24**(-1) * ( 8*s12**2*
     +    s23 + 8*s12**2*s34 - 8*s12*s13*s23 + 8*s12*s23**2 )

      LB = LB + log(s24**(-1)*s1234)*S14**(-1) * ( 8*s12**2 + 32*s12*
     +    s23 + 92*s12*s24 + 48*s12*s34 + 8*s13**2 + 8*s13*s23 + 40*s13
     +    *s24 + 16*s13*s34 + 8*s23*s34 + 12*s24**2 + 32*s24*s34 + 8*
     +    s34**2 )

      LB = LB + log(s24**(-1)*s1234)*S23**(-1)*S24**(-1) * (  - 4*
     +    s12**3 + 8*s12**2*s13 - 8*s12**2*s14 + 20*s12**2*s34 - 8*s12*
     +    s13*s14 - 24*s12*s13*s34 + 4*s12*s14**2 - 12*s12*s14*s34 - 24
     +    *s12*s34**2 - 24*s13**2*s34 - 48*s13*s14*s34 - 24*s13*s34**2
     +     - 20*s14**2*s34 - 24*s14*s34**2 )

      LB = LB + log(s24**(-1)*s1234)*S23**(-1) * ( 12*s12**2 + 32*s12*
     +    s13 + 32*s12*s14 + 80*s12*s24 + 104*s12*s34 + 8*s13**2 + 28*
     +    s13*s14 + 76*s13*s24 - 24*s13*s34 + 12*s14**2 + 12*s14*s24 - 
     +    4*s14*s34 + 84*s24*s34 - 24*s34**2 )

      LB = LB + log(s24**(-1)*s1234)*S24**(-1) * ( 16*s12**2 + 8*s12*
     +    s13 - 20*s12*s14 - 8*s12*s23 + 8*s12*s34 + 8*s13**2 + 16*s13*
     +    s14 + 8*s13*s34 + 4*s14**2 + 8*s14*s34 )

      LB = LB + log(s24**(-1)*s1234)*SF*S13**(-1)*S23**(-1) * ( 16*s12*
     +    s14 - 8*s14**2 )

      LB = LB + log(s24**(-1)*s1234)*SF*S13**(-1)*S24**(-1) * ( 16*s12*
     +    s14 - 8*s14**2 )

      LB = LB + log(s24**(-1)*s1234)*SF*S14**(-1)*S23**(-1) * (  - 16*
     +    s12*s13 )

      LB = LB + log(s24**(-1)*s1234)*SF*S23**(-1) * ( 16*s13 + 8*s14 )

      LB = LB + log(s24**(-1)*s1234)*SF*S24**(-1) * ( 16*s12 - 8*s14 )

      LB = LB + log(s24**(-1)*s1234) * ( 56*s12 + 32*s13 + 4*s14 + 16*
     +    s23 + 4*s24 + 24*s34 )

      LB = LB + log(s34**(-1)*s234)*S24**(-1)*S234**(-1) * (  - 32*s12*
     +    s13*s23 - 32*s12*s13*s34 - 32*s12*s14*s23 - 32*s12*s14*s34 - 
     +    32*s12*s23*s34 - 32*s12*s34**2 - 32*s13**2*s23 - 32*s13**2*
     +    s34 - 64*s13*s14*s23 - 64*s13*s14*s34 - 32*s13*s23*s34 - 32*
     +    s13*s34**2 - 32*s14**2*s23 - 32*s14**2*s34 - 32*s14*s23*s34
     +     - 32*s14*s34**2 )

      LB = LB + log(s34**(-1)*s134)*S14**(-1)*S134**(-1) * (  - 32*s12*
     +    s13*s23 - 32*s12*s13*s24 - 32*s12*s13*s34 - 32*s12*s23*s34 - 
     +    32*s12*s24*s34 - 32*s12*s34**2 - 32*s13*s23**2 - 64*s13*s23*
     +    s24 - 32*s13*s23*s34 - 32*s13*s24**2 - 32*s13*s24*s34 - 32*
     +    s23**2*s34 - 64*s23*s24*s34 - 32*s23*s34**2 - 32*s24**2*s34
     +     - 32*s24*s34**2 )

      LB = LB + log(s34**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1) * ( 
     +    440*s12**2*s24*s34 + 440*s12**2*s34**2 + 48*s12*s24**3 + 728*
     +    s12*s24**2*s34 + 80*s12*s24*s34**2 + 8*s12*s34**3 + 88*s24**4
     +     + 176*s24**3*s34 + 32*s24**2*s34**2 )

      LB = LB + log(s34**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1) * ( 
     +    328*s12**2*s23*s34 + 488*s12**2*s34**2 + 24*s12*s23**3 + 96*
     +    s12*s23**2*s34 - 128*s12*s23*s34**2 + 24*s12*s34**3 - 16*
     +    s23**3*s34 )

      LB = LB + log(s34**(-1)*s1234)*S13**(-1)*S14**(-1) * ( 768*s12**2
     +    *s34 + 120*s12*s23**2 + 216*s12*s23*s24 + 800*s12*s23*s34 + 
     +    168*s12*s24**2 + 1432*s12*s24*s34 - 40*s12*s34**2 + 64*s23**3
     +     + 272*s23**2*s24 + 56*s23**2*s34 + 440*s23*s24**2 + 296*s23*
     +    s24*s34 + 64*s23*s34**2 + 320*s24**3 + 400*s24**2*s34 + 96*
     +    s24*s34**2 )

      LB = LB + log(s34**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1) * ( 
     +    184*s12**2*s14*s34 + 400*s12**2*s34**2 + 240*s12*s14**2*s34
     +     - 240*s12*s14*s34**2 - 32*s14**3*s34 - 32*s14**2*s34**2 )

      LB = LB + log(s34**(-1)*s1234)*S13**(-1)*S23**(-1) * ( 576*s12**2
     +    *s34 + 96*s12*s14*s24 + 1200*s12*s14*s34 + 120*s12*s24**2 + 
     +    1536*s12*s24*s34 - 216*s12*s34**2 + 88*s14**3 + 272*s14**2*
     +    s24 + 184*s14**2*s34 + 400*s14*s24**2 + 536*s14*s24*s34 - 72*
     +    s14*s34**2 + 304*s24**3 + 528*s24**2*s34 - 8*s24*s34**2 )

      LB = LB + log(s34**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 480*s12**2
     +    *s34 + 96*s12*s14*s23 + 824*s12*s14*s34 + 72*s12*s23**2 + 488
     +    *s12*s23*s34 - 400*s12*s34**2 + 88*s14**3 + 72*s14**2*s23 - 
     +    24*s14**2*s34 + 56*s14*s23**2 - 40*s14*s23*s34 - 48*s14*
     +    s34**2 + 16*s23**3 - 104*s23**2*s34 - 56*s23*s34**2 )

      LB = LB + log(s34**(-1)*s1234)*S13**(-1) * ( 192*s12*s14 + 272*
     +    s12*s23 + 320*s12*s24 + 1936*s12*s34 + 352*s14**2 + 456*s14*
     +    s23 + 784*s14*s24 + 368*s14*s34 + 272*s23**2 + 792*s23*s24 + 
     +    128*s23*s34 + 840*s24**2 + 704*s24*s34 - 8*s34**2 )

      LB = LB + log(s34**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1) * ( 
     +     - 88*s12**2*s13*s34 + 448*s12**2*s34**2 + 8*s12*s13**2*s34
     +     + 88*s12*s13*s34**2 + 16*s12*s34**3 )

      LB = LB + log(s34**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 288*s12**2
     +    *s34 - 136*s12*s13*s34 + 440*s12*s24*s34 + 88*s12*s34**2 - 8*
     +    s13**2*s24 - 16*s13**2*s34 - 16*s13*s24**2 - 64*s13*s24*s34
     +     - 16*s13*s34**2 + 8*s24**3 + 88*s24**2*s34 + 24*s24*s34**2 )

      LB = LB + log(s34**(-1)*s1234)*S14**(-1)*S24**(-1) * ( 192*s12**2
     +    *s34 + 16*s12*s13*s34 + 16*s12*s23*s34 - 144*s12*s34**2 + 16*
     +    s13**2*s34 - 32*s13*s23*s34 - 16*s13*s34**2 + 16*s23**2*s34
     +     - 16*s23*s34**2 - 48*s34**3 )

      LB = LB + log(s34**(-1)*s1234)*S14**(-1) * ( 8*s12*s23 + 8*s12*
     +    s24 + 304*s12*s34 - 16*s13*s23 - 16*s13*s24 - 32*s13*s34 + 32
     +    *s23**2 + 64*s23*s24 + 64*s23*s34 + 40*s24**2 + 112*s24*s34
     +     - 24*s34**2 )

      LB = LB + log(s34**(-1)*s1234)*S23**(-1)*S24**(-1) * ( 96*s12**2*
     +    s34 - 104*s12*s13*s34 + 128*s12*s14*s34 - 128*s12*s34**2 - 32
     +    *s13*s14*s34 - 32*s14*s34**2 )

      LB = LB + log(s34**(-1)*s1234)*S23**(-1) * ( 8*s12*s13 + 8*s12*
     +    s14 + 592*s12*s34 - 80*s13*s34 + 160*s14*s34 + 8*s24**2 + 224
     +    *s24*s34 - 8*s34**2 )

      LB = LB + log(s34**(-1)*s1234)*S24**(-1) * ( 8*s12*s13 + 8*s12*
     +    s14 + 208*s12*s34 + 16*s13**2 + 32*s13*s14 + 16*s14**2 + 48*
     +    s14*s34 - 16*s23**2 - 32*s23*s34 - 72*s34**2 )

      LB = LB + log(s34**(-1)*s1234) * ( 16*s13 + 16*s14 + 24*s24 + 128
     +    *s34 )

      LB = LB + log(s123**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * (  - 120*s12**4*s34 - 492*s12**3*s34**2 - 240*s12**2
     +    *s34**3 )

      LB = LB + log(s123**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)
     +  * (  - 24*s12**4 - 160*s12**3*s24 - 696*s12**3*s34 + 40*s12**2*
     +    s24**2 - 96*s12**2*s24*s34 - 376*s12**2*s34**2 - 24*s12*
     +    s24**2*s34 - 24*s12*s24*s34**2 )

      LB = LB + log(s123**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1)
     +  * (  - 24*s12**4 - 144*s12**3*s23 - 400*s12**3*s34 + 28*s12**2*
     +    s23**2 - 196*s12**2*s23*s34 - 396*s12**2*s34**2 - 148*s12*
     +    s23**2*s34 - 164*s12*s23*s34**2 - 104*s12*s34**3 - 16*s23**3*
     +    s34 - 48*s23**2*s34**2 - 8*s23*s34**3 )

      LB = LB + log(s123**(-1)*s1234)*S13**(-1)*S14**(-1) * (  - 216*
     +    s12**3 - 404*s12**2*s23 - 440*s12**2*s24 - 1040*s12**2*s34 - 
     +    236*s12*s23**2 - 444*s12*s23*s24 - 680*s12*s23*s34 - 32*s12*
     +    s24**2 - 208*s12*s24*s34 - 304*s12*s34**2 - 32*s23**3 - 80*
     +    s23**2*s24 - 128*s23**2*s34 - 16*s23*s24**2 - 80*s23*s24*s34
     +     - 120*s23*s34**2 )

      LB = LB + log(s123**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 64*s12**4 - 56*s12**3*s14 + 976*s12**3*s34 - 120*s12**2*
     +    s14**2 - 272*s12**2*s14*s34 + 336*s12**2*s34**2 - 8*s12*
     +    s14**2*s34 - 8*s12*s14*s34**2 )

      LB = LB + log(s123**(-1)*s1234)*S13**(-1)*S23**(-1) * ( 260*
     +    s12**3 + 136*s12**2*s14 + 8*s12**2*s24 + 344*s12**2*s34 - 8*
     +    s12*s14**2 + 16*s12*s14*s24 - 16*s12*s14*s34 - 8*s12*s24**2
     +     - 16*s12*s34**2 )

      LB = LB + log(s123**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 212*
     +    s12**3 - 148*s12**2*s14 + 248*s12**2*s23 + 844*s12**2*s34 - 
     +    232*s12*s14**2 - 168*s12*s14*s23 - 440*s12*s14*s34 + 152*s12*
     +    s23**2 + 512*s12*s23*s34 + 32*s12*s34**2 - 56*s14**2*s23 - 36
     +    *s14*s23**2 - 64*s14*s23*s34 + 40*s23**3 + 52*s23**2*s34 + 48
     +    *s23*s34**2 )

      LB = LB + log(s123**(-1)*s1234)*S13**(-1) * ( 640*s12**2 + 264*
     +    s12*s14 + 244*s12*s23 - 16*s12*s24 + 304*s12*s34 - 8*s14**2
     +     + 24*s14*s23 - 8*s14*s24 - 16*s14*s34 + 72*s23**2 + 64*s23*
     +    s34 - 8*s24*s34 - 8*s34**2 )

      LB = LB + log(s123**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 56*s12**4 - 264*s12**3*s13 + 868*s12**3*s34 - 148*s12**2
     +    *s13**2 - 56*s12**2*s13*s34 + 596*s12**2*s34**2 - 56*s12*
     +    s13**3 - 40*s12*s13**2*s34 - 128*s12*s13*s34**2 + 88*s12*
     +    s34**3 + 16*s13**4 - 88*s13**3*s34 - 12*s13**2*s34**2 + 8*s13
     +    *s34**3 )

      LB = LB + log(s123**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 344*
     +    s12**3 + 204*s12**2*s13 - 224*s12**2*s24 + 400*s12**2*s34 + 
     +    332*s12*s13**2 - 252*s12*s13*s24 + 140*s12*s13*s34 - 152*s12*
     +    s24*s34 - 72*s12*s34**2 + 56*s13**3 + 16*s13**2*s24 + 112*
     +    s13**2*s34 - 8*s13*s24**2 - 56*s13*s24*s34 - 64*s13*s34**2 )

      LB = LB + log(s123**(-1)*s1234)*S14**(-1)*S24**(-1) * ( 152*
     +    s12**3 + 108*s12**2*s13 + 76*s12**2*s23 + 188*s12**2*s34 + 
     +    244*s12*s13**2 + 284*s12*s13*s23 + 88*s12*s13*s34 + 76*s12*
     +    s23**2 + 44*s12*s23*s34 - 80*s12*s34**2 + 112*s13**3 + 164*
     +    s13**2*s23 - 96*s13**2*s34 + 112*s13*s23**2 - 60*s13*s23*s34
     +     - 52*s13*s34**2 + 16*s23**3 - 32*s23**2*s34 - 80*s23*s34**2
     +     )

      LB = LB + log(s123**(-1)*s1234)*S14**(-1) * ( 228*s12**2 + 176*
     +    s12*s13 - 260*s12*s23 - 592*s12*s24 - 480*s12*s34 + 132*
     +    s13**2 - 4*s13*s23 - 180*s13*s24 - 112*s13*s34 - 96*s23**2 - 
     +    208*s23*s24 - 216*s23*s34 - 16*s24**2 - 88*s24*s34 - 128*
     +    s34**2 )

      LB = LB + log(s123**(-1)*s1234)*S23**(-1)*S24**(-1) * (  - 368*
     +    s12**3 - 328*s12**2*s13 - 252*s12**2*s14 - 684*s12**2*s34 - 
     +    324*s12*s13**2 - 456*s12*s13*s14 - 396*s12*s13*s34 - 248*s12*
     +    s14**2 - 336*s12*s14*s34 - 112*s12*s34**2 - 120*s13**3 - 164*
     +    s13**2*s14 - 64*s13**2*s34 - 48*s13*s14**2 + 24*s13*s14*s34 )

      LB = LB + log(s123**(-1)*s1234)*S23**(-1) * ( 144*s12**2 + 184*
     +    s12*s13 - 56*s12*s14 - 80*s12*s24 + 88*s12*s34 + 64*s13**2 + 
     +    16*s13*s14 - 8*s13*s24 + 40*s13*s34 - 8*s14*s24 - 8*s14*s34
     +     - 8*s24**2 - 16*s24*s34 - 8*s34**2 )

      LB = LB + log(s123**(-1)*s1234)*S24**(-1) * (  - 188*s12**2 - 436
     +    *s12*s13 - 968*s12*s14 + 256*s12*s23 - 236*s12*s34 - 152*
     +    s13**2 - 496*s13*s14 + 80*s13*s23 - 92*s13*s34 - 128*s14**2
     +     - 300*s14*s23 - 120*s14*s34 + 152*s23**2 + 76*s23*s34 - 16*
     +    s34**2 )

      LB = LB + log(s123**(-1)*s1234)*SF*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * (  - 192*s12**2*s34**2 )

      LB = LB + log(s123**(-1)*s1234)*SF*S13**(-1)*S14**(-1)*S23**(-1)
     +  * (  - 96*s12**2*s24 + 192*s12**2*s34 )

      LB = LB + log(s123**(-1)*s1234)*SF*S13**(-1)*S14**(-1)*S24**(-1)
     +  * ( 96*s12**2*s23 + 192*s12**2*s34 + 256*s12*s23*s34 - 256*s12*
     +    s34**2 + 64*s23**2*s34 - 64*s23*s34**2 )

      LB = LB + log(s123**(-1)*s1234)*SF*S13**(-1)*S14**(-1) * (  - 96*
     +    s12*s23 - 96*s12*s24 + 256*s12*s34 - 32*s23**2 - 32*s23*s24
     +     + 64*s23*s34 )

      LB = LB + log(s123**(-1)*s1234)*SF*S13**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 192*s12**2*s14 - 384*s12**2*s34 )

      LB = LB + log(s123**(-1)*s1234)*SF*S13**(-1)*S23**(-1) * (  - 64*
     +    s12*s14 - 32*s12*s24 )

      LB = LB + log(s123**(-1)*s1234)*SF*S13**(-1)*S24**(-1) * (  - 320
     +    *s12*s14 + 160*s12*s23 - 512*s12*s34 - 96*s14*s23 + 32*s23**2
     +     - 128*s23*s34 )

      LB = LB + log(s123**(-1)*s1234)*SF*S13**(-1) * ( 128*s12 - 32*s14
     +     + 32*s23 )

      LB = LB + log(s123**(-1)*s1234)*SF*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 192*s12**2*s13 - 192*s12**2*s34 - 256*s12*s13*s34 - 256*s12
     +    *s34**2 - 64*s13**2*s34 - 64*s13*s34**2 )

      LB = LB + log(s123**(-1)*s1234)*SF*S14**(-1)*S23**(-1) * ( 320*
     +    s12*s13 - 160*s12*s24 + 256*s12*s34 + 64*s13**2 + 64*s13*s34
     +     )

      LB = LB + log(s123**(-1)*s1234)*SF*S14**(-1)*S24**(-1) * ( 256*
     +    s12*s13 + 128*s12*s23 + 64*s13**2 + 96*s13*s23 - 64*s13*s34
     +     + 32*s23**2 + 64*s23*s34 - 128*s34**2 )

      LB = LB + log(s123**(-1)*s1234)*SF*S14**(-1) * (  - 32*s12 + 96*
     +    s13 - 32*s23 - 64*s24 + 128*s34 )

      LB = LB + log(s123**(-1)*s1234)*SF*S23**(-1)*S24**(-1) * (  - 192
     +    *s12*s13 - 192*s12*s14 - 512*s12*s34 - 64*s13**2 - 64*s13*s14
     +     - 128*s13*s34 )

      LB = LB + log(s123**(-1)*s1234)*SF*S23**(-1) * ( 256*s12 + 64*s13
     +     + 32*s24 )

      LB = LB + log(s123**(-1)*s1234)*SF*S24**(-1) * (  - 64*s12 - 64*
     +    s13 - 128*s14 - 256*s34 )

      LB = LB + log(s123**(-1)*s1234)*SF * ( 96 )

      LB = LB + log(s123**(-1)*s1234) * ( 676*s12 + 204*s13 - 64*s14 + 
     +    216*s23 - 48*s24 + 112*s34 )

      LB = LB + log(s234**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * (  - 56*s12**2*s34**3 - 32*s12*s34**4 )

      LB = LB + log(s234**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)
     +  * ( 8*s12**3*s24 - 56*s12**2*s24**2 - 108*s12**2*s24*s34 - 116*
     +    s12**2*s34**2 - 24*s12*s24**3 - 100*s12*s24**2*s34 - 180*s12*
     +    s24*s34**2 - 124*s12*s34**3 )

      LB = LB + log(s234**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1)
     +  * ( 8*s12**3*s23 - 56*s12**2*s23**2 - 108*s12**2*s23*s34 - 116*
     +    s12**2*s34**2 - 24*s12*s23**3 - 100*s12*s23**2*s34 - 180*s12*
     +    s23*s34**2 - 124*s12*s34**3 )

      LB = LB + log(s234**(-1)*s1234)*S13**(-1)*S14**(-1) * (  - 88*
     +    s12**2*s23 - 88*s12**2*s24 - 136*s12**2*s34 - 92*s12*s23**2
     +     - 136*s12*s23*s24 - 272*s12*s23*s34 - 92*s12*s24**2 - 272*
     +    s12*s24*s34 - 344*s12*s34**2 )

      LB = LB + log(s234**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1)
     +  * ( 4*s12**2*s14*s34 - 4*s12**2*s34**2 + 8*s12*s14**2*s34 + 24*
     +    s12*s14*s34**2 - 20*s12*s34**3 - 4*s14**3*s34 - 20*s14**2*
     +    s34**2 + 8*s14*s34**3 + 40*s34**4 )

      LB = LB + log(s234**(-1)*s1234)*S13**(-1)*S23**(-1) * (  - 4*
     +    s12**2*s14 - 40*s12**2*s24 - 48*s12**2*s34 - 64*s12*s14*s24
     +     - 16*s12*s14*s34 + 32*s12*s24**2 + 32*s12*s24*s34 - 28*s12*
     +    s34**2 + 8*s14**3 + 8*s14**2*s24 - 24*s14**2*s34 - 28*s14*
     +    s24**2 + 8*s14*s24*s34 + 44*s14*s34**2 + 40*s24**3 + 184*
     +    s24**2*s34 + 280*s24*s34**2 + 188*s34**3 )

      LB = LB + log(s234**(-1)*s1234)*S13**(-1)*S24**(-1) * (  - 16*
     +    s12**2*s14 - 8*s12**2*s23 - 36*s12**2*s34 + 8*s12*s14**2 - 36
     +    *s12*s14*s23 - 136*s12*s14*s34 - 28*s12*s23**2 - 20*s12*s23*
     +    s34 - 144*s12*s34**2 + 4*s14**3 + 84*s14**2*s23 + 76*s14**2*
     +    s34 - 16*s14*s23**2 + 4*s14*s23*s34 + 12*s14*s34**2 - 64*
     +    s23**3 + 36*s23**2*s34 + 196*s23*s34**2 + 116*s34**3 )

      LB = LB + log(s234**(-1)*s1234)*S13**(-1) * (  - 16*s12**2 - 144*
     +    s12*s14 - 124*s12*s23 - 60*s12*s24 - 196*s12*s34 + 100*s14**2
     +     + 96*s14*s23 + 124*s14*s24 + 216*s14*s34 - 100*s23**2 - 56*
     +    s23*s24 + 208*s23*s34 + 20*s24**2 + 288*s24*s34 + 388*s34**2
     +     )

      LB = LB + log(s234**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 12*s12**2*s13*s34 - 52*s12**2*s34**2 - 16*s12*s13**2*s34
     +     - 16*s12*s13*s34**2 - 36*s12*s34**3 - 4*s13**3*s34 - 20*
     +    s13**2*s34**2 + 8*s13*s34**3 + 40*s34**4 )

      LB = LB + log(s234**(-1)*s1234)*S14**(-1)*S23**(-1) * (  - 16*
     +    s12**2*s13 - 8*s12**2*s24 - 36*s12**2*s34 + 8*s12*s13**2 - 36
     +    *s12*s13*s24 - 120*s12*s13*s34 - 28*s12*s24**2 - 20*s12*s24*
     +    s34 - 152*s12*s34**2 + 4*s13**3 + 84*s13**2*s24 + 84*s13**2*
     +    s34 - 24*s13*s24**2 - 4*s13*s24*s34 + 20*s13*s34**2 - 64*
     +    s24**3 + 28*s24**2*s34 + 180*s24*s34**2 + 108*s34**3 )

      LB = LB + log(s234**(-1)*s1234)*S14**(-1)*S24**(-1) * (  - 4*
     +    s12**2*s13 - 40*s12**2*s23 - 48*s12**2*s34 - 64*s12*s13*s23
     +     - 32*s12*s13*s34 + 32*s12*s23**2 + 32*s12*s23*s34 - 20*s12*
     +    s34**2 + 8*s13**3 + 8*s13**2*s23 - 32*s13**2*s34 - 28*s13*
     +    s23**2 + 24*s13*s23*s34 + 52*s13*s34**2 + 40*s23**3 + 184*
     +    s23**2*s34 + 288*s23*s34**2 + 212*s34**3 )

      LB = LB + log(s234**(-1)*s1234)*S14**(-1) * (  - 16*s12**2 - 144*
     +    s12*s13 - 60*s12*s23 - 124*s12*s24 - 196*s12*s34 + 100*s13**2
     +     + 132*s13*s23 + 96*s13*s24 + 224*s13*s34 + 20*s23**2 - 56*
     +    s23*s24 + 296*s23*s34 - 100*s24**2 + 208*s24*s34 + 404*s34**2
     +     )

      LB = LB + log(s234**(-1)*s1234)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**2*s34 - 8*s12*s13*s34 + 16*s12*s14*s34 + 56*s12*s34**2
     +     + 20*s13**2*s34 + 48*s13*s14*s34 + 8*s13*s34**2 + 20*s14**2*
     +    s34 + 8*s14*s34**2 - 48*s34**3 )

      LB = LB + log(s234**(-1)*s1234)*S23**(-1) * (  - 20*s12**2 - 8*
     +    s12*s13 - 16*s12*s14 - 60*s12*s24 - 140*s12*s34 - 4*s13**2 - 
     +    32*s13*s14 + 104*s13*s24 + 192*s13*s34 - 16*s14**2 + 56*s14*
     +    s24 + 56*s14*s34 + 56*s24**2 + 148*s24*s34 + 172*s34**2 )

      LB = LB + log(s234**(-1)*s1234)*S24**(-1) * (  - 20*s12**2 - 32*
     +    s12*s13 - 24*s12*s14 - 60*s12*s23 - 28*s12*s34 - 48*s13**2 - 
     +    96*s13*s14 + 56*s13*s23 + 40*s13*s34 - 36*s14**2 + 104*s14*
     +    s23 + 176*s14*s34 + 64*s23**2 + 172*s23*s34 + 236*s34**2 )

      LB = LB + log(s234**(-1)*s1234)*SF*S13**(-1)*S23**(-1) * (  - 16*
     +    s12*s14 + 8*s14**2 )

      LB = LB + log(s234**(-1)*s1234)*SF*S13**(-1)*S24**(-1) * (  - 32*
     +    s12*s14 + 8*s14**2 )

      LB = LB + log(s234**(-1)*s1234)*SF*S14**(-1)*S23**(-1) * ( 32*s12
     +    *s13 - 8*s13**2 )

      LB = LB + log(s234**(-1)*s1234)*SF*S14**(-1)*S24**(-1) * ( 16*s12
     +    *s13 - 8*s13**2 )

      LB = LB + log(s234**(-1)*s1234)*SF*S23**(-1) * ( 16*s12 - 24*s13
     +     - 8*s14 )

      LB = LB + log(s234**(-1)*s1234)*SF*S24**(-1) * (  - 16*s12 + 8*
     +    s13 + 24*s14 )

      LB = LB + log(s234**(-1)*s1234) * (  - 56*s12 + 180*s13 + 180*s14
     +     + 404*s23 + 396*s24 + 696*s34 )

      LB = LB + log(s134**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * (  - 56*s12**2*s34**3 - 32*s12*s34**4 )

      LB = LB + log(s134**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)
     +  * (  - 12*s12**2*s24*s34 - 4*s12**2*s34**2 - 24*s12*s24**2*s34
     +     + 16*s12*s24*s34**2 - 20*s12*s34**3 - 4*s24**3*s34 - 44*
     +    s24**2*s34**2 + 32*s24*s34**3 + 40*s34**4 )

      LB = LB + log(s134**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1)
     +  * ( 4*s12**2*s23*s34 - 52*s12**2*s34**2 + 24*s12*s23*s34**2 - 
     +    36*s12*s34**3 - 4*s23**3*s34 - 44*s23**2*s34**2 + 32*s23*
     +    s34**3 + 40*s34**4 )

      LB = LB + log(s134**(-1)*s1234)*S13**(-1)*S14**(-1) * (  - 8*
     +    s12**2*s34 + 8*s12*s23*s34 - 16*s12*s24*s34 + 104*s12*s34**2
     +     + 20*s23**2*s34 + 48*s23*s24*s34 - 64*s23*s34**2 + 20*s24**2
     +    *s34 - 64*s24*s34**2 )

      LB = LB + log(s134**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1)
     +  * ( 8*s12**3*s14 - 56*s12**2*s14**2 - 108*s12**2*s14*s34 - 116*
     +    s12**2*s34**2 - 24*s12*s14**3 - 100*s12*s14**2*s34 - 180*s12*
     +    s14*s34**2 - 124*s12*s34**3 )

      LB = LB + log(s134**(-1)*s1234)*S13**(-1)*S23**(-1) * (  - 16*
     +    s12**2*s14 - 4*s12**2*s24 - 24*s12**2*s34 + 8*s12*s14**2 - 88
     +    *s12*s14*s24 + 8*s12*s14*s34 - 28*s12*s34**2 + 40*s14**3 - 4*
     +    s14**2*s24 + 184*s14**2*s34 + 32*s14*s24**2 + 32*s14*s24*s34
     +     + 280*s14*s34**2 + 8*s24**3 - 24*s24**2*s34 + 68*s24*s34**2
     +     + 188*s34**3 )

      LB = LB + log(s134**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 16*s12**2
     +    *s14 - 16*s12**2*s23 - 12*s12**2*s34 - 28*s12*s14**2 - 60*s12
     +    *s14*s23 + 28*s12*s14*s34 + 8*s12*s23**2 - 120*s12*s23*s34 - 
     +    104*s12*s34**2 - 64*s14**3 - 24*s14**2*s23 + 28*s14**2*s34 + 
     +    108*s14*s23**2 - 76*s14*s23*s34 + 204*s14*s34**2 + 4*s23**3
     +     + 84*s23**2*s34 - 28*s23*s34**2 + 132*s34**3 )

      LB = LB + log(s134**(-1)*s1234)*S13**(-1) * (  - 20*s12**2 - 84*
     +    s12*s14 - 8*s12*s23 - 16*s12*s24 - 52*s12*s34 + 56*s14**2 + 
     +    152*s14*s23 + 104*s14*s24 + 76*s14*s34 - 4*s23**2 - 32*s23*
     +    s24 + 168*s23*s34 - 16*s24**2 + 32*s24*s34 + 148*s34**2 )

      LB = LB + log(s134**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 8*s12**3*s13 - 56*s12**2*s13**2 - 108*s12**2*s13*s34 - 116*
     +    s12**2*s34**2 - 24*s12*s13**3 - 100*s12*s13**2*s34 - 180*s12*
     +    s13*s34**2 - 124*s12*s34**3 )

      LB = LB + log(s134**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 16*s12**2
     +    *s13 - 16*s12**2*s24 - 12*s12**2*s34 - 28*s12*s13**2 - 60*s12
     +    *s13*s24 + 28*s12*s13*s34 + 8*s12*s24**2 - 152*s12*s24*s34 - 
     +    96*s12*s34**2 - 64*s13**3 - 16*s13**2*s24 + 36*s13**2*s34 + 
     +    108*s13*s24**2 - 68*s13*s24*s34 + 220*s13*s34**2 + 4*s24**3
     +     + 76*s24**2*s34 - 36*s24*s34**2 + 140*s34**3 )

      LB = LB + log(s134**(-1)*s1234)*S14**(-1)*S24**(-1) * (  - 16*
     +    s12**2*s13 - 4*s12**2*s23 - 24*s12**2*s34 + 8*s12*s13**2 - 88
     +    *s12*s13*s23 + 8*s12*s13*s34 - 32*s12*s23*s34 - 20*s12*s34**2
     +     + 40*s13**3 - 4*s13**2*s23 + 184*s13**2*s34 + 32*s13*s23**2
     +     + 48*s13*s23*s34 + 288*s13*s34**2 + 8*s23**3 - 32*s23**2*s34
     +     + 76*s23*s34**2 + 212*s34**3 )

      LB = LB + log(s134**(-1)*s1234)*S14**(-1) * (  - 20*s12**2 - 84*
     +    s12*s13 - 32*s12*s23 - 24*s12*s24 - 68*s12*s34 + 64*s13**2 + 
     +    104*s13*s23 + 152*s13*s24 + 100*s13*s34 - 48*s23**2 - 96*s23*
     +    s24 + 16*s23*s34 - 36*s24**2 + 152*s24*s34 + 212*s34**2 )

      LB = LB + log(s134**(-1)*s1234)*S23**(-1)*S24**(-1) * (  - 88*
     +    s12**2*s13 - 88*s12**2*s14 - 136*s12**2*s34 - 92*s12*s13**2
     +     - 136*s12*s13*s14 - 272*s12*s13*s34 - 92*s12*s14**2 - 272*
     +    s12*s14*s34 - 344*s12*s34**2 )

      LB = LB + log(s134**(-1)*s1234)*S23**(-1) * ( 32*s12**2 - 148*s12
     +    *s13 - 108*s12*s14 - 192*s12*s24 - 172*s12*s34 - 84*s13**2 - 
     +    40*s13*s14 + 96*s13*s24 + 224*s13*s34 + 20*s14**2 + 148*s14*
     +    s24 + 288*s14*s34 + 148*s24**2 + 144*s24*s34 + 412*s34**2 )

      LB = LB + log(s134**(-1)*s1234)*S24**(-1) * ( 32*s12**2 - 108*s12
     +    *s13 - 148*s12*s14 - 192*s12*s23 - 172*s12*s34 + 20*s13**2 - 
     +    40*s13*s14 + 156*s13*s23 + 296*s13*s34 - 84*s14**2 + 96*s14*
     +    s23 + 224*s14*s34 + 148*s23**2 + 152*s23*s34 + 428*s34**2 )

      LB = LB + log(s134**(-1)*s1234)*SF*S13**(-1)*S23**(-1) * ( 16*s12
     +    *s24 - 8*s24**2 )

      LB = LB + log(s134**(-1)*s1234)*SF*S13**(-1)*S24**(-1) * (  - 32*
     +    s12*s23 + 8*s23**2 )

      LB = LB + log(s134**(-1)*s1234)*SF*S13**(-1) * (  - 16*s12 + 24*
     +    s23 + 8*s24 )

      LB = LB + log(s134**(-1)*s1234)*SF*S14**(-1)*S23**(-1) * ( 32*s12
     +    *s24 - 8*s24**2 )

      LB = LB + log(s134**(-1)*s1234)*SF*S14**(-1)*S24**(-1) * (  - 16*
     +    s12*s23 + 8*s23**2 )

      LB = LB + log(s134**(-1)*s1234)*SF*S14**(-1) * ( 16*s12 - 8*s23
     +     - 24*s24 )

      LB = LB + log(s134**(-1)*s1234) * (  - 104*s12 + 404*s13 + 396*
     +    s14 + 276*s23 + 276*s24 + 552*s34 )

      LB = LB + log(s124**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * (  - 120*s12**4*s34 - 492*s12**3*s34**2 - 240*s12**2
     +    *s34**3 )

      LB = LB + log(s124**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)
     +  * (  - 24*s12**4 - 144*s12**3*s24 - 400*s12**3*s34 + 28*s12**2*
     +    s24**2 - 196*s12**2*s24*s34 - 396*s12**2*s34**2 - 148*s12*
     +    s24**2*s34 - 164*s12*s24*s34**2 - 104*s12*s34**3 - 16*s24**3*
     +    s34 - 48*s24**2*s34**2 - 8*s24*s34**3 )

      LB = LB + log(s124**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1)
     +  * (  - 24*s12**4 - 160*s12**3*s23 - 696*s12**3*s34 + 40*s12**2*
     +    s23**2 - 96*s12**2*s23*s34 - 376*s12**2*s34**2 - 24*s12*
     +    s23**2*s34 - 24*s12*s23*s34**2 )

      LB = LB + log(s124**(-1)*s1234)*S13**(-1)*S14**(-1) * (  - 216*
     +    s12**3 - 440*s12**2*s23 - 404*s12**2*s24 - 1040*s12**2*s34 - 
     +    32*s12*s23**2 - 444*s12*s23*s24 - 208*s12*s23*s34 - 236*s12*
     +    s24**2 - 680*s12*s24*s34 - 304*s12*s34**2 - 16*s23**2*s24 - 
     +    80*s23*s24**2 - 80*s23*s24*s34 - 32*s24**3 - 128*s24**2*s34
     +     - 120*s24*s34**2 )

      LB = LB + log(s124**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 56*s12**4 - 264*s12**3*s14 + 868*s12**3*s34 - 148*s12**2
     +    *s14**2 - 56*s12**2*s14*s34 + 596*s12**2*s34**2 - 56*s12*
     +    s14**3 - 40*s12*s14**2*s34 - 128*s12*s14*s34**2 + 88*s12*
     +    s34**3 + 16*s14**4 - 88*s14**3*s34 - 12*s14**2*s34**2 + 8*s14
     +    *s34**3 )

      LB = LB + log(s124**(-1)*s1234)*S13**(-1)*S23**(-1) * ( 152*
     +    s12**3 + 108*s12**2*s14 + 76*s12**2*s24 + 188*s12**2*s34 + 
     +    244*s12*s14**2 + 284*s12*s14*s24 + 88*s12*s14*s34 + 76*s12*
     +    s24**2 + 44*s12*s24*s34 - 80*s12*s34**2 + 112*s14**3 + 164*
     +    s14**2*s24 - 96*s14**2*s34 + 112*s14*s24**2 - 60*s14*s24*s34
     +     - 52*s14*s34**2 + 16*s24**3 - 32*s24**2*s34 - 80*s24*s34**2
     +     )

      LB = LB + log(s124**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 344*
     +    s12**3 + 204*s12**2*s14 - 224*s12**2*s23 + 400*s12**2*s34 + 
     +    332*s12*s14**2 - 252*s12*s14*s23 + 140*s12*s14*s34 - 152*s12*
     +    s23*s34 - 72*s12*s34**2 + 56*s14**3 + 16*s14**2*s23 + 112*
     +    s14**2*s34 - 8*s14*s23**2 - 56*s14*s23*s34 - 64*s14*s34**2 )

      LB = LB + log(s124**(-1)*s1234)*S13**(-1) * ( 228*s12**2 + 176*
     +    s12*s14 - 592*s12*s23 - 260*s12*s24 - 480*s12*s34 + 132*
     +    s14**2 - 180*s14*s23 - 4*s14*s24 - 112*s14*s34 - 16*s23**2 - 
     +    208*s23*s24 - 88*s23*s34 - 96*s24**2 - 216*s24*s34 - 128*
     +    s34**2 )

      LB = LB + log(s124**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 64*s12**4 - 56*s12**3*s13 + 976*s12**3*s34 - 120*s12**2*
     +    s13**2 - 272*s12**2*s13*s34 + 336*s12**2*s34**2 - 8*s12*
     +    s13**2*s34 - 8*s12*s13*s34**2 )

      LB = LB + log(s124**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 212*
     +    s12**3 - 148*s12**2*s13 + 248*s12**2*s24 + 844*s12**2*s34 - 
     +    232*s12*s13**2 - 168*s12*s13*s24 - 440*s12*s13*s34 + 152*s12*
     +    s24**2 + 512*s12*s24*s34 + 32*s12*s34**2 - 56*s13**2*s24 - 36
     +    *s13*s24**2 - 64*s13*s24*s34 + 40*s24**3 + 52*s24**2*s34 + 48
     +    *s24*s34**2 )

      LB = LB + log(s124**(-1)*s1234)*S14**(-1)*S24**(-1) * ( 260*
     +    s12**3 + 136*s12**2*s13 + 8*s12**2*s23 + 344*s12**2*s34 - 8*
     +    s12*s13**2 + 16*s12*s13*s23 - 16*s12*s13*s34 - 8*s12*s23**2
     +     - 16*s12*s34**2 )

      LB = LB + log(s124**(-1)*s1234)*S14**(-1) * ( 640*s12**2 + 264*
     +    s12*s13 - 16*s12*s23 + 244*s12*s24 + 304*s12*s34 - 8*s13**2
     +     - 8*s13*s23 + 24*s13*s24 - 16*s13*s34 - 8*s23*s34 + 72*
     +    s24**2 + 64*s24*s34 - 8*s34**2 )

      LB = LB + log(s124**(-1)*s1234)*S23**(-1)*S24**(-1) * (  - 368*
     +    s12**3 - 252*s12**2*s13 - 328*s12**2*s14 - 684*s12**2*s34 - 
     +    248*s12*s13**2 - 456*s12*s13*s14 - 336*s12*s13*s34 - 324*s12*
     +    s14**2 - 396*s12*s14*s34 - 112*s12*s34**2 - 48*s13**2*s14 - 
     +    164*s13*s14**2 + 24*s13*s14*s34 - 120*s14**3 - 64*s14**2*s34
     +     )

      LB = LB + log(s124**(-1)*s1234)*S23**(-1) * (  - 188*s12**2 - 968
     +    *s12*s13 - 436*s12*s14 + 256*s12*s24 - 236*s12*s34 - 128*
     +    s13**2 - 496*s13*s14 - 300*s13*s24 - 120*s13*s34 - 152*s14**2
     +     + 80*s14*s24 - 92*s14*s34 + 152*s24**2 + 76*s24*s34 - 16*
     +    s34**2 )

      LB = LB + log(s124**(-1)*s1234)*S24**(-1) * ( 144*s12**2 - 56*s12
     +    *s13 + 184*s12*s14 - 80*s12*s23 + 88*s12*s34 + 16*s13*s14 - 8
     +    *s13*s23 - 8*s13*s34 + 64*s14**2 - 8*s14*s23 + 40*s14*s34 - 8
     +    *s23**2 - 16*s23*s34 - 8*s34**2 )

      LB = LB + log(s124**(-1)*s1234)*SF*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * ( 192*s12**2*s34**2 )

      LB = LB + log(s124**(-1)*s1234)*SF*S13**(-1)*S14**(-1)*S23**(-1)
     +  * (  - 96*s12**2*s24 - 192*s12**2*s34 - 256*s12*s24*s34 + 256*
     +    s12*s34**2 - 64*s24**2*s34 + 64*s24*s34**2 )

      LB = LB + log(s124**(-1)*s1234)*SF*S13**(-1)*S14**(-1)*S24**(-1)
     +  * ( 96*s12**2*s23 - 192*s12**2*s34 )

      LB = LB + log(s124**(-1)*s1234)*SF*S13**(-1)*S14**(-1) * ( 96*s12
     +    *s23 + 96*s12*s24 - 256*s12*s34 + 32*s23*s24 + 32*s24**2 - 64
     +    *s24*s34 )

      LB = LB + log(s124**(-1)*s1234)*SF*S13**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 192*s12**2*s14 + 192*s12**2*s34 + 256*s12*s14*s34 + 256*
     +    s12*s34**2 + 64*s14**2*s34 + 64*s14*s34**2 )

      LB = LB + log(s124**(-1)*s1234)*SF*S13**(-1)*S23**(-1) * (  - 256
     +    *s12*s14 - 128*s12*s24 - 64*s14**2 - 96*s14*s24 + 64*s14*s34
     +     - 32*s24**2 - 64*s24*s34 + 128*s34**2 )

      LB = LB + log(s124**(-1)*s1234)*SF*S13**(-1)*S24**(-1) * (  - 320
     +    *s12*s14 + 160*s12*s23 - 256*s12*s34 - 64*s14**2 - 64*s14*s34
     +     )

      LB = LB + log(s124**(-1)*s1234)*SF*S13**(-1) * ( 32*s12 - 96*s14
     +     + 64*s23 + 32*s24 - 128*s34 )

      LB = LB + log(s124**(-1)*s1234)*SF*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 192*s12**2*s13 + 384*s12**2*s34 )

      LB = LB + log(s124**(-1)*s1234)*SF*S14**(-1)*S23**(-1) * ( 320*
     +    s12*s13 - 160*s12*s24 + 512*s12*s34 + 96*s13*s24 - 32*s24**2
     +     + 128*s24*s34 )

      LB = LB + log(s124**(-1)*s1234)*SF*S14**(-1)*S24**(-1) * ( 64*s12
     +    *s13 + 32*s12*s23 )

      LB = LB + log(s124**(-1)*s1234)*SF*S14**(-1) * (  - 128*s12 + 32*
     +    s13 - 32*s24 )

      LB = LB + log(s124**(-1)*s1234)*SF*S23**(-1)*S24**(-1) * ( 192*
     +    s12*s13 + 192*s12*s14 + 512*s12*s34 + 64*s13*s14 + 64*s14**2
     +     + 128*s14*s34 )

      LB = LB + log(s124**(-1)*s1234)*SF*S23**(-1) * ( 64*s12 + 128*s13
     +     + 64*s14 + 256*s34 )

      LB = LB + log(s124**(-1)*s1234)*SF*S24**(-1) * (  - 256*s12 - 64*
     +    s14 - 32*s23 )

      LB = LB + log(s124**(-1)*s1234)*SF * (  - 96 )

      LB = LB + log(s124**(-1)*s1234) * ( 676*s12 - 64*s13 + 204*s14 - 
     +    48*s23 + 216*s24 + 112*s34 )

      LBa=-LB/s134/s234
      
      return
      end

      function LBb(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      SF=(s13*s24-s14*s23)/2d0/s34

      LB=0d0

      LB = LB + Lc0(p12,p34)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 912*s12**3*s34**3 - 16*s12**2*s34**4 )

      LB = LB + Lc0(p12,p34)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 432*
     +    s12**3*s24*s34 - 1320*s12**3*s34**2 - 48*s12**2*s24**3 - 808*
     +    s12**2*s24**2*s34 - 1488*s12**2*s24*s34**2 - 136*s12**2*
     +    s34**3 - 88*s12*s24**4 - 352*s12*s24**3*s34 - 384*s12*s24**2*
     +    s34**2 - 64*s12*s24*s34**3 - 32*s24**4*s34 - 16*s24**3*s34**2
     +     )

      LB = LB + Lc0(p12,p34)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 336*
     +    s12**3*s23*s34 - 1128*s12**3*s34**2 - 24*s12**2*s23**3 - 152*
     +    s12**2*s23**2*s34 - 72*s12**2*s23*s34**2 + 264*s12**2*s34**3
     +     + 16*s12*s23**3*s34 + 32*s12*s23**2*s34**2 )

      LB = LB + Lc0(p12,p34)*S13**(-1)*S14**(-1) * (  - 768*s12**3*s34
     +     - 120*s12**2*s23**2 - 216*s12**2*s23*s24 - 984*s12**2*s23*
     +    s34 - 168*s12**2*s24**2 - 1640*s12**2*s24*s34 - 1304*s12**2*
     +    s34**2 - 64*s12*s23**3 - 272*s12*s23**2*s24 - 184*s12*s23**2*
     +    s34 - 440*s12*s23*s24**2 - 712*s12*s23*s24*s34 - 208*s12*s23*
     +    s34**2 - 320*s12*s24**3 - 864*s12*s24**2*s34 - 544*s12*s24*
     +    s34**2 - 128*s12*s34**3 - 32*s23**3*s34 - 112*s23**2*s24*s34
     +     - 160*s23*s24**2*s34 - 16*s23*s24*s34**2 + 32*s23*s34**3 - 
     +    112*s24**3*s34 - 32*s24**2*s34**2 + 32*s24*s34**3 )

      LB = LB + Lc0(p12,p34)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 288*
     +    s12**3*s14*s34 - 576*s12**3*s34**2 + 24*s12**2*s14**3 - 288*
     +    s12**2*s14**2*s34 - 520*s12**2*s14*s34**2 + 608*s12**2*s34**3
     +     + 40*s12*s14**3*s34 + 48*s12*s14**2*s34**2 + 80*s12*s14*
     +    s34**3 )

      LB = LB + Lc0(p12,p34)*S13**(-1)*S23**(-1) * (  - 528*s12**3*s34
     +     - 120*s12**2*s14*s24 - 1328*s12**2*s14*s34 - 120*s12**2*
     +    s24**2 - 1648*s12**2*s24*s34 - 1360*s12**2*s34**2 - 88*s12*
     +    s14**3 - 280*s12*s14**2*s24 - 360*s12*s14**2*s34 - 408*s12*
     +    s14*s24**2 - 920*s12*s14*s24*s34 - 320*s12*s14*s34**2 - 304*
     +    s12*s24**3 - 952*s12*s24**2*s34 - 672*s12*s24*s34**2 + 96*s12
     +    *s34**3 - 16*s14**3*s34 - 112*s14**2*s24*s34 + 16*s14**2*
     +    s34**2 - 192*s14*s24**2*s34 - 128*s24**3*s34 - 32*s24**2*
     +    s34**2 )

      LB = LB + Lc0(p12,p34)*S13**(-1)*S24**(-1) * (  - 432*s12**3*s34
     +     + 24*s12**2*s14**2 - 144*s12**2*s14*s23 - 1016*s12**2*s14*
     +    s34 - 72*s12**2*s23**2 - 520*s12**2*s23*s34 - 304*s12**2*
     +    s34**2 - 80*s12*s14**3 - 16*s12*s14**2*s23 - 120*s12*s14**2*
     +    s34 - 144*s12*s14*s23**2 - 176*s12*s14*s23*s34 - 56*s12*s14*
     +    s34**2 - 16*s12*s23**3 + 64*s12*s23**2*s34 + 184*s12*s23*
     +    s34**2 + 72*s12*s34**3 - 8*s14**3*s23 + 16*s14**2*s23**2 - 40
     +    *s14**2*s23*s34 - 16*s14*s23**3 - 40*s14*s23**2*s34 + 8*s14*
     +    s23*s34**2 + 32*s23**3*s34 - 32*s23*s34**3 )

      LB = LB + Lc0(p12,p34)*S13**(-1) * (  - 216*s12**2*s14 - 264*
     +    s12**2*s23 - 312*s12**2*s24 - 2120*s12**2*s34 - 376*s12*
     +    s14**2 - 496*s12*s14*s23 - 824*s12*s14*s24 - 848*s12*s14*s34
     +     - 272*s12*s23**2 - 792*s12*s23*s24 - 512*s12*s23*s34 - 840*
     +    s12*s24**2 - 1472*s12*s24*s34 - 224*s12*s34**2 - 8*s14**3 - 
     +    16*s14**2*s23 - 8*s14**2*s24 - 136*s14**2*s34 - 16*s14*s23**2
     +     - 16*s14*s23*s24 - 168*s14*s23*s34 - 296*s14*s24*s34 + 16*
     +    s14*s34**2 - 192*s23*s24*s34 - 288*s24**2*s34 - 32*s24*s34**2
     +     + 32*s34**3 )

      LB = LB + Lc0(p12,p34)*S14**(-1)*S23**(-1)*S24**(-1) * ( 24*
     +    s12**2*s13**3 - 32*s12**2*s13**2*s34 - 296*s12**2*s13*s34**2
     +     + 32*s12**2*s34**3 + 8*s12*s13**3*s34 - 48*s12*s13**2*s34**2
     +     + 16*s12*s13*s34**3 )

      LB = LB + Lc0(p12,p34)*S14**(-1)*S23**(-1) * (  - 240*s12**3*s34
     +     + 24*s12**2*s13**2 - 48*s12**2*s13*s24 - 72*s12**2*s13*s34
     +     - 248*s12**2*s24*s34 + 584*s12**2*s34**2 + 8*s12*s13**3 + 88
     +    *s12*s13**2*s24 + 64*s12*s13**2*s34 - 96*s12*s13*s24**2 - 184
     +    *s12*s13*s24*s34 - 64*s12*s13*s34**2 - 8*s12*s24**3 + 48*s12*
     +    s24**2*s34 + 128*s12*s24*s34**2 + 24*s12*s34**3 + 8*s13**3*
     +    s24 + 16*s13**2*s24**2 + 56*s13**2*s24*s34 + 16*s13**2*s34**2
     +     - 32*s13*s24**3 - 88*s13*s24**2*s34 - 24*s13*s24*s34**2 + 16
     +    *s13*s34**3 + 16*s24**3*s34 - 16*s24**2*s34**2 - 16*s24*
     +    s34**3 )

      LB = LB + Lc0(p12,p34)*S14**(-1)*S24**(-1) * (  - 144*s12**3*s34
     +     - 24*s12**2*s13*s23 - 128*s12**2*s13*s34 + 96*s12**2*s23*s34
     +     + 440*s12**2*s34**2 - 8*s12*s13**2*s23 - 8*s12*s13**2*s34 - 
     +    8*s12*s13*s23**2 - 16*s12*s13*s23*s34 + 24*s12*s13*s34**2 - 
     +    24*s12*s23*s34**2 + 16*s12*s34**3 )

      LB = LB + Lc0(p12,p34)*S14**(-1) * (  - 24*s12**2*s13 - 104*
     +    s12**2*s34 - 64*s12*s13*s23 - 88*s12*s13*s24 - 144*s12*s13*
     +    s34 - 16*s12*s23**2 - 32*s12*s23*s24 + 8*s12*s23*s34 - 24*s12
     +    *s24**2 + 80*s12*s24*s34 - 16*s12*s34**2 + 8*s13**3 - 88*
     +    s13**2*s23 - 96*s13**2*s24 - 72*s13**2*s34 + 16*s13*s23**2 - 
     +    112*s13*s23*s34 - 32*s13*s24**2 - 192*s13*s24*s34 - 120*s13*
     +    s34**2 + 40*s23**2*s34 + 80*s23*s24*s34 - 8*s23*s34**2 + 56*
     +    s24**2*s34 - 24*s24*s34**2 - 48*s34**3 )

      LB = LB + Lc0(p12,p34)*S23**(-1)*S24**(-1) * (  - 288*s12**3*s34
     +     + 48*s12**2*s13**2 + 48*s12**2*s13*s14 + 288*s12**2*s13*s34
     +     + 48*s12**2*s14**2 + 32*s12**2*s14*s34 - 272*s12**2*s34**2
     +     - 24*s12*s13**3 + 152*s12*s13**2*s14 + 72*s12*s13**2*s34 + 
     +    152*s12*s13*s14**2 + 256*s12*s13*s14*s34 + 96*s12*s13*s34**2
     +     - 24*s12*s14**3 + 72*s12*s14**2*s34 + 64*s12*s14*s34**2 - 
     +    176*s12*s34**3 - 8*s13**4 + 16*s13**3*s14 - 32*s13**3*s34 + 
     +    48*s13**2*s14**2 + 96*s13**2*s14*s34 - 24*s13**2*s34**2 + 16*
     +    s13*s14**3 + 96*s13*s14**2*s34 + 96*s13*s14*s34**2 - 8*s14**4
     +     - 32*s14**3*s34 - 24*s14**2*s34**2 )

      LB = LB + Lc0(p12,p34)*S23**(-1) * (  - 48*s12**2*s13 - 72*s12**2
     +    *s14 - 72*s12**2*s24 - 792*s12**2*s34 + 152*s12*s13**2 - 8*
     +    s12*s13*s14 - 144*s12*s13*s24 - 32*s12*s13*s34 - 104*s12*
     +    s14**2 - 152*s12*s14*s24 - 272*s12*s14*s34 - 72*s12*s24**2 - 
     +    192*s12*s24*s34 - 96*s12*s34**2 - 8*s13**3 + 64*s13**2*s14 + 
     +    64*s13**2*s24 + 80*s13**2*s34 + 16*s13*s14**2 - 56*s13*s14*
     +    s24 - 8*s13*s14*s34 - 80*s13*s24**2 - 128*s13*s24*s34 + 16*
     +    s13*s34**2 - 24*s14**3 - 24*s14**2*s24 - 40*s14**2*s34 - 16*
     +    s14*s24**2 + 40*s14*s24*s34 - 64*s14*s34**2 - 8*s24**3 + 48*
     +    s24**2*s34 - 40*s24*s34**2 - 16*s34**3 )

      LB = LB + Lc0(p12,p34)*S24**(-1) * (  - 72*s12**2*s13 - 48*s12**2
     +    *s14 - 72*s12**2*s23 - 536*s12**2*s34 - 104*s12*s13**2 - 8*
     +    s12*s13*s14 - 192*s12*s13*s23 - 328*s12*s13*s34 + 152*s12*
     +    s14**2 - 208*s12*s14*s23 - 48*s12*s14*s34 - 24*s12*s23**2 - 
     +    176*s12*s23*s34 - 320*s12*s34**2 - 24*s13**3 + 16*s13**2*s14
     +     - 8*s13**2*s23 - 48*s13**2*s34 + 64*s13*s14**2 - 40*s13*s14*
     +    s23 + 8*s13*s14*s34 - 96*s13*s23**2 - 128*s13*s23*s34 - 56*
     +    s13*s34**2 - 8*s14**3 + 48*s14**2*s23 + 40*s14**2*s34 - 160*
     +    s14*s23**2 - 152*s14*s23*s34 - 40*s14*s34**2 + 8*s23**3 - 128
     +    *s23**2*s34 - 160*s23*s34**2 - 32*s34**3 )

      LB = LB + Lc0(p12,p34) * (  - 48*s12**2 - 144*s12*s13 - 168*s12*
     +    s14 - 56*s12*s23 - 104*s12*s24 - 80*s12*s34 + 8*s13**2 - 32*
     +    s13*s14 - 136*s13*s23 - 80*s13*s24 - 160*s13*s34 - 24*s14**2
     +     - 80*s14*s23 + 24*s14*s24 + 24*s23**2 + 16*s23*s24 - 80*s23*
     +    s34 - 8*s24**2 + 80*s24*s34 - 80*s34**2 )

      LB = LB + Lc0(p13,p24)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 16*s12**4*s34**2 + 16*s12**3*s34**3 )

      LB = LB + Lc0(p13,p24)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16*
     +    s12**4*s34 + 16*s12**3*s34**2 )

      LB = LB + Lc0(p13,p24)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 8*
     +    s12**4*s23 - 24*s12**4*s34 + 24*s12**3*s23**2 + 16*s12**3*s23
     +    *s34 + 8*s12**3*s34**2 - 56*s12**2*s23**3 - 96*s12**2*s23**2*
     +    s34 - 24*s12**2*s23*s34**2 + 16*s12**2*s34**3 + 8*s12*s23**4
     +     + 16*s12*s23**3*s34 + 16*s12*s23**2*s34**2 + 8*s12*s23*
     +    s34**3 )

      LB = LB + Lc0(p13,p24)*S13**(-1)*S14**(-1) * (  - 8*s12**4 + 40*
     +    s12**3*s23 + 16*s12**3*s24 + 8*s12**3*s34 + 8*s12**2*s23**2
     +     + 56*s12**2*s23*s24 + 16*s12**2*s23*s34 - 8*s12**2*s24**2 - 
     +    16*s12**2*s24*s34 + 8*s12**2*s34**2 - 24*s12*s23**3 - 24*s12*
     +    s23**2*s24 - 56*s12*s23**2*s34 + 8*s12*s23*s24**2 - 24*s12*
     +    s23*s24*s34 - 24*s12*s23*s34**2 )

      LB = LB + Lc0(p13,p24)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**4*s14 - 24*s12**4*s34 + 24*s12**3*s14**2 + 16*s12**3*s14
     +    *s34 + 8*s12**3*s34**2 - 56*s12**2*s14**3 - 96*s12**2*s14**2*
     +    s34 - 24*s12**2*s14*s34**2 + 16*s12**2*s34**3 + 8*s12*s14**4
     +     + 16*s12*s14**3*s34 + 16*s12*s14**2*s34**2 + 8*s12*s14*
     +    s34**3 )

      LB = LB + Lc0(p13,p24)*S13**(-1)*S23**(-1) * (  - 16*s12**4 + 8*
     +    s12**3*s14 + 24*s12**3*s34 + 8*s12**2*s14**2 + 32*s12**2*s14*
     +    s34 + 24*s12**2*s34**2 - 8*s12*s14**3 - 8*s12*s14**2*s34 )

      LB = LB + Lc0(p13,p24)*S13**(-1)*S24**(-1) * (  - 16*s12**4 - 16*
     +    s12**3*s14 - 16*s12**3*s23 - 16*s12**3*s34 + 48*s12**2*s14**2
     +     + 64*s12**2*s14*s23 + 128*s12**2*s14*s34 + 48*s12**2*s23**2
     +     + 128*s12**2*s23*s34 + 96*s12**2*s34**2 - 64*s12*s14**3 + 
     +    104*s12*s14**2*s23 - 16*s12*s14**2*s34 + 104*s12*s14*s23**2
     +     + 248*s12*s14*s23*s34 + 88*s12*s14*s34**2 - 64*s12*s23**3 - 
     +    16*s12*s23**2*s34 + 88*s12*s23*s34**2 + 40*s12*s34**3 + 8*
     +    s14**4 + 16*s14**3*s23 + 40*s14**3*s34 + 48*s14**2*s23**2 + 
     +    88*s14**2*s23*s34 + 56*s14**2*s34**2 + 16*s14*s23**3 + 88*s14
     +    *s23**2*s34 + 104*s14*s23*s34**2 + 32*s14*s34**3 + 8*s23**4
     +     + 40*s23**3*s34 + 56*s23**2*s34**2 + 32*s23*s34**3 + 8*
     +    s34**4 )

      LB = LB + Lc0(p13,p24)*S13**(-1) * (  - 16*s12**3 + 88*s12**2*s14
     +     + 64*s12**2*s23 + 16*s12**2*s24 + 120*s12**2*s34 + 80*s12*
     +    s14**2 + 112*s12*s14*s23 + 128*s12*s14*s34 + 64*s12*s23*s24
     +     + 120*s12*s23*s34 + 48*s12*s34**2 + 16*s14**3 + 40*s14**2*
     +    s23 + 32*s14**2*s34 + 16*s14*s23**2 + 64*s14*s23*s34 + 24*s14
     +    *s34**2 + 8*s23**3 + 32*s23**2*s34 + 24*s23*s34**2 + 8*s34**3
     +     )

      LB = LB + Lc0(p13,p24)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**4*s34 + 16*s12**3*s34**2 )

      LB = LB + Lc0(p13,p24)*S14**(-1)*S23**(-1) * (  - 16*s12**4 + 16*
     +    s12**3*s34 + 48*s12**2*s13*s24 + 48*s12**2*s13*s34 + 48*
     +    s12**2*s24*s34 + 48*s12**2*s34**2 )

      LB = LB + Lc0(p13,p24)*S14**(-1)*S24**(-1) * (  - 16*s12**4 + 8*
     +    s12**3*s23 + 24*s12**3*s34 + 8*s12**2*s23**2 + 32*s12**2*s23*
     +    s34 + 24*s12**2*s34**2 - 8*s12*s23**3 - 8*s12*s23**2*s34 )

      LB = LB + Lc0(p13,p24)*S14**(-1) * ( 8*s12**3 + 48*s12**2*s13 + 
     +    48*s12**2*s23 + 40*s12**2*s24 + 112*s12**2*s34 - 24*s12*s13*
     +    s23 - 24*s12*s13*s24 - 24*s12*s13*s34 + 48*s12*s23**2 + 24*
     +    s12*s23*s24 + 64*s12*s23*s34 - 32*s12*s24**2 - 24*s12*s24*s34
     +     + 8*s12*s34**2 - 8*s13*s23**2 - 32*s13*s23*s24 - 8*s13*s23*
     +    s34 - 24*s13*s24**2 - 24*s13*s24*s34 - 8*s23**2*s34 - 8*s23*
     +    s24*s34 - 8*s23*s34**2 )

      LB = LB + Lc0(p13,p24)*S23**(-1)*S24**(-1) * (  - 8*s12**4 + 16*
     +    s12**3*s13 + 40*s12**3*s14 + 8*s12**3*s34 - 8*s12**2*s13**2
     +     + 56*s12**2*s13*s14 - 16*s12**2*s13*s34 + 8*s12**2*s14**2 + 
     +    16*s12**2*s14*s34 + 8*s12**2*s34**2 + 8*s12*s13**2*s14 - 24*
     +    s12*s13*s14**2 - 24*s12*s13*s14*s34 - 24*s12*s14**3 - 56*s12*
     +    s14**2*s34 - 24*s12*s14*s34**2 )

      LB = LB + Lc0(p13,p24)*S23**(-1) * ( 8*s12**3 + 40*s12**2*s13 + 
     +    48*s12**2*s14 + 48*s12**2*s24 + 112*s12**2*s34 - 32*s12*
     +    s13**2 + 24*s12*s13*s14 - 24*s12*s13*s24 - 24*s12*s13*s34 + 
     +    48*s12*s14**2 - 24*s12*s14*s24 + 64*s12*s14*s34 - 24*s12*s24*
     +    s34 + 8*s12*s34**2 - 24*s13**2*s24 - 32*s13*s14*s24 - 8*s13*
     +    s14*s34 - 24*s13*s24*s34 - 8*s14**2*s24 - 8*s14**2*s34 - 8*
     +    s14*s24*s34 - 8*s14*s34**2 )

      LB = LB + Lc0(p13,p24)*S24**(-1) * (  - 16*s12**3 + 16*s12**2*s13
     +     + 64*s12**2*s14 + 88*s12**2*s23 + 120*s12**2*s34 + 64*s12*
     +    s13*s14 + 112*s12*s14*s23 + 120*s12*s14*s34 + 80*s12*s23**2
     +     + 128*s12*s23*s34 + 48*s12*s34**2 + 8*s14**3 + 16*s14**2*s23
     +     + 32*s14**2*s34 + 40*s14*s23**2 + 64*s14*s23*s34 + 24*s14*
     +    s34**2 + 16*s23**3 + 32*s23**2*s34 + 24*s23*s34**2 + 8*s34**3
     +     )

      LB = LB + Lc0(p13,p24) * ( 160*s12**2 + 16*s12*s13 + 104*s12*s14
     +     + 104*s12*s23 + 16*s12*s24 + 88*s12*s34 + 16*s13*s14 - 32*
     +    s13*s23 - 32*s13*s24 - 32*s13*s34 + 32*s14**2 - 32*s14*s24 + 
     +    32*s23**2 + 16*s23*s24 - 32*s24*s34 - 24*s34**2 )

      LB = LB + Lc0(p14,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 16*s12**4*s34**2 + 16*s12**3*s34**3 )

      LB = LB + Lc0(p14,p23)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 8*
     +    s12**4*s24 - 24*s12**4*s34 + 24*s12**3*s24**2 + 16*s12**3*s24
     +    *s34 + 8*s12**3*s34**2 - 56*s12**2*s24**3 - 96*s12**2*s24**2*
     +    s34 - 24*s12**2*s24*s34**2 + 16*s12**2*s34**3 + 8*s12*s24**4
     +     + 16*s12*s24**3*s34 + 16*s12*s24**2*s34**2 + 8*s12*s24*
     +    s34**3 )

      LB = LB + Lc0(p14,p23)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16*
     +    s12**4*s34 + 16*s12**3*s34**2 )

      LB = LB + Lc0(p14,p23)*S13**(-1)*S14**(-1) * (  - 8*s12**4 + 16*
     +    s12**3*s23 + 40*s12**3*s24 + 8*s12**3*s34 - 8*s12**2*s23**2
     +     + 56*s12**2*s23*s24 - 16*s12**2*s23*s34 + 8*s12**2*s24**2 + 
     +    16*s12**2*s24*s34 + 8*s12**2*s34**2 + 8*s12*s23**2*s24 - 24*
     +    s12*s23*s24**2 - 24*s12*s23*s24*s34 - 24*s12*s24**3 - 56*s12*
     +    s24**2*s34 - 24*s12*s24*s34**2 )

      LB = LB + Lc0(p14,p23)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**4*s34 + 16*s12**3*s34**2 )

      LB = LB + Lc0(p14,p23)*S13**(-1)*S23**(-1) * (  - 16*s12**4 + 8*
     +    s12**3*s24 + 24*s12**3*s34 + 8*s12**2*s24**2 + 32*s12**2*s24*
     +    s34 + 24*s12**2*s34**2 - 8*s12*s24**3 - 8*s12*s24**2*s34 )

      LB = LB + Lc0(p14,p23)*S13**(-1)*S24**(-1) * (  - 16*s12**4 + 16*
     +    s12**3*s34 + 48*s12**2*s14*s23 + 48*s12**2*s14*s34 + 48*
     +    s12**2*s23*s34 + 48*s12**2*s34**2 )

      LB = LB + Lc0(p14,p23)*S13**(-1) * ( 8*s12**3 + 48*s12**2*s14 + 
     +    40*s12**2*s23 + 48*s12**2*s24 + 112*s12**2*s34 - 24*s12*s14*
     +    s23 - 24*s12*s14*s24 - 24*s12*s14*s34 - 32*s12*s23**2 + 24*
     +    s12*s23*s24 - 24*s12*s23*s34 + 48*s12*s24**2 + 64*s12*s24*s34
     +     + 8*s12*s34**2 - 24*s14*s23**2 - 32*s14*s23*s24 - 24*s14*s23
     +    *s34 - 8*s14*s24**2 - 8*s14*s24*s34 - 8*s23*s24*s34 - 8*
     +    s24**2*s34 - 8*s24*s34**2 )

      LB = LB + Lc0(p14,p23)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**4*s13 - 24*s12**4*s34 + 24*s12**3*s13**2 + 16*s12**3*s13
     +    *s34 + 8*s12**3*s34**2 - 56*s12**2*s13**3 - 96*s12**2*s13**2*
     +    s34 - 24*s12**2*s13*s34**2 + 16*s12**2*s34**3 + 8*s12*s13**4
     +     + 16*s12*s13**3*s34 + 16*s12*s13**2*s34**2 + 8*s12*s13*
     +    s34**3 )

      LB = LB + Lc0(p14,p23)*S14**(-1)*S23**(-1) * (  - 16*s12**4 - 16*
     +    s12**3*s13 - 16*s12**3*s24 - 16*s12**3*s34 + 48*s12**2*s13**2
     +     + 64*s12**2*s13*s24 + 128*s12**2*s13*s34 + 48*s12**2*s24**2
     +     + 128*s12**2*s24*s34 + 96*s12**2*s34**2 - 64*s12*s13**3 + 
     +    104*s12*s13**2*s24 - 16*s12*s13**2*s34 + 104*s12*s13*s24**2
     +     + 248*s12*s13*s24*s34 + 88*s12*s13*s34**2 - 64*s12*s24**3 - 
     +    16*s12*s24**2*s34 + 88*s12*s24*s34**2 + 40*s12*s34**3 + 8*
     +    s13**4 + 16*s13**3*s24 + 40*s13**3*s34 + 48*s13**2*s24**2 + 
     +    88*s13**2*s24*s34 + 56*s13**2*s34**2 + 16*s13*s24**3 + 88*s13
     +    *s24**2*s34 + 104*s13*s24*s34**2 + 32*s13*s34**3 + 8*s24**4
     +     + 40*s24**3*s34 + 56*s24**2*s34**2 + 32*s24*s34**3 + 8*
     +    s34**4 )

      LB = LB + Lc0(p14,p23)*S14**(-1)*S24**(-1) * (  - 16*s12**4 + 8*
     +    s12**3*s13 + 24*s12**3*s34 + 8*s12**2*s13**2 + 32*s12**2*s13*
     +    s34 + 24*s12**2*s34**2 - 8*s12*s13**3 - 8*s12*s13**2*s34 )

      LB = LB + Lc0(p14,p23)*S14**(-1) * (  - 16*s12**3 + 88*s12**2*s13
     +     + 16*s12**2*s23 + 64*s12**2*s24 + 120*s12**2*s34 + 80*s12*
     +    s13**2 + 112*s12*s13*s24 + 128*s12*s13*s34 + 64*s12*s23*s24
     +     + 120*s12*s24*s34 + 48*s12*s34**2 + 16*s13**3 + 40*s13**2*
     +    s24 + 32*s13**2*s34 + 16*s13*s24**2 + 64*s13*s24*s34 + 24*s13
     +    *s34**2 + 8*s24**3 + 32*s24**2*s34 + 24*s24*s34**2 + 8*s34**3
     +     )

      LB = LB + Lc0(p14,p23)*S23**(-1)*S24**(-1) * (  - 8*s12**4 + 40*
     +    s12**3*s13 + 16*s12**3*s14 + 8*s12**3*s34 + 8*s12**2*s13**2
     +     + 56*s12**2*s13*s14 + 16*s12**2*s13*s34 - 8*s12**2*s14**2 - 
     +    16*s12**2*s14*s34 + 8*s12**2*s34**2 - 24*s12*s13**3 - 24*s12*
     +    s13**2*s14 - 56*s12*s13**2*s34 + 8*s12*s13*s14**2 - 24*s12*
     +    s13*s14*s34 - 24*s12*s13*s34**2 )

      LB = LB + Lc0(p14,p23)*S23**(-1) * (  - 16*s12**3 + 64*s12**2*s13
     +     + 16*s12**2*s14 + 88*s12**2*s24 + 120*s12**2*s34 + 64*s12*
     +    s13*s14 + 112*s12*s13*s24 + 120*s12*s13*s34 + 80*s12*s24**2
     +     + 128*s12*s24*s34 + 48*s12*s34**2 + 8*s13**3 + 16*s13**2*s24
     +     + 32*s13**2*s34 + 40*s13*s24**2 + 64*s13*s24*s34 + 24*s13*
     +    s34**2 + 16*s24**3 + 32*s24**2*s34 + 24*s24*s34**2 + 8*s34**3
     +     )

      LB = LB + Lc0(p14,p23)*S24**(-1) * ( 8*s12**3 + 48*s12**2*s13 + 
     +    40*s12**2*s14 + 48*s12**2*s23 + 112*s12**2*s34 + 48*s12*
     +    s13**2 + 24*s12*s13*s14 - 24*s12*s13*s23 + 64*s12*s13*s34 - 
     +    32*s12*s14**2 - 24*s12*s14*s23 - 24*s12*s14*s34 - 24*s12*s23*
     +    s34 + 8*s12*s34**2 - 8*s13**2*s23 - 8*s13**2*s34 - 32*s13*s14
     +    *s23 - 8*s13*s14*s34 - 8*s13*s23*s34 - 8*s13*s34**2 - 24*
     +    s14**2*s23 - 24*s14*s23*s34 )

      LB = LB + Lc0(p14,p23) * ( 160*s12**2 + 104*s12*s13 + 16*s12*s14
     +     + 16*s12*s23 + 104*s12*s24 + 88*s12*s34 + 32*s13**2 + 16*s13
     +    *s14 - 32*s13*s23 - 32*s14*s23 - 32*s14*s24 - 32*s14*s34 + 16
     +    *s23*s24 - 32*s23*s34 + 32*s24**2 - 24*s34**2 )

      LB = LB + Lc1(p1,p23)*S13**(-1)*S14**(-1)*S23**(-1) * ( 8*s12**3*
     +    s24**2 + 16*s12**3*s24*s34 + 8*s12**3*s34**2 - 8*s12**2*
     +    s24**2*s34 - 16*s12**2*s24*s34**2 - 8*s12**2*s34**3 )

      LB = LB + Lc1(p1,p23)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*s12**4
     +    *s23 + 16*s12**4*s34 + 28*s12**3*s23**2 - 24*s12**3*s23*s34
     +     - 28*s12**3*s34**2 + 12*s12**2*s23**2*s34 + 12*s12**2*s23*
     +    s34**2 + 16*s12**2*s34**3 )

      LB = LB + Lc1(p1,p23)*S13**(-1)*S14**(-1) * ( 16*s12**4 + 48*
     +    s12**3*s23 + 28*s12**3*s24 - 28*s12**2*s23**2 - 44*s12**2*s23
     +    *s24 - 48*s12**2*s23*s34 - 16*s12**2*s24**2 - 56*s12**2*s24*
     +    s34 - 24*s12**2*s34**2 )

      LB = LB + Lc1(p1,p23)*S13**(-1)*S23**(-1) * (  - 8*s12**3*s24 - 8
     +    *s12**3*s34 + 8*s12**2*s14*s24 + 8*s12**2*s14*s34 - 8*s12**2*
     +    s24**2 - 8*s12**2*s24*s34 )

      LB = LB + Lc1(p1,p23)*S13**(-1)*S24**(-1) * (  - 8*s12**4 + 8*
     +    s12**3*s14 - 72*s12**3*s23 - 24*s12**3*s34 + 56*s12**2*s14*
     +    s23 + 24*s12**2*s14*s34 - 44*s12**2*s23**2 + 28*s12**2*s23*
     +    s34 + 24*s12**2*s34**2 - 16*s12*s14**2*s23 + 8*s12*s14**2*s34
     +     + 48*s12*s14*s23**2 + 16*s12*s14*s34**2 + 64*s12*s23**3 - 72
     +    *s12*s23**2*s34 - 8*s12*s23*s34**2 + 8*s12*s34**3 - 8*s14**3*
     +    s23 - 8*s14**2*s23**2 - 16*s14**2*s23*s34 - 8*s14*s23**2*s34
     +     - 8*s14*s23*s34**2 )

      LB = LB + Lc1(p1,p23)*S13**(-1) * (  - 16*s12**3 + 16*s12**2*s14
     +     + 28*s12**2*s23 + 8*s12**2*s34 - 16*s12*s14**2 - 24*s12*s14*
     +    s23 - 8*s12*s14*s34 + 96*s12*s23**2 + 32*s12*s23*s24 + 16*s12
     +    *s23*s34 + 8*s12*s34**2 - 8*s14**2*s23 - 8*s14*s23*s34 )

      LB = LB + Lc1(p1,p23)*S24**(-1) * ( 16*s12*s14*s34 - 8*s14**2*s23
     +     )

      LB = LB + Lc1(p1,p24)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*s12**4
     +    *s24 + 16*s12**4*s34 + 28*s12**3*s24**2 - 24*s12**3*s24*s34
     +     - 28*s12**3*s34**2 + 12*s12**2*s24**2*s34 + 12*s12**2*s24*
     +    s34**2 + 16*s12**2*s34**3 )

      LB = LB + Lc1(p1,p24)*S13**(-1)*S14**(-1)*S24**(-1) * ( 8*s12**3*
     +    s23**2 + 16*s12**3*s23*s34 + 8*s12**3*s34**2 - 8*s12**2*
     +    s23**2*s34 - 16*s12**2*s23*s34**2 - 8*s12**2*s34**3 )

      LB = LB + Lc1(p1,p24)*S13**(-1)*S14**(-1) * ( 16*s12**4 + 28*
     +    s12**3*s23 + 48*s12**3*s24 - 16*s12**2*s23**2 - 44*s12**2*s23
     +    *s24 - 56*s12**2*s23*s34 - 28*s12**2*s24**2 - 48*s12**2*s24*
     +    s34 - 24*s12**2*s34**2 )

      LB = LB + Lc1(p1,p24)*S14**(-1)*S23**(-1) * (  - 8*s12**4 + 8*
     +    s12**3*s13 - 72*s12**3*s24 - 24*s12**3*s34 + 56*s12**2*s13*
     +    s24 + 24*s12**2*s13*s34 - 44*s12**2*s24**2 + 28*s12**2*s24*
     +    s34 + 24*s12**2*s34**2 - 16*s12*s13**2*s24 + 8*s12*s13**2*s34
     +     + 48*s12*s13*s24**2 + 16*s12*s13*s34**2 + 64*s12*s24**3 - 72
     +    *s12*s24**2*s34 - 8*s12*s24*s34**2 + 8*s12*s34**3 - 8*s13**3*
     +    s24 - 8*s13**2*s24**2 - 16*s13**2*s24*s34 - 8*s13*s24**2*s34
     +     - 8*s13*s24*s34**2 )

      LB = LB + Lc1(p1,p24)*S14**(-1)*S24**(-1) * (  - 8*s12**3*s23 - 8
     +    *s12**3*s34 + 8*s12**2*s13*s23 + 8*s12**2*s13*s34 - 8*s12**2*
     +    s23**2 - 8*s12**2*s23*s34 )

      LB = LB + Lc1(p1,p24)*S14**(-1) * (  - 16*s12**3 + 16*s12**2*s13
     +     + 28*s12**2*s24 + 8*s12**2*s34 - 16*s12*s13**2 - 24*s12*s13*
     +    s24 - 8*s12*s13*s34 + 32*s12*s23*s24 + 96*s12*s24**2 + 16*s12
     +    *s24*s34 + 8*s12*s34**2 - 8*s13**2*s24 - 8*s13*s24*s34 )

      LB = LB + Lc1(p1,p24)*S23**(-1) * ( 16*s12*s13*s34 - 8*s13**2*s24
     +     )

      LB = LB + Lc1(p1,p34)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*s12**3
     +    *s34**2 + 8*s12**2*s24*s34**2 + 8*s12**2*s34**3 )

      LB = LB + Lc1(p1,p34)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*s12**3
     +    *s34**2 + 8*s12**2*s23*s34**2 + 8*s12**2*s34**3 )

      LB = LB + Lc1(p1,p34)*S13**(-1)*S14**(-1) * ( 16*s12**2*s34**2 )

      LB = LB + Lc1(p1,p34)*S13**(-1)*S23**(-1) * ( 16*s12**2*s34**2 + 
     +    16*s12*s14*s24*s34 - 16*s12*s24**2*s34 - 16*s12*s24*s34**2 - 
     +    8*s14*s24**2*s34 )

      LB = LB + Lc1(p1,p34)*S13**(-1)*S24**(-1) * (  - 16*s12**2*s34**2
     +     + 16*s12*s14*s23*s34 + 16*s12*s23**2*s34 + 16*s12*s23*s34**2
     +     - 8*s14*s23**2*s34 )

      LB = LB + Lc1(p1,p34)*S13**(-1) * ( 16*s12*s23*s34 - 16*s12*s24*
     +    s34 )

      LB = LB + Lc1(p1,p34)*S14**(-1)*S23**(-1) * (  - 16*s12**2*s24*
     +    s34 + 32*s12**2*s34**2 - 16*s12*s13*s24*s34 + 8*s12*s13*
     +    s34**2 - 8*s12*s24**2*s34 + 8*s12*s24*s34**2 + 16*s12*s34**3
     +     - 16*s13**2*s24*s34 - 8*s13**2*s34**2 - 16*s13*s24**2*s34 - 
     +    24*s13*s24*s34**2 - 8*s13*s34**3 )

      LB = LB + Lc1(p1,p34)*S14**(-1)*S24**(-1) * ( 16*s12**2*s23*s34
     +     - 32*s12**2*s34**2 - 16*s12*s13*s23*s34 + 8*s12*s13*s34**2
     +     + 8*s12*s23**2*s34 - 8*s12*s23*s34**2 - 16*s12*s34**3 + 16*
     +    s13**2*s23*s34 + 8*s13**2*s34**2 - 16*s13*s23**2*s34 + 8*s13*
     +    s23*s34**2 + 24*s13*s34**3 )

      LB = LB + Lc1(p1,p34)*S14**(-1) * ( 32*s12*s13*s23 + 32*s12*s13*
     +    s24 + 32*s12*s13*s34 + 8*s12*s23*s34 - 8*s12*s24*s34 + 16*s13
     +    *s23**2 + 32*s13*s23*s24 + 32*s13*s23*s34 + 16*s13*s24**2 + 
     +    32*s13*s24*s34 + 48*s13*s34**2 )

      LB = LB + Lc1(p1,p234)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s14**3*s34**2 - 20*s14**2*s34**3 - 56*s14*s34**4 )

      LB = LB + Lc1(p1,p234)*S13**(-1)*S23**(-1) * ( 8*s14**3*s34 + 4*
     +    s14**2*s24**2 - 76*s14**2*s24*s34 - 100*s14**2*s34**2 - 56*
     +    s14*s24**3 - 244*s14*s24**2*s34 - 376*s14*s24*s34**2 - 252*
     +    s14*s34**3 )

      LB = LB + Lc1(p1,p234)*S13**(-1)*S24**(-1) * (  - 80*s14**3*s23
     +     - 64*s14**3*s34 + 36*s14**2*s23**2 - 8*s14**2*s23*s34 - 56*
     +    s14**2*s34**2 + 48*s14*s23**3 - 92*s14*s23**2*s34 - 240*s14*
     +    s23*s34**2 - 164*s14*s34**3 )

      LB = LB + Lc1(p1,p234)*S13**(-1) * (  - 88*s14**3 - 124*s14**2*
     +    s23 - 156*s14**2*s24 - 276*s14**2*s34 + 124*s14*s23**2 + 68*
     +    s14*s23*s24 - 280*s14*s23*s34 - 64*s14*s24**2 - 412*s14*s24*
     +    s34 - 520*s14*s34**2 )

      LB = LB + Lc1(p1,p234)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s13**3*s34**2 - 20*s13**2*s34**3 - 56*s13*s34**4 )

      LB = LB + Lc1(p1,p234)*S14**(-1)*S23**(-1) * (  - 80*s13**3*s24
     +     - 64*s13**3*s34 + 44*s13**2*s24**2 + 16*s13**2*s24*s34 - 40*
     +    s13**2*s34**2 + 48*s13*s24**3 - 84*s13*s24**2*s34 - 216*s13*
     +    s24*s34**2 - 148*s13*s34**3 )

      LB = LB + Lc1(p1,p234)*S14**(-1)*S24**(-1) * ( 8*s13**3*s34 + 4*
     +    s13**2*s23**2 - 76*s13**2*s23*s34 - 100*s13**2*s34**2 - 56*
     +    s13*s23**3 - 244*s13*s23**2*s34 - 376*s13*s23*s34**2 - 252*
     +    s13*s34**3 )

      LB = LB + Lc1(p1,p234)*S14**(-1) * (  - 88*s13**3 - 132*s13**2*
     +    s23 - 92*s13**2*s24 - 236*s13**2*s34 - 64*s13*s23**2 + 68*s13
     +    *s23*s24 - 388*s13*s23*s34 + 124*s13*s24**2 - 248*s13*s24*s34
     +     - 480*s13*s34**2 )

      LB = LB + Lc1(p1,p234)*S23**(-1)*S24**(-1) * ( 32*s13**2*s34**2
     +     + 32*s13*s14*s34**2 + 28*s13*s34**3 + 32*s14**2*s34**2 + 28*
     +    s14*s34**3 - 112*s34**4 )

      LB = LB + Lc1(p1,p234)*S23**(-1) * (  - 216*s13**2*s24 - 184*
     +    s13**2*s34 - 200*s13*s14*s24 - 176*s13*s14*s34 - 16*s13*
     +    s24**2 - 256*s13*s24*s34 - 196*s13*s34**2 - 64*s14**2*s24 - 
     +    48*s14**2*s34 - 72*s14*s24**2 - 372*s14*s24*s34 - 264*s14*
     +    s34**2 - 256*s24**2*s34 - 556*s24*s34**2 - 428*s34**3 )

      LB = LB + Lc1(p1,p234)*S24**(-1) * (  - 64*s13**2*s23 - 48*s13**2
     +    *s34 - 200*s13*s14*s23 - 176*s13*s14*s34 - 48*s13*s23**2 - 
     +    332*s13*s23*s34 - 248*s13*s34**2 - 216*s14**2*s23 - 184*
     +    s14**2*s34 - 240*s14*s23*s34 - 196*s14*s34**2 - 232*s23**2*
     +    s34 - 516*s23*s34**2 - 412*s34**3 )

      LB = LB + Lc1(p1,p234) * (  - 296*s13**2 - 416*s13*s14 - 552*s13*
     +    s23 - 520*s13*s24 - 1004*s13*s34 - 296*s14**2 - 528*s14*s23
     +     - 600*s14*s24 - 1044*s14*s34 + 84*s23**2 + 168*s23*s24 - 540
     +    *s23*s34 + 84*s24**2 - 564*s24*s34 - 1008*s34**2 )

      LB = LB + Lc1(p2,p13)*S13**(-1)*S23**(-1)*S24**(-1) * ( 8*s12**3*
     +    s14**2 + 16*s12**3*s14*s34 + 8*s12**3*s34**2 - 8*s12**2*
     +    s14**2*s34 - 16*s12**2*s14*s34**2 - 8*s12**2*s34**3 )

      LB = LB + Lc1(p2,p13)*S13**(-1)*S23**(-1) * (  - 8*s12**3*s14 - 8
     +    *s12**3*s34 - 8*s12**2*s14**2 + 8*s12**2*s14*s24 - 8*s12**2*
     +    s14*s34 + 8*s12**2*s24*s34 )

      LB = LB + Lc1(p2,p13)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*s12**4
     +    *s13 + 16*s12**4*s34 + 28*s12**3*s13**2 - 24*s12**3*s13*s34
     +     - 28*s12**3*s34**2 + 12*s12**2*s13**2*s34 + 12*s12**2*s13*
     +    s34**2 + 16*s12**2*s34**3 )

      LB = LB + Lc1(p2,p13)*S14**(-1)*S23**(-1) * (  - 8*s12**4 - 72*
     +    s12**3*s13 + 8*s12**3*s24 - 24*s12**3*s34 - 44*s12**2*s13**2
     +     + 56*s12**2*s13*s24 + 28*s12**2*s13*s34 + 8*s12**2*s24*s34
     +     + 24*s12**2*s34**2 + 64*s12*s13**3 + 24*s12*s13**2*s24 - 72*
     +    s12*s13**2*s34 - 16*s12*s13*s24**2 - 8*s12*s13*s34**2 + 8*s12
     +    *s24**2*s34 + 16*s12*s24*s34**2 + 8*s12*s34**3 - 8*s13**2*
     +    s24**2 - 8*s13**2*s24*s34 - 8*s13*s24**3 - 16*s13*s24**2*s34
     +     - 8*s13*s24*s34**2 )

      LB = LB + Lc1(p2,p13)*S14**(-1) * (  - 8*s13*s24**2 )

      LB = LB + Lc1(p2,p13)*S23**(-1)*S24**(-1) * ( 16*s12**4 + 48*
     +    s12**3*s13 + 28*s12**3*s14 - 28*s12**2*s13**2 - 44*s12**2*s13
     +    *s14 - 48*s12**2*s13*s34 - 16*s12**2*s14**2 - 56*s12**2*s14*
     +    s34 - 24*s12**2*s34**2 )

      LB = LB + Lc1(p2,p13)*S23**(-1) * (  - 16*s12**3 + 28*s12**2*s13
     +     + 16*s12**2*s24 + 8*s12**2*s34 + 96*s12*s13**2 + 32*s12*s13*
     +    s14 - 24*s12*s13*s24 + 16*s12*s13*s34 - 16*s12*s24**2 - 8*s12
     +    *s24*s34 + 8*s12*s34**2 - 8*s13*s24**2 - 8*s13*s24*s34 )

      LB = LB + Lc1(p2,p14)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*s12**4
     +    *s14 + 16*s12**4*s34 + 28*s12**3*s14**2 - 24*s12**3*s14*s34
     +     - 28*s12**3*s34**2 + 12*s12**2*s14**2*s34 + 12*s12**2*s14*
     +    s34**2 + 16*s12**2*s34**3 )

      LB = LB + Lc1(p2,p14)*S13**(-1)*S24**(-1) * (  - 8*s12**4 - 72*
     +    s12**3*s14 + 8*s12**3*s23 - 24*s12**3*s34 - 44*s12**2*s14**2
     +     + 56*s12**2*s14*s23 + 28*s12**2*s14*s34 + 8*s12**2*s23*s34
     +     + 24*s12**2*s34**2 + 64*s12*s14**3 + 24*s12*s14**2*s23 - 72*
     +    s12*s14**2*s34 - 16*s12*s14*s23**2 - 8*s12*s14*s34**2 + 8*s12
     +    *s23**2*s34 + 16*s12*s23*s34**2 + 8*s12*s34**3 - 8*s14**2*
     +    s23**2 - 8*s14**2*s23*s34 - 8*s14*s23**3 - 16*s14*s23**2*s34
     +     - 8*s14*s23*s34**2 )

      LB = LB + Lc1(p2,p14)*S13**(-1) * (  - 8*s14*s23**2 )

      LB = LB + Lc1(p2,p14)*S14**(-1)*S23**(-1)*S24**(-1) * ( 8*s12**3*
     +    s13**2 + 16*s12**3*s13*s34 + 8*s12**3*s34**2 - 8*s12**2*
     +    s13**2*s34 - 16*s12**2*s13*s34**2 - 8*s12**2*s34**3 )

      LB = LB + Lc1(p2,p14)*S14**(-1)*S24**(-1) * (  - 8*s12**3*s13 - 8
     +    *s12**3*s34 - 8*s12**2*s13**2 + 8*s12**2*s13*s23 - 8*s12**2*
     +    s13*s34 + 8*s12**2*s23*s34 )

      LB = LB + Lc1(p2,p14)*S23**(-1)*S24**(-1) * ( 16*s12**4 + 28*
     +    s12**3*s13 + 48*s12**3*s14 - 16*s12**2*s13**2 - 44*s12**2*s13
     +    *s14 - 56*s12**2*s13*s34 - 28*s12**2*s14**2 - 48*s12**2*s14*
     +    s34 - 24*s12**2*s34**2 )

      LB = LB + Lc1(p2,p14)*S24**(-1) * (  - 16*s12**3 + 28*s12**2*s14
     +     + 16*s12**2*s23 + 8*s12**2*s34 + 32*s12*s13*s14 + 96*s12*
     +    s14**2 - 24*s12*s14*s23 + 16*s12*s14*s34 - 16*s12*s23**2 - 8*
     +    s12*s23*s34 + 8*s12*s34**2 - 8*s14*s23**2 - 8*s14*s23*s34 )

      LB = LB + Lc1(p2,p34)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*s12**3
     +    *s34**2 + 8*s12**2*s14*s34**2 + 8*s12**2*s34**3 )

      LB = LB + Lc1(p2,p34)*S13**(-1)*S23**(-1) * ( 16*s12**2*s14*s34
     +     + 16*s12**2*s34**2 + 16*s12*s14**2*s34 + 16*s12*s14*s34**2
     +     - 8*s14**2*s24*s34 )

      LB = LB + Lc1(p2,p34)*S13**(-1)*S24**(-1) * ( 32*s12**2*s34**2 + 
     +    8*s12*s14**2*s34 - 16*s12*s14*s23*s34 + 24*s12*s14*s34**2 + 8
     +    *s12*s23*s34**2 + 16*s12*s34**3 - 16*s14**2*s23*s34 - 16*s14*
     +    s23**2*s34 - 24*s14*s23*s34**2 - 8*s23**2*s34**2 - 8*s23*
     +    s34**3 )

      LB = LB + Lc1(p2,p34)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*s12**3
     +    *s34**2 + 8*s12**2*s13*s34**2 + 8*s12**2*s34**3 )

      LB = LB + Lc1(p2,p34)*S14**(-1)*S23**(-1) * (  - 16*s12**2*s13*
     +    s34 - 16*s12**2*s34**2 - 16*s12*s13**2*s34 - 16*s12*s13*
     +    s34**2 - 8*s13**2*s24*s34 )

      LB = LB + Lc1(p2,p34)*S14**(-1)*S24**(-1) * (  - 32*s12**2*s34**2
     +     - 8*s12*s13**2*s34 - 16*s12*s13*s23*s34 - 24*s12*s13*s34**2
     +     + 8*s12*s23*s34**2 - 16*s12*s34**3 - 16*s13**2*s23*s34 + 16*
     +    s13*s23**2*s34 + 8*s13*s23*s34**2 + 8*s23**2*s34**2 + 24*s23*
     +    s34**3 )

      LB = LB + Lc1(p2,p34)*S23**(-1)*S24**(-1) * ( 16*s12**2*s34**2 )

      LB = LB + Lc1(p2,p34)*S23**(-1) * (  - 16*s12*s13*s34 + 16*s12*
     +    s14*s34 - 64*s12*s24*s34 )

      LB = LB + Lc1(p2,p34)*S24**(-1) * ( 32*s12*s13*s23 - 8*s12*s13*
     +    s34 + 32*s12*s14*s23 + 8*s12*s14*s34 + 96*s12*s23*s34 + 16*
     +    s13**2*s23 + 32*s13*s14*s23 + 32*s13*s23*s34 + 16*s14**2*s23
     +     + 32*s14*s23*s34 + 48*s23*s34**2 )

      LB = LB + Lc1(p2,p134)*S13**(-1)*S14**(-1)*S23**(-1) * ( 40*
     +    s24**3*s34**2 - 44*s24**2*s34**3 - 56*s24*s34**4 )

      LB = LB + Lc1(p2,p134)*S13**(-1)*S14**(-1)*S24**(-1) * ( 40*
     +    s23**3*s34**2 - 44*s23**2*s34**3 - 56*s23*s34**4 )

      LB = LB + Lc1(p2,p134)*S13**(-1)*S14**(-1) * ( 128*s23**2*s34**2
     +     + 176*s23*s24*s34**2 - 44*s23*s34**3 + 128*s24**2*s34**2 - 
     +    44*s24*s34**3 - 112*s34**4 )

      LB = LB + Lc1(p2,p134)*S13**(-1)*S23**(-1) * (  - 56*s14**3*s24
     +     - 20*s14**2*s24**2 - 244*s14**2*s24*s34 - 24*s14*s24**3 - 
     +    100*s14*s24**2*s34 - 376*s14*s24*s34**2 + 8*s24**3*s34 - 124*
     +    s24**2*s34**2 - 252*s24*s34**3 )

      LB = LB + Lc1(p2,p134)*S13**(-1)*S24**(-1) * ( 48*s14**3*s23 + 44
     +    *s14**2*s23**2 - 84*s14**2*s23*s34 - 104*s14*s23**3 + 88*s14*
     +    s23**2*s34 - 240*s14*s23*s34**2 - 64*s23**3*s34 + 8*s23**2*
     +    s34**2 - 172*s23*s34**3 )

      LB = LB + Lc1(p2,p134)*S13**(-1) * (  - 16*s14**2*s23 - 96*s14**2
     +    *s24 - 256*s14**2*s34 - 288*s14*s23**2 - 296*s14*s23*s24 - 
     +    112*s14*s23*s34 - 136*s14*s24**2 - 324*s14*s24*s34 - 580*s14*
     +    s34**2 - 160*s23**2*s34 - 128*s23*s24*s34 - 124*s23*s34**2 - 
     +    24*s24**2*s34 - 264*s24*s34**2 - 452*s34**3 )

      LB = LB + Lc1(p2,p134)*S14**(-1)*S23**(-1) * ( 48*s13**3*s24 + 36
     +    *s13**2*s24**2 - 92*s13**2*s24*s34 - 104*s13*s24**3 + 64*s13*
     +    s24**2*s34 - 264*s13*s24*s34**2 - 64*s24**3*s34 - 8*s24**2*
     +    s34**2 - 188*s24*s34**3 )

      LB = LB + Lc1(p2,p134)*S14**(-1)*S24**(-1) * (  - 56*s13**3*s23
     +     - 20*s13**2*s23**2 - 244*s13**2*s23*s34 - 24*s13*s23**3 - 
     +    100*s13*s23**2*s34 - 376*s13*s23*s34**2 + 8*s23**3*s34 - 124*
     +    s23**2*s34**2 - 252*s23*s34**3 )

      LB = LB + Lc1(p2,p134)*S14**(-1) * (  - 72*s13**2*s23 - 232*
     +    s13**2*s34 - 136*s13*s23**2 - 296*s13*s23*s24 - 284*s13*s23*
     +    s34 - 288*s13*s24**2 - 96*s13*s24*s34 - 540*s13*s34**2 - 24*
     +    s23**2*s34 - 128*s23*s24*s34 - 248*s23*s34**2 - 160*s24**2*
     +    s34 - 124*s24*s34**2 - 436*s34**3 )

      LB = LB + Lc1(p2,p134)*S23**(-1) * ( 108*s13**2*s24 + 52*s13*s14*
     +    s24 - 124*s13*s24**2 - 296*s13*s24*s34 - 64*s14**2*s24 - 180*
     +    s14*s24**2 - 412*s14*s24*s34 - 136*s24**3 - 204*s24**2*s34 - 
     +    544*s24*s34**2 )

      LB = LB + Lc1(p2,p134)*S24**(-1) * (  - 64*s13**2*s23 + 52*s13*
     +    s14*s23 - 156*s13*s23**2 - 388*s13*s23*s34 + 108*s14**2*s23
     +     - 92*s14*s23**2 - 264*s14*s23*s34 - 136*s23**3 - 164*s23**2*
     +    s34 - 504*s23*s34**2 )

      LB = LB + Lc1(p2,p134) * ( 68*s13**2 + 136*s13*s14 - 576*s13*s23
     +     - 528*s13*s24 - 556*s13*s34 + 68*s14**2 - 520*s14*s23 - 624*
     +    s14*s24 - 580*s14*s34 - 440*s23**2 - 608*s23*s24 - 788*s23*
     +    s34 - 440*s24**2 - 828*s24*s34 - 1056*s34**2 )

      LB = LB + Lc1(p3,p12)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 48*
     +    s12**4*s34 - 144*s12**3*s23**2 - 224*s12**3*s23*s34 - 48*
     +    s12**3*s34**2 + 32*s12**2*s23**3 + 96*s12**2*s23**2*s34 - 32*
     +    s12*s23**3*s34 )

      LB = LB + Lc1(p3,p12)*S13**(-1)*S14**(-1) * (  - 96*s12**3*s23 - 
     +    64*s12**3*s34 - 112*s12**2*s23**2 - 32*s12**2*s23*s24 - 16*
     +    s12**2*s23*s34 - 16*s12**2*s24*s34 - 32*s12**2*s34**2 - 16*
     +    s12*s23**3 - 48*s12*s23**2*s24 - 16*s12*s23**2*s34 + 16*s12*
     +    s23*s24*s34 + 32*s12*s23*s34**2 - 16*s12*s24**2*s34 - 16*s12*
     +    s24*s34**2 - 16*s23**3*s34 - 16*s23**2*s24*s34 - 16*s23**2*
     +    s34**2 )

      LB = LB + Lc1(p3,p12)*S13**(-1)*S23**(-1)*S24**(-1) * ( 48*s12**4
     +    *s34 - 32*s12**3*s14*s34 + 32*s12**3*s34**2 )

      LB = LB + Lc1(p3,p12)*S13**(-1)*S23**(-1) * ( 16*s12**3*s34 )

      LB = LB + Lc1(p3,p12)*S13**(-1)*S24**(-1) * (  - 96*s12**3*s14 + 
     +    240*s12**3*s23 + 352*s12**3*s34 - 32*s12**2*s14*s23 - 64*
     +    s12**2*s14*s34 + 48*s12**2*s23**2 + 80*s12**2*s23*s34 + 96*
     +    s12**2*s34**2 - 16*s12*s14**2*s23 + 48*s12*s14*s23**2 - 48*
     +    s12*s14*s23*s34 - 16*s12*s23**3 + 80*s12*s23**2*s34 - 32*s12*
     +    s23*s34**2 + 16*s14*s23**2*s34 - 16*s23**3*s34 + 16*s23**2*
     +    s34**2 )

      LB = LB + Lc1(p3,p12)*S13**(-1) * ( 96*s12**3 + 208*s12**2*s23 + 
     +    32*s12**2*s24 + 96*s12**2*s34 + 48*s12*s14*s23 - 16*s12*s14*
     +    s34 + 64*s12*s23*s24 + 64*s12*s23*s34 - 16*s12*s34**2 )

      LB = LB + Lc1(p3,p12)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 48*
     +    s12**3*s13**2 + 16*s12**2*s13**3 - 32*s12**2*s13**2*s34 )

      LB = LB + Lc1(p3,p12)*S14**(-1)*S23**(-1) * (  - 32*s12**2*s13**2
     +     - 96*s12**2*s13*s24 - 96*s12**2*s13*s34 - 16*s12**2*s34**2
     +     + 64*s12*s13**3 - 16*s12*s13**2*s24 - 32*s12*s13**2*s34 - 32
     +    *s12*s13*s24**2 - 48*s12*s13*s24*s34 - 32*s12*s13*s34**2 - 16
     +    *s12*s24**2*s34 - 16*s12*s24*s34**2 + 16*s13**3*s34 + 16*
     +    s13**2*s24**2 - 16*s13**2*s24*s34 - 16*s13**2*s34**2 )

      LB = LB + Lc1(p3,p12)*S23**(-1)*S24**(-1) * ( 48*s12**3*s13 + 96*
     +    s12**3*s14 - 32*s12**2*s13**2 - 96*s12**2*s13*s14 + 192*
     +    s12**2*s13*s34 + 48*s12**2*s14*s34 + 16*s12**2*s34**2 + 64*
     +    s12*s13**3 + 16*s12*s13**2*s14 + 96*s12*s13**2*s34 - 16*s12*
     +    s13*s14**2 + 16*s12*s13*s14*s34 + 32*s12*s13*s34**2 + 16*
     +    s13**3*s34 - 16*s13**2*s14**2 + 16*s13**2*s14*s34 + 16*s13**2
     +    *s34**2 )

      LB = LB + Lc1(p3,p12)*S23**(-1) * ( 32*s12**2*s14 - 16*s12*s13*
     +    s14 - 32*s12*s13*s24 - 16*s12*s14*s34 - 16*s12*s34**2 - 16*
     +    s13**2*s14 + 16*s13**2*s24 )

      LB = LB + Lc1(p3,p12)*SF*S13**(-1)*S14**(-1)*S24**(-1) * ( 96*
     +    s12**2*s23**2 )

      LB = LB + Lc1(p3,p12)*SF*S13**(-1)*S14**(-1) * ( 96*s12**2*s23 + 
     +    32*s12*s23**2 + 32*s12*s23*s24 )

      LB = LB + Lc1(p3,p12)*SF*S13**(-1)*S24**(-1) * (  - 96*s12**2*s23
     +     - 32*s12*s14*s23 + 32*s12*s23**2 )

      LB = LB + Lc1(p3,p12)*SF*S13**(-1) * (  - 96*s12**2 - 32*s12*s14
     +     - 32*s12*s24 )

      LB = LB + Lc1(p3,p12)*SF*S14**(-1)*S23**(-1)*S24**(-1) * ( 192*
     +    s12**2*s13**2 )

      LB = LB + Lc1(p3,p12)*SF*S14**(-1)*S23**(-1) * (  - 192*s12**2*
     +    s13 + 64*s12*s13**2 - 64*s12*s13*s24 )

      LB = LB + Lc1(p3,p12)*SF*S23**(-1)*S24**(-1) * ( 192*s12**2*s13
     +     + 64*s12*s13**2 + 64*s12*s13*s14 )

      LB = LB + Lc1(p3,p12)*SF*S23**(-1) * (  - 192*s12**2 - 64*s12*s14
     +     - 64*s12*s24 )

      LB = LB + Lc1(p3,p14)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 4*
     +    s12**2*s24*s34**2 - 4*s12**2*s34**3 - 8*s12*s24**2*s34**2 - 8
     +    *s12*s24*s34**3 - 4*s24**3*s34**2 - 4*s24**2*s34**3 )

      LB = LB + Lc1(p3,p14)*S13**(-1)*S14**(-1) * (  - 4*s12**2*s34**2
     +     + 24*s12*s23*s34**2 + 16*s12*s24*s34**2 + 24*s12*s34**3 + 24
     +    *s23**2*s34**2 + 48*s23*s24*s34**2 + 24*s23*s34**3 + 20*
     +    s24**2*s34**2 + 24*s24*s34**3 )

      LB = LB + Lc1(p3,p14)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*s12**3
     +    *s34**2 + 24*s12**2*s14**2*s34 + 12*s12**2*s14*s34**2 + 20*
     +    s12**2*s34**3 + 12*s12*s14**2*s34**2 + 24*s12*s14*s34**3 )

      LB = LB + Lc1(p3,p14)*S13**(-1)*S23**(-1) * ( 4*s12**3*s34 - 8*
     +    s12**2*s14*s34 + 8*s12**2*s24*s34 + 36*s12**2*s34**2 - 32*s12
     +    *s14**2*s34 + 24*s12*s14*s24*s34 + 12*s12*s14*s34**2 + 8*s12*
     +    s24**2*s34 + 40*s12*s24*s34**2 + 28*s12*s34**3 + 36*s14**2*
     +    s24*s34 - 36*s14**2*s34**2 + 16*s14*s24**2*s34 + 20*s14*s24*
     +    s34**2 + 24*s14*s34**3 + 12*s24**3*s34 + 20*s24**2*s34**2 + 8
     +    *s24*s34**3 )

      LB = LB + Lc1(p3,p14)*S13**(-1)*S24**(-1) * ( 4*s12**3*s34 + 32*
     +    s12**2*s14**2 + 4*s12**2*s14*s23 - 28*s12**2*s14*s34 + 20*
     +    s12**2*s23*s34 + 24*s12**2*s34**2 + 24*s12*s14**3 - 68*s12*
     +    s14**2*s23 - 80*s12*s14**2*s34 - 32*s12*s14*s23**2 + 8*s12*
     +    s14*s23*s34 + 32*s12*s14*s34**2 + 16*s12*s23**2*s34 + 32*s12*
     +    s23*s34**2 + 8*s12*s34**3 - 24*s14**3*s23 + 56*s14**3*s34 - 
     +    24*s14**2*s23**2 - 44*s14**2*s23*s34 - 64*s14**2*s34**2 - 16*
     +    s14*s23**3 - 32*s14*s23**2*s34 + 8*s14*s23*s34**2 )

      LB = LB + Lc1(p3,p14)*S13**(-1) * ( 4*s12**2*s14 + 28*s12**2*s34
     +     - 24*s12*s14**2 - 24*s12*s14*s23 + 8*s12*s14*s24 + 44*s12*
     +    s14*s34 + 20*s12*s23*s34 + 12*s12*s24*s34 + 32*s12*s34**2 - 
     +    16*s14**3 + 28*s14**2*s23 + 16*s14**2*s24 + 80*s14**2*s34 - 
     +    24*s14*s23**2 + 8*s14*s23*s24 - 76*s14*s23*s34 + 16*s14*
     +    s24**2 + 8*s14*s24*s34 - 24*s14*s34**2 - 16*s23**2*s34 - 44*
     +    s23*s24*s34 + 32*s23*s34**2 - 16*s24**2*s34 + 28*s24*s34**2
     +     + 40*s34**3 )

      LB = LB + Lc1(p3,p14)*SF*S13**(-1)*S24**(-1) * ( 16*s12*s14*s23
     +     + 8*s14*s23**2 )

      LB = LB + Lc1(p3,p14)*SF*S13**(-1) * ( 16*s12*s14 - 8*s14*s23 - 
     +    16*s14*s24 )

      LB = LB + Lc1(p3,p24)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*s12**3
     +    *s34**2 + 24*s12**2*s24**2*s34 + 12*s12**2*s24*s34**2 + 20*
     +    s12**2*s34**3 + 12*s12*s24**2*s34**2 + 24*s12*s24*s34**3 )

      LB = LB + Lc1(p3,p24)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 4*
     +    s12**2*s14*s34**2 - 4*s12**2*s34**3 - 8*s12*s14**2*s34**2 - 8
     +    *s12*s14*s34**3 - 4*s14**3*s34**2 - 4*s14**2*s34**3 )

      LB = LB + Lc1(p3,p24)*S13**(-1)*S23**(-1) * ( 4*s12**3*s34 + 8*
     +    s12**2*s14*s34 - 8*s12**2*s24*s34 + 36*s12**2*s34**2 + 8*s12*
     +    s14**2*s34 + 24*s12*s14*s24*s34 + 40*s12*s14*s34**2 - 32*s12*
     +    s24**2*s34 + 12*s12*s24*s34**2 + 28*s12*s34**3 + 12*s14**3*
     +    s34 + 16*s14**2*s24*s34 + 20*s14**2*s34**2 + 36*s14*s24**2*
     +    s34 + 20*s14*s24*s34**2 + 8*s14*s34**3 - 36*s24**2*s34**2 + 
     +    24*s24*s34**3 )

      LB = LB + Lc1(p3,p24)*S14**(-1)*S23**(-1) * ( 4*s12**3*s34 + 4*
     +    s12**2*s13*s24 + 20*s12**2*s13*s34 + 32*s12**2*s24**2 - 28*
     +    s12**2*s24*s34 + 24*s12**2*s34**2 - 16*s12*s13**2*s24 + 16*
     +    s12*s13**2*s34 - 52*s12*s13*s24**2 + 24*s12*s13*s24*s34 + 32*
     +    s12*s13*s34**2 + 24*s12*s24**3 - 80*s12*s24**2*s34 + 32*s12*
     +    s24*s34**2 + 8*s12*s34**3 - 16*s13**3*s24 - 24*s13**2*s24**2
     +     - 32*s13**2*s24*s34 - 24*s13*s24**3 - 44*s13*s24**2*s34 + 8*
     +    s13*s24*s34**2 + 56*s24**3*s34 - 64*s24**2*s34**2 )

      LB = LB + Lc1(p3,p24)*S23**(-1)*S24**(-1) * (  - 4*s12**2*s34**2
     +     + 24*s12*s13*s34**2 + 16*s12*s14*s34**2 + 24*s12*s34**3 + 24
     +    *s13**2*s34**2 + 48*s13*s14*s34**2 + 24*s13*s34**3 + 20*
     +    s14**2*s34**2 + 24*s14*s34**3 )

      LB = LB + Lc1(p3,p24)*S23**(-1) * ( 4*s12**2*s24 + 28*s12**2*s34
     +     - 8*s12*s13*s24 + 20*s12*s13*s34 + 8*s12*s14*s24 + 12*s12*
     +    s14*s34 - 24*s12*s24**2 + 44*s12*s24*s34 + 32*s12*s34**2 - 24
     +    *s13**2*s24 - 16*s13**2*s34 + 8*s13*s14*s24 - 44*s13*s14*s34
     +     + 28*s13*s24**2 - 76*s13*s24*s34 + 32*s13*s34**2 + 16*s14**2
     +    *s24 - 16*s14**2*s34 + 16*s14*s24**2 + 8*s14*s24*s34 + 28*s14
     +    *s34**2 - 16*s24**3 + 80*s24**2*s34 - 24*s24*s34**2 + 40*
     +    s34**3 )

      LB = LB + Lc1(p3,p24)*SF*S14**(-1)*S23**(-1) * (  - 16*s12*s13*
     +    s24 - 8*s13**2*s24 )

      LB = LB + Lc1(p3,p24)*SF*S23**(-1) * (  - 16*s12*s24 + 8*s13*s24
     +     + 16*s14*s24 )

      LB = LB + Lc1(p3,p124)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 56*s12**4*s34**2 + 492*s12**3*s34**3 + 240*s12**2*s34**4 )

      LB = LB + Lc1(p3,p124)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**4*s34 + 8*s12**3*s24*s34 + 236*s12**3*s34**2 - 24*s12**2
     +    *s24**2*s34 + 312*s12**2*s24*s34**2 + 364*s12**2*s34**3 + 136
     +    *s12*s24**2*s34**2 + 128*s12*s24*s34**3 + 104*s12*s34**4 + 16
     +    *s24**3*s34**2 + 48*s24**2*s34**3 + 8*s24*s34**4 )

      LB = LB + Lc1(p3,p124)*S13**(-1)*S14**(-1)*S24**(-1) * ( 48*
     +    s12**4*s34 + 144*s12**3*s23**2 + 752*s12**3*s23*s34 + 1184*
     +    s12**3*s34**2 + 16*s12**2*s23**3 + 176*s12**2*s23**2*s34 + 
     +    544*s12**2*s23*s34**2 + 640*s12**2*s34**3 )

      LB = LB + Lc1(p3,p124)*S13**(-1)*S14**(-1) * ( 96*s12**3*s23 + 
     +    256*s12**3*s34 + 400*s12**2*s23**2 + 224*s12**2*s23*s24 + 
     +    1296*s12**2*s23*s34 + 416*s12**2*s24*s34 + 1472*s12**2*s34**2
     +     + 32*s12*s23**3 + 336*s12*s23**2*s24 + 208*s12*s23**2*s34 + 
     +    160*s12*s23*s24**2 + 880*s12*s23*s24*s34 + 464*s12*s23*s34**2
     +     + 256*s12*s24**2*s34 + 816*s12*s24*s34**2 + 432*s12*s34**3
     +     + 16*s23**3*s24 + 80*s23**2*s24**2 + 80*s23**2*s24*s34 + 32*
     +    s23*s24**3 + 192*s23*s24**2*s34 + 144*s23*s24*s34**2 + 48*
     +    s24**3*s34 + 160*s24**2*s34**2 + 112*s24*s34**3 )

      LB = LB + Lc1(p3,p124)*S13**(-1)*S23**(-1)*S24**(-1) * ( 240*
     +    s12**3*s14*s34 - 660*s12**3*s34**2 + 120*s12**2*s14**2*s34 + 
     +    136*s12**2*s14*s34**2 - 628*s12**2*s34**3 + 56*s12*s14**3*s34
     +     + 100*s12*s14**2*s34**2 + 92*s12*s14*s34**3 - 88*s12*s34**4
     +     - 16*s14**4*s34 + 88*s14**3*s34**2 + 12*s14**2*s34**3 - 8*
     +    s14*s34**4 )

      LB = LB + Lc1(p3,p124)*S13**(-1)*S23**(-1) * (  - 52*s12**3*s34
     +     - 204*s12**2*s14*s34 - 240*s12**2*s24*s34 - 352*s12**2*
     +    s34**2 - 248*s12*s14**2*s34 - 472*s12*s14*s24*s34 - 184*s12*
     +    s14*s34**2 - 84*s12*s24**2*s34 - 48*s12*s24*s34**2 + 16*s12*
     +    s34**3 - 112*s14**3*s34 - 192*s14**2*s24*s34 + 116*s14**2*
     +    s34**2 - 140*s14*s24**2*s34 + 32*s14*s24*s34**2 - 4*s14*
     +    s34**3 - 16*s24**3*s34 + 56*s24**2*s34**2 + 24*s24*s34**3 )

      LB = LB + Lc1(p3,p124)*S13**(-1)*S24**(-1) * ( 96*s12**3*s14 - 
     +    240*s12**3*s23 - 928*s12**3*s34 - 208*s12**2*s14*s23 - 176*
     +    s12**2*s14*s34 + 192*s12**2*s23**2 - 224*s12**2*s23*s34 - 
     +    1024*s12**2*s34**2 - 208*s12*s14**2*s23 - 224*s12*s14**2*s34
     +     + 176*s12*s14*s23**2 + 112*s12*s14*s23*s34 - 48*s12*s14*
     +    s34**2 + 32*s12*s23**3 + 112*s12*s23**2*s34 + 64*s12*s23*
     +    s34**2 - 80*s12*s34**3 - 48*s14**3*s23 - 48*s14**3*s34 + 32*
     +    s14**2*s23**2 - 32*s14**2*s34**2 + 16*s14*s23**3 + 48*s14*
     +    s23**2*s34 + 48*s14*s23*s34**2 + 16*s14*s34**3 )

      LB = LB + Lc1(p3,p124)*S13**(-1) * (  - 96*s12**3 - 192*s12**2*
     +    s14 - 208*s12**2*s23 - 176*s12**2*s24 - 736*s12**2*s34 - 256*
     +    s12*s14**2 - 272*s12*s14*s23 - 352*s12*s14*s24 - 608*s12*s14*
     +    s34 + 512*s12*s23**2 + 96*s12*s23*s24 + 848*s12*s23*s34 - 96*
     +    s12*s24**2 - 32*s12*s24*s34 + 480*s12*s34**2 - 64*s14**3 - 96
     +    *s14**2*s23 - 144*s14**2*s24 - 160*s14**2*s34 + 144*s14*
     +    s23**2 - 16*s14*s23*s24 + 192*s14*s23*s34 - 96*s14*s24**2 - 
     +    96*s14*s24*s34 + 96*s14*s34**2 + 32*s23**3 + 192*s23**2*s24
     +     + 128*s23**2*s34 + 64*s23*s24**2 + 384*s23*s24*s34 + 192*s23
     +    *s34**2 - 16*s24**3 + 64*s24**2*s34 + 288*s24*s34**2 + 128*
     +    s34**3 )

      LB = LB + Lc1(p3,p124)*S14**(-1)*S23**(-1)*S24**(-1) * ( 40*
     +    s12**4*s13 + 40*s12**4*s34 - 168*s12**3*s13**2 - 376*s12**3*
     +    s13*s34 - 220*s12**3*s34**2 + 160*s12**2*s13**3 + 368*s12**2*
     +    s13**2*s34 + 240*s12**2*s13*s34**2 + 40*s12**2*s34**3 )

      LB = LB + Lc1(p3,p124)*S14**(-1)*S23**(-1) * (  - 8*s12**4 + 192*
     +    s12**3*s13 - 80*s12**3*s24 + 228*s12**3*s34 - 240*s12**2*
     +    s13**2 + 60*s12**2*s13*s24 - 628*s12**2*s13*s34 - 96*s12**2*
     +    s24**2 + 188*s12**2*s24*s34 - 488*s12**2*s34**2 + 248*s12*
     +    s13**3 - 100*s12*s13**2*s24 + 584*s12*s13**2*s34 - 184*s12*
     +    s13*s24**2 - 212*s12*s13*s24*s34 + 288*s12*s13*s34**2 - 24*
     +    s12*s24**3 - 88*s12*s24**2*s34 - 296*s12*s24*s34**2 + 8*s12*
     +    s34**3 + 64*s13**3*s24 + 184*s13**2*s24*s34 - 24*s13*s24**3
     +     + 16*s13*s24**2*s34 + 8*s13*s24*s34**2 - 80*s24**3*s34 + 16*
     +    s24**2*s34**2 - 48*s24*s34**3 )

      LB = LB + Lc1(p3,p124)*S23**(-1)*S24**(-1) * ( 32*s12**4 - 84*
     +    s12**3*s13 + 8*s12**3*s14 + 92*s12**3*s34 - 32*s12**2*s13**2
     +     - 28*s12**2*s13*s14 - 244*s12**2*s13*s34 + 140*s12**2*s14*
     +    s34 + 136*s12**2*s34**2 + 248*s12*s13**3 + 404*s12*s13**2*s14
     +     + 504*s12*s13**2*s34 + 156*s12*s13*s14**2 + 604*s12*s13*s14*
     +    s34 + 328*s12*s13*s34**2 - 24*s12*s14**3 + 408*s12*s14**2*s34
     +     + 460*s12*s14*s34**2 + 48*s12*s34**3 + 112*s13**3*s14 + 208*
     +    s13**2*s14**2 + 56*s13**2*s14*s34 + 48*s13*s14**3 + 284*s13*
     +    s14**2*s34 + 32*s13*s14*s34**2 - 48*s14**4 + 256*s14**3*s34
     +     + 56*s14**2*s34**2 + 8*s14*s34**3 )

      LB = LB + Lc1(p3,p124)*S23**(-1) * ( 48*s12**3 - 272*s12**2*s13
     +     - 148*s12**2*s14 - 164*s12**2*s24 - 112*s12**2*s34 + 304*s12
     +    *s13**2 - 384*s12*s13*s14 - 696*s12*s13*s24 + 196*s12*s13*s34
     +     - 364*s12*s14**2 - 424*s12*s14*s24 - 204*s12*s14*s34 - 124*
     +    s12*s24**2 - 452*s12*s24*s34 + 116*s12*s34**2 + 176*s13**3 + 
     +    428*s13**2*s14 + 132*s13**2*s24 + 208*s13**2*s34 - 12*s13*
     +    s14**2 - 212*s13*s14*s24 + 508*s13*s14*s34 - 160*s13*s24**2
     +     + 108*s13*s24*s34 + 48*s13*s34**2 - 152*s14**3 - 172*s14**2*
     +    s24 + 208*s14**2*s34 - 132*s14*s24**2 - 200*s14*s24*s34 + 84*
     +    s14*s34**2 - 8*s24**3 - 216*s24**2*s34 - 32*s24*s34**2 - 16*
     +    s34**3 )

      LB = LB + Lc1(p3,p124)*SF*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 192*s12**2*s34**3 )

      LB = LB + Lc1(p3,p124)*SF*S13**(-1)*S14**(-1)*S23**(-1) * ( 192*
     +    s12**2*s34**2 + 256*s12*s24*s34**2 - 256*s12*s34**3 + 64*
     +    s24**2*s34**2 - 64*s24*s34**3 )

      LB = LB + Lc1(p3,p124)*SF*S13**(-1)*S14**(-1)*S24**(-1) * (  - 96
     +    *s12**2*s23**2 )

      LB = LB + Lc1(p3,p124)*SF*S13**(-1)*S14**(-1) * (  - 96*s12**2*
     +    s23 - 128*s12*s23**2 - 128*s12*s23*s24 - 32*s23**2*s24 - 32*
     +    s23*s24**2 )

      LB = LB + Lc1(p3,p124)*SF*S13**(-1)*S23**(-1)*S24**(-1) * (  - 
     +    192*s12**2*s34**2 - 256*s12*s14*s34**2 - 256*s12*s34**3 - 64*
     +    s14**2*s34**2 - 64*s14*s34**3 )

      LB = LB + Lc1(p3,p124)*SF*S13**(-1)*S23**(-1) * ( 192*s12**2*s34
     +     + 256*s12*s14*s34 + 256*s12*s24*s34 + 64*s14**2*s34 + 128*
     +    s14*s24*s34 - 64*s14*s34**2 + 64*s24**2*s34 + 64*s24*s34**2
     +     - 128*s34**3 )

      LB = LB + Lc1(p3,p124)*SF*S13**(-1)*S24**(-1) * ( 96*s12**2*s23
     +     + 128*s12*s14*s23 - 128*s12*s23**2 + 32*s14**2*s23 - 32*s14*
     +    s23**2 )

      LB = LB + Lc1(p3,p124)*SF*S13**(-1) * ( 96*s12**2 + 128*s12*s14
     +     + 128*s12*s24 + 32*s14**2 + 32*s14*s23 + 64*s14*s24 - 64*
     +    s23**2 - 32*s23*s24 + 32*s24**2 )

      LB = LB + Lc1(p3,p124)*SF*S14**(-1)*S23**(-1)*S24**(-1) * (  - 
     +    192*s12**2*s13**2 - 576*s12**2*s13*s34 - 576*s12**2*s34**2 )

      LB = LB + Lc1(p3,p124)*SF*S14**(-1)*S23**(-1) * ( 192*s12**2*s13
     +     + 384*s12**2*s34 - 256*s12*s13**2 + 256*s12*s13*s24 - 768*
     +    s12*s13*s34 + 512*s12*s24*s34 - 768*s12*s34**2 - 64*s13**2*
     +    s24 + 64*s13*s24**2 - 192*s13*s24*s34 + 128*s24**2*s34 - 192*
     +    s24*s34**2 )

      LB = LB + Lc1(p3,p124)*SF*S23**(-1)*S24**(-1) * (  - 192*s12**2*
     +    s13 - 384*s12**2*s34 - 256*s12*s13**2 - 256*s12*s13*s14 - 768
     +    *s12*s13*s34 - 512*s12*s14*s34 - 768*s12*s34**2 - 64*s13**2*
     +    s14 - 64*s13*s14**2 - 192*s13*s14*s34 - 128*s14**2*s34 - 192*
     +    s14*s34**2 )

      LB = LB + Lc1(p3,p124)*SF*S23**(-1) * ( 192*s12**2 + 256*s12*s14
     +     + 256*s12*s24 - 128*s13**2 - 64*s13*s14 + 64*s13*s24 - 384*
     +    s13*s34 + 64*s14**2 + 128*s14*s24 - 128*s14*s34 + 64*s24**2
     +     + 128*s24*s34 - 384*s34**2 )

      LB = LB + Lc1(p4,p12)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 48*
     +    s12**4*s34 - 144*s12**3*s24**2 - 224*s12**3*s24*s34 - 48*
     +    s12**3*s34**2 + 32*s12**2*s24**3 + 96*s12**2*s24**2*s34 - 32*
     +    s12*s24**3*s34 )

      LB = LB + Lc1(p4,p12)*S13**(-1)*S14**(-1) * (  - 96*s12**3*s24 - 
     +    64*s12**3*s34 - 32*s12**2*s23*s24 - 16*s12**2*s23*s34 - 112*
     +    s12**2*s24**2 - 16*s12**2*s24*s34 - 32*s12**2*s34**2 - 16*s12
     +    *s23**2*s34 - 48*s12*s23*s24**2 + 16*s12*s23*s24*s34 - 16*s12
     +    *s23*s34**2 - 16*s12*s24**3 - 16*s12*s24**2*s34 + 32*s12*s24*
     +    s34**2 - 16*s23*s24**2*s34 - 16*s24**3*s34 - 16*s24**2*s34**2
     +     )

      LB = LB + Lc1(p4,p12)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 48*
     +    s12**3*s14**2 + 16*s12**2*s14**3 - 32*s12**2*s14**2*s34 )

      LB = LB + Lc1(p4,p12)*S13**(-1)*S24**(-1) * (  - 32*s12**2*s14**2
     +     - 96*s12**2*s14*s23 - 96*s12**2*s14*s34 - 16*s12**2*s34**2
     +     + 64*s12*s14**3 - 16*s12*s14**2*s23 - 32*s12*s14**2*s34 - 32
     +    *s12*s14*s23**2 - 48*s12*s14*s23*s34 - 32*s12*s14*s34**2 - 16
     +    *s12*s23**2*s34 - 16*s12*s23*s34**2 + 16*s14**3*s34 + 16*
     +    s14**2*s23**2 - 16*s14**2*s23*s34 - 16*s14**2*s34**2 )

      LB = LB + Lc1(p4,p12)*S14**(-1)*S23**(-1)*S24**(-1) * ( 48*s12**4
     +    *s34 - 32*s12**3*s13*s34 + 32*s12**3*s34**2 )

      LB = LB + Lc1(p4,p12)*S14**(-1)*S23**(-1) * (  - 96*s12**3*s13 + 
     +    240*s12**3*s24 + 352*s12**3*s34 - 32*s12**2*s13*s24 - 64*
     +    s12**2*s13*s34 + 48*s12**2*s24**2 + 80*s12**2*s24*s34 + 96*
     +    s12**2*s34**2 - 16*s12*s13**2*s24 + 48*s12*s13*s24**2 - 48*
     +    s12*s13*s24*s34 - 16*s12*s24**3 + 80*s12*s24**2*s34 - 32*s12*
     +    s24*s34**2 + 16*s13*s24**2*s34 - 16*s24**3*s34 + 16*s24**2*
     +    s34**2 )

      LB = LB + Lc1(p4,p12)*S14**(-1)*S24**(-1) * ( 16*s12**3*s34 )

      LB = LB + Lc1(p4,p12)*S14**(-1) * ( 96*s12**3 + 32*s12**2*s23 + 
     +    208*s12**2*s24 + 96*s12**2*s34 + 48*s12*s13*s24 - 16*s12*s13*
     +    s34 + 64*s12*s23*s24 + 64*s12*s24*s34 - 16*s12*s34**2 )

      LB = LB + Lc1(p4,p12)*S23**(-1)*S24**(-1) * ( 96*s12**3*s13 + 48*
     +    s12**3*s14 - 96*s12**2*s13*s14 + 48*s12**2*s13*s34 - 32*
     +    s12**2*s14**2 + 192*s12**2*s14*s34 + 16*s12**2*s34**2 - 16*
     +    s12*s13**2*s14 + 16*s12*s13*s14**2 + 16*s12*s13*s14*s34 + 64*
     +    s12*s14**3 + 96*s12*s14**2*s34 + 32*s12*s14*s34**2 - 16*
     +    s13**2*s14**2 + 16*s13*s14**2*s34 + 16*s14**3*s34 + 16*s14**2
     +    *s34**2 )

      LB = LB + Lc1(p4,p12)*S24**(-1) * ( 32*s12**2*s13 - 16*s12*s13*
     +    s14 - 16*s12*s13*s34 - 32*s12*s14*s23 - 16*s12*s34**2 - 16*
     +    s13*s14**2 + 16*s14**2*s23 )

      LB = LB + Lc1(p4,p12)*SF*S13**(-1)*S14**(-1)*S23**(-1) * (  - 96*
     +    s12**2*s24**2 )

      LB = LB + Lc1(p4,p12)*SF*S13**(-1)*S14**(-1) * (  - 96*s12**2*s24
     +     - 32*s12*s23*s24 - 32*s12*s24**2 )

      LB = LB + Lc1(p4,p12)*SF*S13**(-1)*S23**(-1)*S24**(-1) * (  - 192
     +    *s12**2*s14**2 )

      LB = LB + Lc1(p4,p12)*SF*S13**(-1)*S24**(-1) * ( 192*s12**2*s14
     +     - 64*s12*s14**2 + 64*s12*s14*s23 )

      LB = LB + Lc1(p4,p12)*SF*S14**(-1)*S23**(-1) * ( 96*s12**2*s24 + 
     +    32*s12*s13*s24 - 32*s12*s24**2 )

      LB = LB + Lc1(p4,p12)*SF*S14**(-1) * ( 96*s12**2 + 32*s12*s13 + 
     +    32*s12*s23 )

      LB = LB + Lc1(p4,p12)*SF*S23**(-1)*S24**(-1) * (  - 192*s12**2*
     +    s14 - 64*s12*s13*s14 - 64*s12*s14**2 )

      LB = LB + Lc1(p4,p12)*SF*S24**(-1) * ( 192*s12**2 + 64*s12*s13 + 
     +    64*s12*s23 )

      LB = LB + Lc1(p4,p13)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 4*
     +    s12**2*s23*s34**2 - 4*s12**2*s34**3 - 8*s12*s23**2*s34**2 - 8
     +    *s12*s23*s34**3 - 4*s23**3*s34**2 - 4*s23**2*s34**3 )

      LB = LB + Lc1(p4,p13)*S13**(-1)*S14**(-1) * (  - 4*s12**2*s34**2
     +     + 16*s12*s23*s34**2 + 24*s12*s24*s34**2 + 24*s12*s34**3 + 20
     +    *s23**2*s34**2 + 48*s23*s24*s34**2 + 24*s23*s34**3 + 24*
     +    s24**2*s34**2 + 24*s24*s34**3 )

      LB = LB + Lc1(p4,p13)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*s12**3
     +    *s34**2 + 24*s12**2*s13**2*s34 + 12*s12**2*s13*s34**2 + 20*
     +    s12**2*s34**3 + 12*s12*s13**2*s34**2 + 24*s12*s13*s34**3 )

      LB = LB + Lc1(p4,p13)*S14**(-1)*S23**(-1) * ( 4*s12**3*s34 + 32*
     +    s12**2*s13**2 + 4*s12**2*s13*s24 - 28*s12**2*s13*s34 + 20*
     +    s12**2*s24*s34 + 24*s12**2*s34**2 + 24*s12*s13**3 - 68*s12*
     +    s13**2*s24 - 80*s12*s13**2*s34 - 32*s12*s13*s24**2 + 8*s12*
     +    s13*s24*s34 + 32*s12*s13*s34**2 + 16*s12*s24**2*s34 + 32*s12*
     +    s24*s34**2 + 8*s12*s34**3 - 24*s13**3*s24 + 56*s13**3*s34 - 
     +    24*s13**2*s24**2 - 44*s13**2*s24*s34 - 64*s13**2*s34**2 - 16*
     +    s13*s24**3 - 32*s13*s24**2*s34 + 8*s13*s24*s34**2 )

      LB = LB + Lc1(p4,p13)*S14**(-1)*S24**(-1) * ( 4*s12**3*s34 - 8*
     +    s12**2*s13*s34 + 8*s12**2*s23*s34 + 36*s12**2*s34**2 - 32*s12
     +    *s13**2*s34 + 24*s12*s13*s23*s34 + 12*s12*s13*s34**2 + 8*s12*
     +    s23**2*s34 + 40*s12*s23*s34**2 + 28*s12*s34**3 + 36*s13**2*
     +    s23*s34 - 36*s13**2*s34**2 + 16*s13*s23**2*s34 + 20*s13*s23*
     +    s34**2 + 24*s13*s34**3 + 12*s23**3*s34 + 20*s23**2*s34**2 + 8
     +    *s23*s34**3 )

      LB = LB + Lc1(p4,p13)*S14**(-1) * ( 4*s12**2*s13 + 28*s12**2*s34
     +     - 24*s12*s13**2 + 8*s12*s13*s23 - 24*s12*s13*s24 + 44*s12*
     +    s13*s34 + 12*s12*s23*s34 + 20*s12*s24*s34 + 32*s12*s34**2 - 
     +    16*s13**3 + 16*s13**2*s23 + 28*s13**2*s24 + 80*s13**2*s34 + 
     +    16*s13*s23**2 + 8*s13*s23*s24 + 8*s13*s23*s34 - 24*s13*s24**2
     +     - 76*s13*s24*s34 - 24*s13*s34**2 - 16*s23**2*s34 - 44*s23*
     +    s24*s34 + 28*s23*s34**2 - 16*s24**2*s34 + 32*s24*s34**2 + 40*
     +    s34**3 )

      LB = LB + Lc1(p4,p13)*SF*S14**(-1)*S23**(-1) * (  - 16*s12*s13*
     +    s24 - 8*s13*s24**2 )

      LB = LB + Lc1(p4,p13)*SF*S14**(-1) * (  - 16*s12*s13 + 16*s13*s23
     +     + 8*s13*s24 )

      LB = LB + Lc1(p4,p23)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*s12**3
     +    *s34**2 + 24*s12**2*s23**2*s34 + 12*s12**2*s23*s34**2 + 20*
     +    s12**2*s34**3 + 12*s12*s23**2*s34**2 + 24*s12*s23*s34**3 )

      LB = LB + Lc1(p4,p23)*S13**(-1)*S24**(-1) * ( 4*s12**3*s34 + 4*
     +    s12**2*s14*s23 + 20*s12**2*s14*s34 + 32*s12**2*s23**2 - 28*
     +    s12**2*s23*s34 + 24*s12**2*s34**2 - 16*s12*s14**2*s23 + 16*
     +    s12*s14**2*s34 - 52*s12*s14*s23**2 + 24*s12*s14*s23*s34 + 32*
     +    s12*s14*s34**2 + 24*s12*s23**3 - 80*s12*s23**2*s34 + 32*s12*
     +    s23*s34**2 + 8*s12*s34**3 - 16*s14**3*s23 - 24*s14**2*s23**2
     +     - 32*s14**2*s23*s34 - 24*s14*s23**3 - 44*s14*s23**2*s34 + 8*
     +    s14*s23*s34**2 + 56*s23**3*s34 - 64*s23**2*s34**2 )

      LB = LB + Lc1(p4,p23)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 4*
     +    s12**2*s13*s34**2 - 4*s12**2*s34**3 - 8*s12*s13**2*s34**2 - 8
     +    *s12*s13*s34**3 - 4*s13**3*s34**2 - 4*s13**2*s34**3 )

      LB = LB + Lc1(p4,p23)*S14**(-1)*S24**(-1) * ( 4*s12**3*s34 + 8*
     +    s12**2*s13*s34 - 8*s12**2*s23*s34 + 36*s12**2*s34**2 + 8*s12*
     +    s13**2*s34 + 24*s12*s13*s23*s34 + 40*s12*s13*s34**2 - 32*s12*
     +    s23**2*s34 + 12*s12*s23*s34**2 + 28*s12*s34**3 + 12*s13**3*
     +    s34 + 16*s13**2*s23*s34 + 20*s13**2*s34**2 + 36*s13*s23**2*
     +    s34 + 20*s13*s23*s34**2 + 8*s13*s34**3 - 36*s23**2*s34**2 + 
     +    24*s23*s34**3 )

      LB = LB + Lc1(p4,p23)*S23**(-1)*S24**(-1) * (  - 4*s12**2*s34**2
     +     + 16*s12*s13*s34**2 + 24*s12*s14*s34**2 + 24*s12*s34**3 + 20
     +    *s13**2*s34**2 + 48*s13*s14*s34**2 + 24*s13*s34**3 + 24*
     +    s14**2*s34**2 + 24*s14*s34**3 )

      LB = LB + Lc1(p4,p23)*S24**(-1) * ( 4*s12**2*s23 + 28*s12**2*s34
     +     + 8*s12*s13*s23 + 12*s12*s13*s34 - 8*s12*s14*s23 + 20*s12*
     +    s14*s34 - 24*s12*s23**2 + 44*s12*s23*s34 + 32*s12*s34**2 + 16
     +    *s13**2*s23 - 16*s13**2*s34 + 8*s13*s14*s23 - 44*s13*s14*s34
     +     + 16*s13*s23**2 + 8*s13*s23*s34 + 28*s13*s34**2 - 24*s14**2*
     +    s23 - 16*s14**2*s34 + 28*s14*s23**2 - 76*s14*s23*s34 + 32*s14
     +    *s34**2 - 16*s23**3 + 80*s23**2*s34 - 24*s23*s34**2 + 40*
     +    s34**3 )

      LB = LB + Lc1(p4,p23)*SF*S13**(-1)*S24**(-1) * ( 16*s12*s14*s23
     +     + 8*s14**2*s23 )

      LB = LB + Lc1(p4,p23)*SF*S24**(-1) * ( 16*s12*s23 - 16*s13*s23 - 
     +    8*s14*s23 )

      LB = LB + Lc1(p4,p123)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 56*s12**4*s34**2 + 492*s12**3*s34**3 + 240*s12**2*s34**4 )

      LB = LB + Lc1(p4,p123)*S13**(-1)*S14**(-1)*S23**(-1) * ( 48*
     +    s12**4*s34 + 144*s12**3*s24**2 + 752*s12**3*s24*s34 + 1184*
     +    s12**3*s34**2 + 16*s12**2*s24**3 + 176*s12**2*s24**2*s34 + 
     +    544*s12**2*s24*s34**2 + 640*s12**2*s34**3 )

      LB = LB + Lc1(p4,p123)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**4*s34 + 8*s12**3*s23*s34 + 236*s12**3*s34**2 - 24*s12**2
     +    *s23**2*s34 + 312*s12**2*s23*s34**2 + 364*s12**2*s34**3 + 136
     +    *s12*s23**2*s34**2 + 128*s12*s23*s34**3 + 104*s12*s34**4 + 16
     +    *s23**3*s34**2 + 48*s23**2*s34**3 + 8*s23*s34**4 )

      LB = LB + Lc1(p4,p123)*S13**(-1)*S14**(-1) * ( 96*s12**3*s24 + 
     +    256*s12**3*s34 + 224*s12**2*s23*s24 + 416*s12**2*s23*s34 + 
     +    400*s12**2*s24**2 + 1296*s12**2*s24*s34 + 1472*s12**2*s34**2
     +     + 160*s12*s23**2*s24 + 256*s12*s23**2*s34 + 336*s12*s23*
     +    s24**2 + 880*s12*s23*s24*s34 + 816*s12*s23*s34**2 + 32*s12*
     +    s24**3 + 208*s12*s24**2*s34 + 464*s12*s24*s34**2 + 432*s12*
     +    s34**3 + 32*s23**3*s24 + 48*s23**3*s34 + 80*s23**2*s24**2 + 
     +    192*s23**2*s24*s34 + 160*s23**2*s34**2 + 16*s23*s24**3 + 80*
     +    s23*s24**2*s34 + 144*s23*s24*s34**2 + 112*s23*s34**3 )

      LB = LB + Lc1(p4,p123)*S13**(-1)*S23**(-1)*S24**(-1) * ( 40*
     +    s12**4*s14 + 40*s12**4*s34 - 168*s12**3*s14**2 - 376*s12**3*
     +    s14*s34 - 220*s12**3*s34**2 + 160*s12**2*s14**3 + 368*s12**2*
     +    s14**2*s34 + 240*s12**2*s14*s34**2 + 40*s12**2*s34**3 )

      LB = LB + Lc1(p4,p123)*S13**(-1)*S24**(-1) * (  - 8*s12**4 + 192*
     +    s12**3*s14 - 80*s12**3*s23 + 228*s12**3*s34 - 240*s12**2*
     +    s14**2 + 60*s12**2*s14*s23 - 628*s12**2*s14*s34 - 96*s12**2*
     +    s23**2 + 188*s12**2*s23*s34 - 488*s12**2*s34**2 + 248*s12*
     +    s14**3 - 100*s12*s14**2*s23 + 584*s12*s14**2*s34 - 184*s12*
     +    s14*s23**2 - 212*s12*s14*s23*s34 + 288*s12*s14*s34**2 - 24*
     +    s12*s23**3 - 88*s12*s23**2*s34 - 296*s12*s23*s34**2 + 8*s12*
     +    s34**3 + 64*s14**3*s23 + 184*s14**2*s23*s34 - 24*s14*s23**3
     +     + 16*s14*s23**2*s34 + 8*s14*s23*s34**2 - 80*s23**3*s34 + 16*
     +    s23**2*s34**2 - 48*s23*s34**3 )

      LB = LB + Lc1(p4,p123)*S14**(-1)*S23**(-1)*S24**(-1) * ( 240*
     +    s12**3*s13*s34 - 660*s12**3*s34**2 + 120*s12**2*s13**2*s34 + 
     +    136*s12**2*s13*s34**2 - 628*s12**2*s34**3 + 56*s12*s13**3*s34
     +     + 100*s12*s13**2*s34**2 + 92*s12*s13*s34**3 - 88*s12*s34**4
     +     - 16*s13**4*s34 + 88*s13**3*s34**2 + 12*s13**2*s34**3 - 8*
     +    s13*s34**4 )

      LB = LB + Lc1(p4,p123)*S14**(-1)*S23**(-1) * ( 96*s12**3*s13 - 
     +    240*s12**3*s24 - 928*s12**3*s34 - 208*s12**2*s13*s24 - 176*
     +    s12**2*s13*s34 + 192*s12**2*s24**2 - 224*s12**2*s24*s34 - 
     +    1024*s12**2*s34**2 - 208*s12*s13**2*s24 - 224*s12*s13**2*s34
     +     + 176*s12*s13*s24**2 + 112*s12*s13*s24*s34 - 48*s12*s13*
     +    s34**2 + 32*s12*s24**3 + 112*s12*s24**2*s34 + 64*s12*s24*
     +    s34**2 - 80*s12*s34**3 - 48*s13**3*s24 - 48*s13**3*s34 + 32*
     +    s13**2*s24**2 - 32*s13**2*s34**2 + 16*s13*s24**3 + 48*s13*
     +    s24**2*s34 + 48*s13*s24*s34**2 + 16*s13*s34**3 )

      LB = LB + Lc1(p4,p123)*S14**(-1)*S24**(-1) * (  - 52*s12**3*s34
     +     - 204*s12**2*s13*s34 - 240*s12**2*s23*s34 - 352*s12**2*
     +    s34**2 - 248*s12*s13**2*s34 - 472*s12*s13*s23*s34 - 184*s12*
     +    s13*s34**2 - 84*s12*s23**2*s34 - 48*s12*s23*s34**2 + 16*s12*
     +    s34**3 - 112*s13**3*s34 - 192*s13**2*s23*s34 + 116*s13**2*
     +    s34**2 - 140*s13*s23**2*s34 + 32*s13*s23*s34**2 - 4*s13*
     +    s34**3 - 16*s23**3*s34 + 56*s23**2*s34**2 + 24*s23*s34**3 )

      LB = LB + Lc1(p4,p123)*S14**(-1) * (  - 96*s12**3 - 192*s12**2*
     +    s13 - 176*s12**2*s23 - 208*s12**2*s24 - 736*s12**2*s34 - 256*
     +    s12*s13**2 - 352*s12*s13*s23 - 272*s12*s13*s24 - 608*s12*s13*
     +    s34 - 96*s12*s23**2 + 96*s12*s23*s24 - 32*s12*s23*s34 + 512*
     +    s12*s24**2 + 848*s12*s24*s34 + 480*s12*s34**2 - 64*s13**3 - 
     +    144*s13**2*s23 - 96*s13**2*s24 - 160*s13**2*s34 - 96*s13*
     +    s23**2 - 16*s13*s23*s24 - 96*s13*s23*s34 + 144*s13*s24**2 + 
     +    192*s13*s24*s34 + 96*s13*s34**2 - 16*s23**3 + 64*s23**2*s24
     +     + 64*s23**2*s34 + 192*s23*s24**2 + 384*s23*s24*s34 + 288*s23
     +    *s34**2 + 32*s24**3 + 128*s24**2*s34 + 192*s24*s34**2 + 128*
     +    s34**3 )

      LB = LB + Lc1(p4,p123)*S23**(-1)*S24**(-1) * ( 32*s12**4 + 8*
     +    s12**3*s13 - 84*s12**3*s14 + 92*s12**3*s34 - 28*s12**2*s13*
     +    s14 + 140*s12**2*s13*s34 - 32*s12**2*s14**2 - 244*s12**2*s14*
     +    s34 + 136*s12**2*s34**2 - 24*s12*s13**3 + 156*s12*s13**2*s14
     +     + 408*s12*s13**2*s34 + 404*s12*s13*s14**2 + 604*s12*s13*s14*
     +    s34 + 460*s12*s13*s34**2 + 248*s12*s14**3 + 504*s12*s14**2*
     +    s34 + 328*s12*s14*s34**2 + 48*s12*s34**3 - 48*s13**4 + 48*
     +    s13**3*s14 + 256*s13**3*s34 + 208*s13**2*s14**2 + 284*s13**2*
     +    s14*s34 + 56*s13**2*s34**2 + 112*s13*s14**3 + 56*s13*s14**2*
     +    s34 + 32*s13*s14*s34**2 + 8*s13*s34**3 )

      LB = LB + Lc1(p4,p123)*S24**(-1) * ( 48*s12**3 - 148*s12**2*s13
     +     - 272*s12**2*s14 - 164*s12**2*s23 - 112*s12**2*s34 - 364*s12
     +    *s13**2 - 384*s12*s13*s14 - 424*s12*s13*s23 - 204*s12*s13*s34
     +     + 304*s12*s14**2 - 696*s12*s14*s23 + 196*s12*s14*s34 - 124*
     +    s12*s23**2 - 452*s12*s23*s34 + 116*s12*s34**2 - 152*s13**3 - 
     +    12*s13**2*s14 - 172*s13**2*s23 + 208*s13**2*s34 + 428*s13*
     +    s14**2 - 212*s13*s14*s23 + 508*s13*s14*s34 - 132*s13*s23**2
     +     - 200*s13*s23*s34 + 84*s13*s34**2 + 176*s14**3 + 132*s14**2*
     +    s23 + 208*s14**2*s34 - 160*s14*s23**2 + 108*s14*s23*s34 + 48*
     +    s14*s34**2 - 8*s23**3 - 216*s23**2*s34 - 32*s23*s34**2 - 16*
     +    s34**3 )

      LB = LB + Lc1(p4,p123)*SF*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 192*s12**2*s34**3 )

      LB = LB + Lc1(p4,p123)*SF*S13**(-1)*S14**(-1)*S23**(-1) * ( 96*
     +    s12**2*s24**2 )

      LB = LB + Lc1(p4,p123)*SF*S13**(-1)*S14**(-1)*S24**(-1) * (  - 
     +    192*s12**2*s34**2 - 256*s12*s23*s34**2 + 256*s12*s34**3 - 64*
     +    s23**2*s34**2 + 64*s23*s34**3 )

      LB = LB + Lc1(p4,p123)*SF*S13**(-1)*S14**(-1) * ( 96*s12**2*s24
     +     + 128*s12*s23*s24 + 128*s12*s24**2 + 32*s23**2*s24 + 32*s23*
     +    s24**2 )

      LB = LB + Lc1(p4,p123)*SF*S13**(-1)*S23**(-1)*S24**(-1) * ( 192*
     +    s12**2*s14**2 + 576*s12**2*s14*s34 + 576*s12**2*s34**2 )

      LB = LB + Lc1(p4,p123)*SF*S13**(-1)*S24**(-1) * (  - 192*s12**2*
     +    s14 - 384*s12**2*s34 + 256*s12*s14**2 - 256*s12*s14*s23 + 768
     +    *s12*s14*s34 - 512*s12*s23*s34 + 768*s12*s34**2 + 64*s14**2*
     +    s23 - 64*s14*s23**2 + 192*s14*s23*s34 - 128*s23**2*s34 + 192*
     +    s23*s34**2 )

      LB = LB + Lc1(p4,p123)*SF*S14**(-1)*S23**(-1)*S24**(-1) * ( 192*
     +    s12**2*s34**2 + 256*s12*s13*s34**2 + 256*s12*s34**3 + 64*
     +    s13**2*s34**2 + 64*s13*s34**3 )

      LB = LB + Lc1(p4,p123)*SF*S14**(-1)*S23**(-1) * (  - 96*s12**2*
     +    s24 - 128*s12*s13*s24 + 128*s12*s24**2 - 32*s13**2*s24 + 32*
     +    s13*s24**2 )

      LB = LB + Lc1(p4,p123)*SF*S14**(-1)*S24**(-1) * (  - 192*s12**2*
     +    s34 - 256*s12*s13*s34 - 256*s12*s23*s34 - 64*s13**2*s34 - 128
     +    *s13*s23*s34 + 64*s13*s34**2 - 64*s23**2*s34 - 64*s23*s34**2
     +     + 128*s34**3 )

      LB = LB + Lc1(p4,p123)*SF*S14**(-1) * (  - 96*s12**2 - 128*s12*
     +    s13 - 128*s12*s23 - 32*s13**2 - 64*s13*s23 - 32*s13*s24 - 32*
     +    s23**2 + 32*s23*s24 + 64*s24**2 )

      LB = LB + Lc1(p4,p123)*SF*S23**(-1)*S24**(-1) * ( 192*s12**2*s14
     +     + 384*s12**2*s34 + 256*s12*s13*s14 + 512*s12*s13*s34 + 256*
     +    s12*s14**2 + 768*s12*s14*s34 + 768*s12*s34**2 + 64*s13**2*s14
     +     + 128*s13**2*s34 + 64*s13*s14**2 + 192*s13*s14*s34 + 192*s13
     +    *s34**2 )

      LB = LB + Lc1(p4,p123)*SF*S24**(-1) * (  - 192*s12**2 - 256*s12*
     +    s13 - 256*s12*s23 - 64*s13**2 + 64*s13*s14 - 128*s13*s23 + 
     +    128*s13*s34 + 128*s14**2 - 64*s14*s23 + 384*s14*s34 - 64*
     +    s23**2 - 128*s23*s34 + 384*s34**2 )

      LBb=-LB/s134/s234
      
      return
      end

      function LBc(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      SF=(s13*s24-s14*s23)/2d0/s34

      LB=0d0

      LB = LB + Lc1(p12,p34)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 1824*s12**3*s34**3 + 32*s12**2*s34**4 )

      LB = LB + Lc1(p12,p34)*S13**(-1)*S14**(-1)*S23**(-1) * ( 1728*
     +    s12**3*s34**2 - 240*s12**2*s24**2*s34 + 2392*s12**2*s24*
     +    s34**2 + 256*s12**2*s34**3 - 48*s12*s24**4 - 360*s12*s24**3*
     +    s34 + 640*s12*s24**2*s34**2 + 120*s12*s24*s34**3 - 88*s24**5
     +     - 112*s24**4*s34 )

      LB = LB + Lc1(p12,p34)*S13**(-1)*S14**(-1)*S24**(-1) * ( 1344*
     +    s12**3*s34**2 - 240*s12**2*s23**2*s34 - 40*s12**2*s23*s34**2
     +     - 544*s12**2*s34**3 - 24*s12*s23**4 - 104*s12*s23**3*s34 + 
     +    72*s12*s23**2*s34**2 - 8*s12*s23*s34**3 + 16*s23**4*s34 )

      LB = LB + Lc1(p12,p34)*S13**(-1)*S14**(-1) * (  - 720*s12**2*s23*
     +    s34 - 720*s12**2*s24*s34 + 1840*s12**2*s34**2 - 144*s12*
     +    s23**3 - 336*s12*s23**2*s24 - 640*s12*s23**2*s34 - 384*s12*
     +    s23*s24**2 - 1360*s12*s23*s24*s34 + 496*s12*s23*s34**2 - 216*
     +    s12*s24**3 - 1184*s12*s24**2*s34 + 904*s12*s24*s34**2 + 240*
     +    s12*s34**3 - 64*s23**4 - 336*s23**3*s24 + 24*s23**3*s34 - 712
     +    *s23**2*s24**2 - 128*s23**2*s24*s34 - 64*s23**2*s34**2 - 760*
     +    s23*s24**3 - 376*s23*s24**2*s34 - 128*s23*s24*s34**2 - 64*s23
     +    *s34**3 - 408*s24**4 - 352*s24**3*s34 - 64*s24**2*s34**2 - 64
     +    *s24*s34**3 )

      LB = LB + Lc1(p12,p34)*S13**(-1)*S23**(-1)*S24**(-1) * ( 576*
     +    s12**3*s34**2 - 288*s12**2*s14**2*s34 + 1024*s12**2*s14*
     +    s34**2 - 1120*s12**2*s34**3 - 256*s12*s14**3*s34 + 160*s12*
     +    s14**2*s34**2 - 128*s12*s14*s34**3 + 32*s14**4*s34 + 32*
     +    s14**3*s34**2 )

      LB = LB + Lc1(p12,p34)*S13**(-1)*S23**(-1) * (  - 672*s12**2*s14*
     +    s34 - 720*s12**2*s24*s34 + 2488*s12**2*s34**2 - 96*s12*s14**2
     +    *s24 - 1104*s12*s14**2*s34 - 216*s12*s14*s24**2 - 2016*s12*
     +    s14*s24*s34 + 1208*s12*s14*s34**2 - 168*s12*s24**3 - 1400*s12
     +    *s24**2*s34 + 1528*s12*s24*s34**2 - 168*s12*s34**3 - 88*
     +    s14**4 - 360*s14**3*s24 - 112*s14**3*s34 - 672*s14**2*s24**2
     +     - 488*s14**2*s24*s34 + 72*s14**2*s34**2 - 704*s14*s24**3 - 
     +    672*s14*s24**2*s34 + 80*s14*s24*s34**2 - 392*s24**4 - 440*
     +    s24**3*s34 + 40*s24**2*s34**2 )

      LB = LB + Lc1(p12,p34)*S13**(-1)*S24**(-1) * (  - 480*s12**2*s14*
     +    s34 - 624*s12**2*s23*s34 + 696*s12**2*s34**2 - 96*s12*s14**2*
     +    s23 - 848*s12*s14**2*s34 - 168*s12*s14*s23**2 - 1088*s12*s14*
     +    s23*s34 + 808*s12*s14*s34**2 - 96*s12*s23**3 - 536*s12*s23**2
     +    *s34 + 304*s12*s23*s34**2 - 136*s12*s34**3 - 88*s14**4 - 168*
     +    s14**3*s23 + 16*s14**3*s34 - 152*s14**2*s23**2 + 120*s14**2*
     +    s23*s34 + 48*s14**2*s34**2 - 80*s14*s23**3 + 128*s14*s23**2*
     +    s34 + 48*s14*s23*s34**2 - 16*s23**4 + 40*s23**3*s34 + 40*
     +    s23**2*s34**2 + 64*s23*s34**3 )

      LB = LB + Lc1(p12,p34)*S13**(-1) * (  - 1344*s12**2*s34 - 192*s12
     +    *s14**2 - 552*s12*s14*s23 - 600*s12*s14*s24 - 3104*s12*s14*
     +    s34 - 456*s12*s23**2 - 792*s12*s23*s24 - 2440*s12*s23*s34 - 
     +    600*s12*s24**2 - 3304*s12*s24*s34 + 1256*s12*s34**2 - 528*
     +    s14**3 - 888*s14**2*s23 - 1408*s14**2*s24 - 304*s14**2*s34 - 
     +    792*s14*s23**2 - 2032*s14*s23*s24 - 248*s14*s23*s34 - 2024*
     +    s14*s24**2 - 1032*s14*s24*s34 + 64*s14*s34**2 - 352*s23**3 - 
     +    1336*s23**2*s24 - 112*s23**2*s34 - 2072*s23*s24**2 - 760*s23*
     +    s24*s34 - 24*s23*s34**2 - 1464*s24**3 - 1048*s24**2*s34 - 16*
     +    s24*s34**2 - 64*s34**3 )

      LB = LB + Lc1(p12,p34)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 576*
     +    s12**3*s34**2 + 32*s12**2*s34**3 )

      LB = LB + Lc1(p12,p34)*S14**(-1)*S23**(-1) * (  - 912*s12**2*s24*
     +    s34 - 2056*s12**2*s34**2 - 48*s12*s24**3 - 1448*s12*s24**2*
     +    s34 - 448*s12*s24*s34**2 - 40*s12*s34**3 - 96*s24**4 - 336*
     +    s24**3*s34 - 88*s24**2*s34**2 )

      LB = LB + Lc1(p12,p34)*S14**(-1)*S24**(-1) * (  - 624*s12**2*s23*
     +    s34 - 1288*s12**2*s34**2 - 24*s12*s23**3 - 104*s12*s23**2*s34
     +     + 328*s12*s23*s34**2 - 8*s12*s34**3 + 16*s23**3*s34 )

      LB = LB + Lc1(p12,p34)*S14**(-1) * (  - 1536*s12**2*s34 - 120*s12
     +    *s23**2 - 216*s12*s23*s24 - 1272*s12*s23*s34 - 168*s12*s24**2
     +     - 2616*s12*s24*s34 + 72*s12*s34**2 - 80*s23**3 - 320*s23**2*
     +    s24 - 184*s23**2*s34 - 496*s23*s24**2 - 648*s23*s24*s34 - 112
     +    *s23*s34**2 - 352*s24**3 - 784*s24**2*s34 - 208*s24*s34**2 + 
     +    64*s34**3 )

      LB = LB + Lc1(p12,p34)*S23**(-1)*S24**(-1) * (  - 288*s12**2*s14*
     +    s34 - 1024*s12**2*s34**2 - 512*s12*s14**2*s34 + 416*s12*s14*
     +    s34**2 + 160*s12*s34**3 + 32*s14**3*s34 + 64*s14**2*s34**2 )

      LB = LB + Lc1(p12,p34)*S23**(-1) * (  - 1056*s12**2*s34 - 96*s12*
     +    s14*s24 - 2064*s12*s14*s34 - 120*s12*s24**2 - 2992*s12*s24*
     +    s34 + 152*s12*s34**2 - 88*s14**3 - 272*s14**2*s24 - 368*
     +    s14**2*s34 - 408*s14*s24**2 - 1112*s14*s24*s34 + 144*s14*
     +    s34**2 - 320*s24**3 - 1032*s24**2*s34 - 40*s24*s34**2 )

      LB = LB + Lc1(p12,p34)*S24**(-1) * (  - 864*s12**2*s34 - 96*s12*
     +    s14*s23 - 1296*s12*s14*s34 - 72*s12*s23**2 - 848*s12*s23*s34
     +     + 904*s12*s34**2 - 88*s14**3 - 80*s14**2*s23 - 80*s14**2*s34
     +     - 64*s14*s23**2 - 88*s14*s23*s34 + 104*s14*s34**2 + 152*
     +    s23**2*s34 + 88*s23*s34**2 )

      LB = LB + Lc1(p12,p34) * (  - 192*s12*s14 - 264*s12*s23 - 312*s12
     +    *s24 - 3488*s12*s34 - 352*s14**2 - 448*s14*s23 - 792*s14*s24
     +     - 880*s14*s34 - 256*s23**2 - 816*s23*s24 - 336*s23*s34 - 880
     +    *s24**2 - 1408*s24*s34 - 48*s34**2 )

      LB = LB + Lc1(p13,p24)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**4*s34**2 - 16*s12**3*s34**3 )

      LB = LB + Lc1(p13,p24)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**4*s34 + 48*s12**3*s24*s34 + 32*s12**3*s34**2 - 12*s12**2
     +    *s24**2*s34 + 12*s12**2*s24*s34**2 + 24*s12**2*s34**3 )

      LB = LB + Lc1(p13,p24)*S13**(-1)*S14**(-1)*S24**(-1) * ( 8*s12**4
     +    *s23 + 24*s12**4*s34 - 32*s12**3*s23**2 - 64*s12**3*s23*s34
     +     - 48*s12**3*s34**2 )

      LB = LB + Lc1(p13,p24)*S13**(-1)*S14**(-1) * ( 8*s12**4 - 48*
     +    s12**3*s23 - 16*s12**3*s24 - 24*s12**2*s23**2 - 24*s12**2*s23
     +    *s24 + 40*s12**2*s23*s34 + 52*s12**2*s24*s34 + 88*s12**2*
     +    s34**2 + 32*s12*s23**2*s34 + 20*s12*s23*s24*s34 + 48*s12*s23*
     +    s34**2 - 12*s12*s24**2*s34 + 4*s12*s24*s34**2 + 16*s12*s34**3
     +     )

      LB = LB + Lc1(p13,p24)*S13**(-1)*S23**(-1)*S24**(-1) * ( 8*s12**4
     +    *s14 + 24*s12**4*s34 - 24*s12**3*s14**2 - 64*s12**3*s14*s34
     +     - 56*s12**3*s34**2 + 64*s12**2*s14**3 + 72*s12**2*s14**2*s34
     +     - 24*s12**2*s14*s34**2 - 32*s12**2*s34**3 - 16*s12*s14**4 - 
     +    48*s12*s14**3*s34 - 48*s12*s14**2*s34**2 - 16*s12*s14*s34**3
     +     )

      LB = LB + Lc1(p13,p24)*S13**(-1)*S23**(-1) * ( 16*s12**4 - 24*
     +    s12**3*s14 + 48*s12**3*s24 + 8*s12**3*s34 + 24*s12**2*s14**2
     +     + 52*s12**2*s14*s24 + 64*s12**2*s14*s34 - 12*s12**2*s24**2
     +     + 64*s12**2*s24*s34 + 64*s12**2*s34**2 )

      LB = LB + Lc1(p13,p24)*S13**(-1)*S24**(-1) * ( 16*s12**4 - 16*
     +    s12**3*s14 - 40*s12**3*s23 - 72*s12**3*s34 + 32*s12**2*s14**2
     +     - 72*s12**2*s14*s23 - 64*s12**2*s14*s34 - 32*s12**2*s23**2
     +     - 88*s12**2*s23*s34 - 80*s12**2*s34**2 + 112*s12*s14**3 + 64
     +    *s12*s14**2*s23 + 176*s12*s14**2*s34 + 64*s12*s14*s23*s34 + 
     +    64*s12*s14*s34**2 + 24*s14**3*s23 + 24*s14**2*s23*s34 )

      LB = LB + Lc1(p13,p24)*S13**(-1) * ( 8*s12**3 - 20*s12**2*s14 - 
     +    28*s12**2*s23 - 8*s12**2*s24 + 24*s12**2*s34 + 36*s12*s14**2
     +     - 8*s12*s14*s23 - 8*s12*s14*s24 + 28*s12*s14*s34 - 60*s12*
     +    s23**2 - 52*s12*s23*s24 - 28*s12*s23*s34 + 8*s12*s24**2 + 40*
     +    s12*s24*s34 + 32*s12*s34**2 - 24*s14*s23**2 - 24*s14*s23*s24
     +     - 24*s14*s23*s34 - 16*s23**3 - 8*s23**2*s24 - 16*s23**2*s34
     +     + 8*s23*s24**2 + 8*s23*s24*s34 )

      LB = LB + Lc1(p13,p24)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**4*s34 - 16*s12**3*s34**2 )

      LB = LB + Lc1(p13,p24)*S14**(-1)*S23**(-1) * ( 16*s12**4 + 48*
     +    s12**3*s24 + 32*s12**3*s34 - 60*s12**2*s13*s24 - 60*s12**2*
     +    s13*s34 - 12*s12**2*s24**2 - 48*s12**2*s24*s34 - 36*s12**2*
     +    s34**2 + 24*s12*s13*s24**2 + 24*s12*s13*s24*s34 + 24*s12*
     +    s24**2*s34 + 24*s12*s24*s34**2 )

      LB = LB + Lc1(p13,p24)*S14**(-1)*S24**(-1) * ( 16*s12**4 - 48*
     +    s12**3*s23 - 64*s12**3*s34 )

      LB = LB + Lc1(p13,p24)*S14**(-1) * (  - 60*s12**2*s13 - 28*s12**2
     +    *s23 - 40*s12**2*s24 - 64*s12**2*s34 + 24*s12*s13*s24 + 28*
     +    s12*s23*s24 + 28*s12*s24**2 + 52*s12*s24*s34 + 16*s23**2*s24
     +     + 8*s23*s24**2 - 8*s24**3 - 24*s24**2*s34 - 16*s24*s34**2 )

      LB = LB + Lc1(p13,p24)*S23**(-1)*S24**(-1) * ( 8*s12**4 - 16*
     +    s12**3*s13 - 40*s12**3*s14 - 56*s12**3*s34 - 32*s12**2*s13*
     +    s14 + 32*s12**2*s14**2 - 24*s12**2*s14*s34 - 32*s12**2*s34**2
     +     + 16*s12*s13*s14**2 + 16*s12*s13*s14*s34 )

      LB = LB + Lc1(p13,p24)*S23**(-1) * (  - 24*s12**3 - 40*s12**2*s13
     +     - 16*s12**2*s14 - 8*s12**2*s24 - 60*s12**2*s34 + 8*s12*
     +    s13**2 - 56*s12*s13*s14 - 20*s12*s13*s24 - 52*s12*s13*s34 - 
     +    64*s12*s14**2 - 20*s12*s14*s24 - 124*s12*s14*s34 + 24*s12*
     +    s24**2 + 4*s12*s24*s34 - 60*s12*s34**2 + 8*s13**2*s14 + 8*s13
     +    *s14**2 + 8*s13*s14*s34 )

      LB = LB + Lc1(p13,p24)*S24**(-1) * (  - 16*s12**3 - 24*s12**2*s13
     +     + 8*s12**2*s14 - 72*s12**2*s23 - 120*s12**2*s34 - 24*s12*s13
     +    *s14 + 88*s12*s14**2 + 64*s12*s14*s23 + 40*s12*s14*s34 + 24*
     +    s14**2*s23 )

      LB = LB + Lc1(p13,p24) * (  - 80*s12**2 - 80*s12*s13 - 44*s12*s14
     +     - 24*s12*s23 - 104*s12*s34 - 24*s13*s14 - 24*s14**2 - 8*s14*
     +    s23 - 8*s14*s24 - 32*s14*s34 + 24*s23*s24 + 24*s24**2 + 24*
     +    s24*s34 )

      LB = LB + Lc1(p14,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**4*s34**2 - 16*s12**3*s34**3 )

      LB = LB + Lc1(p14,p23)*S13**(-1)*S14**(-1)*S23**(-1) * ( 8*s12**4
     +    *s24 + 24*s12**4*s34 - 32*s12**3*s24**2 - 64*s12**3*s24*s34
     +     - 48*s12**3*s34**2 )

      LB = LB + Lc1(p14,p23)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**4*s34 + 48*s12**3*s23*s34 + 32*s12**3*s34**2 - 12*s12**2
     +    *s23**2*s34 + 12*s12**2*s23*s34**2 + 24*s12**2*s34**3 )

      LB = LB + Lc1(p14,p23)*S13**(-1)*S14**(-1) * ( 8*s12**4 - 16*
     +    s12**3*s23 - 48*s12**3*s24 - 24*s12**2*s23*s24 + 52*s12**2*
     +    s23*s34 - 24*s12**2*s24**2 + 40*s12**2*s24*s34 + 88*s12**2*
     +    s34**2 - 12*s12*s23**2*s34 + 20*s12*s23*s24*s34 + 4*s12*s23*
     +    s34**2 + 32*s12*s24**2*s34 + 48*s12*s24*s34**2 + 16*s12*
     +    s34**3 )

      LB = LB + Lc1(p14,p23)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**4*s34 - 16*s12**3*s34**2 )

      LB = LB + Lc1(p14,p23)*S13**(-1)*S23**(-1) * ( 16*s12**4 - 48*
     +    s12**3*s24 - 64*s12**3*s34 )

      LB = LB + Lc1(p14,p23)*S13**(-1)*S24**(-1) * ( 16*s12**4 + 48*
     +    s12**3*s23 + 32*s12**3*s34 - 60*s12**2*s14*s23 - 60*s12**2*
     +    s14*s34 - 12*s12**2*s23**2 - 48*s12**2*s23*s34 - 36*s12**2*
     +    s34**2 + 24*s12*s14*s23**2 + 24*s12*s14*s23*s34 + 24*s12*
     +    s23**2*s34 + 24*s12*s23*s34**2 )

      LB = LB + Lc1(p14,p23)*S13**(-1) * (  - 60*s12**2*s14 - 40*s12**2
     +    *s23 - 28*s12**2*s24 - 64*s12**2*s34 + 24*s12*s14*s23 + 28*
     +    s12*s23**2 + 28*s12*s23*s24 + 52*s12*s23*s34 - 8*s23**3 + 8*
     +    s23**2*s24 - 24*s23**2*s34 + 16*s23*s24**2 - 16*s23*s34**2 )

      LB = LB + Lc1(p14,p23)*S14**(-1)*S23**(-1)*S24**(-1) * ( 8*s12**4
     +    *s13 + 24*s12**4*s34 - 24*s12**3*s13**2 - 64*s12**3*s13*s34
     +     - 56*s12**3*s34**2 + 64*s12**2*s13**3 + 72*s12**2*s13**2*s34
     +     - 24*s12**2*s13*s34**2 - 32*s12**2*s34**3 - 16*s12*s13**4 - 
     +    48*s12*s13**3*s34 - 48*s12*s13**2*s34**2 - 16*s12*s13*s34**3
     +     )

      LB = LB + Lc1(p14,p23)*S14**(-1)*S23**(-1) * ( 16*s12**4 - 16*
     +    s12**3*s13 - 40*s12**3*s24 - 72*s12**3*s34 + 32*s12**2*s13**2
     +     - 72*s12**2*s13*s24 - 64*s12**2*s13*s34 - 32*s12**2*s24**2
     +     - 88*s12**2*s24*s34 - 80*s12**2*s34**2 + 112*s12*s13**3 + 64
     +    *s12*s13**2*s24 + 176*s12*s13**2*s34 + 64*s12*s13*s24*s34 + 
     +    64*s12*s13*s34**2 + 24*s13**3*s24 + 24*s13**2*s24*s34 )

      LB = LB + Lc1(p14,p23)*S14**(-1)*S24**(-1) * ( 16*s12**4 - 24*
     +    s12**3*s13 + 48*s12**3*s23 + 8*s12**3*s34 + 24*s12**2*s13**2
     +     + 52*s12**2*s13*s23 + 64*s12**2*s13*s34 - 12*s12**2*s23**2
     +     + 64*s12**2*s23*s34 + 64*s12**2*s34**2 )

      LB = LB + Lc1(p14,p23)*S14**(-1) * ( 8*s12**3 - 20*s12**2*s13 - 8
     +    *s12**2*s23 - 28*s12**2*s24 + 24*s12**2*s34 + 36*s12*s13**2
     +     - 8*s12*s13*s23 - 8*s12*s13*s24 + 28*s12*s13*s34 + 8*s12*
     +    s23**2 - 52*s12*s23*s24 + 40*s12*s23*s34 - 60*s12*s24**2 - 28
     +    *s12*s24*s34 + 32*s12*s34**2 - 24*s13*s23*s24 - 24*s13*s24**2
     +     - 24*s13*s24*s34 + 8*s23**2*s24 - 8*s23*s24**2 + 8*s23*s24*
     +    s34 - 16*s24**3 - 16*s24**2*s34 )

      LB = LB + Lc1(p14,p23)*S23**(-1)*S24**(-1) * ( 8*s12**4 - 40*
     +    s12**3*s13 - 16*s12**3*s14 - 56*s12**3*s34 + 32*s12**2*s13**2
     +     - 32*s12**2*s13*s14 - 24*s12**2*s13*s34 - 32*s12**2*s34**2
     +     + 16*s12*s13**2*s14 + 16*s12*s13*s14*s34 )

      LB = LB + Lc1(p14,p23)*S23**(-1) * (  - 16*s12**3 + 8*s12**2*s13
     +     - 24*s12**2*s14 - 72*s12**2*s24 - 120*s12**2*s34 + 88*s12*
     +    s13**2 - 24*s12*s13*s14 + 64*s12*s13*s24 + 40*s12*s13*s34 + 
     +    24*s13**2*s24 )

      LB = LB + Lc1(p14,p23)*S24**(-1) * (  - 24*s12**3 - 16*s12**2*s13
     +     - 40*s12**2*s14 - 8*s12**2*s23 - 60*s12**2*s34 - 64*s12*
     +    s13**2 - 56*s12*s13*s14 - 20*s12*s13*s23 - 124*s12*s13*s34 + 
     +    8*s12*s14**2 - 20*s12*s14*s23 - 52*s12*s14*s34 + 24*s12*
     +    s23**2 + 4*s12*s23*s34 - 60*s12*s34**2 + 8*s13**2*s14 + 8*s13
     +    *s14**2 + 8*s13*s14*s34 )

      LB = LB + Lc1(p14,p23) * (  - 80*s12**2 - 44*s12*s13 - 80*s12*s14
     +     - 24*s12*s24 - 104*s12*s34 - 24*s13**2 - 24*s13*s14 - 8*s13*
     +    s23 - 8*s13*s24 - 32*s13*s34 + 24*s23**2 + 24*s23*s24 + 24*
     +    s23*s34 )

      LB = LB + Lc1(p23,p14)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**4*s34**2 - 16*s12**3*s34**3 )

      LB = LB + Lc1(p23,p14)*S13**(-1)*S14**(-1)*S23**(-1) * ( 8*s12**4
     +    *s24 + 24*s12**4*s34 - 24*s12**3*s24**2 - 64*s12**3*s24*s34
     +     - 56*s12**3*s34**2 + 64*s12**2*s24**3 + 72*s12**2*s24**2*s34
     +     - 24*s12**2*s24*s34**2 - 32*s12**2*s34**3 - 16*s12*s24**4 - 
     +    48*s12*s24**3*s34 - 48*s12*s24**2*s34**2 - 16*s12*s24*s34**3
     +     )

      LB = LB + Lc1(p23,p14)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**4*s34 - 16*s12**3*s34**2 )

      LB = LB + Lc1(p23,p14)*S13**(-1)*S14**(-1) * ( 8*s12**4 - 16*
     +    s12**3*s23 - 40*s12**3*s24 - 56*s12**3*s34 - 32*s12**2*s23*
     +    s24 + 32*s12**2*s24**2 - 24*s12**2*s24*s34 - 32*s12**2*s34**2
     +     + 16*s12*s23*s24**2 + 16*s12*s23*s24*s34 )

      LB = LB + Lc1(p23,p14)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**4*s34 + 48*s12**3*s14*s34 + 32*s12**3*s34**2 - 12*s12**2
     +    *s14**2*s34 + 12*s12**2*s14*s34**2 + 24*s12**2*s34**3 )

      LB = LB + Lc1(p23,p14)*S13**(-1)*S23**(-1) * ( 16*s12**4 + 48*
     +    s12**3*s14 - 24*s12**3*s24 + 8*s12**3*s34 - 12*s12**2*s14**2
     +     + 52*s12**2*s14*s24 + 64*s12**2*s14*s34 + 24*s12**2*s24**2
     +     + 64*s12**2*s24*s34 + 64*s12**2*s34**2 )

      LB = LB + Lc1(p23,p14)*S13**(-1)*S24**(-1) * ( 16*s12**4 + 48*
     +    s12**3*s14 + 32*s12**3*s34 - 12*s12**2*s14**2 - 60*s12**2*s14
     +    *s23 - 48*s12**2*s14*s34 - 60*s12**2*s23*s34 - 36*s12**2*
     +    s34**2 + 24*s12*s14**2*s23 + 24*s12*s14**2*s34 + 24*s12*s14*
     +    s23*s34 + 24*s12*s14*s34**2 )

      LB = LB + Lc1(p23,p14)*S13**(-1) * (  - 24*s12**3 - 8*s12**2*s14
     +     - 40*s12**2*s23 - 16*s12**2*s24 - 60*s12**2*s34 + 24*s12*
     +    s14**2 - 20*s12*s14*s23 - 20*s12*s14*s24 + 4*s12*s14*s34 + 8*
     +    s12*s23**2 - 56*s12*s23*s24 - 52*s12*s23*s34 - 64*s12*s24**2
     +     - 124*s12*s24*s34 - 60*s12*s34**2 + 8*s23**2*s24 + 8*s23*
     +    s24**2 + 8*s23*s24*s34 )

      LB = LB + Lc1(p23,p14)*S14**(-1)*S23**(-1)*S24**(-1) * ( 8*s12**4
     +    *s13 + 24*s12**4*s34 - 32*s12**3*s13**2 - 64*s12**3*s13*s34
     +     - 48*s12**3*s34**2 )

      LB = LB + Lc1(p23,p14)*S14**(-1)*S23**(-1) * ( 16*s12**4 - 40*
     +    s12**3*s13 - 16*s12**3*s24 - 72*s12**3*s34 - 32*s12**2*s13**2
     +     - 72*s12**2*s13*s24 - 88*s12**2*s13*s34 + 32*s12**2*s24**2
     +     - 64*s12**2*s24*s34 - 80*s12**2*s34**2 + 64*s12*s13*s24**2
     +     + 64*s12*s13*s24*s34 + 112*s12*s24**3 + 176*s12*s24**2*s34
     +     + 64*s12*s24*s34**2 + 24*s13*s24**3 + 24*s13*s24**2*s34 )

      LB = LB + Lc1(p23,p14)*S14**(-1)*S24**(-1) * ( 16*s12**4 - 48*
     +    s12**3*s13 - 64*s12**3*s34 )

      LB = LB + Lc1(p23,p14)*S14**(-1) * (  - 16*s12**3 - 72*s12**2*s13
     +     - 24*s12**2*s23 + 8*s12**2*s24 - 120*s12**2*s34 + 64*s12*s13
     +    *s24 - 24*s12*s23*s24 + 88*s12*s24**2 + 40*s12*s24*s34 + 24*
     +    s13*s24**2 )

      LB = LB + Lc1(p23,p14)*S23**(-1)*S24**(-1) * ( 8*s12**4 - 48*
     +    s12**3*s13 - 16*s12**3*s14 - 24*s12**2*s13**2 - 24*s12**2*s13
     +    *s14 + 40*s12**2*s13*s34 + 52*s12**2*s14*s34 + 88*s12**2*
     +    s34**2 + 32*s12*s13**2*s34 + 20*s12*s13*s14*s34 + 48*s12*s13*
     +    s34**2 - 12*s12*s14**2*s34 + 4*s12*s14*s34**2 + 16*s12*s34**3
     +     )

      LB = LB + Lc1(p23,p14)*S23**(-1) * ( 8*s12**3 - 28*s12**2*s13 - 8
     +    *s12**2*s14 - 20*s12**2*s24 + 24*s12**2*s34 - 60*s12*s13**2
     +     - 52*s12*s13*s14 - 8*s12*s13*s24 - 28*s12*s13*s34 + 8*s12*
     +    s14**2 - 8*s12*s14*s24 + 40*s12*s14*s34 + 36*s12*s24**2 + 28*
     +    s12*s24*s34 + 32*s12*s34**2 - 16*s13**3 - 8*s13**2*s14 - 24*
     +    s13**2*s24 - 16*s13**2*s34 + 8*s13*s14**2 - 24*s13*s14*s24 + 
     +    8*s13*s14*s34 - 24*s13*s24*s34 )

      LB = LB + Lc1(p23,p14)*S24**(-1) * (  - 28*s12**2*s13 - 40*s12**2
     +    *s14 - 60*s12**2*s23 - 64*s12**2*s34 + 28*s12*s13*s14 + 28*
     +    s12*s14**2 + 24*s12*s14*s23 + 52*s12*s14*s34 + 16*s13**2*s14
     +     + 8*s13*s14**2 - 8*s14**3 - 24*s14**2*s34 - 16*s14*s34**2 )

      LB = LB + Lc1(p23,p14) * (  - 80*s12**2 - 24*s12*s13 - 80*s12*s23
     +     - 44*s12*s24 - 104*s12*s34 + 24*s13*s14 - 8*s13*s24 + 24*
     +    s14**2 - 8*s14*s24 + 24*s14*s34 - 24*s23*s24 - 24*s24**2 - 32
     +    *s24*s34 )

      LB = LB + Lc1(p24,p13)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**4*s34**2 - 16*s12**3*s34**3 )

      LB = LB + Lc1(p24,p13)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**4*s34 - 16*s12**3*s34**2 )

      LB = LB + Lc1(p24,p13)*S13**(-1)*S14**(-1)*S24**(-1) * ( 8*s12**4
     +    *s23 + 24*s12**4*s34 - 24*s12**3*s23**2 - 64*s12**3*s23*s34
     +     - 56*s12**3*s34**2 + 64*s12**2*s23**3 + 72*s12**2*s23**2*s34
     +     - 24*s12**2*s23*s34**2 - 32*s12**2*s34**3 - 16*s12*s23**4 - 
     +    48*s12*s23**3*s34 - 48*s12*s23**2*s34**2 - 16*s12*s23*s34**3
     +     )

      LB = LB + Lc1(p24,p13)*S13**(-1)*S14**(-1) * ( 8*s12**4 - 40*
     +    s12**3*s23 - 16*s12**3*s24 - 56*s12**3*s34 + 32*s12**2*s23**2
     +     - 32*s12**2*s23*s24 - 24*s12**2*s23*s34 - 32*s12**2*s34**2
     +     + 16*s12*s23**2*s24 + 16*s12*s23*s24*s34 )

      LB = LB + Lc1(p24,p13)*S13**(-1)*S23**(-1)*S24**(-1) * ( 8*s12**4
     +    *s14 + 24*s12**4*s34 - 32*s12**3*s14**2 - 64*s12**3*s14*s34
     +     - 48*s12**3*s34**2 )

      LB = LB + Lc1(p24,p13)*S13**(-1)*S23**(-1) * ( 16*s12**4 - 48*
     +    s12**3*s14 - 64*s12**3*s34 )

      LB = LB + Lc1(p24,p13)*S13**(-1)*S24**(-1) * ( 16*s12**4 - 40*
     +    s12**3*s14 - 16*s12**3*s23 - 72*s12**3*s34 - 32*s12**2*s14**2
     +     - 72*s12**2*s14*s23 - 88*s12**2*s14*s34 + 32*s12**2*s23**2
     +     - 64*s12**2*s23*s34 - 80*s12**2*s34**2 + 64*s12*s14*s23**2
     +     + 64*s12*s14*s23*s34 + 112*s12*s23**3 + 176*s12*s23**2*s34
     +     + 64*s12*s23*s34**2 + 24*s14*s23**3 + 24*s14*s23**2*s34 )

      LB = LB + Lc1(p24,p13)*S13**(-1) * (  - 16*s12**3 - 72*s12**2*s14
     +     + 8*s12**2*s23 - 24*s12**2*s24 - 120*s12**2*s34 + 64*s12*s14
     +    *s23 + 88*s12*s23**2 - 24*s12*s23*s24 + 40*s12*s23*s34 + 24*
     +    s14*s23**2 )

      LB = LB + Lc1(p24,p13)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**4*s34 + 48*s12**3*s13*s34 + 32*s12**3*s34**2 - 12*s12**2
     +    *s13**2*s34 + 12*s12**2*s13*s34**2 + 24*s12**2*s34**3 )

      LB = LB + Lc1(p24,p13)*S14**(-1)*S23**(-1) * ( 16*s12**4 + 48*
     +    s12**3*s13 + 32*s12**3*s34 - 12*s12**2*s13**2 - 60*s12**2*s13
     +    *s24 - 48*s12**2*s13*s34 - 60*s12**2*s24*s34 - 36*s12**2*
     +    s34**2 + 24*s12*s13**2*s24 + 24*s12*s13**2*s34 + 24*s12*s13*
     +    s24*s34 + 24*s12*s13*s34**2 )

      LB = LB + Lc1(p24,p13)*S14**(-1)*S24**(-1) * ( 16*s12**4 + 48*
     +    s12**3*s13 - 24*s12**3*s23 + 8*s12**3*s34 - 12*s12**2*s13**2
     +     + 52*s12**2*s13*s23 + 64*s12**2*s13*s34 + 24*s12**2*s23**2
     +     + 64*s12**2*s23*s34 + 64*s12**2*s34**2 )

      LB = LB + Lc1(p24,p13)*S14**(-1) * (  - 24*s12**3 - 8*s12**2*s13
     +     - 16*s12**2*s23 - 40*s12**2*s24 - 60*s12**2*s34 + 24*s12*
     +    s13**2 - 20*s12*s13*s23 - 20*s12*s13*s24 + 4*s12*s13*s34 - 64
     +    *s12*s23**2 - 56*s12*s23*s24 - 124*s12*s23*s34 + 8*s12*s24**2
     +     - 52*s12*s24*s34 - 60*s12*s34**2 + 8*s23**2*s24 + 8*s23*
     +    s24**2 + 8*s23*s24*s34 )

      LB = LB + Lc1(p24,p13)*S23**(-1)*S24**(-1) * ( 8*s12**4 - 16*
     +    s12**3*s13 - 48*s12**3*s14 - 24*s12**2*s13*s14 + 52*s12**2*
     +    s13*s34 - 24*s12**2*s14**2 + 40*s12**2*s14*s34 + 88*s12**2*
     +    s34**2 - 12*s12*s13**2*s34 + 20*s12*s13*s14*s34 + 4*s12*s13*
     +    s34**2 + 32*s12*s14**2*s34 + 48*s12*s14*s34**2 + 16*s12*
     +    s34**3 )

      LB = LB + Lc1(p24,p13)*S23**(-1) * (  - 40*s12**2*s13 - 28*s12**2
     +    *s14 - 60*s12**2*s24 - 64*s12**2*s34 + 28*s12*s13**2 + 28*s12
     +    *s13*s14 + 24*s12*s13*s24 + 52*s12*s13*s34 - 8*s13**3 + 8*
     +    s13**2*s14 - 24*s13**2*s34 + 16*s13*s14**2 - 16*s13*s34**2 )

      LB = LB + Lc1(p24,p13)*S24**(-1) * ( 8*s12**3 - 8*s12**2*s13 - 28
     +    *s12**2*s14 - 20*s12**2*s23 + 24*s12**2*s34 + 8*s12*s13**2 - 
     +    52*s12*s13*s14 - 8*s12*s13*s23 + 40*s12*s13*s34 - 60*s12*
     +    s14**2 - 8*s12*s14*s23 - 28*s12*s14*s34 + 36*s12*s23**2 + 28*
     +    s12*s23*s34 + 32*s12*s34**2 + 8*s13**2*s14 - 8*s13*s14**2 - 
     +    24*s13*s14*s23 + 8*s13*s14*s34 - 16*s14**3 - 24*s14**2*s23 - 
     +    16*s14**2*s34 - 24*s14*s23*s34 )

      LB = LB + Lc1(p24,p13) * (  - 80*s12**2 - 24*s12*s14 - 44*s12*s23
     +     - 80*s12*s24 - 104*s12*s34 + 24*s13**2 + 24*s13*s14 - 8*s13*
     +    s23 + 24*s13*s34 - 8*s14*s23 - 24*s23**2 - 24*s23*s24 - 32*
     +    s23*s34 )

      LB = LB + Lc1(p34,p12)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 32*
     +    s24**5 - 16*s24**4*s34 )

      LB = LB + Lc1(p34,p12)*S13**(-1)*S14**(-1) * (  - 32*s23**4 - 144
     +    *s23**3*s24 - 272*s23**2*s24**2 - 16*s23**2*s24*s34 + 32*
     +    s23**2*s34**2 - 272*s23*s24**3 - 48*s23*s24**2*s34 + 64*s23*
     +    s24*s34**2 - 144*s24**4 - 48*s24**3*s34 + 32*s24**2*s34**2 )

      LB = LB + Lc1(p34,p12)*S13**(-1)*S23**(-1) * (  - 16*s14**4 - 128
     +    *s14**3*s24 + 16*s14**3*s34 - 304*s14**2*s24**2 + 16*s14**2*
     +    s24*s34 - 320*s14*s24**3 - 32*s14*s24**2*s34 - 160*s24**4 - 
     +    48*s24**3*s34 )

      LB = LB + Lc1(p34,p12)*S13**(-1)*S24**(-1) * ( 16*s14**4 - 48*
     +    s14**3*s23 + 16*s14**3*s34 - 48*s14**2*s23**2 + 48*s14**2*s23
     +    *s34 + 16*s14*s23**3 + 16*s14*s23**2*s34 - 32*s14*s23*s34**2
     +     + 32*s23**4 - 32*s23**2*s34**2 )

      LB = LB + Lc1(p34,p12)*S13**(-1) * (  - 112*s14**3 - 288*s14**2*
     +    s23 - 512*s14**2*s24 + 64*s14**2*s34 - 144*s14*s23**2 - 608*
     +    s14*s23*s24 + 48*s14*s23*s34 - 768*s14*s24**2 + 32*s14*s34**2
     +     - 304*s23**2*s24 - 640*s23*s24**2 - 48*s23*s24*s34 + 32*s23*
     +    s34**2 - 528*s24**3 - 96*s24**2*s34 + 64*s24*s34**2 )

      LB = LB + Lc2(p1,p234)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 12*
     +    s14**3*s34**2 - 16*s14**2*s34**3 )

      LB = LB + Lc2(p1,p234)*S13**(-1)*S23**(-1) * (  - 16*s14**3*s24
     +     - 28*s14**3*s34 - 16*s14**2*s24**2 - 48*s14**2*s24*s34 - 48*
     +    s14**2*s34**2 )

      LB = LB + Lc2(p1,p234)*S13**(-1)*S24**(-1) * (  - 12*s14**3*s23
     +     - 24*s14**3*s34 - 4*s14**2*s23**2 - 20*s14**2*s23*s34 - 32*
     +    s14**2*s34**2 )

      LB = LB + Lc2(p1,p234)*S13**(-1) * (  - 28*s14**3 - 8*s14**2*s23
     +     - 20*s14**2*s24 - 52*s14**2*s34 )

      LB = LB + Lc2(p1,p234)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 12*
     +    s13**3*s34**2 - 16*s13**2*s34**3 )

      LB = LB + Lc2(p1,p234)*S14**(-1)*S23**(-1) * (  - 12*s13**3*s24
     +     - 24*s13**3*s34 - 4*s13**2*s24**2 - 20*s13**2*s24*s34 - 32*
     +    s13**2*s34**2 )

      LB = LB + Lc2(p1,p234)*S14**(-1)*S24**(-1) * (  - 16*s13**3*s23
     +     - 28*s13**3*s34 - 16*s13**2*s23**2 - 48*s13**2*s23*s34 - 48*
     +    s13**2*s34**2 )

      LB = LB + Lc2(p1,p234)*S14**(-1) * (  - 28*s13**3 - 20*s13**2*s23
     +     - 8*s13**2*s24 - 52*s13**2*s34 )

      LB = LB + Lc2(p1,p234)*S23**(-1)*S24**(-1) * (  - 48*s13**2*
     +    s34**2 - 72*s13*s14*s34**2 - 48*s13*s34**3 - 48*s14**2*s34**2
     +     - 48*s14*s34**3 )

      LB = LB + Lc2(p1,p234)*S23**(-1) * (  - 56*s13**2*s24 - 104*
     +    s13**2*s34 - 84*s13*s14*s24 - 156*s13*s14*s34 - 24*s13*s24**2
     +     - 84*s13*s24*s34 - 108*s13*s34**2 - 56*s14**2*s24 - 104*
     +    s14**2*s34 - 32*s14*s24**2 - 100*s14*s24*s34 - 116*s14*s34**2
     +     )

      LB = LB + Lc2(p1,p234)*S24**(-1) * (  - 56*s13**2*s23 - 104*
     +    s13**2*s34 - 84*s13*s14*s23 - 156*s13*s14*s34 - 32*s13*s23**2
     +     - 100*s13*s23*s34 - 116*s13*s34**2 - 56*s14**2*s23 - 104*
     +    s14**2*s34 - 24*s14*s23**2 - 84*s14*s23*s34 - 108*s14*s34**2
     +     )

      LB = LB + Lc2(p1,p234) * (  - 112*s13**2 - 168*s13*s14 - 32*s13*
     +    s23 - 24*s13*s24 - 128*s13*s34 - 112*s14**2 - 24*s14*s23 - 32
     +    *s14*s24 - 128*s14*s34 )

      LB = LB + Lc2(p2,p134)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 12*
     +    s24**3*s34**2 - 16*s24**2*s34**3 )

      LB = LB + Lc2(p2,p134)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 12*
     +    s23**3*s34**2 - 16*s23**2*s34**3 )

      LB = LB + Lc2(p2,p134)*S13**(-1)*S14**(-1) * (  - 48*s23**2*
     +    s34**2 - 72*s23*s24*s34**2 - 48*s23*s34**3 - 48*s24**2*s34**2
     +     - 48*s24*s34**3 )

      LB = LB + Lc2(p2,p134)*S13**(-1)*S23**(-1) * (  - 16*s14**2*
     +    s24**2 - 16*s14*s24**3 - 48*s14*s24**2*s34 - 28*s24**3*s34 - 
     +    48*s24**2*s34**2 )

      LB = LB + Lc2(p2,p134)*S13**(-1)*S24**(-1) * (  - 4*s14**2*s23**2
     +     - 12*s14*s23**3 - 20*s14*s23**2*s34 - 24*s23**3*s34 - 32*
     +    s23**2*s34**2 )

      LB = LB + Lc2(p2,p134)*S13**(-1) * (  - 24*s14**2*s23 - 32*s14**2
     +    *s24 - 56*s14*s23**2 - 84*s14*s23*s24 - 84*s14*s23*s34 - 56*
     +    s14*s24**2 - 100*s14*s24*s34 - 104*s23**2*s34 - 156*s23*s24*
     +    s34 - 108*s23*s34**2 - 104*s24**2*s34 - 116*s24*s34**2 )

      LB = LB + Lc2(p2,p134)*S14**(-1)*S23**(-1) * (  - 4*s13**2*s24**2
     +     - 12*s13*s24**3 - 20*s13*s24**2*s34 - 24*s24**3*s34 - 32*
     +    s24**2*s34**2 )

      LB = LB + Lc2(p2,p134)*S14**(-1)*S24**(-1) * (  - 16*s13**2*
     +    s23**2 - 16*s13*s23**3 - 48*s13*s23**2*s34 - 28*s23**3*s34 - 
     +    48*s23**2*s34**2 )

      LB = LB + Lc2(p2,p134)*S14**(-1) * (  - 32*s13**2*s23 - 24*s13**2
     +    *s24 - 56*s13*s23**2 - 84*s13*s23*s24 - 100*s13*s23*s34 - 56*
     +    s13*s24**2 - 84*s13*s24*s34 - 104*s23**2*s34 - 156*s23*s24*
     +    s34 - 116*s23*s34**2 - 104*s24**2*s34 - 108*s24*s34**2 )

      LB = LB + Lc2(p2,p134)*S23**(-1) * (  - 8*s13*s24**2 - 20*s14*
     +    s24**2 - 28*s24**3 - 52*s24**2*s34 )

      LB = LB + Lc2(p2,p134)*S24**(-1) * (  - 20*s13*s23**2 - 8*s14*
     +    s23**2 - 28*s23**3 - 52*s23**2*s34 )

      LB = LB + Lc2(p2,p134) * (  - 32*s13*s23 - 24*s13*s24 - 24*s14*
     +    s23 - 32*s14*s24 - 112*s23**2 - 168*s23*s24 - 128*s23*s34 - 
     +    112*s24**2 - 128*s24*s34 )

      LB = LB + Lc2(p3,p14)*S13**(-1)*S14**(-1)*S23**(-1) * ( 4*s12**2*
     +    s24*s34**2 + 4*s12**2*s34**3 + 8*s12*s24**2*s34**2 + 8*s12*
     +    s24*s34**3 + 4*s24**3*s34**2 + 4*s24**2*s34**3 )

      LB = LB + Lc2(p3,p14)*S13**(-1)*S14**(-1) * ( 4*s12**2*s34**2 - 4
     +    *s12*s23*s34**2 + 4*s12*s24*s34**2 - 4*s12*s34**3 - 8*s23**2*
     +    s34**2 - 12*s23*s24*s34**2 - 8*s23*s34**3 - 4*s24*s34**3 )

      LB = LB + Lc2(p3,p14)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 4*
     +    s12**2*s34**3 - 8*s12*s14*s34**3 )

      LB = LB + Lc2(p3,p14)*S13**(-1)*S23**(-1) * (  - 8*s12**2*s34**2
     +     + 4*s12*s34**3 + 8*s24**2*s34**2 + 8*s24*s34**3 )

      LB = LB + Lc2(p3,p14)*S13**(-1)*S24**(-1) * (  - 4*s12**2*s23*s34
     +     - 8*s12**2*s34**2 - 8*s12*s14*s23*s34 - 16*s12*s14*s34**2 - 
     +    4*s12*s23**2*s34 - 8*s12*s23*s34**2 - 4*s12*s34**3 + 16*
     +    s14**2*s23**2 + 20*s14**2*s23*s34 + 8*s14**2*s34**2 + 4*s14*
     +    s23**3 + 8*s14*s23**2*s34 + 4*s14*s23*s34**2 )

      LB = LB + Lc2(p3,p14)*S13**(-1) * (  - 4*s12**2*s34 + 4*s12*s23*
     +    s34 + 8*s12*s24*s34 + 8*s12*s34**2 + 8*s14**2*s23 + 4*s14**2*
     +    s34 + 12*s14*s23**2 + 8*s14*s23*s24 + 36*s14*s23*s34 + 16*s14
     +    *s24*s34 + 20*s14*s34**2 + 12*s23*s24*s34 - 12*s23*s34**2 + 
     +    12*s24**2*s34 + 8*s24*s34**2 - 12*s34**3 )

      LB = LB + Lc2(p3,p14)*SF*S13**(-1)*S24**(-1) * (  - 8*s14*s23**2
     +     )

      LB = LB + Lc2(p3,p14)*SF*S13**(-1) * (  - 8*s14*s23 )

      LB = LB + Lc2(p3,p24)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 4*
     +    s12**2*s34**3 - 8*s12*s24*s34**3 )

      LB = LB + Lc2(p3,p24)*S13**(-1)*S23**(-1)*S24**(-1) * ( 4*s12**2*
     +    s14*s34**2 + 4*s12**2*s34**3 + 8*s12*s14**2*s34**2 + 8*s12*
     +    s14*s34**3 + 4*s14**3*s34**2 + 4*s14**2*s34**3 )

      LB = LB + Lc2(p3,p24)*S13**(-1)*S23**(-1) * (  - 8*s12**2*s34**2
     +     + 4*s12*s34**3 + 8*s14**2*s34**2 + 8*s14*s34**3 )

      LB = LB + Lc2(p3,p24)*S14**(-1)*S23**(-1) * (  - 4*s12**2*s13*s34
     +     - 8*s12**2*s34**2 - 4*s12*s13**2*s34 - 8*s12*s13*s24*s34 - 8
     +    *s12*s13*s34**2 - 16*s12*s24*s34**2 - 4*s12*s34**3 + 4*s13**3
     +    *s24 + 16*s13**2*s24**2 + 8*s13**2*s24*s34 + 20*s13*s24**2*
     +    s34 + 4*s13*s24*s34**2 + 8*s24**2*s34**2 )

      LB = LB + Lc2(p3,p24)*S23**(-1)*S24**(-1) * ( 4*s12**2*s34**2 - 4
     +    *s12*s13*s34**2 + 4*s12*s14*s34**2 - 4*s12*s34**3 - 8*s13**2*
     +    s34**2 - 12*s13*s14*s34**2 - 8*s13*s34**3 - 4*s14*s34**3 )

      LB = LB + Lc2(p3,p24)*S23**(-1) * (  - 4*s12**2*s34 + 4*s12*s13*
     +    s34 + 8*s12*s14*s34 + 8*s12*s34**2 + 12*s13**2*s24 + 8*s13*
     +    s14*s24 + 12*s13*s14*s34 + 8*s13*s24**2 + 36*s13*s24*s34 - 12
     +    *s13*s34**2 + 12*s14**2*s34 + 16*s14*s24*s34 + 8*s14*s34**2
     +     + 4*s24**2*s34 + 20*s24*s34**2 - 12*s34**3 )

      LB = LB + Lc2(p3,p24)*SF*S14**(-1)*S23**(-1) * ( 8*s13**2*s24 )

      LB = LB + Lc2(p3,p24)*SF*S23**(-1) * ( 8*s13*s24 )

      LB = LB + Lc2(p3,p124)*S13**(-1)*S14**(-1)*S23**(-1) * ( 28*
     +    s12**2*s34**3 + 24*s12*s24*s34**3 )

      LB = LB + Lc2(p3,p124)*S13**(-1)*S23**(-1) * ( 4*s12**2*s34**2 + 
     +    4*s12*s14*s34**2 + 16*s12*s24*s34**2 + 32*s12*s34**3 + 16*s14
     +    *s24*s34**2 + 4*s14*s34**3 + 8*s24*s34**3 )

      LB = LB + Lc2(p3,p124)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 96*
     +    s12**2*s13**3 - 192*s12**2*s13**2*s34 - 132*s12**2*s13*s34**2
     +     - 36*s12**2*s34**3 )

      LB = LB + Lc2(p3,p124)*S14**(-1)*S23**(-1) * ( 60*s12**2*s13**2
     +     + 136*s12**2*s13*s34 + 104*s12**2*s34**2 - 164*s12*s13**3 + 
     +    132*s12*s13**2*s24 - 240*s12*s13**2*s34 + 116*s12*s13*s24*s34
     +     - 108*s12*s13*s34**2 + 88*s12*s24*s34**2 - 32*s12*s34**3 - 
     +    20*s13**3*s24 + 16*s13**3*s34 + 24*s13**2*s24**2 - 36*s13**2*
     +    s24*s34 + 16*s13**2*s34**2 + 16*s13*s24**2*s34 + 8*s24**2*
     +    s34**2 )

      LB = LB + Lc2(p3,p124)*S23**(-1)*S24**(-1) * (  - 60*s12**2*
     +    s13**2 - 44*s12**2*s13*s34 - 12*s12**2*s34**2 - 164*s12*
     +    s13**3 - 132*s12*s13**2*s14 - 256*s12*s13**2*s34 - 120*s12*
     +    s13*s14*s34 - 132*s12*s13*s34**2 - 12*s12*s14*s34**2 - 40*s12
     +    *s34**3 - 20*s13**3*s14 + 16*s13**3*s34 - 24*s13**2*s14**2 - 
     +    12*s13**2*s14*s34 + 16*s13**2*s34**2 - 24*s13*s14**2*s34 + 4*
     +    s13*s14*s34**2 - 4*s14*s34**3 )

      LB = LB + Lc2(p3,p124)*S23**(-1) * ( 24*s12**2*s13 + 24*s12**2*
     +    s34 + 116*s12*s13*s14 + 116*s12*s13*s24 + 4*s12*s13*s34 + 24*
     +    s12*s14*s34 + 48*s12*s24*s34 + 84*s12*s34**2 - 32*s13**3 - 28
     +    *s13**2*s14 + 28*s13**2*s24 - 32*s13**2*s34 + 24*s13*s14**2
     +     + 64*s13*s14*s24 - 52*s13*s14*s34 + 24*s13*s24**2 + 16*s13*
     +    s34**2 + 8*s14**2*s34 + 32*s14*s24*s34 + 4*s14*s34**2 + 8*
     +    s24**2*s34 + 24*s24*s34**2 )

      LB = LB + Lc2(p4,p13)*S13**(-1)*S14**(-1)*S24**(-1) * ( 4*s12**2*
     +    s23*s34**2 + 4*s12**2*s34**3 + 8*s12*s23**2*s34**2 + 8*s12*
     +    s23*s34**3 + 4*s23**3*s34**2 + 4*s23**2*s34**3 )

      LB = LB + Lc2(p4,p13)*S13**(-1)*S14**(-1) * ( 4*s12**2*s34**2 + 4
     +    *s12*s23*s34**2 - 4*s12*s24*s34**2 - 4*s12*s34**3 - 12*s23*
     +    s24*s34**2 - 4*s23*s34**3 - 8*s24**2*s34**2 - 8*s24*s34**3 )

      LB = LB + Lc2(p4,p13)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 4*
     +    s12**2*s34**3 - 8*s12*s13*s34**3 )

      LB = LB + Lc2(p4,p13)*S14**(-1)*S23**(-1) * (  - 4*s12**2*s24*s34
     +     - 8*s12**2*s34**2 - 8*s12*s13*s24*s34 - 16*s12*s13*s34**2 - 
     +    4*s12*s24**2*s34 - 8*s12*s24*s34**2 - 4*s12*s34**3 + 16*
     +    s13**2*s24**2 + 20*s13**2*s24*s34 + 8*s13**2*s34**2 + 4*s13*
     +    s24**3 + 8*s13*s24**2*s34 + 4*s13*s24*s34**2 )

      LB = LB + Lc2(p4,p13)*S14**(-1)*S24**(-1) * (  - 8*s12**2*s34**2
     +     + 4*s12*s34**3 + 8*s23**2*s34**2 + 8*s23*s34**3 )

      LB = LB + Lc2(p4,p13)*S14**(-1) * (  - 4*s12**2*s34 + 8*s12*s23*
     +    s34 + 4*s12*s24*s34 + 8*s12*s34**2 + 8*s13**2*s24 + 4*s13**2*
     +    s34 + 8*s13*s23*s24 + 16*s13*s23*s34 + 12*s13*s24**2 + 36*s13
     +    *s24*s34 + 20*s13*s34**2 + 12*s23**2*s34 + 12*s23*s24*s34 + 8
     +    *s23*s34**2 - 12*s24*s34**2 - 12*s34**3 )

      LB = LB + Lc2(p4,p13)*SF*S14**(-1)*S23**(-1) * ( 8*s13*s24**2 )

      LB = LB + Lc2(p4,p13)*SF*S14**(-1) * ( 8*s13*s24 )

      LB = LB + Lc2(p4,p23)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 4*
     +    s12**2*s34**3 - 8*s12*s23*s34**3 )

      LB = LB + Lc2(p4,p23)*S13**(-1)*S24**(-1) * (  - 4*s12**2*s14*s34
     +     - 8*s12**2*s34**2 - 4*s12*s14**2*s34 - 8*s12*s14*s23*s34 - 8
     +    *s12*s14*s34**2 - 16*s12*s23*s34**2 - 4*s12*s34**3 + 4*s14**3
     +    *s23 + 16*s14**2*s23**2 + 8*s14**2*s23*s34 + 20*s14*s23**2*
     +    s34 + 4*s14*s23*s34**2 + 8*s23**2*s34**2 )

      LB = LB + Lc2(p4,p23)*S14**(-1)*S23**(-1)*S24**(-1) * ( 4*s12**2*
     +    s13*s34**2 + 4*s12**2*s34**3 + 8*s12*s13**2*s34**2 + 8*s12*
     +    s13*s34**3 + 4*s13**3*s34**2 + 4*s13**2*s34**3 )

      LB = LB + Lc2(p4,p23)*S14**(-1)*S24**(-1) * (  - 8*s12**2*s34**2
     +     + 4*s12*s34**3 + 8*s13**2*s34**2 + 8*s13*s34**3 )

      LB = LB + Lc2(p4,p23)*S23**(-1)*S24**(-1) * ( 4*s12**2*s34**2 + 4
     +    *s12*s13*s34**2 - 4*s12*s14*s34**2 - 4*s12*s34**3 - 12*s13*
     +    s14*s34**2 - 4*s13*s34**3 - 8*s14**2*s34**2 - 8*s14*s34**3 )

      LB = LB + Lc2(p4,p23)*S24**(-1) * (  - 4*s12**2*s34 + 8*s12*s13*
     +    s34 + 4*s12*s14*s34 + 8*s12*s34**2 + 12*s13**2*s34 + 8*s13*
     +    s14*s23 + 12*s13*s14*s34 + 16*s13*s23*s34 + 8*s13*s34**2 + 12
     +    *s14**2*s23 + 8*s14*s23**2 + 36*s14*s23*s34 - 12*s14*s34**2
     +     + 4*s23**2*s34 + 20*s23*s34**2 - 12*s34**3 )

      LB = LB + Lc2(p4,p23)*SF*S13**(-1)*S24**(-1) * (  - 8*s14**2*s23
     +     )

      LB = LB + Lc2(p4,p23)*SF*S24**(-1) * (  - 8*s14*s23 )

      LB = LB + Lc2(p4,p123)*S13**(-1)*S14**(-1)*S24**(-1) * ( 28*
     +    s12**2*s34**3 + 24*s12*s23*s34**3 )

      LB = LB + Lc2(p4,p123)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 96*
     +    s12**2*s14**3 - 192*s12**2*s14**2*s34 - 132*s12**2*s14*s34**2
     +     - 36*s12**2*s34**3 )

      LB = LB + Lc2(p4,p123)*S13**(-1)*S24**(-1) * ( 60*s12**2*s14**2
     +     + 136*s12**2*s14*s34 + 104*s12**2*s34**2 - 164*s12*s14**3 + 
     +    132*s12*s14**2*s23 - 240*s12*s14**2*s34 + 116*s12*s14*s23*s34
     +     - 108*s12*s14*s34**2 + 88*s12*s23*s34**2 - 32*s12*s34**3 - 
     +    20*s14**3*s23 + 16*s14**3*s34 + 24*s14**2*s23**2 - 36*s14**2*
     +    s23*s34 + 16*s14**2*s34**2 + 16*s14*s23**2*s34 + 8*s23**2*
     +    s34**2 )

      LB = LB + Lc2(p4,p123)*S14**(-1)*S24**(-1) * ( 4*s12**2*s34**2 + 
     +    4*s12*s13*s34**2 + 16*s12*s23*s34**2 + 32*s12*s34**3 + 16*s13
     +    *s23*s34**2 + 4*s13*s34**3 + 8*s23*s34**3 )

      LB = LB + Lc2(p4,p123)*S23**(-1)*S24**(-1) * (  - 60*s12**2*
     +    s14**2 - 44*s12**2*s14*s34 - 12*s12**2*s34**2 - 132*s12*s13*
     +    s14**2 - 120*s12*s13*s14*s34 - 12*s12*s13*s34**2 - 164*s12*
     +    s14**3 - 256*s12*s14**2*s34 - 132*s12*s14*s34**2 - 40*s12*
     +    s34**3 - 24*s13**2*s14**2 - 24*s13**2*s14*s34 - 20*s13*s14**3
     +     - 12*s13*s14**2*s34 + 4*s13*s14*s34**2 - 4*s13*s34**3 + 16*
     +    s14**3*s34 + 16*s14**2*s34**2 )

      LB = LB + Lc2(p4,p123)*S24**(-1) * ( 24*s12**2*s14 + 24*s12**2*
     +    s34 + 116*s12*s13*s14 + 24*s12*s13*s34 + 116*s12*s14*s23 + 4*
     +    s12*s14*s34 + 48*s12*s23*s34 + 84*s12*s34**2 + 24*s13**2*s14
     +     + 8*s13**2*s34 - 28*s13*s14**2 + 64*s13*s14*s23 - 52*s13*s14
     +    *s34 + 32*s13*s23*s34 + 4*s13*s34**2 - 32*s14**3 + 28*s14**2*
     +    s23 - 32*s14**2*s34 + 24*s14*s23**2 + 16*s14*s34**2 + 8*
     +    s23**2*s34 + 24*s23*s34**2 )

      LBc=-LB/s134/s234
      
      return
      end

      function LBd(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      SF=(s13*s24-s14*s23)/2d0/s34

      LB=0d0

      LB = LB + Lc2(p13,p24)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 16*s12**4*s34**2 + 16*s12**3*s34**3 )

      LB = LB + Lc2(p13,p24)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16*
     +    s12**4*s34 - 24*s12**3*s24*s34 - 8*s12**3*s34**2 - 16*s12**2*
     +    s24*s34**2 - 16*s12**2*s34**3 )

      LB = LB + Lc2(p13,p24)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16*
     +    s12**4*s23 - 32*s12**4*s34 + 96*s12**3*s23**2 + 208*s12**3*
     +    s23*s34 + 128*s12**3*s34**2 - 24*s12**2*s23**3 - 32*s12**2*
     +    s23**2*s34 + 8*s12**2*s23*s34**2 + 16*s12**2*s34**3 )

      LB = LB + Lc2(p13,p24)*S13**(-1)*S14**(-1) * (  - 16*s12**4 + 96*
     +    s12**3*s23 + 88*s12**3*s34 + 24*s12**2*s23**2 + 48*s12**2*s23
     +    *s24 + 40*s12**2*s23*s34 - 24*s12*s23**3 - 24*s12*s23**2*s24
     +     - 72*s12*s23**2*s34 - 48*s12*s23*s24*s34 - 64*s12*s23*s34**2
     +     - 16*s12*s24*s34**2 - 16*s12*s34**3 )

      LB = LB + Lc2(p13,p24)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**4*s14 - 32*s12**4*s34 + 96*s12**3*s14**2 + 208*s12**3*
     +    s14*s34 + 128*s12**3*s34**2 - 24*s12**2*s14**3 - 32*s12**2*
     +    s14**2*s34 + 8*s12**2*s14*s34**2 + 16*s12**2*s34**3 )

      LB = LB + Lc2(p13,p24)*S13**(-1)*S23**(-1) * (  - 16*s12**4 + 104
     +    *s12**3*s14 - 24*s12**3*s24 + 96*s12**3*s34 - 16*s12**2*
     +    s14**2 - 24*s12**2*s14*s24 - 24*s12**2*s14*s34 - 40*s12**2*
     +    s24*s34 - 24*s12**2*s34**2 )

      LB = LB + Lc2(p13,p24)*S13**(-1)*S24**(-1) * (  - 16*s12**4 + 88*
     +    s12**3*s14 + 88*s12**3*s23 + 192*s12**3*s34 + 72*s12**2*
     +    s14**2 + 224*s12**2*s14*s23 + 320*s12**2*s14*s34 + 72*s12**2*
     +    s23**2 + 320*s12**2*s23*s34 + 272*s12**2*s34**2 - 32*s12*
     +    s14**3 - 24*s12*s14**2*s23 - 40*s12*s14**2*s34 - 24*s12*s14*
     +    s23**2 - 32*s12*s14*s23*s34 + 8*s12*s14*s34**2 - 32*s12*
     +    s23**3 - 40*s12*s23**2*s34 + 8*s12*s23*s34**2 + 16*s12*s34**3
     +     - 8*s14**3*s23 - 8*s14**2*s23*s34 - 8*s14*s23**3 - 8*s14*
     +    s23**2*s34 )

      LB = LB + Lc2(p13,p24)*S13**(-1) * ( 64*s12**3 + 200*s12**2*s14
     +     + 112*s12**2*s23 + 40*s12**2*s24 + 248*s12**2*s34 - 16*s12*
     +    s14**2 + 32*s12*s14*s23 + 56*s12*s14*s24 + 56*s12*s14*s34 + 
     +    24*s12*s23**2 + 56*s12*s23*s24 + 64*s12*s23*s34 + 16*s12*s24*
     +    s34 + 32*s12*s34**2 + 8*s14*s23*s24 + 8*s14*s23*s34 - 8*
     +    s23**3 - 8*s23**2*s24 - 24*s23**2*s34 - 16*s23*s24*s34 - 16*
     +    s23*s34**2 )

      LB = LB + Lc2(p13,p24)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**4*s34 - 24*s12**3*s13*s34 - 8*s12**3*s34**2 - 16*s12**2*
     +    s13*s34**2 - 16*s12**2*s34**3 )

      LB = LB + Lc2(p13,p24)*S14**(-1)*S23**(-1) * (  - 16*s12**4 - 24*
     +    s12**3*s13 - 24*s12**3*s24 - 32*s12**3*s34 + 80*s12**2*s13*
     +    s24 + 64*s12**2*s13*s34 + 64*s12**2*s24*s34 + 48*s12**2*
     +    s34**2 - 8*s12*s13**2*s24 - 8*s12*s13**2*s34 - 8*s12*s13*
     +    s24**2 + 8*s12*s13*s34**2 - 8*s12*s24**2*s34 + 8*s12*s24*
     +    s34**2 + 16*s12*s34**3 )

      LB = LB + Lc2(p13,p24)*S14**(-1)*S24**(-1) * (  - 16*s12**4 - 24*
     +    s12**3*s13 + 104*s12**3*s23 + 96*s12**3*s34 - 24*s12**2*s13*
     +    s23 - 40*s12**2*s13*s34 - 16*s12**2*s23**2 - 24*s12**2*s23*
     +    s34 - 24*s12**2*s34**2 )

      LB = LB + Lc2(p13,p24)*S14**(-1) * ( 80*s12**3 + 56*s12**2*s13 + 
     +    32*s12**2*s23 + 48*s12**2*s24 + 104*s12**2*s34 - 8*s12*s13**2
     +     + 56*s12*s13*s23 + 48*s12*s13*s24 + 64*s12*s13*s34 - 16*s12*
     +    s23*s24 + 64*s12*s23*s34 - 16*s12*s24**2 + 40*s12*s24*s34 + 
     +    80*s12*s34**2 + 8*s13*s23*s24 + 8*s13*s24**2 + 8*s13*s24*s34
     +     - 16*s23**2*s24 - 16*s23*s24**2 - 24*s23*s24*s34 - 8*s24**2*
     +    s34 - 8*s24*s34**2 )

      LB = LB + Lc2(p13,p24)*S23**(-1)*S24**(-1) * (  - 16*s12**4 + 96*
     +    s12**3*s14 + 88*s12**3*s34 + 48*s12**2*s13*s14 + 24*s12**2*
     +    s14**2 + 40*s12**2*s14*s34 - 24*s12*s13*s14**2 - 48*s12*s13*
     +    s14*s34 - 16*s12*s13*s34**2 - 24*s12*s14**3 - 72*s12*s14**2*
     +    s34 - 64*s12*s14*s34**2 - 16*s12*s34**3 )

      LB = LB + Lc2(p13,p24)*S23**(-1) * ( 80*s12**3 + 48*s12**2*s13 + 
     +    32*s12**2*s14 + 56*s12**2*s24 + 104*s12**2*s34 - 16*s12*
     +    s13**2 - 16*s12*s13*s14 + 48*s12*s13*s24 + 40*s12*s13*s34 + 
     +    56*s12*s14*s24 + 64*s12*s14*s34 - 8*s12*s24**2 + 64*s12*s24*
     +    s34 + 80*s12*s34**2 - 16*s13**2*s14 + 8*s13**2*s24 - 8*s13**2
     +    *s34 - 16*s13*s14**2 + 8*s13*s14*s24 - 24*s13*s14*s34 + 8*s13
     +    *s24*s34 - 8*s13*s34**2 )

      LB = LB + Lc2(p13,p24)*S24**(-1) * ( 64*s12**3 + 40*s12**2*s13 + 
     +    112*s12**2*s14 + 200*s12**2*s23 + 248*s12**2*s34 + 56*s12*s13
     +    *s14 + 56*s12*s13*s23 + 16*s12*s13*s34 + 24*s12*s14**2 + 32*
     +    s12*s14*s23 + 64*s12*s14*s34 - 16*s12*s23**2 + 56*s12*s23*s34
     +     + 32*s12*s34**2 - 8*s13*s14**2 + 8*s13*s14*s23 - 16*s13*s14*
     +    s34 - 8*s14**3 - 24*s14**2*s34 + 8*s14*s23*s34 - 16*s14*
     +    s34**2 )

      LB = LB + Lc2(p13,p24) * ( 256*s12**2 + 128*s12*s13 + 120*s12*s14
     +     + 120*s12*s23 + 128*s12*s24 + 304*s12*s34 + 8*s13*s14 + 48*
     +    s13*s23 + 32*s13*s24 + 48*s13*s34 + 8*s14**2 + 64*s14*s23 + 
     +    48*s14*s24 + 72*s14*s34 + 8*s23**2 + 8*s23*s24 + 72*s23*s34
     +     + 48*s24*s34 + 64*s34**2 )

      LB = LB + Lc2(p14,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 16*s12**4*s34**2 + 16*s12**3*s34**3 )

      LB = LB + Lc2(p14,p23)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16*
     +    s12**4*s24 - 32*s12**4*s34 + 96*s12**3*s24**2 + 208*s12**3*
     +    s24*s34 + 128*s12**3*s34**2 - 24*s12**2*s24**3 - 32*s12**2*
     +    s24**2*s34 + 8*s12**2*s24*s34**2 + 16*s12**2*s34**3 )

      LB = LB + Lc2(p14,p23)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16*
     +    s12**4*s34 - 24*s12**3*s23*s34 - 8*s12**3*s34**2 - 16*s12**2*
     +    s23*s34**2 - 16*s12**2*s34**3 )

      LB = LB + Lc2(p14,p23)*S13**(-1)*S14**(-1) * (  - 16*s12**4 + 96*
     +    s12**3*s24 + 88*s12**3*s34 + 48*s12**2*s23*s24 + 24*s12**2*
     +    s24**2 + 40*s12**2*s24*s34 - 24*s12*s23*s24**2 - 48*s12*s23*
     +    s24*s34 - 16*s12*s23*s34**2 - 24*s12*s24**3 - 72*s12*s24**2*
     +    s34 - 64*s12*s24*s34**2 - 16*s12*s34**3 )

      LB = LB + Lc2(p14,p23)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**4*s34 - 24*s12**3*s14*s34 - 8*s12**3*s34**2 - 16*s12**2*
     +    s14*s34**2 - 16*s12**2*s34**3 )

      LB = LB + Lc2(p14,p23)*S13**(-1)*S23**(-1) * (  - 16*s12**4 - 24*
     +    s12**3*s14 + 104*s12**3*s24 + 96*s12**3*s34 - 24*s12**2*s14*
     +    s24 - 40*s12**2*s14*s34 - 16*s12**2*s24**2 - 24*s12**2*s24*
     +    s34 - 24*s12**2*s34**2 )

      LB = LB + Lc2(p14,p23)*S13**(-1)*S24**(-1) * (  - 16*s12**4 - 24*
     +    s12**3*s14 - 24*s12**3*s23 - 32*s12**3*s34 + 80*s12**2*s14*
     +    s23 + 64*s12**2*s14*s34 + 64*s12**2*s23*s34 + 48*s12**2*
     +    s34**2 - 8*s12*s14**2*s23 - 8*s12*s14**2*s34 - 8*s12*s14*
     +    s23**2 + 8*s12*s14*s34**2 - 8*s12*s23**2*s34 + 8*s12*s23*
     +    s34**2 + 16*s12*s34**3 )

      LB = LB + Lc2(p14,p23)*S13**(-1) * ( 80*s12**3 + 56*s12**2*s14 + 
     +    48*s12**2*s23 + 32*s12**2*s24 + 104*s12**2*s34 - 8*s12*s14**2
     +     + 48*s12*s14*s23 + 56*s12*s14*s24 + 64*s12*s14*s34 - 16*s12*
     +    s23**2 - 16*s12*s23*s24 + 40*s12*s23*s34 + 64*s12*s24*s34 + 
     +    80*s12*s34**2 + 8*s14*s23**2 + 8*s14*s23*s24 + 8*s14*s23*s34
     +     - 16*s23**2*s24 - 8*s23**2*s34 - 16*s23*s24**2 - 24*s23*s24*
     +    s34 - 8*s23*s34**2 )

      LB = LB + Lc2(p14,p23)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**4*s13 - 32*s12**4*s34 + 96*s12**3*s13**2 + 208*s12**3*
     +    s13*s34 + 128*s12**3*s34**2 - 24*s12**2*s13**3 - 32*s12**2*
     +    s13**2*s34 + 8*s12**2*s13*s34**2 + 16*s12**2*s34**3 )

      LB = LB + Lc2(p14,p23)*S14**(-1)*S23**(-1) * (  - 16*s12**4 + 88*
     +    s12**3*s13 + 88*s12**3*s24 + 192*s12**3*s34 + 72*s12**2*
     +    s13**2 + 224*s12**2*s13*s24 + 320*s12**2*s13*s34 + 72*s12**2*
     +    s24**2 + 320*s12**2*s24*s34 + 272*s12**2*s34**2 - 32*s12*
     +    s13**3 - 24*s12*s13**2*s24 - 40*s12*s13**2*s34 - 24*s12*s13*
     +    s24**2 - 32*s12*s13*s24*s34 + 8*s12*s13*s34**2 - 32*s12*
     +    s24**3 - 40*s12*s24**2*s34 + 8*s12*s24*s34**2 + 16*s12*s34**3
     +     - 8*s13**3*s24 - 8*s13**2*s24*s34 - 8*s13*s24**3 - 8*s13*
     +    s24**2*s34 )

      LB = LB + Lc2(p14,p23)*S14**(-1)*S24**(-1) * (  - 16*s12**4 + 104
     +    *s12**3*s13 - 24*s12**3*s23 + 96*s12**3*s34 - 16*s12**2*
     +    s13**2 - 24*s12**2*s13*s23 - 24*s12**2*s13*s34 - 40*s12**2*
     +    s23*s34 - 24*s12**2*s34**2 )

      LB = LB + Lc2(p14,p23)*S14**(-1) * ( 64*s12**3 + 200*s12**2*s13
     +     + 40*s12**2*s23 + 112*s12**2*s24 + 248*s12**2*s34 - 16*s12*
     +    s13**2 + 56*s12*s13*s23 + 32*s12*s13*s24 + 56*s12*s13*s34 + 
     +    56*s12*s23*s24 + 16*s12*s23*s34 + 24*s12*s24**2 + 64*s12*s24*
     +    s34 + 32*s12*s34**2 + 8*s13*s23*s24 + 8*s13*s24*s34 - 8*s23*
     +    s24**2 - 16*s23*s24*s34 - 8*s24**3 - 24*s24**2*s34 - 16*s24*
     +    s34**2 )

      LB = LB + Lc2(p14,p23)*S23**(-1)*S24**(-1) * (  - 16*s12**4 + 96*
     +    s12**3*s13 + 88*s12**3*s34 + 24*s12**2*s13**2 + 48*s12**2*s13
     +    *s14 + 40*s12**2*s13*s34 - 24*s12*s13**3 - 24*s12*s13**2*s14
     +     - 72*s12*s13**2*s34 - 48*s12*s13*s14*s34 - 64*s12*s13*s34**2
     +     - 16*s12*s14*s34**2 - 16*s12*s34**3 )

      LB = LB + Lc2(p14,p23)*S23**(-1) * ( 64*s12**3 + 112*s12**2*s13
     +     + 40*s12**2*s14 + 200*s12**2*s24 + 248*s12**2*s34 + 24*s12*
     +    s13**2 + 56*s12*s13*s14 + 32*s12*s13*s24 + 64*s12*s13*s34 + 
     +    56*s12*s14*s24 + 16*s12*s14*s34 - 16*s12*s24**2 + 56*s12*s24*
     +    s34 + 32*s12*s34**2 - 8*s13**3 - 8*s13**2*s14 - 24*s13**2*s34
     +     + 8*s13*s14*s24 - 16*s13*s14*s34 + 8*s13*s24*s34 - 16*s13*
     +    s34**2 )

      LB = LB + Lc2(p14,p23)*S24**(-1) * ( 80*s12**3 + 32*s12**2*s13 + 
     +    48*s12**2*s14 + 56*s12**2*s23 + 104*s12**2*s34 - 16*s12*s13*
     +    s14 + 56*s12*s13*s23 + 64*s12*s13*s34 - 16*s12*s14**2 + 48*
     +    s12*s14*s23 + 40*s12*s14*s34 - 8*s12*s23**2 + 64*s12*s23*s34
     +     + 80*s12*s34**2 - 16*s13**2*s14 - 16*s13*s14**2 + 8*s13*s14*
     +    s23 - 24*s13*s14*s34 + 8*s14**2*s23 - 8*s14**2*s34 + 8*s14*
     +    s23*s34 - 8*s14*s34**2 )

      LB = LB + Lc2(p14,p23) * ( 256*s12**2 + 120*s12*s13 + 128*s12*s14
     +     + 128*s12*s23 + 120*s12*s24 + 304*s12*s34 + 8*s13**2 + 8*s13
     +    *s14 + 48*s13*s23 + 64*s13*s24 + 72*s13*s34 + 32*s14*s23 + 48
     +    *s14*s24 + 48*s14*s34 + 8*s23*s24 + 48*s23*s34 + 8*s24**2 + 
     +    72*s24*s34 + 64*s34**2 )

      LB = LB + Lc3(p13,p24)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 32*s12**4*s34**2 + 8*s12**3*s34**3 )

      LB = LB + Lc3(p13,p24)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 32*
     +    s12**4*s34 - 80*s12**3*s24*s34 - 72*s12**3*s34**2 - 8*s12**2*
     +    s24**2*s34 - 24*s12**2*s24*s34**2 - 16*s12**2*s34**3 + 8*s12*
     +    s24**2*s34**2 + 8*s12*s24*s34**3 )

      LB = LB + Lc3(p13,p24)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 32*
     +    s12**4*s23 - 64*s12**4*s34 + 24*s12**3*s23**2 + 48*s12**3*s23
     +    *s34 + 32*s12**3*s34**2 )

      LB = LB + Lc3(p13,p24)*S13**(-1)*S14**(-1) * (  - 32*s12**4 - 24*
     +    s12**3*s23 - 48*s12**3*s24 - 104*s12**3*s34 - 24*s12**2*s23*
     +    s24 - 32*s12**2*s23*s34 - 24*s12**2*s24**2 - 64*s12**2*s24*
     +    s34 - 48*s12**2*s34**2 + 16*s12*s23*s24*s34 + 16*s12*s24**2*
     +    s34 + 24*s12*s24*s34**2 )

      LB = LB + Lc3(p13,p24)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**4*s14 - 40*s12**4*s34 + 24*s12**3*s14**2 + 40*s12**3*s14
     +    *s34 + 24*s12**3*s34**2 - 24*s12**2*s14**3 - 24*s12**2*s14**2
     +    *s34 + 16*s12**2*s14*s34**2 + 16*s12**2*s34**3 + 8*s12*s14**4
     +     + 24*s12*s14**3*s34 + 24*s12*s14**2*s34**2 + 8*s12*s14*
     +    s34**3 )

      LB = LB + Lc3(p13,p24)*S13**(-1)*S23**(-1) * (  - 32*s12**4 - 80*
     +    s12**3*s24 - 72*s12**3*s34 - 32*s12**2*s14**2 - 104*s12**2*
     +    s14*s24 - 128*s12**2*s14*s34 - 8*s12**2*s24**2 - 128*s12**2*
     +    s24*s34 - 112*s12**2*s34**2 - 24*s12*s14**2*s24 - 24*s12*
     +    s14**2*s34 - 8*s12*s14*s24**2 - 48*s12*s14*s24*s34 - 40*s12*
     +    s14*s34**2 - 16*s12*s24*s34**2 - 16*s12*s34**3 )

      LB = LB + Lc3(p13,p24)*S13**(-1)*S24**(-1) * (  - 32*s12**4 - 8*
     +    s12**3*s14 - 8*s12**3*s23 - 8*s12**3*s34 - 16*s12**2*s14**2
     +     + 48*s12**2*s14*s23 + 56*s12**2*s14*s34 + 24*s12**2*s23**2
     +     + 72*s12**2*s23*s34 + 72*s12**2*s34**2 - 40*s12*s14**3 - 48*
     +    s12*s14**2*s23 - 64*s12*s14**2*s34 - 48*s12*s14*s23*s34 - 24*
     +    s12*s14*s34**2 - 8*s14**3*s23 - 8*s14**2*s23*s34 )

      LB = LB + Lc3(p13,p24)*S13**(-1) * (  - 88*s12**3 - 56*s12**2*s14
     +     - 48*s12**2*s23 - 80*s12**2*s24 - 144*s12**2*s34 - 64*s12*
     +    s14**2 - 40*s12*s14*s23 - 48*s12*s14*s24 - 120*s12*s14*s34 + 
     +    8*s12*s23**2 - 24*s12*s23*s24 - 40*s12*s23*s34 - 32*s12*
     +    s24**2 - 80*s12*s24*s34 - 64*s12*s34**2 - 16*s14**2*s23 - 16*
     +    s14**2*s24 - 16*s14**2*s34 + 8*s14*s23**2 - 8*s14*s23*s24 - 8
     +    *s14*s23*s34 - 16*s14*s24**2 - 32*s14*s24*s34 - 16*s14*s34**2
     +     - 8*s23**2*s24 - 8*s23*s24**2 - 8*s23*s24*s34 )

      LB = LB + Lc3(p13,p24)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 32*
     +    s12**4*s34 + 8*s12**3*s34**2 )

      LB = LB + Lc3(p13,p24)*S14**(-1)*S23**(-1) * (  - 32*s12**4 - 80*
     +    s12**3*s24 - 72*s12**3*s34 + 8*s12**2*s13*s24 + 8*s12**2*s13*
     +    s34 - 8*s12**2*s24**2 - 16*s12**2*s24*s34 - 8*s12**2*s34**2
     +     - 16*s12*s13*s24**2 - 16*s12*s13*s24*s34 - 8*s12*s24**2*s34
     +     - 8*s12*s24*s34**2 )

      LB = LB + Lc3(p13,p24)*S14**(-1)*S24**(-1) * (  - 32*s12**4 + 24*
     +    s12**3*s23 + 32*s12**3*s34 )

      LB = LB + Lc3(p13,p24)*S14**(-1) * (  - 56*s12**3 + 8*s12**2*s13
     +     - 16*s12**2*s23 - 24*s12**2*s24 - 24*s12**2*s34 - 16*s12*s13
     +    *s24 - 16*s12*s23*s24 - 16*s12*s24**2 - 24*s12*s24*s34 + 8*
     +    s23*s24**2 + 8*s24**3 + 8*s24**2*s34 )

      LB = LB + Lc3(p13,p24)*S23**(-1)*S24**(-1) * (  - 8*s12**4 + 24*
     +    s12**3*s14 + 16*s12**3*s34 - 24*s12**2*s14**2 + 16*s12**2*
     +    s34**2 + 8*s12*s14**3 + 16*s12*s14**2*s34 + 8*s12*s14*s34**2
     +     )

      LB = LB + Lc3(p13,p24)*S23**(-1) * ( 8*s12**2*s13 - 24*s12**2*s14
     +     - 96*s12**2*s24 - 80*s12**2*s34 + 16*s12*s13*s14 + 16*s12*
     +    s13*s34 + 16*s12*s14**2 - 24*s12*s14*s24 + 8*s12*s14*s34 - 24
     +    *s12*s24**2 - 40*s12*s24*s34 + 8*s13*s14**2 - 8*s13*s14*s24
     +     + 8*s13*s14*s34 - 8*s13*s24**2 - 16*s13*s24*s34 + 8*s14**3
     +     - 8*s14**2*s24 + 16*s14**2*s34 - 8*s14*s24**2 - 24*s14*s24*
     +    s34 + 8*s14*s34**2 - 8*s24**2*s34 - 16*s24*s34**2 )

      LB = LB + Lc3(p13,p24)*S24**(-1) * (  - 8*s12**3 - 16*s12**2*s14
     +     + 48*s12**2*s23 + 72*s12**2*s34 - 40*s12*s14**2 - 48*s12*s14
     +    *s23 - 24*s12*s14*s34 - 8*s14**2*s23 )

      LB = LB + Lc3(p13,p24) * (  - 48*s12**2 + 8*s12*s13 - 56*s12*s14
     +     - 24*s12*s23 - 48*s12*s24 - 32*s12*s34 - 16*s13*s24 - 8*s14*
     +    s23 - 24*s14*s24 - 8*s14*s34 - 24*s23*s24 - 24*s24**2 - 40*
     +    s24*s34 )

      LB = LB + Lc3(p14,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 32*s12**4*s34**2 + 8*s12**3*s34**3 )

      LB = LB + Lc3(p14,p23)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 32*
     +    s12**4*s24 - 64*s12**4*s34 + 24*s12**3*s24**2 + 48*s12**3*s24
     +    *s34 + 32*s12**3*s34**2 )

      LB = LB + Lc3(p14,p23)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 32*
     +    s12**4*s34 - 80*s12**3*s23*s34 - 72*s12**3*s34**2 - 8*s12**2*
     +    s23**2*s34 - 24*s12**2*s23*s34**2 - 16*s12**2*s34**3 + 8*s12*
     +    s23**2*s34**2 + 8*s12*s23*s34**3 )

      LB = LB + Lc3(p14,p23)*S13**(-1)*S14**(-1) * (  - 32*s12**4 - 48*
     +    s12**3*s23 - 24*s12**3*s24 - 104*s12**3*s34 - 24*s12**2*
     +    s23**2 - 24*s12**2*s23*s24 - 64*s12**2*s23*s34 - 32*s12**2*
     +    s24*s34 - 48*s12**2*s34**2 + 16*s12*s23**2*s34 + 16*s12*s23*
     +    s24*s34 + 24*s12*s23*s34**2 )

      LB = LB + Lc3(p14,p23)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 32*
     +    s12**4*s34 + 8*s12**3*s34**2 )

      LB = LB + Lc3(p14,p23)*S13**(-1)*S23**(-1) * (  - 32*s12**4 + 24*
     +    s12**3*s24 + 32*s12**3*s34 )

      LB = LB + Lc3(p14,p23)*S13**(-1)*S24**(-1) * (  - 32*s12**4 - 80*
     +    s12**3*s23 - 72*s12**3*s34 + 8*s12**2*s14*s23 + 8*s12**2*s14*
     +    s34 - 8*s12**2*s23**2 - 16*s12**2*s23*s34 - 8*s12**2*s34**2
     +     - 16*s12*s14*s23**2 - 16*s12*s14*s23*s34 - 8*s12*s23**2*s34
     +     - 8*s12*s23*s34**2 )

      LB = LB + Lc3(p14,p23)*S13**(-1) * (  - 56*s12**3 + 8*s12**2*s14
     +     - 24*s12**2*s23 - 16*s12**2*s24 - 24*s12**2*s34 - 16*s12*s14
     +    *s23 - 16*s12*s23**2 - 16*s12*s23*s24 - 24*s12*s23*s34 + 8*
     +    s23**3 + 8*s23**2*s24 + 8*s23**2*s34 )

      LB = LB + Lc3(p14,p23)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**4*s13 - 40*s12**4*s34 + 24*s12**3*s13**2 + 40*s12**3*s13
     +    *s34 + 24*s12**3*s34**2 - 24*s12**2*s13**3 - 24*s12**2*s13**2
     +    *s34 + 16*s12**2*s13*s34**2 + 16*s12**2*s34**3 + 8*s12*s13**4
     +     + 24*s12*s13**3*s34 + 24*s12*s13**2*s34**2 + 8*s12*s13*
     +    s34**3 )

      LB = LB + Lc3(p14,p23)*S14**(-1)*S23**(-1) * (  - 32*s12**4 - 8*
     +    s12**3*s13 - 8*s12**3*s24 - 8*s12**3*s34 - 16*s12**2*s13**2
     +     + 48*s12**2*s13*s24 + 56*s12**2*s13*s34 + 24*s12**2*s24**2
     +     + 72*s12**2*s24*s34 + 72*s12**2*s34**2 - 40*s12*s13**3 - 48*
     +    s12*s13**2*s24 - 64*s12*s13**2*s34 - 48*s12*s13*s24*s34 - 24*
     +    s12*s13*s34**2 - 8*s13**3*s24 - 8*s13**2*s24*s34 )

      LB = LB + Lc3(p14,p23)*S14**(-1)*S24**(-1) * (  - 32*s12**4 - 80*
     +    s12**3*s23 - 72*s12**3*s34 - 32*s12**2*s13**2 - 104*s12**2*
     +    s13*s23 - 128*s12**2*s13*s34 - 8*s12**2*s23**2 - 128*s12**2*
     +    s23*s34 - 112*s12**2*s34**2 - 24*s12*s13**2*s23 - 24*s12*
     +    s13**2*s34 - 8*s12*s13*s23**2 - 48*s12*s13*s23*s34 - 40*s12*
     +    s13*s34**2 - 16*s12*s23*s34**2 - 16*s12*s34**3 )

      LB = LB + Lc3(p14,p23)*S14**(-1) * (  - 88*s12**3 - 56*s12**2*s13
     +     - 80*s12**2*s23 - 48*s12**2*s24 - 144*s12**2*s34 - 64*s12*
     +    s13**2 - 48*s12*s13*s23 - 40*s12*s13*s24 - 120*s12*s13*s34 - 
     +    32*s12*s23**2 - 24*s12*s23*s24 - 80*s12*s23*s34 + 8*s12*
     +    s24**2 - 40*s12*s24*s34 - 64*s12*s34**2 - 16*s13**2*s23 - 16*
     +    s13**2*s24 - 16*s13**2*s34 - 16*s13*s23**2 - 8*s13*s23*s24 - 
     +    32*s13*s23*s34 + 8*s13*s24**2 - 8*s13*s24*s34 - 16*s13*s34**2
     +     - 8*s23**2*s24 - 8*s23*s24**2 - 8*s23*s24*s34 )

      LB = LB + Lc3(p14,p23)*S23**(-1)*S24**(-1) * (  - 8*s12**4 + 24*
     +    s12**3*s13 + 16*s12**3*s34 - 24*s12**2*s13**2 + 16*s12**2*
     +    s34**2 + 8*s12*s13**3 + 16*s12*s13**2*s34 + 8*s12*s13*s34**2
     +     )

      LB = LB + Lc3(p14,p23)*S23**(-1) * (  - 8*s12**3 - 16*s12**2*s13
     +     + 48*s12**2*s24 + 72*s12**2*s34 - 40*s12*s13**2 - 48*s12*s13
     +    *s24 - 24*s12*s13*s34 - 8*s13**2*s24 )

      LB = LB + Lc3(p14,p23)*S24**(-1) * (  - 24*s12**2*s13 + 8*s12**2*
     +    s14 - 96*s12**2*s23 - 80*s12**2*s34 + 16*s12*s13**2 + 16*s12*
     +    s13*s14 - 24*s12*s13*s23 + 8*s12*s13*s34 + 16*s12*s14*s34 - 
     +    24*s12*s23**2 - 40*s12*s23*s34 + 8*s13**3 + 8*s13**2*s14 - 8*
     +    s13**2*s23 + 16*s13**2*s34 - 8*s13*s14*s23 + 8*s13*s14*s34 - 
     +    8*s13*s23**2 - 24*s13*s23*s34 + 8*s13*s34**2 - 8*s14*s23**2
     +     - 16*s14*s23*s34 - 8*s23**2*s34 - 16*s23*s34**2 )

      LB = LB + Lc3(p14,p23) * (  - 48*s12**2 - 56*s12*s13 + 8*s12*s14
     +     - 48*s12*s23 - 24*s12*s24 - 32*s12*s34 - 24*s13*s23 - 8*s13*
     +    s24 - 8*s13*s34 - 16*s14*s23 - 24*s23**2 - 24*s23*s24 - 40*
     +    s23*s34 )

      LB = LB + Lc3(p23,p14)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 32*s12**4*s34**2 + 8*s12**3*s34**3 )

      LB = LB + Lc3(p23,p14)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 8*
     +    s12**4*s24 - 40*s12**4*s34 + 24*s12**3*s24**2 + 40*s12**3*s24
     +    *s34 + 24*s12**3*s34**2 - 24*s12**2*s24**3 - 24*s12**2*s24**2
     +    *s34 + 16*s12**2*s24*s34**2 + 16*s12**2*s34**3 + 8*s12*s24**4
     +     + 24*s12*s24**3*s34 + 24*s12*s24**2*s34**2 + 8*s12*s24*
     +    s34**3 )

      LB = LB + Lc3(p23,p14)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 32*
     +    s12**4*s34 + 8*s12**3*s34**2 )

      LB = LB + Lc3(p23,p14)*S13**(-1)*S14**(-1) * (  - 8*s12**4 + 24*
     +    s12**3*s24 + 16*s12**3*s34 - 24*s12**2*s24**2 + 16*s12**2*
     +    s34**2 + 8*s12*s24**3 + 16*s12*s24**2*s34 + 8*s12*s24*s34**2
     +     )

      LB = LB + Lc3(p23,p14)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 32*
     +    s12**4*s34 - 80*s12**3*s14*s34 - 72*s12**3*s34**2 - 8*s12**2*
     +    s14**2*s34 - 24*s12**2*s14*s34**2 - 16*s12**2*s34**3 + 8*s12*
     +    s14**2*s34**2 + 8*s12*s14*s34**3 )

      LB = LB + Lc3(p23,p14)*S13**(-1)*S23**(-1) * (  - 32*s12**4 - 80*
     +    s12**3*s14 - 72*s12**3*s34 - 8*s12**2*s14**2 - 104*s12**2*s14
     +    *s24 - 128*s12**2*s14*s34 - 32*s12**2*s24**2 - 128*s12**2*s24
     +    *s34 - 112*s12**2*s34**2 - 8*s12*s14**2*s24 - 24*s12*s14*
     +    s24**2 - 48*s12*s14*s24*s34 - 16*s12*s14*s34**2 - 24*s12*
     +    s24**2*s34 - 40*s12*s24*s34**2 - 16*s12*s34**3 )

      LB = LB + Lc3(p23,p14)*S13**(-1)*S24**(-1) * (  - 32*s12**4 - 80*
     +    s12**3*s14 - 72*s12**3*s34 - 8*s12**2*s14**2 + 8*s12**2*s14*
     +    s23 - 16*s12**2*s14*s34 + 8*s12**2*s23*s34 - 8*s12**2*s34**2
     +     - 16*s12*s14**2*s23 - 8*s12*s14**2*s34 - 16*s12*s14*s23*s34
     +     - 8*s12*s14*s34**2 )

      LB = LB + Lc3(p23,p14)*S13**(-1) * (  - 96*s12**2*s14 + 8*s12**2*
     +    s23 - 24*s12**2*s24 - 80*s12**2*s34 - 24*s12*s14**2 - 24*s12*
     +    s14*s24 - 40*s12*s14*s34 + 16*s12*s23*s24 + 16*s12*s23*s34 + 
     +    16*s12*s24**2 + 8*s12*s24*s34 - 8*s14**2*s23 - 8*s14**2*s24
     +     - 8*s14**2*s34 - 8*s14*s23*s24 - 16*s14*s23*s34 - 8*s14*
     +    s24**2 - 24*s14*s24*s34 - 16*s14*s34**2 + 8*s23*s24**2 + 8*
     +    s23*s24*s34 + 8*s24**3 + 16*s24**2*s34 + 8*s24*s34**2 )

      LB = LB + Lc3(p23,p14)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 32*
     +    s12**4*s13 - 64*s12**4*s34 + 24*s12**3*s13**2 + 48*s12**3*s13
     +    *s34 + 32*s12**3*s34**2 )

      LB = LB + Lc3(p23,p14)*S14**(-1)*S23**(-1) * (  - 32*s12**4 - 8*
     +    s12**3*s13 - 8*s12**3*s24 - 8*s12**3*s34 + 24*s12**2*s13**2
     +     + 48*s12**2*s13*s24 + 72*s12**2*s13*s34 - 16*s12**2*s24**2
     +     + 56*s12**2*s24*s34 + 72*s12**2*s34**2 - 48*s12*s13*s24**2
     +     - 48*s12*s13*s24*s34 - 40*s12*s24**3 - 64*s12*s24**2*s34 - 
     +    24*s12*s24*s34**2 - 8*s13*s24**3 - 8*s13*s24**2*s34 )

      LB = LB + Lc3(p23,p14)*S14**(-1)*S24**(-1) * (  - 32*s12**4 + 24*
     +    s12**3*s13 + 32*s12**3*s34 )

      LB = LB + Lc3(p23,p14)*S14**(-1) * (  - 8*s12**3 + 48*s12**2*s13
     +     - 16*s12**2*s24 + 72*s12**2*s34 - 48*s12*s13*s24 - 40*s12*
     +    s24**2 - 24*s12*s24*s34 - 8*s13*s24**2 )

      LB = LB + Lc3(p23,p14)*S23**(-1)*S24**(-1) * (  - 32*s12**4 - 24*
     +    s12**3*s13 - 48*s12**3*s14 - 104*s12**3*s34 - 24*s12**2*s13*
     +    s14 - 32*s12**2*s13*s34 - 24*s12**2*s14**2 - 64*s12**2*s14*
     +    s34 - 48*s12**2*s34**2 + 16*s12*s13*s14*s34 + 16*s12*s14**2*
     +    s34 + 24*s12*s14*s34**2 )

      LB = LB + Lc3(p23,p14)*S23**(-1) * (  - 88*s12**3 - 48*s12**2*s13
     +     - 80*s12**2*s14 - 56*s12**2*s24 - 144*s12**2*s34 + 8*s12*
     +    s13**2 - 24*s12*s13*s14 - 40*s12*s13*s24 - 40*s12*s13*s34 - 
     +    32*s12*s14**2 - 48*s12*s14*s24 - 80*s12*s14*s34 - 64*s12*
     +    s24**2 - 120*s12*s24*s34 - 64*s12*s34**2 - 8*s13**2*s14 + 8*
     +    s13**2*s24 - 8*s13*s14**2 - 8*s13*s14*s24 - 8*s13*s14*s34 - 
     +    16*s13*s24**2 - 8*s13*s24*s34 - 16*s14**2*s24 - 16*s14*s24**2
     +     - 32*s14*s24*s34 - 16*s24**2*s34 - 16*s24*s34**2 )

      LB = LB + Lc3(p23,p14)*S24**(-1) * (  - 56*s12**3 - 16*s12**2*s13
     +     - 24*s12**2*s14 + 8*s12**2*s23 - 24*s12**2*s34 - 16*s12*s13*
     +    s14 - 16*s12*s14**2 - 16*s12*s14*s23 - 24*s12*s14*s34 + 8*s13
     +    *s14**2 + 8*s14**3 + 8*s14**2*s34 )

      LB = LB + Lc3(p23,p14) * (  - 48*s12**2 - 24*s12*s13 - 48*s12*s14
     +     + 8*s12*s23 - 56*s12*s24 - 32*s12*s34 - 24*s13*s14 - 8*s13*
     +    s24 - 24*s14**2 - 16*s14*s23 - 24*s14*s24 - 40*s14*s34 - 8*
     +    s24*s34 )

      LB = LB + Lc3(p24,p13)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 32*s12**4*s34**2 + 8*s12**3*s34**3 )

      LB = LB + Lc3(p24,p13)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 32*
     +    s12**4*s34 + 8*s12**3*s34**2 )

      LB = LB + Lc3(p24,p13)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 8*
     +    s12**4*s23 - 40*s12**4*s34 + 24*s12**3*s23**2 + 40*s12**3*s23
     +    *s34 + 24*s12**3*s34**2 - 24*s12**2*s23**3 - 24*s12**2*s23**2
     +    *s34 + 16*s12**2*s23*s34**2 + 16*s12**2*s34**3 + 8*s12*s23**4
     +     + 24*s12*s23**3*s34 + 24*s12*s23**2*s34**2 + 8*s12*s23*
     +    s34**3 )

      LB = LB + Lc3(p24,p13)*S13**(-1)*S14**(-1) * (  - 8*s12**4 + 24*
     +    s12**3*s23 + 16*s12**3*s34 - 24*s12**2*s23**2 + 16*s12**2*
     +    s34**2 + 8*s12*s23**3 + 16*s12*s23**2*s34 + 8*s12*s23*s34**2
     +     )

      LB = LB + Lc3(p24,p13)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 32*
     +    s12**4*s14 - 64*s12**4*s34 + 24*s12**3*s14**2 + 48*s12**3*s14
     +    *s34 + 32*s12**3*s34**2 )

      LB = LB + Lc3(p24,p13)*S13**(-1)*S23**(-1) * (  - 32*s12**4 + 24*
     +    s12**3*s14 + 32*s12**3*s34 )

      LB = LB + Lc3(p24,p13)*S13**(-1)*S24**(-1) * (  - 32*s12**4 - 8*
     +    s12**3*s14 - 8*s12**3*s23 - 8*s12**3*s34 + 24*s12**2*s14**2
     +     + 48*s12**2*s14*s23 + 72*s12**2*s14*s34 - 16*s12**2*s23**2
     +     + 56*s12**2*s23*s34 + 72*s12**2*s34**2 - 48*s12*s14*s23**2
     +     - 48*s12*s14*s23*s34 - 40*s12*s23**3 - 64*s12*s23**2*s34 - 
     +    24*s12*s23*s34**2 - 8*s14*s23**3 - 8*s14*s23**2*s34 )

      LB = LB + Lc3(p24,p13)*S13**(-1) * (  - 8*s12**3 + 48*s12**2*s14
     +     - 16*s12**2*s23 + 72*s12**2*s34 - 48*s12*s14*s23 - 40*s12*
     +    s23**2 - 24*s12*s23*s34 - 8*s14*s23**2 )

      LB = LB + Lc3(p24,p13)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 32*
     +    s12**4*s34 - 80*s12**3*s13*s34 - 72*s12**3*s34**2 - 8*s12**2*
     +    s13**2*s34 - 24*s12**2*s13*s34**2 - 16*s12**2*s34**3 + 8*s12*
     +    s13**2*s34**2 + 8*s12*s13*s34**3 )

      LB = LB + Lc3(p24,p13)*S14**(-1)*S23**(-1) * (  - 32*s12**4 - 80*
     +    s12**3*s13 - 72*s12**3*s34 - 8*s12**2*s13**2 + 8*s12**2*s13*
     +    s24 - 16*s12**2*s13*s34 + 8*s12**2*s24*s34 - 8*s12**2*s34**2
     +     - 16*s12*s13**2*s24 - 8*s12*s13**2*s34 - 16*s12*s13*s24*s34
     +     - 8*s12*s13*s34**2 )

      LB = LB + Lc3(p24,p13)*S14**(-1)*S24**(-1) * (  - 32*s12**4 - 80*
     +    s12**3*s13 - 72*s12**3*s34 - 8*s12**2*s13**2 - 104*s12**2*s13
     +    *s23 - 128*s12**2*s13*s34 - 32*s12**2*s23**2 - 128*s12**2*s23
     +    *s34 - 112*s12**2*s34**2 - 8*s12*s13**2*s23 - 24*s12*s13*
     +    s23**2 - 48*s12*s13*s23*s34 - 16*s12*s13*s34**2 - 24*s12*
     +    s23**2*s34 - 40*s12*s23*s34**2 - 16*s12*s34**3 )

      LB = LB + Lc3(p24,p13)*S14**(-1) * (  - 96*s12**2*s13 - 24*s12**2
     +    *s23 + 8*s12**2*s24 - 80*s12**2*s34 - 24*s12*s13**2 - 24*s12*
     +    s13*s23 - 40*s12*s13*s34 + 16*s12*s23**2 + 16*s12*s23*s24 + 8
     +    *s12*s23*s34 + 16*s12*s24*s34 - 8*s13**2*s23 - 8*s13**2*s24
     +     - 8*s13**2*s34 - 8*s13*s23**2 - 8*s13*s23*s24 - 24*s13*s23*
     +    s34 - 16*s13*s24*s34 - 16*s13*s34**2 + 8*s23**3 + 8*s23**2*
     +    s24 + 16*s23**2*s34 + 8*s23*s24*s34 + 8*s23*s34**2 )

      LB = LB + Lc3(p24,p13)*S23**(-1)*S24**(-1) * (  - 32*s12**4 - 48*
     +    s12**3*s13 - 24*s12**3*s14 - 104*s12**3*s34 - 24*s12**2*
     +    s13**2 - 24*s12**2*s13*s14 - 64*s12**2*s13*s34 - 32*s12**2*
     +    s14*s34 - 48*s12**2*s34**2 + 16*s12*s13**2*s34 + 16*s12*s13*
     +    s14*s34 + 24*s12*s13*s34**2 )

      LB = LB + Lc3(p24,p13)*S23**(-1) * (  - 56*s12**3 - 24*s12**2*s13
     +     - 16*s12**2*s14 + 8*s12**2*s24 - 24*s12**2*s34 - 16*s12*
     +    s13**2 - 16*s12*s13*s14 - 16*s12*s13*s24 - 24*s12*s13*s34 + 8
     +    *s13**3 + 8*s13**2*s14 + 8*s13**2*s34 )

      LB = LB + Lc3(p24,p13)*S24**(-1) * (  - 88*s12**3 - 80*s12**2*s13
     +     - 48*s12**2*s14 - 56*s12**2*s23 - 144*s12**2*s34 - 32*s12*
     +    s13**2 - 24*s12*s13*s14 - 48*s12*s13*s23 - 80*s12*s13*s34 + 8
     +    *s12*s14**2 - 40*s12*s14*s23 - 40*s12*s14*s34 - 64*s12*s23**2
     +     - 120*s12*s23*s34 - 64*s12*s34**2 - 8*s13**2*s14 - 16*s13**2
     +    *s23 - 8*s13*s14**2 - 8*s13*s14*s23 - 8*s13*s14*s34 - 16*s13*
     +    s23**2 - 32*s13*s23*s34 + 8*s14**2*s23 - 16*s14*s23**2 - 8*
     +    s14*s23*s34 - 16*s23**2*s34 - 16*s23*s34**2 )

      LB = LB + Lc3(p24,p13) * (  - 48*s12**2 - 48*s12*s13 - 24*s12*s14
     +     - 56*s12*s23 + 8*s12*s24 - 32*s12*s34 - 24*s13**2 - 24*s13*
     +    s14 - 24*s13*s23 - 16*s13*s24 - 40*s13*s34 - 8*s14*s23 - 8*
     +    s23*s34 )

      LB = LB + Lcd0(p1,p23,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 8*
     +    s12**4*s23*s34 - 16*s12**4*s34**2 - 56*s12**3*s23**2*s34 - 4*
     +    s12**3*s23*s34**2 - 16*s12**2*s23**2*s34**2 - 40*s12**2*s23*
     +    s34**3 - 16*s12**2*s34**4 )

      LB = LB + Lcd0(p1,p23,p4)*S13**(-1)*S14**(-1) * ( 8*s12**4*s23 - 
     +    32*s12**3*s23**2 - 8*s12**3*s23*s24 - 8*s12**3*s23*s34 + 24*
     +    s12**3*s24**2 + 64*s12**3*s24*s34 + 56*s12**3*s34**2 + 40*
     +    s12**2*s23**2*s24 + 32*s12**2*s23**2*s34 + 24*s12**2*s23*
     +    s24**2 + 48*s12**2*s23*s24*s34 + 16*s12**2*s23*s34**2 - 16*
     +    s12**2*s24**3 - 40*s12**2*s24**2*s34 - 48*s12**2*s24*s34**2
     +     - 40*s12**2*s34**3 )

      LB = LB + Lcd0(p1,p23,p4)*S13**(-1)*S24**(-1) * (  - 8*s12**3*
     +    s23**2 + 40*s12**3*s23*s34 - 32*s12**3*s34**2 - 24*s12**2*s14
     +    *s23**2 + 32*s12**2*s14*s23*s34 - 32*s12**2*s14*s34**2 + 32*
     +    s12**2*s23**3 + 20*s12**2*s23**2*s34 - 16*s12**2*s23*s34**2
     +     - 48*s12**2*s34**3 + 32*s12*s14**2*s23*s34 + 20*s12*s14*
     +    s23**3 + 64*s12*s14*s23**2*s34 + 48*s12*s14*s23*s34**2 - 24*
     +    s12*s23**3*s34 + 92*s12*s23**2*s34**2 + 8*s12*s23*s34**3 - 12
     +    *s14**2*s23**3 + 32*s14*s23**4 - 44*s14*s23**3*s34 + 8*s14*
     +    s23**2*s34**2 )

      LB = LB + Lcd0(p1,p23,p4)*S13**(-1) * ( 8*s12**3*s23 - 32*s12**2*
     +    s14*s23 - 16*s12**2*s14*s24 - 32*s12**2*s14*s34 + 32*s12**2*
     +    s23**2 - 44*s12**2*s23*s24 - 72*s12**2*s23*s34 - 16*s12**2*
     +    s24**2 - 64*s12**2*s24*s34 - 80*s12**2*s34**2 + 60*s12*s14*
     +    s23**2 + 32*s12*s14*s23*s34 - 36*s12*s23**3 + 12*s12*s23**2*
     +    s24 + 8*s12*s23**2*s34 + 48*s12*s23*s24**2 + 48*s12*s23*s24*
     +    s34 + 40*s12*s23*s34**2 + 32*s14*s23**3 - 8*s14*s23**2*s34 )

      LB = LB + Lcd0(p1,p23,p4)*S14**(-1)*S24**(-1) * (  - 32*s12**3*
     +    s23*s34 - 48*s12**3*s34**2 - 120*s12**2*s13*s23*s34 - 72*
     +    s12**2*s13*s34**2 - 12*s12**2*s23**2*s34 - 52*s12**2*s23*
     +    s34**2 - 56*s12**2*s34**3 - 88*s12*s13**2*s23*s34 - 64*s12*
     +    s13**2*s34**2 - 32*s12*s13*s23**2*s34 - 68*s12*s13*s23*s34**2
     +     - 64*s12*s13*s34**3 + 32*s12*s23**2*s34**2 - 64*s12*s23*
     +    s34**3 - 24*s13**3*s34**2 - 44*s13**2*s23**2*s34 - 20*s13**2*
     +    s23*s34**2 - 24*s13**2*s34**3 + 40*s13*s23**2*s34**2 - 32*s13
     +    *s23*s34**3 )

      LB = LB + Lcd0(p1,p23,p4)*S24**(-1) * ( 56*s12**2*s23**2 + 32*
     +    s12**2*s23*s34 - 96*s12**2*s34**2 + 56*s12*s13*s23**2 - 40*
     +    s12*s13*s23*s34 - 96*s12*s13*s34**2 + 56*s12*s14*s23**2 + 64*
     +    s12*s14*s23*s34 - 32*s12*s14*s34**2 - 4*s12*s23**3 + 12*s12*
     +    s23**2*s34 - 24*s12*s23*s34**2 - 32*s12*s34**3 + 16*s13**2*
     +    s23*s34 - 32*s13**2*s34**2 - 8*s13*s14*s23**2 - 16*s13*s14*
     +    s34**2 + 24*s13*s23**3 - 16*s13*s23**2*s34 - 36*s13*s23*
     +    s34**2 - 16*s13*s34**3 + 12*s14*s23**3 + 20*s14*s23**2*s34 - 
     +    16*s14*s23*s34**2 - 68*s23**3*s34 + 56*s23**2*s34**2 - 24*s23
     +    *s34**3 )

      LB = LB + Lcd0(p1,p24,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 8*
     +    s12**4*s24*s34 - 16*s12**4*s34**2 - 56*s12**3*s24**2*s34 - 4*
     +    s12**3*s24*s34**2 - 16*s12**2*s24**2*s34**2 - 40*s12**2*s24*
     +    s34**3 - 16*s12**2*s34**4 )

      LB = LB + Lcd0(p1,p24,p3)*S13**(-1)*S14**(-1) * ( 8*s12**4*s24 + 
     +    24*s12**3*s23**2 - 8*s12**3*s23*s24 + 64*s12**3*s23*s34 - 32*
     +    s12**3*s24**2 - 8*s12**3*s24*s34 + 56*s12**3*s34**2 - 16*
     +    s12**2*s23**3 + 24*s12**2*s23**2*s24 - 40*s12**2*s23**2*s34
     +     + 40*s12**2*s23*s24**2 + 48*s12**2*s23*s24*s34 - 48*s12**2*
     +    s23*s34**2 + 32*s12**2*s24**2*s34 + 16*s12**2*s24*s34**2 - 40
     +    *s12**2*s34**3 )

      LB = LB + Lcd0(p1,p24,p3)*S13**(-1)*S23**(-1) * (  - 32*s12**3*
     +    s24*s34 - 48*s12**3*s34**2 - 120*s12**2*s14*s24*s34 - 72*
     +    s12**2*s14*s34**2 - 12*s12**2*s24**2*s34 - 52*s12**2*s24*
     +    s34**2 - 56*s12**2*s34**3 - 88*s12*s14**2*s24*s34 - 64*s12*
     +    s14**2*s34**2 - 32*s12*s14*s24**2*s34 - 68*s12*s14*s24*s34**2
     +     - 64*s12*s14*s34**3 + 32*s12*s24**2*s34**2 - 64*s12*s24*
     +    s34**3 - 24*s14**3*s34**2 - 44*s14**2*s24**2*s34 - 20*s14**2*
     +    s24*s34**2 - 24*s14**2*s34**3 + 40*s14*s24**2*s34**2 - 32*s14
     +    *s24*s34**3 )

      LB = LB + Lcd0(p1,p24,p3)*S14**(-1)*S23**(-1) * (  - 8*s12**3*
     +    s24**2 + 40*s12**3*s24*s34 - 32*s12**3*s34**2 - 24*s12**2*s13
     +    *s24**2 + 32*s12**2*s13*s24*s34 - 32*s12**2*s13*s34**2 + 32*
     +    s12**2*s24**3 + 20*s12**2*s24**2*s34 - 16*s12**2*s24*s34**2
     +     - 48*s12**2*s34**3 + 32*s12*s13**2*s24*s34 + 20*s12*s13*
     +    s24**3 + 64*s12*s13*s24**2*s34 + 48*s12*s13*s24*s34**2 - 24*
     +    s12*s24**3*s34 + 92*s12*s24**2*s34**2 + 8*s12*s24*s34**3 - 12
     +    *s13**2*s24**3 + 32*s13*s24**4 - 44*s13*s24**3*s34 + 8*s13*
     +    s24**2*s34**2 )

      LB = LB + Lcd0(p1,p24,p3)*S14**(-1) * ( 8*s12**3*s24 - 16*s12**2*
     +    s13*s23 - 32*s12**2*s13*s24 - 32*s12**2*s13*s34 - 16*s12**2*
     +    s23**2 - 44*s12**2*s23*s24 - 64*s12**2*s23*s34 + 32*s12**2*
     +    s24**2 - 72*s12**2*s24*s34 - 80*s12**2*s34**2 + 60*s12*s13*
     +    s24**2 + 32*s12*s13*s24*s34 + 48*s12*s23**2*s24 + 12*s12*s23*
     +    s24**2 + 48*s12*s23*s24*s34 - 36*s12*s24**3 + 8*s12*s24**2*
     +    s34 + 40*s12*s24*s34**2 + 32*s13*s24**3 - 8*s13*s24**2*s34 )

      LB = LB + Lcd0(p1,p24,p3)*S23**(-1) * ( 56*s12**2*s24**2 + 32*
     +    s12**2*s24*s34 - 96*s12**2*s34**2 + 56*s12*s13*s24**2 + 64*
     +    s12*s13*s24*s34 - 32*s12*s13*s34**2 + 56*s12*s14*s24**2 - 40*
     +    s12*s14*s24*s34 - 96*s12*s14*s34**2 - 4*s12*s24**3 + 12*s12*
     +    s24**2*s34 - 24*s12*s24*s34**2 - 32*s12*s34**3 - 8*s13*s14*
     +    s24**2 - 16*s13*s14*s34**2 + 12*s13*s24**3 + 20*s13*s24**2*
     +    s34 - 16*s13*s24*s34**2 + 16*s14**2*s24*s34 - 32*s14**2*
     +    s34**2 + 24*s14*s24**3 - 16*s14*s24**2*s34 - 36*s14*s24*
     +    s34**2 - 16*s14*s34**3 - 68*s24**3*s34 + 56*s24**2*s34**2 - 
     +    24*s24*s34**3 )

      LB = LB + Lcd0(p2,p13,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**4*s13*s34 - 16*s12**4*s34**2 - 56*s12**3*s13**2*s34 - 4*
     +    s12**3*s13*s34**2 - 16*s12**2*s13**2*s34**2 - 40*s12**2*s13*
     +    s34**3 - 16*s12**2*s34**4 )

      LB = LB + Lcd0(p2,p13,p4)*S14**(-1)*S23**(-1) * (  - 8*s12**3*
     +    s13**2 + 40*s12**3*s13*s34 - 32*s12**3*s34**2 + 32*s12**2*
     +    s13**3 - 24*s12**2*s13**2*s24 + 20*s12**2*s13**2*s34 + 32*
     +    s12**2*s13*s24*s34 - 16*s12**2*s13*s34**2 - 32*s12**2*s24*
     +    s34**2 - 48*s12**2*s34**3 + 20*s12*s13**3*s24 - 24*s12*s13**3
     +    *s34 + 64*s12*s13**2*s24*s34 + 92*s12*s13**2*s34**2 + 32*s12*
     +    s13*s24**2*s34 + 48*s12*s13*s24*s34**2 + 8*s12*s13*s34**3 + 
     +    32*s13**4*s24 - 12*s13**3*s24**2 - 44*s13**3*s24*s34 + 8*
     +    s13**2*s24*s34**2 )

      LB = LB + Lcd0(p2,p13,p4)*S14**(-1)*S24**(-1) * (  - 32*s12**3*
     +    s13*s34 - 48*s12**3*s34**2 - 12*s12**2*s13**2*s34 - 120*
     +    s12**2*s13*s23*s34 - 52*s12**2*s13*s34**2 - 72*s12**2*s23*
     +    s34**2 - 56*s12**2*s34**3 - 32*s12*s13**2*s23*s34 + 32*s12*
     +    s13**2*s34**2 - 88*s12*s13*s23**2*s34 - 68*s12*s13*s23*s34**2
     +     - 64*s12*s13*s34**3 - 64*s12*s23**2*s34**2 - 64*s12*s23*
     +    s34**3 - 44*s13**2*s23**2*s34 + 40*s13**2*s23*s34**2 - 20*s13
     +    *s23**2*s34**2 - 32*s13*s23*s34**3 - 24*s23**3*s34**2 - 24*
     +    s23**2*s34**3 )

      LB = LB + Lcd0(p2,p13,p4)*S14**(-1) * ( 56*s12**2*s13**2 + 32*
     +    s12**2*s13*s34 - 96*s12**2*s34**2 - 4*s12*s13**3 + 56*s12*
     +    s13**2*s23 + 56*s12*s13**2*s24 + 12*s12*s13**2*s34 - 40*s12*
     +    s13*s23*s34 + 64*s12*s13*s24*s34 - 24*s12*s13*s34**2 - 96*s12
     +    *s23*s34**2 - 32*s12*s24*s34**2 - 32*s12*s34**3 + 24*s13**3*
     +    s23 + 12*s13**3*s24 - 68*s13**3*s34 - 8*s13**2*s23*s24 - 16*
     +    s13**2*s23*s34 + 20*s13**2*s24*s34 + 56*s13**2*s34**2 + 16*
     +    s13*s23**2*s34 - 36*s13*s23*s34**2 - 16*s13*s24*s34**2 - 24*
     +    s13*s34**3 - 32*s23**2*s34**2 - 16*s23*s24*s34**2 - 16*s23*
     +    s34**3 )

      LB = LB + Lcd0(p2,p13,p4)*S23**(-1)*S24**(-1) * ( 8*s12**4*s13 - 
     +    32*s12**3*s13**2 - 8*s12**3*s13*s14 - 8*s12**3*s13*s34 + 24*
     +    s12**3*s14**2 + 64*s12**3*s14*s34 + 56*s12**3*s34**2 + 40*
     +    s12**2*s13**2*s14 + 32*s12**2*s13**2*s34 + 24*s12**2*s13*
     +    s14**2 + 48*s12**2*s13*s14*s34 + 16*s12**2*s13*s34**2 - 16*
     +    s12**2*s14**3 - 40*s12**2*s14**2*s34 - 48*s12**2*s14*s34**2
     +     - 40*s12**2*s34**3 )

      LB = LB + Lcd0(p2,p13,p4)*S23**(-1) * ( 8*s12**3*s13 + 32*s12**2*
     +    s13**2 - 44*s12**2*s13*s14 - 32*s12**2*s13*s24 - 72*s12**2*
     +    s13*s34 - 16*s12**2*s14**2 - 16*s12**2*s14*s24 - 64*s12**2*
     +    s14*s34 - 32*s12**2*s24*s34 - 80*s12**2*s34**2 - 36*s12*
     +    s13**3 + 12*s12*s13**2*s14 + 60*s12*s13**2*s24 + 8*s12*s13**2
     +    *s34 + 48*s12*s13*s14**2 + 48*s12*s13*s14*s34 + 32*s12*s13*
     +    s24*s34 + 40*s12*s13*s34**2 + 32*s13**3*s24 - 8*s13**2*s24*
     +    s34 )

      LB = LB + Lcd0(p2,p14,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**4*s14*s34 - 16*s12**4*s34**2 - 56*s12**3*s14**2*s34 - 4*
     +    s12**3*s14*s34**2 - 16*s12**2*s14**2*s34**2 - 40*s12**2*s14*
     +    s34**3 - 16*s12**2*s34**4 )

      LB = LB + Lcd0(p2,p14,p3)*S13**(-1)*S23**(-1) * (  - 32*s12**3*
     +    s14*s34 - 48*s12**3*s34**2 - 12*s12**2*s14**2*s34 - 120*
     +    s12**2*s14*s24*s34 - 52*s12**2*s14*s34**2 - 72*s12**2*s24*
     +    s34**2 - 56*s12**2*s34**3 - 32*s12*s14**2*s24*s34 + 32*s12*
     +    s14**2*s34**2 - 88*s12*s14*s24**2*s34 - 68*s12*s14*s24*s34**2
     +     - 64*s12*s14*s34**3 - 64*s12*s24**2*s34**2 - 64*s12*s24*
     +    s34**3 - 44*s14**2*s24**2*s34 + 40*s14**2*s24*s34**2 - 20*s14
     +    *s24**2*s34**2 - 32*s14*s24*s34**3 - 24*s24**3*s34**2 - 24*
     +    s24**2*s34**3 )

      LB = LB + Lcd0(p2,p14,p3)*S13**(-1)*S24**(-1) * (  - 8*s12**3*
     +    s14**2 + 40*s12**3*s14*s34 - 32*s12**3*s34**2 + 32*s12**2*
     +    s14**3 - 24*s12**2*s14**2*s23 + 20*s12**2*s14**2*s34 + 32*
     +    s12**2*s14*s23*s34 - 16*s12**2*s14*s34**2 - 32*s12**2*s23*
     +    s34**2 - 48*s12**2*s34**3 + 20*s12*s14**3*s23 - 24*s12*s14**3
     +    *s34 + 64*s12*s14**2*s23*s34 + 92*s12*s14**2*s34**2 + 32*s12*
     +    s14*s23**2*s34 + 48*s12*s14*s23*s34**2 + 8*s12*s14*s34**3 + 
     +    32*s14**4*s23 - 12*s14**3*s23**2 - 44*s14**3*s23*s34 + 8*
     +    s14**2*s23*s34**2 )

      LB = LB + Lcd0(p2,p14,p3)*S13**(-1) * ( 56*s12**2*s14**2 + 32*
     +    s12**2*s14*s34 - 96*s12**2*s34**2 - 4*s12*s14**3 + 56*s12*
     +    s14**2*s23 + 56*s12*s14**2*s24 + 12*s12*s14**2*s34 + 64*s12*
     +    s14*s23*s34 - 40*s12*s14*s24*s34 - 24*s12*s14*s34**2 - 32*s12
     +    *s23*s34**2 - 96*s12*s24*s34**2 - 32*s12*s34**3 + 12*s14**3*
     +    s23 + 24*s14**3*s24 - 68*s14**3*s34 - 8*s14**2*s23*s24 + 20*
     +    s14**2*s23*s34 - 16*s14**2*s24*s34 + 56*s14**2*s34**2 - 16*
     +    s14*s23*s34**2 + 16*s14*s24**2*s34 - 36*s14*s24*s34**2 - 24*
     +    s14*s34**3 - 16*s23*s24*s34**2 - 32*s24**2*s34**2 - 16*s24*
     +    s34**3 )

      LB = LB + Lcd0(p2,p14,p3)*S23**(-1)*S24**(-1) * ( 8*s12**4*s14 + 
     +    24*s12**3*s13**2 - 8*s12**3*s13*s14 + 64*s12**3*s13*s34 - 32*
     +    s12**3*s14**2 - 8*s12**3*s14*s34 + 56*s12**3*s34**2 - 16*
     +    s12**2*s13**3 + 24*s12**2*s13**2*s14 - 40*s12**2*s13**2*s34
     +     + 40*s12**2*s13*s14**2 + 48*s12**2*s13*s14*s34 - 48*s12**2*
     +    s13*s34**2 + 32*s12**2*s14**2*s34 + 16*s12**2*s14*s34**2 - 40
     +    *s12**2*s34**3 )

      LB = LB + Lcd0(p2,p14,p3)*S24**(-1) * ( 8*s12**3*s14 - 16*s12**2*
     +    s13**2 - 44*s12**2*s13*s14 - 16*s12**2*s13*s23 - 64*s12**2*
     +    s13*s34 + 32*s12**2*s14**2 - 32*s12**2*s14*s23 - 72*s12**2*
     +    s14*s34 - 32*s12**2*s23*s34 - 80*s12**2*s34**2 + 48*s12*
     +    s13**2*s14 + 12*s12*s13*s14**2 + 48*s12*s13*s14*s34 - 36*s12*
     +    s14**3 + 60*s12*s14**2*s23 + 8*s12*s14**2*s34 + 32*s12*s14*
     +    s23*s34 + 40*s12*s14*s34**2 + 32*s14**3*s23 - 8*s14**2*s23*
     +    s34 )

      LB = LB + Lcd0(p3,p12,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**4*s14*s34 - 128*s12**4*s34**2 + 16*s12**3*s14**2*s34 + 
     +    64*s12**3*s14*s34**2 - 48*s12**3*s34**3 )

      LB = LB + Lcd0(p3,p12,p4)*S13**(-1)*S23**(-1) * (  - 48*s12**4*
     +    s34 - 16*s12**3*s24*s34 - 48*s12**3*s34**2 )

      LB = LB + Lcd0(p3,p12,p4)*S13**(-1)*S24**(-1) * (  - 48*s12**4*
     +    s34 + 32*s12**3*s14**2 + 16*s12**3*s14*s23 + 272*s12**3*s14*
     +    s34 - 64*s12**3*s23*s34 - 112*s12**3*s34**2 - 16*s12**2*
     +    s14**3 + 16*s12**2*s14**2*s23 - 64*s12**2*s14**2*s34 + 96*
     +    s12**2*s14*s23**2 + 208*s12**2*s14*s23*s34 + 112*s12**2*s14*
     +    s34**2 - 16*s12**2*s23**2*s34 - 32*s12**2*s23*s34**2 - 16*
     +    s12**2*s34**3 + 16*s12*s14**3*s23 - 64*s12*s14**2*s23**2 - 80
     +    *s12*s14**2*s23*s34 + 16*s12*s14*s23**3 + 64*s12*s14*s23**2*
     +    s34 + 32*s12*s14*s23*s34**2 + 16*s14**3*s23**2 - 32*s14**2*
     +    s23**3 - 16*s14**2*s23**2*s34 )

      LB = LB + Lcd0(p3,p12,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**4*s13*s34 - 128*s12**4*s34**2 + 16*s12**3*s13**2*s34 + 
     +    64*s12**3*s13*s34**2 - 48*s12**3*s34**3 )

      LB = LB + Lcd0(p3,p12,p4)*S14**(-1)*S23**(-1) * (  - 48*s12**4*
     +    s34 + 32*s12**3*s13**2 + 16*s12**3*s13*s24 + 272*s12**3*s13*
     +    s34 - 64*s12**3*s24*s34 - 112*s12**3*s34**2 - 16*s12**2*
     +    s13**3 + 16*s12**2*s13**2*s24 - 64*s12**2*s13**2*s34 + 96*
     +    s12**2*s13*s24**2 + 208*s12**2*s13*s24*s34 + 112*s12**2*s13*
     +    s34**2 - 16*s12**2*s24**2*s34 - 32*s12**2*s24*s34**2 - 16*
     +    s12**2*s34**3 + 16*s12*s13**3*s24 - 64*s12*s13**2*s24**2 - 80
     +    *s12*s13**2*s24*s34 + 16*s12*s13*s24**3 + 64*s12*s13*s24**2*
     +    s34 + 32*s12*s13*s24*s34**2 + 16*s13**3*s24**2 - 32*s13**2*
     +    s24**3 - 16*s13**2*s24**2*s34 )

      LB = LB + Lcd0(p3,p12,p4)*S14**(-1)*S24**(-1) * (  - 48*s12**4*
     +    s34 - 16*s12**3*s23*s34 - 48*s12**3*s34**2 )

      LB = LB + Lcd0(p3,p12,p4)*S23**(-1)*S24**(-1) * ( 32*s12**4*s34
     +     - 64*s12**3*s13**2 - 128*s12**3*s13*s14 + 48*s12**3*s13*s34
     +     - 64*s12**3*s14**2 + 48*s12**3*s14*s34 + 480*s12**3*s34**2
     +     - 16*s12**2*s13**3 + 208*s12**2*s13**2*s14 - 96*s12**2*
     +    s13**2*s34 + 208*s12**2*s13*s14**2 - 640*s12**2*s13*s14*s34
     +     + 16*s12**2*s13*s34**2 - 16*s12**2*s14**3 - 96*s12**2*s14**2
     +    *s34 + 16*s12**2*s14*s34**2 + 64*s12**2*s34**3 + 48*s12*
     +    s13**3*s14 + 192*s12*s13**2*s14**2 - 16*s12*s13**2*s14*s34 + 
     +    48*s12*s13*s14**3 - 16*s12*s13*s14**2*s34 - 96*s12*s13*s14*
     +    s34**2 + 48*s13**3*s14**2 + 48*s13**2*s14**3 + 32*s13**2*
     +    s14**2*s34 )

      LB = LB + Lcd0(p3,p12,p4)*S23**(-1) * (  - 80*s12**3*s13 - 112*
     +    s12**3*s14 + 16*s12**3*s24 + 368*s12**3*s34 + 96*s12**2*
     +    s13**2 + 32*s12**2*s13*s14 - 288*s12**2*s13*s34 - 48*s12**2*
     +    s14**2 - 32*s12**2*s14*s24 + 128*s12**2*s14*s34 + 16*s12**2*
     +    s24**2 + 144*s12**2*s24*s34 + 160*s12**2*s34**2 + 32*s12*
     +    s13**3 + 128*s12*s13**2*s14 - 32*s12*s13**2*s24 - 64*s12*
     +    s13**2*s34 - 32*s12*s13*s14**2 - 144*s12*s13*s14*s24 - 144*
     +    s12*s13*s14*s34 - 64*s12*s13*s24**2 - 48*s12*s13*s24*s34 - 48
     +    *s12*s13*s34**2 + 48*s13**3*s14 + 48*s13**3*s24 + 64*s13**2*
     +    s14**2 + 16*s13**2*s14*s34 - 64*s13**2*s24**2 - 16*s13**2*s24
     +    *s34 )

      LB = LB + Lcd0(p3,p12,p4)*S24**(-1) * (  - 112*s12**3*s13 - 80*
     +    s12**3*s14 + 16*s12**3*s23 + 368*s12**3*s34 - 48*s12**2*
     +    s13**2 + 32*s12**2*s13*s14 - 32*s12**2*s13*s23 + 128*s12**2*
     +    s13*s34 + 96*s12**2*s14**2 - 288*s12**2*s14*s34 + 16*s12**2*
     +    s23**2 + 144*s12**2*s23*s34 + 160*s12**2*s34**2 - 32*s12*
     +    s13**2*s14 + 128*s12*s13*s14**2 - 144*s12*s13*s14*s23 - 144*
     +    s12*s13*s14*s34 + 32*s12*s14**3 - 32*s12*s14**2*s23 - 64*s12*
     +    s14**2*s34 - 64*s12*s14*s23**2 - 48*s12*s14*s23*s34 - 48*s12*
     +    s14*s34**2 + 64*s13**2*s14**2 + 48*s13*s14**3 + 16*s13*s14**2
     +    *s34 + 48*s14**3*s23 - 64*s14**2*s23**2 - 16*s14**2*s23*s34 )

      LBd=-LB/s134/s234
      
      return
      end

      function LBe(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      SF=(s13*s24-s14*s23)/2d0/s34

      LB=0d0

      LB = LB + Lcd1(p1,p23,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s24**3 + 36*s12**3*s24**2*s34 + 20*s12**3*s24*s34**2
     +     + 16*s12**2*s24**4 + 32*s12**2*s24**3*s34 + 16*s12**2*s24**2
     +    *s34**2 )

      LB = LB + Lcd1(p1,p23,p4)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16
     +    *s12**3*s23*s34**2 - 8*s12**2*s23*s34**3 )

      LB = LB + Lcd1(p1,p23,p4)*S13**(-1)*S14**(-1) * (  - 16*s12**3*
     +    s23*s34 + 16*s12**3*s24**2 + 20*s12**3*s24*s34 + 28*s12**2*
     +    s23*s24**2 + 28*s12**2*s23*s24*s34 - 8*s12**2*s23*s34**2 + 44
     +    *s12**2*s24**3 + 72*s12**2*s24**2*s34 + 28*s12**2*s24*s34**2
     +     )

      LB = LB + Lcd1(p1,p23,p4)*S14**(-1)*S23**(-1) * ( 32*s12**3*
     +    s24**2 + 32*s12**3*s24*s34 + 56*s12**2*s13*s24**2 + 56*s12**2
     +    *s13*s24*s34 + 28*s12**2*s24**3 + 60*s12**2*s24**2*s34 + 32*
     +    s12**2*s24*s34**2 + 16*s12*s13**2*s24**2 + 16*s12*s13**2*s24*
     +    s34 - 4*s12*s13*s24**2*s34 - 4*s12*s13*s24*s34**2 + 24*s12*
     +    s24**4 + 48*s12*s24**3*s34 + 24*s12*s24**2*s34**2 - 8*s13**3*
     +    s24**2 - 8*s13**3*s24*s34 - 12*s13**2*s24**3 - 28*s13**2*
     +    s24**2*s34 - 16*s13**2*s24*s34**2 - 8*s13*s24**3*s34 - 16*s13
     +    *s24**2*s34**2 - 8*s13*s24*s34**3 )

      LB = LB + Lcd1(p1,p23,p4)*S14**(-1)*S24**(-1) * (  - 16*s12**3*
     +    s34**2 - 32*s12**2*s13*s34**2 + 8*s12**2*s23*s34**2 - 16*s12*
     +    s13**2*s34**2 - 8*s12*s13*s23*s34**2 + 8*s12*s23*s34**3 - 16*
     +    s13**2*s23*s34**2 + 8*s13*s23*s34**3 )

      LB = LB + Lcd1(p1,p23,p4)*S14**(-1) * ( 32*s12**3*s24 + 64*s12**2
     +    *s13*s24 + 12*s12**2*s23*s24 + 40*s12**2*s24**2 + 52*s12**2*
     +    s24*s34 + 32*s12*s13**2*s24 + 40*s12*s13*s23*s24 + 40*s12*s13
     +    *s24**2 + 52*s12*s13*s24*s34 + 48*s12*s23*s24**2 + 40*s12*s23
     +    *s24*s34 + 72*s12*s24**3 + 112*s12*s24**2*s34 + 40*s12*s24*
     +    s34**2 + 28*s13**2*s23*s24 + 16*s13**2*s24**2 + 20*s13**2*s24
     +    *s34 + 36*s13*s23*s24**2 + 28*s13*s23*s24*s34 + 36*s13*s24**3
     +     + 56*s13*s24**2*s34 + 20*s13*s24*s34**2 )

      LB = LB + Lcd1(p1,p24,p3)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16
     +    *s12**3*s24*s34**2 - 8*s12**2*s24*s34**3 )

      LB = LB + Lcd1(p1,p24,p3)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s23**3 + 36*s12**3*s23**2*s34 + 20*s12**3*s23*s34**2
     +     + 16*s12**2*s23**4 + 32*s12**2*s23**3*s34 + 16*s12**2*s23**2
     +    *s34**2 )

      LB = LB + Lcd1(p1,p24,p3)*S13**(-1)*S14**(-1) * ( 16*s12**3*
     +    s23**2 + 20*s12**3*s23*s34 - 16*s12**3*s24*s34 + 44*s12**2*
     +    s23**3 + 28*s12**2*s23**2*s24 + 72*s12**2*s23**2*s34 + 28*
     +    s12**2*s23*s24*s34 + 28*s12**2*s23*s34**2 - 8*s12**2*s24*
     +    s34**2 )

      LB = LB + Lcd1(p1,p24,p3)*S13**(-1)*S23**(-1) * (  - 16*s12**3*
     +    s34**2 - 32*s12**2*s14*s34**2 + 8*s12**2*s24*s34**2 - 16*s12*
     +    s14**2*s34**2 - 8*s12*s14*s24*s34**2 + 8*s12*s24*s34**3 - 16*
     +    s14**2*s24*s34**2 + 8*s14*s24*s34**3 )

      LB = LB + Lcd1(p1,p24,p3)*S13**(-1)*S24**(-1) * ( 32*s12**3*
     +    s23**2 + 32*s12**3*s23*s34 + 56*s12**2*s14*s23**2 + 56*s12**2
     +    *s14*s23*s34 + 28*s12**2*s23**3 + 60*s12**2*s23**2*s34 + 32*
     +    s12**2*s23*s34**2 + 16*s12*s14**2*s23**2 + 16*s12*s14**2*s23*
     +    s34 - 4*s12*s14*s23**2*s34 - 4*s12*s14*s23*s34**2 + 24*s12*
     +    s23**4 + 48*s12*s23**3*s34 + 24*s12*s23**2*s34**2 - 8*s14**3*
     +    s23**2 - 8*s14**3*s23*s34 - 12*s14**2*s23**3 - 28*s14**2*
     +    s23**2*s34 - 16*s14**2*s23*s34**2 - 8*s14*s23**3*s34 - 16*s14
     +    *s23**2*s34**2 - 8*s14*s23*s34**3 )

      LB = LB + Lcd1(p1,p24,p3)*S13**(-1) * ( 32*s12**3*s23 + 64*s12**2
     +    *s14*s23 + 40*s12**2*s23**2 + 12*s12**2*s23*s24 + 52*s12**2*
     +    s23*s34 + 32*s12*s14**2*s23 + 40*s12*s14*s23**2 + 40*s12*s14*
     +    s23*s24 + 52*s12*s14*s23*s34 + 72*s12*s23**3 + 48*s12*s23**2*
     +    s24 + 112*s12*s23**2*s34 + 40*s12*s23*s24*s34 + 40*s12*s23*
     +    s34**2 + 16*s14**2*s23**2 + 28*s14**2*s23*s24 + 20*s14**2*s23
     +    *s34 + 36*s14*s23**3 + 36*s14*s23**2*s24 + 56*s14*s23**2*s34
     +     + 28*s14*s23*s24*s34 + 20*s14*s23*s34**2 )

      LB = LB + Lcd1(p2,p13,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s14**3 + 36*s12**3*s14**2*s34 + 20*s12**3*s14*s34**2
     +     + 16*s12**2*s14**4 + 32*s12**2*s14**3*s34 + 16*s12**2*s14**2
     +    *s34**2 )

      LB = LB + Lcd1(p2,p13,p4)*S13**(-1)*S24**(-1) * ( 32*s12**3*
     +    s14**2 + 32*s12**3*s14*s34 + 28*s12**2*s14**3 + 56*s12**2*
     +    s14**2*s23 + 60*s12**2*s14**2*s34 + 56*s12**2*s14*s23*s34 + 
     +    32*s12**2*s14*s34**2 + 24*s12*s14**4 + 48*s12*s14**3*s34 + 16
     +    *s12*s14**2*s23**2 - 4*s12*s14**2*s23*s34 + 24*s12*s14**2*
     +    s34**2 + 16*s12*s14*s23**2*s34 - 4*s12*s14*s23*s34**2 - 12*
     +    s14**3*s23**2 - 8*s14**3*s23*s34 - 8*s14**2*s23**3 - 28*
     +    s14**2*s23**2*s34 - 16*s14**2*s23*s34**2 - 8*s14*s23**3*s34
     +     - 16*s14*s23**2*s34**2 - 8*s14*s23*s34**3 )

      LB = LB + Lcd1(p2,p13,p4)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16
     +    *s12**3*s13*s34**2 - 8*s12**2*s13*s34**3 )

      LB = LB + Lcd1(p2,p13,p4)*S14**(-1)*S24**(-1) * (  - 16*s12**3*
     +    s34**2 + 8*s12**2*s13*s34**2 - 32*s12**2*s23*s34**2 - 8*s12*
     +    s13*s23*s34**2 + 8*s12*s13*s34**3 - 16*s12*s23**2*s34**2 - 16
     +    *s13*s23**2*s34**2 + 8*s13*s23*s34**3 )

      LB = LB + Lcd1(p2,p13,p4)*S23**(-1)*S24**(-1) * (  - 16*s12**3*
     +    s13*s34 + 16*s12**3*s14**2 + 20*s12**3*s14*s34 + 28*s12**2*
     +    s13*s14**2 + 28*s12**2*s13*s14*s34 - 8*s12**2*s13*s34**2 + 44
     +    *s12**2*s14**3 + 72*s12**2*s14**2*s34 + 28*s12**2*s14*s34**2
     +     )

      LB = LB + Lcd1(p2,p13,p4)*S24**(-1) * ( 32*s12**3*s14 + 12*s12**2
     +    *s13*s14 + 40*s12**2*s14**2 + 64*s12**2*s14*s23 + 52*s12**2*
     +    s14*s34 + 64*s12*s13*s14**2 + 40*s12*s13*s14*s23 + 56*s12*s13
     +    *s14*s34 + 88*s12*s14**3 + 40*s12*s14**2*s23 + 144*s12*s14**2
     +    *s34 + 32*s12*s14*s23**2 + 52*s12*s14*s23*s34 + 56*s12*s14*
     +    s34**2 + 36*s13*s14**2*s23 + 28*s13*s14*s23**2 + 28*s13*s14*
     +    s23*s34 + 36*s14**3*s23 + 16*s14**2*s23**2 + 56*s14**2*s23*
     +    s34 + 20*s14*s23**2*s34 + 20*s14*s23*s34**2 )

      LB = LB + Lcd1(p2,p14,p3)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16
     +    *s12**3*s14*s34**2 - 8*s12**2*s14*s34**3 )

      LB = LB + Lcd1(p2,p14,p3)*S13**(-1)*S23**(-1) * (  - 16*s12**3*
     +    s34**2 + 8*s12**2*s14*s34**2 - 32*s12**2*s24*s34**2 - 8*s12*
     +    s14*s24*s34**2 + 8*s12*s14*s34**3 - 16*s12*s24**2*s34**2 - 16
     +    *s14*s24**2*s34**2 + 8*s14*s24*s34**3 )

      LB = LB + Lcd1(p2,p14,p3)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s13**3 + 36*s12**3*s13**2*s34 + 20*s12**3*s13*s34**2
     +     + 16*s12**2*s13**4 + 32*s12**2*s13**3*s34 + 16*s12**2*s13**2
     +    *s34**2 )

      LB = LB + Lcd1(p2,p14,p3)*S14**(-1)*S23**(-1) * ( 32*s12**3*
     +    s13**2 + 32*s12**3*s13*s34 + 28*s12**2*s13**3 + 56*s12**2*
     +    s13**2*s24 + 60*s12**2*s13**2*s34 + 56*s12**2*s13*s24*s34 + 
     +    32*s12**2*s13*s34**2 + 24*s12*s13**4 + 48*s12*s13**3*s34 + 16
     +    *s12*s13**2*s24**2 - 4*s12*s13**2*s24*s34 + 24*s12*s13**2*
     +    s34**2 + 16*s12*s13*s24**2*s34 - 4*s12*s13*s24*s34**2 - 12*
     +    s13**3*s24**2 - 8*s13**3*s24*s34 - 8*s13**2*s24**3 - 28*
     +    s13**2*s24**2*s34 - 16*s13**2*s24*s34**2 - 8*s13*s24**3*s34
     +     - 16*s13*s24**2*s34**2 - 8*s13*s24*s34**3 )

      LB = LB + Lcd1(p2,p14,p3)*S23**(-1)*S24**(-1) * ( 16*s12**3*
     +    s13**2 + 20*s12**3*s13*s34 - 16*s12**3*s14*s34 + 44*s12**2*
     +    s13**3 + 28*s12**2*s13**2*s14 + 72*s12**2*s13**2*s34 + 28*
     +    s12**2*s13*s14*s34 + 28*s12**2*s13*s34**2 - 8*s12**2*s14*
     +    s34**2 )

      LB = LB + Lcd1(p2,p14,p3)*S23**(-1) * ( 32*s12**3*s13 + 40*s12**2
     +    *s13**2 + 12*s12**2*s13*s14 + 64*s12**2*s13*s24 + 52*s12**2*
     +    s13*s34 + 88*s12*s13**3 + 64*s12*s13**2*s14 + 40*s12*s13**2*
     +    s24 + 144*s12*s13**2*s34 + 40*s12*s13*s14*s24 + 56*s12*s13*
     +    s14*s34 + 32*s12*s13*s24**2 + 52*s12*s13*s24*s34 + 56*s12*s13
     +    *s34**2 + 36*s13**3*s24 + 36*s13**2*s14*s24 + 16*s13**2*
     +    s24**2 + 56*s13**2*s24*s34 + 28*s13*s14*s24**2 + 28*s13*s14*
     +    s24*s34 + 20*s13*s24**2*s34 + 20*s13*s24*s34**2 )

      LB = LB + Lcd1(p3,p12,p4)*S13**(-1)*S24**(-1) * ( 48*s12**2*
     +    s14**3 - 112*s12**2*s14**2*s23 + 144*s12*s14**3*s23 + 16*s12*
     +    s14**2*s23**2 + 16*s14**4*s23 + 32*s14**3*s23**2 )

      LB = LB + Lcd1(p3,p12,p4)*S13**(-1) * (  - 64*s12**2*s14**2 - 80*
     +    s12**2*s14*s23 - 80*s12**2*s14*s24 + 144*s12*s14**2*s23 - 16*
     +    s12*s14**2*s24 - 32*s12*s14*s23**2 - 48*s12*s14*s23*s24 - 16*
     +    s12*s14*s24**2 + 32*s14**3*s23 + 16*s14**2*s23**2 - 16*s14*
     +    s23**3 - 32*s14*s23**2*s24 - 16*s14*s23*s24**2 )

      LB = LB + Lcd1(p3,p12,p4)*S23**(-1)*S24**(-1) * (  - 48*s12**2*
     +    s13**2*s14 - 48*s12**2*s13*s14**2 - 48*s12*s13**3*s14 + 16*
     +    s12*s13**2*s14**2 + 112*s12*s13*s14**3 + 48*s12*s14**4 + 16*
     +    s13**3*s14**2 + 16*s13**2*s14**3 )

      LB = LB + Lcd1(p3,p12,p4)*S23**(-1) * (  - 48*s12**2*s13**2 - 176
     +    *s12**2*s13*s14 - 96*s12**2*s13*s24 - 128*s12**2*s14**2 - 96*
     +    s12**2*s14*s24 - 48*s12*s13**3 + 32*s12*s13**2*s14 - 32*s12*
     +    s13**2*s24 + 192*s12*s13*s14**2 - 32*s12*s13*s24**2 + 32*s12*
     +    s14**3 - 48*s12*s14**2*s24 - 32*s12*s14*s24**2 + 32*s13**3*
     +    s14 + 80*s13**2*s14**2 + 64*s13**2*s14*s24 + 16*s13**2*s24**2
     +     + 48*s13*s14**3 + 80*s13*s14**2*s24 + 32*s13*s14*s24**2 )

      LB = LB + Lcd1(p3,p12,p4)*S24**(-1) * (  - 128*s12**2*s13*s14 - 
     +    80*s12**2*s14**2 - 112*s12**2*s14*s23 - 32*s12*s13**2*s14 + 
     +    176*s12*s13*s14**2 - 48*s12*s13*s14*s23 + 176*s12*s14**3 + 
     +    160*s12*s14**2*s23 - 16*s12*s14*s23**2 + 80*s13**2*s14**2 + 
     +    96*s13*s14**3 + 80*s13*s14**2*s23 + 128*s14**3*s23 + 16*
     +    s14**2*s23**2 )

      LB = LB + Lcd1(p3,p12,p4) * (  - 96*s12**2*s13 - 160*s12**2*s14
     +     - 80*s12**2*s23 - 80*s12**2*s24 - 32*s12*s13**2 + 144*s12*
     +    s13*s14 - 48*s12*s13*s23 - 80*s12*s13*s24 + 256*s12*s14**2 + 
     +    96*s12*s14*s23 - 16*s12*s14*s24 - 16*s12*s23**2 - 16*s12*s23*
     +    s24 + 128*s13**2*s14 + 16*s13**2*s24 + 240*s13*s14**2 + 112*
     +    s13*s14*s23 + 128*s13*s14*s24 + 32*s13*s23*s24 + 32*s13*
     +    s24**2 + 80*s14**3 + 224*s14**2*s23 + 144*s14**2*s24 + 80*s14
     +    *s23*s24 + 80*s14*s24**2 + 16*s23**2*s24 + 32*s23*s24**2 + 16
     +    *s24**3 )

      LB = LB + Lcd1(p3,p14,p2)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 36*s12**4*s34**3 )

      LB = LB + Lcd1(p3,p14,p2)*S13**(-1)*S14**(-1)*S23**(-1) * ( 32*
     +    s12**4*s34**2 + 48*s12**3*s24*s34**2 + 52*s12**3*s34**3 + 16*
     +    s12**2*s24**2*s34**2 + 16*s12**2*s24*s34**3 )

      LB = LB + Lcd1(p3,p14,p2)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**4*s14*s34 + 36*s12**4*s34**2 - 4*s12**3*s14*s34**2 + 4*
     +    s12**3*s34**3 )

      LB = LB + Lcd1(p3,p14,p2)*S13**(-1)*S23**(-1) * ( 32*s12**4*s34
     +     - 4*s12**3*s14*s34 + 56*s12**3*s24*s34 + 64*s12**3*s34**2 + 
     +    4*s12**2*s14*s24*s34 - 4*s12**2*s14*s34**2 + 24*s12**2*s24**2
     +    *s34 + 28*s12**2*s24*s34**2 + 4*s12**2*s34**3 )

      LB = LB + Lcd1(p3,p14,p2)*S14**(-1)*S23**(-1)*S24**(-1) * ( 48*
     +    s12**4*s13**2 + 132*s12**4*s13*s34 + 120*s12**4*s34**2 + 16*
     +    s12**3*s13**3 + 48*s12**3*s13**2*s34 + 48*s12**3*s13*s34**2
     +     + 16*s12**3*s34**3 )

      LB = LB + Lcd1(p3,p14,p2)*S14**(-1)*S23**(-1) * ( 32*s12**4*s13
     +     + 64*s12**4*s34 + 92*s12**3*s13**2 + 72*s12**3*s13*s24 + 244
     +    *s12**3*s13*s34 + 120*s12**3*s24*s34 + 204*s12**3*s34**2 + 40
     +    *s12**2*s13**3 + 68*s12**2*s13**2*s24 + 104*s12**2*s13**2*s34
     +     + 64*s12**2*s13*s24**2 + 168*s12**2*s13*s24*s34 + 88*s12**2*
     +    s13*s34**2 + 80*s12**2*s24**2*s34 + 116*s12**2*s24*s34**2 + 
     +    24*s12**2*s34**3 + 24*s12*s13**3*s24 + 24*s12*s13**2*s24**2
     +     + 56*s12*s13**2*s24*s34 + 24*s12*s13*s24**3 + 56*s12*s13*
     +    s24**2*s34 + 40*s12*s13*s24*s34**2 + 24*s12*s24**3*s34 + 32*
     +    s12*s24**2*s34**2 + 8*s12*s24*s34**3 )

      LB = LB + Lcd1(p3,p14,p2)*S23**(-1)*S24**(-1) * ( 48*s12**4*s13
     +     + 84*s12**4*s34 + 28*s12**3*s13**2 + 12*s12**3*s13*s14 + 60*
     +    s12**3*s13*s34 + 16*s12**3*s14*s34 + 36*s12**3*s34**2 )

      LB = LB + Lcd1(p3,p14,p2)*S23**(-1) * ( 32*s12**4 + 112*s12**3*
     +    s13 + 20*s12**3*s14 + 80*s12**3*s24 + 184*s12**3*s34 + 36*
     +    s12**2*s13**2 - 4*s12**2*s13*s14 + 88*s12**2*s13*s24 + 76*
     +    s12**2*s13*s34 + 20*s12**2*s14*s24 + 16*s12**2*s14*s34 + 72*
     +    s12**2*s24**2 + 132*s12**2*s24*s34 + 44*s12**2*s34**2 + 8*s12
     +    *s13**2*s24 - 16*s12*s13*s14*s24 + 24*s12*s13*s24**2 + 16*s12
     +    *s13*s24*s34 + 24*s12*s24**3 + 32*s12*s24**2*s34 + 8*s12*s24*
     +    s34**2 )

      LB = LB + Lcd1(p3,p24,p1)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 36*s12**4*s34**3 )

      LB = LB + Lcd1(p3,p24,p1)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 8*
     +    s12**4*s24*s34 + 36*s12**4*s34**2 - 4*s12**3*s24*s34**2 + 4*
     +    s12**3*s34**3 )

      LB = LB + Lcd1(p3,p24,p1)*S13**(-1)*S14**(-1)*S24**(-1) * ( 48*
     +    s12**4*s23**2 + 132*s12**4*s23*s34 + 120*s12**4*s34**2 + 16*
     +    s12**3*s23**3 + 48*s12**3*s23**2*s34 + 48*s12**3*s23*s34**2
     +     + 16*s12**3*s34**3 )

      LB = LB + Lcd1(p3,p24,p1)*S13**(-1)*S14**(-1) * ( 48*s12**4*s23
     +     + 84*s12**4*s34 + 28*s12**3*s23**2 + 12*s12**3*s23*s24 + 60*
     +    s12**3*s23*s34 + 16*s12**3*s24*s34 + 36*s12**3*s34**2 )

      LB = LB + Lcd1(p3,p24,p1)*S13**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**4*s34**2 + 48*s12**3*s14*s34**2 + 52*s12**3*s34**3 + 16*
     +    s12**2*s14**2*s34**2 + 16*s12**2*s14*s34**3 )

      LB = LB + Lcd1(p3,p24,p1)*S13**(-1)*S23**(-1) * ( 32*s12**4*s34
     +     + 56*s12**3*s14*s34 - 4*s12**3*s24*s34 + 64*s12**3*s34**2 + 
     +    24*s12**2*s14**2*s34 + 4*s12**2*s14*s24*s34 + 28*s12**2*s14*
     +    s34**2 - 4*s12**2*s24*s34**2 + 4*s12**2*s34**3 )

      LB = LB + Lcd1(p3,p24,p1)*S13**(-1)*S24**(-1) * ( 32*s12**4*s23
     +     + 64*s12**4*s34 + 72*s12**3*s14*s23 + 120*s12**3*s14*s34 + 
     +    92*s12**3*s23**2 + 244*s12**3*s23*s34 + 204*s12**3*s34**2 + 
     +    64*s12**2*s14**2*s23 + 80*s12**2*s14**2*s34 + 68*s12**2*s14*
     +    s23**2 + 168*s12**2*s14*s23*s34 + 116*s12**2*s14*s34**2 + 40*
     +    s12**2*s23**3 + 104*s12**2*s23**2*s34 + 88*s12**2*s23*s34**2
     +     + 24*s12**2*s34**3 + 24*s12*s14**3*s23 + 24*s12*s14**3*s34
     +     + 24*s12*s14**2*s23**2 + 56*s12*s14**2*s23*s34 + 32*s12*
     +    s14**2*s34**2 + 24*s12*s14*s23**3 + 56*s12*s14*s23**2*s34 + 
     +    40*s12*s14*s23*s34**2 + 8*s12*s14*s34**3 )

      LB = LB + Lcd1(p3,p24,p1)*S13**(-1) * ( 32*s12**4 + 80*s12**3*s14
     +     + 112*s12**3*s23 + 20*s12**3*s24 + 184*s12**3*s34 + 72*
     +    s12**2*s14**2 + 88*s12**2*s14*s23 + 20*s12**2*s14*s24 + 132*
     +    s12**2*s14*s34 + 52*s12**2*s23**2 + 12*s12**2*s23*s24 + 92*
     +    s12**2*s23*s34 + 16*s12**2*s24*s34 + 44*s12**2*s34**2 + 24*
     +    s12*s14**3 + 24*s12*s14**2*s23 + 32*s12*s14**2*s34 + 24*s12*
     +    s14*s23**2 + 32*s12*s14*s23*s34 + 8*s12*s14*s34**2 )

      LB = LB + Lcd1(p4,p12,p3)*S14**(-1)*S23**(-1) * ( 48*s12**2*
     +    s13**3 - 112*s12**2*s13**2*s24 + 144*s12*s13**3*s24 + 16*s12*
     +    s13**2*s24**2 + 16*s13**4*s24 + 32*s13**3*s24**2 )

      LB = LB + Lcd1(p4,p12,p3)*S14**(-1) * (  - 64*s12**2*s13**2 - 80*
     +    s12**2*s13*s23 - 80*s12**2*s13*s24 - 16*s12*s13**2*s23 + 144*
     +    s12*s13**2*s24 - 16*s12*s13*s23**2 - 48*s12*s13*s23*s24 - 32*
     +    s12*s13*s24**2 + 32*s13**3*s24 + 16*s13**2*s24**2 - 16*s13*
     +    s23**2*s24 - 32*s13*s23*s24**2 - 16*s13*s24**3 )

      LB = LB + Lcd1(p4,p12,p3)*S23**(-1)*S24**(-1) * (  - 48*s12**2*
     +    s13**2*s14 - 48*s12**2*s13*s14**2 + 48*s12*s13**4 + 112*s12*
     +    s13**3*s14 + 16*s12*s13**2*s14**2 - 48*s12*s13*s14**3 + 16*
     +    s13**3*s14**2 + 16*s13**2*s14**3 )

      LB = LB + Lcd1(p4,p12,p3)*S23**(-1) * (  - 80*s12**2*s13**2 - 128
     +    *s12**2*s13*s14 - 112*s12**2*s13*s24 + 176*s12*s13**3 + 176*
     +    s12*s13**2*s14 + 160*s12*s13**2*s24 - 32*s12*s13*s14**2 - 48*
     +    s12*s13*s14*s24 - 16*s12*s13*s24**2 + 96*s13**3*s14 + 128*
     +    s13**3*s24 + 80*s13**2*s14**2 + 80*s13**2*s14*s24 + 16*s13**2
     +    *s24**2 )

      LB = LB + Lcd1(p4,p12,p3)*S24**(-1) * (  - 128*s12**2*s13**2 - 
     +    176*s12**2*s13*s14 - 96*s12**2*s13*s23 - 48*s12**2*s14**2 - 
     +    96*s12**2*s14*s23 + 32*s12*s13**3 + 192*s12*s13**2*s14 - 48*
     +    s12*s13**2*s23 + 32*s12*s13*s14**2 - 32*s12*s13*s23**2 - 48*
     +    s12*s14**3 - 32*s12*s14**2*s23 - 32*s12*s14*s23**2 + 48*
     +    s13**3*s14 + 80*s13**2*s14**2 + 80*s13**2*s14*s23 + 32*s13*
     +    s14**3 + 64*s13*s14**2*s23 + 32*s13*s14*s23**2 + 16*s14**2*
     +    s23**2 )

      LB = LB + Lcd1(p4,p12,p3) * (  - 160*s12**2*s13 - 96*s12**2*s14
     +     - 80*s12**2*s23 - 80*s12**2*s24 + 256*s12*s13**2 + 144*s12*
     +    s13*s14 - 16*s12*s13*s23 + 96*s12*s13*s24 - 32*s12*s14**2 - 
     +    80*s12*s14*s23 - 48*s12*s14*s24 - 16*s12*s23*s24 - 16*s12*
     +    s24**2 + 80*s13**3 + 240*s13**2*s14 + 144*s13**2*s23 + 224*
     +    s13**2*s24 + 128*s13*s14**2 + 128*s13*s14*s23 + 112*s13*s14*
     +    s24 + 80*s13*s23**2 + 80*s13*s23*s24 + 16*s14**2*s23 + 32*s14
     +    *s23**2 + 32*s14*s23*s24 + 16*s23**3 + 32*s23**2*s24 + 16*s23
     +    *s24**2 )

      LB = LB + Lcd1(p4,p13,p2)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 36*s12**4*s34**3 )

      LB = LB + Lcd1(p4,p13,p2)*S13**(-1)*S14**(-1)*S24**(-1) * ( 32*
     +    s12**4*s34**2 + 48*s12**3*s23*s34**2 + 52*s12**3*s34**3 + 16*
     +    s12**2*s23**2*s34**2 + 16*s12**2*s23*s34**3 )

      LB = LB + Lcd1(p4,p13,p2)*S13**(-1)*S23**(-1)*S24**(-1) * ( 48*
     +    s12**4*s14**2 + 132*s12**4*s14*s34 + 120*s12**4*s34**2 + 16*
     +    s12**3*s14**3 + 48*s12**3*s14**2*s34 + 48*s12**3*s14*s34**2
     +     + 16*s12**3*s34**3 )

      LB = LB + Lcd1(p4,p13,p2)*S13**(-1)*S24**(-1) * ( 32*s12**4*s14
     +     + 64*s12**4*s34 + 92*s12**3*s14**2 + 72*s12**3*s14*s23 + 244
     +    *s12**3*s14*s34 + 120*s12**3*s23*s34 + 204*s12**3*s34**2 + 40
     +    *s12**2*s14**3 + 68*s12**2*s14**2*s23 + 104*s12**2*s14**2*s34
     +     + 64*s12**2*s14*s23**2 + 168*s12**2*s14*s23*s34 + 88*s12**2*
     +    s14*s34**2 + 80*s12**2*s23**2*s34 + 116*s12**2*s23*s34**2 + 
     +    24*s12**2*s34**3 + 24*s12*s14**3*s23 + 24*s12*s14**2*s23**2
     +     + 56*s12*s14**2*s23*s34 + 24*s12*s14*s23**3 + 56*s12*s14*
     +    s23**2*s34 + 40*s12*s14*s23*s34**2 + 24*s12*s23**3*s34 + 32*
     +    s12*s23**2*s34**2 + 8*s12*s23*s34**3 )

      LB = LB + Lcd1(p4,p13,p2)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**4*s13*s34 + 36*s12**4*s34**2 - 4*s12**3*s13*s34**2 + 4*
     +    s12**3*s34**3 )

      LB = LB + Lcd1(p4,p13,p2)*S14**(-1)*S24**(-1) * ( 32*s12**4*s34
     +     - 4*s12**3*s13*s34 + 56*s12**3*s23*s34 + 64*s12**3*s34**2 + 
     +    4*s12**2*s13*s23*s34 - 4*s12**2*s13*s34**2 + 24*s12**2*s23**2
     +    *s34 + 28*s12**2*s23*s34**2 + 4*s12**2*s34**3 )

      LB = LB + Lcd1(p4,p13,p2)*S23**(-1)*S24**(-1) * ( 48*s12**4*s14
     +     + 84*s12**4*s34 + 12*s12**3*s13*s14 + 16*s12**3*s13*s34 + 28
     +    *s12**3*s14**2 + 60*s12**3*s14*s34 + 36*s12**3*s34**2 )

      LB = LB + Lcd1(p4,p13,p2)*S24**(-1) * ( 32*s12**4 + 20*s12**3*s13
     +     + 112*s12**3*s14 + 80*s12**3*s23 + 184*s12**3*s34 - 4*s12**2
     +    *s13*s14 + 20*s12**2*s13*s23 + 16*s12**2*s13*s34 + 36*s12**2*
     +    s14**2 + 88*s12**2*s14*s23 + 76*s12**2*s14*s34 + 72*s12**2*
     +    s23**2 + 132*s12**2*s23*s34 + 44*s12**2*s34**2 - 16*s12*s13*
     +    s14*s23 + 8*s12*s14**2*s23 + 24*s12*s14*s23**2 + 16*s12*s14*
     +    s23*s34 + 24*s12*s23**3 + 32*s12*s23**2*s34 + 8*s12*s23*
     +    s34**2 )

      LB = LB + Lcd1(p4,p23,p1)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 36*s12**4*s34**3 )

      LB = LB + Lcd1(p4,p23,p1)*S13**(-1)*S14**(-1)*S23**(-1) * ( 48*
     +    s12**4*s24**2 + 132*s12**4*s24*s34 + 120*s12**4*s34**2 + 16*
     +    s12**3*s24**3 + 48*s12**3*s24**2*s34 + 48*s12**3*s24*s34**2
     +     + 16*s12**3*s34**3 )

      LB = LB + Lcd1(p4,p23,p1)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 8*
     +    s12**4*s23*s34 + 36*s12**4*s34**2 - 4*s12**3*s23*s34**2 + 4*
     +    s12**3*s34**3 )

      LB = LB + Lcd1(p4,p23,p1)*S13**(-1)*S14**(-1) * ( 48*s12**4*s24
     +     + 84*s12**4*s34 + 12*s12**3*s23*s24 + 16*s12**3*s23*s34 + 28
     +    *s12**3*s24**2 + 60*s12**3*s24*s34 + 36*s12**3*s34**2 )

      LB = LB + Lcd1(p4,p23,p1)*S14**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**4*s34**2 + 48*s12**3*s13*s34**2 + 52*s12**3*s34**3 + 16*
     +    s12**2*s13**2*s34**2 + 16*s12**2*s13*s34**3 )

      LB = LB + Lcd1(p4,p23,p1)*S14**(-1)*S23**(-1) * ( 32*s12**4*s24
     +     + 64*s12**4*s34 + 72*s12**3*s13*s24 + 120*s12**3*s13*s34 + 
     +    92*s12**3*s24**2 + 244*s12**3*s24*s34 + 204*s12**3*s34**2 + 
     +    64*s12**2*s13**2*s24 + 80*s12**2*s13**2*s34 + 68*s12**2*s13*
     +    s24**2 + 168*s12**2*s13*s24*s34 + 116*s12**2*s13*s34**2 + 40*
     +    s12**2*s24**3 + 104*s12**2*s24**2*s34 + 88*s12**2*s24*s34**2
     +     + 24*s12**2*s34**3 + 24*s12*s13**3*s24 + 24*s12*s13**3*s34
     +     + 24*s12*s13**2*s24**2 + 56*s12*s13**2*s24*s34 + 32*s12*
     +    s13**2*s34**2 + 24*s12*s13*s24**3 + 56*s12*s13*s24**2*s34 + 
     +    40*s12*s13*s24*s34**2 + 8*s12*s13*s34**3 )

      LB = LB + Lcd1(p4,p23,p1)*S14**(-1)*S24**(-1) * ( 32*s12**4*s34
     +     + 56*s12**3*s13*s34 - 4*s12**3*s23*s34 + 64*s12**3*s34**2 + 
     +    24*s12**2*s13**2*s34 + 4*s12**2*s13*s23*s34 + 28*s12**2*s13*
     +    s34**2 - 4*s12**2*s23*s34**2 + 4*s12**2*s34**3 )

      LB = LB + Lcd1(p4,p23,p1)*S14**(-1) * ( 32*s12**4 + 80*s12**3*s13
     +     + 20*s12**3*s23 + 112*s12**3*s24 + 184*s12**3*s34 + 72*
     +    s12**2*s13**2 + 20*s12**2*s13*s23 + 88*s12**2*s13*s24 + 132*
     +    s12**2*s13*s34 + 12*s12**2*s23*s24 + 16*s12**2*s23*s34 + 52*
     +    s12**2*s24**2 + 92*s12**2*s24*s34 + 44*s12**2*s34**2 + 24*s12
     +    *s13**3 + 24*s12*s13**2*s24 + 32*s12*s13**2*s34 + 24*s12*s13*
     +    s24**2 + 32*s12*s13*s24*s34 + 8*s12*s13*s34**2 )

      LB = LB + Lcd2(p1,p23,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S234 * ( 
     +    16*s12**2*s24**3 + 28*s12**2*s24**2*s34 + 12*s12**2*s24*
     +    s34**2 )

      LB = LB + Lcd2(p1,p23,p4)*S14**(-1)*S23**(-1)*S234 * ( 16*s12**2*
     +    s24**2 + 12*s12**2*s24*s34 + 20*s12*s13*s24**2 + 12*s12*s13*
     +    s24*s34 + 20*s12*s24**3 + 32*s12*s24**2*s34 + 12*s12*s24*
     +    s34**2 + 4*s13**2*s24**2 + 4*s13*s24**3 + 4*s13*s24**2*s34 )

      LB = LB + Lcd2(p1,p24,p3)*S13**(-1)*S14**(-1)*S24**(-1)*S234 * ( 
     +    16*s12**2*s23**3 + 28*s12**2*s23**2*s34 + 12*s12**2*s23*
     +    s34**2 )

      LB = LB + Lcd2(p1,p24,p3)*S13**(-1)*S24**(-1)*S234 * ( 16*s12**2*
     +    s23**2 + 12*s12**2*s23*s34 + 20*s12*s14*s23**2 + 12*s12*s14*
     +    s23*s34 + 20*s12*s23**3 + 32*s12*s23**2*s34 + 12*s12*s23*
     +    s34**2 + 4*s14**2*s23**2 + 4*s14*s23**3 + 4*s14*s23**2*s34 )

      LB = LB + Lcd2(p2,p13,p4)*S13**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +    16*s12**2*s14**3 + 28*s12**2*s14**2*s34 + 12*s12**2*s14*
     +    s34**2 )

      LB = LB + Lcd2(p2,p13,p4)*S13**(-1)*S24**(-1)*S134 * ( 16*s12**2*
     +    s14**2 + 12*s12**2*s14*s34 + 20*s12*s14**3 + 20*s12*s14**2*
     +    s23 + 32*s12*s14**2*s34 + 12*s12*s14*s23*s34 + 12*s12*s14*
     +    s34**2 + 4*s14**3*s23 + 4*s14**2*s23**2 + 4*s14**2*s23*s34 )

      LB = LB + Lcd2(p2,p14,p3)*S14**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +    16*s12**2*s13**3 + 28*s12**2*s13**2*s34 + 12*s12**2*s13*
     +    s34**2 )

      LB = LB + Lcd2(p2,p14,p3)*S14**(-1)*S23**(-1)*S134 * ( 16*s12**2*
     +    s13**2 + 12*s12**2*s13*s34 + 20*s12*s13**3 + 20*s12*s13**2*
     +    s24 + 32*s12*s13**2*s34 + 12*s12*s13*s24*s34 + 12*s12*s13*
     +    s34**2 + 4*s13**3*s24 + 4*s13**2*s24**2 + 4*s13**2*s24*s34 )

      LB = LB + Lcd2(p3,p12,p4)*S13**(-1)*S24**(-1) * (  - 80*s12*
     +    s14**3*s23 - 16*s14**4*s23 - 16*s14**3*s23**2 )

      LB = LB + Lcd2(p3,p12,p4)*S13**(-1) * (  - 80*s12*s14**3 - 80*s12
     +    *s14**2*s23 - 80*s12*s14**2*s24 - 16*s14**4 - 48*s14**3*s23
     +     - 32*s14**3*s24 - 16*s14**2*s23**2 - 32*s14**2*s23*s24 - 16*
     +    s14**2*s24**2 )

      LB = LB + Lcd2(p3,p12,p4)*S23**(-1) * (  - 80*s12*s13*s14**2 - 80
     +    *s12*s13*s14*s24 - 80*s12*s14**3 - 80*s12*s14**2*s24 - 16*
     +    s13**2*s14**2 - 16*s13**2*s14*s24 - 32*s13*s14**3 - 48*s13*
     +    s14**2*s24 - 16*s13*s14*s24**2 - 16*s14**4 - 32*s14**3*s24 - 
     +    16*s14**2*s24**2 )

      LB = LB + Lcd2(p3,p12,p4)*S24**(-1) * (  - 80*s12*s13*s14**2 - 80
     +    *s12*s14**3 - 80*s12*s14**2*s23 - 16*s13**2*s14**2 - 32*s13*
     +    s14**3 - 32*s13*s14**2*s23 - 16*s14**4 - 48*s14**3*s23 - 16*
     +    s14**2*s23**2 )

      LB = LB + Lcd2(p3,p12,p4) * (  - 80*s12*s13*s14 - 160*s12*s14**2
     +     - 80*s12*s14*s23 - 80*s12*s14*s24 - 16*s13**2*s14 - 80*s13*
     +    s14**2 - 32*s13*s14*s23 - 48*s13*s14*s24 - 80*s14**3 - 80*
     +    s14**2*s23 - 80*s14**2*s24 - 16*s14*s23**2 - 32*s14*s23*s24
     +     - 16*s14*s24**2 )

      LB = LB + Lcd2(p3,p14,p2)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     + *S134 * (  - 4*s12**4*s34**2 )

      LB = LB + Lcd2(p3,p14,p2)*S13**(-1)*S14**(-1)*S23**(-1)*S134 * ( 
     +     - 4*s12**4*s34 - 4*s12**3*s24*s34 - 4*s12**3*s34**2 )

      LB = LB + Lcd2(p3,p14,p2)*S14**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +     - 16*s12**4*s13 - 20*s12**4*s34 )

      LB = LB + Lcd2(p3,p14,p2)*S14**(-1)*S23**(-1)*S134 * (  - 16*
     +    s12**4 - 28*s12**3*s13 - 28*s12**3*s24 - 32*s12**3*s34 - 12*
     +    s12**2*s13*s24 - 12*s12**2*s24**2 - 12*s12**2*s24*s34 )

      LB = LB + Lcd2(p3,p24,p1)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     + *S234 * (  - 4*s12**4*s34**2 )

      LB = LB + Lcd2(p3,p24,p1)*S13**(-1)*S14**(-1)*S24**(-1)*S234 * ( 
     +     - 16*s12**4*s23 - 20*s12**4*s34 )

      LB = LB + Lcd2(p3,p24,p1)*S13**(-1)*S23**(-1)*S24**(-1)*S234 * ( 
     +     - 4*s12**4*s34 - 4*s12**3*s14*s34 - 4*s12**3*s34**2 )

      LB = LB + Lcd2(p3,p24,p1)*S13**(-1)*S24**(-1)*S234 * (  - 16*
     +    s12**4 - 28*s12**3*s14 - 28*s12**3*s23 - 32*s12**3*s34 - 12*
     +    s12**2*s14**2 - 12*s12**2*s14*s23 - 12*s12**2*s14*s34 )

      LB = LB + Lcd2(p4,p12,p3)*S14**(-1)*S23**(-1) * (  - 80*s12*
     +    s13**3*s24 - 16*s13**4*s24 - 16*s13**3*s24**2 )

      LB = LB + Lcd2(p4,p12,p3)*S14**(-1) * (  - 80*s12*s13**3 - 80*s12
     +    *s13**2*s23 - 80*s12*s13**2*s24 - 16*s13**4 - 32*s13**3*s23
     +     - 48*s13**3*s24 - 16*s13**2*s23**2 - 32*s13**2*s23*s24 - 16*
     +    s13**2*s24**2 )

      LB = LB + Lcd2(p4,p12,p3)*S23**(-1) * (  - 80*s12*s13**3 - 80*s12
     +    *s13**2*s14 - 80*s12*s13**2*s24 - 16*s13**4 - 32*s13**3*s14
     +     - 48*s13**3*s24 - 16*s13**2*s14**2 - 32*s13**2*s14*s24 - 16*
     +    s13**2*s24**2 )

      LB = LB + Lcd2(p4,p12,p3)*S24**(-1) * (  - 80*s12*s13**3 - 80*s12
     +    *s13**2*s14 - 80*s12*s13**2*s23 - 80*s12*s13*s14*s23 - 16*
     +    s13**4 - 32*s13**3*s14 - 32*s13**3*s23 - 16*s13**2*s14**2 - 
     +    48*s13**2*s14*s23 - 16*s13**2*s23**2 - 16*s13*s14**2*s23 - 16
     +    *s13*s14*s23**2 )

      LB = LB + Lcd2(p4,p12,p3) * (  - 160*s12*s13**2 - 80*s12*s13*s14
     +     - 80*s12*s13*s23 - 80*s12*s13*s24 - 80*s13**3 - 80*s13**2*
     +    s14 - 80*s13**2*s23 - 80*s13**2*s24 - 16*s13*s14**2 - 48*s13*
     +    s14*s23 - 32*s13*s14*s24 - 16*s13*s23**2 - 32*s13*s23*s24 - 
     +    16*s13*s24**2 )

      LB = LB + Lcd2(p4,p13,p2)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     + *S134 * (  - 4*s12**4*s34**2 )

      LB = LB + Lcd2(p4,p13,p2)*S13**(-1)*S14**(-1)*S24**(-1)*S134 * ( 
     +     - 4*s12**4*s34 - 4*s12**3*s23*s34 - 4*s12**3*s34**2 )

      LB = LB + Lcd2(p4,p13,p2)*S13**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +     - 16*s12**4*s14 - 20*s12**4*s34 )

      LB = LB + Lcd2(p4,p13,p2)*S13**(-1)*S24**(-1)*S134 * (  - 16*
     +    s12**4 - 28*s12**3*s14 - 28*s12**3*s23 - 32*s12**3*s34 - 12*
     +    s12**2*s14*s23 - 12*s12**2*s23**2 - 12*s12**2*s23*s34 )

      LB = LB + Lcd2(p4,p23,p1)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     + *S234 * (  - 4*s12**4*s34**2 )

      LB = LB + Lcd2(p4,p23,p1)*S13**(-1)*S14**(-1)*S23**(-1)*S234 * ( 
     +     - 16*s12**4*s24 - 20*s12**4*s34 )

      LB = LB + Lcd2(p4,p23,p1)*S14**(-1)*S23**(-1)*S24**(-1)*S234 * ( 
     +     - 4*s12**4*s34 - 4*s12**3*s13*s34 - 4*s12**3*s34**2 )

      LB = LB + Lcd2(p4,p23,p1)*S14**(-1)*S23**(-1)*S234 * (  - 16*
     +    s12**4 - 28*s12**3*s13 - 28*s12**3*s24 - 32*s12**3*s34 - 12*
     +    s12**2*s13**2 - 12*s12**2*s13*s24 - 12*s12**2*s13*s34 )

      LBe=-LB/s134/s234
      
      return
      end

      function LBf(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      SF=(s13*s24-s14*s23)/2d0/s34

      LB=0d0

      LB = LB + Ld0(p1,p2,p3)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LB = LB + Ld0(p1,p2,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s34 + 40*s12**2*s24*s34 + 40*s12**2*s34**2 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LB = LB + Ld0(p1,p2,p3)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 )

      LB = LB + Ld0(p1,p2,p3)*S13**(-1)*S14**(-1) * (  - 16*s12**2*s23
     +     - 16*s12**2*s24 + 24*s12**2*s34 - 16*s12*s23*s24 - 16*s12*
     +    s24**2 - 8*s12*s24*s34 - 8*s23*s24**2 - 8*s24**3 - 8*s24**2*
     +    s34 )

      LB = LB + Ld0(p1,p2,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s14*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s14**2*s34 + 8*s12*s14*s34**2 )

      LB = LB + Ld0(p1,p2,p3)*S13**(-1)*S23**(-1) * ( 32*s12**3 + 56*
     +    s12**2*s14 + 56*s12**2*s24 + 96*s12**2*s34 + 16*s12*s14**2 + 
     +    24*s12*s14*s34 + 16*s12*s24**2 + 24*s12*s24*s34 + 16*s12*
     +    s34**2 )

      LB = LB + Ld0(p1,p2,p3)*S13**(-1)*S24**(-1) * ( 40*s12**3 + 64*
     +    s12**2*s14 + 8*s12**2*s23 + 32*s12**2*s34 + 16*s12*s14**2 + 
     +    16*s12*s14*s23 + 24*s12*s14*s34 + 16*s12*s23*s34 + 8*s12*
     +    s34**2 + 16*s14**2*s23 + 16*s14**2*s34 + 8*s14*s23**2 + 32*
     +    s14*s23*s34 + 16*s14*s34**2 + 8*s23*s34**2 )

      LB = LB + Ld0(p1,p2,p3)*S13**(-1) * ( 64*s12**2 + 8*s12*s14 + 8*
     +    s12*s23 + 24*s12*s24 + 32*s12*s34 - 8*s14**2 - 8*s14*s23 - 16
     +    *s14*s24 - 8*s14*s34 + 8*s23*s24 - 8*s23*s34 + 8*s24**2 )

      LB = LB + Ld0(p1,p2,p3)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s13*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s13**2*s34 + 8*s12*s13*s34**2 )

      LB = LB + Ld0(p1,p2,p3)*S14**(-1)*S23**(-1) * ( 32*s12**3 + 64*
     +    s12**2*s13 + 80*s12**2*s24 + 96*s12**2*s34 + 48*s12*s13**2 + 
     +    64*s12*s13*s24 + 72*s12*s13*s34 + 32*s12*s24**2 + 56*s12*s24*
     +    s34 + 24*s12*s34**2 + 16*s13**3 + 32*s13**2*s24 + 32*s13**2*
     +    s34 + 24*s13*s24**2 + 48*s13*s24*s34 + 24*s13*s34**2 + 8*
     +    s24**3 + 24*s24**2*s34 + 24*s24*s34**2 + 8*s34**3 )

      LB = LB + Ld0(p1,p2,p3)*S14**(-1)*S24**(-1) * ( 32*s12**3 + 48*
     +    s12**2*s13 + 16*s12**2*s34 + 32*s12*s13**2 + 8*s12*s13*s34 + 
     +    8*s13**3 )

      LB = LB + Ld0(p1,p2,p3)*S14**(-1) * ( 80*s12**2 + 64*s12*s13 + 32
     +    *s12*s24 + 24*s12*s34 + 32*s13**2 + 8*s13*s23 + 32*s13*s24 + 
     +    32*s13*s34 + 8*s23*s34 + 8*s24**2 + 24*s24*s34 + 16*s34**2 )

      LB = LB + Ld0(p1,p2,p3)*S23**(-1)*S24**(-1) * ( 16*s12**2*s13 + 
     +    16*s12**2*s14 + 48*s12**2*s34 + 16*s12*s13**2 + 16*s12*s13*
     +    s14 + 48*s12*s13*s34 + 32*s12*s14*s34 + 24*s12*s34**2 + 8*
     +    s13**3 + 8*s13**2*s14 + 16*s13**2*s34 + 16*s13*s14*s34 + 8*
     +    s13*s34**2 + 8*s14**2*s34 + 8*s14*s34**2 )

      LB = LB + Ld0(p1,p2,p3)*S23**(-1) * ( 112*s12**2 + 80*s12*s13 + 
     +    48*s12*s14 + 48*s12*s24 + 72*s12*s34 + 24*s13**2 + 8*s13*s14
     +     + 16*s13*s24 + 16*s13*s34 - 8*s14*s24 - 8*s14*s34 + 8*s24**2
     +     )

      LB = LB + Ld0(p1,p2,p3)*S24**(-1) * ( 88*s12**2 + 56*s12*s13 + 40
     +    *s12*s14 + 8*s12*s23 + 16*s12*s34 - 16*s13*s14 - 8*s13*s23 - 
     +    8*s14**2 + 24*s14*s34 + 8*s23*s34 + 16*s34**2 )

      LB = LB + Ld0(p1,p2,p3)*SF*S13**(-1)*S23**(-1) * ( 32*s12**2 + 32
     +    *s12*s14 + 16*s14**2 )

      LB = LB + Ld0(p1,p2,p3)*SF*S13**(-1)*S24**(-1) * ( 32*s12**2 + 32
     +    *s12*s14 + 16*s14**2 )

      LB = LB + Ld0(p1,p2,p3)*SF*S14**(-1)*S23**(-1) * ( 32*s12**2 + 32
     +    *s12*s13 + 16*s13**2 )

      LB = LB + Ld0(p1,p2,p3)*SF*S14**(-1)*S24**(-1) * ( 32*s12**2 + 32
     +    *s12*s13 + 16*s13**2 )

      LB = LB + Ld0(p1,p2,p3)*SF*S23**(-1) * ( 64*s12 + 48*s13 + 48*s14
     +     )

      LB = LB + Ld0(p1,p2,p3)*SF*S24**(-1) * ( 64*s12 + 48*s13 + 48*s14
     +     )

      LB = LB + Ld0(p1,p2,p3) * ( 56*s12 - 32*s14 - 8*s23 - 16*s34 )

      LB = LB + Ld0(p1,p2,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LB = LB + Ld0(p1,p2,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s34 )

      LB = LB + Ld0(p1,p2,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 40*s12**2*s23*s34 + 40*s12**2*s34**2 + 8*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LB = LB + Ld0(p1,p2,p4)*S13**(-1)*S14**(-1) * (  - 16*s12**2*s23
     +     - 16*s12**2*s24 + 24*s12**2*s34 - 16*s12*s23**2 - 16*s12*s23
     +    *s24 - 8*s12*s23*s34 - 8*s23**3 - 8*s23**2*s24 - 8*s23**2*s34
     +     )

      LB = LB + Ld0(p1,p2,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s14*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s14**2*s34 + 8*s12*s14*s34**2 )

      LB = LB + Ld0(p1,p2,p4)*S13**(-1)*S23**(-1) * ( 32*s12**3 + 48*
     +    s12**2*s14 + 16*s12**2*s34 + 32*s12*s14**2 + 8*s12*s14*s34 + 
     +    8*s14**3 )

      LB = LB + Ld0(p1,p2,p4)*S13**(-1)*S24**(-1) * ( 32*s12**3 + 64*
     +    s12**2*s14 + 80*s12**2*s23 + 96*s12**2*s34 + 48*s12*s14**2 + 
     +    64*s12*s14*s23 + 72*s12*s14*s34 + 32*s12*s23**2 + 56*s12*s23*
     +    s34 + 24*s12*s34**2 + 16*s14**3 + 32*s14**2*s23 + 32*s14**2*
     +    s34 + 24*s14*s23**2 + 48*s14*s23*s34 + 24*s14*s34**2 + 8*
     +    s23**3 + 24*s23**2*s34 + 24*s23*s34**2 + 8*s34**3 )

      LB = LB + Ld0(p1,p2,p4)*S13**(-1) * ( 80*s12**2 + 64*s12*s14 + 32
     +    *s12*s23 + 24*s12*s34 + 32*s14**2 + 32*s14*s23 + 8*s14*s24 + 
     +    32*s14*s34 + 8*s23**2 + 24*s23*s34 + 8*s24*s34 + 16*s34**2 )

      LB = LB + Ld0(p1,p2,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s13*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s13**2*s34 + 8*s12*s13*s34**2 )

      LB = LB + Ld0(p1,p2,p4)*S14**(-1)*S23**(-1) * ( 40*s12**3 + 64*
     +    s12**2*s13 + 8*s12**2*s24 + 32*s12**2*s34 + 16*s12*s13**2 + 
     +    16*s12*s13*s24 + 24*s12*s13*s34 + 16*s12*s24*s34 + 8*s12*
     +    s34**2 + 16*s13**2*s24 + 16*s13**2*s34 + 8*s13*s24**2 + 32*
     +    s13*s24*s34 + 16*s13*s34**2 + 8*s24*s34**2 )

      LB = LB + Ld0(p1,p2,p4)*S14**(-1)*S24**(-1) * ( 32*s12**3 + 56*
     +    s12**2*s13 + 56*s12**2*s23 + 96*s12**2*s34 + 16*s12*s13**2 + 
     +    24*s12*s13*s34 + 16*s12*s23**2 + 24*s12*s23*s34 + 16*s12*
     +    s34**2 )

      LB = LB + Ld0(p1,p2,p4)*S14**(-1) * ( 64*s12**2 + 8*s12*s13 + 24*
     +    s12*s23 + 8*s12*s24 + 32*s12*s34 - 8*s13**2 - 16*s13*s23 - 8*
     +    s13*s24 - 8*s13*s34 + 8*s23**2 + 8*s23*s24 - 8*s24*s34 )

      LB = LB + Ld0(p1,p2,p4)*S23**(-1)*S24**(-1) * ( 16*s12**2*s13 + 
     +    16*s12**2*s14 + 48*s12**2*s34 + 16*s12*s13*s14 + 32*s12*s13*
     +    s34 + 16*s12*s14**2 + 48*s12*s14*s34 + 24*s12*s34**2 + 8*
     +    s13**2*s34 + 8*s13*s14**2 + 16*s13*s14*s34 + 8*s13*s34**2 + 8
     +    *s14**3 + 16*s14**2*s34 + 8*s14*s34**2 )

      LB = LB + Ld0(p1,p2,p4)*S23**(-1) * ( 88*s12**2 + 40*s12*s13 + 56
     +    *s12*s14 + 8*s12*s24 + 16*s12*s34 - 8*s13**2 - 16*s13*s14 + 
     +    24*s13*s34 - 8*s14*s24 + 8*s24*s34 + 16*s34**2 )

      LB = LB + Ld0(p1,p2,p4)*S24**(-1) * ( 112*s12**2 + 48*s12*s13 + 
     +    80*s12*s14 + 48*s12*s23 + 72*s12*s34 + 8*s13*s14 - 8*s13*s23
     +     - 8*s13*s34 + 24*s14**2 + 16*s14*s23 + 16*s14*s34 + 8*s23**2
     +     )

      LB = LB + Ld0(p1,p2,p4)*SF*S13**(-1)*S23**(-1) * (  - 32*s12**2
     +     - 32*s12*s14 - 16*s14**2 )

      LB = LB + Ld0(p1,p2,p4)*SF*S13**(-1)*S24**(-1) * (  - 32*s12**2
     +     - 32*s12*s14 - 16*s14**2 )

      LB = LB + Ld0(p1,p2,p4)*SF*S14**(-1)*S23**(-1) * (  - 32*s12**2
     +     - 32*s12*s13 - 16*s13**2 )

      LB = LB + Ld0(p1,p2,p4)*SF*S14**(-1)*S24**(-1) * (  - 32*s12**2
     +     - 32*s12*s13 - 16*s13**2 )

      LB = LB + Ld0(p1,p2,p4)*SF*S23**(-1) * (  - 64*s12 - 48*s13 - 48*
     +    s14 )

      LB = LB + Ld0(p1,p2,p4)*SF*S24**(-1) * (  - 64*s12 - 48*s13 - 48*
     +    s14 )

      LB = LB + Ld0(p1,p2,p4) * ( 56*s12 - 32*s13 - 8*s24 - 16*s34 )

      LB = LB + Ld0(p1,p2,p34)*S13**(-1)*S14**(-1)*S23**(-1)*S134 * ( 
     +     - 8*s12**3 - 8*s12**2*s24 + 8*s12**2*s34 - 16*s12*s24*s34 + 
     +    8*s12*s34**2 + 8*s24*s34**2 )

      LB = LB + Ld0(p1,p2,p34)*S13**(-1)*S14**(-1)*S23**(-1) * ( 8*
     +    s12**3*s34 + 8*s12**2*s24*s34 - 8*s12**2*s34**2 + 16*s12*s24*
     +    s34**2 - 8*s12*s34**3 - 8*s24*s34**3 )

      LB = LB + Ld0(p1,p2,p34)*S13**(-1)*S14**(-1)*S24**(-1)*S134 * ( 
     +     - 8*s12**2*s23 + 32*s12**2*s34 - 24*s12*s34**2 + 8*s34**3 )

      LB = LB + Ld0(p1,p2,p34)*S13**(-1)*S14**(-1)*S24**(-1) * ( 8*
     +    s12**2*s23*s34 - 32*s12**2*s34**2 + 24*s12*s34**3 - 8*s34**4
     +     )

      LB = LB + Ld0(p1,p2,p34)*S13**(-1)*S14**(-1)*S134 * (  - 16*
     +    s12**2 + 24*s12*s34 - 16*s23*s34 - 24*s34**2 )

      LB = LB + Ld0(p1,p2,p34)*S13**(-1)*S14**(-1) * ( 16*s12**2*s34 - 
     +    24*s12*s34**2 + 16*s23*s34**2 + 24*s34**3 )

      LB = LB + Ld0(p1,p2,p34)*S13**(-1)*S23**(-1)*S134 * ( 8*s12**2 - 
     +    8*s12*s14 - 8*s12*s24 + 48*s12*s34 - 8*s14**2 + 8*s14*s24 + 8
     +    *s14*s34 + 16*s24*s34 )

      LB = LB + Ld0(p1,p2,p34)*S13**(-1)*S23**(-1) * ( 8*s12**3 - 32*
     +    s12**2*s14 - 8*s12**2*s34 + 16*s12*s14*s24 - 8*s12*s14*s34 + 
     +    32*s12*s24*s34 - 40*s12*s34**2 - 8*s14**2*s24 - 24*s14*s24*
     +    s34 - 8*s14*s34**2 - 24*s24*s34**2 )

      LB = LB + Ld0(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * ( 16*s12**2
     +     + 24*s12*s14 + 8*s12*s23 + 16*s12*s34 + 8*s14**2 + 16*s14*
     +    s23 + 16*s14*s34 + 8*s23*s34 + 24*s34**2 )

      LB = LB + Ld0(p1,p2,p34)*S13**(-1)*S24**(-1) * (  - 8*s12**3 - 32
     +    *s12**2*s14 - 56*s12**2*s34 + 16*s12*s14*s23 - 8*s12*s14*s34
     +     + 24*s12*s34**2 + 8*s14**2*s23 - 8*s14*s34**2 - 16*s34**3 )

      LB = LB + Ld0(p1,p2,p34)*S13**(-1)*S134 * ( 24*s12 - 8*s14 - 16*
     +    s23 - 24*s34 )

      LB = LB + Ld0(p1,p2,p34)*S13**(-1) * (  - 16*s12*s14 - 16*s12*s34
     +     + 40*s14*s34 + 32*s23*s34 + 56*s34**2 )

      LB = LB + Ld0(p1,p2,p34)*S14**(-1)*S23**(-1)*S134 * (  - 16*
     +    s12**2 + 24*s12*s13 - 8*s12*s24 - 24*s12*s34 + 8*s13**2 - 8*
     +    s13*s24 - 16*s13*s34 - 16*s24*s34 )

      LB = LB + Ld0(p1,p2,p34)*S14**(-1)*S24**(-1)*S134 * (  - 24*
     +    s12**2 - 8*s12*s13 + 8*s12*s23 + 40*s12*s34 - 8*s13**2 + 8*
     +    s13*s34 - 8*s34**2 )

      LB = LB + Ld0(p1,p2,p34)*S14**(-1)*S134 * (  - 24*s12 - 40*s13 + 
     +    32*s23 + 16*s24 + 32*s34 )

      LB = LB + Ld0(p1,p2,p34)*S23**(-1)*S24**(-1)*S134 * (  - 16*s12*
     +    s34 - 16*s13*s34 - 16*s14*s34 )

      LB = LB + Ld0(p1,p2,p34)*S23**(-1)*S234**(-1)*S134 * ( 32*s12*s34
     +     - 16*s13*s24 + 16*s13*s34 + 32*s14*s34 + 16*s24**2 + 48*s24*
     +    s34 + 32*s34**2 )

      LB = LB + Ld0(p1,p2,p34)*S23**(-1)*S134 * (  - 40*s12 - 16*s13 - 
     +    32*s14 - 40*s24 - 48*s34 )

      LB = LB + Ld0(p1,p2,p34)*S24**(-1)*S234**(-1)*S134 * ( 32*s12*s34
     +     + 32*s13*s34 - 16*s14*s23 + 16*s14*s34 + 16*s23*s34 + 16*
     +    s34**2 )

      LB = LB + Ld0(p1,p2,p34)*S24**(-1)*S134 * (  - 40*s12 - 32*s13 - 
     +    16*s14 - 16*s23 - 32*s34 )

      LB = LB + Ld0(p1,p2,p34)*S234**(-1)*S134 * ( 64*s12 + 48*s13 + 48
     +    *s14 + 48*s23 + 64*s24 + 96*s34 )

      LB = LB + Ld0(p1,p2,p34)*S134 * (  - 24 )

      LB = LB + Ld0(p1,p3,p4)*S13**(-1)*S14**(-1) * (  - 8*s12*s23*s34
     +     - 8*s12*s24*s34 - 8*s12*s34**2 - 8*s23**2*s34 - 16*s23*s24*
     +    s34 - 8*s23*s34**2 - 8*s24**2*s34 - 8*s24*s34**2 )

      LB = LB + Ld0(p1,p3,p4)*S13**(-1)*S23**(-1) * (  - 8*s12**2*s14
     +     - 8*s12**2*s24 - 8*s12**2*s34 + 8*s12*s14*s24 + 8*s12*s14*
     +    s34 + 8*s12*s24**2 + 16*s12*s24*s34 + 8*s12*s34**2 )

      LB = LB + Ld0(p1,p3,p4)*S13**(-1)*S134**(-1) * (  - 16*s12*s14*
     +    s23 - 16*s12*s14*s24 - 16*s12*s14*s34 - 16*s14*s23**2 - 32*
     +    s14*s23*s24 - 16*s14*s23*s34 - 16*s14*s24**2 - 16*s14*s24*s34
     +     )

      LB = LB + Ld0(p1,p3,p4)*S13**(-1) * ( 8*s12*s14 + 16*s12*s23 + 24
     +    *s12*s24 + 24*s12*s34 - 8*s14*s23 - 8*s14*s24 - 8*s14*s34 + 8
     +    *s23**2 + 16*s23*s24 + 8*s23*s34 + 8*s24**2 + 8*s24*s34 )

      LB = LB + Ld0(p1,p3,p4)*S14**(-1)*S23**(-1) * (  - 8*s12**3 - 8*
     +    s12**2*s13 - 16*s12**2*s24 + 16*s12*s13*s24 + 8*s12*s13*s34
     +     + 24*s12*s24**2 + 32*s12*s24*s34 + 8*s12*s34**2 + 24*s13*
     +    s24**2 + 32*s13*s24*s34 + 8*s13*s34**2 + 8*s24**3 + 24*s24**2
     +    *s34 + 32*s24*s34**2 + 16*s34**3 )

      LB = LB + Ld0(p1,p3,p4)*S14**(-1)*S24**(-1) * (  - 8*s12**2*s23
     +     + 16*s12**2*s34 - 16*s12*s23**2 + 16*s12*s23*s34 + 8*s12*
     +    s34**2 - 8*s23**3 )

      LB = LB + Ld0(p1,p3,p4)*S14**(-1)*S134**(-1) * (  - 32*s12*s13*
     +    s23 - 32*s12*s13*s24 - 32*s12*s13*s34 - 32*s13*s23**2 - 64*
     +    s13*s23*s24 - 32*s13*s23*s34 - 32*s13*s24**2 - 32*s13*s24*s34
     +     )

      LB = LB + Ld0(p1,p3,p4)*S14**(-1) * (  - 16*s12*s23 + 24*s12*s24
     +     + 40*s12*s34 - 16*s13*s23 - 16*s13*s24 - 16*s13*s34 - 8*
     +    s23**2 + 8*s23*s24 + 8*s23*s34 + 16*s24**2 + 24*s24*s34 + 16*
     +    s34**2 )

      LB = LB + Ld0(p1,p3,p4)*S23**(-1) * (  - 16*s12**2 + 24*s12*s24
     +     + 16*s12*s34 + 8*s24**2 + 16*s24*s34 + 8*s34**2 )

      LB = LB + Ld0(p1,p3,p4)*S24**(-1) * (  - 16*s12*s23 + 8*s12*s34
     +     - 8*s14*s23 - 16*s23**2 - 8*s23*s34 )

      LB = LB + Ld0(p1,p3,p4)*S134**(-1) * (  - 32*s12*s23 - 32*s12*s24
     +     - 32*s12*s34 - 32*s23**2 - 64*s23*s24 - 32*s23*s34 - 32*
     +    s24**2 - 32*s24*s34 )

      LB = LB + Ld0(p1,p3,p4) * ( 8*s12 + 8*s13 - 32*s23 - 16*s24 - 16*
     +    s34 )

      LB = LB + Ld0(p1,p4,p3)*S13**(-1)*S14**(-1) * (  - 8*s12*s23*s34
     +     - 8*s12*s24*s34 - 8*s12*s34**2 - 8*s23**2*s34 - 16*s23*s24*
     +    s34 - 8*s23*s34**2 - 8*s24**2*s34 - 8*s24*s34**2 )

      LB = LB + Ld0(p1,p4,p3)*S13**(-1)*S23**(-1) * (  - 8*s12**2*s24
     +     + 16*s12**2*s34 - 16*s12*s24**2 + 16*s12*s24*s34 + 8*s12*
     +    s34**2 - 8*s24**3 )

      LB = LB + Ld0(p1,p4,p3)*S13**(-1)*S24**(-1) * (  - 8*s12**3 - 8*
     +    s12**2*s14 - 16*s12**2*s23 + 16*s12*s14*s23 + 8*s12*s14*s34
     +     + 24*s12*s23**2 + 32*s12*s23*s34 + 8*s12*s34**2 + 24*s14*
     +    s23**2 + 32*s14*s23*s34 + 8*s14*s34**2 + 8*s23**3 + 24*s23**2
     +    *s34 + 32*s23*s34**2 + 16*s34**3 )

      LB = LB + Ld0(p1,p4,p3)*S13**(-1)*S134**(-1) * (  - 32*s12*s14*
     +    s23 - 32*s12*s14*s24 - 32*s12*s14*s34 - 32*s14*s23**2 - 64*
     +    s14*s23*s24 - 32*s14*s23*s34 - 32*s14*s24**2 - 32*s14*s24*s34
     +     )

      LB = LB + Ld0(p1,p4,p3)*S13**(-1) * ( 24*s12*s23 - 16*s12*s24 + 
     +    40*s12*s34 - 16*s14*s23 - 16*s14*s24 - 16*s14*s34 + 16*s23**2
     +     + 8*s23*s24 + 24*s23*s34 - 8*s24**2 + 8*s24*s34 + 16*s34**2
     +     )

      LB = LB + Ld0(p1,p4,p3)*S14**(-1)*S24**(-1) * (  - 8*s12**2*s13
     +     - 8*s12**2*s23 - 8*s12**2*s34 + 8*s12*s13*s23 + 8*s12*s13*
     +    s34 + 8*s12*s23**2 + 16*s12*s23*s34 + 8*s12*s34**2 )

      LB = LB + Ld0(p1,p4,p3)*S14**(-1)*S134**(-1) * (  - 16*s12*s13*
     +    s23 - 16*s12*s13*s24 - 16*s12*s13*s34 - 16*s13*s23**2 - 32*
     +    s13*s23*s24 - 16*s13*s23*s34 - 16*s13*s24**2 - 16*s13*s24*s34
     +     )

      LB = LB + Ld0(p1,p4,p3)*S14**(-1) * ( 8*s12*s13 + 24*s12*s23 + 16
     +    *s12*s24 + 24*s12*s34 - 8*s13*s23 - 8*s13*s24 - 8*s13*s34 + 8
     +    *s23**2 + 16*s23*s24 + 8*s23*s34 + 8*s24**2 + 8*s24*s34 )

      LB = LB + Ld0(p1,p4,p3)*S23**(-1) * (  - 16*s12*s24 + 8*s12*s34
     +     - 8*s13*s24 - 16*s24**2 - 8*s24*s34 )

      LB = LB + Ld0(p1,p4,p3)*S24**(-1) * (  - 16*s12**2 + 24*s12*s23
     +     + 16*s12*s34 + 8*s23**2 + 16*s23*s34 + 8*s34**2 )

      LB = LB + Ld0(p1,p4,p3)*S134**(-1) * (  - 32*s12*s23 - 32*s12*s24
     +     - 32*s12*s34 - 32*s23**2 - 64*s23*s24 - 32*s23*s34 - 32*
     +    s24**2 - 32*s24*s34 )

      LB = LB + Ld0(p1,p4,p3) * ( 8*s12 + 8*s14 - 16*s23 - 32*s24 - 16*
     +    s34 )

      LB = LB + Ld0(p1,p23,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LB = LB + Ld0(p1,p23,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 32*
     +    s12**3*s34 + 8*s12**2*s34**2 )

      LB = LB + Ld0(p1,p23,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 32*
     +    s12**3*s23 - 16*s12**3*s34 + 24*s12**2*s23**2 - 72*s12**2*s23
     +    *s34 - 8*s12**2*s34**2 + 96*s12*s23**2*s34 - 64*s12*s23*
     +    s34**2 )

      LB = LB + Ld0(p1,p23,p4)*S13**(-1)*S14**(-1) * (  - 16*s12**3 - 
     +    16*s12**2*s23 + 16*s12**2*s24 + 8*s12**2*s34 + 40*s12*s23**2
     +     + 40*s12*s23*s24 + 16*s12*s23*s34 )

      LB = LB + Ld0(p1,p23,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s14*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s14**2*s34 + 8*s12*s14*s34**2 )

      LB = LB + Ld0(p1,p23,p4)*S13**(-1)*S23**(-1) * ( 16*s12**3 + 16*
     +    s12**2*s14 + 16*s12**2*s34 + 8*s12*s14**2 + 8*s12*s14*s34 )

      LB = LB + Ld0(p1,p23,p4)*S13**(-1)*S24**(-1) * ( 16*s12**3 - 64*
     +    s12**2*s23 + 32*s12**2*s34 - 8*s12*s14**2 - 16*s12*s14*s23 - 
     +    8*s12*s14*s34 - 32*s12*s23**2 + 56*s12*s23*s34 + 24*s12*
     +    s34**2 - 8*s14**3 - 8*s14**2*s23 - 8*s14**2*s34 )

      LB = LB + Ld0(p1,p23,p4)*S13**(-1) * (  - 16*s12**2 - 16*s12*s14
     +     + 48*s12*s23 - 8*s12*s24 - 8*s12*s34 - 8*s14**2 )

      LB = LB + Ld0(p1,p23,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s13*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s13**2*s34 + 8*s12*s13*s34**2 )

      LB = LB + Ld0(p1,p23,p4)*S14**(-1)*S23**(-1) * ( 16*s12**3 + 32*
     +    s12**2*s13 + 48*s12**2*s34 + 24*s12*s13**2 + 24*s12*s13*s34
     +     - 16*s12*s24*s34 + 8*s13**3 + 8*s13**2*s24 + 8*s13**2*s34 + 
     +    8*s13*s24**2 )

      LB = LB + Ld0(p1,p23,p4)*S14**(-1)*S24**(-1) * ( 16*s12**3 + 16*
     +    s12**2*s13 + 48*s12**2*s34 + 8*s12*s13**2 - 16*s12*s13*s23 + 
     +    40*s12*s13*s34 + 8*s12*s23**2 + 32*s12*s23*s34 + 16*s12*
     +    s34**2 - 16*s13*s23**2 + 32*s13*s23*s34 + 8*s13*s34**2 + 32*
     +    s23**2*s34 - 8*s23*s34**2 )

      LB = LB + Ld0(p1,p23,p4)*S14**(-1) * (  - 16*s12*s13 - 8*s12*s23
     +     - 24*s12*s24 - 16*s12*s34 + 8*s13**2 - 32*s13*s23 - 8*s13*
     +    s24 - 8*s13*s34 - 24*s23**2 - 24*s23*s24 + 8*s23*s34 )

      LB = LB + Ld0(p1,p23,p4)*S23**(-1)*S24**(-1) * ( 32*s12**2*s34 + 
     +    24*s12*s13*s34 + 24*s12*s14*s34 + 16*s12*s34**2 )

      LB = LB + Ld0(p1,p23,p4)*S23**(-1) * ( 48*s12**2 + 56*s12*s13 + 
     +    40*s12*s14 + 16*s12*s24 + 32*s12*s34 + 24*s13**2 + 24*s13*s14
     +     + 16*s13*s24 + 16*s13*s34 + 8*s14**2 + 8*s14*s24 + 8*s14*s34
     +     )

      LB = LB + Ld0(p1,p23,p4)*S24**(-1) * ( 16*s12**2 + 8*s12*s13 - 8*
     +    s12*s14 - 48*s12*s23 + 16*s12*s34 - 8*s13**2 - 24*s13*s14 - 8
     +    *s13*s23 - 8*s13*s34 - 24*s14**2 - 16*s14*s23 - 16*s14*s34 - 
     +    32*s23**2 + 8*s34**2 )

      LB = LB + Ld0(p1,p23,p4)*SF*S13**(-1)*S23**(-1) * ( 32*s12**2 + 
     +    32*s12*s14 + 16*s14**2 )

      LB = LB + Ld0(p1,p23,p4)*SF*S13**(-1)*S24**(-1) * ( 32*s12**2 + 
     +    32*s12*s14 + 16*s14**2 )

      LB = LB + Ld0(p1,p23,p4)*SF*S14**(-1)*S23**(-1) * ( 32*s12**2 + 
     +    32*s12*s13 + 16*s13**2 )

      LB = LB + Ld0(p1,p23,p4)*SF*S14**(-1)*S24**(-1) * ( 32*s12**2 + 
     +    32*s12*s13 + 16*s13**2 )

      LB = LB + Ld0(p1,p23,p4)*SF*S23**(-1) * ( 64*s12 + 48*s13 + 48*
     +    s14 )

      LB = LB + Ld0(p1,p23,p4)*SF*S24**(-1) * ( 64*s12 + 48*s13 + 48*
     +    s14 )

      LB = LB + Ld0(p1,p23,p4) * (  - 16*s12 + 8*s13 - 8*s14 - 8*s23 + 
     +    8*s24 - 8*s34 )

      LB = LB + Ld0(p1,p24,p3)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LB = LB + Ld0(p1,p24,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 32*
     +    s12**3*s24 - 16*s12**3*s34 + 24*s12**2*s24**2 - 72*s12**2*s24
     +    *s34 - 8*s12**2*s34**2 + 96*s12*s24**2*s34 - 64*s12*s24*
     +    s34**2 )

      LB = LB + Ld0(p1,p24,p3)*S13**(-1)*S14**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 + 8*s12**2*s34**2 )

      LB = LB + Ld0(p1,p24,p3)*S13**(-1)*S14**(-1) * (  - 16*s12**3 + 
     +    16*s12**2*s23 - 16*s12**2*s24 + 8*s12**2*s34 + 40*s12*s23*s24
     +     + 40*s12*s24**2 + 16*s12*s24*s34 )

      LB = LB + Ld0(p1,p24,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s14*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s14**2*s34 + 8*s12*s14*s34**2 )

      LB = LB + Ld0(p1,p24,p3)*S13**(-1)*S23**(-1) * ( 16*s12**3 + 16*
     +    s12**2*s14 + 48*s12**2*s34 + 8*s12*s14**2 - 16*s12*s14*s24 + 
     +    40*s12*s14*s34 + 8*s12*s24**2 + 32*s12*s24*s34 + 16*s12*
     +    s34**2 - 16*s14*s24**2 + 32*s14*s24*s34 + 8*s14*s34**2 + 32*
     +    s24**2*s34 - 8*s24*s34**2 )

      LB = LB + Ld0(p1,p24,p3)*S13**(-1)*S24**(-1) * ( 16*s12**3 + 32*
     +    s12**2*s14 + 48*s12**2*s34 + 24*s12*s14**2 + 24*s12*s14*s34
     +     - 16*s12*s23*s34 + 8*s14**3 + 8*s14**2*s23 + 8*s14**2*s34 + 
     +    8*s14*s23**2 )

      LB = LB + Ld0(p1,p24,p3)*S13**(-1) * (  - 16*s12*s14 - 24*s12*s23
     +     - 8*s12*s24 - 16*s12*s34 + 8*s14**2 - 8*s14*s23 - 32*s14*s24
     +     - 8*s14*s34 - 24*s23*s24 - 24*s24**2 + 8*s24*s34 )

      LB = LB + Ld0(p1,p24,p3)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s13*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s13**2*s34 + 8*s12*s13*s34**2 )

      LB = LB + Ld0(p1,p24,p3)*S14**(-1)*S23**(-1) * ( 16*s12**3 - 64*
     +    s12**2*s24 + 32*s12**2*s34 - 8*s12*s13**2 - 16*s12*s13*s24 - 
     +    8*s12*s13*s34 - 32*s12*s24**2 + 56*s12*s24*s34 + 24*s12*
     +    s34**2 - 8*s13**3 - 8*s13**2*s24 - 8*s13**2*s34 )

      LB = LB + Ld0(p1,p24,p3)*S14**(-1)*S24**(-1) * ( 16*s12**3 + 16*
     +    s12**2*s13 + 16*s12**2*s34 + 8*s12*s13**2 + 8*s12*s13*s34 )

      LB = LB + Ld0(p1,p24,p3)*S14**(-1) * (  - 16*s12**2 - 16*s12*s13
     +     - 8*s12*s23 + 48*s12*s24 - 8*s12*s34 - 8*s13**2 )

      LB = LB + Ld0(p1,p24,p3)*S23**(-1)*S24**(-1) * ( 32*s12**2*s34 + 
     +    24*s12*s13*s34 + 24*s12*s14*s34 + 16*s12*s34**2 )

      LB = LB + Ld0(p1,p24,p3)*S23**(-1) * ( 16*s12**2 - 8*s12*s13 + 8*
     +    s12*s14 - 48*s12*s24 + 16*s12*s34 - 24*s13**2 - 24*s13*s14 - 
     +    16*s13*s24 - 16*s13*s34 - 8*s14**2 - 8*s14*s24 - 8*s14*s34 - 
     +    32*s24**2 + 8*s34**2 )

      LB = LB + Ld0(p1,p24,p3)*S24**(-1) * ( 48*s12**2 + 40*s12*s13 + 
     +    56*s12*s14 + 16*s12*s23 + 32*s12*s34 + 8*s13**2 + 24*s13*s14
     +     + 8*s13*s23 + 8*s13*s34 + 24*s14**2 + 16*s14*s23 + 16*s14*
     +    s34 )

      LB = LB + Ld0(p1,p24,p3)*SF*S13**(-1)*S23**(-1) * (  - 32*s12**2
     +     - 32*s12*s14 - 16*s14**2 )

      LB = LB + Ld0(p1,p24,p3)*SF*S13**(-1)*S24**(-1) * (  - 32*s12**2
     +     - 32*s12*s14 - 16*s14**2 )

      LB = LB + Ld0(p1,p24,p3)*SF*S14**(-1)*S23**(-1) * (  - 32*s12**2
     +     - 32*s12*s13 - 16*s13**2 )

      LB = LB + Ld0(p1,p24,p3)*SF*S14**(-1)*S24**(-1) * (  - 32*s12**2
     +     - 32*s12*s13 - 16*s13**2 )

      LB = LB + Ld0(p1,p24,p3)*SF*S23**(-1) * (  - 64*s12 - 48*s13 - 48
     +    *s14 )

      LB = LB + Ld0(p1,p24,p3)*SF*S24**(-1) * (  - 64*s12 - 48*s13 - 48
     +    *s14 )

      LB = LB + Ld0(p1,p24,p3) * (  - 16*s12 - 8*s13 + 8*s14 + 8*s23 - 
     +    8*s24 - 8*s34 )

      LB = LB + Ld0(p2,p1,p3)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LB = LB + Ld0(p2,p1,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s24*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LB = LB + Ld0(p2,p1,p3)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s23*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LB = LB + Ld0(p2,p1,p3)*S13**(-1)*S14**(-1) * ( 16*s12**2*s23 + 
     +    16*s12**2*s24 + 48*s12**2*s34 + 16*s12*s23**2 + 16*s12*s23*
     +    s24 + 48*s12*s23*s34 + 32*s12*s24*s34 + 24*s12*s34**2 + 8*
     +    s23**3 + 8*s23**2*s24 + 16*s23**2*s34 + 16*s23*s24*s34 + 8*
     +    s23*s34**2 + 8*s24**2*s34 + 8*s24*s34**2 )

      LB = LB + Ld0(p2,p1,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 40*s12**2*s14*s34 + 40*s12**2*s34**2 + 8*s12*
     +    s14**2*s34 + 8*s12*s14*s34**2 )

      LB = LB + Ld0(p2,p1,p3)*S13**(-1)*S23**(-1) * ( 32*s12**3 + 56*
     +    s12**2*s14 + 56*s12**2*s24 + 96*s12**2*s34 + 16*s12*s14**2 + 
     +    24*s12*s14*s34 + 16*s12*s24**2 + 24*s12*s24*s34 + 16*s12*
     +    s34**2 )

      LB = LB + Ld0(p2,p1,p3)*S13**(-1)*S24**(-1) * ( 32*s12**3 + 80*
     +    s12**2*s14 + 64*s12**2*s23 + 96*s12**2*s34 + 32*s12*s14**2 + 
     +    64*s12*s14*s23 + 56*s12*s14*s34 + 48*s12*s23**2 + 72*s12*s23*
     +    s34 + 24*s12*s34**2 + 8*s14**3 + 24*s14**2*s23 + 24*s14**2*
     +    s34 + 32*s14*s23**2 + 48*s14*s23*s34 + 24*s14*s34**2 + 16*
     +    s23**3 + 32*s23**2*s34 + 24*s23*s34**2 + 8*s34**3 )

      LB = LB + Ld0(p2,p1,p3)*S13**(-1) * ( 112*s12**2 + 48*s12*s14 + 
     +    80*s12*s23 + 48*s12*s24 + 72*s12*s34 + 8*s14**2 + 16*s14*s23
     +     - 8*s14*s24 + 24*s23**2 + 8*s23*s24 + 16*s23*s34 - 8*s24*s34
     +     )

      LB = LB + Ld0(p2,p1,p3)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 )

      LB = LB + Ld0(p2,p1,p3)*S14**(-1)*S23**(-1) * ( 40*s12**3 + 8*
     +    s12**2*s13 + 64*s12**2*s24 + 32*s12**2*s34 + 16*s12*s13*s24
     +     + 16*s12*s13*s34 + 16*s12*s24**2 + 24*s12*s24*s34 + 8*s12*
     +    s34**2 + 8*s13**2*s24 + 16*s13*s24**2 + 32*s13*s24*s34 + 8*
     +    s13*s34**2 + 16*s24**2*s34 + 16*s24*s34**2 )

      LB = LB + Ld0(p2,p1,p3)*S14**(-1)*S24**(-1) * ( 32*s12**3 + 48*
     +    s12**2*s23 + 16*s12**2*s34 + 32*s12*s23**2 + 8*s12*s23*s34 + 
     +    8*s23**3 )

      LB = LB + Ld0(p2,p1,p3)*S14**(-1) * ( 88*s12**2 + 8*s12*s13 + 56*
     +    s12*s23 + 40*s12*s24 + 16*s12*s34 - 8*s13*s23 + 8*s13*s34 - 
     +    16*s23*s24 - 8*s24**2 + 24*s24*s34 + 16*s34**2 )

      LB = LB + Ld0(p2,p1,p3)*S23**(-1)*S24**(-1) * (  - 16*s12**2*s13
     +     - 16*s12**2*s14 + 24*s12**2*s34 - 16*s12*s13*s14 - 16*s12*
     +    s14**2 - 8*s12*s14*s34 - 8*s13*s14**2 - 8*s14**3 - 8*s14**2*
     +    s34 )

      LB = LB + Ld0(p2,p1,p3)*S23**(-1) * ( 64*s12**2 + 8*s12*s13 + 24*
     +    s12*s14 + 8*s12*s24 + 32*s12*s34 + 8*s13*s14 - 8*s13*s24 - 8*
     +    s13*s34 + 8*s14**2 - 16*s14*s24 - 8*s24**2 - 8*s24*s34 )

      LB = LB + Ld0(p2,p1,p3)*S24**(-1) * ( 80*s12**2 + 32*s12*s14 + 64
     +    *s12*s23 + 24*s12*s34 + 8*s13*s23 + 8*s13*s34 + 8*s14**2 + 32
     +    *s14*s23 + 24*s14*s34 + 32*s23**2 + 32*s23*s34 + 16*s34**2 )

      LB = LB + Ld0(p2,p1,p3)*SF*S13**(-1)*S23**(-1) * (  - 32*s12**2
     +     - 32*s12*s24 - 16*s24**2 )

      LB = LB + Ld0(p2,p1,p3)*SF*S13**(-1)*S24**(-1) * (  - 32*s12**2
     +     - 32*s12*s23 - 16*s23**2 )

      LB = LB + Ld0(p2,p1,p3)*SF*S13**(-1) * (  - 64*s12 - 48*s23 - 48*
     +    s24 )

      LB = LB + Ld0(p2,p1,p3)*SF*S14**(-1)*S23**(-1) * (  - 32*s12**2
     +     - 32*s12*s24 - 16*s24**2 )

      LB = LB + Ld0(p2,p1,p3)*SF*S14**(-1)*S24**(-1) * (  - 32*s12**2
     +     - 32*s12*s23 - 16*s23**2 )

      LB = LB + Ld0(p2,p1,p3)*SF*S14**(-1) * (  - 64*s12 - 48*s23 - 48*
     +    s24 )

      LB = LB + Ld0(p2,p1,p3) * ( 56*s12 - 8*s13 - 32*s24 - 16*s34 )

      LB = LB + Ld0(p2,p1,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LB = LB + Ld0(p2,p1,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s24*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LB = LB + Ld0(p2,p1,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s23*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LB = LB + Ld0(p2,p1,p4)*S13**(-1)*S14**(-1) * ( 16*s12**2*s23 + 
     +    16*s12**2*s24 + 48*s12**2*s34 + 16*s12*s23*s24 + 32*s12*s23*
     +    s34 + 16*s12*s24**2 + 48*s12*s24*s34 + 24*s12*s34**2 + 8*
     +    s23**2*s34 + 8*s23*s24**2 + 16*s23*s24*s34 + 8*s23*s34**2 + 8
     +    *s24**3 + 16*s24**2*s34 + 8*s24*s34**2 )

      LB = LB + Ld0(p2,p1,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 )

      LB = LB + Ld0(p2,p1,p4)*S13**(-1)*S23**(-1) * ( 32*s12**3 + 48*
     +    s12**2*s24 + 16*s12**2*s34 + 32*s12*s24**2 + 8*s12*s24*s34 + 
     +    8*s24**3 )

      LB = LB + Ld0(p2,p1,p4)*S13**(-1)*S24**(-1) * ( 40*s12**3 + 8*
     +    s12**2*s14 + 64*s12**2*s23 + 32*s12**2*s34 + 16*s12*s14*s23
     +     + 16*s12*s14*s34 + 16*s12*s23**2 + 24*s12*s23*s34 + 8*s12*
     +    s34**2 + 8*s14**2*s23 + 16*s14*s23**2 + 32*s14*s23*s34 + 8*
     +    s14*s34**2 + 16*s23**2*s34 + 16*s23*s34**2 )

      LB = LB + Ld0(p2,p1,p4)*S13**(-1) * ( 88*s12**2 + 8*s12*s14 + 40*
     +    s12*s23 + 56*s12*s24 + 16*s12*s34 - 8*s14*s24 + 8*s14*s34 - 8
     +    *s23**2 - 16*s23*s24 + 24*s23*s34 + 16*s34**2 )

      LB = LB + Ld0(p2,p1,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 40*s12**2*s13*s34 + 40*s12**2*s34**2 + 8*s12*
     +    s13**2*s34 + 8*s12*s13*s34**2 )

      LB = LB + Ld0(p2,p1,p4)*S14**(-1)*S23**(-1) * ( 32*s12**3 + 80*
     +    s12**2*s13 + 64*s12**2*s24 + 96*s12**2*s34 + 32*s12*s13**2 + 
     +    64*s12*s13*s24 + 56*s12*s13*s34 + 48*s12*s24**2 + 72*s12*s24*
     +    s34 + 24*s12*s34**2 + 8*s13**3 + 24*s13**2*s24 + 24*s13**2*
     +    s34 + 32*s13*s24**2 + 48*s13*s24*s34 + 24*s13*s34**2 + 16*
     +    s24**3 + 32*s24**2*s34 + 24*s24*s34**2 + 8*s34**3 )

      LB = LB + Ld0(p2,p1,p4)*S14**(-1)*S24**(-1) * ( 32*s12**3 + 56*
     +    s12**2*s13 + 56*s12**2*s23 + 96*s12**2*s34 + 16*s12*s13**2 + 
     +    24*s12*s13*s34 + 16*s12*s23**2 + 24*s12*s23*s34 + 16*s12*
     +    s34**2 )

      LB = LB + Ld0(p2,p1,p4)*S14**(-1) * ( 112*s12**2 + 48*s12*s13 + 
     +    48*s12*s23 + 80*s12*s24 + 72*s12*s34 + 8*s13**2 - 8*s13*s23
     +     + 16*s13*s24 + 8*s23*s24 - 8*s23*s34 + 24*s24**2 + 16*s24*
     +    s34 )

      LB = LB + Ld0(p2,p1,p4)*S23**(-1)*S24**(-1) * (  - 16*s12**2*s13
     +     - 16*s12**2*s14 + 24*s12**2*s34 - 16*s12*s13**2 - 16*s12*s13
     +    *s14 - 8*s12*s13*s34 - 8*s13**3 - 8*s13**2*s14 - 8*s13**2*s34
     +     )

      LB = LB + Ld0(p2,p1,p4)*S23**(-1) * ( 80*s12**2 + 32*s12*s13 + 64
     +    *s12*s24 + 24*s12*s34 + 8*s13**2 + 32*s13*s24 + 24*s13*s34 + 
     +    8*s14*s24 + 8*s14*s34 + 32*s24**2 + 32*s24*s34 + 16*s34**2 )

      LB = LB + Ld0(p2,p1,p4)*S24**(-1) * ( 64*s12**2 + 24*s12*s13 + 8*
     +    s12*s14 + 8*s12*s23 + 32*s12*s34 + 8*s13**2 + 8*s13*s14 - 16*
     +    s13*s23 - 8*s14*s23 - 8*s14*s34 - 8*s23**2 - 8*s23*s34 )

      LB = LB + Ld0(p2,p1,p4)*SF*S13**(-1)*S23**(-1) * ( 32*s12**2 + 32
     +    *s12*s24 + 16*s24**2 )

      LB = LB + Ld0(p2,p1,p4)*SF*S13**(-1)*S24**(-1) * ( 32*s12**2 + 32
     +    *s12*s23 + 16*s23**2 )

      LB = LB + Ld0(p2,p1,p4)*SF*S13**(-1) * ( 64*s12 + 48*s23 + 48*s24
     +     )

      LB = LB + Ld0(p2,p1,p4)*SF*S14**(-1)*S23**(-1) * ( 32*s12**2 + 32
     +    *s12*s24 + 16*s24**2 )

      LB = LB + Ld0(p2,p1,p4)*SF*S14**(-1)*S24**(-1) * ( 32*s12**2 + 32
     +    *s12*s23 + 16*s23**2 )

      LB = LB + Ld0(p2,p1,p4)*SF*S14**(-1) * ( 64*s12 + 48*s23 + 48*s24
     +     )

      LB = LB + Ld0(p2,p1,p4) * ( 56*s12 - 8*s14 - 32*s23 - 16*s34 )

      LB = LB + Ld0(p2,p1,p34)*S13**(-1)*S14**(-1)*S234 * (  - 16*s12*
     +    s34 - 16*s23*s34 - 16*s24*s34 )

      LB = LB + Ld0(p2,p1,p34)*S13**(-1)*S23**(-1)*S24**(-1)*S234 * ( 
     +     - 8*s12**3 - 8*s12**2*s14 + 8*s12**2*s34 - 16*s12*s14*s34 + 
     +    8*s12*s34**2 + 8*s14*s34**2 )

      LB = LB + Ld0(p2,p1,p34)*S13**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**3*s34 + 8*s12**2*s14*s34 - 8*s12**2*s34**2 + 16*s12*s14*
     +    s34**2 - 8*s12*s34**3 - 8*s14*s34**3 )

      LB = LB + Ld0(p2,p1,p34)*S13**(-1)*S23**(-1)*S234 * ( 8*s12**2 - 
     +    8*s12*s14 - 8*s12*s24 + 48*s12*s34 + 8*s14*s24 + 16*s14*s34
     +     - 8*s24**2 + 8*s24*s34 )

      LB = LB + Ld0(p2,p1,p34)*S13**(-1)*S23**(-1) * ( 8*s12**3 - 32*
     +    s12**2*s24 - 8*s12**2*s34 + 16*s12*s14*s24 + 32*s12*s14*s34
     +     - 8*s12*s24*s34 - 40*s12*s34**2 - 8*s14*s24**2 - 24*s14*s24*
     +    s34 - 24*s14*s34**2 - 8*s24*s34**2 )

      LB = LB + Ld0(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * (  - 16*
     +    s12**2 - 8*s12*s14 + 24*s12*s23 - 24*s12*s34 - 8*s14*s23 - 16
     +    *s14*s34 + 8*s23**2 - 16*s23*s34 )

      LB = LB + Ld0(p2,p1,p34)*S13**(-1)*S234*S134**(-1) * ( 32*s12*s34
     +     + 16*s14**2 - 16*s14*s23 + 48*s14*s34 + 16*s23*s34 + 32*s24*
     +    s34 + 32*s34**2 )

      LB = LB + Ld0(p2,p1,p34)*S13**(-1)*S234 * (  - 40*s12 - 40*s14 - 
     +    16*s23 - 32*s24 - 48*s34 )

      LB = LB + Ld0(p2,p1,p34)*S14**(-1)*S23**(-1)*S24**(-1)*S234 * ( 
     +     - 8*s12**2*s13 + 32*s12**2*s34 - 24*s12*s34**2 + 8*s34**3 )

      LB = LB + Ld0(p2,p1,p34)*S14**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**2*s13*s34 - 32*s12**2*s34**2 + 24*s12*s34**3 - 8*s34**4
     +     )

      LB = LB + Ld0(p2,p1,p34)*S14**(-1)*S23**(-1)*S234 * ( 16*s12**2
     +     + 8*s12*s13 + 24*s12*s24 + 16*s12*s34 + 16*s13*s24 + 8*s13*
     +    s34 + 8*s24**2 + 16*s24*s34 + 24*s34**2 )

      LB = LB + Ld0(p2,p1,p34)*S14**(-1)*S23**(-1) * (  - 8*s12**3 - 32
     +    *s12**2*s24 - 56*s12**2*s34 + 16*s12*s13*s24 - 8*s12*s24*s34
     +     + 24*s12*s34**2 + 8*s13*s24**2 - 8*s24*s34**2 - 16*s34**3 )

      LB = LB + Ld0(p2,p1,p34)*S14**(-1)*S24**(-1)*S234 * (  - 24*
     +    s12**2 + 8*s12*s13 - 8*s12*s23 + 40*s12*s34 - 8*s23**2 + 8*
     +    s23*s34 - 8*s34**2 )

      LB = LB + Ld0(p2,p1,p34)*S14**(-1)*S234*S134**(-1) * ( 32*s12*s34
     +     - 16*s13*s24 + 16*s13*s34 + 32*s23*s34 + 16*s24*s34 + 16*
     +    s34**2 )

      LB = LB + Ld0(p2,p1,p34)*S14**(-1)*S234 * (  - 40*s12 - 16*s13 - 
     +    32*s23 - 16*s24 - 32*s34 )

      LB = LB + Ld0(p2,p1,p34)*S23**(-1)*S24**(-1)*S234 * (  - 16*
     +    s12**2 + 24*s12*s34 - 16*s13*s34 - 24*s34**2 )

      LB = LB + Ld0(p2,p1,p34)*S23**(-1)*S24**(-1) * ( 16*s12**2*s34 - 
     +    24*s12*s34**2 + 16*s13*s34**2 + 24*s34**3 )

      LB = LB + Ld0(p2,p1,p34)*S23**(-1)*S234 * ( 24*s12 - 16*s13 - 8*
     +    s24 - 24*s34 )

      LB = LB + Ld0(p2,p1,p34)*S23**(-1) * (  - 16*s12*s24 - 16*s12*s34
     +     + 32*s13*s34 + 40*s24*s34 + 56*s34**2 )

      LB = LB + Ld0(p2,p1,p34)*S24**(-1)*S234 * (  - 24*s12 + 32*s13 + 
     +    16*s14 - 40*s23 + 32*s34 )

      LB = LB + Ld0(p2,p1,p34)*S234*S134**(-1) * ( 64*s12 + 48*s13 + 64
     +    *s14 + 48*s23 + 48*s24 + 96*s34 )

      LB = LB + Ld0(p2,p1,p34)*S234 * (  - 24 )

      LB = LB + Ld0(p2,p3,p4)*S13**(-1)*S23**(-1) * (  - 8*s12**2*s14
     +     - 8*s12**2*s24 - 8*s12**2*s34 + 8*s12*s14**2 + 8*s12*s14*s24
     +     + 16*s12*s14*s34 + 8*s12*s24*s34 + 8*s12*s34**2 )

      LB = LB + Ld0(p2,p3,p4)*S13**(-1)*S24**(-1) * (  - 8*s12**3 - 16*
     +    s12**2*s14 - 8*s12**2*s23 + 24*s12*s14**2 + 16*s12*s14*s23 + 
     +    32*s12*s14*s34 + 8*s12*s23*s34 + 8*s12*s34**2 + 8*s14**3 + 24
     +    *s14**2*s23 + 24*s14**2*s34 + 32*s14*s23*s34 + 32*s14*s34**2
     +     + 8*s23*s34**2 + 16*s34**3 )

      LB = LB + Ld0(p2,p3,p4)*S13**(-1) * (  - 16*s12**2 + 24*s12*s14
     +     + 16*s12*s34 + 8*s14**2 + 16*s14*s34 + 8*s34**2 )

      LB = LB + Ld0(p2,p3,p4)*S14**(-1)*S24**(-1) * (  - 8*s12**2*s13
     +     + 16*s12**2*s34 - 16*s12*s13**2 + 16*s12*s13*s34 + 8*s12*
     +    s34**2 - 8*s13**3 )

      LB = LB + Ld0(p2,p3,p4)*S14**(-1) * (  - 16*s12*s13 + 8*s12*s34
     +     - 16*s13**2 - 8*s13*s24 - 8*s13*s34 )

      LB = LB + Ld0(p2,p3,p4)*S23**(-1)*S24**(-1) * (  - 8*s12*s13*s34
     +     - 8*s12*s14*s34 - 8*s12*s34**2 - 8*s13**2*s34 - 16*s13*s14*
     +    s34 - 8*s13*s34**2 - 8*s14**2*s34 - 8*s14*s34**2 )

      LB = LB + Ld0(p2,p3,p4)*S23**(-1)*S234**(-1) * (  - 16*s12*s13*
     +    s24 - 16*s12*s14*s24 - 16*s12*s24*s34 - 16*s13**2*s24 - 32*
     +    s13*s14*s24 - 16*s13*s24*s34 - 16*s14**2*s24 - 16*s14*s24*s34
     +     )

      LB = LB + Ld0(p2,p3,p4)*S23**(-1) * ( 16*s12*s13 + 24*s12*s14 + 8
     +    *s12*s24 + 24*s12*s34 + 8*s13**2 + 16*s13*s14 - 8*s13*s24 + 8
     +    *s13*s34 + 8*s14**2 - 8*s14*s24 + 8*s14*s34 - 8*s24*s34 )

      LB = LB + Ld0(p2,p3,p4)*S24**(-1)*S234**(-1) * (  - 32*s12*s13*
     +    s23 - 32*s12*s14*s23 - 32*s12*s23*s34 - 32*s13**2*s23 - 64*
     +    s13*s14*s23 - 32*s13*s23*s34 - 32*s14**2*s23 - 32*s14*s23*s34
     +     )

      LB = LB + Ld0(p2,p3,p4)*S24**(-1) * (  - 16*s12*s13 + 24*s12*s14
     +     + 40*s12*s34 - 8*s13**2 + 8*s13*s14 - 16*s13*s23 + 8*s13*s34
     +     + 16*s14**2 - 16*s14*s23 + 24*s14*s34 - 16*s23*s34 + 16*
     +    s34**2 )

      LB = LB + Ld0(p2,p3,p4)*S234**(-1) * (  - 32*s12*s13 - 32*s12*s14
     +     - 32*s12*s34 - 32*s13**2 - 64*s13*s14 - 32*s13*s34 - 32*
     +    s14**2 - 32*s14*s34 )

      LB = LB + Ld0(p2,p3,p4) * ( 8*s12 - 32*s13 - 16*s14 + 8*s23 - 16*
     +    s34 )

      LB = LB + Ld0(p2,p4,p3)*S13**(-1)*S23**(-1) * (  - 8*s12**2*s14
     +     + 16*s12**2*s34 - 16*s12*s14**2 + 16*s12*s14*s34 + 8*s12*
     +    s34**2 - 8*s14**3 )

      LB = LB + Ld0(p2,p4,p3)*S13**(-1) * (  - 16*s12*s14 + 8*s12*s34
     +     - 16*s14**2 - 8*s14*s23 - 8*s14*s34 )

      LB = LB + Ld0(p2,p4,p3)*S14**(-1)*S23**(-1) * (  - 8*s12**3 - 16*
     +    s12**2*s13 - 8*s12**2*s24 + 24*s12*s13**2 + 16*s12*s13*s24 + 
     +    32*s12*s13*s34 + 8*s12*s24*s34 + 8*s12*s34**2 + 8*s13**3 + 24
     +    *s13**2*s24 + 24*s13**2*s34 + 32*s13*s24*s34 + 32*s13*s34**2
     +     + 8*s24*s34**2 + 16*s34**3 )

      LB = LB + Ld0(p2,p4,p3)*S14**(-1)*S24**(-1) * (  - 8*s12**2*s13
     +     - 8*s12**2*s23 - 8*s12**2*s34 + 8*s12*s13**2 + 8*s12*s13*s23
     +     + 16*s12*s13*s34 + 8*s12*s23*s34 + 8*s12*s34**2 )

      LB = LB + Ld0(p2,p4,p3)*S14**(-1) * (  - 16*s12**2 + 24*s12*s13
     +     + 16*s12*s34 + 8*s13**2 + 16*s13*s34 + 8*s34**2 )

      LB = LB + Ld0(p2,p4,p3)*S23**(-1)*S24**(-1) * (  - 8*s12*s13*s34
     +     - 8*s12*s14*s34 - 8*s12*s34**2 - 8*s13**2*s34 - 16*s13*s14*
     +    s34 - 8*s13*s34**2 - 8*s14**2*s34 - 8*s14*s34**2 )

      LB = LB + Ld0(p2,p4,p3)*S23**(-1)*S234**(-1) * (  - 32*s12*s13*
     +    s24 - 32*s12*s14*s24 - 32*s12*s24*s34 - 32*s13**2*s24 - 64*
     +    s13*s14*s24 - 32*s13*s24*s34 - 32*s14**2*s24 - 32*s14*s24*s34
     +     )

      LB = LB + Ld0(p2,p4,p3)*S23**(-1) * ( 24*s12*s13 - 16*s12*s14 + 
     +    40*s12*s34 + 16*s13**2 + 8*s13*s14 - 16*s13*s24 + 24*s13*s34
     +     - 8*s14**2 - 16*s14*s24 + 8*s14*s34 - 16*s24*s34 + 16*s34**2
     +     )

      LB = LB + Ld0(p2,p4,p3)*S24**(-1)*S234**(-1) * (  - 16*s12*s13*
     +    s23 - 16*s12*s14*s23 - 16*s12*s23*s34 - 16*s13**2*s23 - 32*
     +    s13*s14*s23 - 16*s13*s23*s34 - 16*s14**2*s23 - 16*s14*s23*s34
     +     )

      LB = LB + Ld0(p2,p4,p3)*S24**(-1) * ( 24*s12*s13 + 16*s12*s14 + 8
     +    *s12*s23 + 24*s12*s34 + 8*s13**2 + 16*s13*s14 - 8*s13*s23 + 8
     +    *s13*s34 + 8*s14**2 - 8*s14*s23 + 8*s14*s34 - 8*s23*s34 )

      LB = LB + Ld0(p2,p4,p3)*S234**(-1) * (  - 32*s12*s13 - 32*s12*s14
     +     - 32*s12*s34 - 32*s13**2 - 64*s13*s14 - 32*s13*s34 - 32*
     +    s14**2 - 32*s14*s34 )

      LB = LB + Ld0(p2,p4,p3) * ( 8*s12 - 16*s13 - 32*s14 + 8*s24 - 16*
     +    s34 )

      LB = LB + Ld0(p2,p13,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LB = LB + Ld0(p2,p13,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s24*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LB = LB + Ld0(p2,p13,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s23*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LB = LB + Ld0(p2,p13,p4)*S13**(-1)*S14**(-1) * ( 32*s12**2*s34 + 
     +    24*s12*s23*s34 + 24*s12*s24*s34 + 16*s12*s34**2 )

      LB = LB + Ld0(p2,p13,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 + 8*s12**2*s34**2 )

      LB = LB + Ld0(p2,p13,p4)*S13**(-1)*S23**(-1) * ( 16*s12**3 + 16*
     +    s12**2*s24 + 16*s12**2*s34 + 8*s12*s24**2 + 8*s12*s24*s34 )

      LB = LB + Ld0(p2,p13,p4)*S13**(-1)*S24**(-1) * ( 16*s12**3 + 32*
     +    s12**2*s23 + 48*s12**2*s34 - 16*s12*s14*s34 + 24*s12*s23**2
     +     + 24*s12*s23*s34 + 8*s14**2*s23 + 8*s14*s23**2 + 8*s23**3 + 
     +    8*s23**2*s34 )

      LB = LB + Ld0(p2,p13,p4)*S13**(-1) * ( 48*s12**2 + 16*s12*s14 + 
     +    56*s12*s23 + 40*s12*s24 + 32*s12*s34 + 16*s14*s23 + 8*s14*s24
     +     + 24*s23**2 + 24*s23*s24 + 16*s23*s34 + 8*s24**2 + 8*s24*s34
     +     )

      LB = LB + Ld0(p2,p13,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**3*s13 - 16*s12**3*s34 + 24*s12**2*s13**2 - 72*s12**2*s13
     +    *s34 - 8*s12**2*s34**2 + 96*s12*s13**2*s34 - 64*s12*s13*
     +    s34**2 )

      LB = LB + Ld0(p2,p13,p4)*S14**(-1)*S23**(-1) * ( 16*s12**3 - 64*
     +    s12**2*s13 + 32*s12**2*s34 - 32*s12*s13**2 - 16*s12*s13*s24
     +     + 32*s12*s13*s34 - 8*s12*s24**2 - 8*s12*s24*s34 + 24*s12*
     +    s34**2 - 8*s13*s24**2 - 8*s24**3 - 8*s24**2*s34 )

      LB = LB + Ld0(p2,p13,p4)*S14**(-1)*S24**(-1) * ( 16*s12**3 + 16*
     +    s12**2*s23 + 48*s12**2*s34 + 8*s12*s13**2 - 16*s12*s13*s23 + 
     +    32*s12*s13*s34 + 8*s12*s23**2 + 40*s12*s23*s34 + 16*s12*
     +    s34**2 - 16*s13**2*s23 + 32*s13**2*s34 + 32*s13*s23*s34 - 8*
     +    s13*s34**2 + 8*s23*s34**2 )

      LB = LB + Ld0(p2,p13,p4)*S14**(-1) * ( 16*s12**2 - 48*s12*s13 + 8
     +    *s12*s23 - 8*s12*s24 + 16*s12*s34 - 32*s13**2 - 8*s13*s23 - 
     +    16*s13*s24 - 8*s23**2 - 24*s23*s24 - 8*s23*s34 - 24*s24**2 - 
     +    16*s24*s34 + 8*s34**2 )

      LB = LB + Ld0(p2,p13,p4)*S23**(-1)*S24**(-1) * (  - 16*s12**3 - 
     +    16*s12**2*s13 + 16*s12**2*s14 + 8*s12**2*s34 + 40*s12*s13**2
     +     + 40*s12*s13*s14 + 16*s12*s13*s34 )

      LB = LB + Ld0(p2,p13,p4)*S23**(-1) * (  - 16*s12**2 + 24*s12*s13
     +     - 8*s12*s14 - 16*s12*s24 - 8*s12*s34 - 8*s24**2 )

      LB = LB + Ld0(p2,p13,p4)*S24**(-1) * (  - 8*s12*s13 - 24*s12*s14
     +     - 16*s12*s23 - 16*s12*s34 - 24*s13**2 - 24*s13*s14 - 32*s13*
     +    s23 + 8*s13*s34 - 8*s14*s23 + 8*s23**2 - 8*s23*s34 )

      LB = LB + Ld0(p2,p13,p4)*SF*S13**(-1)*S23**(-1) * (  - 32*s12**2
     +     - 32*s12*s24 - 16*s24**2 )

      LB = LB + Ld0(p2,p13,p4)*SF*S13**(-1)*S24**(-1) * (  - 32*s12**2
     +     - 32*s12*s23 - 16*s23**2 )

      LB = LB + Ld0(p2,p13,p4)*SF*S13**(-1) * (  - 64*s12 - 48*s23 - 48
     +    *s24 )

      LB = LB + Ld0(p2,p13,p4)*SF*S14**(-1)*S23**(-1) * (  - 32*s12**2
     +     - 32*s12*s24 - 16*s24**2 )

      LB = LB + Ld0(p2,p13,p4)*SF*S14**(-1)*S24**(-1) * (  - 32*s12**2
     +     - 32*s12*s23 - 16*s23**2 )

      LB = LB + Ld0(p2,p13,p4)*SF*S14**(-1) * (  - 64*s12 - 48*s23 - 48
     +    *s24 )

      LB = LB + Ld0(p2,p13,p4) * (  - 16*s12 - 8*s13 + 8*s14 + 8*s23 - 
     +    8*s24 - 8*s34 )

      LB = LB + Ld0(p2,p14,p3)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LB = LB + Ld0(p2,p14,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s24*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LB = LB + Ld0(p2,p14,p3)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s23*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LB = LB + Ld0(p2,p14,p3)*S13**(-1)*S14**(-1) * ( 32*s12**2*s34 + 
     +    24*s12*s23*s34 + 24*s12*s24*s34 + 16*s12*s34**2 )

      LB = LB + Ld0(p2,p14,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**3*s14 - 16*s12**3*s34 + 24*s12**2*s14**2 - 72*s12**2*s14
     +    *s34 - 8*s12**2*s34**2 + 96*s12*s14**2*s34 - 64*s12*s14*
     +    s34**2 )

      LB = LB + Ld0(p2,p14,p3)*S13**(-1)*S23**(-1) * ( 16*s12**3 + 16*
     +    s12**2*s24 + 48*s12**2*s34 + 8*s12*s14**2 - 16*s12*s14*s24 + 
     +    32*s12*s14*s34 + 8*s12*s24**2 + 40*s12*s24*s34 + 16*s12*
     +    s34**2 - 16*s14**2*s24 + 32*s14**2*s34 + 32*s14*s24*s34 - 8*
     +    s14*s34**2 + 8*s24*s34**2 )

      LB = LB + Ld0(p2,p14,p3)*S13**(-1)*S24**(-1) * ( 16*s12**3 - 64*
     +    s12**2*s14 + 32*s12**2*s34 - 32*s12*s14**2 - 16*s12*s14*s23
     +     + 32*s12*s14*s34 - 8*s12*s23**2 - 8*s12*s23*s34 + 24*s12*
     +    s34**2 - 8*s14*s23**2 - 8*s23**3 - 8*s23**2*s34 )

      LB = LB + Ld0(p2,p14,p3)*S13**(-1) * ( 16*s12**2 - 48*s12*s14 - 8
     +    *s12*s23 + 8*s12*s24 + 16*s12*s34 - 32*s14**2 - 16*s14*s23 - 
     +    8*s14*s24 - 24*s23**2 - 24*s23*s24 - 16*s23*s34 - 8*s24**2 - 
     +    8*s24*s34 + 8*s34**2 )

      LB = LB + Ld0(p2,p14,p3)*S14**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 + 8*s12**2*s34**2 )

      LB = LB + Ld0(p2,p14,p3)*S14**(-1)*S23**(-1) * ( 16*s12**3 + 32*
     +    s12**2*s24 + 48*s12**2*s34 - 16*s12*s13*s34 + 24*s12*s24**2
     +     + 24*s12*s24*s34 + 8*s13**2*s24 + 8*s13*s24**2 + 8*s24**3 + 
     +    8*s24**2*s34 )

      LB = LB + Ld0(p2,p14,p3)*S14**(-1)*S24**(-1) * ( 16*s12**3 + 16*
     +    s12**2*s23 + 16*s12**2*s34 + 8*s12*s23**2 + 8*s12*s23*s34 )

      LB = LB + Ld0(p2,p14,p3)*S14**(-1) * ( 48*s12**2 + 16*s12*s13 + 
     +    40*s12*s23 + 56*s12*s24 + 32*s12*s34 + 8*s13*s23 + 16*s13*s24
     +     + 8*s23**2 + 24*s23*s24 + 8*s23*s34 + 24*s24**2 + 16*s24*s34
     +     )

      LB = LB + Ld0(p2,p14,p3)*S23**(-1)*S24**(-1) * (  - 16*s12**3 + 
     +    16*s12**2*s13 - 16*s12**2*s14 + 8*s12**2*s34 + 40*s12*s13*s14
     +     + 40*s12*s14**2 + 16*s12*s14*s34 )

      LB = LB + Ld0(p2,p14,p3)*S23**(-1) * (  - 24*s12*s13 - 8*s12*s14
     +     - 16*s12*s24 - 16*s12*s34 - 24*s13*s14 - 8*s13*s24 - 24*
     +    s14**2 - 32*s14*s24 + 8*s14*s34 + 8*s24**2 - 8*s24*s34 )

      LB = LB + Ld0(p2,p14,p3)*S24**(-1) * (  - 16*s12**2 - 8*s12*s13
     +     + 24*s12*s14 - 16*s12*s23 - 8*s12*s34 - 8*s23**2 )

      LB = LB + Ld0(p2,p14,p3)*SF*S13**(-1)*S23**(-1) * ( 32*s12**2 + 
     +    32*s12*s24 + 16*s24**2 )

      LB = LB + Ld0(p2,p14,p3)*SF*S13**(-1)*S24**(-1) * ( 32*s12**2 + 
     +    32*s12*s23 + 16*s23**2 )

      LB = LB + Ld0(p2,p14,p3)*SF*S13**(-1) * ( 64*s12 + 48*s23 + 48*
     +    s24 )

      LB = LB + Ld0(p2,p14,p3)*SF*S14**(-1)*S23**(-1) * ( 32*s12**2 + 
     +    32*s12*s24 + 16*s24**2 )

      LB = LB + Ld0(p2,p14,p3)*SF*S14**(-1)*S24**(-1) * ( 32*s12**2 + 
     +    32*s12*s23 + 16*s23**2 )

      LB = LB + Ld0(p2,p14,p3)*SF*S14**(-1) * ( 64*s12 + 48*s23 + 48*
     +    s24 )

      LB = LB + Ld0(p2,p14,p3) * (  - 16*s12 + 8*s13 - 8*s14 - 8*s23 + 
     +    8*s24 - 8*s34 )

      LB = LB + Ld0(p3,p1,p24)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S234 * (  - 16*s12**3*s34 )

      LB = LB + Ld0(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234*
     + S124**(-1) * (  - 16*s12**4 - 16*s12**2*s23**2 )

      LB = LB + Ld0(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234 * ( 
     +     - 16*s12**2*s34 - 8*s12*s23*s34 )

      LB = LB + Ld0(p3,p1,p24)*S13**(-1)*S14**(-1)*S234*S124**(-1) * ( 
     +     - 32*s12**3 - 16*s12**2*s24 - 32*s12*s23**2 - 16*s23**2*s24
     +     )

      LB = LB + Ld0(p3,p1,p24)*S13**(-1)*S14**(-1)*S234 * ( 16*s12**2
     +     + 16*s12*s23 + 8*s23**2 )

      LB = LB + Ld0(p3,p1,p24)*S13**(-1)*S23**(-1)*S24**(-1)*S234 * ( 
     +     - 16*s12**3 - 16*s12**2*s14 - 16*s12**2*s34 - 8*s12*s14**2
     +     - 8*s12*s14*s34 )

      LB = LB + Ld0(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*S124**(-1) * ( 
     +     - 16*s12**3 + 48*s12**2*s14 + 32*s12**2*s23 + 48*s12**2*s34
     +     + 80*s12*s14**2 + 64*s12*s14*s23 + 96*s12*s14*s34 - 16*s12*
     +    s23**2 + 32*s12*s23*s34 + 16*s12*s34**2 + 32*s14**3 + 32*
     +    s14**2*s23 + 48*s14**2*s34 + 32*s14*s23*s34 + 16*s14*s34**2 )

      LB = LB + Ld0(p3,p1,p24)*S13**(-1)*S24**(-1)*S234 * (  - 16*
     +    s12**2 - 32*s12*s14 - 8*s12*s23 - 32*s12*s34 - 16*s14**2 - 16
     +    *s14*s23 - 24*s14*s34 - 16*s23*s34 - 8*s34**2 )

      LB = LB + Ld0(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * (  - 16*
     +    s12**2 + 64*s12*s14 + 32*s12*s23 + 64*s12*s34 + 48*s14**2 + 
     +    32*s14*s23 + 16*s14*s24 + 64*s14*s34 - 16*s23**2 + 32*s23*s34
     +     + 16*s24*s34 + 16*s34**2 )

      LB = LB + Ld0(p3,p1,p24)*S13**(-1)*S234 * (  - 8*s14 - 8*s34 )

      LB = LB + Ld0(p3,p1,p24)*S14**(-1)*S23**(-1)*S24**(-1)*S234 * ( 
     +     - 16*s12**3 )

      LB = LB + Ld0(p3,p1,p24)*S14**(-1)*S24**(-1)*S234*S124**(-1) * ( 
     +    32*s12**3 + 32*s12**2*s23 + 16*s12**2*s34 )

      LB = LB + Ld0(p3,p1,p24)*S14**(-1)*S24**(-1)*S234 * (  - 16*
     +    s12**2 - 8*s12*s23 )

      LB = LB + Ld0(p3,p1,p24)*S14**(-1)*S234*S124**(-1) * ( 64*s12**2
     +     - 16*s12*s13 + 48*s12*s23 + 32*s12*s24 + 16*s12*s34 - 16*s13
     +    *s24 + 16*s23*s24 )

      LB = LB + Ld0(p3,p1,p24)*S23**(-1)*S24**(-1)*S234 * (  - 16*
     +    s12**2 - 8*s12*s14 )

      LB = LB + Ld0(p3,p1,p24)*S23**(-1)*S24**(-1) * ( 16*s12**2*s13 + 
     +    16*s12**2*s14 + 16*s12**2*s34 + 16*s12*s13*s14 + 16*s12*
     +    s14**2 + 16*s12*s14*s34 + 8*s13*s14**2 + 8*s14**3 + 8*s14**2*
     +    s34 )

      LB = LB + Ld0(p3,p1,p24)*S24**(-1)*S234*S124**(-1) * ( 96*s12**2
     +     + 96*s12*s14 + 64*s12*s23 + 32*s12*s34 + 32*s14**2 + 32*s14*
     +    s23 + 16*s14*s34 )

      LB = LB + Ld0(p3,p1,p24)*S24**(-1)*S234 * (  - 32*s12 - 8*s13 - 
     +    24*s14 - 16*s23 - 16*s34 )

      LB = LB + Ld0(p3,p1,p24)*S234*S124**(-1) * ( 112*s12 - 16*s13 + 
     +    48*s14 + 48*s23 + 16*s24 + 16*s34 )

      LB = LB + Ld0(p3,p1,p24)*S234 * (  - 8 )

      LB = LB + Ld0(p3,p2,p14)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S134 * (  - 16*s12**3*s34 )

      LB = LB + Ld0(p3,p2,p14)*S13**(-1)*S14**(-1)*S23**(-1)*S134 * ( 
     +     - 16*s12**3 - 16*s12**2*s24 - 16*s12**2*s34 - 8*s12*s24**2
     +     - 8*s12*s24*s34 )

      LB = LB + Ld0(p3,p2,p14)*S13**(-1)*S14**(-1)*S24**(-1)*S134 * ( 
     +     - 16*s12**3 )

      LB = LB + Ld0(p3,p2,p14)*S13**(-1)*S14**(-1)*S134 * (  - 16*
     +    s12**2 - 8*s12*s24 )

      LB = LB + Ld0(p3,p2,p14)*S13**(-1)*S14**(-1) * ( 16*s12**2*s23 + 
     +    16*s12**2*s24 + 16*s12**2*s34 + 16*s12*s23*s24 + 16*s12*
     +    s24**2 + 16*s12*s24*s34 + 8*s23*s24**2 + 8*s24**3 + 8*s24**2*
     +    s34 )

      LB = LB + Ld0(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * (  - 16*s12**4 - 16*s12**2*s13**2 )

      LB = LB + Ld0(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +     - 16*s12**2*s34 - 8*s12*s13*s34 )

      LB = LB + Ld0(p3,p2,p14)*S14**(-1)*S23**(-1)*S134*S124**(-1) * ( 
     +     - 16*s12**3 + 32*s12**2*s13 + 48*s12**2*s24 + 48*s12**2*s34
     +     - 16*s12*s13**2 + 64*s12*s13*s24 + 32*s12*s13*s34 + 80*s12*
     +    s24**2 + 96*s12*s24*s34 + 16*s12*s34**2 + 32*s13*s24**2 + 32*
     +    s13*s24*s34 + 32*s24**3 + 48*s24**2*s34 + 16*s24*s34**2 )

      LB = LB + Ld0(p3,p2,p14)*S14**(-1)*S23**(-1)*S134 * (  - 16*
     +    s12**2 - 8*s12*s13 - 32*s12*s24 - 32*s12*s34 - 16*s13*s24 - 
     +    16*s13*s34 - 16*s24**2 - 24*s24*s34 - 8*s34**2 )

      LB = LB + Ld0(p3,p2,p14)*S14**(-1)*S24**(-1)*S134*S124**(-1) * ( 
     +    32*s12**3 + 32*s12**2*s13 + 16*s12**2*s34 )

      LB = LB + Ld0(p3,p2,p14)*S14**(-1)*S24**(-1)*S134 * (  - 16*
     +    s12**2 - 8*s12*s13 )

      LB = LB + Ld0(p3,p2,p14)*S14**(-1)*S134*S124**(-1) * ( 96*s12**2
     +     + 64*s12*s13 + 96*s12*s24 + 32*s12*s34 + 32*s13*s24 + 32*
     +    s24**2 + 16*s24*s34 )

      LB = LB + Ld0(p3,p2,p14)*S14**(-1)*S134 * (  - 32*s12 - 16*s13 - 
     +    8*s23 - 24*s24 - 16*s34 )

      LB = LB + Ld0(p3,p2,p14)*S23**(-1)*S24**(-1)*S134*S124**(-1) * ( 
     +     - 32*s12**3 - 16*s12**2*s14 - 32*s12*s13**2 - 16*s13**2*s14
     +     )

      LB = LB + Ld0(p3,p2,p14)*S23**(-1)*S24**(-1)*S134 * ( 16*s12**2
     +     + 16*s12*s13 + 8*s13**2 )

      LB = LB + Ld0(p3,p2,p14)*S23**(-1)*S134*S124**(-1) * (  - 16*
     +    s12**2 + 32*s12*s13 + 64*s12*s24 + 64*s12*s34 - 16*s13**2 + 
     +    32*s13*s24 + 32*s13*s34 + 16*s14*s24 + 16*s14*s34 + 48*s24**2
     +     + 64*s24*s34 + 16*s34**2 )

      LB = LB + Ld0(p3,p2,p14)*S23**(-1)*S134 * (  - 8*s24 - 8*s34 )

      LB = LB + Ld0(p3,p2,p14)*S24**(-1)*S134*S124**(-1) * ( 64*s12**2
     +     + 48*s12*s13 + 32*s12*s14 - 16*s12*s23 + 16*s12*s34 + 16*s13
     +    *s14 - 16*s14*s23 )

      LB = LB + Ld0(p3,p2,p14)*S134*S124**(-1) * ( 112*s12 + 48*s13 + 
     +    16*s14 - 16*s23 + 48*s24 + 16*s34 )

      LB = LB + Ld0(p3,p2,p14)*S134 * (  - 8 )

      LB = LB + Ld0(p3,p4,p12)*S13**(-1)*S14**(-1) * ( 8*s12*s23*s34 + 
     +    8*s12*s24*s34 + 8*s12*s34**2 + 8*s23**2*s34 + 16*s23*s24*s34
     +     + 8*s23*s34**2 + 8*s24**2*s34 + 8*s24*s34**2 )

      LB = LB + Ld0(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 48*
     +    s12**3*s14 + 160*s12**3*s34 + 96*s12**2*s14**2 - 368*s12**2*
     +    s14*s34 + 168*s12**2*s34**2 + 48*s12*s14**2*s34 - 72*s12*s14*
     +    s34**2 + 16*s12*s34**3 )

      LB = LB + Ld0(p3,p4,p12)*S13**(-1)*S23**(-1) * ( 32*s12**3 - 64*
     +    s12**2*s14 + 48*s12**2*s24 + 104*s12**2*s34 + 24*s12*s14**2
     +     - 24*s12*s14*s24 - 72*s12*s14*s34 + 32*s12*s24**2 + 16*s12*
     +    s24*s34 + 16*s12*s34**2 + 8*s14**3 + 8*s24**3 )

      LB = LB + Ld0(p3,p4,p12)*S13**(-1)*S24**(-1) * ( 40*s12**3 - 120*
     +    s12**2*s14 + 80*s12**2*s23 + 160*s12**2*s34 + 88*s12*s14**2
     +     - 80*s12*s14*s23 - 152*s12*s14*s34 + 24*s12*s23**2 + 64*s12*
     +    s23*s34 + 56*s12*s34**2 + 8*s14**3 + 8*s14**2*s23 + 8*s14**2*
     +    s34 - 8*s14*s23**2 - 16*s14*s23*s34 - 8*s14*s34**2 + 8*s23**3
     +     + 24*s23**2*s34 + 16*s23*s34**2 )

      LB = LB + Ld0(p3,p4,p12)*S13**(-1) * ( 104*s12**2 - 64*s12*s14 + 
     +    64*s12*s23 + 72*s12*s24 + 56*s12*s34 + 8*s14**2 - 8*s14*s23
     +     - 8*s14*s24 - 8*s14*s34 + 16*s23**2 + 16*s23*s24 + 40*s23*
     +    s34 + 16*s24**2 + 16*s24*s34 + 16*s34**2 )

      LB = LB + Ld0(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 48*
     +    s12**3*s13 + 160*s12**3*s34 + 48*s12**2*s13**2 - 176*s12**2*
     +    s13*s34 + 56*s12**2*s34**2 + 32*s12*s13**2*s34 - 40*s12*s13*
     +    s34**2 - 16*s12*s34**3 )

      LB = LB + Ld0(p3,p4,p12)*S14**(-1)*S23**(-1) * ( 40*s12**3 - 112*
     +    s12**2*s13 + 72*s12**2*s24 + 176*s12**2*s34 + 48*s12*s13**2
     +     - 128*s12*s13*s24 - 112*s12*s13*s34 + 48*s12*s24**2 + 56*s12
     +    *s24*s34 - 8*s12*s34**2 + 16*s13**2*s34 - 16*s13*s24**2 - 32*
     +    s13*s24*s34 - 16*s13*s34**2 + 16*s24**3 + 16*s24**2*s34 - 8*
     +    s24*s34**2 - 16*s34**3 )

      LB = LB + Ld0(p3,p4,p12)*S14**(-1)*S24**(-1) * ( 32*s12**3 - 16*
     +    s12**2*s13 + 48*s12**2*s23 + 88*s12**2*s34 - 24*s12*s13*s23
     +     - 48*s12*s13*s34 + 8*s12*s23**2 + 8*s12*s23*s34 )

      LB = LB + Ld0(p3,p4,p12)*S14**(-1) * ( 112*s12**2 - 72*s12*s13 + 
     +    8*s12*s23 + 48*s12*s24 - 8*s12*s34 - 8*s13*s23 - 8*s13*s24 - 
     +    24*s13*s34 - 8*s23**2 - 16*s23*s24 - 8*s23*s34 + 8*s24**2 - 8
     +    *s24*s34 - 8*s34**2 )

      LB = LB + Ld0(p3,p4,p12)*S23**(-1)*S24**(-1) * (  - 96*s12**3 - 
     +    96*s12**2*s13 - 48*s12**2*s14 - 832*s12**2*s34 + 56*s12*
     +    s13**2 + 64*s12*s13*s14 + 32*s12*s13*s34 + 8*s12*s14**2 - 184
     +    *s12*s34**2 + 8*s13**3 + 8*s13**2*s14 + 48*s13**2*s34 - 8*s13
     +    *s14**2 + 32*s13*s14*s34 + 40*s13*s34**2 - 8*s14**3 - 16*
     +    s14**2*s34 - 8*s14*s34**2 )

      LB = LB + Ld0(p3,p4,p12)*S23**(-1) * (  - 152*s12**2 - 184*s12*
     +    s13 - 112*s12*s14 - 40*s12*s24 - 288*s12*s34 + 8*s13**2 - 24*
     +    s13*s14 - 64*s13*s24 - 8*s13*s34 - 8*s14*s24 - 8*s14*s34 + 24
     +    *s24**2 - 8*s34**2 )

      LB = LB + Ld0(p3,p4,p12)*S24**(-1) * (  - 96*s12**2 - 48*s12*s13
     +     - 56*s12*s14 - 16*s12*s23 - 96*s12*s34 + 8*s13**2 - 8*s13*
     +    s14 + 8*s13*s23 + 16*s13*s34 - 16*s14*s23 - 24*s14*s34 + 16*
     +    s23**2 + 32*s23*s34 + 16*s34**2 )

      LB = LB + Ld0(p3,p4,p12) * (  - 32*s12 + 8*s13 + 8*s14 + 16*s23
     +     + 16*s24 + 16*s34 )

      LB = LB + Ld0(p3,p12,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 32*s12**3*s34**2 )

      LB = LB + Ld0(p3,p12,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 32*
     +    s12**3*s34 + 16*s12**2*s24*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LB = LB + Ld0(p3,p12,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 + 16*s12**2*s23*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LB = LB + Ld0(p3,p12,p4)*S13**(-1)*S14**(-1) * ( 32*s12**2*s34 + 
     +    8*s12*s23*s34 + 8*s12*s24*s34 )

      LB = LB + Ld0(p3,p12,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 + 16*s12**2*s14*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s14**2*s34 + 8*s12*s14*s34**2 )

      LB = LB + Ld0(p3,p12,p4)*S13**(-1)*S23**(-1) * ( 32*s12**3 + 16*
     +    s12**2*s14 + 16*s12**2*s24 + 32*s12**2*s34 + 8*s12*s14**2 + 8
     +    *s12*s14*s34 + 8*s12*s24**2 + 8*s12*s24*s34 )

      LB = LB + Ld0(p3,p12,p4)*S13**(-1)*S24**(-1) * ( 32*s12**3 - 32*
     +    s12**2*s14 - 32*s12**2*s23 - 16*s12**2*s34 - 24*s12*s14**2 + 
     +    48*s12*s14*s23 + 8*s12*s14*s34 + 8*s12*s23**2 + 8*s12*s23*s34
     +     + 8*s14**3 + 8*s14**2*s23 + 8*s14**2*s34 + 24*s14*s23**2 + 8
     +    *s23**3 + 8*s23**2*s34 )

      LB = LB + Ld0(p3,p12,p4)*S13**(-1) * (  - 16*s12**2 - 32*s12*s14
     +     - 24*s12*s23 - 24*s12*s24 - 32*s12*s34 + 8*s14**2 + 16*s14*
     +    s23 - 8*s14*s24 + 8*s23**2 - 8*s23*s24 - 8*s24**2 - 8*s24*s34
     +     )

      LB = LB + Ld0(p3,p12,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 + 16*s12**2*s13*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s13**2*s34 + 8*s12*s13*s34**2 )

      LB = LB + Ld0(p3,p12,p4)*S14**(-1)*S23**(-1) * ( 32*s12**3 - 32*
     +    s12**2*s13 - 32*s12**2*s24 - 16*s12**2*s34 - 24*s12*s13**2 + 
     +    48*s12*s13*s24 + 8*s12*s13*s34 + 8*s12*s24**2 + 8*s12*s24*s34
     +     + 8*s13**3 + 8*s13**2*s24 + 8*s13**2*s34 + 24*s13*s24**2 + 8
     +    *s24**3 + 8*s24**2*s34 )

      LB = LB + Ld0(p3,p12,p4)*S14**(-1)*S24**(-1) * ( 32*s12**3 + 16*
     +    s12**2*s13 + 16*s12**2*s23 + 32*s12**2*s34 + 8*s12*s13**2 + 8
     +    *s12*s13*s34 + 8*s12*s23**2 + 8*s12*s23*s34 )

      LB = LB + Ld0(p3,p12,p4)*S14**(-1) * (  - 16*s12**2 - 32*s12*s13
     +     - 24*s12*s23 - 24*s12*s24 - 32*s12*s34 + 8*s13**2 - 8*s13*
     +    s23 + 16*s13*s24 - 8*s23**2 - 8*s23*s24 - 8*s23*s34 + 8*
     +    s24**2 )

      LB = LB + Ld0(p3,p12,p4)*S23**(-1)*S24**(-1) * ( 32*s12**2*s34 + 
     +    16*s12*s13**2 + 192*s12*s13*s14 + 8*s12*s13*s34 + 16*s12*
     +    s14**2 + 8*s12*s14*s34 - 16*s13**2*s14 - 16*s13*s14**2 )

      LB = LB + Ld0(p3,p12,p4)*S23**(-1) * (  - 16*s12**2 + 72*s12*s13
     +     + 24*s12*s14 - 32*s12*s24 - 32*s12*s34 + 24*s13**2 - 24*s13*
     +    s14 + 32*s13*s24 - 8*s14**2 - 8*s14*s24 - 8*s14*s34 + 8*
     +    s24**2 )

      LB = LB + Ld0(p3,p12,p4)*S24**(-1) * (  - 16*s12**2 + 24*s12*s13
     +     + 72*s12*s14 - 32*s12*s23 - 32*s12*s34 - 8*s13**2 - 24*s13*
     +    s14 - 8*s13*s23 - 8*s13*s34 + 24*s14**2 + 32*s14*s23 + 8*
     +    s23**2 )

      LB = LB + Ld0(p3,p12,p4) * (  - 224*s12 - 24*s13 - 24*s14 - 40*
     +    s23 - 40*s24 )

      LB = LB + Ld0(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S234 * (  - 16*s12**3*s34 )

      LB = LB + Ld0(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S123**(-1)
     + *S234 * (  - 16*s12**4 - 16*s12**2*s24**2 )

      LB = LB + Ld0(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S234 * ( 
     +     - 16*s12**2*s34 - 8*s12*s24*s34 )

      LB = LB + Ld0(p4,p1,p23)*S13**(-1)*S14**(-1)*S123**(-1)*S234 * ( 
     +     - 32*s12**3 - 16*s12**2*s23 - 32*s12*s24**2 - 16*s23*s24**2
     +     )

      LB = LB + Ld0(p4,p1,p23)*S13**(-1)*S14**(-1)*S234 * ( 16*s12**2
     +     + 16*s12*s24 + 8*s24**2 )

      LB = LB + Ld0(p4,p1,p23)*S13**(-1)*S23**(-1)*S24**(-1)*S234 * ( 
     +     - 16*s12**3 )

      LB = LB + Ld0(p4,p1,p23)*S13**(-1)*S23**(-1)*S123**(-1)*S234 * ( 
     +    32*s12**3 + 32*s12**2*s24 + 16*s12**2*s34 )

      LB = LB + Ld0(p4,p1,p23)*S13**(-1)*S23**(-1)*S234 * (  - 16*
     +    s12**2 - 8*s12*s24 )

      LB = LB + Ld0(p4,p1,p23)*S13**(-1)*S123**(-1)*S234 * ( 64*s12**2
     +     - 16*s12*s14 + 32*s12*s23 + 48*s12*s24 + 16*s12*s34 - 16*s14
     +    *s23 + 16*s23*s24 )

      LB = LB + Ld0(p4,p1,p23)*S14**(-1)*S23**(-1)*S24**(-1)*S234 * ( 
     +     - 16*s12**3 - 16*s12**2*s13 - 16*s12**2*s34 - 8*s12*s13**2
     +     - 8*s12*s13*s34 )

      LB = LB + Ld0(p4,p1,p23)*S14**(-1)*S23**(-1)*S123**(-1)*S234 * ( 
     +     - 16*s12**3 + 48*s12**2*s13 + 32*s12**2*s24 + 48*s12**2*s34
     +     + 80*s12*s13**2 + 64*s12*s13*s24 + 96*s12*s13*s34 - 16*s12*
     +    s24**2 + 32*s12*s24*s34 + 16*s12*s34**2 + 32*s13**3 + 32*
     +    s13**2*s24 + 48*s13**2*s34 + 32*s13*s24*s34 + 16*s13*s34**2 )

      LB = LB + Ld0(p4,p1,p23)*S14**(-1)*S23**(-1)*S234 * (  - 16*
     +    s12**2 - 32*s12*s13 - 8*s12*s24 - 32*s12*s34 - 16*s13**2 - 16
     +    *s13*s24 - 24*s13*s34 - 16*s24*s34 - 8*s34**2 )

      LB = LB + Ld0(p4,p1,p23)*S14**(-1)*S123**(-1)*S234 * (  - 16*
     +    s12**2 + 64*s12*s13 + 32*s12*s24 + 64*s12*s34 + 48*s13**2 + 
     +    16*s13*s23 + 32*s13*s24 + 64*s13*s34 + 16*s23*s34 - 16*s24**2
     +     + 32*s24*s34 + 16*s34**2 )

      LB = LB + Ld0(p4,p1,p23)*S14**(-1)*S234 * (  - 8*s13 - 8*s34 )

      LB = LB + Ld0(p4,p1,p23)*S23**(-1)*S24**(-1)*S234 * (  - 16*
     +    s12**2 - 8*s12*s13 )

      LB = LB + Ld0(p4,p1,p23)*S23**(-1)*S24**(-1) * ( 16*s12**2*s13 + 
     +    16*s12**2*s14 + 16*s12**2*s34 + 16*s12*s13**2 + 16*s12*s13*
     +    s14 + 16*s12*s13*s34 + 8*s13**3 + 8*s13**2*s14 + 8*s13**2*s34
     +     )

      LB = LB + Ld0(p4,p1,p23)*S23**(-1)*S123**(-1)*S234 * ( 96*s12**2
     +     + 96*s12*s13 + 64*s12*s24 + 32*s12*s34 + 32*s13**2 + 32*s13*
     +    s24 + 16*s13*s34 )

      LB = LB + Ld0(p4,p1,p23)*S23**(-1)*S234 * (  - 32*s12 - 24*s13 - 
     +    8*s14 - 16*s24 - 16*s34 )

      LB = LB + Ld0(p4,p1,p23)*S123**(-1)*S234 * ( 112*s12 + 48*s13 - 
     +    16*s14 + 16*s23 + 48*s24 + 16*s34 )

      LB = LB + Ld0(p4,p1,p23)*S234 * (  - 8 )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S134 * (  - 16*s12**3*s34 )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S14**(-1)*S23**(-1)*S134 * ( 
     +     - 16*s12**3 )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S14**(-1)*S24**(-1)*S134 * ( 
     +     - 16*s12**3 - 16*s12**2*s23 - 16*s12**2*s34 - 8*s12*s23**2
     +     - 8*s12*s23*s34 )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S14**(-1)*S134 * (  - 16*
     +    s12**2 - 8*s12*s23 )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S14**(-1) * ( 16*s12**2*s23 + 
     +    16*s12**2*s24 + 16*s12**2*s34 + 16*s12*s23**2 + 16*s12*s23*
     +    s24 + 16*s12*s23*s34 + 8*s23**3 + 8*s23**2*s24 + 8*s23**2*s34
     +     )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*S123**(-1)
     + *S134 * (  - 16*s12**4 - 16*s12**2*s14**2 )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +     - 16*s12**2*s34 - 8*s12*s14*s34 )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S23**(-1)*S123**(-1)*S134 * ( 
     +    32*s12**3 + 32*s12**2*s14 + 16*s12**2*s34 )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S23**(-1)*S134 * (  - 16*
     +    s12**2 - 8*s12*s14 )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*S134 * ( 
     +     - 16*s12**3 + 32*s12**2*s14 + 48*s12**2*s23 + 48*s12**2*s34
     +     - 16*s12*s14**2 + 64*s12*s14*s23 + 32*s12*s14*s34 + 80*s12*
     +    s23**2 + 96*s12*s23*s34 + 16*s12*s34**2 + 32*s14*s23**2 + 32*
     +    s14*s23*s34 + 32*s23**3 + 48*s23**2*s34 + 16*s23*s34**2 )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S24**(-1)*S134 * (  - 16*
     +    s12**2 - 8*s12*s14 - 32*s12*s23 - 32*s12*s34 - 16*s14*s23 - 
     +    16*s14*s34 - 16*s23**2 - 24*s23*s34 - 8*s34**2 )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * ( 96*s12**2
     +     + 64*s12*s14 + 96*s12*s23 + 32*s12*s34 + 32*s14*s23 + 32*
     +    s23**2 + 16*s23*s34 )

      LB = LB + Ld0(p4,p2,p13)*S13**(-1)*S134 * (  - 32*s12 - 16*s14 - 
     +    24*s23 - 8*s24 - 16*s34 )

      LB = LB + Ld0(p4,p2,p13)*S23**(-1)*S24**(-1)*S123**(-1)*S134 * ( 
     +     - 32*s12**3 - 16*s12**2*s13 - 32*s12*s14**2 - 16*s13*s14**2
     +     )

      LB = LB + Ld0(p4,p2,p13)*S23**(-1)*S24**(-1)*S134 * ( 16*s12**2
     +     + 16*s12*s14 + 8*s14**2 )

      LB = LB + Ld0(p4,p2,p13)*S23**(-1)*S123**(-1)*S134 * ( 64*s12**2
     +     + 32*s12*s13 + 48*s12*s14 - 16*s12*s24 + 16*s12*s34 + 16*s13
     +    *s14 - 16*s13*s24 )

      LB = LB + Ld0(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * (  - 16*
     +    s12**2 + 32*s12*s14 + 64*s12*s23 + 64*s12*s34 + 16*s13*s23 + 
     +    16*s13*s34 - 16*s14**2 + 32*s14*s23 + 32*s14*s34 + 48*s23**2
     +     + 64*s23*s34 + 16*s34**2 )

      LB = LB + Ld0(p4,p2,p13)*S24**(-1)*S134 * (  - 8*s23 - 8*s34 )

      LB = LB + Ld0(p4,p2,p13)*S123**(-1)*S134 * ( 112*s12 + 16*s13 + 
     +    48*s14 + 48*s23 - 16*s24 + 16*s34 )

      LB = LB + Ld0(p4,p2,p13)*S134 * (  - 8 )

      LB = LB + Ld0(p4,p3,p12)*S13**(-1)*S14**(-1) * ( 8*s12*s23*s34 + 
     +    8*s12*s24*s34 + 8*s12*s34**2 + 8*s23**2*s34 + 16*s23*s24*s34
     +     + 8*s23*s34**2 + 8*s24**2*s34 + 8*s24*s34**2 )

      LB = LB + Ld0(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 48*
     +    s12**3*s14 + 160*s12**3*s34 + 48*s12**2*s14**2 - 176*s12**2*
     +    s14*s34 + 56*s12**2*s34**2 + 32*s12*s14**2*s34 - 40*s12*s14*
     +    s34**2 - 16*s12*s34**3 )

      LB = LB + Ld0(p4,p3,p12)*S13**(-1)*S23**(-1) * ( 32*s12**3 - 16*
     +    s12**2*s14 + 48*s12**2*s24 + 88*s12**2*s34 - 24*s12*s14*s24
     +     - 48*s12*s14*s34 + 8*s12*s24**2 + 8*s12*s24*s34 )

      LB = LB + Ld0(p4,p3,p12)*S13**(-1)*S24**(-1) * ( 40*s12**3 - 112*
     +    s12**2*s14 + 72*s12**2*s23 + 176*s12**2*s34 + 48*s12*s14**2
     +     - 128*s12*s14*s23 - 112*s12*s14*s34 + 48*s12*s23**2 + 56*s12
     +    *s23*s34 - 8*s12*s34**2 + 16*s14**2*s34 - 16*s14*s23**2 - 32*
     +    s14*s23*s34 - 16*s14*s34**2 + 16*s23**3 + 16*s23**2*s34 - 8*
     +    s23*s34**2 - 16*s34**3 )

      LB = LB + Ld0(p4,p3,p12)*S13**(-1) * ( 112*s12**2 - 72*s12*s14 + 
     +    48*s12*s23 + 8*s12*s24 - 8*s12*s34 - 8*s14*s23 - 8*s14*s24 - 
     +    24*s14*s34 + 8*s23**2 - 16*s23*s24 - 8*s23*s34 - 8*s24**2 - 8
     +    *s24*s34 - 8*s34**2 )

      LB = LB + Ld0(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 48*
     +    s12**3*s13 + 160*s12**3*s34 + 96*s12**2*s13**2 - 368*s12**2*
     +    s13*s34 + 168*s12**2*s34**2 + 48*s12*s13**2*s34 - 72*s12*s13*
     +    s34**2 + 16*s12*s34**3 )

      LB = LB + Ld0(p4,p3,p12)*S14**(-1)*S23**(-1) * ( 40*s12**3 - 120*
     +    s12**2*s13 + 80*s12**2*s24 + 160*s12**2*s34 + 88*s12*s13**2
     +     - 80*s12*s13*s24 - 152*s12*s13*s34 + 24*s12*s24**2 + 64*s12*
     +    s24*s34 + 56*s12*s34**2 + 8*s13**3 + 8*s13**2*s24 + 8*s13**2*
     +    s34 - 8*s13*s24**2 - 16*s13*s24*s34 - 8*s13*s34**2 + 8*s24**3
     +     + 24*s24**2*s34 + 16*s24*s34**2 )

      LB = LB + Ld0(p4,p3,p12)*S14**(-1)*S24**(-1) * ( 32*s12**3 - 64*
     +    s12**2*s13 + 48*s12**2*s23 + 104*s12**2*s34 + 24*s12*s13**2
     +     - 24*s12*s13*s23 - 72*s12*s13*s34 + 32*s12*s23**2 + 16*s12*
     +    s23*s34 + 16*s12*s34**2 + 8*s13**3 + 8*s23**3 )

      LB = LB + Ld0(p4,p3,p12)*S14**(-1) * ( 104*s12**2 - 64*s12*s13 + 
     +    72*s12*s23 + 64*s12*s24 + 56*s12*s34 + 8*s13**2 - 8*s13*s23
     +     - 8*s13*s24 - 8*s13*s34 + 16*s23**2 + 16*s23*s24 + 16*s23*
     +    s34 + 16*s24**2 + 40*s24*s34 + 16*s34**2 )

      LB = LB + Ld0(p4,p3,p12)*S23**(-1)*S24**(-1) * (  - 96*s12**3 - 
     +    48*s12**2*s13 - 96*s12**2*s14 - 832*s12**2*s34 + 8*s12*s13**2
     +     + 64*s12*s13*s14 + 56*s12*s14**2 + 32*s12*s14*s34 - 184*s12*
     +    s34**2 - 8*s13**3 - 8*s13**2*s14 - 16*s13**2*s34 + 8*s13*
     +    s14**2 + 32*s13*s14*s34 - 8*s13*s34**2 + 8*s14**3 + 48*s14**2
     +    *s34 + 40*s14*s34**2 )

      LB = LB + Ld0(p4,p3,p12)*S23**(-1) * (  - 96*s12**2 - 56*s12*s13
     +     - 48*s12*s14 - 16*s12*s24 - 96*s12*s34 - 8*s13*s14 - 16*s13*
     +    s24 - 24*s13*s34 + 8*s14**2 + 8*s14*s24 + 16*s14*s34 + 16*
     +    s24**2 + 32*s24*s34 + 16*s34**2 )

      LB = LB + Ld0(p4,p3,p12)*S24**(-1) * (  - 152*s12**2 - 112*s12*
     +    s13 - 184*s12*s14 - 40*s12*s23 - 288*s12*s34 - 24*s13*s14 - 8
     +    *s13*s23 - 8*s13*s34 + 8*s14**2 - 64*s14*s23 - 8*s14*s34 + 24
     +    *s23**2 - 8*s34**2 )

      LB = LB + Ld0(p4,p3,p12) * (  - 32*s12 + 8*s13 + 8*s14 + 16*s23
     +     + 16*s24 + 16*s34 )

      LBf=-LB/s134/s234
      
      return
      end

      function LBg(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      SF=(s13*s24-s14*s23)/2d0/s34

      LB=0d0

      LB = LB + Ld1(p1,p2,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 8*
     +    s12**2*s24*s34**2 + 8*s12**2*s34**3 )

      LB = LB + Ld1(p1,p2,p3)*S13**(-1)*S14**(-1) * ( 8*s12**2*s34**2 )

      LB = LB + Ld1(p1,p2,p3)*S13**(-1)*S23**(-1) * (  - 8*s12**2*s14*
     +    s34 + 8*s12**2*s24*s34 )

      LB = LB + Ld1(p1,p2,p3)*S13**(-1)*S24**(-1) * (  - 8*s12**2*s14*
     +    s34 - 8*s12**2*s34**2 + 8*s12*s14**2*s23 - 8*s12*s14**2*s34
     +     - 16*s12*s14*s34**2 - 8*s12*s23*s34**2 - 8*s12*s34**3 + 8*
     +    s14**3*s23 + 8*s14**2*s23**2 + 16*s14**2*s23*s34 + 8*s14*
     +    s23**2*s34 + 8*s14*s23*s34**2 )

      LB = LB + Ld1(p1,p2,p3)*S13**(-1) * ( 8*s12**2*s34 + 8*s12*s14**2
     +     - 8*s12*s14*s23 - 8*s12*s14*s24 - 8*s12*s14*s34 - 8*s12*s23*
     +    s34 - 8*s12*s24*s34 - 16*s12*s34**2 + 8*s14**2*s23 + 8*s14*
     +    s23*s34 )

      LB = LB + Ld1(p1,p2,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 8*
     +    s12**2*s23*s34**2 + 8*s12**2*s34**3 )

      LB = LB + Ld1(p1,p2,p4)*S13**(-1)*S14**(-1) * ( 8*s12**2*s34**2 )

      LB = LB + Ld1(p1,p2,p4)*S14**(-1)*S23**(-1) * (  - 8*s12**2*s13*
     +    s34 - 8*s12**2*s34**2 + 8*s12*s13**2*s24 - 8*s12*s13**2*s34
     +     - 16*s12*s13*s34**2 - 8*s12*s24*s34**2 - 8*s12*s34**3 + 8*
     +    s13**3*s24 + 8*s13**2*s24**2 + 16*s13**2*s24*s34 + 8*s13*
     +    s24**2*s34 + 8*s13*s24*s34**2 )

      LB = LB + Ld1(p1,p2,p4)*S14**(-1)*S24**(-1) * (  - 8*s12**2*s13*
     +    s34 + 8*s12**2*s23*s34 )

      LB = LB + Ld1(p1,p2,p4)*S14**(-1) * ( 8*s12**2*s34 + 8*s12*s13**2
     +     - 8*s12*s13*s23 - 8*s12*s13*s24 - 8*s12*s13*s34 - 8*s12*s23*
     +    s34 - 8*s12*s24*s34 - 16*s12*s34**2 + 8*s13**2*s24 + 8*s13*
     +    s24*s34 )

      LB = LB + Ld1(p1,p2,p34)*S13**(-1)*S14**(-1)*S134 * (  - 8*s12*
     +    s34**2 - 16*s23*s34**2 - 8*s24*s34**2 )

      LB = LB + Ld1(p1,p2,p34)*S13**(-1)*S14**(-1) * ( 8*s12*s34**3 + 
     +    16*s23*s34**3 + 8*s24*s34**3 )

      LB = LB + Ld1(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * ( 16*s12**2*
     +    s34 - 16*s12*s14*s23 + 16*s12*s14*s34 + 8*s12*s23*s34 + 16*
     +    s12*s34**2 - 16*s14**2*s23 - 8*s14*s23**2 - 16*s14*s23*s34 )

      LB = LB + Ld1(p1,p2,p34)*S13**(-1)*S134 * (  - 8*s12*s34 + 8*s14*
     +    s23 - 24*s23*s34 - 16*s24*s34 )

      LB = LB + Ld1(p1,p2,p34)*S13**(-1) * ( 16*s12*s34**2 + 16*s14*s23
     +    *s34 + 16*s14*s24*s34 + 40*s23*s34**2 + 24*s24*s34**2 )

      LB = LB + Ld1(p1,p2,p34)*S14**(-1)*S23**(-1)*S134 * (  - 16*
     +    s12**2*s34 + 16*s12*s13*s24 - 16*s12*s13*s34 + 8*s12*s24*s34
     +     + 16*s13**2*s24 - 8*s13*s24**2 )

      LB = LB + Ld1(p1,p2,p34)*S14**(-1)*S134 * ( 32*s12*s13 + 24*s12*
     +    s34 + 32*s13**2 - 64*s13*s23 - 56*s13*s24 - 16*s13*s34 + 16*
     +    s23*s34 + 8*s24*s34 )

      LB = LB + Ld1(p1,p2,p34)*S24**(-1)*S134 * (  - 32*s12*s23 - 32*
     +    s14*s23 - 32*s23**2 - 48*s23*s34 )

      LB = LB + Ld1(p1,p2,p34)*S134 * ( 16*s13 - 16*s14 - 32*s23 - 16*
     +    s34 )

      LB = LB + Ld1(p1,p3,p4)*S14**(-1)*S23**(-1) * (  - 8*s12**3*s34
     +     + 8*s12**2*s13*s24 - 8*s12**2*s13*s34 - 24*s12**2*s24*s34 - 
     +    16*s12**2*s34**2 + 8*s12*s13**2*s24 + 24*s12*s13*s24**2 - 8*
     +    s12*s13*s24*s34 - 16*s12*s13*s34**2 - 16*s12*s24**2*s34 - 32*
     +    s12*s24*s34**2 - 16*s12*s34**3 + 24*s13**2*s24**2 + 16*s13**2
     +    *s24*s34 + 16*s13*s24**3 + 32*s13*s24**2*s34 + 16*s13*s24*
     +    s34**2 )

      LB = LB + Ld1(p1,p3,p4)*S14**(-1)*S24**(-1) * (  - 8*s12**3*s34
     +     - 8*s12**2*s23*s34 )

      LB = LB + Ld1(p1,p3,p4)*S14**(-1) * ( 8*s12**2*s13 - 32*s12**2*
     +    s34 - 8*s12*s13*s23 + 16*s12*s13*s24 - 16*s12*s13*s34 - 16*
     +    s12*s23*s34 - 32*s12*s24*s34 - 32*s12*s34**2 + 16*s13*s24**2
     +     + 16*s13*s24*s34 )

      LB = LB + Ld1(p1,p4,p3)*S13**(-1)*S23**(-1) * (  - 8*s12**3*s34
     +     - 8*s12**2*s24*s34 )

      LB = LB + Ld1(p1,p4,p3)*S13**(-1)*S24**(-1) * (  - 8*s12**3*s34
     +     + 8*s12**2*s14*s23 - 8*s12**2*s14*s34 - 24*s12**2*s23*s34 - 
     +    16*s12**2*s34**2 + 8*s12*s14**2*s23 + 24*s12*s14*s23**2 - 8*
     +    s12*s14*s23*s34 - 16*s12*s14*s34**2 - 16*s12*s23**2*s34 - 32*
     +    s12*s23*s34**2 - 16*s12*s34**3 + 24*s14**2*s23**2 + 16*s14**2
     +    *s23*s34 + 16*s14*s23**3 + 32*s14*s23**2*s34 + 16*s14*s23*
     +    s34**2 )

      LB = LB + Ld1(p1,p4,p3)*S13**(-1) * ( 8*s12**2*s14 - 32*s12**2*
     +    s34 + 16*s12*s14*s23 - 8*s12*s14*s24 - 16*s12*s14*s34 - 32*
     +    s12*s23*s34 - 16*s12*s24*s34 - 32*s12*s34**2 + 16*s14*s23**2
     +     + 16*s14*s23*s34 )

      LB = LB + Ld1(p1,p23,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 24*
     +    s12**3*s23*s34 + 16*s12**2*s23*s34**2 )

      LB = LB + Ld1(p1,p23,p4)*S13**(-1)*S14**(-1) * (  - 8*s12**2*s23*
     +    s24 - 8*s12**2*s23*s34 - 8*s12**2*s24**2 - 16*s12**2*s24*s34
     +     - 8*s12**2*s34**2 )

      LB = LB + Ld1(p1,p23,p4)*S14**(-1)*S23**(-1) * ( 16*s12**3*s34 - 
     +    16*s12**2*s13*s24 + 16*s12**2*s13*s34 + 16*s12**2*s24*s34 + 
     +    16*s12**2*s34**2 - 16*s12*s13**2*s24 - 16*s12*s13*s24**2 - 16
     +    *s12*s13*s24*s34 )

      LB = LB + Ld1(p1,p23,p4)*S14**(-1)*S24**(-1) * ( 16*s12**3*s34 + 
     +    32*s12**2*s13*s34 - 8*s12**2*s23*s34 + 16*s12*s13**2*s34 + 8*
     +    s12*s13*s23*s34 - 8*s12*s23*s34**2 + 16*s13**2*s23*s34 - 8*
     +    s13*s23*s34**2 )

      LB = LB + Ld1(p1,p23,p4)*S14**(-1) * (  - 16*s12**2*s13 + 8*
     +    s12**2*s34 - 16*s12*s13**2 - 8*s12*s13*s23 - 24*s12*s13*s24
     +     + 8*s12*s23*s24 + 8*s12*s23*s34 + 8*s12*s24**2 + 16*s12*s24*
     +    s34 - 16*s13**2*s23 - 16*s13**2*s24 - 24*s13*s23*s24 + 8*s13*
     +    s23*s34 - 24*s13*s24**2 - 16*s13*s24*s34 )

      LB = LB + Ld1(p1,p24,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 24*
     +    s12**3*s24*s34 + 16*s12**2*s24*s34**2 )

      LB = LB + Ld1(p1,p24,p3)*S13**(-1)*S14**(-1) * (  - 8*s12**2*
     +    s23**2 - 8*s12**2*s23*s24 - 16*s12**2*s23*s34 - 8*s12**2*s24*
     +    s34 - 8*s12**2*s34**2 )

      LB = LB + Ld1(p1,p24,p3)*S13**(-1)*S23**(-1) * ( 16*s12**3*s34 + 
     +    32*s12**2*s14*s34 - 8*s12**2*s24*s34 + 16*s12*s14**2*s34 + 8*
     +    s12*s14*s24*s34 - 8*s12*s24*s34**2 + 16*s14**2*s24*s34 - 8*
     +    s14*s24*s34**2 )

      LB = LB + Ld1(p1,p24,p3)*S13**(-1)*S24**(-1) * ( 16*s12**3*s34 - 
     +    16*s12**2*s14*s23 + 16*s12**2*s14*s34 + 16*s12**2*s23*s34 + 
     +    16*s12**2*s34**2 - 16*s12*s14**2*s23 - 16*s12*s14*s23**2 - 16
     +    *s12*s14*s23*s34 )

      LB = LB + Ld1(p1,p24,p3)*S13**(-1) * (  - 16*s12**2*s14 + 8*
     +    s12**2*s34 - 16*s12*s14**2 - 24*s12*s14*s23 - 8*s12*s14*s24
     +     + 8*s12*s23**2 + 8*s12*s23*s24 + 16*s12*s23*s34 + 8*s12*s24*
     +    s34 - 16*s14**2*s23 - 16*s14**2*s24 - 24*s14*s23**2 - 24*s14*
     +    s23*s24 - 16*s14*s23*s34 + 8*s14*s24*s34 )

      LB = LB + Ld1(p2,p1,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**2*s14*s34**2 + 8*s12**2*s34**3 )

      LB = LB + Ld1(p2,p1,p3)*S13**(-1)*S23**(-1) * ( 8*s12**2*s14*s34
     +     - 8*s12**2*s24*s34 )

      LB = LB + Ld1(p2,p1,p3)*S14**(-1)*S23**(-1) * (  - 8*s12**2*s24*
     +    s34 - 8*s12**2*s34**2 + 8*s12*s13*s24**2 - 8*s12*s13*s34**2
     +     - 8*s12*s24**2*s34 - 16*s12*s24*s34**2 - 8*s12*s34**3 + 8*
     +    s13**2*s24**2 + 8*s13**2*s24*s34 + 8*s13*s24**3 + 16*s13*
     +    s24**2*s34 + 8*s13*s24*s34**2 )

      LB = LB + Ld1(p2,p1,p3)*S23**(-1)*S24**(-1) * ( 8*s12**2*s34**2 )

      LB = LB + Ld1(p2,p1,p3)*S23**(-1) * ( 8*s12**2*s34 - 8*s12*s13*
     +    s24 - 8*s12*s13*s34 - 8*s12*s14*s24 - 8*s12*s14*s34 + 8*s12*
     +    s24**2 - 8*s12*s24*s34 - 16*s12*s34**2 + 8*s13*s24**2 + 8*s13
     +    *s24*s34 )

      LB = LB + Ld1(p2,p1,p4)*S13**(-1)*S24**(-1) * (  - 8*s12**2*s23*
     +    s34 - 8*s12**2*s34**2 + 8*s12*s14*s23**2 - 8*s12*s14*s34**2
     +     - 8*s12*s23**2*s34 - 16*s12*s23*s34**2 - 8*s12*s34**3 + 8*
     +    s14**2*s23**2 + 8*s14**2*s23*s34 + 8*s14*s23**3 + 16*s14*
     +    s23**2*s34 + 8*s14*s23*s34**2 )

      LB = LB + Ld1(p2,p1,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**2*s13*s34**2 + 8*s12**2*s34**3 )

      LB = LB + Ld1(p2,p1,p4)*S14**(-1)*S24**(-1) * ( 8*s12**2*s13*s34
     +     - 8*s12**2*s23*s34 )

      LB = LB + Ld1(p2,p1,p4)*S23**(-1)*S24**(-1) * ( 8*s12**2*s34**2 )

      LB = LB + Ld1(p2,p1,p4)*S24**(-1) * ( 8*s12**2*s34 - 8*s12*s13*
     +    s23 - 8*s12*s13*s34 - 8*s12*s14*s23 - 8*s12*s14*s34 + 8*s12*
     +    s23**2 - 8*s12*s23*s34 - 16*s12*s34**2 + 8*s14*s23**2 + 8*s14
     +    *s23*s34 )

      LB = LB + Ld1(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * (  - 16*
     +    s12**2*s34 + 16*s12*s14*s23 + 8*s12*s14*s34 - 16*s12*s23*s34
     +     - 8*s14**2*s23 + 16*s14*s23**2 )

      LB = LB + Ld1(p2,p1,p34)*S14**(-1)*S23**(-1)*S234 * ( 16*s12**2*
     +    s34 - 16*s12*s13*s24 + 8*s12*s13*s34 + 16*s12*s24*s34 + 16*
     +    s12*s34**2 - 8*s13**2*s24 - 16*s13*s24**2 - 16*s13*s24*s34 )

      LB = LB + Ld1(p2,p1,p34)*S14**(-1)*S234 * (  - 32*s12*s13 - 32*
     +    s13**2 - 32*s13*s24 - 48*s13*s34 )

      LB = LB + Ld1(p2,p1,p34)*S23**(-1)*S24**(-1)*S234 * (  - 8*s12*
     +    s34**2 - 16*s13*s34**2 - 8*s14*s34**2 )

      LB = LB + Ld1(p2,p1,p34)*S23**(-1)*S24**(-1) * ( 8*s12*s34**3 + 
     +    16*s13*s34**3 + 8*s14*s34**3 )

      LB = LB + Ld1(p2,p1,p34)*S23**(-1)*S234 * (  - 8*s12*s34 + 8*s13*
     +    s24 - 24*s13*s34 - 16*s14*s34 )

      LB = LB + Ld1(p2,p1,p34)*S23**(-1) * ( 16*s12*s34**2 + 16*s13*s24
     +    *s34 + 40*s13*s34**2 + 16*s14*s24*s34 + 24*s14*s34**2 )

      LB = LB + Ld1(p2,p1,p34)*S24**(-1)*S234 * ( 32*s12*s23 + 24*s12*
     +    s34 - 64*s13*s23 + 16*s13*s34 - 56*s14*s23 + 8*s14*s34 + 32*
     +    s23**2 - 16*s23*s34 )

      LB = LB + Ld1(p2,p1,p34)*S234 * (  - 32*s13 + 16*s23 - 16*s24 - 
     +    16*s34 )

      LB = LB + Ld1(p2,p3,p4)*S13**(-1)*S24**(-1) * (  - 8*s12**3*s34
     +     + 8*s12**2*s14*s23 - 24*s12**2*s14*s34 - 8*s12**2*s23*s34 - 
     +    16*s12**2*s34**2 + 24*s12*s14**2*s23 - 16*s12*s14**2*s34 + 8*
     +    s12*s14*s23**2 - 8*s12*s14*s23*s34 - 32*s12*s14*s34**2 - 16*
     +    s12*s23*s34**2 - 16*s12*s34**3 + 16*s14**3*s23 + 24*s14**2*
     +    s23**2 + 32*s14**2*s23*s34 + 16*s14*s23**2*s34 + 16*s14*s23*
     +    s34**2 )

      LB = LB + Ld1(p2,p3,p4)*S14**(-1)*S24**(-1) * (  - 8*s12**3*s34
     +     - 8*s12**2*s13*s34 )

      LB = LB + Ld1(p2,p3,p4)*S24**(-1) * ( 8*s12**2*s23 - 32*s12**2*
     +    s34 - 8*s12*s13*s23 - 16*s12*s13*s34 + 16*s12*s14*s23 - 32*
     +    s12*s14*s34 - 16*s12*s23*s34 - 32*s12*s34**2 + 16*s14**2*s23
     +     + 16*s14*s23*s34 )

      LB = LB + Ld1(p2,p4,p3)*S13**(-1)*S23**(-1) * (  - 8*s12**3*s34
     +     - 8*s12**2*s14*s34 )

      LB = LB + Ld1(p2,p4,p3)*S14**(-1)*S23**(-1) * (  - 8*s12**3*s34
     +     + 8*s12**2*s13*s24 - 24*s12**2*s13*s34 - 8*s12**2*s24*s34 - 
     +    16*s12**2*s34**2 + 24*s12*s13**2*s24 - 16*s12*s13**2*s34 + 8*
     +    s12*s13*s24**2 - 8*s12*s13*s24*s34 - 32*s12*s13*s34**2 - 16*
     +    s12*s24*s34**2 - 16*s12*s34**3 + 16*s13**3*s24 + 24*s13**2*
     +    s24**2 + 32*s13**2*s24*s34 + 16*s13*s24**2*s34 + 16*s13*s24*
     +    s34**2 )

      LB = LB + Ld1(p2,p4,p3)*S23**(-1) * ( 8*s12**2*s24 - 32*s12**2*
     +    s34 + 16*s12*s13*s24 - 32*s12*s13*s34 - 8*s12*s14*s24 - 16*
     +    s12*s14*s34 - 16*s12*s24*s34 - 32*s12*s34**2 + 16*s13**2*s24
     +     + 16*s13*s24*s34 )

      LB = LB + Ld1(p2,p13,p4)*S13**(-1)*S24**(-1) * ( 16*s12**3*s34 - 
     +    16*s12**2*s14*s23 + 16*s12**2*s14*s34 + 16*s12**2*s23*s34 + 
     +    16*s12**2*s34**2 - 16*s12*s14**2*s23 - 16*s12*s14*s23**2 - 16
     +    *s12*s14*s23*s34 )

      LB = LB + Ld1(p2,p13,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 24*
     +    s12**3*s13*s34 + 16*s12**2*s13*s34**2 )

      LB = LB + Ld1(p2,p13,p4)*S14**(-1)*S24**(-1) * ( 16*s12**3*s34 - 
     +    8*s12**2*s13*s34 + 32*s12**2*s23*s34 + 8*s12*s13*s23*s34 - 8*
     +    s12*s13*s34**2 + 16*s12*s23**2*s34 + 16*s13*s23**2*s34 - 8*
     +    s13*s23*s34**2 )

      LB = LB + Ld1(p2,p13,p4)*S23**(-1)*S24**(-1) * (  - 8*s12**2*s13*
     +    s14 - 8*s12**2*s13*s34 - 8*s12**2*s14**2 - 16*s12**2*s14*s34
     +     - 8*s12**2*s34**2 )

      LB = LB + Ld1(p2,p13,p4)*S24**(-1) * (  - 16*s12**2*s23 + 8*
     +    s12**2*s34 + 8*s12*s13*s14 - 8*s12*s13*s23 + 8*s12*s13*s34 + 
     +    8*s12*s14**2 - 24*s12*s14*s23 + 16*s12*s14*s34 - 16*s12*
     +    s23**2 - 24*s13*s14*s23 - 16*s13*s23**2 + 8*s13*s23*s34 - 24*
     +    s14**2*s23 - 16*s14*s23**2 - 16*s14*s23*s34 )

      LB = LB + Ld1(p2,p14,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 24*
     +    s12**3*s14*s34 + 16*s12**2*s14*s34**2 )

      LB = LB + Ld1(p2,p14,p3)*S13**(-1)*S23**(-1) * ( 16*s12**3*s34 - 
     +    8*s12**2*s14*s34 + 32*s12**2*s24*s34 + 8*s12*s14*s24*s34 - 8*
     +    s12*s14*s34**2 + 16*s12*s24**2*s34 + 16*s14*s24**2*s34 - 8*
     +    s14*s24*s34**2 )

      LB = LB + Ld1(p2,p14,p3)*S14**(-1)*S23**(-1) * ( 16*s12**3*s34 - 
     +    16*s12**2*s13*s24 + 16*s12**2*s13*s34 + 16*s12**2*s24*s34 + 
     +    16*s12**2*s34**2 - 16*s12*s13**2*s24 - 16*s12*s13*s24**2 - 16
     +    *s12*s13*s24*s34 )

      LB = LB + Ld1(p2,p14,p3)*S23**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s13**2 - 8*s12**2*s13*s14 - 16*s12**2*s13*s34 - 8*s12**2*s14*
     +    s34 - 8*s12**2*s34**2 )

      LB = LB + Ld1(p2,p14,p3)*S23**(-1) * (  - 16*s12**2*s24 + 8*
     +    s12**2*s34 + 8*s12*s13**2 + 8*s12*s13*s14 - 24*s12*s13*s24 + 
     +    16*s12*s13*s34 - 8*s12*s14*s24 + 8*s12*s14*s34 - 16*s12*
     +    s24**2 - 24*s13**2*s24 - 24*s13*s14*s24 - 16*s13*s24**2 - 16*
     +    s13*s24*s34 - 16*s14*s24**2 + 8*s14*s24*s34 )

      LB = LB + Ld1(p3,p1,p24)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S234*S124**(-1) * ( 8*s12**4*s34**2 )

      LB = LB + Ld1(p3,p1,p24)*S13**(-1)*S14**(-1)*S23**(-1)*S234*
     + S124**(-1) * (  - 8*s12**3*s34**2 )

      LB = LB + Ld1(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234*
     + S124**(-1) * (  - 8*s12**4*s34 - 48*s12**3*s23**2 - 48*s12**3*
     +    s23*s34 + 8*s12**2*s23**3 + 16*s12**2*s23**2*s34 + 8*s12**2*
     +    s23*s34**2 )

      LB = LB + Ld1(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234 * ( 
     +    32*s12**3*s23 + 32*s12**3*s34 - 16*s12**2*s23**2 + 8*s12*
     +    s23**3 + 8*s12*s23**2*s34 )

      LB = LB + Ld1(p3,p1,p24)*S13**(-1)*S14**(-1)*S234*S124**(-1) * ( 
     +     - 16*s12**3*s23 - 72*s12**3*s34 - 80*s12**2*s23**2 + 16*
     +    s12**2*s23*s24 - 112*s12**2*s23*s34 - 24*s12**2*s24*s34 - 16*
     +    s12**2*s34**2 - 8*s12*s23**3 - 8*s12*s23**2*s34 - 16*s12*s23*
     +    s24*s34 - 8*s12*s24**2*s34 )

      LB = LB + Ld1(p3,p1,p24)*S13**(-1)*S14**(-1)*S234 * ( 32*s12**2*
     +    s23 + 40*s12**2*s34 + 16*s12*s23*s34 + 8*s12*s24*s34 )

      LB = LB + Ld1(p3,p1,p24)*S13**(-1)*S23**(-1)*S24**(-1)*S234*
     + S124**(-1) * ( 8*s12**4*s34 + 24*s12**3*s14*s34 + 24*s12**3*
     +    s34**2 + 24*s12**2*s14**2*s34 + 24*s12**2*s14*s34**2 + 8*s12*
     +    s14**3*s34 + 8*s12*s14**2*s34**2 )

      LB = LB + Ld1(p3,p1,p24)*S13**(-1)*S23**(-1)*S234*S124**(-1) * ( 
     +     - 8*s12**3*s34 )

      LB = LB + Ld1(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*S124**(-1) * ( 
     +     - 16*s12**4 - 24*s12**3*s14 + 8*s12**3*s23 + 16*s12**2*s14*
     +    s23 + 24*s12**2*s14*s34 - 88*s12**2*s23**2 - 80*s12**2*s23*
     +    s34 + 8*s12**2*s34**2 + 8*s12*s14**3 + 8*s12*s14**2*s23 + 16*
     +    s12*s14**2*s34 - 40*s12*s14*s23**2 - 32*s12*s14*s23*s34 + 8*
     +    s12*s14*s34**2 + 8*s12*s23**3 + 16*s12*s23**2*s34 + 8*s12*s23
     +    *s34**2 )

      LB = LB + Ld1(p3,p1,p24)*S13**(-1)*S24**(-1)*S234 * ( 32*s12**3
     +     + 48*s12**2*s14 + 48*s12**2*s23 + 48*s12**2*s34 + 24*s12*
     +    s14**2 + 24*s12*s14*s23 + 24*s12*s14*s34 - 24*s12*s23**2 + 8*
     +    s12*s23*s34 + 8*s14**3 + 8*s14**2*s23 + 8*s14**2*s34 - 8*s14*
     +    s23**2 + 8*s14*s23*s34 + 8*s23**3 + 8*s23**2*s34 )

      LB = LB + Ld1(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * (  - 72*
     +    s12**3 - 128*s12**2*s14 - 48*s12**2*s23 - 32*s12**2*s24 - 128
     +    *s12**2*s34 - 72*s12*s14**2 - 40*s12*s14*s23 - 80*s12*s14*s24
     +     - 72*s12*s14*s34 - 88*s12*s23**2 - 16*s12*s23*s24 - 120*s12*
     +    s23*s34 - 8*s12*s24**2 - 80*s12*s24*s34 - 8*s14**3 - 8*s14**2
     +    *s23 - 24*s14**2*s24 - 8*s14**2*s34 - 24*s14*s23**2 - 8*s14*
     +    s23*s24 - 40*s14*s23*s34 - 24*s14*s24**2 - 24*s14*s24*s34 - 8
     +    *s23**3 - 16*s23**2*s24 - 8*s23**2*s34 - 8*s23*s24**2 - 32*
     +    s23*s24*s34 - 24*s24**2*s34 )

      LB = LB + Ld1(p3,p1,p24)*S13**(-1)*S234 * ( 40*s12**2 + 48*s12*
     +    s14 + 32*s12*s23 + 8*s12*s24 + 48*s12*s34 + 24*s14*s24 + 16*
     +    s23**2 + 8*s23*s24 + 32*s23*s34 + 24*s24*s34 )

      LB = LB + Ld1(p3,p1,p24)*S14**(-1)*S23**(-1)*S24**(-1)*S234*
     + S124**(-1) * ( 8*s12**4*s34 )

      LB = LB + Ld1(p3,p1,p24)*S14**(-1)*S23**(-1)*S234*S124**(-1) * ( 
     +     - 8*s12**3*s13 - 16*s12**3*s34 + 8*s12**2*s13*s24 + 8*s12**2
     +    *s24*s34 )

      LB = LB + Ld1(p3,p1,p24)*S14**(-1)*S24**(-1)*S234*S124**(-1) * ( 
     +     - 16*s12**4 - 8*s12**2*s23**2 - 16*s12**2*s23*s34 - 8*s12**2
     +    *s34**2 )

      LB = LB + Ld1(p3,p1,p24)*S14**(-1)*S24**(-1)*S234 * ( 32*s12**3
     +     - 8*s12*s23**2 - 8*s12*s23*s34 )

      LB = LB + Ld1(p3,p1,p24)*S14**(-1)*S234*S124**(-1) * (  - 80*
     +    s12**3 + 48*s12**2*s23 - 32*s12**2*s24 + 16*s12*s13*s23 + 16*
     +    s12*s13*s34 - 8*s12*s23**2 + 112*s12*s23*s24 - 8*s12*s23*s34
     +     - 16*s12*s24**2 + 32*s12*s24*s34 - 8*s13**2*s24 - 16*s13*
     +    s24**2 + 8*s23**2*s24 + 16*s23*s24**2 )

      LB = LB + Ld1(p3,p1,p24)*S14**(-1)*S234 * ( 40*s12**2 + 8*s12*s24
     +     + 8*s13*s23 - 8*s23**2 - 16*s23*s24 )

      LB = LB + Ld1(p3,p1,p24)*S23**(-1)*S24**(-1)*S234*S124**(-1) * ( 
     +    24*s12**3*s34 + 24*s12**2*s14*s34 + 8*s12*s14**2*s34 )

      LB = LB + Ld1(p3,p1,p24)*S23**(-1)*S234*S124**(-1) * (  - 8*
     +    s12**3 - 32*s12**2*s13 - 32*s12**2*s14 + 8*s12**2*s24 - 32*
     +    s12**2*s34 - 40*s12*s13*s14 - 40*s12*s13*s24 - 40*s12*s14**2
     +     - 40*s12*s14*s24 - 40*s12*s14*s34 - 40*s12*s24*s34 - 8*s13*
     +    s14**2 - 16*s13*s14*s24 - 16*s13*s24**2 - 8*s14**3 - 16*
     +    s14**2*s24 - 8*s14**2*s34 - 16*s14*s24**2 - 16*s14*s24*s34 - 
     +    16*s24**2*s34 )

      LB = LB + Ld1(p3,p1,p24)*S23**(-1)*S234 * ( 8*s12*s13 + 8*s12*s14
     +     + 8*s12*s34 + 16*s13*s24 + 16*s14*s24 + 16*s24*s34 )

      LB = LB + Ld1(p3,p1,p24)*S23**(-1)*S124**(-1) * ( 8*s12**2*s13*
     +    s24 + 16*s12**2*s13*s34 + 8*s12**2*s14*s24 + 16*s12**2*s14*
     +    s34 + 8*s12**2*s24*s34 + 16*s12**2*s34**2 - 8*s12*s13**2*s24
     +     + 8*s12*s13*s14*s24 + 16*s12*s13*s14*s34 + 40*s12*s13*s24**2
     +     + 32*s12*s13*s24*s34 + 16*s12*s14**2*s24 + 16*s12*s14**2*s34
     +     + 40*s12*s14*s24**2 + 56*s12*s14*s24*s34 + 16*s12*s14*s34**2
     +     + 40*s12*s24**2*s34 + 40*s12*s24*s34**2 + 16*s13*s14*s24**2
     +     + 16*s13*s14*s24*s34 + 16*s13*s24**3 + 16*s13*s24**2*s34 + 
     +    16*s14**2*s24**2 + 16*s14**2*s24*s34 + 16*s14*s24**3 + 32*s14
     +    *s24**2*s34 + 16*s14*s24*s34**2 + 16*s24**3*s34 + 16*s24**2*
     +    s34**2 )

      LB = LB + Ld1(p3,p1,p24)*S23**(-1) * (  - 8*s12*s13*s24 - 8*s12*
     +    s13*s34 - 8*s12*s14*s24 - 8*s12*s14*s34 - 8*s12*s24*s34 - 8*
     +    s12*s34**2 - 16*s13*s24**2 - 16*s13*s24*s34 - 16*s14*s24**2
     +     - 16*s14*s24*s34 - 16*s24**2*s34 - 16*s24*s34**2 )

      LB = LB + Ld1(p3,p1,p24)*S24**(-1)*S234*S124**(-1) * (  - 24*
     +    s12**3 + 8*s12*s14**2 - 8*s12*s23**2 - 16*s12*s23*s34 - 8*s12
     +    *s34**2 )

      LB = LB + Ld1(p3,p1,p24)*S24**(-1)*S234 * ( 48*s12**2 + 24*s12*
     +    s14 + 8*s14**2 - 8*s23**2 - 8*s23*s34 )

      LB = LB + Ld1(p3,p1,p24)*S234*S124**(-1) * (  - 152*s12**2 - 96*
     +    s12*s14 + 64*s12*s23 - 80*s12*s24 + 8*s13*s23 - 8*s13*s24 + 8
     +    *s13*s34 - 16*s14**2 + 8*s14*s23 - 24*s14*s24 - 8*s14*s34 + 
     +    40*s23*s24 - 24*s24**2 )

      LB = LB + Ld1(p3,p1,p24)*S234 * ( 48*s12 + 8*s23 + 24*s24 )

      LB = LB + Ld1(p3,p2,p14)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S134*S124**(-1) * ( 8*s12**4*s34**2 )

      LB = LB + Ld1(p3,p2,p14)*S13**(-1)*S14**(-1)*S23**(-1)*S134*
     + S124**(-1) * ( 8*s12**4*s34 + 24*s12**3*s24*s34 + 24*s12**3*
     +    s34**2 + 24*s12**2*s24**2*s34 + 24*s12**2*s24*s34**2 + 8*s12*
     +    s24**3*s34 + 8*s12*s24**2*s34**2 )

      LB = LB + Ld1(p3,p2,p14)*S13**(-1)*S14**(-1)*S24**(-1)*S134*
     + S124**(-1) * ( 8*s12**4*s34 )

      LB = LB + Ld1(p3,p2,p14)*S13**(-1)*S14**(-1)*S134*S124**(-1) * ( 
     +    24*s12**3*s34 + 24*s12**2*s24*s34 + 8*s12*s24**2*s34 )

      LB = LB + Ld1(p3,p2,p14)*S13**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * (  - 8*s12**3*s34**2 )

      LB = LB + Ld1(p3,p2,p14)*S13**(-1)*S23**(-1)*S134*S124**(-1) * ( 
     +     - 8*s12**3*s34 )

      LB = LB + Ld1(p3,p2,p14)*S13**(-1)*S24**(-1)*S134*S124**(-1) * ( 
     +     - 8*s12**3*s23 - 16*s12**3*s34 + 8*s12**2*s14*s23 + 8*s12**2
     +    *s14*s34 )

      LB = LB + Ld1(p3,p2,p14)*S13**(-1)*S134*S124**(-1) * (  - 8*
     +    s12**3 + 8*s12**2*s14 - 32*s12**2*s23 - 32*s12**2*s24 - 32*
     +    s12**2*s34 - 40*s12*s14*s23 - 40*s12*s14*s24 - 40*s12*s14*s34
     +     - 40*s12*s23*s24 - 40*s12*s24**2 - 40*s12*s24*s34 - 16*
     +    s14**2*s23 - 16*s14**2*s24 - 16*s14**2*s34 - 16*s14*s23*s24
     +     - 16*s14*s24**2 - 16*s14*s24*s34 - 8*s23*s24**2 - 8*s24**3
     +     - 8*s24**2*s34 )

      LB = LB + Ld1(p3,p2,p14)*S13**(-1)*S134 * ( 8*s12*s23 + 8*s12*s24
     +     + 8*s12*s34 + 16*s14*s23 + 16*s14*s24 + 16*s14*s34 )

      LB = LB + Ld1(p3,p2,p14)*S13**(-1)*S124**(-1) * ( 8*s12**2*s14*
     +    s23 + 8*s12**2*s14*s24 + 8*s12**2*s14*s34 + 16*s12**2*s23*s34
     +     + 16*s12**2*s24*s34 + 16*s12**2*s34**2 + 40*s12*s14**2*s23
     +     + 40*s12*s14**2*s24 + 40*s12*s14**2*s34 - 8*s12*s14*s23**2
     +     + 8*s12*s14*s23*s24 + 32*s12*s14*s23*s34 + 16*s12*s14*s24**2
     +     + 56*s12*s14*s24*s34 + 40*s12*s14*s34**2 + 16*s12*s23*s24*
     +    s34 + 16*s12*s24**2*s34 + 16*s12*s24*s34**2 + 16*s14**3*s23
     +     + 16*s14**3*s24 + 16*s14**3*s34 + 16*s14**2*s23*s24 + 16*
     +    s14**2*s23*s34 + 16*s14**2*s24**2 + 32*s14**2*s24*s34 + 16*
     +    s14**2*s34**2 + 16*s14*s23*s24*s34 + 16*s14*s24**2*s34 + 16*
     +    s14*s24*s34**2 )

      LB = LB + Ld1(p3,p2,p14)*S13**(-1) * (  - 8*s12*s14*s23 - 8*s12*
     +    s14*s24 - 8*s12*s14*s34 - 8*s12*s23*s34 - 8*s12*s24*s34 - 8*
     +    s12*s34**2 - 16*s14**2*s23 - 16*s14**2*s24 - 16*s14**2*s34 - 
     +    16*s14*s23*s34 - 16*s14*s24*s34 - 16*s14*s34**2 )

      LB = LB + Ld1(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * (  - 8*s12**4*s34 - 48*s12**3*s13**2 - 48*s12**3*
     +    s13*s34 + 8*s12**2*s13**3 + 16*s12**2*s13**2*s34 + 8*s12**2*
     +    s13*s34**2 )

      LB = LB + Ld1(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +    32*s12**3*s13 + 32*s12**3*s34 - 16*s12**2*s13**2 + 8*s12*
     +    s13**3 + 8*s12*s13**2*s34 )

      LB = LB + Ld1(p3,p2,p14)*S14**(-1)*S23**(-1)*S134*S124**(-1) * ( 
     +     - 16*s12**4 + 8*s12**3*s13 - 24*s12**3*s24 - 88*s12**2*
     +    s13**2 + 16*s12**2*s13*s24 - 80*s12**2*s13*s34 + 24*s12**2*
     +    s24*s34 + 8*s12**2*s34**2 + 8*s12*s13**3 - 40*s12*s13**2*s24
     +     + 16*s12*s13**2*s34 + 8*s12*s13*s24**2 - 32*s12*s13*s24*s34
     +     + 8*s12*s13*s34**2 + 8*s12*s24**3 + 16*s12*s24**2*s34 + 8*
     +    s12*s24*s34**2 )

      LB = LB + Ld1(p3,p2,p14)*S14**(-1)*S23**(-1)*S134 * ( 32*s12**3
     +     + 48*s12**2*s13 + 48*s12**2*s24 + 48*s12**2*s34 - 24*s12*
     +    s13**2 + 24*s12*s13*s24 + 8*s12*s13*s34 + 24*s12*s24**2 + 24*
     +    s12*s24*s34 + 8*s13**3 - 8*s13**2*s24 + 8*s13**2*s34 + 8*s13*
     +    s24**2 + 8*s13*s24*s34 + 8*s24**3 + 8*s24**2*s34 )

      LB = LB + Ld1(p3,p2,p14)*S14**(-1)*S24**(-1)*S134*S124**(-1) * ( 
     +     - 16*s12**4 - 8*s12**2*s13**2 - 16*s12**2*s13*s34 - 8*s12**2
     +    *s34**2 )

      LB = LB + Ld1(p3,p2,p14)*S14**(-1)*S24**(-1)*S134 * ( 32*s12**3
     +     - 8*s12*s13**2 - 8*s12*s13*s34 )

      LB = LB + Ld1(p3,p2,p14)*S14**(-1)*S134*S124**(-1) * (  - 24*
     +    s12**3 - 8*s12*s13**2 - 16*s12*s13*s34 + 8*s12*s24**2 - 8*s12
     +    *s34**2 )

      LB = LB + Ld1(p3,p2,p14)*S14**(-1)*S134 * ( 48*s12**2 + 24*s12*
     +    s24 - 8*s13**2 - 8*s13*s34 + 8*s24**2 )

      LB = LB + Ld1(p3,p2,p14)*S23**(-1)*S24**(-1)*S134*S124**(-1) * ( 
     +     - 16*s12**3*s13 - 72*s12**3*s34 - 80*s12**2*s13**2 + 16*
     +    s12**2*s13*s14 - 112*s12**2*s13*s34 - 24*s12**2*s14*s34 - 16*
     +    s12**2*s34**2 - 8*s12*s13**3 - 8*s12*s13**2*s34 - 16*s12*s13*
     +    s14*s34 - 8*s12*s14**2*s34 )

      LB = LB + Ld1(p3,p2,p14)*S23**(-1)*S24**(-1)*S134 * ( 32*s12**2*
     +    s13 + 40*s12**2*s34 + 16*s12*s13*s34 + 8*s12*s14*s34 )

      LB = LB + Ld1(p3,p2,p14)*S23**(-1)*S134*S124**(-1) * (  - 72*
     +    s12**3 - 48*s12**2*s13 - 32*s12**2*s14 - 128*s12**2*s24 - 128
     +    *s12**2*s34 - 88*s12*s13**2 - 16*s12*s13*s14 - 40*s12*s13*s24
     +     - 120*s12*s13*s34 - 8*s12*s14**2 - 80*s12*s14*s24 - 80*s12*
     +    s14*s34 - 72*s12*s24**2 - 72*s12*s24*s34 - 8*s13**3 - 16*
     +    s13**2*s14 - 24*s13**2*s24 - 8*s13**2*s34 - 8*s13*s14**2 - 8*
     +    s13*s14*s24 - 32*s13*s14*s34 - 8*s13*s24**2 - 40*s13*s24*s34
     +     - 24*s14**2*s24 - 24*s14**2*s34 - 24*s14*s24**2 - 24*s14*s24
     +    *s34 - 8*s24**3 - 8*s24**2*s34 )

      LB = LB + Ld1(p3,p2,p14)*S23**(-1)*S134 * ( 40*s12**2 + 32*s12*
     +    s13 + 8*s12*s14 + 48*s12*s24 + 48*s12*s34 + 16*s13**2 + 8*s13
     +    *s14 + 32*s13*s34 + 24*s14*s24 + 24*s14*s34 )

      LB = LB + Ld1(p3,p2,p14)*S24**(-1)*S134*S124**(-1) * (  - 80*
     +    s12**3 + 48*s12**2*s13 - 32*s12**2*s14 - 8*s12*s13**2 + 112*
     +    s12*s13*s14 + 16*s12*s13*s23 - 8*s12*s13*s34 - 16*s12*s14**2
     +     + 32*s12*s14*s34 + 16*s12*s23*s34 + 8*s13**2*s14 + 16*s13*
     +    s14**2 - 16*s14**2*s23 - 8*s14*s23**2 )

      LB = LB + Ld1(p3,p2,p14)*S24**(-1)*S134 * ( 40*s12**2 + 8*s12*s14
     +     - 8*s13**2 - 16*s13*s14 + 8*s13*s23 )

      LB = LB + Ld1(p3,p2,p14)*S134*S124**(-1) * (  - 152*s12**2 + 64*
     +    s12*s13 - 80*s12*s14 - 96*s12*s24 + 40*s13*s14 + 8*s13*s23 + 
     +    8*s13*s24 - 24*s14**2 - 8*s14*s23 - 24*s14*s24 + 8*s23*s34 - 
     +    16*s24**2 - 8*s24*s34 )

      LB = LB + Ld1(p3,p2,p14)*S134 * ( 48*s12 + 8*s13 + 24*s14 )

      LB = LB + Ld1(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1)*S124**(-1)
     +  * (  - 144*s12**4*s14*s34 + 288*s12**4*s34**2 + 16*s12**3*
     +    s14**2*s34 - 320*s12**3*s14*s34**2 + 216*s12**3*s34**3 + 16*
     +    s12**2*s14**3*s34 - 32*s12**2*s14**2*s34**2 - 24*s12**2*s14*
     +    s34**3 + 16*s12**2*s34**4 )

      LB = LB + Ld1(p3,p4,p12)*S13**(-1)*S23**(-1)*S124**(-1) * ( 48*
     +    s12**4*s34 - 160*s12**3*s14*s34 + 80*s12**3*s24*s34 + 280*
     +    s12**3*s34**2 - 24*s12**2*s14*s24*s34 - 104*s12**2*s14*s34**2
     +     + 24*s12**2*s24**2*s34 + 64*s12**2*s24*s34**2 + 64*s12**2*
     +    s34**3 )

      LB = LB + Ld1(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1) * ( 48*
     +    s12**4*s34 + 96*s12**3*s14**2 - 48*s12**3*s14*s23 - 480*
     +    s12**3*s14*s34 + 80*s12**3*s23*s34 + 232*s12**3*s34**2 - 48*
     +    s12**2*s14**3 + 192*s12**2*s14**2*s23 + 272*s12**2*s14**2*s34
     +     - 80*s12**2*s14*s23**2 - 288*s12**2*s14*s23*s34 - 296*s12**2
     +    *s14*s34**2 + 40*s12**2*s23**2*s34 + 96*s12**2*s23*s34**2 + 
     +    72*s12**2*s34**3 - 16*s12*s14**3*s34 + 56*s12*s14**2*s23**2
     +     + 64*s12*s14**2*s23*s34 + 8*s12*s14**2*s34**2 - 40*s12*s14*
     +    s23**3 - 88*s12*s14*s23**2*s34 - 56*s12*s14*s23*s34**2 - 8*
     +    s12*s14*s34**3 + 8*s12*s23**3*s34 + 24*s12*s23**2*s34**2 + 24
     +    *s12*s23*s34**3 + 8*s12*s34**4 + 16*s14**3*s23**2 + 16*s14**3
     +    *s23*s34 - 8*s14**2*s23**3 - 16*s14**2*s23**2*s34 - 8*s14**2*
     +    s23*s34**2 - 8*s14*s23**4 - 24*s14*s23**3*s34 - 24*s14*s23**2
     +    *s34**2 - 8*s14*s23*s34**3 )

      LB = LB + Ld1(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1)*S124**(-1)
     +  * (  - 144*s12**4*s13*s34 + 288*s12**4*s34**2 + 64*s12**3*
     +    s13**2*s34 - 256*s12**3*s13*s34**2 + 104*s12**3*s34**3 + 32*
     +    s12**2*s13**2*s34**2 - 40*s12**2*s13*s34**3 - 16*s12**2*
     +    s34**4 )

      LB = LB + Ld1(p3,p4,p12)*S14**(-1)*S23**(-1)*S124**(-1) * ( 48*
     +    s12**4*s34 + 96*s12**3*s13**2 - 48*s12**3*s13*s24 - 624*
     +    s12**3*s13*s34 + 128*s12**3*s24*s34 + 376*s12**3*s34**2 - 48*
     +    s12**2*s13**3 + 288*s12**2*s13**2*s24 + 272*s12**2*s13**2*s34
     +     - 128*s12**2*s13*s24**2 - 608*s12**2*s13*s24*s34 - 312*
     +    s12**2*s13*s34**2 + 104*s12**2*s24**2*s34 + 176*s12**2*s24*
     +    s34**2 + 56*s12**2*s34**3 - 48*s12*s13**3*s24 - 32*s12*s13**3
     +    *s34 + 232*s12*s13**2*s24**2 + 160*s12*s13**2*s24*s34 + 56*
     +    s12*s13**2*s34**2 - 104*s12*s13*s24**3 - 216*s12*s13*s24**2*
     +    s34 - 104*s12*s13*s24*s34**2 + 8*s12*s13*s34**3 + 24*s12*
     +    s24**3*s34 + 40*s12*s24**2*s34**2 + 8*s12*s24*s34**3 - 8*s12*
     +    s34**4 - 16*s13**3*s24*s34 + 40*s13**2*s24**3 + 48*s13**2*
     +    s24**2*s34 + 8*s13**2*s24*s34**2 - 24*s13*s24**4 - 40*s13*
     +    s24**3*s34 - 8*s13*s24**2*s34**2 + 8*s13*s24*s34**3 )

      LB = LB + Ld1(p3,p4,p12)*S14**(-1)*S24**(-1)*S124**(-1) * ( 48*
     +    s12**4*s34 - 64*s12**3*s13*s34 + 32*s12**3*s23*s34 + 88*
     +    s12**3*s34**2 - 8*s12**2*s13*s23*s34 - 40*s12**2*s13*s34**2
     +     + 8*s12**2*s23**2*s34 + 16*s12**2*s23*s34**2 )

      LB = LB + Ld1(p3,p4,p12)*S23**(-1)*S24**(-1)*S124**(-1) * (  - 
     +    288*s12**4*s34 + 96*s12**3*s13**2 + 192*s12**3*s13*s14 - 288*
     +    s12**3*s13*s34 + 96*s12**3*s14**2 - 336*s12**3*s14*s34 - 1120
     +    *s12**3*s34**2 - 48*s12**2*s13**3 + 272*s12**2*s13**2*s14 + 
     +    280*s12**2*s13**2*s34 + 272*s12**2*s13*s14**2 + 1152*s12**2*
     +    s13*s14*s34 - 80*s12**2*s13*s34**2 - 48*s12**2*s14**3 + 472*
     +    s12**2*s14**2*s34 - 560*s12**2*s14*s34**2 - 208*s12**2*s34**3
     +     - 40*s12*s13**3*s14 - 24*s12*s13**3*s34 + 96*s12*s13**2*
     +    s14**2 + 64*s12*s13**2*s14*s34 + 80*s12*s13**2*s34**2 + 136*
     +    s12*s13*s14**3 + 240*s12*s13*s14**2*s34 + 272*s12*s13*s14*
     +    s34**2 + 48*s12*s13*s34**3 - 24*s12*s14**3*s34 + 80*s12*
     +    s14**2*s34**2 - 96*s12*s14*s34**3 - 8*s13**4*s14 + 8*s13**3*
     +    s14**2 - 40*s13**3*s14*s34 + 40*s13**2*s14**3 + 32*s13**2*
     +    s14**2*s34 - 32*s13**2*s14*s34**2 + 24*s13*s14**4 + 72*s13*
     +    s14**3*s34 + 48*s13*s14**2*s34**2 )

      LB = LB + Ld1(p3,p4,p12)*S23**(-1)*S124**(-1) * ( 48*s12**3*s13
     +     - 48*s12**3*s14 - 48*s12**3*s24 - 832*s12**3*s34 + 448*
     +    s12**2*s13**2 + 352*s12**2*s13*s14 + 16*s12**2*s13*s24 + 232*
     +    s12**2*s13*s34 - 48*s12**2*s14**2 - 128*s12**2*s14*s24 - 248*
     +    s12**2*s14*s34 - 80*s12**2*s24**2 - 504*s12**2*s24*s34 - 920*
     +    s12**2*s34**2 - 96*s12*s13**3 + 408*s12*s13**2*s14 + 552*s12*
     +    s13**2*s24 + 192*s12*s13**2*s34 + 336*s12*s13*s14**2 + 160*
     +    s12*s13*s14*s24 + 376*s12*s13*s14*s34 - 144*s12*s13*s24**2 - 
     +    80*s12*s13*s24*s34 + 128*s12*s13*s34**2 - 8*s12*s14**3 - 40*
     +    s12*s14**2*s24 - 56*s12*s14**2*s34 - 56*s12*s14*s24**2 - 144*
     +    s12*s14*s24*s34 - 80*s12*s14*s34**2 - 24*s12*s24**3 - 72*s12*
     +    s24**2*s34 - 128*s12*s24*s34**2 - 88*s12*s34**3 - 32*s13**3*
     +    s34 + 112*s13**2*s14**2 + 192*s13**2*s14*s24 + 80*s13**2*s14*
     +    s34 + 144*s13**2*s24**2 + 112*s13**2*s24*s34 + 72*s13*s14**3
     +     + 48*s13*s14**2*s24 + 112*s13*s14**2*s34 - 48*s13*s14*s24**2
     +     + 16*s13*s14*s24*s34 + 56*s13*s14*s34**2 - 72*s13*s24**3 - 
     +    80*s13*s24**2*s34 )

      LB = LB + Ld1(p3,p4,p12)*S23**(-1)*S124**(-1) * ( 8*s13*s24*
     +    s34**2 + 16*s13*s34**3 )

      LB = LB + Ld1(p3,p4,p12)*S24**(-1)*S124**(-1) * (  - 48*s12**3*
     +    s13 + 48*s12**3*s14 - 48*s12**3*s23 - 592*s12**3*s34 + 208*
     +    s12**2*s13*s14 - 32*s12**2*s13*s23 - 24*s12**2*s13*s34 + 256*
     +    s12**2*s14**2 + 16*s12**2*s14*s23 + 216*s12**2*s14*s34 - 32*
     +    s12**2*s23**2 - 120*s12**2*s23*s34 - 248*s12**2*s34**2 + 8*
     +    s12*s13**3 + 16*s12*s13**2*s14 + 8*s12*s13**2*s23 + 40*s12*
     +    s13**2*s34 + 72*s12*s13*s14**2 - 32*s12*s13*s14*s23 - 24*s12*
     +    s13*s14*s34 - 8*s12*s13*s23**2 + 16*s12*s13*s23*s34 + 64*s12*
     +    s13*s34**2 + 120*s12*s14**2*s23 + 64*s12*s14**2*s34 - 80*s12*
     +    s14*s23**2 - 144*s12*s14*s23*s34 - 64*s12*s14*s34**2 - 8*s12*
     +    s23**3 - 8*s12*s23**2*s34 + 16*s12*s23*s34**2 + 24*s12*s34**3
     +     - 24*s13**3*s14 + 16*s13**2*s14**2 - 32*s13**2*s14*s23 - 64*
     +    s13**2*s14*s34 + 48*s13*s14**3 + 16*s13*s14**2*s34 - 32*s13*
     +    s14*s23**2 - 80*s13*s14*s23*s34 - 56*s13*s14*s34**2 + 48*
     +    s14**3*s23 + 32*s14**3*s34 - 16*s14**2*s23**2 - 16*s14**2*s23
     +    *s34 - 24*s14*s23**3 - 64*s14*s23**2*s34 - 56*s14*s23*s34**2
     +     - 16*s14*s34**3 )

      LB = LB + Ld1(p3,p12,p4)*S13**(-1)*S24**(-1) * (  - 48*s12**2*
     +    s14**2 - 48*s12**2*s14*s23 - 80*s12*s14**2*s23 + 48*s12*s14*
     +    s23**2 + 8*s14**3*s23 - 16*s14**2*s23**2 + 24*s14*s23**3 )

      LB = LB + Ld1(p3,p12,p4)*S13**(-1) * (  - 48*s12**2*s14 - 16*s12*
     +    s14**2 + 16*s12*s14*s23 - 32*s12*s14*s24 + 8*s14**3 + 40*s14*
     +    s23**2 + 8*s14*s23*s24 - 8*s14*s24**2 )

      LB = LB + Ld1(p3,p12,p4)*S14**(-1)*S23**(-1) * (  - 48*s12**2*
     +    s13**2 - 48*s12**2*s13*s24 - 80*s12*s13**2*s24 + 48*s12*s13*
     +    s24**2 + 8*s13**3*s24 - 16*s13**2*s24**2 + 24*s13*s24**3 )

      LB = LB + Ld1(p3,p12,p4)*S14**(-1) * (  - 48*s12**2*s13 - 16*s12*
     +    s13**2 - 32*s12*s13*s23 + 16*s12*s13*s24 + 8*s13**3 - 8*s13*
     +    s23**2 + 8*s13*s23*s24 + 40*s13*s24**2 )

      LB = LB + Ld1(p3,p12,p4)*S23**(-1)*S24**(-1) * ( 48*s12**2*s13**2
     +     + 96*s12**2*s13*s14 + 48*s12**2*s14**2 - 128*s12*s13**2*s14
     +     - 128*s12*s13*s14**2 - 16*s13**3*s14 - 32*s13**2*s14**2 - 16
     +    *s13*s14**3 )

      LB = LB + Ld1(p3,p12,p4)*S23**(-1) * ( 48*s12**2*s13 + 96*s12**2*
     +    s14 - 48*s12**2*s24 - 64*s12*s13**2 + 16*s12*s13*s24 + 16*s12
     +    *s14**2 + 16*s13**3 - 32*s13**2*s14 - 24*s13**2*s24 - 32*s13*
     +    s14**2 + 8*s13*s14*s24 + 32*s13*s24**2 - 8*s14**2*s24 + 8*
     +    s24**3 )

      LB = LB + Ld1(p3,p12,p4)*S24**(-1) * ( 96*s12**2*s13 + 48*s12**2*
     +    s14 - 48*s12**2*s23 + 16*s12*s13**2 - 64*s12*s14**2 + 16*s12*
     +    s14*s23 - 32*s13**2*s14 - 8*s13**2*s23 - 32*s13*s14**2 + 8*
     +    s13*s14*s23 + 16*s14**3 - 24*s14**2*s23 + 32*s14*s23**2 + 8*
     +    s23**3 )

      LB = LB + Ld1(p3,p12,p4) * (  - 96*s12**2 + 32*s12*s13 + 32*s12*
     +    s14 - 160*s12*s23 - 160*s12*s24 + 16*s13*s14 - 16*s13*s23 + 
     +    16*s13*s24 + 16*s14*s23 - 16*s14*s24 - 32*s23**2 - 80*s23*s24
     +     - 32*s24**2 )

      LB = LB + Ld1(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S234 * ( 8*s12**4*s34**2 )

      LB = LB + Ld1(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S123**(-1)
     + *S234 * (  - 8*s12**4*s34 - 48*s12**3*s24**2 - 48*s12**3*s24*s34
     +     + 8*s12**2*s24**3 + 16*s12**2*s24**2*s34 + 8*s12**2*s24*
     +    s34**2 )

      LB = LB + Ld1(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S234 * ( 
     +    32*s12**3*s24 + 32*s12**3*s34 - 16*s12**2*s24**2 + 8*s12*
     +    s24**3 + 8*s12*s24**2*s34 )

      LB = LB + Ld1(p4,p1,p23)*S13**(-1)*S14**(-1)*S24**(-1)*S123**(-1)
     + *S234 * (  - 8*s12**3*s34**2 )

      LB = LB + Ld1(p4,p1,p23)*S13**(-1)*S14**(-1)*S123**(-1)*S234 * ( 
     +     - 16*s12**3*s24 - 72*s12**3*s34 + 16*s12**2*s23*s24 - 24*
     +    s12**2*s23*s34 - 80*s12**2*s24**2 - 112*s12**2*s24*s34 - 16*
     +    s12**2*s34**2 - 8*s12*s23**2*s34 - 16*s12*s23*s24*s34 - 8*s12
     +    *s24**3 - 8*s12*s24**2*s34 )

      LB = LB + Ld1(p4,p1,p23)*S13**(-1)*S14**(-1)*S234 * ( 32*s12**2*
     +    s24 + 40*s12**2*s34 + 8*s12*s23*s34 + 16*s12*s24*s34 )

      LB = LB + Ld1(p4,p1,p23)*S13**(-1)*S23**(-1)*S24**(-1)*S123**(-1)
     + *S234 * ( 8*s12**4*s34 )

      LB = LB + Ld1(p4,p1,p23)*S13**(-1)*S23**(-1)*S123**(-1)*S234 * ( 
     +     - 16*s12**4 - 8*s12**2*s24**2 - 16*s12**2*s24*s34 - 8*s12**2
     +    *s34**2 )

      LB = LB + Ld1(p4,p1,p23)*S13**(-1)*S23**(-1)*S234 * ( 32*s12**3
     +     - 8*s12*s24**2 - 8*s12*s24*s34 )

      LB = LB + Ld1(p4,p1,p23)*S13**(-1)*S24**(-1)*S123**(-1)*S234 * ( 
     +     - 8*s12**3*s14 - 16*s12**3*s34 + 8*s12**2*s14*s23 + 8*s12**2
     +    *s23*s34 )

      LB = LB + Ld1(p4,p1,p23)*S13**(-1)*S123**(-1)*S234 * (  - 80*
     +    s12**3 - 32*s12**2*s23 + 48*s12**2*s24 + 16*s12*s14*s24 + 16*
     +    s12*s14*s34 - 16*s12*s23**2 + 112*s12*s23*s24 + 32*s12*s23*
     +    s34 - 8*s12*s24**2 - 8*s12*s24*s34 - 8*s14**2*s23 - 16*s14*
     +    s23**2 + 16*s23**2*s24 + 8*s23*s24**2 )

      LB = LB + Ld1(p4,p1,p23)*S13**(-1)*S234 * ( 40*s12**2 + 8*s12*s23
     +     + 8*s14*s24 - 16*s23*s24 - 8*s24**2 )

      LB = LB + Ld1(p4,p1,p23)*S14**(-1)*S23**(-1)*S24**(-1)*S123**(-1)
     + *S234 * ( 8*s12**4*s34 + 24*s12**3*s13*s34 + 24*s12**3*s34**2 + 
     +    24*s12**2*s13**2*s34 + 24*s12**2*s13*s34**2 + 8*s12*s13**3*
     +    s34 + 8*s12*s13**2*s34**2 )

      LB = LB + Ld1(p4,p1,p23)*S14**(-1)*S23**(-1)*S123**(-1)*S234 * ( 
     +     - 16*s12**4 - 24*s12**3*s13 + 8*s12**3*s24 + 16*s12**2*s13*
     +    s24 + 24*s12**2*s13*s34 - 88*s12**2*s24**2 - 80*s12**2*s24*
     +    s34 + 8*s12**2*s34**2 + 8*s12*s13**3 + 8*s12*s13**2*s24 + 16*
     +    s12*s13**2*s34 - 40*s12*s13*s24**2 - 32*s12*s13*s24*s34 + 8*
     +    s12*s13*s34**2 + 8*s12*s24**3 + 16*s12*s24**2*s34 + 8*s12*s24
     +    *s34**2 )

      LB = LB + Ld1(p4,p1,p23)*S14**(-1)*S23**(-1)*S234 * ( 32*s12**3
     +     + 48*s12**2*s13 + 48*s12**2*s24 + 48*s12**2*s34 + 24*s12*
     +    s13**2 + 24*s12*s13*s24 + 24*s12*s13*s34 - 24*s12*s24**2 + 8*
     +    s12*s24*s34 + 8*s13**3 + 8*s13**2*s24 + 8*s13**2*s34 - 8*s13*
     +    s24**2 + 8*s13*s24*s34 + 8*s24**3 + 8*s24**2*s34 )

      LB = LB + Ld1(p4,p1,p23)*S14**(-1)*S24**(-1)*S123**(-1)*S234 * ( 
     +     - 8*s12**3*s34 )

      LB = LB + Ld1(p4,p1,p23)*S14**(-1)*S123**(-1)*S234 * (  - 72*
     +    s12**3 - 128*s12**2*s13 - 32*s12**2*s23 - 48*s12**2*s24 - 128
     +    *s12**2*s34 - 72*s12*s13**2 - 80*s12*s13*s23 - 40*s12*s13*s24
     +     - 72*s12*s13*s34 - 8*s12*s23**2 - 16*s12*s23*s24 - 80*s12*
     +    s23*s34 - 88*s12*s24**2 - 120*s12*s24*s34 - 8*s13**3 - 24*
     +    s13**2*s23 - 8*s13**2*s24 - 8*s13**2*s34 - 24*s13*s23**2 - 8*
     +    s13*s23*s24 - 24*s13*s23*s34 - 24*s13*s24**2 - 40*s13*s24*s34
     +     - 8*s23**2*s24 - 24*s23**2*s34 - 16*s23*s24**2 - 32*s23*s24*
     +    s34 - 8*s24**3 - 8*s24**2*s34 )

      LB = LB + Ld1(p4,p1,p23)*S14**(-1)*S234 * ( 40*s12**2 + 48*s12*
     +    s13 + 8*s12*s23 + 32*s12*s24 + 48*s12*s34 + 24*s13*s23 + 8*
     +    s23*s24 + 24*s23*s34 + 16*s24**2 + 32*s24*s34 )

      LB = LB + Ld1(p4,p1,p23)*S23**(-1)*S24**(-1)*S123**(-1)*S234 * ( 
     +    24*s12**3*s34 + 32*s12**2*s13*s34 + 8*s12**2*s14*s34 + 8*
     +    s12**2*s34**2 + 8*s12*s13**2*s34 + 8*s12*s13*s14*s34 + 8*s12*
     +    s14**2*s34 + 8*s12*s14*s34**2 )

      LB = LB + Ld1(p4,p1,p23)*S23**(-1)*S24**(-1)*S123**(-1) * (  - 8*
     +    s12**2*s13*s34**2 - 8*s12**2*s14*s34**2 - 8*s12**2*s34**3 - 8
     +    *s12*s13*s14*s34**2 - 8*s12*s14**2*s34**2 - 8*s12*s14*s34**3
     +     )

      LB = LB + Ld1(p4,p1,p23)*S23**(-1)*S123**(-1)*S234 * (  - 24*
     +    s12**3 - 8*s12**2*s13 - 8*s12**2*s14 - 8*s12**2*s34 - 8*s12*
     +    s13**2 - 8*s12*s13*s14 + 40*s12*s13*s24 + 24*s12*s13*s34 + 8*
     +    s12*s14**2 + 40*s12*s14*s24 + 48*s12*s14*s34 - 8*s12*s24**2
     +     + 24*s12*s24*s34 + 32*s12*s34**2 + 16*s13**2*s24 + 16*s13**2
     +    *s34 + 16*s13*s14*s24 + 16*s13*s14*s34 - 16*s13*s24**2 - 16*
     +    s13*s24*s34 - 16*s14*s24**2 - 32*s14*s24*s34 - 16*s14*s34**2
     +     - 16*s24**2*s34 - 32*s24*s34**2 - 16*s34**3 )

      LB = LB + Ld1(p4,p1,p23)*S23**(-1)*S123**(-1) * ( 8*s12**2*s13*
     +    s24 + 8*s12**2*s14*s24 + 8*s12**2*s24*s34 + 16*s12*s13**2*s24
     +     + 16*s12*s13**2*s34 + 8*s12*s13*s14*s24 - 40*s12*s13*s24**2
     +     - 64*s12*s13*s24*s34 - 24*s12*s13*s34**2 - 8*s12*s14**2*s24
     +     - 16*s12*s14**2*s34 - 40*s12*s14*s24**2 - 88*s12*s14*s24*s34
     +     - 56*s12*s14*s34**2 - 40*s12*s24**2*s34 - 80*s12*s24*s34**2
     +     - 40*s12*s34**3 - 16*s13**2*s24**2 - 32*s13**2*s24*s34 - 16*
     +    s13**2*s34**2 - 16*s13*s14*s24**2 - 32*s13*s14*s24*s34 - 16*
     +    s13*s14*s34**2 + 16*s13*s24**3 + 32*s13*s24**2*s34 + 16*s13*
     +    s24*s34**2 + 16*s14*s24**3 + 48*s14*s24**2*s34 + 48*s14*s24*
     +    s34**2 + 16*s14*s34**3 + 16*s24**3*s34 + 48*s24**2*s34**2 + 
     +    48*s24*s34**3 + 16*s34**4 )

      LB = LB + Ld1(p4,p1,p23)*S23**(-1)*S234 * ( 48*s12**2 + 32*s12*
     +    s13 + 8*s12*s14 + 8*s12*s34 + 8*s13**2 - 16*s13*s24 - 16*s13*
     +    s34 - 16*s14*s24 - 16*s14*s34 - 8*s24**2 - 24*s24*s34 - 16*
     +    s34**2 )

      LB = LB + Ld1(p4,p1,p23)*S23**(-1) * (  - 8*s12*s13*s24 - 8*s12*
     +    s13*s34 - 8*s12*s14*s24 - 8*s12*s14*s34 - 8*s12*s24*s34 - 8*
     +    s12*s34**2 + 16*s13*s24**2 + 32*s13*s24*s34 + 16*s13*s34**2
     +     + 16*s14*s24**2 + 32*s14*s24*s34 + 16*s14*s34**2 + 16*s24**2
     +    *s34 + 32*s24*s34**2 + 16*s34**3 )

      LB = LB + Ld1(p4,p1,p23)*S24**(-1)*S123**(-1)*S234 * (  - 8*
     +    s12**3 - 24*s12**2*s13 - 24*s12**2*s14 + 8*s12**2*s23 - 24*
     +    s12**2*s34 - 24*s12*s13**2 - 32*s12*s13*s14 - 24*s12*s13*s34
     +     - 8*s12*s14**2 - 8*s12*s14*s34 - 8*s13**3 - 8*s13**2*s14 - 8
     +    *s13**2*s34 )

      LB = LB + Ld1(p4,p1,p23)*S123**(-1)*S234 * (  - 152*s12**2 - 136*
     +    s12*s13 - 40*s12*s14 - 80*s12*s23 + 64*s12*s24 - 40*s12*s34
     +     - 32*s13**2 - 16*s13*s14 - 40*s13*s23 + 24*s13*s24 - 8*s13*
     +    s34 - 24*s14*s23 + 24*s14*s24 + 24*s14*s34 - 24*s23**2 + 40*
     +    s23*s24 - 16*s23*s34 + 16*s24*s34 + 16*s34**2 )

      LB = LB + Ld1(p4,p1,p23)*S234 * ( 48*s12 + 16*s13 + 16*s14 + 24*
     +    s23 + 8*s24 + 16*s34 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S134 * ( 8*s12**4*s34**2 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S14**(-1)*S23**(-1)*S123**(-1)
     + *S134 * ( 8*s12**4*s34 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S14**(-1)*S24**(-1)*S123**(-1)
     + *S134 * ( 8*s12**4*s34 + 24*s12**3*s23*s34 + 24*s12**3*s34**2 + 
     +    24*s12**2*s23**2*s34 + 24*s12**2*s23*s34**2 + 8*s12*s23**3*
     +    s34 + 8*s12*s23**2*s34**2 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S14**(-1)*S123**(-1)*S134 * ( 
     +    24*s12**3*s34 + 32*s12**2*s23*s34 + 8*s12**2*s24*s34 + 8*
     +    s12**2*s34**2 + 8*s12*s23**2*s34 + 8*s12*s23*s24*s34 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S14**(-1)*S123**(-1) * (  - 8*
     +    s12**2*s23*s34**2 - 8*s12**2*s24*s34**2 - 8*s12**2*s34**3 - 8
     +    *s12*s23*s24*s34**2 - 8*s12*s24**2*s34**2 - 8*s12*s24*s34**3
     +     )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*S123**(-1)
     + *S134 * (  - 8*s12**4*s34 - 48*s12**3*s14**2 - 48*s12**3*s14*s34
     +     + 8*s12**2*s14**3 + 16*s12**2*s14**2*s34 + 8*s12**2*s14*
     +    s34**2 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +    32*s12**3*s14 + 32*s12**3*s34 - 16*s12**2*s14**2 + 8*s12*
     +    s14**3 + 8*s12*s14**2*s34 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S23**(-1)*S123**(-1)*S134 * ( 
     +     - 16*s12**4 - 8*s12**2*s14**2 - 16*s12**2*s14*s34 - 8*s12**2
     +    *s34**2 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S23**(-1)*S134 * ( 32*s12**3
     +     - 8*s12*s14**2 - 8*s12*s14*s34 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*S134 * ( 
     +     - 16*s12**4 + 8*s12**3*s14 - 24*s12**3*s23 - 88*s12**2*
     +    s14**2 + 16*s12**2*s14*s23 - 80*s12**2*s14*s34 + 24*s12**2*
     +    s23*s34 + 8*s12**2*s34**2 + 8*s12*s14**3 - 40*s12*s14**2*s23
     +     + 16*s12*s14**2*s34 + 8*s12*s14*s23**2 - 32*s12*s14*s23*s34
     +     + 8*s12*s14*s34**2 + 8*s12*s23**3 + 16*s12*s23**2*s34 + 8*
     +    s12*s23*s34**2 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S24**(-1)*S134 * ( 32*s12**3
     +     + 48*s12**2*s14 + 48*s12**2*s23 + 48*s12**2*s34 - 24*s12*
     +    s14**2 + 24*s12*s14*s23 + 8*s12*s14*s34 + 24*s12*s23**2 + 24*
     +    s12*s23*s34 + 8*s14**3 - 8*s14**2*s23 + 8*s14**2*s34 + 8*s14*
     +    s23**2 + 8*s14*s23*s34 + 8*s23**3 + 8*s23**2*s34 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * (  - 24*
     +    s12**3 - 8*s12**2*s23 - 8*s12**2*s24 - 8*s12**2*s34 - 8*s12*
     +    s14**2 + 40*s12*s14*s23 + 40*s12*s14*s24 + 24*s12*s14*s34 - 8
     +    *s12*s23**2 - 8*s12*s23*s24 + 24*s12*s23*s34 + 8*s12*s24**2
     +     + 48*s12*s24*s34 + 32*s12*s34**2 - 16*s14**2*s23 - 16*s14**2
     +    *s24 - 16*s14**2*s34 + 16*s14*s23**2 + 16*s14*s23*s24 - 16*
     +    s14*s23*s34 - 32*s14*s24*s34 - 32*s14*s34**2 + 16*s23**2*s34
     +     + 16*s23*s24*s34 - 16*s24*s34**2 - 16*s34**3 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S123**(-1) * ( 8*s12**2*s14*
     +    s23 + 8*s12**2*s14*s24 + 8*s12**2*s14*s34 - 40*s12*s14**2*s23
     +     - 40*s12*s14**2*s24 - 40*s12*s14**2*s34 + 16*s12*s14*s23**2
     +     + 8*s12*s14*s23*s24 - 64*s12*s14*s23*s34 - 8*s12*s14*s24**2
     +     - 88*s12*s14*s24*s34 - 80*s12*s14*s34**2 + 16*s12*s23**2*s34
     +     - 24*s12*s23*s34**2 - 16*s12*s24**2*s34 - 56*s12*s24*s34**2
     +     - 40*s12*s34**3 + 16*s14**3*s23 + 16*s14**3*s24 + 16*s14**3*
     +    s34 - 16*s14**2*s23**2 - 16*s14**2*s23*s24 + 32*s14**2*s23*
     +    s34 + 48*s14**2*s24*s34 + 48*s14**2*s34**2 - 32*s14*s23**2*
     +    s34 - 32*s14*s23*s24*s34 + 16*s14*s23*s34**2 + 48*s14*s24*
     +    s34**2 + 48*s14*s34**3 - 16*s23**2*s34**2 - 16*s23*s24*s34**2
     +     + 16*s24*s34**3 + 16*s34**4 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1)*S134 * ( 48*s12**2 + 32*s12*
     +    s23 + 8*s12*s24 + 8*s12*s34 - 8*s14**2 - 16*s14*s23 - 16*s14*
     +    s24 - 24*s14*s34 + 8*s23**2 - 16*s23*s34 - 16*s24*s34 - 16*
     +    s34**2 )

      LB = LB + Ld1(p4,p2,p13)*S13**(-1) * (  - 8*s12*s14*s23 - 8*s12*
     +    s14*s24 - 8*s12*s14*s34 - 8*s12*s23*s34 - 8*s12*s24*s34 - 8*
     +    s12*s34**2 + 16*s14**2*s23 + 16*s14**2*s24 + 16*s14**2*s34 + 
     +    32*s14*s23*s34 + 32*s14*s24*s34 + 32*s14*s34**2 + 16*s23*
     +    s34**2 + 16*s24*s34**2 + 16*s34**3 )

      LB = LB + Ld1(p4,p2,p13)*S14**(-1)*S23**(-1)*S24**(-1)*S123**(-1)
     + *S134 * (  - 8*s12**3*s34**2 )

      LB = LB + Ld1(p4,p2,p13)*S14**(-1)*S23**(-1)*S123**(-1)*S134 * ( 
     +     - 8*s12**3*s24 - 16*s12**3*s34 + 8*s12**2*s13*s24 + 8*s12**2
     +    *s13*s34 )

      LB = LB + Ld1(p4,p2,p13)*S14**(-1)*S24**(-1)*S123**(-1)*S134 * ( 
     +     - 8*s12**3*s34 )

      LB = LB + Ld1(p4,p2,p13)*S14**(-1)*S123**(-1)*S134 * (  - 8*
     +    s12**3 + 8*s12**2*s13 - 24*s12**2*s23 - 24*s12**2*s24 - 24*
     +    s12**2*s34 - 24*s12*s23**2 - 32*s12*s23*s24 - 24*s12*s23*s34
     +     - 8*s12*s24**2 - 8*s12*s24*s34 - 8*s23**3 - 8*s23**2*s24 - 8
     +    *s23**2*s34 )

      LB = LB + Ld1(p4,p2,p13)*S23**(-1)*S24**(-1)*S123**(-1)*S134 * ( 
     +     - 16*s12**3*s14 - 72*s12**3*s34 + 16*s12**2*s13*s14 - 24*
     +    s12**2*s13*s34 - 80*s12**2*s14**2 - 112*s12**2*s14*s34 - 16*
     +    s12**2*s34**2 - 8*s12*s13**2*s34 - 16*s12*s13*s14*s34 - 8*s12
     +    *s14**3 - 8*s12*s14**2*s34 )

      LB = LB + Ld1(p4,p2,p13)*S23**(-1)*S24**(-1)*S134 * ( 32*s12**2*
     +    s14 + 40*s12**2*s34 + 8*s12*s13*s34 + 16*s12*s14*s34 )

      LB = LB + Ld1(p4,p2,p13)*S23**(-1)*S123**(-1)*S134 * (  - 80*
     +    s12**3 - 32*s12**2*s13 + 48*s12**2*s14 - 16*s12*s13**2 + 112*
     +    s12*s13*s14 + 32*s12*s13*s34 - 8*s12*s14**2 + 16*s12*s14*s24
     +     - 8*s12*s14*s34 + 16*s12*s24*s34 + 16*s13**2*s14 - 16*s13**2
     +    *s24 + 8*s13*s14**2 - 8*s13*s24**2 )

      LB = LB + Ld1(p4,p2,p13)*S23**(-1)*S134 * ( 40*s12**2 + 8*s12*s13
     +     - 16*s13*s14 - 8*s14**2 + 8*s14*s24 )

      LB = LB + Ld1(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * (  - 72*
     +    s12**3 - 32*s12**2*s13 - 48*s12**2*s14 - 128*s12**2*s23 - 128
     +    *s12**2*s34 - 8*s12*s13**2 - 16*s12*s13*s14 - 80*s12*s13*s23
     +     - 80*s12*s13*s34 - 88*s12*s14**2 - 40*s12*s14*s23 - 120*s12*
     +    s14*s34 - 72*s12*s23**2 - 72*s12*s23*s34 - 8*s13**2*s14 - 24*
     +    s13**2*s23 - 24*s13**2*s34 - 16*s13*s14**2 - 8*s13*s14*s23 - 
     +    32*s13*s14*s34 - 24*s13*s23**2 - 24*s13*s23*s34 - 8*s14**3 - 
     +    24*s14**2*s23 - 8*s14**2*s34 - 8*s14*s23**2 - 40*s14*s23*s34
     +     - 8*s23**3 - 8*s23**2*s34 )

      LB = LB + Ld1(p4,p2,p13)*S24**(-1)*S134 * ( 40*s12**2 + 8*s12*s13
     +     + 32*s12*s14 + 48*s12*s23 + 48*s12*s34 + 8*s13*s14 + 24*s13*
     +    s23 + 24*s13*s34 + 16*s14**2 + 32*s14*s34 )

      LB = LB + Ld1(p4,p2,p13)*S123**(-1)*S134 * (  - 152*s12**2 - 80*
     +    s12*s13 + 64*s12*s14 - 136*s12*s23 - 40*s12*s24 - 40*s12*s34
     +     - 24*s13**2 + 40*s13*s14 - 40*s13*s23 - 24*s13*s24 - 16*s13*
     +    s34 + 24*s14*s23 + 24*s14*s24 + 16*s14*s34 - 32*s23**2 - 16*
     +    s23*s24 - 8*s23*s34 + 24*s24*s34 + 16*s34**2 )

      LB = LB + Ld1(p4,p2,p13)*S134 * ( 48*s12 + 24*s13 + 8*s14 + 16*
     +    s23 + 16*s24 + 16*s34 )

      LB = LB + Ld1(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1)*S123**(-1)
     +  * (  - 144*s12**4*s14*s34 + 288*s12**4*s34**2 + 64*s12**3*
     +    s14**2*s34 - 256*s12**3*s14*s34**2 + 104*s12**3*s34**3 + 32*
     +    s12**2*s14**2*s34**2 - 40*s12**2*s14*s34**3 - 16*s12**2*
     +    s34**4 )

      LB = LB + Ld1(p4,p3,p12)*S13**(-1)*S23**(-1)*S123**(-1) * ( 48*
     +    s12**4*s34 - 64*s12**3*s14*s34 + 32*s12**3*s24*s34 + 88*
     +    s12**3*s34**2 - 8*s12**2*s14*s24*s34 - 40*s12**2*s14*s34**2
     +     + 8*s12**2*s24**2*s34 + 16*s12**2*s24*s34**2 )

      LB = LB + Ld1(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 48*
     +    s12**4*s34 + 96*s12**3*s14**2 - 48*s12**3*s14*s23 - 624*
     +    s12**3*s14*s34 + 128*s12**3*s23*s34 + 376*s12**3*s34**2 - 48*
     +    s12**2*s14**3 + 288*s12**2*s14**2*s23 + 272*s12**2*s14**2*s34
     +     - 128*s12**2*s14*s23**2 - 608*s12**2*s14*s23*s34 - 312*
     +    s12**2*s14*s34**2 + 104*s12**2*s23**2*s34 + 176*s12**2*s23*
     +    s34**2 + 56*s12**2*s34**3 - 48*s12*s14**3*s23 - 32*s12*s14**3
     +    *s34 + 232*s12*s14**2*s23**2 + 160*s12*s14**2*s23*s34 + 56*
     +    s12*s14**2*s34**2 - 104*s12*s14*s23**3 - 216*s12*s14*s23**2*
     +    s34 - 104*s12*s14*s23*s34**2 + 8*s12*s14*s34**3 + 24*s12*
     +    s23**3*s34 + 40*s12*s23**2*s34**2 + 8*s12*s23*s34**3 - 8*s12*
     +    s34**4 - 16*s14**3*s23*s34 + 40*s14**2*s23**3 + 48*s14**2*
     +    s23**2*s34 + 8*s14**2*s23*s34**2 - 24*s14*s23**4 - 40*s14*
     +    s23**3*s34 - 8*s14*s23**2*s34**2 + 8*s14*s23*s34**3 )

      LB = LB + Ld1(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1)*S123**(-1)
     +  * (  - 144*s12**4*s13*s34 + 288*s12**4*s34**2 + 16*s12**3*
     +    s13**2*s34 - 320*s12**3*s13*s34**2 + 216*s12**3*s34**3 + 16*
     +    s12**2*s13**3*s34 - 32*s12**2*s13**2*s34**2 - 24*s12**2*s13*
     +    s34**3 + 16*s12**2*s34**4 )

      LB = LB + Ld1(p4,p3,p12)*S14**(-1)*S23**(-1)*S123**(-1) * ( 48*
     +    s12**4*s34 + 96*s12**3*s13**2 - 48*s12**3*s13*s24 - 480*
     +    s12**3*s13*s34 + 80*s12**3*s24*s34 + 232*s12**3*s34**2 - 48*
     +    s12**2*s13**3 + 192*s12**2*s13**2*s24 + 272*s12**2*s13**2*s34
     +     - 80*s12**2*s13*s24**2 - 288*s12**2*s13*s24*s34 - 296*s12**2
     +    *s13*s34**2 + 40*s12**2*s24**2*s34 + 96*s12**2*s24*s34**2 + 
     +    72*s12**2*s34**3 - 16*s12*s13**3*s34 + 56*s12*s13**2*s24**2
     +     + 64*s12*s13**2*s24*s34 + 8*s12*s13**2*s34**2 - 40*s12*s13*
     +    s24**3 - 88*s12*s13*s24**2*s34 - 56*s12*s13*s24*s34**2 - 8*
     +    s12*s13*s34**3 + 8*s12*s24**3*s34 + 24*s12*s24**2*s34**2 + 24
     +    *s12*s24*s34**3 + 8*s12*s34**4 + 16*s13**3*s24**2 + 16*s13**3
     +    *s24*s34 - 8*s13**2*s24**3 - 16*s13**2*s24**2*s34 - 8*s13**2*
     +    s24*s34**2 - 8*s13*s24**4 - 24*s13*s24**3*s34 - 24*s13*s24**2
     +    *s34**2 - 8*s13*s24*s34**3 )

      LB = LB + Ld1(p4,p3,p12)*S14**(-1)*S24**(-1)*S123**(-1) * ( 48*
     +    s12**4*s34 - 160*s12**3*s13*s34 + 80*s12**3*s23*s34 + 280*
     +    s12**3*s34**2 - 24*s12**2*s13*s23*s34 - 104*s12**2*s13*s34**2
     +     + 24*s12**2*s23**2*s34 + 64*s12**2*s23*s34**2 + 64*s12**2*
     +    s34**3 )

      LB = LB + Ld1(p4,p3,p12)*S23**(-1)*S24**(-1)*S123**(-1) * (  - 
     +    288*s12**4*s34 + 96*s12**3*s13**2 + 192*s12**3*s13*s14 - 336*
     +    s12**3*s13*s34 + 96*s12**3*s14**2 - 288*s12**3*s14*s34 - 1120
     +    *s12**3*s34**2 - 48*s12**2*s13**3 + 272*s12**2*s13**2*s14 + 
     +    472*s12**2*s13**2*s34 + 272*s12**2*s13*s14**2 + 1152*s12**2*
     +    s13*s14*s34 - 560*s12**2*s13*s34**2 - 48*s12**2*s14**3 + 280*
     +    s12**2*s14**2*s34 - 80*s12**2*s14*s34**2 - 208*s12**2*s34**3
     +     + 136*s12*s13**3*s14 - 24*s12*s13**3*s34 + 96*s12*s13**2*
     +    s14**2 + 240*s12*s13**2*s14*s34 + 80*s12*s13**2*s34**2 - 40*
     +    s12*s13*s14**3 + 64*s12*s13*s14**2*s34 + 272*s12*s13*s14*
     +    s34**2 - 96*s12*s13*s34**3 - 24*s12*s14**3*s34 + 80*s12*
     +    s14**2*s34**2 + 48*s12*s14*s34**3 + 24*s13**4*s14 + 40*s13**3
     +    *s14**2 + 72*s13**3*s14*s34 + 8*s13**2*s14**3 + 32*s13**2*
     +    s14**2*s34 + 48*s13**2*s14*s34**2 - 8*s13*s14**4 - 40*s13*
     +    s14**3*s34 - 32*s13*s14**2*s34**2 )

      LB = LB + Ld1(p4,p3,p12)*S23**(-1)*S123**(-1) * ( 48*s12**3*s13
     +     - 48*s12**3*s14 - 48*s12**3*s24 - 592*s12**3*s34 + 256*
     +    s12**2*s13**2 + 208*s12**2*s13*s14 + 16*s12**2*s13*s24 + 216*
     +    s12**2*s13*s34 - 32*s12**2*s14*s24 - 24*s12**2*s14*s34 - 32*
     +    s12**2*s24**2 - 120*s12**2*s24*s34 - 248*s12**2*s34**2 + 72*
     +    s12*s13**2*s14 + 120*s12*s13**2*s24 + 64*s12*s13**2*s34 + 16*
     +    s12*s13*s14**2 - 32*s12*s13*s14*s24 - 24*s12*s13*s14*s34 - 80
     +    *s12*s13*s24**2 - 144*s12*s13*s24*s34 - 64*s12*s13*s34**2 + 8
     +    *s12*s14**3 + 8*s12*s14**2*s24 + 40*s12*s14**2*s34 - 8*s12*
     +    s14*s24**2 + 16*s12*s14*s24*s34 + 64*s12*s14*s34**2 - 8*s12*
     +    s24**3 - 8*s12*s24**2*s34 + 16*s12*s24*s34**2 + 24*s12*s34**3
     +     + 48*s13**3*s14 + 48*s13**3*s24 + 32*s13**3*s34 + 16*s13**2*
     +    s14**2 + 16*s13**2*s14*s34 - 16*s13**2*s24**2 - 16*s13**2*s24
     +    *s34 - 24*s13*s14**3 - 32*s13*s14**2*s24 - 64*s13*s14**2*s34
     +     - 32*s13*s14*s24**2 - 80*s13*s14*s24*s34 - 56*s13*s14*s34**2
     +     - 24*s13*s24**3 - 64*s13*s24**2*s34 - 56*s13*s24*s34**2 - 16
     +    *s13*s34**3 )

      LB = LB + Ld1(p4,p3,p12)*S24**(-1)*S123**(-1) * (  - 48*s12**3*
     +    s13 + 48*s12**3*s14 - 48*s12**3*s23 - 832*s12**3*s34 - 48*
     +    s12**2*s13**2 + 352*s12**2*s13*s14 - 128*s12**2*s13*s23 - 248
     +    *s12**2*s13*s34 + 448*s12**2*s14**2 + 16*s12**2*s14*s23 + 232
     +    *s12**2*s14*s34 - 80*s12**2*s23**2 - 504*s12**2*s23*s34 - 920
     +    *s12**2*s34**2 - 8*s12*s13**3 + 336*s12*s13**2*s14 - 40*s12*
     +    s13**2*s23 - 56*s12*s13**2*s34 + 408*s12*s13*s14**2 + 160*s12
     +    *s13*s14*s23 + 376*s12*s13*s14*s34 - 56*s12*s13*s23**2 - 144*
     +    s12*s13*s23*s34 - 80*s12*s13*s34**2 - 96*s12*s14**3 + 552*s12
     +    *s14**2*s23 + 192*s12*s14**2*s34 - 144*s12*s14*s23**2 - 80*
     +    s12*s14*s23*s34 + 128*s12*s14*s34**2 - 24*s12*s23**3 - 72*s12
     +    *s23**2*s34 - 128*s12*s23*s34**2 - 88*s12*s34**3 + 72*s13**3*
     +    s14 + 112*s13**2*s14**2 + 48*s13**2*s14*s23 + 112*s13**2*s14*
     +    s34 + 192*s13*s14**2*s23 + 80*s13*s14**2*s34 - 48*s13*s14*
     +    s23**2 + 16*s13*s14*s23*s34 + 56*s13*s14*s34**2 - 32*s14**3*
     +    s34 + 144*s14**2*s23**2 + 112*s14**2*s23*s34 - 72*s14*s23**3
     +     - 80*s14*s23**2*s34 )

      LB = LB + Ld1(p4,p3,p12)*S24**(-1)*S123**(-1) * ( 8*s14*s23*
     +    s34**2 + 16*s14*s34**3 )

      LB = LB + Ld21(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * (  - 8*s12*
     +    s23**2 - 16*s12*s23*s34 - 8*s12*s34**2 )

      LB = LB + Ld21(p1,p2,p34)*S14**(-1)*S23**(-1)*S134 * (  - 8*s12*
     +    s34**2 )

      LB = LB + Ld21(p1,p2,p34)*S14**(-1)*S134 * (  - 8*s12*s23 - 16*
     +    s12*s34 )

      LB = LB + Ld21(p1,p3,p4)*S14**(-1)*S23**(-1) * ( 16*s12*s13**2*
     +    s24 + 16*s12*s13*s24**2 + 16*s12*s13*s24*s34 - 8*s13**2*
     +    s24**2 )

      LB = LB + Ld21(p1,p3,p4)*S14**(-1) * ( 16*s12*s13*s24 )

      LB = LB + Ld21(p1,p4,p3)*S13**(-1)*S24**(-1) * ( 16*s12*s14**2*
     +    s23 + 16*s12*s14*s23**2 + 16*s12*s14*s23*s34 - 8*s14**2*
     +    s23**2 )

      LB = LB + Ld21(p1,p4,p3)*S13**(-1) * ( 16*s12*s14*s23 )

      LB = LB + Ld21(p1,p23,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 8*s12**4*s34**2 - 16*s12**3*s34**3 )

      LB = LB + Ld21(p1,p23,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 24*
     +    s12**4*s24 + 32*s12**4*s34 + 8*s12**3*s24**2 - 16*s12**3*
     +    s34**2 )

      LB = LB + Ld21(p1,p23,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 8*
     +    s12**4*s34 - 8*s12**3*s34**2 )

      LB = LB + Ld21(p1,p23,p4)*S13**(-1)*S14**(-1) * ( 24*s12**4 + 8*
     +    s12**3*s24 - 8*s12**3*s34 )

      LB = LB + Ld21(p1,p23,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**4*s34 - 56*s12**3*s34**2 - 8*s12**2*s14*s34**2 )

      LB = LB + Ld21(p1,p23,p4)*S13**(-1)*S23**(-1) * ( 32*s12**4 - 16*
     +    s12**3*s14 + 8*s12**3*s24 - 48*s12**3*s34 + 8*s12**2*s14*s24
     +     + 8*s12**2*s14*s34 )

      LB = LB + Ld21(p1,p23,p4)*S13**(-1)*S24**(-1) * ( 32*s12**4 - 48*
     +    s12**3*s14 + 40*s12**3*s23 - 8*s12**3*s34 + 32*s12**2*s14**2
     +     + 16*s12**2*s14*s23 - 8*s12**2*s14*s34 - 16*s12**2*s34**2 + 
     +    56*s12*s14**2*s23 + 16*s12*s14**2*s34 + 64*s12*s14*s23**2 - 
     +    56*s12*s14*s23*s34 )

      LB = LB + Ld21(p1,p23,p4)*S13**(-1) * ( 56*s12**3 + 56*s12**2*s14
     +     - 32*s12**2*s23 - 32*s12**2*s24 - 16*s12**2*s34 - 16*s12*
     +    s14**2 + 64*s12*s14*s23 )

      LB = LB + Ld21(p1,p23,p4)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16
     +    *s12**3*s34**2 - 32*s12**2*s13*s34**2 - 16*s12**2*s34**3 - 16
     +    *s12*s13**2*s34**2 - 8*s12*s13*s34**3 )

      LB = LB + Ld21(p1,p23,p4)*S14**(-1)*S23**(-1) * ( 40*s12**3*s24
     +     + 32*s12**3*s34 + 32*s12**2*s13*s24 + 16*s12**2*s13*s34 + 16
     +    *s12**2*s24**2 + 16*s12**2*s24*s34 + 8*s12*s13**2*s24 + 8*s12
     +    *s13*s24**2 + 8*s12*s13*s24*s34 )

      LB = LB + Ld21(p1,p23,p4)*S14**(-1)*S24**(-1) * ( 24*s12**3*s34
     +     + 48*s12**2*s13*s34 + 8*s12**2*s34**2 + 24*s12*s13**2*s34 + 
     +    8*s12*s13*s34**2 )

      LB = LB + Ld21(p1,p23,p4)*S14**(-1) * ( 40*s12**3 + 32*s12**2*s13
     +     + 16*s12**2*s24 + 8*s12*s13**2 + 8*s12*s13*s24 )

      LB = LB + Ld21(p1,p23,p4)*S23**(-1)*S24**(-1) * ( 16*s12**3*s34
     +     + 48*s12**2*s13*s34 + 48*s12**2*s14*s34 - 88*s12**2*s34**2
     +     + 32*s12*s13**2*s34 + 32*s12*s13*s14*s34 - 56*s12*s13*s34**2
     +     + 16*s12*s14*s34**2 + 24*s13*s14*s34**2 )

      LB = LB + Ld21(p1,p23,p4)*S23**(-1) * ( 32*s12**3 + 16*s12**2*s13
     +     + 64*s12**2*s24 + 32*s12*s13*s24 )

      LB = LB + Ld21(p1,p23,p4)*S24**(-1) * ( 32*s12**3 + 56*s12**2*s23
     +     + 72*s12**2*s34 - 16*s12*s13**2 - 16*s12*s13*s14 + 16*s12*
     +    s13*s23 + 80*s12*s13*s34 + 48*s12*s14*s23 - 8*s12*s14*s34 + 
     +    32*s12*s23*s34 - 64*s12*s34**2 - 16*s13**2*s23 + 32*s13**2*
     +    s34 - 16*s13*s14*s23 + 8*s13*s14*s34 + 56*s13*s23*s34 - 40*
     +    s13*s34**2 )

      LB = LB + Ld21(p1,p23,p4) * ( 120*s12**2 + 56*s12*s13 + 32*s12*
     +    s14 + 8*s12*s23 + 8*s12*s24 )

      LB = LB + Ld21(p1,p24,p3)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 8*s12**4*s34**2 - 16*s12**3*s34**3 )

      LB = LB + Ld21(p1,p24,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 8*
     +    s12**4*s34 - 8*s12**3*s34**2 )

      LB = LB + Ld21(p1,p24,p3)*S13**(-1)*S14**(-1)*S24**(-1) * ( 24*
     +    s12**4*s23 + 32*s12**4*s34 + 8*s12**3*s23**2 - 16*s12**3*
     +    s34**2 )

      LB = LB + Ld21(p1,p24,p3)*S13**(-1)*S14**(-1) * ( 24*s12**4 + 8*
     +    s12**3*s23 - 8*s12**3*s34 )

      LB = LB + Ld21(p1,p24,p3)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16
     +    *s12**3*s34**2 - 32*s12**2*s14*s34**2 - 16*s12**2*s34**3 - 16
     +    *s12*s14**2*s34**2 - 8*s12*s14*s34**3 )

      LB = LB + Ld21(p1,p24,p3)*S13**(-1)*S23**(-1) * ( 24*s12**3*s34
     +     + 48*s12**2*s14*s34 + 8*s12**2*s34**2 + 24*s12*s14**2*s34 + 
     +    8*s12*s14*s34**2 )

      LB = LB + Ld21(p1,p24,p3)*S13**(-1)*S24**(-1) * ( 40*s12**3*s23
     +     + 32*s12**3*s34 + 32*s12**2*s14*s23 + 16*s12**2*s14*s34 + 16
     +    *s12**2*s23**2 + 16*s12**2*s23*s34 + 8*s12*s14**2*s23 + 8*s12
     +    *s14*s23**2 + 8*s12*s14*s23*s34 )

      LB = LB + Ld21(p1,p24,p3)*S13**(-1) * ( 40*s12**3 + 32*s12**2*s14
     +     + 16*s12**2*s23 + 8*s12*s14**2 + 8*s12*s14*s23 )

      LB = LB + Ld21(p1,p24,p3)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**4*s34 - 56*s12**3*s34**2 - 8*s12**2*s13*s34**2 )

      LB = LB + Ld21(p1,p24,p3)*S14**(-1)*S23**(-1) * ( 32*s12**4 - 48*
     +    s12**3*s13 + 40*s12**3*s24 - 8*s12**3*s34 + 32*s12**2*s13**2
     +     + 16*s12**2*s13*s24 - 8*s12**2*s13*s34 - 16*s12**2*s34**2 + 
     +    56*s12*s13**2*s24 + 16*s12*s13**2*s34 + 64*s12*s13*s24**2 - 
     +    56*s12*s13*s24*s34 )

      LB = LB + Ld21(p1,p24,p3)*S14**(-1)*S24**(-1) * ( 32*s12**4 - 16*
     +    s12**3*s13 + 8*s12**3*s23 - 48*s12**3*s34 + 8*s12**2*s13*s23
     +     + 8*s12**2*s13*s34 )

      LB = LB + Ld21(p1,p24,p3)*S14**(-1) * ( 56*s12**3 + 56*s12**2*s13
     +     - 32*s12**2*s23 - 32*s12**2*s24 - 16*s12**2*s34 - 16*s12*
     +    s13**2 + 64*s12*s13*s24 )

      LB = LB + Ld21(p1,p24,p3)*S23**(-1)*S24**(-1) * ( 16*s12**3*s34
     +     + 48*s12**2*s13*s34 + 48*s12**2*s14*s34 - 88*s12**2*s34**2
     +     + 32*s12*s13*s14*s34 + 16*s12*s13*s34**2 + 32*s12*s14**2*s34
     +     - 56*s12*s14*s34**2 + 24*s13*s14*s34**2 )

      LB = LB + Ld21(p1,p24,p3)*S23**(-1) * ( 32*s12**3 + 56*s12**2*s24
     +     + 72*s12**2*s34 - 16*s12*s13*s14 + 48*s12*s13*s24 - 8*s12*
     +    s13*s34 - 16*s12*s14**2 + 16*s12*s14*s24 + 80*s12*s14*s34 + 
     +    32*s12*s24*s34 - 64*s12*s34**2 - 16*s13*s14*s24 + 8*s13*s14*
     +    s34 - 16*s14**2*s24 + 32*s14**2*s34 + 56*s14*s24*s34 - 40*s14
     +    *s34**2 )

      LB = LB + Ld21(p1,p24,p3)*S24**(-1) * ( 32*s12**3 + 16*s12**2*s14
     +     + 64*s12**2*s23 + 32*s12*s14*s23 )

      LB = LB + Ld21(p1,p24,p3) * ( 120*s12**2 + 32*s12*s13 + 56*s12*
     +    s14 + 8*s12*s23 + 8*s12*s24 )

      LB = LB + Ld21(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * (  - 8*s12*
     +    s34**2 )

      LB = LB + Ld21(p2,p1,p34)*S14**(-1)*S23**(-1)*S234 * (  - 8*s12*
     +    s13**2 - 16*s12*s13*s34 - 8*s12*s34**2 )

      LB = LB + Ld21(p2,p1,p34)*S24**(-1)*S234 * (  - 8*s12*s13 - 16*
     +    s12*s34 )

      LB = LB + Ld21(p2,p3,p4)*S13**(-1)*S24**(-1) * (  - 8*s14**2*
     +    s23**2 )

      LB = LB + Ld21(p2,p4,p3)*S14**(-1)*S23**(-1) * (  - 8*s13**2*
     +    s24**2 )

      LB = LB + Ld21(p2,p13,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 8*s12**4*s34**2 - 16*s12**3*s34**3 )

      LB = LB + Ld21(p2,p13,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**4*s34 + 24*s12**3*s24*s34 - 56*s12**3*s34**2 + 16*s12**2
     +    *s24*s34**2 )

      LB = LB + Ld21(p2,p13,p4)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16
     +    *s12**3*s34**2 - 32*s12**2*s23*s34**2 - 16*s12**2*s34**3 - 16
     +    *s12*s23**2*s34**2 - 8*s12*s23*s34**3 )

      LB = LB + Ld21(p2,p13,p4)*S13**(-1)*S14**(-1) * ( 40*s12**3*s34
     +     + 72*s12**2*s23*s34 + 72*s12**2*s24*s34 - 64*s12**2*s34**2
     +     + 32*s12*s23**2*s34 + 32*s12*s23*s24*s34 - 32*s12*s23*s34**2
     +     + 40*s12*s24*s34**2 + 24*s23*s24*s34**2 )

      LB = LB + Ld21(p2,p13,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 24*
     +    s12**4*s14 + 32*s12**4*s34 + 8*s12**3*s14**2 - 16*s12**3*
     +    s34**2 )

      LB = LB + Ld21(p2,p13,p4)*S13**(-1)*S23**(-1) * ( 56*s12**4 - 16*
     +    s12**3*s14 - 16*s12**3*s24 - 48*s12**3*s34 + 8*s12**2*s14*s24
     +     + 8*s12**2*s24*s34 )

      LB = LB + Ld21(p2,p13,p4)*S13**(-1)*S24**(-1) * ( 40*s12**3*s14
     +     + 32*s12**3*s34 + 16*s12**2*s14**2 + 32*s12**2*s14*s23 + 16*
     +    s12**2*s14*s34 + 16*s12**2*s23*s34 + 8*s12*s14**2*s23 + 8*s12
     +    *s14*s23**2 + 8*s12*s14*s23*s34 )

      LB = LB + Ld21(p2,p13,p4)*S13**(-1) * ( 80*s12**3 + 16*s12**2*s14
     +     + 40*s12**2*s23 + 8*s12*s14*s23 )

      LB = LB + Ld21(p2,p13,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**4*s34 - 8*s12**3*s34**2 )

      LB = LB + Ld21(p2,p13,p4)*S14**(-1)*S23**(-1) * ( 56*s12**4 + 40*
     +    s12**3*s13 - 48*s12**3*s24 + 40*s12**3*s34 - 8*s12**2*s13*s24
     +     + 32*s12**2*s24**2 - 32*s12**2*s24*s34 + 8*s12**2*s34**2 + 
     +    64*s12*s13**2*s24 + 32*s12*s13*s24**2 - 56*s12*s13*s24*s34 + 
     +    16*s12*s24**2*s34 )

      LB = LB + Ld21(p2,p13,p4)*S14**(-1)*S24**(-1) * ( 24*s12**3*s34
     +     + 48*s12**2*s23*s34 + 8*s12**2*s34**2 + 24*s12*s23**2*s34 + 
     +    8*s12*s23*s34**2 )

      LB = LB + Ld21(p2,p13,p4)*S14**(-1) * ( 56*s12**3 + 56*s12**2*s13
     +     + 96*s12**2*s34 + 16*s12*s13*s23 + 24*s12*s13*s24 + 32*s12*
     +    s13*s34 - 16*s12*s23**2 - 16*s12*s23*s24 + 56*s12*s23*s34 - 
     +    32*s12*s24*s34 - 40*s12*s34**2 - 16*s13*s23**2 - 16*s13*s23*
     +    s24 + 56*s13*s23*s34 + 32*s23**2*s34 + 8*s23*s24*s34 - 40*s23
     +    *s34**2 )

      LB = LB + Ld21(p2,p13,p4)*S23**(-1)*S24**(-1) * ( 24*s12**4 + 8*
     +    s12**3*s14 - 8*s12**3*s34 )

      LB = LB + Ld21(p2,p13,p4)*S23**(-1) * ( 32*s12**3 - 32*s12**2*s13
     +     - 32*s12**2*s14 + 32*s12**2*s24 - 16*s12**2*s34 + 64*s12*s13
     +    *s24 - 16*s12*s24**2 )

      LB = LB + Ld21(p2,p13,p4)*S24**(-1) * ( 40*s12**3 + 16*s12**2*s14
     +     + 32*s12**2*s23 + 8*s12*s14*s23 + 8*s12*s23**2 )

      LB = LB + Ld21(p2,p13,p4) * ( 72*s12**2 + 8*s12*s13 + 8*s12*s14
     +     + 32*s12*s23 + 8*s12*s24 )

      LB = LB + Ld21(p2,p14,p3)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 8*s12**4*s34**2 - 16*s12**3*s34**3 )

      LB = LB + Ld21(p2,p14,p3)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16
     +    *s12**3*s34**2 - 32*s12**2*s24*s34**2 - 16*s12**2*s34**3 - 16
     +    *s12*s24**2*s34**2 - 8*s12*s24*s34**3 )

      LB = LB + Ld21(p2,p14,p3)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**4*s34 + 24*s12**3*s23*s34 - 56*s12**3*s34**2 + 16*s12**2
     +    *s23*s34**2 )

      LB = LB + Ld21(p2,p14,p3)*S13**(-1)*S14**(-1) * ( 40*s12**3*s34
     +     + 72*s12**2*s23*s34 + 72*s12**2*s24*s34 - 64*s12**2*s34**2
     +     + 32*s12*s23*s24*s34 + 40*s12*s23*s34**2 + 32*s12*s24**2*s34
     +     - 32*s12*s24*s34**2 + 24*s23*s24*s34**2 )

      LB = LB + Ld21(p2,p14,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**4*s34 - 8*s12**3*s34**2 )

      LB = LB + Ld21(p2,p14,p3)*S13**(-1)*S23**(-1) * ( 24*s12**3*s34
     +     + 48*s12**2*s24*s34 + 8*s12**2*s34**2 + 24*s12*s24**2*s34 + 
     +    8*s12*s24*s34**2 )

      LB = LB + Ld21(p2,p14,p3)*S13**(-1)*S24**(-1) * ( 56*s12**4 + 40*
     +    s12**3*s14 - 48*s12**3*s23 + 40*s12**3*s34 - 8*s12**2*s14*s23
     +     + 32*s12**2*s23**2 - 32*s12**2*s23*s34 + 8*s12**2*s34**2 + 
     +    64*s12*s14**2*s23 + 32*s12*s14*s23**2 - 56*s12*s14*s23*s34 + 
     +    16*s12*s23**2*s34 )

      LB = LB + Ld21(p2,p14,p3)*S13**(-1) * ( 56*s12**3 + 56*s12**2*s14
     +     + 96*s12**2*s34 + 24*s12*s14*s23 + 16*s12*s14*s24 + 32*s12*
     +    s14*s34 - 16*s12*s23*s24 - 32*s12*s23*s34 - 16*s12*s24**2 + 
     +    56*s12*s24*s34 - 40*s12*s34**2 - 16*s14*s23*s24 - 16*s14*
     +    s24**2 + 56*s14*s24*s34 + 8*s23*s24*s34 + 32*s24**2*s34 - 40*
     +    s24*s34**2 )

      LB = LB + Ld21(p2,p14,p3)*S14**(-1)*S23**(-1)*S24**(-1) * ( 24*
     +    s12**4*s13 + 32*s12**4*s34 + 8*s12**3*s13**2 - 16*s12**3*
     +    s34**2 )

      LB = LB + Ld21(p2,p14,p3)*S14**(-1)*S23**(-1) * ( 40*s12**3*s13
     +     + 32*s12**3*s34 + 16*s12**2*s13**2 + 32*s12**2*s13*s24 + 16*
     +    s12**2*s13*s34 + 16*s12**2*s24*s34 + 8*s12*s13**2*s24 + 8*s12
     +    *s13*s24**2 + 8*s12*s13*s24*s34 )

      LB = LB + Ld21(p2,p14,p3)*S14**(-1)*S24**(-1) * ( 56*s12**4 - 16*
     +    s12**3*s13 - 16*s12**3*s23 - 48*s12**3*s34 + 8*s12**2*s13*s23
     +     + 8*s12**2*s23*s34 )

      LB = LB + Ld21(p2,p14,p3)*S14**(-1) * ( 80*s12**3 + 16*s12**2*s13
     +     + 40*s12**2*s24 + 8*s12*s13*s24 )

      LB = LB + Ld21(p2,p14,p3)*S23**(-1)*S24**(-1) * ( 24*s12**4 + 8*
     +    s12**3*s13 - 8*s12**3*s34 )

      LB = LB + Ld21(p2,p14,p3)*S23**(-1) * ( 40*s12**3 + 16*s12**2*s13
     +     + 32*s12**2*s24 + 8*s12*s13*s24 + 8*s12*s24**2 )

      LB = LB + Ld21(p2,p14,p3)*S24**(-1) * ( 32*s12**3 - 32*s12**2*s13
     +     - 32*s12**2*s14 + 32*s12**2*s23 - 16*s12**2*s34 + 64*s12*s14
     +    *s23 - 16*s12*s23**2 )

      LB = LB + Ld21(p2,p14,p3) * ( 72*s12**2 + 8*s12*s13 + 8*s12*s14
     +     + 8*s12*s23 + 32*s12*s24 )

      LB = LB + Ld21(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234 * ( 
     +     - 24*s12**3*s23 - 24*s12**3*s34 )

      LB = LB + Ld21(p3,p1,p24)*S13**(-1)*S14**(-1)*S234 * (  - 24*
     +    s12**2*s23 - 24*s12**2*s34 )

      LB = LB + Ld21(p3,p1,p24)*S13**(-1)*S24**(-1)*S234 * (  - 24*
     +    s12**3 - 24*s12**2*s14 - 24*s12**2*s23 - 24*s12**2*s34 )

      LB = LB + Ld21(p3,p1,p24)*S13**(-1)*S234 * (  - 24*s12**2 - 24*
     +    s12*s14 - 24*s12*s23 - 24*s12*s34 )

      LB = LB + Ld21(p3,p1,p24)*S14**(-1)*S23**(-1)*S234*S124**(-1)
     +  * ( 8*s12**3*s13 + 8*s12**3*s34 + 16*s12**2*s13*s24 + 16*s12**2
     +    *s24*s34 + 8*s12*s13*s24**2 + 8*s12*s24**2*s34 )

      LB = LB + Ld21(p3,p1,p24)*S14**(-1)*S24**(-1)*S234*S124**(-1)
     +  * ( 8*s12**4 - 16*s12**3*s23 - 16*s12**3*s34 )

      LB = LB + Ld21(p3,p1,p24)*S14**(-1)*S24**(-1)*S234 * (  - 24*
     +    s12**3 )

      LB = LB + Ld21(p3,p1,p24)*S14**(-1)*S234*S124**(-1) * ( 32*s12**3
     +     + 16*s12**2*s13 - 32*s12**2*s23 + 40*s12**2*s24 - 32*s12**2*
     +    s34 + 32*s12*s13*s24 - 16*s12*s23*s24 + 16*s12*s24**2 - 16*
     +    s12*s24*s34 + 16*s13*s24**2 )

      LB = LB + Ld21(p3,p1,p24)*S14**(-1)*S234 * (  - 24*s12**2 )

      LB = LB + Ld21(p3,p1,p24)*S23**(-1)*S234*S124**(-1) * ( 8*s12**3
     +     + 16*s12**2*s24 + 8*s12*s24**2 )

      LB = LB + Ld21(p3,p1,p24)*S23**(-1)*S124**(-1) * (  - 8*s12**2*
     +    s13**2 - 8*s12**2*s13*s14 - 8*s12**2*s13*s34 - 16*s12*s13**2*
     +    s24 - 16*s12*s13*s14*s24 - 16*s12*s13*s24*s34 - 8*s13**2*
     +    s24**2 - 8*s13*s14*s24**2 - 8*s13*s24**2*s34 )

      LB = LB + Ld21(p3,p1,p24)*S24**(-1)*S234*S124**(-1) * ( 8*s12**3
     +     - 16*s12**2*s23 - 16*s12**2*s34 )

      LB = LB + Ld21(p3,p1,p24)*S24**(-1)*S234 * (  - 24*s12**2 )

      LB = LB + Ld21(p3,p1,p24)*S234*S124**(-1) * ( 24*s12**2 - 32*s12*
     +    s23 + 24*s12*s24 - 32*s12*s34 - 16*s23*s24 + 8*s24**2 - 16*
     +    s24*s34 )

      LB = LB + Ld21(p3,p1,p24)*S234 * (  - 24*s12 )

      LB = LB + Ld21(p3,p2,p14)*S13**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 8*s12**3*s23 + 8*s12**3*s34 + 16*s12**2*s14*s23 + 16*s12**2
     +    *s14*s34 + 8*s12*s14**2*s23 + 8*s12*s14**2*s34 )

      LB = LB + Ld21(p3,p2,p14)*S13**(-1)*S134*S124**(-1) * ( 8*s12**3
     +     + 16*s12**2*s14 + 8*s12*s14**2 )

      LB = LB + Ld21(p3,p2,p14)*S13**(-1)*S124**(-1) * (  - 8*s12**2*
     +    s23**2 - 8*s12**2*s23*s24 - 8*s12**2*s23*s34 - 16*s12*s14*
     +    s23**2 - 16*s12*s14*s23*s24 - 16*s12*s14*s23*s34 - 8*s14**2*
     +    s23**2 - 8*s14**2*s23*s24 - 8*s14**2*s23*s34 )

      LB = LB + Ld21(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +     - 24*s12**3*s13 - 24*s12**3*s34 )

      LB = LB + Ld21(p3,p2,p14)*S14**(-1)*S23**(-1)*S134 * (  - 24*
     +    s12**3 - 24*s12**2*s13 - 24*s12**2*s24 - 24*s12**2*s34 )

      LB = LB + Ld21(p3,p2,p14)*S14**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 8*s12**4 - 16*s12**3*s13 - 16*s12**3*s34 )

      LB = LB + Ld21(p3,p2,p14)*S14**(-1)*S24**(-1)*S134 * (  - 24*
     +    s12**3 )

      LB = LB + Ld21(p3,p2,p14)*S14**(-1)*S134*S124**(-1) * ( 8*s12**3
     +     - 16*s12**2*s13 - 16*s12**2*s34 )

      LB = LB + Ld21(p3,p2,p14)*S14**(-1)*S134 * (  - 24*s12**2 )

      LB = LB + Ld21(p3,p2,p14)*S23**(-1)*S24**(-1)*S134 * (  - 24*
     +    s12**2*s13 - 24*s12**2*s34 )

      LB = LB + Ld21(p3,p2,p14)*S23**(-1)*S134 * (  - 24*s12**2 - 24*
     +    s12*s13 - 24*s12*s24 - 24*s12*s34 )

      LB = LB + Ld21(p3,p2,p14)*S24**(-1)*S134*S124**(-1) * ( 32*s12**3
     +     - 32*s12**2*s13 + 40*s12**2*s14 + 16*s12**2*s23 - 32*s12**2*
     +    s34 - 16*s12*s13*s14 + 16*s12*s14**2 + 32*s12*s14*s23 - 16*
     +    s12*s14*s34 + 16*s14**2*s23 )

      LB = LB + Ld21(p3,p2,p14)*S24**(-1)*S134 * (  - 24*s12**2 )

      LB = LB + Ld21(p3,p2,p14)*S134*S124**(-1) * ( 24*s12**2 - 32*s12*
     +    s13 + 24*s12*s14 - 32*s12*s34 - 16*s13*s14 + 8*s14**2 - 16*
     +    s14*s34 )

      LB = LB + Ld21(p3,p2,p14)*S134 * (  - 24*s12 )

      LB = LB + Ld21(p3,p4,p1)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 8*
     +    s12**3*s34**2 )

      LB = LB + Ld21(p3,p4,p1)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s34**2 - 8*s12**2*s23*s34**2 - 8*s12**2*s34**3 )

      LB = LB + Ld21(p3,p4,p1)*S13**(-1)*S14**(-1) * (  - 8*s12**2*
     +    s34**2 )

      LB = LB + Ld21(p3,p4,p1)*S13**(-1)*S24**(-1) * ( 16*s12**2*s23*
     +    s34 - 8*s12**2*s34**2 - 8*s12*s14*s23**2 - 8*s14**2*s23**2 - 
     +    8*s14*s23**3 )

      LB = LB + Ld21(p3,p4,p1)*S13**(-1) * ( 16*s12**2*s34 - 8*s12*s14*
     +    s23 - 8*s14*s23**2 )

      LB = LB + Ld21(p3,p4,p2)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s34**2 )

      LB = LB + Ld21(p3,p4,p2)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s34**2 - 8*s12**2*s13*s34**2 - 8*s12**2*s34**3 )

      LB = LB + Ld21(p3,p4,p2)*S14**(-1)*S23**(-1) * ( 16*s12**2*s13*
     +    s34 - 8*s12**2*s34**2 - 8*s12*s13**2*s24 + 16*s12*s13**2*s34
     +     + 16*s12*s13*s24*s34 + 16*s12*s13*s34**2 - 8*s13**3*s24 - 8*
     +    s13**2*s24**2 )

      LB = LB + Ld21(p3,p4,p2)*S23**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s34**2 )

      LB = LB + Ld21(p3,p4,p2)*S23**(-1) * ( 16*s12**2*s34 - 8*s12*s13*
     +    s24 + 16*s12*s13*s34 - 8*s13**2*s24 )

      LB = LB + Ld21(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * ( 144*s12**4*s14*s34 - 80*s12**4*s34**2 + 96*s12**3
     +    *s14**2*s34 - 96*s12**3*s14*s34**2 + 32*s12**2*s14**3*s34 - 
     +    96*s12**2*s14**2*s34**2 - 32*s12*s14**3*s34**2 )

      LB = LB + Ld21(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * ( 144*s12**4*s13*s34 - 80*s12**4*s34**2 - 48*s12**3
     +    *s13**2*s34 + 80*s12**3*s13*s34**2 - 16*s12**3*s34**3 )

      LB = LB + Ld21(p3,p4,p12)*S23**(-1)*S24**(-1)*S124**(-1) * ( 288*
     +    s12**4*s34 + 96*s12**3*s13**2 + 192*s12**3*s13*s14 - 512*
     +    s12**3*s13*s34 + 96*s12**3*s14**2 - 368*s12**3*s14*s34 + 224*
     +    s12**3*s34**2 + 64*s12**2*s13**2*s34 + 144*s12**2*s13*s14*s34
     +     - 112*s12**2*s13*s34**2 - 64*s12**2*s14**2*s34 )

      LB = LB + Ld21(p3,p12,p4)*S13**(-1)*S24**(-1) * (  - 48*s12*
     +    s14**2*s23 + 16*s14**3*s23 - 32*s14**2*s23**2 - 32*s14**2*s23
     +    *s34 )

      LB = LB + Ld21(p3,p12,p4)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 48
     +    *s12**2*s13**2*s34 - 32*s12*s13**2*s34**2 )

      LB = LB + Ld21(p3,p12,p4)*S14**(-1)*S23**(-1) * ( 48*s12*s13**3
     +     - 48*s12*s13**2*s24 - 128*s12*s13**2*s34 - 16*s13**4 + 16*
     +    s13**3*s24 + 16*s13**3*s34 - 16*s13**2*s24**2 - 48*s13**2*s24
     +    *s34 - 16*s13**2*s34**2 )

      LB = LB + Ld21(p3,p12,p4)*S14**(-1)*S24**(-1) * (  - 16*s12*
     +    s13**2*s34 )

      LB = LB + Ld21(p3,p12,p4)*S14**(-1) * (  - 32*s13**3 - 16*s13**2*
     +    s23 )

      LB = LB + Ld21(p3,p12,p4)*S23**(-1)*S24**(-1) * ( 48*s12**2*s13*
     +    s34 + 96*s12**2*s14*s34 + 96*s12*s13**3 - 16*s12*s13**2*s34
     +     - 96*s12*s13*s14**2 - 112*s12*s13*s14*s34 + 96*s12*s13*
     +    s34**2 + 48*s12*s14*s34**2 + 32*s13**4 + 32*s13**3*s14 - 48*
     +    s13**3*s34 - 32*s13**2*s14**2 - 16*s13**2*s14*s34 + 32*s13**2
     +    *s34**2 - 32*s13*s14**3 + 32*s13*s14**2*s34 - 48*s13*s14*
     +    s34**2 )

      LB = LB + Ld21(p3,p12,p4)*S23**(-1) * (  - 48*s12*s13*s14 - 48*
     +    s12*s13*s24 + 32*s12*s14*s34 + 48*s13**3 + 48*s13**2*s14 - 16
     +    *s13**2*s24 - 64*s13**2*s34 - 16*s13*s14**2 - 32*s13*s14*s24
     +     - 48*s13*s14*s34 - 16*s13*s24**2 + 16*s13*s34**2 )

      LB = LB + Ld21(p3,p12,p4)*S24**(-1) * ( 144*s12*s13**2 + 96*s12*
     +    s13*s23 + 112*s12*s13*s34 - 144*s12*s14**2 + 48*s12*s14*s23
     +     + 80*s12*s14*s34 + 48*s13**3 - 16*s13**2*s14 + 48*s13**2*s23
     +     - 16*s13**2*s34 - 80*s13*s14**2 - 32*s13*s14*s23 + 48*s13*
     +    s14*s34 + 32*s13*s23**2 + 48*s13*s23*s34 + 16*s13*s34**2 - 16
     +    *s14**3 - 64*s14**2*s23 + 48*s14**2*s34 + 48*s14*s23*s34 )

      LB = LB + Ld21(p3,p12,p4) * ( 32*s13**2 + 64*s13*s14 + 16*s13*s23
     +     + 32*s14*s23 )

      LB = LB + Ld21(p3,p14,p2)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 8*s12**3*s34**3 + 8*s12**2*s34**4 )

      LB = LB + Ld21(p3,p14,p2)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**2*s34**3 + 16*s12*s24*s34**3 + 8*s12*s34**4 )

      LB = LB + Ld21(p3,p14,p2)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16
     +    *s12**3*s34**2 - 40*s12**2*s23*s34**2 + 32*s12**2*s34**3 - 16
     +    *s12*s23*s34**3 )

      LB = LB + Ld21(p3,p14,p2)*S13**(-1)*S14**(-1) * (  - 40*s12**2*
     +    s34**2 - 32*s12*s23*s34**2 - 32*s12*s24*s34**2 + 32*s12*
     +    s34**3 - 24*s23*s34**3 )

      LB = LB + Ld21(p3,p14,p2)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s34**2 )

      LB = LB + Ld21(p3,p14,p2)*S13**(-1)*S23**(-1) * (  - 24*s12**2*
     +    s34**2 - 24*s12*s24*s34**2 - 8*s12*s34**3 )

      LB = LB + Ld21(p3,p14,p2)*S13**(-1)*S24**(-1) * (  - 56*s12**3*
     +    s34 + 32*s12**2*s14*s23 - 16*s12**2*s14*s34 - 64*s12**2*
     +    s34**2 + 24*s12*s14**2*s23 - 32*s12*s14*s23**2 - 40*s12*s14*
     +    s23*s34 + 24*s12*s14*s34**2 + 16*s12*s23**2*s34 + 48*s12*s23*
     +    s34**2 - 32*s14**2*s23**2 + 32*s14**2*s23*s34 - 8*s14*s23*
     +    s34**2 + 8*s23**2*s34**2 )

      LB = LB + Ld21(p3,p14,p2)*S13**(-1) * (  - 16*s12*s14*s23 - 40*
     +    s12*s14*s34 + 48*s12*s23*s34 + 32*s12*s24*s34 - 24*s12*s34**2
     +     - 16*s14**2*s23 + 48*s14*s23*s34 + 32*s14*s24*s34 - 64*s14*
     +    s34**2 - 32*s24*s34**2 + 40*s34**3 )

      LB = LB + Ld21(p3,p14,p2)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 24
     +    *s12**3*s13**2 - 56*s12**3*s13*s34 - 40*s12**3*s34**2 - 8*
     +    s12**2*s13**3 - 8*s12**2*s13**2*s34 + 16*s12**2*s13*s34**2 + 
     +    24*s12**2*s34**3 )

      LB = LB + Ld21(p3,p14,p2)*S14**(-1)*S23**(-1) * (  - 16*s12**2*
     +    s13**2 - 16*s12**2*s13*s34 + 16*s12**2*s34**2 - 8*s12*s13**3
     +     - 16*s12*s13**2*s24 - 24*s12*s13**2*s34 - 16*s12*s13*s24*s34
     +     - 16*s12*s13*s34**2 + 16*s12*s24*s34**2 + 8*s12*s34**3 )

      LB = LB + Ld21(p3,p14,p2)*S14**(-1)*S24**(-1) * (  - 56*s12**3*
     +    s13 - 72*s12**3*s34 + 16*s12**2*s13**2 + 16*s12**2*s13*s23 + 
     +    64*s12**2*s13*s34 - 8*s12**2*s23*s34 + 80*s12**2*s34**2 - 8*
     +    s12*s13**2*s23 - 16*s12*s13*s23*s34 - 16*s12*s23*s34**2 )

      LB = LB + Ld21(p3,p14,p2)*S14**(-1) * (  - 24*s12**2*s13 - 48*
     +    s12**2*s34 - 32*s12*s13**2 - 16*s12*s13*s23 - 16*s12*s13*s24
     +     - 32*s12*s13*s34 - 32*s12*s23*s34 - 32*s12*s24*s34 + 32*s12*
     +    s34**2 + 8*s13**2*s23 - 24*s23*s34**2 )

      LB = LB + Ld21(p3,p14,p2)*S23**(-1)*S24**(-1) * (  - 24*s12**3*
     +    s13 - 32*s12**3*s34 - 8*s12**2*s13**2 + 16*s12**2*s34**2 )

      LB = LB + Ld21(p3,p14,p2)*S23**(-1) * (  - 16*s12**2*s13 - 32*
     +    s12**2*s34 - 8*s12*s13**2 - 16*s12*s13*s24 - 16*s12*s13*s34
     +     - 32*s12*s24*s34 - 8*s12*s34**2 )

      LB = LB + Ld21(p3,p14,p2)*S24**(-1) * (  - 56*s12**3 - 32*s12**2*
     +    s13 - 40*s12**2*s14 + 32*s12**2*s23 - 72*s12**2*s34 + 24*s12*
     +    s13**2 + 24*s12*s13*s14 - 16*s12*s13*s23 + 32*s12*s13*s34 - 8
     +    *s12*s14*s23 + 24*s12*s14*s34 - 16*s12*s23**2 + 32*s12*s23*
     +    s34 + 8*s12*s34**2 - 24*s13*s14*s23 + 8*s13*s23**2 - 24*
     +    s14**2*s23 - 8*s14*s23**2 + 8*s14*s23*s34 - 8*s23**2*s34 )

      LB = LB + Ld21(p3,p14,p2) * (  - 40*s12*s13 - 16*s12*s14 - 16*s12
     +    *s23 - 48*s12*s34 - 24*s13**2 - 24*s13*s14 - 8*s13*s23 - 16*
     +    s13*s24 - 16*s13*s34 - 16*s14*s23 - 48*s14*s34 - 16*s23*s34
     +     - 32*s24*s34 + 40*s34**2 )

      LB = LB + Ld21(p3,p24,p1)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 8*s12**3*s34**3 + 8*s12**2*s34**4 )

      LB = LB + Ld21(p3,p24,p1)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 8*
     +    s12**3*s34**2 )

      LB = LB + Ld21(p3,p24,p1)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 24
     +    *s12**3*s23**2 - 56*s12**3*s23*s34 - 40*s12**3*s34**2 - 8*
     +    s12**2*s23**3 - 8*s12**2*s23**2*s34 + 16*s12**2*s23*s34**2 + 
     +    24*s12**2*s34**3 )

      LB = LB + Ld21(p3,p24,p1)*S13**(-1)*S14**(-1) * (  - 24*s12**3*
     +    s23 - 32*s12**3*s34 - 8*s12**2*s23**2 + 16*s12**2*s34**2 )

      LB = LB + Ld21(p3,p24,p1)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**2*s34**3 + 16*s12*s14*s34**3 + 8*s12*s34**4 )

      LB = LB + Ld21(p3,p24,p1)*S13**(-1)*S23**(-1) * (  - 24*s12**2*
     +    s34**2 - 24*s12*s14*s34**2 - 8*s12*s34**3 )

      LB = LB + Ld21(p3,p24,p1)*S13**(-1)*S24**(-1) * (  - 16*s12**2*
     +    s23**2 - 16*s12**2*s23*s34 + 16*s12**2*s34**2 - 16*s12*s14*
     +    s23**2 - 16*s12*s14*s23*s34 + 16*s12*s14*s34**2 - 8*s12*
     +    s23**3 - 24*s12*s23**2*s34 - 16*s12*s23*s34**2 + 8*s12*s34**3
     +     )

      LB = LB + Ld21(p3,p24,p1)*S13**(-1) * (  - 16*s12**2*s23 - 32*
     +    s12**2*s34 - 16*s12*s14*s23 - 32*s12*s14*s34 - 8*s12*s23**2
     +     - 16*s12*s23*s34 - 8*s12*s34**2 )

      LB = LB + Ld21(p3,p24,p1)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16
     +    *s12**3*s34**2 - 16*s12**2*s13*s34**2 + 32*s12**2*s34**3 + 8*
     +    s12*s13*s34**3 )

      LB = LB + Ld21(p3,p24,p1)*S14**(-1)*S23**(-1) * (  - 32*s12**3*
     +    s34 + 32*s12**2*s13*s24 - 16*s12**2*s24*s34 - 16*s12**2*
     +    s34**2 - 32*s12*s13**2*s24 + 16*s12*s13**2*s34 + 24*s12*s13*
     +    s24**2 - 64*s12*s13*s24*s34 + 24*s12*s13*s34**2 + 24*s12*s24*
     +    s34**2 + 24*s12*s34**3 - 32*s13**2*s24**2 + 8*s13**2*s34**2
     +     + 32*s13*s24**2*s34 - 8*s13*s24*s34**2 )

      LB = LB + Ld21(p3,p24,p1)*S14**(-1)*S24**(-1) * (  - 32*s12**3*
     +    s23 - 48*s12**3*s34 + 16*s12**2*s13*s23 + 16*s12**2*s13*s34
     +     - 8*s12**2*s23**2 + 40*s12**2*s23*s34 + 80*s12**2*s34**2 - 8
     +    *s12*s13*s23**2 - 16*s12*s13*s23*s34 + 8*s12*s13*s34**2 )

      LB = LB + Ld21(p3,p24,p1)*S14**(-1) * (  - 32*s12**3 + 32*s12**2*
     +    s13 - 56*s12**2*s23 - 40*s12**2*s24 - 48*s12**2*s34 - 16*s12*
     +    s13**2 - 40*s12*s13*s23 - 32*s12*s13*s24 - 16*s12*s13*s34 + 
     +    24*s12*s23**2 + 24*s12*s23*s24 + 32*s12*s23*s34 + 24*s12*s24*
     +    s34 + 32*s12*s34**2 + 8*s13**2*s23 - 8*s13**2*s24 - 8*s13**2*
     +    s34 - 24*s13*s23*s24 - 24*s13*s24**2 + 8*s13*s24*s34 )

      LB = LB + Ld21(p3,p24,p1)*S23**(-1)*S24**(-1) * (  - 16*s12**2*
     +    s34**2 - 32*s12*s13*s34**2 - 32*s12*s14*s34**2 + 56*s12*
     +    s34**3 - 24*s13*s34**3 )

      LB = LB + Ld21(p3,p24,p1)*S23**(-1) * (  - 16*s12*s13*s24 + 48*
     +    s12*s13*s34 + 32*s12*s14*s34 - 40*s12*s24*s34 - 48*s12*s34**2
     +     - 16*s13*s24**2 + 48*s13*s24*s34 + 32*s14*s24*s34 - 32*s14*
     +    s34**2 - 64*s24*s34**2 + 40*s34**3 )

      LB = LB + Ld21(p3,p24,p1)*S24**(-1) * (  - 16*s12*s13*s23 - 32*
     +    s12*s13*s34 - 16*s12*s14*s23 - 32*s12*s14*s34 - 56*s12*s23**2
     +     - 56*s12*s23*s34 + 56*s12*s34**2 + 8*s13*s23**2 - 24*s13*
     +    s34**2 )

      LB = LB + Ld21(p3,p24,p1) * (  - 16*s12*s13 - 64*s12*s23 - 16*s12
     +    *s24 - 96*s12*s34 - 8*s13*s23 - 16*s13*s24 - 16*s13*s34 - 16*
     +    s14*s23 - 32*s14*s34 - 24*s23**2 - 24*s23*s24 - 16*s23*s34 - 
     +    48*s24*s34 + 40*s34**2 )

      LB = LB + Ld21(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S234 * ( 
     +     - 24*s12**3*s24 - 24*s12**3*s34 )

      LB = LB + Ld21(p4,p1,p23)*S13**(-1)*S14**(-1)*S234 * (  - 24*
     +    s12**2*s24 - 24*s12**2*s34 )

      LB = LB + Ld21(p4,p1,p23)*S13**(-1)*S23**(-1)*S123**(-1)*S234
     +  * ( 8*s12**4 - 16*s12**3*s24 - 16*s12**3*s34 )

      LB = LB + Ld21(p4,p1,p23)*S13**(-1)*S23**(-1)*S234 * (  - 24*
     +    s12**3 )

      LB = LB + Ld21(p4,p1,p23)*S13**(-1)*S24**(-1)*S123**(-1)*S234
     +  * ( 8*s12**3*s14 + 8*s12**3*s34 + 16*s12**2*s14*s23 + 16*s12**2
     +    *s23*s34 + 8*s12*s14*s23**2 + 8*s12*s23**2*s34 )

      LB = LB + Ld21(p4,p1,p23)*S13**(-1)*S123**(-1)*S234 * ( 32*s12**3
     +     + 16*s12**2*s14 + 40*s12**2*s23 - 32*s12**2*s24 - 32*s12**2*
     +    s34 + 32*s12*s14*s23 + 16*s12*s23**2 - 16*s12*s23*s24 - 16*
     +    s12*s23*s34 + 16*s14*s23**2 )

      LB = LB + Ld21(p4,p1,p23)*S13**(-1)*S234 * (  - 24*s12**2 )

      LB = LB + Ld21(p4,p1,p23)*S14**(-1)*S23**(-1)*S234 * (  - 24*
     +    s12**3 - 24*s12**2*s13 - 24*s12**2*s24 - 24*s12**2*s34 )

      LB = LB + Ld21(p4,p1,p23)*S14**(-1)*S234 * (  - 24*s12**2 - 24*
     +    s12*s13 - 24*s12*s24 - 24*s12*s34 )

      LB = LB + Ld21(p4,p1,p23)*S23**(-1)*S24**(-1)*S123**(-1)*S234
     +  * (  - 8*s12**2*s13*s14 - 8*s12**2*s14**2 - 8*s12**2*s14*s34 + 
     +    16*s12*s13*s14*s34 + 16*s12*s14**2*s34 + 16*s12*s14*s34**2 - 
     +    8*s13*s14*s34**2 - 8*s14**2*s34**2 - 8*s14*s34**3 )

      LB = LB + Ld21(p4,p1,p23)*S23**(-1)*S24**(-1)*S123**(-1) * ( 8*
     +    s12**2*s13*s14*s34 + 8*s12**2*s14**2*s34 + 8*s12**2*s14*
     +    s34**2 - 16*s12*s13*s14*s34**2 - 16*s12*s14**2*s34**2 - 16*
     +    s12*s14*s34**3 + 8*s13*s14*s34**3 + 8*s14**2*s34**3 + 8*s14*
     +    s34**4 )

      LB = LB + Ld21(p4,p1,p23)*S23**(-1)*S123**(-1)*S234 * ( 8*s12**3
     +     - 16*s12**2*s24 - 16*s12**2*s34 + 16*s12*s13*s14 + 16*s12*
     +    s14**2 + 16*s12*s14*s34 - 8*s13*s14*s24 - 16*s13*s14*s34 - 8*
     +    s14**2*s24 - 16*s14**2*s34 - 8*s14*s24*s34 - 16*s14*s34**2 )

      LB = LB + Ld21(p4,p1,p23)*S23**(-1)*S123**(-1) * ( 8*s12**2*s13*
     +    s14 + 8*s12**2*s14**2 + 8*s12**2*s14*s34 - 16*s12*s13*s14*s24
     +     - 32*s12*s13*s14*s34 - 16*s12*s14**2*s24 - 32*s12*s14**2*s34
     +     - 16*s12*s14*s24*s34 - 32*s12*s14*s34**2 + 8*s13*s14*s24**2
     +     + 24*s13*s14*s24*s34 + 24*s13*s14*s34**2 + 8*s14**2*s24**2
     +     + 24*s14**2*s24*s34 + 24*s14**2*s34**2 + 8*s14*s24**2*s34 + 
     +    24*s14*s24*s34**2 + 24*s14*s34**3 )

      LB = LB + Ld21(p4,p1,p23)*S23**(-1)*S234 * (  - 24*s12**2 )

      LB = LB + Ld21(p4,p1,p23)*S24**(-1)*S123**(-1)*S234 * ( 8*s12**3
     +     + 16*s12**2*s23 - 16*s12*s13*s14 - 16*s12*s14**2 - 16*s12*
     +    s14*s34 + 8*s12*s23**2 - 8*s13*s14*s23 + 8*s13*s14*s34 - 8*
     +    s14**2*s23 + 8*s14**2*s34 - 8*s14*s23*s34 + 8*s14*s34**2 )

      LB = LB + Ld21(p4,p1,p23)*S123**(-1)*S234 * ( 24*s12**2 + 24*s12*
     +    s23 - 32*s12*s24 - 32*s12*s34 + 8*s13*s14 + 8*s14**2 + 8*s14*
     +    s34 + 8*s23**2 - 16*s23*s24 - 16*s23*s34 )

      LB = LB + Ld21(p4,p1,p23)*S234 * (  - 24*s12 )

      LB = LB + Ld21(p4,p2,p13)*S13**(-1)*S14**(-1)*S123**(-1)*S134
     +  * (  - 8*s12**2*s23*s24 - 8*s12**2*s24**2 - 8*s12**2*s24*s34 + 
     +    16*s12*s23*s24*s34 + 16*s12*s24**2*s34 + 16*s12*s24*s34**2 - 
     +    8*s23*s24*s34**2 - 8*s24**2*s34**2 - 8*s24*s34**3 )

      LB = LB + Ld21(p4,p2,p13)*S13**(-1)*S14**(-1)*S123**(-1) * ( 8*
     +    s12**2*s23*s24*s34 + 8*s12**2*s24**2*s34 + 8*s12**2*s24*
     +    s34**2 - 16*s12*s23*s24*s34**2 - 16*s12*s24**2*s34**2 - 16*
     +    s12*s24*s34**3 + 8*s23*s24*s34**3 + 8*s24**2*s34**3 + 8*s24*
     +    s34**4 )

      LB = LB + Ld21(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +     - 24*s12**3*s14 - 24*s12**3*s34 )

      LB = LB + Ld21(p4,p2,p13)*S13**(-1)*S23**(-1)*S123**(-1)*S134
     +  * ( 8*s12**4 - 16*s12**3*s14 - 16*s12**3*s34 )

      LB = LB + Ld21(p4,p2,p13)*S13**(-1)*S23**(-1)*S134 * (  - 24*
     +    s12**3 )

      LB = LB + Ld21(p4,p2,p13)*S13**(-1)*S24**(-1)*S134 * (  - 24*
     +    s12**3 - 24*s12**2*s14 - 24*s12**2*s23 - 24*s12**2*s34 )

      LB = LB + Ld21(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * ( 8*s12**3
     +     - 16*s12**2*s14 - 16*s12**2*s34 + 16*s12*s23*s24 + 16*s12*
     +    s24**2 + 16*s12*s24*s34 - 8*s14*s23*s24 - 8*s14*s24**2 - 8*
     +    s14*s24*s34 - 16*s23*s24*s34 - 16*s24**2*s34 - 16*s24*s34**2
     +     )

      LB = LB + Ld21(p4,p2,p13)*S13**(-1)*S123**(-1) * ( 8*s12**2*s23*
     +    s24 + 8*s12**2*s24**2 + 8*s12**2*s24*s34 - 16*s12*s14*s23*s24
     +     - 16*s12*s14*s24**2 - 16*s12*s14*s24*s34 - 32*s12*s23*s24*
     +    s34 - 32*s12*s24**2*s34 - 32*s12*s24*s34**2 + 8*s14**2*s23*
     +    s24 + 8*s14**2*s24**2 + 8*s14**2*s24*s34 + 24*s14*s23*s24*s34
     +     + 24*s14*s24**2*s34 + 24*s14*s24*s34**2 + 24*s23*s24*s34**2
     +     + 24*s24**2*s34**2 + 24*s24*s34**3 )

      LB = LB + Ld21(p4,p2,p13)*S13**(-1)*S134 * (  - 24*s12**2 )

      LB = LB + Ld21(p4,p2,p13)*S14**(-1)*S23**(-1)*S123**(-1)*S134
     +  * ( 8*s12**3*s24 + 8*s12**3*s34 + 16*s12**2*s13*s24 + 16*s12**2
     +    *s13*s34 + 8*s12*s13**2*s24 + 8*s12*s13**2*s34 )

      LB = LB + Ld21(p4,p2,p13)*S14**(-1)*S123**(-1)*S134 * ( 8*s12**3
     +     + 16*s12**2*s13 + 8*s12*s13**2 - 16*s12*s23*s24 - 16*s12*
     +    s24**2 - 16*s12*s24*s34 - 8*s13*s23*s24 - 8*s13*s24**2 - 8*
     +    s13*s24*s34 + 8*s23*s24*s34 + 8*s24**2*s34 + 8*s24*s34**2 )

      LB = LB + Ld21(p4,p2,p13)*S23**(-1)*S24**(-1)*S134 * (  - 24*
     +    s12**2*s14 - 24*s12**2*s34 )

      LB = LB + Ld21(p4,p2,p13)*S23**(-1)*S123**(-1)*S134 * ( 32*s12**3
     +     + 40*s12**2*s13 - 32*s12**2*s14 + 16*s12**2*s24 - 32*s12**2*
     +    s34 + 16*s12*s13**2 - 16*s12*s13*s14 + 32*s12*s13*s24 - 16*
     +    s12*s13*s34 + 16*s13**2*s24 )

      LB = LB + Ld21(p4,p2,p13)*S23**(-1)*S134 * (  - 24*s12**2 )

      LB = LB + Ld21(p4,p2,p13)*S24**(-1)*S134 * (  - 24*s12**2 - 24*
     +    s12*s14 - 24*s12*s23 - 24*s12*s34 )

      LB = LB + Ld21(p4,p2,p13)*S123**(-1)*S134 * ( 24*s12**2 + 24*s12*
     +    s13 - 32*s12*s14 - 32*s12*s34 + 8*s13**2 - 16*s13*s14 - 16*
     +    s13*s34 + 8*s23*s24 + 8*s24**2 + 8*s24*s34 )

      LB = LB + Ld21(p4,p2,p13)*S134 * (  - 24*s12 )

      LB = LB + Ld21(p4,p3,p1)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 8*
     +    s12**3*s34**2 - 8*s12**2*s24*s34**2 - 8*s12**2*s34**3 )

      LB = LB + Ld21(p4,p3,p1)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s34**2 )

      LB = LB + Ld21(p4,p3,p1)*S13**(-1)*S14**(-1) * (  - 8*s12**2*
     +    s34**2 )

      LB = LB + Ld21(p4,p3,p1)*S14**(-1)*S23**(-1) * ( 16*s12**2*s24*
     +    s34 - 8*s12**2*s34**2 - 8*s12*s13*s24**2 - 8*s13**2*s24**2 - 
     +    8*s13*s24**3 )

      LB = LB + Ld21(p4,p3,p1)*S14**(-1) * ( 16*s12**2*s34 - 8*s12*s13*
     +    s24 - 8*s13*s24**2 )

      LB = LB + Ld21(p4,p3,p2)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s34**2 - 8*s12**2*s14*s34**2 - 8*s12**2*s34**3 )

      LB = LB + Ld21(p4,p3,p2)*S13**(-1)*S24**(-1) * ( 16*s12**2*s14*
     +    s34 - 8*s12**2*s34**2 - 8*s12*s14**2*s23 + 16*s12*s14**2*s34
     +     + 16*s12*s14*s23*s34 + 16*s12*s14*s34**2 - 8*s14**3*s23 - 8*
     +    s14**2*s23**2 )

      LB = LB + Ld21(p4,p3,p2)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s34**2 )

      LB = LB + Ld21(p4,p3,p2)*S23**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s34**2 )

      LB = LB + Ld21(p4,p3,p2)*S24**(-1) * ( 16*s12**2*s34 - 8*s12*s14*
     +    s23 + 16*s12*s14*s34 - 8*s14**2*s23 )

      LB = LB + Ld21(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * ( 144*s12**4*s14*s34 - 80*s12**4*s34**2 - 48*s12**3
     +    *s14**2*s34 + 80*s12**3*s14*s34**2 - 16*s12**3*s34**3 )

      LB = LB + Ld21(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * ( 144*s12**4*s13*s34 - 80*s12**4*s34**2 + 96*s12**3
     +    *s13**2*s34 - 96*s12**3*s13*s34**2 + 32*s12**2*s13**3*s34 - 
     +    96*s12**2*s13**2*s34**2 - 32*s12*s13**3*s34**2 )

      LB = LB + Ld21(p4,p3,p12)*S23**(-1)*S24**(-1)*S123**(-1) * ( 288*
     +    s12**4*s34 + 96*s12**3*s13**2 + 192*s12**3*s13*s14 - 368*
     +    s12**3*s13*s34 + 96*s12**3*s14**2 - 512*s12**3*s14*s34 + 224*
     +    s12**3*s34**2 - 64*s12**2*s13**2*s34 + 144*s12**2*s13*s14*s34
     +     + 64*s12**2*s14**2*s34 - 112*s12**2*s14*s34**2 )

      LB = LB + Ld21(p4,p12,p3)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 48
     +    *s12**2*s14**2*s34 - 32*s12*s14**2*s34**2 )

      LB = LB + Ld21(p4,p12,p3)*S13**(-1)*S23**(-1) * (  - 16*s12*
     +    s14**2*s34 )

      LB = LB + Ld21(p4,p12,p3)*S13**(-1)*S24**(-1) * ( 48*s12*s14**3
     +     - 48*s12*s14**2*s23 - 128*s12*s14**2*s34 - 16*s14**4 + 16*
     +    s14**3*s23 + 16*s14**3*s34 - 16*s14**2*s23**2 - 48*s14**2*s23
     +    *s34 - 16*s14**2*s34**2 )

      LB = LB + Ld21(p4,p12,p3)*S13**(-1) * (  - 32*s14**3 - 16*s14**2*
     +    s24 )

      LB = LB + Ld21(p4,p12,p3)*S14**(-1)*S23**(-1) * (  - 48*s12*
     +    s13**2*s24 + 16*s13**3*s24 - 32*s13**2*s24**2 - 32*s13**2*s24
     +    *s34 )

      LB = LB + Ld21(p4,p12,p3)*S23**(-1)*S24**(-1) * ( 96*s12**2*s13*
     +    s34 + 48*s12**2*s14*s34 - 96*s12*s13**2*s14 - 112*s12*s13*s14
     +    *s34 + 48*s12*s13*s34**2 + 96*s12*s14**3 - 16*s12*s14**2*s34
     +     + 96*s12*s14*s34**2 - 32*s13**3*s14 - 32*s13**2*s14**2 + 32*
     +    s13**2*s14*s34 + 32*s13*s14**3 - 16*s13*s14**2*s34 - 48*s13*
     +    s14*s34**2 + 32*s14**4 - 48*s14**3*s34 + 32*s14**2*s34**2 )

      LB = LB + Ld21(p4,p12,p3)*S23**(-1) * (  - 144*s12*s13**2 + 48*
     +    s12*s13*s24 + 80*s12*s13*s34 + 144*s12*s14**2 + 96*s12*s14*
     +    s24 + 112*s12*s14*s34 - 16*s13**3 - 80*s13**2*s14 - 64*s13**2
     +    *s24 + 48*s13**2*s34 - 16*s13*s14**2 - 32*s13*s14*s24 + 48*
     +    s13*s14*s34 + 48*s13*s24*s34 + 48*s14**3 + 48*s14**2*s24 - 16
     +    *s14**2*s34 + 32*s14*s24**2 + 48*s14*s24*s34 + 16*s14*s34**2
     +     )

      LB = LB + Ld21(p4,p12,p3)*S24**(-1) * (  - 48*s12*s13*s14 + 32*
     +    s12*s13*s34 - 48*s12*s14*s23 - 16*s13**2*s14 + 48*s13*s14**2
     +     - 32*s13*s14*s23 - 48*s13*s14*s34 + 48*s14**3 - 16*s14**2*
     +    s23 - 64*s14**2*s34 - 16*s14*s23**2 + 16*s14*s34**2 )

      LB = LB + Ld21(p4,p12,p3) * ( 64*s13*s14 + 32*s13*s24 + 32*s14**2
     +     + 16*s14*s24 )

      LB = LB + Ld21(p4,p13,p2)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 8*s12**3*s34**3 + 8*s12**2*s34**4 )

      LB = LB + Ld21(p4,p13,p2)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16
     +    *s12**3*s34**2 - 40*s12**2*s24*s34**2 + 32*s12**2*s34**3 - 16
     +    *s12*s24*s34**3 )

      LB = LB + Ld21(p4,p13,p2)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**2*s34**3 + 16*s12*s23*s34**3 + 8*s12*s34**4 )

      LB = LB + Ld21(p4,p13,p2)*S13**(-1)*S14**(-1) * (  - 40*s12**2*
     +    s34**2 - 32*s12*s23*s34**2 - 32*s12*s24*s34**2 + 32*s12*
     +    s34**3 - 24*s24*s34**3 )

      LB = LB + Ld21(p4,p13,p2)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 24
     +    *s12**3*s14**2 - 56*s12**3*s14*s34 - 40*s12**3*s34**2 - 8*
     +    s12**2*s14**3 - 8*s12**2*s14**2*s34 + 16*s12**2*s14*s34**2 + 
     +    24*s12**2*s34**3 )

      LB = LB + Ld21(p4,p13,p2)*S13**(-1)*S23**(-1) * (  - 56*s12**3*
     +    s14 - 72*s12**3*s34 + 16*s12**2*s14**2 + 16*s12**2*s14*s24 + 
     +    64*s12**2*s14*s34 - 8*s12**2*s24*s34 + 80*s12**2*s34**2 - 8*
     +    s12*s14**2*s24 - 16*s12*s14*s24*s34 - 16*s12*s24*s34**2 )

      LB = LB + Ld21(p4,p13,p2)*S13**(-1)*S24**(-1) * (  - 16*s12**2*
     +    s14**2 - 16*s12**2*s14*s34 + 16*s12**2*s34**2 - 8*s12*s14**3
     +     - 16*s12*s14**2*s23 - 24*s12*s14**2*s34 - 16*s12*s14*s23*s34
     +     - 16*s12*s14*s34**2 + 16*s12*s23*s34**2 + 8*s12*s34**3 )

      LB = LB + Ld21(p4,p13,p2)*S13**(-1) * (  - 24*s12**2*s14 - 48*
     +    s12**2*s34 - 32*s12*s14**2 - 16*s12*s14*s23 - 16*s12*s14*s24
     +     - 32*s12*s14*s34 - 32*s12*s23*s34 - 32*s12*s24*s34 + 32*s12*
     +    s34**2 + 8*s14**2*s24 - 24*s24*s34**2 )

      LB = LB + Ld21(p4,p13,p2)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s34**2 )

      LB = LB + Ld21(p4,p13,p2)*S14**(-1)*S23**(-1) * (  - 56*s12**3*
     +    s34 + 32*s12**2*s13*s24 - 16*s12**2*s13*s34 - 64*s12**2*
     +    s34**2 + 24*s12*s13**2*s24 - 32*s12*s13*s24**2 - 40*s12*s13*
     +    s24*s34 + 24*s12*s13*s34**2 + 16*s12*s24**2*s34 + 48*s12*s24*
     +    s34**2 - 32*s13**2*s24**2 + 32*s13**2*s24*s34 - 8*s13*s24*
     +    s34**2 + 8*s24**2*s34**2 )

      LB = LB + Ld21(p4,p13,p2)*S14**(-1)*S24**(-1) * (  - 24*s12**2*
     +    s34**2 - 24*s12*s23*s34**2 - 8*s12*s34**3 )

      LB = LB + Ld21(p4,p13,p2)*S14**(-1) * (  - 16*s12*s13*s24 - 40*
     +    s12*s13*s34 + 32*s12*s23*s34 + 48*s12*s24*s34 - 24*s12*s34**2
     +     - 16*s13**2*s24 + 32*s13*s23*s34 + 48*s13*s24*s34 - 64*s13*
     +    s34**2 - 32*s23*s34**2 + 40*s34**3 )

      LB = LB + Ld21(p4,p13,p2)*S23**(-1)*S24**(-1) * (  - 24*s12**3*
     +    s14 - 32*s12**3*s34 - 8*s12**2*s14**2 + 16*s12**2*s34**2 )

      LB = LB + Ld21(p4,p13,p2)*S23**(-1) * (  - 56*s12**3 - 40*s12**2*
     +    s13 - 32*s12**2*s14 + 32*s12**2*s24 - 72*s12**2*s34 + 24*s12*
     +    s13*s14 - 8*s12*s13*s24 + 24*s12*s13*s34 + 24*s12*s14**2 - 16
     +    *s12*s14*s24 + 32*s12*s14*s34 - 16*s12*s24**2 + 32*s12*s24*
     +    s34 + 8*s12*s34**2 - 24*s13**2*s24 - 24*s13*s14*s24 - 8*s13*
     +    s24**2 + 8*s13*s24*s34 + 8*s14*s24**2 - 8*s24**2*s34 )

      LB = LB + Ld21(p4,p13,p2)*S24**(-1) * (  - 16*s12**2*s14 - 32*
     +    s12**2*s34 - 8*s12*s14**2 - 16*s12*s14*s23 - 16*s12*s14*s34
     +     - 32*s12*s23*s34 - 8*s12*s34**2 )

      LB = LB + Ld21(p4,p13,p2) * (  - 16*s12*s13 - 40*s12*s14 - 16*s12
     +    *s24 - 48*s12*s34 - 24*s13*s14 - 16*s13*s24 - 48*s13*s34 - 24
     +    *s14**2 - 16*s14*s23 - 8*s14*s24 - 16*s14*s34 - 32*s23*s34 - 
     +    16*s24*s34 + 40*s34**2 )

      LB = LB + Ld21(p4,p23,p1)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 8*s12**3*s34**3 + 8*s12**2*s34**4 )

      LB = LB + Ld21(p4,p23,p1)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 24
     +    *s12**3*s24**2 - 56*s12**3*s24*s34 - 40*s12**3*s34**2 - 8*
     +    s12**2*s24**3 - 8*s12**2*s24**2*s34 + 16*s12**2*s24*s34**2 + 
     +    24*s12**2*s34**3 )

      LB = LB + Ld21(p4,p23,p1)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s34**2 )

      LB = LB + Ld21(p4,p23,p1)*S13**(-1)*S14**(-1) * (  - 24*s12**3*
     +    s24 - 32*s12**3*s34 - 8*s12**2*s24**2 + 16*s12**2*s34**2 )

      LB = LB + Ld21(p4,p23,p1)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16
     +    *s12**3*s34**2 - 16*s12**2*s14*s34**2 + 32*s12**2*s34**3 + 8*
     +    s12*s14*s34**3 )

      LB = LB + Ld21(p4,p23,p1)*S13**(-1)*S23**(-1) * (  - 32*s12**3*
     +    s24 - 48*s12**3*s34 + 16*s12**2*s14*s24 + 16*s12**2*s14*s34
     +     - 8*s12**2*s24**2 + 40*s12**2*s24*s34 + 80*s12**2*s34**2 - 8
     +    *s12*s14*s24**2 - 16*s12*s14*s24*s34 + 8*s12*s14*s34**2 )

      LB = LB + Ld21(p4,p23,p1)*S13**(-1)*S24**(-1) * (  - 32*s12**3*
     +    s34 + 32*s12**2*s14*s23 - 16*s12**2*s23*s34 - 16*s12**2*
     +    s34**2 - 32*s12*s14**2*s23 + 16*s12*s14**2*s34 + 24*s12*s14*
     +    s23**2 - 64*s12*s14*s23*s34 + 24*s12*s14*s34**2 + 24*s12*s23*
     +    s34**2 + 24*s12*s34**3 - 32*s14**2*s23**2 + 8*s14**2*s34**2
     +     + 32*s14*s23**2*s34 - 8*s14*s23*s34**2 )

      LB = LB + Ld21(p4,p23,p1)*S13**(-1) * (  - 32*s12**3 + 32*s12**2*
     +    s14 - 40*s12**2*s23 - 56*s12**2*s24 - 48*s12**2*s34 - 16*s12*
     +    s14**2 - 32*s12*s14*s23 - 40*s12*s14*s24 - 16*s12*s14*s34 + 
     +    24*s12*s23*s24 + 24*s12*s23*s34 + 24*s12*s24**2 + 32*s12*s24*
     +    s34 + 32*s12*s34**2 - 8*s14**2*s23 + 8*s14**2*s24 - 8*s14**2*
     +    s34 - 24*s14*s23**2 - 24*s14*s23*s24 + 8*s14*s23*s34 )

      LB = LB + Ld21(p4,p23,p1)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**2*s34**3 + 16*s12*s13*s34**3 + 8*s12*s34**4 )

      LB = LB + Ld21(p4,p23,p1)*S14**(-1)*S23**(-1) * (  - 16*s12**2*
     +    s24**2 - 16*s12**2*s24*s34 + 16*s12**2*s34**2 - 16*s12*s13*
     +    s24**2 - 16*s12*s13*s24*s34 + 16*s12*s13*s34**2 - 8*s12*
     +    s24**3 - 24*s12*s24**2*s34 - 16*s12*s24*s34**2 + 8*s12*s34**3
     +     )

      LB = LB + Ld21(p4,p23,p1)*S14**(-1)*S24**(-1) * (  - 24*s12**2*
     +    s34**2 - 24*s12*s13*s34**2 - 8*s12*s34**3 )

      LB = LB + Ld21(p4,p23,p1)*S14**(-1) * (  - 16*s12**2*s24 - 32*
     +    s12**2*s34 - 16*s12*s13*s24 - 32*s12*s13*s34 - 8*s12*s24**2
     +     - 16*s12*s24*s34 - 8*s12*s34**2 )

      LB = LB + Ld21(p4,p23,p1)*S23**(-1)*S24**(-1) * (  - 16*s12**2*
     +    s34**2 - 32*s12*s13*s34**2 - 32*s12*s14*s34**2 + 56*s12*
     +    s34**3 - 24*s14*s34**3 )

      LB = LB + Ld21(p4,p23,p1)*S23**(-1) * (  - 16*s12*s13*s24 - 32*
     +    s12*s13*s34 - 16*s12*s14*s24 - 32*s12*s14*s34 - 56*s12*s24**2
     +     - 56*s12*s24*s34 + 56*s12*s34**2 + 8*s14*s24**2 - 24*s14*
     +    s34**2 )

      LB = LB + Ld21(p4,p23,p1)*S24**(-1) * ( 32*s12*s13*s34 - 16*s12*
     +    s14*s23 + 48*s12*s14*s34 - 40*s12*s23*s34 - 48*s12*s34**2 + 
     +    32*s13*s23*s34 - 32*s13*s34**2 - 16*s14*s23**2 + 48*s14*s23*
     +    s34 - 64*s23*s34**2 + 40*s34**3 )

      LB = LB + Ld21(p4,p23,p1) * (  - 16*s12*s14 - 16*s12*s23 - 64*s12
     +    *s24 - 96*s12*s34 - 16*s13*s24 - 32*s13*s34 - 16*s14*s23 - 8*
     +    s14*s24 - 16*s14*s34 - 24*s23*s24 - 48*s23*s34 - 24*s24**2 - 
     +    16*s24*s34 + 40*s34**2 )

      LBg=-LB/s134/s234
      
      return
      end

      function LBh(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      SF=(s13*s24-s14*s23)/2d0/s34

      LB=0d0

      LB = LB + Ld22(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * (  - 8*s12*
     +    s23**2 - 16*s12*s23*s34 + 8*s14*s23**2 )

      LB = LB + Ld22(p1,p2,p34)*S14**(-1)*S134 * (  - 8*s12*s23 - 16*
     +    s12*s34 + 8*s13*s23 )

      LB = LB + Ld22(p1,p2,p34)*S24**(-1)*S134 * ( 8*s23**2 )

      LB = LB + Ld22(p1,p2,p34)*S134 * ( 8*s23 )

      LB = LB + Ld22(p2,p1,p34)*S14**(-1)*S23**(-1)*S234 * (  - 8*s12*
     +    s13**2 - 16*s12*s13*s34 + 8*s13**2*s24 )

      LB = LB + Ld22(p2,p1,p34)*S14**(-1)*S234 * ( 8*s13**2 )

      LB = LB + Ld22(p2,p1,p34)*S24**(-1)*S234 * (  - 8*s12*s13 - 16*
     +    s12*s34 + 8*s13*s23 )

      LB = LB + Ld22(p2,p1,p34)*S234 * ( 8*s13 )

      LB = LB + Ld22(p3,p1,p24)*S13**(-1)*S14**(-1)*S23**(-1)*S234*
     + S124**(-1) * (  - 8*s12**3*s34**2 )

      LB = LB + Ld22(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234*
     + S124**(-1) * (  - 8*s12**4*s23 - 8*s12**4*s34 + 16*s12**3*s23**2
     +     + 32*s12**3*s23*s34 + 16*s12**3*s34**2 )

      LB = LB + Ld22(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234 * ( 
     +     - 24*s12**3*s23 - 24*s12**3*s34 )

      LB = LB + Ld22(p3,p1,p24)*S13**(-1)*S14**(-1)*S234*S124**(-1)
     +  * (  - 16*s12**3*s23 - 24*s12**3*s34 )

      LB = LB + Ld22(p3,p1,p24)*S13**(-1)*S23**(-1)*S234*S124**(-1)
     +  * (  - 8*s12**3*s34 )

      LB = LB + Ld22(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*S124**(-1)
     +  * (  - 8*s12**3*s23 - 8*s12**3*s34 + 16*s12**2*s23**2 + 32*
     +    s12**2*s23*s34 + 16*s12**2*s34**2 )

      LB = LB + Ld22(p3,p1,p24)*S13**(-1)*S24**(-1)*S234 * (  - 24*
     +    s12**3 - 24*s12**2*s14 - 24*s12**2*s23 - 24*s12**2*s34 )

      LB = LB + Ld22(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * (  - 8*
     +    s12**3 - 8*s12**2*s23 - 8*s12**2*s34 )

      LB = LB + Ld22(p3,p1,p24)*S14**(-1)*S23**(-1)*S234*S124**(-1)
     +  * ( 8*s12**3*s13 + 16*s12**2*s13*s24 + 16*s12**2*s24*s34 )

      LB = LB + Ld22(p3,p1,p24)*S14**(-1)*S24**(-1)*S234*S124**(-1)
     +  * ( 8*s12**4 - 16*s12**3*s23 - 16*s12**3*s34 )

      LB = LB + Ld22(p3,p1,p24)*S14**(-1)*S24**(-1)*S234 * (  - 24*
     +    s12**3 )

      LB = LB + Ld22(p3,p1,p24)*S14**(-1)*S234*S124**(-1) * ( 24*s12**3
     +     + 16*s12**2*s13 - 48*s12**2*s23 + 32*s12**2*s24 - 48*s12**2*
     +    s34 + 32*s12*s13*s24 )

      LB = LB + Ld22(p3,p1,p24)*S23**(-1)*S234*S124**(-1) * ( 8*s12**3
     +     + 8*s12**2*s13 + 8*s12**2*s14 + 16*s12**2*s24 + 8*s12**2*s34
     +     )

      LB = LB + Ld22(p3,p1,p24)*S23**(-1)*S124**(-1) * (  - 8*s12**2*
     +    s13**2 - 8*s12**2*s13*s14 - 8*s12**2*s13*s24 - 8*s12**2*s13*
     +    s34 - 8*s12**2*s14*s24 - 8*s12**2*s24*s34 - 16*s12*s13**2*s24
     +     - 16*s12*s13*s14*s24 - 16*s12*s13*s24*s34 )

      LB = LB + Ld22(p3,p1,p24)*S24**(-1)*S234*S124**(-1) * ( 8*s12**3
     +     - 16*s12**2*s23 - 16*s12**2*s34 )

      LB = LB + Ld22(p3,p1,p24)*S24**(-1)*S234 * (  - 24*s12**2 )

      LB = LB + Ld22(p3,p1,p24)*S234*S124**(-1) * ( 24*s12**2 - 32*s12*
     +    s23 + 16*s12*s24 - 32*s12*s34 )

      LB = LB + Ld22(p3,p2,p14)*S13**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * (  - 8*s12**3*s34**2 )

      LB = LB + Ld22(p3,p2,p14)*S13**(-1)*S23**(-1)*S134*S124**(-1)
     +  * (  - 8*s12**3*s34 )

      LB = LB + Ld22(p3,p2,p14)*S13**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 8*s12**3*s23 + 16*s12**2*s14*s23 + 16*s12**2*s14*s34 )

      LB = LB + Ld22(p3,p2,p14)*S13**(-1)*S134*S124**(-1) * ( 8*s12**3
     +     + 16*s12**2*s14 + 8*s12**2*s23 + 8*s12**2*s24 + 8*s12**2*s34
     +     )

      LB = LB + Ld22(p3,p2,p14)*S13**(-1)*S124**(-1) * (  - 8*s12**2*
     +    s14*s23 - 8*s12**2*s14*s24 - 8*s12**2*s14*s34 - 8*s12**2*
     +    s23**2 - 8*s12**2*s23*s24 - 8*s12**2*s23*s34 - 16*s12*s14*
     +    s23**2 - 16*s12*s14*s23*s24 - 16*s12*s14*s23*s34 )

      LB = LB + Ld22(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * (  - 8*s12**4*s13 - 8*s12**4*s34 + 16*s12**3*s13**2
     +     + 32*s12**3*s13*s34 + 16*s12**3*s34**2 )

      LB = LB + Ld22(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +     - 24*s12**3*s13 - 24*s12**3*s34 )

      LB = LB + Ld22(p3,p2,p14)*S14**(-1)*S23**(-1)*S134*S124**(-1)
     +  * (  - 8*s12**3*s13 - 8*s12**3*s34 + 16*s12**2*s13**2 + 32*
     +    s12**2*s13*s34 + 16*s12**2*s34**2 )

      LB = LB + Ld22(p3,p2,p14)*S14**(-1)*S23**(-1)*S134 * (  - 24*
     +    s12**3 - 24*s12**2*s13 - 24*s12**2*s24 - 24*s12**2*s34 )

      LB = LB + Ld22(p3,p2,p14)*S14**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 8*s12**4 - 16*s12**3*s13 - 16*s12**3*s34 )

      LB = LB + Ld22(p3,p2,p14)*S14**(-1)*S24**(-1)*S134 * (  - 24*
     +    s12**3 )

      LB = LB + Ld22(p3,p2,p14)*S14**(-1)*S134*S124**(-1) * ( 8*s12**3
     +     - 16*s12**2*s13 - 16*s12**2*s34 )

      LB = LB + Ld22(p3,p2,p14)*S14**(-1)*S134 * (  - 24*s12**2 )

      LB = LB + Ld22(p3,p2,p14)*S23**(-1)*S24**(-1)*S134*S124**(-1)
     +  * (  - 16*s12**3*s13 - 24*s12**3*s34 )

      LB = LB + Ld22(p3,p2,p14)*S23**(-1)*S134*S124**(-1) * (  - 8*
     +    s12**3 - 8*s12**2*s13 - 8*s12**2*s34 )

      LB = LB + Ld22(p3,p2,p14)*S24**(-1)*S134*S124**(-1) * ( 24*s12**3
     +     - 48*s12**2*s13 + 32*s12**2*s14 + 16*s12**2*s23 - 48*s12**2*
     +    s34 + 32*s12*s14*s23 )

      LB = LB + Ld22(p3,p2,p14)*S134*S124**(-1) * ( 24*s12**2 - 32*s12*
     +    s13 + 16*s12*s14 - 32*s12*s34 )

      LB = LB + Ld22(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * ( 48*s12**4*s34**2 + 144*s12**3*s14**2*s34 - 224*
     +    s12**3*s14*s34**2 + 48*s12**3*s34**3 + 32*s12**2*s14**3*s34
     +     - 96*s12**2*s14**2*s34**2 - 32*s12*s14**3*s34**2 )

      LB = LB + Ld22(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1) * (  - 
     +    96*s12**3*s14*s34 + 64*s12**3*s34**2 - 48*s12**2*s14**3 + 48*
     +    s12**2*s14**2*s23 + 208*s12**2*s14**2*s34 - 128*s12**2*s14*
     +    s23*s34 - 112*s12**2*s14*s34**2 + 16*s12**2*s23*s34**2 + 16*
     +    s12**2*s34**3 - 64*s12*s14**3*s23 + 32*s12*s14**3*s34 + 64*
     +    s12*s14**2*s23**2 + 80*s12*s14**2*s23*s34 - 32*s12*s14*s23**2
     +    *s34 - 32*s12*s14*s23*s34**2 - 16*s14**3*s23**2 + 16*s14**2*
     +    s23**3 + 16*s14**2*s23**2*s34 )

      LB = LB + Ld22(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * ( 48*s12**4*s34**2 - 32*s12**3*s13*s34**2 + 32*
     +    s12**3*s34**3 )

      LB = LB + Ld22(p3,p4,p12)*S14**(-1)*S24**(-1)*S124**(-1) * ( 16*
     +    s12**3*s34**2 )

      LB = LB + Ld22(p3,p4,p12)*S23**(-1)*S24**(-1)*S124**(-1) * ( 96*
     +    s12**3*s13*s34 + 240*s12**3*s14*s34 - 352*s12**3*s34**2 - 48*
     +    s12**2*s13*s14**2 + 64*s12**2*s13*s14*s34 + 64*s12**2*s13*
     +    s34**2 - 48*s12**2*s14**3 + 48*s12**2*s14**2*s34 + 176*s12**2
     +    *s14*s34**2 - 80*s12**2*s34**3 - 64*s12*s13**2*s14**2 + 16*
     +    s12*s13**2*s14*s34 - 64*s12*s13*s14**3 - 16*s12*s13*s14**2*
     +    s34 + 16*s12*s13*s14*s34**2 + 32*s12*s14**3*s34 - 16*s13**3*
     +    s14**2 - 16*s13**2*s14**3 - 16*s13**2*s14**2*s34 )

      LB = LB + Ld22(p3,p4,p12)*S24**(-1)*S124**(-1) * (  - 96*s12**3*
     +    s34 + 48*s12**2*s13*s14 + 48*s12**2*s14*s23 + 208*s12**2*s14*
     +    s34 - 32*s12**2*s23*s34 - 96*s12**2*s34**2 + 16*s12*s13**2*
     +    s14 - 64*s12*s13*s14**2 + 32*s12*s13*s14*s23 + 80*s12*s13*s14
     +    *s34 - 128*s12*s14**3 + 64*s12*s14**2*s23 + 64*s12*s14**2*s34
     +     + 16*s12*s14*s23**2 + 32*s12*s14*s23*s34 + 48*s12*s14*s34**2
     +     - 32*s13**2*s14**2 - 48*s13*s14**3 - 16*s13*s14**2*s34 - 48*
     +    s14**3*s23 + 32*s14**2*s23**2 + 16*s14**2*s23*s34 )

      LB = LB + Ld22(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S123**(-1)*S234 * (  - 8*s12**4*s24 - 8*s12**4*s34 + 16*s12**3*
     +    s24**2 + 32*s12**3*s24*s34 + 16*s12**3*s34**2 )

      LB = LB + Ld22(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S234 * ( 
     +     - 24*s12**3*s24 - 24*s12**3*s34 )

      LB = LB + Ld22(p4,p1,p23)*S13**(-1)*S14**(-1)*S24**(-1)*
     + S123**(-1)*S234 * (  - 8*s12**3*s34**2 )

      LB = LB + Ld22(p4,p1,p23)*S13**(-1)*S14**(-1)*S123**(-1)*S234
     +  * (  - 16*s12**3*s24 - 24*s12**3*s34 )

      LB = LB + Ld22(p4,p1,p23)*S13**(-1)*S23**(-1)*S123**(-1)*S234
     +  * ( 8*s12**4 - 16*s12**3*s24 - 16*s12**3*s34 )

      LB = LB + Ld22(p4,p1,p23)*S13**(-1)*S23**(-1)*S234 * (  - 24*
     +    s12**3 )

      LB = LB + Ld22(p4,p1,p23)*S13**(-1)*S24**(-1)*S123**(-1)*S234
     +  * ( 8*s12**3*s14 + 16*s12**2*s14*s23 + 16*s12**2*s23*s34 )

      LB = LB + Ld22(p4,p1,p23)*S13**(-1)*S123**(-1)*S234 * ( 24*s12**3
     +     + 16*s12**2*s14 + 32*s12**2*s23 - 48*s12**2*s24 - 48*s12**2*
     +    s34 + 32*s12*s14*s23 )

      LB = LB + Ld22(p4,p1,p23)*S14**(-1)*S23**(-1)*S123**(-1)*S234
     +  * (  - 8*s12**3*s24 - 8*s12**3*s34 + 16*s12**2*s24**2 + 32*
     +    s12**2*s24*s34 + 16*s12**2*s34**2 )

      LB = LB + Ld22(p4,p1,p23)*S14**(-1)*S23**(-1)*S234 * (  - 24*
     +    s12**3 - 24*s12**2*s13 - 24*s12**2*s24 - 24*s12**2*s34 )

      LB = LB + Ld22(p4,p1,p23)*S14**(-1)*S24**(-1)*S123**(-1)*S234
     +  * (  - 8*s12**3*s34 )

      LB = LB + Ld22(p4,p1,p23)*S14**(-1)*S123**(-1)*S234 * (  - 8*
     +    s12**3 - 8*s12**2*s24 - 8*s12**2*s34 )

      LB = LB + Ld22(p4,p1,p23)*S23**(-1)*S24**(-1)*S123**(-1)*S234
     +  * (  - 8*s12**2*s13*s14 + 8*s12**2*s13*s34 - 8*s12**2*s14**2 + 
     +    8*s12**2*s34**2 + 16*s12*s13*s14*s34 + 16*s12*s14**2*s34 + 16
     +    *s12*s14*s34**2 )

      LB = LB + Ld22(p4,p1,p23)*S23**(-1)*S24**(-1)*S123**(-1) * ( 8*
     +    s12**2*s13*s14*s34 - 8*s12**2*s13*s34**2 + 8*s12**2*s14**2*
     +    s34 - 8*s12**2*s34**3 - 16*s12*s13*s14*s34**2 - 16*s12*s14**2
     +    *s34**2 - 16*s12*s14*s34**3 )

      LB = LB + Ld22(p4,p1,p23)*S23**(-1)*S123**(-1)*S234 * ( 8*s12**3
     +     + 8*s12**2*s13 + 8*s12**2*s14 - 16*s12**2*s24 - 8*s12**2*s34
     +     + 16*s12*s13*s14 + 16*s12*s14**2 + 16*s12*s14*s34 )

      LB = LB + Ld22(p4,p1,p23)*S23**(-1)*S123**(-1) * ( 8*s12**2*s13*
     +    s14 - 8*s12**2*s13*s24 - 16*s12**2*s13*s34 + 8*s12**2*s14**2
     +     - 8*s12**2*s14*s24 - 8*s12**2*s14*s34 - 8*s12**2*s24*s34 - 
     +    16*s12**2*s34**2 - 16*s12*s13*s14*s24 - 32*s12*s13*s14*s34 - 
     +    16*s12*s14**2*s24 - 32*s12*s14**2*s34 - 16*s12*s14*s24*s34 - 
     +    32*s12*s14*s34**2 )

      LB = LB + Ld22(p4,p1,p23)*S23**(-1)*S234 * (  - 24*s12**2 )

      LB = LB + Ld22(p4,p1,p23)*S24**(-1)*S123**(-1)*S234 * ( 8*s12**3
     +     + 16*s12**2*s23 - 16*s12*s13*s14 - 16*s12*s14**2 - 16*s12*
     +    s14*s34 )

      LB = LB + Ld22(p4,p1,p23)*S123**(-1)*S234 * ( 24*s12**2 + 16*s12*
     +    s23 - 32*s12*s24 - 32*s12*s34 )

      LB = LB + Ld22(p4,p2,p13)*S13**(-1)*S14**(-1)*S123**(-1)*S134
     +  * (  - 8*s12**2*s23*s24 + 8*s12**2*s23*s34 - 8*s12**2*s24**2 + 
     +    8*s12**2*s34**2 + 16*s12*s23*s24*s34 + 16*s12*s24**2*s34 + 16
     +    *s12*s24*s34**2 )

      LB = LB + Ld22(p4,p2,p13)*S13**(-1)*S14**(-1)*S123**(-1) * ( 8*
     +    s12**2*s23*s24*s34 - 8*s12**2*s23*s34**2 + 8*s12**2*s24**2*
     +    s34 - 8*s12**2*s34**3 - 16*s12*s23*s24*s34**2 - 16*s12*s24**2
     +    *s34**2 - 16*s12*s24*s34**3 )

      LB = LB + Ld22(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S134 * (  - 8*s12**4*s14 - 8*s12**4*s34 + 16*s12**3*
     +    s14**2 + 32*s12**3*s14*s34 + 16*s12**3*s34**2 )

      LB = LB + Ld22(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +     - 24*s12**3*s14 - 24*s12**3*s34 )

      LB = LB + Ld22(p4,p2,p13)*S13**(-1)*S23**(-1)*S123**(-1)*S134
     +  * ( 8*s12**4 - 16*s12**3*s14 - 16*s12**3*s34 )

      LB = LB + Ld22(p4,p2,p13)*S13**(-1)*S23**(-1)*S134 * (  - 24*
     +    s12**3 )

      LB = LB + Ld22(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*S134
     +  * (  - 8*s12**3*s14 - 8*s12**3*s34 + 16*s12**2*s14**2 + 32*
     +    s12**2*s14*s34 + 16*s12**2*s34**2 )

      LB = LB + Ld22(p4,p2,p13)*S13**(-1)*S24**(-1)*S134 * (  - 24*
     +    s12**3 - 24*s12**2*s14 - 24*s12**2*s23 - 24*s12**2*s34 )

      LB = LB + Ld22(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * ( 8*s12**3
     +     - 16*s12**2*s14 + 8*s12**2*s23 + 8*s12**2*s24 - 8*s12**2*s34
     +     + 16*s12*s23*s24 + 16*s12*s24**2 + 16*s12*s24*s34 )

      LB = LB + Ld22(p4,p2,p13)*S13**(-1)*S123**(-1) * (  - 8*s12**2*
     +    s14*s23 - 8*s12**2*s14*s24 - 8*s12**2*s14*s34 + 8*s12**2*s23*
     +    s24 - 16*s12**2*s23*s34 + 8*s12**2*s24**2 - 8*s12**2*s24*s34
     +     - 16*s12**2*s34**2 - 16*s12*s14*s23*s24 - 16*s12*s14*s24**2
     +     - 16*s12*s14*s24*s34 - 32*s12*s23*s24*s34 - 32*s12*s24**2*
     +    s34 - 32*s12*s24*s34**2 )

      LB = LB + Ld22(p4,p2,p13)*S13**(-1)*S134 * (  - 24*s12**2 )

      LB = LB + Ld22(p4,p2,p13)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S134 * (  - 8*s12**3*s34**2 )

      LB = LB + Ld22(p4,p2,p13)*S14**(-1)*S23**(-1)*S123**(-1)*S134
     +  * ( 8*s12**3*s24 + 16*s12**2*s13*s24 + 16*s12**2*s13*s34 )

      LB = LB + Ld22(p4,p2,p13)*S14**(-1)*S24**(-1)*S123**(-1)*S134
     +  * (  - 8*s12**3*s34 )

      LB = LB + Ld22(p4,p2,p13)*S14**(-1)*S123**(-1)*S134 * ( 8*s12**3
     +     + 16*s12**2*s13 - 16*s12*s23*s24 - 16*s12*s24**2 - 16*s12*
     +    s24*s34 )

      LB = LB + Ld22(p4,p2,p13)*S23**(-1)*S24**(-1)*S123**(-1)*S134
     +  * (  - 16*s12**3*s14 - 24*s12**3*s34 )

      LB = LB + Ld22(p4,p2,p13)*S23**(-1)*S123**(-1)*S134 * ( 24*s12**3
     +     + 32*s12**2*s13 - 48*s12**2*s14 + 16*s12**2*s24 - 48*s12**2*
     +    s34 + 32*s12*s13*s24 )

      LB = LB + Ld22(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * (  - 8*
     +    s12**3 - 8*s12**2*s14 - 8*s12**2*s34 )

      LB = LB + Ld22(p4,p2,p13)*S123**(-1)*S134 * ( 24*s12**2 + 16*s12*
     +    s13 - 32*s12*s14 - 32*s12*s34 )

      LB = LB + Ld22(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * ( 48*s12**4*s34**2 - 32*s12**3*s14*s34**2 + 32*
     +    s12**3*s34**3 )

      LB = LB + Ld22(p4,p3,p12)*S13**(-1)*S23**(-1)*S123**(-1) * ( 16*
     +    s12**3*s34**2 )

      LB = LB + Ld22(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * ( 48*s12**4*s34**2 + 144*s12**3*s13**2*s34 - 224*
     +    s12**3*s13*s34**2 + 48*s12**3*s34**3 + 32*s12**2*s13**3*s34
     +     - 96*s12**2*s13**2*s34**2 - 32*s12*s13**3*s34**2 )

      LB = LB + Ld22(p4,p3,p12)*S14**(-1)*S23**(-1)*S123**(-1) * (  - 
     +    96*s12**3*s13*s34 + 64*s12**3*s34**2 - 48*s12**2*s13**3 + 48*
     +    s12**2*s13**2*s24 + 208*s12**2*s13**2*s34 - 128*s12**2*s13*
     +    s24*s34 - 112*s12**2*s13*s34**2 + 16*s12**2*s24*s34**2 + 16*
     +    s12**2*s34**3 - 64*s12*s13**3*s24 + 32*s12*s13**3*s34 + 64*
     +    s12*s13**2*s24**2 + 80*s12*s13**2*s24*s34 - 32*s12*s13*s24**2
     +    *s34 - 32*s12*s13*s24*s34**2 - 16*s13**3*s24**2 + 16*s13**2*
     +    s24**3 + 16*s13**2*s24**2*s34 )

      LB = LB + Ld22(p4,p3,p12)*S23**(-1)*S24**(-1)*S123**(-1) * ( 240*
     +    s12**3*s13*s34 + 96*s12**3*s14*s34 - 352*s12**3*s34**2 - 48*
     +    s12**2*s13**3 - 48*s12**2*s13**2*s14 + 48*s12**2*s13**2*s34
     +     + 64*s12**2*s13*s14*s34 + 176*s12**2*s13*s34**2 + 64*s12**2*
     +    s14*s34**2 - 80*s12**2*s34**3 - 64*s12*s13**3*s14 + 32*s12*
     +    s13**3*s34 - 64*s12*s13**2*s14**2 - 16*s12*s13**2*s14*s34 + 
     +    16*s12*s13*s14**2*s34 + 16*s12*s13*s14*s34**2 - 16*s13**3*
     +    s14**2 - 16*s13**2*s14**3 - 16*s13**2*s14**2*s34 )

      LB = LB + Ld22(p4,p3,p12)*S23**(-1)*S123**(-1) * (  - 96*s12**3*
     +    s34 + 48*s12**2*s13*s14 + 48*s12**2*s13*s24 + 208*s12**2*s13*
     +    s34 - 32*s12**2*s24*s34 - 96*s12**2*s34**2 - 128*s12*s13**3
     +     - 64*s12*s13**2*s14 + 64*s12*s13**2*s24 + 64*s12*s13**2*s34
     +     + 16*s12*s13*s14**2 + 32*s12*s13*s14*s24 + 80*s12*s13*s14*
     +    s34 + 16*s12*s13*s24**2 + 32*s12*s13*s24*s34 + 48*s12*s13*
     +    s34**2 - 48*s13**3*s14 - 48*s13**3*s24 - 32*s13**2*s14**2 - 
     +    16*s13**2*s14*s34 + 32*s13**2*s24**2 + 16*s13**2*s24*s34 )

      LB = LB + Ld24(p1,p2,p34)*S14**(-1)*S23**(-1)*S134 * ( 16*s12*s13
     +    *s34 - 8*s13**2*s24 )

      LB = LB + Ld24(p1,p2,p34)*S14**(-1)*S134 * (  - 24*s13**2 )

      LB = LB + Ld24(p1,p2,p34)*S24**(-1)*S134 * ( 16*s12*s34 - 24*s13*
     +    s23 - 16*s14*s23 )

      LB = LB + Ld24(p1,p2,p34)*S134 * (  - 24*s13 )

      LB = LB + Ld24(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * ( 16*s12*s23
     +    *s34 - 8*s14*s23**2 )

      LB = LB + Ld24(p2,p1,p34)*S14**(-1)*S234 * ( 16*s12*s34 - 24*s13*
     +    s23 - 16*s13*s24 )

      LB = LB + Ld24(p2,p1,p34)*S24**(-1)*S234 * (  - 24*s23**2 )

      LB = LB + Ld24(p2,p1,p34)*S234 * (  - 24*s23 )

      LB = LB + Ld24(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234*
     + S124**(-1) * ( 24*s12**3*s23**2 + 16*s12**3*s23*s34 - 48*s12**2*
     +    s23**3 - 80*s12**2*s23**2*s34 - 32*s12**2*s23*s34**2 )

      LB = LB + Ld24(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234 * ( 
     +    24*s12**2*s23**2 + 24*s12**2*s23*s34 )

      LB = LB + Ld24(p3,p1,p24)*S13**(-1)*S14**(-1)*S234*S124**(-1)
     +  * ( 48*s12**2*s23**2 + 56*s12**2*s23*s34 + 16*s12**2*s34**2 )

      LB = LB + Ld24(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*S124**(-1)
     +  * ( 32*s12**2*s23**2 + 16*s12**2*s23*s34 + 8*s12*s14*s23**2 - 
     +    64*s12*s23**3 - 96*s12*s23**2*s34 - 32*s12*s23*s34**2 - 16*
     +    s14*s23**3 - 16*s14*s23**2*s34 )

      LB = LB + Ld24(p3,p1,p24)*S13**(-1)*S24**(-1)*S234 * ( 24*s12**2*
     +    s23 + 24*s12*s14*s23 + 24*s12*s23**2 + 24*s12*s23*s34 )

      LB = LB + Ld24(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * ( 24*s12**2
     +    *s23 + 16*s12**2*s34 + 8*s12*s14*s23 + 40*s12*s23**2 + 24*s12
     +    *s23*s34 + 8*s14*s23**2 )

      LB = LB + Ld24(p3,p1,p24)*S14**(-1)*S24**(-1)*S234 * ( 24*s12**2*
     +    s23 )

      LB = LB + Ld24(p3,p1,p24)*S14**(-1)*S234*S124**(-1) * ( 8*s12**2*
     +    s23 + 16*s12**2*s34 - 16*s12*s13*s24 + 80*s12*s23**2 - 32*s12
     +    *s23*s24 + 64*s12*s23*s34 - 16*s12*s24*s34 - 32*s13*s23*s24 )

      LB = LB + Ld24(p3,p1,p24)*S23**(-1)*S234*S124**(-1) * ( 24*s12*
     +    s13*s24 + 8*s12*s13*s34 + 24*s12*s14*s24 + 8*s12*s14*s34 + 24
     +    *s12*s24*s34 + 8*s12*s34**2 + 16*s13**2*s24 + 24*s13*s14*s24
     +     + 8*s13*s14*s34 + 16*s13*s24*s34 + 8*s14**2*s24 + 8*s14**2*
     +    s34 + 8*s14*s24*s34 + 8*s14*s34**2 )

      LB = LB + Ld24(p3,p1,p24)*S23**(-1)*S124**(-1) * (  - 24*s12*s13*
     +    s24**2 - 32*s12*s13*s24*s34 - 8*s12*s13*s34**2 - 24*s12*s14*
     +    s24**2 - 32*s12*s14*s24*s34 - 8*s12*s14*s34**2 - 24*s12*
     +    s24**2*s34 - 32*s12*s24*s34**2 - 8*s12*s34**3 - 16*s13**2*
     +    s24**2 - 16*s13**2*s24*s34 - 24*s13*s14*s24**2 - 32*s13*s14*
     +    s24*s34 - 8*s13*s14*s34**2 - 16*s13*s24**2*s34 - 16*s13*s24*
     +    s34**2 - 8*s14**2*s24**2 - 16*s14**2*s24*s34 - 8*s14**2*
     +    s34**2 - 8*s14*s24**2*s34 - 16*s14*s24*s34**2 - 8*s14*s34**3
     +     )

      LB = LB + Ld24(p3,p1,p24)*S24**(-1)*S234 * ( 24*s12*s23 )

      LB = LB + Ld24(p3,p1,p24)*S234*S124**(-1) * (  - 24*s12*s13 - 24*
     +    s12*s14 - 8*s12*s23 - 16*s12*s24 - 24*s12*s34 - 8*s13*s14 - 8
     +    *s14**2 - 8*s14*s34 + 48*s23**2 - 16*s23*s24 + 32*s23*s34 )

      LB = LB + Ld24(p3,p2,p14)*S13**(-1)*S134*S124**(-1) * ( 24*s12*
     +    s14*s23 + 24*s12*s14*s24 + 24*s12*s14*s34 + 8*s12*s23*s34 + 8
     +    *s12*s24*s34 + 8*s12*s34**2 + 16*s14*s23**2 + 24*s14*s23*s24
     +     + 16*s14*s23*s34 + 8*s14*s24**2 + 8*s14*s24*s34 + 8*s23*s24*
     +    s34 + 8*s24**2*s34 + 8*s24*s34**2 )

      LB = LB + Ld24(p3,p2,p14)*S13**(-1)*S124**(-1) * (  - 24*s12*
     +    s14**2*s23 - 24*s12*s14**2*s24 - 24*s12*s14**2*s34 - 32*s12*
     +    s14*s23*s34 - 32*s12*s14*s24*s34 - 32*s12*s14*s34**2 - 8*s12*
     +    s23*s34**2 - 8*s12*s24*s34**2 - 8*s12*s34**3 - 16*s14**2*
     +    s23**2 - 24*s14**2*s23*s24 - 16*s14**2*s23*s34 - 8*s14**2*
     +    s24**2 - 8*s14**2*s24*s34 - 16*s14*s23**2*s34 - 32*s14*s23*
     +    s24*s34 - 16*s14*s23*s34**2 - 16*s14*s24**2*s34 - 16*s14*s24*
     +    s34**2 - 8*s23*s24*s34**2 - 8*s24**2*s34**2 - 8*s24*s34**3 )

      LB = LB + Ld24(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * ( 24*s12**3*s13**2 + 16*s12**3*s13*s34 - 48*s12**2*
     +    s13**3 - 80*s12**2*s13**2*s34 - 32*s12**2*s13*s34**2 )

      LB = LB + Ld24(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +    24*s12**2*s13**2 + 24*s12**2*s13*s34 )

      LB = LB + Ld24(p3,p2,p14)*S14**(-1)*S23**(-1)*S134*S124**(-1)
     +  * ( 32*s12**2*s13**2 + 16*s12**2*s13*s34 - 64*s12*s13**3 + 8*
     +    s12*s13**2*s24 - 96*s12*s13**2*s34 - 32*s12*s13*s34**2 - 16*
     +    s13**3*s24 - 16*s13**2*s24*s34 )

      LB = LB + Ld24(p3,p2,p14)*S14**(-1)*S23**(-1)*S134 * ( 24*s12**2*
     +    s13 + 24*s12*s13**2 + 24*s12*s13*s24 + 24*s12*s13*s34 )

      LB = LB + Ld24(p3,p2,p14)*S14**(-1)*S24**(-1)*S134 * ( 24*s12**2*
     +    s13 )

      LB = LB + Ld24(p3,p2,p14)*S14**(-1)*S134 * ( 24*s12*s13 )

      LB = LB + Ld24(p3,p2,p14)*S23**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 48*s12**2*s13**2 + 56*s12**2*s13*s34 + 16*s12**2*s34**2 )

      LB = LB + Ld24(p3,p2,p14)*S23**(-1)*S134*S124**(-1) * ( 24*s12**2
     +    *s13 + 16*s12**2*s34 + 40*s12*s13**2 + 8*s12*s13*s24 + 24*s12
     +    *s13*s34 + 8*s13**2*s24 )

      LB = LB + Ld24(p3,p2,p14)*S24**(-1)*S134*S124**(-1) * ( 8*s12**2*
     +    s13 + 16*s12**2*s34 + 80*s12*s13**2 - 32*s12*s13*s14 + 64*s12
     +    *s13*s34 - 16*s12*s14*s23 - 16*s12*s14*s34 - 32*s13*s14*s23 )

      LB = LB + Ld24(p3,p2,p14)*S134*S124**(-1) * (  - 8*s12*s13 - 16*
     +    s12*s14 - 24*s12*s23 - 24*s12*s24 - 24*s12*s34 + 48*s13**2 - 
     +    16*s13*s14 + 32*s13*s34 - 8*s23*s24 - 8*s24**2 - 8*s24*s34 )

      LB = LB + Ld24(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * (  - 48*s12**4*s34**2 + 32*s12**3*s14*s34**2 - 48*
     +    s12**3*s34**3 )

      LB = LB + Ld24(p3,p4,p12)*S13**(-1)*S23**(-1)*S124**(-1) * (  - 
     +    16*s12**3*s34**2 )

      LB = LB + Ld24(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * (  - 48*s12**4*s34**2 - 144*s12**3*s13**2*s34 + 320
     +    *s12**3*s13*s34**2 - 112*s12**3*s34**3 + 16*s12**2*s13**3*s34
     +     - 112*s12**2*s13**2*s34**2 + 112*s12**2*s13*s34**3 - 16*
     +    s12**2*s34**4 )

      LB = LB + Ld24(p3,p4,p12)*S14**(-1)*S23**(-1)*S124**(-1) * ( 96*
     +    s12**3*s13*s34 - 64*s12**3*s34**2 + 48*s12**2*s13**3 - 48*
     +    s12**2*s13**2*s24 - 256*s12**2*s13**2*s34 + 128*s12**2*s13*
     +    s24*s34 + 240*s12**2*s13*s34**2 - 16*s12**2*s24*s34**2 - 32*
     +    s12**2*s34**3 + 64*s12*s13**3*s24 + 32*s12*s13**3*s34 - 64*
     +    s12*s13**2*s24**2 - 144*s12*s13**2*s24*s34 - 80*s12*s13**2*
     +    s34**2 + 32*s12*s13*s24**2*s34 + 64*s12*s13*s24*s34**2 + 32*
     +    s12*s13*s34**3 + 16*s13**3*s24**2 + 16*s13**3*s24*s34 - 16*
     +    s13**2*s24**3 - 32*s13**2*s24**2*s34 - 16*s13**2*s24*s34**2 )

      LB = LB + Ld24(p3,p4,p12)*S23**(-1)*S24**(-1)*S124**(-1) * (  - 
     +    240*s12**3*s13*s34 - 96*s12**3*s14*s34 + 448*s12**3*s34**2 + 
     +    48*s12**2*s13**3 + 48*s12**2*s13**2*s14 - 64*s12**2*s13*s14*
     +    s34 - 512*s12**2*s13*s34**2 - 96*s12**2*s14*s34**2 + 192*
     +    s12**2*s34**3 + 64*s12*s13**3*s14 + 32*s12*s13**3*s34 + 64*
     +    s12*s13**2*s14**2 + 80*s12*s13**2*s14*s34 + 16*s12*s13**2*
     +    s34**2 - 16*s12*s13*s14**2*s34 - 32*s12*s13*s14*s34**2 - 80*
     +    s12*s13*s34**3 + 16*s13**3*s14**2 + 16*s13**3*s14*s34 + 16*
     +    s13**2*s14**3 + 32*s13**2*s14**2*s34 + 16*s13**2*s14*s34**2 )

      LB = LB + Ld24(p3,p4,p12)*S23**(-1)*S124**(-1) * ( 96*s12**3*s34
     +     - 48*s12**2*s13*s14 - 48*s12**2*s13*s24 - 256*s12**2*s13*s34
     +     + 32*s12**2*s24*s34 + 128*s12**2*s34**2 + 128*s12*s13**3 + 
     +    64*s12*s13**2*s14 - 64*s12*s13**2*s24 - 64*s12*s13**2*s34 - 
     +    16*s12*s13*s14**2 - 32*s12*s13*s14*s24 - 96*s12*s13*s14*s34
     +     - 16*s12*s13*s24**2 - 48*s12*s13*s24*s34 - 112*s12*s13*
     +    s34**2 + 48*s13**3*s14 + 48*s13**3*s24 + 32*s13**3*s34 + 32*
     +    s13**2*s14**2 + 32*s13**2*s14*s34 - 32*s13**2*s24**2 - 32*
     +    s13**2*s24*s34 )

      LB = LB + Ld24(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S123**(-1)*S234 * ( 24*s12**3*s24**2 + 16*s12**3*s24*s34 - 48*
     +    s12**2*s24**3 - 80*s12**2*s24**2*s34 - 32*s12**2*s24*s34**2 )

      LB = LB + Ld24(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*S234 * ( 
     +    24*s12**2*s24**2 + 24*s12**2*s24*s34 )

      LB = LB + Ld24(p4,p1,p23)*S13**(-1)*S14**(-1)*S123**(-1)*S234
     +  * ( 48*s12**2*s24**2 + 56*s12**2*s24*s34 + 16*s12**2*s34**2 )

      LB = LB + Ld24(p4,p1,p23)*S13**(-1)*S23**(-1)*S234 * ( 24*s12**2*
     +    s24 )

      LB = LB + Ld24(p4,p1,p23)*S13**(-1)*S123**(-1)*S234 * ( 8*s12**2*
     +    s24 + 16*s12**2*s34 - 16*s12*s14*s23 - 32*s12*s23*s24 - 16*
     +    s12*s23*s34 + 80*s12*s24**2 + 64*s12*s24*s34 - 32*s14*s23*s24
     +     )

      LB = LB + Ld24(p4,p1,p23)*S14**(-1)*S23**(-1)*S123**(-1)*S234
     +  * ( 32*s12**2*s24**2 + 16*s12**2*s24*s34 + 8*s12*s13*s24**2 - 
     +    64*s12*s24**3 - 96*s12*s24**2*s34 - 32*s12*s24*s34**2 - 16*
     +    s13*s24**3 - 16*s13*s24**2*s34 )

      LB = LB + Ld24(p4,p1,p23)*S14**(-1)*S23**(-1)*S234 * ( 24*s12**2*
     +    s24 + 24*s12*s13*s24 + 24*s12*s24**2 + 24*s12*s24*s34 )

      LB = LB + Ld24(p4,p1,p23)*S14**(-1)*S123**(-1)*S234 * ( 24*s12**2
     +    *s24 + 16*s12**2*s34 + 8*s12*s13*s24 + 40*s12*s24**2 + 24*s12
     +    *s24*s34 + 8*s13*s24**2 )

      LB = LB + Ld24(p4,p1,p23)*S23**(-1)*S123**(-1)*S234 * (  - 24*s12
     +    *s13*s24 - 16*s12*s13*s34 - 24*s12*s14*s24 - 16*s12*s14*s34
     +     - 24*s12*s24*s34 - 16*s12*s34**2 - 8*s13**2*s24 - 24*s13*s14
     +    *s24 - 16*s13*s14*s34 - 8*s13*s24*s34 - 16*s14**2*s24 - 16*
     +    s14**2*s34 - 16*s14*s24*s34 - 16*s14*s34**2 )

      LB = LB + Ld24(p4,p1,p23)*S23**(-1)*S123**(-1) * ( 24*s12*s13*
     +    s24**2 + 40*s12*s13*s24*s34 + 16*s12*s13*s34**2 + 24*s12*s14*
     +    s24**2 + 40*s12*s14*s24*s34 + 16*s12*s14*s34**2 + 24*s12*
     +    s24**2*s34 + 40*s12*s24*s34**2 + 16*s12*s34**3 + 8*s13**2*
     +    s24**2 + 8*s13**2*s24*s34 + 24*s13*s14*s24**2 + 40*s13*s14*
     +    s24*s34 + 16*s13*s14*s34**2 + 8*s13*s24**2*s34 + 8*s13*s24*
     +    s34**2 + 16*s14**2*s24**2 + 32*s14**2*s24*s34 + 16*s14**2*
     +    s34**2 + 16*s14*s24**2*s34 + 32*s14*s24*s34**2 + 16*s14*
     +    s34**3 )

      LB = LB + Ld24(p4,p1,p23)*S23**(-1)*S234 * ( 24*s12*s24 )

      LB = LB + Ld24(p4,p1,p23)*S123**(-1)*S234 * (  - 16*s12*s23 - 8*
     +    s12*s24 + 16*s13*s14 + 16*s14**2 + 16*s14*s34 - 16*s23*s24 + 
     +    48*s24**2 + 32*s24*s34 )

      LB = LB + Ld24(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S134 * ( 24*s12**3*s14**2 + 16*s12**3*s14*s34 - 48*
     +    s12**2*s14**3 - 80*s12**2*s14**2*s34 - 32*s12**2*s14*s34**2 )

      LB = LB + Ld24(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +    24*s12**2*s14**2 + 24*s12**2*s14*s34 )

      LB = LB + Ld24(p4,p2,p13)*S13**(-1)*S23**(-1)*S134 * ( 24*s12**2*
     +    s14 )

      LB = LB + Ld24(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*S134
     +  * ( 32*s12**2*s14**2 + 16*s12**2*s14*s34 - 64*s12*s14**3 + 8*
     +    s12*s14**2*s23 - 96*s12*s14**2*s34 - 32*s12*s14*s34**2 - 16*
     +    s14**3*s23 - 16*s14**2*s23*s34 )

      LB = LB + Ld24(p4,p2,p13)*S13**(-1)*S24**(-1)*S134 * ( 24*s12**2*
     +    s14 + 24*s12*s14**2 + 24*s12*s14*s23 + 24*s12*s14*s34 )

      LB = LB + Ld24(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * (  - 24*s12
     +    *s14*s23 - 24*s12*s14*s24 - 24*s12*s14*s34 - 16*s12*s23*s34
     +     - 16*s12*s24*s34 - 16*s12*s34**2 - 8*s14*s23**2 - 24*s14*s23
     +    *s24 - 8*s14*s23*s34 - 16*s14*s24**2 - 16*s14*s24*s34 - 16*
     +    s23*s24*s34 - 16*s24**2*s34 - 16*s24*s34**2 )

      LB = LB + Ld24(p4,p2,p13)*S13**(-1)*S123**(-1) * ( 24*s12*s14**2*
     +    s23 + 24*s12*s14**2*s24 + 24*s12*s14**2*s34 + 40*s12*s14*s23*
     +    s34 + 40*s12*s14*s24*s34 + 40*s12*s14*s34**2 + 16*s12*s23*
     +    s34**2 + 16*s12*s24*s34**2 + 16*s12*s34**3 + 8*s14**2*s23**2
     +     + 24*s14**2*s23*s24 + 8*s14**2*s23*s34 + 16*s14**2*s24**2 + 
     +    16*s14**2*s24*s34 + 8*s14*s23**2*s34 + 40*s14*s23*s24*s34 + 8
     +    *s14*s23*s34**2 + 32*s14*s24**2*s34 + 32*s14*s24*s34**2 + 16*
     +    s23*s24*s34**2 + 16*s24**2*s34**2 + 16*s24*s34**3 )

      LB = LB + Ld24(p4,p2,p13)*S13**(-1)*S134 * ( 24*s12*s14 )

      LB = LB + Ld24(p4,p2,p13)*S23**(-1)*S24**(-1)*S123**(-1)*S134
     +  * ( 48*s12**2*s14**2 + 56*s12**2*s14*s34 + 16*s12**2*s34**2 )

      LB = LB + Ld24(p4,p2,p13)*S23**(-1)*S123**(-1)*S134 * ( 8*s12**2*
     +    s14 + 16*s12**2*s34 - 32*s12*s13*s14 - 16*s12*s13*s24 - 16*
     +    s12*s13*s34 + 80*s12*s14**2 + 64*s12*s14*s34 - 32*s13*s14*s24
     +     )

      LB = LB + Ld24(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * ( 24*s12**2
     +    *s14 + 16*s12**2*s34 + 40*s12*s14**2 + 8*s12*s14*s23 + 24*s12
     +    *s14*s34 + 8*s14**2*s23 )

      LB = LB + Ld24(p4,p2,p13)*S123**(-1)*S134 * (  - 16*s12*s13 - 8*
     +    s12*s14 - 16*s13*s14 + 48*s14**2 + 32*s14*s34 + 16*s23*s24 + 
     +    16*s24**2 + 16*s24*s34 )

      LB = LB + Ld24(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * (  - 48*s12**4*s34**2 - 144*s12**3*s14**2*s34 + 320
     +    *s12**3*s14*s34**2 - 112*s12**3*s34**3 + 16*s12**2*s14**3*s34
     +     - 112*s12**2*s14**2*s34**2 + 112*s12**2*s14*s34**3 - 16*
     +    s12**2*s34**4 )

      LB = LB + Ld24(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 96*
     +    s12**3*s14*s34 - 64*s12**3*s34**2 + 48*s12**2*s14**3 - 48*
     +    s12**2*s14**2*s23 - 256*s12**2*s14**2*s34 + 128*s12**2*s14*
     +    s23*s34 + 240*s12**2*s14*s34**2 - 16*s12**2*s23*s34**2 - 32*
     +    s12**2*s34**3 + 64*s12*s14**3*s23 + 32*s12*s14**3*s34 - 64*
     +    s12*s14**2*s23**2 - 144*s12*s14**2*s23*s34 - 80*s12*s14**2*
     +    s34**2 + 32*s12*s14*s23**2*s34 + 64*s12*s14*s23*s34**2 + 32*
     +    s12*s14*s34**3 + 16*s14**3*s23**2 + 16*s14**3*s23*s34 - 16*
     +    s14**2*s23**3 - 32*s14**2*s23**2*s34 - 16*s14**2*s23*s34**2 )

      LB = LB + Ld24(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * (  - 48*s12**4*s34**2 + 32*s12**3*s13*s34**2 - 48*
     +    s12**3*s34**3 )

      LB = LB + Ld24(p4,p3,p12)*S14**(-1)*S24**(-1)*S123**(-1) * (  - 
     +    16*s12**3*s34**2 )

      LB = LB + Ld24(p4,p3,p12)*S23**(-1)*S24**(-1)*S123**(-1) * (  - 
     +    96*s12**3*s13*s34 - 240*s12**3*s14*s34 + 448*s12**3*s34**2 + 
     +    48*s12**2*s13*s14**2 - 64*s12**2*s13*s14*s34 - 96*s12**2*s13*
     +    s34**2 + 48*s12**2*s14**3 - 512*s12**2*s14*s34**2 + 192*
     +    s12**2*s34**3 + 64*s12*s13**2*s14**2 - 16*s12*s13**2*s14*s34
     +     + 64*s12*s13*s14**3 + 80*s12*s13*s14**2*s34 - 32*s12*s13*s14
     +    *s34**2 + 32*s12*s14**3*s34 + 16*s12*s14**2*s34**2 - 80*s12*
     +    s14*s34**3 + 16*s13**3*s14**2 + 16*s13**2*s14**3 + 32*s13**2*
     +    s14**2*s34 + 16*s13*s14**3*s34 + 16*s13*s14**2*s34**2 )

      LB = LB + Ld24(p4,p3,p12)*S24**(-1)*S123**(-1) * ( 96*s12**3*s34
     +     - 48*s12**2*s13*s14 - 48*s12**2*s14*s23 - 256*s12**2*s14*s34
     +     + 32*s12**2*s23*s34 + 128*s12**2*s34**2 - 16*s12*s13**2*s14
     +     + 64*s12*s13*s14**2 - 32*s12*s13*s14*s23 - 96*s12*s13*s14*
     +    s34 + 128*s12*s14**3 - 64*s12*s14**2*s23 - 64*s12*s14**2*s34
     +     - 16*s12*s14*s23**2 - 48*s12*s14*s23*s34 - 112*s12*s14*
     +    s34**2 + 32*s13**2*s14**2 + 48*s13*s14**3 + 32*s13*s14**2*s34
     +     + 48*s14**3*s23 + 32*s14**3*s34 - 32*s14**2*s23**2 - 32*
     +    s14**2*s23*s34 )

      LB = LB + Ld311(p3,p1,p24)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1)*S234*S124**(-1) * ( 24*s12**4*s34**2 )

      LB = LB + Ld311(p3,p1,p24)*S13**(-1)*S14**(-1)*S23**(-1)*S234*
     + S124**(-1) * ( 48*s12**3*s34**2 + 24*s12**2*s24*s34**2 )

      LB = LB + Ld311(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234*
     + S124**(-1) * ( 24*s12**4*s23 + 48*s12**4*s34 )

      LB = LB + Ld311(p3,p1,p24)*S13**(-1)*S14**(-1)*S234*S124**(-1)
     +  * ( 48*s12**3*s23 + 96*s12**3*s34 + 24*s12**2*s23*s24 + 48*
     +    s12**2*s24*s34 )

      LB = LB + Ld311(p3,p1,p24)*S13**(-1)*S23**(-1)*S24**(-1)*S234*
     + S124**(-1) * ( 24*s12**4*s34 + 24*s12**3*s14*s34 + 24*s12**3*
     +    s34**2 )

      LB = LB + Ld311(p3,p1,p24)*S13**(-1)*S23**(-1)*S234*S124**(-1)
     +  * ( 48*s12**3*s34 + 48*s12**2*s14*s34 + 24*s12**2*s24*s34 + 48*
     +    s12**2*s34**2 + 24*s12*s14*s24*s34 + 24*s12*s24*s34**2 )

      LB = LB + Ld311(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*S124**(-1)
     +  * ( 24*s12**4 + 24*s12**3*s14 + 24*s12**3*s23 + 48*s12**3*s34 )

      LB = LB + Ld311(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * ( 48*
     +    s12**3 + 48*s12**2*s14 + 48*s12**2*s23 + 24*s12**2*s24 + 96*
     +    s12**2*s34 + 24*s12*s14*s24 + 24*s12*s23*s24 + 48*s12*s24*s34
     +     )

      LB = LB + Ld311(p3,p1,p24)*S14**(-1)*S23**(-1)*S24**(-1)*S234*
     + S124**(-1) * ( 16*s12**4*s13 + 40*s12**4*s34 )

      LB = LB + Ld311(p3,p1,p24)*S14**(-1)*S23**(-1)*S234*S124**(-1)
     +  * ( 24*s12**3*s13 + 72*s12**3*s34 + 24*s12**2*s24*s34 - 8*s12*
     +    s13*s24**2 - 8*s12*s24**2*s34 )

      LB = LB + Ld311(p3,p1,p24)*S14**(-1)*S24**(-1)*S234*S124**(-1)
     +  * ( 40*s12**4 )

      LB = LB + Ld311(p3,p1,p24)*S14**(-1)*S234*S124**(-1) * ( 72*
     +    s12**3 + 24*s12**2*s24 - 8*s12*s24**2 )

      LB = LB + Ld311(p3,p1,p24)*S23**(-1)*S24**(-1)*S234*S124**(-1)
     +  * ( 16*s12**4 + 16*s12**3*s13 + 16*s12**3*s14 + 40*s12**3*s34 )

      LB = LB + Ld311(p3,p1,p24)*S23**(-1)*S234*S124**(-1) * ( 24*
     +    s12**3 + 24*s12**2*s13 + 24*s12**2*s14 + 72*s12**2*s34 - 8*
     +    s12*s24**2 + 24*s12*s24*s34 - 8*s13*s24**2 - 8*s14*s24**2 - 8
     +    *s24**2*s34 )

      LB = LB + Ld311(p3,p1,p24)*S24**(-1)*S234*S124**(-1) * ( 40*
     +    s12**3 )

      LB = LB + Ld311(p3,p1,p24)*S234*S124**(-1) * ( 72*s12**2 + 24*s12
     +    *s24 - 8*s24**2 )

      LB = LB + Ld311(p3,p2,p14)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1)*S134*S124**(-1) * ( 24*s12**4*s34**2 )

      LB = LB + Ld311(p3,p2,p14)*S13**(-1)*S14**(-1)*S23**(-1)*S134*
     + S124**(-1) * ( 24*s12**4*s34 + 24*s12**3*s24*s34 + 24*s12**3*
     +    s34**2 )

      LB = LB + Ld311(p3,p2,p14)*S13**(-1)*S14**(-1)*S24**(-1)*S134*
     + S124**(-1) * ( 16*s12**4*s23 + 40*s12**4*s34 )

      LB = LB + Ld311(p3,p2,p14)*S13**(-1)*S14**(-1)*S134*S124**(-1)
     +  * ( 16*s12**4 + 16*s12**3*s23 + 16*s12**3*s24 + 40*s12**3*s34 )

      LB = LB + Ld311(p3,p2,p14)*S13**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * ( 48*s12**3*s34**2 + 24*s12**2*s14*s34**2 )

      LB = LB + Ld311(p3,p2,p14)*S13**(-1)*S23**(-1)*S134*S124**(-1)
     +  * ( 48*s12**3*s34 + 24*s12**2*s14*s34 + 48*s12**2*s24*s34 + 48*
     +    s12**2*s34**2 + 24*s12*s14*s24*s34 + 24*s12*s14*s34**2 )

      LB = LB + Ld311(p3,p2,p14)*S13**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 24*s12**3*s23 + 72*s12**3*s34 + 24*s12**2*s14*s34 - 8*s12*
     +    s14**2*s23 - 8*s12*s14**2*s34 )

      LB = LB + Ld311(p3,p2,p14)*S13**(-1)*S134*S124**(-1) * ( 24*
     +    s12**3 + 24*s12**2*s23 + 24*s12**2*s24 + 72*s12**2*s34 - 8*
     +    s12*s14**2 + 24*s12*s14*s34 - 8*s14**2*s23 - 8*s14**2*s24 - 8
     +    *s14**2*s34 )

      LB = LB + Ld311(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * ( 24*s12**4*s13 + 48*s12**4*s34 )

      LB = LB + Ld311(p3,p2,p14)*S14**(-1)*S23**(-1)*S134*S124**(-1)
     +  * ( 24*s12**4 + 24*s12**3*s13 + 24*s12**3*s24 + 48*s12**3*s34 )

      LB = LB + Ld311(p3,p2,p14)*S14**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 40*s12**4 )

      LB = LB + Ld311(p3,p2,p14)*S14**(-1)*S134*S124**(-1) * ( 40*
     +    s12**3 )

      LB = LB + Ld311(p3,p2,p14)*S23**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 48*s12**3*s13 + 96*s12**3*s34 + 24*s12**2*s13*s14 + 48*
     +    s12**2*s14*s34 )

      LB = LB + Ld311(p3,p2,p14)*S23**(-1)*S134*S124**(-1) * ( 48*
     +    s12**3 + 48*s12**2*s13 + 24*s12**2*s14 + 48*s12**2*s24 + 96*
     +    s12**2*s34 + 24*s12*s13*s14 + 24*s12*s14*s24 + 48*s12*s14*s34
     +     )

      LB = LB + Ld311(p3,p2,p14)*S24**(-1)*S134*S124**(-1) * ( 72*
     +    s12**3 + 24*s12**2*s14 - 8*s12*s14**2 )

      LB = LB + Ld311(p3,p2,p14)*S134*S124**(-1) * ( 72*s12**2 + 24*s12
     +    *s14 - 8*s14**2 )

      LB = LB + Ld311(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1)*S123**(-1)*S234 * ( 24*s12**4*s34**2 )

      LB = LB + Ld311(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S123**(-1)*S234 * ( 24*s12**4*s24 + 48*s12**4*s34 )

      LB = LB + Ld311(p4,p1,p23)*S13**(-1)*S14**(-1)*S24**(-1)*
     + S123**(-1)*S234 * ( 48*s12**3*s34**2 + 24*s12**2*s23*s34**2 )

      LB = LB + Ld311(p4,p1,p23)*S13**(-1)*S14**(-1)*S123**(-1)*S234
     +  * ( 48*s12**3*s24 + 96*s12**3*s34 + 24*s12**2*s23*s24 + 48*
     +    s12**2*s23*s34 )

      LB = LB + Ld311(p4,p1,p23)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S234 * ( 16*s12**4*s14 + 40*s12**4*s34 )

      LB = LB + Ld311(p4,p1,p23)*S13**(-1)*S23**(-1)*S123**(-1)*S234
     +  * ( 40*s12**4 )

      LB = LB + Ld311(p4,p1,p23)*S13**(-1)*S24**(-1)*S123**(-1)*S234
     +  * ( 24*s12**3*s14 + 72*s12**3*s34 + 24*s12**2*s23*s34 - 8*s12*
     +    s14*s23**2 - 8*s12*s23**2*s34 )

      LB = LB + Ld311(p4,p1,p23)*S13**(-1)*S123**(-1)*S234 * ( 72*
     +    s12**3 + 24*s12**2*s23 - 8*s12*s23**2 )

      LB = LB + Ld311(p4,p1,p23)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S234 * ( 24*s12**4*s34 + 24*s12**3*s13*s34 + 24*
     +    s12**3*s34**2 )

      LB = LB + Ld311(p4,p1,p23)*S14**(-1)*S23**(-1)*S123**(-1)*S234
     +  * ( 24*s12**4 + 24*s12**3*s13 + 24*s12**3*s24 + 48*s12**3*s34 )

      LB = LB + Ld311(p4,p1,p23)*S14**(-1)*S24**(-1)*S123**(-1)*S234
     +  * ( 48*s12**3*s34 + 48*s12**2*s13*s34 + 24*s12**2*s23*s34 + 48*
     +    s12**2*s34**2 + 24*s12*s13*s23*s34 + 24*s12*s23*s34**2 )

      LB = LB + Ld311(p4,p1,p23)*S14**(-1)*S123**(-1)*S234 * ( 48*
     +    s12**3 + 48*s12**2*s13 + 24*s12**2*s23 + 48*s12**2*s24 + 96*
     +    s12**2*s34 + 24*s12*s13*s23 + 24*s12*s23*s24 + 48*s12*s23*s34
     +     )

      LB = LB + Ld311(p4,p1,p23)*S23**(-1)*S24**(-1)*S123**(-1)*S234
     +  * ( 16*s12**4 + 16*s12**3*s13 + 16*s12**3*s14 + 40*s12**3*s34 )

      LB = LB + Ld311(p4,p1,p23)*S23**(-1)*S123**(-1)*S234 * ( 40*
     +    s12**3 )

      LB = LB + Ld311(p4,p1,p23)*S24**(-1)*S123**(-1)*S234 * ( 24*
     +    s12**3 + 24*s12**2*s13 + 24*s12**2*s14 + 72*s12**2*s34 - 8*
     +    s12*s23**2 + 24*s12*s23*s34 - 8*s13*s23**2 - 8*s14*s23**2 - 8
     +    *s23**2*s34 )

      LB = LB + Ld311(p4,p1,p23)*S123**(-1)*S234 * ( 72*s12**2 + 24*s12
     +    *s23 - 8*s23**2 )

      LB = LB + Ld311(p4,p2,p13)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1)*S123**(-1)*S134 * ( 24*s12**4*s34**2 )

      LB = LB + Ld311(p4,p2,p13)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S123**(-1)*S134 * ( 16*s12**4*s24 + 40*s12**4*s34 )

      LB = LB + Ld311(p4,p2,p13)*S13**(-1)*S14**(-1)*S24**(-1)*
     + S123**(-1)*S134 * ( 24*s12**4*s34 + 24*s12**3*s23*s34 + 24*
     +    s12**3*s34**2 )

      LB = LB + Ld311(p4,p2,p13)*S13**(-1)*S14**(-1)*S123**(-1)*S134
     +  * ( 16*s12**4 + 16*s12**3*s23 + 16*s12**3*s24 + 40*s12**3*s34 )

      LB = LB + Ld311(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S134 * ( 24*s12**4*s14 + 48*s12**4*s34 )

      LB = LB + Ld311(p4,p2,p13)*S13**(-1)*S23**(-1)*S123**(-1)*S134
     +  * ( 40*s12**4 )

      LB = LB + Ld311(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*S134
     +  * ( 24*s12**4 + 24*s12**3*s14 + 24*s12**3*s23 + 48*s12**3*s34 )

      LB = LB + Ld311(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * ( 40*
     +    s12**3 )

      LB = LB + Ld311(p4,p2,p13)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S134 * ( 48*s12**3*s34**2 + 24*s12**2*s13*s34**2 )

      LB = LB + Ld311(p4,p2,p13)*S14**(-1)*S23**(-1)*S123**(-1)*S134
     +  * ( 24*s12**3*s24 + 72*s12**3*s34 + 24*s12**2*s13*s34 - 8*s12*
     +    s13**2*s24 - 8*s12*s13**2*s34 )

      LB = LB + Ld311(p4,p2,p13)*S14**(-1)*S24**(-1)*S123**(-1)*S134
     +  * ( 48*s12**3*s34 + 24*s12**2*s13*s34 + 48*s12**2*s23*s34 + 48*
     +    s12**2*s34**2 + 24*s12*s13*s23*s34 + 24*s12*s13*s34**2 )

      LB = LB + Ld311(p4,p2,p13)*S14**(-1)*S123**(-1)*S134 * ( 24*
     +    s12**3 + 24*s12**2*s23 + 24*s12**2*s24 + 72*s12**2*s34 - 8*
     +    s12*s13**2 + 24*s12*s13*s34 - 8*s13**2*s23 - 8*s13**2*s24 - 8
     +    *s13**2*s34 )

      LB = LB + Ld311(p4,p2,p13)*S23**(-1)*S24**(-1)*S123**(-1)*S134
     +  * ( 48*s12**3*s14 + 96*s12**3*s34 + 24*s12**2*s13*s14 + 48*
     +    s12**2*s13*s34 )

      LB = LB + Ld311(p4,p2,p13)*S23**(-1)*S123**(-1)*S134 * ( 72*
     +    s12**3 + 24*s12**2*s13 - 8*s12*s13**2 )

      LB = LB + Ld311(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * ( 48*
     +    s12**3 + 24*s12**2*s13 + 48*s12**2*s14 + 48*s12**2*s23 + 96*
     +    s12**2*s34 + 24*s12*s13*s14 + 24*s12*s13*s23 + 48*s12*s13*s34
     +     )

      LB = LB + Ld311(p4,p2,p13)*S123**(-1)*S134 * ( 72*s12**2 + 24*s12
     +    *s13 - 8*s13**2 )

      LBh=-LB/s134/s234
      
      return
      end

      function LBi(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      SF=(s13*s24-s14*s23)/2d0/s34

      LB=0d0

      LB = LB + Ld314(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234*
     + S124**(-1) * (  - 72*s12**3*s23**2 - 120*s12**3*s23*s34 - 48*
     +    s12**3*s34**2 )

      LB = LB + Ld314(p3,p1,p24)*S13**(-1)*S14**(-1)*S234*S124**(-1)
     +  * (  - 72*s12**2*s23**2 - 120*s12**2*s23*s34 - 48*s12**2*s34**2
     +     )

      LB = LB + Ld314(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*S124**(-1)
     +  * (  - 72*s12**3*s23 - 48*s12**3*s34 - 96*s12**2*s14*s23 - 48*
     +    s12**2*s14*s34 - 96*s12**2*s23**2 - 144*s12**2*s23*s34 - 48*
     +    s12**2*s34**2 - 24*s12*s14**2*s23 - 24*s12*s14*s23**2 - 24*
     +    s12*s14*s23*s34 )

      LB = LB + Ld314(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * (  - 72*
     +    s12**2*s23 - 48*s12**2*s34 - 96*s12*s14*s23 - 48*s12*s14*s34
     +     - 96*s12*s23**2 - 144*s12*s23*s34 - 48*s12*s34**2 - 24*
     +    s14**2*s23 - 24*s14*s23**2 - 24*s14*s23*s34 )

      LB = LB + Ld314(p3,p1,p24)*S14**(-1)*S24**(-1)*S234*S124**(-1)
     +  * (  - 24*s12**3*s13 - 96*s12**3*s23 - 72*s12**3*s34 )

      LB = LB + Ld314(p3,p1,p24)*S14**(-1)*S234*S124**(-1) * (  - 72*
     +    s12**2*s23 - 48*s12**2*s34 + 24*s12*s13*s24 + 24*s12*s23*s24
     +     + 24*s12*s24*s34 )

      LB = LB + Ld314(p3,p1,p24)*S24**(-1)*S234*S124**(-1) * (  - 24*
     +    s12**3 - 24*s12**2*s13 - 24*s12**2*s14 - 120*s12**2*s23 - 72*
     +    s12**2*s34 - 24*s12*s14*s23 )

      LB = LB + Ld314(p3,p1,p24)*S234*S124**(-1) * (  - 96*s12*s23 + 24
     +    *s12*s24 - 48*s12*s34 + 24*s13*s24 - 24*s14*s23 + 24*s14*s24
     +     + 24*s23*s24 + 24*s24*s34 )

      LB = LB + Ld314(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * (  - 72*s12**3*s13**2 - 120*s12**3*s13*s34 - 48*
     +    s12**3*s34**2 )

      LB = LB + Ld314(p3,p2,p14)*S14**(-1)*S23**(-1)*S134*S124**(-1)
     +  * (  - 72*s12**3*s13 - 48*s12**3*s34 - 96*s12**2*s13**2 - 96*
     +    s12**2*s13*s24 - 144*s12**2*s13*s34 - 48*s12**2*s24*s34 - 48*
     +    s12**2*s34**2 - 24*s12*s13**2*s24 - 24*s12*s13*s24**2 - 24*
     +    s12*s13*s24*s34 )

      LB = LB + Ld314(p3,p2,p14)*S14**(-1)*S24**(-1)*S134*S124**(-1)
     +  * (  - 96*s12**3*s13 - 24*s12**3*s23 - 72*s12**3*s34 )

      LB = LB + Ld314(p3,p2,p14)*S14**(-1)*S134*S124**(-1) * (  - 24*
     +    s12**3 - 120*s12**2*s13 - 24*s12**2*s23 - 24*s12**2*s24 - 72*
     +    s12**2*s34 - 24*s12*s13*s24 )

      LB = LB + Ld314(p3,p2,p14)*S23**(-1)*S24**(-1)*S134*S124**(-1)
     +  * (  - 72*s12**2*s13**2 - 120*s12**2*s13*s34 - 48*s12**2*s34**2
     +     )

      LB = LB + Ld314(p3,p2,p14)*S23**(-1)*S134*S124**(-1) * (  - 72*
     +    s12**2*s13 - 48*s12**2*s34 - 96*s12*s13**2 - 96*s12*s13*s24
     +     - 144*s12*s13*s34 - 48*s12*s24*s34 - 48*s12*s34**2 - 24*
     +    s13**2*s24 - 24*s13*s24**2 - 24*s13*s24*s34 )

      LB = LB + Ld314(p3,p2,p14)*S24**(-1)*S134*S124**(-1) * (  - 72*
     +    s12**2*s13 - 48*s12**2*s34 + 24*s12*s13*s14 + 24*s12*s14*s23
     +     + 24*s12*s14*s34 )

      LB = LB + Ld314(p3,p2,p14)*S134*S124**(-1) * (  - 96*s12*s13 + 24
     +    *s12*s14 - 48*s12*s34 + 24*s13*s14 - 24*s13*s24 + 24*s14*s23
     +     + 24*s14*s24 + 24*s14*s34 )

      LB = LB + Ld314(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S123**(-1)*S234 * (  - 72*s12**3*s24**2 - 120*s12**3*s24*s34 - 
     +    48*s12**3*s34**2 )

      LB = LB + Ld314(p4,p1,p23)*S13**(-1)*S14**(-1)*S123**(-1)*S234
     +  * (  - 72*s12**2*s24**2 - 120*s12**2*s24*s34 - 48*s12**2*s34**2
     +     )

      LB = LB + Ld314(p4,p1,p23)*S13**(-1)*S23**(-1)*S123**(-1)*S234
     +  * (  - 24*s12**3*s14 - 96*s12**3*s24 - 72*s12**3*s34 )

      LB = LB + Ld314(p4,p1,p23)*S13**(-1)*S123**(-1)*S234 * (  - 72*
     +    s12**2*s24 - 48*s12**2*s34 + 24*s12*s14*s23 + 24*s12*s23*s24
     +     + 24*s12*s23*s34 )

      LB = LB + Ld314(p4,p1,p23)*S14**(-1)*S23**(-1)*S123**(-1)*S234
     +  * (  - 72*s12**3*s24 - 48*s12**3*s34 - 96*s12**2*s13*s24 - 48*
     +    s12**2*s13*s34 - 96*s12**2*s24**2 - 144*s12**2*s24*s34 - 48*
     +    s12**2*s34**2 - 24*s12*s13**2*s24 - 24*s12*s13*s24**2 - 24*
     +    s12*s13*s24*s34 )

      LB = LB + Ld314(p4,p1,p23)*S14**(-1)*S123**(-1)*S234 * (  - 72*
     +    s12**2*s24 - 48*s12**2*s34 - 96*s12*s13*s24 - 48*s12*s13*s34
     +     - 96*s12*s24**2 - 144*s12*s24*s34 - 48*s12*s34**2 - 24*
     +    s13**2*s24 - 24*s13*s24**2 - 24*s13*s24*s34 )

      LB = LB + Ld314(p4,p1,p23)*S23**(-1)*S123**(-1)*S234 * (  - 24*
     +    s12**3 - 24*s12**2*s13 - 24*s12**2*s14 - 120*s12**2*s24 - 72*
     +    s12**2*s34 - 24*s12*s13*s24 )

      LB = LB + Ld314(p4,p1,p23)*S123**(-1)*S234 * ( 24*s12*s23 - 96*
     +    s12*s24 - 48*s12*s34 + 24*s13*s23 - 24*s13*s24 + 24*s14*s23
     +     + 24*s23*s24 + 24*s23*s34 )

      LB = LB + Ld314(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S134 * (  - 72*s12**3*s14**2 - 120*s12**3*s14*s34 - 
     +    48*s12**3*s34**2 )

      LB = LB + Ld314(p4,p2,p13)*S13**(-1)*S23**(-1)*S123**(-1)*S134
     +  * (  - 96*s12**3*s14 - 24*s12**3*s24 - 72*s12**3*s34 )

      LB = LB + Ld314(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*S134
     +  * (  - 72*s12**3*s14 - 48*s12**3*s34 - 96*s12**2*s14**2 - 96*
     +    s12**2*s14*s23 - 144*s12**2*s14*s34 - 48*s12**2*s23*s34 - 48*
     +    s12**2*s34**2 - 24*s12*s14**2*s23 - 24*s12*s14*s23**2 - 24*
     +    s12*s14*s23*s34 )

      LB = LB + Ld314(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * (  - 24*
     +    s12**3 - 120*s12**2*s14 - 24*s12**2*s23 - 24*s12**2*s24 - 72*
     +    s12**2*s34 - 24*s12*s14*s23 )

      LB = LB + Ld314(p4,p2,p13)*S23**(-1)*S24**(-1)*S123**(-1)*S134
     +  * (  - 72*s12**2*s14**2 - 120*s12**2*s14*s34 - 48*s12**2*s34**2
     +     )

      LB = LB + Ld314(p4,p2,p13)*S23**(-1)*S123**(-1)*S134 * (  - 72*
     +    s12**2*s14 - 48*s12**2*s34 + 24*s12*s13*s14 + 24*s12*s13*s24
     +     + 24*s12*s13*s34 )

      LB = LB + Ld314(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * (  - 72*
     +    s12**2*s14 - 48*s12**2*s34 - 96*s12*s14**2 - 96*s12*s14*s23
     +     - 144*s12*s14*s34 - 48*s12*s23*s34 - 48*s12*s34**2 - 24*
     +    s14**2*s23 - 24*s14*s23**2 - 24*s14*s23*s34 )

      LB = LB + Ld314(p4,p2,p13)*S123**(-1)*S134 * ( 24*s12*s13 - 96*
     +    s12*s14 - 48*s12*s34 + 24*s13*s14 + 24*s13*s23 + 24*s13*s24
     +     + 24*s13*s34 - 24*s14*s23 )

      LB = LB + Ld322(p3,p1,p24)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1)*S234*S124**(-1) * ( 8*s12**4*s34**2 )

      LB = LB + Ld322(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234*
     + S124**(-1) * ( 32*s12**4*s23 + 40*s12**4*s34 )

      LB = LB + Ld322(p3,p1,p24)*S13**(-1)*S23**(-1)*S24**(-1)*S234*
     + S124**(-1) * ( 8*s12**4*s34 + 8*s12**3*s14*s34 + 8*s12**3*s34**2
     +     )

      LB = LB + Ld322(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*S124**(-1)
     +  * ( 32*s12**4 + 56*s12**3*s14 + 56*s12**3*s23 + 64*s12**3*s34
     +     + 24*s12**2*s14**2 + 24*s12**2*s14*s23 + 24*s12**2*s14*s34 )

      LB = LB + Ld322(p3,p1,p24)*S14**(-1)*S23**(-1)*S24**(-1)*S234*
     + S124**(-1) * (  - 16*s12**4*s13 - 8*s12**4*s34 )

      LB = LB + Ld322(p3,p1,p24)*S14**(-1)*S23**(-1)*S234*S124**(-1)
     +  * (  - 24*s12**3*s13 - 24*s12**3*s34 )

      LB = LB + Ld322(p3,p1,p24)*S14**(-1)*S24**(-1)*S234*S124**(-1)
     +  * ( 16*s12**4 )

      LB = LB + Ld322(p3,p1,p24)*S14**(-1)*S234*S124**(-1) * (  - 24*
     +    s12**3 )

      LB = LB + Ld322(p3,p1,p24)*S23**(-1)*S24**(-1)*S234*S124**(-1)
     +  * (  - 16*s12**4 - 16*s12**3*s13 - 16*s12**3*s14 - 8*s12**3*s34
     +     )

      LB = LB + Ld322(p3,p1,p24)*S23**(-1)*S234*S124**(-1) * (  - 24*
     +    s12**3 - 24*s12**2*s13 - 24*s12**2*s14 - 24*s12**2*s34 )

      LB = LB + Ld322(p3,p1,p24)*S24**(-1)*S234*S124**(-1) * ( 40*
     +    s12**3 + 24*s12**2*s14 )

      LB = LB + Ld322(p3,p1,p24)*S234*S124**(-1) * (  - 24*s12**2 )

      LB = LB + Ld322(p3,p2,p14)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1)*S134*S124**(-1) * ( 8*s12**4*s34**2 )

      LB = LB + Ld322(p3,p2,p14)*S13**(-1)*S14**(-1)*S23**(-1)*S134*
     + S124**(-1) * ( 8*s12**4*s34 + 8*s12**3*s24*s34 + 8*s12**3*s34**2
     +     )

      LB = LB + Ld322(p3,p2,p14)*S13**(-1)*S14**(-1)*S24**(-1)*S134*
     + S124**(-1) * (  - 16*s12**4*s23 - 8*s12**4*s34 )

      LB = LB + Ld322(p3,p2,p14)*S13**(-1)*S14**(-1)*S134*S124**(-1)
     +  * (  - 16*s12**4 - 16*s12**3*s23 - 16*s12**3*s24 - 8*s12**3*s34
     +     )

      LB = LB + Ld322(p3,p2,p14)*S13**(-1)*S24**(-1)*S134*S124**(-1)
     +  * (  - 24*s12**3*s23 - 24*s12**3*s34 )

      LB = LB + Ld322(p3,p2,p14)*S13**(-1)*S134*S124**(-1) * (  - 24*
     +    s12**3 - 24*s12**2*s23 - 24*s12**2*s24 - 24*s12**2*s34 )

      LB = LB + Ld322(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * ( 32*s12**4*s13 + 40*s12**4*s34 )

      LB = LB + Ld322(p3,p2,p14)*S14**(-1)*S23**(-1)*S134*S124**(-1)
     +  * ( 32*s12**4 + 56*s12**3*s13 + 56*s12**3*s24 + 64*s12**3*s34
     +     + 24*s12**2*s13*s24 + 24*s12**2*s24**2 + 24*s12**2*s24*s34 )

      LB = LB + Ld322(p3,p2,p14)*S14**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 16*s12**4 )

      LB = LB + Ld322(p3,p2,p14)*S14**(-1)*S134*S124**(-1) * ( 40*
     +    s12**3 + 24*s12**2*s24 )

      LB = LB + Ld322(p3,p2,p14)*S24**(-1)*S134*S124**(-1) * (  - 24*
     +    s12**3 )

      LB = LB + Ld322(p3,p2,p14)*S134*S124**(-1) * (  - 24*s12**2 )

      LB = LB + Ld322(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1)*S123**(-1)*S234 * ( 8*s12**4*s34**2 )

      LB = LB + Ld322(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S123**(-1)*S234 * ( 32*s12**4*s24 + 40*s12**4*s34 )

      LB = LB + Ld322(p4,p1,p23)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S234 * (  - 16*s12**4*s14 - 8*s12**4*s34 )

      LB = LB + Ld322(p4,p1,p23)*S13**(-1)*S23**(-1)*S123**(-1)*S234
     +  * ( 16*s12**4 )

      LB = LB + Ld322(p4,p1,p23)*S13**(-1)*S24**(-1)*S123**(-1)*S234
     +  * (  - 24*s12**3*s14 - 24*s12**3*s34 )

      LB = LB + Ld322(p4,p1,p23)*S13**(-1)*S123**(-1)*S234 * (  - 24*
     +    s12**3 )

      LB = LB + Ld322(p4,p1,p23)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S234 * ( 8*s12**4*s34 + 8*s12**3*s13*s34 + 8*s12**3*
     +    s34**2 )

      LB = LB + Ld322(p4,p1,p23)*S14**(-1)*S23**(-1)*S123**(-1)*S234
     +  * ( 32*s12**4 + 56*s12**3*s13 + 56*s12**3*s24 + 64*s12**3*s34
     +     + 24*s12**2*s13**2 + 24*s12**2*s13*s24 + 24*s12**2*s13*s34 )

      LB = LB + Ld322(p4,p1,p23)*S23**(-1)*S24**(-1)*S123**(-1)*S234
     +  * (  - 16*s12**4 - 16*s12**3*s13 - 16*s12**3*s14 - 8*s12**3*s34
     +     )

      LB = LB + Ld322(p4,p1,p23)*S23**(-1)*S123**(-1)*S234 * ( 40*
     +    s12**3 + 24*s12**2*s13 )

      LB = LB + Ld322(p4,p1,p23)*S24**(-1)*S123**(-1)*S234 * (  - 24*
     +    s12**3 - 24*s12**2*s13 - 24*s12**2*s14 - 24*s12**2*s34 )

      LB = LB + Ld322(p4,p1,p23)*S123**(-1)*S234 * (  - 24*s12**2 )

      LB = LB + Ld322(p4,p2,p13)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1)*S123**(-1)*S134 * ( 8*s12**4*s34**2 )

      LB = LB + Ld322(p4,p2,p13)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S123**(-1)*S134 * (  - 16*s12**4*s24 - 8*s12**4*s34 )

      LB = LB + Ld322(p4,p2,p13)*S13**(-1)*S14**(-1)*S24**(-1)*
     + S123**(-1)*S134 * ( 8*s12**4*s34 + 8*s12**3*s23*s34 + 8*s12**3*
     +    s34**2 )

      LB = LB + Ld322(p4,p2,p13)*S13**(-1)*S14**(-1)*S123**(-1)*S134
     +  * (  - 16*s12**4 - 16*s12**3*s23 - 16*s12**3*s24 - 8*s12**3*s34
     +     )

      LB = LB + Ld322(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S134 * ( 32*s12**4*s14 + 40*s12**4*s34 )

      LB = LB + Ld322(p4,p2,p13)*S13**(-1)*S23**(-1)*S123**(-1)*S134
     +  * ( 16*s12**4 )

      LB = LB + Ld322(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*S134
     +  * ( 32*s12**4 + 56*s12**3*s14 + 56*s12**3*s23 + 64*s12**3*s34
     +     + 24*s12**2*s14*s23 + 24*s12**2*s23**2 + 24*s12**2*s23*s34 )

      LB = LB + Ld322(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * ( 40*
     +    s12**3 + 24*s12**2*s23 )

      LB = LB + Ld322(p4,p2,p13)*S14**(-1)*S23**(-1)*S123**(-1)*S134
     +  * (  - 24*s12**3*s24 - 24*s12**3*s34 )

      LB = LB + Ld322(p4,p2,p13)*S14**(-1)*S123**(-1)*S134 * (  - 24*
     +    s12**3 - 24*s12**2*s23 - 24*s12**2*s24 - 24*s12**2*s34 )

      LB = LB + Ld322(p4,p2,p13)*S23**(-1)*S123**(-1)*S134 * (  - 24*
     +    s12**3 )

      LB = LB + Ld322(p4,p2,p13)*S123**(-1)*S134 * (  - 24*s12**2 )

      LB = LB + Ld344(p3,p1,p24)*S13**(-1)*S14**(-1)*S24**(-1)*S234*
     + S124**(-1) * ( 32*s12**2*s23**3 + 56*s12**2*s23**2*s34 + 24*
     +    s12**2*s23*s34**2 )

      LB = LB + Ld344(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*S124**(-1)
     +  * ( 32*s12**2*s23**2 + 24*s12**2*s23*s34 + 40*s12*s14*s23**2 + 
     +    24*s12*s14*s23*s34 + 40*s12*s23**3 + 64*s12*s23**2*s34 + 24*
     +    s12*s23*s34**2 + 8*s14**2*s23**2 + 8*s14*s23**3 + 8*s14*
     +    s23**2*s34 )

      LB = LB + Ld344(p3,p1,p24)*S14**(-1)*S24**(-1)*S234*S124**(-1)
     +  * ( 24*s12**2*s13*s23 + 56*s12**2*s23**2 + 48*s12**2*s23*s34 )

      LB = LB + Ld344(p3,p1,p24)*S24**(-1)*S234*S124**(-1) * ( 24*
     +    s12**2*s23 + 24*s12*s13*s23 + 24*s12*s14*s23 + 64*s12*s23**2
     +     + 48*s12*s23*s34 + 8*s14*s23**2 )

      LB = LB + Ld344(p3,p2,p14)*S14**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * ( 32*s12**2*s13**3 + 56*s12**2*s13**2*s34 + 24*
     +    s12**2*s13*s34**2 )

      LB = LB + Ld344(p3,p2,p14)*S14**(-1)*S23**(-1)*S134*S124**(-1)
     +  * ( 32*s12**2*s13**2 + 24*s12**2*s13*s34 + 40*s12*s13**3 + 40*
     +    s12*s13**2*s24 + 64*s12*s13**2*s34 + 24*s12*s13*s24*s34 + 24*
     +    s12*s13*s34**2 + 8*s13**3*s24 + 8*s13**2*s24**2 + 8*s13**2*
     +    s24*s34 )

      LB = LB + Ld344(p3,p2,p14)*S14**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 56*s12**2*s13**2 + 24*s12**2*s13*s23 + 48*s12**2*s13*s34 )

      LB = LB + Ld344(p3,p2,p14)*S14**(-1)*S134*S124**(-1) * ( 24*
     +    s12**2*s13 + 64*s12*s13**2 + 24*s12*s13*s23 + 24*s12*s13*s24
     +     + 48*s12*s13*s34 + 8*s13**2*s24 )

      LB = LB + Ld344(p4,p1,p23)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S123**(-1)*S234 * ( 32*s12**2*s24**3 + 56*s12**2*s24**2*s34 + 24
     +    *s12**2*s24*s34**2 )

      LB = LB + Ld344(p4,p1,p23)*S13**(-1)*S23**(-1)*S123**(-1)*S234
     +  * ( 24*s12**2*s14*s24 + 56*s12**2*s24**2 + 48*s12**2*s24*s34 )

      LB = LB + Ld344(p4,p1,p23)*S14**(-1)*S23**(-1)*S123**(-1)*S234
     +  * ( 32*s12**2*s24**2 + 24*s12**2*s24*s34 + 40*s12*s13*s24**2 + 
     +    24*s12*s13*s24*s34 + 40*s12*s24**3 + 64*s12*s24**2*s34 + 24*
     +    s12*s24*s34**2 + 8*s13**2*s24**2 + 8*s13*s24**3 + 8*s13*
     +    s24**2*s34 )

      LB = LB + Ld344(p4,p1,p23)*S23**(-1)*S123**(-1)*S234 * ( 24*
     +    s12**2*s24 + 24*s12*s13*s24 + 24*s12*s14*s24 + 64*s12*s24**2
     +     + 48*s12*s24*s34 + 8*s13*s24**2 )

      LB = LB + Ld344(p4,p2,p13)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S134 * ( 32*s12**2*s14**3 + 56*s12**2*s14**2*s34 + 24
     +    *s12**2*s14*s34**2 )

      LB = LB + Ld344(p4,p2,p13)*S13**(-1)*S23**(-1)*S123**(-1)*S134
     +  * ( 56*s12**2*s14**2 + 24*s12**2*s14*s24 + 48*s12**2*s14*s34 )

      LB = LB + Ld344(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*S134
     +  * ( 32*s12**2*s14**2 + 24*s12**2*s14*s34 + 40*s12*s14**3 + 40*
     +    s12*s14**2*s23 + 64*s12*s14**2*s34 + 24*s12*s14*s23*s34 + 24*
     +    s12*s14*s34**2 + 8*s14**3*s23 + 8*s14**2*s23**2 + 8*s14**2*
     +    s23*s34 )

      LB = LB + Ld344(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * ( 24*
     +    s12**2*s14 + 64*s12*s14**2 + 24*s12*s14*s23 + 24*s12*s14*s24
     +     + 48*s12*s14*s34 + 8*s14**2*s23 )

      LB = LB + Le1(p1,p2,p3,p4)*S13**(-1)*S23**(-1) * (  - 8*s12**3*
     +    s14*s24 - 8*s12**3*s14*s34 - 8*s12**3*s24**2 - 16*s12**3*s24*
     +    s34 - 8*s12**3*s34**2 + 8*s12**2*s14**2*s24 + 8*s12**2*s14**2
     +    *s34 + 8*s12**2*s14*s24**2 + 24*s12**2*s14*s24*s34 + 16*
     +    s12**2*s14*s34**2 + 8*s12**2*s24**2*s34 + 16*s12**2*s24*
     +    s34**2 + 8*s12**2*s34**3 )

      LB = LB + Le1(p1,p2,p3,p4)*S13**(-1)*S24**(-1) * (  - 24*s12**4*
     +    s34 + 24*s12**3*s14*s23 - 48*s12**3*s14*s34 - 24*s12**3*s23*
     +    s34 - 24*s12**3*s34**2 + 48*s12**2*s14**2*s23 + 24*s12**2*s14
     +    *s23**2 + 16*s12**2*s14*s23*s34 - 8*s12**2*s23*s34**2 + 8*s12
     +    *s14**2*s23**2 + 8*s12*s14*s23**2*s34 + 8*s12*s14*s34**3 + 8*
     +    s12*s34**4 - 8*s14**2*s23*s34**2 - 8*s14*s23*s34**3 )

      LB = LB + Le1(p1,p2,p3,p4)*S13**(-1) * (  - 8*s12**4 - 16*s12**3*
     +    s14 - 8*s12**3*s23 - 16*s12**3*s24 - 24*s12**3*s34 + 32*
     +    s12**2*s14**2 + 40*s12**2*s14*s23 + 32*s12**2*s14*s24 + 64*
     +    s12**2*s14*s34 + 8*s12**2*s23*s34 + 16*s12**2*s24*s34 + 24*
     +    s12**2*s34**2 + 8*s12*s14**2*s34 + 16*s12*s14*s23*s34 + 8*s12
     +    *s14*s24*s34 + 24*s12*s14*s34**2 + 8*s12*s23*s34**2 + 8*s12*
     +    s24*s34**2 + 16*s12*s34**3 )

      LB = LB + Le1(p1,p2,p3,p4)*S14**(-1)*S24**(-1) * (  - 16*s12**4*
     +    s34 - 48*s12**3*s13*s34 - 56*s12**2*s13**2*s34 - 32*s12*
     +    s13**3*s34 - 8*s13**4*s34 )

      LB = LB + Le1(p1,p2,p3,p4)*S23**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s13*s34**2 - 8*s12**2*s14*s34**2 - 8*s12**2*s34**3 - 16*s12*
     +    s13**2*s34**2 - 24*s12*s13*s14*s34**2 - 16*s12*s13*s34**3 - 8
     +    *s12*s14**2*s34**2 - 8*s12*s14*s34**3 - 8*s13**3*s34**2 - 16*
     +    s13**2*s14*s34**2 - 8*s13**2*s34**3 - 8*s13*s14**2*s34**2 - 8
     +    *s13*s14*s34**3 )

      LB = LB + Le1(p1,p2,p3,p4)*S24**(-1) * ( 16*s12**3*s23 - 80*
     +    s12**3*s34 + 16*s12**2*s13*s23 - 120*s12**2*s13*s34 + 40*
     +    s12**2*s14*s23 - 88*s12**2*s14*s34 - 48*s12**2*s23*s34 - 40*
     +    s12**2*s34**2 + 8*s12*s13**2*s23 - 72*s12*s13**2*s34 + 16*s12
     +    *s13*s14*s23 - 56*s12*s13*s14*s34 - 40*s12*s13*s23*s34 - 40*
     +    s12*s13*s34**2 + 8*s12*s14**2*s23 - 16*s12*s14**2*s34 + 8*s12
     +    *s14*s23**2 - 40*s12*s14*s23*s34 - 48*s12*s14*s34**2 - 24*s12
     +    *s23*s34**2 - 24*s12*s34**3 - 16*s13**3*s34 - 8*s13**2*s14*
     +    s34 - 8*s13**2*s23*s34 - 16*s13**2*s34**2 - 8*s13*s14*s23*s34
     +     - 32*s13*s14*s34**2 - 8*s13*s23*s34**2 - 16*s13*s34**3 - 16*
     +    s14**2*s34**2 - 16*s14*s23*s34**2 - 16*s14*s34**3 - 8*s23*
     +    s34**3 )

      LB = LB + Le1(p1,p2,p4,p3)*S13**(-1)*S23**(-1) * (  - 16*s12**4*
     +    s34 - 48*s12**3*s14*s34 - 56*s12**2*s14**2*s34 - 32*s12*
     +    s14**3*s34 - 8*s14**4*s34 )

      LB = LB + Le1(p1,p2,p4,p3)*S14**(-1)*S23**(-1) * (  - 24*s12**4*
     +    s34 + 24*s12**3*s13*s24 - 48*s12**3*s13*s34 - 24*s12**3*s24*
     +    s34 - 24*s12**3*s34**2 + 48*s12**2*s13**2*s24 + 24*s12**2*s13
     +    *s24**2 + 16*s12**2*s13*s24*s34 - 8*s12**2*s24*s34**2 + 8*s12
     +    *s13**2*s24**2 + 8*s12*s13*s24**2*s34 + 8*s12*s13*s34**3 + 8*
     +    s12*s34**4 - 8*s13**2*s24*s34**2 - 8*s13*s24*s34**3 )

      LB = LB + Le1(p1,p2,p4,p3)*S14**(-1)*S24**(-1) * (  - 8*s12**3*
     +    s13*s23 - 8*s12**3*s13*s34 - 8*s12**3*s23**2 - 16*s12**3*s23*
     +    s34 - 8*s12**3*s34**2 + 8*s12**2*s13**2*s23 + 8*s12**2*s13**2
     +    *s34 + 8*s12**2*s13*s23**2 + 24*s12**2*s13*s23*s34 + 16*
     +    s12**2*s13*s34**2 + 8*s12**2*s23**2*s34 + 16*s12**2*s23*
     +    s34**2 + 8*s12**2*s34**3 )

      LB = LB + Le1(p1,p2,p4,p3)*S14**(-1) * (  - 8*s12**4 - 16*s12**3*
     +    s13 - 16*s12**3*s23 - 8*s12**3*s24 - 24*s12**3*s34 + 32*
     +    s12**2*s13**2 + 32*s12**2*s13*s23 + 40*s12**2*s13*s24 + 64*
     +    s12**2*s13*s34 + 16*s12**2*s23*s34 + 8*s12**2*s24*s34 + 24*
     +    s12**2*s34**2 + 8*s12*s13**2*s34 + 8*s12*s13*s23*s34 + 16*s12
     +    *s13*s24*s34 + 24*s12*s13*s34**2 + 8*s12*s23*s34**2 + 8*s12*
     +    s24*s34**2 + 16*s12*s34**3 )

      LB = LB + Le1(p1,p2,p4,p3)*S23**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s13*s34**2 - 8*s12**2*s14*s34**2 - 8*s12**2*s34**3 - 8*s12*
     +    s13**2*s34**2 - 24*s12*s13*s14*s34**2 - 8*s12*s13*s34**3 - 16
     +    *s12*s14**2*s34**2 - 16*s12*s14*s34**3 - 8*s13**2*s14*s34**2
     +     - 16*s13*s14**2*s34**2 - 8*s13*s14*s34**3 - 8*s14**3*s34**2
     +     - 8*s14**2*s34**3 )

      LB = LB + Le1(p1,p2,p4,p3)*S23**(-1) * ( 16*s12**3*s24 - 80*
     +    s12**3*s34 + 40*s12**2*s13*s24 - 88*s12**2*s13*s34 + 16*
     +    s12**2*s14*s24 - 120*s12**2*s14*s34 - 48*s12**2*s24*s34 - 40*
     +    s12**2*s34**2 + 8*s12*s13**2*s24 - 16*s12*s13**2*s34 + 16*s12
     +    *s13*s14*s24 - 56*s12*s13*s14*s34 + 8*s12*s13*s24**2 - 40*s12
     +    *s13*s24*s34 - 48*s12*s13*s34**2 + 8*s12*s14**2*s24 - 72*s12*
     +    s14**2*s34 - 40*s12*s14*s24*s34 - 40*s12*s14*s34**2 - 24*s12*
     +    s24*s34**2 - 24*s12*s34**3 - 16*s13**2*s34**2 - 8*s13*s14**2*
     +    s34 - 8*s13*s14*s24*s34 - 32*s13*s14*s34**2 - 16*s13*s24*
     +    s34**2 - 16*s13*s34**3 - 16*s14**3*s34 - 8*s14**2*s24*s34 - 
     +    16*s14**2*s34**2 - 8*s14*s24*s34**2 - 16*s14*s34**3 - 8*s24*
     +    s34**3 )

      LB = LB + Le1(p2,p1,p3,p4)*S13**(-1)*S14**(-1) * (  - 8*s12**2*
     +    s23*s34**2 - 8*s12**2*s24*s34**2 - 8*s12**2*s34**3 - 16*s12*
     +    s23**2*s34**2 - 24*s12*s23*s24*s34**2 - 16*s12*s23*s34**3 - 8
     +    *s12*s24**2*s34**2 - 8*s12*s24*s34**3 - 8*s23**3*s34**2 - 16*
     +    s23**2*s24*s34**2 - 8*s23**2*s34**3 - 8*s23*s24**2*s34**2 - 8
     +    *s23*s24*s34**3 )

      LB = LB + Le1(p2,p1,p3,p4)*S13**(-1)*S23**(-1) * (  - 8*s12**3*
     +    s14**2 - 8*s12**3*s14*s24 - 16*s12**3*s14*s34 - 8*s12**3*s24*
     +    s34 - 8*s12**3*s34**2 + 8*s12**2*s14**2*s24 + 8*s12**2*s14**2
     +    *s34 + 8*s12**2*s14*s24**2 + 24*s12**2*s14*s24*s34 + 16*
     +    s12**2*s14*s34**2 + 8*s12**2*s24**2*s34 + 16*s12**2*s24*
     +    s34**2 + 8*s12**2*s34**3 )

      LB = LB + Le1(p2,p1,p3,p4)*S14**(-1)*S23**(-1) * (  - 24*s12**4*
     +    s34 + 24*s12**3*s13*s24 - 24*s12**3*s13*s34 - 48*s12**3*s24*
     +    s34 - 24*s12**3*s34**2 + 24*s12**2*s13**2*s24 + 48*s12**2*s13
     +    *s24**2 + 16*s12**2*s13*s24*s34 - 8*s12**2*s13*s34**2 + 8*s12
     +    *s13**2*s24**2 + 8*s12*s13**2*s24*s34 + 8*s12*s24*s34**3 + 8*
     +    s12*s34**4 - 8*s13*s24**2*s34**2 - 8*s13*s24*s34**3 )

      LB = LB + Le1(p2,p1,p3,p4)*S14**(-1)*S24**(-1) * (  - 16*s12**4*
     +    s34 - 48*s12**3*s23*s34 - 56*s12**2*s23**2*s34 - 32*s12*
     +    s23**3*s34 - 8*s23**4*s34 )

      LB = LB + Le1(p2,p1,p3,p4)*S14**(-1) * ( 16*s12**3*s13 - 80*
     +    s12**3*s34 + 16*s12**2*s13*s23 + 40*s12**2*s13*s24 - 48*
     +    s12**2*s13*s34 - 120*s12**2*s23*s34 - 88*s12**2*s24*s34 - 40*
     +    s12**2*s34**2 + 8*s12*s13**2*s24 + 8*s12*s13*s23**2 + 16*s12*
     +    s13*s23*s24 - 40*s12*s13*s23*s34 + 8*s12*s13*s24**2 - 40*s12*
     +    s13*s24*s34 - 24*s12*s13*s34**2 - 72*s12*s23**2*s34 - 56*s12*
     +    s23*s24*s34 - 40*s12*s23*s34**2 - 16*s12*s24**2*s34 - 48*s12*
     +    s24*s34**2 - 24*s12*s34**3 - 8*s13*s23**2*s34 - 8*s13*s23*s24
     +    *s34 - 8*s13*s23*s34**2 - 16*s13*s24*s34**2 - 8*s13*s34**3 - 
     +    16*s23**3*s34 - 8*s23**2*s24*s34 - 16*s23**2*s34**2 - 32*s23*
     +    s24*s34**2 - 16*s23*s34**3 - 16*s24**2*s34**2 - 16*s24*s34**3
     +     )

      LB = LB + Le1(p2,p1,p3,p4)*S23**(-1) * (  - 8*s12**4 - 8*s12**3*
     +    s13 - 16*s12**3*s14 - 16*s12**3*s24 - 24*s12**3*s34 + 40*
     +    s12**2*s13*s24 + 8*s12**2*s13*s34 + 32*s12**2*s14*s24 + 16*
     +    s12**2*s14*s34 + 32*s12**2*s24**2 + 64*s12**2*s24*s34 + 24*
     +    s12**2*s34**2 + 16*s12*s13*s24*s34 + 8*s12*s13*s34**2 + 8*s12
     +    *s14*s24*s34 + 8*s12*s14*s34**2 + 8*s12*s24**2*s34 + 24*s12*
     +    s24*s34**2 + 16*s12*s34**3 )

      LB = LB + Le1(p2,p1,p4,p3)*S13**(-1)*S14**(-1) * (  - 8*s12**2*
     +    s23*s34**2 - 8*s12**2*s24*s34**2 - 8*s12**2*s34**3 - 8*s12*
     +    s23**2*s34**2 - 24*s12*s23*s24*s34**2 - 8*s12*s23*s34**3 - 16
     +    *s12*s24**2*s34**2 - 16*s12*s24*s34**3 - 8*s23**2*s24*s34**2
     +     - 16*s23*s24**2*s34**2 - 8*s23*s24*s34**3 - 8*s24**3*s34**2
     +     - 8*s24**2*s34**3 )

      LB = LB + Le1(p2,p1,p4,p3)*S13**(-1)*S23**(-1) * (  - 16*s12**4*
     +    s34 - 48*s12**3*s24*s34 - 56*s12**2*s24**2*s34 - 32*s12*
     +    s24**3*s34 - 8*s24**4*s34 )

      LB = LB + Le1(p2,p1,p4,p3)*S13**(-1)*S24**(-1) * (  - 24*s12**4*
     +    s34 + 24*s12**3*s14*s23 - 24*s12**3*s14*s34 - 48*s12**3*s23*
     +    s34 - 24*s12**3*s34**2 + 24*s12**2*s14**2*s23 + 48*s12**2*s14
     +    *s23**2 + 16*s12**2*s14*s23*s34 - 8*s12**2*s14*s34**2 + 8*s12
     +    *s14**2*s23**2 + 8*s12*s14**2*s23*s34 + 8*s12*s23*s34**3 + 8*
     +    s12*s34**4 - 8*s14*s23**2*s34**2 - 8*s14*s23*s34**3 )

      LB = LB + Le1(p2,p1,p4,p3)*S13**(-1) * ( 16*s12**3*s14 - 80*
     +    s12**3*s34 + 40*s12**2*s14*s23 + 16*s12**2*s14*s24 - 48*
     +    s12**2*s14*s34 - 88*s12**2*s23*s34 - 120*s12**2*s24*s34 - 40*
     +    s12**2*s34**2 + 8*s12*s14**2*s23 + 8*s12*s14*s23**2 + 16*s12*
     +    s14*s23*s24 - 40*s12*s14*s23*s34 + 8*s12*s14*s24**2 - 40*s12*
     +    s14*s24*s34 - 24*s12*s14*s34**2 - 16*s12*s23**2*s34 - 56*s12*
     +    s23*s24*s34 - 48*s12*s23*s34**2 - 72*s12*s24**2*s34 - 40*s12*
     +    s24*s34**2 - 24*s12*s34**3 - 8*s14*s23*s24*s34 - 16*s14*s23*
     +    s34**2 - 8*s14*s24**2*s34 - 8*s14*s24*s34**2 - 8*s14*s34**3
     +     - 16*s23**2*s34**2 - 8*s23*s24**2*s34 - 32*s23*s24*s34**2 - 
     +    16*s23*s34**3 - 16*s24**3*s34 - 16*s24**2*s34**2 - 16*s24*
     +    s34**3 )

      LB = LB + Le1(p2,p1,p4,p3)*S14**(-1)*S24**(-1) * (  - 8*s12**3*
     +    s13**2 - 8*s12**3*s13*s23 - 16*s12**3*s13*s34 - 8*s12**3*s23*
     +    s34 - 8*s12**3*s34**2 + 8*s12**2*s13**2*s23 + 8*s12**2*s13**2
     +    *s34 + 8*s12**2*s13*s23**2 + 24*s12**2*s13*s23*s34 + 16*
     +    s12**2*s13*s34**2 + 8*s12**2*s23**2*s34 + 16*s12**2*s23*
     +    s34**2 + 8*s12**2*s34**3 )

      LB = LB + Le1(p2,p1,p4,p3)*S24**(-1) * (  - 8*s12**4 - 16*s12**3*
     +    s13 - 8*s12**3*s14 - 16*s12**3*s23 - 24*s12**3*s34 + 32*
     +    s12**2*s13*s23 + 16*s12**2*s13*s34 + 40*s12**2*s14*s23 + 8*
     +    s12**2*s14*s34 + 32*s12**2*s23**2 + 64*s12**2*s23*s34 + 24*
     +    s12**2*s34**2 + 8*s12*s13*s23*s34 + 8*s12*s13*s34**2 + 16*s12
     +    *s14*s23*s34 + 8*s12*s14*s34**2 + 8*s12*s23**2*s34 + 24*s12*
     +    s23*s34**2 + 16*s12*s34**3 )

      LB = LB + Le1(p3,p1,p2,p4)*S13**(-1)*S14**(-1) * ( 16*s12**3*s23*
     +    s34 + 16*s12**3*s24*s34 + 16*s12**3*s34**2 - 16*s12**2*s23**2
     +    *s24 + 16*s12**2*s23**2*s34 - 16*s12**2*s23*s24**2 + 16*
     +    s12**2*s23*s34**2 - 16*s12*s23**3*s24 + 8*s12*s23**3*s34 - 16
     +    *s12*s23**2*s24**2 - 8*s12*s23**2*s24*s34 + 8*s12*s23**2*
     +    s34**2 - 8*s23**4*s24 - 8*s23**3*s24**2 - 8*s23**3*s24*s34 )

      LB = LB + Le1(p3,p1,p2,p4)*S13**(-1) * ( 16*s12**3*s23 + 16*
     +    s12**3*s24 + 16*s12**3*s34 + 16*s12**2*s14*s23 + 16*s12**2*
     +    s14*s24 + 16*s12**2*s14*s34 + 16*s12**2*s23**2 + 16*s12**2*
     +    s23*s24 + 32*s12**2*s23*s34 + 16*s12**2*s24*s34 + 16*s12**2*
     +    s34**2 + 8*s12*s14**2*s23 + 8*s12*s14**2*s24 + 8*s12*s14**2*
     +    s34 + 32*s12*s14*s23**2 + 32*s12*s14*s23*s24 + 40*s12*s14*s23
     +    *s34 + 8*s12*s14*s24*s34 + 8*s12*s14*s34**2 + 8*s12*s23**3 + 
     +    8*s12*s23**2*s24 + 40*s12*s23**2*s34 + 32*s12*s23*s24*s34 + 
     +    32*s12*s23*s34**2 + 16*s14**2*s23**2 + 16*s14**2*s23*s24 + 16
     +    *s14**2*s23*s34 + 16*s14*s23**3 + 24*s14*s23**2*s24 + 40*s14*
     +    s23**2*s34 + 8*s14*s23*s24**2 + 32*s14*s23*s24*s34 + 24*s14*
     +    s23*s34**2 + 16*s23**3*s34 + 24*s23**2*s24*s34 + 24*s23**2*
     +    s34**2 + 8*s23*s24**2*s34 + 16*s23*s24*s34**2 + 8*s23*s34**3
     +     )

      LB = LB + Le1(p3,p1,p2,p4)*S14**(-1) * ( 16*s12**3*s23 + 16*
     +    s12**3*s24 + 16*s12**3*s34 + 16*s12**2*s23**2 + 16*s12**2*s23
     +    *s24 + 16*s12**2*s23*s34 + 8*s12*s23**3 + 8*s12*s23**2*s24 + 
     +    8*s12*s23**2*s34 )

      LB = LB + Le1(p3,p1,p2,p4)*S23**(-1)*S24**(-1) * (  - 16*s12**3*
     +    s13*s34 - 16*s12**3*s14*s34 - 16*s12**3*s34**2 + 16*s12**2*
     +    s13**2*s14 + 16*s12**2*s13*s14**2 - 16*s12**2*s14**2*s34 - 16
     +    *s12**2*s14*s34**2 + 16*s12*s13**2*s14**2 + 16*s12*s13*s14**3
     +     + 8*s12*s13*s14**2*s34 - 8*s12*s14**3*s34 - 8*s12*s14**2*
     +    s34**2 + 8*s13**2*s14**3 + 8*s13*s14**4 + 8*s13*s14**3*s34 )

      LB = LB + Le1(p3,p1,p2,p4)*S23**(-1) * (  - 16*s12**3*s13 - 16*
     +    s12**3*s14 - 16*s12**3*s34 - 16*s12**2*s13*s14 - 16*s12**2*
     +    s14**2 - 16*s12**2*s14*s34 - 8*s12*s13*s14**2 - 8*s12*s14**3
     +     - 8*s12*s14**2*s34 )

      LB = LB + Le1(p3,p1,p2,p4)*S24**(-1) * (  - 16*s12**3*s13 - 16*
     +    s12**3*s14 - 16*s12**3*s34 - 16*s12**2*s13*s14 - 16*s12**2*
     +    s13*s23 - 16*s12**2*s13*s34 - 16*s12**2*s14**2 - 16*s12**2*
     +    s14*s23 - 32*s12**2*s14*s34 - 16*s12**2*s23*s34 - 16*s12**2*
     +    s34**2 - 8*s12*s13*s14**2 - 32*s12*s13*s14*s23 - 32*s12*s13*
     +    s14*s34 - 8*s12*s13*s23**2 - 8*s12*s13*s23*s34 - 8*s12*s14**3
     +     - 32*s12*s14**2*s23 - 40*s12*s14**2*s34 - 8*s12*s14*s23**2
     +     - 40*s12*s14*s23*s34 - 32*s12*s14*s34**2 - 8*s12*s23**2*s34
     +     - 8*s12*s23*s34**2 - 8*s13**2*s14*s23 - 8*s13**2*s14*s34 - 
     +    24*s13*s14**2*s23 - 24*s13*s14**2*s34 - 16*s13*s14*s23**2 - 
     +    32*s13*s14*s23*s34 - 16*s13*s14*s34**2 - 16*s14**3*s23 - 16*
     +    s14**3*s34 - 16*s14**2*s23**2 - 40*s14**2*s23*s34 - 24*s14**2
     +    *s34**2 - 16*s14*s23**2*s34 - 24*s14*s23*s34**2 - 8*s14*
     +    s34**3 )

      LB = LB + Le1(p3,p1,p2,p4) * (  - 32*s12**2*s13 - 32*s12**2*s14
     +     + 32*s12**2*s23 + 32*s12**2*s24 - 48*s12*s13*s14 - 8*s12*s13
     +    *s23 - 48*s12*s14**2 + 8*s12*s14*s24 - 40*s12*s14*s34 + 48*
     +    s12*s23**2 + 48*s12*s23*s24 + 40*s12*s23*s34 - 8*s13**2*s14
     +     - 32*s13*s14**2 - 24*s13*s14*s23 - 8*s13*s14*s24 - 24*s13*
     +    s14*s34 + 8*s13*s23**2 + 8*s13*s23*s24 + 8*s13*s23*s34 - 24*
     +    s14**3 - 24*s14**2*s23 - 8*s14**2*s24 - 40*s14**2*s34 + 24*
     +    s14*s23**2 + 24*s14*s23*s24 - 8*s14*s24*s34 - 16*s14*s34**2
     +     + 24*s23**3 + 32*s23**2*s24 + 40*s23**2*s34 + 8*s23*s24**2
     +     + 24*s23*s24*s34 + 16*s23*s34**2 )

      LB = LB + Le1(p3,p2,p1,p4)*S13**(-1)*S14**(-1) * (  - 16*s12**3*
     +    s23*s34 - 16*s12**3*s24*s34 - 16*s12**3*s34**2 + 16*s12**2*
     +    s23**2*s24 + 16*s12**2*s23*s24**2 - 16*s12**2*s24**2*s34 - 16
     +    *s12**2*s24*s34**2 + 16*s12*s23**2*s24**2 + 16*s12*s23*s24**3
     +     + 8*s12*s23*s24**2*s34 - 8*s12*s24**3*s34 - 8*s12*s24**2*
     +    s34**2 + 8*s23**2*s24**3 + 8*s23*s24**4 + 8*s23*s24**3*s34 )

      LB = LB + Le1(p3,p2,p1,p4)*S13**(-1) * (  - 16*s12**3*s23 - 16*
     +    s12**3*s24 - 16*s12**3*s34 - 16*s12**2*s23*s24 - 16*s12**2*
     +    s24**2 - 16*s12**2*s24*s34 - 8*s12*s23*s24**2 - 8*s12*s24**3
     +     - 8*s12*s24**2*s34 )

      LB = LB + Le1(p3,p2,p1,p4)*S14**(-1) * (  - 16*s12**3*s23 - 16*
     +    s12**3*s24 - 16*s12**3*s34 - 16*s12**2*s13*s23 - 16*s12**2*
     +    s13*s24 - 16*s12**2*s13*s34 - 16*s12**2*s23*s24 - 16*s12**2*
     +    s23*s34 - 16*s12**2*s24**2 - 32*s12**2*s24*s34 - 16*s12**2*
     +    s34**2 - 8*s12*s13**2*s23 - 8*s12*s13**2*s24 - 8*s12*s13**2*
     +    s34 - 32*s12*s13*s23*s24 - 8*s12*s13*s23*s34 - 32*s12*s13*
     +    s24**2 - 40*s12*s13*s24*s34 - 8*s12*s13*s34**2 - 8*s12*s23*
     +    s24**2 - 32*s12*s23*s24*s34 - 8*s12*s24**3 - 40*s12*s24**2*
     +    s34 - 32*s12*s24*s34**2 - 16*s13**2*s23*s24 - 16*s13**2*
     +    s24**2 - 16*s13**2*s24*s34 - 8*s13*s23**2*s24 - 24*s13*s23*
     +    s24**2 - 32*s13*s23*s24*s34 - 16*s13*s24**3 - 40*s13*s24**2*
     +    s34 - 24*s13*s24*s34**2 - 8*s23**2*s24*s34 - 24*s23*s24**2*
     +    s34 - 16*s23*s24*s34**2 - 16*s24**3*s34 - 24*s24**2*s34**2 - 
     +    8*s24*s34**3 )

      LB = LB + Le1(p3,p2,p1,p4)*S23**(-1)*S24**(-1) * ( 16*s12**3*s13*
     +    s34 + 16*s12**3*s14*s34 + 16*s12**3*s34**2 - 16*s12**2*s13**2
     +    *s14 + 16*s12**2*s13**2*s34 - 16*s12**2*s13*s14**2 + 16*
     +    s12**2*s13*s34**2 - 16*s12*s13**3*s14 + 8*s12*s13**3*s34 - 16
     +    *s12*s13**2*s14**2 - 8*s12*s13**2*s14*s34 + 8*s12*s13**2*
     +    s34**2 - 8*s13**4*s14 - 8*s13**3*s14**2 - 8*s13**3*s14*s34 )

      LB = LB + Le1(p3,p2,p1,p4)*S23**(-1) * ( 16*s12**3*s13 + 16*
     +    s12**3*s14 + 16*s12**3*s34 + 16*s12**2*s13**2 + 16*s12**2*s13
     +    *s14 + 16*s12**2*s13*s24 + 32*s12**2*s13*s34 + 16*s12**2*s14*
     +    s24 + 16*s12**2*s14*s34 + 16*s12**2*s24*s34 + 16*s12**2*
     +    s34**2 + 8*s12*s13**3 + 8*s12*s13**2*s14 + 32*s12*s13**2*s24
     +     + 40*s12*s13**2*s34 + 32*s12*s13*s14*s24 + 32*s12*s13*s14*
     +    s34 + 8*s12*s13*s24**2 + 40*s12*s13*s24*s34 + 32*s12*s13*
     +    s34**2 + 8*s12*s14*s24**2 + 8*s12*s14*s24*s34 + 8*s12*s24**2*
     +    s34 + 8*s12*s24*s34**2 + 16*s13**3*s24 + 16*s13**3*s34 + 24*
     +    s13**2*s14*s24 + 24*s13**2*s14*s34 + 16*s13**2*s24**2 + 40*
     +    s13**2*s24*s34 + 24*s13**2*s34**2 + 8*s13*s14**2*s24 + 8*s13*
     +    s14**2*s34 + 16*s13*s14*s24**2 + 32*s13*s14*s24*s34 + 16*s13*
     +    s14*s34**2 + 16*s13*s24**2*s34 + 24*s13*s24*s34**2 + 8*s13*
     +    s34**3 )

      LB = LB + Le1(p3,p2,p1,p4)*S24**(-1) * ( 16*s12**3*s13 + 16*
     +    s12**3*s14 + 16*s12**3*s34 + 16*s12**2*s13**2 + 16*s12**2*s13
     +    *s14 + 16*s12**2*s13*s34 + 8*s12*s13**3 + 8*s12*s13**2*s14 + 
     +    8*s12*s13**2*s34 )

      LB = LB + Le1(p3,p2,p1,p4) * ( 32*s12**2*s13 + 32*s12**2*s14 - 32
     +    *s12**2*s23 - 32*s12**2*s24 + 48*s12*s13**2 + 48*s12*s13*s14
     +     - 8*s12*s13*s23 + 40*s12*s13*s34 + 8*s12*s14*s24 - 48*s12*
     +    s23*s24 - 48*s12*s24**2 - 40*s12*s24*s34 + 24*s13**3 + 32*
     +    s13**2*s14 + 8*s13**2*s23 + 24*s13**2*s24 + 40*s13**2*s34 + 8
     +    *s13*s14**2 + 8*s13*s14*s23 + 24*s13*s14*s24 + 24*s13*s14*s34
     +     - 24*s13*s23*s24 + 8*s13*s23*s34 - 24*s13*s24**2 + 16*s13*
     +    s34**2 - 8*s14*s23*s24 - 8*s14*s24**2 - 8*s14*s24*s34 - 8*
     +    s23**2*s24 - 32*s23*s24**2 - 24*s23*s24*s34 - 24*s24**3 - 40*
     +    s24**2*s34 - 16*s24*s34**2 )

      LB = LB + SF*S13**(-1)*S24**(-1) * ( 32*s12*s14 + 32*s12*s23 + 24
     +    *s14**2 + 64*s14*s23 + 24*s23**2 )

      LB = LB + SF*S13**(-1) * ( 32*s12 + 64*s14 + 56*s23 + 32*s24 )

      LB = LB + SF*S14**(-1)*S23**(-1) * (  - 32*s12*s13 - 32*s12*s24
     +     - 24*s13**2 - 64*s13*s24 - 24*s24**2 )

      LB = LB + SF*S14**(-1) * (  - 32*s12 - 64*s13 - 32*s23 - 56*s24 )

      LB = LB + SF*S23**(-1) * (  - 32*s12 - 56*s13 - 32*s14 - 64*s24 )

      LB = LB + SF*S24**(-1) * ( 32*s12 + 32*s13 + 56*s14 + 64*s23 )

      LB = LB + 472*s12 + 136*s13 + 136*s14 + 132*s23 + 132*s24 + 80*
     +    s34

      LBi=-LB/s134/s234
      
      return
      end
      
      
      function LB34(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)

      LB34=LB34a(p1,p2,p3,p4)+LB34b(p1,p2,p3,p4)+LB34c(p1,p2,p3,p4)
     .    +LB34d(p1,p2,p3,p4)+LB34e(p1,p2,p3,p4)

      return
      end

      function LB34a(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LB34=0d0

      LB34 = LB34 + S13**(-1)*S24**(-1)*S34**(-1) * (  - 8*s12**3*s14
     +     - 8*s12**3*s23 - 16*s12**2*s14**2 + 124*s12**2*s14*s23 + 4*
     +    s12**2*s23**2 + 64*s12*s14**3 + 96*s12*s14**2*s23 + 172*s12*
     +    s14*s23**2 - 16*s12*s23**3 + 136*s14**3*s23 - 20*s14**2*
     +    s23**2 + 64*s14*s23**3 )

      LB34 = LB34 + S13**(-1)*S24**(-1)*S134**(-1) * ( 8*s12**3*s34 )

      LB34 = LB34 + S13**(-1)*S24**(-1) * ( 112*s12**3 + 360*s12**2*s14
     +     + 400*s12**2*s23 + 396*s12**2*s34 + 484*s12*s14**2 + 504*s12
     +    *s14*s23 + 564*s12*s14*s34 + 336*s12*s23**2 + 516*s12*s23*s34
     +     + 208*s12*s34**2 + 180*s14**3 + 304*s14**2*s23 + 248*s14**2*
     +    s34 + 216*s14*s23**2 + 464*s14*s23*s34 + 224*s14*s34**2 + 156
     +    *s23**3 + 252*s23**2*s34 + 204*s23*s34**2 + 80*s34**3 )

      LB34 = LB34 + S13**(-1)*S34**(-1) * (  - 8*s12**3 + 252*s12**2*
     +    s14 - 4*s12**2*s23 - 8*s12**2*s24 + 240*s12*s14**2 + 536*s12*
     +    s14*s23 + 296*s12*s14*s24 + 12*s12*s23**2 - 20*s12*s23*s24 - 
     +    16*s12*s24**2 + 160*s14**3 + 32*s14**2*s23 - 48*s14**2*s24 + 
     +    360*s14*s23**2 + 332*s14*s23*s24 + 144*s14*s24**2 - 8*s23**3
     +     - 8*s23*s24**2 )

      LB34 = LB34 + S13**(-1)*S134**(-1) * ( 64*s12*s23*s34 + 64*s12*
     +    s24*s34 + 64*s12*s34**2 + 64*s23**2*s34 + 128*s23*s24*s34 + 
     +    64*s23*s34**2 + 64*s24**2*s34 + 64*s24*s34**2 )

      LB34 = LB34 + S13**(-1) * ( 204*s12**2 + 584*s12*s14 + 360*s12*
     +    s23 + 40*s12*s24 + 152*s12*s34 + 212*s14**2 + 368*s14*s23 + 
     +    60*s14*s24 + 144*s14*s34 + 200*s23**2 + 76*s23*s24 + 116*s23*
     +    s34 + 8*s24**2 - 4*s24*s34 + 68*s34**2 )

      LB34 = LB34 + S24**(-1)*S34**(-1)*S234**(-1) * (  - 140*s12*s13*
     +    s23**2 - 152*s12*s14*s23**2 - 144*s12*s23**3 - 156*s13**2*
     +    s23**2 - 304*s13*s14*s23**2 - 144*s13*s23**3 - 152*s14**2*
     +    s23**2 - 144*s14*s23**3 )

      LB34 = LB34 + S24**(-1)*S34**(-1) * (  - 8*s12**3 + 12*s12**2*s13
     +     - 24*s12**2*s14 + 232*s12**2*s23 + 48*s12*s13**2 + 8*s12*s13
     +    *s14 + 228*s12*s13*s23 + 28*s12*s14**2 + 376*s12*s14*s23 + 
     +    432*s12*s23**2 - 16*s13**3 + 24*s13**2*s14 + 168*s13**2*s23
     +     + 88*s13*s14**2 + 260*s13*s14*s23 + 80*s13*s23**2 + 72*
     +    s14**3 + 268*s14**2*s23 + 192*s14*s23**2 + 152*s23**3 )

      LB34 = LB34 + S24**(-1)*S34**(-2)*S234**(-1) * (  - 144*s12*s13*
     +    s23**3 - 144*s12*s14*s23**3 - 144*s13**2*s23**3 - 288*s13*s14
     +    *s23**3 - 144*s14**2*s23**3 )

      LB34 = LB34 + S24**(-1)*S34**(-2) * ( 128*s12*s13*s23**2 + 128*
     +    s12*s14*s23**2 + 136*s13**2*s23**2 + 272*s13*s14*s23**2 + 136
     +    *s14**2*s23**2 )

      LB34 = LB34 + S24**(-1)*S234**(-1) * ( 12*s12**2*s23 + 12*s12**2*
     +    s34 - 48*s12*s13*s23 + 12*s12*s13*s34 - 72*s12*s14*s23 - 152*
     +    s12*s23**2 - 72*s12*s23*s34 - 80*s13**2*s23 - 4*s13**2*s34 - 
     +    144*s13*s14*s23 - 152*s13*s23**2 - 72*s13*s23*s34 - 72*s14**2
     +    *s23 - 152*s14*s23**2 - 72*s14*s23*s34 )

      LB34 = LB34 + S24**(-1) * ( 264*s12**2 + 180*s12*s13 + 376*s12*
     +    s14 + 652*s12*s23 + 324*s12*s34 + 60*s13**2 + 292*s13*s14 + 
     +    136*s13*s23 + 56*s13*s34 + 344*s14**2 + 344*s14*s23 + 332*s14
     +    *s34 + 220*s23**2 + 184*s23*s34 + 56*s34**2 )

      LB34 = LB34 + S34**(-1)*S134**(-1) * ( 144*s12*s13**2 + 280*s12*
     +    s13*s23 + 292*s12*s13*s24 + 144*s13**2*s23 + 144*s13**2*s24
     +     + 280*s13*s23**2 + 560*s13*s23*s24 + 280*s13*s24**2 )

      LB34 = LB34 + S34**(-1) * (  - 152*s12**2 - 236*s12*s13 + 116*s12
     +    *s14 - 120*s12*s23 - 272*s12*s24 + 104*s13**2 + 120*s13*s14
     +     - 344*s13*s23 + 12*s13*s24 + 144*s14**2 - 48*s14*s23 - 104*
     +    s14*s24 + 100*s23**2 - 208*s23*s24 - 72*s24**2 )

      LB34 = LB34 + S34**(-2)*S134**(-1) * ( 144*s12*s13**2*s23 + 144*
     +    s12*s13**2*s24 + 144*s13**2*s23**2 + 288*s13**2*s23*s24 + 144
     +    *s13**2*s24**2 )

      LB34 = LB34 + S34**(-2) * (  - 256*s12*s13*s23 - 136*s13**2*s23
     +     + 104*s13**2*s24 - 240*s13*s14*s23 - 136*s13*s23**2 - 272*
     +    s13*s23*s24 + 136*s14*s23**2 )

      LB34 = LB34 + S134**(-1) * (  - 12*s12**2 + 280*s12*s13 + 200*s12
     +    *s23 + 200*s12*s24 + 200*s12*s34 + 280*s13*s23 + 280*s13*s24
     +     + 200*s23**2 + 400*s23*s24 + 200*s23*s34 + 200*s24**2 + 200*
     +    s24*s34 )

      LB34 = LB34 + log(s12**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-1)
     +  * (  - 576*s12**2*s14**2 + 48*s12**2*s14*s23 + 184*s12**2*
     +    s23**2 + 1200*s12*s14**3 + 1376*s12*s14**2*s23 + 448*s12*s14*
     +    s23**2 - 96*s12*s23**3 - 128*s14**4 - 248*s14**3*s23 - 104*
     +    s14**2*s23**2 + 64*s14*s23**3 + 256*s23**4 )

      LB34 = LB34 + log(s12**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-2)
     +  * ( 24*s12*s14**3*s23 )

      LB34 = LB34 + log(s12**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 248*
     +    s12**3 + 1408*s12**2*s14 - 208*s12**2*s23 + 160*s12**2*s34 - 
     +    4024*s12*s14**2 - 2240*s12*s14*s23 + 1624*s12*s14*s34 + 80*
     +    s12*s23**2 + 328*s12*s23*s34 - 40*s12*s34**2 + 296*s14**3 + 
     +    448*s14**2*s23 - 384*s14**2*s34 + 152*s14*s23**2 - 400*s14*
     +    s23*s34 - 8*s14*s34**2 - 272*s23**2*s34 - 16*s23*s34**2 )

      LB34 = LB34 + log(s12**(-1)*s1234)*S13**(-1)*S34**(-1) * ( 32*
     +    s12**2*s14 + 880*s12**2*s23 + 960*s12**2*s24 + 2160*s12*
     +    s14**2 + 1648*s12*s14*s23 + 1504*s12*s14*s24 + 832*s12*s23**2
     +     + 1216*s12*s23*s24 + 528*s12*s24**2 - 528*s14**3 - 488*
     +    s14**2*s23 - 560*s14**2*s24 + 152*s14*s23**2 - 24*s14*s23*s24
     +     - 128*s14*s24**2 + 544*s23**3 + 432*s23**2*s24 + 168*s23*
     +    s24**2 + 24*s24**3 )

      LB34 = LB34 + log(s12**(-1)*s1234)*S13**(-1)*S34**(-2) * ( 128*
     +    s12*s14**2*s23 + 128*s12*s14**2*s24 + 288*s12*s14*s23**2 + 
     +    672*s12*s14*s23*s24 + 384*s12*s14*s24**2 + 256*s12*s23**3 + 
     +    672*s12*s23**2*s24 + 672*s12*s23*s24**2 + 256*s12*s24**3 + 64
     +    *s14**2*s23**2 + 128*s14**2*s23*s24 + 64*s14**2*s24**2 + 128*
     +    s14*s23**3 + 384*s14*s23**2*s24 + 384*s14*s23*s24**2 + 128*
     +    s14*s24**3 + 128*s23**4 + 384*s23**3*s24 + 448*s23**2*s24**2
     +     + 256*s23*s24**3 + 64*s24**4 )

      LB34 = LB34 + log(s12**(-1)*s1234)*S13**(-1) * ( 288*s12**2 - 
     +    2720*s12*s14 - 208*s12*s23 - 608*s12*s24 + 176*s12*s34 + 208*
     +    s14**2 + 64*s14*s23 - 8*s14*s24 - 304*s14*s34 - 32*s23**2 - 
     +    80*s23*s24 - 216*s23*s34 - 8*s24**2 - 88*s24*s34 - 24*s34**2
     +     )

      LB34 = LB34 + log(s12**(-1)*s1234)*S24**(-1)*S34**(-1) * ( 224*
     +    s12**2*s13 + 192*s12**2*s14 - 160*s12**2*s23 + 32*s12*s13**2
     +     + 368*s12*s13*s14 + 80*s12*s13*s23 - 864*s12*s14**2 - 288*
     +    s12*s14*s23 - 32*s12*s23**2 - 16*s13**3 + 72*s13**2*s14 - 8*
     +    s13**2*s23 - 160*s13*s14**2 - 24*s13*s14*s23 + 112*s13*s23**2
     +     + 152*s14**3 + 80*s14**2*s23 + 48*s14*s23**2 - 256*s23**3 )

      LB34 = LB34 + log(s12**(-1)*s1234)*S24**(-1)*S34**(-2) * (  - 24*
     +    s12*s13**2*s14 + 32*s12*s13*s14**2 + 24*s12*s14**3 + 56*s12*
     +    s14**2*s23 )

      LB34 = LB34 + log(s12**(-1)*s1234)*S24**(-1) * ( 256*s12**2 + 216
     +    *s12*s13 + 1296*s12*s14 + 104*s12*s23 + 168*s12*s34 + 8*
     +    s13**2 + 208*s13*s14 + 120*s13*s23 - 16*s13*s34 - 360*s14**2
     +     - 96*s14*s23 + 272*s14*s34 - 144*s23**2 + 144*s23*s34 + 8*
     +    s34**2 )

      LB34 = LB34 + log(s12**(-1)*s1234)*S34**(-1) * (  - 224*s12**2 + 
     +    224*s12*s13 - 576*s12*s14 - 368*s12*s23 - 256*s12*s24 - 72*
     +    s13*s14 + 168*s13*s23 + 24*s13*s24 + 336*s14**2 + 48*s14*s23
     +     + 120*s14*s24 - 312*s23**2 - 144*s23*s24 - 24*s24**2 )

      LB34 = LB34 + log(s12**(-1)*s1234)*S34**(-2) * ( 16*s12*s13**2 - 
     +    24*s12*s13*s14 + 64*s12*s13*s23 + 128*s12*s13*s24 + 40*s12*
     +    s14**2 - 128*s12*s14*s23 - 128*s12*s14*s24 - 128*s12*s23**2
     +     - 288*s12*s23*s24 - 192*s12*s24**2 - 32*s13**2*s23 - 32*
     +    s13**2*s24 + 96*s13*s23**2 + 128*s13*s23*s24 + 64*s13*s24**2
     +     - 32*s14*s23**2 - 128*s14*s23*s24 - 64*s14*s24**2 - 128*
     +    s23**3 - 256*s23**2*s24 - 192*s23*s24**2 - 64*s24**3 )

      LB34 = LB34 + log(s12**(-1)*s1234) * ( 416*s12 - 32*s13 - 32*s14
     +     + 80*s23 + 16*s24 + 32*s34 )

      LB34 = LB34 + log(s13**(-1)*s134)*S13**(-1)*S134**(-1) * ( 24*s12
     +    *s23*s34 + 24*s12*s24*s34 + 24*s12*s34**2 + 24*s23**2*s34 + 
     +    48*s23*s24*s34 + 24*s23*s34**2 + 24*s24**2*s34 + 24*s24*
     +    s34**2 )

      LB34 = LB34 + log(s13**(-1)*s134)*S24**(-1)*S134**(-1) * ( 12*
     +    s12**3 + 8*s12**2*s23 )

      LB34 = LB34 + log(s13**(-1)*s134)*S34**(-1)*S134**(-1) * (  - 8*
     +    s12**2*s13 + 20*s12*s13*s23 - 4*s12*s13*s24 + 8*s13*s23**2 + 
     +    16*s13*s23*s24 + 8*s13*s24**2 )

      LB34 = LB34 + log(s13**(-1)*s134)*S134**(-1) * ( 4*s12**2 + 8*s12
     +    *s13 + 32*s12*s23 + 32*s12*s24 + 32*s12*s34 + 8*s13*s23 + 8*
     +    s13*s24 + 32*s23**2 + 64*s23*s24 + 32*s23*s34 + 32*s24**2 + 
     +    32*s24*s34 )

      LB34 = LB34 + log(s13**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-1)
     +  * (  - 8*s12**3*s14 + 4*s12**3*s23 + 16*s12**2*s14**2 - 4*
     +    s12**2*s14*s23 + 16*s12**2*s23**2 + 16*s12*s14*s23**2 - 12*
     +    s12*s23**3 + 4*s14*s23**3 )

      LB34 = LB34 + log(s13**(-1)*s1234)*S13**(-1)*S24**(-1) * (  - 4*
     +    s12**3 + 28*s12**2*s14 + 20*s12**2*s23 + 20*s12**2*s34 + 8*
     +    s12*s14**2 + 16*s12*s14*s23 + 8*s12*s14*s34 - 28*s12*s23**2
     +     - 16*s12*s23*s34 + 4*s14*s23**2 - 4*s23**3 - 4*s23**2*s34 )

      LB34 = LB34 + log(s13**(-1)*s1234)*S13**(-1)*S34**(-1) * ( 4*
     +    s12**3 - 4*s12**2*s14 + 8*s12**2*s23 - 8*s12**2*s24 + 16*s12*
     +    s14*s23 - 4*s12*s23**2 + 8*s12*s23*s24 + 4*s14*s23**2 )

      LB34 = LB34 + log(s13**(-1)*s1234)*S13**(-1) * (  - 4*s12**2 - 8*
     +    s12*s14 - 8*s12*s23 - 8*s12*s34 - 4*s23**2 )

      LB34 = LB34 + log(s13**(-1)*s1234)*S24**(-1)*S34**(-1) * (  - 8*
     +    s12**3 - 104*s12**2*s13 - 80*s12**2*s14 - 4*s12**2*s23 - 32*
     +    s12*s13**2 - 48*s12*s13*s14 - 36*s12*s13*s23 - 16*s12*s14**2
     +     - 28*s12*s14*s23 - 4*s12*s23**2 - 16*s13**2*s23 - 16*s13*s14
     +    *s23 - 24*s13*s23**2 - 16*s14*s23**2 + 4*s23**3 )

      LB34 = LB34 + log(s13**(-1)*s1234)*S24**(-1) * (  - 20*s12**2 + 
     +    48*s12*s13 + 48*s12*s14 + 72*s12*s23 + 92*s12*s34 - 8*s13**2
     +     - 8*s13*s14 - 12*s13*s23 + 8*s13*s34 - 8*s14*s23 + 8*s14*s34
     +     - 12*s23**2 - 16*s23*s34 )

      LB34 = LB34 + log(s13**(-1)*s1234)*S34**(-1) * ( 4*s12**2 - 16*
     +    s12*s13 - 24*s12*s23 - 16*s12*s24 - 60*s13**2 - 24*s13*s14 - 
     +    8*s13*s23 - 16*s13*s24 + 24*s14**2 - 10*s23**2 - 8*s23*s24 )

      LB34 = LB34 + log(s13**(-1)*s1234) * ( 36*s12 - 16*s13 + 32*s14
     +     + 24*s23 + 48*s24 + 32*s34 )

      LB34 = LB34 + log(s24**(-1)*s234)*S24**(-1)*S34**(-1)*S234**(-1)
     +  * (  - 12*s12*s13*s23**2 + 8*s12*s14*s23**2 - 16*s13**2*s23**2
     +     - 8*s13*s14*s23**2 + 14*s14**2*s23**2 )

      LB34 = LB34 + log(s24**(-1)*s234)*S24**(-1)*S234**(-1) * (  - 12*
     +    s12**2*s23 - 12*s12**2*s34 - 56*s12*s13*s23 - 20*s12*s13*s34
     +     - 4*s12*s14*s23 + 12*s12*s14*s34 + 8*s12*s23**2 - 16*s12*s23
     +    *s34 - 64*s13**2*s23 - 24*s13**2*s34 - 80*s13*s14*s23 - 24*
     +    s13*s14*s34 - 16*s13*s23**2 - 64*s13*s23*s34 - 24*s13*s34**2
     +     + 2*s14**2*s23 + 12*s14**2*s34 + 8*s14*s23**2 - 16*s14*s23*
     +    s34 )

      LB34 = LB34 + log(s24**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-1)
     +  * ( 4*s12**3*s14 - 8*s12**3*s23 + 16*s12**2*s14**2 - 4*s12**2*
     +    s14*s23 + 16*s12**2*s23**2 - 12*s12*s14**3 + 22*s12*s14**2*
     +    s23 + 4*s14**3*s23 )

      LB34 = LB34 + log(s24**(-1)*s1234)*S13**(-1)*S24**(-1) * (  - 16*
     +    s12**3 + 12*s12**2*s14 + 28*s12**2*s23 + 36*s12**2*s34 - 28*
     +    s12*s14**2 + 16*s12*s14*s23 - 16*s12*s14*s34 + 8*s12*s23**2
     +     + 8*s12*s23*s34 - 4*s14**3 + 4*s14**2*s23 - 4*s14**2*s34 )

      LB34 = LB34 + log(s24**(-1)*s1234)*S13**(-1)*S34**(-1) * (  - 8*
     +    s12**3 - 4*s12**2*s14 - 80*s12**2*s23 - 104*s12**2*s24 + 2*
     +    s12*s14**2 - 28*s12*s14*s23 - 36*s12*s14*s24 - 16*s12*s23**2
     +     - 48*s12*s23*s24 - 32*s12*s24**2 + 4*s14**3 - 16*s14**2*s23
     +     - 24*s14**2*s24 - 16*s14*s23*s24 - 16*s14*s24**2 )

      LB34 = LB34 + log(s24**(-1)*s1234)*S13**(-1) * (  - 20*s12**2 + 
     +    72*s12*s14 + 48*s12*s23 + 48*s12*s24 + 92*s12*s34 - 12*s14**2
     +     - 8*s14*s23 - 12*s14*s24 - 16*s14*s34 - 8*s23*s24 + 8*s23*
     +    s34 - 8*s24**2 + 8*s24*s34 )

      LB34 = LB34 + log(s24**(-1)*s1234)*S24**(-1)*S34**(-1) * ( 4*
     +    s12**3 - 8*s12**2*s13 + 8*s12**2*s14 - 4*s12**2*s23 + 8*s12*
     +    s13*s14 + 12*s12*s13*s23 - 4*s12*s14**2 + 8*s12*s14*s23 + 16*
     +    s13**2*s23 + 8*s13*s14*s23 - 10*s14**2*s23 )

      LB34 = LB34 + log(s24**(-1)*s1234)*S24**(-1) * ( 24*s12**2 + 44*
     +    s12*s13 + 4*s12*s14 - 16*s12*s23 + 24*s12*s34 + 48*s13**2 + 
     +    72*s13*s14 + 16*s13*s23 + 48*s13*s34 + 8*s14**2 - 8*s14*s23
     +     + 24*s14*s34 )

      LB34 = LB34 + log(s24**(-1)*s1234)*S34**(-1) * ( 20*s12**2 - 60*
     +    s12*s13 - 36*s12*s14 - 16*s12*s24 - 16*s13**2 - 16*s13*s14 - 
     +    16*s13*s24 + 10*s14**2 - 8*s14*s24 + 24*s23**2 - 24*s23*s24
     +     - 60*s24**2 )

      LB34 = LB34 + log(s24**(-1)*s1234) * ( 12*s12 + 16*s13 + 32*s14
     +     + 32*s23 - 16*s24 + 32*s34 )

      LB34 = LB34 + log(s34**(-1)*s234)*S24**(-1)*S34**(-1)*S234**(-1)
     +  * (  - 64*s12*s13*s23**2 - 56*s12*s14*s23**2 - 48*s12*s23**3 - 
     +    60*s13**2*s23**2 - 136*s13*s14*s23**2 - 48*s13*s23**3 - 56*
     +    s14**2*s23**2 - 48*s14*s23**3 )

      LB34 = LB34 + log(s34**(-1)*s234)*S24**(-1)*S34**(-2)*S234**(-1)
     +  * (  - 48*s12*s13*s23**3 - 48*s12*s14*s23**3 - 48*s13**2*s23**3
     +     - 96*s13*s14*s23**3 - 48*s14**2*s23**3 )

      LB34 = LB34 + log(s34**(-1)*s234)*S24**(-1)*S234**(-1) * ( 12*
     +    s12**2*s34 - 4*s12*s13*s23 + 12*s12*s13*s34 + 4*s12*s14*s23
     +     + 12*s12*s14*s34 - 56*s12*s23**2 - 8*s12*s23*s34 - 8*s13**2*
     +    s23 + 4*s13**2*s34 - 56*s13*s14*s23 - 16*s13*s14*s34 - 64*s13
     +    *s23**2 - 16*s13*s23*s34 - 8*s14**2*s23 - 56*s14*s23**2 - 8*
     +    s14*s23*s34 )

      LB34 = LB34 + log(s34**(-1)*s134)*S13**(-1)*S24**(-1)*S134**(-1)
     +  * ( 8*s12**3*s34 + 8*s12**2*s23*s34 - 8*s12**2*s34**2 )

      LB34 = LB34 + log(s34**(-1)*s134)*S13**(-1)*S134**(-1) * (  - 16*
     +    s12**2*s34 + 24*s12*s24*s34 )

      LB34 = LB34 + log(s34**(-1)*s134)*S34**(-1)*S134**(-1) * ( 48*s12
     +    *s13**2 + 88*s12*s13*s23 + 88*s12*s13*s24 + 48*s13**2*s23 + 
     +    48*s13**2*s24 + 88*s13*s23**2 + 176*s13*s23*s24 + 88*s13*
     +    s24**2 )

      LB34 = LB34 + log(s34**(-1)*s134)*S34**(-2)*S134**(-1) * ( 48*s12
     +    *s13**2*s23 + 48*s12*s13**2*s24 + 48*s13**2*s23**2 + 96*
     +    s13**2*s23*s24 + 48*s13**2*s24**2 )

      LB34 = LB34 + log(s34**(-1)*s134)*S134**(-1) * (  - 8*s12**2 + 88
     +    *s12*s13 + 52*s12*s23 + 52*s12*s24 + 40*s12*s34 + 88*s13*s23
     +     + 88*s13*s24 + 40*s23**2 + 80*s23*s24 + 40*s23*s34 + 40*
     +    s24**2 + 40*s24*s34 )

      LB34 = LB34 + log(s34**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-1)
     +  * (  - 312*s12*s14**3 - 264*s12*s14**2*s23 + 128*s12*s14*s23**2
     +     + 80*s12*s23**3 + 616*s14**4 + 1288*s14**3*s23 + 936*s14**2*
     +    s23**2 + 192*s14*s23**3 - 48*s23**4 )

      LB34 = LB34 + log(s34**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 160*
     +    s12**2*s14 + 184*s12**2*s23 + 638*s12*s14**2 + 584*s12*s14*
     +    s23 + 164*s12*s14*s34 - 84*s12*s23**2 + 96*s12*s23*s34 - 28*
     +    s12*s34**2 - 2080*s14**3 - 3212*s14**2*s23 + 752*s14**2*s34
     +     - 1072*s14*s23**2 + 1068*s14*s23*s34 + 4*s14*s34**2 + 68*
     +    s23**3 + 248*s23**2*s34 + 8*s23*s34**2 + 4*s34**3 )

      LB34 = LB34 + log(s34**(-1)*s1234)*S13**(-1)*S34**(-1) * (  - 288
     +    *s12*s14**2 + 520*s12*s14*s23 + 512*s12*s14*s24 + 544*s12*
     +    s23**2 + 960*s12*s23*s24 + 496*s12*s24**2 + 1688*s14**3 + 
     +    2576*s14**2*s23 + 1792*s14**2*s24 + 1462*s14*s23**2 + 2192*
     +    s14*s23*s24 + 1000*s14*s24**2 + 360*s23**3 + 1032*s23**2*s24
     +     + 888*s23*s24**2 + 264*s24**3 )

      LB34 = LB34 + log(s34**(-1)*s1234)*S13**(-1)*S34**(-2) * ( 64*
     +    s14**3*s23 + 64*s14**3*s24 + 208*s14**2*s23**2 + 464*s14**2*
     +    s23*s24 + 256*s14**2*s24**2 + 272*s14*s23**3 + 816*s14*s23**2
     +    *s24 + 864*s14*s23*s24**2 + 320*s14*s24**3 + 128*s23**4 + 464
     +    *s23**3*s24 + 672*s23**2*s24**2 + 464*s23*s24**3 + 128*s24**4
     +     )

      LB34 = LB34 + log(s34**(-1)*s1234)*S13**(-1) * ( 184*s12**2 + 864
     +    *s12*s14 + 36*s12*s23 + 116*s12*s24 + 24*s12*s34 - 3472*
     +    s14**2 - 2596*s14*s23 - 1696*s14*s24 + 884*s14*s34 - 24*
     +    s23**2 - 404*s23*s24 + 252*s23*s34 - 328*s24**2 + 60*s24*s34
     +     )

      LB34 = LB34 + log(s34**(-1)*s1234)*S24**(-1)*S34**(-1) * ( 32*s12
     +    *s13**2 + 144*s12*s13*s14 + 56*s12*s13*s23 - 176*s12*s14**2
     +     + 40*s12*s14*s23 + 32*s12*s23**2 - 16*s13**3 + 160*s13**2*
     +    s14 + 36*s13**2*s23 - 208*s13*s14**2 + 56*s13*s14*s23 - 48*
     +    s13*s23**2 + 224*s14**3 + 12*s14**2*s23 - 24*s14*s23**2 - 48*
     +    s23**3 )

      LB34 = LB34 + log(s34**(-1)*s1234)*S24**(-1) * ( 168*s12**2 + 48*
     +    s12*s13 + 860*s12*s14 + 48*s12*s23 + 120*s12*s34 - 48*s13**2
     +     + 672*s13*s14 + 4*s13*s23 + 4*s13*s34 - 1428*s14**2 - 500*
     +    s14*s23 + 876*s14*s34 + 72*s23**2 + 256*s23*s34 + 16*s34**2 )

      LB34 = LB34 + log(s34**(-1)*s1234)*S34**(-1) * (  - 144*s12*s13
     +     - 136*s12*s14 + 232*s12*s23 + 336*s12*s24 + 4*s13**2 - 40*
     +    s13*s14 - 32*s13*s23 - 16*s13*s24 + 360*s14**2 + 144*s14*s23
     +     + 280*s14*s24 + 162*s23**2 + 288*s23*s24 + 148*s24**2 )

      LB34 = LB34 + log(s34**(-1)*s1234)*S34**(-2) * (  - 64*s13*s23**2
     +     - 64*s13*s23*s24 - 32*s13*s24**2 + 64*s14*s23*s24 + 32*s14*
     +    s24**2 + 64*s23**3 + 128*s23**2*s24 + 96*s23*s24**2 + 32*
     +    s24**3 )

      LB34 = LB34 + log(s34**(-1)*s1234) * ( 224*s12 + 180*s13 - 540*
     +    s14 + 128*s23 - 120*s24 + 116*s34 )

      LB34 = LB34 + log(s123**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-1)
     +  * (  - 8*s12**3*s14 + 48*s12**2*s14**2 - 24*s12**2*s23**2 - 96*
     +    s12*s14**3 + 280*s12*s14**2*s23 - 56*s12*s14*s23**2 - 96*
     +    s14**3*s23 + 120*s14**2*s23**2 - 8*s14*s23**3 )

      LB34 = LB34 + log(s123**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-2)
     +  * (  - 24*s12*s14**3*s23 - 24*s14**3*s23**2 )

      LB34 = LB34 + log(s123**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 176*
     +    s12**3 - 56*s12**2*s14 + 192*s12**2*s23 + 528*s12**2*s34 - 
     +    168*s12*s14**2 + 112*s12*s14*s23 - 208*s12*s14*s34 + 104*s12*
     +    s23**2 + 592*s12*s23*s34 + 168*s12*s34**2 - 8*s14**3 - 152*
     +    s14**2*s23 - 16*s14**2*s34 + 120*s14*s23**2 - 120*s14*s23*s34
     +     - 8*s14*s34**2 + 136*s23**2*s34 + 32*s23*s34**2 )

      LB34 = LB34 + log(s123**(-1)*s1234)*S13**(-1)*S34**(-1) * (  - 24
     +    *s12**2*s14 + 56*s12**2*s23 + 40*s12**2*s24 + 96*s12*s14**2
     +     - 72*s12*s14*s23 - 48*s12*s14*s24 + 24*s12*s23**2 + 88*s12*
     +    s23*s24 + 16*s12*s24**2 - 8*s14**3 + 88*s14**2*s23 + 8*s14**2
     +    *s24 - 24*s14*s23**2 - 16*s14*s23*s24 + 16*s23**2*s24 + 16*
     +    s23*s24**2 )

      LB34 = LB34 + log(s123**(-1)*s1234)*S13**(-1) * ( 304*s12**2 + 40
     +    *s12*s14 + 336*s12*s23 + 96*s12*s24 + 304*s12*s34 - 8*s14**2
     +     + 72*s14*s23 + 8*s14*s24 + 32*s23**2 + 80*s23*s24 + 160*s23*
     +    s34 )

      LB34 = LB34 + log(s123**(-1)*s1234)*S24**(-1)*S34**(-1) * (  - 32
     +    *s12**3 - 120*s12**2*s13 - 80*s12**2*s14 - 264*s12*s13**2 + 
     +    80*s12*s13*s14 - 168*s12*s13*s23 + 344*s12*s14**2 - 120*s12*
     +    s14*s23 - 16*s12*s23**2 - 184*s13**3 + 72*s13**2*s14 - 212*
     +    s13**2*s23 + 152*s13*s14**2 + 84*s13*s14*s23 - 64*s13*s23**2
     +     - 96*s14**3 + 288*s14**2*s23 - 56*s14*s23**2 )

      LB34 = LB34 + log(s123**(-1)*s1234)*S24**(-1)*S34**(-2) * ( 24*
     +    s12*s13**2*s14 - 32*s12*s13*s14**2 - 24*s12*s14**3 - 56*s12*
     +    s14**2*s23 - 56*s13**2*s14**2 - 24*s13*s14**3 - 112*s13*
     +    s14**2*s23 - 48*s14**3*s23 - 56*s14**2*s23**2 )

      LB34 = LB34 + log(s123**(-1)*s1234)*S24**(-1) * ( 344*s12**2 - 
     +    148*s12*s13 - 456*s12*s14 + 256*s12*s23 + 648*s12*s34 - 112*
     +    s13**2 + 56*s13*s23 + 296*s13*s34 - 184*s14**2 + 24*s14*s23
     +     - 96*s14*s34 + 144*s23**2 + 472*s23*s34 + 32*s34**2 )

      LB34 = LB34 + log(s123**(-1)*s1234)*S34**(-1) * ( 80*s12**2 + 104
     +    *s12*s13 - 344*s12*s14 + 192*s12*s23 + 192*s12*s24 + 40*
     +    s13**2 - 88*s13*s14 + 88*s13*s23 + 88*s13*s24 + 24*s14**2 - 
     +    192*s14*s23 - 64*s14*s24 + 72*s23**2 + 136*s23*s24 + 16*
     +    s24**2 )

      LB34 = LB34 + log(s123**(-1)*s1234)*S34**(-2) * (  - 16*s12*
     +    s13**2 + 24*s12*s13*s14 - 40*s12*s14**2 - 40*s13*s14**2 - 40*
     +    s14**2*s23 )

      LB34 = LB34 + log(s123**(-1)*s1234) * ( 728*s12 + 384*s13 - 8*s14
     +     + 376*s23 - 24*s24 + 88*s34 )

      LB34 = LB34 + log(s234**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-1)
     +  * ( 32*s12**2*s23**2 + 2*s12*s14**2*s23 - 32*s12*s14*s23**2 + 
     +    40*s12*s23**3 - 4*s14**3*s23 + 16*s14**2*s23**2 - 68*s14*
     +    s23**3 )

      LB34 = LB34 + log(s234**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 12*
     +    s12**3 + 8*s12**2*s14 + 64*s12**2*s23 - 16*s12**2*s34 + 2*s12
     +    *s14**2 - 56*s12*s14*s23 - 52*s12*s14*s34 + 84*s12*s23**2 + 
     +    16*s12*s23*s34 - 16*s12*s34**2 + 4*s14**3 + 48*s14**2*s23 + 
     +    36*s14**2*s34 - 168*s14*s23**2 - 136*s14*s23*s34 - 24*s14*
     +    s34**2 - 48*s23**3 - 128*s23**2*s34 - 104*s23*s34**2 - 24*
     +    s34**3 )

      LB34 = LB34 + log(s234**(-1)*s1234)*S13**(-1)*S34**(-1) * ( 96*
     +    s12**2*s23 + 72*s12**2*s24 + 2*s12*s14**2 + 24*s12*s14*s23 + 
     +    40*s12*s14*s24 + 100*s12*s23**2 + 76*s12*s23*s24 + 16*s12*
     +    s24**2 - 4*s14**3 + 88*s14**2*s23 + 72*s14**2*s24 - 88*s14*
     +    s23**2 - 28*s14*s23*s24 + 16*s14*s24**2 )

      LB34 = LB34 + log(s234**(-1)*s1234)*S13**(-1) * ( 32*s12**2 - 96*
     +    s12*s14 + 92*s12*s23 - 36*s12*s24 - 68*s12*s34 + 84*s14**2 - 
     +    104*s14*s23 + 20*s14*s24 - 16*s14*s34 - 32*s23**2 - 16*s23*
     +    s24 - 88*s23*s34 - 16*s24**2 - 48*s24*s34 - 40*s34**2 )

      LB34 = LB34 + log(s234**(-1)*s1234)*S24**(-1)*S34**(-1) * (  - 68
     +    *s12*s13*s23 - 8*s12*s14*s23 - 32*s12*s23**2 - 84*s13**2*s23
     +     - 96*s13*s14*s23 + 104*s13*s23**2 - 2*s14**2*s23 + 112*s14*
     +    s23**2 - 80*s23**3 )

      LB34 = LB34 + log(s234**(-1)*s1234)*S24**(-1) * (  - 76*s12**2 - 
     +    44*s12*s13 - 16*s12*s14 - 104*s12*s23 - 48*s12*s34 - 48*
     +    s13**2 - 104*s13*s14 + 36*s13*s23 - 28*s13*s34 - 20*s14**2 + 
     +    116*s14*s23 + 20*s14*s34 - 120*s23**2 - 64*s23*s34 + 8*s34**2
     +     )

      LB34 = LB34 + log(s234**(-1)*s1234)*S34**(-1) * (  - 16*s12**2 + 
     +    68*s12*s13 + 24*s12*s14 + 16*s12*s23 + 64*s12*s24 + 44*s13**2
     +     + 60*s13*s14 - 40*s13*s23 - 84*s13*s24 - 14*s14**2 + 36*s14*
     +    s23 - 16*s14*s24 - 100*s23**2 - 4*s23*s24 + 68*s24**2 )

      LB34 = LB34 + log(s234**(-1)*s1234)*S34**(-2) * ( 32*s13*s23**2
     +     + 32*s14*s23**2 )

      LB34 = LB34 + log(s234**(-1)*s1234) * ( 12*s12 - 68*s13 + 4*s14
     +     - 180*s23 + 4*s24 - 52*s34 )

      LB34 = LB34 + log(s134**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-1)
     +  * ( 32*s12**2*s14**2 + 40*s12*s14**3 - 16*s12*s14**2*s23 + 8*
     +    s12*s14*s23**2 - 52*s14**3*s23 + 16*s14**2*s23**2 - 4*s14*
     +    s23**3 )

      LB34 = LB34 + log(s134**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 64*
     +    s12**2*s14 - 16*s12**2*s23 + 16*s12**2*s34 + 100*s12*s14**2
     +     - 40*s12*s14*s23 + 56*s12*s14*s34 - 12*s12*s23**2 - 24*s12*
     +    s23*s34 - 4*s12*s34**2 - 32*s14**3 - 144*s14**2*s23 - 88*
     +    s14**2*s34 + 16*s14*s23**2 - 128*s14*s23*s34 - 76*s14*s34**2
     +     - 8*s23**3 + 8*s23**2*s34 - 36*s23*s34**2 - 20*s34**3 )

      LB34 = LB34 + log(s134**(-1)*s1234)*S13**(-1)*S34**(-1) * (  - 16
     +    *s12*s14**2 - 64*s14**3 + 80*s14**2*s23 + 72*s14**2*s24 - 10*
     +    s14*s23**2 )

      LB34 = LB34 + log(s134**(-1)*s1234)*S13**(-1) * (  - 16*s12**2 - 
     +    72*s12*s14 + 12*s12*s23 + 44*s12*s24 - 16*s12*s34 - 96*s14**2
     +     + 176*s14*s23 + 160*s14*s24 - 4*s14*s34 - 8*s23**2 + 104*s23
     +    *s34 + 88*s24*s34 + 28*s34**2 )

      LB34 = LB34 + log(s134**(-1)*s1234)*S24**(-1)*S34**(-1) * ( 72*
     +    s12**2*s13 + 96*s12**2*s14 + 16*s12*s13**2 + 76*s12*s13*s14
     +     + 24*s12*s13*s23 + 100*s12*s14**2 + 24*s12*s14*s23 + 8*s12*
     +    s23**2 + 48*s13**2*s23 - 20*s13*s14*s23 + 8*s13*s23**2 - 96*
     +    s14**2*s23 + 24*s14*s23**2 - 4*s23**3 )

      LB34 = LB34 + log(s134**(-1)*s1234)*S24**(-1) * ( 32*s12**2 - 52*
     +    s12*s13 + 92*s12*s14 - 112*s12*s23 - 108*s12*s34 + 8*s13**2
     +     + 8*s13*s14 + 20*s13*s23 + 8*s13*s34 - 16*s14**2 - 176*s14*
     +    s23 - 72*s14*s34 - 12*s23**2 - 124*s23*s34 - 20*s34**2 )

      LB34 = LB34 + log(s134**(-1)*s1234)*S34**(-1) * ( 72*s12*s13 + 40
     +    *s12*s14 + 28*s12*s23 + 8*s12*s24 + 116*s13**2 + 4*s13*s14 - 
     +    72*s13*s23 - 76*s13*s24 - 124*s14**2 - 4*s14*s23 - 16*s14*s24
     +     + 52*s23**2 + 28*s23*s24 - 20*s24**2 )

      LB34 = LB34 + log(s134**(-1)*s1234)*S34**(-2) * ( 32*s13**2*s23
     +     + 32*s13**2*s24 )

      LB34 = LB34 + log(s134**(-1)*s1234) * (  - 44*s12 + 132*s13 - 76*
     +    s14 - 80*s23 - 104*s24 - 4*s34 )

      LB34 = LB34 + log(s124**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-1)
     +  * ( 16*s12**3*s23 + 112*s12**2*s14**2 + 20*s12**2*s14*s23 - 48*
     +    s12**2*s23**2 - 4*s12*s14**2*s23 + 128*s12*s14*s23**2 + 16*
     +    s12*s23**3 - 32*s14**4 + 64*s14**2*s23**2 + 16*s14*s23**3 )

      LB34 = LB34 + log(s124**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-2)
     +  * (  - 24*s12*s14**3*s23 )

      LB34 = LB34 + log(s124**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 44*
     +    s12**3 - 152*s12**2*s14 - 32*s12**2*s23 + 88*s12**2*s34 + 220
     +    *s12*s14**2 + 184*s12*s14*s23 + 8*s12*s14*s34 + 64*s12*s23**2
     +     + 80*s12*s23*s34 + 16*s12*s34**2 + 88*s14**3 + 96*s14**2*s23
     +     + 24*s14**2*s34 + 8*s14*s23*s34 )

      LB34 = LB34 + log(s124**(-1)*s1234)*S13**(-1)*S34**(-1) * ( 16*
     +    s12**3 - 12*s12**2*s14 + 108*s12**2*s23 + 156*s12**2*s24 + 
     +    140*s12*s14**2 + 68*s12*s14*s23 + 20*s12*s14*s24 - 40*s12*
     +    s23**2 + 60*s12*s23*s24 + 52*s12*s24**2 + 64*s14**3 - 8*
     +    s14**2*s23 + 64*s14**2*s24 + 40*s14*s23**2 + 40*s14*s23*s24
     +     + 16*s23**3 - 24*s23**2*s24 + 16*s23*s24**2 )

      LB34 = LB34 + log(s124**(-1)*s1234)*S13**(-1) * ( 188*s12**2 + 68
     +    *s12*s14 - 56*s12*s23 + 20*s12*s24 - 48*s12*s34 + 104*s14**2
     +     + 48*s14*s23 + 72*s14*s24 + 24*s14*s34 + 32*s23**2 - 24*s23*
     +    s24 + 40*s23*s34 + 24*s24**2 + 48*s24*s34 )

      LB34 = LB34 + log(s124**(-1)*s1234)*S24**(-1)*S34**(-1) * (  - 4*
     +    s12**3 - 80*s12**2*s13 + 4*s12**2*s14 + 64*s12**2*s23 - 144*
     +    s12*s13**2 + 64*s12*s13*s14 + 48*s12*s13*s23 + 168*s12*s14**2
     +     - 160*s12*s14*s23 - 16*s12*s23**2 + 8*s13**3 - 64*s13**2*s14
     +     - 8*s13**2*s23 + 104*s13*s14**2 + 80*s13*s14*s23 + 80*s14**3
     +     - 72*s14*s23**2 )

      LB34 = LB34 + log(s124**(-1)*s1234)*S24**(-1)*S34**(-2) * ( 24*
     +    s12*s13**2*s14 - 32*s12*s13*s14**2 - 24*s12*s14**3 - 56*s12*
     +    s14**2*s23 + 24*s13**2*s14**2 + 24*s13*s14**3 )

      LB34 = LB34 + log(s124**(-1)*s1234)*S24**(-1) * (  - 24*s12**2 - 
     +    216*s12*s13 - 128*s12*s14 - 128*s12*s34 - 8*s13**2 - 136*s13*
     +    s14 - 8*s13*s34 + 48*s14**2 + 24*s14*s23 - 64*s14*s34 + 8*s23
     +    *s34 + 8*s34**2 )

      LB34 = LB34 + log(s124**(-1)*s1234)*S34**(-1) * ( 56*s12**2 - 16*
     +    s12*s13 - 16*s12*s14 + 104*s12*s23 + 108*s12*s24 - 120*s13**2
     +     + 96*s13*s14 + 64*s13*s23 + 24*s13*s24 + 64*s14**2 - 56*s14*
     +    s23 + 52*s14*s24 - 40*s23**2 + 56*s23*s24 + 64*s24**2 )

      LB34 = LB34 + log(s124**(-1)*s1234)*S34**(-2) * (  - 16*s12*
     +    s13**2 + 24*s12*s13*s14 - 40*s12*s14**2 + 8*s13**2*s14 - 16*
     +    s13**2*s24 + 48*s13*s14**2 + 24*s13*s14*s24 )

      LB34 = LB34 + log(s124**(-1)*s1234) * (  - 24*s12 - 128*s13 + 120
     +    *s14 + 24*s23 + 80*s24 - 32*s34 )

      LB34 = LB34 + Lc0(p12,p34)*S13**(-1)*S24**(-1)*S34**(-1) * ( 312*
     +    s12**2*s14**3 + 280*s12**2*s14**2*s23 - 128*s12**2*s14*s23**2
     +     - 80*s12**2*s23**3 - 624*s12*s14**4 - 1272*s12*s14**3*s23 - 
     +    904*s12*s14**2*s23**2 - 184*s12*s14*s23**3 + 48*s12*s23**4 + 
     +    8*s14**5 - 12*s14**4*s23 + 4*s14**3*s23**2 + 20*s14**2*s23**3
     +     - 4*s14*s23**4 )

      LB34 = LB34 + Lc0(p12,p34)*S13**(-1)*S24**(-1) * (  - 184*s12**3*
     +    s14 - 160*s12**3*s23 - 320*s12**3*s34 + 112*s12**2*s14**2 - 
     +    760*s12**2*s14*s23 - 1764*s12**2*s14*s34 - 32*s12**2*s23**2
     +     + 260*s12**2*s23*s34 - 104*s12**2*s34**2 + 832*s12*s14**3 + 
     +    2060*s12*s14**2*s23 + 3432*s12*s14**2*s34 + 556*s12*s14*
     +    s23**2 + 1120*s12*s14*s23*s34 - 1636*s12*s14*s34**2 + 60*s12*
     +    s23**3 - 260*s12*s23**2*s34 - 400*s12*s23*s34**2 + 12*s12*
     +    s34**3 + 140*s14**4 + 216*s14**3*s23 - 308*s14**3*s34 + 196*
     +    s14**2*s23**2 - 420*s14**2*s23*s34 + 384*s14**2*s34**2 - 80*
     +    s14*s23**3 - 136*s14*s23**2*s34 + 424*s14*s23*s34**2 + 16*s14
     +    *s34**3 - 256*s23**4 + 288*s23**2*s34**2 + 16*s23*s34**3 )

      LB34 = LB34 + Lc0(p12,p34)*S13**(-1)*S34**(-1) * ( 304*s12**2*
     +    s14**2 - 512*s12**2*s14*s23 - 496*s12**2*s14*s24 - 544*s12**2
     +    *s23**2 - 960*s12**2*s23*s24 - 496*s12**2*s24**2 - 1688*s12*
     +    s14**3 - 2672*s12*s14**2*s23 - 1904*s12*s14**2*s24 - 1728*s12
     +    *s14*s23**2 - 2824*s12*s14*s23*s24 - 1376*s12*s14*s24**2 - 
     +    616*s12*s23**3 - 1704*s12*s23**2*s24 - 1560*s12*s23*s24**2 - 
     +    520*s12*s24**3 + 12*s14**4 - 8*s14**3*s23 + 4*s14**3*s24 - 20
     +    *s14**2*s23**2 - 100*s14**2*s23*s24 - 60*s14**2*s24**2 - 120*
     +    s14*s23**3 - 368*s14*s23**2*s24 - 376*s14*s23*s24**2 - 124*
     +    s14*s24**3 - 128*s23**4 - 384*s23**3*s24 - 448*s23**2*s24**2
     +     - 256*s23*s24**3 - 64*s24**4 )

      LB34 = LB34 + Lc0(p12,p34)*S13**(-1)*S34**(-2) * (  - 64*s12*
     +    s14**3*s23 - 64*s12*s14**3*s24 - 208*s12*s14**2*s23**2 - 464*
     +    s12*s14**2*s23*s24 - 256*s12*s14**2*s24**2 - 272*s12*s14*
     +    s23**3 - 816*s12*s14*s23**2*s24 - 864*s12*s14*s23*s24**2 - 
     +    320*s12*s14*s24**3 - 128*s12*s23**4 - 464*s12*s23**3*s24 - 
     +    672*s12*s23**2*s24**2 - 464*s12*s23*s24**3 - 128*s12*s24**4 )

      LB34 = LB34 + Lc0(p12,p34)*S13**(-1) * (  - 192*s12**3 - 872*
     +    s12**2*s14 - 992*s12**2*s23 - 1200*s12**2*s24 - 468*s12**2*
     +    s34 + 1356*s12*s14**2 + 944*s12*s14*s23 + 224*s12*s14*s24 + 
     +    1864*s12*s14*s34 - 788*s12*s23**2 - 860*s12*s23*s24 - 144*s12
     +    *s23*s34 - 212*s12*s24**2 + 568*s12*s24*s34 - 128*s12*s34**2
     +     + 536*s14**3 + 516*s14**2*s23 + 556*s14**2*s24 - 200*s14**2*
     +    s34 - 116*s14*s23**2 + 44*s14*s23*s24 - 52*s14*s23*s34 + 136*
     +    s14*s24**2 + 4*s14*s24*s34 + 320*s14*s34**2 - 544*s23**3 - 
     +    432*s23**2*s24 + 32*s23**2*s34 - 168*s23*s24**2 + 64*s23*s24*
     +    s34 + 200*s23*s34**2 - 24*s24**3 + 8*s24**2*s34 + 72*s24*
     +    s34**2 + 24*s34**3 )

      LB34 = LB34 + Lc0(p12,p34)*S24**(-1)*S34**(-1) * (  - 8*s12**2*
     +    s13**2 - 168*s12**2*s13*s14 + 104*s12**2*s13*s23 + 176*s12**2
     +    *s14**2 + 32*s12**2*s14*s23 - 16*s12**2*s23**2 + 24*s12*
     +    s13**3 - 296*s12*s13**2*s14 + 24*s12*s13**2*s23 + 296*s12*s13
     +    *s14**2 - 152*s12*s13*s14*s23 + 192*s12*s13*s23**2 - 272*s12*
     +    s14**3 + 64*s12*s14**2*s23 + 96*s12*s14*s23**2 + 64*s12*
     +    s23**3 + 20*s13**4 - 52*s13**3*s14 + 68*s13**3*s23 + 24*
     +    s13**2*s14**2 - 60*s13**2*s14*s23 - 108*s13**2*s23**2 - 48*
     +    s13*s14**3 + 184*s13*s14**2*s23 - 240*s13*s14*s23**2 + 148*
     +    s13*s23**3 - 16*s14**4 + 8*s14**3*s23 + 52*s14**2*s23**2 + 
     +    124*s14*s23**3 )

      LB34 = LB34 + Lc0(p12,p34)*S24**(-1) * (  - 112*s12**3 - 104*
     +    s12**2*s13 - 1040*s12**2*s14 + 256*s12**2*s23 - 244*s12**2*
     +    s34 - 48*s12*s13**2 - 1196*s12*s13*s14 + 68*s12*s13*s23 - 256
     +    *s12*s13*s34 + 2652*s12*s14**2 + 700*s12*s14*s23 - 2128*s12*
     +    s14*s34 + 176*s12*s23**2 - 136*s12*s23*s34 + 64*s13**3 - 164*
     +    s13**2*s14 + 4*s13**2*s23 + 28*s13**2*s34 + 328*s13*s14**2 - 
     +    164*s13*s14*s23 - 356*s13*s14*s34 - 88*s13*s23**2 - 184*s13*
     +    s23*s34 + 32*s13*s34**2 - 192*s14**3 + 276*s14**2*s23 + 460*
     +    s14**2*s34 - 24*s14*s23**2 + 108*s14*s23*s34 - 240*s14*s34**2
     +     + 404*s23**3 + 276*s23**2*s34 - 152*s23*s34**2 - 16*s34**3 )

      LB34 = LB34 + Lc0(p12,p34)*S34**(-1) * ( 88*s12**2*s13 + 128*
     +    s12**2*s14 - 336*s12**2*s23 - 400*s12**2*s24 - 24*s12*s13**2
     +     - 72*s12*s13*s14 - 8*s12*s13*s23 - 112*s12*s13*s24 - 352*s12
     +    *s14**2 + 56*s12*s14*s23 - 176*s12*s14*s24 - 104*s12*s23**2
     +     - 120*s12*s23*s24 + 48*s12*s24**2 + 72*s13**3 + 16*s13**2*
     +    s14 - 244*s13**2*s23 + 148*s13**2*s24 - 40*s13*s14**2 - 384*
     +    s13*s14*s23 - 36*s13*s14*s24 - 232*s13*s23**2 - 412*s13*s23*
     +    s24 - 28*s13*s24**2 + 8*s14**3 + 16*s14**2*s23 - 4*s14**2*s24
     +     + 144*s14*s23**2 + 48*s14*s23*s24 + 80*s14*s24**2 + 140*
     +    s23**3 + 216*s23**2*s24 + 128*s23*s24**2 + 60*s24**3 )

      LB34 = LB34 + Lc0(p12,p34)*S34**(-2) * (  - 32*s12*s13**2*s23 + 
     +    32*s12*s13**2*s24 - 64*s12*s13*s14*s23 + 32*s12*s13*s23**2 + 
     +    32*s12*s13*s24**2 + 32*s12*s14*s23**2 - 64*s12*s14*s23*s24 - 
     +    32*s12*s14*s24**2 - 64*s12*s23**3 - 128*s12*s23**2*s24 - 96*
     +    s12*s23*s24**2 - 32*s12*s24**3 + 32*s13**3*s23 + 64*s13**3*
     +    s24 + 64*s13**2*s14*s24 - 256*s13**2*s23**2 - 256*s13**2*s23*
     +    s24 + 32*s13**2*s24**2 - 32*s13*s14**2*s23 - 256*s13*s14*
     +    s23**2 - 320*s13*s14*s23*s24 + 32*s13*s23**3 - 32*s13*s23*
     +    s24**2 + 32*s14**2*s23**2 + 64*s14*s23**3 + 64*s14*s23**2*s24
     +     )

      LB34 = LB34 + Lc0(p12,p34) * (  - 40*s12**2 - 452*s12*s13 + 1204*
     +    s12*s14 + 244*s12*s23 + 376*s12*s24 - 388*s12*s34 + 80*s13**2
     +     - 52*s13*s14 - 484*s13*s23 + 36*s13*s24 - 20*s13*s34 - 304*
     +    s14**2 - 152*s14*s23 - 140*s14*s24 + 28*s14*s34 + 372*s23**2
     +     + 28*s23*s24 - 132*s23*s34 + 12*s24**2 - 16*s24*s34 - 72*
     +    s34**2 )

      LB34 = LB34 + Lc0(p13,p24)*S13**(-1)*S24**(-1)*S34**(-1) * ( 8*
     +    s12**4*s14 + 8*s12**4*s23 - 24*s12**3*s14**2 + 48*s12**3*s14*
     +    s23 - 24*s12**3*s23**2 + 56*s12**2*s14**3 - 24*s12**2*s14**2*
     +    s23 - 24*s12**2*s14*s23**2 + 56*s12**2*s23**3 - 8*s12*s14**4
     +     + 104*s12*s14**3*s23 - 80*s12*s14**2*s23**2 + 104*s12*s14*
     +    s23**3 - 8*s12*s23**4 + 16*s14**3*s23**2 + 16*s14**2*s23**3 )

      LB34 = LB34 + Lc0(p13,p24)*S13**(-1)*S24**(-1) * ( 16*s12**4 + 16
     +    *s12**3*s14 + 16*s12**3*s23 + 32*s12**3*s34 + 120*s12**2*
     +    s14**2 - 16*s12**2*s14*s23 + 96*s12**2*s14*s34 + 120*s12**2*
     +    s23**2 + 96*s12**2*s23*s34 + 32*s12**2*s34**2 + 24*s12*s14**3
     +     + 152*s12*s14**2*s23 + 96*s12*s14**2*s34 + 152*s12*s14*
     +    s23**2 + 216*s12*s14*s23*s34 + 104*s12*s14*s34**2 + 24*s12*
     +    s23**3 + 96*s12*s23**2*s34 + 104*s12*s23*s34**2 + 40*s12*
     +    s34**3 + 8*s14**4 + 24*s14**3*s23 + 32*s14**3*s34 + 80*s14**2
     +    *s23**2 + 96*s14**2*s23*s34 + 48*s14**2*s34**2 + 24*s14*
     +    s23**3 + 96*s14*s23**2*s34 + 104*s14*s23*s34**2 + 32*s14*
     +    s34**3 + 8*s23**4 + 32*s23**3*s34 + 48*s23**2*s34**2 + 32*s23
     +    *s34**3 + 8*s34**4 )

      LB34 = LB34 + Lc0(p13,p24)*S13**(-1)*S34**(-1) * ( 8*s12**4 + 24*
     +    s12**3*s14 - 40*s12**3*s23 - 16*s12**3*s24 + 16*s12**2*s14**2
     +     - 64*s12**2*s14*s23 - 16*s12**2*s14*s24 - 8*s12**2*s23**2 - 
     +    56*s12**2*s23*s24 + 8*s12**2*s24**2 + 48*s12*s14**3 - 56*s12*
     +    s14**2*s23 + 24*s12*s14*s23**2 - 72*s12*s14*s23*s24 + 24*s12*
     +    s23**3 + 24*s12*s23**2*s24 - 8*s12*s23*s24**2 + 8*s14**4 + 16
     +    *s14**3*s23 + 24*s14**2*s23**2 )

      LB34 = LB34 + Lc0(p13,p24)*S13**(-1) * ( 24*s12**2*s14 - 16*
     +    s12**2*s23 + 16*s12**2*s24 + 32*s12**2*s34 + 120*s12*s14**2
     +     - 8*s12*s14*s23 + 112*s12*s14*s34 + 80*s12*s23**2 + 16*s12*
     +    s23*s24 + 80*s12*s23*s34 + 40*s12*s34**2 + 32*s14**3 + 72*
     +    s14**2*s23 + 48*s14**2*s34 + 32*s14*s23**2 + 80*s14*s23*s34
     +     + 32*s14*s34**2 + 8*s23**3 + 24*s23**2*s34 + 24*s23*s34**2
     +     + 8*s34**3 )

      LB34 = LB34 + Lc0(p13,p24)*S24**(-1)*S34**(-1) * ( 8*s12**4 - 16*
     +    s12**3*s13 - 40*s12**3*s14 + 24*s12**3*s23 + 8*s12**2*s13**2
     +     - 56*s12**2*s13*s14 - 16*s12**2*s13*s23 - 8*s12**2*s14**2 - 
     +    64*s12**2*s14*s23 + 16*s12**2*s23**2 - 8*s12*s13**2*s14 + 24*
     +    s12*s13*s14**2 - 72*s12*s13*s14*s23 + 24*s12*s14**3 + 24*s12*
     +    s14**2*s23 - 56*s12*s14*s23**2 + 48*s12*s23**3 + 24*s14**2*
     +    s23**2 + 16*s14*s23**3 + 8*s23**4 )

      LB34 = LB34 + Lc0(p13,p24)*S24**(-1) * ( 16*s12**2*s13 - 16*
     +    s12**2*s14 + 24*s12**2*s23 + 32*s12**2*s34 + 16*s12*s13*s14
     +     + 80*s12*s14**2 - 8*s12*s14*s23 + 80*s12*s14*s34 + 120*s12*
     +    s23**2 + 112*s12*s23*s34 + 40*s12*s34**2 + 8*s14**3 + 32*
     +    s14**2*s23 + 24*s14**2*s34 + 72*s14*s23**2 + 80*s14*s23*s34
     +     + 24*s14*s34**2 + 32*s23**3 + 48*s23**2*s34 + 32*s23*s34**2
     +     + 8*s34**3 )

      LB34 = LB34 + Lc0(p13,p24)*S34**(-1) * (  - 40*s12**2*s13 - 48*
     +    s12**2*s14 - 48*s12**2*s23 - 40*s12**2*s24 + 32*s12*s13**2 - 
     +    32*s12*s13*s14 - 24*s12*s13*s23 + 16*s12*s13*s24 - 24*s12*
     +    s14**2 - 96*s12*s14*s23 - 24*s12*s14*s24 - 24*s12*s23**2 - 32
     +    *s12*s23*s24 + 32*s12*s24**2 + 24*s13**2*s24 - 48*s13*s14*s23
     +     - 24*s13*s23**2 + 24*s13*s24**2 + 8*s14**3 - 24*s14**2*s23
     +     - 24*s14**2*s24 - 24*s14*s23**2 - 48*s14*s23*s24 + 8*s23**3
     +     )

      LB34 = LB34 + Lc0(p13,p24) * (  - 64*s12**2 + 16*s12*s13 - 56*s12
     +    *s14 - 56*s12*s23 + 16*s12*s24 - 8*s12*s34 - 24*s13*s14 - 64*
     +    s13*s23 + 8*s13*s24 - 40*s13*s34 - 72*s14*s23 - 64*s14*s24 - 
     +    40*s14*s34 - 24*s23*s24 - 40*s23*s34 - 40*s24*s34 - 32*s34**2
     +     )

      LB34 = LB34 + Lc1(p1,p24)*S13**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s23**2 - 16*s12**2*s23*s34 - 8*s12**2*s34**2 + 8*s12*s23**2*
     +    s34 + 16*s12*s23*s34**2 + 8*s12*s34**3 )

      LB34 = LB34 + Lc1(p1,p24)*S13**(-1)*S34**(-1) * ( 16*s12**3*s23
     +     + 16*s12**3*s24 + 32*s12**2*s23**2 + 28*s12**2*s23*s24 - 4*
     +    s12**2*s24**2 )

      LB34 = LB34 + Lc1(p1,p24)*S13**(-1) * ( 16*s12**3 + 8*s12**2*s23
     +     - 44*s12**2*s24 - 24*s12**2*s34 - 16*s12*s23**2 + 8*s12*s23*
     +    s24 + 8*s12*s23*s34 + 24*s12*s24**2 + 24*s12*s24*s34 + 16*s12
     +    *s34**2 )

      LB34 = LB34 + Lc1(p1,p24)*S24**(-1) * ( 8*s12**2*s23 + 8*s12**2*
     +    s34 - 8*s12*s13*s23 - 8*s12*s13*s34 + 8*s12*s23**2 + 8*s12*
     +    s23*s34 )

      LB34 = LB34 + Lc1(p1,p24)*S34**(-1) * (  - 8*s12**3 + 8*s12**2*
     +    s13 - 32*s12**2*s23 - 80*s12**2*s24 + 32*s12*s13*s24 - 24*s12
     +    *s23**2 - 16*s12*s23*s24 - 48*s12*s24**2 - 8*s13**2*s23 - 8*
     +    s13**2*s24 + 8*s13*s23**2 - 16*s13*s23*s24 - 24*s13*s24**2 )

      LB34 = LB34 + Lc1(p1,p24) * (  - 40*s12**2 + 8*s12*s13 + 8*s12*
     +    s23 + 32*s12*s24 + 40*s12*s34 - 32*s13*s24 + 8*s23**2 - 8*s23
     +    *s24 + 8*s23*s34 - 16*s24**2 - 16*s24*s34 )

      LB34 = LB34 + Lc1(p1,p34)*S13**(-1)*S24**(-1)*S134**(-1) * (  - 8
     +    *s12**2*s34**3 )

      LB34 = LB34 + Lc1(p1,p34)*S13**(-1)*S24**(-1) * (  - 16*s12**3*
     +    s34 - 32*s12**2*s23*s34 + 4*s12**2*s34**2 - 16*s12*s23**2*s34
     +     - 16*s12*s23*s34**2 )

      LB34 = LB34 + Lc1(p1,p34)*S13**(-1)*S134**(-1) * ( 12*s12**2*s14*
     +    s34 - 20*s12**2*s34**2 + 12*s12*s14**2*s24 - 12*s12*s14*s24*
     +    s34 )

      LB34 = LB34 + Lc1(p1,p34)*S13**(-1) * ( 8*s12**2*s34 - 16*s12*s23
     +    *s34 )

      LB34 = LB34 + Lc1(p1,p34)*S24**(-1) * (  - 16*s12**2*s23 + 16*
     +    s12**2*s34 + 32*s12*s13*s23 + 8*s12*s13*s34 - 20*s12*s23**2
     +     + 68*s12*s23*s34 + 40*s12*s34**2 - 24*s13**2*s23 - 8*s13**2*
     +    s34 + 32*s13*s23**2 - 52*s13*s23*s34 - 32*s13*s34**2 - 12*
     +    s23**3 + 44*s23**2*s34 + 40*s23*s34**2 - 16*s34**3 )

      LB34 = LB34 + Lc1(p1,p34)*S34**(-1) * (  - 48*s12*s13**2 - 40*s12
     +    *s13*s23 - 72*s12*s13*s24 - 128*s13**2*s23 - 128*s13**2*s24
     +     - 8*s13*s23**2 - 80*s13*s23*s24 - 72*s13*s24**2 )

      LB34 = LB34 + Lc1(p1,p34)*S34**(-2) * (  - 48*s12*s13**2*s23 - 48
     +    *s12*s13**2*s24 - 48*s13**2*s23**2 - 96*s13**2*s23*s24 - 48*
     +    s13**2*s24**2 )

      LB34 = LB34 + Lc1(p1,p34) * ( 48*s12**2 - 40*s12*s13 + 32*s12*s23
     +     + 28*s12*s24 + 56*s12*s34 - 72*s13**2 - 148*s13*s23 - 180*
     +    s13*s24 - 144*s13*s34 - 4*s23**2 + 8*s23*s24 + 64*s23*s34 - 
     +    16*s34**2 )

      LB34 = LB34 + Lc1(p1,p234)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 
     +    32*s14**3*s23**2 + 72*s14**2*s23**3 )

      LB34 = LB34 + Lc1(p1,p234)*S13**(-1)*S24**(-1) * (  - 64*s14**3*
     +    s23 - 32*s14**3*s34 + 172*s14**2*s23**2 + 128*s14**2*s23*s34
     +     + 28*s14**2*s34**2 + 48*s14*s23**3 + 120*s14*s23**2*s34 + 96
     +    *s14*s23*s34**2 + 24*s14*s34**3 )

      LB34 = LB34 + Lc1(p1,p234)*S13**(-1)*S34**(-1) * (  - 72*s14**3*
     +    s23 - 48*s14**3*s24 + 172*s14**2*s23**2 + 128*s14**2*s23*s24
     +     + 28*s14**2*s24**2 )

      LB34 = LB34 + Lc1(p1,p234)*S13**(-1) * (  - 72*s14**3 + 256*
     +    s14**2*s23 + 84*s14**2*s24 + 84*s14**2*s34 + 112*s14*s23**2
     +     + 104*s14*s23*s24 + 184*s14*s23*s34 + 40*s14*s24**2 + 80*s14
     +    *s24*s34 + 72*s14*s34**2 )

      LB34 = LB34 + Lc1(p1,p234)*S24**(-1)*S34**(-1) * (  - 24*s13**2*
     +    s23**2 - 80*s13*s14*s23**2 + 84*s13*s23**3 - 104*s14**2*
     +    s23**2 + 148*s14*s23**3 )

      LB34 = LB34 + Lc1(p1,p234)*S24**(-1) * (  - 56*s13**2*s23 - 32*
     +    s13**2*s34 - 176*s13*s14*s23 - 96*s13*s14*s34 + 172*s13*
     +    s23**2 + 68*s13*s23*s34 - 20*s13*s34**2 - 216*s14**2*s23 - 
     +    112*s14**2*s34 + 316*s14*s23**2 + 164*s14*s23*s34 - 4*s14*
     +    s34**2 + 36*s23**3 + 84*s23**2*s34 + 68*s23*s34**2 + 20*
     +    s34**3 )

      LB34 = LB34 + Lc1(p1,p234)*S34**(-1) * ( 192*s13**2*s23 + 152*
     +    s13**2*s24 + 80*s13*s14*s23 + 88*s13*s14*s24 + 272*s13*s23**2
     +     + 180*s13*s23*s24 - 8*s13*s24**2 - 112*s14**2*s23 - 24*
     +    s14**2*s24 + 368*s14*s23**2 + 220*s14*s23*s24 )

      LB34 = LB34 + Lc1(p1,p234)*S34**(-2) * ( 96*s13**2*s23**2 + 128*
     +    s13**2*s23*s24 + 32*s13**2*s24**2 + 64*s13*s14*s23**2 + 64*
     +    s13*s14*s23*s24 )

      LB34 = LB34 + Lc1(p1,p234) * ( 88*s13**2 + 340*s13*s23 + 56*s13*
     +    s24 + 44*s13*s34 - 120*s14**2 + 432*s14*s23 + 44*s14*s24 + 40
     +    *s14*s34 + 100*s23**2 + 104*s23*s24 + 144*s23*s34 + 40*s24**2
     +     + 64*s24*s34 + 52*s34**2 )

      LB34 = LB34 + Lc1(p2,p13)*S13**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s14**2 - 16*s12**2*s14*s34 - 8*s12**2*s34**2 + 8*s12*s14**2*
     +    s34 + 16*s12*s14*s34**2 + 8*s12*s34**3 )

      LB34 = LB34 + Lc1(p2,p13)*S13**(-1) * ( 8*s12**2*s14 + 8*s12**2*
     +    s34 + 8*s12*s14**2 - 8*s12*s14*s24 + 8*s12*s14*s34 - 8*s12*
     +    s24*s34 )

      LB34 = LB34 + Lc1(p2,p13)*S24**(-1)*S34**(-1) * ( 16*s12**3*s13
     +     + 16*s12**3*s14 - 4*s12**2*s13**2 + 28*s12**2*s13*s14 + 32*
     +    s12**2*s14**2 )

      LB34 = LB34 + Lc1(p2,p13)*S24**(-1) * ( 16*s12**3 - 44*s12**2*s13
     +     + 8*s12**2*s14 - 24*s12**2*s34 + 24*s12*s13**2 + 8*s12*s13*
     +    s14 + 24*s12*s13*s34 - 16*s12*s14**2 + 8*s12*s14*s34 + 24*s12
     +    *s34**2 )

      LB34 = LB34 + Lc1(p2,p13)*S34**(-1) * (  - 8*s12**3 - 80*s12**2*
     +    s13 - 32*s12**2*s14 + 8*s12**2*s24 - 48*s12*s13**2 - 16*s12*
     +    s13*s14 + 32*s12*s13*s24 - 24*s12*s14**2 - 24*s13**2*s24 - 16
     +    *s13*s14*s24 + 8*s14**2*s24 - 8*s14*s24**2 )

      LB34 = LB34 + Lc1(p2,p13) * (  - 40*s12**2 + 32*s12*s13 + 8*s12*
     +    s14 - 8*s12*s24 + 48*s12*s34 - 16*s13**2 - 8*s13*s14 - 48*s13
     +    *s24 - 32*s13*s34 + 8*s14**2 - 16*s14*s24 - 8*s14*s34 + 16*
     +    s24**2 - 16*s34**2 )

      LB34 = LB34 + Lc1(p2,p34)*S13**(-1)*S24**(-1) * (  - 16*s12**3*
     +    s34 + 16*s12**2*s14*s23 - 24*s12**2*s14*s34 - 16*s12**2*s23*
     +    s34 + 4*s12**2*s34**2 + 20*s12*s14**2*s23 - 12*s12*s14**2*s34
     +     + 32*s12*s14*s23**2 + 12*s12*s14*s23*s34 - 20*s12*s14*s34**2
     +     + 8*s12*s23**2*s34 + 16*s12*s23*s34**2 - 8*s12*s34**3 + 12*
     +    s14**3*s23 + 32*s14**2*s23**2 + 36*s14**2*s23*s34 + 24*s14*
     +    s23**3 + 56*s14*s23**2*s34 + 48*s14*s23*s34**2 + 8*s23**3*s34
     +     + 32*s23**2*s34**2 + 24*s23*s34**3 )

      LB34 = LB34 + Lc1(p2,p34)*S24**(-1)*S34**(-1) * (  - 24*s12*s13*
     +    s23**2 + 8*s12*s14*s23**2 + 48*s12*s23**3 - 48*s13**2*s23**2
     +     - 32*s13*s14*s23**2 + 128*s13*s23**3 + 16*s14**2*s23**2 + 
     +    128*s14*s23**3 )

      LB34 = LB34 + Lc1(p2,p34)*S24**(-1)*S34**(-2) * ( 48*s12*s13*
     +    s23**3 + 48*s12*s14*s23**3 + 48*s13**2*s23**3 + 96*s13*s14*
     +    s23**3 + 48*s14**2*s23**3 )

      LB34 = LB34 + Lc1(p2,p34)*S24**(-1)*S234**(-1) * ( 12*s12**2*
     +    s34**2 )

      LB34 = LB34 + Lc1(p2,p34)*S24**(-1) * (  - 48*s12**2*s23 - 24*
     +    s12**2*s34 - 28*s12*s13*s23 - 8*s12*s13*s34 - 32*s12*s14*s23
     +     - 20*s12*s14*s34 + 8*s12*s23**2 + 24*s12*s23*s34 - 16*s12*
     +    s34**2 - 8*s13**2*s23 - 24*s13*s14*s23 + 44*s13*s23**2 - 24*
     +    s13*s23*s34 - 4*s14**2*s23 + 76*s14*s23**2 - 8*s14*s23*s34 + 
     +    72*s23**3 + 76*s23**2*s34 + 8*s23*s34**2 )

      LB34 = LB34 + Lc1(p2,p34)*S34**(-1)*S234**(-1) * (  - 8*s12*s13*
     +    s24**2 + 8*s13**2*s24**2 - 24*s13*s14*s24**2 )

      LB34 = LB34 + Lc1(p2,p34)*S34**(-1) * ( 16*s12*s13*s24 + 8*s13**2
     +    *s24 + 8*s13*s14*s24 )

      LB34 = LB34 + Lc1(p2,p34)*S234**(-1) * ( 36*s12**2*s34 - 52*s12*
     +    s13*s24 - 20*s12*s13*s34 - 12*s12*s14*s24 - 12*s12*s14*s34 - 
     +    8*s13**2*s24 - 8*s13**2*s34 - 32*s13*s14*s24 - 8*s13*s14*s34
     +     - 8*s13*s24**2 - 16*s13*s24*s34 - 8*s13*s34**2 )

      LB34 = LB34 + Lc1(p2,p34) * ( 16*s12*s13 + 8*s13**2 + 8*s13*s14
     +     + 8*s13*s24 + 8*s13*s34 )

      LB34 = LB34 + Lc1(p2,p134)*S13**(-1)*S24**(-1)*S34**(-1) * ( 72*
     +    s14**3*s23**2 - 32*s14**2*s23**3 )

      LB34 = LB34 + Lc1(p2,p134)*S13**(-1)*S24**(-1) * ( 48*s14**3*s23
     +     + 180*s14**2*s23**2 + 128*s14**2*s23*s34 - 64*s14*s23**3 + 
     +    140*s14*s23**2*s34 + 108*s14*s23*s34**2 - 32*s23**3*s34 + 32*
     +    s23**2*s34**2 + 28*s23*s34**3 )

      LB34 = LB34 + Lc1(p2,p134)*S13**(-1)*S34**(-1) * ( 176*s14**3*s23
     +     + 112*s14**3*s24 - 88*s14**2*s23**2 - 112*s14**2*s23*s24 - 
     +    72*s14**2*s24**2 )

      LB34 = LB34 + Lc1(p2,p134)*S13**(-1) * ( 64*s14**3 + 420*s14**2*
     +    s23 + 204*s14**2*s24 + 164*s14**2*s34 - 192*s14*s23**2 - 256*
     +    s14*s23*s24 + 320*s14*s23*s34 - 160*s14*s24**2 + 84*s14*s24*
     +    s34 + 140*s14*s34**2 - 104*s23**2*s34 - 144*s23*s24*s34 + 76*
     +    s23*s34**2 - 88*s24**2*s34 - 8*s24*s34**2 + 40*s34**3 )

      LB34 = LB34 + Lc1(p2,p134)*S24**(-1)*S34**(-1) * ( 104*s13**2*
     +    s23**2 + 244*s13*s14*s23**2 - 48*s13*s23**3 + 212*s14**2*
     +    s23**2 - 72*s14*s23**3 )

      LB34 = LB34 + Lc1(p2,p134)*S24**(-1) * ( 92*s13**2*s23 + 172*s13*
     +    s14*s23 + 220*s13*s23**2 + 176*s13*s23*s34 + 128*s14**2*s23
     +     + 364*s14*s23**2 + 252*s14*s23*s34 - 72*s23**3 + 148*s23**2*
     +    s34 + 120*s23*s34**2 )

      LB34 = LB34 + Lc1(p2,p134)*S34**(-1) * ( 108*s13**2*s23 - 40*
     +    s13**2*s24 + 360*s13*s14*s23 + 76*s13*s14*s24 + 208*s13*
     +    s23**2 + 232*s13*s23*s24 + 64*s13*s24**2 + 428*s14**2*s23 + 
     +    228*s14**2*s24 + 72*s14*s23**2 + 64*s14*s23*s24 - 8*s14*
     +    s24**2 )

      LB34 = LB34 + Lc1(p2,p134)*S34**(-2) * ( 96*s13**2*s23**2 + 64*
     +    s13**2*s23*s24 + 128*s13*s14*s23**2 + 64*s13*s14*s23*s24 + 32
     +    *s14**2*s23**2 )

      LB34 = LB34 + Lc1(p2,p134) * ( 32*s13**2 + 80*s13*s14 + 228*s13*
     +    s23 - 88*s13*s24 + 56*s13*s34 + 112*s14**2 + 616*s14*s23 + 
     +    160*s14*s24 + 180*s14*s34 + 24*s23**2 + 32*s23*s24 + 196*s23*
     +    s34 - 24*s24**2 - 56*s24*s34 + 72*s34**2 )

      LB34 = LB34 + Lc1(p3,p12)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 80
     +    *s12**2*s14**2*s23 + 32*s12**2*s14*s23**2 - 16*s12**2*s23**3
     +     )

      LB34 = LB34 + Lc1(p3,p12)*S13**(-1)*S24**(-1) * (  - 48*s12**3*
     +    s14 + 48*s12**3*s23 + 80*s12**3*s34 + 48*s12**2*s14**2 + 32*
     +    s12**2*s14*s23 - 64*s12**2*s14*s34 - 24*s12**2*s23**2 - 48*
     +    s12**2*s23*s34 - 32*s12**2*s34**2 - 32*s12*s14*s23**2 - 8*s12
     +    *s14*s34**2 + 80*s12*s23**2*s34 - 8*s12*s34**3 - 16*s23**3*
     +    s34 )

      LB34 = LB34 + Lc1(p3,p12)*S13**(-1)*S34**(-1) * ( 32*s12**2*s14*
     +    s23 + 8*s12**2*s23**2 - 32*s12*s14*s23*s24 - 16*s12*s23**3 + 
     +    32*s12*s23**2*s24 )

      LB34 = LB34 + Lc1(p3,p12)*S13**(-1) * ( 32*s12**3 - 48*s12**2*s14
     +     - 16*s12**2*s34 - 32*s12*s14*s23 - 8*s12*s14*s34 + 64*s12*
     +    s23**2 - 32*s12*s23*s24 - 32*s12*s23*s34 + 8*s12*s24*s34 + 16
     +    *s23**2*s24 + 16*s23**2*s34 )

      LB34 = LB34 + Lc1(p3,p12)*S24**(-1)*S34**(-1) * (  - 88*s12**2*
     +    s13**2 - 40*s12**2*s13*s14 - 48*s12**2*s14**2 + 16*s12*s13**3
     +     + 56*s12*s13**2*s14 + 48*s12*s13*s14**2 - 16*s13**3*s14 - 8*
     +    s13**2*s14**2 + 16*s13*s14**3 )

      LB34 = LB34 + Lc1(p3,p12)*S24**(-1)*S34**(-2) * (  - 8*s12*s13**3
     +    *s14 - 8*s12*s13**2*s14**2 - 8*s13**3*s14**2 - 8*s13**2*
     +    s14**3 )

      LB34 = LB34 + Lc1(p3,p12)*S24**(-1) * (  - 152*s12**2*s13 + 80*
     +    s12**2*s14 - 80*s12**2*s34 - 96*s12*s13**2 - 144*s12*s13*s14
     +     - 96*s12*s13*s34 + 48*s12*s14**2 + 8*s12*s34**2 - 16*s13**3
     +     - 16*s13**2*s14 - 16*s13**2*s34 + 24*s13*s14**2 + 8*s13*s14*
     +    s34 - 8*s14**3 - 16*s14**2*s34 - 8*s14*s34**2 )

      LB34 = LB34 + Lc1(p3,p12)*S34**(-1) * (  - 24*s12**2*s13 - 32*
     +    s12**2*s14 - 80*s12**2*s24 - 16*s12*s13**2 - 56*s12*s13*s14
     +     + 48*s12*s13*s24 + 32*s12*s14**2 - 16*s13**3 - 48*s13**2*s14
     +     - 40*s13**2*s24 + 32*s13*s14**2 + 48*s13*s14*s24 + 32*s13*
     +    s24**2 - 8*s14**3 + 8*s14**2*s24 + 8*s14*s24**2 - 8*s24**3 )

      LB34 = LB34 + Lc1(p3,p12)*S34**(-2) * (  - 8*s12*s13**3 - 16*s12*
     +    s13**2*s14 - 8*s12*s13**2*s24 + 32*s12*s13*s14**2 + 72*s12*
     +    s13*s14*s24 + 40*s12*s13*s24**2 - 16*s13**3*s14 - 8*s13**3*
     +    s24 - 32*s13**2*s14**2 - 40*s13**2*s14*s24 - 16*s13**2*s24**2
     +     + 16*s13*s14**3 + 32*s13*s14**2*s24 + 16*s13*s14*s24**2 )

      LB34 = LB34 + Lc1(p3,p12) * (  - 160*s12**2 - 88*s12*s13 + 32*s12
     +    *s14 + 16*s12*s24 + 32*s12*s34 - 16*s13**2 + 32*s13*s14 - 8*
     +    s13*s24 - 8*s13*s34 - 8*s14**2 + 8*s14*s24 - 8*s14*s34 + 8*
     +    s24**2 + 8*s24*s34 - 8*s34**2 )

      LB34 = LB34 + Lc1(p3,p24)*S13**(-1)*S24**(-1) * ( 4*s12**2*s14*
     +    s34 + 4*s12**2*s34**2 + 8*s12*s14**2*s34 + 8*s12*s14*s34**2
     +     + 4*s14**3*s34 + 4*s14**2*s34**2 )

      LB34 = LB34 + Lc1(p3,p24)*S13**(-1) * (  - 12*s12**3 - 4*s12**2*
     +    s14 + 32*s12**2*s24 + 16*s12**2*s34 + 8*s12*s14*s24 + 16*s12*
     +    s14*s34 + 28*s12*s24**2 + 36*s12*s24*s34 + 12*s12*s34**2 - 8*
     +    s14**3 - 8*s14**2*s24 - 24*s14*s24**2 + 16*s14*s24*s34 + 12*
     +    s14*s34**2 + 24*s24**2*s34 )

      LB34 = LB34 + Lc1(p3,p24)*S24**(-1) * ( 4*s12**2*s34 - 24*s12*s13
     +    *s34 - 16*s12*s14*s34 - 24*s12*s34**2 - 24*s13**2*s34 - 48*
     +    s13*s14*s34 - 24*s13*s34**2 - 20*s14**2*s34 - 24*s14*s34**2 )

      LB34 = LB34 + Lc1(p3,p24)*S34**(-1)*S234**(-1) * ( 24*s12*s13*
     +    s24**2 + 12*s12*s14*s24**2 - 12*s13**2*s24**2 - 16*s13*s14*
     +    s24**2 + 8*s13*s24**3 + 6*s14**2*s24**2 )

      LB34 = LB34 + Lc1(p3,p24)*S34**(-1) * ( 16*s12**2*s24 + 8*s12*s13
     +    *s24 - 16*s12*s14*s24 + 16*s13**2*s24 + 4*s13*s14*s24 - 32*
     +    s13*s24**2 - 2*s14**2*s24 + 8*s14*s24**2 + 12*s24**3 )

      LB34 = LB34 + Lc1(p3,p24)*S34**(-2)*S234**(-1) * ( 8*s12*s13*
     +    s24**3 - 8*s13**2*s24**3 + 24*s13*s14*s24**3 )

      LB34 = LB34 + Lc1(p3,p24)*S34**(-2) * (  - 16*s12*s13*s24**2 - 8*
     +    s13**2*s24**2 - 8*s13*s14*s24**2 )

      LB34 = LB34 + Lc1(p3,p24)*S234**(-1) * (  - 24*s12**2*s24 - 12*
     +    s12*s14*s24 - 16*s13*s24**2 - 6*s14**2*s24 )

      LB34 = LB34 + Lc1(p3,p24) * ( 16*s12**2 + 4*s12*s13 + 12*s12*s14
     +     + 32*s12*s24 + 8*s12*s34 + 8*s13*s14 + 36*s13*s24 - 32*s13*
     +    s34 + 6*s14**2 - 20*s14*s34 - 16*s24**2 + 4*s24*s34 - 32*
     +    s34**2 )

      LB34 = LB34 + Lc1(p3,p124)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 
     +    80*s12**2*s14**2*s23 + 8*s12**2*s14*s23**2 + 8*s12**2*s23**3
     +     + 32*s12*s14**2*s23**2 - 144*s12*s14*s23**3 - 16*s12*s23**4
     +     + 24*s14**3*s23**2 - 72*s14**2*s23**3 - 16*s14*s23**4 )

      LB34 = LB34 + Lc1(p3,p124)*S13**(-1)*S24**(-1) * (  - 24*s12**3*
     +    s23 - 60*s12**3*s34 - 256*s12**2*s14**2 + 184*s12**2*s14*s23
     +     + 144*s12**2*s14*s34 + 40*s12**2*s23**2 + 40*s12**2*s23*s34
     +     - 16*s12**2*s34**2 - 160*s12*s14**3 - 88*s12*s14**2*s23 - 
     +    156*s12*s14**2*s34 - 304*s12*s14*s23**2 - 96*s12*s14*s23*s34
     +     + 16*s12*s14*s34**2 - 80*s12*s23**3 - 112*s12*s23**2*s34 - 
     +    48*s12*s23*s34**2 - 64*s14**4 + 24*s14**3*s23 + 8*s14**3*s34
     +     - 120*s14**2*s23**2 - 24*s14**2*s23*s34 - 48*s14*s23**3 - 48
     +    *s14*s23**2*s34 - 16*s14*s23*s34**2 )

      LB34 = LB34 + Lc1(p3,p124)*S13**(-1)*S34**(-1) * ( 80*s12**2*s14*
     +    s23 - 16*s12**2*s23**2 - 32*s12*s14**2*s23 - 40*s12*s14*
     +    s23**2 + 128*s12*s14*s23*s24 + 40*s12*s23**3 - 40*s12*s23**2*
     +    s24 - 32*s14**3*s23 - 8*s14**2*s23**2 + 16*s14**2*s23*s24 - 
     +    40*s14*s23**3 - 56*s14*s23**2*s24 + 48*s14*s23*s24**2 - 16*
     +    s23**4 + 32*s23**3*s24 - 24*s23**2*s24**2 )

      LB34 = LB34 + Lc1(p3,p124)*S13**(-1) * (  - 12*s12**3 + 52*s12**2
     +    *s14 - 40*s12**2*s23 + 8*s12**2*s24 - 124*s12**2*s34 - 128*
     +    s12*s14**2 + 96*s12*s14*s23 + 160*s12*s14*s24 - 36*s12*s14*
     +    s34 + 96*s12*s23**2 - 80*s12*s23*s24 + 72*s12*s23*s34 - 44*
     +    s12*s24**2 - 96*s12*s24*s34 - 40*s12*s34**2 - 96*s14**3 + 24*
     +    s14**2*s23 + 32*s14**2*s24 - 8*s14**2*s34 - 48*s14*s23**2 - 
     +    16*s14*s23*s24 + 24*s14*s23*s34 + 84*s14*s24**2 - 24*s14*s24*
     +    s34 - 24*s14*s34**2 - 48*s23**3 + 72*s23**2*s24 - 48*s23**2*
     +    s34 - 48*s23*s24**2 + 48*s23*s24*s34 - 16*s23*s34**2 - 32*
     +    s24**2*s34 - 32*s24*s34**2 )

      LB34 = LB34 + Lc1(p3,p124)*S24**(-1)*S34**(-1) * (  - 16*s12**3*
     +    s13 - 40*s12**2*s13**2 - 156*s12**2*s13*s14 + 48*s12**2*
     +    s14**2 + 112*s12*s13**3 - 56*s12*s13**2*s14 - 268*s12*s13*
     +    s14**2 + 16*s12*s14**3 + 112*s13**3*s14 - 40*s13**2*s14**2 - 
     +    152*s13*s14**3 - 32*s14**4 )

      LB34 = LB34 + Lc1(p3,p124)*S24**(-1)*S34**(-2) * ( 8*s12*s13**3*
     +    s14 + 8*s12*s13**2*s14**2 + 32*s13**3*s14**2 + 32*s13**2*
     +    s14**3 )

      LB34 = LB34 + Lc1(p3,p124)*S24**(-1) * ( 4*s12**3 - 72*s12**2*s13
     +     - 140*s12**2*s14 - 72*s12**2*s34 + 248*s12*s13**2 - 120*s12*
     +    s13*s14 + 192*s12*s13*s34 - 216*s12*s14**2 - 120*s12*s14*s34
     +     + 56*s12*s34**2 + 240*s13**2*s14 - 48*s13*s14**2 + 184*s13*
     +    s14*s34 - 72*s14**3 - 48*s14**2*s34 + 56*s14*s34**2 )

      LB34 = LB34 + Lc1(p3,p124)*S34**(-1) * (  - 4*s12**3 - 12*s12**2*
     +    s13 - 36*s12**2*s14 + 16*s12**2*s24 - 96*s12*s13**2 - 188*s12
     +    *s13*s14 - 36*s12*s13*s24 - 24*s12*s14**2 - 48*s12*s14*s24 - 
     +    60*s12*s24**2 + 112*s13**3 - 80*s13**2*s14 - 56*s13**2*s24 - 
     +    184*s13*s14**2 - 60*s13*s14*s24 - 72*s14**3 - 72*s14**2*s24
     +     - 44*s14*s24**2 - 16*s24**3 )

      LB34 = LB34 + Lc1(p3,p124)*S34**(-2) * ( 8*s12*s13**3 + 16*s12*
     +    s13**2*s14 + 8*s12*s13**2*s24 - 32*s12*s13*s14**2 - 72*s12*
     +    s13*s14*s24 - 40*s12*s13*s24**2 + 64*s13**3*s14 + 32*s13**3*
     +    s24 + 72*s13**2*s14**2 + 48*s13**2*s14*s24 + 8*s13**2*s24**2
     +     + 8*s13*s14**3 + 16*s13*s14**2*s24 + 8*s13*s14*s24**2 )

      LB34 = LB34 + Lc1(p3,p124) * (  - 184*s12*s13 - 208*s12*s14 - 52*
     +    s12*s24 - 176*s12*s34 + 256*s13**2 - 176*s13*s14 - 144*s13*
     +    s24 + 208*s13*s34 - 112*s14**2 - 92*s14*s24 - 168*s14*s34 - 8
     +    *s24**2 - 128*s24*s34 + 64*s34**2 )

      LB34 = LB34 + Lc1(p4,p12)*S13**(-1)*S24**(-1)*S34**(-1) * ( 24*
     +    s12**2*s14**3 - 24*s12**2*s14**2*s23 + 16*s12*s14**4 - 24*s12
     +    *s14**3*s23 + 24*s12*s14**2*s23**2 - 16*s14**4*s23 + 8*s14**3
     +    *s23**2 + 16*s14**2*s23**3 )

      LB34 = LB34 + Lc1(p4,p12)*S13**(-1)*S24**(-1)*S34**(-2) * (  - 8*
     +    s12*s14**4*s23 + 8*s12*s14**3*s23**2 - 8*s14**4*s23**2 + 8*
     +    s14**3*s23**3 )

      LB34 = LB34 + Lc1(p4,p12)*S13**(-1)*S24**(-1) * (  - 16*s12**2*
     +    s14**2 - 48*s12**2*s14*s23 - 16*s12**2*s14*s34 - 32*s12**2*
     +    s23*s34 - 24*s12**2*s34**2 - 64*s12*s14**3 + 8*s12*s14**2*s23
     +     + 32*s12*s14**2*s34 + 16*s12*s14*s23**2 - 8*s12*s14*s34**2
     +     - 8*s12*s23*s34**2 - 8*s12*s34**3 - 16*s14**4 + 16*s14**3*
     +    s23 + 16*s14**3*s34 + 24*s14**2*s23**2 + 8*s14**2*s23*s34 + 8
     +    *s14*s23**3 + 16*s14*s23**2*s34 + 8*s14*s23*s34**2 )

      LB34 = LB34 + Lc1(p4,p12)*S13**(-1)*S34**(-1) * ( 40*s12**2*s23*
     +    s24 + 40*s12**2*s24**2 )

      LB34 = LB34 + Lc1(p4,p12)*S13**(-1) * ( 48*s12**3 + 48*s12**2*s24
     +     + 16*s12**2*s34 - 16*s12*s24**2 - 32*s12*s24*s34 + 16*s24**2
     +    *s34 )

      LB34 = LB34 + Lc1(p4,p12)*S24**(-1)*S34**(-1) * ( 96*s12**2*s13*
     +    s14 - 8*s12**2*s14**2 - 16*s12**2*s14*s23 - 64*s12*s13**2*s14
     +     + 96*s12*s13*s14**2 - 32*s12*s13*s14*s23 + 48*s12*s14**3 - 
     +    32*s12*s14**2*s23 + 8*s13**3*s14 + 32*s13**2*s14**2 - 8*
     +    s13**2*s14*s23 + 40*s13*s14**3 + 48*s13*s14**2*s23 - 8*s13*
     +    s14*s23**2 - 16*s14**4 + 48*s14**3*s23 + 32*s14**2*s23**2 + 8
     +    *s14*s23**3 )

      LB34 = LB34 + Lc1(p4,p12)*S24**(-1)*S34**(-2) * ( 16*s12*s13**2*
     +    s14**2 + 8*s12*s13*s14**3 + 24*s12*s13*s14**2*s23 - 8*s12*
     +    s14**4 + 16*s12*s14**3*s23 + 8*s12*s14**2*s23**2 + 16*s13**2*
     +    s14**3 + 16*s13**2*s14**2*s23 - 8*s13*s14**4 + 40*s13*s14**3*
     +    s23 + 32*s13*s14**2*s23**2 - 16*s14**4*s23 + 32*s14**3*s23**2
     +     + 16*s14**2*s23**3 )

      LB34 = LB34 + Lc1(p4,p12)*S24**(-1) * ( 112*s12**2*s14 - 16*
     +    s12**2*s23 + 16*s12*s13**2 - 80*s12*s13*s14 - 16*s12*s13*s23
     +     + 8*s12*s13*s34 + 80*s12*s14**2 - 64*s12*s14*s23 - 48*s12*
     +    s14*s34 - 24*s12*s23*s34 - 16*s12*s34**2 - 8*s13**2*s14 - 8*
     +    s13*s14**2 - 8*s13*s14*s23 - 8*s13*s14*s34 + 16*s14**3 + 32*
     +    s14**2*s23 - 8*s14**2*s34 + 8*s14*s23**2 + 8*s14*s23*s34 + 8*
     +    s14*s34**2 )

      LB34 = LB34 + Lc1(p4,p12)*S34**(-1) * (  - 96*s12**2*s13 + 16*
     +    s12**2*s24 - 32*s12*s13**2 + 32*s12*s13*s24 + 16*s12*s24**2 )

      LB34 = LB34 + Lc1(p4,p12) * (  - 96*s12**2 - 64*s12*s13 - 32*s12*
     +    s34 + 16*s13*s24 + 16*s24*s34 )

      LB34 = LB34 + Lc1(p4,p13)*S13**(-1)*S24**(-1) * ( 4*s12**2*s23*
     +    s34 + 4*s12**2*s34**2 + 8*s12*s23**2*s34 + 8*s12*s23*s34**2
     +     + 4*s23**3*s34 + 4*s23**2*s34**2 )

      LB34 = LB34 + Lc1(p4,p13)*S13**(-1) * ( 4*s12**2*s34 - 16*s12*s23
     +    *s34 - 24*s12*s24*s34 - 24*s12*s34**2 - 20*s23**2*s34 - 48*
     +    s23*s24*s34 - 24*s23*s34**2 - 24*s24**2*s34 - 24*s24*s34**2 )

      LB34 = LB34 + Lc1(p4,p13)*S24**(-1)*S134**(-1) * ( 8*s12**3*s13
     +     + 8*s12**2*s13*s23 + 8*s12**2*s23*s34 )

      LB34 = LB34 + Lc1(p4,p13)*S24**(-1) * (  - 12*s12**3 + 32*s12**2*
     +    s13 - 4*s12**2*s23 + 16*s12**2*s34 + 28*s12*s13**2 + 8*s12*
     +    s13*s23 + 36*s12*s13*s34 + 16*s12*s23*s34 + 12*s12*s34**2 - 
     +    24*s13**2*s23 + 24*s13**2*s34 - 8*s13*s23**2 + 16*s13*s23*s34
     +     - 8*s23**3 + 12*s23*s34**2 )

      LB34 = LB34 + Lc1(p4,p13)*S34**(-1)*S134**(-1) * (  - 8*s12**2*
     +    s13**2 + 12*s12*s13**2*s23 - 24*s12*s13**2*s24 )

      LB34 = LB34 + Lc1(p4,p13)*S34**(-1) * ( 8*s12**2*s13 - 8*s12*s13*
     +    s23 + 8*s12*s13*s24 + 12*s13**3 + 8*s13**2*s23 - 24*s13**2*
     +    s24 - 2*s13*s23**2 + 4*s13*s23*s24 + 16*s13*s24**2 )

      LB34 = LB34 + Lc1(p4,p13)*S134**(-1) * ( 8*s12**2*s13 + 16*s12**2
     +    *s34 + 12*s12*s13*s23 - 24*s12*s13*s24 )

      LB34 = LB34 + Lc1(p4,p13) * ( 24*s12**2 + 32*s12*s13 + 4*s12*s23
     +     - 28*s12*s24 - 24*s12*s34 - 16*s13**2 + 36*s13*s24 + 4*s13*
     +    s34 + 6*s23**2 + 8*s23*s24 - 20*s23*s34 - 32*s24*s34 - 32*
     +    s34**2 )

      LB34 = LB34 + Lc1(p4,p123)*S13**(-1)*S24**(-1)*S34**(-1) * ( 44*
     +    s12**3*s14**2 - 232*s12**2*s14**3 + 196*s12**2*s14**2*s23 + 
     +    112*s12*s14**4 - 416*s12*s14**3*s23 + 192*s12*s14**2*s23**2
     +     + 112*s14**4*s23 - 160*s14**3*s23**2 + 40*s14**2*s23**3 )

      LB34 = LB34 + Lc1(p4,p123)*S13**(-1)*S24**(-1)*S34**(-2) * ( 8*
     +    s12*s14**4*s23 - 8*s12*s14**3*s23**2 + 32*s14**4*s23**2 - 32*
     +    s14**3*s23**3 )

      LB34 = LB34 + Lc1(p4,p123)*S13**(-1)*S24**(-1) * (  - 4*s12**3*
     +    s14 - 184*s12**3*s34 - 336*s12**2*s14**2 + 156*s12**2*s14*s23
     +     - 184*s12**2*s14*s34 - 200*s12**2*s23*s34 - 584*s12**2*
     +    s34**2 + 296*s12*s14**3 - 696*s12*s14**2*s23 + 200*s12*s14**2
     +    *s34 + 232*s12*s14*s23**2 - 496*s12*s14*s23*s34 + 64*s12*s14*
     +    s34**2 - 440*s12*s23*s34**2 - 144*s12*s34**3 + 304*s14**3*s23
     +     - 360*s14**2*s23**2 + 216*s14**2*s23*s34 + 72*s14*s23**3 - 
     +    312*s14*s23**2*s34 + 72*s14*s23*s34**2 + 48*s23**3*s34 - 128*
     +    s23**2*s34**2 - 32*s23*s34**3 )

      LB34 = LB34 + Lc1(p4,p123)*S13**(-1)*S34**(-1) * (  - 32*s12**2*
     +    s23*s24 - 32*s12**2*s24**2 - 24*s12*s23**2*s24 - 40*s12*s23*
     +    s24**2 - 16*s12*s24**3 + 8*s23**3*s24 - 8*s23**2*s24**2 - 16*
     +    s23*s24**3 )

      LB34 = LB34 + Lc1(p4,p123)*S13**(-1) * (  - 72*s12**3 - 168*
     +    s12**2*s23 - 304*s12**2*s24 - 768*s12**2*s34 - 80*s12*s23**2
     +     - 288*s12*s23*s24 - 520*s12*s23*s34 - 144*s12*s24**2 - 384*
     +    s12*s24*s34 - 400*s12*s34**2 + 16*s23**3 - 32*s23**2*s24 - 40
     +    *s23**2*s34 - 80*s23*s24**2 - 144*s23*s24*s34 - 112*s23*
     +    s34**2 )

      LB34 = LB34 + Lc1(p4,p123)*S24**(-1)*S34**(-1) * ( 68*s12**3*s14
     +     + 224*s12**2*s13*s14 + 64*s12**2*s14**2 + 268*s12**2*s14*s23
     +     + 284*s12*s13**2*s14 - 172*s12*s13*s14**2 + 456*s12*s13*s14*
     +    s23 - 376*s12*s14**3 + 112*s12*s14**2*s23 + 240*s12*s14*
     +    s23**2 + 120*s13**3*s14 - 120*s13**2*s14**2 + 276*s13**2*s14*
     +    s23 - 144*s13*s14**3 - 132*s13*s14**2*s23 + 208*s13*s14*
     +    s23**2 + 112*s14**4 - 320*s14**3*s23 + 56*s14**2*s23**2 + 48*
     +    s14*s23**3 )

      LB34 = LB34 + Lc1(p4,p123)*S24**(-1)*S34**(-2) * (  - 16*s12*
     +    s13**2*s14**2 - 8*s12*s13*s14**3 - 24*s12*s13*s14**2*s23 + 8*
     +    s12*s14**4 - 16*s12*s14**3*s23 - 8*s12*s14**2*s23**2 - 40*
     +    s13**3*s14**2 - 8*s13**2*s14**3 - 112*s13**2*s14**2*s23 + 32*
     +    s13*s14**4 - 48*s13*s14**3*s23 - 104*s13*s14**2*s23**2 + 64*
     +    s14**4*s23 - 72*s14**3*s23**2 - 32*s14**2*s23**3 )

      LB34 = LB34 + Lc1(p4,p123)*S24**(-1) * (  - 8*s12**3 + 176*s12**2
     +    *s13 + 104*s12**2*s14 + 64*s12**2*s23 - 280*s12**2*s34 + 296*
     +    s12*s13**2 - 4*s12*s13*s14 + 256*s12*s13*s23 + 152*s12*s13*
     +    s34 - 784*s12*s14**2 + 208*s12*s14*s23 - 448*s12*s14*s34 + 72
     +    *s12*s23**2 - 240*s12*s23*s34 - 768*s12*s34**2 + 136*s13**3
     +     - 64*s13**2*s14 + 248*s13**2*s23 + 88*s13**2*s34 - 456*s13*
     +    s14**2 - 108*s13*s14*s23 - 240*s13*s14*s34 + 112*s13*s23**2
     +     - 48*s13*s23*s34 - 280*s13*s34**2 + 288*s14**3 - 848*s14**2*
     +    s23 + 192*s14**2*s34 + 40*s14*s23**2 - 576*s14*s23*s34 + 64*
     +    s14*s34**2 + 16*s23**3 - 72*s23**2*s34 - 408*s23*s34**2 - 32*
     +    s34**3 )

      LB34 = LB34 + Lc1(p4,p123)*S34**(-1) * ( 48*s12**2*s13 - 56*
     +    s12**2*s24 + 224*s12*s13**2 + 64*s12*s13*s23 - 80*s12*s13*s24
     +     - 136*s12*s23*s24 - 224*s12*s24**2 + 96*s13**3 + 112*s13**2*
     +    s23 - 24*s13**2*s24 + 16*s13*s23**2 - 72*s13*s23*s24 - 112*
     +    s13*s24**2 - 40*s23**2*s24 - 120*s23*s24**2 - 16*s24**3 )

      LB34 = LB34 + Lc1(p4,p123) * (  - 280*s12**2 + 56*s12*s13 - 352*
     +    s12*s23 - 1024*s12*s24 - 1456*s12*s34 + 72*s13**2 - 72*s13*
     +    s23 - 448*s13*s24 - 560*s13*s34 - 96*s23**2 - 480*s23*s24 - 
     +    600*s23*s34 - 80*s24**2 - 144*s24*s34 - 112*s34**2 )

      LB34a=-LB34/s134/s234
      
      return
      end

      function LB34b(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LB34=0d0

      LB34 = LB34 + Lc1(p12,p34)*S13**(-1)*S24**(-1)*S34**(-1) * ( 312*
     +    s12*s14**4 + 576*s12*s14**3*s23 + 152*s12*s14**2*s23**2 - 208
     +    *s12*s14*s23**3 - 80*s12*s23**4 - 616*s14**5 - 1888*s14**4*
     +    s23 - 2224*s14**3*s23**2 - 1112*s14**2*s23**3 - 128*s14*
     +    s23**4 + 48*s23**5 )

      LB34 = LB34 + Lc1(p12,p34)*S13**(-1)*S24**(-1) * ( 688*s12**3*s34
     +     - 1416*s12**2*s14**2 - 200*s12**2*s14*s23 + 2880*s12**2*s14*
     +    s34 + 144*s12**2*s23**2 - 512*s12**2*s23*s34 + 336*s12**2*
     +    s34**2 + 1832*s12*s14**3 + 1392*s12*s14**2*s23 - 8336*s12*
     +    s14**2*s34 + 464*s12*s14*s23**2 - 4760*s12*s14*s23*s34 + 3312
     +    *s12*s14*s34**2 - 88*s12*s23**3 + 48*s12*s23**2*s34 + 864*s12
     +    *s23*s34**2 - 8*s12*s34**3 + 1824*s14**4 + 4792*s14**3*s23 - 
     +    144*s14**3*s34 + 3996*s14**2*s23**2 - 1000*s14**2*s23*s34 - 
     +    772*s14**2*s34**2 + 1212*s14*s23**3 - 1028*s14*s23**2*s34 - 
     +    908*s14*s23*s34**2 - 36*s14*s34**3 + 472*s23**4 - 196*s23**3*
     +    s34 - 584*s23**2*s34**2 - 60*s23*s34**3 )

      LB34 = LB34 + Lc1(p12,p34)*S13**(-1)*S34**(-1) * ( 600*s12*s14**3
     +     + 296*s12*s14**2*s23 + 32*s12*s14**2*s24 - 608*s12*s14*
     +    s23**2 - 640*s12*s14*s23*s24 - 240*s12*s14*s24**2 - 112*s12*
     +    s23**3 - 160*s12*s23**2*s24 - 112*s12*s23*s24**2 + 16*s12*
     +    s24**3 - 2304*s14**4 - 5552*s14**3*s23 - 3480*s14**3*s24 - 
     +    4848*s14**2*s23**2 - 6304*s14**2*s23*s24 - 2664*s14**2*s24**2
     +     - 1736*s14*s23**3 - 3912*s14*s23**2*s24 - 3312*s14*s23*
     +    s24**2 - 1008*s14*s24**3 - 56*s23**4 - 624*s23**3*s24 - 1024*
     +    s23**2*s24**2 - 640*s23*s24**3 - 136*s24**4 )

      LB34 = LB34 + Lc1(p12,p34)*S13**(-1)*S34**(-2) * (  - 64*s14**4*
     +    s23 - 64*s14**4*s24 - 272*s14**3*s23**2 - 592*s14**3*s23*s24
     +     - 320*s14**3*s24**2 - 480*s14**2*s23**3 - 1488*s14**2*s23**2
     +    *s24 - 1584*s14**2*s23*s24**2 - 576*s14**2*s24**3 - 400*s14*
     +    s23**4 - 1552*s14*s23**3*s24 - 2352*s14*s23**2*s24**2 - 1648*
     +    s14*s23*s24**3 - 448*s14*s24**4 - 128*s23**5 - 592*s23**4*s24
     +     - 1136*s23**3*s24**2 - 1136*s23**2*s24**3 - 592*s23*s24**4
     +     - 128*s24**5 )

      LB34 = LB34 + Lc1(p12,p34)*S13**(-1) * (  - 296*s12**2*s14 + 1504
     +    *s12**2*s23 + 1808*s12**2*s24 + 656*s12**2*s34 + 2792*s12*
     +    s14**2 + 1840*s12*s14*s23 + 1904*s12*s14*s24 - 5688*s12*s14*
     +    s34 + 1696*s12*s23**2 + 2296*s12*s23*s24 - 440*s12*s23*s34 + 
     +    896*s12*s24**2 - 1368*s12*s24*s34 + 280*s12*s34**2 + 4480*
     +    s14**3 + 8236*s14**2*s23 + 4064*s14**2*s24 - 1236*s14**2*s34
     +     + 4068*s14*s23**2 + 4648*s14*s23*s24 - 2112*s14*s23*s34 + 
     +    1768*s14*s24**2 - 944*s14*s24*s34 - 644*s14*s34**2 + 1084*
     +    s23**3 + 1304*s23**2*s24 - 512*s23**2*s34 + 1068*s23*s24**2
     +     - 440*s23*s24*s34 - 408*s23*s34**2 + 376*s24**3 - 76*s24**2*
     +    s34 - 144*s24*s34**2 - 52*s34**3 )

      LB34 = LB34 + Lc1(p12,p34)*S24**(-1)*S34**(-1) * ( 456*s12*s14**3
     +     + 488*s12*s14**2*s23 - 128*s12*s14*s23**2 - 112*s12*s23**3
     +     - 808*s14**4 - 1560*s14**3*s23 - 1056*s14**2*s23**2 - 200*
     +    s14*s23**3 + 112*s23**4 )

      LB34 = LB34 + Lc1(p12,p34)*S24**(-1) * (  - 104*s12**2*s14 - 576*
     +    s12**2*s23 + 400*s12**2*s34 - 3672*s12*s14**2 - 1976*s12*s14*
     +    s23 + 2304*s12*s14*s34 + 56*s12*s23**2 - 160*s12*s23*s34 - 56
     +    *s12*s34**2 + 3632*s14**3 + 5008*s14**2*s23 - 2480*s14**2*s34
     +     + 1452*s14*s23**2 - 2456*s14*s23*s34 + 540*s14*s34**2 - 664*
     +    s23**3 - 844*s23**2*s34 + 248*s23*s34**2 + 60*s34**3 )

      LB34 = LB34 + Lc1(p12,p34)*S34**(-1) * ( 448*s12*s14**2 - 880*s12
     +    *s14*s23 - 1008*s12*s14*s24 - 1088*s12*s23**2 - 2144*s12*s23*
     +    s24 - 1232*s12*s24**2 - 2376*s14**3 - 3248*s14**2*s23 - 2568*
     +    s14**2*s24 - 1920*s14*s23**2 - 3160*s14*s23*s24 - 1552*s14*
     +    s24**2 - 752*s23**3 - 2048*s23**2*s24 - 1704*s23*s24**2 - 520
     +    *s24**3 )

      LB34 = LB34 + Lc1(p12,p34)*S34**(-2) * (  - 64*s14**3*s23 - 64*
     +    s14**3*s24 - 240*s14**2*s23**2 - 528*s14**2*s23*s24 - 288*
     +    s14**2*s24**2 - 336*s14*s23**3 - 1008*s14*s23**2*s24 - 1056*
     +    s14*s23*s24**2 - 384*s14*s24**3 - 192*s23**4 - 656*s23**3*s24
     +     - 896*s23**2*s24**2 - 592*s23*s24**3 - 160*s24**4 )

      LB34 = LB34 + Lc1(p12,p34) * (  - 832*s12**2 - 3328*s12*s14 - 872
     +    *s12*s23 - 912*s12*s24 + 368*s12*s34 + 5784*s14**2 + 3540*s14
     +    *s23 + 2680*s14*s24 - 1828*s14*s34 - 724*s23**2 + 244*s23*s24
     +     - 460*s23*s34 + 456*s24**2 - 148*s24*s34 + 136*s34**2 )

      LB34 = LB34 + Lc1(p13,p24)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 8
     +    *s12**4*s14 - 8*s12**4*s23 + 24*s12**3*s14**2 - 16*s12**3*s14
     +    *s23 + 32*s12**3*s23**2 - 64*s12**2*s14**3 + 24*s12**2*s14*
     +    s23**2 + 16*s12*s14**4 - 120*s12*s14**3*s23 - 16*s12*s14**2*
     +    s23**2 - 24*s14**3*s23**2 )

      LB34 = LB34 + Lc1(p13,p24)*S13**(-1)*S24**(-1) * (  - 16*s12**4
     +     + 32*s12**3*s14 + 8*s12**3*s23 - 40*s12**2*s14**2 + 8*s12**2
     +    *s14*s23 + 16*s12**2*s14*s34 - 8*s12**2*s23**2 - 8*s12**2*s23
     +    *s34 + 8*s12**2*s34**2 + 40*s12*s14**3 - 144*s12*s14**2*s23
     +     + 32*s12*s14**2*s34 - 16*s12*s14*s23**2 - 24*s12*s14*s23*s34
     +     + 8*s12*s14*s34**2 - 24*s14**2*s23**2 )

      LB34 = LB34 + Lc1(p13,p24)*S13**(-1)*S34**(-1) * (  - 8*s12**4 - 
     +    8*s12**3*s14 + 48*s12**3*s23 + 16*s12**3*s24 + 8*s12**2*
     +    s14**2 + 52*s12**2*s14*s23 + 28*s12**2*s14*s24 + 24*s12**2*
     +    s23**2 + 24*s12**2*s23*s24 - 8*s12*s14**3 + 28*s12*s14**2*s23
     +     + 16*s12*s14**2*s24 + 60*s12*s14*s23**2 + 52*s12*s14*s23*s24
     +     - 8*s12*s14*s24**2 + 16*s14**2*s23**2 + 16*s14**2*s23*s24 + 
     +    16*s14*s23**3 + 8*s14*s23**2*s24 - 8*s14*s23*s24**2 )

      LB34 = LB34 + Lc1(p13,p24)*S13**(-1) * ( 8*s12**2*s14 - 16*s12**2
     +    *s23 - 32*s12**2*s24 - 44*s12**2*s34 + 60*s12*s14*s23 - 20*
     +    s12*s14*s24 - 20*s12*s14*s34 - 32*s12*s23**2 - 20*s12*s23*s24
     +     - 36*s12*s23*s34 + 12*s12*s24**2 + 8*s12*s24*s34 - 4*s12*
     +    s34**2 + 16*s14**2*s23 + 8*s14*s23**2 - 16*s14*s23*s24 - 8*
     +    s14*s23*s34 )

      LB34 = LB34 + Lc1(p13,p24)*S24**(-1)*S34**(-1) * (  - 8*s12**4 + 
     +    16*s12**3*s13 + 40*s12**3*s14 - 8*s12**3*s23 + 32*s12**2*s13*
     +    s14 + 16*s12**2*s13*s23 - 32*s12**2*s14**2 + 16*s12**2*s14*
     +    s23 - 8*s12**2*s23**2 - 16*s12*s13*s14**2 + 32*s12*s13*s14*
     +    s23 - 88*s12*s14**2*s23 - 16*s12*s14*s23**2 - 24*s14**2*
     +    s23**2 )

      LB34 = LB34 + Lc1(p13,p24)*S24**(-1) * ( 32*s12**3 - 8*s12**2*s13
     +     + 48*s12**2*s14 + 8*s12**2*s23 - 8*s12*s13*s14 + 8*s12*s14*
     +    s23 )

      LB34 = LB34 + Lc1(p13,p24)*S34**(-1) * ( 32*s12**2*s13 + 40*
     +    s12**2*s14 + 52*s12**2*s23 + 60*s12**2*s24 - 8*s12*s13**2 + 
     +    64*s12*s13*s14 + 16*s12*s13*s23 - 44*s12*s13*s24 + 64*s12*
     +    s14**2 + 60*s12*s14*s23 - 12*s12*s14*s24 - 28*s12*s23*s24 - 
     +    28*s12*s24**2 - 8*s13**2*s14 - 8*s13*s14**2 + 16*s13*s14*s23
     +     - 8*s13*s14*s24 + 8*s13*s23*s24 + 8*s13*s24**2 + 24*s14**2*
     +    s23 - 8*s14*s23**2 - 24*s14*s23*s24 - 16*s14*s24**2 - 16*
     +    s23**2*s24 - 8*s23*s24**2 + 8*s24**3 )

      LB34 = LB34 + Lc1(p13,p24) * ( 80*s12**2 - 12*s12*s13 + 92*s12*
     +    s14 + 28*s12*s23 - 60*s12*s24 + 8*s12*s34 - 16*s13*s14 + 8*
     +    s13*s24 + 8*s14*s23 - 24*s14*s24 - 8*s14*s34 + 8*s23*s24 + 32
     +    *s24**2 + 24*s24*s34 )

      LB34 = LB34 + Lc1(p24,p13)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 8
     +    *s12**4*s14 - 8*s12**4*s23 + 32*s12**3*s14**2 - 16*s12**3*s14
     +    *s23 + 24*s12**3*s23**2 + 24*s12**2*s14**2*s23 - 64*s12**2*
     +    s23**3 - 16*s12*s14**2*s23**2 - 120*s12*s14*s23**3 + 16*s12*
     +    s23**4 - 24*s14**2*s23**3 )

      LB34 = LB34 + Lc1(p24,p13)*S13**(-1)*S24**(-1) * (  - 16*s12**4
     +     + 8*s12**3*s14 + 32*s12**3*s23 - 8*s12**2*s14**2 + 8*s12**2*
     +    s14*s23 - 8*s12**2*s14*s34 - 40*s12**2*s23**2 + 16*s12**2*s23
     +    *s34 + 8*s12**2*s34**2 - 16*s12*s14**2*s23 - 144*s12*s14*
     +    s23**2 - 24*s12*s14*s23*s34 + 40*s12*s23**3 + 32*s12*s23**2*
     +    s34 + 8*s12*s23*s34**2 - 24*s14**2*s23**2 )

      LB34 = LB34 + Lc1(p24,p13)*S13**(-1)*S34**(-1) * (  - 8*s12**4 - 
     +    8*s12**3*s14 + 40*s12**3*s23 + 16*s12**3*s24 - 8*s12**2*
     +    s14**2 + 16*s12**2*s14*s23 + 16*s12**2*s14*s24 - 32*s12**2*
     +    s23**2 + 32*s12**2*s23*s24 - 16*s12*s14**2*s23 - 88*s12*s14*
     +    s23**2 + 32*s12*s14*s23*s24 - 16*s12*s23**2*s24 - 24*s14**2*
     +    s23**2 )

      LB34 = LB34 + Lc1(p24,p13)*S13**(-1) * ( 32*s12**3 + 8*s12**2*s14
     +     + 48*s12**2*s23 - 8*s12**2*s24 + 8*s12*s14*s23 - 8*s12*s23*
     +    s24 )

      LB34 = LB34 + Lc1(p24,p13)*S24**(-1)*S34**(-1) * (  - 8*s12**4 + 
     +    16*s12**3*s13 + 48*s12**3*s14 - 8*s12**3*s23 + 24*s12**2*s13*
     +    s14 + 28*s12**2*s13*s23 + 24*s12**2*s14**2 + 52*s12**2*s14*
     +    s23 + 8*s12**2*s23**2 - 8*s12*s13**2*s23 + 52*s12*s13*s14*s23
     +     + 16*s12*s13*s23**2 + 60*s12*s14**2*s23 + 28*s12*s14*s23**2
     +     - 8*s12*s23**3 - 8*s13**2*s14*s23 + 8*s13*s14**2*s23 + 16*
     +    s13*s14*s23**2 + 16*s14**3*s23 + 16*s14**2*s23**2 )

      LB34 = LB34 + Lc1(p24,p13)*S24**(-1) * (  - 32*s12**2*s13 - 16*
     +    s12**2*s14 + 8*s12**2*s23 - 44*s12**2*s34 + 12*s12*s13**2 - 
     +    20*s12*s13*s14 - 20*s12*s13*s23 + 8*s12*s13*s34 - 32*s12*
     +    s14**2 + 60*s12*s14*s23 - 36*s12*s14*s34 - 20*s12*s23*s34 - 4
     +    *s12*s34**2 - 16*s13*s14*s23 + 8*s14**2*s23 + 16*s14*s23**2
     +     - 8*s14*s23*s34 )

      LB34 = LB34 + Lc1(p24,p13)*S34**(-1) * ( 60*s12**2*s13 + 52*
     +    s12**2*s14 + 40*s12**2*s23 + 32*s12**2*s24 - 28*s12*s13**2 - 
     +    28*s12*s13*s14 - 12*s12*s13*s23 - 44*s12*s13*s24 + 60*s12*s14
     +    *s23 + 16*s12*s14*s24 + 64*s12*s23**2 + 64*s12*s23*s24 - 8*
     +    s12*s24**2 + 8*s13**3 - 8*s13**2*s14 - 16*s13**2*s23 + 8*
     +    s13**2*s24 - 16*s13*s14**2 - 24*s13*s14*s23 + 8*s13*s14*s24
     +     - 8*s13*s23*s24 - 8*s14**2*s23 + 24*s14*s23**2 + 16*s14*s23*
     +    s24 - 8*s23**2*s24 - 8*s23*s24**2 )

      LB34 = LB34 + Lc1(p24,p13) * ( 80*s12**2 - 60*s12*s13 + 28*s12*
     +    s14 + 92*s12*s23 - 12*s12*s24 + 8*s12*s34 + 32*s13**2 + 8*s13
     +    *s14 - 24*s13*s23 + 8*s13*s24 + 24*s13*s34 + 8*s14*s23 - 16*
     +    s23*s24 - 8*s23*s34 )

      LB34 = LB34 + Lc1(p34,p12)*S13**(-1)*S24**(-1)*S34**(-1) * ( 128*
     +    s14**5 + 400*s14**4*s23 + 360*s14**3*s23**2 + 16*s14**2*
     +    s23**3 - 320*s14*s23**4 - 256*s23**5 )

      LB34 = LB34 + Lc1(p34,p12)*S13**(-1)*S24**(-1) * (  - 240*s14**4
     +     - 728*s14**3*s23 + 416*s14**3*s34 - 576*s14**2*s23**2 + 832*
     +    s14**2*s23*s34 + 16*s14**2*s34**2 - 160*s14*s23**3 + 696*s14*
     +    s23**2*s34 + 40*s14*s23*s34**2 + 288*s23**3*s34 + 16*s23**2*
     +    s34**2 )

      LB34 = LB34 + Lc1(p34,p12)*S13**(-1)*S34**(-1) * ( 672*s14**4 + 
     +    1296*s14**3*s23 + 1096*s14**3*s24 + 424*s14**2*s23**2 + 1072*
     +    s14**2*s23*s24 + 680*s14**2*s24**2 - 768*s14*s23**3 - 568*s14
     +    *s23**2*s24 - 16*s14*s23*s24**2 + 104*s14*s24**3 - 800*s23**4
     +     - 976*s23**3*s24 - 600*s23**2*s24**2 - 192*s23*s24**3 - 24*
     +    s24**4 )

      LB34 = LB34 + Lc1(p34,p12)*S13**(-1)*S34**(-2) * (  - 64*s14**3*
     +    s23**2 - 128*s14**3*s23*s24 - 64*s14**3*s24**2 - 192*s14**2*
     +    s23**3 - 576*s14**2*s23**2*s24 - 576*s14**2*s23*s24**2 - 192*
     +    s14**2*s24**3 - 256*s14*s23**4 - 896*s14*s23**3*s24 - 1216*
     +    s14*s23**2*s24**2 - 768*s14*s23*s24**3 - 192*s14*s24**4 - 128
     +    *s23**5 - 512*s23**4*s24 - 832*s23**3*s24**2 - 704*s23**2*
     +    s24**3 - 320*s23*s24**4 - 64*s24**5 )

      LB34 = LB34 + Lc1(p34,p12)*S13**(-1) * (  - 440*s14**3 - 664*
     +    s14**2*s23 - 200*s14**2*s24 + 704*s14**2*s34 - 192*s14*s23**2
     +     + 8*s14*s23*s24 + 960*s14*s23*s34 + 8*s14*s24**2 + 392*s14*
     +    s24*s34 + 40*s14*s34**2 + 32*s23**3 + 96*s23**2*s24 + 488*
     +    s23**2*s34 + 72*s23*s24**2 + 272*s23*s24*s34 + 40*s23*s34**2
     +     + 8*s24**3 + 72*s24**2*s34 + 24*s24*s34**2 )

      LB34 = LB34 + Lc2(p1,p34)*S13**(-1)*S24**(-1)*S134**(-1) * (  - 4
     +    *s12**3*s14*s34 + 4*s12**3*s34**2 )

      LB34 = LB34 + Lc2(p1,p34)*S13**(-1)*S24**(-1) * (  - 8*s12**3*s34
     +     - 4*s12**2*s23*s34 - 4*s12**2*s34**2 )

      LB34 = LB34 + Lc2(p1,p34)*S13**(-1) * (  - 4*s12**2*s34 )

      LB34 = LB34 + Lc2(p1,p34)*S24**(-1) * (  - 8*s12**2*s23 + 8*
     +    s12**2*s34 + 8*s12*s13*s23 - 4*s12*s13*s34 - 4*s12*s23**2 + 4
     +    *s12*s23*s34 + 8*s12*s34**2 - 12*s13**2*s23 - 8*s13**2*s34 + 
     +    8*s13*s23**2 - 8*s13*s23*s34 - 16*s13*s34**2 )

      LB34 = LB34 + Lc2(p1,p34)*S34**(-1) * (  - 16*s12*s13**2 - 16*s12
     +    *s13*s24 - 32*s13**2*s23 - 32*s13**2*s24 - 4*s13*s23**2 - 8*
     +    s13*s23*s24 - 4*s13*s24**2 )

      LB34 = LB34 + Lc2(p1,p34)*S34**(-2) * (  - 16*s12*s13**2*s23 - 16
     +    *s12*s13**2*s24 - 8*s13**2*s23**2 - 16*s13**2*s23*s24 - 8*
     +    s13**2*s24**2 )

      LB34 = LB34 + Lc2(p1,p34) * ( 24*s12**2 - 8*s12*s13 + 4*s12*s23
     +     + 8*s12*s24 + 16*s12*s34 - 28*s13**2 - 4*s13*s23 - 12*s13*
     +    s24 - 24*s13*s34 )

      LB34 = LB34 + Lc2(p1,p234)*S13**(-1)*S24**(-1)*S34**(-1) * ( 12*
     +    s14**3*s23**2 )

      LB34 = LB34 + Lc2(p1,p234)*S13**(-1)*S24**(-1) * ( 24*s14**3*s23
     +     + 12*s14**3*s34 + 8*s14**2*s23**2 + 16*s14**2*s23*s34 + 8*
     +    s14**2*s34**2 )

      LB34 = LB34 + Lc2(p1,p234)*S13**(-1)*S34**(-1) * ( 28*s14**3*s23
     +     + 16*s14**3*s24 )

      LB34 = LB34 + Lc2(p1,p234)*S13**(-1) * ( 28*s14**3 + 16*s14**2*
     +    s23 + 8*s14**2*s24 + 16*s14**2*s34 )

      LB34 = LB34 + Lc2(p1,p234)*S24**(-1)*S34**(-1) * ( 28*s13**2*
     +    s23**2 + 60*s13*s14*s23**2 + 48*s14**2*s23**2 )

      LB34 = LB34 + Lc2(p1,p234)*S24**(-1) * ( 40*s13**2*s23 + 12*
     +    s13**2*s34 + 96*s13*s14*s23 + 36*s13*s14*s34 + 12*s13*s23**2
     +     + 24*s13*s23*s34 + 12*s13*s34**2 + 84*s14**2*s23 + 36*s14**2
     +    *s34 + 16*s14*s23**2 + 32*s14*s23*s34 + 16*s14*s34**2 )

      LB34 = LB34 + Lc2(p1,p234)*S34**(-1) * ( 32*s13**2*s23 + 4*s13**2
     +    *s24 + 84*s13*s14*s23 + 24*s13*s14*s24 + 72*s14**2*s23 + 24*
     +    s14**2*s24 )

      LB34 = LB34 + Lc2(p1,p234) * ( 16*s13**2 + 60*s13*s14 + 20*s13*
     +    s23 + 8*s13*s24 + 20*s13*s34 + 60*s14**2 + 32*s14*s23 + 16*
     +    s14*s24 + 32*s14*s34 )

      LB34 = LB34 + Lc2(p2,p34)*S13**(-1)*S24**(-1) * (  - 8*s12**3*s34
     +     + 8*s12**2*s14*s23 - 4*s12**2*s14*s34 - 8*s12**2*s23*s34 - 4
     +    *s12**2*s34**2 + 4*s12*s14**2*s23 + 8*s12*s14*s23**2 - 4*s12*
     +    s14*s23*s34 - 4*s12*s23**2*s34 - 8*s12*s23*s34**2 + 8*s14**2*
     +    s23**2 + 12*s14*s23**3 + 16*s14*s23**2*s34 + 8*s23**3*s34 + 8
     +    *s23**2*s34**2 )

      LB34 = LB34 + Lc2(p2,p34)*S24**(-1)*S34**(-1) * (  - 16*s12*s13*
     +    s23**2 + 16*s12*s23**3 - 4*s13**2*s23**2 - 8*s13*s14*s23**2
     +     + 32*s13*s23**3 - 4*s14**2*s23**2 + 32*s14*s23**3 )

      LB34 = LB34 + Lc2(p2,p34)*S24**(-1)*S34**(-2) * ( 16*s12*s13*
     +    s23**3 + 16*s12*s14*s23**3 + 8*s13**2*s23**3 + 16*s13*s14*
     +    s23**3 + 8*s14**2*s23**3 )

      LB34 = LB34 + Lc2(p2,p34)*S24**(-1) * (  - 24*s12**2*s23 - 4*
     +    s12**2*s34 - 8*s12*s13*s23 - 4*s12*s14*s23 - 8*s12*s23**2 - 
     +    16*s12*s23*s34 - 12*s13*s23**2 - 4*s14*s23**2 + 28*s23**3 )

      LB34 = LB34 + Lc2(p2,p134)*S13**(-1)*S24**(-1)*S34**(-1) * ( 16*
     +    s14**2*s23**3 )

      LB34 = LB34 + Lc2(p2,p134)*S13**(-1)*S24**(-1) * ( 12*s14**2*
     +    s23**2 + 28*s14*s23**3 + 20*s14*s23**2*s34 + 12*s23**3*s34 + 
     +    8*s23**2*s34**2 )

      LB34 = LB34 + Lc2(p2,p134)*S13**(-1)*S34**(-1) * ( 48*s14**2*
     +    s23**2 + 60*s14**2*s23*s24 + 32*s14**2*s24**2 )

      LB34 = LB34 + Lc2(p2,p134)*S13**(-1) * ( 12*s14**2*s23 + 16*
     +    s14**2*s24 + 84*s14*s23**2 + 96*s14*s23*s24 + 28*s14*s23*s34
     +     + 44*s14*s24**2 + 28*s14*s24*s34 + 36*s23**2*s34 + 36*s23*
     +    s24*s34 + 16*s23*s34**2 + 12*s24**2*s34 + 12*s24*s34**2 )

      LB34 = LB34 + Lc2(p2,p134)*S24**(-1)*S34**(-1) * ( 20*s13*s23**3
     +     + 36*s14*s23**3 )

      LB34 = LB34 + Lc2(p2,p134)*S24**(-1) * ( 12*s13*s23**2 + 24*s14*
     +    s23**2 + 32*s23**3 + 20*s23**2*s34 )

      LB34 = LB34 + Lc2(p2,p134)*S34**(-1) * ( 24*s13*s23**2 + 24*s13*
     +    s23*s24 + 8*s13*s24**2 + 72*s14*s23**2 + 84*s14*s23*s24 + 40*
     +    s14*s24**2 )

      LB34 = LB34 + Lc2(p2,p134) * ( 12*s13*s23 + 12*s13*s24 + 24*s14*
     +    s23 + 28*s14*s24 + 60*s23**2 + 60*s23*s24 + 28*s23*s34 + 20*
     +    s24**2 + 24*s24*s34 )

      LB34 = LB34 + Lc2(p3,p12)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 8*
     +    s12*s14*s23**3 + 8*s12*s23**4 )

      LB34 = LB34 + Lc2(p3,p12)*S13**(-1)*S24**(-1) * (  - 24*s12**2*
     +    s23**2 + 48*s12*s14*s23**2 + 8*s12*s23**3 )

      LB34 = LB34 + Lc2(p3,p12)*S13**(-1)*S34**(-1) * ( 24*s12*s14*
     +    s23**2 - 8*s12*s23**3 )

      LB34 = LB34 + Lc2(p3,p12)*S24**(-1)*S34**(-1) * ( 8*s13**3*s14 + 
     +    8*s13**2*s14**2 )

      LB34 = LB34 + Lc2(p3,p12)*S24**(-1) * (  - 24*s12*s13**2 - 24*s12
     +    *s13*s14 - 24*s12*s13*s34 - 16*s13**3 - 8*s13**2*s14 - 16*
     +    s13**2*s34 )

      LB34 = LB34 + Lc2(p3,p12)*S34**(-1) * (  - 24*s12*s13*s14 - 24*
     +    s12*s13*s24 + 8*s13**3 + 8*s13**2*s14 )

      LB34 = LB34 + Lc2(p3,p12)*S34**(-2) * ( 8*s13**2*s14**2 + 16*
     +    s13**2*s14*s24 + 8*s13**2*s24**2 )

      LB34 = LB34 + Lc2(p3,p12) * (  - 48*s12*s13 - 24*s13**2 )

      LB34 = LB34 + Lc2(p3,p24)*S13**(-1)*S24**(-1) * (  - 4*s12**2*s14
     +    *s34 - 4*s12**2*s34**2 - 8*s12*s14**2*s34 - 8*s12*s14*s34**2
     +     - 4*s14**3*s34 - 4*s14**2*s34**2 )

      LB34 = LB34 + Lc2(p3,p24)*S13**(-1) * ( 8*s12**2*s34 - 8*s12*s24*
     +    s34 - 12*s12*s34**2 - 8*s14**2*s34 - 8*s14*s24*s34 - 12*s14*
     +    s34**2 - 8*s24*s34**2 )

      LB34 = LB34 + Lc2(p3,p24)*S24**(-1) * (  - 4*s12**2*s34 + 4*s12*
     +    s13*s34 - 4*s12*s14*s34 + 4*s12*s34**2 + 8*s13**2*s34 + 12*
     +    s13*s14*s34 + 8*s13*s34**2 + 4*s14*s34**2 )

      LB34 = LB34 + Lc2(p3,p24)*S34**(-1)*S234**(-1) * (  - 8*s13**2*
     +    s24**2 )

      LB34 = LB34 + Lc2(p3,p24)*S34**(-1) * (  - 8*s12*s13*s24 + 4*
     +    s13**2*s24 + 4*s13*s14*s24 + 8*s13*s24**2 )

      LB34 = LB34 + Lc2(p3,p24) * ( 4*s12**2 - 4*s12*s13 - 16*s12*s24
     +     - 16*s12*s34 + 4*s13**2 - 4*s13*s24 + 12*s13*s34 - 4*s14**2
     +     - 8*s14*s34 + 4*s24**2 - 12*s24*s34 + 8*s34**2 )

      LB34 = LB34 + Lc2(p3,p124)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 8
     +    *s12*s14*s23**3 + 8*s12*s23**4 - 8*s14**2*s23**3 + 8*s14*
     +    s23**4 )

      LB34 = LB34 + Lc2(p3,p124)*S13**(-1)*S24**(-1) * ( 24*s12*s14*
     +    s23**2 + 72*s12*s14*s23*s34 + 40*s12*s14*s34**2 + 24*s12*
     +    s23**3 + 24*s12*s23**2*s34 + 8*s12*s23*s34**2 + 24*s14**2*
     +    s23**2 + 72*s14**2*s23*s34 + 40*s14**2*s34**2 + 24*s14*s23**3
     +     + 24*s14*s23**2*s34 + 8*s14*s23*s34**2 )

      LB34 = LB34 + Lc2(p3,p124)*S13**(-1)*S34**(-1) * ( 24*s12*s14*
     +    s23**2 - 8*s12*s23**3 + 24*s14**2*s23**2 - 16*s14*s23**3 + 24
     +    *s14*s23**2*s24 + 8*s23**4 - 8*s23**3*s24 )

      LB34 = LB34 + Lc2(p3,p124)*S13**(-1) * ( 20*s12**2*s34 + 48*s12*
     +    s14*s23 + 68*s12*s14*s34 - 24*s12*s23**2 - 24*s12*s23*s34 + 
     +    16*s12*s24*s34 + 16*s12*s34**2 + 48*s14**2*s23 + 48*s14**2*
     +    s34 + 48*s14*s23*s24 + 48*s14*s23*s34 + 40*s14*s24*s34 + 56*
     +    s14*s34**2 + 24*s23**3 - 24*s23**2*s24 + 24*s23**2*s34 - 24*
     +    s23*s24*s34 + 8*s23*s34**2 + 8*s24*s34**2 )

      LB34 = LB34 + Lc2(p3,p124)*S24**(-1)*S34**(-1) * (  - 20*s12**2*
     +    s13**2 - 64*s12*s13**3 - 76*s12*s13**2*s14 - 64*s13**3*s14 - 
     +    56*s13**2*s14**2 )

      LB34 = LB34 + Lc2(p3,p124)*S24**(-1) * (  - 32*s12**2*s13 - 20*
     +    s12**2*s34 - 128*s12*s13**2 - 88*s12*s13*s14 - 96*s12*s13*s34
     +     - 52*s12*s14*s34 - 32*s12*s34**2 - 128*s13**2*s14 - 56*s13*
     +    s14**2 - 96*s13*s14*s34 - 32*s14**2*s34 - 32*s14*s34**2 )

      LB34 = LB34 + Lc2(p3,p124)*S34**(-1) * ( 20*s12**2*s13 + 16*s12*
     +    s13**2 + 60*s12*s13*s14 + 32*s12*s13*s24 - 64*s13**3 - 24*
     +    s13**2*s14 + 24*s13**2*s24 + 24*s13*s14**2 - 16*s13*s24**2 )

      LB34 = LB34 + Lc2(p3,p124)*S34**(-2) * (  - 8*s13**2*s14**2 - 16*
     +    s13**2*s14*s24 - 8*s13**2*s24**2 )

      LB34 = LB34 + Lc2(p3,p124) * ( 32*s12**2 + 64*s12*s13 + 72*s12*
     +    s14 + 32*s12*s24 + 56*s12*s34 - 128*s13**2 + 16*s13*s14 + 48*
     +    s13*s24 - 96*s13*s34 + 32*s14**2 + 16*s14*s24 + 32*s14*s34 - 
     +    8*s24**2 + 40*s24*s34 - 32*s34**2 )

      LB34 = LB34 + Lc2(p4,p12)*S13**(-1)*S24**(-1)*S34**(-1) * ( 8*
     +    s14**4*s23 - 8*s14**3*s23**2 )

      LB34 = LB34 + Lc2(p4,p12)*S13**(-1)*S24**(-1) * (  - 24*s12*
     +    s14**3 + 24*s12*s14**2*s23 + 24*s12*s14**2*s34 - 16*s14**4 + 
     +    8*s14**3*s23 + 16*s14**3*s34 )

      LB34 = LB34 + Lc2(p4,p12)*S13**(-1)*S34**(-1) * ( 8*s12*s23*
     +    s24**2 + 8*s12*s24**3 )

      LB34 = LB34 + Lc2(p4,p12)*S13**(-1) * ( 24*s12**2*s24 )

      LB34 = LB34 + Lc2(p4,p12)*S24**(-1)*S34**(-1) * ( 24*s12*s13*
     +    s14**2 + 24*s12*s14**2*s23 + 8*s14**4 - 8*s14**3*s23 )

      LB34 = LB34 + Lc2(p4,p12)*S24**(-1)*S34**(-2) * (  - 8*s13**2*
     +    s14**3 - 16*s13*s14**3*s23 - 8*s14**3*s23**2 )

      LB34 = LB34 + Lc2(p4,p12)*S24**(-1) * ( 48*s12*s14**2 + 24*s14**3
     +     )

      LB34 = LB34 + Lc2(p4,p12)*S34**(-1) * (  - 24*s12*s13*s24 + 8*s12
     +    *s24**2 )

      LB34 = LB34 + Lc2(p4,p12) * (  - 24*s12*s24 )

      LB34 = LB34 + Lc2(p4,p13)*S13**(-1)*S24**(-1) * (  - 4*s12**2*s23
     +    *s34 - 4*s12**2*s34**2 - 8*s12*s23**2*s34 - 8*s12*s23*s34**2
     +     - 4*s23**3*s34 - 4*s23**2*s34**2 )

      LB34 = LB34 + Lc2(p4,p13)*S13**(-1) * (  - 4*s12**2*s34 - 4*s12*
     +    s23*s34 + 4*s12*s24*s34 + 4*s12*s34**2 + 12*s23*s24*s34 + 4*
     +    s23*s34**2 + 8*s24**2*s34 + 8*s24*s34**2 )

      LB34 = LB34 + Lc2(p4,p13)*S24**(-1) * ( 8*s12**2*s34 - 8*s12*s13*
     +    s34 - 12*s12*s34**2 - 8*s13*s23*s34 - 8*s13*s34**2 - 8*s23**2
     +    *s34 - 12*s23*s34**2 )

      LB34 = LB34 + Lc2(p4,p13)*S34**(-1) * (  - 8*s12*s13*s24 + 8*
     +    s13**2*s24 + 4*s13*s23*s24 + 4*s13*s24**2 )

      LB34 = LB34 + Lc2(p4,p13) * ( 4*s12**2 - 16*s12*s13 - 4*s12*s24
     +     - 16*s12*s34 + 4*s13**2 - 4*s13*s24 - 12*s13*s34 - 4*s23**2
     +     - 8*s23*s34 + 4*s24**2 + 12*s24*s34 + 8*s34**2 )

      LB34 = LB34 + Lc2(p4,p123)*S13**(-1)*S24**(-1)*S34**(-1) * ( 20*
     +    s12**2*s14**3 - 64*s12*s14**4 + 76*s12*s14**3*s23 - 64*s14**4
     +    *s23 + 56*s14**3*s23**2 )

      LB34 = LB34 + Lc2(p4,p123)*S13**(-1)*S24**(-1) * ( 28*s12**2*
     +    s14**2 + 16*s12**2*s14*s34 + 8*s12**2*s34**2 - 128*s12*s14**3
     +     + 140*s12*s14**2*s23 - 96*s12*s14**2*s34 + 104*s12*s14*s23*
     +    s34 - 32*s12*s14*s34**2 + 48*s12*s23*s34**2 + 16*s12*s34**3
     +     - 128*s14**3*s23 + 112*s14**2*s23**2 - 96*s14**2*s23*s34 + 
     +    88*s14*s23**2*s34 - 32*s14*s23*s34**2 + 40*s23**2*s34**2 + 16
     +    *s23*s34**3 )

      LB34 = LB34 + Lc2(p4,p123)*S13**(-1)*S34**(-1) * ( 8*s12*s23*
     +    s24**2 + 8*s12*s24**3 + 8*s23**2*s24**2 + 8*s23*s24**3 )

      LB34 = LB34 + Lc2(p4,p123)*S13**(-1) * ( 24*s12*s23*s24 + 24*s12*
     +    s23*s34 + 40*s12*s24**2 + 72*s12*s24*s34 + 56*s12*s34**2 + 24
     +    *s23**2*s24 + 24*s23**2*s34 + 40*s23*s24**2 + 72*s23*s24*s34
     +     + 56*s23*s34**2 )

      LB34 = LB34 + Lc2(p4,p123)*S24**(-1)*S34**(-1) * ( 20*s12**2*
     +    s14**2 + 32*s12*s13*s14**2 - 16*s12*s14**3 + 60*s12*s14**2*
     +    s23 + 32*s13**2*s14**2 - 24*s13*s14**3 + 96*s13*s14**2*s23 - 
     +    64*s14**4 + 24*s14**3*s23 + 72*s14**2*s23**2 )

      LB34 = LB34 + Lc2(p4,p123)*S24**(-1)*S34**(-2) * ( 8*s13**2*
     +    s14**3 + 16*s13*s14**3*s23 + 8*s14**3*s23**2 )

      LB34 = LB34 + Lc2(p4,p123)*S24**(-1) * ( 8*s12**2*s14 + 8*s12**2*
     +    s34 + 32*s12*s13*s14 - 8*s12*s13*s34 + 16*s12*s14**2 + 48*s12
     +    *s14*s23 + 24*s12*s14*s34 + 32*s12*s23*s34 + 24*s13**2*s14 - 
     +    16*s13**2*s34 + 80*s13*s14*s23 + 8*s13*s14*s34 + 8*s13*s23*
     +    s34 - 8*s13*s34**2 - 128*s14**3 + 112*s14**2*s23 - 96*s14**2*
     +    s34 + 64*s14*s23**2 + 96*s14*s23*s34 - 32*s14*s34**2 + 32*
     +    s23**2*s34 + 32*s23*s34**2 + 16*s34**3 )

      LB34 = LB34 + Lc2(p4,p123)*S34**(-1) * (  - 24*s12*s13*s24 + 8*
     +    s12*s24**2 - 24*s13**2*s24 - 24*s13*s23*s24 + 8*s13*s24**2 + 
     +    16*s23*s24**2 + 8*s24**3 )

      LB34 = LB34 + Lc2(p4,p123) * (  - 48*s12*s13 - 24*s12*s34 - 48*
     +    s13**2 - 48*s13*s23 - 24*s13*s34 + 24*s23*s24 + 40*s24**2 + 
     +    72*s24*s34 + 56*s34**2 )

      LB34 = LB34 + Lc2(p12,p34)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 
     +    32*s12*s14**3*s23 - 32*s12*s14**2*s23**2 - 32*s14**4*s23 - 64
     +    *s14**3*s23**2 - 32*s14**2*s23**3 - 16*s14*s23**4 )

      LB34 = LB34 + Lc2(p12,p34)*S13**(-1)*S24**(-1) * (  - 16*s12**2*
     +    s14*s23 - 64*s12**2*s14*s34 + 32*s12**2*s23*s34 + 32*s12**2*
     +    s34**2 - 80*s12*s14**3 - 16*s12*s14**2*s23 - 272*s12*s14**2*
     +    s34 + 48*s12*s14*s23*s34 + 48*s12*s14*s34**2 + 32*s12*s23**2*
     +    s34 + 48*s12*s23*s34**2 + 16*s12*s34**3 - 32*s14**4 - 96*
     +    s14**3*s23 - 160*s14**3*s34 - 80*s14**2*s23**2 - 48*s14**2*
     +    s23*s34 - 56*s14*s23**3 - 56*s14*s23**2*s34 - 16*s14*s23*
     +    s34**2 - 16*s23**4 - 24*s23**3*s34 - 8*s23**2*s34**2 )

      LB34 = LB34 + Lc2(p12,p34)*S13**(-1)*S34**(-1) * (  - 32*s12*
     +    s14**3 - 96*s12*s14**2*s23 - 64*s12*s14**2*s24 - 32*s14**4 - 
     +    96*s14**3*s23 - 32*s14**3*s24 - 64*s14**2*s23**2 - 32*s14**2*
     +    s23*s24 - 16*s14*s23**3 )

      LB34 = LB34 + Lc2(p12,p34)*S13**(-1) * ( 32*s12**2*s14 + 32*
     +    s12**2*s34 - 192*s12*s14**2 + 32*s12*s14*s23 + 32*s12*s14*s24
     +     + 80*s12*s14*s34 + 48*s12*s23*s34 + 16*s12*s24*s34 + 32*s12*
     +    s34**2 - 96*s14**3 - 80*s14**2*s23 - 56*s14*s23**2 - 16*s14*
     +    s23*s24 - 32*s14*s23*s34 - 16*s23**3 - 8*s23**2*s34 )

      LB34 = LB34 + Lc2(p12,p34)*S24**(-1)*S34**(-1) * (  - 32*s12*
     +    s13**3 - 32*s12*s13**2*s14 - 32*s12*s13**2*s23 + 48*s12*s13*
     +    s14**2 - 32*s12*s13*s14*s23 - 32*s12*s13*s23**2 + 32*s12*
     +    s14**3 - 112*s12*s14**2*s23 + 32*s12*s14*s23**2 + 32*s13**4
     +     - 128*s13**3*s14 + 16*s13**3*s23 + 80*s13**2*s14**2 - 240*
     +    s13**2*s14*s23 - 184*s13**2*s23**2 - 64*s13*s14**3 + 144*s13*
     +    s14**2*s23 - 280*s13*s14*s23**2 + 88*s13*s23**3 - 32*s14**4
     +     - 32*s14**3*s23 - 32*s14**2*s23**2 + 56*s14*s23**3 - 16*
     +    s23**4 )

      LB34 = LB34 + Lc2(p12,p34)*S24**(-1) * ( 48*s12**2*s13 - 16*
     +    s12**2*s23 + 80*s12**2*s34 + 144*s12*s13**2 + 32*s12*s13*s14
     +     + 32*s12*s13*s23 + 384*s12*s13*s34 + 112*s12*s14**2 + 160*
     +    s12*s14*s23 + 208*s12*s14*s34 + 112*s12*s23*s34 + 160*s12*
     +    s34**2 + 128*s13**3 - 432*s13**2*s14 - 160*s13**2*s23 + 152*
     +    s13**2*s34 + 432*s13*s14**2 - 544*s13*s14*s23 - 376*s13*s14*
     +    s34 - 144*s13*s23**2 - 192*s13*s23*s34 - 8*s13*s34**2 + 64*
     +    s14**3 + 256*s14**2*s23 + 240*s14**2*s34 - 104*s14*s23**2 - 
     +    96*s14*s23*s34 - 16*s14*s34**2 + 64*s23**3 + 32*s23**2*s34 - 
     +    16*s23*s34**2 )

      LB34 = LB34 + Lc2(p12,p34)*S34**(-1) * ( 192*s12*s13**2 + 240*s12
     +    *s13*s14 + 160*s12*s13*s23 + 208*s12*s13*s24 + 96*s12*s14*s23
     +     + 32*s12*s14*s24 + 112*s13**3 - 112*s13**2*s14 - 248*s13**2*
     +    s23 - 32*s13**2*s24 - 240*s13*s14**2 - 504*s13*s14*s23 - 368*
     +    s13*s14*s24 - 72*s13*s23**2 - 96*s13*s23*s24 + 96*s14**3 + 32
     +    *s14**2*s23 + 160*s14**2*s24 - 136*s14*s23**2 - 128*s14*s23*
     +    s24 - 16*s23**3 )

      LB34 = LB34 + Lc2(p12,p34)*S34**(-2) * ( 64*s13**3*s24 - 64*
     +    s13**2*s14*s23 + 64*s13**2*s14*s24 + 64*s13**2*s23*s24 - 64*
     +    s13*s14**2*s23 - 64*s13*s14*s23**2 + 64*s13*s14*s23*s24 - 64*
     +    s14**2*s23**2 )

      LB34 = LB34 + Lc2(p12,p34) * ( 80*s12**2 + 480*s12*s13 + 320*s12*
     +    s14 + 32*s12*s23 + 96*s12*s24 + 208*s12*s34 - 24*s13**2 - 664
     +    *s13*s14 - 344*s13*s23 - 80*s13*s24 - 56*s13*s34 + 352*s14**2
     +     - 240*s14*s23 - 16*s14*s24 - 32*s14*s34 - 80*s23*s24 - 64*
     +    s23*s34 )

      LB34 = LB34 + Lc2(p13,p24)*S13**(-1)*S24**(-1)*S34**(-1) * ( 16*
     +    s12**4*s14 + 16*s12**4*s23 - 96*s12**3*s14**2 + 40*s12**3*s14
     +    *s23 - 96*s12**3*s23**2 + 24*s12**2*s14**3 - 80*s12**2*s14**2
     +    *s23 - 80*s12**2*s14*s23**2 + 24*s12**2*s23**3 + 32*s12*
     +    s14**3*s23 + 24*s12*s14**2*s23**2 + 32*s12*s14*s23**3 + 8*
     +    s14**3*s23**2 + 8*s14**2*s23**3 )

      LB34 = LB34 + Lc2(p13,p24)*S13**(-1)*S24**(-1) * ( 32*s12**4 - 80
     +    *s12**3*s14 - 80*s12**3*s23 - 8*s12**3*s34 + 24*s12**2*s14**2
     +     - 168*s12**2*s14*s23 + 24*s12**2*s23**2 + 8*s12**2*s34**2 + 
     +    48*s12*s14**2*s23 + 8*s12*s14**2*s34 + 48*s12*s14*s23**2 + 8*
     +    s12*s14*s23*s34 + 8*s12*s14*s34**2 + 8*s12*s23**2*s34 + 8*s12
     +    *s23*s34**2 + 24*s14**2*s23**2 + 8*s14**2*s23*s34 + 8*s14*
     +    s23**2*s34 + 8*s14*s23*s34**2 )

      LB34 = LB34 + Lc2(p13,p24)*S13**(-1)*S34**(-1) * ( 16*s12**4 + 24
     +    *s12**3*s14 - 96*s12**3*s23 + 8*s12**2*s14**2 - 96*s12**2*s14
     +    *s23 - 16*s12**2*s14*s24 - 24*s12**2*s23**2 - 48*s12**2*s23*
     +    s24 - 16*s12*s14**2*s24 - 48*s12*s14*s23**2 - 80*s12*s14*s23*
     +    s24 + 24*s12*s23**3 + 24*s12*s23**2*s24 - 8*s14**2*s23**2 - 
     +    16*s14**2*s23*s24 + 8*s14*s23**3 + 8*s14*s23**2*s24 )

      LB34 = LB34 + Lc2(p13,p24)*S13**(-1) * (  - 8*s12**2*s14 - 24*
     +    s12**2*s23 + 24*s12**2*s24 + 32*s12**2*s34 - 8*s12*s14**2 - 
     +    64*s12*s14*s23 + 8*s12*s14*s24 + 16*s12*s14*s34 + 48*s12*
     +    s23**2 + 24*s12*s23*s24 + 32*s12*s23*s34 - 8*s14**2*s23 + 16*
     +    s14*s23**2 + 8*s14*s23*s24 + 16*s14*s23*s34 )

      LB34 = LB34 + Lc2(p13,p24)*S24**(-1)*S34**(-1) * ( 16*s12**4 - 96
     +    *s12**3*s14 + 24*s12**3*s23 - 48*s12**2*s13*s14 - 16*s12**2*
     +    s13*s23 - 24*s12**2*s14**2 - 96*s12**2*s14*s23 + 8*s12**2*
     +    s23**2 + 24*s12*s13*s14**2 - 80*s12*s13*s14*s23 - 16*s12*s13*
     +    s23**2 + 24*s12*s14**3 - 48*s12*s14**2*s23 + 8*s13*s14**2*s23
     +     - 16*s13*s14*s23**2 + 8*s14**3*s23 - 8*s14**2*s23**2 )

      LB34 = LB34 + Lc2(p13,p24)*S24**(-1) * ( 24*s12**2*s13 - 24*
     +    s12**2*s14 - 8*s12**2*s23 + 32*s12**2*s34 + 24*s12*s13*s14 + 
     +    8*s12*s13*s23 + 48*s12*s14**2 - 64*s12*s14*s23 + 32*s12*s14*
     +    s34 - 8*s12*s23**2 + 16*s12*s23*s34 + 8*s13*s14*s23 + 16*
     +    s14**2*s23 - 8*s14*s23**2 + 16*s14*s23*s34 )

      LB34 = LB34 + Lc2(p13,p24)*S34**(-1) * ( 8*s12**3 - 24*s12**2*s13
     +     - 16*s12**2*s14 - 16*s12**2*s23 - 24*s12**2*s24 + 16*s12*
     +    s13**2 - 8*s12*s13*s14 + 40*s12*s13*s24 - 24*s12*s14**2 - 32*
     +    s12*s14*s23 - 24*s12*s23**2 - 8*s12*s23*s24 + 16*s12*s24**2
     +     + 16*s13**2*s14 - 8*s13**2*s24 + 16*s13*s14**2 + 8*s13*s14*
     +    s24 + 8*s13*s23*s24 - 8*s13*s24**2 - 16*s14**2*s23 - 16*s14*
     +    s23**2 + 16*s23**2*s24 + 16*s23*s24**2 )

      LB34 = LB34 + Lc2(p13,p24) * (  - 40*s12**2 + 32*s12*s13 - 40*s12
     +    *s14 - 40*s12*s23 + 32*s12*s24 - 8*s12*s34 + 8*s13**2 + 40*
     +    s13*s14 + 8*s13*s23 - 8*s13*s24 + 16*s13*s34 - 16*s14*s23 + 8
     +    *s14*s24 + 8*s14*s34 + 40*s23*s24 + 8*s23*s34 + 8*s24**2 + 16
     +    *s24*s34 + 8*s34**2 )

      LB34 = LB34 + Lc3(p12,p34)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 
     +    32*s14*s23**4 )

      LB34 = LB34 + Lc3(p12,p34)*S13**(-1)*S24**(-1) * (  - 48*s12**2*
     +    s14*s34 + 64*s12*s14**2*s23 - 32*s12*s14**2*s34 - 64*s12*s14*
     +    s23*s34 - 64*s12*s14*s34**2 - 32*s12*s23*s34**2 - 32*s12*
     +    s34**3 + 32*s14**3*s23 + 64*s14**2*s23**2 + 64*s14**2*s23*s34
     +     - 80*s14*s23**3 - 24*s14*s23**2*s34 + 24*s14*s23*s34**2 - 32
     +    *s23**4 - 80*s23**3*s34 - 56*s23**2*s34**2 - 8*s23*s34**3 )

      LB34 = LB34 + Lc3(p12,p34)*S13**(-1)*S34**(-1) * (  - 32*s14*
     +    s23**3 )

      LB34 = LB34 + Lc3(p12,p34)*S13**(-1) * ( 16*s12*s14**2 - 64*s12*
     +    s14*s34 - 32*s12*s34**2 + 32*s14**3 + 64*s14**2*s23 - 48*s14*
     +    s23**2 + 24*s14*s23*s34 - 32*s23**3 - 48*s23**2*s34 - 8*s23*
     +    s34**2 )

      LB34 = LB34 + Lc3(p12,p34)*S24**(-1)*S34**(-1) * ( 32*s13**4 - 32
     +    *s13**3*s14 + 96*s13**3*s23 + 32*s13**2*s14**2 + 96*s13**2*
     +    s14*s23 + 8*s13**2*s23**2 - 64*s13*s14**3 + 192*s13*s14**2*
     +    s23 + 72*s13*s14*s23**2 + 24*s13*s23**3 - 32*s14**4 + 32*
     +    s14**3*s23 + 96*s14**2*s23**2 + 24*s14*s23**3 - 32*s23**4 )

      LB34 = LB34 + Lc3(p12,p34)*S24**(-1) * ( 48*s12**2*s34 - 48*s12*
     +    s13**2 - 96*s12*s13*s14 - 32*s12*s13*s23 + 16*s12*s13*s34 + 
     +    192*s12*s14**2 - 160*s12*s14*s23 - 160*s12*s14*s34 - 64*s12*
     +    s23*s34 - 64*s12*s34**2 + 32*s13**3 - 272*s13**2*s14 + 152*
     +    s13**2*s23 + 64*s13**2*s34 + 288*s13*s14**2 + 24*s13*s14*s23
     +     - 272*s13*s14*s34 + 64*s13*s23**2 + 112*s13*s23*s34 + 8*s13*
     +    s34**2 + 192*s14**3 + 96*s14**2*s23 + 32*s14**2*s34 + 152*s14
     +    *s23**2 + 152*s14*s23*s34 - 40*s14*s34**2 - 56*s23**3 + 48*
     +    s23*s34**2 + 8*s34**3 )

      LB34 = LB34 + Lc3(p12,p34)*S34**(-1) * (  - 128*s13**2*s14 - 56*
     +    s13**2*s23 - 96*s13**2*s24 - 192*s13*s14**2 - 24*s13*s14*s23
     +     - 224*s13*s14*s24 + 24*s13*s23**2 + 32*s14**3 + 128*s14**2*
     +    s23 + 64*s14**2*s24 + 24*s14*s23**2 - 32*s23**3 )

      LB34 = LB34 + Lc3(p12,p34) * (  - 128*s12*s13 - 64*s12*s14 - 64*
     +    s12*s34 - 144*s13**2 - 336*s13*s14 + 104*s13*s23 + 40*s13*s34
     +     + 176*s14**2 + 192*s14*s23 - 8*s14*s34 - 24*s23**2 + 56*s23*
     +    s34 + 32*s24*s34 + 24*s34**2 )

      LB34 = LB34 + Lc3(p13,p24)*S13**(-1)*S24**(-1)*S34**(-1) * ( 8*
     +    s12**4*s14 + 32*s12**4*s23 - 24*s12**3*s14**2 + 48*s12**3*s14
     +    *s23 - 24*s12**3*s23**2 + 24*s12**2*s14**3 - 16*s12**2*s14*
     +    s23**2 - 8*s12*s14**4 + 48*s12*s14**3*s23 + 16*s12*s14**2*
     +    s23**2 + 8*s14**3*s23**2 )

      LB34 = LB34 + Lc3(p13,p24)*S13**(-1)*S24**(-1) * ( 40*s12**4 - 8*
     +    s12**3*s23 - 8*s12**3*s34 + 8*s12**2*s14**2 - 24*s12**2*s14*
     +    s23 - 16*s12**2*s14*s34 + 8*s12**2*s23**2 - 16*s12*s14**3 + 
     +    48*s12*s14**2*s23 - 8*s12*s14**2*s34 + 16*s12*s14*s23**2 + 8*
     +    s14**2*s23**2 )

      LB34 = LB34 + Lc3(p13,p24)*S13**(-1)*S34**(-1) * ( 32*s12**4 + 40
     +    *s12**3*s14 + 24*s12**3*s23 + 48*s12**3*s24 + 16*s12**2*
     +    s14**2 + 24*s12**2*s14*s23 + 40*s12**2*s14*s24 + 24*s12**2*
     +    s23*s24 + 24*s12**2*s24**2 + 8*s12*s14**3 - 8*s12*s14**2*s24
     +     - 8*s12*s14*s23**2 + 24*s12*s14*s23*s24 + 32*s12*s14*s24**2
     +     - 8*s14**2*s23**2 + 8*s14**2*s24**2 + 8*s14*s23**2*s24 + 8*
     +    s14*s23*s24**2 )

      LB34 = LB34 + Lc3(p13,p24)*S13**(-1) * ( 56*s12**3 + 64*s12**2*
     +    s14 + 8*s12**2*s23 + 24*s12**2*s24 + 8*s12**2*s34 + 8*s12*
     +    s14**2 - 8*s12*s14*s23 + 24*s12*s14*s24 - 16*s12*s23*s24 - 8*
     +    s12*s23*s34 - 16*s12*s24**2 - 24*s12*s24*s34 - 8*s12*s34**2
     +     - 16*s14**2*s23 - 8*s14**2*s34 - 8*s14*s23*s34 - 8*s14*
     +    s24**2 - 16*s14*s24*s34 - 8*s14*s34**2 )

      LB34 = LB34 + Lc3(p13,p24)*S24**(-1)*S34**(-1) * ( 8*s12**4 - 24*
     +    s12**3*s14 + 16*s12**3*s23 + 24*s12**2*s14**2 + 8*s12**2*
     +    s23**2 - 8*s12*s14**3 + 48*s12*s14**2*s23 + 16*s12*s14*s23**2
     +     + 8*s14**2*s23**2 )

      LB34 = LB34 + Lc3(p13,p24)*S24**(-1) * (  - 8*s12**3 - 16*s12**2*
     +    s14 - 8*s12*s14**2 )

      LB34 = LB34 + Lc3(p13,p24)*S34**(-1) * ( 8*s12**3 - 8*s12**2*s13
     +     + 8*s12**2*s14 - 8*s12**2*s23 - 16*s12**2*s24 - 16*s12*s13*
     +    s14 + 8*s12*s13*s24 - 8*s12*s14**2 - 16*s12*s14*s23 - 16*s12*
     +    s14*s24 + 16*s12*s23*s24 + 16*s12*s24**2 - 8*s13*s14**2 + 8*
     +    s13*s14*s24 - 8*s13*s24**2 - 8*s14**3 - 8*s14**2*s23 + 16*s14
     +    *s23*s24 + 8*s14*s24**2 - 8*s23*s24**2 - 8*s24**3 )

      LB34 = LB34 + Lc3(p13,p24) * (  - 16*s12**2 - 8*s12*s13 - 40*s12*
     +    s14 - 8*s12*s23 + 16*s12*s24 - 16*s12*s34 - 8*s13*s14 - 24*
     +    s14**2 - 8*s14*s23 + 16*s14*s24 - 16*s14*s34 - 16*s24**2 )

      LB34 = LB34 + Lc3(p24,p13)*S13**(-1)*S24**(-1)*S34**(-1) * ( 32*
     +    s12**4*s14 + 8*s12**4*s23 - 24*s12**3*s14**2 + 48*s12**3*s14*
     +    s23 - 24*s12**3*s23**2 - 16*s12**2*s14**2*s23 + 24*s12**2*
     +    s23**3 + 16*s12*s14**2*s23**2 + 48*s12*s14*s23**3 - 8*s12*
     +    s23**4 + 8*s14**2*s23**3 )

      LB34 = LB34 + Lc3(p24,p13)*S13**(-1)*S24**(-1) * ( 40*s12**4 - 8*
     +    s12**3*s14 - 8*s12**3*s34 + 8*s12**2*s14**2 - 24*s12**2*s14*
     +    s23 + 8*s12**2*s23**2 - 16*s12**2*s23*s34 + 16*s12*s14**2*s23
     +     + 48*s12*s14*s23**2 - 16*s12*s23**3 - 8*s12*s23**2*s34 + 8*
     +    s14**2*s23**2 )

      LB34 = LB34 + Lc3(p24,p13)*S13**(-1)*S34**(-1) * ( 8*s12**4 + 16*
     +    s12**3*s14 - 24*s12**3*s23 + 8*s12**2*s14**2 + 24*s12**2*
     +    s23**2 + 16*s12*s14**2*s23 + 48*s12*s14*s23**2 - 8*s12*s23**3
     +     + 8*s14**2*s23**2 )

      LB34 = LB34 + Lc3(p24,p13)*S13**(-1) * (  - 8*s12**3 - 16*s12**2*
     +    s23 - 8*s12*s23**2 )

      LB34 = LB34 + Lc3(p24,p13)*S24**(-1)*S34**(-1) * ( 32*s12**4 + 48
     +    *s12**3*s13 + 24*s12**3*s14 + 40*s12**3*s23 + 24*s12**2*
     +    s13**2 + 24*s12**2*s13*s14 + 40*s12**2*s13*s23 + 24*s12**2*
     +    s14*s23 + 16*s12**2*s23**2 + 32*s12*s13**2*s23 + 24*s12*s13*
     +    s14*s23 - 8*s12*s13*s23**2 - 8*s12*s14**2*s23 + 8*s12*s23**3
     +     + 8*s13**2*s14*s23 + 8*s13**2*s23**2 + 8*s13*s14**2*s23 - 8*
     +    s14**2*s23**2 )

      LB34 = LB34 + Lc3(p24,p13)*S24**(-1) * ( 56*s12**3 + 24*s12**2*
     +    s13 + 8*s12**2*s14 + 64*s12**2*s23 + 8*s12**2*s34 - 16*s12*
     +    s13**2 - 16*s12*s13*s14 + 24*s12*s13*s23 - 24*s12*s13*s34 - 8
     +    *s12*s14*s23 - 8*s12*s14*s34 + 8*s12*s23**2 - 8*s12*s34**2 - 
     +    8*s13**2*s23 - 16*s13*s23*s34 - 16*s14*s23**2 - 8*s14*s23*s34
     +     - 8*s23**2*s34 - 8*s23*s34**2 )

      LB34 = LB34 + Lc3(p24,p13)*S34**(-1) * ( 8*s12**3 - 16*s12**2*s13
     +     - 8*s12**2*s14 + 8*s12**2*s23 - 8*s12**2*s24 + 16*s12*s13**2
     +     + 16*s12*s13*s14 - 16*s12*s13*s23 + 8*s12*s13*s24 - 16*s12*
     +    s14*s23 - 8*s12*s23**2 - 16*s12*s23*s24 - 8*s13**3 - 8*s13**2
     +    *s14 + 8*s13**2*s23 - 8*s13**2*s24 + 16*s13*s14*s23 + 8*s13*
     +    s23*s24 - 8*s14*s23**2 - 8*s23**3 - 8*s23**2*s24 )

      LB34 = LB34 + Lc3(p24,p13) * (  - 16*s12**2 + 16*s12*s13 - 8*s12*
     +    s14 - 40*s12*s23 - 8*s12*s24 - 16*s12*s34 - 16*s13**2 + 16*
     +    s13*s23 - 8*s14*s23 - 24*s23**2 - 8*s23*s24 - 16*s23*s34 )

      LB34 = LB34 + Lc3(p34,p12)*S13**(-1)*S24**(-1)*S34**(-1) * ( 32*
     +    s12**2*s14**2*s23 + 32*s12*s14**2*s23**2 - 16*s14**4*s23 - 16
     +    *s14**3*s23**2 + 16*s14**2*s23**3 )

      LB34 = LB34 + Lc3(p34,p12)*S13**(-1)*S24**(-1) * (  - 16*s12**3*
     +    s14 + 16*s12**3*s23 + 80*s12**2*s14**2 - 48*s12**2*s14*s23 - 
     +    48*s12**2*s14*s34 - 32*s12**2*s23*s34 - 32*s12**2*s34**2 + 
     +    144*s12*s14**3 - 16*s12*s14**2*s23 - 96*s12*s14**2*s34 + 16*
     +    s12*s14*s23**2 + 16*s12*s14*s23*s34 - 16*s12*s23**2*s34 - 16*
     +    s12*s23*s34**2 + 64*s14**4 - 64*s14**3*s23 - 64*s14**3*s34 + 
     +    16*s14**2*s23**2 + 16*s14*s23**3 + 16*s14*s23**2*s34 )

      LB34 = LB34 + Lc3(p34,p12)*S13**(-1)*S34**(-1) * ( 32*s12**2*
     +    s14**2 + 32*s12**2*s14*s23 + 32*s12**2*s14*s24 + 32*s12*
     +    s14**2*s23 + 32*s12*s14*s23**2 + 32*s12*s14*s23*s24 - 16*
     +    s14**4 - 32*s14**3*s23 - 16*s14**3*s24 + 16*s14**2*s23**2 + 
     +    16*s14*s23**3 + 16*s14*s23**2*s24 )

      LB34 = LB34 + Lc3(p34,p12)*S13**(-1) * (  - 16*s12**3 + 32*s12**2
     +    *s14 - 32*s12**2*s23 - 32*s12**2*s24 - 64*s12**2*s34 + 48*s12
     +    *s14**2 + 48*s12*s14*s23 - 16*s12*s23**2 - 16*s12*s23*s24 - 
     +    32*s12*s23*s34 + 32*s14*s23**2 )

      LB34 = LB34 + Lc3(p34,p12)*S24**(-1)*S34**(-1) * (  - 48*s12**2*
     +    s13*s14 - 16*s12**2*s14*s23 - 96*s12*s13*s14**2 + 32*s12*s13*
     +    s14*s23 - 64*s12*s14**2*s23 + 32*s12*s14*s23**2 + 16*s13**4
     +     - 16*s13**3*s14 + 48*s13**3*s23 + 16*s13**2*s14**2 + 16*
     +    s13**2*s14*s23 - 80*s13*s14**3 + 16*s13*s14**2*s23 + 32*s13*
     +    s14*s23**2 + 96*s13*s23**3 - 16*s14**4 - 96*s14**3*s23 + 32*
     +    s14**2*s23**2 + 112*s14*s23**3 )

      LB34 = LB34 + Lc3(p34,p12)*S24**(-1) * ( 16*s12**3 - 16*s12**2*
     +    s13 - 80*s12**2*s14 - 32*s12**2*s23 - 48*s12**2*s34 + 32*s12*
     +    s13*s14 - 112*s12*s13*s23 + 32*s12*s13*s34 - 112*s12*s14**2
     +     + 16*s12*s14*s34 - 16*s12*s23**2 - 80*s12*s23*s34 - 16*s12*
     +    s34**2 + 64*s13**3 - 16*s13**2*s14 - 16*s13**2*s23 + 80*
     +    s13**2*s34 + 112*s13*s14**2 - 32*s13*s14*s23 - 32*s13*s14*s34
     +     + 80*s13*s23**2 - 32*s13*s23*s34 - 80*s14**3 + 32*s14**2*s23
     +     + 48*s14**2*s34 + 128*s14*s23**2 + 32*s14*s23*s34 + 96*
     +    s23**3 + 80*s23**2*s34 )

      LB34 = LB34 + Lc3(p34,p12)*S34**(-1) * (  - 128*s12**2*s13 - 48*
     +    s12**2*s14 - 96*s12**2*s23 - 48*s12**2*s24 - 64*s12*s13**2 + 
     +    128*s12*s13*s14 - 32*s12*s13*s23 + 64*s12*s13*s24 + 32*s12*
     +    s14**2 + 64*s12*s14*s23 + 32*s12*s14*s24 + 32*s12*s23**2 - 32
     +    *s12*s23*s24 + 96*s13**3 + 176*s13**2*s14 + 128*s13**2*s23 + 
     +    128*s13**2*s24 + 16*s13*s14**2 + 112*s13*s14*s23 + 16*s13*s14
     +    *s24 + 224*s13*s23**2 + 96*s13*s23*s24 + 16*s14**3 + 32*
     +    s14**2*s23 + 48*s14**2*s24 + 176*s14*s23**2 + 32*s14*s23*s24
     +     + 48*s23**3 + 48*s23**2*s24 )

      LB34 = LB34 + Lc3(p34,p12)*S34**(-2) * (  - 64*s12*s13**2*s24 + 
     +    64*s12*s13*s14*s23 - 64*s12*s13*s23*s24 + 64*s12*s14*s23**2
     +     + 64*s13**3*s23 + 64*s13**3*s24 + 64*s13**2*s14*s23 + 64*
     +    s13**2*s14*s24 + 128*s13**2*s23**2 + 128*s13**2*s23*s24 + 128
     +    *s13*s14*s23**2 + 128*s13*s14*s23*s24 + 64*s13*s23**3 + 64*
     +    s13*s23**2*s24 + 64*s14*s23**3 + 64*s14*s23**2*s24 )

      LB34 = LB34 + Lc3(p34,p12) * (  - 160*s12**2 + 96*s12*s13 + 48*
     +    s12*s14 - 64*s12*s23 - 16*s12*s24 - 32*s12*s34 + 160*s13**2
     +     + 32*s13*s14 + 32*s13*s23 + 96*s14**2 + 64*s14*s23 + 112*
     +    s23**2 )

      LB34b=-LB34/s134/s234
      
      return
      end

      function LB34c(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LB34=0d0

      LB34 = LB34 + Lcd0(p1,p24,p3)*S13**(-1)*S34**(-1) * ( 8*s12**3*
     +    s23*s24 - 16*s12**2*s23**3 - 32*s12**2*s23**2*s24 - 16*s12**2
     +    *s23*s24**2 )

      LB34 = LB34 + Lcd0(p1,p24,p3)*S13**(-1) * ( 40*s12**3*s24 - 16*
     +    s12**3*s34 + 144*s12**2*s14*s24 - 24*s12**2*s14*s34 - 56*
     +    s12**2*s23**2 - 56*s12**2*s23*s24 - 64*s12**2*s23*s34 - 12*
     +    s12**2*s24**2 - 16*s12**2*s34**2 + 136*s12*s14**2*s24 + 48*
     +    s12*s14*s24**2 + 24*s12*s14*s24*s34 + 16*s12*s14*s34**2 + 32*
     +    s12*s23**3 + 16*s12*s23**2*s24 + 72*s12*s23**2*s34 - 16*s12*
     +    s23*s24**2 + 24*s12*s23*s24*s34 + 48*s12*s23*s34**2 - 32*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 + 8*s12*s34**3 + 24*s14**3*s24
     +     + 8*s14**3*s34 + 44*s14**2*s24**2 + 8*s14**2*s34**2 - 16*s14
     +    *s24**2*s34 )

      LB34 = LB34 + Lcd0(p1,p24,p3)*S34**(-1) * (  - 16*s12**2*s23*s24
     +     - 56*s12**2*s24**2 - 32*s12*s13*s24**2 - 56*s12*s14*s24**2
     +     + 12*s12*s23*s24**2 - 12*s12*s24**3 - 16*s13*s14*s24**2 - 16
     +    *s13*s23*s24**2 - 40*s13*s24**3 - 24*s14**2*s24**2 - 24*s14*
     +    s24**3 )

      LB34 = LB34 + Lcd0(p1,p24,p3) * ( 16*s12**2*s24 + 96*s12*s14*s24
     +     + 32*s12*s23*s24 + 48*s12*s24**2 + 32*s12*s24*s34 - 8*s13*
     +    s24**2 + 8*s14**2*s24 + 44*s14*s24**2 - 16*s23**2*s24 - 8*s23
     +    *s24**2 - 8*s23*s24*s34 + 8*s24**3 )

      LB34 = LB34 + Lcd0(p2,p13,p4)*S24**(-1)*S34**(-1) * ( 8*s12**3*
     +    s13*s14 - 16*s12**2*s13**2*s14 - 32*s12**2*s13*s14**2 - 16*
     +    s12**2*s14**3 )

      LB34 = LB34 + Lcd0(p2,p13,p4)*S24**(-1) * ( 40*s12**3*s13 - 16*
     +    s12**3*s34 - 12*s12**2*s13**2 - 56*s12**2*s13*s14 + 144*
     +    s12**2*s13*s23 - 56*s12**2*s14**2 - 64*s12**2*s14*s34 - 24*
     +    s12**2*s23*s34 - 16*s12**2*s34**2 - 16*s12*s13**2*s14 + 48*
     +    s12*s13**2*s23 - 32*s12*s13**2*s34 + 16*s12*s13*s14**2 + 24*
     +    s12*s13*s14*s34 + 136*s12*s13*s23**2 + 24*s12*s13*s23*s34 + 8
     +    *s12*s13*s34**2 + 32*s12*s14**3 + 72*s12*s14**2*s34 + 48*s12*
     +    s14*s34**2 + 16*s12*s23*s34**2 + 8*s12*s34**3 + 44*s13**2*
     +    s23**2 - 16*s13**2*s23*s34 + 24*s13*s23**3 + 8*s23**3*s34 + 8
     +    *s23**2*s34**2 )

      LB34 = LB34 + Lcd0(p2,p13,p4)*S34**(-1) * (  - 56*s12**2*s13**2
     +     - 16*s12**2*s13*s14 - 12*s12*s13**3 + 12*s12*s13**2*s14 - 56
     +    *s12*s13**2*s23 - 32*s12*s13**2*s24 - 24*s13**3*s23 - 40*
     +    s13**3*s24 - 16*s13**2*s14*s24 - 24*s13**2*s23**2 - 16*s13**2
     +    *s23*s24 )

      LB34 = LB34 + Lcd0(p2,p13,p4) * ( 16*s12**2*s13 + 48*s12*s13**2
     +     + 32*s12*s13*s14 + 96*s12*s13*s23 + 32*s12*s13*s34 + 8*
     +    s13**3 - 8*s13**2*s14 + 44*s13**2*s23 - 8*s13**2*s24 - 16*s13
     +    *s14**2 - 8*s13*s14*s34 + 8*s13*s23**2 )

      LB34 = LB34 + Lcd0(p3,p12,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 
     +    24*s12**2*s14**3*s23 - 8*s12**2*s14**2*s23**2 + 16*s12*s14**4
     +    *s23 - 8*s12*s14**3*s23**2 - 24*s12*s14**2*s23**3 + 16*s14**4
     +    *s23**2 - 8*s14**3*s23**3 - 16*s14**2*s23**4 )

      LB34 = LB34 + Lcd0(p3,p12,p4)*S13**(-1)*S24**(-1)*S34**(-2) * ( 
     +     - 16*s12*s14**4*s23**2 + 16*s12*s14**3*s23**3 + 8*s14**4*
     +    s23**3 - 8*s14**3*s23**4 )

      LB34 = LB34 + Lcd0(p3,p12,p4)*S13**(-1)*S24**(-1) * (  - 24*
     +    s12**4*s34 - 8*s12**3*s14**2 + 40*s12**3*s14*s23 + 72*s12**3*
     +    s14*s34 - 40*s12**3*s23*s34 - 72*s12**3*s34**2 - 16*s12**2*
     +    s14**3 - 72*s12**2*s14**2*s23 + 32*s12**2*s14**2*s34 + 72*
     +    s12**2*s14*s23**2 + 136*s12**2*s14*s23*s34 + 32*s12**2*s14*
     +    s34**2 - 16*s12**2*s23**2*s34 - 32*s12**2*s23*s34**2 - 16*
     +    s12**2*s34**3 - 48*s12*s14**3*s23 - 56*s12*s14**2*s23**2 - 32
     +    *s12*s14**2*s23*s34 + 32*s12*s14*s23**3 + 64*s12*s14*s23**2*
     +    s34 + 32*s12*s14*s23*s34**2 - 32*s14**2*s23**3 - 16*s14**2*
     +    s23**2*s34 )

      LB34 = LB34 + Lcd0(p3,p12,p4)*S13**(-1) * ( 16*s12**3*s14 - 24*
     +    s12**3*s24 - 64*s12**3*s34 + 16*s12**2*s14**2 - 16*s12**2*s14
     +    *s24 - 16*s12**2*s14*s34 - 16*s12**2*s24*s34 - 32*s12**2*
     +    s34**2 )

      LB34 = LB34 + Lcd0(p3,p12,p4)*S24**(-1)*S34**(-1) * (  - 64*
     +    s12**2*s13**2*s14 - 16*s12**2*s13*s14**2 + 32*s12**2*s13*s14*
     +    s23 + 24*s12**2*s14**3 + 32*s12**2*s14**2*s23 + 40*s12**2*s14
     +    *s23**2 + 16*s12*s13**3*s14 - 72*s12*s13**2*s14**2 - 48*s12*
     +    s13*s14**3 - 112*s12*s13*s14**2*s23 + 32*s12*s13*s14*s23**2
     +     + 16*s12*s14**4 - 8*s12*s14**3*s23 - 88*s12*s14**2*s23**2 + 
     +    32*s12*s14*s23**3 - 80*s13**2*s14**2*s23 - 24*s13*s14**3*s23
     +     - 128*s13*s14**2*s23**2 + 32*s14**4*s23 - 24*s14**3*s23**2
     +     - 80*s14**2*s23**3 )

      LB34 = LB34 + Lcd0(p3,p12,p4)*S24**(-1)*S34**(-2) * ( 8*s12*
     +    s13**3*s14**2 - 32*s12*s13**2*s14**3 + 56*s12*s13**2*s14**2*
     +    s23 - 16*s12*s13*s14**4 - 16*s12*s13*s14**3*s23 + 40*s12*s13*
     +    s14**2*s23**2 - 32*s12*s14**4*s23 + 16*s12*s14**3*s23**2 + 8*
     +    s12*s14**2*s23**3 - 8*s13**3*s14**3 - 16*s13**3*s14**2*s23 + 
     +    16*s13**2*s14**4 - 56*s13**2*s14**3*s23 - 48*s13**2*s14**2*
     +    s23**2 + 24*s13*s14**4*s23 - 72*s13*s14**3*s23**2 - 48*s13*
     +    s14**2*s23**3 + 24*s14**4*s23**2 - 40*s14**3*s23**3 - 16*
     +    s14**2*s23**4 )

      LB34 = LB34 + Lcd0(p3,p12,p4)*S24**(-1) * ( 32*s12**3*s13 + 48*
     +    s12**3*s14 - 24*s12**3*s23 + 24*s12**3*s34 - 16*s12**2*s13**2
     +     - 8*s12**2*s13*s14 + 16*s12**2*s13*s23 + 32*s12**2*s13*s34
     +     - 80*s12**2*s14**2 + 104*s12**2*s14*s23 + 144*s12**2*s14*s34
     +     - 16*s12**2*s23**2 - 16*s12**2*s23*s34 + 32*s12**2*s34**2 - 
     +    48*s12*s13**2*s14 - 144*s12*s13*s14**2 + 32*s12*s13*s14*s23
     +     - 32*s12*s13*s14*s34 - 48*s12*s14**3 - 120*s12*s14**2*s23 - 
     +    32*s12*s14**2*s34 + 96*s12*s14*s23**2 + 64*s12*s14*s23*s34 + 
     +    32*s12*s14*s34**2 - 32*s13**2*s14**2 - 32*s13*s14**3 - 96*s13
     +    *s14**2*s23 - 32*s13*s14**2*s34 - 96*s14**2*s23**2 - 32*
     +    s14**2*s23*s34 )

      LB34 = LB34 + Lcd0(p3,p12,p4)*S34**(-1) * (  - 24*s12**2*s13**2
     +     - 96*s12**2*s13*s14 - 40*s12**2*s13*s24 + 40*s12**2*s14**2
     +     + 64*s12**2*s14*s24 + 56*s12**2*s24**2 + 16*s12*s13**3 - 56*
     +    s12*s13**2*s14 - 32*s12*s13**2*s24 - 184*s12*s13*s14**2 - 232
     +    *s12*s13*s14*s24 - 96*s12*s13*s24**2 + 32*s12*s14**2*s24 + 32
     +    *s12*s14*s24**2 + 32*s13**3*s14 + 16*s13**3*s24 + 24*s13**2*
     +    s14**2 + 24*s13**2*s14*s24 + 8*s13**2*s24**2 - 80*s13*s14**3
     +     - 128*s13*s14**2*s24 - 80*s13*s14*s24**2 - 16*s13*s24**3 )

      LB34 = LB34 + Lcd0(p3,p12,p4)*S34**(-2) * (  - 32*s12*s13**3*s14
     +     - 16*s12*s13**3*s24 - 16*s12*s13**2*s14**2 + 16*s12*s13**2*
     +    s14*s24 + 16*s12*s13**2*s24**2 - 56*s12*s13*s14**3 - 152*s12*
     +    s13*s14**2*s24 - 136*s12*s13*s14*s24**2 - 40*s12*s13*s24**3
     +     + 24*s13**3*s14**2 + 24*s13**3*s14*s24 + 8*s13**3*s24**2 + 
     +    40*s13**2*s14**3 + 72*s13**2*s14**2*s24 + 56*s13**2*s14*
     +    s24**2 + 16*s13**2*s24**3 - 16*s13*s14**4 - 48*s13*s14**3*s24
     +     - 48*s13*s14**2*s24**2 - 16*s13*s14*s24**3 )

      LB34 = LB34 + Lcd0(p3,p12,p4) * ( 56*s12**3 + 104*s12**2*s14 + 
     +    144*s12**2*s24 + 152*s12**2*s34 - 48*s12*s13**2 - 168*s12*s13
     +    *s14 - 88*s12*s13*s24 - 32*s12*s13*s34 + 32*s12*s14**2 + 96*
     +    s12*s14*s24 + 64*s12*s14*s34 + 32*s12*s24**2 + 64*s12*s24*s34
     +     + 32*s12*s34**2 - 96*s13*s14**2 - 96*s13*s14*s24 - 32*s13*
     +    s14*s34 - 32*s13*s24**2 - 16*s13*s24*s34 )

      LB34 = LB34 + Lcd1(p1,p24,p3)*S13**(-1)*S24**(-1)*S34**(-1) * ( 
     +     - 32*s12**3*s23**3 - 80*s12**2*s14*s23**3 - 16*s12**2*s23**4
     +     - 64*s12*s14**2*s23**3 - 32*s12*s14*s23**4 - 16*s14**3*
     +    s23**3 - 16*s14**2*s23**4 )

      LB34 = LB34 + Lcd1(p1,p24,p3)*S13**(-1)*S24**(-1) * (  - 32*
     +    s12**3*s23**2 - 104*s12**2*s14*s23**2 - 24*s12**2*s14*s23*s34
     +     - 48*s12**2*s23**3 - 56*s12**2*s23**2*s34 - 24*s12**2*s23*
     +    s34**2 - 112*s12*s14**2*s23**2 - 48*s12*s14**2*s23*s34 - 104*
     +    s12*s14*s23**3 - 128*s12*s14*s23**2*s34 - 56*s12*s14*s23*
     +    s34**2 - 8*s12*s23**4 - 16*s12*s23**3*s34 - 8*s12*s23**2*
     +    s34**2 - 40*s14**3*s23**2 - 24*s14**3*s23*s34 - 56*s14**2*
     +    s23**3 - 72*s14**2*s23**2*s34 - 32*s14**2*s23*s34**2 - 16*s14
     +    *s23**4 - 40*s14*s23**3*s34 - 32*s14*s23**2*s34**2 - 8*s14*
     +    s23*s34**3 )

      LB34 = LB34 + Lcd1(p1,p24,p3)*S13**(-1)*S34**(-1) * (  - 32*
     +    s12**3*s23**2 - 88*s12**2*s14*s23**2 - 44*s12**2*s23**3 - 28*
     +    s12**2*s23**2*s24 - 80*s12*s14**2*s23**2 - 88*s12*s14*s23**3
     +     - 56*s12*s14*s23**2*s24 - 24*s14**3*s23**2 - 44*s14**2*
     +    s23**3 - 28*s14**2*s23**2*s24 )

      LB34 = LB34 + Lcd1(p1,p24,p3)*S13**(-1) * ( 16*s12**3*s34 - 24*
     +    s12**2*s14*s23 + 32*s12**2*s14*s34 - 84*s12**2*s23**2 - 32*
     +    s12**2*s23*s24 - 40*s12**2*s23*s34 - 24*s12**2*s24*s34 - 48*
     +    s12*s14**2*s23 + 16*s12*s14**2*s34 - 160*s12*s14*s23**2 - 16*
     +    s12*s14*s23*s24 - 72*s12*s14*s23*s34 + 8*s12*s14*s24*s34 - 16
     +    *s12*s23**3 - 8*s12*s23**2*s24 - 32*s12*s23**2*s34 - 24*s12*
     +    s23*s24*s34 - 16*s12*s23*s34**2 - 16*s12*s24*s34**2 - 24*
     +    s14**3*s23 - 76*s14**2*s23**2 - 32*s14**2*s23*s34 + 16*s14**2
     +    *s24*s34 - 8*s14*s23**3 + 8*s14*s23**2*s24 - 16*s14*s23**2*
     +    s34 - 8*s14*s23*s34**2 - 8*s14*s24*s34**2 )

      LB34 = LB34 + Lcd1(p2,p13,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 
     +     - 32*s12**3*s14**3 - 16*s12**2*s14**4 - 80*s12**2*s14**3*s23
     +     - 32*s12*s14**4*s23 - 64*s12*s14**3*s23**2 - 16*s14**4*
     +    s23**2 - 16*s14**3*s23**3 )

      LB34 = LB34 + Lcd1(p2,p13,p4)*S13**(-1)*S24**(-1) * (  - 32*
     +    s12**3*s14**2 - 48*s12**2*s14**3 - 104*s12**2*s14**2*s23 - 56
     +    *s12**2*s14**2*s34 - 24*s12**2*s14*s23*s34 - 24*s12**2*s14*
     +    s34**2 - 8*s12*s14**4 - 104*s12*s14**3*s23 - 16*s12*s14**3*
     +    s34 - 112*s12*s14**2*s23**2 - 128*s12*s14**2*s23*s34 - 8*s12*
     +    s14**2*s34**2 - 48*s12*s14*s23**2*s34 - 56*s12*s14*s23*s34**2
     +     - 16*s14**4*s23 - 56*s14**3*s23**2 - 40*s14**3*s23*s34 - 40*
     +    s14**2*s23**3 - 72*s14**2*s23**2*s34 - 32*s14**2*s23*s34**2
     +     - 24*s14*s23**3*s34 - 32*s14*s23**2*s34**2 - 8*s14*s23*
     +    s34**3 )

      LB34 = LB34 + Lcd1(p2,p13,p4)*S24**(-1)*S34**(-1) * (  - 32*
     +    s12**3*s14**2 - 28*s12**2*s13*s14**2 - 44*s12**2*s14**3 - 88*
     +    s12**2*s14**2*s23 - 56*s12*s13*s14**2*s23 - 88*s12*s14**3*s23
     +     - 80*s12*s14**2*s23**2 - 28*s13*s14**2*s23**2 - 44*s14**3*
     +    s23**2 - 24*s14**2*s23**3 )

      LB34 = LB34 + Lcd1(p2,p13,p4)*S24**(-1) * ( 16*s12**3*s34 - 32*
     +    s12**2*s13*s14 - 24*s12**2*s13*s34 - 84*s12**2*s14**2 - 24*
     +    s12**2*s14*s23 - 40*s12**2*s14*s34 + 32*s12**2*s23*s34 + 8*
     +    s12*s13*s14**2 - 16*s12*s13*s14*s23 - 8*s12*s13*s14*s34 + 8*
     +    s12*s13*s23*s34 - 16*s12*s13*s34**2 - 160*s12*s14**2*s23 - 48
     +    *s12*s14*s23**2 - 72*s12*s14*s23*s34 + 16*s12*s23**2*s34 + 8*
     +    s13*s14**2*s23 + 16*s13*s23**2*s34 - 8*s13*s23*s34**2 - 8*
     +    s14**3*s23 - 76*s14**2*s23**2 - 16*s14**2*s23*s34 - 24*s14*
     +    s23**3 - 32*s14*s23**2*s34 - 8*s14*s23*s34**2 )

      LB34 = LB34 + Lcd1(p3,p12,p4)*S13**(-1)*S24**(-1)*S34**(-2) * ( 
     +    24*s14**4*s23**3 )

      LB34 = LB34 + Lcd1(p3,p12,p4)*S13**(-1)*S34**(-2) * ( 24*s14**4*
     +    s23**2 + 24*s14**3*s23**3 + 24*s14**3*s23**2*s24 )

      LB34 = LB34 + Lcd1(p3,p12,p4)*S24**(-1)*S34**(-2) * ( 48*s13**3*
     +    s14**3 + 48*s13**2*s14**4 + 120*s13**2*s14**3*s23 + 120*s13*
     +    s14**4*s23 + 96*s13*s14**3*s23**2 + 96*s14**4*s23**2 + 24*
     +    s14**3*s23**3 )

      LB34 = LB34 + Lcd1(p3,p12,p4)*S34**(-2) * ( 40*s13**3*s14**2 + 
     +    104*s13**2*s14**3 + 96*s13**2*s14**2*s23 + 56*s13**2*s14**2*
     +    s24 + 64*s13*s14**4 + 232*s13*s14**3*s23 + 104*s13*s14**3*s24
     +     + 72*s13*s14**2*s23**2 + 112*s13*s14**2*s23*s24 + 40*s13*
     +    s14**2*s24**2 + 88*s14**4*s23 + 152*s14**3*s23**2 + 128*
     +    s14**3*s23*s24 + 16*s14**2*s23**3 + 56*s14**2*s23**2*s24 + 40
     +    *s14**2*s23*s24**2 )

      LB34 = LB34 + Lcd1(p3,p24,p1)*S13**(-1)*S24**(-1)*S34**(-1) * ( 
     +     - 32*s12**4*s23**2 - 48*s12**3*s14*s23**2 - 16*s12**3*s23**3
     +     - 16*s12**2*s14**2*s23**2 - 16*s12**2*s14*s23**3 )

      LB34 = LB34 + Lcd1(p3,p24,p1)*S13**(-1)*S24**(-1) * (  - 64*
     +    s12**4*s23 - 32*s12**4*s34 - 72*s12**3*s14*s23 - 24*s12**3*
     +    s14*s34 - 32*s12**3*s23**2 - 8*s12**3*s23*s34 + 8*s12**3*
     +    s34**2 + 16*s12**2*s14**2*s23 + 32*s12**2*s14**2*s34 - 8*
     +    s12**2*s14*s23**2 + 48*s12**2*s14*s23*s34 + 40*s12**2*s14*
     +    s34**2 + 24*s12**2*s23**3 + 56*s12**2*s23**2*s34 + 40*s12**2*
     +    s23*s34**2 + 8*s12**2*s34**3 + 24*s12*s14**3*s23 + 24*s12*
     +    s14**3*s34 + 24*s12*s14**2*s23**2 + 56*s12*s14**2*s23*s34 + 
     +    32*s12*s14**2*s34**2 + 24*s12*s14*s23**3 + 56*s12*s14*s23**2*
     +    s34 + 40*s12*s14*s23*s34**2 + 8*s12*s14*s34**3 )

      LB34 = LB34 + Lcd1(p3,p24,p1)*S13**(-1)*S34**(-1) * (  - 32*
     +    s12**4*s23 - 56*s12**3*s14*s23 - 20*s12**3*s23**2 - 4*s12**3*
     +    s23*s24 - 24*s12**2*s14**2*s23 - 20*s12**2*s14*s23**2 - 4*
     +    s12**2*s14*s23*s24 )

      LB34 = LB34 + Lcd1(p3,p24,p1)*S13**(-1) * (  - 32*s12**4 - 32*
     +    s12**3*s14 - 16*s12**3*s23 + 4*s12**3*s24 + 12*s12**3*s34 + 
     +    24*s12**2*s14**2 + 8*s12**2*s14*s23 + 4*s12**2*s14*s24 + 44*
     +    s12**2*s14*s34 + 24*s12**2*s23**2 + 32*s12**2*s23*s34 - 8*
     +    s12**2*s24*s34 + 8*s12**2*s34**2 + 24*s12*s14**3 + 24*s12*
     +    s14**2*s23 + 32*s12*s14**2*s34 + 24*s12*s14*s23**2 + 32*s12*
     +    s14*s23*s34 - 8*s12*s14*s24*s34 + 8*s12*s14*s34**2 )

      LB34 = LB34 + Lcd1(p4,p12,p3)*S24**(-1)*S34**(-2) * (  - 48*
     +    s13**4*s14**2 - 48*s13**3*s14**3 - 72*s13**3*s14**2*s23 - 72*
     +    s13**2*s14**3*s23 - 24*s13**2*s14**2*s23**2 - 24*s13*s14**3*
     +    s23**2 )

      LB34 = LB34 + Lcd1(p4,p12,p3)*S34**(-2) * (  - 56*s13**4*s14 - 8*
     +    s13**4*s24 - 88*s13**3*s14**2 - 64*s13**3*s14*s23 - 32*s13**3
     +    *s14*s24 + 8*s13**3*s23*s24 + 8*s13**3*s24**2 - 32*s13**2*
     +    s14**3 - 136*s13**2*s14**2*s23 - 72*s13**2*s14**2*s24 - 8*
     +    s13**2*s14*s23**2 - 56*s13**2*s14*s23*s24 - 48*s13**2*s14*
     +    s24**2 + 16*s13**2*s23**2*s24 + 8*s13**2*s23*s24**2 - 8*
     +    s13**2*s24**3 - 24*s13*s14**3*s23 - 48*s13*s14**2*s23**2 - 48
     +    *s13*s14**2*s23*s24 - 24*s13*s14*s23**2*s24 - 24*s13*s14*s23*
     +    s24**2 )

      LB34 = LB34 + Lcd1(p4,p13,p2)*S13**(-1)*S24**(-1)*S34**(-1) * ( 
     +     - 32*s12**4*s14**2 - 16*s12**3*s14**3 - 48*s12**3*s14**2*s23
     +     - 16*s12**2*s14**3*s23 - 16*s12**2*s14**2*s23**2 )

      LB34 = LB34 + Lcd1(p4,p13,p2)*S13**(-1)*S24**(-1) * (  - 64*
     +    s12**4*s14 - 32*s12**4*s34 - 32*s12**3*s14**2 - 72*s12**3*s14
     +    *s23 - 8*s12**3*s14*s34 - 24*s12**3*s23*s34 + 8*s12**3*s34**2
     +     + 24*s12**2*s14**3 - 8*s12**2*s14**2*s23 + 56*s12**2*s14**2*
     +    s34 + 16*s12**2*s14*s23**2 + 48*s12**2*s14*s23*s34 + 40*
     +    s12**2*s14*s34**2 + 32*s12**2*s23**2*s34 + 40*s12**2*s23*
     +    s34**2 + 8*s12**2*s34**3 + 24*s12*s14**3*s23 + 24*s12*s14**2*
     +    s23**2 + 56*s12*s14**2*s23*s34 + 24*s12*s14*s23**3 + 56*s12*
     +    s14*s23**2*s34 + 40*s12*s14*s23*s34**2 + 24*s12*s23**3*s34 + 
     +    32*s12*s23**2*s34**2 + 8*s12*s23*s34**3 )

      LB34 = LB34 + Lcd1(p4,p13,p2)*S24**(-1)*S34**(-1) * (  - 32*
     +    s12**4*s14 - 4*s12**3*s13*s14 - 20*s12**3*s14**2 - 56*s12**3*
     +    s14*s23 - 4*s12**2*s13*s14*s23 - 20*s12**2*s14**2*s23 - 24*
     +    s12**2*s14*s23**2 )

      LB34 = LB34 + Lcd1(p4,p13,p2)*S24**(-1) * (  - 32*s12**4 + 4*
     +    s12**3*s13 - 16*s12**3*s14 - 32*s12**3*s23 + 12*s12**3*s34 - 
     +    16*s12**2*s13*s14 + 4*s12**2*s13*s23 - 8*s12**2*s13*s34 + 8*
     +    s12**2*s14**2 + 8*s12**2*s14*s23 + 16*s12**2*s14*s34 + 24*
     +    s12**2*s23**2 + 44*s12**2*s23*s34 + 8*s12**2*s34**2 - 16*s12*
     +    s13*s14*s23 - 8*s12*s13*s23*s34 + 8*s12*s14**2*s23 + 24*s12*
     +    s14*s23**2 + 16*s12*s14*s23*s34 + 24*s12*s23**3 + 32*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LB34 = LB34 + Lcd2(p1,p24,p3)*S13**(-1)*S24**(-1)*S34**(-1)*S234
     +  * (  - 16*s12**2*s23**3 - 20*s12*s14*s23**3 - 4*s14**2*s23**3 )

      LB34 = LB34 + Lcd2(p1,p24,p3)*S13**(-1)*S24**(-1)*S234 * (  - 12*
     +    s12**2*s23**2 - 12*s12*s14*s23**2 )

      LB34 = LB34 + Lcd2(p2,p13,p4)*S13**(-1)*S24**(-1)*S34**(-1)*S134
     +  * (  - 16*s12**2*s14**3 - 20*s12*s14**3*s23 - 4*s14**3*s23**2 )

      LB34 = LB34 + Lcd2(p2,p13,p4)*S13**(-1)*S24**(-1)*S134 * (  - 12*
     +    s12**2*s14**2 - 12*s12*s14**2*s23 )

      LB34 = LB34 + Lcd2(p3,p24,p1)*S13**(-1)*S24**(-1)*S34**(-1)*S234
     +  * ( 16*s12**4*s23 + 28*s12**3*s14*s23 + 12*s12**2*s14**2*s23 )

      LB34 = LB34 + Lcd2(p3,p24,p1)*S13**(-1)*S24**(-1)*S234 * ( 4*
     +    s12**4 + 4*s12**3*s14 )

      LB34 = LB34 + Lcd2(p4,p13,p2)*S13**(-1)*S24**(-1)*S34**(-1)*S134
     +  * ( 16*s12**4*s14 + 28*s12**3*s14*s23 + 12*s12**2*s14*s23**2 )

      LB34 = LB34 + Lcd2(p4,p13,p2)*S13**(-1)*S24**(-1)*S134 * ( 4*
     +    s12**4 + 4*s12**3*s23 )

      LB34 = LB34 + Ld0(p1,p2,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 32*
     +    s12**2*s14*s23 + 32*s12*s14**2*s23 + 16*s12*s14*s23**2 + 16*
     +    s14**3*s23 + 8*s14*s23**3 )

      LB34 = LB34 + Ld0(p1,p2,p4)*S13**(-1)*S24**(-1) * ( 16*s12**3 + 
     +    64*s12**2*s14 + 80*s12**2*s23 + 80*s12**2*s34 + 56*s12*s14**2
     +     + 96*s12*s14*s23 + 80*s12*s14*s34 + 40*s12*s23**2 + 64*s12*
     +    s23*s34 + 24*s12*s34**2 + 24*s14**3 + 40*s14**2*s23 + 40*
     +    s14**2*s34 + 32*s14*s23**2 + 48*s14*s23*s34 + 24*s14*s34**2
     +     + 16*s23**3 + 32*s23**2*s34 + 24*s23*s34**2 + 8*s34**3 )

      LB34 = LB34 + Ld0(p1,p2,p4)*S13**(-1)*S34**(-1) * ( 32*s12**2*s14
     +     + 16*s12**2*s23 + 16*s12**2*s24 + 32*s12*s14**2 + 32*s12*s14
     +    *s23 + 16*s12*s14*s24 + 16*s12*s23**2 + 16*s12*s23*s24 + 16*
     +    s14**3 + 8*s14**2*s23 + 8*s14**2*s24 + 8*s14*s23**2 + 8*
     +    s23**3 + 8*s23**2*s24 )

      LB34 = LB34 + Ld0(p1,p2,p4)*S13**(-1) * ( 96*s12**2 + 96*s12*s14
     +     + 72*s12*s23 + 16*s12*s24 + 40*s12*s34 + 48*s14**2 + 40*s14*
     +    s23 + 16*s14*s24 + 40*s14*s34 + 24*s23**2 + 24*s23*s34 + 8*
     +    s24*s34 + 16*s34**2 )

      LB34 = LB34 + Ld0(p1,p2,p4)*S24**(-1)*S34**(-1) * (  - 16*s12**2*
     +    s13 - 16*s12**2*s14 + 48*s12**2*s23 - 16*s12*s13*s14 + 32*s12
     +    *s13*s23 - 16*s12*s14**2 + 80*s12*s14*s23 + 32*s12*s23**2 + 
     +    24*s13**2*s23 - 8*s13*s14**2 + 64*s13*s14*s23 - 8*s13*s23**2
     +     - 8*s14**3 + 64*s14**2*s23 + 8*s14*s23**2 + 16*s23**3 )

      LB34 = LB34 + Ld0(p1,p2,p4)*S24**(-1) * ( 48*s12**2 + 8*s12*s13
     +     + 40*s12*s14 + 80*s12*s23 + 24*s12*s34 + 8*s13**2 + 32*s13*
     +    s14 + 8*s13*s23 + 40*s14**2 + 56*s14*s23 + 32*s14*s34 + 24*
     +    s23**2 + 8*s23*s34 )

      LB34 = LB34 + Ld0(p1,p2,p4)*S34**(-1) * ( 40*s12**2 + 56*s12*s14
     +     + 16*s12*s23 - 16*s12*s24 + 40*s13*s14 - 16*s13*s24 + 56*
     +    s14**2 + 16*s14*s23 - 8*s23**2 - 24*s23*s24 )

      LB34 = LB34 + Ld0(p1,p2,p4) * ( 16*s12 - 24*s13 + 32*s14 - 16*s23
     +     - 8*s24 - 16*s34 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S13**(-1)*S24**(-1)*S34**(-1) * ( 
     +     - 16*s12**2*s14*s23 - 16*s12*s14**2*s23 - 8*s14**3*s23 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * (  - 8*
     +    s12*s14 + 8*s12*s23 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S13**(-1)*S24**(-1) * ( 16*s12**3 + 
     +    16*s12**2*s14 + 16*s12*s14**2 - 8*s12*s14*s23 + 8*s12*s14*s34
     +     - 8*s12*s23*s34 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S13**(-1)*S34**(-1)*S134 * (  - 88*
     +    s12**2 + 40*s12*s14 + 32*s12*s23 - 16*s14**2 - 32*s14*s23 - 
     +    16*s23**2 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S13**(-1)*S34**(-1) * ( 104*s12**2*
     +    s14 - 24*s12*s14**2 - 64*s12*s14*s23 + 24*s14**3 + 64*s14**2*
     +    s23 + 32*s14*s23**2 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S13**(-1)*S34**(-2)*S134 * ( 64*s12*
     +    s14*s23 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S13**(-1)*S34**(-2) * (  - 64*s12*
     +    s14**2*s23 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S13**(-1)*S134 * ( 40*s12 - 32*s14
     +     - 32*s23 - 16*s34 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S13**(-1) * ( 56*s12**2 - 112*s12*
     +    s14 - 48*s12*s23 - 56*s12*s34 + 48*s14**2 + 80*s14*s23 + 48*
     +    s14*s34 + 16*s23**2 + 32*s23*s34 + 16*s34**2 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S24**(-1)*S34**(-1)*S134 * ( 32*s12*
     +    s23 + 8*s14*s23 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S24**(-1)*S234**(-1)*S134 * ( 32*s12
     +    *s34 + 32*s13*s34 + 32*s14*s34 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S24**(-1)*S134 * (  - 24*s13 - 24*
     +    s14 - 8*s23 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S34**(-1)*S234**(-1)*S134 * ( 128*
     +    s12*s24 + 128*s13*s24 + 128*s14*s24 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S34**(-1)*S134 * (  - 160*s12 - 104*
     +    s13 - 64*s14 + 32*s23 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S34**(-2)*S234**(-1)*S134 * ( 64*s12
     +    *s24**2 + 64*s13*s24**2 + 64*s14*s24**2 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S34**(-2)*S134 * (  - 64*s12*s24 - 
     +    64*s13*s24 + 64*s14*s23 - 64*s14*s24 + 64*s23**2 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S234**(-1)*S134 * ( 96*s12 + 96*s13
     +     + 96*s14 )

      LB34 = LB34 + Ld0(p1,p2,p34)*S134 * ( 8 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S13**(-1)*S24**(-1)*S34**(-1)*
     + S134**(-1) * (  - 8*s12*s14**2*s23**2 - 8*s14**3*s23**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 8*
     +    s12*s14*s23**2 + 8*s14**2*s23**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S13**(-1)*S24**(-1)*S134**(-1) * ( 
     +     - 16*s12**3*s34 + 8*s12**2*s14*s23 - 32*s12**2*s14*s34 - 16*
     +    s12**2*s23*s34 - 64*s12**2*s34**2 + 8*s12*s14**2*s23 - 16*s12
     +    *s14**2*s34 - 40*s12*s14*s34**2 - 24*s12*s23*s34**2 - 32*s12*
     +    s34**3 + 8*s14**2*s23*s34 + 8*s14*s23**3 + 24*s14*s23**2*s34
     +     + 16*s14*s23*s34**2 + 8*s23**3*s34 + 16*s23**2*s34**2 + 8*
     +    s23*s34**3 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S13**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s23 + 32*s12**2*s34 - 8*s12*s14*s23 + 16*s12*s14*s34 - 8*s12*
     +    s23**2 + 8*s12*s23*s34 + 24*s12*s34**2 - 8*s14*s23**2 - 8*s14
     +    *s23*s34 - 8*s23**3 - 16*s23**2*s34 - 8*s23*s34**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S13**(-1)*S34**(-1)*S134**(-1) * ( 8*
     +    s14**2*s23**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S13**(-1)*S34**(-1) * (  - 8*s14*
     +    s23**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S13**(-1)*S134**(-1) * (  - 16*s12**2
     +    *s14 - 32*s12**2*s34 - 16*s12*s14**2 - 40*s12*s14*s23 - 32*
     +    s12*s14*s24 - 72*s12*s14*s34 - 40*s12*s23*s34 - 24*s12*s24*
     +    s34 - 56*s12*s34**2 + 8*s14**2*s23 + 8*s14*s23**2 - 24*s14*
     +    s23*s24 + 8*s14*s23*s34 - 16*s14*s24**2 - 16*s14*s24*s34 + 16
     +    *s23**2*s34 + 8*s23*s24*s34 + 16*s23*s34**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S13**(-1) * ( 16*s12**2 + 24*s12*s14
     +     + 40*s12*s23 + 40*s12*s24 + 64*s12*s34 - 16*s14*s23 - 8*s14*
     +    s24 - 8*s14*s34 - 8*s23**2 + 8*s23*s24 - 8*s23*s34 + 8*s24**2
     +     + 8*s24*s34 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S24**(-1)*S34**(-1)*S134**(-1) * ( 
     +     - 8*s12*s13*s23**2 - 16*s12*s14*s23**2 - 8*s13*s14*s23**2 - 
     +    16*s14**2*s23**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S24**(-1)*S34**(-1) * ( 8*s12*s23**2
     +     + 8*s14*s23**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S24**(-1)*S134**(-1) * ( 8*s12**2*s23
     +     - 48*s12**2*s34 - 8*s12*s13*s23 - 8*s12*s13*s34 - 24*s12*s14
     +    *s34 - 16*s12*s23*s34 - 32*s12*s34**2 - 8*s13*s14*s23 - 8*
     +    s14**2*s23 + 8*s23**3 + 16*s23**2*s34 + 8*s23*s34**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S24**(-1) * (  - 8*s12*s23 + 16*s12*
     +    s34 - 16*s23**2 - 8*s23*s34 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S34**(-1)*S134**(-1) * ( 40*s12*s13*
     +    s23 + 40*s12*s13*s24 + 8*s12*s14*s23 + 16*s12*s14*s24 + 24*
     +    s13**2*s23 + 32*s13*s14*s23 + 8*s13*s14*s24 + 4*s13*s23**2 + 
     +    16*s13*s23*s24 + 16*s13*s24**2 + 8*s14**2*s23 - 10*s14*s23**2
     +     - 8*s14*s23*s24 + 16*s14*s24**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S34**(-1) * (  - 8*s12**2 - 8*s12*s23
     +     - 16*s12*s24 - 24*s13*s23 - 16*s14*s23 + 8*s23**2 - 16*
     +    s24**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S34**(-2)*S134**(-1) * ( 8*s13**2*
     +    s23**2 - 16*s13**2*s23*s24 - 8*s13**2*s24**2 + 8*s13*s14*
     +    s23**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S34**(-2) * (  - 8*s13*s23**2 )

      LB34 = LB34 + Ld0(p1,p3,p4)*S134**(-1) * ( 48*s12*s13 - 20*s12*
     +    s23 + 32*s12*s24 + 16*s12*s34 + 8*s13**2 + 8*s13*s14 + 40*s13
     +    *s23 + 32*s13*s24 + 16*s13*s34 + 16*s14*s23 + 24*s14*s24 + 8*
     +    s14*s34 - 10*s23**2 - 16*s23*s24 + 16*s23*s34 + 8*s24**2 + 24
     +    *s24*s34 + 16*s34**2 )

      LB34 = LB34 + Ld0(p1,p3,p4) * (  - 24*s23 - 32*s24 - 16*s34 )

      LB34 = LB34 + Ld0(p1,p24,p3)*S13**(-1)*S24**(-1)*S34**(-1) * ( 32
     +    *s12**2*s14*s23 + 32*s12*s14**2*s23 - 16*s12*s14*s23**2 + 16*
     +    s14**3*s23 - 8*s14**2*s23**2 )

      LB34 = LB34 + Ld0(p1,p24,p3)*S13**(-1)*S24**(-1) * ( 32*s12**2*
     +    s14 + 48*s12**2*s23 + 40*s12**2*s34 + 32*s12*s14**2 + 32*s12*
     +    s14*s23 + 32*s12*s14*s34 + 16*s14**3 + 16*s14**2*s23 + 16*
     +    s14**2*s34 )

      LB34 = LB34 + Ld0(p1,p24,p3)*S13**(-1)*S34**(-1) * ( 32*s12**2*
     +    s14 - 16*s12**2*s23 + 16*s12**2*s24 + 32*s12*s14**2 + 16*s12*
     +    s14*s23 + 32*s12*s14*s24 + 8*s12*s23**2 - 32*s12*s23*s24 + 16
     +    *s12*s24**2 + 16*s14**3 - 8*s14**2*s23 - 24*s14*s23**2 + 24*
     +    s14*s24**2 )

      LB34 = LB34 + Ld0(p1,p24,p3)*S13**(-1) * ( 48*s12*s14 + 32*s12*
     +    s23 - 32*s12*s24 + 16*s12*s34 + 24*s14**2 - 16*s14*s23 + 8*
     +    s23*s24 + 8*s24**2 + 8*s24*s34 )

      LB34 = LB34 + Ld0(p1,p24,p3)*S24**(-1)*S34**(-1) * ( 32*s12**2*
     +    s23 + 32*s12*s13*s23 + 64*s12*s14*s23 + 16*s13**2*s23 + 48*
     +    s13*s14*s23 + 48*s14**2*s23 )

      LB34 = LB34 + Ld0(p1,p24,p3)*S24**(-1) * ( 32*s12**2 + 32*s12*s13
     +     + 64*s12*s14 + 32*s12*s23 + 32*s12*s34 + 16*s13**2 + 48*s13*
     +    s14 + 16*s13*s23 + 16*s13*s34 + 48*s14**2 + 32*s14*s23 + 32*
     +    s14*s34 )

      LB34 = LB34 + Ld0(p1,p24,p3)*S34**(-1) * ( 32*s12**2 + 32*s12*s13
     +     + 64*s12*s14 + 24*s12*s23 + 8*s12*s24 + 16*s13**2 + 48*s13*
     +    s14 + 48*s14**2 - 8*s14*s23 - 8*s14*s24 + 8*s23*s24 + 8*
     +    s24**2 )

      LB34 = LB34 + Ld0(p1,p24,p3) * ( 72*s12 + 16*s13 + 40*s14 + 8*s24
     +     )

      LB34 = LB34 + Ld0(p2,p1,p3)*S13**(-1)*S24**(-1)*S34**(-1) * ( 32*
     +    s12**2*s14*s23 + 16*s12*s14**2*s23 + 32*s12*s14*s23**2 + 8*
     +    s14**3*s23 + 16*s14*s23**3 )

      LB34 = LB34 + Ld0(p2,p1,p3)*S13**(-1)*S24**(-1) * ( 16*s12**3 + 
     +    80*s12**2*s14 + 64*s12**2*s23 + 80*s12**2*s34 + 40*s12*s14**2
     +     + 96*s12*s14*s23 + 64*s12*s14*s34 + 56*s12*s23**2 + 80*s12*
     +    s23*s34 + 24*s12*s34**2 + 16*s14**3 + 32*s14**2*s23 + 32*
     +    s14**2*s34 + 40*s14*s23**2 + 48*s14*s23*s34 + 24*s14*s34**2
     +     + 24*s23**3 + 40*s23**2*s34 + 24*s23*s34**2 + 8*s34**3 )

      LB34 = LB34 + Ld0(p2,p1,p3)*S13**(-1)*S34**(-1) * ( 48*s12**2*s14
     +     - 16*s12**2*s23 - 16*s12**2*s24 + 32*s12*s14**2 + 80*s12*s14
     +    *s23 + 32*s12*s14*s24 - 16*s12*s23**2 - 16*s12*s23*s24 + 16*
     +    s14**3 + 8*s14**2*s23 - 8*s14**2*s24 + 64*s14*s23**2 + 64*s14
     +    *s23*s24 + 24*s14*s24**2 - 8*s23**3 - 8*s23**2*s24 )

      LB34 = LB34 + Ld0(p2,p1,p3)*S13**(-1) * ( 48*s12**2 + 80*s12*s14
     +     + 40*s12*s23 + 8*s12*s24 + 24*s12*s34 + 24*s14**2 + 56*s14*
     +    s23 + 8*s14*s24 + 8*s14*s34 + 40*s23**2 + 32*s23*s24 + 32*s23
     +    *s34 + 8*s24**2 )

      LB34 = LB34 + Ld0(p2,p1,p3)*S24**(-1)*S34**(-1) * ( 16*s12**2*s13
     +     + 16*s12**2*s14 + 32*s12**2*s23 + 16*s12*s13*s14 + 16*s12*
     +    s13*s23 + 16*s12*s14**2 + 32*s12*s14*s23 + 32*s12*s23**2 + 8*
     +    s13*s14**2 + 8*s13*s23**2 + 8*s14**3 + 8*s14**2*s23 + 8*s14*
     +    s23**2 + 16*s23**3 )

      LB34 = LB34 + Ld0(p2,p1,p3)*S24**(-1) * ( 96*s12**2 + 16*s12*s13
     +     + 72*s12*s14 + 96*s12*s23 + 40*s12*s34 + 16*s13*s23 + 8*s13*
     +    s34 + 24*s14**2 + 40*s14*s23 + 24*s14*s34 + 48*s23**2 + 40*
     +    s23*s34 + 16*s34**2 )

      LB34 = LB34 + Ld0(p2,p1,p3)*S34**(-1) * ( 40*s12**2 - 16*s12*s13
     +     + 16*s12*s14 + 56*s12*s23 - 24*s13*s14 - 16*s13*s24 - 8*
     +    s14**2 + 16*s14*s23 + 56*s23**2 + 40*s23*s24 )

      LB34 = LB34 + Ld0(p2,p1,p3) * ( 16*s12 - 8*s13 - 16*s14 + 32*s23
     +     - 24*s24 - 16*s34 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S13**(-1)*S24**(-1)*S34**(-1)*S234
     +  * ( 16*s12**2*s14 + 16*s12*s14*s23 + 8*s14*s23**2 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * ( 48*
     +    s12**2 + 16*s12*s14 + 40*s12*s23 - 8*s12*s34 + 8*s14*s23 - 8*
     +    s14*s34 + 16*s23**2 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S13**(-1)*S24**(-1) * ( 16*s12**3 + 
     +    16*s12**2*s14 - 16*s12**2*s34 - 16*s12*s14*s34 + 8*s12*s34**2
     +     + 8*s14*s34**2 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S13**(-1)*S34**(-1)*S234*S134**(-1)
     +  * (  - 64*s12*s14**2 - 64*s14**2*s23 - 64*s14**2*s24 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S13**(-1)*S34**(-1)*S234 * ( 48*s12*
     +    s14 + 32*s14*s23 + 8*s14*s24 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S13**(-1)*S34**(-1) * ( 16*s12**2*
     +    s14 - 16*s12*s14*s24 + 8*s14*s24**2 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S13**(-1)*S34**(-2)*S234*S134**(-1)
     +  * (  - 64*s12*s14**3 - 64*s14**3*s23 - 64*s14**3*s24 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S13**(-1)*S34**(-2)*S234 * ( 64*s12*
     +    s14**2 + 64*s14**2*s23 + 64*s14**2*s24 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S13**(-1)*S234*S134**(-1) * (  - 32*
     +    s12*s14 - 32*s14*s23 - 32*s14*s24 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S13**(-1)*S234 * (  - 24*s14 + 8*s23
     +     + 8*s24 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S13**(-1) * (  - 16*s12**2 - 24*s12*
     +    s14 + 16*s12*s24 + 24*s12*s34 + 24*s14*s24 + 24*s14*s34 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S24**(-1)*S34**(-1)*S234 * ( 48*
     +    s12**2 - 64*s12*s13 - 32*s12*s14 + 48*s12*s23 + 32*s13**2 + 
     +    16*s13*s14 - 64*s13*s23 - 32*s14*s23 + 24*s23**2 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S24**(-1)*S234 * (  - 112*s12 + 64*
     +    s13 - 72*s23 + 40*s34 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S24**(-1) * (  - 48*s12**2 + 48*s12*
     +    s13 + 80*s12*s34 - 16*s13**2 - 48*s13*s34 - 40*s34**2 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S34**(-1)*S234 * (  - 72*s12 + 160*
     +    s13 - 8*s23 + 64*s24 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S34**(-1) * (  - 104*s12**2 + 64*s12
     +    *s13 + 40*s12*s24 - 32*s13**2 - 64*s13*s24 - 24*s24**2 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S34**(-2)*S234 * (  - 64*s12*s14 + 
     +    64*s13**2 + 64*s13*s24 - 64*s14*s23 - 64*s14*s24 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S34**(-2) * ( 64*s12*s13*s24 )

      LB34 = LB34 + Ld0(p2,p1,p34)*S234 * ( 104 )

      LB34 = LB34 + Ld0(p2,p1,p34) * ( 128*s12 - 112*s13 - 88*s24 - 104
     +    *s34 )

      LB34 = LB34 + Ld0(p2,p4,p3)*S13**(-1)*S24**(-1)*S234**(-1) * ( 
     +     - 8*s12**3*s34 - 24*s12**2*s14*s34 - 16*s12**2*s34**2 + 2*
     +    s12*s14**2*s23 - 14*s12*s14**2*s34 - 16*s12*s14*s23*s34 - 32*
     +    s12*s14*s34**2 + 8*s14**3*s23 + 8*s14**3*s34 + 8*s14**2*
     +    s23**2 + 16*s14**2*s23*s34 + 8*s14**2*s34**2 )

      LB34 = LB34 + Ld0(p2,p4,p3)*S13**(-1)*S24**(-1) * (  - 8*s12*
     +    s14**2 + 16*s12*s14*s34 - 8*s14**3 - 8*s14**2*s23 - 8*s14**2*
     +    s34 )

      LB34 = LB34 + Ld0(p2,p4,p3)*S13**(-1)*S234**(-1) * (  - 8*s12**2*
     +    s14 + 16*s12**2*s34 - 12*s12*s14**2 - 16*s12*s14*s23 - 16*s12
     +    *s14*s24 - 32*s12*s14*s34 + 8*s12*s23*s34 + 8*s12*s24*s34 + 
     +    16*s12*s34**2 + 8*s14**3 - 8*s14**2*s24 - 8*s14*s23**2 - 8*
     +    s14*s23*s24 - 16*s14*s23*s34 - 8*s14*s24*s34 - 8*s14*s34**2 )

      LB34 = LB34 + Ld0(p2,p4,p3)*S13**(-1) * (  - 8*s14**2 )

      LB34 = LB34 + Ld0(p2,p4,p3)*S24**(-1)*S34**(-1)*S234**(-1) * ( 8*
     +    s14**2*s23**2 )

      LB34 = LB34 + Ld0(p2,p4,p3)*S24**(-1)*S34**(-1) * (  - 8*s14**2*
     +    s23 )

      LB34 = LB34 + Ld0(p2,p4,p3)*S24**(-1)*S234**(-1) * (  - 16*s12**2
     +    *s34 - 32*s12*s13*s23 - 24*s12*s13*s34 - 48*s12*s14*s23 - 56*
     +    s12*s14*s34 - 32*s12*s23*s34 - 24*s12*s34**2 - 16*s13**2*s23
     +     - 24*s13*s14*s23 + 8*s13*s14*s34 - 16*s13*s23*s34 + 8*s14**2
     +    *s23 + 16*s14**2*s34 - 8*s14*s23*s34 + 8*s14*s34**2 )

      LB34 = LB34 + Ld0(p2,p4,p3)*S24**(-1) * ( 40*s12*s13 + 48*s12*s14
     +     + 8*s12*s23 + 40*s12*s34 + 8*s13**2 + 8*s13*s14 - 8*s13*s23
     +     + 8*s13*s34 - 8*s14**2 - 8*s14*s23 - 8*s23*s34 )

      LB34 = LB34 + Ld0(p2,p4,p3)*S34**(-1)*S234**(-1) * ( 8*s12*s13*
     +    s24 - 8*s12*s14*s23 + 16*s13**2*s23 + 48*s13**2*s24 - 8*s13*
     +    s14*s23 + 48*s13*s14*s24 + 8*s13*s23*s24 + 8*s13*s24**2 - 16*
     +    s14**2*s23 - 24*s14**2*s24 - 8*s14*s23**2 - 8*s14*s23*s24 )

      LB34 = LB34 + Ld0(p2,p4,p3)*S34**(-1) * (  - 8*s12**2 + 8*s12*s14
     +     - 16*s13**2 + 8*s14**2 )

      LB34 = LB34 + Ld0(p2,p4,p3)*S234**(-1) * ( 24*s12**2 - 8*s12*s13
     +     - 52*s12*s14 + 8*s12*s23 + 8*s12*s24 + 8*s12*s34 + 8*s13**2
     +     - 24*s13*s14 + 16*s13*s23 + 48*s13*s24 + 8*s13*s34 - 24*
     +    s14**2 - 40*s14*s23 - 32*s14*s24 - 40*s14*s34 + 8*s23*s24 + 8
     +    *s24**2 )

      LB34 = LB34 + Ld0(p2,p4,p3) * ( 8*s12 - 24*s13 + 8*s14 - 8*s34 )

      LB34 = LB34 + Ld0(p2,p13,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 32
     +    *s12**2*s14*s23 - 16*s12*s14**2*s23 + 32*s12*s14*s23**2 - 8*
     +    s14**2*s23**2 + 16*s14*s23**3 )

      LB34 = LB34 + Ld0(p2,p13,p4)*S13**(-1)*S24**(-1) * ( 48*s12**2*
     +    s14 + 32*s12**2*s23 + 40*s12**2*s34 + 32*s12*s14*s23 + 32*s12
     +    *s23**2 + 32*s12*s23*s34 + 16*s14*s23**2 + 16*s23**3 + 16*
     +    s23**2*s34 )

      LB34 = LB34 + Ld0(p2,p13,p4)*S13**(-1)*S34**(-1) * ( 32*s12**2*
     +    s14 + 64*s12*s14*s23 + 32*s12*s14*s24 + 48*s14*s23**2 + 48*
     +    s14*s23*s24 + 16*s14*s24**2 )

      LB34 = LB34 + Ld0(p2,p13,p4)*S13**(-1) * ( 32*s12**2 + 32*s12*s14
     +     + 64*s12*s23 + 32*s12*s24 + 32*s12*s34 + 32*s14*s23 + 16*s14
     +    *s24 + 48*s23**2 + 48*s23*s24 + 32*s23*s34 + 16*s24**2 + 16*
     +    s24*s34 )

      LB34 = LB34 + Ld0(p2,p13,p4)*S24**(-1)*S34**(-1) * ( 16*s12**2*
     +    s13 - 16*s12**2*s14 + 32*s12**2*s23 + 16*s12*s13**2 - 32*s12*
     +    s13*s14 + 32*s12*s13*s23 + 8*s12*s14**2 + 16*s12*s14*s23 + 32
     +    *s12*s23**2 + 24*s13**2*s23 - 24*s14**2*s23 - 8*s14*s23**2 + 
     +    16*s23**3 )

      LB34 = LB34 + Ld0(p2,p13,p4)*S24**(-1) * (  - 32*s12*s13 + 32*s12
     +    *s14 + 48*s12*s23 + 16*s12*s34 + 8*s13**2 + 8*s13*s14 + 8*s13
     +    *s34 - 16*s14*s23 + 24*s23**2 )

      LB34 = LB34 + Ld0(p2,p13,p4)*S34**(-1) * ( 32*s12**2 + 8*s12*s13
     +     + 24*s12*s14 + 64*s12*s23 + 32*s12*s24 + 8*s13**2 + 8*s13*
     +    s14 - 8*s13*s23 - 8*s14*s23 + 48*s23**2 + 48*s23*s24 + 16*
     +    s24**2 )

      LB34 = LB34 + Ld0(p2,p13,p4) * ( 72*s12 + 8*s13 + 40*s23 + 16*s24
     +     )

      LB34 = LB34 + Ld0(p3,p1,p24)*S13**(-1)*S24**(-1)*S34**(-1)*S234
     +  * ( 16*s12**3 + 32*s12**2*s14 + 32*s12*s14**2 - 16*s12*s14*s23
     +     + 16*s12*s23**2 + 8*s14**3 + 8*s14*s23**2 )

      LB34 = LB34 + Ld0(p3,p1,p24)*S13**(-1)*S24**(-1)*S234 * ( 32*
     +    s12**2 + 48*s12*s14 + 16*s12*s23 + 16*s12*s34 + 24*s14**2 + 
     +    16*s14*s23 + 24*s14*s34 + 8*s23**2 + 16*s23*s34 + 8*s34**2 )

      LB34 = LB34 + Ld0(p3,p1,p24)*S13**(-1)*S34**(-1)*S234 * ( 16*s12*
     +    s14 - 16*s12*s23 + 8*s14**2 + 8*s23**2 )

      LB34 = LB34 + Ld0(p3,p1,p24)*S13**(-1)*S234 * ( 16*s12 + 16*s14
     +     + 8*s34 )

      LB34 = LB34 + Ld0(p3,p1,p24)*S24**(-1)*S34**(-1)*S234 * (  - 16*
     +    s12*s13 - 16*s12*s23 - 8*s13*s23 + 8*s14**2 - 8*s14*s23 + 8*
     +    s23**2 )

      LB34 = LB34 + Ld0(p3,p1,p24)*S24**(-1)*S34**(-1) * (  - 16*s12**2
     +    *s13 - 16*s12**2*s14 - 16*s12*s13*s14 - 16*s12*s14**2 - 8*s13
     +    *s14**2 - 8*s14**3 )

      LB34 = LB34 + Ld0(p3,p1,p24)*S24**(-1)*S234 * (  - 16*s12 - 8*s13
     +     + 8*s14 + 8*s23 )

      LB34 = LB34 + Ld0(p3,p1,p24)*S24**(-1) * (  - 16*s12**2 - 16*s12*
     +    s14 - 8*s14**2 )

      LB34 = LB34 + Ld0(p3,p1,p24)*S34**(-1)*S234 * (  - 16*s12 + 8*s13
     +     - 16*s23 )

      LB34 = LB34 + Ld0(p3,p4,p12)*S13**(-1)*S24**(-1)*S34**(-1) * ( 
     +     - 16*s12*s14**3 + 16*s14**4 - 16*s14**3*s23 )

      LB34 = LB34 + Ld0(p3,p4,p12)*S13**(-1)*S24**(-1) * ( 48*s12*
     +    s14**2 - 16*s14**3 )

      LB34 = LB34 + Ld0(p3,p4,p12)*S24**(-1)*S34**(-1) * (  - 48*s12*
     +    s14**2 - 8*s13**3 - 16*s13**2*s14 - 64*s13*s14**2 - 16*s14**3
     +     )

      LB34 = LB34 + Ld0(p3,p4,p12)*S24**(-1) * (  - 8*s12*s13 - 8*s12*
     +    s23 - 8*s12*s34 - 32*s13**2 - 32*s13*s14 + 8*s13*s23 - 24*s13
     +    *s34 - 56*s14**2 + 8*s14*s23 + 8*s23*s34 )

      LB34 = LB34 + Ld0(p3,p4,p12)*S34**(-1) * ( 8*s12**2 - 8*s12*s14
     +     + 8*s14**2 )

      LB34 = LB34 + Ld0(p3,p4,p12) * (  - 8*s12 + 8*s13 + 8*s14 + 8*s34
     +     )

      LB34 = LB34 + Ld0(p3,p12,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 16
     +    *s12**2*s14*s23 + 16*s12*s14*s23**2 + 32*s14*s23**3 )

      LB34 = LB34 + Ld0(p3,p12,p4)*S13**(-1)*S24**(-1) * ( 16*s12**2*
     +    s14 + 16*s12**2*s23 + 16*s12**2*s34 + 16*s12*s14**2 + 32*s12*
     +    s14*s23 + 16*s12*s14*s34 + 16*s12*s23**2 + 16*s12*s23*s34 + 
     +    16*s14**3 + 32*s14**2*s23 + 16*s14**2*s34 + 32*s14*s23**2 + 
     +    16*s23**3 + 16*s23**2*s34 )

      LB34 = LB34 + Ld0(p3,p12,p4)*S13**(-1)*S34**(-1) * ( 16*s12**2*
     +    s14 + 16*s12*s14**2 + 16*s12*s14*s23 + 16*s14**3 + 16*s14**2*
     +    s23 + 32*s14*s23**2 )

      LB34 = LB34 + Ld0(p3,p12,p4)*S13**(-1) * ( 16*s12**2 + 16*s12*s14
     +     + 16*s12*s23 + 16*s14**2 + 16*s23**2 )

      LB34 = LB34 + Ld0(p3,p12,p4)*S24**(-1)*S34**(-1) * ( 16*s12**2*
     +    s23 + 16*s12*s13*s14 + 112*s12*s14**2 + 96*s12*s14*s23 + 16*
     +    s12*s23**2 + 16*s13**2*s14 - 32*s13*s14**2 + 48*s13*s14*s23
     +     + 32*s14**3 + 64*s14**2*s23 + 48*s14*s23**2 + 16*s23**3 )

      LB34 = LB34 + Ld0(p3,p12,p4)*S24**(-1)*S34**(-2) * ( 48*s12*s13*
     +    s14*s23 - 48*s12*s14**3 + 16*s13**2*s14**2 + 16*s13**2*s14*
     +    s23 + 32*s13*s14**2*s23 + 32*s13*s14*s23**2 + 16*s14**2*
     +    s23**2 + 16*s14*s23**3 )

      LB34 = LB34 + Ld0(p3,p12,p4)*S24**(-1) * ( 16*s12**2 + 16*s12*s14
     +     + 16*s12*s23 + 16*s13*s14 + 16*s14**2 + 32*s14*s23 + 16*
     +    s23**2 )

      LB34 = LB34 + Ld0(p3,p12,p4)*S34**(-1) * ( 16*s12**2 - 96*s12*s13
     +     + 112*s12*s14 - 16*s12*s23 - 32*s12*s24 - 16*s13**2 - 80*s13
     +    *s14 - 32*s13*s23 - 32*s13*s24 + 64*s14**2 + 32*s14*s23 - 16*
     +    s14*s24 - 16*s23*s24 )

      LB34 = LB34 + Ld0(p3,p12,p4)*S34**(-2) * (  - 48*s12*s13**2 - 32*
     +    s12*s13*s23 - 80*s12*s13*s24 + 16*s12*s14*s23 + 16*s12*s14*
     +    s24 - 16*s13**2*s14 - 16*s13**2*s23 - 16*s13*s14**2 - 16*s13*
     +    s14*s23 - 64*s13*s14*s24 - 16*s13*s23**2 - 32*s13*s23*s24 - 
     +    16*s13*s24**2 + 16*s14**3 + 48*s14**2*s23 + 16*s14**2*s24 + 
     +    32*s14*s23**2 + 16*s14*s23*s24 )

      LB34 = LB34 + Ld0(p3,p12,p4) * (  - 32*s12 - 16*s13 - 16*s14 - 16
     +    *s23 )

      LB34 = LB34 + Ld0(p4,p2,p13)*S13**(-1)*S24**(-1)*S34**(-1)*S134
     +  * ( 16*s12**3 + 32*s12**2*s23 + 16*s12*s14**2 - 16*s12*s14*s23
     +     + 32*s12*s23**2 + 8*s14**2*s23 + 8*s23**3 )

      LB34 = LB34 + Ld0(p4,p2,p13)*S13**(-1)*S24**(-1)*S134 * ( 32*
     +    s12**2 + 16*s12*s14 + 48*s12*s23 + 16*s12*s34 + 8*s14**2 + 16
     +    *s14*s23 + 16*s14*s34 + 24*s23**2 + 24*s23*s34 + 8*s34**2 )

      LB34 = LB34 + Ld0(p4,p2,p13)*S13**(-1)*S34**(-1)*S134 * (  - 16*
     +    s12*s14 - 16*s12*s24 + 8*s14**2 - 8*s14*s23 - 8*s14*s24 + 8*
     +    s23**2 )

      LB34 = LB34 + Ld0(p4,p2,p13)*S13**(-1)*S34**(-1) * (  - 16*s12**2
     +    *s23 - 16*s12**2*s24 - 16*s12*s23**2 - 16*s12*s23*s24 - 8*
     +    s23**3 - 8*s23**2*s24 )

      LB34 = LB34 + Ld0(p4,p2,p13)*S13**(-1)*S134 * (  - 16*s12 + 8*s14
     +     + 8*s23 - 8*s24 )

      LB34 = LB34 + Ld0(p4,p2,p13)*S13**(-1) * (  - 16*s12**2 - 16*s12*
     +    s23 - 8*s23**2 )

      LB34 = LB34 + Ld0(p4,p2,p13)*S24**(-1)*S34**(-1)*S134 * (  - 16*
     +    s12*s14 + 16*s12*s23 + 8*s14**2 + 8*s23**2 )

      LB34 = LB34 + Ld0(p4,p2,p13)*S24**(-1)*S134 * ( 16*s12 + 16*s23
     +     + 8*s34 )

      LB34 = LB34 + Ld0(p4,p2,p13)*S34**(-1)*S134 * (  - 16*s12 - 16*
     +    s14 + 8*s24 )

      LB34 = LB34 + Ld0(p4,p3,p12)*S13**(-1)*S24**(-1) * ( 32*s12**3 - 
     +    128*s12**2*s14 + 64*s12**2*s23 + 168*s12**2*s34 + 72*s12*
     +    s14**2 - 104*s12*s14*s23 - 80*s12*s14*s34 + 48*s12*s23**2 + 
     +    64*s12*s23*s34 - 8*s14**3 + 24*s14**2*s23 + 8*s14**2*s34 - 16
     +    *s14*s23**2 + 16*s23**3 + 16*s23**2*s34 )

      LB34 = LB34 + Ld0(p4,p3,p12)*S13**(-1)*S34**(-1) * ( 16*s12**2*
     +    s14 + 32*s12*s14*s23 + 16*s12*s14*s24 + 16*s14*s23**2 + 16*
     +    s14*s23*s24 + 8*s14*s24**2 )

      LB34 = LB34 + Ld0(p4,p3,p12)*S13**(-1) * ( 64*s12**2 - 32*s12*s14
     +     + 32*s12*s23 - 8*s12*s24 - 8*s12*s34 + 8*s14**2 + 8*s14*s23
     +     + 8*s14*s24 + 8*s23**2 - 16*s23*s24 - 8*s23*s34 - 8*s24**2
     +     - 8*s24*s34 )

      LB34 = LB34 + Ld0(p4,p3,p12)*S24**(-1)*S34**(-1) * ( 48*s12**2*
     +    s13 + 16*s12**2*s23 + 48*s12*s13**2 + 64*s12*s13*s23 + 96*s12
     +    *s14**2 - 32*s12*s14*s23 + 16*s12*s23**2 + 32*s13**3 - 16*
     +    s13**2*s14 + 32*s13**2*s23 + 48*s13*s14**2 - 48*s13*s14*s23
     +     + 24*s13*s23**2 + 48*s14**2*s23 - 16*s14*s23**2 + 8*s23**3 )

      LB34 = LB34 + Ld0(p4,p3,p12)*S24**(-1) * ( 48*s12**2 + 8*s12*s13
     +     - 224*s12*s14 + 88*s12*s23 - 104*s12*s34 + 56*s13**2 + 56*
     +    s13*s14 + 40*s13*s23 + 24*s13*s34 + 24*s14**2 - 80*s14*s23 - 
     +    8*s14*s34 + 40*s23**2 + 8*s23*s34 )

      LB34 = LB34 + Ld0(p4,p3,p12)*S34**(-1) * ( 8*s12**2 + 32*s12*s13
     +     - 64*s12*s14 + 8*s12*s23 - 32*s12*s24 + 32*s13**2 + 64*s13*
     +    s14 + 16*s13*s23 + 16*s13*s24 - 16*s14*s23 - 16*s14*s24 + 8*
     +    s23**2 - 16*s23*s24 - 16*s24**2 )

      LB34 = LB34 + Ld0(p4,p3,p12) * (  - 96*s12 + 40*s13 - 16*s14 - 8*
     +    s23 - 24*s24 - 8*s34 )

      LB34c=-LB34/s134/s234
      
      return
      end

      function LB34d(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LB34=0d0

      LB34 = LB34 + Ld1(p1,p2,p4)*S13**(-1)*S24**(-1) * ( 24*s12**2*s23
     +    *s34 + 24*s12**2*s34**2 )

      LB34 = LB34 + Ld1(p1,p2,p4)*S13**(-1) * ( 24*s12**2*s34 )

      LB34 = LB34 + Ld1(p1,p2,p4)*S24**(-1) * ( 16*s12**2*s13 + 16*
     +    s12**2*s23 + 24*s12**2*s34 + 8*s12*s13**2 + 8*s12*s13*s23 + 
     +    16*s12*s13*s34 + 8*s12*s23*s34 + 8*s12*s34**2 )

      LB34 = LB34 + Ld1(p1,p2,p4)*S34**(-1) * (  - 16*s12*s13**2 - 16*
     +    s12*s13*s23 - 16*s12*s13*s24 - 8*s13**3 + 8*s13**2*s23 - 8*
     +    s13**2*s24 - 16*s13*s23**2 - 8*s13*s23*s24 + 8*s13*s24**2 )

      LB34 = LB34 + Ld1(p1,p2,p4) * ( 16*s12**2 - 24*s12*s13 - 32*s12*
     +    s23 - 32*s12*s24 - 24*s12*s34 - 16*s13**2 - 8*s13*s23 - 8*s13
     +    *s34 - 16*s23**2 - 16*s23*s24 - 16*s23*s34 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S13**(-1)*S24**(-1)*S34**(-1)*S134
     +  * ( 16*s12**2*s14*s23 + 16*s12*s14**2*s23 + 16*s12*s14*s23**2
     +     + 8*s14**3*s23 + 16*s14**2*s23**2 + 8*s14*s23**3 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * (  - 16*
     +    s12**3 - 16*s12**2*s14 - 16*s12**2*s23 - 16*s12**2*s34 - 8*
     +    s12*s14**2 - 16*s12*s14*s34 - 8*s12*s23**2 - 16*s12*s23*s34
     +     - 8*s12*s34**2 + 16*s14**2*s23 + 16*s14*s23**2 + 8*s14*s23*
     +    s34 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S13**(-1)*S34**(-1)*S134 * ( 32*
     +    s12**2*s14 + 48*s12*s14*s23 + 32*s12*s14*s24 - 48*s14**2*s23
     +     - 32*s14**2*s24 - 80*s14*s23**2 - 64*s14*s23*s24 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S13**(-1)*S34**(-1) * (  - 32*s12**2
     +    *s14**2 - 96*s12*s14**2*s23 - 64*s12*s14**2*s24 + 32*s14**3*
     +    s23 + 32*s14**3*s24 + 64*s14**2*s23**2 + 64*s14**2*s23*s24 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S13**(-1)*S34**(-2)*S134 * ( 32*s12*
     +    s14**2*s23 + 32*s12*s14**2*s24 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S13**(-1)*S34**(-2) * (  - 32*s12*
     +    s14**3*s23 - 32*s12*s14**3*s24 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S13**(-1)*S134 * ( 16*s12**2 - 16*
     +    s12*s14 + 32*s12*s23 + 24*s12*s24 - 16*s12*s34 - 96*s14*s23
     +     - 40*s14*s24 - 48*s23**2 - 32*s23*s24 - 48*s23*s34 - 16*s24*
     +    s34 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S13**(-1) * (  - 32*s12**2*s14 - 24*
     +    s12**2*s34 + 32*s12*s14**2 - 56*s12*s14*s23 - 56*s12*s14*s24
     +     + 40*s12*s14*s34 - 32*s12*s23*s34 - 24*s12*s24*s34 + 16*s12*
     +    s34**2 + 136*s14**2*s23 + 72*s14**2*s24 + 128*s14*s23**2 + 96
     +    *s14*s23*s24 + 144*s14*s23*s34 + 56*s14*s24*s34 + 48*s23**2*
     +    s34 + 32*s23*s24*s34 + 48*s23*s34**2 + 16*s24*s34**2 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S24**(-1)*S34**(-1)*S134 * ( 32*
     +    s12**2*s23 + 32*s12*s14*s23 + 64*s12*s23**2 + 16*s13**2*s23
     +     + 24*s13*s14*s23 + 24*s14**2*s23 + 64*s14*s23**2 + 48*s23**3
     +     )

      LB34 = LB34 + Ld1(p1,p2,p34)*S24**(-1)*S234**(-1)*S134 * ( 8*
     +    s12**2*s34 + 24*s12*s13*s34 + 16*s12*s14*s34 + 16*s13**2*s34
     +     + 24*s13*s14*s34 + 8*s14**2*s34 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S24**(-1)*S134 * (  - 24*s12*s13 - 
     +    16*s12*s14 + 64*s12*s23 - 16*s13**2 - 24*s13*s14 - 8*s14**2
     +     + 64*s14*s23 + 96*s23**2 + 48*s23*s34 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S34**(-1)*S234**(-1)*S134 * (  - 32*
     +    s12**2*s24 - 128*s12*s13*s24 - 96*s12*s14*s24 - 96*s13**2*s24
     +     - 160*s13*s14*s24 - 64*s14**2*s24 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S34**(-1)*S134 * ( 16*s12**2 + 64*
     +    s12*s13 + 80*s12*s14 + 80*s12*s23 - 16*s12*s24 + 72*s13**2 + 
     +    104*s13*s14 - 96*s13*s23 - 16*s13*s24 + 40*s14**2 + 64*s14*
     +    s23 + 16*s14*s24 + 88*s23**2 + 32*s23*s24 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S34**(-2)*S234**(-1)*S134 * (  - 32*
     +    s12*s13*s24**2 - 32*s12*s14*s24**2 - 32*s13**2*s24**2 - 64*
     +    s13*s14*s24**2 - 32*s14**2*s24**2 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S34**(-2)*S134 * ( 64*s12*s13*s24 - 
     +    64*s12*s14*s23 + 64*s13**2*s24 - 64*s13*s14*s23 + 64*s13*s14*
     +    s24 - 192*s13*s23**2 - 128*s13*s23*s24 - 32*s14**2*s23 + 32*
     +    s14**2*s24 - 64*s14*s23**2 )

      LB34 = LB34 + Ld1(p1,p2,p34)*S234**(-1)*S134 * (  - 32*s12**2 - 
     +    88*s12*s13 - 56*s12*s14 - 56*s13**2 - 80*s13*s14 - 24*s14**2
     +     )

      LB34 = LB34 + Ld1(p1,p2,p34)*S134 * ( 32*s12 + 16*s14 + 96*s23 + 
     +    16*s24 + 8*s34 )

      LB34 = LB34 + Ld1(p1,p3,p4)*S13**(-1)*S24**(-1)*S134**(-1) * ( 
     +     - 16*s12**3*s34**2 - 24*s12**2*s23*s34**2 - 32*s12**2*s34**3
     +     - 8*s12*s23**2*s34**2 - 16*s12*s23*s34**3 - 8*s12*s34**4 )

      LB34 = LB34 + Ld1(p1,p3,p4)*S13**(-1)*S24**(-1) * ( 16*s12**3*s34
     +     + 24*s12**2*s23*s34 + 32*s12**2*s34**2 + 8*s12*s23**2*s34 + 
     +    16*s12*s23*s34**2 + 8*s12*s34**3 )

      LB34 = LB34 + Ld1(p1,p3,p4)*S13**(-1)*S134**(-1) * (  - 16*s12**2
     +    *s34**2 - 16*s12*s23*s34**2 - 8*s12*s24*s34**2 - 16*s12*
     +    s34**3 )

      LB34 = LB34 + Ld1(p1,p3,p4)*S13**(-1) * ( 16*s12**2*s34 + 16*s12*
     +    s23*s34 + 8*s12*s24*s34 + 16*s12*s34**2 )

      LB34 = LB34 + Ld1(p1,p3,p4)*S24**(-1)*S134**(-1) * (  - 24*s12**3
     +    *s34 - 16*s12**2*s13*s34 - 32*s12**2*s23*s34 - 48*s12**2*
     +    s34**2 - 8*s12*s23**2*s34 - 16*s12*s23*s34**2 - 8*s12*s34**3
     +     )

      LB34 = LB34 + Ld1(p1,p3,p4)*S24**(-1) * ( 16*s12**3 + 24*s12**2*
     +    s23 + 32*s12**2*s34 + 8*s12*s23**2 + 16*s12*s23*s34 + 8*s12*
     +    s34**2 )

      LB34 = LB34 + Ld1(p1,p3,p4)*S34**(-1)*S134**(-1) * ( 16*s12*
     +    s13**2*s23 + 8*s12*s13**2*s24 - 8*s13**3*s24 - 2*s13**2*
     +    s23**2 - 24*s13**2*s23*s24 - 24*s13**2*s24**2 )

      LB34 = LB34 + Ld1(p1,p3,p4)*S34**(-1) * (  - 16*s12**2*s13 - 24*
     +    s12*s13*s23 - 24*s12*s13*s24 + 8*s13**2*s24 - 8*s13*s23**2 - 
     +    8*s13*s23*s24 - 8*s13*s24**2 )

      LB34 = LB34 + Ld1(p1,p3,p4)*S34**(-2)*S134**(-1) * (  - 16*s13**3
     +    *s23*s24 - 8*s13**3*s24**2 )

      LB34 = LB34 + Ld1(p1,p3,p4)*S34**(-2) * ( 16*s13**2*s23*s24 + 8*
     +    s13**2*s24**2 )

      LB34 = LB34 + Ld1(p1,p3,p4)*S134**(-1) * ( 24*s12**2*s13 - 16*
     +    s12**2*s34 + 16*s12*s13**2 + 16*s12*s13*s23 + 80*s12*s13*s24
     +     + 72*s12*s13*s34 - 4*s12*s23*s34 + 40*s12*s24*s34 + 40*s12*
     +    s34**2 - 24*s13**2*s24 + 6*s13*s23**2 + 8*s13*s23*s24 + 16*
     +    s13*s23*s34 - 8*s13*s24**2 + 8*s13*s34**2 + 8*s23**2*s34 + 16
     +    *s23*s24*s34 + 16*s23*s34**2 + 8*s24**2*s34 + 16*s24*s34**2
     +     + 8*s34**3 )

      LB34 = LB34 + Ld1(p1,p3,p4) * (  - 8*s12**2 - 32*s12*s13 - 8*s12*
     +    s24 - 8*s12*s34 - 16*s13*s23 - 16*s13*s24 - 8*s13*s34 - 8*
     +    s23**2 - 16*s23*s24 - 16*s23*s34 - 8*s24**2 - 16*s24*s34 - 8*
     +    s34**2 )

      LB34 = LB34 + Ld1(p1,p24,p3)*S13**(-1)*S24**(-1) * ( 16*s12**3*
     +    s34 - 16*s12**2*s14*s23 + 16*s12**2*s14*s34 + 16*s12**2*s23*
     +    s34 + 16*s12**2*s34**2 - 16*s12*s14**2*s23 - 16*s12*s14*
     +    s23**2 - 16*s12*s14*s23*s34 )

      LB34 = LB34 + Ld1(p1,p24,p3)*S13**(-1) * (  - 16*s12**2*s14 + 24*
     +    s12**2*s24 + 8*s12**2*s34 - 16*s12*s14**2 - 24*s12*s14*s23 - 
     +    8*s12*s14*s24 + 8*s12*s23**2 + 8*s12*s23*s24 + 16*s12*s23*s34
     +     + 24*s12*s24*s34 - 16*s14**2*s23 - 16*s14**2*s24 - 24*s14*
     +    s23**2 - 24*s14*s23*s24 - 16*s14*s23*s34 + 8*s14*s24*s34 )

      LB34 = LB34 + Ld1(p2,p1,p3)*S13**(-1)*S24**(-1) * ( 24*s12**2*s14
     +    *s34 + 24*s12**2*s34**2 )

      LB34 = LB34 + Ld1(p2,p1,p3)*S13**(-1) * ( 16*s12**2*s14 + 16*
     +    s12**2*s24 + 32*s12**2*s34 + 8*s12*s14*s24 + 8*s12*s14*s34 + 
     +    8*s12*s24**2 + 16*s12*s24*s34 + 8*s12*s34**2 )

      LB34 = LB34 + Ld1(p2,p1,p3)*S24**(-1) * ( 24*s12**2*s34 )

      LB34 = LB34 + Ld1(p2,p1,p3)*S34**(-1) * (  - 16*s12*s13*s24 - 16*
     +    s12*s14*s24 - 16*s12*s24**2 + 8*s13**2*s24 - 8*s13*s14*s24 - 
     +    16*s13*s24**2 - 16*s14**2*s24 + 8*s14*s24**2 - 8*s24**3 )

      LB34 = LB34 + Ld1(p2,p1,p3) * ( 16*s12**2 - 32*s12*s13 - 32*s12*
     +    s14 - 24*s12*s24 - 24*s12*s34 - 16*s13*s14 - 16*s14**2 - 8*
     +    s14*s24 - 16*s14*s34 - 16*s24**2 - 8*s24*s34 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S13**(-1)*S24**(-1)*S34**(-1)*S234
     +  * (  - 16*s12**2*s14*s23 + 16*s12*s14**2*s23 - 16*s12*s14*
     +    s23**2 + 16*s14**2*s23**2 - 8*s14*s23**3 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * ( 16*
     +    s12**3 - 16*s12**2*s14 + 16*s12**2*s23 - 16*s12**2*s34 + 8*
     +    s12*s23**2 - 16*s12*s23*s34 + 16*s14*s23**2 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S13**(-1)*S34**(-1)*S234*S134**(-1)
     +  * ( 32*s12**2*s14**2 + 128*s12*s14**2*s23 + 96*s12*s14**2*s24
     +     + 96*s14**2*s23**2 + 160*s14**2*s23*s24 + 64*s14**2*s24**2 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S13**(-1)*S34**(-1)*S234 * (  - 32*
     +    s12**2*s14 - 96*s12*s14*s23 - 64*s12*s14*s24 - 72*s14*s23**2
     +     - 104*s14*s23*s24 - 32*s14*s24**2 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S13**(-1)*S34**(-2)*S234*S134**(-1)
     +  * ( 32*s12*s14**3*s23 + 32*s12*s14**3*s24 + 32*s14**3*s23**2 + 
     +    64*s14**3*s23*s24 + 32*s14**3*s24**2 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S13**(-1)*S34**(-2)*S234 * (  - 32*
     +    s12*s14**2*s23 - 32*s12*s14**2*s24 - 32*s14**2*s23**2 - 64*
     +    s14**2*s23*s24 - 32*s14**2*s24**2 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S13**(-1)*S234*S134**(-1) * ( 32*
     +    s12**2*s14 - 8*s12**2*s34 + 88*s12*s14*s23 + 56*s12*s14*s24
     +     - 24*s12*s23*s34 - 16*s12*s24*s34 + 56*s14*s23**2 + 80*s14*
     +    s23*s24 + 24*s14*s24**2 - 16*s23**2*s34 - 24*s23*s24*s34 - 8*
     +    s24**2*s34 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S13**(-1)*S234 * ( 24*s12*s23 + 16*
     +    s12*s24 + 16*s23**2 + 24*s23*s24 + 8*s24**2 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S24**(-1)*S34**(-1)*S234 * (  - 32*
     +    s12**2*s23 + 128*s12*s13*s23 + 112*s12*s14*s23 - 32*s12*
     +    s23**2 - 144*s13**2*s23 - 152*s13*s14*s23 + 128*s13*s23**2 - 
     +    32*s14**2*s23 + 112*s14*s23**2 - 16*s23**3 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S24**(-1)*S234 * (  - 48*s12**2 - 8*
     +    s12*s13 - 8*s12*s14 + 16*s12*s23 + 40*s12*s34 + 48*s13**2 + 
     +    32*s13*s14 - 160*s13*s23 + 64*s13*s34 - 72*s14*s23 + 24*s14*
     +    s34 + 64*s23**2 - 16*s23*s34 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S24**(-1) * ( 24*s12**2*s34 + 32*s12
     +    *s13*s34 + 24*s12*s14*s34 - 24*s12*s34**2 - 48*s13**2*s34 - 
     +    32*s13*s14*s34 - 64*s13*s34**2 - 24*s14*s34**2 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S34**(-1)*S234 * (  - 16*s12**2 + 48
     +    *s12*s13 - 16*s12*s14 - 16*s12*s23 + 32*s12*s24 + 56*s13**2
     +     + 48*s13*s14 - 176*s13*s23 - 16*s13*s24 - 64*s14*s23 + 32*
     +    s14*s24 - 24*s23**2 - 24*s23*s24 - 8*s24**2 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S34**(-1) * ( 32*s12**2*s24 + 96*s12
     +    *s13*s24 + 64*s12*s14*s24 - 64*s13**2*s24 - 64*s13*s14*s24 - 
     +    32*s13*s24**2 - 32*s14*s24**2 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S34**(-2)*S234 * (  - 64*s12*s13*s24
     +     + 64*s12*s14*s23 - 192*s13**2*s23 - 64*s13**2*s24 - 128*s13*
     +    s14*s23 - 64*s13*s23*s24 - 32*s13*s24**2 + 64*s14*s23**2 + 64
     +    *s14*s23*s24 + 32*s14*s24**2 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S34**(-2) * ( 32*s12*s13*s24**2 + 32
     +    *s12*s14*s24**2 )

      LB34 = LB34 + Ld1(p2,p1,p34)*S234 * ( 96*s12 + 104*s13 + 56*s14
     +     + 16*s23 )

      LB34 = LB34 + Ld1(p2,p1,p34) * ( 32*s12**2 + 56*s12*s13 + 56*s12*
     +    s14 - 32*s12*s24 - 56*s12*s34 - 128*s13**2 - 96*s13*s14 - 152
     +    *s13*s24 - 184*s13*s34 - 88*s14*s24 - 80*s14*s34 )

      LB34 = LB34 + Ld1(p2,p4,p3)*S13**(-1)*S24**(-1)*S234**(-1) * ( 
     +     - 8*s12**3*s34**2 - 24*s12**2*s14*s34**2 - 16*s12**2*s34**3
     +     - 16*s12*s14**2*s34**2 - 16*s12*s14*s34**3 )

      LB34 = LB34 + Ld1(p2,p4,p3)*S13**(-1)*S24**(-1) * ( 16*s12**3*s34
     +     + 32*s12**2*s14*s34 + 16*s12*s14**2*s34 + 16*s12*s14*s34**2
     +     )

      LB34 = LB34 + Ld1(p2,p4,p3)*S13**(-1)*S234**(-1) * (  - 8*s12**3*
     +    s34 - 8*s12**2*s14*s24 - 32*s12**2*s14*s34 + 16*s12**2*s24*
     +    s34 - 14*s12*s14**2*s24 - 30*s12*s14**2*s34 - 16*s12*s14*
     +    s34**2 + 8*s12*s24*s34**2 + 8*s12*s34**3 )

      LB34 = LB34 + Ld1(p2,p4,p3)*S13**(-1) * ( 16*s12**3 + 32*s12**2*
     +    s14 + 16*s12*s14**2 + 16*s12*s14*s34 )

      LB34 = LB34 + Ld1(p2,p4,p3)*S24**(-1)*S234**(-1) * (  - 16*s12**2
     +    *s34**2 - 8*s12*s13*s34**2 - 24*s12*s14*s34**2 - 8*s12*s34**3
     +     )

      LB34 = LB34 + Ld1(p2,p4,p3)*S24**(-1) * ( 8*s12*s13*s34 + 24*s12*
     +    s14*s34 + 8*s12*s34**2 )

      LB34 = LB34 + Ld1(p2,p4,p3)*S34**(-1)*S234**(-1) * (  - 8*s12*s14
     +    *s24**2 + 16*s13**2*s24**2 + 48*s13*s14*s24**2 - 16*s14**2*
     +    s24**2 )

      LB34 = LB34 + Ld1(p2,p4,p3)*S34**(-1) * (  - 16*s12**2*s24 - 16*
     +    s12*s13*s24 - 24*s13**2*s24 - 24*s13*s14*s24 )

      LB34 = LB34 + Ld1(p2,p4,p3)*S234**(-1) * ( 24*s12**2*s24 - 16*
     +    s12**2*s34 + 48*s12*s13*s24 + 16*s12*s13*s34 + 8*s12*s14*s24
     +     - 20*s12*s14*s34 - 16*s12*s24**2 + 16*s12*s24*s34 + 24*s12*
     +    s34**2 + 32*s13**2*s24 + 8*s13**2*s34 + 40*s13*s14*s24 + 8*
     +    s13*s14*s34 + 16*s13*s24**2 + 24*s13*s24*s34 + 8*s13*s34**2
     +     - 16*s14**2*s24 - 16*s14*s24**2 - 16*s14*s24*s34 - 8*s24**2*
     +    s34 - 8*s24*s34**2 )

      LB34 = LB34 + Ld1(p2,p4,p3) * (  - 16*s12**2 + 16*s12*s13 + 32*
     +    s12*s14 + 16*s12*s34 - 8*s13**2 - 8*s13*s14 - 24*s13*s24 - 8*
     +    s13*s34 )

      LB34 = LB34 + Ld1(p2,p13,p4)*S13**(-1)*S24**(-1) * ( 16*s12**3*
     +    s34 - 16*s12**2*s14*s23 + 16*s12**2*s14*s34 + 16*s12**2*s23*
     +    s34 + 16*s12**2*s34**2 - 16*s12*s14**2*s23 - 16*s12*s14*
     +    s23**2 - 16*s12*s14*s23*s34 )

      LB34 = LB34 + Ld1(p2,p13,p4)*S24**(-1) * ( 24*s12**2*s13 - 16*
     +    s12**2*s23 + 8*s12**2*s34 + 8*s12*s13*s14 - 8*s12*s13*s23 + 
     +    24*s12*s13*s34 + 8*s12*s14**2 - 24*s12*s14*s23 + 16*s12*s14*
     +    s34 - 16*s12*s23**2 - 24*s13*s14*s23 - 16*s13*s23**2 + 8*s13*
     +    s23*s34 - 24*s14**2*s23 - 16*s14*s23**2 - 16*s14*s23*s34 )

      LB34 = LB34 + Ld1(p3,p1,p24)*S13**(-1)*S24**(-1)*S34**(-1)*S234*
     + S124**(-1) * (  - 32*s12**4*s23 - 104*s12**3*s14*s23 + 64*s12**3
     +    *s23**2 - 120*s12**2*s14**2*s23 + 144*s12**2*s14*s23**2 - 16*
     +    s12**2*s23**3 - 56*s12*s14**3*s23 + 96*s12*s14**2*s23**2 - 24
     +    *s12*s14*s23**3 - 8*s14**4*s23 + 16*s14**3*s23**2 - 8*s14**2*
     +    s23**3 )

      LB34 = LB34 + Ld1(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*S124**(-1)
     +  * (  - 8*s12**4 - 24*s12**3*s14 + 32*s12**3*s23 - 24*s12**2*
     +    s14**2 + 64*s12**2*s14*s23 - 8*s12**2*s23**2 + 16*s12**2*s23*
     +    s34 + 8*s12**2*s34**2 - 8*s12*s14**3 + 32*s12*s14**2*s23 - 8*
     +    s12*s14*s23**2 + 24*s12*s14*s23*s34 + 8*s12*s14*s34**2 + 8*
     +    s14**2*s23*s34 )

      LB34 = LB34 + Ld1(p3,p1,p24)*S13**(-1)*S34**(-1)*S234*S124**(-1)
     +  * (  - 48*s12**3*s23 - 96*s12**2*s14*s23 + 96*s12**2*s23**2 - 
     +    48*s12**2*s23*s24 - 40*s12*s14**2*s23 + 96*s12*s14*s23**2 - 
     +    24*s12*s14*s23*s24 + 16*s14**2*s23**2 )

      LB34 = LB34 + Ld1(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * (  - 8*
     +    s12**2*s14 + 64*s12**2*s23 - 8*s12**2*s24 + 8*s12**2*s34 + 40
     +    *s12*s14*s23 )

      LB34 = LB34 + Ld1(p3,p1,p24)*S24**(-1)*S34**(-1)*S234*S124**(-1)
     +  * (  - 16*s12**3*s23 - 32*s12**2*s14*s23 + 32*s12**2*s23**2 - 
     +    16*s12*s14**2*s23 + 48*s12*s14*s23**2 + 16*s14**2*s23**2 )

      LB34 = LB34 + Ld1(p3,p1,p24)*S24**(-1)*S234*S124**(-1) * ( 48*
     +    s12**2*s23 + 16*s12**2*s34 + 64*s12*s14*s23 + 16*s12*s14*s34
     +     + 16*s14**2*s23 )

      LB34 = LB34 + Ld1(p3,p1,p24)*S34**(-1)*S234*S124**(-1) * ( 8*
     +    s12**3 + 24*s12**2*s14 - 80*s12**2*s23 + 8*s12*s13*s14 - 48*
     +    s12*s13*s23 + 24*s12*s13*s24 + 32*s12*s14**2 - 120*s12*s14*
     +    s23 + 24*s12*s14*s24 + 24*s12*s23**2 - 96*s12*s23*s24 + 8*s12
     +    *s24**2 + 16*s13**2*s24 - 32*s13*s14*s23 + 16*s13*s14*s24 - 8
     +    *s13*s23*s24 + 16*s13*s24**2 + 8*s14**3 - 32*s14**2*s23 + 16*
     +    s14*s23**2 - 32*s14*s23*s24 )

      LB34 = LB34 + Ld1(p3,p1,p24)*S34**(-1)*S124**(-1) * ( 8*s12*
     +    s13**2*s24 - 16*s12*s13*s24**2 - 8*s12*s14**2*s24 - 16*s12*
     +    s14*s24**2 )

      LB34 = LB34 + Ld1(p3,p1,p24)*S234*S124**(-1) * (  - 8*s12**2 - 32
     +    *s12*s13 - 8*s12*s14 - 8*s12*s23 - 8*s12*s24 - 16*s12*s34 - 
     +    16*s13*s14 + 8*s13*s24 - 8*s14*s23 - 8*s14*s34 )

      LB34 = LB34 + Ld1(p3,p1,p24)*S124**(-1) * (  - 8*s12**2*s13 - 8*
     +    s12**2*s14 - 8*s12**2*s34 - 8*s12*s13*s14 - 8*s12*s13*s24 - 8
     +    *s12*s14**2 - 24*s12*s14*s24 - 8*s12*s14*s34 - 16*s12*s24**2
     +     - 16*s12*s24*s34 )

      LB34 = LB34 + Ld1(p3,p4,p12)*S13**(-1)*S24**(-1)*S34**(-1)*
     + S124**(-1) * ( 32*s12*s14**4*s23 - 16*s12*s14**3*s23**2 )

      LB34 = LB34 + Ld1(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1) * ( 
     +    48*s12**3*s14**2 - 48*s12**3*s14*s34 + 48*s12**2*s14**3 + 48*
     +    s12**2*s14**2*s23 + 56*s12**2*s14**2*s34 + 64*s12*s14**4 - 40
     +    *s12*s14**3*s23 + 40*s12*s14**3*s34 - 8*s12*s14**2*s23*s34 - 
     +    8*s12*s14**2*s34**2 + 32*s14**5 - 8*s14**4*s23 + 8*s14**3*
     +    s23**2 + 8*s14**3*s23*s34 )

      LB34 = LB34 + Ld1(p3,p4,p12)*S13**(-1)*S34**(-1)*S124**(-1) * ( 
     +    16*s12*s14**3*s23 )

      LB34 = LB34 + Ld1(p3,p4,p12)*S13**(-1)*S124**(-1) * (  - 16*
     +    s12**3*s14 - 16*s12**3*s24 + 64*s12**2*s14**2 - 32*s12**2*s14
     +    *s24 - 48*s12**2*s14*s34 + 80*s12*s14**3 + 24*s12*s14**2*s24
     +     + 48*s12*s14**2*s34 + 64*s14**4 + 32*s14**3*s24 )

      LB34 = LB34 + Ld1(p3,p4,p12)*S24**(-1)*S34**(-1)*S124**(-1) * ( 
     +     - 48*s12**2*s13**2*s14 - 16*s12*s13**3*s14 - 160*s12*s13**2*
     +    s14**2 - 16*s12*s13**2*s14*s23 + 32*s12*s13*s14**3 - 64*s12*
     +    s13*s14**2*s23 + 32*s12*s14**4 + 16*s12*s14**3*s23 + 8*s13**4
     +    *s14 + 16*s13**3*s14*s23 - 48*s13**2*s14**3 + 8*s13**2*s14*
     +    s23**2 )

      LB34 = LB34 + Ld1(p3,p4,p12)*S24**(-1)*S124**(-1) * (  - 16*
     +    s12**2*s13**2 + 32*s12**2*s13*s14 + 8*s12**2*s13*s34 - 176*
     +    s12**2*s14**2 + 120*s12**2*s14*s34 + 24*s12**2*s34**2 - 96*
     +    s12*s13**2*s14 - 8*s12*s13**2*s23 - 8*s12*s13**2*s34 - 224*
     +    s12*s13*s14**2 - 40*s12*s13*s14*s23 - 80*s12*s13*s14*s34 - 8*
     +    s12*s13*s23*s34 - 8*s12*s13*s34**2 - 256*s12*s14**3 - 72*s12*
     +    s14**2*s23 - 16*s12*s14*s23*s34 + 8*s12*s14*s34**2 + 24*
     +    s13**3*s14 - 32*s13**2*s14**2 + 24*s13**2*s14*s23 + 16*s13**2
     +    *s14*s34 - 112*s13*s14**3 - 16*s13*s14**2*s23 - 40*s13*s14**2
     +    *s34 + 8*s13*s14*s23**2 + 8*s13*s14*s23*s34 - 48*s14**4 + 16*
     +    s14**3*s23 - 32*s14**3*s34 - 8*s14**2*s23**2 - 8*s14**2*s23*
     +    s34 )

      LB34 = LB34 + Ld1(p3,p4,p12)*S34**(-1)*S124**(-1) * (  - 48*
     +    s12**2*s14**2 + 16*s12**2*s14*s24 + 16*s12**2*s24**2 - 96*s12
     +    *s13**2*s14 + 48*s12*s13*s14**2 + 16*s12*s13*s14*s24 + 16*s12
     +    *s13*s24**2 - 80*s12*s14**3 + 48*s12*s14**2*s23 - 96*s12*
     +    s14**2*s24 - 96*s13**2*s14**2 - 48*s13**2*s14*s24 - 16*s13*
     +    s14**3 - 32*s13*s14**2*s24 - 16*s13*s14*s24**2 - 40*s14**4 - 
     +    80*s14**3*s24 - 40*s14**2*s24**2 )

      LB34 = LB34 + Ld1(p3,p4,p12)*S124**(-1) * (  - 16*s12**2*s14 - 16
     +    *s12**2*s24 - 40*s12*s13**2 - 40*s12*s13*s14 - 16*s12*s13*s34
     +     - 280*s12*s14**2 - 16*s12*s14*s24 + 120*s12*s14*s34 + 24*s12
     +    *s34**2 + 8*s13**3 - 48*s13**2*s14 - 24*s13**2*s24 + 8*s13**2
     +    *s34 - 192*s13*s14**2 - 72*s13*s14*s24 - 56*s13*s14*s34 - 24*
     +    s13*s24*s34 - 120*s14**3 - 80*s14**2*s24 - 40*s14**2*s34 )

      LB34 = LB34 + Ld1(p4,p2,p13)*S13**(-1)*S24**(-1)*S34**(-1)*
     + S123**(-1)*S134 * (  - 32*s12**4*s14 + 64*s12**3*s14**2 - 104*
     +    s12**3*s14*s23 - 16*s12**2*s14**3 + 144*s12**2*s14**2*s23 - 
     +    120*s12**2*s14*s23**2 - 24*s12*s14**3*s23 + 96*s12*s14**2*
     +    s23**2 - 56*s12*s14*s23**3 - 8*s14**3*s23**2 + 16*s14**2*
     +    s23**3 - 8*s14*s23**4 )

      LB34 = LB34 + Ld1(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*S134
     +  * (  - 8*s12**4 + 32*s12**3*s14 - 24*s12**3*s23 - 8*s12**2*
     +    s14**2 + 64*s12**2*s14*s23 + 16*s12**2*s14*s34 - 24*s12**2*
     +    s23**2 + 8*s12**2*s34**2 - 8*s12*s14**2*s23 + 32*s12*s14*
     +    s23**2 + 24*s12*s14*s23*s34 - 8*s12*s23**3 + 8*s12*s23*s34**2
     +     + 8*s14*s23**2*s34 )

      LB34 = LB34 + Ld1(p4,p2,p13)*S13**(-1)*S34**(-1)*S123**(-1)*S134
     +  * (  - 16*s12**3*s14 + 32*s12**2*s14**2 - 32*s12**2*s14*s23 + 
     +    32*s12*s14**2*s23 - 16*s12*s14**2*s24 - 8*s12*s14*s23**2 - 8*
     +    s12*s14*s24**2 + 16*s14**2*s23**2 )

      LB34 = LB34 + Ld1(p4,p2,p13)*S13**(-1)*S34**(-1)*S123**(-1) * ( 
     +    16*s12*s14**3*s23 + 16*s12*s14**3*s24 - 8*s12*s14**2*s23**2
     +     + 8*s12*s14**2*s24**2 )

      LB34 = LB34 + Ld1(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * ( 48*
     +    s12**2*s14 - 8*s12**2*s23 - 8*s12**2*s24 + 8*s12**2*s34 - 16*
     +    s12*s14**2 + 56*s12*s14*s23 - 24*s12*s14*s24 - 16*s12*s14*s34
     +     - 8*s12*s23*s24 + 16*s12*s23*s34 - 8*s12*s24**2 - 8*s12*s24*
     +    s34 + 16*s14*s23**2 )

      LB34 = LB34 + Ld1(p4,p2,p13)*S13**(-1)*S123**(-1) * ( 8*s12**2*
     +    s14*s23 + 8*s12**2*s14*s24 + 8*s12**2*s14*s34 + 8*s12**2*s23*
     +    s34 + 8*s12**2*s24*s34 + 8*s12**2*s34**2 + 16*s12*s14**3 + 24
     +    *s12*s14**2*s23 + 40*s12*s14**2*s24 + 32*s12*s14**2*s34 - 8*
     +    s12*s14*s23**2 + 8*s12*s14*s23*s24 + 8*s12*s14*s23*s34 + 16*
     +    s12*s14*s24**2 + 32*s12*s14*s24*s34 + 16*s12*s14*s34**2 + 8*
     +    s12*s23*s24*s34 + 8*s12*s24**2*s34 + 8*s12*s24*s34**2 )

      LB34 = LB34 + Ld1(p4,p2,p13)*S24**(-1)*S34**(-1)*S123**(-1)*S134
     +  * (  - 48*s12**3*s14 - 48*s12**2*s13*s14 + 96*s12**2*s14**2 - 
     +    96*s12**2*s14*s23 - 24*s12*s13*s14*s23 + 96*s12*s14**2*s23 - 
     +    40*s12*s14*s23**2 + 16*s14**2*s23**2 )

      LB34 = LB34 + Ld1(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * (  - 8*
     +    s12**2*s13 + 64*s12**2*s14 - 8*s12**2*s23 + 8*s12**2*s34 + 40
     +    *s12*s14*s23 )

      LB34 = LB34 + Ld1(p4,p2,p13)*S34**(-1)*S123**(-1)*S134 * ( 8*
     +    s12**3 - 80*s12**2*s14 + 24*s12**2*s23 + 8*s12*s13**2 - 96*
     +    s12*s13*s14 + 8*s12*s13*s23 + 8*s12*s13*s24 + 24*s12*s14**2
     +     - 104*s12*s14*s23 - 32*s12*s14*s24 + 24*s12*s23**2 + 8*s12*
     +    s23*s24 + 8*s12*s24**2 + 16*s13**2*s24 - 32*s13*s14*s23 - 8*
     +    s13*s14*s24 + 16*s13*s23*s24 + 16*s13*s24**2 + 16*s14**2*s23
     +     - 32*s14*s23**2 - 32*s14*s23*s24 + 8*s23**3 )

      LB34 = LB34 + Ld1(p4,p2,p13)*S123**(-1)*S134 * (  - 8*s12**2 - 24
     +    *s12*s13 + 8*s12*s14 - 16*s12*s23 - 24*s12*s24 - 16*s12*s34
     +     + 8*s13*s24 - 8*s14*s23 - 16*s23*s24 - 8*s23*s34 )

      LB34 = LB34 + Ld1(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 
     +    48*s12**4*s34 + 48*s12**3*s14**2 - 48*s12**3*s14*s23 - 320*
     +    s12**3*s14*s34 + 112*s12**3*s23*s34 + 248*s12**3*s34**2 - 16*
     +    s12**2*s14**3 + 288*s12**2*s14**2*s23 + 136*s12**2*s14**2*s34
     +     - 112*s12**2*s14*s23**2 - 592*s12**2*s14*s23*s34 - 112*
     +    s12**2*s14*s34**2 + 88*s12**2*s23**2*s34 + 160*s12**2*s23*
     +    s34**2 - 104*s12*s14**3*s23 - 8*s12*s14**3*s34 + 264*s12*
     +    s14**2*s23**2 + 184*s12*s14**2*s23*s34 + 8*s12*s14**2*s34**2
     +     - 88*s12*s14*s23**3 - 232*s12*s14*s23**2*s34 - 32*s12*s14*
     +    s23*s34**2 + 24*s12*s23**3*s34 + 24*s12*s23**2*s34**2 + 8*
     +    s14**4*s23 - 40*s14**3*s23**2 - 8*s14**3*s23*s34 + 72*s14**2*
     +    s23**3 + 16*s14**2*s23**2*s34 - 24*s14*s23**4 - 24*s14*s23**3
     +    *s34 )

      LB34 = LB34 + Ld1(p4,p3,p12)*S13**(-1)*S123**(-1) * (  - 32*
     +    s12**3*s14 + 16*s12**3*s24 + 128*s12**3*s34 + 16*s12**2*
     +    s14**2 - 16*s12**2*s14*s24 - 88*s12**2*s14*s34 + 16*s12**2*
     +    s24**2 + 40*s12**2*s24*s34 + 24*s12**2*s34**2 + 8*s12*s14**2*
     +    s34 - 8*s12*s14*s24*s34 - 8*s12*s14*s34**2 + 8*s12*s24**3 + 
     +    16*s12*s24**2*s34 + 8*s12*s24*s34**2 )

      LB34 = LB34 + Ld1(p4,p3,p12)*S24**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 48*s12**2*s13**2*s14 - 144*s12**2*s13*s14*s23 - 48*s12**2*
     +    s14*s23**2 - 16*s12*s13**3*s14 + 32*s12*s13**2*s14**2 - 224*
     +    s12*s13**2*s14*s23 - 96*s12*s13*s14**3 + 64*s12*s13*s14**2*
     +    s23 - 256*s12*s13*s14*s23**2 - 96*s12*s14**3*s23 + 48*s12*
     +    s14**2*s23**2 - 64*s12*s14*s23**3 + 48*s13**3*s14**2 - 64*
     +    s13**3*s14*s23 - 48*s13**2*s14**3 + 128*s13**2*s14**2*s23 - 
     +    152*s13**2*s14*s23**2 - 96*s13*s14**3*s23 + 112*s13*s14**2*
     +    s23**2 - 112*s13*s14*s23**3 - 48*s14**3*s23**2 + 32*s14**2*
     +    s23**3 - 24*s14*s23**4 )

      LB34 = LB34 + Ld1(p4,p3,p12)*S24**(-1)*S123**(-1) * (  - 48*
     +    s12**3*s13 - 96*s12**3*s14 + 48*s12**3*s23 + 16*s12**3*s34 - 
     +    80*s12**2*s13**2 - 128*s12**2*s13*s14 - 32*s12**2*s13*s23 - 
     +    136*s12**2*s13*s34 + 560*s12**2*s14**2 - 400*s12**2*s14*s23
     +     - 824*s12**2*s14*s34 + 64*s12**2*s23**2 + 56*s12**2*s23*s34
     +     - 72*s12**2*s34**2 - 16*s12*s13**3 + 8*s12*s13**2*s14 - 48*
     +    s12*s13**2*s23 - 40*s12*s13**2*s34 + 800*s12*s13*s14**2 - 416
     +    *s12*s13*s14*s23 - 64*s12*s13*s14*s34 - 72*s12*s13*s23*s34 - 
     +    24*s12*s13*s34**2 - 104*s12*s14**3 + 1016*s12*s14**2*s23 + 
     +    184*s12*s14**2*s34 - 440*s12*s14*s23**2 - 456*s12*s14*s23*s34
     +     - 40*s12*s14*s34**2 + 24*s12*s23**3 + 24*s12*s23**2*s34 - 24
     +    *s12*s23*s34**2 - 8*s13**3*s14 + 184*s13**2*s14**2 - 128*
     +    s13**2*s14*s23 - 8*s13**2*s14*s34 - 40*s13*s14**3 + 504*s13*
     +    s14**2*s23 + 24*s13*s14**2*s34 - 240*s13*s14*s23**2 - 64*s13*
     +    s14*s23*s34 + 8*s14**4 - 80*s14**3*s23 - 8*s14**3*s34 + 384*
     +    s14**2*s23**2 + 40*s14**2*s23*s34 - 136*s14*s23**3 - 88*s14*
     +    s23**2*s34 )

      LB34 = LB34 + Ld1(p4,p3,p12)*S34**(-1)*S123**(-1) * (  - 64*
     +    s12**2*s14*s24 - 16*s12**2*s24**2 + 16*s12*s13**3 - 16*s12*
     +    s13**2*s14 + 16*s12*s13**2*s24 + 96*s12*s13*s14**2 - 48*s12*
     +    s13*s14*s23 + 128*s12*s13*s14*s24 + 32*s12*s13*s24**2 - 32*
     +    s12*s14**2*s24 - 48*s12*s14*s24**2 - 16*s12*s24**3 - 8*s14**2
     +    *s24**2 - 16*s14*s24**3 - 8*s24**4 )

      LB34 = LB34 + Ld1(p4,p3,p12)*S123**(-1) * (  - 48*s12**3 - 96*
     +    s12**2*s13 - 288*s12**2*s14 - 160*s12**2*s24 - 304*s12**2*s34
     +     + 24*s12*s13**2 + 216*s12*s13*s14 + 56*s12*s13*s24 + 48*s12*
     +    s13*s34 - 32*s12*s14**2 - 88*s12*s14*s24 - 32*s12*s14*s34 - 
     +    40*s12*s24**2 - 16*s12*s24*s34 + 8*s12*s34**2 - 8*s13**3 - 16
     +    *s13**2*s14 - 8*s13**2*s24 - 8*s13**2*s34 - 8*s13*s14**2 - 16
     +    *s13*s14*s24 - 8*s13*s14*s34 - 8*s13*s24**2 - 8*s13*s24*s34
     +     - 8*s14**2*s24 - 24*s14*s24**2 - 8*s14*s24*s34 - 16*s24**3
     +     - 8*s24**2*s34 )

      LB34 = LB34 + Ld21(p1,p2,p4)*S13**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s34**2 )

      LB34 = LB34 + Ld21(p1,p2,p4)*S24**(-1) * (  - 8*s12**2*s34 - 16*
     +    s12*s13**2 - 16*s12*s13*s14 + 16*s12*s13*s23 + 16*s12*s23*s34
     +     + 16*s12*s34**2 )

      LB34 = LB34 + Ld21(p1,p2,p4)*S34**(-1) * ( 8*s13**3 + 8*s13**2*
     +    s14 - 8*s13**2*s23 - 8*s13**2*s24 )

      LB34 = LB34 + Ld21(p1,p2,p4) * ( 16*s12*s13 + 16*s12*s34 - 8*s13*
     +    s23 - 8*s13*s24 - 8*s13*s34 )

      LB34 = LB34 + Ld21(p1,p2,p34)*S13**(-1)*S24**(-1)*S34**(-1)*S134
     +  * ( 16*s12**2*s23**2 + 16*s12*s14*s23**2 + 16*s12*s23**3 )

      LB34 = LB34 + Ld21(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * ( 32*
     +    s12**2*s23 + 16*s12**2*s34 + 32*s12*s14*s23 + 16*s12*s14*s34
     +     + 48*s12*s23**2 + 48*s12*s23*s34 + 16*s12*s34**2 )

      LB34 = LB34 + Ld21(p1,p2,p34)*S13**(-1)*S34**(-1)*S134 * ( 8*s12*
     +    s23**2 )

      LB34 = LB34 + Ld21(p1,p2,p34)*S13**(-1)*S34**(-1) * (  - 16*s12*
     +    s14*s23**2 )

      LB34 = LB34 + Ld21(p1,p2,p34)*S13**(-1)*S134 * ( 16*s12*s23 + 8*
     +    s12*s34 )

      LB34 = LB34 + Ld21(p1,p2,p34)*S13**(-1) * (  - 32*s12*s14*s23 - 
     +    16*s12*s14*s34 - 8*s12*s23**2 - 16*s12*s23*s34 - 8*s12*s34**2
     +     )

      LB34 = LB34 + Ld21(p1,p2,p34)*S24**(-1)*S34**(-1)*S134 * (  - 24*
     +    s23**3 )

      LB34 = LB34 + Ld21(p1,p2,p34)*S24**(-1)*S134 * (  - 48*s23**2 - 
     +    24*s23*s34 )

      LB34 = LB34 + Ld21(p1,p2,p34)*S34**(-1)*S134 * (  - 64*s12*s23 - 
     +    24*s23**2 )

      LB34 = LB34 + Ld21(p1,p2,p34)*S34**(-2)*S134 * (  - 32*s12*s23**2
     +     )

      LB34 = LB34 + Ld21(p1,p2,p34)*S134 * (  - 32*s12 - 24*s23 )

      LB34 = LB34 + Ld21(p1,p24,p3)*S13**(-1)*S24**(-1)*S34**(-1) * ( 8
     +    *s12**3*s23**2 )

      LB34 = LB34 + Ld21(p1,p24,p3)*S13**(-1)*S24**(-1) * ( 24*s12**3*
     +    s23 + 16*s12**3*s34 + 16*s12**2*s14*s23 + 8*s12**2*s14*s34 - 
     +    8*s12**2*s23**2 - 16*s12**2*s23*s34 - 16*s12**2*s34**2 + 8*
     +    s12*s14**2*s23 - 8*s12*s14**2*s34 - 16*s12*s14*s34**2 - 8*
     +    s14**3*s34 - 8*s14**2*s34**2 )

      LB34 = LB34 + Ld21(p1,p24,p3)*S13**(-1)*S34**(-1) * ( 8*s12**3*
     +    s23 )

      LB34 = LB34 + Ld21(p1,p24,p3)*S13**(-1) * (  - 8*s12**3 - 16*
     +    s12**2*s14 - 8*s12**2*s23 + 16*s12*s14**2 + 24*s12*s14*s34 + 
     +    16*s14**3 + 16*s14**2*s34 )

      LB34 = LB34 + Ld21(p1,p24,p3)*S24**(-1)*S34**(-1) * ( 16*s12**3*
     +    s23 - 8*s12**2*s13*s23 - 8*s12**2*s23**2 )

      LB34 = LB34 + Ld21(p1,p24,p3)*S24**(-1) * (  - 48*s12**2*s14 - 16
     +    *s12**2*s23 + 8*s12**2*s34 + 24*s12*s13*s14 - 32*s12*s14**2
     +     + 8*s12*s14*s34 + 16*s13*s14**2 - 8*s14**2*s34 )

      LB34 = LB34 + Ld21(p1,p24,p3)*S34**(-1) * ( 16*s12**3 - 40*s12**2
     +    *s13 + 16*s12**2*s14 + 8*s12**2*s23 + 8*s12**2*s24 + 16*s12*
     +    s13**2 - 8*s12*s13*s14 + 16*s12*s13*s23 - 40*s12*s13*s24 + 16
     +    *s12*s14**2 + 16*s12*s14*s24 - 8*s13*s14**2 + 24*s14**2*s24 )

      LB34 = LB34 + Ld21(p1,p24,p3) * (  - 32*s12**2 - 48*s12*s14 + 16*
     +    s12*s23 + 16*s12*s24 - 32*s14**2 )

      LB34 = LB34 + Ld21(p2,p1,p3)*S34**(-1) * (  - 8*s13*s24**2 - 8*
     +    s14*s24**2 + 8*s24**3 )

      LB34 = LB34 + Ld21(p2,p1,p3) * (  - 8*s13*s24 - 8*s14*s24 - 8*s24
     +    *s34 )

      LB34 = LB34 + Ld21(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * ( 16*
     +    s12**2*s34 - 8*s12*s14*s34 + 16*s12*s23*s34 - 8*s12*s34**2 )

      LB34 = LB34 + Ld21(p2,p1,p34)*S24**(-1)*S34**(-1)*S234 * ( 16*
     +    s12**2*s13 - 32*s12*s13**2 - 8*s12*s13*s14 + 16*s12*s13*s23
     +     + 24*s13**2*s23 + 24*s13*s14*s23 )

      LB34 = LB34 + Ld21(p2,p1,p34)*S24**(-1)*S234 * ( 32*s12**2 - 72*
     +    s12*s13 - 16*s12*s14 + 32*s12*s23 - 48*s12*s34 + 48*s13*s23
     +     + 24*s14*s23 + 24*s23*s34 )

      LB34 = LB34 + Ld21(p2,p1,p34)*S24**(-1) * ( 8*s12*s13**2 + 16*s12
     +    *s13*s34 + 8*s12*s34**2 )

      LB34 = LB34 + Ld21(p2,p1,p34)*S34**(-1)*S234 * (  - 64*s12*s13 )

      LB34 = LB34 + Ld21(p2,p1,p34)*S34**(-1) * ( 16*s12*s13**2 )

      LB34 = LB34 + Ld21(p2,p1,p34)*S34**(-2)*S234 * (  - 32*s12*s13**2
     +     )

      LB34 = LB34 + Ld21(p2,p1,p34)*S234 * (  - 32*s12 )

      LB34 = LB34 + Ld21(p2,p1,p34) * ( 32*s12*s13 + 16*s12*s34 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S13**(-1)*S24**(-1)*S34**(-1)*
     + S234**(-1) * (  - 6*s12*s14**2*s23**3 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S13**(-1)*S24**(-1)*S234**(-1) * ( 
     +     - 8*s12**3*s23**2 - 16*s12**3*s23*s34 - 8*s12**3*s34**2 - 8*
     +    s12**2*s14*s23*s34 - 8*s12**2*s14*s34**2 - 24*s12**2*s23**2*
     +    s34 - 32*s12**2*s23*s34**2 - 8*s12**2*s34**3 - 6*s12*s14**2*
     +    s23**2 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S13**(-1)*S24**(-1) * ( 16*s12**3*
     +    s23 + 16*s12**3*s34 + 8*s12**2*s14*s23 + 8*s12**2*s14*s34 + 8
     +    *s12**2*s23*s34 + 8*s12**2*s34**2 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S13**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 12*s12*s14**2*s23**2 - 6*s12*s14**2*s23*s24 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S13**(-1)*S234**(-1) * (  - 16*
     +    s12**3*s23 - 8*s12**3*s24 - 16*s12**3*s34 - 8*s12**2*s14*s34
     +     - 32*s12**2*s23*s34 - 8*s12**2*s24*s34 - 16*s12**2*s34**2 - 
     +    6*s12*s14**2*s23 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S13**(-1) * ( 16*s12**3 + 8*s12**2*
     +    s14 + 8*s12**2*s34 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S24**(-1)*S234**(-1) * (  - 24*
     +    s12**2*s23**2 - 32*s12**2*s23*s34 - 8*s12**2*s34**2 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S24**(-1) * ( 8*s12**2*s23 + 8*
     +    s12**2*s34 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S34**(-1)*S234**(-1) * ( 16*s12**2*
     +    s23**2 + 32*s12**2*s23*s24 + 16*s12**2*s24**2 + 48*s12*s13*
     +    s23**2 + 64*s12*s13*s23*s24 - 48*s12*s13*s24**2 + 36*s12*s14*
     +    s23**2 + 72*s12*s14*s23*s24 + 24*s12*s14*s24**2 - 8*s13**2*
     +    s24**2 - 32*s13*s14*s24**2 - 8*s13*s24**3 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S34**(-1) * (  - 32*s12**2*s23 - 32*
     +    s12**2*s24 - 16*s12*s13*s23 - 16*s12*s14*s23 - 16*s12*s14*s24
     +     + 8*s13**2*s24 + 8*s13*s14*s24 + 8*s13*s24**2 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S34**(-2)*S234**(-1) * (  - 8*s12*
     +    s13*s24**3 + 8*s13**2*s24**3 - 24*s13*s14*s24**3 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S34**(-2) * ( 16*s12*s13*s24**2 + 8*
     +    s13**2*s24**2 + 8*s13*s14*s24**2 )

      LB34 = LB34 + Ld21(p2,p4,p3)*S234**(-1) * ( 72*s12**2*s24 + 24*
     +    s12**2*s34 + 64*s12*s13*s23 + 16*s12*s13*s34 + 52*s12*s14*s23
     +     + 40*s12*s14*s24 + 16*s12*s14*s34 + 48*s12*s23**2 + 64*s12*
     +    s23*s24 + 64*s12*s23*s34 + 16*s12*s24**2 + 32*s12*s24*s34 + 
     +    16*s12*s34**2 - 8*s13**2*s24 - 8*s13*s14*s24 - 16*s13*s24**2
     +     - 8*s13*s24*s34 )

      LB34 = LB34 + Ld21(p2,p4,p3) * (  - 24*s12**2 - 16*s12*s13 - 16*
     +    s12*s14 - 16*s12*s23 - 16*s12*s24 - 16*s12*s34 + 8*s13*s24 )

      LB34 = LB34 + Ld21(p2,p13,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 8
     +    *s12**3*s14**2 )

      LB34 = LB34 + Ld21(p2,p13,p4)*S13**(-1)*S24**(-1) * ( 24*s12**3*
     +    s14 + 16*s12**3*s34 - 8*s12**2*s14**2 + 16*s12**2*s14*s23 - 
     +    16*s12**2*s14*s34 + 8*s12**2*s23*s34 - 16*s12**2*s34**2 + 8*
     +    s12*s14*s23**2 - 8*s12*s23**2*s34 - 16*s12*s23*s34**2 - 8*
     +    s23**3*s34 - 8*s23**2*s34**2 )

      LB34 = LB34 + Ld21(p2,p13,p4)*S13**(-1)*S34**(-1) * ( 16*s12**3*
     +    s14 - 8*s12**2*s14**2 - 8*s12**2*s14*s24 )

      LB34 = LB34 + Ld21(p2,p13,p4)*S13**(-1) * (  - 24*s12**3 - 16*
     +    s12**2*s14 - 72*s12**2*s23 - 16*s12**2*s34 - 32*s12*s23**2 + 
     +    24*s12*s23*s24 - 16*s12*s23*s34 + 16*s23**2*s24 - 8*s23**2*
     +    s34 )

      LB34 = LB34 + Ld21(p2,p13,p4)*S24**(-1)*S34**(-1) * ( 8*s12**3*
     +    s14 )

      LB34 = LB34 + Ld21(p2,p13,p4)*S24**(-1) * (  - 8*s12**3 - 8*
     +    s12**2*s14 - 16*s12**2*s23 + 16*s12*s23**2 + 24*s12*s23*s34
     +     + 16*s23**3 + 16*s23**2*s34 )

      LB34 = LB34 + Ld21(p2,p13,p4)*S34**(-1) * ( 40*s12**3 + 8*s12**2*
     +    s13 + 8*s12**2*s14 + 40*s12**2*s23 - 40*s12**2*s24 + 16*s12*
     +    s13*s23 - 40*s12*s13*s24 + 16*s12*s14*s24 + 16*s12*s23**2 - 8
     +    *s12*s23*s24 + 16*s12*s24**2 + 24*s13*s23**2 - 8*s23**2*s24 )

      LB34 = LB34 + Ld21(p2,p13,p4) * ( 16*s12**2 + 16*s12*s13 + 16*s12
     +    *s14 - 32*s23**2 )

      LB34 = LB34 + Ld21(p3,p1,p2)*S13**(-1)*S24**(-1) * (  - 8*s12*s14
     +    *s34**2 - 8*s12*s34**3 )

      LB34 = LB34 + Ld21(p3,p1,p2)*S13**(-1) * (  - 8*s12*s14*s34 + 8*
     +    s12*s23*s34 + 8*s12*s24*s34 )

      LB34 = LB34 + Ld21(p3,p1,p2)*S24**(-1) * (  - 8*s12*s34**2 )

      LB34 = LB34 + Ld21(p3,p1,p2) * (  - 8*s12*s34 + 16*s13*s24 + 16*
     +    s13*s34 + 16*s14*s24 + 16*s14*s34 - 16*s23*s24 - 16*s24**2 + 
     +    16*s34**2 )

      LB34 = LB34 + Ld21(p3,p1,p24)*S13**(-1)*S24**(-1)*S34**(-1)*S234*
     + S124**(-1) * ( 24*s12**4*s23 + 48*s12**3*s14*s23 + 24*s12**2*
     +    s14**2*s23 )

      LB34 = LB34 + Ld21(p3,p1,p24)*S13**(-1)*S34**(-1)*S234*S124**(-1)
     +  * ( 48*s12**3*s23 + 72*s12**2*s14*s23 + 24*s12**2*s23*s24 + 24*
     +    s12*s14**2*s23 + 24*s12*s14*s23*s24 )

      LB34 = LB34 + Ld21(p3,p1,p24)*S24**(-1)*S34**(-1)*S234*S124**(-1)
     +  * (  - 8*s12**4 - 8*s12**3*s13 - 16*s12**3*s14 + 16*s12**3*s23
     +     - 8*s12**2*s13*s14 - 8*s12**2*s14**2 + 16*s12**2*s14*s23 )

      LB34 = LB34 + Ld21(p3,p1,p24)*S24**(-1)*S234*S124**(-1) * ( 8*
     +    s12**3 + 8*s12**2*s14 )

      LB34 = LB34 + Ld21(p3,p1,p24)*S34**(-1)*S234*S124**(-1) * (  - 32
     +    *s12**3 - 32*s12**2*s13 - 40*s12**2*s14 + 32*s12**2*s23 - 40*
     +    s12**2*s24 - 16*s12*s13*s14 - 40*s12*s13*s24 - 16*s12*s14**2
     +     + 32*s12*s14*s23 - 32*s12*s14*s24 + 16*s12*s23*s24 - 16*s12*
     +    s24**2 - 8*s13*s14*s24 - 16*s13*s24**2 - 8*s14**2*s24 + 16*
     +    s14*s23*s24 - 8*s14*s24**2 )

      LB34 = LB34 + Ld21(p3,p1,p24)*S34**(-1)*S124**(-1) * ( 8*s12**2*
     +    s13**2 + 8*s12**2*s13*s14 + 16*s12*s13**2*s24 + 16*s12*s13*
     +    s14*s24 + 8*s13**2*s24**2 + 8*s13*s14*s24**2 )

      LB34 = LB34 + Ld21(p3,p1,p24)*S234*S124**(-1) * ( 16*s12**2 + 16*
     +    s12*s14 + 8*s12*s24 + 8*s14*s24 )

      LB34 = LB34 + Ld21(p3,p1,p24)*S124**(-1) * ( 8*s12**2*s13 + 16*
     +    s12*s13*s24 + 8*s13*s24**2 )

      LB34 = LB34 + Ld21(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1) * ( 
     +     - 48*s12**3*s14**2 - 16*s12**3*s14*s34 + 112*s12**2*s14**3
     +     - 240*s12**2*s14**2*s34 + 128*s12*s14**4 - 272*s12*s14**3*
     +    s34 + 48*s14**5 - 96*s14**4*s34 )

      LB34 = LB34 + Ld21(p3,p4,p12)*S13**(-1)*S124**(-1) * ( 16*s12**3*
     +    s34 + 48*s12**2*s14**2 - 48*s12**2*s14*s34 + 80*s12*s14**3 - 
     +    144*s12*s14**2*s34 + 48*s14**4 - 80*s14**3*s34 )

      LB34 = LB34 + Ld21(p3,p4,p12)*S24**(-1)*S34**(-1)*S124**(-1) * ( 
     +    80*s12**2*s13**2*s14 - 80*s12**2*s14**3 )

      LB34 = LB34 + Ld21(p3,p4,p12)*S24**(-1)*S124**(-1) * ( 16*s12**3*
     +    s13 - 48*s12**3*s14 + 16*s12**3*s34 + 32*s12**2*s13**2 + 32*
     +    s12**2*s13*s14 + 32*s12**2*s13*s34 + 272*s12**2*s14**2 - 80*
     +    s12**2*s14*s34 )

      LB34 = LB34 + Ld21(p3,p4,p12)*S124**(-1) * ( 96*s12**2*s14 + 48*
     +    s12*s14**2 )

      LB34 = LB34 + Ld21(p3,p12,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 
     +     - 16*s14**3*s23**2 )

      LB34 = LB34 + Ld21(p3,p12,p4)*S13**(-1)*S24**(-1) * (  - 16*
     +    s14**3*s23 - 32*s14**2*s23**2 )

      LB34 = LB34 + Ld21(p3,p12,p4)*S24**(-1)*S34**(-1) * ( 48*s13**3*
     +    s14 + 64*s13**2*s14*s23 - 48*s13*s14**3 + 32*s13*s14*s23**2
     +     - 64*s14**3*s23 + 16*s14**2*s23**2 )

      LB34 = LB34 + Ld21(p3,p12,p4)*S24**(-1) * (  - 48*s12*s13**2 + 48
     +    *s12*s13*s14 - 64*s12*s13*s34 - 48*s12*s14**2 + 48*s12*s14*
     +    s23 + 128*s12*s14*s34 + 16*s13**3 + 64*s13**2*s14 + 32*s13*
     +    s14**2 + 128*s13*s14*s23 - 64*s13*s14*s34 - 16*s13*s34**2 - 
     +    16*s14**3 + 32*s14**2*s23 + 64*s14**2*s34 + 64*s14*s23**2 + 
     +    48*s14*s23*s34 )

      LB34 = LB34 + Ld21(p3,p12,p4)*S34**(-1) * ( 16*s13**3 - 16*s13**2
     +    *s24 - 16*s13*s14**2 - 16*s13*s14*s24 )

      LB34 = LB34 + Ld21(p3,p12,p4) * (  - 48*s12*s13 + 48*s12*s14 + 16
     +    *s13**2 - 96*s13*s14 - 32*s13*s24 - 48*s13*s34 + 32*s14**2 )

      LB34 = LB34 + Ld21(p3,p24,p1)*S13**(-1)*S24**(-1)*S34**(-1) * ( 
     +     - 8*s12**2*s23**3 + 8*s12*s14*s23**3 - 8*s14**2*s23**3 )

      LB34 = LB34 + Ld21(p3,p24,p1)*S13**(-1)*S24**(-1) * (  - 32*
     +    s12**2*s23**2 - 40*s12**2*s23*s34 - 16*s12**2*s34**2 + 16*s12
     +    *s14*s23**2 + 8*s12*s14*s23*s34 + 8*s12*s23**3 + 24*s12*
     +    s23**2*s34 + 24*s12*s23*s34**2 + 8*s12*s34**3 - 8*s14**2*
     +    s23**2 + 8*s14**2*s23*s34 + 8*s14**2*s34**2 - 8*s14*s23**3 - 
     +    8*s14*s23**2*s34 + 8*s14*s23*s34**2 + 8*s14*s34**3 )

      LB34 = LB34 + Ld21(p3,p24,p1)*S13**(-1)*S34**(-1) * (  - 8*s12**2
     +    *s23**2 + 8*s12*s14*s23**2 - 8*s14**2*s23**2 )

      LB34 = LB34 + Ld21(p3,p24,p1)*S13**(-1) * ( 8*s12**2*s34 + 16*s12
     +    *s14*s23 + 8*s12*s23**2 + 8*s12*s23*s34 - 8*s12*s34**2 - 16*
     +    s14**2*s23 - 16*s14**2*s34 - 8*s14*s23**2 - 16*s14*s23*s34 - 
     +    16*s14*s34**2 )

      LB34 = LB34 + Ld21(p3,p24,p1)*S24**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s23**2 + 8*s12*s13*s23**2 + 16*s12*s14*s23**2 + 8*s12*
     +    s23**3 - 8*s13*s14*s23**2 - 8*s14*s23**3 )

      LB34 = LB34 + Ld21(p3,p24,p1)*S24**(-1) * (  - 16*s12**2*s23 + 16
     +    *s12**2*s34 + 8*s12*s13*s23 - 8*s12*s13*s34 + 32*s12*s14*s23
     +     + 32*s12*s14*s34 + 24*s12*s23**2 - 16*s12*s34**2 - 16*s13*
     +    s14*s23 - 16*s13*s14*s34 - 8*s14*s23**2 + 8*s14*s23*s34 + 8*
     +    s14*s34**2 )

      LB34 = LB34 + Ld21(p3,p24,p1)*S34**(-1) * (  - 16*s12**2*s23 + 24
     +    *s12*s13*s23 + 16*s12*s13*s24 - 8*s12*s23**2 - 8*s12*s23*s24
     +     - 8*s13**2*s23 - 8*s13**2*s24 - 8*s13*s23**2 + 8*s13*s23*s24
     +     + 16*s13*s24**2 + 8*s14*s23**2 - 8*s14*s23*s24 )

      LB34 = LB34 + Ld21(p3,p24,p1) * (  - 16*s12**2 - 8*s12*s13 - 32*
     +    s12*s14 + 24*s12*s23 + 16*s12*s24 + 16*s12*s34 + 8*s13**2 + 
     +    16*s13*s14 - 8*s13*s24 + 32*s14*s23 - 40*s14*s24 + 32*s14*s34
     +     - 8*s23**2 - 8*s23*s24 + 8*s24*s34 )

      LB34 = LB34 + Ld21(p4,p2,p1)*S13**(-1)*S24**(-1) * (  - 8*s12*s23
     +    *s34**2 - 8*s12*s34**3 )

      LB34 = LB34 + Ld21(p4,p2,p1)*S24**(-1) * ( 8*s12*s13*s34 - 8*s12*
     +    s23*s34 )

      LB34 = LB34 + Ld21(p4,p2,p13)*S13**(-1)*S24**(-1)*S34**(-1)*
     + S123**(-1)*S134 * ( 24*s12**4*s14 + 48*s12**3*s14*s23 + 24*
     +    s12**2*s14*s23**2 )

      LB34 = LB34 + Ld21(p4,p2,p13)*S13**(-1)*S34**(-1)*S123**(-1)*S134
     +  * (  - 8*s12**4 + 16*s12**3*s14 - 16*s12**3*s23 - 8*s12**3*s24
     +     + 16*s12**2*s14*s23 - 8*s12**2*s23**2 + 8*s12**2*s24**2 - 16
     +    *s12*s14*s23*s24 - 16*s12*s14*s24**2 + 8*s14**2*s23*s24 + 8*
     +    s14**2*s24**2 )

      LB34 = LB34 + Ld21(p4,p2,p13)*S13**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 8*s12**2*s14*s23*s24 - 8*s12**2*s14*s24**2 + 16*s12*s14**2
     +    *s23*s24 + 16*s12*s14**2*s24**2 - 8*s14**3*s23*s24 - 8*s14**3
     +    *s24**2 )

      LB34 = LB34 + Ld21(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * ( 8*
     +    s12**3 + 8*s12**2*s23 + 8*s12**2*s24 - 16*s12*s14*s24 - 16*
     +    s12*s23*s24 - 16*s12*s24**2 - 16*s12*s24*s34 + 8*s14**2*s24
     +     + 16*s14*s23*s24 + 16*s14*s24**2 + 16*s14*s24*s34 + 8*s23*
     +    s24*s34 + 8*s24**2*s34 + 8*s24*s34**2 )

      LB34 = LB34 + Ld21(p4,p2,p13)*S13**(-1)*S123**(-1) * (  - 8*
     +    s12**2*s14*s24 - 8*s12**2*s23*s24 - 8*s12**2*s24**2 - 8*
     +    s12**2*s24*s34 + 16*s12*s14**2*s24 + 32*s12*s14*s23*s24 + 32*
     +    s12*s14*s24**2 + 32*s12*s14*s24*s34 + 16*s12*s23*s24*s34 + 16
     +    *s12*s24**2*s34 + 16*s12*s24*s34**2 - 8*s14**3*s24 - 24*
     +    s14**2*s23*s24 - 24*s14**2*s24**2 - 24*s14**2*s24*s34 - 24*
     +    s14*s23*s24*s34 - 24*s14*s24**2*s34 - 24*s14*s24*s34**2 - 8*
     +    s23*s24*s34**2 - 8*s24**2*s34**2 - 8*s24*s34**3 )

      LB34 = LB34 + Ld21(p4,p2,p13)*S24**(-1)*S34**(-1)*S123**(-1)*S134
     +  * ( 48*s12**3*s14 + 24*s12**2*s13*s14 + 72*s12**2*s14*s23 + 24*
     +    s12*s13*s14*s23 + 24*s12*s14*s23**2 )

      LB34 = LB34 + Ld21(p4,p2,p13)*S34**(-1)*S123**(-1)*S134 * (  - 32
     +    *s12**3 - 40*s12**2*s13 + 32*s12**2*s14 - 40*s12**2*s23 - 32*
     +    s12**2*s24 - 16*s12*s13**2 + 16*s12*s13*s14 - 32*s12*s13*s23
     +     - 40*s12*s13*s24 + 32*s12*s14*s23 - 16*s12*s23**2 + 16*s12*
     +    s24**2 - 8*s13**2*s23 - 16*s13**2*s24 + 16*s13*s14*s23 - 8*
     +    s13*s23**2 + 8*s13*s24**2 - 8*s14*s23*s24 - 8*s14*s24**2 )

      LB34 = LB34 + Ld21(p4,p2,p13)*S123**(-1)*S134 * ( 16*s12**2 + 8*
     +    s12*s13 + 16*s12*s23 + 16*s12*s24 + 8*s13*s23 + 8*s13*s24 - 8
     +    *s14*s24 - 8*s23*s24 - 8*s24**2 - 8*s24*s34 )

      LB34 = LB34 + Ld21(p4,p3,p1)*S13**(-1)*S24**(-1)*S134**(-1) * ( 8
     +    *s12**2*s23*s34**2 )

      LB34 = LB34 + Ld21(p4,p3,p1)*S13**(-1)*S34**(-1)*S134**(-1) * ( 6
     +    *s14**3*s23**2 )

      LB34 = LB34 + Ld21(p4,p3,p1)*S13**(-1)*S134**(-1) * (  - 16*
     +    s12**2*s14**2 - 32*s12**2*s14*s34 - 16*s12*s14**3 - 4*s12*
     +    s14**2*s23 + 32*s12*s14**2*s24 - 4*s12*s14*s23*s34 + 32*s12*
     +    s14*s24*s34 + 16*s12*s14*s34**2 + 6*s14**2*s23**2 )

      LB34 = LB34 + Ld21(p4,p3,p1)*S13**(-1) * ( 8*s12**2*s34 + 16*s12*
     +    s14**2 + 16*s12*s14*s34 )

      LB34 = LB34 + Ld21(p4,p3,p1)*S24**(-1)*S134**(-1) * ( 8*s12**3*
     +    s34 + 8*s12**2*s23*s34 )

      LB34 = LB34 + Ld21(p4,p3,p1)*S34**(-1)*S134**(-1) * ( 24*s12*
     +    s13**2*s24 + 48*s12*s13*s14*s24 + 24*s12*s14**2*s24 + 8*
     +    s13**2*s14*s24 - 16*s13**2*s23*s24 - 16*s13**2*s24**2 + 16*
     +    s13*s14**2*s24 + 6*s13*s14*s23**2 - 32*s13*s14*s23*s24 - 32*
     +    s13*s14*s24**2 + 8*s14**3*s24 + 12*s14**2*s23**2 - 16*s14**2*
     +    s23*s24 - 16*s14**2*s24**2 )

      LB34 = LB34 + Ld21(p4,p3,p1)*S34**(-1) * (  - 16*s12*s13*s24 - 16
     +    *s12*s14*s24 - 8*s13*s14*s24 + 8*s13*s24**2 - 8*s14**2*s24 )

      LB34 = LB34 + Ld21(p4,p3,p1)*S34**(-2)*S134**(-1) * (  - 8*s13**3
     +    *s24**2 - 16*s13**2*s14*s24**2 - 8*s13*s14**2*s24**2 )

      LB34 = LB34 + Ld21(p4,p3,p1)*S34**(-2) * ( 8*s13**2*s24**2 + 8*
     +    s13*s14*s24**2 )

      LB34 = LB34 + Ld21(p4,p3,p1)*S134**(-1) * (  - 24*s12**2*s13 - 32
     +    *s12**2*s14 - 16*s12*s13*s14 + 8*s12*s13*s23 - 32*s12*s14**2
     +     - 8*s12*s14*s23 + 80*s12*s14*s24 + 8*s12*s23*s34 - 16*s13*
     +    s23*s24 - 8*s13*s24**2 + 6*s14*s23**2 - 16*s14*s23*s24 - 16*
     +    s14*s24**2 - 8*s14*s24*s34 )

      LB34 = LB34 + Ld21(p4,p3,p1) * ( 8*s12**2 + 16*s12*s14 - 16*s12*
     +    s24 - 8*s14*s24 )

      LB34 = LB34 + Ld21(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 
     +     - 48*s12**4*s34 - 96*s12**3*s14**2 + 192*s12**3*s14*s34 - 16
     +    *s12**3*s23*s34 - 32*s12**3*s34**2 + 64*s12**2*s14**3 - 48*
     +    s12**2*s14**2*s23 - 48*s12**2*s14**2*s34 )

      LB34 = LB34 + Ld21(p4,p3,p12)*S24**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 80*s12**2*s13**2*s14 + 80*s12**2*s14**3 )

      LB34 = LB34 + Ld21(p4,p3,p12)*S24**(-1)*S123**(-1) * ( 128*s12**3
     +    *s13 - 48*s12**3*s14 - 32*s12**3*s34 + 160*s12**2*s13**2 - 
     +    336*s12**2*s13*s14 + 48*s12**2*s13*s23 - 32*s12**2*s13*s34 - 
     +    176*s12**2*s14**2 - 96*s12**2*s14*s23 + 16*s12**2*s14*s34 + 
     +    144*s12*s13**3 - 96*s12*s13**2*s14 + 96*s12*s13**2*s23 + 16*
     +    s12*s13**2*s34 - 48*s12*s13*s14**2 - 48*s12*s13*s14*s23 + 48*
     +    s12*s13*s23*s34 - 48*s12*s14**2*s23 + 48*s13**4 + 48*s13**3*
     +    s23 + 16*s13**3*s34 + 32*s13**2*s23*s34 )

      LB34 = LB34 + Ld21(p4,p12,p3)*S13**(-1)*S24**(-1)*S34**(-1) * ( 
     +    16*s14**4*s23 - 16*s14**3*s23**2 )

      LB34 = LB34 + Ld21(p4,p12,p3)*S13**(-1)*S24**(-1) * (  - 16*s12*
     +    s14**2*s34 + 16*s14**4 - 32*s14**3*s34 - 32*s14**2*s23**2 - 
     +    48*s14**2*s23*s34 )

      LB34 = LB34 + Ld21(p4,p12,p3)*S24**(-1)*S34**(-1) * (  - 48*
     +    s13**2*s14**2 - 16*s13*s14**2*s23 + 48*s14**4 - 16*s14**2*
     +    s23**2 )

      LB34 = LB34 + Ld21(p4,p12,p3)*S24**(-1) * ( 48*s12*s13*s14 - 48*
     +    s12*s14**2 + 80*s12*s14*s34 - 16*s13**2*s14 - 48*s13*s14**2
     +     + 32*s13*s14*s23 + 16*s13*s14*s34 - 32*s14**3 - 48*s14**2*
     +    s23 + 32*s14**2*s34 + 32*s14*s23*s34 + 32*s14*s34**2 )

      LB34 = LB34 + Ld21(p4,p12,p3)*S34**(-1) * (  - 64*s13**2*s14 - 16
     +    *s13**2*s24 + 16*s13*s14*s24 + 64*s14**3 + 32*s14**2*s24 )

      LB34 = LB34 + Ld21(p4,p12,p3) * (  - 16*s13**2 - 96*s13*s14 - 32*
     +    s13*s24 - 16*s13*s34 + 48*s14**2 + 64*s14*s24 + 48*s14*s34 )

      LB34 = LB34 + Ld21(p4,p13,p2)*S13**(-1)*S24**(-1)*S34**(-1) * ( 
     +     - 8*s12**2*s14**3 + 8*s12*s14**3*s23 - 8*s14**3*s23**2 )

      LB34 = LB34 + Ld21(p4,p13,p2)*S13**(-1)*S24**(-1) * (  - 32*
     +    s12**2*s14**2 - 40*s12**2*s14*s34 - 16*s12**2*s34**2 + 8*s12*
     +    s14**3 + 16*s12*s14**2*s23 + 24*s12*s14**2*s34 + 8*s12*s14*
     +    s23*s34 + 24*s12*s14*s34**2 + 8*s12*s34**3 - 8*s14**3*s23 - 8
     +    *s14**2*s23**2 - 8*s14**2*s23*s34 + 8*s14*s23**2*s34 + 8*s14*
     +    s23*s34**2 + 8*s23**2*s34**2 + 8*s23*s34**3 )

      LB34 = LB34 + Ld21(p4,p13,p2)*S13**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s14**2 + 8*s12*s14**3 + 16*s12*s14**2*s23 + 8*s12*
     +    s14**2*s24 - 8*s14**3*s23 - 8*s14**2*s23*s24 )

      LB34 = LB34 + Ld21(p4,p13,p2)*S13**(-1) * ( 8*s12**2*s14 + 40*
     +    s12**2*s34 + 24*s12*s14**2 + 32*s12*s14*s23 + 8*s12*s14*s24
     +     + 24*s12*s14*s34 + 32*s12*s23*s34 - 8*s12*s24*s34 + 8*s12*
     +    s34**2 - 8*s14**2*s23 - 16*s14*s23*s24 + 8*s14*s23*s34 - 16*
     +    s23*s24*s34 + 8*s23*s34**2 )

      LB34 = LB34 + Ld21(p4,p13,p2)*S24**(-1)*S34**(-1) * (  - 8*s12**2
     +    *s14**2 + 8*s12*s14**2*s23 - 8*s14**2*s23**2 )

      LB34 = LB34 + Ld21(p4,p13,p2)*S24**(-1) * ( 8*s12**2*s34 + 8*s12*
     +    s14**2 + 16*s12*s14*s23 + 8*s12*s14*s34 - 8*s12*s34**2 - 8*
     +    s14**2*s23 - 16*s14*s23**2 - 16*s14*s23*s34 - 16*s23**2*s34
     +     - 16*s23*s34**2 )

      LB34 = LB34 + Ld21(p4,p13,p2)*S34**(-1) * (  - 40*s12**2*s14 - 8*
     +    s12*s13*s14 + 16*s12*s13*s24 - 8*s12*s14**2 + 24*s12*s14*s24
     +     + 16*s13**2*s24 - 8*s13*s14*s23 + 8*s13*s14*s24 - 8*s13*
     +    s24**2 + 8*s14**2*s23 - 8*s14**2*s24 - 8*s14*s24**2 )

      LB34 = LB34 + Ld21(p4,p13,p2) * (  - 40*s12**2 + 16*s12*s13 - 24*
     +    s12*s14 - 32*s12*s23 - 8*s12*s24 - 32*s12*s34 - 8*s13*s14 - 
     +    40*s13*s23 - 8*s13*s24 + 8*s13*s34 - 8*s14**2 + 32*s14*s23 + 
     +    16*s23*s24 + 32*s23*s34 + 8*s24**2 )

      LB34d=-LB34/s134/s234
      
      return
      end

      function LB34e(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LB34=0d0

      LB34 = LB34 + Ld22(p1,p2,p34)*S13**(-1)*S24**(-1)*S34**(-1)*S134
     +  * ( 16*s12**2*s23**2 + 16*s12*s23**3 - 16*s14**2*s23**2 - 16*
     +    s14*s23**3 )

      LB34 = LB34 + Ld22(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * ( 32*
     +    s12**2*s23 + 32*s12*s14*s23 + 48*s12*s23**2 + 32*s12*s23*s34
     +     - 16*s14*s23**2 )

      LB34 = LB34 + Ld22(p1,p2,p34)*S13**(-1)*S34**(-1)*S134 * ( 8*s12*
     +    s23**2 + 8*s14*s23**2 )

      LB34 = LB34 + Ld22(p1,p2,p34)*S13**(-1)*S34**(-1) * (  - 16*s12*
     +    s14*s23**2 )

      LB34 = LB34 + Ld22(p1,p2,p34)*S13**(-1)*S134 * ( 16*s12*s23 + 8*
     +    s23**2 )

      LB34 = LB34 + Ld22(p1,p2,p34)*S13**(-1) * (  - 32*s12*s14*s23 - 8
     +    *s12*s23**2 - 16*s12*s23*s34 - 16*s14*s23**2 - 8*s23**2*s34 )

      LB34 = LB34 + Ld22(p1,p2,p34)*S24**(-1)*S34**(-1)*S134 * (  - 16*
     +    s12*s23**2 - 16*s14*s23**2 - 40*s23**3 )

      LB34 = LB34 + Ld22(p1,p2,p34)*S24**(-1)*S134 * (  - 40*s23**2 )

      LB34 = LB34 + Ld22(p1,p2,p34)*S34**(-1)*S134 * (  - 64*s12*s23 - 
     +    32*s23**2 )

      LB34 = LB34 + Ld22(p1,p2,p34)*S34**(-2)*S134 * (  - 32*s12*s23**2
     +     + 32*s13*s23**2 + 32*s14*s23**2 )

      LB34 = LB34 + Ld22(p2,p1,p34)*S24**(-1)*S34**(-1)*S234 * ( 16*
     +    s12**2*s13 - 32*s12*s13**2 - 8*s12*s13*s14 + 56*s13**2*s23 + 
     +    32*s13*s14*s23 - 16*s13*s23**2 )

      LB34 = LB34 + Ld22(p2,p1,p34)*S24**(-1)*S234 * ( 32*s12**2 - 72*
     +    s12*s13 - 16*s12*s14 + 32*s12*s23 - 16*s12*s34 - 8*s13**2 + 
     +    32*s13*s23 )

      LB34 = LB34 + Ld22(p2,p1,p34)*S24**(-1) * ( 8*s12*s13**2 + 16*s12
     +    *s13*s34 + 8*s13**2*s34 )

      LB34 = LB34 + Ld22(p2,p1,p34)*S34**(-1)*S234 * (  - 80*s12*s13 + 
     +    16*s13**2 + 8*s13*s14 - 16*s13*s23 )

      LB34 = LB34 + Ld22(p2,p1,p34)*S34**(-1) * ( 16*s12*s13**2 )

      LB34 = LB34 + Ld22(p2,p1,p34)*S34**(-2)*S234 * (  - 32*s12*s13**2
     +     + 32*s13**2*s23 + 32*s13**2*s24 )

      LB34 = LB34 + Ld22(p2,p1,p34)*S234 * ( 8*s13 )

      LB34 = LB34 + Ld22(p2,p1,p34) * ( 32*s12*s13 + 16*s13**2 )

      LB34 = LB34 + Ld22(p3,p1,p24)*S13**(-1)*S24**(-1)*S34**(-1)*S234*
     + S124**(-1) * ( 32*s12**4*s23 + 64*s12**3*s14*s23 - 16*s12**3*
     +    s23**2 + 32*s12**2*s14**2*s23 - 16*s12**2*s14*s23**2 )

      LB34 = LB34 + Ld22(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*S124**(-1)
     +  * ( 8*s12**4 + 16*s12**3*s14 - 24*s12**3*s23 - 8*s12**3*s34 + 8
     +    *s12**2*s14**2 - 24*s12**2*s14*s23 - 8*s12**2*s14*s34 )

      LB34 = LB34 + Ld22(p3,p1,p24)*S13**(-1)*S34**(-1)*S234*S124**(-1)
     +  * ( 40*s12**3*s23 + 32*s12**2*s14*s23 )

      LB34 = LB34 + Ld22(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * ( 16*
     +    s12**3 + 8*s12**2*s14 )

      LB34 = LB34 + Ld22(p3,p1,p24)*S24**(-1)*S34**(-1)*S234*S124**(-1)
     +  * (  - 8*s12**4 - 8*s12**3*s13 - 16*s12**3*s14 + 24*s12**3*s23
     +     - 8*s12**2*s13*s14 - 8*s12**2*s14**2 + 24*s12**2*s14*s23 )

      LB34 = LB34 + Ld22(p3,p1,p24)*S24**(-1)*S234*S124**(-1) * ( 16*
     +    s12**3 + 16*s12**2*s14 )

      LB34 = LB34 + Ld22(p3,p1,p24)*S34**(-1)*S234*S124**(-1) * (  - 32
     +    *s12**3 - 40*s12**2*s13 - 48*s12**2*s14 + 48*s12**2*s23 - 32*
     +    s12**2*s24 - 16*s12*s13*s14 - 32*s12*s13*s24 - 16*s12*s14**2
     +     + 32*s12*s14*s23 - 16*s12*s14*s24 )

      LB34 = LB34 + Ld22(p3,p1,p24)*S34**(-1)*S124**(-1) * ( 8*s12**2*
     +    s13**2 + 8*s12**2*s13*s14 + 8*s12**2*s13*s24 + 8*s12**2*s14*
     +    s24 + 16*s12*s13**2*s24 + 16*s12*s13*s14*s24 )

      LB34 = LB34 + Ld22(p3,p1,p24)*S234*S124**(-1) * ( 24*s12**2 + 16*
     +    s12*s14 )

      LB34 = LB34 + Ld22(p3,p1,p24)*S124**(-1) * ( 8*s12**2*s13 + 8*
     +    s12**2*s24 + 16*s12*s13*s24 )

      LB34 = LB34 + Ld22(p3,p4,p12)*S13**(-1)*S24**(-1)*S34**(-1)*
     + S124**(-1) * (  - 16*s14**5*s23 + 16*s14**4*s23**2 )

      LB34 = LB34 + Ld22(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1) * ( 
     +     - 48*s12**2*s14**3 + 128*s12**2*s14**2*s34 - 16*s12**2*s14*
     +    s34**2 - 48*s12*s14**3*s23 + 48*s12*s14**3*s34 + 32*s12*
     +    s14**2*s23*s34 - 16*s14**5 + 32*s14**4*s23 + 32*s14**4*s34 - 
     +    16*s14**3*s23**2 )

      LB34 = LB34 + Ld22(p3,p4,p12)*S13**(-1)*S34**(-1)*S124**(-1) * ( 
     +     - 16*s14**4*s23 + 16*s14**3*s23**2 )

      LB34 = LB34 + Ld22(p3,p4,p12)*S13**(-1)*S124**(-1) * ( 48*s12**2*
     +    s14*s34 + 16*s12*s14**3 - 48*s12*s14**2*s23 + 48*s12*s14**2*
     +    s34 - 16*s14**4 + 16*s14**3*s23 + 48*s14**3*s34 )

      LB34 = LB34 + Ld22(p3,p4,p12)*S24**(-1)*S34**(-1)*S124**(-1) * ( 
     +     - 16*s12*s13**2*s14**2 - 16*s12*s13*s14**2*s23 + 16*s13**3*
     +    s14**2 + 48*s13**2*s14**3 + 32*s13**2*s14**2*s23 + 16*s13*
     +    s14**4 + 48*s13*s14**3*s23 + 16*s13*s14**2*s23**2 - 16*s14**5
     +     + 32*s14**4*s23 )

      LB34 = LB34 + Ld22(p3,p4,p12)*S24**(-1)*S124**(-1) * ( 80*s12**2*
     +    s13*s14 + 16*s12**2*s13*s34 - 48*s12**2*s14**2 + 80*s12**2*
     +    s14*s34 + 16*s12**2*s34**2 - 16*s12*s13*s14**2 - 32*s12*s13*
     +    s14*s23 + 32*s12*s14**3 - 16*s12*s14**2*s23 - 32*s12*s14*s23*
     +    s34 + 16*s13**2*s14**2 + 80*s13*s14**3 + 32*s13*s14**2*s23 + 
     +    32*s14**4 + 16*s14**3*s23 + 48*s14**3*s34 + 16*s14**2*s23**2
     +     )

      LB34 = LB34 + Ld22(p3,p4,p12)*S34**(-1)*S124**(-1) * ( 48*s13**2*
     +    s14**2 + 16*s13*s14**3 + 48*s13*s14**2*s23 - 16*s14**4 + 32*
     +    s14**3*s23 )

      LB34 = LB34 + Ld22(p3,p4,p12)*S124**(-1) * ( 96*s13*s14**2 + 16*
     +    s14**3 + 48*s14**2*s23 + 48*s14**2*s34 )

      LB34 = LB34 + Ld22(p4,p2,p13)*S13**(-1)*S24**(-1)*S34**(-1)*
     + S123**(-1)*S134 * ( 32*s12**4*s14 - 16*s12**3*s14**2 + 64*s12**3
     +    *s14*s23 - 16*s12**2*s14**2*s23 + 32*s12**2*s14*s23**2 )

      LB34 = LB34 + Ld22(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*S134
     +  * ( 8*s12**4 - 24*s12**3*s14 + 16*s12**3*s23 - 8*s12**3*s34 - 
     +    24*s12**2*s14*s23 + 8*s12**2*s23**2 - 8*s12**2*s23*s34 )

      LB34 = LB34 + Ld22(p4,p2,p13)*S13**(-1)*S34**(-1)*S123**(-1)*S134
     +  * (  - 8*s12**4 + 24*s12**3*s14 - 16*s12**3*s23 - 8*s12**3*s24
     +     + 16*s12**2*s14*s23 - 8*s12**2*s14*s24 - 8*s12**2*s23**2 + 8
     +    *s12**2*s24**2 - 16*s12*s14*s23*s24 - 16*s12*s14*s24**2 )

      LB34 = LB34 + Ld22(p4,p2,p13)*S13**(-1)*S34**(-1)*S123**(-1) * ( 
     +    8*s12**2*s14**2*s23 + 8*s12**2*s14**2*s24 - 8*s12**2*s14*s23*
     +    s24 - 8*s12**2*s14*s24**2 + 16*s12*s14**2*s23*s24 + 16*s12*
     +    s14**2*s24**2 )

      LB34 = LB34 + Ld22(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * ( 16*
     +    s12**3 - 8*s12**2*s14 + 8*s12**2*s23 - 8*s12**2*s34 - 16*s12*
     +    s14*s24 - 16*s12*s23*s24 - 16*s12*s24**2 - 16*s12*s24*s34 )

      LB34 = LB34 + Ld22(p4,p2,p13)*S13**(-1)*S123**(-1) * ( 8*s12**2*
     +    s14**2 + 16*s12**2*s14*s23 + 8*s12**2*s14*s24 + 16*s12**2*s14
     +    *s34 - 8*s12**2*s23*s24 + 8*s12**2*s23*s34 - 8*s12**2*s24**2
     +     + 8*s12**2*s34**2 + 16*s12*s14**2*s24 + 32*s12*s14*s23*s24
     +     + 32*s12*s14*s24**2 + 32*s12*s14*s24*s34 + 16*s12*s23*s24*
     +    s34 + 16*s12*s24**2*s34 + 16*s12*s24*s34**2 )

      LB34 = LB34 + Ld22(p4,p2,p13)*S24**(-1)*S34**(-1)*S123**(-1)*S134
     +  * ( 40*s12**3*s14 + 32*s12**2*s14*s23 )

      LB34 = LB34 + Ld22(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * ( 16*
     +    s12**3 + 8*s12**2*s23 )

      LB34 = LB34 + Ld22(p4,p2,p13)*S34**(-1)*S123**(-1)*S134 * (  - 32
     +    *s12**3 - 32*s12**2*s13 + 48*s12**2*s14 - 40*s12**2*s23 - 32*
     +    s12**2*s24 - 16*s12*s13*s23 - 32*s12*s13*s24 + 32*s12*s14*s23
     +     - 16*s12*s23**2 + 16*s12*s24**2 )

      LB34 = LB34 + Ld22(p4,p2,p13)*S123**(-1)*S134 * ( 32*s12**2 + 16*
     +    s12*s23 + 16*s12*s24 )

      LB34 = LB34 + Ld22(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 
     +     - 48*s12**3*s14*s34 + 80*s12**3*s34**2 + 48*s12**2*s14**2*
     +    s34 - 32*s12**2*s14*s34**2 )

      LB34 = LB34 + Ld22(p4,p3,p12)*S13**(-1)*S123**(-1) * ( 32*s12**3*
     +    s34 - 32*s12**2*s14*s34 + 16*s12**2*s24*s34 + 16*s12**2*
     +    s34**2 )

      LB34 = LB34 + Ld22(p4,p3,p12)*S24**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 16*s13**4*s14 - 16*s13**3*s14**2 - 16*s13**3*s14*s23 - 16*
     +    s13**2*s14**2*s23 )

      LB34 = LB34 + Ld22(p4,p3,p12)*S24**(-1)*S123**(-1) * (  - 96*
     +    s12**3*s34 + 16*s12**2*s13**2 + 96*s12**2*s13*s14 - 224*
     +    s12**2*s13*s34 + 80*s12**2*s14**2 - 32*s12**2*s14*s34 - 48*
     +    s12**2*s23*s34 - 48*s12**2*s34**2 - 16*s12*s13**3 + 112*s12*
     +    s13**2*s14 - 144*s12*s13**2*s34 - 16*s12*s13*s14*s34 - 48*s12
     +    *s13*s23*s34 - 16*s13**4 + 16*s13**3*s14 - 16*s13**3*s23 - 48
     +    *s13**3*s34 - 80*s13**2*s14**2 - 96*s13**2*s14*s34 - 32*
     +    s13**2*s23*s34 - 96*s13*s14**2*s23 - 96*s13*s14*s23*s34 )

      LB34 = LB34 + Ld22(p4,p3,p12)*S34**(-1)*S123**(-1) * ( 48*s12*s13
     +    *s14**2 + 80*s12*s13*s14*s24 + 32*s12*s13*s24**2 - 16*s13**4
     +     - 32*s13**3*s14 - 16*s13**3*s23 - 16*s13**3*s24 - 48*s13**2*
     +    s14**2 - 32*s13**2*s14*s23 - 48*s13**2*s14*s24 - 16*s13**2*
     +    s23*s24 - 48*s13*s14**2*s23 + 16*s13*s14**2*s24 - 48*s13*s14*
     +    s23*s24 + 32*s13*s14*s24**2 + 16*s13*s24**3 )

      LB34 = LB34 + Ld22(p4,p3,p12)*S123**(-1) * ( 48*s12**2*s13 - 80*
     +    s12**2*s14 - 64*s12**2*s24 - 160*s12**2*s34 + 128*s12*s13**2
     +     + 80*s12*s13*s14 + 48*s12*s13*s23 + 80*s12*s13*s24 - 32*s12*
     +    s24**2 - 32*s12*s24*s34 + 16*s13**3 - 112*s13**2*s14 + 16*
     +    s13**2*s24 + 16*s13*s14**2 - 144*s13*s14*s23 + 32*s13*s14*s24
     +     + 16*s13*s24**2 )

      LB34 = LB34 + Ld24(p1,p2,p34)*S13**(-1)*S34**(-1)*S134 * ( 16*
     +    s14**2*s23 + 16*s14**2*s24 )

      LB34 = LB34 + Ld24(p1,p2,p34)*S13**(-1)*S34**(-1) * (  - 16*
     +    s14**3*s23 - 16*s14**3*s24 )

      LB34 = LB34 + Ld24(p1,p2,p34)*S13**(-1)*S134 * ( 32*s12*s14 + 16*
     +    s12*s34 + 56*s14*s23 + 24*s14*s24 + 24*s23*s34 + 8*s24*s34 )

      LB34 = LB34 + Ld24(p1,p2,p34)*S13**(-1) * (  - 32*s12*s14**2 - 48
     +    *s12*s14*s34 - 16*s12*s34**2 - 72*s14**2*s23 - 40*s14**2*s24
     +     - 80*s14*s23*s34 - 32*s14*s24*s34 - 24*s23*s34**2 - 8*s24*
     +    s34**2 )

      LB34 = LB34 + Ld24(p1,p2,p34)*S24**(-1)*S34**(-1)*S134 * ( 48*s12
     +    *s13*s23 + 32*s12*s14*s23 + 48*s13*s14*s23 + 72*s13*s23**2 + 
     +    32*s14**2*s23 + 32*s14*s23**2 )

      LB34 = LB34 + Ld24(p1,p2,p34)*S24**(-1)*S134 * (  - 32*s12**2 - 
     +    32*s12*s14 - 32*s12*s23 - 32*s12*s34 + 72*s13*s23 + 32*s14*
     +    s23 )

      LB34 = LB34 + Ld24(p1,p2,p34)*S34**(-1)*S134 * ( 80*s12*s13 + 16*
     +    s13*s14 + 64*s13*s23 + 8*s13*s24 - 32*s14*s23 - 16*s14*s24 )

      LB34 = LB34 + Ld24(p1,p2,p34)*S34**(-2)*S134 * (  - 96*s13**2*s23
     +     - 32*s13**2*s24 - 64*s13*s14*s23 )

      LB34 = LB34 + Ld24(p1,p2,p34)*S134 * (  - 16*s12 + 16*s13 - 24*
     +    s23 - 8*s24 )

      LB34 = LB34 + Ld24(p2,p1,p34)*S13**(-1)*S24**(-1)*S34**(-1)*S234
     +  * ( 16*s12*s14*s23**2 - 8*s14**2*s23**2 + 16*s14*s23**3 )

      LB34 = LB34 + Ld24(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * (  - 32*
     +    s12**2*s23 + 16*s12*s14*s23 - 32*s12*s23**2 + 16*s12*s23*s34
     +     - 8*s14*s23**2 )

      LB34 = LB34 + Ld24(p2,p1,p34)*S24**(-1)*S34**(-1)*S234 * ( 48*s12
     +    *s23**2 - 120*s13*s23**2 - 80*s14*s23**2 + 48*s23**3 )

      LB34 = LB34 + Ld24(p2,p1,p34)*S24**(-1)*S234 * ( 64*s12*s23 - 16*
     +    s12*s34 + 24*s13*s23 - 24*s13*s34 + 8*s14*s23 - 8*s14*s34 - 
     +    48*s23**2 )

      LB34 = LB34 + Ld24(p2,p1,p34)*S24**(-1) * ( 16*s12*s34**2 + 24*
     +    s13*s34**2 + 8*s14*s34**2 )

      LB34 = LB34 + Ld24(p2,p1,p34)*S34**(-1)*S234 * ( 96*s12*s23 - 16*
     +    s13*s23 - 16*s13*s24 - 16*s14*s24 + 32*s23**2 )

      LB34 = LB34 + Ld24(p2,p1,p34)*S34**(-1) * ( 16*s13*s24**2 + 16*
     +    s14*s24**2 )

      LB34 = LB34 + Ld24(p2,p1,p34)*S34**(-2)*S234 * (  - 96*s13*s23**2
     +     - 64*s13*s23*s24 - 32*s14*s23**2 )

      LB34 = LB34 + Ld24(p2,p1,p34)*S234 * (  - 32*s12 - 56*s13 - 24*
     +    s14 - 16*s23 )

      LB34 = LB34 + Ld24(p2,p1,p34) * ( 32*s12*s24 + 48*s12*s34 + 72*
     +    s13*s24 + 80*s13*s34 + 40*s14*s24 + 32*s14*s34 )

      LB34 = LB34 + Ld24(p3,p1,p24)*S13**(-1)*S24**(-1)*S34**(-1)*S234*
     + S124**(-1) * (  - 48*s12**3*s23**2 - 104*s12**2*s14*s23**2 + 48*
     +    s12**2*s23**3 - 64*s12*s14**2*s23**2 + 64*s12*s14*s23**3 - 8*
     +    s14**3*s23**2 + 16*s14**2*s23**3 )

      LB34 = LB34 + Ld24(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*S124**(-1)
     +  * (  - 16*s12**3*s23 - 32*s12**2*s14*s23 + 56*s12**2*s23**2 + 
     +    16*s12**2*s23*s34 - 16*s12*s14**2*s23 + 64*s12*s14*s23**2 + 
     +    16*s12*s14*s23*s34 + 8*s14**2*s23**2 )

      LB34 = LB34 + Ld24(p3,p1,p24)*S13**(-1)*S34**(-1)*S234*S124**(-1)
     +  * (  - 72*s12**2*s23**2 - 64*s12*s14*s23**2 - 8*s14**2*s23**2 )

      LB34 = LB34 + Ld24(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * (  - 32
     +    *s12**2*s23 - 16*s12*s14*s23 )

      LB34 = LB34 + Ld24(p3,p1,p24)*S24**(-1)*S34**(-1)*S234*S124**(-1)
     +  * (  - 24*s12**2*s23**2 - 32*s12*s14*s23**2 - 8*s14**2*s23**2 )

      LB34 = LB34 + Ld24(p3,p1,p24)*S24**(-1)*S234*S124**(-1) * (  - 16
     +    *s12**2*s23 - 16*s12*s14*s23 )

      LB34 = LB34 + Ld24(p3,p1,p24)*S34**(-1)*S234*S124**(-1) * ( 16*
     +    s12**2*s23 + 40*s12*s13*s23 - 24*s12*s13*s24 + 56*s12*s14*s23
     +     - 24*s12*s14*s24 - 80*s12*s23**2 + 32*s12*s23*s24 - 16*
     +    s13**2*s24 + 24*s13*s14*s23 - 24*s13*s14*s24 + 32*s13*s23*s24
     +     + 24*s14**2*s23 - 8*s14**2*s24 - 48*s14*s23**2 + 16*s14*s23*
     +    s24 )

      LB34 = LB34 + Ld24(p3,p1,p24)*S34**(-1)*S124**(-1) * ( 24*s12*s13
     +    *s24**2 + 24*s12*s14*s24**2 + 16*s13**2*s24**2 + 24*s13*s14*
     +    s24**2 + 8*s14**2*s24**2 )

      LB34 = LB34 + Ld24(p3,p1,p24)*S234*S124**(-1) * (  - 8*s12*s13 - 
     +    8*s12*s14 - 24*s12*s23 - 24*s12*s24 - 8*s12*s34 - 8*s13*s14
     +     - 16*s13*s24 - 8*s14**2 - 8*s14*s23 - 8*s14*s24 - 8*s14*s34
     +     )

      LB34 = LB34 + Ld24(p3,p1,p24)*S124**(-1) * ( 32*s12*s13*s24 + 8*
     +    s12*s13*s34 + 32*s12*s14*s24 + 8*s12*s14*s34 + 24*s12*s24**2
     +     + 32*s12*s24*s34 + 8*s12*s34**2 + 16*s13**2*s24 + 32*s13*s14
     +    *s24 + 8*s13*s14*s34 + 16*s13*s24**2 + 16*s13*s24*s34 + 16*
     +    s14**2*s24 + 8*s14**2*s34 + 8*s14*s24**2 + 16*s14*s24*s34 + 8
     +    *s14*s34**2 )

      LB34 = LB34 + Ld24(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1) * ( 
     +     - 16*s12**3*s34**2 - 176*s12**2*s14**2*s34 + 32*s12**2*s14*
     +    s34**2 - 160*s12*s14**3*s34 - 64*s14**4*s34 )

      LB34 = LB34 + Ld24(p3,p4,p12)*S13**(-1)*S124**(-1) * (  - 16*
     +    s12**3*s34 - 32*s12**2*s14*s34 - 96*s12*s14**2*s34 - 64*
     +    s14**3*s34 )

      LB34 = LB34 + Ld24(p3,p4,p12)*S24**(-1)*S124**(-1) * ( 16*s12**2*
     +    s13**2 + 48*s12**2*s13*s14 + 32*s12**2*s13*s34 + 80*s12**2*
     +    s14**2 - 48*s12**2*s14*s34 + 16*s12**2*s34**2 - 16*s12*s13**3
     +     + 192*s12*s13**2*s14 + 16*s12*s13**2*s34 + 16*s12*s13*s14**2
     +     + 160*s12*s13*s14*s34 + 32*s12*s13*s34**2 + 464*s12*s14**2*
     +    s34 - 80*s12*s14*s34**2 - 16*s13**3*s14 + 96*s13**2*s14**2 - 
     +    16*s13**2*s14*s34 - 32*s13*s14**3 + 112*s13*s14**2*s34 + 192*
     +    s14**3*s34 )

      LB34 = LB34 + Ld24(p3,p4,p12)*S34**(-1)*S124**(-1) * (  - 16*s12*
     +    s13*s14*s24 - 16*s12*s13*s24**2 - 16*s13**2*s14**2 - 32*
     +    s13**2*s14*s24 - 16*s13**2*s24**2 + 16*s13*s14**3 + 32*s13*
     +    s14**2*s24 + 16*s13*s14*s24**2 )

      LB34 = LB34 + Ld24(p3,p4,p12)*S124**(-1) * ( 16*s12**2*s14 + 32*
     +    s12**2*s24 - 16*s12**2*s34 + 16*s12*s13**2 + 64*s12*s13*s14
     +     + 32*s12*s13*s24 + 16*s12*s13*s34 + 192*s12*s14**2 + 16*s12*
     +    s14*s24 + 32*s12*s14*s34 - 16*s13**3 + 96*s13**2*s14 - 16*
     +    s13**2*s34 + 32*s13*s14*s24 + 112*s13*s14*s34 + 96*s14**3 + 
     +    96*s14**2*s24 + 192*s14**2*s34 )

      LB34 = LB34 + Ld24(p4,p2,p13)*S13**(-1)*S24**(-1)*S34**(-1)*
     + S123**(-1)*S134 * (  - 48*s12**3*s14**2 + 48*s12**2*s14**3 - 104
     +    *s12**2*s14**2*s23 + 64*s12*s14**3*s23 - 64*s12*s14**2*s23**2
     +     + 16*s14**3*s23**2 - 8*s14**2*s23**3 )

      LB34 = LB34 + Ld24(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*S134
     +  * (  - 16*s12**3*s14 + 56*s12**2*s14**2 - 32*s12**2*s14*s23 + 
     +    16*s12**2*s14*s34 + 64*s12*s14**2*s23 - 16*s12*s14*s23**2 + 
     +    16*s12*s14*s23*s34 + 8*s14**2*s23**2 )

      LB34 = LB34 + Ld24(p4,p2,p13)*S13**(-1)*S34**(-1)*S123**(-1)*S134
     +  * (  - 24*s12**2*s14**2 - 8*s12*s14**2*s23 + 24*s12*s14**2*s24
     +     + 24*s14**2*s23*s24 + 16*s14**2*s24**2 )

      LB34 = LB34 + Ld24(p4,p2,p13)*S13**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 24*s12*s14**3*s23 - 24*s12*s14**3*s24 - 8*s14**3*s23**2 - 
     +    24*s14**3*s23*s24 - 16*s14**3*s24**2 )

      LB34 = LB34 + Ld24(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * (  - 16
     +    *s12**2*s14 + 24*s12*s14**2 + 16*s12*s14*s24 + 16*s12*s14*s34
     +     + 8*s14**2*s23 + 16*s14**2*s24 + 16*s14*s23*s24 + 16*s14*
     +    s24**2 + 16*s14*s24*s34 )

      LB34 = LB34 + Ld24(p4,p2,p13)*S13**(-1)*S123**(-1) * (  - 24*s12*
     +    s14**3 - 40*s12*s14**2*s23 - 40*s12*s14**2*s24 - 40*s12*
     +    s14**2*s34 - 16*s12*s14*s23*s34 - 16*s12*s14*s24*s34 - 16*s12
     +    *s14*s34**2 - 8*s14**3*s23 - 16*s14**3*s24 - 8*s14**2*s23**2
     +     - 40*s14**2*s23*s24 - 8*s14**2*s23*s34 - 32*s14**2*s24**2 - 
     +    32*s14**2*s24*s34 - 16*s14*s23*s24*s34 - 16*s14*s24**2*s34 - 
     +    16*s14*s24*s34**2 )

      LB34 = LB34 + Ld24(p4,p2,p13)*S24**(-1)*S34**(-1)*S123**(-1)*S134
     +  * (  - 72*s12**2*s14**2 - 64*s12*s14**2*s23 - 8*s14**2*s23**2 )

      LB34 = LB34 + Ld24(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * (  - 32
     +    *s12**2*s14 - 16*s12*s14*s23 )

      LB34 = LB34 + Ld24(p4,p2,p13)*S34**(-1)*S123**(-1)*S134 * ( 16*
     +    s12**2*s14 + 32*s12*s13*s14 - 80*s12*s14**2 + 32*s12*s14*s23
     +     + 16*s12*s14*s24 + 16*s13*s14*s23 + 32*s13*s14*s24 - 48*
     +    s14**2*s23 + 16*s14*s23**2 - 16*s14*s24**2 )

      LB34 = LB34 + Ld24(p4,p2,p13)*S123**(-1)*S134 * (  - 48*s12*s14
     +     - 16*s14*s23 - 16*s14*s24 )

      LB34 = LB34 + Ld24(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 
     +    96*s12**3*s14*s34 - 64*s12**3*s34**2 + 48*s12**2*s14**3 - 48*
     +    s12**2*s14**2*s23 - 288*s12**2*s14**2*s34 + 160*s12**2*s14*
     +    s23*s34 + 256*s12**2*s14*s34**2 - 32*s12**2*s23*s34**2 - 32*
     +    s12**2*s34**3 - 16*s12*s14**4 + 112*s12*s14**3*s23 + 80*s12*
     +    s14**3*s34 - 80*s12*s14**2*s23**2 - 272*s12*s14**2*s23*s34 - 
     +    48*s12*s14**2*s34**2 + 64*s12*s14*s23**2*s34 + 64*s12*s14*s23
     +    *s34**2 - 16*s14**4*s23 + 64*s14**3*s23**2 + 16*s14**3*s23*
     +    s34 - 32*s14**2*s23**3 - 32*s14**2*s23**2*s34 )

      LB34 = LB34 + Ld24(p4,p3,p12)*S24**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 64*s12*s13**2*s14**2 - 112*s12*s13*s14**2*s23 - 48*s12*
     +    s14**2*s23**2 - 48*s13**3*s14**2 + 16*s13**2*s14**3 - 128*
     +    s13**2*s14**2*s23 + 32*s13*s14**3*s23 - 112*s13*s14**2*s23**2
     +     + 16*s14**3*s23**2 - 32*s14**2*s23**3 )

      LB34 = LB34 + Ld24(p4,p3,p12)*S24**(-1)*S123**(-1) * (  - 48*
     +    s12**3*s34 - 16*s12**2*s13*s14 + 16*s12**2*s13*s34 - 96*
     +    s12**2*s14**2 + 96*s12**2*s14*s23 + 272*s12**2*s14*s34 - 32*
     +    s12**2*s23*s34 - 16*s12**2*s34**2 - 192*s12*s13**2*s14 - 256*
     +    s12*s13*s14**2 + 48*s12*s13*s14*s23 - 112*s12*s13*s14*s34 + 
     +    288*s12*s14**3 - 320*s12*s14**2*s23 - 512*s12*s14**2*s34 + 64
     +    *s12*s14*s23**2 + 112*s12*s14*s23*s34 + 80*s12*s14*s34**2 - 
     +    96*s13**3*s14 - 144*s13**2*s14**2 - 96*s13**2*s14*s23 - 96*
     +    s13**2*s14*s34 + 160*s13*s14**3 - 256*s13*s14**2*s23 - 192*
     +    s13*s14**2*s34 - 96*s13*s14*s23*s34 - 16*s14**4 + 224*s14**3*
     +    s23 + 16*s14**3*s34 - 144*s14**2*s23**2 - 224*s14**2*s23*s34
     +     )

      LB34 = LB34 + Ld311(p1,p2,p34)*S13**(-1)*S24**(-1)*S34**(-1)*S134
     +  * ( 16*s12*s23**3 + 24*s14*s23**3 )

      LB34 = LB34 + Ld311(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * ( 24*
     +    s12*s23**2 - 8*s12*s34**2 + 48*s14*s23**2 + 24*s14*s23*s34 )

      LB34 = LB34 + Ld311(p1,p2,p34)*S24**(-1)*S34**(-1)*S134 * ( 24*
     +    s23**3 )

      LB34 = LB34 + Ld311(p1,p2,p34)*S24**(-1)*S134 * ( 48*s23**2 + 24*
     +    s23*s34 )

      LB34 = LB34 + Ld311(p1,p3,p4)*S24**(-1)*S134**(-1) * ( 8*s12**3*
     +    s13 + 8*s12**3*s34 )

      LB34 = LB34 + Ld311(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * ( 8*s12
     +    *s34**2 )

      LB34 = LB34 + Ld311(p2,p1,p34)*S24**(-1)*S34**(-1)*S234 * (  - 16
     +    *s12*s13**2 - 24*s13**2*s23 )

      LB34 = LB34 + Ld311(p2,p1,p34)*S24**(-1)*S234 * (  - 24*s12*s13
     +     - 48*s13*s23 - 24*s23*s34 )

      LB34 = LB34 + Ld311(p2,p1,p34)*S34**(-1)*S234 * (  - 24*s13**2 )

      LB34 = LB34 + Ld311(p2,p1,p34)*S234 * (  - 48*s13 - 24*s34 )

      LB34 = LB34 + Ld311(p2,p4,p3)*S13**(-1)*S24**(-1)*S234**(-1) * ( 
     +    8*s12**3*s23**2 + 8*s12**3*s23*s34 )

      LB34 = LB34 + Ld311(p2,p4,p3)*S13**(-1)*S234**(-1) * ( 16*s12**3*
     +    s23 + 8*s12**3*s24 + 8*s12**3*s34 )

      LB34 = LB34 + Ld311(p3,p1,p24)*S13**(-1)*S24**(-1)*S34**(-1)*S234
     + *S124**(-1) * (  - 24*s12**4*s23 - 24*s12**3*s14*s23 )

      LB34 = LB34 + Ld311(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*
     + S124**(-1) * (  - 24*s12**4 - 24*s12**3*s14 )

      LB34 = LB34 + Ld311(p3,p1,p24)*S13**(-1)*S34**(-1)*S234*
     + S124**(-1) * (  - 48*s12**3*s23 - 48*s12**2*s14*s23 - 24*s12**2*
     +    s23*s24 - 24*s12*s14*s23*s24 )

      LB34 = LB34 + Ld311(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * (  - 
     +    48*s12**3 - 48*s12**2*s14 - 24*s12**2*s24 - 24*s12*s14*s24 )

      LB34 = LB34 + Ld311(p3,p1,p24)*S24**(-1)*S34**(-1)*S234*
     + S124**(-1) * (  - 16*s12**4 - 16*s12**3*s14 )

      LB34 = LB34 + Ld311(p3,p1,p24)*S34**(-1)*S234*S124**(-1) * (  - 
     +    24*s12**3 - 24*s12**2*s14 + 8*s12*s24**2 + 8*s14*s24**2 )

      LB34 = LB34 + Ld311(p3,p4,p2)*S34**(-1)*S234**(-1) * (  - 8*
     +    s13**2*s24**2 )

      LB34 = LB34 + Ld311(p3,p4,p2)*S234**(-1) * (  - 8*s13**2*s24 )

      LB34 = LB34 + Ld311(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1)
     +  * (  - 16*s12**4*s34 + 48*s12**3*s14*s23 + 80*s12**3*s14*s34 - 
     +    16*s12**3*s23*s34 - 16*s12**3*s34**2 + 48*s12**2*s14**2*s23
     +     + 240*s12**2*s14**2*s34 + 48*s12**2*s14*s23**2 + 48*s12**2*
     +    s14*s23*s34 - 48*s12*s14**3*s23 + 176*s12*s14**3*s34 + 96*s12
     +    *s14**2*s23**2 + 144*s12*s14**2*s23*s34 + 48*s12*s14**2*
     +    s34**2 - 48*s14**4*s23 + 32*s14**4*s34 + 48*s14**3*s23**2 + 
     +    80*s14**3*s23*s34 + 32*s14**3*s34**2 )

      LB34 = LB34 + Ld311(p3,p4,p12)*S13**(-1)*S124**(-1) * ( 32*s12**3
     +    *s14 - 16*s12**3*s24 - 32*s12**3*s34 + 96*s12**2*s14**2 + 96*
     +    s12*s14**3 + 48*s12*s14**2*s24 + 96*s12*s14**2*s34 + 32*
     +    s14**4 + 32*s14**3*s24 + 64*s14**3*s34 )

      LB34 = LB34 + Ld311(p3,p4,p12)*S24**(-1)*S34**(-1)*S124**(-1)
     +  * ( 48*s12**2*s13**2*s14 + 96*s12**2*s13*s14*s23 + 48*s12**2*
     +    s14*s23**2 + 96*s12*s13**2*s14**2 + 192*s12*s13*s14**2*s23 + 
     +    96*s12*s14**2*s23**2 + 48*s13**2*s14**3 + 96*s13*s14**3*s23
     +     + 48*s14**3*s23**2 )

      LB34 = LB34 + Ld311(p3,p4,p12)*S24**(-1)*S124**(-1) * (  - 16*
     +    s12**3*s13 + 48*s12**3*s14 - 16*s12**3*s23 - 32*s12**3*s34 + 
     +    96*s12**2*s13*s14 + 48*s12**2*s14**2 + 144*s12**2*s14*s23 + 
     +    48*s12**2*s14*s34 + 240*s12*s13*s14**2 - 48*s12*s14**3 + 336*
     +    s12*s14**2*s23 + 192*s12*s14**2*s34 + 128*s13*s14**3 - 48*
     +    s14**4 + 176*s14**3*s23 + 112*s14**3*s34 )

      LB34 = LB34 + Ld311(p4,p2,p13)*S13**(-1)*S24**(-1)*S34**(-1)*
     + S123**(-1)*S134 * (  - 24*s12**4*s14 - 24*s12**3*s14*s23 )

      LB34 = LB34 + Ld311(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*
     + S134 * (  - 24*s12**4 - 24*s12**3*s23 )

      LB34 = LB34 + Ld311(p4,p2,p13)*S13**(-1)*S34**(-1)*S123**(-1)*
     + S134 * (  - 16*s12**4 - 16*s12**3*s23 )

      LB34 = LB34 + Ld311(p4,p2,p13)*S24**(-1)*S34**(-1)*S123**(-1)*
     + S134 * (  - 48*s12**3*s14 - 24*s12**2*s13*s14 - 48*s12**2*s14*
     +    s23 - 24*s12*s13*s14*s23 )

      LB34 = LB34 + Ld311(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * (  - 
     +    48*s12**3 - 24*s12**2*s13 - 48*s12**2*s23 - 24*s12*s13*s23 )

      LB34 = LB34 + Ld311(p4,p2,p13)*S34**(-1)*S123**(-1)*S134 * (  - 
     +    24*s12**3 - 24*s12**2*s23 + 8*s12*s13**2 + 8*s13**2*s23 )

      LB34 = LB34 + Ld311(p4,p3,p1)*S34**(-1)*S134**(-1) * (  - 8*
     +    s13**2*s24**2 - 16*s13*s14*s24**2 - 8*s14**2*s24**2 )

      LB34 = LB34 + Ld311(p4,p3,p1)*S134**(-1) * (  - 8*s13*s24**2 - 8*
     +    s14*s24**2 )

      LB34 = LB34 + Ld311(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1)
     +  * ( 16*s12**4*s34 + 16*s12**3*s14*s34 + 16*s12**3*s23*s34 + 16*
     +    s12**3*s34**2 )

      LB34 = LB34 + Ld311(p4,p3,p12)*S13**(-1)*S123**(-1) * ( 16*s12**3
     +    *s14 + 16*s12**3*s24 + 32*s12**3*s34 )

      LB34 = LB34 + Ld311(p4,p3,p12)*S24**(-1)*S123**(-1) * (  - 32*
     +    s12**3*s13 - 48*s12**3*s14 + 16*s12**3*s23 - 16*s12**3*s34 - 
     +    96*s12**2*s13**2 - 144*s12**2*s13*s14 - 144*s12**2*s13*s34 - 
     +    48*s12**2*s14**2 - 48*s12**2*s14*s34 - 96*s12*s13**3 - 144*
     +    s12*s13**2*s14 - 48*s12*s13**2*s23 - 176*s12*s13**2*s34 - 96*
     +    s12*s13*s14**2 - 144*s12*s13*s14*s34 - 48*s12*s13*s23*s34 - 
     +    48*s12*s13*s34**2 - 32*s13**4 - 48*s13**3*s14 - 32*s13**3*s23
     +     - 64*s13**3*s34 - 48*s13**2*s14**2 - 80*s13**2*s14*s34 - 32*
     +    s13**2*s23*s34 - 32*s13**2*s34**2 )

      LB34 = LB34 + Ld311(p4,p3,p12)*S34**(-1)*S123**(-1) * (  - 48*
     +    s12**2*s14**2 - 96*s12**2*s14*s24 - 48*s12**2*s24**2 - 96*s12
     +    *s13*s14**2 - 192*s12*s13*s14*s24 - 96*s12*s13*s24**2 - 48*
     +    s13**2*s14**2 - 96*s13**2*s14*s24 - 48*s13**2*s24**2 )

      LB34 = LB34 + Ld311(p4,p3,p12)*S123**(-1) * (  - 48*s12**3 - 144*
     +    s12**2*s13 - 144*s12**2*s14 - 96*s12**2*s24 - 48*s12**2*s34
     +     - 144*s12*s13**2 - 336*s12*s13*s14 - 240*s12*s13*s24 - 192*
     +    s12*s13*s34 - 48*s13**3 - 176*s13**2*s14 - 128*s13**2*s24 - 
     +    112*s13**2*s34 )

      LB34 = LB34 + Ld314(p1,p2,p34)*S24**(-1)*S34**(-1)*S134 * (  - 24
     +    *s12*s23**2 - 72*s13*s23**2 - 48*s14*s23**2 )

      LB34 = LB34 + Ld314(p1,p2,p34)*S24**(-1)*S134 * ( 24*s12*s34 - 72
     +    *s13*s23 - 48*s14*s23 )

      LB34 = LB34 + Ld314(p1,p2,p34)*S34**(-1)*S134 * (  - 24*s13*s23 )

      LB34 = LB34 + Ld314(p1,p2,p34)*S134 * (  - 24*s13 )

      LB34 = LB34 + Ld314(p1,p3,p4)*S34**(-1)*S134**(-1) * ( 24*s12*
     +    s13**2*s24 )

      LB34 = LB34 + Ld314(p1,p3,p4)*S134**(-1) * (  - 24*s12**2*s13 - 
     +    24*s12**2*s34 + 24*s12*s13*s24 )

      LB34 = LB34 + Ld314(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * (  - 24
     +    *s12*s23*s34 + 24*s14*s23**2 )

      LB34 = LB34 + Ld314(p2,p1,p34)*S24**(-1)*S34**(-1)*S234 * ( 24*
     +    s12*s13*s23 + 72*s13*s23**2 + 24*s14*s23**2 )

      LB34 = LB34 + Ld314(p2,p1,p34)*S24**(-1)*S234 * ( 72*s23**2 )

      LB34 = LB34 + Ld314(p2,p1,p34)*S34**(-1)*S234 * ( 48*s13*s23 )

      LB34 = LB34 + Ld314(p2,p1,p34)*S234 * ( 48*s23 )

      LB34 = LB34 + Ld314(p2,p4,p3)*S34**(-1)*S234**(-1) * ( 24*s12*s13
     +    *s24**2 )

      LB34 = LB34 + Ld314(p2,p4,p3)*S234**(-1) * (  - 24*s12**2*s24 - 
     +    24*s12**2*s34 + 24*s12*s13*s24 )

      LB34 = LB34 + Ld314(p3,p1,p24)*S13**(-1)*S24**(-1)*S34**(-1)*S234
     + *S124**(-1) * ( 72*s12**3*s23**2 + 96*s12**2*s14*s23**2 + 24*s12
     +    *s14**2*s23**2 )

      LB34 = LB34 + Ld314(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*
     + S124**(-1) * ( 48*s12**3*s23 + 48*s12**2*s14*s23 )

      LB34 = LB34 + Ld314(p3,p1,p24)*S13**(-1)*S34**(-1)*S234*
     + S124**(-1) * ( 72*s12**2*s23**2 + 96*s12*s14*s23**2 + 24*s14**2*
     +    s23**2 )

      LB34 = LB34 + Ld314(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * ( 48*
     +    s12**2*s23 + 48*s12*s14*s23 )

      LB34 = LB34 + Ld314(p3,p1,p24)*S24**(-1)*S34**(-1)*S234*
     + S124**(-1) * ( 24*s12**3*s23 + 24*s12**2*s14*s23 )

      LB34 = LB34 + Ld314(p3,p1,p24)*S34**(-1)*S234*S124**(-1) * (  - 
     +    24*s12*s23*s24 - 24*s14*s23*s24 )

      LB34 = LB34 + Ld314(p3,p4,p12)*S24**(-1)*S34**(-1)*S124**(-1)
     +  * (  - 96*s12*s13**3*s14 - 192*s12*s13**2*s14*s23 - 96*s12*s13*
     +    s14*s23**2 - 96*s13**3*s14**2 - 192*s13**2*s14**2*s23 - 96*
     +    s13*s14**2*s23**2 )

      LB34 = LB34 + Ld314(p3,p4,p12)*S24**(-1)*S124**(-1) * ( 48*s12**3
     +    *s34 - 144*s12**2*s13*s14 + 48*s12**2*s13*s23 + 48*s12**2*s13
     +    *s34 - 96*s12**2*s14*s23 - 144*s12**2*s14*s34 + 48*s12**2*s23
     +    *s34 + 48*s12**2*s34**2 - 288*s12*s13**2*s14 - 96*s12*s13*
     +    s14**2 - 288*s12*s13*s14*s23 - 192*s12*s13*s14*s34 - 240*s12*
     +    s14**2*s34 - 96*s12*s14*s23**2 - 96*s12*s14*s23*s34 - 288*
     +    s13**2*s14**2 + 48*s13*s14**3 - 336*s13*s14**2*s23 - 240*s13*
     +    s14**2*s34 + 96*s14**3*s23 - 48*s14**3*s34 - 96*s14**2*s23**2
     +     - 144*s14**2*s23*s34 - 48*s14**2*s34**2 )

      LB34 = LB34 + Ld314(p3,p4,p12)*S34**(-1)*S124**(-1) * (  - 48*s12
     +    *s13*s14**2 - 96*s12*s13*s14*s24 - 48*s12*s13*s24**2 - 48*s13
     +    *s14**3 - 96*s13*s14**2*s24 - 48*s13*s14*s24**2 )

      LB34 = LB34 + Ld314(p3,p4,p12)*S124**(-1) * (  - 48*s12**2*s13 - 
     +    48*s12**2*s14 + 48*s12**2*s24 + 96*s12**2*s34 - 48*s12*s13**2
     +     - 192*s12*s13*s14 - 96*s12*s13*s24 - 48*s12*s13*s34 - 96*s12
     +    *s14**2 - 48*s13**2*s14 - 144*s13*s14**2 - 96*s13*s14*s24 - 
     +    48*s13*s14*s34 - 48*s14**3 - 48*s14**2*s24 - 96*s14**2*s34 )

      LB34 = LB34 + Ld314(p4,p2,p13)*S13**(-1)*S24**(-1)*S34**(-1)*
     + S123**(-1)*S134 * ( 72*s12**3*s14**2 + 96*s12**2*s14**2*s23 + 24
     +    *s12*s14**2*s23**2 )

      LB34 = LB34 + Ld314(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*
     + S134 * ( 48*s12**3*s14 + 48*s12**2*s14*s23 )

      LB34 = LB34 + Ld314(p4,p2,p13)*S13**(-1)*S34**(-1)*S123**(-1)*
     + S134 * ( 24*s12**3*s14 + 24*s12**2*s14*s23 )

      LB34 = LB34 + Ld314(p4,p2,p13)*S24**(-1)*S34**(-1)*S123**(-1)*
     + S134 * ( 72*s12**2*s14**2 + 96*s12*s14**2*s23 + 24*s14**2*s23**2
     +     )

      LB34 = LB34 + Ld314(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * ( 48*
     +    s12**2*s14 + 48*s12*s14*s23 )

      LB34 = LB34 + Ld314(p4,p2,p13)*S34**(-1)*S123**(-1)*S134 * (  - 
     +    24*s12*s13*s14 - 24*s13*s14*s23 )

      LB34 = LB34 + Ld314(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1)
     +  * (  - 48*s12**3*s14*s34 + 48*s12**2*s14**2*s23 + 48*s12**2*
     +    s14**2*s34 - 48*s12**2*s14*s23*s34 - 48*s12**2*s14*s34**2 - 
     +    48*s12*s14**3*s23 + 48*s12*s14**2*s23**2 + 48*s12*s14**2*s23*
     +    s34 )

      LB34 = LB34 + Ld314(p4,p3,p12)*S13**(-1)*S123**(-1) * (  - 48*
     +    s12**2*s14*s24 - 96*s12**2*s14*s34 )

      LB34 = LB34 + Ld314(p4,p3,p12)*S24**(-1)*S34**(-1)*S123**(-1)
     +  * ( 48*s12*s13**2*s14**2 + 96*s12*s13*s14**2*s23 + 48*s12*
     +    s14**2*s23**2 + 48*s13**3*s14**2 + 96*s13**2*s14**2*s23 + 48*
     +    s13*s14**2*s23**2 )

      LB34 = LB34 + Ld314(p4,p3,p12)*S24**(-1)*S123**(-1) * ( 48*s12**2
     +    *s13*s14 + 144*s12**2*s14**2 - 48*s12**2*s14*s23 + 96*s12*
     +    s13**2*s14 + 336*s12*s13*s14**2 + 144*s12*s13*s14*s34 + 48*
     +    s12*s14**3 + 192*s12*s14**2*s23 + 240*s12*s14**2*s34 + 48*
     +    s13**3*s14 + 192*s13**2*s14**2 + 48*s13**2*s14*s23 + 96*
     +    s13**2*s14*s34 + 48*s13*s14**3 + 144*s13*s14**2*s23 + 192*s13
     +    *s14**2*s34 + 48*s13*s14*s23*s34 + 48*s13*s14*s34**2 - 48*
     +    s14**3*s23 + 48*s14**2*s23**2 + 48*s14**2*s23*s34 )

      LB34 = LB34 + Ld314(p4,p3,p12)*S34**(-1)*S123**(-1) * ( 96*s12*
     +    s14**3 + 192*s12*s14**2*s24 + 96*s12*s14*s24**2 + 96*s13*
     +    s14**3 + 192*s13*s14**2*s24 + 96*s13*s14*s24**2 )

      LB34 = LB34 + Ld314(p4,p3,p12)*S123**(-1) * ( 96*s12**2*s14 + 192
     +    *s12*s13*s14 + 336*s12*s14**2 + 192*s12*s14*s24 + 96*s12*s14*
     +    s34 + 96*s13**2*s14 + 336*s13*s14**2 + 240*s13*s14*s24 + 192*
     +    s13*s14*s34 )

      LB34 = LB34 + Ld322(p1,p2,p34)*S13**(-1)*S24**(-1)*S34**(-1)*S134
     +  * (  - 16*s12*s23**3 + 8*s14*s23**3 )

      LB34 = LB34 + Ld322(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * (  - 24
     +    *s12*s23**2 )

      LB34 = LB34 + Ld322(p1,p2,p34)*S24**(-1)*S34**(-1)*S134 * ( 32*
     +    s23**3 )

      LB34 = LB34 + Ld322(p1,p2,p34)*S34**(-1)*S134 * ( 24*s23**2 )

      LB34 = LB34 + Ld322(p2,p1,p34)*S24**(-1)*S34**(-1)*S234 * ( 16*
     +    s12*s13**2 - 32*s13**2*s23 - 24*s13*s14*s23 )

      LB34 = LB34 + Ld322(p2,p1,p34)*S24**(-1)*S234 * ( 24*s12*s13 )

      LB34 = LB34 + Ld322(p2,p1,p34)*S34**(-1)*S234 * (  - 8*s13**2 )

      LB34 = LB34 + Ld322(p3,p1,p24)*S13**(-1)*S24**(-1)*S34**(-1)*S234
     + *S124**(-1) * (  - 32*s12**4*s23 - 56*s12**3*s14*s23 - 24*s12**2
     +    *s14**2*s23 )

      LB34 = LB34 + Ld322(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*
     + S124**(-1) * (  - 8*s12**4 - 8*s12**3*s14 )

      LB34 = LB34 + Ld322(p3,p1,p24)*S24**(-1)*S34**(-1)*S234*
     + S124**(-1) * ( 16*s12**4 + 16*s12**3*s14 )

      LB34 = LB34 + Ld322(p3,p1,p24)*S34**(-1)*S234*S124**(-1) * ( 24*
     +    s12**3 + 24*s12**2*s14 )

      LB34 = LB34 + Ld322(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1)
     +  * (  - 48*s12**2*s14**2*s34 + 16*s12*s14**3*s23 - 48*s12*s14**3
     +    *s34 - 48*s12*s14**2*s23*s34 - 48*s12*s14**2*s34**2 - 16*
     +    s14**4*s23 - 32*s14**4*s34 + 16*s14**3*s23**2 - 16*s14**3*s23
     +    *s34 - 32*s14**3*s34**2 )

      LB34 = LB34 + Ld322(p3,p4,p12)*S13**(-1)*S124**(-1) * (  - 32*s12
     +    *s14**3 - 48*s12*s14**2*s24 - 96*s12*s14**2*s34 - 32*s14**4
     +     - 32*s14**3*s24 - 64*s14**3*s34 )

      LB34 = LB34 + Ld322(p3,p4,p12)*S24**(-1)*S34**(-1)*S124**(-1)
     +  * ( 16*s13**2*s14**3 + 32*s13*s14**3*s23 + 16*s14**3*s23**2 )

      LB34 = LB34 + Ld322(p3,p4,p12)*S24**(-1)*S124**(-1) * ( 64*s12*
     +    s14**3 - 48*s12*s14**2*s23 - 48*s12*s14**2*s34 + 48*s13*
     +    s14**3 + 32*s14**4 + 16*s14**3*s23 )

      LB34 = LB34 + Ld322(p3,p4,p12)*S34**(-1)*S124**(-1) * ( 48*s14**4
     +     + 96*s14**3*s24 + 48*s14**2*s24**2 )

      LB34 = LB34 + Ld322(p3,p4,p12)*S124**(-1) * ( 48*s12*s14**2 + 48*
     +    s13*s14**2 + 144*s14**3 + 96*s14**2*s24 + 48*s14**2*s34 )

      LB34 = LB34 + Ld322(p4,p2,p13)*S13**(-1)*S24**(-1)*S34**(-1)*
     + S123**(-1)*S134 * (  - 32*s12**4*s14 - 56*s12**3*s14*s23 - 24*
     +    s12**2*s14*s23**2 )

      LB34 = LB34 + Ld322(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*
     + S134 * (  - 8*s12**4 - 8*s12**3*s23 )

      LB34 = LB34 + Ld322(p4,p2,p13)*S13**(-1)*S34**(-1)*S123**(-1)*
     + S134 * ( 16*s12**4 + 16*s12**3*s23 )

      LB34 = LB34 + Ld322(p4,p2,p13)*S34**(-1)*S123**(-1)*S134 * ( 24*
     +    s12**3 + 24*s12**2*s23 )

      LB34 = LB34 + Ld322(p4,p3,p12)*S24**(-1)*S34**(-1)*S123**(-1)
     +  * (  - 48*s13**4*s14 - 96*s13**3*s14*s23 - 48*s13**2*s14*s23**2
     +     )

      LB34 = LB34 + Ld322(p4,p3,p12)*S24**(-1)*S123**(-1) * ( 48*s12**2
     +    *s13*s34 + 32*s12*s13**3 - 64*s12*s13**2*s14 + 48*s12*s13**2*
     +    s23 + 112*s12*s13**2*s34 - 48*s12*s13*s14*s23 - 48*s12*s13*
     +    s14*s34 + 48*s12*s13*s23*s34 + 48*s12*s13*s34**2 + 32*s13**4
     +     - 112*s13**3*s14 + 32*s13**3*s23 + 64*s13**3*s34 + 32*s13**2
     +    *s14**2 - 144*s13**2*s14*s23 - 32*s13**2*s14*s34 + 32*s13**2*
     +    s23*s34 + 32*s13**2*s34**2 + 48*s13*s14**2*s23 - 48*s13*s14*
     +    s23**2 - 48*s13*s14*s23*s34 )

      LB34 = LB34 + Ld322(p4,p3,p12)*S34**(-1)*S123**(-1) * (  - 16*
     +    s13**2*s14**2 - 32*s13**2*s14*s24 - 16*s13**2*s24**2 )

      LB34 = LB34 + Ld322(p4,p3,p12)*S123**(-1) * (  - 16*s12*s13**2 + 
     +    48*s12*s13*s24 + 96*s12*s13*s34 - 16*s13**3 - 16*s13**2*s14
     +     + 48*s13**2*s34 )

      LB34 = LB34 + Ld344(p1,p2,p34)*S24**(-1)*S34**(-1)*S134 * ( 24*
     +    s12*s13*s23 + 32*s13**2*s23 + 24*s13*s14*s23 )

      LB34 = LB34 + Ld344(p1,p2,p34)*S34**(-1)*S134 * ( 8*s13**2 )

      LB34 = LB34 + Ld344(p2,p1,p34)*S13**(-1)*S24**(-1)*S34**(-1)*S234
     +  * (  - 8*s14*s23**3 )

      LB34 = LB34 + Ld344(p2,p1,p34)*S24**(-1)*S34**(-1)*S234 * (  - 24
     +    *s12*s23**2 - 32*s23**3 )

      LB34 = LB34 + Ld344(p2,p1,p34)*S34**(-1)*S234 * (  - 24*s23**2 )

      LB34 = LB34 + Ld344(p3,p1,p24)*S13**(-1)*S24**(-1)*S34**(-1)*S234
     + *S124**(-1) * (  - 32*s12**2*s23**3 - 40*s12*s14*s23**3 - 8*
     +    s14**2*s23**3 )

      LB34 = LB34 + Ld344(p3,p1,p24)*S13**(-1)*S24**(-1)*S234*
     + S124**(-1) * (  - 24*s12**2*s23**2 - 24*s12*s14*s23**2 )

      LB34 = LB34 + Ld344(p3,p1,p24)*S24**(-1)*S34**(-1)*S234*
     + S124**(-1) * (  - 24*s12**2*s23**2 - 24*s12*s14*s23**2 )

      LB34 = LB34 + Ld344(p3,p4,p12)*S24**(-1)*S34**(-1)*S124**(-1)
     +  * ( 48*s13**4*s14 + 96*s13**3*s14*s23 + 48*s13**2*s14*s23**2 )

      LB34 = LB34 + Ld344(p3,p4,p12)*S24**(-1)*S124**(-1) * ( 16*s12*
     +    s13**3 + 64*s12*s13**2*s14 + 16*s12*s13**2*s34 + 48*s12*s13*
     +    s14*s23 + 144*s12*s13*s14*s34 + 160*s13**3*s14 - 32*s13**2*
     +    s14**2 + 192*s13**2*s14*s23 + 160*s13**2*s14*s34 - 48*s13*
     +    s14**2*s23 + 48*s13*s14**2*s34 + 48*s13*s14*s23**2 + 96*s13*
     +    s14*s23*s34 + 48*s13*s14*s34**2 )

      LB34 = LB34 + Ld344(p3,p4,p12)*S34**(-1)*S124**(-1) * ( 16*s13**2
     +    *s14**2 + 32*s13**2*s14*s24 + 16*s13**2*s24**2 )

      LB34 = LB34 + Ld344(p3,p4,p12)*S124**(-1) * ( 16*s12*s13**2 + 48*
     +    s12*s13*s14 + 16*s13**3 + 48*s13**2*s14 + 32*s13**2*s24 + 16*
     +    s13**2*s34 + 48*s13*s14**2 + 48*s13*s14*s24 + 96*s13*s14*s34
     +     )

      LB34 = LB34 + Ld344(p4,p2,p13)*S13**(-1)*S24**(-1)*S34**(-1)*
     + S123**(-1)*S134 * (  - 32*s12**2*s14**3 - 40*s12*s14**3*s23 - 8*
     +    s14**3*s23**2 )

      LB34 = LB34 + Ld344(p4,p2,p13)*S13**(-1)*S24**(-1)*S123**(-1)*
     + S134 * (  - 24*s12**2*s14**2 - 24*s12*s14**2*s23 )

      LB34 = LB34 + Ld344(p4,p2,p13)*S13**(-1)*S34**(-1)*S123**(-1)*
     + S134 * (  - 24*s12**2*s14**2 - 24*s12*s14**2*s23 )

      LB34 = LB34 + Ld344(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1)
     +  * (  - 16*s12*s14**3*s23 - 32*s12*s14**3*s34 + 16*s14**4*s23 - 
     +    16*s14**3*s23**2 - 16*s14**3*s23*s34 )

      LB34 = LB34 + Ld344(p4,p3,p12)*S13**(-1)*S123**(-1) * (  - 16*s12
     +    *s14**3 )

      LB34 = LB34 + Ld344(p4,p3,p12)*S24**(-1)*S34**(-1)*S123**(-1)
     +  * (  - 16*s13**2*s14**3 - 32*s13*s14**3*s23 - 16*s14**3*s23**2
     +     )

      LB34 = LB34 + Ld344(p4,p3,p12)*S24**(-1)*S123**(-1) * (  - 48*s12
     +    *s13*s14**2 - 64*s12*s14**3 - 96*s12*s14**2*s34 - 48*s13**2*
     +    s14**2 - 80*s13*s14**3 - 48*s13*s14**2*s23 - 96*s13*s14**2*
     +    s34 - 32*s14**4 - 48*s14**3*s23 - 112*s14**3*s34 - 48*s14**2*
     +    s23*s34 - 48*s14**2*s34**2 )

      LB34 = LB34 + Ld344(p4,p3,p12)*S34**(-1)*S123**(-1) * (  - 48*
     +    s14**4 - 96*s14**3*s24 - 48*s14**2*s24**2 )

      LB34 = LB34 + Ld344(p4,p3,p12)*S123**(-1) * (  - 48*s12*s14**2 - 
     +    48*s13*s14**2 - 192*s14**3 - 144*s14**2*s24 - 144*s14**2*s34
     +     )

      LB34 = LB34 + Le1(p1,p2,p4,p3)*S13**(-1) * ( 16*s12**4 + 48*
     +    s12**3*s14 + 56*s12**2*s14**2 + 32*s12*s14**3 + 8*s14**4 )

      LB34 = LB34 + Le1(p1,p2,p4,p3)*S24**(-1) * ( 8*s12**2*s13*s23 + 
     +    16*s12**2*s13*s34 + 8*s12**2*s14*s34 + 8*s12**2*s23**2 + 16*
     +    s12**2*s23*s34 + 16*s12**2*s34**2 - 8*s12*s13**2*s23 + 24*s12
     +    *s13*s14*s34 - 8*s12*s13*s23**2 - 24*s12*s13*s23*s34 - 8*s12*
     +    s13*s34**2 + 16*s12*s14**2*s34 + 16*s12*s14*s34**2 - 8*s12*
     +    s23**2*s34 - 16*s12*s23*s34**2 - 8*s12*s34**3 + 8*s13**2*s14*
     +    s34 + 16*s13*s14**2*s34 + 8*s13*s14*s34**2 + 8*s14**3*s34 + 8
     +    *s14**2*s34**2 )

      LB34 = LB34 + Le1(p1,p2,p4,p3)*S34**(-1) * (  - 8*s12**3*s23 - 16
     +    *s12**3*s24 - 8*s12**2*s13*s24 - 16*s12**2*s14*s24 - 8*s12*
     +    s13*s14*s24 - 8*s12*s14**2*s24 )

      LB34 = LB34 + Le1(p1,p2,p4,p3) * ( 8*s12**3 + 32*s12**2*s14 + 8*
     +    s12**2*s23 + 8*s12**2*s34 - 16*s12*s13**2 - 8*s12*s13*s14 - 
     +    16*s12*s13*s23 - 8*s12*s13*s24 - 16*s12*s13*s34 + 24*s12*
     +    s14**2 + 8*s12*s14*s34 - 8*s12*s23*s34 + 8*s13**2*s34 + 16*
     +    s13*s14*s34 + 8*s13*s34**2 + 8*s14**3 + 8*s14**2*s34 + 8*s14*
     +    s34**2 )

      LB34 = LB34 + Le1(p2,p1,p3,p4)*S13**(-1) * ( 8*s12**2*s14**2 + 8*
     +    s12**2*s14*s24 + 16*s12**2*s14*s34 + 8*s12**2*s23*s34 + 16*
     +    s12**2*s24*s34 + 16*s12**2*s34**2 - 8*s12*s14**2*s24 - 8*s12*
     +    s14**2*s34 - 8*s12*s14*s24**2 - 24*s12*s14*s24*s34 - 16*s12*
     +    s14*s34**2 + 16*s12*s23**2*s34 + 24*s12*s23*s24*s34 + 16*s12*
     +    s23*s34**2 - 8*s12*s24*s34**2 - 8*s12*s34**3 + 8*s23**3*s34
     +     + 16*s23**2*s24*s34 + 8*s23**2*s34**2 + 8*s23*s24**2*s34 + 8
     +    *s23*s24*s34**2 )

      LB34 = LB34 + Le1(p2,p1,p3,p4)*S24**(-1) * ( 16*s12**4 + 48*
     +    s12**3*s23 + 56*s12**2*s23**2 + 32*s12*s23**3 + 8*s23**4 )

      LB34 = LB34 + Le1(p2,p1,p3,p4)*S34**(-1) * (  - 16*s12**3*s13 - 8
     +    *s12**3*s14 - 16*s12**2*s13*s23 - 8*s12**2*s13*s24 - 8*s12*
     +    s13*s23**2 - 8*s12*s13*s23*s24 )

      LB34 = LB34 + Le1(p2,p1,p3,p4) * ( 8*s12**3 + 8*s12**2*s14 + 32*
     +    s12**2*s23 + 8*s12**2*s34 - 8*s12*s13*s24 - 16*s12*s14*s24 - 
     +    8*s12*s14*s34 + 24*s12*s23**2 - 8*s12*s23*s24 + 8*s12*s23*s34
     +     - 16*s12*s24**2 - 16*s12*s24*s34 + 8*s23**3 + 8*s23**2*s34
     +     + 16*s23*s24*s34 + 8*s23*s34**2 + 8*s24**2*s34 + 8*s24*
     +    s34**2 )

      LB34 = LB34 + Le1(p3,p1,p2,p4)*S13**(-1)*S34**(-1) * ( 16*s12**2*
     +    s14*s23**2 + 16*s12**2*s14*s23*s24 + 16*s12**2*s23**2*s24 + 
     +    16*s12**2*s23*s24**2 + 16*s12*s14**2*s23**2 + 16*s12*s14**2*
     +    s23*s24 + 16*s12*s14*s23**3 + 32*s12*s14*s23**2*s24 + 16*s12*
     +    s14*s23*s24**2 + 16*s12*s23**3*s24 + 16*s12*s23**2*s24**2 + 8
     +    *s14**3*s23**2 + 8*s14**3*s23*s24 + 8*s14**2*s23**2*s24 + 8*
     +    s14**2*s23*s24**2 + 8*s14*s23**4 + 8*s14*s23**3*s24 + 8*
     +    s23**4*s24 + 8*s23**3*s24**2 )

      LB34 = LB34 + Le1(p3,p1,p2,p4)*S13**(-1) * ( 16*s12**2*s14*s23 + 
     +    16*s12**2*s23**2 + 32*s12**2*s23*s24 + 16*s12**2*s23*s34 + 16
     +    *s12*s14**2*s23 + 64*s12*s14*s23**2 + 64*s12*s14*s23*s24 + 48
     +    *s12*s14*s23*s34 + 16*s12*s23**3 + 48*s12*s23**2*s24 + 48*s12
     +    *s23**2*s34 + 16*s12*s23*s24**2 + 48*s12*s23*s24*s34 + 32*s12
     +    *s23*s34**2 + 8*s14**3*s23 + 24*s14**2*s23**2 + 32*s14**2*s23
     +    *s24 + 24*s14**2*s23*s34 + 24*s14*s23**3 + 32*s14*s23**2*s24
     +     + 40*s14*s23**2*s34 + 16*s14*s23*s24**2 + 40*s14*s23*s24*s34
     +     + 24*s14*s23*s34**2 + 8*s23**4 + 16*s23**3*s24 + 24*s23**3*
     +    s34 + 24*s23**2*s24*s34 + 24*s23**2*s34**2 + 8*s23*s24**2*s34
     +     + 16*s23*s24*s34**2 + 8*s23*s34**3 )

      LB34 = LB34 + Le1(p3,p1,p2,p4)*S24**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s13**2*s14 - 16*s12**2*s13*s14**2 - 16*s12**2*s13*s14*
     +    s23 - 16*s12**2*s14**2*s23 - 16*s12*s13**2*s14**2 - 16*s12*
     +    s13**2*s14*s23 - 16*s12*s13*s14**3 - 32*s12*s13*s14**2*s23 - 
     +    16*s12*s13*s14*s23**2 - 16*s12*s14**3*s23 - 16*s12*s14**2*
     +    s23**2 - 8*s13**2*s14**3 - 8*s13**2*s14*s23**2 - 8*s13*s14**4
     +     - 8*s13*s14**3*s23 - 8*s13*s14**2*s23**2 - 8*s13*s14*s23**3
     +     - 8*s14**4*s23 - 8*s14**2*s23**3 )

      LB34 = LB34 + Le1(p3,p1,p2,p4)*S24**(-1) * (  - 32*s12**2*s13*s14
     +     - 16*s12**2*s14**2 - 16*s12**2*s14*s23 - 16*s12**2*s14*s34
     +     - 16*s12*s13**2*s14 - 48*s12*s13*s14**2 - 64*s12*s13*s14*s23
     +     - 48*s12*s13*s14*s34 - 16*s12*s14**3 - 64*s12*s14**2*s23 - 
     +    48*s12*s14**2*s34 - 16*s12*s14*s23**2 - 48*s12*s14*s23*s34 - 
     +    32*s12*s14*s34**2 - 16*s13**2*s14*s23 - 8*s13**2*s14*s34 - 16
     +    *s13*s14**3 - 32*s13*s14**2*s23 - 24*s13*s14**2*s34 - 32*s13*
     +    s14*s23**2 - 40*s13*s14*s23*s34 - 16*s13*s14*s34**2 - 8*
     +    s14**4 - 24*s14**3*s23 - 24*s14**3*s34 - 24*s14**2*s23**2 - 
     +    40*s14**2*s23*s34 - 24*s14**2*s34**2 - 8*s14*s23**3 - 24*s14*
     +    s23**2*s34 - 24*s14*s23*s34**2 - 8*s14*s34**3 )

      LB34 = LB34 + Le1(p3,p1,p2,p4)*S34**(-1) * (  - 16*s12**2*s13*s14
     +     + 16*s12**2*s13*s23 - 16*s12**2*s14**2 - 16*s12**2*s14*s24
     +     + 16*s12**2*s23**2 + 16*s12**2*s23*s24 - 16*s12*s13**2*s14
     +     - 32*s12*s13*s14**2 - 16*s12*s13*s14*s23 - 16*s12*s13*s14*
     +    s24 + 16*s12*s13*s23**2 + 16*s12*s13*s23*s24 - 16*s12*s14**3
     +     - 16*s12*s14**2*s23 - 16*s12*s14**2*s24 + 16*s12*s14*s23**2
     +     + 16*s12*s14*s23*s24 + 16*s12*s23**3 + 32*s12*s23**2*s24 + 
     +    16*s12*s23*s24**2 + 8*s13**2*s14*s24 - 8*s13*s14**3 - 8*s13*
     +    s14*s23**2 + 8*s13*s23**3 - 8*s13*s23*s24**2 - 8*s14**4 - 8*
     +    s14**3*s24 + 8*s14**2*s23*s24 + 8*s23**4 + 8*s23**3*s24 )

      LB34 = LB34 + Le1(p3,p1,p2,p4) * (  - 32*s12**2*s14 + 32*s12**2*
     +    s23 - 64*s12*s13*s14 + 16*s12*s13*s23 - 64*s12*s14**2 - 16*
     +    s12*s14*s24 - 48*s12*s14*s34 + 64*s12*s23**2 + 64*s12*s23*s24
     +     + 48*s12*s23*s34 - 24*s13*s14**2 - 24*s13*s14*s23 - 16*s13*
     +    s14*s34 + 16*s13*s23**2 + 8*s13*s23*s34 - 32*s14**3 - 16*
     +    s14**2*s23 - 16*s14**2*s24 - 40*s14**2*s34 + 16*s14*s23**2 + 
     +    24*s14*s23*s24 - 8*s14*s24*s34 - 16*s14*s34**2 + 32*s23**3 + 
     +    24*s23**2*s24 + 40*s23**2*s34 + 16*s23*s24*s34 + 16*s23*
     +    s34**2 )

      LB34 = LB34 - 248*s12 + 4*s13 - 28*s14 - 164*s23 - 264*s24 - 200*
     +    s34

      LB34e=-LB34/s134/s234
      
      return
      end
      
      
      function LC(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)

      LC=LCa(p1,p2,p3,p4)+LCb(p1,p2,p3,p4)+LCc(p1,p2,p3,p4)
     .  +LCd(p1,p2,p3,p4)+LCe(p1,p2,p3,p4)+LCf(p1,p2,p3,p4)
     .  +LCg(p1,p2,p3,p4)+LCh(p1,p2,p3,p4)+LCi(p1,p2,p3,p4)

      return
      end

      function LCa(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LC=0d0

      LC = LC + S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 216*
     +    s12**3*s34**2 + 1008*s12**2*s34**3 )

      LC = LC + S13**(-1)*S14**(-1)*S23**(-1) * (  - 480*s12**3*s34 + 
     +    48*s12**2*s24**2 + 440*s12**2*s24*s34 + 1456*s12**2*s34**2 + 
     +    144*s12*s24**3 + 976*s12*s24**2*s34 + 1560*s12*s24*s34**2 + 
     +    728*s12*s34**3 + 144*s24**4 - 88*s24**3*s34 - 32*s24**2*
     +    s34**2 + 48*s24*s34**3 )

      LC = LC + S13**(-1)*S14**(-1)*S24**(-1) * (  - 384*s12**3*s34 + 
     +    504*s12**2*s23*s34 + 1184*s12**2*s34**2 - 72*s12*s23**2*s34
     +     + 504*s12*s23*s34**2 + 600*s12*s34**3 + 24*s23**2*s34**2 + 
     +    48*s23*s34**3 )

      LC = LC + S13**(-1)*S14**(-1) * (  - 96*s12**2*s23 - 48*s12**2*
     +    s24 + 472*s12**2*s34 + 48*s12*s23*s24 + 696*s12*s23*s34 + 192
     +    *s12*s24**2 + 1520*s12*s24*s34 + 2960*s12*s34**2 + 72*s23**2*
     +    s24 + 72*s23**2*s34 + 192*s23*s24**2 + 312*s23*s24*s34 + 144*
     +    s23*s34**2 + 264*s24**3 + 136*s24**2*s34 + 168*s24*s34**2 )

      LC = LC + S13**(-1)*S23**(-1)*S24**(-1) * (  - 456*s12**3*s34 - 
     +    784*s12**2*s14*s34 + 1400*s12**2*s34**2 + 952*s12*s14**2*s34
     +     - 1056*s12*s14*s34**2 + 760*s12*s34**3 + 40*s14**2*s34**2 )

      LC = LC + S13**(-1)*S23**(-1) * (  - 240*s12**2*s24 - 1184*s12**2
     +    *s34 - 336*s12*s14**2 - 480*s12*s14*s24 + 2352*s12*s14*s34 - 
     +    24*s12*s24**2 + 2160*s12*s24*s34 + 1176*s12*s34**2 - 24*
     +    s14**3 + 72*s14**2*s24 - 144*s14**2*s34 + 336*s14*s24**2 - 
     +    112*s14*s24*s34 + 96*s14*s34**2 + 384*s24**3 - 32*s24**2*s34
     +     + 192*s24*s34**2 + 48*s34**3 )

      LC = LC + S13**(-1)*S24**(-1) * (  - 288*s12**2*s23 - 912*s12**2*
     +    s34 - 360*s12*s14**2 - 120*s12*s14*s23 + 2336*s12*s14*s34 + 
     +    576*s12*s23*s34 + 96*s12*s34**2 + 24*s14**3 + 48*s14**2*s23
     +     - 360*s14**2*s34 + 48*s14*s23**2 - 80*s14*s23*s34 + 248*s14*
     +    s34**2 - 32*s23**2*s34 + 88*s23*s34**2 )

      LC = LC + S13**(-1) * (  - 480*s12**2 - 696*s12*s14 - 72*s12*s23
     +     - 192*s12*s24 + 1528*s12*s34 + 240*s14**2 + 192*s14*s23 + 
     +    528*s14*s24 - 480*s14*s34 + 72*s23**2 + 288*s23*s24 + 56*s23*
     +    s34 + 600*s24**2 + 112*s24*s34 + 272*s34**2 )

      LC = LC + S14**(-1)*S23**(-1)*S24**(-1) * ( 24*s12**3*s34 + 176*
     +    s12**2*s13*s34 - 824*s12**2*s34**2 - 24*s12*s13**2*s34 - 64*
     +    s12*s13*s34**2 + 40*s12*s34**3 - 24*s13**2*s34**2 )

      LC = LC + S14**(-1)*S23**(-1) * (  - 48*s12**2*s24 - 392*s12**2*
     +    s34 - 24*s12*s13**2 + 72*s12*s13*s24 + 80*s12*s13*s34 - 120*
     +    s12*s24**2 - 288*s12*s24*s34 - 616*s12*s34**2 - 96*s13**2*s24
     +     - 72*s13**2*s34 + 168*s13*s24**2 + 192*s13*s24*s34 + 48*s13*
     +    s34**2 - 144*s24**3 - 64*s24**2*s34 - 72*s24*s34**2 )

      LC = LC + S14**(-1)*S24**(-1) * (  - 424*s12**2*s34 - 32*s12*s13*
     +    s34 + 16*s12*s23*s34 - 352*s12*s34**2 - 24*s13*s34**2 + 24*
     +    s23*s34**2 + 48*s34**3 )

      LC = LC + S14**(-1) * (  - 24*s12*s13 - 24*s12*s23 - 48*s12*s24
     +     - 520*s12*s34 + 24*s13**2 + 48*s13*s23 + 24*s13*s24 + 24*
     +    s23**2 - 24*s23*s24 + 48*s23*s34 - 96*s24**2 - 24*s24*s34 + 
     +    120*s34**2 )

      LC = LC + S23**(-1)*S24**(-1) * (  - 96*s12**2*s13 - 96*s12**2*
     +    s14 + 1008*s12**2*s34 + 24*s12*s13**2 - 192*s12*s13*s14 + 416
     +    *s12*s13*s34 + 24*s12*s14**2 - 560*s12*s14*s34 - 72*s12*
     +    s34**2 - 72*s13**2*s14 + 32*s13**2*s34 - 72*s13*s14**2 - 72*
     +    s13*s14*s34 + 8*s13*s34**2 + 32*s14**2*s34 - 56*s14*s34**2 )

      LC = LC + S23**(-1) * ( 240*s12**2 - 72*s12*s13 + 384*s12*s14 + 
     +    144*s12*s24 - 560*s12*s34 - 72*s13**2 + 24*s13*s14 + 120*s13*
     +    s24 - 8*s13*s34 - 144*s14*s24 + 152*s14*s34 - 264*s24**2 - 40
     +    *s24*s34 - 80*s34**2 )

      LC = LC + S24**(-1) * ( 240*s12**2 + 48*s12*s13 + 264*s12*s14 - 
     +    448*s12*s34 - 24*s13**2 + 48*s13*s14 - 48*s13*s23 - 40*s13*
     +    s34 - 96*s14**2 + 232*s14*s34 - 24*s23**2 - 8*s23*s34 - 120*
     +    s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * (  - 1160*s12**4*s34 + 1968*s12**3*s34**2 - 1832*
     +    s12**2*s34**3 )

      LC = LC + log(s12**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1) * ( 
     +     - 72*s12**3*s24 + 1760*s12**3*s34 + 1432*s12**2*s24**2 + 
     +    3160*s12**2*s24*s34 - 2280*s12**2*s34**2 + 1368*s12*s24**3 - 
     +    2632*s12*s24**2*s34 - 1368*s12*s24*s34**2 - 848*s12*s34**3 - 
     +    320*s24**4 + 120*s24**3*s34 + 80*s24**2*s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1) * ( 
     +     - 72*s12**3*s23 + 1520*s12**3*s34 + 16*s12**2*s23**2 + 272*
     +    s12**2*s23*s34 - 1848*s12**2*s34**2 - 48*s12*s23**2*s34 - 192
     +    *s12*s23*s34**2 - 480*s12*s34**3 )

      LC = LC + log(s12**(-1)*s1234)*S13**(-1)*S14**(-1)*S34**(-1) * ( 
     +    32*s12**2*s23**2 + 64*s12**2*s23*s24 + 32*s12**2*s24**2 + 32*
     +    s12*s23**2*s24 + 32*s12*s23*s24**2 )

      LC = LC + log(s12**(-1)*s1234)*S13**(-1)*S14**(-1) * (  - 288*
     +    s12**3 + 584*s12**2*s23 + 1712*s12**2*s24 + 2472*s12**2*s34
     +     + 32*s12*s23**2 + 496*s12*s23*s24 - 1144*s12*s23*s34 + 1528*
     +    s12*s24**2 - 2904*s12*s24*s34 - 1440*s12*s34**2 + 16*s23**3
     +     - 48*s23**2*s24 + 16*s23**2*s34 - 392*s23*s24**2 - 48*s23*
     +    s24*s34 - 48*s23*s34**2 - 648*s24**3 - 56*s24**2*s34 - 80*s24
     +    *s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1) * ( 
     +     - 8*s12**3*s14 + 1960*s12**3*s34 - 256*s12**2*s14**2 + 6256*
     +    s12**2*s14*s34 - 5104*s12**2*s34**2 - 1368*s12*s14**2*s34 + 
     +    976*s12*s14*s34**2 + 736*s12*s34**3 + 688*s14**2*s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S13**(-1)*S23**(-1) * (  - 304*
     +    s12**3 - 416*s12**2*s14 + 1984*s12**2*s24 + 6072*s12**2*s34
     +     + 1568*s12*s14**2 + 4328*s12*s14*s24 - 7208*s12*s14*s34 + 
     +    3816*s12*s24**2 - 7768*s12*s24*s34 - 1344*s12*s34**2 - 8*
     +    s14**3 - 416*s14**2*s24 + 416*s14**2*s34 - 1032*s14*s24**2 + 
     +    392*s14*s24*s34 + 672*s14*s34**2 - 960*s24**3 + 96*s24**2*s34
     +     + 128*s24*s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-1) * ( 
     +    32*s12**2*s23**2 - 32*s12*s14**2*s23 + 32*s12*s14*s23**2 )

      LC = LC + log(s12**(-1)*s1234)*S13**(-1)*S24**(-1) * (  - 304*
     +    s12**3 - 536*s12**2*s14 + 1224*s12**2*s23 + 2696*s12**2*s34
     +     + 1704*s12*s14**2 + 984*s12*s14*s23 - 6632*s12*s14*s34 - 144
     +    *s12*s23**2 - 2192*s12*s23*s34 + 560*s12*s34**2 + 8*s14**3 - 
     +    312*s14**2*s23 + 544*s14**2*s34 - 24*s14*s23**2 + 440*s14*s23
     +    *s34 + 480*s14*s34**2 - 16*s23**3 + 80*s23**2*s34 + 112*s23*
     +    s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S13**(-1)*S34**(-1) * ( 48*s12**2*
     +    s23 + 16*s12**2*s24 - 16*s12*s14**2 + 16*s12*s14*s23 - 16*s12
     +    *s14*s24 + 32*s12*s23**2 + 32*s12*s23*s24 )

      LC = LC + log(s12**(-1)*s1234)*S13**(-1) * ( 2520*s12**2 + 4848*
     +    s12*s14 + 704*s12*s23 + 3888*s12*s24 - 6888*s12*s34 - 632*
     +    s14**2 - 640*s14*s23 - 1496*s14*s24 + 1056*s14*s34 - 208*
     +    s23**2 - 952*s23*s24 + 304*s23*s34 - 1648*s24**2 + 248*s24*
     +    s34 + 512*s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1) * ( 
     +     - 8*s12**3*s13 - 584*s12**3*s34 - 16*s12**2*s13**2 + 224*
     +    s12**2*s13*s34 + 680*s12**2*s34**2 + 240*s12*s13**2*s34 - 512
     +    *s12*s13*s34**2 + 352*s12*s34**3 )

      LC = LC + log(s12**(-1)*s1234)*S14**(-1)*S23**(-1)*S34**(-1) * ( 
     +    32*s12**2*s24**2 - 32*s12*s13**2*s24 + 32*s12*s13*s24**2 )

      LC = LC + log(s12**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 32*s12**3
     +     + 184*s12**2*s13 - 600*s12**2*s24 - 1328*s12**2*s34 + 64*s12
     +    *s13**2 - 32*s12*s13*s24 - 568*s12*s13*s34 - 488*s12*s24**2
     +     + 968*s12*s24*s34 + 840*s12*s34**2 + 80*s13**2*s24 - 16*
     +    s13**2*s34 - 248*s13*s24**2 - 96*s13*s24*s34 - 32*s13*s34**2
     +     + 320*s24**3 + 56*s24**2*s34 + 16*s24*s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S14**(-1)*S24**(-1) * ( 32*s12**3
     +     + 16*s12**2*s13 - 32*s12**2*s23 - 432*s12**2*s34 - 168*s12*
     +    s13*s34 + 104*s12*s23*s34 + 320*s12*s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S14**(-1)*S34**(-1) * ( 16*s12**2*
     +    s23 + 48*s12**2*s24 - 16*s12*s13**2 - 16*s12*s13*s23 + 16*s12
     +    *s13*s24 + 32*s12*s23*s24 + 32*s12*s24**2 )

      LC = LC + log(s12**(-1)*s1234)*S14**(-1) * (  - 552*s12**2 - 112*
     +    s12*s13 + 48*s12*s23 - 120*s12*s24 + 976*s12*s34 + 16*s13*s23
     +     - 80*s13*s24 + 32*s13*s34 - 16*s23**2 + 64*s23*s24 - 16*s23*
     +    s34 + 328*s24**2 + 64*s24*s34 + 48*s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S23**(-1)*S24**(-1)*S34**(-1) * ( 
     +     - 32*s12*s13**2*s14 - 32*s12*s13*s14**2 )

      LC = LC + log(s12**(-1)*s1234)*S23**(-1)*S24**(-1) * ( 80*s12**3
     +     + 712*s12**2*s13 + 952*s12**2*s14 - 1112*s12**2*s34 + 80*s12
     +    *s13**2 + 728*s12*s13*s14 - 416*s12*s13*s34 + 80*s12*s14**2
     +     + 1192*s12*s14*s34 - 272*s12*s34**2 + 152*s13**2*s14 - 80*
     +    s13**2*s34 + 152*s13*s14**2 + 168*s13*s14*s34 + 352*s13*
     +    s34**2 - 80*s14**2*s34 - 336*s14*s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S23**(-1)*S34**(-1) * ( 80*s12**2*
     +    s13 + 80*s12**2*s14 + 32*s12*s13*s14 + 16*s12*s13*s24 + 32*
     +    s12*s14**2 + 48*s12*s14*s24 + 16*s12*s24**2 )

      LC = LC + log(s12**(-1)*s1234)*S23**(-1) * (  - 840*s12**2 + 416*
     +    s12*s13 - 1648*s12*s14 - 1528*s12*s24 + 1944*s12*s34 + 160*
     +    s13**2 - 160*s13*s14 - 392*s13*s24 + 80*s13*s34 + 8*s14**2 + 
     +    408*s14*s24 - 320*s14*s34 + 640*s24**2 - 104*s24*s34 - 304*
     +    s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S24**(-1)*S34**(-1) * ( 80*s12**2*
     +    s13 + 80*s12**2*s14 + 32*s12*s13**2 + 32*s12*s13*s14 + 48*s12
     +    *s13*s23 + 16*s12*s14*s23 + 16*s12*s23**2 )

      LC = LC + log(s12**(-1)*s1234)*S24**(-1) * (  - 696*s12**2 - 56*
     +    s12*s13 - 1200*s12*s14 + 152*s12*s23 + 1328*s12*s34 - 152*s13
     +    *s14 + 144*s13*s34 + 152*s14**2 + 8*s14*s23 - 432*s14*s34 + 
     +    16*s23**2 - 128*s23*s34 - 224*s34**2 )

      LC = LC + log(s12**(-1)*s1234)*S34**(-1) * ( 80*s12*s13 + 80*s12*
     +    s14 - 16*s12*s23 - 16*s12*s24 )

      LC = LC + log(s12**(-1)*s1234) * (  - 616*s12 - 160*s13 + 472*s14
     +     + 208*s23 + 680*s24 - 160*s34 )

      LC = LC + log(s13**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1) * ( 
     +    16*s12**2*s13**2 + 24*s12**2*s13*s34 + 8*s12**2*s34**2 - 16*
     +    s12*s13**2*s34 )

      LC = LC + log(s13**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 8*s12**2*
     +    s13 + 8*s12**2*s34 + 16*s12*s13**2 - 24*s12*s13*s34 - 16*s12*
     +    s24*s34 - 8*s13**3 + 8*s13**2*s24 + 8*s13**2*s34 + 16*s13*
     +    s24**2 )

      LC = LC + log(s13**(-1)*s1234)*S14**(-1)*S24**(-1) * ( 8*s12**2*
     +    s13 + 8*s12**2*s34 + 16*s12*s13**2 - 8*s12*s13*s34 - 8*s13*
     +    s23*s34 )

      LC = LC + log(s13**(-1)*s1234)*S14**(-1)*S34**(-1) * ( 24*s13*
     +    s23**2 - 24*s13*s24**2 )

      LC = LC + log(s13**(-1)*s1234)*S14**(-1) * ( 8*s13**2 - 24*s13*
     +    s34 - 24*s23**2 - 24*s23*s24 )

      LC = LC + log(s13**(-1)*s1234)*S23**(-1)*S24**(-1) * ( 24*s12**2*
     +    s13 + 8*s12**2*s14 + 16*s12**2*s34 + 32*s12*s13**2 + 40*s12*
     +    s13*s14 + 16*s12*s13*s34 + 8*s12*s14**2 + 8*s12*s14*s34 )

      LC = LC + log(s13**(-1)*s1234)*S23**(-1) * ( 8*s12**2 + 24*s12*
     +    s13 + 8*s12*s14 - 8*s13**2 - 16*s13*s14 - 16*s14**2 - 16*s14*
     +    s34 )

      LC = LC + log(s13**(-1)*s1234)*S24**(-1) * ( 8*s12**2 + 24*s12*
     +    s13 + 8*s12*s14 + 8*s13*s14 + 8*s13*s23 + 8*s14**2 + 8*s14*
     +    s23 + 8*s14*s34 )

      LC = LC + log(s13**(-1)*s1234)*S34**(-1) * ( 24*s23**2 + 24*s23*
     +    s24 )

      LC = LC + log(s13**(-1)*s1234) * ( 24*s13 + 8*s14 )

      LC = LC + log(s14**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1) * ( 
     +    16*s12**2*s14**2 + 24*s12**2*s14*s34 + 8*s12**2*s34**2 - 16*
     +    s12*s14**2*s34 )

      LC = LC + log(s14**(-1)*s1234)*S13**(-1)*S23**(-1) * ( 8*s12**2*
     +    s14 + 8*s12**2*s34 + 16*s12*s14**2 - 8*s12*s14*s34 - 8*s14*
     +    s24*s34 )

      LC = LC + log(s14**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 8*s12**2*
     +    s14 + 8*s12**2*s34 + 16*s12*s14**2 - 24*s12*s14*s34 - 16*s12*
     +    s23*s34 - 8*s14**3 + 8*s14**2*s23 + 8*s14**2*s34 + 16*s14*
     +    s23**2 )

      LC = LC + log(s14**(-1)*s1234)*S13**(-1)*S34**(-1) * (  - 24*s14*
     +    s23**2 + 24*s14*s24**2 )

      LC = LC + log(s14**(-1)*s1234)*S13**(-1) * ( 8*s14**2 - 24*s14*
     +    s34 - 24*s23*s24 - 24*s24**2 )

      LC = LC + log(s14**(-1)*s1234)*S23**(-1)*S24**(-1) * ( 8*s12**2*
     +    s13 + 24*s12**2*s14 + 16*s12**2*s34 + 8*s12*s13**2 + 40*s12*
     +    s13*s14 + 8*s12*s13*s34 + 32*s12*s14**2 + 16*s12*s14*s34 )

      LC = LC + log(s14**(-1)*s1234)*S23**(-1) * ( 8*s12**2 + 8*s12*s13
     +     + 24*s12*s14 + 8*s13**2 + 8*s13*s14 + 8*s13*s24 + 8*s13*s34
     +     + 8*s14*s24 )

      LC = LC + log(s14**(-1)*s1234)*S24**(-1) * ( 8*s12**2 + 8*s12*s13
     +     + 24*s12*s14 - 16*s13**2 - 16*s13*s14 - 16*s13*s34 - 8*
     +    s14**2 )

      LC = LC + log(s14**(-1)*s1234)*S34**(-1) * ( 24*s23*s24 + 24*
     +    s24**2 )

      LC = LC + log(s14**(-1)*s1234) * ( 8*s13 + 24*s14 )

      LC = LC + log(s23**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1) * ( 
     +    16*s12**2*s23**2 + 24*s12**2*s23*s34 + 8*s12**2*s34**2 - 16*
     +    s12*s23**2*s34 )

      LC = LC + log(s23**(-1)*s1234)*S13**(-1)*S14**(-1) * ( 24*s12**2*
     +    s23 + 8*s12**2*s24 + 16*s12**2*s34 + 32*s12*s23**2 + 40*s12*
     +    s23*s24 + 16*s12*s23*s34 + 8*s12*s24**2 + 8*s12*s24*s34 )

      LC = LC + log(s23**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 8*s12**2*
     +    s23 + 8*s12**2*s34 - 16*s12*s14*s34 + 16*s12*s23**2 - 24*s12*
     +    s23*s34 + 16*s14**2*s23 + 8*s14*s23**2 - 8*s23**3 + 8*s23**2*
     +    s34 )

      LC = LC + log(s23**(-1)*s1234)*S13**(-1) * ( 8*s12**2 + 24*s12*
     +    s23 + 8*s12*s24 - 8*s23**2 - 16*s23*s24 - 16*s24**2 - 16*s24*
     +    s34 )

      LC = LC + log(s23**(-1)*s1234)*S14**(-1)*S24**(-1) * ( 8*s12**2*
     +    s23 + 8*s12**2*s34 + 16*s12*s23**2 - 8*s12*s23*s34 - 8*s13*
     +    s23*s34 )

      LC = LC + log(s23**(-1)*s1234)*S14**(-1) * ( 8*s12**2 + 24*s12*
     +    s23 + 8*s12*s24 + 8*s13*s23 + 8*s13*s24 + 8*s23*s24 + 8*
     +    s24**2 + 8*s24*s34 )

      LC = LC + log(s23**(-1)*s1234)*S24**(-1)*S34**(-1) * ( 24*s13**2*
     +    s23 - 24*s14**2*s23 )

      LC = LC + log(s23**(-1)*s1234)*S24**(-1) * (  - 24*s13**2 - 24*
     +    s13*s14 + 8*s23**2 - 24*s23*s34 )

      LC = LC + log(s23**(-1)*s1234)*S34**(-1) * ( 24*s13**2 + 24*s13*
     +    s14 )

      LC = LC + log(s23**(-1)*s1234) * ( 24*s23 + 8*s24 )

      LC = LC + log(s24**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1) * ( 
     +    16*s12**2*s24**2 + 24*s12**2*s24*s34 + 8*s12**2*s34**2 - 16*
     +    s12*s24**2*s34 )

      LC = LC + log(s24**(-1)*s1234)*S13**(-1)*S14**(-1) * ( 8*s12**2*
     +    s23 + 24*s12**2*s24 + 16*s12**2*s34 + 8*s12*s23**2 + 40*s12*
     +    s23*s24 + 8*s12*s23*s34 + 32*s12*s24**2 + 16*s12*s24*s34 )

      LC = LC + log(s24**(-1)*s1234)*S13**(-1)*S23**(-1) * ( 8*s12**2*
     +    s24 + 8*s12**2*s34 + 16*s12*s24**2 - 8*s12*s24*s34 - 8*s14*
     +    s24*s34 )

      LC = LC + log(s24**(-1)*s1234)*S13**(-1) * ( 8*s12**2 + 8*s12*s23
     +     + 24*s12*s24 + 8*s14*s23 + 8*s14*s24 + 8*s23**2 + 8*s23*s24
     +     + 8*s23*s34 )

      LC = LC + log(s24**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 8*s12**2*
     +    s24 + 8*s12**2*s34 - 16*s12*s13*s34 + 16*s12*s24**2 - 24*s12*
     +    s24*s34 + 16*s13**2*s24 + 8*s13*s24**2 - 8*s24**3 + 8*s24**2*
     +    s34 )

      LC = LC + log(s24**(-1)*s1234)*S14**(-1) * ( 8*s12**2 + 8*s12*s23
     +     + 24*s12*s24 - 16*s23**2 - 16*s23*s24 - 16*s23*s34 - 8*
     +    s24**2 )

      LC = LC + log(s24**(-1)*s1234)*S23**(-1)*S34**(-1) * (  - 24*
     +    s13**2*s24 + 24*s14**2*s24 )

      LC = LC + log(s24**(-1)*s1234)*S23**(-1) * (  - 24*s13*s14 - 24*
     +    s14**2 + 8*s24**2 - 24*s24*s34 )

      LC = LC + log(s24**(-1)*s1234)*S34**(-1) * ( 24*s13*s14 + 24*
     +    s14**2 )

      LC = LC + log(s24**(-1)*s1234) * ( 8*s23 + 24*s24 )

      LC = LC + log(s34**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * ( 44*s12**3*s34**2 - 368*s12**2*s34**3 - 360*s12*
     +    s34**4 )

      LC = LC + log(s34**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1) * ( 
     +     - 828*s12**3*s34 - 96*s12**2*s24**2 + 1060*s12**2*s24*s34 + 
     +    1452*s12**2*s34**2 + 828*s12*s24**3 + 1638*s12*s24**2*s34 - 
     +    1646*s12*s24*s34**2 - 2428*s12*s34**3 + 828*s24**4 - 1848*
     +    s24**3*s34 - 1076*s24**2*s34**2 - 592*s24*s34**3 )

      LC = LC + log(s34**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1) * ( 
     +     - 780*s12**3*s34 - 120*s12**2*s23**2 + 1012*s12**2*s23*s34
     +     + 1372*s12**2*s34**2 - 126*s12*s23**2*s34 - 822*s12*s23*
     +    s34**2 - 1444*s12*s34**3 - 64*s23**3*s34 - 192*s23**2*s34**2
     +     - 336*s23*s34**3 )

      LC = LC + log(s34**(-1)*s1234)*S13**(-1)*S14**(-1) * (  - 384*
     +    s12**2*s23 - 360*s12**2*s24 + 2076*s12**2*s34 + 264*s12*
     +    s23**2 + 1164*s12*s23*s24 + 1370*s12*s23*s34 + 1728*s12*
     +    s24**2 + 3238*s12*s24*s34 - 1924*s12*s34**2 + 92*s23**3 + 556
     +    *s23**2*s24 - 536*s23**2*s34 + 1520*s23*s24**2 - 1840*s23*s24
     +    *s34 - 1340*s23*s34**2 + 1884*s24**3 - 3064*s24**2*s34 - 2256
     +    *s24*s34**2 - 952*s34**3 )

      LC = LC + log(s34**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1) * ( 
     +     - 768*s12**3*s34 + 492*s12**2*s14*s34 + 2888*s12**2*s34**2
     +     - 120*s12*s14**3 + 4130*s12*s14**2*s34 - 5050*s12*s14*s34**2
     +     - 1032*s12*s34**3 - 924*s14**3*s34 + 1368*s14**2*s34**2 + 64
     +    *s14*s34**3 )

      LC = LC + log(s34**(-1)*s1234)*S13**(-1)*S23**(-1) * (  - 168*
     +    s12**2*s14 - 288*s12**2*s24 + 2044*s12**2*s34 - 504*s12*
     +    s14**2 + 696*s12*s14*s24 + 8896*s12*s14*s34 + 1896*s12*s24**2
     +     + 6252*s12*s24*s34 - 5364*s12*s34**2 + 940*s14**3 + 3476*
     +    s14**2*s24 - 5144*s14**2*s34 + 4900*s14*s24**2 - 8616*s14*s24
     +    *s34 + 488*s14*s34**2 + 3192*s24**3 - 6168*s24**2*s34 - 1856*
     +    s24*s34**2 - 528*s34**3 )

      LC = LC + log(s34**(-1)*s1234)*S13**(-1)*S24**(-1) * (  - 168*
     +    s12**2*s14 - 288*s12**2*s23 + 1988*s12**2*s34 - 504*s12*
     +    s14**2 + 264*s12*s14*s23 + 6864*s12*s14*s34 + 744*s12*s23**2
     +     + 1716*s12*s23*s34 - 5612*s12*s34**2 + 1000*s14**3 + 1724*
     +    s14**2*s23 - 5008*s14**2*s34 + 460*s14*s23**2 - 5136*s14*s23*
     +    s34 + 1964*s14*s34**2 + 68*s23**3 - 1080*s23**2*s34 + 184*s23
     +    *s34**2 - 408*s34**3 )

      LC = LC + log(s34**(-1)*s1234)*S13**(-1) * (  - 576*s12**2 + 816*
     +    s12*s14 + 2640*s12*s23 + 3600*s12*s24 + 7452*s12*s34 + 4864*
     +    s14**2 + 4296*s14*s23 + 8188*s14*s24 - 12200*s14*s34 + 936*
     +    s23**2 + 3916*s23*s24 - 5000*s23*s34 + 6096*s24**2 - 9400*s24
     +    *s34 - 1504*s34**2 )

      LC = LC + log(s34**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1) * ( 
     +     - 528*s12**3*s34 - 308*s12**2*s13*s34 + 608*s12**2*s34**2 + 
     +    142*s12*s13**2*s34 + 174*s12*s13*s34**2 - 672*s12*s34**3 + 96
     +    *s13**2*s34**2 )

      LC = LC + log(s34**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 376*s12**2
     +    *s34 + 144*s12*s13**2 - 336*s12*s13*s24 - 668*s12*s13*s34 + 
     +    384*s12*s24**2 + 812*s12*s24*s34 - 992*s12*s34**2 + 144*
     +    s13**2*s24 + 48*s13**2*s34 - 352*s13*s24**2 - 80*s13*s24*s34
     +     - 216*s13*s34**2 + 400*s24**3 - 632*s24**2*s34 - 80*s24*
     +    s34**2 - 32*s34**3 )

      LC = LC + log(s34**(-1)*s1234)*S14**(-1)*S24**(-1) * ( 312*s12**2
     +    *s34 - 4*s12*s13*s34 + 44*s12*s23*s34 - 712*s12*s34**2 - 16*
     +    s13*s23*s34 - 96*s13*s34**2 + 128*s23*s34**2 + 56*s34**3 )

      LC = LC + log(s34**(-1)*s1234)*S14**(-1) * (  - 96*s12*s13 + 96*
     +    s12*s23 + 384*s12*s24 + 364*s12*s34 - 8*s13*s23 - 112*s13*s24
     +     + 8*s23**2 + 120*s23*s24 - 16*s23*s34 + 416*s24**2 - 288*s24
     +    *s34 + 368*s34**2 )

      LC = LC + log(s34**(-1)*s1234)*S23**(-1)*S24**(-1) * ( 800*s12**2
     +    *s34 + 48*s12*s13**2 + 96*s12*s13*s14 + 118*s12*s13*s34 + 48*
     +    s12*s14**2 + 2170*s12*s14*s34 - 1384*s12*s34**2 + 96*s13**2*
     +    s14 - 96*s13**2*s34 + 96*s13*s14**2 + 472*s13*s14*s34 + 152*
     +    s13*s34**2 - 96*s14**2*s34 + 368*s14*s34**2 + 728*s34**3 )

      LC = LC + log(s34**(-1)*s1234)*S23**(-1) * (  - 96*s12*s13 - 144*
     +    s12*s14 + 240*s12*s24 + 1460*s12*s34 + 192*s13**2 - 144*s13*
     +    s14 - 432*s13*s24 + 600*s13*s34 + 480*s14*s24 - 1584*s14*s34
     +     + 768*s24**2 - 1616*s24*s34 + 280*s34**2 )

      LC = LC + log(s34**(-1)*s1234)*S24**(-1) * (  - 144*s12*s13 - 96*
     +    s12*s14 + 144*s12*s23 + 212*s12*s34 - 144*s13*s14 + 96*s13*
     +    s34 + 192*s14**2 + 48*s14*s23 - 1104*s14*s34 - 8*s23**2 - 128
     +    *s23*s34 + 496*s34**2 )

      LC = LC + log(s34**(-1)*s1234) * ( 480*s12 - 192*s13 + 576*s14 + 
     +    200*s23 + 784*s24 - 784*s34 )

      LC = LC + log(s123**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * ( 56*s12**4*s34 + 824*s12**3*s34**2 - 256*s12**2*
     +    s34**3 )

      LC = LC + log(s123**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)
     +  * ( 72*s12**3*s24 + 832*s12**3*s34 - 16*s12**2*s24**2 - 176*
     +    s12**2*s24*s34 - 416*s12**2*s34**2 )

      LC = LC + log(s123**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1)
     +  * (  - 120*s12**3*s23 - 16*s12**3*s34 - 32*s12**2*s23**2 + 56*
     +    s12**2*s23*s34 + 728*s12**2*s34**2 + 104*s12*s23**2*s34 + 464
     +    *s12*s23*s34**2 - 144*s12*s34**3 + 32*s23**3*s34 + 80*s23**2*
     +    s34**2 - 32*s23*s34**3 )

      LC = LC + log(s123**(-1)*s1234)*S13**(-1)*S14**(-1)*S34**(-1)
     +  * (  - 32*s12**2*s23**2 - 16*s12**2*s23*s24 + 16*s12**2*s24**2
     +     + 24*s12*s23**2*s24 + 24*s12*s23*s24**2 + 24*s23**3*s24 + 24
     +    *s23**2*s24**2 )

      LC = LC + log(s123**(-1)*s1234)*S13**(-1)*S14**(-1) * ( 48*s12**2
     +    *s23 + 184*s12**2*s24 + 1224*s12**2*s34 + 240*s12*s23**2 + 
     +    168*s12*s23*s24 + 792*s12*s23*s34 - 96*s12*s24**2 - 272*s12*
     +    s24*s34 - 320*s12*s34**2 + 80*s23**3 + 96*s23**2*s24 + 200*
     +    s23**2*s34 - 16*s23*s24**2 - 80*s23*s24*s34 - 96*s23*s34**2 )

      LC = LC + log(s123**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1)
     +  * ( 8*s12**3*s14 - 360*s12**3*s34 + 16*s12**2*s14**2 - 272*
     +    s12**2*s14*s34 + 408*s12**2*s34**2 )

      LC = LC + log(s123**(-1)*s1234)*S13**(-1)*S23**(-1) * (  - 32*
     +    s12**3 - 16*s12**2*s14 + 32*s12**2*s24 + 288*s12**2*s34 - 8*
     +    s12*s14*s34 + 8*s12*s24*s34 )

      LC = LC + log(s123**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-1)
     +  * (  - 48*s12**2*s14**2 + 48*s12**2*s14*s23 - 32*s12**2*s23**2
     +     - 56*s12*s14**2*s23 + 64*s12*s14*s23**2 - 16*s14**2*s23**2
     +     + 32*s14*s23**3 )

      LC = LC + log(s123**(-1)*s1234)*S13**(-1)*S24**(-1) * ( 80*s12**3
     +     + 128*s12**2*s14 - 144*s12**2*s23 - 424*s12**2*s34 + 72*s12*
     +    s14**2 + 32*s12*s14*s23 - 200*s12*s14*s34 - 120*s12*s23**2 - 
     +    336*s12*s23*s34 + 136*s12*s34**2 + 56*s14**2*s23 - 8*s14*
     +    s23**2 - 16*s14*s23*s34 - 40*s23**3 - 160*s23**2*s34 + 56*s23
     +    *s34**2 )

      LC = LC + log(s123**(-1)*s1234)*S13**(-1)*S34**(-1) * ( 48*s12**2
     +    *s14 - 96*s12**2*s23 - 64*s12**2*s24 + 16*s12*s14**2 + 80*s12
     +    *s14*s23 + 16*s12*s14*s24 - 128*s12*s23**2 - 128*s12*s23*s24
     +     + 8*s14**2*s23 + 32*s14*s23**2 - 32*s23**3 - 40*s23**2*s24
     +     - 8*s23*s24**2 )

      LC = LC + log(s123**(-1)*s1234)*S13**(-1) * (  - 8*s12**2 - 184*
     +    s12*s23 + 56*s12*s24 + 192*s12*s34 - 40*s14*s23 - 24*s23**2
     +     + 64*s23*s24 + 64*s23*s34 + 16*s24**2 + 16*s24*s34 )

      LC = LC + log(s123**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 24*s12**3*s13 - 480*s12**3*s34 - 88*s12**2*s13**2 + 288*
     +    s12**2*s13*s34 - 568*s12**2*s34**2 - 184*s12*s13**3 + 560*s12
     +    *s13**2*s34 - 360*s12*s13*s34**2 + 64*s12*s34**3 - 8*s13**4
     +     + 296*s13**3*s34 - 168*s13**2*s34**2 )

      LC = LC + log(s123**(-1)*s1234)*S14**(-1)*S23**(-1)*S34**(-1)
     +  * (  - 48*s12**2*s13*s24 + 16*s12**2*s24**2 - 16*s12*s13**2*s24
     +     + 24*s12*s13*s24**2 - 16*s13**3*s24 + 32*s13**2*s24**2 )

      LC = LC + log(s123**(-1)*s1234)*S14**(-1)*S23**(-1) * (  - 80*
     +    s12**3 + 112*s12**2*s13 - 72*s12**2*s24 - 704*s12**2*s34 + 
     +    584*s12*s13**2 - 256*s12*s13*s24 - 736*s12*s13*s34 + 32*s12*
     +    s24**2 + 32*s12*s24*s34 + 48*s12*s34**2 + 8*s13**3 + 88*
     +    s13**2*s24 + 104*s13**2*s34 - 32*s13*s24**2 - 48*s13*s24*s34
     +     - 32*s13*s34**2 )

      LC = LC + log(s123**(-1)*s1234)*S14**(-1)*S24**(-1) * ( 16*s12**3
     +     + 56*s12**2*s13 - 120*s12**2*s23 - 304*s12**2*s34 - 104*s12*
     +    s13**2 + 32*s12*s13*s23 - 320*s12*s13*s34 - 24*s12*s23**2 + 
     +    128*s12*s23*s34 + 88*s12*s34**2 - 72*s13**3 - 40*s13**2*s23
     +     - 24*s13**2*s34 + 40*s13*s23**2 - 152*s13*s23*s34 + 16*s13*
     +    s34**2 + 40*s23**3 + 120*s23**2*s34 + 264*s23*s34**2 - 32*
     +    s34**3 )

      LC = LC + log(s123**(-1)*s1234)*S14**(-1)*S34**(-1) * (  - 48*
     +    s12**2*s13 - 64*s12**2*s23 - 48*s12**2*s24 - 32*s12*s13**2 - 
     +    176*s12*s13*s23 - 152*s12*s13*s24 - 96*s12*s23**2 - 16*s12*
     +    s23*s24 + 80*s12*s24**2 - 16*s13**3 - 80*s13**2*s23 - 48*
     +    s13**2*s24 - 96*s13*s23**2 - 40*s13*s23*s24 + 56*s13*s24**2
     +     - 32*s23**3 + 32*s23**2*s24 + 64*s23*s24**2 )

      LC = LC + log(s123**(-1)*s1234)*S14**(-1) * (  - 8*s12**2 + 32*
     +    s12*s13 - 40*s12*s23 + 312*s12*s24 + 104*s12*s34 - 72*s13**2
     +     - 216*s13*s23 + 152*s13*s24 + 232*s13*s34 + 16*s23**2 + 256*
     +    s23*s24 + 360*s23*s34 - 32*s24**2 - 80*s24*s34 - 80*s34**2 )

      LC = LC + log(s123**(-1)*s1234)*S23**(-1)*S24**(-1)*S34**(-1)
     +  * (  - 48*s12**2*s13*s14 - 48*s12**2*s14**2 - 56*s12*s13**2*s14
     +     - 56*s12*s13*s14**2 - 24*s13**3*s14 - 24*s13**2*s14**2 )

      LC = LC + log(s123**(-1)*s1234)*S23**(-1)*S24**(-1) * ( 32*s12**3
     +     - 624*s12**2*s13 - 560*s12**2*s14 + 112*s12**2*s34 - 592*s12
     +    *s13**2 - 296*s12*s13*s14 + 656*s12*s13*s34 + 56*s12*s14**2
     +     - 72*s12*s14*s34 - 8*s12*s34**2 - 240*s13**3 - 176*s13**2*
     +    s14 + 112*s13**2*s34 + 72*s13*s14**2 + 64*s13*s14*s34 + 24*
     +    s13*s34**2 )

      LC = LC + log(s123**(-1)*s1234)*S23**(-1)*S34**(-1) * (  - 32*
     +    s12**2*s13 - 32*s12**2*s14 - 48*s12**2*s24 + 48*s12*s13**2 + 
     +    16*s12*s13*s14 - 64*s12*s13*s24 - 32*s12*s14**2 - 48*s12*s14*
     +    s24 - 16*s12*s24**2 + 16*s13**3 + 8*s13**2*s14 - 16*s13**2*
     +    s24 - 8*s13*s14**2 + 8*s13*s24**2 )

      LC = LC + log(s123**(-1)*s1234)*S23**(-1) * ( 24*s12**2 + 304*s12
     +    *s13 - 144*s12*s14 + 56*s12*s24 + 96*s12*s34 + 152*s13**2 + 8
     +    *s13*s14 + 48*s13*s24 + 16*s13*s34 + 16*s14**2 + 16*s14*s34 )

      LC = LC + log(s123**(-1)*s1234)*S24**(-1)*S34**(-1) * (  - 32*
     +    s12**2*s13 - 80*s12**2*s14 + 48*s12**2*s23 + 16*s12*s13**2 - 
     +    160*s12*s13*s14 + 48*s12*s13*s23 - 176*s12*s14**2 - 8*s12*s14
     +    *s23 + 80*s12*s23**2 + 16*s13**3 - 64*s13**2*s14 + 48*s13**2*
     +    s23 - 80*s13*s14**2 - 40*s13*s14*s23 + 64*s13*s23**2 - 88*
     +    s14**2*s23 + 48*s14*s23**2 + 32*s23**3 )

      LC = LC + log(s123**(-1)*s1234)*S24**(-1) * ( 264*s12**2 - 248*
     +    s12*s13 - 440*s12*s14 + 208*s12*s23 + 56*s12*s34 - 112*s13**2
     +     - 208*s13*s14 + 200*s13*s23 + 104*s13*s34 + 96*s14**2 - 104*
     +    s14*s23 - 48*s14*s34 + 88*s23**2 - 88*s23*s34 + 32*s34**2 )

      LC = LC + log(s123**(-1)*s1234)*S34**(-1) * (  - 32*s12*s13 + 16*
     +    s12*s14 - 80*s12*s23 - 176*s12*s24 + 32*s13**2 + 32*s13*s14
     +     - 48*s13*s23 - 104*s13*s24 - 16*s14**2 + 40*s14*s23 - 32*s14
     +    *s24 - 64*s23**2 - 112*s23*s24 - 16*s24**2 )

      LC = LC + log(s123**(-1)*s1234) * ( 88*s12 + 16*s13 - 96*s14 - 80
     +    *s23 + 96*s24 + 96*s34 )

      LC = LC + log(s234**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * ( 32*s12**2*s34**3 + 32*s12*s34**4 )

      LC = LC + log(s234**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)
     +  * (  - 8*s12**2*s24**2 - 8*s12**2*s24*s34 + 8*s12*s24**2*s34 - 
     +    16*s12*s24*s34**2 - 48*s12*s34**3 )

      LC = LC + log(s234**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1)
     +  * (  - 8*s12**2*s23**2 - 8*s12**2*s23*s34 + 8*s12*s23**2*s34 - 
     +    24*s12*s23*s34**2 + 16*s12*s34**3 )

      LC = LC + log(s234**(-1)*s1234)*S13**(-1)*S14**(-1) * (  - 8*
     +    s12**2*s23 - 8*s12**2*s24 - 72*s12*s23**2 - 144*s12*s23*s24
     +     - 128*s12*s23*s34 - 72*s12*s24**2 - 128*s12*s24*s34 - 104*
     +    s12*s34**2 )

      LC = LC + log(s234**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 4*s12**2*s14*s34 + 48*s12**2*s34**2 - 2*s12*s14**2*s34
     +     - 2*s12*s14*s34**2 + 32*s12*s34**3 )

      LC = LC + log(s234**(-1)*s1234)*S13**(-1)*S23**(-1) * ( 44*s12*
     +    s14*s34 - 24*s12*s24**2 - 8*s12*s24*s34 - 40*s12*s34**2 + 8*
     +    s14*s24**2 + 40*s14*s24*s34 - 8*s14*s34**2 + 8*s24**2*s34 + 
     +    32*s24*s34**2 - 8*s34**3 )

      LC = LC + log(s234**(-1)*s1234)*S13**(-1)*S24**(-1) * (  - 44*s12
     +    *s14*s34 - 48*s12*s23**2 - 40*s12*s23*s34 + 8*s12*s34**2 + 56
     +    *s14*s23**2 + 136*s14*s23*s34 + 40*s14*s34**2 + 24*s23**3 + 
     +    40*s23**2*s34 + 80*s23*s34**2 + 48*s34**3 )

      LC = LC + log(s234**(-1)*s1234)*S13**(-1) * (  - 144*s12*s23 - 
     +    120*s12*s24 - 104*s12*s34 + 112*s14*s23 + 56*s14*s24 + 96*s14
     +    *s34 + 24*s23**2 + 40*s23*s24 + 80*s23*s34 + 40*s24**2 + 112*
     +    s24*s34 + 96*s34**2 )

      LC = LC + log(s234**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 4*s12**2*s13*s34 - 48*s12**2*s34**2 + 2*s12*s13**2*s34 + 10
     +    *s12*s13*s34**2 - 32*s12*s34**3 )

      LC = LC + log(s234**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 44*s12*
     +    s13*s34 - 48*s12*s24**2 - 40*s12*s24*s34 - 104*s12*s34**2 + 
     +    56*s13*s24**2 + 144*s13*s24*s34 + 24*s13*s34**2 + 24*s24**3
     +     + 40*s24**2*s34 + 56*s24*s34**2 - 48*s34**3 )

      LC = LC + log(s234**(-1)*s1234)*S14**(-1)*S24**(-1) * (  - 44*s12
     +    *s13*s34 - 24*s12*s23**2 - 8*s12*s23*s34 - 40*s12*s34**2 + 8*
     +    s13*s23**2 + 48*s13*s23*s34 + 8*s13*s34**2 + 8*s23**2*s34 + 8
     +    *s23*s34**2 - 24*s34**3 )

      LC = LC + log(s234**(-1)*s1234)*S14**(-1) * (  - 120*s12*s23 - 
     +    144*s12*s24 - 104*s12*s34 + 56*s13*s23 + 112*s13*s24 + 88*s13
     +    *s34 + 40*s23**2 + 40*s23*s24 + 128*s23*s34 + 24*s24**2 + 96*
     +    s24*s34 )

      LC = LC + log(s234**(-1)*s1234)*S23**(-1)*S24**(-1) * ( 2*s12*s13
     +    *s34 - 2*s12*s14*s34 - 8*s12*s34**2 )

      LC = LC + log(s234**(-1)*s1234)*S23**(-1)*S34**(-1) * ( 24*s13**2
     +    *s24 - 24*s14**2*s24 )

      LC = LC + log(s234**(-1)*s1234)*S23**(-1) * (  - 92*s12*s34 + 24*
     +    s13*s14 + 8*s13*s34 + 24*s14**2 + 16*s14*s34 + 56*s24**2 + 
     +    160*s24*s34 - 48*s34**2 )

      LC = LC + log(s234**(-1)*s1234)*S24**(-1)*S34**(-1) * (  - 24*
     +    s13**2*s23 + 24*s14**2*s23 )

      LC = LC + log(s234**(-1)*s1234)*S24**(-1) * ( 92*s12*s34 + 24*
     +    s13**2 + 24*s13*s14 - 8*s14*s34 + 56*s23**2 + 160*s23*s34 + 8
     +    *s34**2 )

      LC = LC + log(s234**(-1)*s1234)*S34**(-1) * (  - 24*s13**2 - 48*
     +    s13*s14 - 24*s14**2 )

      LC = LC + log(s234**(-1)*s1234) * ( 152*s23 + 152*s24 + 88*s34 )

      LC = LC + log(s134**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * ( 32*s12**2*s34**3 + 32*s12*s34**4 )

      LC = LC + log(s134**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)
     +  * (  - 4*s12**2*s24*s34 + 48*s12**2*s34**2 - 2*s12*s24**2*s34
     +     + 6*s12*s24*s34**2 - 32*s12*s34**3 )

      LC = LC + log(s134**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1)
     +  * ( 4*s12**2*s23*s34 - 48*s12**2*s34**2 + 2*s12*s23**2*s34 + 2*
     +    s12*s23*s34**2 + 32*s12*s34**3 )

      LC = LC + log(s134**(-1)*s1234)*S13**(-1)*S14**(-1) * ( 2*s12*s23
     +    *s34 - 2*s12*s24*s34 - 8*s12*s34**2 )

      LC = LC + log(s134**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 8*s12**2*s14**2 - 8*s12**2*s14*s34 + 8*s12*s14**2*s34 - 
     +    24*s12*s14*s34**2 + 16*s12*s34**3 )

      LC = LC + log(s134**(-1)*s1234)*S13**(-1)*S23**(-1) * (  - 24*s12
     +    *s14**2 - 8*s12*s14*s34 + 44*s12*s24*s34 - 40*s12*s34**2 + 8*
     +    s14**2*s24 + 8*s14**2*s34 + 40*s14*s24*s34 + 24*s24*s34**2 - 
     +    8*s34**3 )

      LC = LC + log(s134**(-1)*s1234)*S13**(-1)*S24**(-1) * (  - 48*s12
     +    *s14**2 - 40*s12*s14*s34 + 44*s12*s23*s34 + 8*s12*s34**2 + 24
     +    *s14**3 + 56*s14**2*s23 + 40*s14**2*s34 + 144*s14*s23*s34 + 
     +    88*s14*s34**2 + 56*s23*s34**2 + 64*s34**3 )

      LC = LC + log(s134**(-1)*s1234)*S13**(-1)*S34**(-1) * ( 24*s14*
     +    s23**2 - 24*s14*s24**2 )

      LC = LC + log(s134**(-1)*s1234)*S13**(-1) * (  - 92*s12*s34 + 56*
     +    s14**2 + 160*s14*s34 + 24*s23*s24 - 8*s23*s34 + 24*s24**2 + 
     +    40*s34**2 )

      LC = LC + log(s134**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 8*s12**2*s13**2 - 8*s12**2*s13*s34 + 8*s12*s13**2*s34 - 
     +    16*s12*s13*s34**2 - 48*s12*s34**3 )

      LC = LC + log(s134**(-1)*s1234)*S14**(-1)*S23**(-1) * (  - 48*s12
     +    *s13**2 - 40*s12*s13*s34 - 44*s12*s24*s34 - 104*s12*s34**2 + 
     +    24*s13**3 + 56*s13**2*s24 + 40*s13**2*s34 + 136*s13*s24*s34
     +     + 48*s13*s34**2 + 8*s24*s34**2 - 64*s34**3 )

      LC = LC + log(s134**(-1)*s1234)*S14**(-1)*S24**(-1) * (  - 24*s12
     +    *s13**2 - 8*s12*s13*s34 - 44*s12*s23*s34 - 40*s12*s34**2 + 8*
     +    s13**2*s23 + 8*s13**2*s34 + 48*s13*s23*s34 + 40*s13*s34**2 - 
     +    24*s23*s34**2 - 24*s34**3 )

      LC = LC + log(s134**(-1)*s1234)*S14**(-1)*S34**(-1) * (  - 24*s13
     +    *s23**2 + 24*s13*s24**2 )

      LC = LC + log(s134**(-1)*s1234)*S14**(-1) * ( 92*s12*s34 + 56*
     +    s13**2 + 160*s13*s34 + 24*s23**2 + 24*s23*s24 + 16*s23*s34 + 
     +    8*s24*s34 - 80*s34**2 )

      LC = LC + log(s134**(-1)*s1234)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**2*s13 - 8*s12**2*s14 - 72*s12*s13**2 - 144*s12*s13*s14
     +     - 128*s12*s13*s34 - 72*s12*s14**2 - 128*s12*s14*s34 - 104*
     +    s12*s34**2 )

      LC = LC + log(s134**(-1)*s1234)*S23**(-1) * (  - 144*s12*s13 - 
     +    120*s12*s14 - 104*s12*s34 + 24*s13**2 + 40*s13*s14 + 112*s13*
     +    s24 + 96*s13*s34 + 40*s14**2 + 56*s14*s24 + 128*s14*s34 + 96*
     +    s24*s34 + 8*s34**2 )

      LC = LC + log(s134**(-1)*s1234)*S24**(-1) * (  - 120*s12*s13 - 
     +    144*s12*s14 - 104*s12*s34 + 40*s13**2 + 40*s13*s14 + 56*s13*
     +    s23 + 112*s13*s34 + 24*s14**2 + 112*s14*s23 + 80*s14*s34 + 88
     +    *s23*s34 + 88*s34**2 )

      LC = LC + log(s134**(-1)*s1234)*S34**(-1) * (  - 24*s23**2 - 48*
     +    s23*s24 - 24*s24**2 )

      LC = LC + log(s134**(-1)*s1234) * ( 152*s13 + 152*s14 + 88*s34 )

      LC = LC + log(s124**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)*
     + S24**(-1) * ( 56*s12**4*s34 + 824*s12**3*s34**2 - 256*s12**2*
     +    s34**3 )

      LC = LC + log(s124**(-1)*s1234)*S13**(-1)*S14**(-1)*S23**(-1)
     +  * (  - 120*s12**3*s24 - 16*s12**3*s34 - 32*s12**2*s24**2 + 56*
     +    s12**2*s24*s34 + 728*s12**2*s34**2 + 104*s12*s24**2*s34 + 464
     +    *s12*s24*s34**2 - 144*s12*s34**3 + 32*s24**3*s34 + 80*s24**2*
     +    s34**2 - 32*s24*s34**3 )

      LC = LC + log(s124**(-1)*s1234)*S13**(-1)*S14**(-1)*S24**(-1)
     +  * ( 72*s12**3*s23 + 832*s12**3*s34 - 16*s12**2*s23**2 - 176*
     +    s12**2*s23*s34 - 416*s12**2*s34**2 )

      LC = LC + log(s124**(-1)*s1234)*S13**(-1)*S14**(-1)*S34**(-1)
     +  * ( 16*s12**2*s23**2 - 16*s12**2*s23*s24 - 32*s12**2*s24**2 + 
     +    24*s12*s23**2*s24 + 24*s12*s23*s24**2 + 24*s23**2*s24**2 + 24
     +    *s23*s24**3 )

      LC = LC + log(s124**(-1)*s1234)*S13**(-1)*S14**(-1) * ( 184*
     +    s12**2*s23 + 48*s12**2*s24 + 1224*s12**2*s34 - 96*s12*s23**2
     +     + 168*s12*s23*s24 - 272*s12*s23*s34 + 240*s12*s24**2 + 792*
     +    s12*s24*s34 - 320*s12*s34**2 - 16*s23**2*s24 + 96*s23*s24**2
     +     - 80*s23*s24*s34 + 80*s24**3 + 200*s24**2*s34 - 96*s24*
     +    s34**2 )

      LC = LC + log(s124**(-1)*s1234)*S13**(-1)*S23**(-1)*S24**(-1)
     +  * ( 24*s12**3*s14 - 480*s12**3*s34 - 88*s12**2*s14**2 + 288*
     +    s12**2*s14*s34 - 568*s12**2*s34**2 - 184*s12*s14**3 + 560*s12
     +    *s14**2*s34 - 360*s12*s14*s34**2 + 64*s12*s34**3 - 8*s14**4
     +     + 296*s14**3*s34 - 168*s14**2*s34**2 )

      LC = LC + log(s124**(-1)*s1234)*S13**(-1)*S23**(-1) * ( 16*s12**3
     +     + 56*s12**2*s14 - 120*s12**2*s24 - 304*s12**2*s34 - 104*s12*
     +    s14**2 + 32*s12*s14*s24 - 320*s12*s14*s34 - 24*s12*s24**2 + 
     +    128*s12*s24*s34 + 88*s12*s34**2 - 72*s14**3 - 40*s14**2*s24
     +     - 24*s14**2*s34 + 40*s14*s24**2 - 152*s14*s24*s34 + 16*s14*
     +    s34**2 + 40*s24**3 + 120*s24**2*s34 + 264*s24*s34**2 - 32*
     +    s34**3 )

      LC = LC + log(s124**(-1)*s1234)*S13**(-1)*S24**(-1)*S34**(-1)
     +  * (  - 48*s12**2*s14*s23 + 16*s12**2*s23**2 - 16*s12*s14**2*s23
     +     + 24*s12*s14*s23**2 - 16*s14**3*s23 + 32*s14**2*s23**2 )

      LC = LC + log(s124**(-1)*s1234)*S13**(-1)*S24**(-1) * (  - 80*
     +    s12**3 + 112*s12**2*s14 - 72*s12**2*s23 - 704*s12**2*s34 + 
     +    584*s12*s14**2 - 256*s12*s14*s23 - 736*s12*s14*s34 + 32*s12*
     +    s23**2 + 32*s12*s23*s34 + 48*s12*s34**2 + 8*s14**3 + 88*
     +    s14**2*s23 + 104*s14**2*s34 - 32*s14*s23**2 - 48*s14*s23*s34
     +     - 32*s14*s34**2 )

      LC = LC + log(s124**(-1)*s1234)*S13**(-1)*S34**(-1) * (  - 48*
     +    s12**2*s14 - 48*s12**2*s23 - 64*s12**2*s24 - 32*s12*s14**2 - 
     +    152*s12*s14*s23 - 176*s12*s14*s24 + 80*s12*s23**2 - 16*s12*
     +    s23*s24 - 96*s12*s24**2 - 16*s14**3 - 48*s14**2*s23 - 80*
     +    s14**2*s24 + 56*s14*s23**2 - 40*s14*s23*s24 - 96*s14*s24**2
     +     + 64*s23**2*s24 + 32*s23*s24**2 - 32*s24**3 )

      LC = LC + log(s124**(-1)*s1234)*S13**(-1) * (  - 8*s12**2 + 32*
     +    s12*s14 + 312*s12*s23 - 40*s12*s24 + 104*s12*s34 - 72*s14**2
     +     + 152*s14*s23 - 216*s14*s24 + 232*s14*s34 - 32*s23**2 + 256*
     +    s23*s24 - 80*s23*s34 + 16*s24**2 + 360*s24*s34 - 80*s34**2 )

      LC = LC + log(s124**(-1)*s1234)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 8*s12**3*s13 - 360*s12**3*s34 + 16*s12**2*s13**2 - 272*
     +    s12**2*s13*s34 + 408*s12**2*s34**2 )

      LC = LC + log(s124**(-1)*s1234)*S14**(-1)*S23**(-1)*S34**(-1)
     +  * (  - 48*s12**2*s13**2 + 48*s12**2*s13*s24 - 32*s12**2*s24**2
     +     - 56*s12*s13**2*s24 + 64*s12*s13*s24**2 - 16*s13**2*s24**2
     +     + 32*s13*s24**3 )

      LC = LC + log(s124**(-1)*s1234)*S14**(-1)*S23**(-1) * ( 80*s12**3
     +     + 128*s12**2*s13 - 144*s12**2*s24 - 424*s12**2*s34 + 72*s12*
     +    s13**2 + 32*s12*s13*s24 - 200*s12*s13*s34 - 120*s12*s24**2 - 
     +    336*s12*s24*s34 + 136*s12*s34**2 + 56*s13**2*s24 - 8*s13*
     +    s24**2 - 16*s13*s24*s34 - 40*s24**3 - 160*s24**2*s34 + 56*s24
     +    *s34**2 )

      LC = LC + log(s124**(-1)*s1234)*S14**(-1)*S24**(-1) * (  - 32*
     +    s12**3 - 16*s12**2*s13 + 32*s12**2*s23 + 288*s12**2*s34 - 8*
     +    s12*s13*s34 + 8*s12*s23*s34 )

      LC = LC + log(s124**(-1)*s1234)*S14**(-1)*S34**(-1) * ( 48*s12**2
     +    *s13 - 64*s12**2*s23 - 96*s12**2*s24 + 16*s12*s13**2 + 16*s12
     +    *s13*s23 + 80*s12*s13*s24 - 128*s12*s23*s24 - 128*s12*s24**2
     +     + 8*s13**2*s24 + 32*s13*s24**2 - 8*s23**2*s24 - 40*s23*
     +    s24**2 - 32*s24**3 )

      LC = LC + log(s124**(-1)*s1234)*S14**(-1) * (  - 8*s12**2 + 56*
     +    s12*s23 - 184*s12*s24 + 192*s12*s34 - 40*s13*s24 + 16*s23**2
     +     + 64*s23*s24 + 16*s23*s34 - 24*s24**2 + 64*s24*s34 )

      LC = LC + log(s124**(-1)*s1234)*S23**(-1)*S24**(-1)*S34**(-1)
     +  * (  - 48*s12**2*s13**2 - 48*s12**2*s13*s14 - 56*s12*s13**2*s14
     +     - 56*s12*s13*s14**2 - 24*s13**2*s14**2 - 24*s13*s14**3 )

      LC = LC + log(s124**(-1)*s1234)*S23**(-1)*S24**(-1) * ( 32*s12**3
     +     - 560*s12**2*s13 - 624*s12**2*s14 + 112*s12**2*s34 + 56*s12*
     +    s13**2 - 296*s12*s13*s14 - 72*s12*s13*s34 - 592*s12*s14**2 + 
     +    656*s12*s14*s34 - 8*s12*s34**2 + 72*s13**2*s14 - 176*s13*
     +    s14**2 + 64*s13*s14*s34 - 240*s14**3 + 112*s14**2*s34 + 24*
     +    s14*s34**2 )

      LC = LC + log(s124**(-1)*s1234)*S23**(-1)*S34**(-1) * (  - 80*
     +    s12**2*s13 - 32*s12**2*s14 + 48*s12**2*s24 - 176*s12*s13**2
     +     - 160*s12*s13*s14 - 8*s12*s13*s24 + 16*s12*s14**2 + 48*s12*
     +    s14*s24 + 80*s12*s24**2 - 80*s13**2*s14 - 88*s13**2*s24 - 64*
     +    s13*s14**2 - 40*s13*s14*s24 + 48*s13*s24**2 + 16*s14**3 + 48*
     +    s14**2*s24 + 64*s14*s24**2 + 32*s24**3 )

      LC = LC + log(s124**(-1)*s1234)*S23**(-1) * ( 264*s12**2 - 440*
     +    s12*s13 - 248*s12*s14 + 208*s12*s24 + 56*s12*s34 + 96*s13**2
     +     - 208*s13*s14 - 104*s13*s24 - 48*s13*s34 - 112*s14**2 + 200*
     +    s14*s24 + 104*s14*s34 + 88*s24**2 - 88*s24*s34 + 32*s34**2 )

      LC = LC + log(s124**(-1)*s1234)*S24**(-1)*S34**(-1) * (  - 32*
     +    s12**2*s13 - 32*s12**2*s14 - 48*s12**2*s23 - 32*s12*s13**2 + 
     +    16*s12*s13*s14 - 48*s12*s13*s23 + 48*s12*s14**2 - 64*s12*s14*
     +    s23 - 16*s12*s23**2 - 8*s13**2*s14 + 8*s13*s14**2 + 16*s14**3
     +     - 16*s14**2*s23 + 8*s14*s23**2 )

      LC = LC + log(s124**(-1)*s1234)*S24**(-1) * ( 24*s12**2 - 144*s12
     +    *s13 + 304*s12*s14 + 56*s12*s23 + 96*s12*s34 + 16*s13**2 + 8*
     +    s13*s14 + 16*s13*s34 + 152*s14**2 + 48*s14*s23 + 16*s14*s34 )

      LC = LC + log(s124**(-1)*s1234)*S34**(-1) * ( 16*s12*s13 - 32*s12
     +    *s14 - 176*s12*s23 - 80*s12*s24 - 16*s13**2 + 32*s13*s14 - 32
     +    *s13*s23 + 40*s13*s24 + 32*s14**2 - 104*s14*s23 - 48*s14*s24
     +     - 16*s23**2 - 112*s23*s24 - 64*s24**2 )

      LC = LC + log(s124**(-1)*s1234) * ( 88*s12 - 96*s13 + 16*s14 + 96
     +    *s23 - 80*s24 + 96*s34 )

      LC = LC + Lc0(p12,p34)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 1324*s12**4*s34**2 - 2192*s12**3*s34**3 + 1832*s12**2*
     +    s34**4 )

      LC = LC + Lc0(p12,p34)*S13**(-1)*S14**(-1)*S23**(-1) * ( 828*
     +    s12**4*s34 + 96*s12**3*s24**2 - 672*s12**3*s24*s34 - 2932*
     +    s12**3*s34**2 - 828*s12**2*s24**3 - 3420*s12**2*s24**2*s34 - 
     +    2424*s12**2*s24*s34**2 + 3236*s12**2*s34**3 - 828*s12*s24**4
     +     - 80*s12*s24**3*s34 + 3380*s12*s24**2*s34**2 + 1792*s12*s24*
     +    s34**3 + 848*s12*s34**4 + 368*s24**4*s34 - 96*s24**3*s34**2
     +     - 80*s24**2*s34**3 )
      
      LCa=-LC/s134/s234
      
      return
      end
      
      function LCb(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LC=0d0

      LC = LC + Lc0(p12,p34)*S13**(-1)*S14**(-1)*S24**(-1) * ( 780*
     +    s12**4*s34 + 120*s12**3*s23**2 - 584*s12**3*s23*s34 - 2556*
     +    s12**3*s34**2 + 28*s12**2*s23**2*s34 + 828*s12**2*s23*s34**2
     +     + 2868*s12**2*s34**3 + 64*s12*s23**3*s34 + 224*s12*s23**2*
     +    s34**2 + 432*s12*s23*s34**3 + 480*s12*s34**4 )

      LC = LC + Lc0(p12,p34)*S13**(-1)*S14**(-1) * ( 384*s12**3*s23 + 
     +    360*s12**3*s24 - 1068*s12**3*s34 - 264*s12**2*s23**2 - 1164*
     +    s12**2*s23*s24 - 1756*s12**2*s23*s34 - 1728*s12**2*s24**2 - 
     +    4804*s12**2*s24*s34 - 844*s12**2*s34**2 - 92*s12*s23**3 - 556
     +    *s12*s23**2*s24 + 520*s12*s23**2*s34 - 1520*s12*s23*s24**2 + 
     +    1248*s12*s23*s24*s34 + 2116*s12*s23*s34**2 - 1884*s12*s24**3
     +     + 912*s12*s24**2*s34 + 4408*s12*s24*s34**2 + 2168*s12*s34**3
     +     - 16*s23**3*s34 + 48*s23**2*s24*s34 + 416*s23*s24**2*s34 + 
     +    80*s23*s24*s34**2 + 64*s23*s34**3 + 720*s24**3*s34 + 96*
     +    s24**2*s34**2 + 96*s24*s34**3 )

      LC = LC + Lc0(p12,p34)*S13**(-1)*S23**(-1)*S24**(-1) * ( 768*
     +    s12**4*s34 - 136*s12**3*s14*s34 - 4424*s12**3*s34**2 - 168*
     +    s12**2*s14**3 - 2536*s12**2*s14**2*s34 - 3452*s12**2*s14*
     +    s34**2 + 5392*s12**2*s34**3 + 72*s12*s14**4 + 580*s12*s14**3*
     +    s34 + 800*s12*s14**2*s34**2 - 1392*s12*s14*s34**3 - 736*s12*
     +    s34**4 - 24*s14**4*s34 - 24*s14**3*s34**2 - 688*s14**2*s34**3
     +     )

      LC = LC + Lc0(p12,p34)*S13**(-1)*S23**(-1) * ( 168*s12**3*s14 + 
     +    288*s12**3*s24 - 1316*s12**3*s34 + 192*s12**2*s14**2 - 720*
     +    s12**2*s14*s24 - 6460*s12**2*s14*s34 - 1896*s12**2*s24**2 - 
     +    8008*s12**2*s24*s34 - 3660*s12**2*s34**2 - 892*s12*s14**3 - 
     +    3508*s12*s14**2*s24 + 2720*s12*s14**2*s34 - 4908*s12*s14*
     +    s24**2 + 2952*s12*s14*s24*s34 + 7448*s12*s14*s34**2 - 3192*
     +    s12*s24**3 + 968*s12*s24**2*s34 + 8808*s12*s24*s34**2 + 1400*
     +    s12*s34**3 - 64*s14**3*s34 + 344*s14**2*s24*s34 - 416*s14**2*
     +    s34**2 + 1056*s14*s24**2*s34 - 440*s14*s24*s34**2 - 672*s14*
     +    s34**3 + 1056*s24**3*s34 - 96*s24**2*s34**2 - 128*s24*s34**3
     +     )

      LC = LC + Lc0(p12,p34)*S13**(-1)*S24**(-1)*S34**(-1) * ( 48*s12*
     +    s14**4 - 96*s12*s14**3*s23 + 48*s12*s14**2*s23**2 )

      LC = LC + Lc0(p12,p34)*S13**(-1)*S24**(-1) * ( 168*s12**3*s14 + 
     +    288*s12**3*s23 - 1356*s12**3*s34 + 1008*s12**2*s14**2 - 480*
     +    s12**2*s14*s23 - 5820*s12**2*s14*s34 - 744*s12**2*s23**2 - 
     +    3136*s12**2*s23*s34 + 500*s12**2*s34**2 - 1400*s12*s14**3 - 
     +    1244*s12*s14**2*s23 + 3344*s12*s14**2*s34 - 628*s12*s14*
     +    s23**2 + 3360*s12*s14*s23*s34 + 5692*s12*s14*s34**2 - 68*s12*
     +    s23**3 + 1088*s12*s23**2*s34 + 1792*s12*s23*s34**2 - 680*s12*
     +    s34**3 + 24*s14**4 - 96*s14**3*s23 - 16*s14**3*s34 + 96*
     +    s14**2*s23**2 + 464*s14**2*s23*s34 - 536*s14**2*s34**2 - 24*
     +    s14*s23**3 - 32*s14*s23**2*s34 - 464*s14*s23*s34**2 - 456*s14
     +    *s34**3 + 8*s23**3*s34 - 80*s23**2*s34**2 - 136*s23*s34**3 )

      LC = LC + Lc0(p12,p34)*S13**(-1)*S34**(-1) * ( 48*s12*s14**3 - 48
     +    *s12*s14**2*s23 )

      LC = LC + Lc0(p12,p34)*S13**(-1) * ( 576*s12**3 - 624*s12**2*s14
     +     - 2640*s12**2*s23 - 3600*s12**2*s24 - 10296*s12**2*s34 - 
     +    5168*s12*s14**2 - 4224*s12*s14*s23 - 8220*s12*s14*s24 + 5768*
     +    s12*s14*s34 - 936*s12*s23**2 - 3916*s12*s23*s24 + 3616*s12*
     +    s23*s34 - 6096*s12*s24**2 + 3808*s12*s24*s34 + 7592*s12*
     +    s34**2 - 72*s14**2*s23 - 72*s14**2*s24 + 632*s14**2*s34 + 16*
     +    s14*s23*s24 + 600*s14*s23*s34 + 8*s14*s24**2 + 1520*s14*s24*
     +    s34 - 1168*s14*s34**2 + 200*s23**2*s34 + 984*s23*s24*s34 - 
     +    336*s23*s34**2 + 1752*s24**2*s34 - 288*s24*s34**2 - 536*
     +    s34**3 )

      LC = LC + Lc0(p12,p34)*S14**(-1)*S23**(-1)*S24**(-1) * ( 528*
     +    s12**4*s34 + 656*s12**3*s13*s34 - 768*s12**3*s34**2 - 288*
     +    s12**2*s13**3 + 728*s12**2*s13**2*s34 - 704*s12**2*s13*s34**2
     +     - 32*s12**2*s34**3 + 72*s12*s13**4 - 344*s12*s13**3*s34 - 32
     +    *s12*s13**2*s34**2 + 288*s12*s13*s34**3 - 352*s12*s34**4 - 24
     +    *s13**4*s34 - 24*s13**3*s34**2 )

      LC = LC + Lc0(p12,p34)*S14**(-1)*S23**(-1)*S34**(-1) * ( 48*s12*
     +    s13**4 - 96*s12*s13**3*s24 + 48*s12*s13**2*s24**2 )

      LC = LC + Lc0(p12,p34)*S14**(-1)*S23**(-1) * (  - 800*s12**3*s34
     +     + 360*s12**2*s13**2 + 120*s12**2*s13*s24 - 128*s12**2*s13*
     +    s34 - 384*s12**2*s24**2 - 120*s12**2*s24*s34 + 2256*s12**2*
     +    s34**2 - 400*s12*s13**3 + 336*s12*s13**2*s24 + 672*s12*s13**2
     +    *s34 + 184*s12*s13*s24**2 - 328*s12*s13*s24*s34 + 448*s12*s13
     +    *s34**2 - 400*s12*s24**3 + 1304*s12*s24**2*s34 - 768*s12*s24*
     +    s34**2 - 584*s12*s34**3 + 24*s13**4 - 96*s13**3*s24 - 32*
     +    s13**3*s34 + 96*s13**2*s24**2 + 48*s13**2*s24*s34 + 72*s13**2
     +    *s34**2 - 24*s13*s24**3 + 240*s13*s24**2*s34 + 96*s13*s24*
     +    s34**2 + 56*s13*s34**3 - 376*s24**3*s34 - 80*s24**2*s34**2 - 
     +    40*s24*s34**3 )

      LC = LC + Lc0(p12,p34)*S14**(-1)*S24**(-1) * (  - 640*s12**3*s34
     +     - 312*s12**2*s13**2 - 24*s12**2*s13*s23 + 824*s12**2*s13*s34
     +     + 96*s12**2*s23*s34 + 656*s12**2*s34**2 + 48*s12*s13**3 - 32
     +    *s12*s13**2*s23 - 256*s12*s13**2*s34 - 8*s12*s13*s23**2 + 88*
     +    s12*s13*s23*s34 + 496*s12*s13*s34**2 - 240*s12*s23*s34**2 - 
     +    256*s12*s34**3 - 48*s13**3*s34 - 24*s13**2*s23*s34 + 48*
     +    s13**2*s34**2 + 24*s13*s23*s34**2 )

      LC = LC + Lc0(p12,p34)*S14**(-1)*S34**(-1) * ( 48*s12*s13**3 - 48
     +    *s12*s13**2*s24 )

      LC = LC + Lc0(p12,p34)*S14**(-1) * ( 288*s12**2*s13 - 96*s12**2*
     +    s23 - 384*s12**2*s24 - 424*s12**2*s34 - 304*s12*s13**2 - 24*
     +    s12*s13*s23 + 184*s12*s13*s24 + 312*s12*s13*s34 - 8*s12*
     +    s23**2 - 120*s12*s23*s24 - 32*s12*s23*s34 - 416*s12*s24**2 + 
     +    512*s12*s24*s34 - 936*s12*s34**2 - 72*s13**2*s23 - 72*s13**2*
     +    s24 - 24*s13**2*s34 + 8*s13*s23**2 + 16*s13*s23*s24 - 16*s13*
     +    s23*s34 + 40*s13*s24*s34 - 48*s13*s34**2 + 24*s23**2*s34 - 56
     +    *s23*s24*s34 - 360*s24**2*s34 - 96*s24*s34**2 - 72*s34**3 )

      LC = LC + Lc0(p12,p34)*S23**(-1)*S24**(-1)*S34**(-1) * ( 48*s12*
     +    s13**4 - 96*s12*s13**2*s14**2 + 48*s12*s14**4 )

      LC = LC + Lc0(p12,p34)*S23**(-1)*S24**(-1) * (  - 432*s12**3*s34
     +     + 48*s12**2*s13**2 + 672*s12**2*s13*s14 - 1528*s12**2*s13*
     +    s34 + 48*s12**2*s14**2 - 4296*s12**2*s14*s34 + 5088*s12**2*
     +    s34**2 + 152*s12*s13**2*s14 - 760*s12*s13**2*s34 + 152*s12*
     +    s13*s14**2 - 352*s12*s13*s14*s34 + 368*s12*s13*s34**2 - 760*
     +    s12*s14**2*s34 - 1952*s12*s14*s34**2 - 432*s12*s34**3 + 64*
     +    s13**4 + 64*s13**3*s14 - 56*s13**3*s34 + 96*s13**2*s14*s34 - 
     +    176*s13**2*s34**2 + 64*s13*s14**3 + 96*s13*s14**2*s34 - 144*
     +    s13*s14*s34**2 - 368*s13*s34**3 + 64*s14**4 - 56*s14**3*s34
     +     - 176*s14**2*s34**2 + 320*s14*s34**3 )

      LC = LC + Lc0(p12,p34)*S23**(-1)*S34**(-1) * (  - 96*s12*s13**3
     +     - 96*s12*s13**2*s14 + 96*s12*s13*s14**2 + 96*s12*s13*s14*s24
     +     + 48*s12*s13*s24**2 + 48*s12*s14**3 )

      LC = LC + Lc0(p12,p34)*S23**(-1) * ( 264*s12**2*s13 - 504*s12**2*
     +    s14 - 480*s12**2*s24 - 184*s12**2*s34 - 160*s12*s13**2 + 424*
     +    s12*s13*s14 + 400*s12*s13*s24 - 1104*s12*s13*s34 - 56*s12*
     +    s14**2 - 720*s12*s14*s24 + 2536*s12*s14*s34 - 824*s12*s24**2
     +     + 3712*s12*s24*s34 - 1368*s12*s34**2 - 152*s13**3 + 16*
     +    s13**2*s14 + 80*s13**2*s24 - 216*s13**2*s34 + 136*s13*s14**2
     +     - 24*s13*s14*s24 + 432*s13*s14*s34 - 112*s13*s24**2 + 304*
     +    s13*s24*s34 - 64*s13*s34**2 + 72*s14**3 + 8*s14**2*s24 - 200*
     +    s14**2*s34 - 56*s14*s24**2 - 624*s14*s24*s34 + 168*s14*s34**2
     +     - 760*s24**2*s34 + 16*s24*s34**2 + 296*s34**3 )

      LC = LC + Lc0(p12,p34)*S24**(-1)*S34**(-1) * ( 48*s12*s13**3 + 96
     +    *s12*s13**2*s14 - 96*s12*s13*s14**2 + 96*s12*s13*s14*s23 - 96
     +    *s12*s14**3 + 48*s12*s14*s23**2 )

      LC = LC + Lc0(p12,p34)*S24**(-1) * (  - 504*s12**2*s13 + 264*
     +    s12**2*s14 - 384*s12**2*s23 + 856*s12**2*s34 - 56*s12*s13**2
     +     + 424*s12*s13*s14 - 240*s12*s13*s23 - 1368*s12*s13*s34 - 160
     +    *s12*s14**2 - 80*s12*s14*s23 + 2928*s12*s14*s34 - 48*s12*
     +    s23**2 - 32*s12*s23*s34 - 1424*s12*s34**2 + 72*s13**3 + 136*
     +    s13**2*s14 + 8*s13**2*s23 - 216*s13**2*s34 + 16*s13*s14**2 - 
     +    24*s13*s14*s23 + 448*s13*s14*s34 - 56*s13*s23**2 - 240*s13*
     +    s23*s34 - 344*s13*s34**2 - 152*s14**3 + 80*s14**2*s23 - 232*
     +    s14**2*s34 - 112*s14*s23**2 - 96*s14*s23*s34 + 496*s14*s34**2
     +     - 88*s23**2*s34 + 16*s23*s34**2 + 216*s34**3 )

      LC = LC + Lc0(p12,p34)*S34**(-1) * (  - 96*s12*s13*s14 - 48*s12*
     +    s13*s24 - 48*s12*s14*s23 )

      LC = LC + Lc0(p12,p34) * (  - 96*s12**2 - 320*s12*s13 - 1088*s12*
     +    s14 - 232*s12*s23 - 816*s12*s24 + 1888*s12*s34 - 104*s13**2
     +     - 80*s13*s14 - 120*s13*s23 - 112*s13*s24 - 64*s13*s34 - 104*
     +    s14**2 - 112*s14*s23 - 120*s14*s24 - 720*s14*s34 + 8*s23**2
     +     + 16*s23*s24 - 288*s23*s34 + 8*s24**2 - 784*s24*s34 + 48*
     +    s34**2 )

      LC = LC + Lc0(p13,p24)*S13**(-1)*S14**(-1)*S23**(-1) * ( 8*s12**2
     +    *s24*s34**2 + 8*s12**2*s34**3 )

      LC = LC + Lc0(p13,p24)*S13**(-1)*S14**(-1) * (  - 8*s12**3*s23 - 
     +    8*s12**3*s24 - 8*s12**3*s34 + 64*s12**2*s23**2 + 64*s12**2*
     +    s23*s24 + 128*s12**2*s23*s34 + 64*s12**2*s24*s34 + 72*s12**2*
     +    s34**2 - 8*s12*s23**3 - 8*s12*s23**2*s24 - 24*s12*s23**2*s34
     +     - 16*s12*s23*s24*s34 - 24*s12*s23*s34**2 - 8*s12*s24*s34**2
     +     - 8*s12*s34**3 )

      LC = LC + Lc0(p13,p24)*S13**(-1)*S23**(-1) * ( 8*s12**2*s24*s34
     +     + 8*s12**2*s34**2 )

      LC = LC + Lc0(p13,p24)*S13**(-1) * ( 40*s12**2*s23 + 40*s12**2*
     +    s24 + 48*s12**2*s34 + 40*s12*s14*s23 + 40*s12*s14*s24 + 40*
     +    s12*s14*s34 + 56*s12*s23**2 + 56*s12*s23*s24 + 96*s12*s23*s34
     +     + 40*s12*s24*s34 + 40*s12*s34**2 + 8*s14*s23**2 + 8*s14*s23*
     +    s24 + 8*s14*s23*s34 )

      LC = LC + Lc0(p13,p24)*S14**(-1)*S23**(-1)*S24**(-1) * ( 8*s12**2
     +    *s13*s34**2 + 8*s12**2*s34**3 )

      LC = LC + Lc0(p13,p24)*S14**(-1)*S23**(-1) * (  - 16*s12**2*s13*
     +    s24 - 8*s12**2*s13*s34 - 8*s12**2*s24*s34 - 8*s12*s13**2*s24
     +     - 8*s12*s13**2*s34 - 8*s12*s13*s24**2 + 8*s12*s13*s34**2 - 8
     +    *s12*s24**2*s34 + 8*s12*s24*s34**2 + 16*s12*s34**3 )

      LC = LC + Lc0(p13,p24)*S14**(-1)*S24**(-1) * ( 8*s12**2*s13*s34
     +     + 8*s12**2*s34**2 )

      LC = LC + Lc0(p13,p24)*S14**(-1) * (  - 16*s12**2*s13 + 48*s12**2
     +    *s23 + 48*s12**2*s24 + 40*s12**2*s34 - 8*s12*s13**2 + 16*s12*
     +    s13*s23 + 8*s12*s13*s24 + 24*s12*s13*s34 + 8*s12*s23*s24 + 8*
     +    s12*s23*s34 + 8*s12*s24**2 + 8*s12*s24*s34 + 24*s12*s34**2 + 
     +    8*s13*s23*s24 + 8*s13*s24**2 + 8*s13*s24*s34 - 8*s23**2*s24
     +     - 8*s23*s24**2 - 16*s23*s24*s34 - 8*s24**2*s34 - 8*s24*
     +    s34**2 )

      LC = LC + Lc0(p13,p24)*S23**(-1)*S24**(-1) * (  - 8*s12**3*s13 - 
     +    8*s12**3*s14 - 8*s12**3*s34 + 64*s12**2*s13*s14 + 64*s12**2*
     +    s13*s34 + 64*s12**2*s14**2 + 128*s12**2*s14*s34 + 72*s12**2*
     +    s34**2 - 8*s12*s13*s14**2 - 16*s12*s13*s14*s34 - 8*s12*s13*
     +    s34**2 - 8*s12*s14**3 - 24*s12*s14**2*s34 - 24*s12*s14*s34**2
     +     - 8*s12*s34**3 )

      LC = LC + Lc0(p13,p24)*S23**(-1) * ( 48*s12**2*s13 + 48*s12**2*
     +    s14 - 16*s12**2*s24 + 40*s12**2*s34 + 8*s12*s13**2 + 8*s12*
     +    s13*s14 + 8*s12*s13*s24 + 8*s12*s13*s34 + 16*s12*s14*s24 + 8*
     +    s12*s14*s34 - 8*s12*s24**2 + 24*s12*s24*s34 + 24*s12*s34**2
     +     - 8*s13**2*s14 + 8*s13**2*s24 - 8*s13**2*s34 - 8*s13*s14**2
     +     + 8*s13*s14*s24 - 16*s13*s14*s34 + 8*s13*s24*s34 - 8*s13*
     +    s34**2 )

      LC = LC + Lc0(p13,p24)*S24**(-1) * ( 40*s12**2*s13 + 40*s12**2*
     +    s14 + 48*s12**2*s34 + 56*s12*s13*s14 + 40*s12*s13*s23 + 40*
     +    s12*s13*s34 + 56*s12*s14**2 + 40*s12*s14*s23 + 96*s12*s14*s34
     +     + 40*s12*s23*s34 + 40*s12*s34**2 + 8*s13*s14*s23 + 8*s14**2*
     +    s23 + 8*s14*s23*s34 )

      LC = LC + Lc0(p13,p24) * (  - 16*s12**2 + 40*s12*s13 + 48*s12*s14
     +     + 48*s12*s23 + 40*s12*s24 + 112*s12*s34 + 24*s13*s23 + 16*
     +    s13*s24 + 24*s13*s34 + 32*s14*s23 + 24*s14*s24 + 32*s14*s34
     +     + 32*s23*s34 + 24*s24*s34 + 32*s34**2 )

      LC = LC + Lc0(p14,p23)*S13**(-1)*S14**(-1)*S24**(-1) * ( 8*s12**2
     +    *s23*s34**2 + 8*s12**2*s34**3 )

      LC = LC + Lc0(p14,p23)*S13**(-1)*S14**(-1) * (  - 8*s12**3*s23 - 
     +    8*s12**3*s24 - 8*s12**3*s34 + 64*s12**2*s23*s24 + 64*s12**2*
     +    s23*s34 + 64*s12**2*s24**2 + 128*s12**2*s24*s34 + 72*s12**2*
     +    s34**2 - 8*s12*s23*s24**2 - 16*s12*s23*s24*s34 - 8*s12*s23*
     +    s34**2 - 8*s12*s24**3 - 24*s12*s24**2*s34 - 24*s12*s24*s34**2
     +     - 8*s12*s34**3 )

      LC = LC + Lc0(p14,p23)*S13**(-1)*S23**(-1)*S24**(-1) * ( 8*s12**2
     +    *s14*s34**2 + 8*s12**2*s34**3 )

      LC = LC + Lc0(p14,p23)*S13**(-1)*S23**(-1) * ( 8*s12**2*s14*s34
     +     + 8*s12**2*s34**2 )

      LC = LC + Lc0(p14,p23)*S13**(-1)*S24**(-1) * (  - 16*s12**2*s14*
     +    s23 - 8*s12**2*s14*s34 - 8*s12**2*s23*s34 - 8*s12*s14**2*s23
     +     - 8*s12*s14**2*s34 - 8*s12*s14*s23**2 + 8*s12*s14*s34**2 - 8
     +    *s12*s23**2*s34 + 8*s12*s23*s34**2 + 16*s12*s34**3 )

      LC = LC + Lc0(p14,p23)*S13**(-1) * (  - 16*s12**2*s14 + 48*s12**2
     +    *s23 + 48*s12**2*s24 + 40*s12**2*s34 - 8*s12*s14**2 + 8*s12*
     +    s14*s23 + 16*s12*s14*s24 + 24*s12*s14*s34 + 8*s12*s23**2 + 8*
     +    s12*s23*s24 + 8*s12*s23*s34 + 8*s12*s24*s34 + 24*s12*s34**2
     +     + 8*s14*s23**2 + 8*s14*s23*s24 + 8*s14*s23*s34 - 8*s23**2*
     +    s24 - 8*s23**2*s34 - 8*s23*s24**2 - 16*s23*s24*s34 - 8*s23*
     +    s34**2 )

      LC = LC + Lc0(p14,p23)*S14**(-1)*S24**(-1) * ( 8*s12**2*s23*s34
     +     + 8*s12**2*s34**2 )

      LC = LC + Lc0(p14,p23)*S14**(-1) * ( 40*s12**2*s23 + 40*s12**2*
     +    s24 + 48*s12**2*s34 + 40*s12*s13*s23 + 40*s12*s13*s24 + 40*
     +    s12*s13*s34 + 56*s12*s23*s24 + 40*s12*s23*s34 + 56*s12*s24**2
     +     + 96*s12*s24*s34 + 40*s12*s34**2 + 8*s13*s23*s24 + 8*s13*
     +    s24**2 + 8*s13*s24*s34 )

      LC = LC + Lc0(p14,p23)*S23**(-1)*S24**(-1) * (  - 8*s12**3*s13 - 
     +    8*s12**3*s14 - 8*s12**3*s34 + 64*s12**2*s13**2 + 64*s12**2*
     +    s13*s14 + 128*s12**2*s13*s34 + 64*s12**2*s14*s34 + 72*s12**2*
     +    s34**2 - 8*s12*s13**3 - 8*s12*s13**2*s14 - 24*s12*s13**2*s34
     +     - 16*s12*s13*s14*s34 - 24*s12*s13*s34**2 - 8*s12*s14*s34**2
     +     - 8*s12*s34**3 )

      LC = LC + Lc0(p14,p23)*S23**(-1) * ( 40*s12**2*s13 + 40*s12**2*
     +    s14 + 48*s12**2*s34 + 56*s12*s13**2 + 56*s12*s13*s14 + 40*s12
     +    *s13*s24 + 96*s12*s13*s34 + 40*s12*s14*s24 + 40*s12*s14*s34
     +     + 40*s12*s24*s34 + 40*s12*s34**2 + 8*s13**2*s24 + 8*s13*s14*
     +    s24 + 8*s13*s24*s34 )

      LC = LC + Lc0(p14,p23)*S24**(-1) * ( 48*s12**2*s13 + 48*s12**2*
     +    s14 - 16*s12**2*s23 + 40*s12**2*s34 + 8*s12*s13*s14 + 16*s12*
     +    s13*s23 + 8*s12*s13*s34 + 8*s12*s14**2 + 8*s12*s14*s23 + 8*
     +    s12*s14*s34 - 8*s12*s23**2 + 24*s12*s23*s34 + 24*s12*s34**2
     +     - 8*s13**2*s14 - 8*s13*s14**2 + 8*s13*s14*s23 - 16*s13*s14*
     +    s34 + 8*s14**2*s23 - 8*s14**2*s34 + 8*s14*s23*s34 - 8*s14*
     +    s34**2 )

      LC = LC + Lc0(p14,p23) * (  - 16*s12**2 + 48*s12*s13 + 40*s12*s14
     +     + 40*s12*s23 + 48*s12*s24 + 112*s12*s34 + 24*s13*s23 + 32*
     +    s13*s24 + 32*s13*s34 + 16*s14*s23 + 24*s14*s24 + 24*s14*s34
     +     + 24*s23*s34 + 32*s24*s34 + 32*s34**2 )

      LC = LC + Lc1(p1,p23)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s23**2 - 8*s12**3*s23*s34 + 8*s12**2*s23**2*s34 + 8*
     +    s12**2*s23*s34**2 )

      LC = LC + Lc1(p1,p23)*S13**(-1)*S14**(-1) * (  - 8*s12**3*s23 + 8
     +    *s12**2*s23**2 + 8*s12**2*s23*s24 + 16*s12**2*s23*s34 )

      LC = LC + Lc1(p1,p23)*S13**(-1)*S24**(-1) * ( 16*s12**2*s14*s34
     +     + 32*s12**2*s23**2 + 8*s12**2*s23*s34 - 16*s12*s14**2*s23 - 
     +    16*s12*s14*s23**2 - 16*s12*s23**3 )

      LC = LC + Lc1(p1,p23)*S13**(-1) * ( 8*s12**2*s23 - 16*s12*s23**2
     +     + 16*s12*s23*s24 + 16*s12*s24**2 + 16*s12*s24*s34 )

      LC = LC + Lc1(p1,p23)*S24**(-1) * ( 16*s12*s14*s34 - 16*s14**2*
     +    s23 )

      LC = LC + Lc1(p1,p23) * ( 16*s23*s24 + 16*s24**2 + 16*s24*s34 )

      LC = LC + Lc1(p1,p24)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 8*
     +    s12**3*s24**2 - 8*s12**3*s24*s34 + 8*s12**2*s24**2*s34 + 8*
     +    s12**2*s24*s34**2 )

      LC = LC + Lc1(p1,p24)*S13**(-1)*S14**(-1) * (  - 8*s12**3*s24 + 8
     +    *s12**2*s23*s24 + 8*s12**2*s24**2 + 16*s12**2*s24*s34 )

      LC = LC + Lc1(p1,p24)*S14**(-1)*S23**(-1) * ( 16*s12**2*s13*s34
     +     + 32*s12**2*s24**2 + 8*s12**2*s24*s34 - 16*s12*s13**2*s24 - 
     +    16*s12*s13*s24**2 - 16*s12*s24**3 )

      LC = LC + Lc1(p1,p24)*S14**(-1) * ( 8*s12**2*s24 + 16*s12*s23**2
     +     + 16*s12*s23*s24 + 16*s12*s23*s34 - 16*s12*s24**2 )

      LC = LC + Lc1(p1,p24)*S23**(-1) * ( 16*s12*s13*s34 - 16*s13**2*
     +    s24 )

      LC = LC + Lc1(p1,p24) * ( 16*s23**2 + 16*s23*s24 + 16*s23*s34 )

      LC = LC + Lc1(p1,p34)*S13**(-1)*S23**(-1) * (  - 4*s12**2*s24*s34
     +     + 48*s12**2*s34**2 + 44*s12*s14*s24*s34 - 2*s12*s24**2*s34
     +     - 2*s12*s24*s34**2 )

      LC = LC + Lc1(p1,p34)*S13**(-1)*S24**(-1) * ( 4*s12**2*s23*s34 - 
     +    48*s12**2*s34**2 + 44*s12*s14*s23*s34 + 2*s12*s23**2*s34 + 2*
     +    s12*s23*s34**2 )

      LC = LC + Lc1(p1,p34)*S13**(-1) * (  - 92*s12*s14*s34 + 2*s12*s23
     +    *s34 - 2*s12*s24*s34 )

      LC = LC + Lc1(p1,p34)*S14**(-1)*S23**(-1) * (  - 4*s12**2*s24*s34
     +     + 48*s12**2*s34**2 - 44*s12*s13*s24*s34 - 2*s12*s24**2*s34
     +     - 2*s12*s24*s34**2 - 8*s13**2*s24*s34 - 8*s13**2*s34**2 - 16
     +    *s13*s24*s34**2 - 16*s13*s34**3 )

      LC = LC + Lc1(p1,p34)*S14**(-1)*S24**(-1) * ( 4*s12**2*s23*s34 - 
     +    48*s12**2*s34**2 - 44*s12*s13*s23*s34 + 2*s12*s23**2*s34 + 2*
     +    s12*s23*s34**2 + 8*s13**2*s23*s34 + 8*s13**2*s34**2 - 16*s13*
     +    s23*s34**2 - 16*s13*s34**3 )

      LC = LC + Lc1(p1,p34)*S14**(-1) * ( 92*s12*s13*s34 + 2*s12*s23*
     +    s34 - 2*s12*s24*s34 - 32*s13*s34**2 )

      LC = LC + Lc1(p1,p234)*S13**(-1)*S23**(-1) * (  - 8*s14**2*s24**2
     +     - 24*s14**2*s24*s34 - 16*s14**2*s34**2 - 8*s14*s24**2*s34 - 
     +    24*s14*s24*s34**2 - 16*s14*s34**3 )

      LC = LC + Lc1(p1,p234)*S13**(-1)*S24**(-1) * (  - 56*s14**2*
     +    s23**2 - 72*s14**2*s23*s34 - 16*s14**2*s34**2 - 16*s14*s23**3
     +     - 16*s14*s23**2*s34 - 24*s14*s23*s34**2 - 24*s14*s34**3 )

      LC = LC + Lc1(p1,p234)*S13**(-1) * (  - 98*s14**2*s23 - 50*s14**2
     +    *s24 - 74*s14**2*s34 - 44*s14*s23**2 - 72*s14*s23*s24 - 70*
     +    s14*s23*s34 - 44*s14*s24**2 - 94*s14*s24*s34 - 82*s14*s34**2
     +     )

      LC = LC + Lc1(p1,p234)*S14**(-1)*S23**(-1) * (  - 56*s13**2*
     +    s24**2 - 72*s13**2*s24*s34 - 16*s13**2*s34**2 - 16*s13*s24**3
     +     - 16*s13*s24**2*s34 - 24*s13*s24*s34**2 - 24*s13*s34**3 )

      LC = LC + Lc1(p1,p234)*S14**(-1)*S24**(-1) * (  - 8*s13**2*s23**2
     +     - 24*s13**2*s23*s34 - 16*s13**2*s34**2 - 8*s13*s23**2*s34 - 
     +    24*s13*s23*s34**2 - 16*s13*s34**3 )

      LC = LC + Lc1(p1,p234)*S14**(-1) * (  - 50*s13**2*s23 - 98*s13**2
     +    *s24 - 74*s13**2*s34 - 44*s13*s23**2 - 72*s13*s23*s24 - 94*
     +    s13*s23*s34 - 44*s13*s24**2 - 70*s13*s24*s34 - 82*s13*s34**2
     +     )

      LC = LC + Lc1(p1,p234)*S23**(-1) * (  - 4*s13**2*s24 - 110*s13*
     +    s24**2 - 162*s13*s24*s34 - 48*s13*s34**2 + 4*s14**2*s24 - 62*
     +    s14*s24**2 - 106*s14*s24*s34 - 48*s14*s34**2 - 16*s24**3 - 54
     +    *s24**2*s34 - 54*s24*s34**2 - 16*s34**3 )

      LC = LC + Lc1(p1,p234)*S24**(-1) * ( 4*s13**2*s23 - 62*s13*s23**2
     +     - 106*s13*s23*s34 - 48*s13*s34**2 - 4*s14**2*s23 - 110*s14*
     +    s23**2 - 162*s14*s23*s34 - 48*s14*s34**2 - 16*s23**3 - 54*
     +    s23**2*s34 - 54*s23*s34**2 - 16*s34**3 )

      LC = LC + Lc1(p1,p234) * (  - 280*s13*s23 - 328*s13*s24 - 314*s13
     +    *s34 - 328*s14*s23 - 280*s14*s24 - 314*s14*s34 - 72*s23**2 - 
     +    112*s23*s24 - 254*s23*s34 - 72*s24**2 - 254*s24*s34 - 192*
     +    s34**2 )

      LC = LC + Lc1(p2,p13)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s13**2 - 8*s12**3*s13*s34 + 8*s12**2*s13**2*s34 + 8*
     +    s12**2*s13*s34**2 )

      LC = LC + Lc1(p2,p13)*S14**(-1)*S23**(-1) * ( 32*s12**2*s13**2 + 
     +    8*s12**2*s13*s34 + 16*s12**2*s24*s34 - 16*s12*s13**3 - 16*s12
     +    *s13**2*s24 - 16*s12*s13*s24**2 )

      LC = LC + Lc1(p2,p13)*S14**(-1) * ( 16*s12*s24*s34 - 16*s13*
     +    s24**2 )

      LC = LC + Lc1(p2,p13)*S23**(-1)*S24**(-1) * (  - 8*s12**3*s13 + 8
     +    *s12**2*s13**2 + 8*s12**2*s13*s14 + 16*s12**2*s13*s34 )

      LC = LC + Lc1(p2,p13)*S23**(-1) * ( 8*s12**2*s13 - 16*s12*s13**2
     +     + 16*s12*s13*s14 + 16*s12*s14**2 + 16*s12*s14*s34 )

      LC = LC + Lc1(p2,p13) * ( 16*s13*s14 + 16*s14**2 + 16*s14*s34 )

      LC = LC + Lc1(p2,p14)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s14**2 - 8*s12**3*s14*s34 + 8*s12**2*s14**2*s34 + 8*
     +    s12**2*s14*s34**2 )

      LC = LC + Lc1(p2,p14)*S13**(-1)*S24**(-1) * ( 32*s12**2*s14**2 + 
     +    8*s12**2*s14*s34 + 16*s12**2*s23*s34 - 16*s12*s14**3 - 16*s12
     +    *s14**2*s23 - 16*s12*s14*s23**2 )

      LC = LC + Lc1(p2,p14)*S13**(-1) * ( 16*s12*s23*s34 - 16*s14*
     +    s23**2 )

      LC = LC + Lc1(p2,p14)*S23**(-1)*S24**(-1) * (  - 8*s12**3*s14 + 8
     +    *s12**2*s13*s14 + 8*s12**2*s14**2 + 16*s12**2*s14*s34 )

      LC = LC + Lc1(p2,p14)*S24**(-1) * ( 8*s12**2*s14 + 16*s12*s13**2
     +     + 16*s12*s13*s14 + 16*s12*s13*s34 - 16*s12*s14**2 )

      LC = LC + Lc1(p2,p14) * ( 16*s13**2 + 16*s13*s14 + 16*s13*s34 )

      LC = LC + Lc1(p2,p34)*S13**(-1)*S23**(-1) * (  - 4*s12**2*s14*s34
     +     + 48*s12**2*s34**2 - 2*s12*s14**2*s34 + 44*s12*s14*s24*s34
     +     - 2*s12*s14*s34**2 )

      LC = LC + Lc1(p2,p34)*S13**(-1)*S24**(-1) * (  - 4*s12**2*s14*s34
     +     + 48*s12**2*s34**2 - 2*s12*s14**2*s34 - 44*s12*s14*s23*s34
     +     - 2*s12*s14*s34**2 - 8*s14*s23**2*s34 - 16*s14*s23*s34**2 - 
     +    8*s23**2*s34**2 - 16*s23*s34**3 )

      LC = LC + Lc1(p2,p34)*S14**(-1)*S23**(-1) * ( 4*s12**2*s13*s34 - 
     +    48*s12**2*s34**2 + 2*s12*s13**2*s34 + 44*s12*s13*s24*s34 + 2*
     +    s12*s13*s34**2 )

      LC = LC + Lc1(p2,p34)*S14**(-1)*S24**(-1) * ( 4*s12**2*s13*s34 - 
     +    48*s12**2*s34**2 + 2*s12*s13**2*s34 - 44*s12*s13*s23*s34 + 2*
     +    s12*s13*s34**2 + 8*s13*s23**2*s34 - 16*s13*s23*s34**2 + 8*
     +    s23**2*s34**2 - 16*s23*s34**3 )

      LC = LC + Lc1(p2,p34)*S23**(-1) * ( 2*s12*s13*s34 - 2*s12*s14*s34
     +     - 92*s12*s24*s34 )

      LC = LC + Lc1(p2,p34)*S24**(-1) * ( 2*s12*s13*s34 - 2*s12*s14*s34
     +     + 92*s12*s23*s34 - 32*s23*s34**2 )

      LC = LC + Lc1(p2,p134)*S13**(-1)*S23**(-1) * (  - 8*s14**2*s24**2
     +     - 8*s14**2*s24*s34 - 24*s14*s24**2*s34 - 24*s14*s24*s34**2
     +     - 16*s24**2*s34**2 - 16*s24*s34**3 )

      LC = LC + Lc1(p2,p134)*S13**(-1)*S24**(-1) * (  - 16*s14**3*s23
     +     - 56*s14**2*s23**2 - 16*s14**2*s23*s34 - 72*s14*s23**2*s34
     +     - 24*s14*s23*s34**2 - 16*s23**2*s34**2 - 24*s23*s34**3 )

      LC = LC + Lc1(p2,p134)*S13**(-1) * (  - 16*s14**3 - 110*s14**2*
     +    s23 - 62*s14**2*s24 - 54*s14**2*s34 - 4*s14*s23**2 - 162*s14*
     +    s23*s34 + 4*s14*s24**2 - 106*s14*s24*s34 - 54*s14*s34**2 - 48
     +    *s23*s34**2 - 48*s24*s34**2 - 16*s34**3 )

      LC = LC + Lc1(p2,p134)*S14**(-1)*S23**(-1) * (  - 16*s13**3*s24
     +     - 56*s13**2*s24**2 - 16*s13**2*s24*s34 - 72*s13*s24**2*s34
     +     - 24*s13*s24*s34**2 - 16*s24**2*s34**2 - 24*s24*s34**3 )

      LC = LC + Lc1(p2,p134)*S14**(-1)*S24**(-1) * (  - 8*s13**2*s23**2
     +     - 8*s13**2*s23*s34 - 24*s13*s23**2*s34 - 24*s13*s23*s34**2
     +     - 16*s23**2*s34**2 - 16*s23*s34**3 )

      LC = LC + Lc1(p2,p134)*S14**(-1) * (  - 16*s13**3 - 62*s13**2*s23
     +     - 110*s13**2*s24 - 54*s13**2*s34 + 4*s13*s23**2 - 106*s13*
     +    s23*s34 - 4*s13*s24**2 - 162*s13*s24*s34 - 54*s13*s34**2 - 48
     +    *s23*s34**2 - 48*s24*s34**2 - 16*s34**3 )

      LC = LC + Lc1(p2,p134)*S23**(-1) * (  - 44*s13**2*s24 - 72*s13*
     +    s14*s24 - 98*s13*s24**2 - 70*s13*s24*s34 - 44*s14**2*s24 - 50
     +    *s14*s24**2 - 94*s14*s24*s34 - 74*s24**2*s34 - 82*s24*s34**2
     +     )

      LC = LC + Lc1(p2,p134)*S24**(-1) * (  - 44*s13**2*s23 - 72*s13*
     +    s14*s23 - 50*s13*s23**2 - 94*s13*s23*s34 - 44*s14**2*s23 - 98
     +    *s14*s23**2 - 70*s14*s23*s34 - 74*s23**2*s34 - 82*s23*s34**2
     +     )

      LC = LC + Lc1(p2,p134) * (  - 72*s13**2 - 112*s13*s14 - 280*s13*
     +    s23 - 328*s13*s24 - 254*s13*s34 - 72*s14**2 - 328*s14*s23 - 
     +    280*s14*s24 - 254*s14*s34 - 314*s23*s34 - 314*s24*s34 - 192*
     +    s34**2 )

      LC = LC + Lc1(p3,p12)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 8*s12**4*s34**2 )

      LC = LC + Lc1(p3,p12)*S13**(-1)*S14**(-1)*S24**(-1) * ( 40*s12**4
     +    *s34 - 120*s12**3*s23**2 - 208*s12**3*s23*s34 - 56*s12**3*
     +    s34**2 - 16*s12**2*s23**3 - 240*s12**2*s23**2*s34 - 288*
     +    s12**2*s23*s34**2 - 80*s12*s23**3*s34 )

      LC = LC + Lc1(p3,p12)*S13**(-1)*S14**(-1)*S34**(-1) * (  - 32*
     +    s12**2*s23**3 - 32*s12**2*s23**2*s24 - 16*s12*s23**3*s24 - 16
     +    *s12*s23**2*s24**2 )

      LC = LC + Lc1(p3,p12)*S13**(-1)*S14**(-1) * (  - 72*s12**3*s23 + 
     +    24*s12**3*s34 - 120*s12**2*s23**2 - 8*s12**2*s23*s24 - 136*
     +    s12**2*s23*s34 - 16*s12**2*s24*s34 - 32*s12**2*s34**2 - 96*
     +    s12*s23**2*s24 - 112*s12*s23**2*s34 - 64*s12*s23*s24**2 - 96*
     +    s12*s23*s24*s34 - 32*s12*s23*s34**2 - 16*s23**3*s34 - 16*
     +    s23**2*s24*s34 - 16*s23**2*s34**2 )

      LC = LC + Lc1(p3,p12)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**4*s34 + 8*s12**3*s14*s34 - 16*s12**3*s34**2 )

      LC = LC + Lc1(p3,p12)*S13**(-1)*S23**(-1) * (  - 8*s12**3*s34 )

      LC = LC + Lc1(p3,p12)*S13**(-1)*S24**(-1)*S34**(-1) * ( 32*s12**2
     +    *s14*s23**2 - 32*s12**2*s23**3 + 16*s12*s14**2*s23**2 - 16*
     +    s12*s14*s23**3 )

      LC = LC + Lc1(p3,p12)*S13**(-1)*S24**(-1) * (  - 48*s12**3*s14 + 
     +    168*s12**3*s23 + 96*s12**3*s34 + 40*s12**2*s14*s23 - 64*
     +    s12**2*s14*s34 + 56*s12**2*s23**2 + 248*s12**2*s23*s34 + 96*
     +    s12**2*s34**2 - 16*s12*s14**2*s23 + 32*s12*s14*s23**2 - 48*
     +    s12*s14*s23*s34 + 112*s12*s23**2*s34 - 32*s12*s23*s34**2 + 16
     +    *s14*s23**2*s34 - 16*s23**3*s34 + 16*s23**2*s34**2 )

      LC = LC + Lc1(p3,p12)*S13**(-1)*S34**(-1) * ( 32*s12**2*s14*s23
     +     + 32*s12**2*s23*s24 + 16*s12*s14**2*s23 + 16*s12*s14*s23**2
     +     + 32*s12*s14*s23*s24 - 32*s12*s23**3 - 16*s12*s23**2*s24 + 
     +    16*s12*s23*s24**2 )

      LC = LC + Lc1(p3,p12)*S13**(-1) * ( 72*s12**3 + 176*s12**2*s23 + 
     +    32*s12**2*s24 + 96*s12**2*s34 + 48*s12*s14*s23 - 8*s12*s14*
     +    s34 - 64*s12*s23**2 + 8*s12*s24*s34 )

      LC = LC + Lc1(p3,p12)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 48*
     +    s12**3*s13**2 + 16*s12**3*s13*s34 - 24*s12**3*s34**2 + 16*
     +    s12**2*s13**3 - 32*s12**2*s13**2*s34 )

      LC = LC + Lc1(p3,p12)*S14**(-1)*S23**(-1)*S34**(-1) * ( 32*s12**2
     +    *s13**3 - 32*s12**2*s13**2*s24 - 32*s12*s13**3*s24 + 32*s12*
     +    s13**2*s24**2 - 16*s13**3*s24**2 + 16*s13**2*s24**3 )

      LC = LC + Lc1(p3,p12)*S14**(-1)*S23**(-1) * (  - 24*s12**3*s34 - 
     +    208*s12**2*s13**2 + 48*s12**2*s13*s24 + 48*s12**2*s13*s34 - 
     +    16*s12**2*s34**2 - 16*s12*s13**2*s24 - 32*s12*s13**2*s34 + 32
     +    *s12*s13*s24**2 + 64*s12*s13*s24*s34 + 32*s12*s13*s34**2 + 16
     +    *s13**3*s34 + 16*s13**2*s24**2 - 16*s13**2*s24*s34 - 16*
     +    s13**2*s34**2 )

      LC = LC + Lc1(p3,p12)*S23**(-1)*S24**(-1)*S34**(-1) * ( 32*s12**2
     +    *s13**3 + 32*s12**2*s13**2*s14 - 32*s12*s13**3*s14 - 32*s12*
     +    s13**2*s14**2 - 16*s13**3*s14**2 - 16*s13**2*s14**3 )

      LC = LC + Lc1(p3,p12)*S23**(-1)*S24**(-1) * ( 48*s12**3*s13 + 96*
     +    s12**3*s14 + 56*s12**3*s34 - 240*s12**2*s13**2 - 288*s12**2*
     +    s13*s14 + 48*s12**2*s14*s34 + 16*s12**2*s34**2 - 48*s12*
     +    s13**2*s14 + 32*s12*s13**2*s34 - 16*s12*s13*s14**2 + 16*s12*
     +    s13*s14*s34 + 32*s12*s13*s34**2 + 16*s13**3*s34 - 16*s13**2*
     +    s14**2 + 16*s13**2*s14*s34 + 16*s13**2*s34**2 )

      LC = LC + Lc1(p3,p12)*S23**(-1)*S34**(-1) * (  - 32*s12**2*s13*
     +    s14 - 32*s12**2*s13*s24 - 64*s12*s13**3 - 32*s12*s13**2*s14
     +     + 32*s12*s13**2*s24 - 16*s12*s13*s14**2 - 32*s12*s13*s14*s24
     +     - 16*s12*s13*s24**2 - 48*s13**3*s14 - 48*s13**3*s24 - 32*
     +    s13**2*s14**2 + 32*s13**2*s24**2 )

      LC = LC + Lc1(p3,p12)*S23**(-1) * ( 32*s12**2*s13 + 32*s12**2*s14
     +     - 64*s12*s13**2 - 16*s12*s13*s14 + 32*s12*s13*s24 + 64*s12*
     +    s13*s34 - 8*s12*s14*s34 + 8*s12*s24*s34 - 16*s13**2*s14 + 16*
     +    s13**2*s24 )

      LC = LC + Lc1(p3,p14)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**2*s14*s34**2 + 8*s12*s14**2*s34**2 )

      LC = LC + Lc1(p3,p14)*S13**(-1)*S23**(-1) * (  - 16*s12*s14**2*
     +    s34 - 32*s14**2*s24*s34 + 8*s14**2*s34**2 + 8*s14*s24*s34**2
     +     )

      LC = LC + Lc1(p3,p14)*S13**(-1)*S24**(-1) * (  - 16*s12*s14**3 + 
     +    16*s12*s14*s34**2 + 16*s14**3*s23 - 16*s14**3*s34 - 16*s14**2
     +    *s23*s34 + 8*s14**2*s34**2 )

      LC = LC + Lc1(p3,p14)*S13**(-1)*S34**(-1) * (  - 24*s14**2*s23**2
     +     - 24*s14**2*s23*s24 )

      LC = LC + Lc1(p3,p14)*S13**(-1) * ( 8*s14**3 - 48*s14**2*s34 + 24
     +    *s14*s23**2 - 24*s14*s24**2 + 16*s14*s34**2 + 24*s23*s24*s34
     +     + 24*s24**2*s34 )

      LC = LC + Lc1(p3,p24)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 8*
     +    s12**2*s24*s34**2 + 8*s12*s24**2*s34**2 )

      LC = LC + Lc1(p3,p24)*S13**(-1)*S23**(-1) * (  - 16*s12*s24**2*
     +    s34 - 32*s14*s24**2*s34 + 8*s14*s24*s34**2 + 8*s24**2*s34**2
     +     )

      LC = LC + Lc1(p3,p24)*S14**(-1)*S23**(-1) * (  - 16*s12*s24**3 + 
     +    16*s12*s24*s34**2 + 16*s13*s24**3 - 16*s13*s24**2*s34 - 16*
     +    s24**3*s34 + 8*s24**2*s34**2 )

      LC = LC + Lc1(p3,p24)*S23**(-1)*S34**(-1) * (  - 24*s13**2*s24**2
     +     - 24*s13*s14*s24**2 )

      LC = LC + Lc1(p3,p24)*S23**(-1) * ( 24*s13**2*s24 + 24*s13*s14*
     +    s34 - 24*s14**2*s24 + 24*s14**2*s34 + 8*s24**3 - 48*s24**2*
     +    s34 + 16*s24*s34**2 )

      LC = LC + Lc1(p3,p124)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 136*s12**4*s34**2 - 1072*s12**3*s34**3 + 256*s12**2*
     +    s34**4 )

      LC = LC + Lc1(p3,p124)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 456*
     +    s12**3*s34**2 - 584*s12**2*s24*s34**2 - 1464*s12**2*s34**3 - 
     +    320*s12*s24**2*s34**2 - 776*s12*s24*s34**3 + 144*s12*s34**4
     +     - 56*s24**3*s34**2 - 128*s24**2*s34**3 + 32*s24*s34**4 )

      LC = LC + Lc1(p3,p124)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 112*
     +    s12**4*s34 - 120*s12**3*s23**2 - 1168*s12**3*s23*s34 - 2120*
     +    s12**3*s34**2 + 16*s12**2*s23**3 + 176*s12**2*s23**2*s34 + 
     +    544*s12**2*s23*s34**2 + 640*s12**2*s34**3 )

      LC = LC + Lc1(p3,p124)*S13**(-1)*S14**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s23**3 - 16*s12**2*s23**2*s24 - 40*s12*s23**3*s24 - 40
     +    *s12*s23**2*s24**2 - 24*s23**3*s24**2 - 24*s23**2*s24**3 )

      LC = LC + Lc1(p3,p124)*S13**(-1)*S14**(-1) * (  - 120*s12**3*s23
     +     - 528*s12**3*s34 - 408*s12**2*s23**2 - 400*s12**2*s23*s24 - 
     +    2288*s12**2*s23*s34 - 936*s12**2*s24*s34 - 3360*s12**2*s34**2
     +     + 32*s12*s23**3 - 432*s12*s23**2*s24 + 208*s12*s23**2*s34 - 
     +    408*s12*s23*s24**2 - 1672*s12*s23*s24*s34 + 464*s12*s23*
     +    s34**2 - 680*s12*s24**2*s34 - 2056*s12*s24*s34**2 + 432*s12*
     +    s34**3 + 16*s23**3*s24 - 144*s23**2*s24**2 + 80*s23**2*s24*
     +    s34 - 128*s23*s24**3 - 408*s23*s24**2*s34 + 144*s23*s24*
     +    s34**2 - 160*s24**3*s34 - 416*s24**2*s34**2 + 112*s24*s34**3
     +     )

      LC = LC + Lc1(p3,p124)*S13**(-1)*S23**(-1)*S24**(-1) * ( 40*
     +    s12**4*s34 - 224*s12**3*s14*s34 + 896*s12**3*s34**2 + 24*
     +    s12**2*s14**2*s34 - 16*s12**2*s14*s34**2 + 392*s12**2*s34**3
     +     - 8*s12*s14**3*s34 + 136*s12*s14**2*s34**2 + 152*s12*s14*
     +    s34**3 - 64*s12*s34**4 + 8*s14**4*s34 - 224*s14**3*s34**2 + 
     +    168*s14**2*s34**3 )

      LC = LC + Lc1(p3,p124)*S13**(-1)*S23**(-1) * ( 152*s12**3*s34 + 
     +    128*s12**2*s14*s34 + 104*s12**2*s24*s34 + 344*s12**2*s34**2
     +     + 120*s12*s14**2*s34 + 72*s12*s14*s24*s34 + 648*s12*s14*
     +    s34**2 - 40*s12*s24**2*s34 - 264*s12*s24*s34**2 - 656*s12*
     +    s34**3 + 72*s14**3*s34 + 72*s14**2*s24*s34 + 64*s14**2*s34**2
     +     - 8*s14*s24**2*s34 + 152*s14*s24*s34**2 - 64*s14*s34**3 - 40
     +    *s24**3*s34 - 176*s24**2*s34**2 - 360*s24*s34**3 + 32*s34**4
     +     )

      LC = LC + Lc1(p3,p124)*S13**(-1)*S24**(-1)*S34**(-1) * ( 16*
     +    s12**2*s14*s23**2 - 16*s12**2*s23**3 + 40*s12*s14**2*s23**2
     +     - 40*s12*s14*s23**3 + 24*s14**3*s23**2 - 24*s14**2*s23**3 )

      LC = LC + Lc1(p3,p124)*S13**(-1)*S24**(-1) * (  - 48*s12**3*s14
     +     + 120*s12**3*s23 + 952*s12**3*s34 + 192*s12**2*s14**2 - 352*
     +    s12**2*s14*s23 - 744*s12**2*s14*s34 + 24*s12**2*s23**2 + 608*
     +    s12**2*s23*s34 + 1024*s12**2*s34**2 + 144*s12*s14**3 - 240*
     +    s12*s14**2*s23 - 504*s12*s14**2*s34 - 32*s12*s14*s23**2 + 320
     +    *s12*s14*s23*s34 + 496*s12*s14*s34**2 + 32*s12*s23**3 + 112*
     +    s12*s23**2*s34 + 64*s12*s23*s34**2 - 80*s12*s34**3 + 40*
     +    s14**3*s23 - 120*s14**3*s34 - 80*s14**2*s23**2 - 240*s14**2*
     +    s23*s34 - 40*s14**2*s34**2 + 16*s14*s23**3 + 48*s14*s23**2*
     +    s34 + 48*s14*s23*s34**2 + 16*s14*s34**3 )

      LC = LC + Lc1(p3,p124)*S13**(-1)*S34**(-1) * ( 16*s12**2*s14*s23
     +     + 16*s12**2*s23*s24 + 40*s12*s14**2*s23 + 40*s12*s14*s23**2
     +     + 80*s12*s14*s23*s24 - 80*s12*s23**3 - 40*s12*s23**2*s24 + 
     +    40*s12*s23*s24**2 + 24*s14**3*s23 + 48*s14**2*s23**2 + 72*
     +    s14**2*s23*s24 - 72*s14*s23**3 + 72*s14*s23*s24**2 - 72*
     +    s23**3*s24 - 48*s23**2*s24**2 + 24*s23*s24**3 )

      LC = LC + Lc1(p3,p124)*S13**(-1) * ( 72*s12**3 + 176*s12**2*s23
     +     + 192*s12**2*s24 + 776*s12**2*s34 + 176*s12*s14**2 + 96*s12*
     +    s14*s23 + 96*s12*s14*s24 + 408*s12*s14*s34 - 464*s12*s23**2
     +     - 72*s12*s23*s24 - 856*s12*s23*s34 + 64*s12*s24**2 - 216*s12
     +    *s24*s34 - 1112*s12*s34**2 + 56*s14**3 + 240*s14**2*s23 + 56*
     +    s14**2*s24 + 336*s14**2*s34 - 304*s14*s23**2 + 232*s14*s23*
     +    s24 - 632*s14*s23*s34 - 56*s14*s24**2 + 328*s14*s24*s34 - 528
     +    *s14*s34**2 + 32*s23**3 - 368*s23**2*s24 + 128*s23**2*s34 - 
     +    96*s23*s24**2 - 800*s23*s24*s34 + 192*s23*s34**2 - 56*s24**3
     +     - 288*s24**2*s34 - 904*s24*s34**2 + 128*s34**3 )

      LC = LC + Lc1(p3,p124)*S14**(-1)*S23**(-1)*S24**(-1) * ( 48*
     +    s12**3*s13**2 + 8*s12**3*s13*s34 + 24*s12**3*s34**2 - 16*
     +    s12**2*s13**3 + 80*s12**2*s13**2*s34 - 40*s12**2*s13*s34**2 )

      LC = LC + Lc1(p3,p124)*S14**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2*s13**3 - 16*s12**2*s13**2*s24 + 120*s12*s13**3*s24 - 
     +    120*s12*s13**2*s24**2 + 40*s13**3*s24**2 - 40*s13**2*s24**3 )

      LC = LC + Lc1(p3,p124)*S14**(-1)*S23**(-1) * (  - 16*s12**3*s13
     +     + 16*s12**3*s24 + 16*s12**3*s34 + 272*s12**2*s13**2 - 120*
     +    s12**2*s13*s24 + 40*s12**2*s13*s34 + 32*s12**2*s24**2 - 48*
     +    s12**2*s24*s34 - 8*s12**2*s34**2 - 32*s12*s13**3 + 520*s12*
     +    s13**2*s24 + 48*s12*s13**2*s34 - 280*s12*s13*s24**2 + 176*s12
     +    *s13*s24*s34 + 16*s12*s24**3 - 104*s12*s24**2*s34 + 24*s12*
     +    s24*s34**2 - 32*s13**3*s24 + 184*s13**2*s24**2 - 64*s13**2*
     +    s24*s34 - 112*s13*s24**3 + 64*s13*s24**2*s34 + 16*s13*s24*
     +    s34**2 - 8*s24**3*s34 + 32*s24**2*s34**2 - 8*s24*s34**3 )

      LC = LC + Lc1(p3,p124)*S23**(-1)*S24**(-1)*S34**(-1) * ( 16*
     +    s12**2*s13**3 + 16*s12**2*s13**2*s14 + 120*s12*s13**3*s14 + 
     +    120*s12*s13**2*s14**2 + 40*s13**3*s14**2 + 40*s13**2*s14**3 )

      LC = LC + Lc1(p3,p124)*S23**(-1)*S24**(-1) * (  - 64*s12**3*s13
     +     - 112*s12**3*s14 - 80*s12**3*s34 + 288*s12**2*s13**2 + 120*
     +    s12**2*s13*s14 + 144*s12**2*s13*s34 - 176*s12**2*s14**2 - 104
     +    *s12**2*s14*s34 + 136*s12**2*s34**2 - 32*s12*s13**3 + 488*s12
     +    *s13**2*s14 + 128*s12*s13**2*s34 + 416*s12*s13*s14**2 + 224*
     +    s12*s13*s14*s34 - 152*s12*s13*s34**2 - 64*s12*s14**3 - 56*s12
     +    *s14**2*s34 + 184*s12*s14*s34**2 - 32*s13**3*s14 + 104*s13**2
     +    *s14**2 + 16*s13**2*s14*s34 + 104*s13*s14**3 - 40*s13*s14**2*
     +    s34 - 136*s13*s14*s34**2 - 128*s14**3*s34 + 16*s14**2*s34**2
     +     - 8*s14*s34**3 )

      LC = LC + Lc1(p3,p124)*S23**(-1)*S34**(-1) * (  - 16*s12**2*s13*
     +    s14 - 16*s12**2*s13*s24 + 240*s12*s13**3 + 120*s12*s13**2*s14
     +     - 120*s12*s13**2*s24 - 72*s12*s13*s14**2 - 144*s12*s13*s14*
     +    s24 - 72*s12*s13*s24**2 + 120*s13**3*s14 + 120*s13**3*s24 + 
     +    80*s13**2*s14**2 - 80*s13**2*s24**2 - 24*s13*s14**3 - 72*s13*
     +    s14**2*s24 - 72*s13*s14*s24**2 - 24*s13*s24**3 )

      LC = LC + Lc1(p3,p124)*S23**(-1) * (  - 96*s12**2*s13 - 184*
     +    s12**2*s14 - 72*s12**2*s24 - 48*s12**2*s34 + 1008*s12*s13**2
     +     + 528*s12*s13*s14 - 168*s12*s13*s24 + 368*s12*s13*s34 - 160*
     +    s12*s14**2 - 256*s12*s14*s24 + 152*s12*s14*s34 - 144*s12*
     +    s24**2 + 40*s12*s24*s34 + 136*s12*s34**2 - 64*s13**3 + 376*
     +    s13**2*s14 + 488*s13**2*s24 - 48*s13**2*s34 + 232*s13*s14**2
     +     + 24*s13*s14*s24 - 48*s13*s14*s34 - 200*s13*s24**2 + 104*s13
     +    *s24*s34 - 120*s13*s34**2 + 48*s14**3 - 8*s14**2*s24 - 96*
     +    s14**2*s34 - 88*s14*s24**2 - 40*s14*s24*s34 + 8*s14*s34**2 - 
     +    80*s24**3 - 64*s24**2*s34 + 40*s24*s34**2 - 16*s34**3 )

      LC = LC + Lc1(p4,p12)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 8*s12**4*s34**2 )

      LC = LC + Lc1(p4,p12)*S13**(-1)*S14**(-1)*S23**(-1) * ( 40*s12**4
     +    *s34 - 120*s12**3*s24**2 - 208*s12**3*s24*s34 - 56*s12**3*
     +    s34**2 - 16*s12**2*s24**3 - 240*s12**2*s24**2*s34 - 288*
     +    s12**2*s24*s34**2 - 80*s12*s24**3*s34 )

      LC = LC + Lc1(p4,p12)*S13**(-1)*S14**(-1)*S34**(-1) * (  - 32*
     +    s12**2*s23*s24**2 - 32*s12**2*s24**3 - 16*s12*s23**2*s24**2
     +     - 16*s12*s23*s24**3 )

      LC = LC + Lc1(p4,p12)*S13**(-1)*S14**(-1) * (  - 72*s12**3*s24 + 
     +    24*s12**3*s34 - 8*s12**2*s23*s24 - 16*s12**2*s23*s34 - 120*
     +    s12**2*s24**2 - 136*s12**2*s24*s34 - 32*s12**2*s34**2 - 64*
     +    s12*s23**2*s24 - 96*s12*s23*s24**2 - 96*s12*s23*s24*s34 - 112
     +    *s12*s24**2*s34 - 32*s12*s24*s34**2 - 16*s23*s24**2*s34 - 16*
     +    s24**3*s34 - 16*s24**2*s34**2 )

      LC = LC + Lc1(p4,p12)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 48*
     +    s12**3*s14**2 + 16*s12**3*s14*s34 - 24*s12**3*s34**2 + 16*
     +    s12**2*s14**3 - 32*s12**2*s14**2*s34 )

      LC = LC + Lc1(p4,p12)*S13**(-1)*S24**(-1)*S34**(-1) * ( 32*s12**2
     +    *s14**3 - 32*s12**2*s14**2*s23 - 32*s12*s14**3*s23 + 32*s12*
     +    s14**2*s23**2 - 16*s14**3*s23**2 + 16*s14**2*s23**3 )

      LC = LC + Lc1(p4,p12)*S13**(-1)*S24**(-1) * (  - 24*s12**3*s34 - 
     +    208*s12**2*s14**2 + 48*s12**2*s14*s23 + 48*s12**2*s14*s34 - 
     +    16*s12**2*s34**2 - 16*s12*s14**2*s23 - 32*s12*s14**2*s34 + 32
     +    *s12*s14*s23**2 + 64*s12*s14*s23*s34 + 32*s12*s14*s34**2 + 16
     +    *s14**3*s34 + 16*s14**2*s23**2 - 16*s14**2*s23*s34 - 16*
     +    s14**2*s34**2 )

      LC = LC + Lc1(p4,p12)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**4*s34 + 8*s12**3*s13*s34 - 16*s12**3*s34**2 )

      LC = LC + Lc1(p4,p12)*S14**(-1)*S23**(-1)*S34**(-1) * ( 32*s12**2
     +    *s13*s24**2 - 32*s12**2*s24**3 + 16*s12*s13**2*s24**2 - 16*
     +    s12*s13*s24**3 )

      LC = LC + Lc1(p4,p12)*S14**(-1)*S23**(-1) * (  - 48*s12**3*s13 + 
     +    168*s12**3*s24 + 96*s12**3*s34 + 40*s12**2*s13*s24 - 64*
     +    s12**2*s13*s34 + 56*s12**2*s24**2 + 248*s12**2*s24*s34 + 96*
     +    s12**2*s34**2 - 16*s12*s13**2*s24 + 32*s12*s13*s24**2 - 48*
     +    s12*s13*s24*s34 + 112*s12*s24**2*s34 - 32*s12*s24*s34**2 + 16
     +    *s13*s24**2*s34 - 16*s24**3*s34 + 16*s24**2*s34**2 )

      LC = LC + Lc1(p4,p12)*S14**(-1)*S24**(-1) * (  - 8*s12**3*s34 )

      LC = LC + Lc1(p4,p12)*S14**(-1)*S34**(-1) * ( 32*s12**2*s13*s24
     +     + 32*s12**2*s23*s24 + 16*s12*s13**2*s24 + 32*s12*s13*s23*s24
     +     + 16*s12*s13*s24**2 + 16*s12*s23**2*s24 - 16*s12*s23*s24**2
     +     - 32*s12*s24**3 )

      LC = LC + Lc1(p4,p12)*S14**(-1) * ( 72*s12**3 + 32*s12**2*s23 + 
     +    176*s12**2*s24 + 96*s12**2*s34 + 48*s12*s13*s24 - 8*s12*s13*
     +    s34 + 8*s12*s23*s34 - 64*s12*s24**2 )

      LC = LC + Lc1(p4,p12)*S23**(-1)*S24**(-1)*S34**(-1) * ( 32*s12**2
     +    *s13*s14**2 + 32*s12**2*s14**3 - 32*s12*s13**2*s14**2 - 32*
     +    s12*s13*s14**3 - 16*s13**3*s14**2 - 16*s13**2*s14**3 )

      LC = LC + Lc1(p4,p12)*S23**(-1)*S24**(-1) * ( 96*s12**3*s13 + 48*
     +    s12**3*s14 + 56*s12**3*s34 - 288*s12**2*s13*s14 + 48*s12**2*
     +    s13*s34 - 240*s12**2*s14**2 + 16*s12**2*s34**2 - 16*s12*
     +    s13**2*s14 - 48*s12*s13*s14**2 + 16*s12*s13*s14*s34 + 32*s12*
     +    s14**2*s34 + 32*s12*s14*s34**2 - 16*s13**2*s14**2 + 16*s13*
     +    s14**2*s34 + 16*s14**3*s34 + 16*s14**2*s34**2 )

      LC = LC + Lc1(p4,p12)*S24**(-1)*S34**(-1) * (  - 32*s12**2*s13*
     +    s14 - 32*s12**2*s14*s23 - 16*s12*s13**2*s14 - 32*s12*s13*
     +    s14**2 - 32*s12*s13*s14*s23 - 64*s12*s14**3 + 32*s12*s14**2*
     +    s23 - 16*s12*s14*s23**2 - 32*s13**2*s14**2 - 48*s13*s14**3 - 
     +    48*s14**3*s23 + 32*s14**2*s23**2 )

      LC = LC + Lc1(p4,p12)*S24**(-1) * ( 32*s12**2*s13 + 32*s12**2*s14
     +     - 16*s12*s13*s14 - 8*s12*s13*s34 - 64*s12*s14**2 + 32*s12*
     +    s14*s23 + 64*s12*s14*s34 + 8*s12*s23*s34 - 16*s13*s14**2 + 16
     +    *s14**2*s23 )

      LC = LC + Lc1(p4,p13)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**2*s13*s34**2 + 8*s12*s13**2*s34**2 )

      LC = LC + Lc1(p4,p13)*S14**(-1)*S23**(-1) * (  - 16*s12*s13**3 + 
     +    16*s12*s13*s34**2 + 16*s13**3*s24 - 16*s13**3*s34 - 16*s13**2
     +    *s24*s34 + 8*s13**2*s34**2 )

      LC = LC + Lc1(p4,p13)*S14**(-1)*S24**(-1) * (  - 16*s12*s13**2*
     +    s34 - 32*s13**2*s23*s34 + 8*s13**2*s34**2 + 8*s13*s23*s34**2
     +     )

      LC = LC + Lc1(p4,p13)*S14**(-1)*S34**(-1) * (  - 24*s13**2*s23*
     +    s24 - 24*s13**2*s24**2 )

      LC = LC + Lc1(p4,p13)*S14**(-1) * ( 8*s13**3 - 48*s13**2*s34 - 24
     +    *s13*s23**2 + 24*s13*s24**2 + 16*s13*s34**2 + 24*s23**2*s34
     +     + 24*s23*s24*s34 )

      LC = LC + Lc1(p4,p23)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 8*
     +    s12**2*s23*s34**2 + 8*s12*s23**2*s34**2 )

      LC = LC + Lc1(p4,p23)*S13**(-1)*S24**(-1) * (  - 16*s12*s23**3 + 
     +    16*s12*s23*s34**2 + 16*s14*s23**3 - 16*s14*s23**2*s34 - 16*
     +    s23**3*s34 + 8*s23**2*s34**2 )

      LC = LC + Lc1(p4,p23)*S14**(-1)*S24**(-1) * (  - 16*s12*s23**2*
     +    s34 - 32*s13*s23**2*s34 + 8*s13*s23*s34**2 + 8*s23**2*s34**2
     +     )

      LC = LC + Lc1(p4,p23)*S24**(-1)*S34**(-1) * (  - 24*s13*s14*
     +    s23**2 - 24*s14**2*s23**2 )

      LC = LC + Lc1(p4,p23)*S24**(-1) * (  - 24*s13**2*s23 + 24*s13**2*
     +    s34 + 24*s13*s14*s34 + 24*s14**2*s23 + 8*s23**3 - 48*s23**2*
     +    s34 + 16*s23*s34**2 )

      LC = LC + Lc1(p4,p123)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 136*s12**4*s34**2 - 1072*s12**3*s34**3 + 256*s12**2*
     +    s34**4 )

      LC = LC + Lc1(p4,p123)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 112*
     +    s12**4*s34 - 120*s12**3*s24**2 - 1168*s12**3*s24*s34 - 2120*
     +    s12**3*s34**2 + 16*s12**2*s24**3 + 176*s12**2*s24**2*s34 + 
     +    544*s12**2*s24*s34**2 + 640*s12**2*s34**3 )

      LC = LC + Lc1(p4,p123)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 456*
     +    s12**3*s34**2 - 584*s12**2*s23*s34**2 - 1464*s12**2*s34**3 - 
     +    320*s12*s23**2*s34**2 - 776*s12*s23*s34**3 + 144*s12*s34**4
     +     - 56*s23**3*s34**2 - 128*s23**2*s34**3 + 32*s23*s34**4 )

      LC = LC + Lc1(p4,p123)*S13**(-1)*S14**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s23*s24**2 - 16*s12**2*s24**3 - 40*s12*s23**2*s24**2
     +     - 40*s12*s23*s24**3 - 24*s23**3*s24**2 - 24*s23**2*s24**3 )

      LC = LC + Lc1(p4,p123)*S13**(-1)*S14**(-1) * (  - 120*s12**3*s24
     +     - 528*s12**3*s34 - 400*s12**2*s23*s24 - 936*s12**2*s23*s34
     +     - 408*s12**2*s24**2 - 2288*s12**2*s24*s34 - 3360*s12**2*
     +    s34**2 - 408*s12*s23**2*s24 - 680*s12*s23**2*s34 - 432*s12*
     +    s23*s24**2 - 1672*s12*s23*s24*s34 - 2056*s12*s23*s34**2 + 32*
     +    s12*s24**3 + 208*s12*s24**2*s34 + 464*s12*s24*s34**2 + 432*
     +    s12*s34**3 - 128*s23**3*s24 - 160*s23**3*s34 - 144*s23**2*
     +    s24**2 - 408*s23**2*s24*s34 - 416*s23**2*s34**2 + 16*s23*
     +    s24**3 + 80*s23*s24**2*s34 + 144*s23*s24*s34**2 + 112*s23*
     +    s34**3 )

      LC = LC + Lc1(p4,p123)*S13**(-1)*S23**(-1)*S24**(-1) * ( 48*
     +    s12**3*s14**2 + 8*s12**3*s14*s34 + 24*s12**3*s34**2 - 16*
     +    s12**2*s14**3 + 80*s12**2*s14**2*s34 - 40*s12**2*s14*s34**2 )

      LC = LC + Lc1(p4,p123)*S13**(-1)*S24**(-1)*S34**(-1) * ( 16*
     +    s12**2*s14**3 - 16*s12**2*s14**2*s23 + 120*s12*s14**3*s23 - 
     +    120*s12*s14**2*s23**2 + 40*s14**3*s23**2 - 40*s14**2*s23**3 )

      LC = LC + Lc1(p4,p123)*S13**(-1)*S24**(-1) * (  - 16*s12**3*s14
     +     + 16*s12**3*s23 + 16*s12**3*s34 + 272*s12**2*s14**2 - 120*
     +    s12**2*s14*s23 + 40*s12**2*s14*s34 + 32*s12**2*s23**2 - 48*
     +    s12**2*s23*s34 - 8*s12**2*s34**2 - 32*s12*s14**3 + 520*s12*
     +    s14**2*s23 + 48*s12*s14**2*s34 - 280*s12*s14*s23**2 + 176*s12
     +    *s14*s23*s34 + 16*s12*s23**3 - 104*s12*s23**2*s34 + 24*s12*
     +    s23*s34**2 - 32*s14**3*s23 + 184*s14**2*s23**2 - 64*s14**2*
     +    s23*s34 - 112*s14*s23**3 + 64*s14*s23**2*s34 + 16*s14*s23*
     +    s34**2 - 8*s23**3*s34 + 32*s23**2*s34**2 - 8*s23*s34**3 )

      LC = LC + Lc1(p4,p123)*S14**(-1)*S23**(-1)*S24**(-1) * ( 40*
     +    s12**4*s34 - 224*s12**3*s13*s34 + 896*s12**3*s34**2 + 24*
     +    s12**2*s13**2*s34 - 16*s12**2*s13*s34**2 + 392*s12**2*s34**3
     +     - 8*s12*s13**3*s34 + 136*s12*s13**2*s34**2 + 152*s12*s13*
     +    s34**3 - 64*s12*s34**4 + 8*s13**4*s34 - 224*s13**3*s34**2 + 
     +    168*s13**2*s34**3 )

      LC = LC + Lc1(p4,p123)*S14**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2*s13*s24**2 - 16*s12**2*s24**3 + 40*s12*s13**2*s24**2
     +     - 40*s12*s13*s24**3 + 24*s13**3*s24**2 - 24*s13**2*s24**3 )

      LC = LC + Lc1(p4,p123)*S14**(-1)*S23**(-1) * (  - 48*s12**3*s13
     +     + 120*s12**3*s24 + 952*s12**3*s34 + 192*s12**2*s13**2 - 352*
     +    s12**2*s13*s24 - 744*s12**2*s13*s34 + 24*s12**2*s24**2 + 608*
     +    s12**2*s24*s34 + 1024*s12**2*s34**2 + 144*s12*s13**3 - 240*
     +    s12*s13**2*s24 - 504*s12*s13**2*s34 - 32*s12*s13*s24**2 + 320
     +    *s12*s13*s24*s34 + 496*s12*s13*s34**2 + 32*s12*s24**3 + 112*
     +    s12*s24**2*s34 + 64*s12*s24*s34**2 - 80*s12*s34**3 + 40*
     +    s13**3*s24 - 120*s13**3*s34 - 80*s13**2*s24**2 - 240*s13**2*
     +    s24*s34 - 40*s13**2*s34**2 + 16*s13*s24**3 + 48*s13*s24**2*
     +    s34 + 48*s13*s24*s34**2 + 16*s13*s34**3 )

      LC = LC + Lc1(p4,p123)*S14**(-1)*S24**(-1) * ( 152*s12**3*s34 + 
     +    128*s12**2*s13*s34 + 104*s12**2*s23*s34 + 344*s12**2*s34**2
     +     + 120*s12*s13**2*s34 + 72*s12*s13*s23*s34 + 648*s12*s13*
     +    s34**2 - 40*s12*s23**2*s34 - 264*s12*s23*s34**2 - 656*s12*
     +    s34**3 + 72*s13**3*s34 + 72*s13**2*s23*s34 + 64*s13**2*s34**2
     +     - 8*s13*s23**2*s34 + 152*s13*s23*s34**2 - 64*s13*s34**3 - 40
     +    *s23**3*s34 - 176*s23**2*s34**2 - 360*s23*s34**3 + 32*s34**4
     +     )

      LC = LC + Lc1(p4,p123)*S14**(-1)*S34**(-1) * ( 16*s12**2*s13*s24
     +     + 16*s12**2*s23*s24 + 40*s12*s13**2*s24 + 80*s12*s13*s23*s24
     +     + 40*s12*s13*s24**2 + 40*s12*s23**2*s24 - 40*s12*s23*s24**2
     +     - 80*s12*s24**3 + 24*s13**3*s24 + 72*s13**2*s23*s24 + 48*
     +    s13**2*s24**2 + 72*s13*s23**2*s24 - 72*s13*s24**3 + 24*s23**3
     +    *s24 - 48*s23**2*s24**2 - 72*s23*s24**3 )

      LC = LC + Lc1(p4,p123)*S14**(-1) * ( 72*s12**3 + 192*s12**2*s23
     +     + 176*s12**2*s24 + 776*s12**2*s34 + 176*s12*s13**2 + 96*s12*
     +    s13*s23 + 96*s12*s13*s24 + 408*s12*s13*s34 + 64*s12*s23**2 - 
     +    72*s12*s23*s24 - 216*s12*s23*s34 - 464*s12*s24**2 - 856*s12*
     +    s24*s34 - 1112*s12*s34**2 + 56*s13**3 + 56*s13**2*s23 + 240*
     +    s13**2*s24 + 336*s13**2*s34 - 56*s13*s23**2 + 232*s13*s23*s24
     +     + 328*s13*s23*s34 - 304*s13*s24**2 - 632*s13*s24*s34 - 528*
     +    s13*s34**2 - 56*s23**3 - 96*s23**2*s24 - 288*s23**2*s34 - 368
     +    *s23*s24**2 - 800*s23*s24*s34 - 904*s23*s34**2 + 32*s24**3 + 
     +    128*s24**2*s34 + 192*s24*s34**2 + 128*s34**3 )

      LC = LC + Lc1(p4,p123)*S23**(-1)*S24**(-1)*S34**(-1) * ( 16*
     +    s12**2*s13*s14**2 + 16*s12**2*s14**3 + 120*s12*s13**2*s14**2
     +     + 120*s12*s13*s14**3 + 40*s13**3*s14**2 + 40*s13**2*s14**3 )

      LC = LC + Lc1(p4,p123)*S23**(-1)*S24**(-1) * (  - 112*s12**3*s13
     +     - 64*s12**3*s14 - 80*s12**3*s34 - 176*s12**2*s13**2 + 120*
     +    s12**2*s13*s14 - 104*s12**2*s13*s34 + 288*s12**2*s14**2 + 144
     +    *s12**2*s14*s34 + 136*s12**2*s34**2 - 64*s12*s13**3 + 416*s12
     +    *s13**2*s14 - 56*s12*s13**2*s34 + 488*s12*s13*s14**2 + 224*
     +    s12*s13*s14*s34 + 184*s12*s13*s34**2 - 32*s12*s14**3 + 128*
     +    s12*s14**2*s34 - 152*s12*s14*s34**2 + 104*s13**3*s14 - 128*
     +    s13**3*s34 + 104*s13**2*s14**2 - 40*s13**2*s14*s34 + 16*
     +    s13**2*s34**2 - 32*s13*s14**3 + 16*s13*s14**2*s34 - 136*s13*
     +    s14*s34**2 - 8*s13*s34**3 )

      LC = LC + Lc1(p4,p123)*S24**(-1)*S34**(-1) * (  - 16*s12**2*s13*
     +    s14 - 16*s12**2*s14*s23 - 72*s12*s13**2*s14 + 120*s12*s13*
     +    s14**2 - 144*s12*s13*s14*s23 + 240*s12*s14**3 - 120*s12*
     +    s14**2*s23 - 72*s12*s14*s23**2 - 24*s13**3*s14 + 80*s13**2*
     +    s14**2 - 72*s13**2*s14*s23 + 120*s13*s14**3 - 72*s13*s14*
     +    s23**2 + 120*s14**3*s23 - 80*s14**2*s23**2 - 24*s14*s23**3 )

      LC = LC + Lc1(p4,p123)*S24**(-1) * (  - 184*s12**2*s13 - 96*
     +    s12**2*s14 - 72*s12**2*s23 - 48*s12**2*s34 - 160*s12*s13**2
     +     + 528*s12*s13*s14 - 256*s12*s13*s23 + 152*s12*s13*s34 + 1008
     +    *s12*s14**2 - 168*s12*s14*s23 + 368*s12*s14*s34 - 144*s12*
     +    s23**2 + 40*s12*s23*s34 + 136*s12*s34**2 + 48*s13**3 + 232*
     +    s13**2*s14 - 8*s13**2*s23 - 96*s13**2*s34 + 376*s13*s14**2 + 
     +    24*s13*s14*s23 - 48*s13*s14*s34 - 88*s13*s23**2 - 40*s13*s23*
     +    s34 + 8*s13*s34**2 - 64*s14**3 + 488*s14**2*s23 - 48*s14**2*
     +    s34 - 200*s14*s23**2 + 104*s14*s23*s34 - 120*s14*s34**2 - 80*
     +    s23**3 - 64*s23**2*s34 + 40*s23*s34**2 - 16*s34**3 )

      LCb=-LC/s134/s234
      
      return
      end
      
      function LCc(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LC=0d0

      LC = LC + Lc1(p12,p34)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 2736*s12**4*s34**2 + 6232*s12**3*s34**3 - 4736*s12**2*
     +    s34**4 )

      LC = LC + Lc1(p12,p34)*S13**(-1)*S14**(-1)*S23**(-1) * ( 60*
     +    s12**3*s24*s34 + 4644*s12**3*s34**2 + 96*s12**2*s24**3 + 2704
     +    *s12**2*s24**2*s34 + 6316*s12**2*s24*s34**2 - 4264*s12**2*
     +    s34**3 - 828*s12*s24**4 + 1516*s12*s24**3*s34 - 6736*s12*
     +    s24**2*s34**2 - 5788*s12*s24*s34**3 - 3088*s12*s34**4 - 828*
     +    s24**5 + 264*s24**4*s34 + 1348*s24**3*s34**2 + 840*s24**2*
     +    s34**3 )

      LC = LC + Lc1(p12,p34)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 84*
     +    s12**3*s23*s34 + 3956*s12**3*s34**2 + 120*s12**2*s23**3 - 440
     +    *s12**2*s23**2*s34 - 1884*s12**2*s23*s34**2 - 4808*s12**2*
     +    s34**3 + 28*s12*s23**3*s34 + 1188*s12*s23**2*s34**2 - 452*s12
     +    *s23*s34**3 - 1968*s12*s34**4 + 64*s23**4*s34 + 96*s23**3*
     +    s34**2 + 240*s23**2*s34**3 )

      LC = LC + Lc1(p12,p34)*S13**(-1)*S14**(-1) * (  - 408*s12**3*s34
     +     + 504*s12**2*s23**2 + 744*s12**2*s23*s24 - 1076*s12**2*s23*
     +    s34 + 456*s12**2*s24**2 + 1060*s12**2*s24*s34 + 2712*s12**2*
     +    s34**2 - 264*s12*s23**3 - 1428*s12*s23**2*s24 - 1072*s12*
     +    s23**2*s34 - 2892*s12*s23*s24**2 - 3048*s12*s23*s24*s34 + 648
     +    *s12*s23*s34**2 - 2556*s12*s24**3 - 1136*s12*s24**2*s34 - 
     +    4812*s12*s24*s34**2 - 6464*s12*s34**3 - 92*s23**4 - 648*
     +    s23**3*s24 + 800*s23**3*s34 - 2076*s23**2*s24**2 + 2688*
     +    s23**2*s24*s34 + 1268*s23**2*s34**2 - 3404*s23*s24**3 + 3792*
     +    s23*s24**2*s34 + 2780*s23*s24*s34**2 + 848*s23*s34**3 - 2712*
     +    s24**4 + 2104*s24**3*s34 + 2492*s24**2*s34**2 + 984*s24*
     +    s34**3 )

      LC = LC + Lc1(p12,p34)*S13**(-1)*S23**(-1)*S24**(-1) * ( 240*
     +    s12**3*s14*s34 + 4012*s12**3*s34**2 - 2232*s12**2*s14**2*s34
     +     + 17736*s12**2*s14*s34**2 - 14624*s12**2*s34**3 + 120*s12*
     +    s14**4 - 3504*s12*s14**3*s34 - 3852*s12*s14**2*s34**2 + 6056*
     +    s12*s14*s34**3 - 184*s12*s34**4 + 924*s14**4*s34 - 1016*
     +    s14**3*s34**2 + 992*s14**2*s34**3 )

      LC = LC + Lc1(p12,p34)*S13**(-1)*S23**(-1) * ( 156*s12**3*s34 + 
     +    168*s12**2*s14**2 + 456*s12**2*s14*s24 - 5212*s12**2*s14*s34
     +     + 384*s12**2*s24**2 + 1740*s12**2*s24*s34 + 16892*s12**2*
     +    s34**2 + 624*s12*s14**3 - 192*s12*s14**2*s24 - 5876*s12*
     +    s14**2*s34 - 2592*s12*s14*s24**2 - 572*s12*s14*s24*s34 - 
     +    16192*s12*s14*s34**2 - 2724*s12*s24**3 + 2908*s12*s24**2*s34
     +     - 16420*s12*s24*s34**2 - 4036*s12*s34**3 - 940*s14**4 - 4416
     +    *s14**3*s24 + 5908*s14**3*s34 - 8376*s14**2*s24**2 + 11768*
     +    s14**2*s24*s34 + 200*s14**2*s34**2 - 8092*s14*s24**3 + 10176*
     +    s14*s24**2*s34 + 2992*s14*s24*s34**2 + 1016*s14*s34**3 - 4020
     +    *s24**4 + 3624*s24**3*s34 + 3052*s24**2*s34**2 + 584*s24*
     +    s34**3 )

      LC = LC + Lc1(p12,p34)*S13**(-1)*S24**(-1) * ( 300*s12**3*s34 + 
     +    168*s12**2*s14**2 + 456*s12**2*s14*s23 - 5188*s12**2*s14*s34
     +     + 408*s12**2*s23**2 + 1532*s12**2*s23*s34 + 9188*s12**2*
     +    s34**2 + 768*s12*s14**3 + 48*s12*s14**2*s23 - 4140*s12*s14**2
     +    *s34 - 960*s12*s14*s23**2 - 4004*s12*s14*s23*s34 - 15600*s12*
     +    s14*s34**2 - 744*s12*s23**3 - 1532*s12*s23**2*s34 - 304*s12*
     +    s23*s34**2 + 3756*s12*s34**3 - 1000*s14**4 - 2580*s14**3*s23
     +     + 5468*s14**3*s34 - 2392*s14**2*s23**2 + 8112*s14**2*s23*s34
     +     - 180*s14**2*s34**2 - 480*s14*s23**3 + 6120*s14*s23**2*s34
     +     + 604*s14*s23*s34**2 + 88*s14*s34**3 - 68*s23**4 + 1328*
     +    s23**3*s34 + 400*s23**2*s34**2 + 96*s23*s34**3 )

      LC = LC + Lc1(p12,p34)*S13**(-1) * ( 912*s12**2*s14 + 1248*s12**2
     +    *s23 + 1224*s12**2*s24 + 2372*s12**2*s34 + 240*s12*s14**2 - 
     +    3768*s12*s14*s23 - 5112*s12*s14*s24 - 4864*s12*s14*s34 - 3648
     +    *s12*s23**2 - 7404*s12*s23*s24 - 6916*s12*s23*s34 - 7224*s12*
     +    s24**2 - 4076*s12*s24*s34 - 8932*s12*s34**2 - 6804*s14**3 - 
     +    10852*s14**2*s23 - 16536*s14**2*s24 + 18656*s14**2*s34 - 5740
     +    *s14*s23**2 - 16400*s14*s23*s24 + 19272*s14*s23*s34 - 19184*
     +    s14*s24**2 + 23560*s14*s24*s34 + 4052*s14*s34**2 - 1096*
     +    s23**3 - 5408*s23**2*s24 + 6544*s23**2*s34 - 11532*s23*s24**2
     +     + 13480*s23*s24*s34 + 3428*s23*s34**2 - 11172*s24**3 + 12120
     +    *s24**2*s34 + 5832*s24*s34**2 + 1744*s34**3 )

      LC = LC + Lc1(p12,p34)*S14**(-1)*S23**(-1)*S24**(-1) * ( 12*
     +    s12**3*s34**2 + 2304*s12**2*s34**3 + 1208*s12*s34**4 )

      LC = LC + Lc1(p12,p34)*S14**(-1)*S23**(-1) * ( 2220*s12**3*s34 + 
     +    96*s12**2*s24**2 - 2432*s12**2*s24*s34 - 3924*s12**2*s34**2
     +     - 1212*s12*s24**3 - 3532*s12*s24**2*s34 + 5000*s12*s24*
     +    s34**2 + 5364*s12*s34**3 - 1228*s24**4 + 3408*s24**3*s34 + 
     +    1380*s24**2*s34**2 + 800*s24*s34**3 )

      LC = LC + Lc1(p12,p34)*S14**(-1)*S24**(-1) * ( 1980*s12**3*s34 + 
     +    120*s12**2*s23**2 - 1496*s12**2*s23*s34 - 2076*s12**2*s34**2
     +     + 172*s12*s23**2*s34 + 1756*s12*s23*s34**2 + 2868*s12*s34**3
     +     + 64*s23**3*s34 + 96*s23**2*s34**2 + 336*s23*s34**3 )

      LC = LC + Lc1(p12,p34)*S14**(-1) * ( 384*s12**2*s23 + 360*s12**2*
     +    s24 - 3100*s12**2*s34 - 360*s12*s23**2 - 1644*s12*s23*s24 - 
     +    1852*s12*s23*s34 - 2496*s12*s24**2 - 4932*s12*s24*s34 + 5300*
     +    s12*s34**2 - 100*s23**3 - 684*s23**2*s24 + 504*s23**2*s34 - 
     +    2056*s23*s24**2 + 2272*s23*s24*s34 + 1004*s23*s34**2 - 2700*
     +    s24**3 + 4800*s24**2*s34 + 2328*s24*s34**2 + 1192*s34**3 )

      LC = LC + Lc1(p12,p34)*S23**(-1)*S24**(-1) * ( 912*s12**3*s34 + 
     +    648*s12**2*s14*s34 - 9896*s12**2*s34**2 + 120*s12*s14**3 - 
     +    6032*s12*s14**2*s34 + 10420*s12*s14*s34**2 + 560*s12*s34**3
     +     + 924*s14**3*s34 - 1488*s14**2*s34**2 - 1376*s14*s34**3 )

      LC = LC + Lc1(p12,p34)*S23**(-1) * ( 168*s12**2*s14 + 288*s12**2*
     +    s24 - 5364*s12**2*s34 + 504*s12*s14**2 - 792*s12*s14*s24 - 
     +    16916*s12*s14*s34 - 2472*s12*s24**2 - 12968*s12*s24*s34 + 
     +    10596*s12*s34**2 - 940*s14**3 - 3956*s14**2*s24 + 6752*s14**2
     +    *s34 - 6156*s14*s24**2 + 12624*s14*s24*s34 - 1728*s14*s34**2
     +     - 4360*s24**3 + 9976*s24**2*s34 + 1384*s24*s34**2 - 696*
     +    s34**3 )

      LC = LC + Lc1(p12,p34)*S24**(-1) * ( 168*s12**2*s14 + 288*s12**2*
     +    s23 - 5196*s12**2*s34 + 648*s12*s14**2 - 504*s12*s14*s23 - 
     +    13388*s12*s14*s34 - 840*s12*s23**2 - 1928*s12*s23*s34 + 9924*
     +    s12*s34**2 - 1000*s14**3 - 2060*s14**2*s23 + 6832*s14**2*s34
     +     - 516*s14*s23**2 + 6216*s14*s23*s34 - 4044*s14*s34**2 - 60*
     +    s23**3 + 1192*s23**2*s34 - 1160*s23*s34**2 - 784*s34**3 )

      LC = LC + Lc1(p12,p34) * ( 576*s12**2 - 912*s12*s14 - 3408*s12*
     +    s23 - 4752*s12*s24 - 11904*s12*s34 - 5632*s14**2 - 5072*s14*
     +    s23 - 10028*s14*s24 + 17104*s14*s34 - 1136*s23**2 - 5020*s23*
     +    s24 + 6480*s23*s34 - 8064*s24**2 + 13792*s24*s34 + 200*s34**2
     +     )

      LC = LC + Lc1(p13,p24)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 8*
     +    s12**3*s24*s34 - 8*s12**3*s34**2 )

      LC = LC + Lc1(p13,p24)*S13**(-1)*S14**(-1) * (  - 8*s12**3*s23 - 
     +    8*s12**3*s24 - 16*s12**3*s34 - 8*s12*s23**3 - 8*s12*s23**2*
     +    s24 - 16*s12*s23**2*s34 - 8*s12*s23*s24*s34 - 8*s12*s23*
     +    s34**2 )

      LC = LC + Lc1(p13,p24)*S13**(-1)*S23**(-1) * (  - 8*s12**3*s24 - 
     +    8*s12**3*s34 - 8*s12**2*s14*s24 - 8*s12**2*s14*s34 - 8*s12**2
     +    *s24*s34 - 8*s12**2*s34**2 )

      LC = LC + Lc1(p13,p24)*S13**(-1) * (  - 8*s12**3 - 8*s12**2*s14
     +     - 8*s12**2*s23 - 8*s12**2*s24 - 16*s12**2*s34 - 8*s12*s23**2
     +     - 8*s12*s23*s24 - 8*s12*s23*s34 - 8*s14*s23**2 - 8*s14*s23*
     +    s24 - 8*s14*s23*s34 - 8*s23**3 - 8*s23**2*s24 - 16*s23**2*s34
     +     - 8*s23*s24*s34 - 8*s23*s34**2 )

      LC = LC + Lc1(p13,p24)*S14**(-1)*S23**(-1) * (  - 8*s12**3*s24 - 
     +    8*s12**3*s34 )

      LC = LC + Lc1(p13,p24)*S14**(-1) * (  - 8*s12**3 - 8*s12*s23**2
     +     - 8*s12*s23*s24 - 8*s12*s23*s34 )

      LC = LC + Lc1(p13,p24)*S23**(-1)*S24**(-1) * (  - 32*s12**2*s13*
     +    s14 - 32*s12**2*s13*s34 - 32*s12**2*s14**2 - 64*s12**2*s14*
     +    s34 - 32*s12**2*s34**2 )

      LC = LC + Lc1(p13,p24)*S23**(-1) * (  - 32*s12**2*s13 - 32*s12**2
     +    *s14 - 8*s12**2*s24 - 40*s12**2*s34 )

      LC = LC + Lc1(p13,p24)*S24**(-1) * (  - 32*s12**2*s13 - 32*s12**2
     +    *s14 - 32*s12**2*s34 - 32*s12*s13*s14 - 32*s12*s13*s23 - 32*
     +    s12*s13*s34 - 32*s12*s14**2 - 32*s12*s14*s23 - 64*s12*s14*s34
     +     - 32*s12*s23*s34 - 32*s12*s34**2 )

      LC = LC + Lc1(p13,p24) * (  - 8*s12**2 - 32*s12*s13 - 32*s12*s14
     +     - 32*s12*s34 - 8*s23**2 - 8*s23*s24 - 8*s23*s34 )

      LC = LC + Lc1(p14,p23)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s23*s34 - 8*s12**3*s34**2 )

      LC = LC + Lc1(p14,p23)*S13**(-1)*S14**(-1) * (  - 8*s12**3*s23 - 
     +    8*s12**3*s24 - 16*s12**3*s34 - 8*s12*s23*s24**2 - 8*s12*s23*
     +    s24*s34 - 8*s12*s24**3 - 16*s12*s24**2*s34 - 8*s12*s24*s34**2
     +     )

      LC = LC + Lc1(p14,p23)*S13**(-1)*S24**(-1) * (  - 8*s12**3*s23 - 
     +    8*s12**3*s34 )

      LC = LC + Lc1(p14,p23)*S13**(-1) * (  - 8*s12**3 - 8*s12*s23*s24
     +     - 8*s12*s24**2 - 8*s12*s24*s34 )

      LC = LC + Lc1(p14,p23)*S14**(-1)*S24**(-1) * (  - 8*s12**3*s23 - 
     +    8*s12**3*s34 - 8*s12**2*s13*s23 - 8*s12**2*s13*s34 - 8*s12**2
     +    *s23*s34 - 8*s12**2*s34**2 )

      LC = LC + Lc1(p14,p23)*S14**(-1) * (  - 8*s12**3 - 8*s12**2*s13
     +     - 8*s12**2*s23 - 8*s12**2*s24 - 16*s12**2*s34 - 8*s12*s23*
     +    s24 - 8*s12*s24**2 - 8*s12*s24*s34 - 8*s13*s23*s24 - 8*s13*
     +    s24**2 - 8*s13*s24*s34 - 8*s23*s24**2 - 8*s23*s24*s34 - 8*
     +    s24**3 - 16*s24**2*s34 - 8*s24*s34**2 )

      LC = LC + Lc1(p14,p23)*S23**(-1)*S24**(-1) * (  - 32*s12**2*
     +    s13**2 - 32*s12**2*s13*s14 - 64*s12**2*s13*s34 - 32*s12**2*
     +    s14*s34 - 32*s12**2*s34**2 )

      LC = LC + Lc1(p14,p23)*S23**(-1) * (  - 32*s12**2*s13 - 32*s12**2
     +    *s14 - 32*s12**2*s34 - 32*s12*s13**2 - 32*s12*s13*s14 - 32*
     +    s12*s13*s24 - 64*s12*s13*s34 - 32*s12*s14*s24 - 32*s12*s14*
     +    s34 - 32*s12*s24*s34 - 32*s12*s34**2 )

      LC = LC + Lc1(p14,p23)*S24**(-1) * (  - 32*s12**2*s13 - 32*s12**2
     +    *s14 - 8*s12**2*s23 - 40*s12**2*s34 )

      LC = LC + Lc1(p14,p23) * (  - 8*s12**2 - 32*s12*s13 - 32*s12*s14
     +     - 32*s12*s34 - 8*s23*s24 - 8*s24**2 - 8*s24*s34 )

      LC = LC + Lc1(p23,p14)*S13**(-1)*S14**(-1) * (  - 32*s12**2*s23*
     +    s24 - 32*s12**2*s23*s34 - 32*s12**2*s24**2 - 64*s12**2*s24*
     +    s34 - 32*s12**2*s34**2 )

      LC = LC + Lc1(p23,p14)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s14*s34 - 8*s12**3*s34**2 )

      LC = LC + Lc1(p23,p14)*S13**(-1)*S23**(-1) * (  - 8*s12**3*s14 - 
     +    8*s12**3*s34 - 8*s12**2*s14*s24 - 8*s12**2*s14*s34 - 8*s12**2
     +    *s24*s34 - 8*s12**2*s34**2 )

      LC = LC + Lc1(p23,p14)*S13**(-1)*S24**(-1) * (  - 8*s12**3*s14 - 
     +    8*s12**3*s34 )

      LC = LC + Lc1(p23,p14)*S13**(-1) * (  - 8*s12**2*s14 - 32*s12**2*
     +    s23 - 32*s12**2*s24 - 40*s12**2*s34 )

      LC = LC + Lc1(p23,p14)*S14**(-1) * (  - 32*s12**2*s23 - 32*s12**2
     +    *s24 - 32*s12**2*s34 - 32*s12*s13*s23 - 32*s12*s13*s24 - 32*
     +    s12*s13*s34 - 32*s12*s23*s24 - 32*s12*s23*s34 - 32*s12*s24**2
     +     - 64*s12*s24*s34 - 32*s12*s34**2 )

      LC = LC + Lc1(p23,p14)*S23**(-1)*S24**(-1) * (  - 8*s12**3*s13 - 
     +    8*s12**3*s14 - 16*s12**3*s34 - 8*s12*s13**3 - 8*s12*s13**2*
     +    s14 - 16*s12*s13**2*s34 - 8*s12*s13*s14*s34 - 8*s12*s13*
     +    s34**2 )

      LC = LC + Lc1(p23,p14)*S23**(-1) * (  - 8*s12**3 - 8*s12**2*s13
     +     - 8*s12**2*s14 - 8*s12**2*s24 - 16*s12**2*s34 - 8*s12*s13**2
     +     - 8*s12*s13*s14 - 8*s12*s13*s34 - 8*s13**3 - 8*s13**2*s14 - 
     +    8*s13**2*s24 - 16*s13**2*s34 - 8*s13*s14*s24 - 8*s13*s14*s34
     +     - 8*s13*s24*s34 - 8*s13*s34**2 )

      LC = LC + Lc1(p23,p14)*S24**(-1) * (  - 8*s12**3 - 8*s12*s13**2
     +     - 8*s12*s13*s14 - 8*s12*s13*s34 )

      LC = LC + Lc1(p23,p14) * (  - 8*s12**2 - 32*s12*s23 - 32*s12*s24
     +     - 32*s12*s34 - 8*s13**2 - 8*s13*s14 - 8*s13*s34 )

      LC = LC + Lc1(p24,p13)*S13**(-1)*S14**(-1) * (  - 32*s12**2*
     +    s23**2 - 32*s12**2*s23*s24 - 64*s12**2*s23*s34 - 32*s12**2*
     +    s24*s34 - 32*s12**2*s34**2 )

      LC = LC + Lc1(p24,p13)*S13**(-1) * (  - 32*s12**2*s23 - 32*s12**2
     +    *s24 - 32*s12**2*s34 - 32*s12*s14*s23 - 32*s12*s14*s24 - 32*
     +    s12*s14*s34 - 32*s12*s23**2 - 32*s12*s23*s24 - 64*s12*s23*s34
     +     - 32*s12*s24*s34 - 32*s12*s34**2 )

      LC = LC + Lc1(p24,p13)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s13*s34 - 8*s12**3*s34**2 )

      LC = LC + Lc1(p24,p13)*S14**(-1)*S23**(-1) * (  - 8*s12**3*s13 - 
     +    8*s12**3*s34 )

      LC = LC + Lc1(p24,p13)*S14**(-1)*S24**(-1) * (  - 8*s12**3*s13 - 
     +    8*s12**3*s34 - 8*s12**2*s13*s23 - 8*s12**2*s13*s34 - 8*s12**2
     +    *s23*s34 - 8*s12**2*s34**2 )

      LC = LC + Lc1(p24,p13)*S14**(-1) * (  - 8*s12**2*s13 - 32*s12**2*
     +    s23 - 32*s12**2*s24 - 40*s12**2*s34 )

      LC = LC + Lc1(p24,p13)*S23**(-1)*S24**(-1) * (  - 8*s12**3*s13 - 
     +    8*s12**3*s14 - 16*s12**3*s34 - 8*s12*s13*s14**2 - 8*s12*s13*
     +    s14*s34 - 8*s12*s14**3 - 16*s12*s14**2*s34 - 8*s12*s14*s34**2
     +     )

      LC = LC + Lc1(p24,p13)*S23**(-1) * (  - 8*s12**3 - 8*s12*s13*s14
     +     - 8*s12*s14**2 - 8*s12*s14*s34 )

      LC = LC + Lc1(p24,p13)*S24**(-1) * (  - 8*s12**3 - 8*s12**2*s13
     +     - 8*s12**2*s14 - 8*s12**2*s23 - 16*s12**2*s34 - 8*s12*s13*
     +    s14 - 8*s12*s14**2 - 8*s12*s14*s34 - 8*s13*s14**2 - 8*s13*s14
     +    *s23 - 8*s13*s14*s34 - 8*s14**3 - 8*s14**2*s23 - 16*s14**2*
     +    s34 - 8*s14*s23*s34 - 8*s14*s34**2 )

      LC = LC + Lc1(p24,p13) * (  - 8*s12**2 - 32*s12*s23 - 32*s12*s24
     +     - 32*s12*s34 - 8*s13*s14 - 8*s14**2 - 8*s14*s34 )

      LC = LC + Lc1(p34,p12)*S13**(-1)*S14**(-1)*S23**(-1) * ( 368*
     +    s24**5 - 192*s24**4*s34 - 128*s24**3*s34**2 )

      LC = LC + Lc1(p34,p12)*S13**(-1)*S14**(-1) * (  - 16*s23**4 + 32*
     +    s23**3*s24 + 464*s23**2*s24**2 + 80*s23**2*s24*s34 + 64*
     +    s23**2*s34**2 + 1136*s23*s24**3 + 128*s23*s24**2*s34 + 160*
     +    s23*s24*s34**2 + 1088*s24**4 - 144*s24**3*s34 - 32*s24**2*
     +    s34**2 )

      LC = LC + Lc1(p34,p12)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 688*
     +    s14**3*s34**2 )

      LC = LC + Lc1(p34,p12)*S13**(-1)*S23**(-1) * (  - 16*s14**4 + 352
     +    *s14**3*s24 - 416*s14**3*s34 + 1424*s14**2*s24**2 - 832*
     +    s14**2*s24*s34 - 1264*s14**2*s34**2 + 2112*s14*s24**3 - 608*
     +    s14*s24**2*s34 - 656*s14*s24*s34**2 + 1424*s24**4 - 384*
     +    s24**3*s34 - 208*s24**2*s34**2 )

      LC = LC + Lc1(p34,p12)*S13**(-1)*S24**(-1) * ( 16*s14**4 + 432*
     +    s14**3*s23 - 656*s14**3*s34 + 144*s14**2*s23**2 - 1216*s14**2
     +    *s23*s34 - 1104*s14**2*s34**2 + 112*s14*s23**3 - 464*s14*
     +    s23**2*s34 - 560*s14*s23*s34**2 + 16*s23**4 - 64*s23**2*
     +    s34**2 )

      LC = LC + Lc1(p34,p12)*S13**(-1) * ( 656*s14**3 + 1632*s14**2*s23
     +     + 2560*s14**2*s24 - 2240*s14**2*s34 + 848*s14*s23**2 + 3136*
     +    s14*s23*s24 - 1920*s14*s23*s34 + 4320*s14*s24**2 - 1920*s14*
     +    s24*s34 - 1456*s14*s34**2 + 208*s23**3 + 1232*s23**2*s24 - 
     +    384*s23**2*s34 + 3136*s23*s24**2 - 576*s23*s24*s34 - 592*s23*
     +    s34**2 + 3520*s24**3 - 480*s24**2*s34 - 512*s24*s34**2 )

      LC = LC + Lc2(p3,p12)*S13**(-1)*S14**(-1)*S24**(-1) * ( 24*s12**3
     +    *s23*s34 + 8*s12**3*s34**2 - 24*s12**2*s23**2*s34 - 24*s12**2
     +    *s23*s34**2 - 48*s12*s23**3*s34 - 48*s12*s23**2*s34**2 )

      LC = LC + Lc2(p3,p12)*S13**(-1)*S14**(-1) * ( 24*s12**2*s23*s34
     +     + 48*s12*s23**3 + 48*s12*s23**2*s24 )

      LC = LC + Lc2(p3,p12)*S13**(-1)*S24**(-1) * (  - 24*s12**3*s34 - 
     +    24*s12**2*s23*s34 - 48*s12*s14*s23**2 + 48*s12*s23**3 )

      LC = LC + Lc2(p3,p12)*S14**(-1)*S23**(-1) * (  - 48*s12*s13**3 + 
     +    48*s12*s13**2*s24 + 48*s12*s13**2*s34 )

      LC = LC + Lc2(p3,p12)*S23**(-1)*S24**(-1) * (  - 48*s12*s13**3 - 
     +    48*s12*s13**2*s14 - 48*s12*s13**2*s34 )

      LC = LC + Lc2(p3,p124)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 96*s12**3*s34**3 - 216*s12**2*s34**4 )

      LC = LC + Lc2(p3,p124)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 192*
     +    s12**2*s34**3 - 120*s12*s24*s34**3 - 264*s12*s34**4 - 24*
     +    s24**2*s34**3 - 48*s24*s34**4 )

      LC = LC + Lc2(p3,p124)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 72*
     +    s12**3*s23*s34 - 168*s12**3*s34**2 - 48*s12**2*s23**3 - 312*
     +    s12**2*s23**2*s34 - 696*s12**2*s23*s34**2 - 648*s12**2*s34**3
     +     )

      LC = LC + Lc2(p3,p124)*S13**(-1)*S14**(-1) * (  - 48*s12**2*
     +    s23**2 - 264*s12**2*s23*s34 - 408*s12**2*s34**2 - 72*s12*
     +    s23**3 - 72*s12*s23**2*s24 - 432*s12*s23**2*s34 - 264*s12*s23
     +    *s24*s34 - 912*s12*s23*s34**2 - 312*s12*s24*s34**2 - 816*s12*
     +    s34**3 - 24*s23**3*s24 - 24*s23**2*s24**2 - 120*s23**2*s24*
     +    s34 - 72*s23*s24**2*s34 - 216*s23*s24*s34**2 - 72*s24**2*
     +    s34**2 - 168*s24*s34**3 )

      LC = LC + Lc2(p3,p124)*S13**(-1)*S23**(-1)*S24**(-1) * ( 64*
     +    s12**3*s34**2 + 64*s12**2*s14*s34**2 + 104*s12**2*s34**3 + 
     +    224*s12*s14*s34**3 - 216*s12*s34**4 + 24*s14**2*s34**3 )

      LC = LC + Lc2(p3,p124)*S13**(-1)*S23**(-1) * ( 96*s12**2*s34**2
     +     + 24*s12*s14*s34**2 + 24*s12*s24*s34**2 + 96*s12*s34**3 + 24
     +    *s14*s34**3 - 24*s24*s34**3 - 48*s34**4 )

      LC = LC + Lc2(p3,p124)*S13**(-1)*S24**(-1) * ( 72*s12**3*s34 + 72
     +    *s12**2*s14*s34 + 48*s12**2*s23**2 + 240*s12**2*s23*s34 + 288
     +    *s12**2*s34**2 + 72*s12*s14*s23**2 + 384*s12*s14*s23*s34 + 
     +    528*s12*s14*s34**2 - 72*s12*s23**3 - 384*s12*s23**2*s34 - 768
     +    *s12*s23*s34**2 - 672*s12*s34**3 + 24*s14**2*s23**2 + 72*
     +    s14**2*s23*s34 + 72*s14**2*s34**2 - 24*s14*s23**3 - 72*s14*
     +    s23**2*s34 - 72*s14*s23*s34**2 - 24*s14*s34**3 )

      LC = LC + Lc2(p3,p124)*S13**(-1) * ( 48*s12**2*s23 + 144*s12**2*
     +    s34 + 24*s12*s14*s23 + 48*s12*s14*s34 + 24*s12*s23*s24 + 96*
     +    s12*s23*s34 + 48*s12*s24*s34 + 192*s12*s34**2 - 24*s14**2*s23
     +     - 24*s14**2*s34 + 24*s14*s23**2 - 48*s14*s23*s24 + 48*s14*
     +    s23*s34 - 48*s14*s24*s34 + 48*s14*s34**2 - 48*s23**3 - 24*
     +    s23**2*s24 - 192*s23**2*s34 - 24*s23*s24**2 - 96*s23*s24*s34
     +     - 288*s23*s34**2 - 24*s24**2*s34 - 96*s24*s34**2 - 192*
     +    s34**3 )

      LC = LC + Lc2(p3,p124)*S23**(-1) * ( 24*s13*s14**2 + 48*s13*s14*
     +    s24 + 24*s13*s14*s34 + 24*s13*s24**2 + 24*s13*s24*s34 + 24*
     +    s14**2*s34 + 48*s14*s24*s34 + 24*s14*s34**2 + 24*s24**2*s34
     +     + 24*s24*s34**2 )

      LC = LC + Lc2(p4,p12)*S13**(-1)*S14**(-1)*S23**(-1) * ( 24*s12**3
     +    *s24*s34 + 8*s12**3*s34**2 - 24*s12**2*s24**2*s34 - 24*s12**2
     +    *s24*s34**2 - 48*s12*s24**3*s34 - 48*s12*s24**2*s34**2 )

      LC = LC + Lc2(p4,p12)*S13**(-1)*S14**(-1) * ( 24*s12**2*s24*s34
     +     + 48*s12*s23*s24**2 + 48*s12*s24**3 )

      LC = LC + Lc2(p4,p12)*S13**(-1)*S24**(-1) * (  - 48*s12*s14**3 + 
     +    48*s12*s14**2*s23 + 48*s12*s14**2*s34 )

      LC = LC + Lc2(p4,p12)*S14**(-1)*S23**(-1) * (  - 24*s12**3*s34 - 
     +    24*s12**2*s24*s34 - 48*s12*s13*s24**2 + 48*s12*s24**3 )

      LC = LC + Lc2(p4,p12)*S23**(-1)*S24**(-1) * (  - 48*s12*s13*
     +    s14**2 - 48*s12*s14**3 - 48*s12*s14**2*s34 )

      LC = LC + Lc2(p4,p123)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 96*s12**3*s34**3 - 216*s12**2*s34**4 )

      LC = LC + Lc2(p4,p123)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 72*
     +    s12**3*s24*s34 - 168*s12**3*s34**2 - 48*s12**2*s24**3 - 312*
     +    s12**2*s24**2*s34 - 696*s12**2*s24*s34**2 - 648*s12**2*s34**3
     +     )

      LC = LC + Lc2(p4,p123)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 192*
     +    s12**2*s34**3 - 120*s12*s23*s34**3 - 264*s12*s34**4 - 24*
     +    s23**2*s34**3 - 48*s23*s34**4 )

      LC = LC + Lc2(p4,p123)*S13**(-1)*S14**(-1) * (  - 48*s12**2*
     +    s24**2 - 264*s12**2*s24*s34 - 408*s12**2*s34**2 - 72*s12*s23*
     +    s24**2 - 264*s12*s23*s24*s34 - 312*s12*s23*s34**2 - 72*s12*
     +    s24**3 - 432*s12*s24**2*s34 - 912*s12*s24*s34**2 - 816*s12*
     +    s34**3 - 24*s23**2*s24**2 - 72*s23**2*s24*s34 - 72*s23**2*
     +    s34**2 - 24*s23*s24**3 - 120*s23*s24**2*s34 - 216*s23*s24*
     +    s34**2 - 168*s23*s34**3 )

      LC = LC + Lc2(p4,p123)*S14**(-1)*S23**(-1)*S24**(-1) * ( 64*
     +    s12**3*s34**2 + 64*s12**2*s13*s34**2 + 104*s12**2*s34**3 + 
     +    224*s12*s13*s34**3 - 216*s12*s34**4 + 24*s13**2*s34**3 )

      LC = LC + Lc2(p4,p123)*S14**(-1)*S23**(-1) * ( 72*s12**3*s34 + 72
     +    *s12**2*s13*s34 + 48*s12**2*s24**2 + 240*s12**2*s24*s34 + 288
     +    *s12**2*s34**2 + 72*s12*s13*s24**2 + 384*s12*s13*s24*s34 + 
     +    528*s12*s13*s34**2 - 72*s12*s24**3 - 384*s12*s24**2*s34 - 768
     +    *s12*s24*s34**2 - 672*s12*s34**3 + 24*s13**2*s24**2 + 72*
     +    s13**2*s24*s34 + 72*s13**2*s34**2 - 24*s13*s24**3 - 72*s13*
     +    s24**2*s34 - 72*s13*s24*s34**2 - 24*s13*s34**3 )

      LC = LC + Lc2(p4,p123)*S14**(-1)*S24**(-1) * ( 96*s12**2*s34**2
     +     + 24*s12*s13*s34**2 + 24*s12*s23*s34**2 + 96*s12*s34**3 + 24
     +    *s13*s34**3 - 24*s23*s34**3 - 48*s34**4 )

      LC = LC + Lc2(p4,p123)*S14**(-1) * ( 48*s12**2*s24 + 144*s12**2*
     +    s34 + 24*s12*s13*s24 + 48*s12*s13*s34 + 24*s12*s23*s24 + 48*
     +    s12*s23*s34 + 96*s12*s24*s34 + 192*s12*s34**2 - 24*s13**2*s24
     +     - 24*s13**2*s34 - 48*s13*s23*s24 - 48*s13*s23*s34 + 24*s13*
     +    s24**2 + 48*s13*s24*s34 + 48*s13*s34**2 - 24*s23**2*s24 - 24*
     +    s23**2*s34 - 24*s23*s24**2 - 96*s23*s24*s34 - 96*s23*s34**2
     +     - 48*s24**3 - 192*s24**2*s34 - 288*s24*s34**2 - 192*s34**3 )

      LC = LC + Lc2(p4,p123)*S24**(-1) * ( 24*s13**2*s14 + 24*s13**2*
     +    s34 + 48*s13*s14*s23 + 24*s13*s14*s34 + 48*s13*s23*s34 + 24*
     +    s13*s34**2 + 24*s14*s23**2 + 24*s14*s23*s34 + 24*s23**2*s34
     +     + 24*s23*s34**2 )

      LC = LC + Lc2(p12,p34)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 960*s12**4*s34**2 - 2496*s12**3*s34**3 - 1312*s12**2*s34**4
     +     )

      LC = LC + Lc2(p12,p34)*S13**(-1)*S14**(-1)*S23**(-1) * ( 1824*
     +    s12**3*s24*s34 + 1360*s12**3*s34**2 - 1776*s12**2*s24**2*s34
     +     - 6064*s12**2*s24*s34**2 - 8256*s12**2*s34**3 - 288*s12*
     +    s24**4 - 4096*s12*s24**3*s34 - 4416*s12*s24**2*s34**2 - 1600*
     +    s12*s24*s34**3 - 288*s24**5 + 368*s24**4*s34 + 208*s24**3*
     +    s34**2 )

      LC = LC + Lc2(p12,p34)*S13**(-1)*S14**(-1)*S24**(-1) * ( 1824*
     +    s12**3*s23*s34 + 1200*s12**3*s34**2 + 96*s12**2*s23**3 - 816*
     +    s12**2*s23**2*s34 - 784*s12**2*s23*s34**2 - 3808*s12**2*
     +    s34**3 + 240*s12*s23**3*s34 - 1056*s12*s23**2*s34**2 - 1056*
     +    s12*s23*s34**3 )

      LC = LC + Lc2(p12,p34)*S13**(-1)*S14**(-1) * ( 4224*s12**3*s34 + 
     +    384*s12**2*s23**2 + 480*s12**2*s23*s24 - 704*s12**2*s23*s34
     +     + 192*s12**2*s24**2 - 800*s12**2*s24*s34 - 4992*s12**2*
     +    s34**2 + 48*s12*s23**3 + 48*s12*s23**2*s24 - 240*s12*s23**2*
     +    s34 - 336*s12*s23*s24**2 - 3376*s12*s23*s24*s34 - 6688*s12*
     +    s23*s34**2 - 624*s12*s24**3 - 6544*s12*s24**2*s34 - 10336*s12
     +    *s24*s34**2 - 2752*s12*s34**3 - 48*s23**3*s24 - 48*s23**3*s34
     +     - 336*s23**2*s24**2 - 288*s23**2*s24*s34 - 48*s23**2*s34**2
     +     - 816*s23*s24**3 - 320*s23*s24**2*s34 - 144*s23*s24*s34**2
     +     - 816*s24**4 + 288*s24**3*s34 + 112*s24**2*s34**2 )

      LC = LC + Lc2(p12,p34)*S13**(-1)*S23**(-1)*S24**(-1) * ( 960*
     +    s12**3*s14*s34 + 5056*s12**3*s34**2 + 3840*s12**2*s14**2*s34
     +     - 12256*s12**2*s14*s34**2 - 2624*s12**2*s34**3 - 1952*s12*
     +    s14**3*s34 + 3968*s12*s14**2*s34**2 - 1952*s12*s14*s34**3 - 
     +    128*s14**3*s34**2 )

      LC = LC + Lc2(p12,p34)*S13**(-1)*S23**(-1) * ( 4032*s12**3*s34 + 
     +    480*s12**2*s14*s24 + 8528*s12**2*s14*s34 + 384*s12**2*s24**2
     +     + 2480*s12**2*s24*s34 - 14848*s12**2*s34**2 + 672*s12*s14**3
     +     + 1632*s12*s14**2*s24 - 9120*s12*s14**2*s34 + 1008*s12*s14*
     +    s24**2 - 14752*s12*s14*s24*s34 + 816*s12*s14*s34**2 - 240*s12
     +    *s24**3 - 11920*s12*s24**2*s34 - 8240*s12*s24*s34**2 - 3936*
     +    s12*s34**3 + 48*s14**4 - 96*s14**3*s24 + 192*s14**3*s34 - 816
     +    *s14**2*s24**2 + 320*s14**2*s24*s34 - 560*s14**2*s34**2 - 
     +    1440*s14*s24**3 + 384*s14*s24**2*s34 - 864*s14*s24*s34**2 - 
     +    1056*s24**4 + 624*s24**3*s34 - 224*s24**2*s34**2 )

      LC = LC + Lc2(p12,p34)*S13**(-1)*S24**(-1) * ( 3648*s12**3*s34 + 
     +    480*s12**2*s14*s23 + 7088*s12**2*s14*s34 + 576*s12**2*s23**2
     +     + 112*s12**2*s23*s34 - 12864*s12**2*s34**2 + 672*s12*s14**3
     +     + 1056*s12*s14**2*s23 - 9440*s12*s14**2*s34 + 144*s12*s14*
     +    s23**2 - 7648*s12*s14*s23*s34 + 6096*s12*s14*s34**2 + 48*s12*
     +    s23**3 - 912*s12*s23**2*s34 - 496*s12*s23*s34**2 - 3744*s12*
     +    s34**3 - 48*s14**4 - 336*s14**3*s23 + 672*s14**3*s34 - 48*
     +    s14**2*s23**2 + 1216*s14**2*s23*s34 - 720*s14**2*s34**2 - 48*
     +    s14*s23**3 + 288*s14*s23**2*s34 - 816*s14*s23*s34**2 - 48*
     +    s23**3*s34 - 336*s23**2*s34**2 )

      LC = LC + Lc2(p12,p34)*S13**(-1) * ( 960*s12**2*s14 + 1536*s12**2
     +    *s23 + 1344*s12**2*s24 + 2976*s12**2*s34 + 2688*s12*s14**2 + 
     +    1776*s12*s14*s23 + 2640*s12*s14*s24 - 20480*s12*s14*s34 + 192
     +    *s12*s23**2 + 384*s12*s23*s24 - 7376*s12*s23*s34 - 16912*s12*
     +    s24*s34 - 8800*s12*s34**2 - 432*s14**3 - 1056*s14**2*s23 - 
     +    1536*s14**2*s24 + 1920*s14**2*s34 - 432*s14*s23**2 - 1920*s14
     +    *s23*s24 + 1344*s14*s23*s34 - 2784*s14*s24**2 + 1152*s14*s24*
     +    s34 - 1328*s14*s34**2 - 96*s23**3 - 720*s23**2*s24 - 2016*s23
     +    *s24**2 - 192*s23*s24*s34 - 576*s23*s34**2 - 2448*s24**3 + 
     +    192*s24**2*s34 - 784*s24*s34**2 )

      LC = LC + Lc3(p12,p34)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 1568*s12**3*s34**3 + 2304*s12**2*s34**4 )

      LC = LC + Lc3(p12,p34)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 2592*
     +    s12**3*s34**2 - 384*s12**2*s24**2*s34 + 320*s12**2*s24*s34**2
     +     + 4480*s12**2*s34**3 + 1120*s12*s24**3*s34 + 5680*s12*s24**2
     +    *s34**2 + 8912*s12*s24*s34**3 + 2512*s12*s34**4 + 1408*s24**4
     +    *s34 + 16*s24**3*s34**2 - 64*s24**2*s34**3 )

      LC = LC + Lc3(p12,p34)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 2208*
     +    s12**3*s34**2 - 672*s12**2*s23**2*s34 + 656*s12**2*s23*s34**2
     +     + 3392*s12**2*s34**3 + 192*s12*s23**3*s34 - 624*s12*s23**2*
     +    s34**2 + 2672*s12*s23*s34**3 + 2000*s12*s34**4 + 192*s23**3*
     +    s34**2 + 192*s23**2*s34**3 )

      LC = LC + Lc3(p12,p34)*S13**(-1)*S14**(-1) * (  - 2208*s12**2*s23
     +    *s34 - 1920*s12**2*s24*s34 - 144*s12**2*s34**2 - 240*s12*
     +    s23**2*s34 - 752*s12*s23*s24*s34 + 816*s12*s23*s34**2 + 800*
     +    s12*s24**2*s34 + 6224*s12*s24*s34**2 + 12096*s12*s34**3 - 336
     +    *s23**3*s34 - 864*s23**2*s24*s34 + 480*s23**2*s34**2 + 272*
     +    s23*s24**2*s34 + 1072*s23*s24*s34**2 + 576*s23*s34**3 + 2208*
     +    s24**3*s34 + 1120*s24**2*s34**2 + 640*s24*s34**3 )

      LC = LC + Lc3(p12,p34)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 1920*
     +    s12**3*s34**2 - 6368*s12**2*s14*s34**2 + 8896*s12**2*s34**3
     +     - 960*s12*s14**3*s34 + 7808*s12*s14**2*s34**2 - 3072*s12*s14
     +    *s34**3 + 2880*s12*s34**4 - 512*s14**3*s34**2 + 512*s14**2*
     +    s34**3 )

      LC = LC + Lc3(p12,p34)*S13**(-1)*S23**(-1) * (  - 1440*s12**2*s14
     +    *s34 - 2304*s12**2*s24*s34 - 5648*s12**2*s34**2 - 4848*s12*
     +    s14**2*s34 - 5456*s12*s14*s24*s34 + 17344*s12*s14*s34**2 - 
     +    736*s12*s24**2*s34 + 14592*s12*s24*s34**2 + 9024*s12*s34**3
     +     + 432*s14**3*s34 + 2368*s14**2*s24*s34 - 1920*s14**2*s34**2
     +     + 4320*s14*s24**2*s34 - 1136*s14*s24*s34**2 + 1392*s14*
     +    s34**3 + 3792*s24**3*s34 + 192*s24**2*s34**2 + 1296*s24*
     +    s34**3 )

      LC = LC + Lc3(p12,p34)*S13**(-1)*S24**(-1) * (  - 1440*s12**2*s14
     +    *s34 - 2496*s12**2*s23*s34 - 4528*s12**2*s34**2 - 4368*s12*
     +    s14**2*s34 - 3008*s12*s14*s23*s34 + 16384*s12*s14*s34**2 - 48
     +    *s12*s23**2*s34 + 4800*s12*s23*s34**2 + 1728*s12*s34**3 + 912
     +    *s14**3*s34 + 2048*s14**2*s23*s34 - 3584*s14**2*s34**2 + 96*
     +    s14*s23**2*s34 - 3440*s14*s23*s34**2 + 1872*s14*s34**3 - 336*
     +    s23**3*s34 - 480*s23**2*s34**2 + 1488*s23*s34**3 )

      LC = LC + Lc3(p12,p34)*S13**(-1) * (  - 4800*s12**2*s34 - 8656*
     +    s12*s14*s34 - 1552*s12*s23*s34 - 3104*s12*s24*s34 + 15552*s12
     +    *s34**2 + 4416*s14**2*s34 + 2832*s14*s23*s34 + 6192*s14*s24*
     +    s34 - 4704*s14*s34**2 - 768*s23**2*s34 + 1056*s23*s24*s34 - 
     +    352*s23*s34**2 + 4896*s24**2*s34 + 576*s24*s34**2 + 2080*
     +    s34**3 )

      LC = LC + Lc3(p34,p12)*S13**(-1)*S14**(-1)*S23**(-1) * ( 192*
     +    s12**2*s24**3 + 256*s12**2*s24**2*s34 + 208*s12**2*s24*s34**2
     +     + 288*s12*s24**4 + 448*s12*s24**3*s34 + 176*s12*s24**2*
     +    s34**2 - 96*s24**5 - 48*s24**4*s34 )

      LC = LC + Lc3(p34,p12)*S13**(-1)*S14**(-1) * ( 384*s12**2*s23**2
     +     + 960*s12**2*s23*s24 + 768*s12**2*s23*s34 + 768*s12**2*
     +    s24**2 + 1024*s12**2*s24*s34 + 208*s12**2*s34**2 + 432*s12*
     +    s23**3 + 1632*s12*s23**2*s24 + 960*s12*s23**2*s34 + 2256*s12*
     +    s23*s24**2 + 2480*s12*s23*s24*s34 + 288*s12*s23*s34**2 + 1344
     +    *s12*s24**3 + 1968*s12*s24**2*s34 + 464*s12*s24*s34**2 - 48*
     +    s23**2*s24**2 - 192*s23*s24**3 - 48*s23*s24**2*s34 - 240*
     +    s24**4 - 96*s24**3*s34 )

      LC = LC + Lc3(p34,p12)*S13**(-1)*S23**(-1)*S24**(-1) * ( 416*
     +    s12**2*s14*s34**2 - 480*s12*s14**3*s34 )

      LC = LC + Lc3(p34,p12)*S13**(-1)*S23**(-1) * ( 576*s12**2*s14*s24
     +     + 1024*s12**2*s14*s34 + 768*s12**2*s24**2 + 1280*s12**2*s24*
     +    s34 + 624*s12**2*s34**2 + 672*s12*s14**3 + 1968*s12*s14**2*
     +    s24 - 592*s12*s14**2*s34 + 2640*s12*s14*s24**2 + 1280*s12*s14
     +    *s24*s34 + 464*s12*s14*s34**2 + 1632*s12*s24**3 + 1840*s12*
     +    s24**2*s34 + 640*s12*s24*s34**2 + 48*s14**4 + 144*s14**3*s24
     +     + 96*s14**3*s34 + 48*s14**2*s24**2 + 240*s14**2*s24*s34 - 
     +    240*s14*s24**3 + 144*s14*s24**2*s34 - 288*s24**4 - 48*s24**3*
     +    s34 )

      LC = LC + Lc3(p34,p12)*S13**(-1)*S24**(-1) * ( 576*s12**2*s14*s23
     +     + 1024*s12**2*s14*s34 + 384*s12**2*s23**2 + 768*s12**2*s23*
     +    s34 + 208*s12**2*s34**2 + 672*s12*s14**3 + 720*s12*s14**2*s23
     +     - 1328*s12*s14**2*s34 + 768*s12*s14*s23**2 + 176*s12*s14*s23
     +    *s34 + 464*s12*s14*s34**2 + 432*s12*s23**3 + 576*s12*s23**2*
     +    s34 + 288*s12*s23*s34**2 - 48*s14**4 - 96*s14**3*s23 + 96*
     +    s14**3*s34 + 48*s14**2*s23**2 + 144*s14**2*s23*s34 )

      LC = LC + Lc3(p34,p12)*S13**(-1) * ( 1152*s12**2*s14 + 1536*
     +    s12**2*s23 + 1920*s12**2*s24 + 2048*s12**2*s34 + 2688*s12*
     +    s14**2 + 3696*s12*s14*s23 + 5568*s12*s14*s24 + 1232*s12*s14*
     +    s34 + 2400*s12*s23**2 + 5232*s12*s23*s24 + 2656*s12*s23*s34
     +     + 4896*s12*s24**2 + 4144*s12*s24*s34 + 928*s12*s34**2 - 48*
     +    s14**3 - 96*s14**2*s23 + 384*s14**2*s34 + 48*s14*s23**2 - 96*
     +    s14*s23*s24 + 240*s14*s23*s34 - 288*s14*s24**2 + 384*s14*s24*
     +    s34 - 48*s23**2*s24 - 288*s23*s24**2 + 48*s23*s24*s34 - 528*
     +    s24**3 )

      LCc=-LC/s134/s234
      
      return
      end
      
      function LCd(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LC=0d0

      LC = LC + Lcd0(p1,p23,p4)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s23**2*s34 + 16*s12**2*s23**2*s34**2 + 8*s12**2*s23*
     +    s34**3 )

      LC = LC + Lcd0(p1,p23,p4)*S13**(-1)*S14**(-1) * (  - 8*s12**3*
     +    s23**2 - 8*s12**3*s23*s24 - 16*s12**3*s23*s34 - 8*s12**2*
     +    s23**2*s24 - 8*s12**2*s23*s24**2 - 8*s12**2*s23*s24*s34 + 8*
     +    s12**2*s23*s34**2 )

      LC = LC + Lcd0(p1,p23,p4)*S13**(-1)*S24**(-1) * ( 8*s12**2*s23**3
     +     - 16*s12**2*s23**2*s34 + 16*s12**2*s23*s34**2 + 16*s12*s14*
     +    s23**3 - 16*s12*s14*s23**2*s34 - 24*s12*s23**2*s34**2 - 16*
     +    s14*s23**4 + 16*s14*s23**3*s34 )

      LC = LC + Lcd0(p1,p23,p4)*S13**(-1) * ( 8*s12**2*s23*s24 + 16*
     +    s12**2*s23*s34 + 32*s12*s23**3 + 32*s12*s23**2*s24 - 16*s14*
     +    s23**3 )

      LC = LC + Lcd0(p1,p23,p4)*S14**(-1)*S24**(-1) * ( 16*s12**2*s23*
     +    s34**2 + 32*s12*s13*s23**2*s34 + 8*s12*s13*s23*s34**2 + 32*
     +    s13**2*s23**2*s34 - 8*s13*s23**2*s34**2 )

      LC = LC + Lcd0(p1,p23,p4)*S24**(-1) * (  - 16*s12*s23**2*s34 + 16
     +    *s12*s23*s34**2 - 16*s13*s23**3 + 32*s13*s23**2*s34 + 8*s13*
     +    s23*s34**2 - 16*s14*s23**3 + 32*s23**3*s34 - 8*s23**2*s34**2
     +     )

      LC = LC + Lcd0(p1,p24,p3)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 8*
     +    s12**3*s24**2*s34 + 16*s12**2*s24**2*s34**2 + 8*s12**2*s24*
     +    s34**3 )

      LC = LC + Lcd0(p1,p24,p3)*S13**(-1)*S14**(-1) * (  - 8*s12**3*s23
     +    *s24 - 8*s12**3*s24**2 - 16*s12**3*s24*s34 - 8*s12**2*s23**2*
     +    s24 - 8*s12**2*s23*s24**2 - 8*s12**2*s23*s24*s34 + 8*s12**2*
     +    s24*s34**2 )

      LC = LC + Lcd0(p1,p24,p3)*S13**(-1)*S23**(-1) * ( 16*s12**2*s24*
     +    s34**2 + 32*s12*s14*s24**2*s34 + 8*s12*s14*s24*s34**2 + 32*
     +    s14**2*s24**2*s34 - 8*s14*s24**2*s34**2 )

      LC = LC + Lcd0(p1,p24,p3)*S14**(-1)*S23**(-1) * ( 8*s12**2*s24**3
     +     - 16*s12**2*s24**2*s34 + 16*s12**2*s24*s34**2 + 16*s12*s13*
     +    s24**3 - 16*s12*s13*s24**2*s34 - 24*s12*s24**2*s34**2 - 16*
     +    s13*s24**4 + 16*s13*s24**3*s34 )

      LC = LC + Lcd0(p1,p24,p3)*S14**(-1) * ( 8*s12**2*s23*s24 + 16*
     +    s12**2*s24*s34 + 32*s12*s23*s24**2 + 32*s12*s24**3 - 16*s13*
     +    s24**3 )

      LC = LC + Lcd0(p1,p24,p3)*S23**(-1) * (  - 16*s12*s24**2*s34 + 16
     +    *s12*s24*s34**2 - 16*s13*s24**3 - 16*s14*s24**3 + 32*s14*
     +    s24**2*s34 + 8*s14*s24*s34**2 + 32*s24**3*s34 - 8*s24**2*
     +    s34**2 )

      LC = LC + Lcd0(p1,p34,p2)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 32*s12**3*s34**4 - 32*s12**2*s34**5 )

      LC = LC + Lcd0(p1,p34,p2)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 8*
     +    s12**2*s24*s34**3 + 32*s12**2*s34**4 )

      LC = LC + Lcd0(p1,p34,p2)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 32
     +    *s12**2*s34**4 )

      LC = LC + Lcd0(p1,p34,p2)*S13**(-1)*S14**(-1) * ( 8*s12**2*s34**3
     +     )

      LC = LC + Lcd0(p1,p34,p2)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 32
     +    *s12**2*s34**4 )

      LC = LC + Lcd0(p1,p34,p2)*S13**(-1)*S23**(-1) * ( 56*s12**2*
     +    s34**3 - 24*s12*s14*s24*s34**2 + 56*s12*s14*s34**3 + 8*s12*
     +    s24**2*s34**2 - 40*s12*s24*s34**3 + 56*s12*s34**4 - 24*s14**2
     +    *s24*s34**2 + 8*s14*s24**2*s34**2 - 24*s14*s24*s34**3 )

      LC = LC + Lcd0(p1,p34,p2)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**2*s13*s34**3 + 32*s12**2*s34**4 )

      LC = LC + Lcd0(p1,p34,p2)*S14**(-1)*S23**(-1) * ( 112*s12**2*
     +    s34**3 + 8*s12*s13**2*s34**2 - 112*s12*s13*s24*s34**2 - 32*
     +    s12*s13*s34**3 + 8*s12*s24**2*s34**2 - 32*s12*s24*s34**3 + 
     +    112*s12*s34**4 - 32*s13**2*s24*s34**2 - 32*s13*s24**2*s34**2
     +     - 112*s13*s24*s34**3 )

      LC = LC + Lcd0(p1,p34,p2)*S14**(-1)*S24**(-1) * ( 56*s12**2*
     +    s34**3 + 8*s12*s13**2*s34**2 - 24*s12*s13*s23*s34**2 - 40*s12
     +    *s13*s34**3 + 56*s12*s23*s34**3 + 56*s12*s34**4 + 8*s13**2*
     +    s23*s34**2 - 24*s13*s23**2*s34**2 - 24*s13*s23*s34**3 )

      LC = LC + Lcd0(p1,p34,p2)*S14**(-1) * (  - 112*s12*s13*s34**2 - 
     +    24*s12*s23*s34**2 - 8*s12*s24*s34**2 + 88*s12*s34**3 + 16*s13
     +    *s23**2*s34 + 32*s13*s23*s24*s34 - 120*s13*s23*s34**2 + 16*
     +    s13*s24**2*s34 - 120*s13*s24*s34**2 - 112*s13*s34**3 )

      LC = LC + Lcd0(p1,p34,p2)*S23**(-1)*S24**(-1) * ( 8*s12**2*s34**3
     +     )

      LC = LC + Lcd0(p1,p34,p2)*S23**(-1) * (  - 8*s12*s13*s34**2 - 24*
     +    s12*s14*s34**2 - 112*s12*s24*s34**2 + 88*s12*s34**3 + 16*
     +    s13**2*s24*s34 + 32*s13*s14*s24*s34 - 120*s13*s24*s34**2 + 16
     +    *s14**2*s24*s34 - 120*s14*s24*s34**2 - 112*s24*s34**3 )

      LC = LC + Lcd0(p2,p13,p4)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s13**2*s34 + 16*s12**2*s13**2*s34**2 + 8*s12**2*s13*
     +    s34**3 )

      LC = LC + Lcd0(p2,p13,p4)*S14**(-1)*S23**(-1) * ( 8*s12**2*s13**3
     +     - 16*s12**2*s13**2*s34 + 16*s12**2*s13*s34**2 + 16*s12*
     +    s13**3*s24 - 16*s12*s13**2*s24*s34 - 24*s12*s13**2*s34**2 - 
     +    16*s13**4*s24 + 16*s13**3*s24*s34 )

      LC = LC + Lcd0(p2,p13,p4)*S14**(-1)*S24**(-1) * ( 16*s12**2*s13*
     +    s34**2 + 32*s12*s13**2*s23*s34 + 8*s12*s13*s23*s34**2 + 32*
     +    s13**2*s23**2*s34 - 8*s13**2*s23*s34**2 )

      LC = LC + Lcd0(p2,p13,p4)*S14**(-1) * (  - 16*s12*s13**2*s34 + 16
     +    *s12*s13*s34**2 - 16*s13**3*s23 - 16*s13**3*s24 + 32*s13**3*
     +    s34 + 32*s13**2*s23*s34 - 8*s13**2*s34**2 + 8*s13*s23*s34**2
     +     )

      LC = LC + Lcd0(p2,p13,p4)*S23**(-1)*S24**(-1) * (  - 8*s12**3*
     +    s13**2 - 8*s12**3*s13*s14 - 16*s12**3*s13*s34 - 8*s12**2*
     +    s13**2*s14 - 8*s12**2*s13*s14**2 - 8*s12**2*s13*s14*s34 + 8*
     +    s12**2*s13*s34**2 )

      LC = LC + Lcd0(p2,p13,p4)*S23**(-1) * ( 8*s12**2*s13*s14 + 16*
     +    s12**2*s13*s34 + 32*s12*s13**3 + 32*s12*s13**2*s14 - 16*
     +    s13**3*s24 )

      LC = LC + Lcd0(p2,p14,p3)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 8*
     +    s12**3*s14**2*s34 + 16*s12**2*s14**2*s34**2 + 8*s12**2*s14*
     +    s34**3 )

      LC = LC + Lcd0(p2,p14,p3)*S13**(-1)*S23**(-1) * ( 16*s12**2*s14*
     +    s34**2 + 32*s12*s14**2*s24*s34 + 8*s12*s14*s24*s34**2 + 32*
     +    s14**2*s24**2*s34 - 8*s14**2*s24*s34**2 )

      LC = LC + Lcd0(p2,p14,p3)*S13**(-1)*S24**(-1) * ( 8*s12**2*s14**3
     +     - 16*s12**2*s14**2*s34 + 16*s12**2*s14*s34**2 + 16*s12*
     +    s14**3*s23 - 16*s12*s14**2*s23*s34 - 24*s12*s14**2*s34**2 - 
     +    16*s14**4*s23 + 16*s14**3*s23*s34 )

      LC = LC + Lcd0(p2,p14,p3)*S13**(-1) * (  - 16*s12*s14**2*s34 + 16
     +    *s12*s14*s34**2 - 16*s14**3*s23 - 16*s14**3*s24 + 32*s14**3*
     +    s34 + 32*s14**2*s24*s34 - 8*s14**2*s34**2 + 8*s14*s24*s34**2
     +     )

      LC = LC + Lcd0(p2,p14,p3)*S23**(-1)*S24**(-1) * (  - 8*s12**3*s13
     +    *s14 - 8*s12**3*s14**2 - 16*s12**3*s14*s34 - 8*s12**2*s13**2*
     +    s14 - 8*s12**2*s13*s14**2 - 8*s12**2*s13*s14*s34 + 8*s12**2*
     +    s14*s34**2 )

      LC = LC + Lcd0(p2,p14,p3)*S24**(-1) * ( 8*s12**2*s13*s14 + 16*
     +    s12**2*s14*s34 + 32*s12*s13*s14**2 + 32*s12*s14**3 - 16*
     +    s14**3*s23 )

      LC = LC + Lcd0(p3,p12,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**4*s14*s34 - 96*s12**4*s34**2 + 80*s12**3*s14*s34**2 - 48
     +    *s12**3*s34**3 )

      LC = LC + Lcd0(p3,p12,p4)*S13**(-1)*S23**(-1) * ( 32*s12**4*s34
     +     + 16*s12**3*s14*s34 - 48*s12**3*s34**2 )

      LC = LC + Lcd0(p3,p12,p4)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 32
     +    *s12**2*s14**3*s23 + 32*s12**2*s14**2*s23**2 + 48*s12*s14**3*
     +    s23**2 - 48*s12*s14**2*s23**3 + 16*s14**3*s23**3 - 16*s14**2*
     +    s23**4 )

      LC = LC + Lcd0(p3,p12,p4)*S13**(-1)*S24**(-1) * ( 32*s12**4*s34
     +     + 16*s12**3*s14**2 + 16*s12**3*s14*s23 + 272*s12**3*s14*s34
     +     - 48*s12**3*s23*s34 - 112*s12**3*s34**2 - 208*s12**2*s14**2*
     +    s23 - 112*s12**2*s14**2*s34 + 112*s12**2*s14*s23**2 + 240*
     +    s12**2*s14*s23*s34 + 112*s12**2*s14*s34**2 - 16*s12**2*s23**2
     +    *s34 - 32*s12**2*s23*s34**2 - 16*s12**2*s34**3 + 32*s12*
     +    s14**3*s23 - 144*s12*s14**2*s23**2 - 80*s12*s14**2*s23*s34 + 
     +    32*s12*s14*s23**3 + 64*s12*s14*s23**2*s34 + 32*s12*s14*s23*
     +    s34**2 + 16*s14**3*s23**2 - 32*s14**2*s23**3 - 16*s14**2*
     +    s23**2*s34 )

      LC = LC + Lcd0(p3,p12,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**4*s13*s34 - 96*s12**4*s34**2 + 80*s12**3*s13*s34**2 - 48
     +    *s12**3*s34**3 )

      LC = LC + Lcd0(p3,p12,p4)*S14**(-1)*S23**(-1)*S34**(-1) * (  - 32
     +    *s12**2*s13**3*s24 + 32*s12**2*s13**2*s24**2 + 48*s12*s13**3*
     +    s24**2 - 48*s12*s13**2*s24**3 + 16*s13**3*s24**3 - 16*s13**2*
     +    s24**4 )

      LC = LC + Lcd0(p3,p12,p4)*S14**(-1)*S23**(-1) * ( 32*s12**4*s34
     +     + 16*s12**3*s13**2 + 16*s12**3*s13*s24 + 272*s12**3*s13*s34
     +     - 48*s12**3*s24*s34 - 112*s12**3*s34**2 - 208*s12**2*s13**2*
     +    s24 - 112*s12**2*s13**2*s34 + 112*s12**2*s13*s24**2 + 240*
     +    s12**2*s13*s24*s34 + 112*s12**2*s13*s34**2 - 16*s12**2*s24**2
     +    *s34 - 32*s12**2*s24*s34**2 - 16*s12**2*s34**3 + 32*s12*
     +    s13**3*s24 - 144*s12*s13**2*s24**2 - 80*s12*s13**2*s24*s34 + 
     +    32*s12*s13*s24**3 + 64*s12*s13*s24**2*s34 + 32*s12*s13*s24*
     +    s34**2 + 16*s13**3*s24**2 - 32*s13**2*s24**3 - 16*s13**2*
     +    s24**2*s34 )

      LC = LC + Lcd0(p3,p12,p4)*S14**(-1)*S24**(-1) * ( 32*s12**4*s34
     +     + 16*s12**3*s13*s34 - 48*s12**3*s34**2 )

      LC = LC + Lcd0(p3,p12,p4)*S23**(-1)*S24**(-1)*S34**(-1) * (  - 32
     +    *s12**2*s13**3*s14 - 64*s12**2*s13**2*s14**2 - 32*s12**2*s13*
     +    s14**3 + 96*s12*s13**3*s14**2 + 96*s12*s13**2*s14**3 + 16*
     +    s13**4*s14**2 + 32*s13**3*s14**3 + 16*s13**2*s14**4 )

      LC = LC + Lcd0(p3,p12,p4)*S23**(-1)*S24**(-1) * ( 32*s12**4*s34
     +     + 16*s12**3*s13**2 + 32*s12**3*s13*s14 + 16*s12**3*s13*s34
     +     + 16*s12**3*s14**2 + 16*s12**3*s14*s34 + 416*s12**3*s34**2
     +     - 16*s12**2*s13**2*s14 - 112*s12**2*s13**2*s34 - 16*s12**2*
     +    s13*s14**2 - 608*s12**2*s13*s14*s34 + 16*s12**2*s13*s34**2 - 
     +    112*s12**2*s14**2*s34 + 16*s12**2*s14*s34**2 + 64*s12**2*
     +    s34**3 + 16*s12*s13**3*s14 + 160*s12*s13**2*s14**2 - 16*s12*
     +    s13**2*s14*s34 + 16*s12*s13*s14**3 - 16*s12*s13*s14**2*s34 - 
     +    96*s12*s13*s14*s34**2 + 48*s13**3*s14**2 + 48*s13**2*s14**3
     +     + 32*s13**2*s14**2*s34 )

      LC = LC + Lcd0(p3,p12,p4)*S23**(-1)*S34**(-1) * (  - 64*s12**2*
     +    s13**3 - 32*s12**2*s13**2*s14 + 32*s12**2*s13**2*s24 + 32*
     +    s12**2*s13*s14**2 + 64*s12**2*s13*s14*s24 + 32*s12**2*s13*
     +    s24**2 + 144*s12*s13**3*s14 + 144*s12*s13**3*s24 + 96*s12*
     +    s13**2*s14**2 - 96*s12*s13**2*s24**2 + 64*s13**3*s14**2 + 96*
     +    s13**3*s14*s24 + 64*s13**3*s24**2 + 48*s13**2*s14**3 + 32*
     +    s13**2*s14**2*s24 - 32*s13**2*s14*s24**2 - 48*s13**2*s24**3 )

      LC = LC + Lcd0(p3,p12,p4)*S23**(-1) * (  - 64*s12**3*s13 - 80*
     +    s12**3*s14 + 16*s12**3*s24 + 336*s12**3*s34 - 192*s12**2*
     +    s13**2 - 256*s12**2*s13*s14 - 112*s12**2*s13*s24 - 272*s12**2
     +    *s13*s34 - 16*s12**2*s14**2 + 32*s12**2*s14*s34 + 16*s12**2*
     +    s24**2 + 112*s12**2*s24*s34 + 160*s12**2*s34**2 + 64*s12*
     +    s13**3 + 16*s12*s13**2*s14 - 208*s12*s13**2*s24 - 64*s12*
     +    s13**2*s34 - 112*s12*s13*s14**2 - 144*s12*s13*s14*s24 - 144*
     +    s12*s13*s14*s34 - 16*s12*s13*s24**2 - 48*s12*s13*s24*s34 - 48
     +    *s12*s13*s34**2 + 48*s13**3*s14 + 48*s13**3*s24 + 64*s13**2*
     +    s14**2 + 16*s13**2*s14*s34 - 64*s13**2*s24**2 - 16*s13**2*s24
     +    *s34 )

      LC = LC + Lcd0(p3,p12,p4)*S24**(-1)*S34**(-1) * ( 32*s12**2*
     +    s13**2*s14 - 32*s12**2*s13*s14**2 + 64*s12**2*s13*s14*s23 - 
     +    64*s12**2*s14**3 + 32*s12**2*s14**2*s23 + 32*s12**2*s14*
     +    s23**2 + 96*s12*s13**2*s14**2 + 144*s12*s13*s14**3 + 144*s12*
     +    s14**3*s23 - 96*s12*s14**2*s23**2 + 48*s13**3*s14**2 + 64*
     +    s13**2*s14**3 + 32*s13**2*s14**2*s23 + 96*s13*s14**3*s23 - 32
     +    *s13*s14**2*s23**2 + 64*s14**3*s23**2 - 48*s14**2*s23**3 )

      LC = LC + Lcd0(p3,p12,p4)*S24**(-1) * (  - 80*s12**3*s13 - 64*
     +    s12**3*s14 + 16*s12**3*s23 + 336*s12**3*s34 - 16*s12**2*
     +    s13**2 - 256*s12**2*s13*s14 + 32*s12**2*s13*s34 - 192*s12**2*
     +    s14**2 - 112*s12**2*s14*s23 - 272*s12**2*s14*s34 + 16*s12**2*
     +    s23**2 + 112*s12**2*s23*s34 + 160*s12**2*s34**2 - 112*s12*
     +    s13**2*s14 + 16*s12*s13*s14**2 - 144*s12*s13*s14*s23 - 144*
     +    s12*s13*s14*s34 + 64*s12*s14**3 - 208*s12*s14**2*s23 - 64*s12
     +    *s14**2*s34 - 16*s12*s14*s23**2 - 48*s12*s14*s23*s34 - 48*s12
     +    *s14*s34**2 + 64*s13**2*s14**2 + 48*s13*s14**3 + 16*s13*
     +    s14**2*s34 + 48*s14**3*s23 - 64*s14**2*s23**2 - 16*s14**2*s23
     +    *s34 )

      LC = LC + Lcd1(p1,p23,p4)*S14**(-1)*S24**(-1) * ( 8*s12**2*s23*
     +    s34**2 + 16*s12*s13*s23*s34**2 + 8*s13**2*s23*s34**2 )

      LC = LC + Lcd1(p1,p23,p4)*S14**(-1) * (  - 16*s12**2*s23*s24 - 16
     +    *s12**2*s24**2 - 16*s12**2*s24*s34 - 32*s12*s13*s23*s24 - 32*
     +    s12*s13*s24**2 - 32*s12*s13*s24*s34 - 32*s12*s23*s24**2 - 32*
     +    s12*s23*s24*s34 - 32*s12*s24**3 - 64*s12*s24**2*s34 - 32*s12*
     +    s24*s34**2 - 16*s13**2*s23*s24 - 16*s13**2*s24**2 - 16*s13**2
     +    *s24*s34 - 16*s13*s23*s24**2 - 16*s13*s23*s24*s34 - 16*s13*
     +    s24**3 - 32*s13*s24**2*s34 - 16*s13*s24*s34**2 )

      LC = LC + Lcd1(p1,p24,p3)*S13**(-1)*S23**(-1) * ( 8*s12**2*s24*
     +    s34**2 + 16*s12*s14*s24*s34**2 + 8*s14**2*s24*s34**2 )

      LC = LC + Lcd1(p1,p24,p3)*S13**(-1) * (  - 16*s12**2*s23**2 - 16*
     +    s12**2*s23*s24 - 16*s12**2*s23*s34 - 32*s12*s14*s23**2 - 32*
     +    s12*s14*s23*s24 - 32*s12*s14*s23*s34 - 32*s12*s23**3 - 32*s12
     +    *s23**2*s24 - 64*s12*s23**2*s34 - 32*s12*s23*s24*s34 - 32*s12
     +    *s23*s34**2 - 16*s14**2*s23**2 - 16*s14**2*s23*s24 - 16*
     +    s14**2*s23*s34 - 16*s14*s23**3 - 16*s14*s23**2*s24 - 32*s14*
     +    s23**2*s34 - 16*s14*s23*s24*s34 - 16*s14*s23*s34**2 )

      LC = LC + Lcd1(p1,p34,p2)*S13**(-1)*S24**(-1) * (  - 16*s14**2*
     +    s23**3 - 16*s14**2*s23**2*s34 - 16*s14*s23**3*s34 - 16*s14*
     +    s23**2*s34**2 )

      LC = LC + Lcd1(p1,p34,p2)*S13**(-1) * (  - 18*s14**2*s23**2 + 20*
     +    s14**2*s23*s24 - 2*s14**2*s23*s34 + 22*s14**2*s24**2 + 22*
     +    s14**2*s24*s34 + 4*s14*s23**3 + 4*s14*s23**2*s24 - 14*s14*
     +    s23**2*s34 - 4*s14*s23*s24**2 + 20*s14*s23*s24*s34 - 2*s14*
     +    s23*s34**2 - 4*s14*s24**3 + 18*s14*s24**2*s34 + 22*s14*s24*
     +    s34**2 )

      LC = LC + Lcd1(p1,p34,p2)*S14**(-1)*S23**(-1) * (  - 16*s13**2*
     +    s24**3 - 16*s13**2*s24**2*s34 - 16*s13*s24**3*s34 - 16*s13*
     +    s24**2*s34**2 )

      LC = LC + Lcd1(p1,p34,p2)*S14**(-1) * ( 22*s13**2*s23**2 + 20*
     +    s13**2*s23*s24 + 22*s13**2*s23*s34 - 18*s13**2*s24**2 - 2*
     +    s13**2*s24*s34 - 4*s13*s23**3 - 4*s13*s23**2*s24 + 18*s13*
     +    s23**2*s34 + 4*s13*s23*s24**2 + 20*s13*s23*s24*s34 + 22*s13*
     +    s23*s34**2 + 4*s13*s24**3 - 14*s13*s24**2*s34 - 2*s13*s24*
     +    s34**2 )

      LC = LC + Lcd1(p1,p34,p2)*S23**(-1) * ( 4*s13**2*s24**2 + 8*s13*
     +    s14*s24**2 - 38*s13*s24**3 - 34*s13*s24**2*s34 + 4*s14**2*
     +    s24**2 - 22*s14*s24**3 - 18*s14*s24**2*s34 - 22*s24**3*s34 - 
     +    22*s24**2*s34**2 )

      LC = LC + Lcd1(p1,p34,p2)*S24**(-1) * ( 4*s13**2*s23**2 + 8*s13*
     +    s14*s23**2 - 22*s13*s23**3 - 18*s13*s23**2*s34 + 4*s14**2*
     +    s23**2 - 38*s14*s23**3 - 34*s14*s23**2*s34 - 22*s23**3*s34 - 
     +    22*s23**2*s34**2 )

      LC = LC + Lcd1(p1,p34,p2) * (  - 4*s13**2*s23 - 4*s13**2*s24 - 8*
     +    s13*s14*s23 - 8*s13*s14*s24 + 18*s13*s23**2 + 56*s13*s23*s24
     +     + 36*s13*s23*s34 - 22*s13*s24**2 + 12*s13*s24*s34 - 4*s14**2
     +    *s23 - 4*s14**2*s24 - 22*s14*s23**2 + 56*s14*s23*s24 + 12*s14
     +    *s23*s34 + 18*s14*s24**2 + 36*s14*s24*s34 - 4*s23**2*s34 + 36
     +    *s23*s24*s34 + 18*s23*s34**2 - 4*s24**2*s34 + 18*s24*s34**2 )

      LC = LC + Lcd1(p2,p13,p4)*S14**(-1)*S24**(-1) * ( 8*s12**2*s13*
     +    s34**2 + 16*s12*s13*s23*s34**2 + 8*s13*s23**2*s34**2 )

      LC = LC + Lcd1(p2,p13,p4)*S24**(-1) * (  - 16*s12**2*s13*s14 - 16
     +    *s12**2*s14**2 - 16*s12**2*s14*s34 - 32*s12*s13*s14**2 - 32*
     +    s12*s13*s14*s23 - 32*s12*s13*s14*s34 - 32*s12*s14**3 - 32*s12
     +    *s14**2*s23 - 64*s12*s14**2*s34 - 32*s12*s14*s23*s34 - 32*s12
     +    *s14*s34**2 - 16*s13*s14**2*s23 - 16*s13*s14*s23**2 - 16*s13*
     +    s14*s23*s34 - 16*s14**3*s23 - 16*s14**2*s23**2 - 32*s14**2*
     +    s23*s34 - 16*s14*s23**2*s34 - 16*s14*s23*s34**2 )

      LC = LC + Lcd1(p2,p14,p3)*S13**(-1)*S23**(-1) * ( 8*s12**2*s14*
     +    s34**2 + 16*s12*s14*s24*s34**2 + 8*s14*s24**2*s34**2 )

      LC = LC + Lcd1(p2,p14,p3)*S23**(-1) * (  - 16*s12**2*s13**2 - 16*
     +    s12**2*s13*s14 - 16*s12**2*s13*s34 - 32*s12*s13**3 - 32*s12*
     +    s13**2*s14 - 32*s12*s13**2*s24 - 64*s12*s13**2*s34 - 32*s12*
     +    s13*s14*s24 - 32*s12*s13*s14*s34 - 32*s12*s13*s24*s34 - 32*
     +    s12*s13*s34**2 - 16*s13**3*s24 - 16*s13**2*s14*s24 - 16*
     +    s13**2*s24**2 - 32*s13**2*s24*s34 - 16*s13*s14*s24**2 - 16*
     +    s13*s14*s24*s34 - 16*s13*s24**2*s34 - 16*s13*s24*s34**2 )

      LC = LC + Lcd1(p2,p34,p1)*S13**(-1)*S24**(-1) * (  - 16*s14**3*
     +    s23**2 - 16*s14**3*s23*s34 - 16*s14**2*s23**2*s34 - 16*s14**2
     +    *s23*s34**2 )

      LC = LC + Lcd1(p2,p34,p1)*S13**(-1) * (  - 38*s14**3*s23 - 22*
     +    s14**3*s24 - 22*s14**3*s34 + 4*s14**2*s23**2 + 8*s14**2*s23*
     +    s24 - 34*s14**2*s23*s34 + 4*s14**2*s24**2 - 18*s14**2*s24*s34
     +     - 22*s14**2*s34**2 )

      LC = LC + Lcd1(p2,p34,p1)*S14**(-1)*S23**(-1) * (  - 16*s13**3*
     +    s24**2 - 16*s13**3*s24*s34 - 16*s13**2*s24**2*s34 - 16*s13**2
     +    *s24*s34**2 )

      LC = LC + Lcd1(p2,p34,p1)*S14**(-1) * (  - 22*s13**3*s23 - 38*
     +    s13**3*s24 - 22*s13**3*s34 + 4*s13**2*s23**2 + 8*s13**2*s23*
     +    s24 - 18*s13**2*s23*s34 + 4*s13**2*s24**2 - 34*s13**2*s24*s34
     +     - 22*s13**2*s34**2 )

      LC = LC + Lcd1(p2,p34,p1)*S23**(-1) * ( 4*s13**3*s24 + 4*s13**2*
     +    s14*s24 - 18*s13**2*s24**2 - 14*s13**2*s24*s34 - 4*s13*s14**2
     +    *s24 + 20*s13*s14*s24**2 + 20*s13*s14*s24*s34 - 2*s13*s24**2*
     +    s34 - 2*s13*s24*s34**2 - 4*s14**3*s24 + 22*s14**2*s24**2 + 18
     +    *s14**2*s24*s34 + 22*s14*s24**2*s34 + 22*s14*s24*s34**2 )

      LC = LC + Lcd1(p2,p34,p1)*S24**(-1) * (  - 4*s13**3*s23 - 4*
     +    s13**2*s14*s23 + 22*s13**2*s23**2 + 18*s13**2*s23*s34 + 4*s13
     +    *s14**2*s23 + 20*s13*s14*s23**2 + 20*s13*s14*s23*s34 + 22*s13
     +    *s23**2*s34 + 22*s13*s23*s34**2 + 4*s14**3*s23 - 18*s14**2*
     +    s23**2 - 14*s14**2*s23*s34 - 2*s14*s23**2*s34 - 2*s14*s23*
     +    s34**2 )

      LC = LC + Lcd1(p2,p34,p1) * ( 18*s13**2*s23 - 22*s13**2*s24 - 4*
     +    s13**2*s34 + 56*s13*s14*s23 + 56*s13*s14*s24 + 36*s13*s14*s34
     +     - 4*s13*s23**2 - 8*s13*s23*s24 + 36*s13*s23*s34 - 4*s13*
     +    s24**2 + 12*s13*s24*s34 + 18*s13*s34**2 - 22*s14**2*s23 + 18*
     +    s14**2*s24 - 4*s14**2*s34 - 4*s14*s23**2 - 8*s14*s23*s24 + 12
     +    *s14*s23*s34 - 4*s14*s24**2 + 36*s14*s24*s34 + 18*s14*s34**2
     +     )

      LC = LC + Lcd1(p3,p12,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 40*
     +    s12*s14**3*s23**2 + 8*s14**4*s23**2 + 8*s14**3*s23**3 )

      LC = LC + Lcd1(p3,p12,p4)*S13**(-1)*S34**(-1) * ( 40*s12*s14**3*
     +    s23 + 40*s12*s14**2*s23**2 + 40*s12*s14**2*s23*s24 + 40*s12*
     +    s14*s23**2*s24 + 40*s12*s14*s23*s24**2 + 40*s12*s23**2*s24**2
     +     + 40*s12*s23*s24**3 + 8*s14**4*s23 + 24*s14**3*s23**2 + 16*
     +    s14**3*s23*s24 + 8*s14**2*s23**3 + 24*s14**2*s23**2*s24 + 16*
     +    s14**2*s23*s24**2 + 8*s14*s23**3*s24 + 24*s14*s23**2*s24**2
     +     + 16*s14*s23*s24**3 + 8*s23**3*s24**2 + 16*s23**2*s24**3 + 8
     +    *s23*s24**4 )

      LC = LC + Lcd1(p3,p12,p4)*S14**(-1)*S23**(-1)*S34**(-1) * ( 40*
     +    s12*s13**2*s24**3 + 8*s13**3*s24**3 + 8*s13**2*s24**4 )

      LC = LC + Lcd1(p3,p12,p4)*S14**(-1)*S34**(-1) * ( 40*s12*s13**2*
     +    s24**2 + 80*s12*s13*s23*s24**2 + 80*s12*s13*s24**3 + 40*s12*
     +    s23**2*s24**2 + 40*s12*s23*s24**3 + 8*s13**3*s24**2 + 24*
     +    s13**2*s23*s24**2 + 32*s13**2*s24**3 + 24*s13*s23**2*s24**2
     +     + 40*s13*s23*s24**3 + 16*s13*s24**4 + 8*s23**3*s24**2 + 16*
     +    s23**2*s24**3 + 8*s23*s24**4 )

      LC = LC + Lcd1(p3,p12,p4)*S23**(-1)*S34**(-1) * ( 40*s12*s13**2*
     +    s14**2 + 40*s12*s13**2*s14*s24 + 40*s12*s13**2*s24**2 + 40*
     +    s12*s13*s14**3 + 40*s12*s13*s14**2*s24 + 40*s12*s13*s14*
     +    s24**2 + 40*s12*s13*s24**3 + 8*s13**3*s14**2 + 8*s13**3*s14*
     +    s24 + 8*s13**3*s24**2 + 16*s13**2*s14**3 + 24*s13**2*s14**2*
     +    s24 + 24*s13**2*s14*s24**2 + 24*s13**2*s24**3 + 8*s13*s14**4
     +     + 16*s13*s14**3*s24 + 16*s13*s14**2*s24**2 + 16*s13*s14*
     +    s24**3 + 8*s13*s24**4 )

      LC = LC + Lcd1(p3,p12,p4)*S24**(-1)*S34**(-1) * ( 40*s12*s13**2*
     +    s14**2 + 40*s12*s13*s14**3 + 80*s12*s13*s14**2*s23 + 80*s12*
     +    s14**3*s23 + 40*s12*s14**2*s23**2 + 8*s13**3*s14**2 + 16*
     +    s13**2*s14**3 + 24*s13**2*s14**2*s23 + 8*s13*s14**4 + 40*s13*
     +    s14**3*s23 + 24*s13*s14**2*s23**2 + 16*s14**4*s23 + 32*s14**3
     +    *s23**2 + 8*s14**2*s23**3 )

      LC = LC + Lcd1(p3,p12,p4)*S34**(-1) * ( 40*s12*s13**2*s14 + 40*
     +    s12*s13**2*s24 + 120*s12*s13*s14**2 + 80*s12*s13*s14*s23 + 
     +    120*s12*s13*s14*s24 + 80*s12*s13*s23*s24 + 120*s12*s13*s24**2
     +     + 80*s12*s14**3 + 120*s12*s14**2*s23 + 80*s12*s14**2*s24 + 
     +    40*s12*s14*s23**2 + 120*s12*s14*s23*s24 + 80*s12*s14*s24**2
     +     + 40*s12*s23**2*s24 + 120*s12*s23*s24**2 + 80*s12*s24**3 + 8
     +    *s13**3*s14 + 8*s13**3*s24 + 48*s13**2*s14**2 + 24*s13**2*s14
     +    *s23 + 48*s13**2*s14*s24 + 24*s13**2*s23*s24 + 48*s13**2*
     +    s24**2 + 56*s13*s14**3 + 80*s13*s14**2*s23 + 72*s13*s14**2*
     +    s24 + 24*s13*s14*s23**2 + 80*s13*s14*s23*s24 + 72*s13*s14*
     +    s24**2 + 24*s13*s23**2*s24 + 80*s13*s23*s24**2 + 64*s13*
     +    s24**3 + 16*s14**4 + 64*s14**3*s23 + 32*s14**3*s24 + 48*
     +    s14**2*s23**2 + 72*s14**2*s23*s24 + 32*s14**2*s24**2 + 8*s14*
     +    s23**3 + 48*s14*s23**2*s24 + 72*s14*s23*s24**2 + 32*s14*
     +    s24**3 + 8*s23**3*s24 + 48*s23**2*s24**2 + 56*s23*s24**3 + 16
     +    *s24**4 )

      LC = LC + Lcd1(p3,p14,p2)*S23**(-1) * ( 16*s12**3*s13 + 16*s12**3
     +    *s14 + 16*s12**3*s34 + 32*s12**2*s13**2 + 32*s12**2*s13*s14
     +     + 32*s12**2*s13*s24 + 48*s12**2*s13*s34 + 32*s12**2*s14*s24
     +     + 16*s12**2*s14*s34 + 32*s12**2*s24*s34 + 16*s12**2*s34**2
     +     + 32*s12*s13**2*s24 + 32*s12*s13*s14*s24 + 16*s12*s13*s24**2
     +     + 48*s12*s13*s24*s34 + 16*s12*s14*s24**2 + 16*s12*s14*s24*
     +    s34 + 16*s12*s24**2*s34 + 16*s12*s24*s34**2 )

      LC = LC + Lcd1(p3,p24,p1)*S13**(-1) * ( 16*s12**3*s23 + 16*s12**3
     +    *s24 + 16*s12**3*s34 + 32*s12**2*s14*s23 + 32*s12**2*s14*s24
     +     + 32*s12**2*s14*s34 + 32*s12**2*s23**2 + 32*s12**2*s23*s24
     +     + 48*s12**2*s23*s34 + 16*s12**2*s24*s34 + 16*s12**2*s34**2
     +     + 16*s12*s14**2*s23 + 16*s12*s14**2*s24 + 16*s12*s14**2*s34
     +     + 32*s12*s14*s23**2 + 32*s12*s14*s23*s24 + 48*s12*s14*s23*
     +    s34 + 16*s12*s14*s24*s34 + 16*s12*s14*s34**2 )

      LC = LC + Lcd1(p4,p12,p3)*S13**(-1)*S24**(-1)*S34**(-1) * ( 40*
     +    s12*s14**2*s23**3 + 8*s14**3*s23**3 + 8*s14**2*s23**4 )

      LC = LC + Lcd1(p4,p12,p3)*S13**(-1)*S34**(-1) * ( 40*s12*s14**2*
     +    s23**2 + 80*s12*s14*s23**3 + 80*s12*s14*s23**2*s24 + 40*s12*
     +    s23**3*s24 + 40*s12*s23**2*s24**2 + 8*s14**3*s23**2 + 32*
     +    s14**2*s23**3 + 24*s14**2*s23**2*s24 + 16*s14*s23**4 + 40*s14
     +    *s23**3*s24 + 24*s14*s23**2*s24**2 + 8*s23**4*s24 + 16*s23**3
     +    *s24**2 + 8*s23**2*s24**3 )

      LC = LC + Lcd1(p4,p12,p3)*S14**(-1)*S23**(-1)*S34**(-1) * ( 40*
     +    s12*s13**3*s24**2 + 8*s13**4*s24**2 + 8*s13**3*s24**3 )

      LC = LC + Lcd1(p4,p12,p3)*S14**(-1)*S34**(-1) * ( 40*s12*s13**3*
     +    s24 + 40*s12*s13**2*s23*s24 + 40*s12*s13**2*s24**2 + 40*s12*
     +    s13*s23**2*s24 + 40*s12*s13*s23*s24**2 + 40*s12*s23**3*s24 + 
     +    40*s12*s23**2*s24**2 + 8*s13**4*s24 + 16*s13**3*s23*s24 + 24*
     +    s13**3*s24**2 + 16*s13**2*s23**2*s24 + 24*s13**2*s23*s24**2
     +     + 8*s13**2*s24**3 + 16*s13*s23**3*s24 + 24*s13*s23**2*s24**2
     +     + 8*s13*s23*s24**3 + 8*s23**4*s24 + 16*s23**3*s24**2 + 8*
     +    s23**2*s24**3 )

      LC = LC + Lcd1(p4,p12,p3)*S23**(-1)*S34**(-1) * ( 40*s12*s13**3*
     +    s14 + 80*s12*s13**3*s24 + 40*s12*s13**2*s14**2 + 80*s12*
     +    s13**2*s14*s24 + 40*s12*s13**2*s24**2 + 8*s13**4*s14 + 16*
     +    s13**4*s24 + 16*s13**3*s14**2 + 40*s13**3*s14*s24 + 32*s13**3
     +    *s24**2 + 8*s13**2*s14**3 + 24*s13**2*s14**2*s24 + 24*s13**2*
     +    s14*s24**2 + 8*s13**2*s24**3 )

      LC = LC + Lcd1(p4,p12,p3)*S24**(-1)*S34**(-1) * ( 40*s12*s13**3*
     +    s14 + 40*s12*s13**2*s14**2 + 40*s12*s13**2*s14*s23 + 40*s12*
     +    s13*s14**2*s23 + 40*s12*s13*s14*s23**2 + 40*s12*s14**2*s23**2
     +     + 40*s12*s14*s23**3 + 8*s13**4*s14 + 16*s13**3*s14**2 + 16*
     +    s13**3*s14*s23 + 8*s13**2*s14**3 + 24*s13**2*s14**2*s23 + 16*
     +    s13**2*s14*s23**2 + 8*s13*s14**3*s23 + 24*s13*s14**2*s23**2
     +     + 16*s13*s14*s23**3 + 8*s14**3*s23**2 + 24*s14**2*s23**3 + 8
     +    *s14*s23**4 )

      LC = LC + Lcd1(p4,p12,p3)*S34**(-1) * ( 80*s12*s13**3 + 120*s12*
     +    s13**2*s14 + 80*s12*s13**2*s23 + 120*s12*s13**2*s24 + 40*s12*
     +    s13*s14**2 + 120*s12*s13*s14*s23 + 80*s12*s13*s14*s24 + 80*
     +    s12*s13*s23**2 + 120*s12*s13*s23*s24 + 40*s12*s13*s24**2 + 40
     +    *s12*s14**2*s23 + 120*s12*s14*s23**2 + 80*s12*s14*s23*s24 + 
     +    80*s12*s23**3 + 120*s12*s23**2*s24 + 40*s12*s23*s24**2 + 16*
     +    s13**4 + 56*s13**3*s14 + 32*s13**3*s23 + 64*s13**3*s24 + 48*
     +    s13**2*s14**2 + 72*s13**2*s14*s23 + 80*s13**2*s14*s24 + 32*
     +    s13**2*s23**2 + 72*s13**2*s23*s24 + 48*s13**2*s24**2 + 8*s13*
     +    s14**3 + 48*s13*s14**2*s23 + 24*s13*s14**2*s24 + 72*s13*s14*
     +    s23**2 + 80*s13*s14*s23*s24 + 24*s13*s14*s24**2 + 32*s13*
     +    s23**3 + 72*s13*s23**2*s24 + 48*s13*s23*s24**2 + 8*s13*s24**3
     +     + 8*s14**3*s23 + 48*s14**2*s23**2 + 24*s14**2*s23*s24 + 64*
     +    s14*s23**3 + 80*s14*s23**2*s24 + 24*s14*s23*s24**2 + 16*
     +    s23**4 + 56*s23**3*s24 + 48*s23**2*s24**2 + 8*s23*s24**3 )

      LC = LC + Lcd1(p4,p13,p2)*S24**(-1) * ( 16*s12**3*s13 + 16*s12**3
     +    *s14 + 16*s12**3*s34 + 32*s12**2*s13*s14 + 32*s12**2*s13*s23
     +     + 16*s12**2*s13*s34 + 32*s12**2*s14**2 + 32*s12**2*s14*s23
     +     + 48*s12**2*s14*s34 + 32*s12**2*s23*s34 + 16*s12**2*s34**2
     +     + 32*s12*s13*s14*s23 + 16*s12*s13*s23**2 + 16*s12*s13*s23*
     +    s34 + 32*s12*s14**2*s23 + 16*s12*s14*s23**2 + 48*s12*s14*s23*
     +    s34 + 16*s12*s23**2*s34 + 16*s12*s23*s34**2 )

      LC = LC + Lcd1(p4,p23,p1)*S14**(-1) * ( 16*s12**3*s23 + 16*s12**3
     +    *s24 + 16*s12**3*s34 + 32*s12**2*s13*s23 + 32*s12**2*s13*s24
     +     + 32*s12**2*s13*s34 + 32*s12**2*s23*s24 + 16*s12**2*s23*s34
     +     + 32*s12**2*s24**2 + 48*s12**2*s24*s34 + 16*s12**2*s34**2 + 
     +    16*s12*s13**2*s23 + 16*s12*s13**2*s24 + 16*s12*s13**2*s34 + 
     +    32*s12*s13*s23*s24 + 16*s12*s13*s23*s34 + 32*s12*s13*s24**2
     +     + 48*s12*s13*s24*s34 + 16*s12*s13*s34**2 )

      LCd=-LC/s134/s234
      
      return
      end
      
      function LCe(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LC=0d0

      LC = LC + Ld0(p1,p2,p3)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LC = LC + Ld0(p1,p2,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s34 + 40*s12**2*s24*s34 + 40*s12**2*s34**2 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LC = LC + Ld0(p1,p2,p3)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 )

      LC = LC + Ld0(p1,p2,p3)*S13**(-1)*S14**(-1) * (  - 16*s12**2*s23
     +     - 16*s12**2*s24 + 24*s12**2*s34 - 16*s12*s23*s24 - 16*s12*
     +    s24**2 - 8*s12*s24*s34 - 8*s23*s24**2 - 8*s24**3 - 8*s24**2*
     +    s34 )

      LC = LC + Ld0(p1,p2,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s14*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s14**2*s34 + 8*s12*s14*s34**2 )

      LC = LC + Ld0(p1,p2,p3)*S13**(-1)*S23**(-1) * ( 32*s12**3 + 56*
     +    s12**2*s14 + 56*s12**2*s24 + 96*s12**2*s34 + 16*s12*s14**2 + 
     +    24*s12*s14*s34 + 16*s12*s24**2 + 24*s12*s24*s34 + 16*s12*
     +    s34**2 )

      LC = LC + Ld0(p1,p2,p3)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s14*s23 - 16*s12*s14**2*s23 - 8*s14**3*s23 )

      LC = LC + Ld0(p1,p2,p3)*S13**(-1)*S24**(-1) * ( 40*s12**3 + 64*
     +    s12**2*s14 + 8*s12**2*s23 + 32*s12**2*s34 + 16*s12*s14**2 + 
     +    16*s12*s14*s23 + 24*s12*s14*s34 + 16*s12*s23*s34 + 8*s12*
     +    s34**2 + 16*s14**2*s23 + 16*s14**2*s34 + 8*s14*s23**2 + 32*
     +    s14*s23*s34 + 16*s14*s34**2 + 8*s23*s34**2 )

      LC = LC + Ld0(p1,p2,p3)*S13**(-1)*S34**(-1) * (  - 16*s12**2*s14
     +     - 16*s12*s14**2 - 8*s14**3 )

      LC = LC + Ld0(p1,p2,p3)*S13**(-1) * ( 64*s12**2 + 8*s12*s14 + 8*
     +    s12*s23 + 24*s12*s24 + 32*s12*s34 - 8*s14**2 - 8*s14*s23 - 16
     +    *s14*s24 - 8*s14*s34 + 8*s23*s24 - 8*s23*s34 + 8*s24**2 )

      LC = LC + Ld0(p1,p2,p3)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s13*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s13**2*s34 + 8*s12*s13*s34**2 )

      LC = LC + Ld0(p1,p2,p3)*S14**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2*s13*s24 + 16*s12*s13**2*s24 + 8*s13**3*s24 )

      LC = LC + Ld0(p1,p2,p3)*S14**(-1)*S23**(-1) * ( 32*s12**3 + 64*
     +    s12**2*s13 + 80*s12**2*s24 + 96*s12**2*s34 + 48*s12*s13**2 + 
     +    64*s12*s13*s24 + 72*s12*s13*s34 + 32*s12*s24**2 + 56*s12*s24*
     +    s34 + 24*s12*s34**2 + 16*s13**3 + 32*s13**2*s24 + 32*s13**2*
     +    s34 + 24*s13*s24**2 + 48*s13*s24*s34 + 24*s13*s34**2 + 8*
     +    s24**3 + 24*s24**2*s34 + 24*s24*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p1,p2,p3)*S14**(-1)*S24**(-1) * ( 32*s12**3 + 48*
     +    s12**2*s13 + 16*s12**2*s34 + 32*s12*s13**2 + 8*s12*s13*s34 + 
     +    8*s13**3 )

      LC = LC + Ld0(p1,p2,p3)*S14**(-1)*S34**(-1) * ( 16*s12**2*s13 + 
     +    16*s12*s13**2 + 8*s13**3 )

      LC = LC + Ld0(p1,p2,p3)*S14**(-1) * ( 80*s12**2 + 64*s12*s13 + 32
     +    *s12*s24 + 24*s12*s34 + 32*s13**2 + 8*s13*s23 + 32*s13*s24 + 
     +    32*s13*s34 + 8*s23*s34 + 8*s24**2 + 24*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p1,p2,p3)*S23**(-1)*S24**(-1) * ( 16*s12**2*s13 + 
     +    16*s12**2*s14 + 48*s12**2*s34 + 16*s12*s13**2 + 16*s12*s13*
     +    s14 + 48*s12*s13*s34 + 32*s12*s14*s34 + 24*s12*s34**2 + 8*
     +    s13**3 + 8*s13**2*s14 + 16*s13**2*s34 + 16*s13*s14*s34 + 8*
     +    s13*s34**2 + 8*s14**2*s34 + 8*s14*s34**2 )

      LC = LC + Ld0(p1,p2,p3)*S23**(-1)*S34**(-1) * ( 16*s12**2*s24 + 
     +    32*s12*s13*s24 + 16*s12*s14*s24 + 24*s13**2*s24 + 24*s13*s14*
     +    s24 + 8*s14**2*s24 )

      LC = LC + Ld0(p1,p2,p3)*S23**(-1) * ( 112*s12**2 + 80*s12*s13 + 
     +    48*s12*s14 + 48*s12*s24 + 72*s12*s34 + 24*s13**2 + 8*s13*s14
     +     + 16*s13*s24 + 16*s13*s34 - 8*s14*s24 - 8*s14*s34 + 8*s24**2
     +     )

      LC = LC + Ld0(p1,p2,p3)*S24**(-1)*S34**(-1) * (  - 16*s12**2*s23
     +     - 16*s12*s13*s23 - 32*s12*s14*s23 - 8*s13**2*s23 - 24*s13*
     +    s14*s23 - 24*s14**2*s23 )

      LC = LC + Ld0(p1,p2,p3)*S24**(-1) * ( 88*s12**2 + 56*s12*s13 + 40
     +    *s12*s14 + 8*s12*s23 + 16*s12*s34 - 16*s13*s14 - 8*s13*s23 - 
     +    8*s14**2 + 24*s14*s34 + 8*s23*s34 + 16*s34**2 )

      LC = LC + Ld0(p1,p2,p3)*S34**(-1) * ( 16*s12*s13 - 16*s12*s14 + 
     +    16*s13**2 - 16*s14**2 )

      LC = LC + Ld0(p1,p2,p3) * ( 56*s12 - 32*s14 - 8*s23 - 16*s34 )

      LC = LC + Ld0(p1,p2,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LC = LC + Ld0(p1,p2,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s34 )

      LC = LC + Ld0(p1,p2,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 40*s12**2*s23*s34 + 40*s12**2*s34**2 + 8*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LC = LC + Ld0(p1,p2,p4)*S13**(-1)*S14**(-1) * (  - 16*s12**2*s23
     +     - 16*s12**2*s24 + 24*s12**2*s34 - 16*s12*s23**2 - 16*s12*s23
     +    *s24 - 8*s12*s23*s34 - 8*s23**3 - 8*s23**2*s24 - 8*s23**2*s34
     +     )

      LC = LC + Ld0(p1,p2,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s14*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s14**2*s34 + 8*s12*s14*s34**2 )

      LC = LC + Ld0(p1,p2,p4)*S13**(-1)*S23**(-1) * ( 32*s12**3 + 48*
     +    s12**2*s14 + 16*s12**2*s34 + 32*s12*s14**2 + 8*s12*s14*s34 + 
     +    8*s14**3 )

      LC = LC + Ld0(p1,p2,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 16*
     +    s12**2*s14*s23 + 16*s12*s14**2*s23 + 8*s14**3*s23 )

      LC = LC + Ld0(p1,p2,p4)*S13**(-1)*S24**(-1) * ( 32*s12**3 + 64*
     +    s12**2*s14 + 80*s12**2*s23 + 96*s12**2*s34 + 48*s12*s14**2 + 
     +    64*s12*s14*s23 + 72*s12*s14*s34 + 32*s12*s23**2 + 56*s12*s23*
     +    s34 + 24*s12*s34**2 + 16*s14**3 + 32*s14**2*s23 + 32*s14**2*
     +    s34 + 24*s14*s23**2 + 48*s14*s23*s34 + 24*s14*s34**2 + 8*
     +    s23**3 + 24*s23**2*s34 + 24*s23*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p1,p2,p4)*S13**(-1)*S34**(-1) * ( 16*s12**2*s14 + 
     +    16*s12*s14**2 + 8*s14**3 )

      LC = LC + Ld0(p1,p2,p4)*S13**(-1) * ( 80*s12**2 + 64*s12*s14 + 32
     +    *s12*s23 + 24*s12*s34 + 32*s14**2 + 32*s14*s23 + 8*s14*s24 + 
     +    32*s14*s34 + 8*s23**2 + 24*s23*s34 + 8*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p1,p2,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s13*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s13**2*s34 + 8*s12*s13*s34**2 )

      LC = LC + Ld0(p1,p2,p4)*S14**(-1)*S23**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s13*s24 - 16*s12*s13**2*s24 - 8*s13**3*s24 )

      LC = LC + Ld0(p1,p2,p4)*S14**(-1)*S23**(-1) * ( 40*s12**3 + 64*
     +    s12**2*s13 + 8*s12**2*s24 + 32*s12**2*s34 + 16*s12*s13**2 + 
     +    16*s12*s13*s24 + 24*s12*s13*s34 + 16*s12*s24*s34 + 8*s12*
     +    s34**2 + 16*s13**2*s24 + 16*s13**2*s34 + 8*s13*s24**2 + 32*
     +    s13*s24*s34 + 16*s13*s34**2 + 8*s24*s34**2 )

      LC = LC + Ld0(p1,p2,p4)*S14**(-1)*S24**(-1) * ( 32*s12**3 + 56*
     +    s12**2*s13 + 56*s12**2*s23 + 96*s12**2*s34 + 16*s12*s13**2 + 
     +    24*s12*s13*s34 + 16*s12*s23**2 + 24*s12*s23*s34 + 16*s12*
     +    s34**2 )

      LC = LC + Ld0(p1,p2,p4)*S14**(-1)*S34**(-1) * (  - 16*s12**2*s13
     +     - 16*s12*s13**2 - 8*s13**3 )

      LC = LC + Ld0(p1,p2,p4)*S14**(-1) * ( 64*s12**2 + 8*s12*s13 + 24*
     +    s12*s23 + 8*s12*s24 + 32*s12*s34 - 8*s13**2 - 16*s13*s23 - 8*
     +    s13*s24 - 8*s13*s34 + 8*s23**2 + 8*s23*s24 - 8*s24*s34 )

      LC = LC + Ld0(p1,p2,p4)*S23**(-1)*S24**(-1) * ( 16*s12**2*s13 + 
     +    16*s12**2*s14 + 48*s12**2*s34 + 16*s12*s13*s14 + 32*s12*s13*
     +    s34 + 16*s12*s14**2 + 48*s12*s14*s34 + 24*s12*s34**2 + 8*
     +    s13**2*s34 + 8*s13*s14**2 + 16*s13*s14*s34 + 8*s13*s34**2 + 8
     +    *s14**3 + 16*s14**2*s34 + 8*s14*s34**2 )

      LC = LC + Ld0(p1,p2,p4)*S23**(-1)*S34**(-1) * (  - 16*s12**2*s24
     +     - 32*s12*s13*s24 - 16*s12*s14*s24 - 24*s13**2*s24 - 24*s13*
     +    s14*s24 - 8*s14**2*s24 )

      LC = LC + Ld0(p1,p2,p4)*S23**(-1) * ( 88*s12**2 + 40*s12*s13 + 56
     +    *s12*s14 + 8*s12*s24 + 16*s12*s34 - 8*s13**2 - 16*s13*s14 + 
     +    24*s13*s34 - 8*s14*s24 + 8*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p1,p2,p4)*S24**(-1)*S34**(-1) * ( 16*s12**2*s23 + 
     +    16*s12*s13*s23 + 32*s12*s14*s23 + 8*s13**2*s23 + 24*s13*s14*
     +    s23 + 24*s14**2*s23 )

      LC = LC + Ld0(p1,p2,p4)*S24**(-1) * ( 112*s12**2 + 48*s12*s13 + 
     +    80*s12*s14 + 48*s12*s23 + 72*s12*s34 + 8*s13*s14 - 8*s13*s23
     +     - 8*s13*s34 + 24*s14**2 + 16*s14*s23 + 16*s14*s34 + 8*s23**2
     +     )

      LC = LC + Ld0(p1,p2,p4)*S34**(-1) * (  - 16*s12*s13 + 16*s12*s14
     +     - 16*s13**2 + 16*s14**2 )

      LC = LC + Ld0(p1,p2,p4) * ( 56*s12 - 32*s13 - 8*s24 - 16*s34 )

      LC = LC + Ld0(p1,p2,p34)*S13**(-1)*S14**(-1)*S23**(-1)*S134 * ( 
     +     - 8*s12**3 - 8*s12**2*s24 + 8*s12**2*s34 - 16*s12*s24*s34 + 
     +    8*s12*s34**2 + 8*s24*s34**2 )

      LC = LC + Ld0(p1,p2,p34)*S13**(-1)*S14**(-1)*S23**(-1) * ( 8*
     +    s12**3*s34 + 8*s12**2*s24*s34 - 8*s12**2*s34**2 + 16*s12*s24*
     +    s34**2 - 8*s12*s34**3 - 8*s24*s34**3 )

      LC = LC + Ld0(p1,p2,p34)*S13**(-1)*S14**(-1)*S24**(-1)*S134 * ( 
     +     - 8*s12**2*s23 + 32*s12**2*s34 - 24*s12*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p1,p2,p34)*S13**(-1)*S14**(-1)*S24**(-1) * ( 8*
     +    s12**2*s23*s34 - 32*s12**2*s34**2 + 24*s12*s34**3 - 8*s34**4
     +     )

      LC = LC + Ld0(p1,p2,p34)*S13**(-1)*S14**(-1)*S134 * (  - 16*
     +    s12**2 + 24*s12*s34 + 16*s24*s34 - 8*s34**2 )

      LC = LC + Ld0(p1,p2,p34)*S13**(-1)*S14**(-1) * ( 16*s12**2*s34 - 
     +    24*s12*s34**2 - 16*s24*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p1,p2,p34)*S13**(-1)*S23**(-1)*S134 * ( 8*s12**2 - 
     +    8*s12*s14 - 8*s12*s24 + 48*s12*s34 - 8*s14**2 + 8*s14*s24 + 8
     +    *s14*s34 + 16*s24*s34 )

      LC = LC + Ld0(p1,p2,p34)*S13**(-1)*S23**(-1) * ( 8*s12**3 - 32*
     +    s12**2*s14 - 8*s12**2*s34 + 16*s12*s14*s24 - 8*s12*s14*s34 + 
     +    32*s12*s24*s34 - 40*s12*s34**2 - 8*s14**2*s24 - 24*s14*s24*
     +    s34 - 8*s14*s34**2 - 24*s24*s34**2 )

      LC = LC + Ld0(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * ( 16*s12**2
     +     + 24*s12*s14 - 8*s12*s23 + 8*s14**2 + 16*s14*s23 + 16*s14*
     +    s34 + 16*s23**2 + 24*s23*s34 + 24*s34**2 )

      LC = LC + Ld0(p1,p2,p34)*S13**(-1)*S24**(-1) * (  - 8*s12**3 - 32
     +    *s12**2*s14 - 56*s12**2*s34 + 16*s12*s14*s23 - 8*s12*s14*s34
     +     + 24*s12*s34**2 + 8*s14**2*s23 - 8*s14*s34**2 - 16*s34**3 )

      LC = LC + Ld0(p1,p2,p34)*S13**(-1)*S134 * ( 8*s12 - 8*s14 + 16*
     +    s23 + 16*s24 - 8*s34 )

      LC = LC + Ld0(p1,p2,p34)*S13**(-1) * (  - 16*s12*s14 - 16*s12*s34
     +     + 40*s14*s34 + 16*s23*s34 - 16*s24*s34 + 40*s34**2 )

      LC = LC + Ld0(p1,p2,p34)*S14**(-1)*S23**(-1)*S134 * (  - 16*
     +    s12**2 + 24*s12*s13 + 8*s12*s24 - 8*s12*s34 + 8*s13**2 + 24*
     +    s13*s24 + 16*s13*s34 + 16*s24**2 + 16*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p1,p2,p34)*S14**(-1)*S24**(-1)*S134 * (  - 24*
     +    s12**2 - 8*s12*s13 + 8*s12*s23 + 40*s12*s34 - 8*s13**2 + 8*
     +    s13*s34 - 8*s34**2 )

      LC = LC + Ld0(p1,p2,p34)*S14**(-1)*S134 * (  - 8*s12 - 8*s13 + 16
     +    *s23 + 16*s24 + 32*s34 )

      LC = LC + Ld0(p1,p2,p34)*S23**(-1)*S24**(-1)*S134 * (  - 16*s12*
     +    s34 - 16*s13*s34 - 16*s14*s34 )

      LC = LC + Ld0(p1,p2,p34)*S23**(-1)*S234**(-1)*S134 * ( 32*s12*s34
     +     - 16*s13*s24 + 16*s13*s34 + 32*s14*s34 + 16*s24*s34 + 16*
     +    s34**2 )

      LC = LC + Ld0(p1,p2,p34)*S23**(-1)*S134 * (  - 40*s12 - 16*s13 - 
     +    32*s14 - 24*s24 - 32*s34 )

      LC = LC + Ld0(p1,p2,p34)*S24**(-1)*S234**(-1)*S134 * ( 32*s12*s34
     +     + 32*s13*s34 - 16*s14*s23 + 16*s14*s34 + 16*s23*s34 + 16*
     +    s34**2 )

      LC = LC + Ld0(p1,p2,p34)*S24**(-1)*S134 * (  - 40*s12 - 32*s13 - 
     +    16*s14 - 16*s23 - 32*s34 )

      LC = LC + Ld0(p1,p2,p34)*S234**(-1)*S134 * ( 64*s12 + 48*s13 + 48
     +    *s14 + 32*s23 + 32*s24 + 64*s34 )

      LC = LC + Ld0(p1,p2,p34)*S134 * (  - 8 )

      LC = LC + Ld0(p1,p3,p2)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 32*s12**3*s34**2 )

      LC = LC + Ld0(p1,p3,p2)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s24 - 16*s12**3*s34 - 32*s12**2*s24*s34 - 32*s12**2*
     +    s34**2 - 16*s12*s24**2*s34 - 16*s12*s24*s34**2 )

      LC = LC + Ld0(p1,p3,p2)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 32*
     +    s12**3*s34 - 48*s12**2*s23*s34 - 48*s12**2*s34**2 - 32*s12*
     +    s23**2*s34 - 32*s12*s23*s34**2 - 8*s23**3*s34 - 8*s23**2*
     +    s34**2 )

      LC = LC + Ld0(p1,p3,p2)*S13**(-1)*S14**(-1) * ( 16*s12**3 + 16*
     +    s12**2*s23 + 16*s12**2*s24 - 64*s12**2*s34 + 8*s12*s23**2 + 8
     +    *s12*s23*s24 - 72*s12*s23*s34 - 64*s12*s24*s34 - 48*s12*
     +    s34**2 - 24*s23**2*s34 - 24*s23*s24*s34 - 16*s23*s34**2 - 8*
     +    s24**2*s34 - 8*s24*s34**2 )

      LC = LC + Ld0(p1,p3,p2)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s14 - 16*s12**3*s34 - 32*s12**2*s14*s34 - 32*s12**2*
     +    s34**2 - 16*s12*s14**2*s34 - 16*s12*s14*s34**2 )

      LC = LC + Ld0(p1,p3,p2)*S13**(-1)*S23**(-1) * (  - 32*s12**3 - 48
     +    *s12**2*s14 - 48*s12**2*s24 - 96*s12**2*s34 - 24*s12*s14**2
     +     - 16*s12*s14*s24 - 48*s12*s14*s34 - 24*s12*s24**2 - 48*s12*
     +    s24*s34 - 32*s12*s34**2 )

      LC = LC + Ld0(p1,p3,p2)*S13**(-1)*S24**(-1) * (  - 32*s12**3 - 48
     +    *s12**2*s14 - 48*s12**2*s23 - 96*s12**2*s34 - 40*s12*s14**2
     +     - 40*s12*s14*s23 - 64*s12*s14*s34 - 32*s12*s23**2 - 72*s12*
     +    s23*s34 - 24*s12*s34**2 - 8*s14**3 - 24*s14**2*s23 - 24*
     +    s14**2*s34 - 24*s14*s23**2 - 48*s14*s23*s34 - 24*s14*s34**2
     +     - 8*s23**3 - 32*s23**2*s34 - 24*s23*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p1,p3,p2)*S13**(-1) * (  - 96*s12**2 - 48*s12*s14
     +     - 56*s12*s23 - 48*s12*s24 - 80*s12*s34 - 8*s14**2 - 8*s14*
     +    s23 + 8*s14*s24 - 8*s14*s34 + 16*s23*s24 + 8*s23*s34 + 8*
     +    s24**2 + 24*s24*s34 + 8*s34**2 )

      LC = LC + Ld0(p1,p3,p2)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 32*
     +    s12**3*s34 - 48*s12**2*s13*s34 - 48*s12**2*s34**2 - 32*s12*
     +    s13**2*s34 - 32*s12*s13*s34**2 - 8*s13**3*s34 - 8*s13**2*
     +    s34**2 )

      LC = LC + Ld0(p1,p3,p2)*S14**(-1)*S23**(-1) * (  - 32*s12**3 - 48
     +    *s12**2*s13 - 48*s12**2*s24 - 96*s12**2*s34 - 32*s12*s13**2
     +     - 40*s12*s13*s24 - 72*s12*s13*s34 - 40*s12*s24**2 - 64*s12*
     +    s24*s34 - 24*s12*s34**2 - 8*s13**3 - 24*s13**2*s24 - 32*
     +    s13**2*s34 - 24*s13*s24**2 - 48*s13*s24*s34 - 24*s13*s34**2
     +     - 8*s24**3 - 24*s24**2*s34 - 24*s24*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p1,p3,p2)*S14**(-1)*S24**(-1) * (  - 32*s12**3 - 48
     +    *s12**2*s13 - 48*s12**2*s23 - 96*s12**2*s34 - 32*s12*s13**2
     +     - 32*s12*s13*s23 - 64*s12*s13*s34 - 32*s12*s23**2 - 64*s12*
     +    s23*s34 - 32*s12*s34**2 - 8*s13**3 - 8*s13**2*s23 - 16*s13**2
     +    *s34 - 8*s13*s23**2 - 16*s13*s23*s34 - 8*s13*s34**2 - 8*
     +    s23**3 - 16*s23**2*s34 - 8*s23*s34**2 )

      LC = LC + Ld0(p1,p3,p2)*S14**(-1) * (  - 96*s12**2 - 72*s12*s13
     +     - 96*s12*s23 - 104*s12*s24 - 120*s12*s34 - 32*s13**2 - 24*
     +    s13*s23 - 40*s13*s24 - 48*s13*s34 - 16*s23**2 - 16*s23*s24 - 
     +    32*s23*s34 - 16*s24**2 - 40*s24*s34 - 24*s34**2 )

      LC = LC + Ld0(p1,p3,p2)*S23**(-1)*S24**(-1) * ( 16*s12**3 + 16*
     +    s12**2*s13 + 16*s12**2*s14 - 64*s12**2*s34 + 8*s12*s13**2 + 8
     +    *s12*s13*s14 - 72*s12*s13*s34 - 64*s12*s14*s34 - 48*s12*
     +    s34**2 - 24*s13**2*s34 - 24*s13*s14*s34 - 16*s13*s34**2 - 8*
     +    s14**2*s34 - 8*s14*s34**2 )

      LC = LC + Ld0(p1,p3,p2)*S23**(-1) * (  - 96*s12**2 - 56*s12*s13
     +     - 48*s12*s14 - 48*s12*s24 - 80*s12*s34 + 16*s13*s14 - 8*s13*
     +    s24 + 8*s13*s34 + 8*s14**2 + 8*s14*s24 + 24*s14*s34 - 8*
     +    s24**2 - 8*s24*s34 + 8*s34**2 )

      LC = LC + Ld0(p1,p3,p2)*S24**(-1) * (  - 96*s12**2 - 96*s12*s13
     +     - 104*s12*s14 - 72*s12*s23 - 120*s12*s34 - 16*s13**2 - 16*
     +    s13*s14 - 24*s13*s23 - 32*s13*s34 - 16*s14**2 - 40*s14*s23 - 
     +    40*s14*s34 - 32*s23**2 - 48*s23*s34 - 24*s34**2 )

      LC = LC + Ld0(p1,p3,p2) * (  - 112*s12 - 16*s13 - 16*s23 )

      LC = LC + Ld0(p1,p3,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LC = LC + Ld0(p1,p3,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 48*
     +    s12**3*s34 - 16*s12**2*s24*s34 + 88*s12**2*s34**2 + 16*s12*
     +    s24**2*s34 - 24*s12*s24*s34**2 + 24*s12*s34**3 )

      LC = LC + Ld0(p1,p3,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s23*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LC = LC + Ld0(p1,p3,p4)*S13**(-1)*S14**(-1) * ( 56*s12**2*s34 + 
     +    24*s12*s23*s34 + 8*s12*s24*s34 + 32*s12*s34**2 - 8*s23**2*s34
     +     - 16*s23*s24*s34 - 8*s23*s34**2 - 8*s24**2*s34 - 8*s24*
     +    s34**2 )

      LC = LC + Ld0(p1,p3,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s14*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s14**2*s34 + 8*s12*s14*s34**2 )

      LC = LC + Ld0(p1,p3,p4)*S13**(-1)*S23**(-1) * ( 48*s12**3 + 56*
     +    s12**2*s14 + 8*s12**2*s24 + 136*s12**2*s34 + 40*s12*s14**2 - 
     +    24*s12*s14*s24 + 104*s12*s14*s34 + 32*s12*s24**2 - 24*s12*s24
     +    *s34 + 96*s12*s34**2 + 8*s14**3 - 16*s14**2*s24 + 24*s14**2*
     +    s34 + 8*s14*s24**2 - 32*s14*s24*s34 + 24*s14*s34**2 + 8*
     +    s24**2*s34 - 16*s24*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p1,p3,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 16*
     +    s12**2*s14*s23 + 16*s12*s14**2*s23 + 16*s12*s14*s23**2 + 8*
     +    s14**3*s23 + 8*s14*s23**3 )

      LC = LC + Ld0(p1,p3,p4)*S13**(-1)*S24**(-1) * ( 32*s12**3 + 64*
     +    s12**2*s14 + 64*s12**2*s23 + 80*s12**2*s34 + 48*s12*s14**2 + 
     +    80*s12*s14*s23 + 72*s12*s14*s34 + 48*s12*s23**2 + 72*s12*s23*
     +    s34 + 24*s12*s34**2 + 16*s14**3 + 32*s14**2*s23 + 32*s14**2*
     +    s34 + 32*s14*s23**2 + 48*s14*s23*s34 + 24*s14*s34**2 + 16*
     +    s23**3 + 32*s23**2*s34 + 24*s23*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p1,p3,p4)*S13**(-1)*S34**(-1)*S134**(-1) * ( 16*s12
     +    *s14**2*s23 + 16*s12*s14**2*s24 + 16*s14**2*s23**2 + 32*
     +    s14**2*s23*s24 + 16*s14**2*s24**2 )

      LC = LC + Ld0(p1,p3,p4)*S13**(-1)*S34**(-1) * ( 32*s12**2*s14 + 
     +    32*s12*s14**2 + 48*s12*s14*s23 + 16*s12*s14*s24 + 16*s14**3
     +     + 16*s14**2*s23 + 24*s14*s23**2 + 8*s14*s23*s24 )

      LC = LC + Ld0(p1,p3,p4)*S13**(-1)*S134**(-1) * ( 16*s12*s14**2 - 
     +    40*s12*s14*s23 - 40*s12*s14*s24 - 40*s12*s14*s34 - 24*s12*s23
     +    *s34 - 24*s12*s24*s34 - 24*s12*s34**2 + 16*s14**2*s23 + 16*
     +    s14**2*s24 - 40*s14*s23**2 - 80*s14*s23*s24 - 40*s14*s23*s34
     +     - 40*s14*s24**2 - 40*s14*s24*s34 - 24*s23**2*s34 - 48*s23*
     +    s24*s34 - 24*s23*s34**2 - 24*s24**2*s34 - 24*s24*s34**2 )

      LC = LC + Ld0(p1,p3,p4)*S13**(-1) * ( 128*s12**2 + 136*s12*s14 + 
     +    152*s12*s23 + 96*s12*s24 + 200*s12*s34 + 56*s14**2 + 48*s14*
     +    s23 - 24*s14*s24 + 56*s14*s34 + 72*s23**2 + 88*s23*s24 + 88*
     +    s23*s34 + 40*s24**2 + 32*s24*s34 + 32*s34**2 )

      LC = LC + Ld0(p1,p3,p4)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 + 48*s12**2*s13*s34 - 56*s12**2*s34**2 + 40*s12*
     +    s13*s34**2 - 24*s12*s34**3 )

      LC = LC + Ld0(p1,p3,p4)*S14**(-1)*S23**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s13*s24 - 16*s12*s13**2*s24 - 16*s12*s13*s24**2 - 8*
     +    s13**3*s24 - 8*s13*s24**3 )

      LC = LC + Ld0(p1,p3,p4)*S14**(-1)*S23**(-1) * (  - 8*s12**3 - 88*
     +    s12**2*s13 - 16*s12**2*s34 - 48*s12*s13**2 - 48*s12*s13*s24
     +     - 104*s12*s13*s34 + 8*s12*s24**2 + 72*s12*s24*s34 + 8*s12*
     +    s34**2 - 24*s13**3 - 24*s13**2*s24 - 16*s13**2*s34 + 8*s13*
     +    s24**2 + 16*s13*s24*s34 + 8*s13*s34**2 + 8*s24**2*s34 + 32*
     +    s24*s34**2 + 16*s34**3 )

      LC = LC + Ld0(p1,p3,p4)*S14**(-1)*S24**(-1) * (  - 16*s12**3 + 16
     +    *s12**2*s13 - 24*s12**2*s23 - 80*s12**2*s34 - 8*s12*s13**2 + 
     +    48*s12*s13*s23 + 56*s12*s13*s34 - 40*s12*s23**2 - 48*s12*s23*
     +    s34 - 80*s12*s34**2 - 8*s13**2*s23 - 8*s13**2*s34 + 16*s13*
     +    s23**2 + 32*s13*s23*s34 + 16*s13*s34**2 - 16*s23**3 - 24*
     +    s23**2*s34 - 24*s23*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p1,p3,p4)*S14**(-1)*S34**(-1)*S134**(-1) * (  - 16*
     +    s12*s13**2*s23 - 16*s12*s13**2*s24 - 16*s13**2*s23**2 - 32*
     +    s13**2*s23*s24 - 16*s13**2*s24**2 )

      LC = LC + Ld0(p1,p3,p4)*S14**(-1)*S34**(-1) * (  - 32*s12**2*s13
     +     - 32*s12*s13**2 - 48*s12*s13*s23 - 80*s12*s13*s24 - 16*
     +    s13**3 - 16*s13**2*s24 - 32*s13*s23**2 - 72*s13*s23*s24 - 56*
     +    s13*s24**2 )

      LC = LC + Ld0(p1,p3,p4)*S14**(-1)*S134**(-1) * (  - 16*s12*s13**2
     +     - 20*s12*s13*s23 - 20*s12*s13*s24 - 20*s12*s13*s34 - 4*s12*
     +    s23*s34 - 4*s12*s24*s34 - 4*s12*s34**2 - 16*s13**2*s23 - 16*
     +    s13**2*s24 - 20*s13*s23**2 - 40*s13*s23*s24 - 20*s13*s23*s34
     +     - 20*s13*s24**2 - 20*s13*s24*s34 - 4*s23**2*s34 - 8*s23*s24*
     +    s34 - 4*s23*s34**2 - 4*s24**2*s34 - 4*s24*s34**2 )

      LC = LC + Ld0(p1,p3,p4)*S14**(-1) * (  - 32*s12**2 - 112*s12*s13
     +     - 12*s12*s23 + 44*s12*s24 + 20*s12*s34 - 24*s13**2 - 32*s13*
     +    s23 - 72*s13*s24 - 28*s23**2 - 8*s23*s24 - 20*s23*s34 - 4*
     +    s24**2 + 20*s24*s34 + 8*s34**2 )

      LC = LC + Ld0(p1,p3,p4)*S23**(-1)*S24**(-1) * ( 8*s12**2*s34 + 32
     +    *s12*s13*s34 + 16*s12*s14*s34 - 8*s12*s34**2 )

      LC = LC + Ld0(p1,p3,p4)*S23**(-1)*S34**(-1) * (  - 32*s12**2*s24
     +     - 32*s12*s13*s24 - 32*s12*s24**2 - 8*s13**2*s24 + 24*s13*s14
     +    *s24 - 16*s13*s24**2 + 16*s14**2*s24 - 16*s24**3 )

      LC = LC + Ld0(p1,p3,p4)*S23**(-1) * ( 32*s12**2 - 40*s12*s13 + 40
     +    *s12*s14 + 40*s12*s24 + 72*s12*s34 - 32*s13**2 - 24*s13*s14
     +     - 16*s13*s34 + 24*s14*s24 + 8*s14*s34 - 16*s24**2 + 16*s24*
     +    s34 + 16*s34**2 )

      LC = LC + Ld0(p1,p3,p4)*S24**(-1)*S34**(-1) * ( 32*s12**2*s23 + 
     +    32*s12*s13*s23 + 64*s12*s14*s23 + 32*s12*s23**2 + 16*s13**2*
     +    s23 + 40*s13*s14*s23 + 40*s14**2*s23 + 16*s14*s23**2 + 16*
     +    s23**3 )

      LC = LC + Ld0(p1,p3,p4)*S24**(-1) * ( 32*s12*s13 + 32*s12*s14 + 
     +    16*s12*s23 - 48*s12*s34 + 8*s13**2 + 24*s13*s14 + 32*s13*s23
     +     + 16*s13*s34 + 24*s14**2 + 32*s14*s23 + 8*s14*s34 - 8*s23**2
     +     - 24*s23*s34 - 16*s34**2 )

      LC = LC + Ld0(p1,p3,p4)*S34**(-1)*S134**(-1) * ( 16*s12*s13*s23
     +     + 16*s12*s13*s24 - 16*s12*s14*s23 - 16*s12*s14*s24 + 16*s13*
     +    s23**2 + 32*s13*s23*s24 + 16*s13*s24**2 - 16*s14*s23**2 - 32*
     +    s14*s23*s24 - 16*s14*s24**2 )

      LC = LC + Ld0(p1,p3,p4)*S34**(-1) * (  - 48*s12*s13 + 16*s12*s14
     +     + 48*s12*s23 - 16*s12*s24 - 32*s13**2 - 32*s13*s14 + 32*
     +    s23**2 + 32*s23*s24 )

      LC = LC + Ld0(p1,p3,p4)*S134**(-1) * ( 16*s12*s13 - 16*s12*s14 - 
     +    76*s12*s23 - 76*s12*s24 - 76*s12*s34 + 16*s13*s23 + 16*s13*
     +    s24 - 16*s14*s23 - 16*s14*s24 - 76*s23**2 - 152*s23*s24 - 76*
     +    s23*s34 - 76*s24**2 - 76*s24*s34 )

      LC = LC + Ld0(p1,p3,p4) * ( 24*s12 - 8*s13 - 16*s14 - 24*s23 - 8*
     +    s24 - 32*s34 )

      LC = LC + Ld0(p1,p3,p24)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16*
     +    s12**3*s24 - 48*s12**3*s34 + 48*s12**2*s24*s34 - 56*s12**2*
     +    s34**2 + 40*s12*s24*s34**2 - 24*s12*s34**3 )

      LC = LC + Ld0(p1,p3,p24)*S13**(-1)*S14**(-1) * (  - 16*s12**3 + 
     +    16*s12**2*s23 + 16*s12**2*s24 + 8*s12**2*s34 + 8*s12*s23**2
     +     + 8*s12*s23*s24 + 16*s12*s24*s34 - 24*s12*s34**2 )

      LC = LC + Ld0(p1,p3,p24)*S13**(-1)*S23**(-1)*S34**(-1)*S234**(-1)
     +  * (  - 8*s12**2*s14*s24**2 - 12*s12*s14**2*s24**2 - 8*s12*s14*
     +    s24**3 - 16*s14**3*s24**2 + 4*s14**2*s24**3 )

      LC = LC + Ld0(p1,p3,p24)*S13**(-1)*S23**(-1)*S34**(-1) * ( 8*
     +    s12**2*s14*s24 + 12*s12*s14**2*s24 + 8*s12*s14*s24**2 + 16*
     +    s14**3*s24 - 4*s14**2*s24**2 )

      LC = LC + Ld0(p1,p3,p24)*S13**(-1)*S23**(-1)*S234**(-1) * (  - 12
     +    *s12**2*s14*s24 - 4*s12**2*s14*s34 - 8*s12**2*s24**2 - 12*
     +    s12**2*s24*s34 - 4*s12**2*s34**2 - 32*s12*s14**2*s24 - 20*s12
     +    *s14**2*s34 - 36*s12*s14*s24**2 - 56*s12*s14*s24*s34 - 28*s12
     +    *s14*s34**2 - 8*s12*s24**3 - 24*s12*s24**2*s34 - 24*s12*s24*
     +    s34**2 - 8*s12*s34**3 - 32*s14**3*s24 - 16*s14**3*s34 - 8*
     +    s14**2*s24**2 - 28*s14**2*s24*s34 - 16*s14**2*s34**2 + 4*s14*
     +    s24**3 + 8*s14*s24**2*s34 + 4*s14*s24*s34**2 )

      LC = LC + Ld0(p1,p3,p24)*S13**(-1)*S23**(-1) * (  - 48*s12**3 - 
     +    60*s12**2*s14 + 40*s12**2*s24 - 92*s12**2*s34 - 20*s12*s14**2
     +     + 68*s12*s14*s24 - 68*s12*s14*s34 + 8*s12*s24**2 + 96*s12*
     +    s24*s34 - 72*s12*s34**2 + 8*s14**3 + 28*s14**2*s24 - 8*s14**2
     +    *s34 - 12*s14*s24**2 + 28*s14*s24*s34 - 24*s14*s34**2 - 8*
     +    s24**2*s34 + 16*s24*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p1,p3,p24)*S13**(-1)*S34**(-1)*S234**(-1) * ( 8*
     +    s12**2*s14*s23 - 12*s12*s14**2*s24 + 8*s12*s14*s23**2 + 8*s12
     +    *s14*s23*s24 - 8*s12*s14*s24**2 - 8*s14**3*s23 - 24*s14**3*
     +    s24 + 8*s14**2*s23**2 + 20*s14**2*s23*s24 + 16*s14**2*s24**2
     +     )

      LC = LC + Ld0(p1,p3,p24)*S13**(-1)*S34**(-1) * ( 8*s12**2*s14 + 
     +    16*s12*s14**2 + 24*s12*s14*s23 + 16*s12*s14*s24 + 16*s14**3
     +     + 8*s14**2*s23 - 12*s14**2*s24 + 16*s14*s23**2 + 16*s14*s23*
     +    s24 + 8*s14*s24**2 )

      LC = LC + Ld0(p1,p3,p24)*S13**(-1)*S234**(-1) * ( 4*s12**2*s14 + 
     +    8*s12**2*s23 + 4*s12**2*s34 - 20*s12*s14**2 + 8*s12*s14*s23
     +     - 28*s12*s14*s24 - 28*s12*s14*s34 + 8*s12*s23**2 + 8*s12*s23
     +    *s24 + 8*s12*s23*s34 - 8*s12*s24**2 - 16*s12*s24*s34 - 8*s12*
     +    s34**2 - 24*s14**3 + 8*s14**2*s23 - 16*s14**2*s34 + 8*s14*
     +    s23**2 + 20*s14*s23*s24 + 16*s14*s23*s34 + 16*s14*s24**2 + 24
     +    *s14*s24*s34 + 8*s14*s34**2 )

      LC = LC + Ld0(p1,p3,p24)*S13**(-1) * (  - 56*s12**2 - 40*s12*s14
     +     - 40*s12*s23 + 24*s12*s24 - 88*s12*s34 - 8*s14**2 - 8*s14*
     +    s23 + 4*s14*s24 - 48*s14*s34 + 8*s23**2 + 24*s23*s24 - 8*s23*
     +    s34 + 8*s24**2 + 16*s24*s34 - 24*s34**2 )

      LC = LC + Ld0(p1,p3,p24)*S14**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 - 16*s12**2*s13*s34 + 88*s12**2*s34**2 + 24*s12*
     +    s13**2*s34 - 16*s12*s13*s34**2 + 24*s12*s34**3 + 8*s13**3*s34
     +     + 8*s13**2*s34**2 )

      LC = LC + Ld0(p1,p3,p24)*S14**(-1)*S23**(-1) * (  - 32*s12**3 - 
     +    64*s12**2*s24 - 16*s12*s13**2 - 8*s12*s13*s24 + 80*s12*s13*
     +    s34 - 8*s12*s24**2 - 48*s12*s24*s34 + 16*s12*s34**2 - 8*s13*
     +    s24**2 - 8*s24**3 )

      LC = LC + Ld0(p1,p3,p24)*S14**(-1)*S24**(-1) * ( 16*s12**3 + 32*
     +    s12**2*s23 + 96*s12**2*s34 + 24*s12*s13**2 - 16*s12*s13*s23
     +     - 32*s12*s13*s34 + 24*s12*s23**2 + 88*s12*s23*s34 + 88*s12*
     +    s34**2 + 8*s13**3 + 8*s13**2*s23 + 16*s13**2*s34 - 8*s13*
     +    s23**2 - 24*s13*s23*s34 - 16*s13*s34**2 + 8*s23**3 + 32*
     +    s23**2*s34 + 32*s23*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p1,p3,p24)*S14**(-1)*S34**(-1) * (  - 16*s12**2*s13
     +     - 16*s12*s13**2 + 16*s12*s13*s23 - 8*s13**3 - 16*s13**2*s24
     +     + 24*s13*s23**2 + 48*s13*s23*s24 + 16*s13*s24**2 )

      LC = LC + Ld0(p1,p3,p24)*S14**(-1) * ( 32*s12**2 + 104*s12*s13 + 
     +    24*s12*s23 + 80*s12*s34 + 48*s13*s23 + 40*s13*s24 + 16*s13*
     +    s34 + 8*s23**2 - 32*s23*s24 + 24*s23*s34 - 32*s24**2 - 32*s24
     +    *s34 + 8*s34**2 )

      LC = LC + Ld0(p1,p3,p24)*S23**(-1)*S24**(-1) * ( 40*s12**2*s34 + 
     +    24*s12*s13*s34 + 24*s12*s14*s34 + 40*s12*s34**2 + 24*s13**2*
     +    s34 + 24*s13*s14*s34 + 16*s13*s34**2 + 8*s14**2*s34 + 8*s14*
     +    s34**2 )

      LC = LC + Ld0(p1,p3,p24)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 8*
     +    s12**2*s24**2 - 28*s12*s13*s24**2 - 40*s12*s14*s24**2 - 8*s12
     +    *s24**3 - 20*s13**2*s24**2 - 40*s13*s14*s24**2 - 12*s13*
     +    s24**3 - 36*s14**2*s24**2 - 8*s14*s24**3 )

      LC = LC + Ld0(p1,p3,p24)*S23**(-1)*S34**(-1) * (  - 8*s12**2*s24
     +     - 36*s12*s13*s24 - 8*s12*s14*s24 - 8*s12*s24**2 - 28*s13**2*
     +    s24 - 40*s13*s14*s24 - 4*s13*s24**2 - 4*s14**2*s24 + 8*s14*
     +    s24**2 - 8*s24**3 )

      LC = LC + Ld0(p1,p3,p24)*S23**(-1)*S234**(-1) * (  - 12*s12**2*
     +    s24 - 4*s12**2*s34 - 32*s12*s13*s24 - 36*s12*s13*s34 - 64*s12
     +    *s14*s24 - 56*s12*s14*s34 - 52*s12*s24**2 - 56*s12*s24*s34 - 
     +    44*s12*s34**2 - 4*s13**2*s24 - 16*s13**2*s34 - 20*s13*s14*s24
     +     - 44*s13*s14*s34 - 28*s13*s24**2 - 16*s13*s34**2 - 48*s14**2
     +    *s24 - 44*s14**2*s34 - 20*s14*s24**2 - 8*s14*s24*s34 - 28*s14
     +    *s34**2 - 12*s24**3 - 8*s24**2*s34 + 4*s24*s34**2 )

      LC = LC + Ld0(p1,p3,p24)*S23**(-1) * (  - 92*s12**2 + 4*s12*s13
     +     - 8*s12*s14 - 28*s12*s24 - 4*s12*s34 + 28*s13*s14 - 40*s13*
     +    s24 - 8*s13*s34 + 28*s14**2 - 28*s14*s24 - 12*s14*s34 + 4*
     +    s24**2 - 4*s24*s34 - 24*s34**2 )

      LC = LC + Ld0(p1,p3,p24)*S24**(-1)*S34**(-1) * ( 16*s12**2*s23 + 
     +    16*s12*s13*s23 + 32*s12*s14*s23 + 16*s12*s23**2 + 8*s13**2*
     +    s23 + 16*s13*s14*s23 + 16*s14**2*s23 + 16*s14*s23**2 + 8*
     +    s23**3 )

      LC = LC + Ld0(p1,p3,p24)*S24**(-1)*S234**(-1) * ( 4*s12*s13*s23
     +     + 4*s12*s13*s34 + 4*s12*s14*s23 + 4*s12*s14*s34 + 4*s12*s23*
     +    s34 + 4*s12*s34**2 + 4*s13*s14*s23 + 4*s13*s14*s34 + 4*s13*
     +    s23**2 + 8*s13*s23*s34 + 4*s13*s34**2 + 4*s14**2*s23 + 4*
     +    s14**2*s34 + 4*s14*s23**2 + 12*s14*s23*s34 + 8*s14*s34**2 + 4
     +    *s23**2*s34 + 8*s23*s34**2 + 4*s34**3 )

      LC = LC + Ld0(p1,p3,p24)*S24**(-1) * ( 48*s12**2 + 28*s12*s13 + 
     +    44*s12*s14 + 96*s12*s23 + 108*s12*s34 + 16*s13**2 + 12*s13*
     +    s14 + 12*s13*s23 + 12*s13*s34 + 12*s14**2 + 60*s14*s23 + 40*
     +    s14*s34 + 48*s23**2 + 76*s23*s34 + 36*s34**2 )

      LC = LC + Ld0(p1,p3,p24)*S34**(-1)*S234**(-1) * ( 8*s12**2*s23 - 
     +    24*s12*s13*s23 + 12*s12*s13*s24 - 24*s12*s14*s23 + 8*s12*
     +    s23**2 + 8*s12*s23*s24 - 8*s12*s24**2 - 4*s13**2*s23 + 40*
     +    s13**2*s24 - 32*s13*s14*s23 + 56*s13*s14*s24 - 8*s13*s23**2
     +     + 4*s13*s23*s24 - 36*s14**2*s23 - 8*s14**2*s24 + 24*s14*s23*
     +    s24 + 16*s14*s24**2 )

      LC = LC + Ld0(p1,p3,p24)*S34**(-1) * (  - 8*s12**2 - 8*s12*s13 + 
     +    24*s12*s14 - 8*s12*s23 - 32*s12*s24 - 12*s13**2 + 8*s13*s23
     +     - 12*s13*s24 + 20*s14**2 - 24*s14*s24 - 16*s23**2 - 32*s23*
     +    s24 - 16*s24**2 )

      LC = LC + Ld0(p1,p3,p24)*S234**(-1) * ( 4*s12**2 - 24*s12*s13 - 
     +    44*s12*s14 - 16*s12*s23 - 4*s12*s24 - 32*s12*s34 + 12*s13**2
     +     - 8*s13*s14 + 4*s13*s23 + 68*s13*s24 + 28*s13*s34 - 44*
     +    s14**2 - 4*s14*s23 + 68*s14*s24 + 4*s14*s34 - 8*s23**2 + 4*
     +    s23*s24 + 8*s23*s34 + 28*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p1,p3,p24) * ( 32*s12 + 16*s13 - 8*s23 - 20*s24 + 4
     +    *s34 )

      LC = LC + Ld0(p1,p4,p2)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 32*s12**3*s34**2 )

      LC = LC + Ld0(p1,p4,p2)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 32*
     +    s12**3*s34 - 48*s12**2*s24*s34 - 48*s12**2*s34**2 - 32*s12*
     +    s24**2*s34 - 32*s12*s24*s34**2 - 8*s24**3*s34 - 8*s24**2*
     +    s34**2 )

      LC = LC + Ld0(p1,p4,p2)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s23 - 16*s12**3*s34 - 32*s12**2*s23*s34 - 32*s12**2*
     +    s34**2 - 16*s12*s23**2*s34 - 16*s12*s23*s34**2 )

      LC = LC + Ld0(p1,p4,p2)*S13**(-1)*S14**(-1) * ( 16*s12**3 + 16*
     +    s12**2*s23 + 16*s12**2*s24 - 64*s12**2*s34 + 8*s12*s23*s24 - 
     +    64*s12*s23*s34 + 8*s12*s24**2 - 72*s12*s24*s34 - 48*s12*
     +    s34**2 - 8*s23**2*s34 - 24*s23*s24*s34 - 8*s23*s34**2 - 24*
     +    s24**2*s34 - 16*s24*s34**2 )

      LC = LC + Ld0(p1,p4,p2)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 32*
     +    s12**3*s34 - 48*s12**2*s14*s34 - 48*s12**2*s34**2 - 32*s12*
     +    s14**2*s34 - 32*s12*s14*s34**2 - 8*s14**3*s34 - 8*s14**2*
     +    s34**2 )

      LC = LC + Ld0(p1,p4,p2)*S13**(-1)*S23**(-1) * (  - 32*s12**3 - 48
     +    *s12**2*s14 - 48*s12**2*s24 - 96*s12**2*s34 - 32*s12*s14**2
     +     - 32*s12*s14*s24 - 64*s12*s14*s34 - 32*s12*s24**2 - 64*s12*
     +    s24*s34 - 32*s12*s34**2 - 8*s14**3 - 8*s14**2*s24 - 16*s14**2
     +    *s34 - 8*s14*s24**2 - 16*s14*s24*s34 - 8*s14*s34**2 - 8*
     +    s24**3 - 16*s24**2*s34 - 8*s24*s34**2 )

      LC = LC + Ld0(p1,p4,p2)*S13**(-1)*S24**(-1) * (  - 32*s12**3 - 48
     +    *s12**2*s14 - 48*s12**2*s23 - 96*s12**2*s34 - 32*s12*s14**2
     +     - 40*s12*s14*s23 - 72*s12*s14*s34 - 40*s12*s23**2 - 64*s12*
     +    s23*s34 - 24*s12*s34**2 - 8*s14**3 - 24*s14**2*s23 - 32*
     +    s14**2*s34 - 24*s14*s23**2 - 48*s14*s23*s34 - 24*s14*s34**2
     +     - 8*s23**3 - 24*s23**2*s34 - 24*s23*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p1,p4,p2)*S13**(-1) * (  - 96*s12**2 - 72*s12*s14
     +     - 104*s12*s23 - 96*s12*s24 - 120*s12*s34 - 32*s14**2 - 40*
     +    s14*s23 - 24*s14*s24 - 48*s14*s34 - 16*s23**2 - 16*s23*s24 - 
     +    40*s23*s34 - 16*s24**2 - 32*s24*s34 - 24*s34**2 )

      LC = LC + Ld0(p1,p4,p2)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s13 - 16*s12**3*s34 - 32*s12**2*s13*s34 - 32*s12**2*
     +    s34**2 - 16*s12*s13**2*s34 - 16*s12*s13*s34**2 )

      LC = LC + Ld0(p1,p4,p2)*S14**(-1)*S23**(-1) * (  - 32*s12**3 - 48
     +    *s12**2*s13 - 48*s12**2*s24 - 96*s12**2*s34 - 40*s12*s13**2
     +     - 40*s12*s13*s24 - 64*s12*s13*s34 - 32*s12*s24**2 - 72*s12*
     +    s24*s34 - 24*s12*s34**2 - 8*s13**3 - 24*s13**2*s24 - 24*
     +    s13**2*s34 - 24*s13*s24**2 - 48*s13*s24*s34 - 24*s13*s34**2
     +     - 8*s24**3 - 32*s24**2*s34 - 24*s24*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p1,p4,p2)*S14**(-1)*S24**(-1) * (  - 32*s12**3 - 48
     +    *s12**2*s13 - 48*s12**2*s23 - 96*s12**2*s34 - 24*s12*s13**2
     +     - 16*s12*s13*s23 - 48*s12*s13*s34 - 24*s12*s23**2 - 48*s12*
     +    s23*s34 - 32*s12*s34**2 )

      LC = LC + Ld0(p1,p4,p2)*S14**(-1) * (  - 96*s12**2 - 48*s12*s13
     +     - 48*s12*s23 - 56*s12*s24 - 80*s12*s34 - 8*s13**2 + 8*s13*
     +    s23 - 8*s13*s24 - 8*s13*s34 + 8*s23**2 + 16*s23*s24 + 24*s23*
     +    s34 + 8*s24*s34 + 8*s34**2 )

      LC = LC + Ld0(p1,p4,p2)*S23**(-1)*S24**(-1) * ( 16*s12**3 + 16*
     +    s12**2*s13 + 16*s12**2*s14 - 64*s12**2*s34 + 8*s12*s13*s14 - 
     +    64*s12*s13*s34 + 8*s12*s14**2 - 72*s12*s14*s34 - 48*s12*
     +    s34**2 - 8*s13**2*s34 - 24*s13*s14*s34 - 8*s13*s34**2 - 24*
     +    s14**2*s34 - 16*s14*s34**2 )

      LC = LC + Ld0(p1,p4,p2)*S23**(-1) * (  - 96*s12**2 - 104*s12*s13
     +     - 96*s12*s14 - 72*s12*s24 - 120*s12*s34 - 16*s13**2 - 16*s13
     +    *s14 - 40*s13*s24 - 40*s13*s34 - 16*s14**2 - 24*s14*s24 - 32*
     +    s14*s34 - 32*s24**2 - 48*s24*s34 - 24*s34**2 )

      LC = LC + Ld0(p1,p4,p2)*S24**(-1) * (  - 96*s12**2 - 48*s12*s13
     +     - 56*s12*s14 - 48*s12*s23 - 80*s12*s34 + 8*s13**2 + 16*s13*
     +    s14 + 8*s13*s23 + 24*s13*s34 - 8*s14*s23 + 8*s14*s34 - 8*
     +    s23**2 - 8*s23*s34 + 8*s34**2 )

      LC = LC + Ld0(p1,p4,p2) * (  - 112*s12 - 16*s14 - 16*s24 )

      LC = LC + Ld0(p1,p4,p3)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LC = LC + Ld0(p1,p4,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s24*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LC = LC + Ld0(p1,p4,p3)*S13**(-1)*S14**(-1)*S24**(-1) * ( 48*
     +    s12**3*s34 - 16*s12**2*s23*s34 + 88*s12**2*s34**2 + 16*s12*
     +    s23**2*s34 - 24*s12*s23*s34**2 + 24*s12*s34**3 )

      LC = LC + Ld0(p1,p4,p3)*S13**(-1)*S14**(-1) * ( 56*s12**2*s34 + 8
     +    *s12*s23*s34 + 24*s12*s24*s34 + 32*s12*s34**2 - 8*s23**2*s34
     +     - 16*s23*s24*s34 - 8*s23*s34**2 - 8*s24**2*s34 - 8*s24*
     +    s34**2 )

      LC = LC + Ld0(p1,p4,p3)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 + 48*s12**2*s14*s34 - 56*s12**2*s34**2 + 40*s12*
     +    s14*s34**2 - 24*s12*s34**3 )

      LC = LC + Ld0(p1,p4,p3)*S13**(-1)*S23**(-1) * (  - 16*s12**3 + 16
     +    *s12**2*s14 - 24*s12**2*s24 - 80*s12**2*s34 - 8*s12*s14**2 + 
     +    48*s12*s14*s24 + 56*s12*s14*s34 - 40*s12*s24**2 - 48*s12*s24*
     +    s34 - 80*s12*s34**2 - 8*s14**2*s24 - 8*s14**2*s34 + 16*s14*
     +    s24**2 + 32*s14*s24*s34 + 16*s14*s34**2 - 16*s24**3 - 24*
     +    s24**2*s34 - 24*s24*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p1,p4,p3)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s14*s23 - 16*s12*s14**2*s23 - 16*s12*s14*s23**2 - 8*
     +    s14**3*s23 - 8*s14*s23**3 )

      LC = LC + Ld0(p1,p4,p3)*S13**(-1)*S24**(-1) * (  - 8*s12**3 - 88*
     +    s12**2*s14 - 16*s12**2*s34 - 48*s12*s14**2 - 48*s12*s14*s23
     +     - 104*s12*s14*s34 + 8*s12*s23**2 + 72*s12*s23*s34 + 8*s12*
     +    s34**2 - 24*s14**3 - 24*s14**2*s23 - 16*s14**2*s34 + 8*s14*
     +    s23**2 + 16*s14*s23*s34 + 8*s14*s34**2 + 8*s23**2*s34 + 32*
     +    s23*s34**2 + 16*s34**3 )

      LC = LC + Ld0(p1,p4,p3)*S13**(-1)*S34**(-1)*S134**(-1) * (  - 16*
     +    s12*s14**2*s23 - 16*s12*s14**2*s24 - 16*s14**2*s23**2 - 32*
     +    s14**2*s23*s24 - 16*s14**2*s24**2 )

      LC = LC + Ld0(p1,p4,p3)*S13**(-1)*S34**(-1) * (  - 32*s12**2*s14
     +     - 32*s12*s14**2 - 80*s12*s14*s23 - 48*s12*s14*s24 - 16*
     +    s14**3 - 16*s14**2*s23 - 56*s14*s23**2 - 72*s14*s23*s24 - 32*
     +    s14*s24**2 )

      LC = LC + Ld0(p1,p4,p3)*S13**(-1)*S134**(-1) * (  - 16*s12*s14**2
     +     - 20*s12*s14*s23 - 20*s12*s14*s24 - 20*s12*s14*s34 - 4*s12*
     +    s23*s34 - 4*s12*s24*s34 - 4*s12*s34**2 - 16*s14**2*s23 - 16*
     +    s14**2*s24 - 20*s14*s23**2 - 40*s14*s23*s24 - 20*s14*s23*s34
     +     - 20*s14*s24**2 - 20*s14*s24*s34 - 4*s23**2*s34 - 8*s23*s24*
     +    s34 - 4*s23*s34**2 - 4*s24**2*s34 - 4*s24*s34**2 )

      LC = LC + Ld0(p1,p4,p3)*S13**(-1) * (  - 32*s12**2 - 112*s12*s14
     +     + 44*s12*s23 - 12*s12*s24 + 20*s12*s34 - 24*s14**2 - 72*s14*
     +    s23 - 32*s14*s24 - 4*s23**2 - 8*s23*s24 + 20*s23*s34 - 28*
     +    s24**2 - 20*s24*s34 + 8*s34**2 )

      LC = LC + Ld0(p1,p4,p3)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s13*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s13**2*s34 + 8*s12*s13*s34**2 )

      LC = LC + Ld0(p1,p4,p3)*S14**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2*s13*s24 + 16*s12*s13**2*s24 + 16*s12*s13*s24**2 + 8*
     +    s13**3*s24 + 8*s13*s24**3 )

      LC = LC + Ld0(p1,p4,p3)*S14**(-1)*S23**(-1) * ( 32*s12**3 + 64*
     +    s12**2*s13 + 64*s12**2*s24 + 80*s12**2*s34 + 48*s12*s13**2 + 
     +    80*s12*s13*s24 + 72*s12*s13*s34 + 48*s12*s24**2 + 72*s12*s24*
     +    s34 + 24*s12*s34**2 + 16*s13**3 + 32*s13**2*s24 + 32*s13**2*
     +    s34 + 32*s13*s24**2 + 48*s13*s24*s34 + 24*s13*s34**2 + 16*
     +    s24**3 + 32*s24**2*s34 + 24*s24*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p1,p4,p3)*S14**(-1)*S24**(-1) * ( 48*s12**3 + 56*
     +    s12**2*s13 + 8*s12**2*s23 + 136*s12**2*s34 + 40*s12*s13**2 - 
     +    24*s12*s13*s23 + 104*s12*s13*s34 + 32*s12*s23**2 - 24*s12*s23
     +    *s34 + 96*s12*s34**2 + 8*s13**3 - 16*s13**2*s23 + 24*s13**2*
     +    s34 + 8*s13*s23**2 - 32*s13*s23*s34 + 24*s13*s34**2 + 8*
     +    s23**2*s34 - 16*s23*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p1,p4,p3)*S14**(-1)*S34**(-1)*S134**(-1) * ( 16*s12
     +    *s13**2*s23 + 16*s12*s13**2*s24 + 16*s13**2*s23**2 + 32*
     +    s13**2*s23*s24 + 16*s13**2*s24**2 )

      LC = LC + Ld0(p1,p4,p3)*S14**(-1)*S34**(-1) * ( 32*s12**2*s13 + 
     +    32*s12*s13**2 + 16*s12*s13*s23 + 48*s12*s13*s24 + 16*s13**3
     +     + 16*s13**2*s24 + 8*s13*s23*s24 + 24*s13*s24**2 )

      LC = LC + Ld0(p1,p4,p3)*S14**(-1)*S134**(-1) * ( 16*s12*s13**2 - 
     +    40*s12*s13*s23 - 40*s12*s13*s24 - 40*s12*s13*s34 - 24*s12*s23
     +    *s34 - 24*s12*s24*s34 - 24*s12*s34**2 + 16*s13**2*s23 + 16*
     +    s13**2*s24 - 40*s13*s23**2 - 80*s13*s23*s24 - 40*s13*s23*s34
     +     - 40*s13*s24**2 - 40*s13*s24*s34 - 24*s23**2*s34 - 48*s23*
     +    s24*s34 - 24*s23*s34**2 - 24*s24**2*s34 - 24*s24*s34**2 )

      LC = LC + Ld0(p1,p4,p3)*S14**(-1) * ( 128*s12**2 + 136*s12*s13 + 
     +    96*s12*s23 + 152*s12*s24 + 200*s12*s34 + 56*s13**2 - 24*s13*
     +    s23 + 48*s13*s24 + 56*s13*s34 + 40*s23**2 + 88*s23*s24 + 32*
     +    s23*s34 + 72*s24**2 + 88*s24*s34 + 32*s34**2 )

      LC = LC + Ld0(p1,p4,p3)*S23**(-1)*S24**(-1) * ( 8*s12**2*s34 + 16
     +    *s12*s13*s34 + 32*s12*s14*s34 - 8*s12*s34**2 )

      LC = LC + Ld0(p1,p4,p3)*S23**(-1)*S34**(-1) * ( 32*s12**2*s24 + 
     +    64*s12*s13*s24 + 32*s12*s14*s24 + 32*s12*s24**2 + 40*s13**2*
     +    s24 + 40*s13*s14*s24 + 16*s13*s24**2 + 16*s14**2*s24 + 16*
     +    s24**3 )

      LC = LC + Ld0(p1,p4,p3)*S23**(-1) * ( 32*s12*s13 + 32*s12*s14 + 
     +    16*s12*s24 - 48*s12*s34 + 24*s13**2 + 24*s13*s14 + 32*s13*s24
     +     + 8*s13*s34 + 8*s14**2 + 32*s14*s24 + 16*s14*s34 - 8*s24**2
     +     - 24*s24*s34 - 16*s34**2 )

      LC = LC + Ld0(p1,p4,p3)*S24**(-1)*S34**(-1) * (  - 32*s12**2*s23
     +     - 32*s12*s14*s23 - 32*s12*s23**2 + 16*s13**2*s23 + 24*s13*
     +    s14*s23 - 8*s14**2*s23 - 16*s14*s23**2 - 16*s23**3 )

      LC = LC + Ld0(p1,p4,p3)*S24**(-1) * ( 32*s12**2 + 40*s12*s13 - 40
     +    *s12*s14 + 40*s12*s23 + 72*s12*s34 - 24*s13*s14 + 24*s13*s23
     +     + 8*s13*s34 - 32*s14**2 - 16*s14*s34 - 16*s23**2 + 16*s23*
     +    s34 + 16*s34**2 )

      LC = LC + Ld0(p1,p4,p3)*S34**(-1)*S134**(-1) * (  - 16*s12*s13*
     +    s23 - 16*s12*s13*s24 + 16*s12*s14*s23 + 16*s12*s14*s24 - 16*
     +    s13*s23**2 - 32*s13*s23*s24 - 16*s13*s24**2 + 16*s14*s23**2
     +     + 32*s14*s23*s24 + 16*s14*s24**2 )

      LC = LC + Ld0(p1,p4,p3)*S34**(-1) * ( 16*s12*s13 - 48*s12*s14 - 
     +    16*s12*s23 + 48*s12*s24 - 32*s13*s14 - 32*s14**2 + 32*s23*s24
     +     + 32*s24**2 )

      LC = LC + Ld0(p1,p4,p3)*S134**(-1) * (  - 16*s12*s13 + 16*s12*s14
     +     - 76*s12*s23 - 76*s12*s24 - 76*s12*s34 - 16*s13*s23 - 16*s13
     +    *s24 + 16*s14*s23 + 16*s14*s24 - 76*s23**2 - 152*s23*s24 - 76
     +    *s23*s34 - 76*s24**2 - 76*s24*s34 )

      LC = LC + Ld0(p1,p4,p3) * ( 24*s12 - 16*s13 - 8*s14 - 8*s23 - 24*
     +    s24 - 32*s34 )

      LC = LC + Ld0(p1,p4,p23)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s23 - 48*s12**3*s34 + 48*s12**2*s23*s34 - 56*s12**2*
     +    s34**2 + 40*s12*s23*s34**2 - 24*s12*s34**3 )

      LC = LC + Ld0(p1,p4,p23)*S13**(-1)*S14**(-1) * (  - 16*s12**3 + 
     +    16*s12**2*s23 + 16*s12**2*s24 + 8*s12**2*s34 + 8*s12*s23*s24
     +     + 16*s12*s23*s34 + 8*s12*s24**2 - 24*s12*s34**2 )

      LC = LC + Ld0(p1,p4,p23)*S13**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 - 16*s12**2*s14*s34 + 88*s12**2*s34**2 + 24*s12*
     +    s14**2*s34 - 16*s12*s14*s34**2 + 24*s12*s34**3 + 8*s14**3*s34
     +     + 8*s14**2*s34**2 )

      LC = LC + Ld0(p1,p4,p23)*S13**(-1)*S23**(-1) * ( 16*s12**3 + 32*
     +    s12**2*s24 + 96*s12**2*s34 + 24*s12*s14**2 - 16*s12*s14*s24
     +     - 32*s12*s14*s34 + 24*s12*s24**2 + 88*s12*s24*s34 + 88*s12*
     +    s34**2 + 8*s14**3 + 8*s14**2*s24 + 16*s14**2*s34 - 8*s14*
     +    s24**2 - 24*s14*s24*s34 - 16*s14*s34**2 + 8*s24**3 + 32*
     +    s24**2*s34 + 32*s24*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p1,p4,p23)*S13**(-1)*S24**(-1) * (  - 32*s12**3 - 
     +    64*s12**2*s23 - 16*s12*s14**2 - 8*s12*s14*s23 + 80*s12*s14*
     +    s34 - 8*s12*s23**2 - 48*s12*s23*s34 + 16*s12*s34**2 - 8*s14*
     +    s23**2 - 8*s23**3 )

      LC = LC + Ld0(p1,p4,p23)*S13**(-1)*S34**(-1) * (  - 16*s12**2*s14
     +     - 16*s12*s14**2 + 16*s12*s14*s24 - 8*s14**3 - 16*s14**2*s23
     +     + 16*s14*s23**2 + 48*s14*s23*s24 + 24*s14*s24**2 )

      LC = LC + Ld0(p1,p4,p23)*S13**(-1) * ( 32*s12**2 + 104*s12*s14 + 
     +    24*s12*s24 + 80*s12*s34 + 40*s14*s23 + 48*s14*s24 + 16*s14*
     +    s34 - 32*s23**2 - 32*s23*s24 - 32*s23*s34 + 8*s24**2 + 24*s24
     +    *s34 + 8*s34**2 )

      LC = LC + Ld0(p1,p4,p23)*S14**(-1)*S24**(-1)*S34**(-1)*S234**(-1)
     +  * (  - 8*s12**2*s13*s23**2 - 12*s12*s13**2*s23**2 - 8*s12*s13*
     +    s23**3 - 16*s13**3*s23**2 + 4*s13**2*s23**3 )

      LC = LC + Ld0(p1,p4,p23)*S14**(-1)*S24**(-1)*S34**(-1) * ( 8*
     +    s12**2*s13*s23 + 12*s12*s13**2*s23 + 8*s12*s13*s23**2 + 16*
     +    s13**3*s23 - 4*s13**2*s23**2 )

      LC = LC + Ld0(p1,p4,p23)*S14**(-1)*S24**(-1)*S234**(-1) * (  - 12
     +    *s12**2*s13*s23 - 4*s12**2*s13*s34 - 8*s12**2*s23**2 - 12*
     +    s12**2*s23*s34 - 4*s12**2*s34**2 - 32*s12*s13**2*s23 - 20*s12
     +    *s13**2*s34 - 36*s12*s13*s23**2 - 56*s12*s13*s23*s34 - 28*s12
     +    *s13*s34**2 - 8*s12*s23**3 - 24*s12*s23**2*s34 - 24*s12*s23*
     +    s34**2 - 8*s12*s34**3 - 32*s13**3*s23 - 16*s13**3*s34 - 8*
     +    s13**2*s23**2 - 28*s13**2*s23*s34 - 16*s13**2*s34**2 + 4*s13*
     +    s23**3 + 8*s13*s23**2*s34 + 4*s13*s23*s34**2 )

      LC = LC + Ld0(p1,p4,p23)*S14**(-1)*S24**(-1) * (  - 48*s12**3 - 
     +    60*s12**2*s13 + 40*s12**2*s23 - 92*s12**2*s34 - 20*s12*s13**2
     +     + 68*s12*s13*s23 - 68*s12*s13*s34 + 8*s12*s23**2 + 96*s12*
     +    s23*s34 - 72*s12*s34**2 + 8*s13**3 + 28*s13**2*s23 - 8*s13**2
     +    *s34 - 12*s13*s23**2 + 28*s13*s23*s34 - 24*s13*s34**2 - 8*
     +    s23**2*s34 + 16*s23*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p1,p4,p23)*S14**(-1)*S34**(-1)*S234**(-1) * ( 8*
     +    s12**2*s13*s24 - 12*s12*s13**2*s23 - 8*s12*s13*s23**2 + 8*s12
     +    *s13*s23*s24 + 8*s12*s13*s24**2 - 24*s13**3*s23 - 8*s13**3*
     +    s24 + 16*s13**2*s23**2 + 20*s13**2*s23*s24 + 8*s13**2*s24**2
     +     )

      LC = LC + Ld0(p1,p4,p23)*S14**(-1)*S34**(-1) * ( 8*s12**2*s13 + 
     +    16*s12*s13**2 + 16*s12*s13*s23 + 24*s12*s13*s24 + 16*s13**3
     +     - 12*s13**2*s23 + 8*s13**2*s24 + 8*s13*s23**2 + 16*s13*s23*
     +    s24 + 16*s13*s24**2 )

      LC = LC + Ld0(p1,p4,p23)*S14**(-1)*S234**(-1) * ( 4*s12**2*s13 + 
     +    8*s12**2*s24 + 4*s12**2*s34 - 20*s12*s13**2 - 28*s12*s13*s23
     +     + 8*s12*s13*s24 - 28*s12*s13*s34 - 8*s12*s23**2 + 8*s12*s23*
     +    s24 - 16*s12*s23*s34 + 8*s12*s24**2 + 8*s12*s24*s34 - 8*s12*
     +    s34**2 - 24*s13**3 + 8*s13**2*s24 - 16*s13**2*s34 + 16*s13*
     +    s23**2 + 20*s13*s23*s24 + 24*s13*s23*s34 + 8*s13*s24**2 + 16*
     +    s13*s24*s34 + 8*s13*s34**2 )

      LC = LC + Ld0(p1,p4,p23)*S14**(-1) * (  - 56*s12**2 - 40*s12*s13
     +     + 24*s12*s23 - 40*s12*s24 - 88*s12*s34 - 8*s13**2 + 4*s13*
     +    s23 - 8*s13*s24 - 48*s13*s34 + 8*s23**2 + 24*s23*s24 + 16*s23
     +    *s34 + 8*s24**2 - 8*s24*s34 - 24*s34**2 )

      LC = LC + Ld0(p1,p4,p23)*S23**(-1)*S24**(-1) * ( 40*s12**2*s34 + 
     +    24*s12*s13*s34 + 24*s12*s14*s34 + 40*s12*s34**2 + 8*s13**2*
     +    s34 + 24*s13*s14*s34 + 8*s13*s34**2 + 24*s14**2*s34 + 16*s14*
     +    s34**2 )

      LC = LC + Ld0(p1,p4,p23)*S23**(-1)*S34**(-1) * ( 16*s12**2*s24 + 
     +    32*s12*s13*s24 + 16*s12*s14*s24 + 16*s12*s24**2 + 16*s13**2*
     +    s24 + 16*s13*s14*s24 + 16*s13*s24**2 + 8*s14**2*s24 + 8*
     +    s24**3 )

      LC = LC + Ld0(p1,p4,p23)*S23**(-1)*S234**(-1) * ( 4*s12*s13*s24
     +     + 4*s12*s13*s34 + 4*s12*s14*s24 + 4*s12*s14*s34 + 4*s12*s24*
     +    s34 + 4*s12*s34**2 + 4*s13**2*s24 + 4*s13**2*s34 + 4*s13*s14*
     +    s24 + 4*s13*s14*s34 + 4*s13*s24**2 + 12*s13*s24*s34 + 8*s13*
     +    s34**2 + 4*s14*s24**2 + 8*s14*s24*s34 + 4*s14*s34**2 + 4*
     +    s24**2*s34 + 8*s24*s34**2 + 4*s34**3 )

      LC = LC + Ld0(p1,p4,p23)*S23**(-1) * ( 48*s12**2 + 44*s12*s13 + 
     +    28*s12*s14 + 96*s12*s24 + 108*s12*s34 + 12*s13**2 + 12*s13*
     +    s14 + 60*s13*s24 + 40*s13*s34 + 16*s14**2 + 12*s14*s24 + 12*
     +    s14*s34 + 48*s24**2 + 76*s24*s34 + 36*s34**2 )

      LC = LC + Ld0(p1,p4,p23)*S24**(-1)*S34**(-1)*S234**(-1) * (  - 8*
     +    s12**2*s23**2 - 40*s12*s13*s23**2 - 28*s12*s14*s23**2 - 8*s12
     +    *s23**3 - 36*s13**2*s23**2 - 40*s13*s14*s23**2 - 8*s13*s23**3
     +     - 20*s14**2*s23**2 - 12*s14*s23**3 )

      LC = LC + Ld0(p1,p4,p23)*S24**(-1)*S34**(-1) * (  - 8*s12**2*s23
     +     - 8*s12*s13*s23 - 36*s12*s14*s23 - 8*s12*s23**2 - 4*s13**2*
     +    s23 - 40*s13*s14*s23 + 8*s13*s23**2 - 28*s14**2*s23 - 4*s14*
     +    s23**2 - 8*s23**3 )

      LC = LC + Ld0(p1,p4,p23)*S24**(-1)*S234**(-1) * (  - 12*s12**2*
     +    s23 - 4*s12**2*s34 - 64*s12*s13*s23 - 56*s12*s13*s34 - 32*s12
     +    *s14*s23 - 36*s12*s14*s34 - 52*s12*s23**2 - 56*s12*s23*s34 - 
     +    44*s12*s34**2 - 48*s13**2*s23 - 44*s13**2*s34 - 20*s13*s14*
     +    s23 - 44*s13*s14*s34 - 20*s13*s23**2 - 8*s13*s23*s34 - 28*s13
     +    *s34**2 - 4*s14**2*s23 - 16*s14**2*s34 - 28*s14*s23**2 - 16*
     +    s14*s34**2 - 12*s23**3 - 8*s23**2*s34 + 4*s23*s34**2 )

      LC = LC + Ld0(p1,p4,p23)*S24**(-1) * (  - 92*s12**2 - 8*s12*s13
     +     + 4*s12*s14 - 28*s12*s23 - 4*s12*s34 + 28*s13**2 + 28*s13*
     +    s14 - 28*s13*s23 - 12*s13*s34 - 40*s14*s23 - 8*s14*s34 + 4*
     +    s23**2 - 4*s23*s34 - 24*s34**2 )

      LC = LC + Ld0(p1,p4,p23)*S34**(-1)*S234**(-1) * ( 8*s12**2*s24 - 
     +    24*s12*s13*s24 + 12*s12*s14*s23 - 24*s12*s14*s24 - 8*s12*
     +    s23**2 + 8*s12*s23*s24 + 8*s12*s24**2 - 8*s13**2*s23 - 36*
     +    s13**2*s24 + 56*s13*s14*s23 - 32*s13*s14*s24 + 16*s13*s23**2
     +     + 24*s13*s23*s24 + 40*s14**2*s23 - 4*s14**2*s24 + 4*s14*s23*
     +    s24 - 8*s14*s24**2 )

      LC = LC + Ld0(p1,p4,p23)*S34**(-1) * (  - 8*s12**2 + 24*s12*s13
     +     - 8*s12*s14 - 32*s12*s23 - 8*s12*s24 + 20*s13**2 - 24*s13*
     +    s23 - 12*s14**2 - 12*s14*s23 + 8*s14*s24 - 16*s23**2 - 32*s23
     +    *s24 - 16*s24**2 )

      LC = LC + Ld0(p1,p4,p23)*S234**(-1) * ( 4*s12**2 - 44*s12*s13 - 
     +    24*s12*s14 - 4*s12*s23 - 16*s12*s24 - 32*s12*s34 - 44*s13**2
     +     - 8*s13*s14 + 68*s13*s23 - 4*s13*s24 + 4*s13*s34 + 12*s14**2
     +     + 68*s14*s23 + 4*s14*s24 + 28*s14*s34 + 4*s23*s24 + 28*s23*
     +    s34 - 8*s24**2 + 8*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p1,p4,p23) * ( 32*s12 + 16*s14 - 20*s23 - 8*s24 + 4
     +    *s34 )

      LC = LC + Ld0(p1,p23,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 16*s12**3*s34**2 )

      LC = LC + Ld0(p1,p23,p4)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16*
     +    s12**3*s34 )

      LC = LC + Ld0(p1,p23,p4)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 - 16*s12**2*s23**2 - 16*s12**2*s23*s34 - 32*s12**2
     +    *s34**2 - 32*s12*s23**2*s34 - 8*s12*s23*s34**2 )

      LC = LC + Ld0(p1,p23,p4)*S13**(-1)*S14**(-1) * ( 8*s12**2*s23 - 
     +    40*s12**2*s34 - 8*s12*s23**2 - 8*s12*s23*s24 - 24*s12*s23*s34
     +     )

      LC = LC + Ld0(p1,p23,p4)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 - 16*s12**2*s14*s34 - 16*s12**2*s34**2 - 8*s12*
     +    s14**2*s34 - 8*s12*s14*s34**2 )

      LC = LC + Ld0(p1,p23,p4)*S13**(-1)*S23**(-1) * (  - 16*s12**3 - 
     +    16*s12**2*s14 - 16*s12**2*s34 - 8*s12*s14**2 - 8*s12*s14*s34
     +     )

      LC = LC + Ld0(p1,p23,p4)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s14*s23 - 16*s12*s14**2*s23 - 8*s14**3*s23 )

      LC = LC + Ld0(p1,p23,p4)*S13**(-1)*S24**(-1) * (  - 16*s12**3 - 
     +    32*s12**2*s14 - 48*s12**2*s23 - 64*s12**2*s34 - 24*s12*s14**2
     +     - 16*s12*s14*s23 - 24*s12*s14*s34 + 8*s12*s23**2 - 32*s12*
     +    s23*s34 - 8*s14**3 - 8*s14**2*s23 - 8*s14**2*s34 )

      LC = LC + Ld0(p1,p23,p4)*S13**(-1)*S34**(-1) * (  - 16*s12**2*s14
     +     - 16*s12*s14**2 - 8*s14**3 )

      LC = LC + Ld0(p1,p23,p4)*S13**(-1) * (  - 48*s12**2 - 16*s12*s14
     +     - 16*s12*s23 - 8*s14**2 )

      LC = LC + Ld0(p1,p23,p4)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 - 16*s12**2*s13*s34 - 16*s12**2*s34**2 - 8*s12*
     +    s13**2*s34 - 8*s12*s13*s34**2 )

      LC = LC + Ld0(p1,p23,p4)*S14**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2*s13*s24 + 16*s12*s13**2*s24 + 8*s13**3*s24 )

      LC = LC + Ld0(p1,p23,p4)*S14**(-1)*S23**(-1) * (  - 16*s12**3 + 
     +    16*s12**2*s24 + 8*s12*s13**2 + 16*s12*s13*s24 + 8*s12*s13*s34
     +     + 8*s13**3 + 8*s13**2*s24 + 8*s13**2*s34 )

      LC = LC + Ld0(p1,p23,p4)*S14**(-1)*S24**(-1) * (  - 16*s12**3 - 
     +    16*s12**2*s13 - 32*s12**2*s23 - 48*s12**2*s34 - 8*s12*s13**2
     +     - 8*s12*s13*s34 - 16*s12*s23**2 - 32*s12*s23*s34 + 8*s13*
     +    s23**2 - 16*s13*s23*s34 - 8*s23**2*s34 )

      LC = LC + Ld0(p1,p23,p4)*S14**(-1)*S34**(-1) * ( 16*s12**2*s13 + 
     +    16*s12*s13**2 + 8*s13**3 )

      LC = LC + Ld0(p1,p23,p4)*S14**(-1) * (  - 16*s12**2 + 16*s12*s13
     +     - 8*s12*s23 + 8*s12*s24 - 8*s12*s34 + 8*s13**2 + 16*s13*s23
     +     + 8*s13*s24 + 8*s23**2 + 8*s23*s24 )

      LC = LC + Ld0(p1,p23,p4)*S23**(-1)*S24**(-1) * (  - 32*s12**2*s34
     +     - 24*s12*s13*s34 - 24*s12*s14*s34 - 16*s12*s34**2 )

      LC = LC + Ld0(p1,p23,p4)*S23**(-1)*S34**(-1) * ( 16*s12**2*s24 + 
     +    32*s12*s13*s24 + 16*s12*s14*s24 + 24*s13**2*s24 + 24*s13*s14*
     +    s24 + 8*s14**2*s24 )

      LC = LC + Ld0(p1,p23,p4)*S23**(-1) * (  - 16*s12**2 + 8*s12*s13
     +     - 8*s12*s14 + 16*s12*s24 + 24*s13**2 + 24*s13*s14 + 16*s13*
     +    s24 + 16*s13*s34 + 8*s14**2 + 8*s14*s24 + 8*s14*s34 )

      LC = LC + Ld0(p1,p23,p4)*S24**(-1)*S34**(-1) * (  - 16*s12**2*s23
     +     - 16*s12*s13*s23 - 32*s12*s14*s23 - 8*s13**2*s23 - 24*s13*
     +    s14*s23 - 24*s14**2*s23 )

      LC = LC + Ld0(p1,p23,p4)*S24**(-1) * (  - 48*s12**2 - 40*s12*s13
     +     - 56*s12*s14 - 16*s12*s23 - 32*s12*s34 - 8*s13**2 - 24*s13*
     +    s14 - 8*s13*s23 - 8*s13*s34 - 24*s14**2 - 16*s14*s23 - 16*s14
     +    *s34 + 16*s23**2 - 8*s23*s34 )

      LC = LC + Ld0(p1,p23,p4)*S34**(-1) * ( 16*s12*s13 - 16*s12*s14 + 
     +    16*s13**2 - 16*s14**2 )

      LC = LC + Ld0(p1,p23,p4) * ( 8*s13 - 8*s14 + 8*s23 )

      LC = LC + Ld0(p1,p24,p3)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 16*s12**3*s34**2 )

      LC = LC + Ld0(p1,p24,p3)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16*
     +    s12**3*s34 - 16*s12**2*s24**2 - 16*s12**2*s24*s34 - 32*s12**2
     +    *s34**2 - 32*s12*s24**2*s34 - 8*s12*s24*s34**2 )

      LC = LC + Ld0(p1,p24,p3)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 )

      LC = LC + Ld0(p1,p24,p3)*S13**(-1)*S14**(-1) * ( 8*s12**2*s24 - 
     +    40*s12**2*s34 - 8*s12*s23*s24 - 8*s12*s24**2 - 24*s12*s24*s34
     +     )

      LC = LC + Ld0(p1,p24,p3)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 - 16*s12**2*s14*s34 - 16*s12**2*s34**2 - 8*s12*
     +    s14**2*s34 - 8*s12*s14*s34**2 )

      LC = LC + Ld0(p1,p24,p3)*S13**(-1)*S23**(-1) * (  - 16*s12**3 - 
     +    16*s12**2*s14 - 32*s12**2*s24 - 48*s12**2*s34 - 8*s12*s14**2
     +     - 8*s12*s14*s34 - 16*s12*s24**2 - 32*s12*s24*s34 + 8*s14*
     +    s24**2 - 16*s14*s24*s34 - 8*s24**2*s34 )

      LC = LC + Ld0(p1,p24,p3)*S13**(-1)*S24**(-1)*S34**(-1) * ( 16*
     +    s12**2*s14*s23 + 16*s12*s14**2*s23 + 8*s14**3*s23 )

      LC = LC + Ld0(p1,p24,p3)*S13**(-1)*S24**(-1) * (  - 16*s12**3 + 
     +    16*s12**2*s23 + 8*s12*s14**2 + 16*s12*s14*s23 + 8*s12*s14*s34
     +     + 8*s14**3 + 8*s14**2*s23 + 8*s14**2*s34 )

      LC = LC + Ld0(p1,p24,p3)*S13**(-1)*S34**(-1) * ( 16*s12**2*s14 + 
     +    16*s12*s14**2 + 8*s14**3 )

      LC = LC + Ld0(p1,p24,p3)*S13**(-1) * (  - 16*s12**2 + 16*s12*s14
     +     + 8*s12*s23 - 8*s12*s24 - 8*s12*s34 + 8*s14**2 + 8*s14*s23
     +     + 16*s14*s24 + 8*s23*s24 + 8*s24**2 )

      LC = LC + Ld0(p1,p24,p3)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 - 16*s12**2*s13*s34 - 16*s12**2*s34**2 - 8*s12*
     +    s13**2*s34 - 8*s12*s13*s34**2 )

      LC = LC + Ld0(p1,p24,p3)*S14**(-1)*S23**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s13*s24 - 16*s12*s13**2*s24 - 8*s13**3*s24 )

      LC = LC + Ld0(p1,p24,p3)*S14**(-1)*S23**(-1) * (  - 16*s12**3 - 
     +    32*s12**2*s13 - 48*s12**2*s24 - 64*s12**2*s34 - 24*s12*s13**2
     +     - 16*s12*s13*s24 - 24*s12*s13*s34 + 8*s12*s24**2 - 32*s12*
     +    s24*s34 - 8*s13**3 - 8*s13**2*s24 - 8*s13**2*s34 )

      LC = LC + Ld0(p1,p24,p3)*S14**(-1)*S24**(-1) * (  - 16*s12**3 - 
     +    16*s12**2*s13 - 16*s12**2*s34 - 8*s12*s13**2 - 8*s12*s13*s34
     +     )

      LC = LC + Ld0(p1,p24,p3)*S14**(-1)*S34**(-1) * (  - 16*s12**2*s13
     +     - 16*s12*s13**2 - 8*s13**3 )

      LC = LC + Ld0(p1,p24,p3)*S14**(-1) * (  - 48*s12**2 - 16*s12*s13
     +     - 16*s12*s24 - 8*s13**2 )

      LC = LC + Ld0(p1,p24,p3)*S23**(-1)*S24**(-1) * (  - 32*s12**2*s34
     +     - 24*s12*s13*s34 - 24*s12*s14*s34 - 16*s12*s34**2 )

      LC = LC + Ld0(p1,p24,p3)*S23**(-1)*S34**(-1) * (  - 16*s12**2*s24
     +     - 32*s12*s13*s24 - 16*s12*s14*s24 - 24*s13**2*s24 - 24*s13*
     +    s14*s24 - 8*s14**2*s24 )

      LC = LC + Ld0(p1,p24,p3)*S23**(-1) * (  - 48*s12**2 - 56*s12*s13
     +     - 40*s12*s14 - 16*s12*s24 - 32*s12*s34 - 24*s13**2 - 24*s13*
     +    s14 - 16*s13*s24 - 16*s13*s34 - 8*s14**2 - 8*s14*s24 - 8*s14*
     +    s34 + 16*s24**2 - 8*s24*s34 )

      LC = LC + Ld0(p1,p24,p3)*S24**(-1)*S34**(-1) * ( 16*s12**2*s23 + 
     +    16*s12*s13*s23 + 32*s12*s14*s23 + 8*s13**2*s23 + 24*s13*s14*
     +    s23 + 24*s14**2*s23 )

      LC = LC + Ld0(p1,p24,p3)*S24**(-1) * (  - 16*s12**2 - 8*s12*s13
     +     + 8*s12*s14 + 16*s12*s23 + 8*s13**2 + 24*s13*s14 + 8*s13*s23
     +     + 8*s13*s34 + 24*s14**2 + 16*s14*s23 + 16*s14*s34 )

      LC = LC + Ld0(p1,p24,p3)*S34**(-1) * (  - 16*s12*s13 + 16*s12*s14
     +     - 16*s13**2 + 16*s14**2 )

      LC = LC + Ld0(p1,p24,p3) * (  - 8*s13 + 8*s14 + 8*s24 )

      LC = LC + Ld0(p1,p34,p2)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 32*s12**3*s34**2 )

      LC = LC + Ld0(p1,p34,p2)*S13**(-1)*S14**(-1)*S23**(-1) * ( 32*
     +    s12**3*s34 + 32*s12**2*s24*s34 + 32*s12**2*s34**2 + 16*s12*
     +    s24**2*s34 + 16*s12*s24*s34**2 )

      LC = LC + Ld0(p1,p34,p2)*S13**(-1)*S14**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 + 32*s12**2*s23*s34 + 32*s12**2*s34**2 + 16*s12*
     +    s23**2*s34 + 16*s12*s23*s34**2 )

      LC = LC + Ld0(p1,p34,p2)*S13**(-1)*S14**(-1) * ( 64*s12**2*s34 + 
     +    48*s12*s23*s34 + 48*s12*s24*s34 + 32*s12*s34**2 )

      LC = LC + Ld0(p1,p34,p2)*S13**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 + 32*s12**2*s14*s34 + 32*s12**2*s34**2 + 16*s12*
     +    s14**2*s34 + 16*s12*s14*s34**2 )

      LC = LC + Ld0(p1,p34,p2)*S13**(-1)*S23**(-1) * ( 32*s12**3 + 32*
     +    s12**2*s14 + 32*s12**2*s24 + 64*s12**2*s34 + 16*s12*s14**2 + 
     +    16*s12*s14*s34 + 16*s12*s24**2 + 16*s12*s24*s34 )

      LC = LC + Ld0(p1,p34,p2)*S13**(-1)*S24**(-1) * ( 32*s12**3 + 32*
     +    s12**2*s14 + 32*s12**2*s23 + 64*s12**2*s34 + 16*s12*s14**2 + 
     +    16*s12*s14*s34 + 16*s12*s23**2 + 16*s12*s23*s34 )

      LC = LC + Ld0(p1,p34,p2)*S13**(-1) * ( 64*s12**2 + 48*s12*s23 + 
     +    48*s12*s24 + 32*s12*s34 )

      LC = LC + Ld0(p1,p34,p2)*S14**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 + 32*s12**2*s13*s34 + 32*s12**2*s34**2 + 16*s12*
     +    s13**2*s34 + 16*s12*s13*s34**2 )

      LC = LC + Ld0(p1,p34,p2)*S14**(-1)*S23**(-1) * ( 32*s12**3 + 32*
     +    s12**2*s13 + 32*s12**2*s24 + 64*s12**2*s34 + 16*s12*s13**2 + 
     +    16*s12*s13*s34 + 16*s12*s24**2 + 16*s12*s24*s34 )

      LC = LC + Ld0(p1,p34,p2)*S14**(-1)*S24**(-1) * ( 32*s12**3 + 32*
     +    s12**2*s13 + 32*s12**2*s23 + 64*s12**2*s34 + 16*s12*s13**2 + 
     +    16*s12*s13*s34 + 16*s12*s23**2 + 16*s12*s23*s34 )

      LC = LC + Ld0(p1,p34,p2)*S14**(-1) * ( 64*s12**2 + 48*s12*s23 + 
     +    48*s12*s24 + 32*s12*s34 )

      LC = LC + Ld0(p1,p34,p2)*S23**(-1)*S24**(-1) * ( 64*s12**2*s34 + 
     +    48*s12*s13*s34 + 48*s12*s14*s34 + 32*s12*s34**2 )

      LC = LC + Ld0(p1,p34,p2)*S23**(-1) * ( 64*s12**2 + 48*s12*s13 + 
     +    48*s12*s14 + 32*s12*s34 )

      LC = LC + Ld0(p1,p34,p2)*S24**(-1) * ( 64*s12**2 + 48*s12*s13 + 
     +    48*s12*s14 + 32*s12*s34 )

      LC = LC + Ld0(p2,p1,p3)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LC = LC + Ld0(p2,p1,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s24*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LC = LC + Ld0(p2,p1,p3)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s23*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LC = LC + Ld0(p2,p1,p3)*S13**(-1)*S14**(-1) * ( 16*s12**2*s23 + 
     +    16*s12**2*s24 + 48*s12**2*s34 + 16*s12*s23**2 + 16*s12*s23*
     +    s24 + 48*s12*s23*s34 + 32*s12*s24*s34 + 24*s12*s34**2 + 8*
     +    s23**3 + 8*s23**2*s24 + 16*s23**2*s34 + 16*s23*s24*s34 + 8*
     +    s23*s34**2 + 8*s24**2*s34 + 8*s24*s34**2 )

      LC = LC + Ld0(p2,p1,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 40*s12**2*s14*s34 + 40*s12**2*s34**2 + 8*s12*
     +    s14**2*s34 + 8*s12*s14*s34**2 )

      LC = LC + Ld0(p2,p1,p3)*S13**(-1)*S23**(-1) * ( 32*s12**3 + 56*
     +    s12**2*s14 + 56*s12**2*s24 + 96*s12**2*s34 + 16*s12*s14**2 + 
     +    24*s12*s14*s34 + 16*s12*s24**2 + 24*s12*s24*s34 + 16*s12*
     +    s34**2 )

      LC = LC + Ld0(p2,p1,p3)*S13**(-1)*S24**(-1)*S34**(-1) * ( 16*
     +    s12**2*s14*s23 + 16*s12*s14*s23**2 + 8*s14*s23**3 )

      LC = LC + Ld0(p2,p1,p3)*S13**(-1)*S24**(-1) * ( 32*s12**3 + 80*
     +    s12**2*s14 + 64*s12**2*s23 + 96*s12**2*s34 + 32*s12*s14**2 + 
     +    64*s12*s14*s23 + 56*s12*s14*s34 + 48*s12*s23**2 + 72*s12*s23*
     +    s34 + 24*s12*s34**2 + 8*s14**3 + 24*s14**2*s23 + 24*s14**2*
     +    s34 + 32*s14*s23**2 + 48*s14*s23*s34 + 24*s14*s34**2 + 16*
     +    s23**3 + 32*s23**2*s34 + 24*s23*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p2,p1,p3)*S13**(-1)*S34**(-1) * ( 16*s12**2*s14 + 
     +    32*s12*s14*s23 + 16*s12*s14*s24 + 24*s14*s23**2 + 24*s14*s23*
     +    s24 + 8*s14*s24**2 )

      LC = LC + Ld0(p2,p1,p3)*S13**(-1) * ( 112*s12**2 + 48*s12*s14 + 
     +    80*s12*s23 + 48*s12*s24 + 72*s12*s34 + 8*s14**2 + 16*s14*s23
     +     - 8*s14*s24 + 24*s23**2 + 8*s23*s24 + 16*s23*s34 - 8*s24*s34
     +     )

      LC = LC + Ld0(p2,p1,p3)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 )

      LC = LC + Ld0(p2,p1,p3)*S14**(-1)*S23**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s13*s24 - 16*s12*s13*s24**2 - 8*s13*s24**3 )

      LC = LC + Ld0(p2,p1,p3)*S14**(-1)*S23**(-1) * ( 40*s12**3 + 8*
     +    s12**2*s13 + 64*s12**2*s24 + 32*s12**2*s34 + 16*s12*s13*s24
     +     + 16*s12*s13*s34 + 16*s12*s24**2 + 24*s12*s24*s34 + 8*s12*
     +    s34**2 + 8*s13**2*s24 + 16*s13*s24**2 + 32*s13*s24*s34 + 8*
     +    s13*s34**2 + 16*s24**2*s34 + 16*s24*s34**2 )

      LC = LC + Ld0(p2,p1,p3)*S14**(-1)*S24**(-1) * ( 32*s12**3 + 48*
     +    s12**2*s23 + 16*s12**2*s34 + 32*s12*s23**2 + 8*s12*s23*s34 + 
     +    8*s23**3 )

      LC = LC + Ld0(p2,p1,p3)*S14**(-1)*S34**(-1) * (  - 16*s12**2*s13
     +     - 16*s12*s13*s23 - 32*s12*s13*s24 - 8*s13*s23**2 - 24*s13*
     +    s23*s24 - 24*s13*s24**2 )

      LC = LC + Ld0(p2,p1,p3)*S14**(-1) * ( 88*s12**2 + 8*s12*s13 + 56*
     +    s12*s23 + 40*s12*s24 + 16*s12*s34 - 8*s13*s23 + 8*s13*s34 - 
     +    16*s23*s24 - 8*s24**2 + 24*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p2,p1,p3)*S23**(-1)*S24**(-1) * (  - 16*s12**2*s13
     +     - 16*s12**2*s14 + 24*s12**2*s34 - 16*s12*s13*s14 - 16*s12*
     +    s14**2 - 8*s12*s14*s34 - 8*s13*s14**2 - 8*s14**3 - 8*s14**2*
     +    s34 )

      LC = LC + Ld0(p2,p1,p3)*S23**(-1)*S34**(-1) * (  - 16*s12**2*s24
     +     - 16*s12*s24**2 - 8*s24**3 )

      LC = LC + Ld0(p2,p1,p3)*S23**(-1) * ( 64*s12**2 + 8*s12*s13 + 24*
     +    s12*s14 + 8*s12*s24 + 32*s12*s34 + 8*s13*s14 - 8*s13*s24 - 8*
     +    s13*s34 + 8*s14**2 - 16*s14*s24 - 8*s24**2 - 8*s24*s34 )

      LC = LC + Ld0(p2,p1,p3)*S24**(-1)*S34**(-1) * ( 16*s12**2*s23 + 
     +    16*s12*s23**2 + 8*s23**3 )

      LC = LC + Ld0(p2,p1,p3)*S24**(-1) * ( 80*s12**2 + 32*s12*s14 + 64
     +    *s12*s23 + 24*s12*s34 + 8*s13*s23 + 8*s13*s34 + 8*s14**2 + 32
     +    *s14*s23 + 24*s14*s34 + 32*s23**2 + 32*s23*s34 + 16*s34**2 )

      LC = LC + Ld0(p2,p1,p3)*S34**(-1) * ( 16*s12*s23 - 16*s12*s24 + 
     +    16*s23**2 - 16*s24**2 )

      LC = LC + Ld0(p2,p1,p3) * ( 56*s12 - 8*s13 - 32*s24 - 16*s34 )

      LC = LC + Ld0(p2,p1,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LC = LC + Ld0(p2,p1,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s24*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LC = LC + Ld0(p2,p1,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s23*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LC = LC + Ld0(p2,p1,p4)*S13**(-1)*S14**(-1) * ( 16*s12**2*s23 + 
     +    16*s12**2*s24 + 48*s12**2*s34 + 16*s12*s23*s24 + 32*s12*s23*
     +    s34 + 16*s12*s24**2 + 48*s12*s24*s34 + 24*s12*s34**2 + 8*
     +    s23**2*s34 + 8*s23*s24**2 + 16*s23*s24*s34 + 8*s23*s34**2 + 8
     +    *s24**3 + 16*s24**2*s34 + 8*s24*s34**2 )

      LC = LC + Ld0(p2,p1,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 )

      LC = LC + Ld0(p2,p1,p4)*S13**(-1)*S23**(-1) * ( 32*s12**3 + 48*
     +    s12**2*s24 + 16*s12**2*s34 + 32*s12*s24**2 + 8*s12*s24*s34 + 
     +    8*s24**3 )

      LC = LC + Ld0(p2,p1,p4)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s14*s23 - 16*s12*s14*s23**2 - 8*s14*s23**3 )

      LC = LC + Ld0(p2,p1,p4)*S13**(-1)*S24**(-1) * ( 40*s12**3 + 8*
     +    s12**2*s14 + 64*s12**2*s23 + 32*s12**2*s34 + 16*s12*s14*s23
     +     + 16*s12*s14*s34 + 16*s12*s23**2 + 24*s12*s23*s34 + 8*s12*
     +    s34**2 + 8*s14**2*s23 + 16*s14*s23**2 + 32*s14*s23*s34 + 8*
     +    s14*s34**2 + 16*s23**2*s34 + 16*s23*s34**2 )

      LC = LC + Ld0(p2,p1,p4)*S13**(-1)*S34**(-1) * (  - 16*s12**2*s14
     +     - 32*s12*s14*s23 - 16*s12*s14*s24 - 24*s14*s23**2 - 24*s14*
     +    s23*s24 - 8*s14*s24**2 )

      LC = LC + Ld0(p2,p1,p4)*S13**(-1) * ( 88*s12**2 + 8*s12*s14 + 40*
     +    s12*s23 + 56*s12*s24 + 16*s12*s34 - 8*s14*s24 + 8*s14*s34 - 8
     +    *s23**2 - 16*s23*s24 + 24*s23*s34 + 16*s34**2 )

      LC = LC + Ld0(p2,p1,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 40*s12**2*s13*s34 + 40*s12**2*s34**2 + 8*s12*
     +    s13**2*s34 + 8*s12*s13*s34**2 )

      LC = LC + Ld0(p2,p1,p4)*S14**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2*s13*s24 + 16*s12*s13*s24**2 + 8*s13*s24**3 )

      LC = LC + Ld0(p2,p1,p4)*S14**(-1)*S23**(-1) * ( 32*s12**3 + 80*
     +    s12**2*s13 + 64*s12**2*s24 + 96*s12**2*s34 + 32*s12*s13**2 + 
     +    64*s12*s13*s24 + 56*s12*s13*s34 + 48*s12*s24**2 + 72*s12*s24*
     +    s34 + 24*s12*s34**2 + 8*s13**3 + 24*s13**2*s24 + 24*s13**2*
     +    s34 + 32*s13*s24**2 + 48*s13*s24*s34 + 24*s13*s34**2 + 16*
     +    s24**3 + 32*s24**2*s34 + 24*s24*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p2,p1,p4)*S14**(-1)*S24**(-1) * ( 32*s12**3 + 56*
     +    s12**2*s13 + 56*s12**2*s23 + 96*s12**2*s34 + 16*s12*s13**2 + 
     +    24*s12*s13*s34 + 16*s12*s23**2 + 24*s12*s23*s34 + 16*s12*
     +    s34**2 )

      LC = LC + Ld0(p2,p1,p4)*S14**(-1)*S34**(-1) * ( 16*s12**2*s13 + 
     +    16*s12*s13*s23 + 32*s12*s13*s24 + 8*s13*s23**2 + 24*s13*s23*
     +    s24 + 24*s13*s24**2 )

      LC = LC + Ld0(p2,p1,p4)*S14**(-1) * ( 112*s12**2 + 48*s12*s13 + 
     +    48*s12*s23 + 80*s12*s24 + 72*s12*s34 + 8*s13**2 - 8*s13*s23
     +     + 16*s13*s24 + 8*s23*s24 - 8*s23*s34 + 24*s24**2 + 16*s24*
     +    s34 )

      LC = LC + Ld0(p2,p1,p4)*S23**(-1)*S24**(-1) * (  - 16*s12**2*s13
     +     - 16*s12**2*s14 + 24*s12**2*s34 - 16*s12*s13**2 - 16*s12*s13
     +    *s14 - 8*s12*s13*s34 - 8*s13**3 - 8*s13**2*s14 - 8*s13**2*s34
     +     )

      LC = LC + Ld0(p2,p1,p4)*S23**(-1)*S34**(-1) * ( 16*s12**2*s24 + 
     +    16*s12*s24**2 + 8*s24**3 )

      LC = LC + Ld0(p2,p1,p4)*S23**(-1) * ( 80*s12**2 + 32*s12*s13 + 64
     +    *s12*s24 + 24*s12*s34 + 8*s13**2 + 32*s13*s24 + 24*s13*s34 + 
     +    8*s14*s24 + 8*s14*s34 + 32*s24**2 + 32*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p2,p1,p4)*S24**(-1)*S34**(-1) * (  - 16*s12**2*s23
     +     - 16*s12*s23**2 - 8*s23**3 )

      LC = LC + Ld0(p2,p1,p4)*S24**(-1) * ( 64*s12**2 + 24*s12*s13 + 8*
     +    s12*s14 + 8*s12*s23 + 32*s12*s34 + 8*s13**2 + 8*s13*s14 - 16*
     +    s13*s23 - 8*s14*s23 - 8*s14*s34 - 8*s23**2 - 8*s23*s34 )

      LC = LC + Ld0(p2,p1,p4)*S34**(-1) * (  - 16*s12*s23 + 16*s12*s24
     +     - 16*s23**2 + 16*s24**2 )

      LC = LC + Ld0(p2,p1,p4) * ( 56*s12 - 8*s14 - 32*s23 - 16*s34 )

      LC = LC + Ld0(p2,p1,p34)*S13**(-1)*S14**(-1)*S234 * (  - 16*s12*
     +    s34 - 16*s23*s34 - 16*s24*s34 )

      LC = LC + Ld0(p2,p1,p34)*S13**(-1)*S23**(-1)*S24**(-1)*S234 * ( 
     +     - 8*s12**3 - 8*s12**2*s14 + 8*s12**2*s34 - 16*s12*s14*s34 + 
     +    8*s12*s34**2 + 8*s14*s34**2 )

      LC = LC + Ld0(p2,p1,p34)*S13**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**3*s34 + 8*s12**2*s14*s34 - 8*s12**2*s34**2 + 16*s12*s14*
     +    s34**2 - 8*s12*s34**3 - 8*s14*s34**3 )

      LC = LC + Ld0(p2,p1,p34)*S13**(-1)*S23**(-1)*S234 * ( 8*s12**2 - 
     +    8*s12*s14 - 8*s12*s24 + 48*s12*s34 + 8*s14*s24 + 16*s14*s34
     +     - 8*s24**2 + 8*s24*s34 )

      LC = LC + Ld0(p2,p1,p34)*S13**(-1)*S23**(-1) * ( 8*s12**3 - 32*
     +    s12**2*s24 - 8*s12**2*s34 + 16*s12*s14*s24 + 32*s12*s14*s34
     +     - 8*s12*s24*s34 - 40*s12*s34**2 - 8*s14*s24**2 - 24*s14*s24*
     +    s34 - 24*s14*s34**2 - 8*s24*s34**2 )

      LC = LC + Ld0(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * (  - 16*
     +    s12**2 + 8*s12*s14 + 24*s12*s23 - 8*s12*s34 + 16*s14**2 + 24*
     +    s14*s23 + 16*s14*s34 + 8*s23**2 + 16*s23*s34 + 16*s34**2 )

      LC = LC + Ld0(p2,p1,p34)*S13**(-1)*S234*S134**(-1) * ( 32*s12*s34
     +     - 16*s14*s23 + 16*s14*s34 + 16*s23*s34 + 32*s24*s34 + 16*
     +    s34**2 )

      LC = LC + Ld0(p2,p1,p34)*S13**(-1)*S234 * (  - 40*s12 - 24*s14 - 
     +    16*s23 - 32*s24 - 32*s34 )

      LC = LC + Ld0(p2,p1,p34)*S14**(-1)*S23**(-1)*S24**(-1)*S234 * ( 
     +     - 8*s12**2*s13 + 32*s12**2*s34 - 24*s12*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p2,p1,p34)*S14**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**2*s13*s34 - 32*s12**2*s34**2 + 24*s12*s34**3 - 8*s34**4
     +     )

      LC = LC + Ld0(p2,p1,p34)*S14**(-1)*S23**(-1)*S234 * ( 16*s12**2
     +     - 8*s12*s13 + 24*s12*s24 + 16*s13**2 + 16*s13*s24 + 24*s13*
     +    s34 + 8*s24**2 + 16*s24*s34 + 24*s34**2 )

      LC = LC + Ld0(p2,p1,p34)*S14**(-1)*S23**(-1) * (  - 8*s12**3 - 32
     +    *s12**2*s24 - 56*s12**2*s34 + 16*s12*s13*s24 - 8*s12*s24*s34
     +     + 24*s12*s34**2 + 8*s13*s24**2 - 8*s24*s34**2 - 16*s34**3 )

      LC = LC + Ld0(p2,p1,p34)*S14**(-1)*S24**(-1)*S234 * (  - 24*
     +    s12**2 + 8*s12*s13 - 8*s12*s23 + 40*s12*s34 - 8*s23**2 + 8*
     +    s23*s34 - 8*s34**2 )

      LC = LC + Ld0(p2,p1,p34)*S14**(-1)*S234*S134**(-1) * ( 32*s12*s34
     +     - 16*s13*s24 + 16*s13*s34 + 32*s23*s34 + 16*s24*s34 + 16*
     +    s34**2 )

      LC = LC + Ld0(p2,p1,p34)*S14**(-1)*S234 * (  - 40*s12 - 16*s13 - 
     +    32*s23 - 16*s24 - 32*s34 )

      LC = LC + Ld0(p2,p1,p34)*S23**(-1)*S24**(-1)*S234 * (  - 16*
     +    s12**2 + 24*s12*s34 + 16*s14*s34 - 8*s34**2 )

      LC = LC + Ld0(p2,p1,p34)*S23**(-1)*S24**(-1) * ( 16*s12**2*s34 - 
     +    24*s12*s34**2 - 16*s14*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p2,p1,p34)*S23**(-1)*S234 * ( 8*s12 + 16*s13 + 16*
     +    s14 - 8*s24 - 8*s34 )

      LC = LC + Ld0(p2,p1,p34)*S23**(-1) * (  - 16*s12*s24 - 16*s12*s34
     +     + 16*s13*s34 - 16*s14*s34 + 40*s24*s34 + 40*s34**2 )

      LC = LC + Ld0(p2,p1,p34)*S24**(-1)*S234 * (  - 8*s12 + 16*s13 + 
     +    16*s14 - 8*s23 + 32*s34 )

      LC = LC + Ld0(p2,p1,p34)*S234*S134**(-1) * ( 64*s12 + 32*s13 + 32
     +    *s14 + 48*s23 + 48*s24 + 64*s34 )

      LC = LC + Ld0(p2,p1,p34)*S234 * (  - 8 )

      LC = LC + Ld0(p2,p3,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LC = LC + Ld0(p2,p3,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s24*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LC = LC + Ld0(p2,p3,p4)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 + 48*s12**2*s23*s34 - 56*s12**2*s34**2 + 40*s12*
     +    s23*s34**2 - 24*s12*s34**3 )

      LC = LC + Ld0(p2,p3,p4)*S13**(-1)*S14**(-1) * ( 8*s12**2*s34 + 32
     +    *s12*s23*s34 + 16*s12*s24*s34 - 8*s12*s34**2 )

      LC = LC + Ld0(p2,p3,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 48*
     +    s12**3*s34 - 16*s12**2*s14*s34 + 88*s12**2*s34**2 + 16*s12*
     +    s14**2*s34 - 24*s12*s14*s34**2 + 24*s12*s34**3 )

      LC = LC + Ld0(p2,p3,p4)*S13**(-1)*S23**(-1) * ( 48*s12**3 + 8*
     +    s12**2*s14 + 56*s12**2*s24 + 136*s12**2*s34 + 32*s12*s14**2
     +     - 24*s12*s14*s24 - 24*s12*s14*s34 + 40*s12*s24**2 + 104*s12*
     +    s24*s34 + 96*s12*s34**2 + 8*s14**2*s24 + 8*s14**2*s34 - 16*
     +    s14*s24**2 - 32*s14*s24*s34 - 16*s14*s34**2 + 8*s24**3 + 24*
     +    s24**2*s34 + 24*s24*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p2,p3,p4)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s14*s23 - 16*s12*s14**2*s23 - 16*s12*s14*s23**2 - 8*
     +    s14**3*s23 - 8*s14*s23**3 )

      LC = LC + Ld0(p2,p3,p4)*S13**(-1)*S24**(-1) * (  - 8*s12**3 - 88*
     +    s12**2*s23 - 16*s12**2*s34 + 8*s12*s14**2 - 48*s12*s14*s23 + 
     +    72*s12*s14*s34 - 48*s12*s23**2 - 104*s12*s23*s34 + 8*s12*
     +    s34**2 + 8*s14**2*s23 + 8*s14**2*s34 - 24*s14*s23**2 + 16*s14
     +    *s23*s34 + 32*s14*s34**2 - 24*s23**3 - 16*s23**2*s34 + 8*s23*
     +    s34**2 + 16*s34**3 )

      LC = LC + Ld0(p2,p3,p4)*S13**(-1)*S34**(-1) * (  - 32*s12**2*s14
     +     - 32*s12*s14**2 - 32*s12*s14*s23 - 16*s14**3 - 16*s14**2*s23
     +     - 8*s14*s23**2 + 24*s14*s23*s24 + 16*s14*s24**2 )

      LC = LC + Ld0(p2,p3,p4)*S13**(-1) * ( 32*s12**2 + 40*s12*s14 - 40
     +    *s12*s23 + 40*s12*s24 + 72*s12*s34 - 16*s14**2 + 24*s14*s24
     +     + 16*s14*s34 - 32*s23**2 - 24*s23*s24 - 16*s23*s34 + 8*s24*
     +    s34 + 16*s34**2 )

      LC = LC + Ld0(p2,p3,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s13*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s13**2*s34 + 8*s12*s13*s34**2 )

      LC = LC + Ld0(p2,p3,p4)*S14**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2*s13*s24 + 16*s12*s13**2*s24 + 16*s12*s13*s24**2 + 8*
     +    s13**3*s24 + 8*s13*s24**3 )

      LC = LC + Ld0(p2,p3,p4)*S14**(-1)*S23**(-1) * ( 32*s12**3 + 64*
     +    s12**2*s13 + 64*s12**2*s24 + 80*s12**2*s34 + 48*s12*s13**2 + 
     +    80*s12*s13*s24 + 72*s12*s13*s34 + 48*s12*s24**2 + 72*s12*s24*
     +    s34 + 24*s12*s34**2 + 16*s13**3 + 32*s13**2*s24 + 32*s13**2*
     +    s34 + 32*s13*s24**2 + 48*s13*s24*s34 + 24*s13*s34**2 + 16*
     +    s24**3 + 32*s24**2*s34 + 24*s24*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p2,p3,p4)*S14**(-1)*S24**(-1) * (  - 16*s12**3 - 24
     +    *s12**2*s13 + 16*s12**2*s23 - 80*s12**2*s34 - 40*s12*s13**2
     +     + 48*s12*s13*s23 - 48*s12*s13*s34 - 8*s12*s23**2 + 56*s12*
     +    s23*s34 - 80*s12*s34**2 - 16*s13**3 + 16*s13**2*s23 - 24*
     +    s13**2*s34 - 8*s13*s23**2 + 32*s13*s23*s34 - 24*s13*s34**2 - 
     +    8*s23**2*s34 + 16*s23*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p2,p3,p4)*S14**(-1)*S34**(-1) * ( 32*s12**2*s13 + 
     +    32*s12*s13**2 + 32*s12*s13*s23 + 64*s12*s13*s24 + 16*s13**3
     +     + 16*s13**2*s24 + 16*s13*s23**2 + 40*s13*s23*s24 + 40*s13*
     +    s24**2 )

      LC = LC + Ld0(p2,p3,p4)*S14**(-1) * ( 16*s12*s13 + 32*s12*s23 + 
     +    32*s12*s24 - 48*s12*s34 - 8*s13**2 + 32*s13*s23 + 32*s13*s24
     +     - 24*s13*s34 + 8*s23**2 + 24*s23*s24 + 16*s23*s34 + 24*
     +    s24**2 + 8*s24*s34 - 16*s34**2 )

      LC = LC + Ld0(p2,p3,p4)*S23**(-1)*S24**(-1) * ( 56*s12**2*s34 + 
     +    24*s12*s13*s34 + 8*s12*s14*s34 + 32*s12*s34**2 - 8*s13**2*s34
     +     - 16*s13*s14*s34 - 8*s13*s34**2 - 8*s14**2*s34 - 8*s14*
     +    s34**2 )

      LC = LC + Ld0(p2,p3,p4)*S23**(-1)*S34**(-1)*S234**(-1) * ( 16*s12
     +    *s13*s24**2 + 16*s12*s14*s24**2 + 16*s13**2*s24**2 + 32*s13*
     +    s14*s24**2 + 16*s14**2*s24**2 )

      LC = LC + Ld0(p2,p3,p4)*S23**(-1)*S34**(-1) * ( 32*s12**2*s24 + 
     +    48*s12*s13*s24 + 16*s12*s14*s24 + 32*s12*s24**2 + 24*s13**2*
     +    s24 + 8*s13*s14*s24 + 16*s13*s24**2 + 16*s24**3 )

      LC = LC + Ld0(p2,p3,p4)*S23**(-1)*S234**(-1) * (  - 40*s12*s13*
     +    s24 - 24*s12*s13*s34 - 40*s12*s14*s24 - 24*s12*s14*s34 + 16*
     +    s12*s24**2 - 40*s12*s24*s34 - 24*s12*s34**2 - 40*s13**2*s24
     +     - 24*s13**2*s34 - 80*s13*s14*s24 - 48*s13*s14*s34 + 16*s13*
     +    s24**2 - 40*s13*s24*s34 - 24*s13*s34**2 - 40*s14**2*s24 - 24*
     +    s14**2*s34 + 16*s14*s24**2 - 40*s14*s24*s34 - 24*s14*s34**2 )

      LC = LC + Ld0(p2,p3,p4)*S23**(-1) * ( 128*s12**2 + 152*s12*s13 + 
     +    96*s12*s14 + 136*s12*s24 + 200*s12*s34 + 72*s13**2 + 88*s13*
     +    s14 + 48*s13*s24 + 88*s13*s34 + 40*s14**2 - 24*s14*s24 + 32*
     +    s14*s34 + 56*s24**2 + 56*s24*s34 + 32*s34**2 )

      LC = LC + Ld0(p2,p3,p4)*S24**(-1)*S34**(-1)*S234**(-1) * (  - 16*
     +    s12*s13*s23**2 - 16*s12*s14*s23**2 - 16*s13**2*s23**2 - 32*
     +    s13*s14*s23**2 - 16*s14**2*s23**2 )

      LC = LC + Ld0(p2,p3,p4)*S24**(-1)*S34**(-1) * (  - 32*s12**2*s23
     +     - 48*s12*s13*s23 - 80*s12*s14*s23 - 32*s12*s23**2 - 32*
     +    s13**2*s23 - 72*s13*s14*s23 - 56*s14**2*s23 - 16*s14*s23**2
     +     - 16*s23**3 )

      LC = LC + Ld0(p2,p3,p4)*S24**(-1)*S234**(-1) * (  - 20*s12*s13*
     +    s23 - 4*s12*s13*s34 - 20*s12*s14*s23 - 4*s12*s14*s34 - 16*s12
     +    *s23**2 - 20*s12*s23*s34 - 4*s12*s34**2 - 20*s13**2*s23 - 4*
     +    s13**2*s34 - 40*s13*s14*s23 - 8*s13*s14*s34 - 16*s13*s23**2
     +     - 20*s13*s23*s34 - 4*s13*s34**2 - 20*s14**2*s23 - 4*s14**2*
     +    s34 - 16*s14*s23**2 - 20*s14*s23*s34 - 4*s14*s34**2 )

      LC = LC + Ld0(p2,p3,p4)*S24**(-1) * (  - 32*s12**2 - 12*s12*s13
     +     + 44*s12*s14 - 112*s12*s23 + 20*s12*s34 - 28*s13**2 - 8*s13*
     +    s14 - 32*s13*s23 - 20*s13*s34 - 4*s14**2 - 72*s14*s23 + 20*
     +    s14*s34 - 24*s23**2 + 8*s34**2 )

      LC = LC + Ld0(p2,p3,p4)*S34**(-1)*S234**(-1) * ( 16*s12*s13*s23
     +     - 16*s12*s13*s24 + 16*s12*s14*s23 - 16*s12*s14*s24 + 16*
     +    s13**2*s23 - 16*s13**2*s24 + 32*s13*s14*s23 - 32*s13*s14*s24
     +     + 16*s14**2*s23 - 16*s14**2*s24 )

      LC = LC + Ld0(p2,p3,p4)*S34**(-1) * ( 48*s12*s13 - 16*s12*s14 - 
     +    48*s12*s23 + 16*s12*s24 + 32*s13**2 + 32*s13*s14 - 32*s23**2
     +     - 32*s23*s24 )

      LC = LC + Ld0(p2,p3,p4)*S234**(-1) * (  - 76*s12*s13 - 76*s12*s14
     +     + 16*s12*s23 - 16*s12*s24 - 76*s12*s34 - 76*s13**2 - 152*s13
     +    *s14 + 16*s13*s23 - 16*s13*s24 - 76*s13*s34 - 76*s14**2 + 16*
     +    s14*s23 - 16*s14*s24 - 76*s14*s34 )

      LC = LC + Ld0(p2,p3,p4) * ( 24*s12 - 24*s13 - 8*s14 - 8*s23 - 16*
     +    s24 - 32*s34 )

      LC = LC + Ld0(p2,p3,p14)*S13**(-1)*S14**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 - 16*s12**2*s23*s34 + 88*s12**2*s34**2 + 24*s12*
     +    s23**2*s34 - 16*s12*s23*s34**2 + 24*s12*s34**3 + 8*s23**3*s34
     +     + 8*s23**2*s34**2 )

      LC = LC + Ld0(p2,p3,p14)*S13**(-1)*S14**(-1) * ( 40*s12**2*s34 + 
     +    24*s12*s23*s34 + 24*s12*s24*s34 + 40*s12*s34**2 + 24*s23**2*
     +    s34 + 24*s23*s24*s34 + 16*s23*s34**2 + 8*s24**2*s34 + 8*s24*
     +    s34**2 )

      LC = LC + Ld0(p2,p3,p14)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s14 - 48*s12**3*s34 + 48*s12**2*s14*s34 - 56*s12**2*
     +    s34**2 + 40*s12*s14*s34**2 - 24*s12*s34**3 )

      LC = LC + Ld0(p2,p3,p14)*S13**(-1)*S23**(-1)*S34**(-1)*S134**(-1)
     +  * (  - 8*s12**2*s14**2*s24 - 8*s12*s14**3*s24 - 12*s12*s14**2*
     +    s24**2 + 4*s14**3*s24**2 - 16*s14**2*s24**3 )

      LC = LC + Ld0(p2,p3,p14)*S13**(-1)*S23**(-1)*S34**(-1) * ( 8*
     +    s12**2*s14*s24 + 8*s12*s14**2*s24 + 12*s12*s14*s24**2 - 4*
     +    s14**2*s24**2 + 16*s14*s24**3 )

      LC = LC + Ld0(p2,p3,p14)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 8*
     +    s12**2*s14**2 - 12*s12**2*s14*s24 - 12*s12**2*s14*s34 - 4*
     +    s12**2*s24*s34 - 4*s12**2*s34**2 - 8*s12*s14**3 - 36*s12*
     +    s14**2*s24 - 24*s12*s14**2*s34 - 32*s12*s14*s24**2 - 56*s12*
     +    s14*s24*s34 - 24*s12*s14*s34**2 - 20*s12*s24**2*s34 - 28*s12*
     +    s24*s34**2 - 8*s12*s34**3 + 4*s14**3*s24 - 8*s14**2*s24**2 + 
     +    8*s14**2*s24*s34 - 32*s14*s24**3 - 28*s14*s24**2*s34 + 4*s14*
     +    s24*s34**2 - 16*s24**3*s34 - 16*s24**2*s34**2 )

      LC = LC + Ld0(p2,p3,p14)*S13**(-1)*S23**(-1) * (  - 48*s12**3 + 
     +    40*s12**2*s14 - 60*s12**2*s24 - 92*s12**2*s34 + 8*s12*s14**2
     +     + 68*s12*s14*s24 + 96*s12*s14*s34 - 20*s12*s24**2 - 68*s12*
     +    s24*s34 - 72*s12*s34**2 - 12*s14**2*s24 - 8*s14**2*s34 + 28*
     +    s14*s24**2 + 28*s14*s24*s34 + 16*s14*s34**2 + 8*s24**3 - 8*
     +    s24**2*s34 - 24*s24*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p2,p3,p14)*S13**(-1)*S24**(-1) * (  - 32*s12**3 - 
     +    64*s12**2*s14 - 8*s12*s14**2 - 8*s12*s14*s23 - 48*s12*s14*s34
     +     - 16*s12*s23**2 + 80*s12*s23*s34 + 16*s12*s34**2 - 8*s14**3
     +     - 8*s14**2*s23 )

      LC = LC + Ld0(p2,p3,p14)*S13**(-1)*S34**(-1)*S134**(-1) * (  - 8*
     +    s12**2*s14**2 - 8*s12*s14**3 - 28*s12*s14**2*s23 - 40*s12*
     +    s14**2*s24 - 12*s14**3*s23 - 8*s14**3*s24 - 20*s14**2*s23**2
     +     - 40*s14**2*s23*s24 - 36*s14**2*s24**2 )

      LC = LC + Ld0(p2,p3,p14)*S13**(-1)*S34**(-1) * (  - 8*s12**2*s14
     +     - 8*s12*s14**2 - 36*s12*s14*s23 - 8*s12*s14*s24 - 8*s14**3
     +     - 4*s14**2*s23 + 8*s14**2*s24 - 28*s14*s23**2 - 40*s14*s23*
     +    s24 - 4*s14*s24**2 )

      LC = LC + Ld0(p2,p3,p14)*S13**(-1)*S134**(-1) * (  - 12*s12**2*
     +    s14 - 4*s12**2*s34 - 52*s12*s14**2 - 32*s12*s14*s23 - 64*s12*
     +    s14*s24 - 56*s12*s14*s34 - 36*s12*s23*s34 - 56*s12*s24*s34 - 
     +    44*s12*s34**2 - 12*s14**3 - 28*s14**2*s23 - 20*s14**2*s24 - 8
     +    *s14**2*s34 - 4*s14*s23**2 - 20*s14*s23*s24 - 48*s14*s24**2
     +     - 8*s14*s24*s34 + 4*s14*s34**2 - 16*s23**2*s34 - 44*s23*s24*
     +    s34 - 16*s23*s34**2 - 44*s24**2*s34 - 28*s24*s34**2 )

      LC = LC + Ld0(p2,p3,p14)*S13**(-1) * (  - 92*s12**2 - 28*s12*s14
     +     + 4*s12*s23 - 8*s12*s24 - 4*s12*s34 + 4*s14**2 - 40*s14*s23
     +     - 28*s14*s24 - 4*s14*s34 + 28*s23*s24 - 8*s23*s34 + 28*
     +    s24**2 - 12*s24*s34 - 24*s34**2 )

      LC = LC + Ld0(p2,p3,p14)*S14**(-1)*S24**(-1) * ( 16*s12**3 + 32*
     +    s12**2*s13 + 96*s12**2*s34 + 24*s12*s13**2 - 16*s12*s13*s23
     +     + 88*s12*s13*s34 + 24*s12*s23**2 - 32*s12*s23*s34 + 88*s12*
     +    s34**2 + 8*s13**3 - 8*s13**2*s23 + 32*s13**2*s34 + 8*s13*
     +    s23**2 - 24*s13*s23*s34 + 32*s13*s34**2 + 8*s23**3 + 16*
     +    s23**2*s34 - 16*s23*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p2,p3,p14)*S14**(-1)*S34**(-1) * ( 16*s12**2*s13 + 
     +    16*s12*s13**2 + 16*s12*s13*s23 + 32*s12*s13*s24 + 8*s13**3 + 
     +    16*s13**2*s24 + 8*s13*s23**2 + 16*s13*s23*s24 + 16*s13*s24**2
     +     )

      LC = LC + Ld0(p2,p3,p14)*S14**(-1)*S134**(-1) * ( 4*s12*s13*s23
     +     + 4*s12*s13*s24 + 4*s12*s13*s34 + 4*s12*s23*s34 + 4*s12*s24*
     +    s34 + 4*s12*s34**2 + 4*s13**2*s23 + 4*s13**2*s24 + 4*s13**2*
     +    s34 + 4*s13*s23*s24 + 8*s13*s23*s34 + 4*s13*s24**2 + 12*s13*
     +    s24*s34 + 8*s13*s34**2 + 4*s23*s24*s34 + 4*s23*s34**2 + 4*
     +    s24**2*s34 + 8*s24*s34**2 + 4*s34**3 )

      LC = LC + Ld0(p2,p3,p14)*S14**(-1) * ( 48*s12**2 + 96*s12*s13 + 
     +    28*s12*s23 + 44*s12*s24 + 108*s12*s34 + 48*s13**2 + 12*s13*
     +    s23 + 60*s13*s24 + 76*s13*s34 + 16*s23**2 + 12*s23*s24 + 12*
     +    s23*s34 + 12*s24**2 + 40*s24*s34 + 36*s34**2 )

      LC = LC + Ld0(p2,p3,p14)*S23**(-1)*S24**(-1) * (  - 16*s12**3 + 
     +    16*s12**2*s13 + 16*s12**2*s14 + 8*s12**2*s34 + 8*s12*s13**2
     +     + 8*s12*s13*s14 + 16*s12*s14*s34 - 24*s12*s34**2 )

      LC = LC + Ld0(p2,p3,p14)*S23**(-1)*S34**(-1)*S134**(-1) * ( 8*
     +    s12**2*s13*s24 + 8*s12*s13**2*s24 + 8*s12*s13*s14*s24 - 8*s12
     +    *s14**2*s24 - 12*s12*s14*s24**2 + 8*s13**2*s24**2 + 20*s13*
     +    s14*s24**2 - 8*s13*s24**3 + 16*s14**2*s24**2 - 24*s14*s24**3
     +     )

      LC = LC + Ld0(p2,p3,p14)*S23**(-1)*S34**(-1) * ( 8*s12**2*s24 + 
     +    24*s12*s13*s24 + 16*s12*s14*s24 + 16*s12*s24**2 + 16*s13**2*
     +    s24 + 16*s13*s14*s24 + 8*s13*s24**2 + 8*s14**2*s24 - 12*s14*
     +    s24**2 + 16*s24**3 )

      LC = LC + Ld0(p2,p3,p14)*S23**(-1)*S134**(-1) * ( 8*s12**2*s13 + 
     +    4*s12**2*s24 + 4*s12**2*s34 + 8*s12*s13**2 + 8*s12*s13*s14 + 
     +    8*s12*s13*s24 + 8*s12*s13*s34 - 8*s12*s14**2 - 28*s12*s14*s24
     +     - 16*s12*s14*s34 - 20*s12*s24**2 - 28*s12*s24*s34 - 8*s12*
     +    s34**2 + 8*s13**2*s24 + 20*s13*s14*s24 + 8*s13*s24**2 + 16*
     +    s13*s24*s34 + 16*s14**2*s24 + 24*s14*s24*s34 - 24*s24**3 - 16
     +    *s24**2*s34 + 8*s24*s34**2 )

      LC = LC + Ld0(p2,p3,p14)*S23**(-1) * (  - 56*s12**2 - 40*s12*s13
     +     + 24*s12*s14 - 40*s12*s24 - 88*s12*s34 + 8*s13**2 + 24*s13*
     +    s14 - 8*s13*s24 - 8*s13*s34 + 8*s14**2 + 4*s14*s24 + 16*s14*
     +    s34 - 8*s24**2 - 48*s24*s34 - 24*s34**2 )

      LC = LC + Ld0(p2,p3,p14)*S24**(-1)*S34**(-1) * (  - 16*s12**2*s23
     +     + 16*s12*s13*s23 - 16*s12*s23**2 + 24*s13**2*s23 + 48*s13*
     +    s14*s23 + 16*s14**2*s23 - 16*s14*s23**2 - 8*s23**3 )

      LC = LC + Ld0(p2,p3,p14)*S24**(-1) * ( 32*s12**2 + 24*s12*s13 + 
     +    104*s12*s23 + 80*s12*s34 + 8*s13**2 - 32*s13*s14 + 48*s13*s23
     +     + 24*s13*s34 - 32*s14**2 + 40*s14*s23 - 32*s14*s34 + 16*s23*
     +    s34 + 8*s34**2 )

      LC = LC + Ld0(p2,p3,p14)*S34**(-1)*S134**(-1) * ( 8*s12**2*s13 + 
     +    8*s12*s13**2 + 8*s12*s13*s14 - 24*s12*s13*s23 - 24*s12*s13*
     +    s24 - 8*s12*s14**2 + 12*s12*s14*s23 - 8*s13**2*s23 + 4*s13*
     +    s14*s23 + 24*s13*s14*s24 - 4*s13*s23**2 - 32*s13*s23*s24 - 36
     +    *s13*s24**2 + 16*s14**2*s24 + 40*s14*s23**2 + 56*s14*s23*s24
     +     - 8*s14*s24**2 )

      LC = LC + Ld0(p2,p3,p14)*S34**(-1) * (  - 8*s12**2 - 8*s12*s13 - 
     +    32*s12*s14 - 8*s12*s23 + 24*s12*s24 - 16*s13**2 - 32*s13*s14
     +     + 8*s13*s23 - 16*s14**2 - 12*s14*s23 - 24*s14*s24 - 12*
     +    s23**2 + 20*s24**2 )

      LC = LC + Ld0(p2,p3,p14)*S134**(-1) * ( 4*s12**2 - 16*s12*s13 - 4
     +    *s12*s14 - 24*s12*s23 - 44*s12*s24 - 32*s12*s34 - 8*s13**2 + 
     +    4*s13*s14 + 4*s13*s23 - 4*s13*s24 + 8*s13*s34 + 68*s14*s23 + 
     +    68*s14*s24 + 28*s14*s34 + 12*s23**2 - 8*s23*s24 + 28*s23*s34
     +     - 44*s24**2 + 4*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p2,p3,p14) * ( 32*s12 - 8*s13 - 20*s14 + 16*s23 + 4
     +    *s34 )

      LC = LC + Ld0(p2,p4,p3)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 16*s12**3*s34**2 )

      LC = LC + Ld0(p2,p4,p3)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16*
     +    s12**3*s34 + 48*s12**2*s24*s34 - 56*s12**2*s34**2 + 40*s12*
     +    s24*s34**2 - 24*s12*s34**3 )

      LC = LC + Ld0(p2,p4,p3)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s23*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LC = LC + Ld0(p2,p4,p3)*S13**(-1)*S14**(-1) * ( 8*s12**2*s34 + 16
     +    *s12*s23*s34 + 32*s12*s24*s34 - 8*s12*s34**2 )

      LC = LC + Ld0(p2,p4,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s34 + 16*s12**2*s14*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s14**2*s34 + 8*s12*s14*s34**2 )

      LC = LC + Ld0(p2,p4,p3)*S13**(-1)*S23**(-1) * (  - 16*s12**3 - 24
     +    *s12**2*s14 + 16*s12**2*s24 - 80*s12**2*s34 - 40*s12*s14**2
     +     + 48*s12*s14*s24 - 48*s12*s14*s34 - 8*s12*s24**2 + 56*s12*
     +    s24*s34 - 80*s12*s34**2 - 16*s14**3 + 16*s14**2*s24 - 24*
     +    s14**2*s34 - 8*s14*s24**2 + 32*s14*s24*s34 - 24*s14*s34**2 - 
     +    8*s24**2*s34 + 16*s24*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p2,p4,p3)*S13**(-1)*S24**(-1)*S34**(-1) * ( 16*
     +    s12**2*s14*s23 + 16*s12*s14**2*s23 + 16*s12*s14*s23**2 + 8*
     +    s14**3*s23 + 8*s14*s23**3 )

      LC = LC + Ld0(p2,p4,p3)*S13**(-1)*S24**(-1) * ( 32*s12**3 + 64*
     +    s12**2*s14 + 64*s12**2*s23 + 80*s12**2*s34 + 48*s12*s14**2 + 
     +    80*s12*s14*s23 + 72*s12*s14*s34 + 48*s12*s23**2 + 72*s12*s23*
     +    s34 + 24*s12*s34**2 + 16*s14**3 + 32*s14**2*s23 + 32*s14**2*
     +    s34 + 32*s14*s23**2 + 48*s14*s23*s34 + 24*s14*s34**2 + 16*
     +    s23**3 + 32*s23**2*s34 + 24*s23*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p2,p4,p3)*S13**(-1)*S34**(-1) * ( 32*s12**2*s14 + 
     +    32*s12*s14**2 + 64*s12*s14*s23 + 32*s12*s14*s24 + 16*s14**3
     +     + 16*s14**2*s23 + 40*s14*s23**2 + 40*s14*s23*s24 + 16*s14*
     +    s24**2 )

      LC = LC + Ld0(p2,p4,p3)*S13**(-1) * ( 16*s12*s14 + 32*s12*s23 + 
     +    32*s12*s24 - 48*s12*s34 - 8*s14**2 + 32*s14*s23 + 32*s14*s24
     +     - 24*s14*s34 + 24*s23**2 + 24*s23*s24 + 8*s23*s34 + 8*s24**2
     +     + 16*s24*s34 - 16*s34**2 )

      LC = LC + Ld0(p2,p4,p3)*S14**(-1)*S23**(-1)*S24**(-1) * ( 48*
     +    s12**3*s34 - 16*s12**2*s13*s34 + 88*s12**2*s34**2 + 16*s12*
     +    s13**2*s34 - 24*s12*s13*s34**2 + 24*s12*s34**3 )

      LC = LC + Ld0(p2,p4,p3)*S14**(-1)*S23**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s13*s24 - 16*s12*s13**2*s24 - 16*s12*s13*s24**2 - 8*
     +    s13**3*s24 - 8*s13*s24**3 )

      LC = LC + Ld0(p2,p4,p3)*S14**(-1)*S23**(-1) * (  - 8*s12**3 - 88*
     +    s12**2*s24 - 16*s12**2*s34 + 8*s12*s13**2 - 48*s12*s13*s24 + 
     +    72*s12*s13*s34 - 48*s12*s24**2 - 104*s12*s24*s34 + 8*s12*
     +    s34**2 + 8*s13**2*s24 + 8*s13**2*s34 - 24*s13*s24**2 + 16*s13
     +    *s24*s34 + 32*s13*s34**2 - 24*s24**3 - 16*s24**2*s34 + 8*s24*
     +    s34**2 + 16*s34**3 )

      LC = LC + Ld0(p2,p4,p3)*S14**(-1)*S24**(-1) * ( 48*s12**3 + 8*
     +    s12**2*s13 + 56*s12**2*s23 + 136*s12**2*s34 + 32*s12*s13**2
     +     - 24*s12*s13*s23 - 24*s12*s13*s34 + 40*s12*s23**2 + 104*s12*
     +    s23*s34 + 96*s12*s34**2 + 8*s13**2*s23 + 8*s13**2*s34 - 16*
     +    s13*s23**2 - 32*s13*s23*s34 - 16*s13*s34**2 + 8*s23**3 + 24*
     +    s23**2*s34 + 24*s23*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p2,p4,p3)*S14**(-1)*S34**(-1) * (  - 32*s12**2*s13
     +     - 32*s12*s13**2 - 32*s12*s13*s24 - 16*s13**3 - 16*s13**2*s24
     +     + 16*s13*s23**2 + 24*s13*s23*s24 - 8*s13*s24**2 )

      LC = LC + Ld0(p2,p4,p3)*S14**(-1) * ( 32*s12**2 + 40*s12*s13 + 40
     +    *s12*s23 - 40*s12*s24 + 72*s12*s34 - 16*s13**2 + 24*s13*s23
     +     + 16*s13*s34 - 24*s23*s24 + 8*s23*s34 - 32*s24**2 - 16*s24*
     +    s34 + 16*s34**2 )

      LC = LC + Ld0(p2,p4,p3)*S23**(-1)*S24**(-1) * ( 56*s12**2*s34 + 8
     +    *s12*s13*s34 + 24*s12*s14*s34 + 32*s12*s34**2 - 8*s13**2*s34
     +     - 16*s13*s14*s34 - 8*s13*s34**2 - 8*s14**2*s34 - 8*s14*
     +    s34**2 )

      LC = LC + Ld0(p2,p4,p3)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 16*
     +    s12*s13*s24**2 - 16*s12*s14*s24**2 - 16*s13**2*s24**2 - 32*
     +    s13*s14*s24**2 - 16*s14**2*s24**2 )

      LC = LC + Ld0(p2,p4,p3)*S23**(-1)*S34**(-1) * (  - 32*s12**2*s24
     +     - 80*s12*s13*s24 - 48*s12*s14*s24 - 32*s12*s24**2 - 56*
     +    s13**2*s24 - 72*s13*s14*s24 - 16*s13*s24**2 - 32*s14**2*s24
     +     - 16*s24**3 )

      LC = LC + Ld0(p2,p4,p3)*S23**(-1)*S234**(-1) * (  - 20*s12*s13*
     +    s24 - 4*s12*s13*s34 - 20*s12*s14*s24 - 4*s12*s14*s34 - 16*s12
     +    *s24**2 - 20*s12*s24*s34 - 4*s12*s34**2 - 20*s13**2*s24 - 4*
     +    s13**2*s34 - 40*s13*s14*s24 - 8*s13*s14*s34 - 16*s13*s24**2
     +     - 20*s13*s24*s34 - 4*s13*s34**2 - 20*s14**2*s24 - 4*s14**2*
     +    s34 - 16*s14*s24**2 - 20*s14*s24*s34 - 4*s14*s34**2 )

      LC = LC + Ld0(p2,p4,p3)*S23**(-1) * (  - 32*s12**2 + 44*s12*s13
     +     - 12*s12*s14 - 112*s12*s24 + 20*s12*s34 - 4*s13**2 - 8*s13*
     +    s14 - 72*s13*s24 + 20*s13*s34 - 28*s14**2 - 32*s14*s24 - 20*
     +    s14*s34 - 24*s24**2 + 8*s34**2 )

      LC = LC + Ld0(p2,p4,p3)*S24**(-1)*S34**(-1)*S234**(-1) * ( 16*s12
     +    *s13*s23**2 + 16*s12*s14*s23**2 + 16*s13**2*s23**2 + 32*s13*
     +    s14*s23**2 + 16*s14**2*s23**2 )

      LC = LC + Ld0(p2,p4,p3)*S24**(-1)*S34**(-1) * ( 32*s12**2*s23 + 
     +    16*s12*s13*s23 + 48*s12*s14*s23 + 32*s12*s23**2 + 8*s13*s14*
     +    s23 + 24*s14**2*s23 + 16*s14*s23**2 + 16*s23**3 )

      LC = LC + Ld0(p2,p4,p3)*S24**(-1)*S234**(-1) * (  - 40*s12*s13*
     +    s23 - 24*s12*s13*s34 - 40*s12*s14*s23 - 24*s12*s14*s34 + 16*
     +    s12*s23**2 - 40*s12*s23*s34 - 24*s12*s34**2 - 40*s13**2*s23
     +     - 24*s13**2*s34 - 80*s13*s14*s23 - 48*s13*s14*s34 + 16*s13*
     +    s23**2 - 40*s13*s23*s34 - 24*s13*s34**2 - 40*s14**2*s23 - 24*
     +    s14**2*s34 + 16*s14*s23**2 - 40*s14*s23*s34 - 24*s14*s34**2 )

      LC = LC + Ld0(p2,p4,p3)*S24**(-1) * ( 128*s12**2 + 96*s12*s13 + 
     +    152*s12*s14 + 136*s12*s23 + 200*s12*s34 + 40*s13**2 + 88*s13*
     +    s14 - 24*s13*s23 + 32*s13*s34 + 72*s14**2 + 48*s14*s23 + 88*
     +    s14*s34 + 56*s23**2 + 56*s23*s34 + 32*s34**2 )

      LC = LC + Ld0(p2,p4,p3)*S34**(-1)*S234**(-1) * (  - 16*s12*s13*
     +    s23 + 16*s12*s13*s24 - 16*s12*s14*s23 + 16*s12*s14*s24 - 16*
     +    s13**2*s23 + 16*s13**2*s24 - 32*s13*s14*s23 + 32*s13*s14*s24
     +     - 16*s14**2*s23 + 16*s14**2*s24 )

      LC = LC + Ld0(p2,p4,p3)*S34**(-1) * (  - 16*s12*s13 + 48*s12*s14
     +     + 16*s12*s23 - 48*s12*s24 + 32*s13*s14 + 32*s14**2 - 32*s23*
     +    s24 - 32*s24**2 )

      LC = LC + Ld0(p2,p4,p3)*S234**(-1) * (  - 76*s12*s13 - 76*s12*s14
     +     - 16*s12*s23 + 16*s12*s24 - 76*s12*s34 - 76*s13**2 - 152*s13
     +    *s14 - 16*s13*s23 + 16*s13*s24 - 76*s13*s34 - 76*s14**2 - 16*
     +    s14*s23 + 16*s14*s24 - 76*s14*s34 )

      LC = LC + Ld0(p2,p4,p3) * ( 24*s12 - 8*s13 - 24*s14 - 16*s23 - 8*
     +    s24 - 32*s34 )

      LC = LC + Ld0(p2,p4,p13)*S13**(-1)*S14**(-1)*S23**(-1) * ( 32*
     +    s12**3*s34 - 16*s12**2*s24*s34 + 88*s12**2*s34**2 + 24*s12*
     +    s24**2*s34 - 16*s12*s24*s34**2 + 24*s12*s34**3 + 8*s24**3*s34
     +     + 8*s24**2*s34**2 )

      LC = LC + Ld0(p2,p4,p13)*S13**(-1)*S14**(-1) * ( 40*s12**2*s34 + 
     +    24*s12*s23*s34 + 24*s12*s24*s34 + 40*s12*s34**2 + 8*s23**2*
     +    s34 + 24*s23*s24*s34 + 8*s23*s34**2 + 24*s24**2*s34 + 16*s24*
     +    s34**2 )

      LC = LC + Ld0(p2,p4,p13)*S13**(-1)*S23**(-1) * ( 16*s12**3 + 32*
     +    s12**2*s14 + 96*s12**2*s34 + 24*s12*s14**2 - 16*s12*s14*s24
     +     + 88*s12*s14*s34 + 24*s12*s24**2 - 32*s12*s24*s34 + 88*s12*
     +    s34**2 + 8*s14**3 - 8*s14**2*s24 + 32*s14**2*s34 + 8*s14*
     +    s24**2 - 24*s14*s24*s34 + 32*s14*s34**2 + 8*s24**3 + 16*
     +    s24**2*s34 - 16*s24*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p2,p4,p13)*S13**(-1)*S34**(-1) * ( 16*s12**2*s14 + 
     +    16*s12*s14**2 + 32*s12*s14*s23 + 16*s12*s14*s24 + 8*s14**3 + 
     +    16*s14**2*s23 + 16*s14*s23**2 + 16*s14*s23*s24 + 8*s14*s24**2
     +     )

      LC = LC + Ld0(p2,p4,p13)*S13**(-1)*S134**(-1) * ( 4*s12*s14*s23
     +     + 4*s12*s14*s24 + 4*s12*s14*s34 + 4*s12*s23*s34 + 4*s12*s24*
     +    s34 + 4*s12*s34**2 + 4*s14**2*s23 + 4*s14**2*s24 + 4*s14**2*
     +    s34 + 4*s14*s23**2 + 4*s14*s23*s24 + 12*s14*s23*s34 + 8*s14*
     +    s24*s34 + 8*s14*s34**2 + 4*s23**2*s34 + 4*s23*s24*s34 + 8*s23
     +    *s34**2 + 4*s24*s34**2 + 4*s34**3 )

      LC = LC + Ld0(p2,p4,p13)*S13**(-1) * ( 48*s12**2 + 96*s12*s14 + 
     +    44*s12*s23 + 28*s12*s24 + 108*s12*s34 + 48*s14**2 + 60*s14*
     +    s23 + 12*s14*s24 + 76*s14*s34 + 12*s23**2 + 12*s23*s24 + 40*
     +    s23*s34 + 16*s24**2 + 12*s24*s34 + 36*s34**2 )

      LC = LC + Ld0(p2,p4,p13)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s13 - 48*s12**3*s34 + 48*s12**2*s13*s34 - 56*s12**2*
     +    s34**2 + 40*s12*s13*s34**2 - 24*s12*s34**3 )

      LC = LC + Ld0(p2,p4,p13)*S14**(-1)*S23**(-1) * (  - 32*s12**3 - 
     +    64*s12**2*s13 - 8*s12*s13**2 - 8*s12*s13*s24 - 48*s12*s13*s34
     +     - 16*s12*s24**2 + 80*s12*s24*s34 + 16*s12*s34**2 - 8*s13**3
     +     - 8*s13**2*s24 )

      LC = LC + Ld0(p2,p4,p13)*S14**(-1)*S24**(-1)*S34**(-1)*S134**(-1)
     +  * (  - 8*s12**2*s13**2*s23 - 8*s12*s13**3*s23 - 12*s12*s13**2*
     +    s23**2 + 4*s13**3*s23**2 - 16*s13**2*s23**3 )

      LC = LC + Ld0(p2,p4,p13)*S14**(-1)*S24**(-1)*S34**(-1) * ( 8*
     +    s12**2*s13*s23 + 8*s12*s13**2*s23 + 12*s12*s13*s23**2 - 4*
     +    s13**2*s23**2 + 16*s13*s23**3 )

      LC = LC + Ld0(p2,p4,p13)*S14**(-1)*S24**(-1)*S134**(-1) * (  - 8*
     +    s12**2*s13**2 - 12*s12**2*s13*s23 - 12*s12**2*s13*s34 - 4*
     +    s12**2*s23*s34 - 4*s12**2*s34**2 - 8*s12*s13**3 - 36*s12*
     +    s13**2*s23 - 24*s12*s13**2*s34 - 32*s12*s13*s23**2 - 56*s12*
     +    s13*s23*s34 - 24*s12*s13*s34**2 - 20*s12*s23**2*s34 - 28*s12*
     +    s23*s34**2 - 8*s12*s34**3 + 4*s13**3*s23 - 8*s13**2*s23**2 + 
     +    8*s13**2*s23*s34 - 32*s13*s23**3 - 28*s13*s23**2*s34 + 4*s13*
     +    s23*s34**2 - 16*s23**3*s34 - 16*s23**2*s34**2 )

      LC = LC + Ld0(p2,p4,p13)*S14**(-1)*S24**(-1) * (  - 48*s12**3 + 
     +    40*s12**2*s13 - 60*s12**2*s23 - 92*s12**2*s34 + 8*s12*s13**2
     +     + 68*s12*s13*s23 + 96*s12*s13*s34 - 20*s12*s23**2 - 68*s12*
     +    s23*s34 - 72*s12*s34**2 - 12*s13**2*s23 - 8*s13**2*s34 + 28*
     +    s13*s23**2 + 28*s13*s23*s34 + 16*s13*s34**2 + 8*s23**3 - 8*
     +    s23**2*s34 - 24*s23*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p2,p4,p13)*S14**(-1)*S34**(-1)*S134**(-1) * (  - 8*
     +    s12**2*s13**2 - 8*s12*s13**3 - 40*s12*s13**2*s23 - 28*s12*
     +    s13**2*s24 - 8*s13**3*s23 - 12*s13**3*s24 - 36*s13**2*s23**2
     +     - 40*s13**2*s23*s24 - 20*s13**2*s24**2 )

      LC = LC + Ld0(p2,p4,p13)*S14**(-1)*S34**(-1) * (  - 8*s12**2*s13
     +     - 8*s12*s13**2 - 8*s12*s13*s23 - 36*s12*s13*s24 - 8*s13**3
     +     + 8*s13**2*s23 - 4*s13**2*s24 - 4*s13*s23**2 - 40*s13*s23*
     +    s24 - 28*s13*s24**2 )

      LC = LC + Ld0(p2,p4,p13)*S14**(-1)*S134**(-1) * (  - 12*s12**2*
     +    s13 - 4*s12**2*s34 - 52*s12*s13**2 - 64*s12*s13*s23 - 32*s12*
     +    s13*s24 - 56*s12*s13*s34 - 56*s12*s23*s34 - 36*s12*s24*s34 - 
     +    44*s12*s34**2 - 12*s13**3 - 20*s13**2*s23 - 28*s13**2*s24 - 8
     +    *s13**2*s34 - 48*s13*s23**2 - 20*s13*s23*s24 - 8*s13*s23*s34
     +     - 4*s13*s24**2 + 4*s13*s34**2 - 44*s23**2*s34 - 44*s23*s24*
     +    s34 - 28*s23*s34**2 - 16*s24**2*s34 - 16*s24*s34**2 )

      LC = LC + Ld0(p2,p4,p13)*S14**(-1) * (  - 92*s12**2 - 28*s12*s13
     +     - 8*s12*s23 + 4*s12*s24 - 4*s12*s34 + 4*s13**2 - 28*s13*s23
     +     - 40*s13*s24 - 4*s13*s34 + 28*s23**2 + 28*s23*s24 - 12*s23*
     +    s34 - 8*s24*s34 - 24*s34**2 )

      LC = LC + Ld0(p2,p4,p13)*S23**(-1)*S24**(-1) * (  - 16*s12**3 + 
     +    16*s12**2*s13 + 16*s12**2*s14 + 8*s12**2*s34 + 8*s12*s13*s14
     +     + 16*s12*s13*s34 + 8*s12*s14**2 - 24*s12*s34**2 )

      LC = LC + Ld0(p2,p4,p13)*S23**(-1)*S34**(-1) * (  - 16*s12**2*s24
     +     + 16*s12*s14*s24 - 16*s12*s24**2 + 16*s13**2*s24 + 48*s13*
     +    s14*s24 - 16*s13*s24**2 + 24*s14**2*s24 - 8*s24**3 )

      LC = LC + Ld0(p2,p4,p13)*S23**(-1) * ( 32*s12**2 + 24*s12*s14 + 
     +    104*s12*s24 + 80*s12*s34 - 32*s13**2 - 32*s13*s14 + 40*s13*
     +    s24 - 32*s13*s34 + 8*s14**2 + 48*s14*s24 + 24*s14*s34 + 16*
     +    s24*s34 + 8*s34**2 )

      LC = LC + Ld0(p2,p4,p13)*S24**(-1)*S34**(-1)*S134**(-1) * ( 8*
     +    s12**2*s14*s23 - 8*s12*s13**2*s23 + 8*s12*s13*s14*s23 - 12*
     +    s12*s13*s23**2 + 8*s12*s14**2*s23 + 16*s13**2*s23**2 + 20*s13
     +    *s14*s23**2 - 24*s13*s23**3 + 8*s14**2*s23**2 - 8*s14*s23**3
     +     )

      LC = LC + Ld0(p2,p4,p13)*S24**(-1)*S34**(-1) * ( 8*s12**2*s23 + 
     +    16*s12*s13*s23 + 24*s12*s14*s23 + 16*s12*s23**2 + 8*s13**2*
     +    s23 + 16*s13*s14*s23 - 12*s13*s23**2 + 16*s14**2*s23 + 8*s14*
     +    s23**2 + 16*s23**3 )

      LC = LC + Ld0(p2,p4,p13)*S24**(-1)*S134**(-1) * ( 8*s12**2*s14 + 
     +    4*s12**2*s23 + 4*s12**2*s34 - 8*s12*s13**2 + 8*s12*s13*s14 - 
     +    28*s12*s13*s23 - 16*s12*s13*s34 + 8*s12*s14**2 + 8*s12*s14*
     +    s23 + 8*s12*s14*s34 - 20*s12*s23**2 - 28*s12*s23*s34 - 8*s12*
     +    s34**2 + 16*s13**2*s23 + 20*s13*s14*s23 + 24*s13*s23*s34 + 8*
     +    s14**2*s23 + 8*s14*s23**2 + 16*s14*s23*s34 - 24*s23**3 - 16*
     +    s23**2*s34 + 8*s23*s34**2 )

      LC = LC + Ld0(p2,p4,p13)*S24**(-1) * (  - 56*s12**2 + 24*s12*s13
     +     - 40*s12*s14 - 40*s12*s23 - 88*s12*s34 + 8*s13**2 + 24*s13*
     +    s14 + 4*s13*s23 + 16*s13*s34 + 8*s14**2 - 8*s14*s23 - 8*s14*
     +    s34 - 8*s23**2 - 48*s23*s34 - 24*s34**2 )

      LC = LC + Ld0(p2,p4,p13)*S34**(-1)*S134**(-1) * ( 8*s12**2*s14 - 
     +    8*s12*s13**2 + 8*s12*s13*s14 + 12*s12*s13*s24 + 8*s12*s14**2
     +     - 24*s12*s14*s23 - 24*s12*s14*s24 + 16*s13**2*s23 + 24*s13*
     +    s14*s23 + 4*s13*s14*s24 - 8*s13*s23**2 + 56*s13*s23*s24 + 40*
     +    s13*s24**2 - 8*s14**2*s24 - 36*s14*s23**2 - 32*s14*s23*s24 - 
     +    4*s14*s24**2 )

      LC = LC + Ld0(p2,p4,p13)*S34**(-1) * (  - 8*s12**2 - 32*s12*s13
     +     - 8*s12*s14 + 24*s12*s23 - 8*s12*s24 - 16*s13**2 - 32*s13*
     +    s14 - 24*s13*s23 - 12*s13*s24 - 16*s14**2 + 8*s14*s24 + 20*
     +    s23**2 - 12*s24**2 )

      LC = LC + Ld0(p2,p4,p13)*S134**(-1) * ( 4*s12**2 - 4*s12*s13 - 16
     +    *s12*s14 - 44*s12*s23 - 24*s12*s24 - 32*s12*s34 + 4*s13*s14
     +     + 68*s13*s23 + 68*s13*s24 + 28*s13*s34 - 8*s14**2 - 4*s14*
     +    s23 + 4*s14*s24 + 8*s14*s34 - 44*s23**2 - 8*s23*s24 + 4*s23*
     +    s34 + 12*s24**2 + 28*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p2,p4,p13) * ( 32*s12 - 20*s13 - 8*s14 + 16*s24 + 4
     +    *s34 )

      LC = LC + Ld0(p2,p13,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 16*s12**3*s34**2 )

      LC = LC + Ld0(p2,p13,p4)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16*
     +    s12**3*s34 - 16*s12**2*s24*s34 - 16*s12**2*s34**2 - 8*s12*
     +    s24**2*s34 - 8*s12*s24*s34**2 )

      LC = LC + Ld0(p2,p13,p4)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 - 16*s12**2*s23*s34 - 16*s12**2*s34**2 - 8*s12*
     +    s23**2*s34 - 8*s12*s23*s34**2 )

      LC = LC + Ld0(p2,p13,p4)*S13**(-1)*S14**(-1) * (  - 32*s12**2*s34
     +     - 24*s12*s23*s34 - 24*s12*s24*s34 - 16*s12*s34**2 )

      LC = LC + Ld0(p2,p13,p4)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 )

      LC = LC + Ld0(p2,p13,p4)*S13**(-1)*S23**(-1) * (  - 16*s12**3 - 
     +    16*s12**2*s24 - 16*s12**2*s34 - 8*s12*s24**2 - 8*s12*s24*s34
     +     )

      LC = LC + Ld0(p2,p13,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 16*
     +    s12**2*s14*s23 + 16*s12*s14*s23**2 + 8*s14*s23**3 )

      LC = LC + Ld0(p2,p13,p4)*S13**(-1)*S24**(-1) * (  - 16*s12**3 + 
     +    16*s12**2*s14 + 16*s12*s14*s23 + 8*s12*s23**2 + 8*s12*s23*s34
     +     + 8*s14*s23**2 + 8*s23**3 + 8*s23**2*s34 )

      LC = LC + Ld0(p2,p13,p4)*S13**(-1)*S34**(-1) * ( 16*s12**2*s14 + 
     +    32*s12*s14*s23 + 16*s12*s14*s24 + 24*s14*s23**2 + 24*s14*s23*
     +    s24 + 8*s14*s24**2 )

      LC = LC + Ld0(p2,p13,p4)*S13**(-1) * (  - 16*s12**2 + 16*s12*s14
     +     + 8*s12*s23 - 8*s12*s24 + 16*s14*s23 + 8*s14*s24 + 24*s23**2
     +     + 24*s23*s24 + 16*s23*s34 + 8*s24**2 + 8*s24*s34 )

      LC = LC + Ld0(p2,p13,p4)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 - 16*s12**2*s13**2 - 16*s12**2*s13*s34 - 32*s12**2
     +    *s34**2 - 32*s12*s13**2*s34 - 8*s12*s13*s34**2 )

      LC = LC + Ld0(p2,p13,p4)*S14**(-1)*S23**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s13*s24 - 16*s12*s13*s24**2 - 8*s13*s24**3 )

      LC = LC + Ld0(p2,p13,p4)*S14**(-1)*S23**(-1) * (  - 16*s12**3 - 
     +    48*s12**2*s13 - 32*s12**2*s24 - 64*s12**2*s34 + 8*s12*s13**2
     +     - 16*s12*s13*s24 - 32*s12*s13*s34 - 24*s12*s24**2 - 24*s12*
     +    s24*s34 - 8*s13*s24**2 - 8*s24**3 - 8*s24**2*s34 )

      LC = LC + Ld0(p2,p13,p4)*S14**(-1)*S24**(-1) * (  - 16*s12**3 - 
     +    32*s12**2*s13 - 16*s12**2*s23 - 48*s12**2*s34 - 16*s12*s13**2
     +     - 32*s12*s13*s34 - 8*s12*s23**2 - 8*s12*s23*s34 + 8*s13**2*
     +    s23 - 8*s13**2*s34 - 16*s13*s23*s34 )

      LC = LC + Ld0(p2,p13,p4)*S14**(-1)*S34**(-1) * (  - 16*s12**2*s13
     +     - 16*s12*s13*s23 - 32*s12*s13*s24 - 8*s13*s23**2 - 24*s13*
     +    s23*s24 - 24*s13*s24**2 )

      LC = LC + Ld0(p2,p13,p4)*S14**(-1) * (  - 48*s12**2 - 16*s12*s13
     +     - 40*s12*s23 - 56*s12*s24 - 32*s12*s34 + 16*s13**2 - 8*s13*
     +    s23 - 16*s13*s24 - 8*s13*s34 - 8*s23**2 - 24*s23*s24 - 8*s23*
     +    s34 - 24*s24**2 - 16*s24*s34 )

      LC = LC + Ld0(p2,p13,p4)*S23**(-1)*S24**(-1) * ( 8*s12**2*s13 - 
     +    40*s12**2*s34 - 8*s12*s13**2 - 8*s12*s13*s14 - 24*s12*s13*s34
     +     )

      LC = LC + Ld0(p2,p13,p4)*S23**(-1)*S34**(-1) * (  - 16*s12**2*s24
     +     - 16*s12*s24**2 - 8*s24**3 )

      LC = LC + Ld0(p2,p13,p4)*S23**(-1) * (  - 48*s12**2 - 16*s12*s13
     +     - 16*s12*s24 - 8*s24**2 )

      LC = LC + Ld0(p2,p13,p4)*S24**(-1)*S34**(-1) * ( 16*s12**2*s23 + 
     +    16*s12*s23**2 + 8*s23**3 )

      LC = LC + Ld0(p2,p13,p4)*S24**(-1) * (  - 16*s12**2 - 8*s12*s13
     +     + 8*s12*s14 + 16*s12*s23 - 8*s12*s34 + 8*s13**2 + 8*s13*s14
     +     + 16*s13*s23 + 8*s14*s23 + 8*s23**2 )

      LC = LC + Ld0(p2,p13,p4)*S34**(-1) * ( 16*s12*s23 - 16*s12*s24 + 
     +    16*s23**2 - 16*s24**2 )

      LC = LC + Ld0(p2,p13,p4) * ( 8*s13 + 8*s23 - 8*s24 )

      LC = LC + Ld0(p2,p14,p3)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 16*s12**3*s34**2 )

      LC = LC + Ld0(p2,p14,p3)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16*
     +    s12**3*s34 - 16*s12**2*s24*s34 - 16*s12**2*s34**2 - 8*s12*
     +    s24**2*s34 - 8*s12*s24*s34**2 )

      LC = LC + Ld0(p2,p14,p3)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 - 16*s12**2*s23*s34 - 16*s12**2*s34**2 - 8*s12*
     +    s23**2*s34 - 8*s12*s23*s34**2 )

      LC = LC + Ld0(p2,p14,p3)*S13**(-1)*S14**(-1) * (  - 32*s12**2*s34
     +     - 24*s12*s23*s34 - 24*s12*s24*s34 - 16*s12*s34**2 )

      LC = LC + Ld0(p2,p14,p3)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 - 16*s12**2*s14**2 - 16*s12**2*s14*s34 - 32*s12**2
     +    *s34**2 - 32*s12*s14**2*s34 - 8*s12*s14*s34**2 )

      LC = LC + Ld0(p2,p14,p3)*S13**(-1)*S23**(-1) * (  - 16*s12**3 - 
     +    32*s12**2*s14 - 16*s12**2*s24 - 48*s12**2*s34 - 16*s12*s14**2
     +     - 32*s12*s14*s34 - 8*s12*s24**2 - 8*s12*s24*s34 + 8*s14**2*
     +    s24 - 8*s14**2*s34 - 16*s14*s24*s34 )

      LC = LC + Ld0(p2,p14,p3)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 16*
     +    s12**2*s14*s23 - 16*s12*s14*s23**2 - 8*s14*s23**3 )

      LC = LC + Ld0(p2,p14,p3)*S13**(-1)*S24**(-1) * (  - 16*s12**3 - 
     +    48*s12**2*s14 - 32*s12**2*s23 - 64*s12**2*s34 + 8*s12*s14**2
     +     - 16*s12*s14*s23 - 32*s12*s14*s34 - 24*s12*s23**2 - 24*s12*
     +    s23*s34 - 8*s14*s23**2 - 8*s23**3 - 8*s23**2*s34 )

      LC = LC + Ld0(p2,p14,p3)*S13**(-1)*S34**(-1) * (  - 16*s12**2*s14
     +     - 32*s12*s14*s23 - 16*s12*s14*s24 - 24*s14*s23**2 - 24*s14*
     +    s23*s24 - 8*s14*s24**2 )

      LC = LC + Ld0(p2,p14,p3)*S13**(-1) * (  - 48*s12**2 - 16*s12*s14
     +     - 56*s12*s23 - 40*s12*s24 - 32*s12*s34 + 16*s14**2 - 16*s14*
     +    s23 - 8*s14*s24 - 8*s14*s34 - 24*s23**2 - 24*s23*s24 - 16*s23
     +    *s34 - 8*s24**2 - 8*s24*s34 )

      LC = LC + Ld0(p2,p14,p3)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34 )

      LC = LC + Ld0(p2,p14,p3)*S14**(-1)*S23**(-1)*S34**(-1) * ( 16*
     +    s12**2*s13*s24 + 16*s12*s13*s24**2 + 8*s13*s24**3 )

      LC = LC + Ld0(p2,p14,p3)*S14**(-1)*S23**(-1) * (  - 16*s12**3 + 
     +    16*s12**2*s13 + 16*s12*s13*s24 + 8*s12*s24**2 + 8*s12*s24*s34
     +     + 8*s13*s24**2 + 8*s24**3 + 8*s24**2*s34 )

      LC = LC + Ld0(p2,p14,p3)*S14**(-1)*S24**(-1) * (  - 16*s12**3 - 
     +    16*s12**2*s23 - 16*s12**2*s34 - 8*s12*s23**2 - 8*s12*s23*s34
     +     )

      LC = LC + Ld0(p2,p14,p3)*S14**(-1)*S34**(-1) * ( 16*s12**2*s13 + 
     +    16*s12*s13*s23 + 32*s12*s13*s24 + 8*s13*s23**2 + 24*s13*s23*
     +    s24 + 24*s13*s24**2 )

      LC = LC + Ld0(p2,p14,p3)*S14**(-1) * (  - 16*s12**2 + 16*s12*s13
     +     - 8*s12*s23 + 8*s12*s24 + 8*s13*s23 + 16*s13*s24 + 8*s23**2
     +     + 24*s23*s24 + 8*s23*s34 + 24*s24**2 + 16*s24*s34 )

      LC = LC + Ld0(p2,p14,p3)*S23**(-1)*S24**(-1) * ( 8*s12**2*s14 - 
     +    40*s12**2*s34 - 8*s12*s13*s14 - 8*s12*s14**2 - 24*s12*s14*s34
     +     )

      LC = LC + Ld0(p2,p14,p3)*S23**(-1)*S34**(-1) * ( 16*s12**2*s24 + 
     +    16*s12*s24**2 + 8*s24**3 )

      LC = LC + Ld0(p2,p14,p3)*S23**(-1) * (  - 16*s12**2 + 8*s12*s13
     +     - 8*s12*s14 + 16*s12*s24 - 8*s12*s34 + 8*s13*s14 + 8*s13*s24
     +     + 8*s14**2 + 16*s14*s24 + 8*s24**2 )

      LC = LC + Ld0(p2,p14,p3)*S24**(-1)*S34**(-1) * (  - 16*s12**2*s23
     +     - 16*s12*s23**2 - 8*s23**3 )

      LC = LC + Ld0(p2,p14,p3)*S24**(-1) * (  - 48*s12**2 - 16*s12*s14
     +     - 16*s12*s23 - 8*s23**2 )

      LC = LC + Ld0(p2,p14,p3)*S34**(-1) * (  - 16*s12*s23 + 16*s12*s24
     +     - 16*s23**2 + 16*s24**2 )

      LC = LC + Ld0(p2,p14,p3) * ( 8*s14 - 8*s23 + 8*s24 )

      LC = LC + Ld0(p3,p1,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 32*s12**3*s34**2 )

      LC = LC + Ld0(p3,p1,p4)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 32*
     +    s12**3*s34 - 16*s12**2*s24*s34 - 16*s12**2*s34**2 + 8*s24**3*
     +    s34 + 8*s24**2*s34**2 )

      LC = LC + Ld0(p3,p1,p4)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 32*
     +    s12**3*s34 - 16*s12**2*s23*s34 - 16*s12**2*s34**2 + 8*s23**3*
     +    s34 + 8*s23**2*s34**2 )

      LC = LC + Ld0(p3,p1,p4)*S13**(-1)*S14**(-1) * (  - 32*s12**2*s34
     +     + 32*s23**2*s34 + 48*s23*s24*s34 + 24*s23*s34**2 + 32*s24**2
     +    *s34 + 24*s24*s34**2 )

      LC = LC + Ld0(p3,p1,p4)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s14 - 48*s12**3*s34 - 16*s12**2*s14*s34 - 16*s12**2*
     +    s34**2 - 8*s12*s14**2*s34 - 8*s12*s14*s34**2 )

      LC = LC + Ld0(p3,p1,p4)*S13**(-1)*S23**(-1) * (  - 64*s12**3 - 32
     +    *s12**2*s14 - 48*s12**2*s24 - 80*s12**2*s34 - 16*s12*s14**2
     +     + 24*s12*s14*s24 - 16*s12*s24**2 - 8*s12*s24*s34 + 8*s14**2*
     +    s24 + 8*s14**2*s34 + 8*s14*s24*s34 + 8*s14*s34**2 + 8*s24**3
     +     + 8*s24**2*s34 )

      LC = LC + Ld0(p3,p1,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 24*
     +    s12**2*s14*s23 - 24*s12*s14**2*s23 - 24*s12*s14*s23**2 - 24*
     +    s14**3*s23 - 16*s14**2*s23**2 )

      LC = LC + Ld0(p3,p1,p4)*S13**(-1)*S24**(-1) * (  - 64*s12**3 - 40
     +    *s12**2*s14 - 56*s12**2*s23 - 56*s12**2*s34 - 32*s12*s14**2
     +     - 80*s12*s14*s23 - 56*s12*s14*s34 - 48*s12*s23**2 - 56*s12*
     +    s23*s34 - 24*s12*s34**2 - 16*s14**3 - 48*s14**2*s23 - 32*
     +    s14**2*s34 - 24*s14*s23**2 - 48*s14*s23*s34 - 24*s14*s34**2
     +     - 8*s23**3 - 16*s23**2*s34 - 24*s23*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p3,p1,p4)*S13**(-1)*S34**(-1) * ( 24*s12**2*s14 - 
     +    24*s12*s14*s23 - 8*s14**3 - 16*s14**2*s23 )

      LC = LC + Ld0(p3,p1,p4)*S13**(-1)*S134**(-1) * ( 72*s12*s14*s23
     +     + 72*s12*s14*s24 + 72*s12*s14*s34 + 40*s12*s23*s34 + 40*s12*
     +    s24*s34 + 40*s12*s34**2 + 72*s14*s23**2 + 144*s14*s23*s24 + 
     +    72*s14*s23*s34 + 72*s14*s24**2 + 72*s14*s24*s34 + 40*s23**2*
     +    s34 + 80*s23*s24*s34 + 40*s23*s34**2 + 40*s24**2*s34 + 40*s24
     +    *s34**2 )

      LC = LC + Ld0(p3,p1,p4)*S13**(-1) * (  - 104*s12**2 - 8*s12*s14
     +     - 128*s12*s23 - 96*s12*s24 - 104*s12*s34 - 8*s14**2 + 16*s14
     +    *s23 + 32*s14*s24 + 24*s14*s34 - 48*s23**2 - 80*s23*s24 - 56*
     +    s23*s34 - 32*s24**2 - 40*s24*s34 - 8*s34**2 )

      LC = LC + Ld0(p3,p1,p4)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s13 - 48*s12**3*s34 - 16*s12**2*s13*s34 - 16*s12**2*
     +    s34**2 - 8*s12*s13**2*s34 - 8*s12*s13*s34**2 )

      LC = LC + Ld0(p3,p1,p4)*S14**(-1)*S23**(-1)*S34**(-1) * ( 24*
     +    s12**2*s13*s24 - 24*s12*s13**2*s24 - 24*s12*s13*s24**2 - 24*
     +    s13**3*s24 - 16*s13**2*s24**2 )

      LC = LC + Ld0(p3,p1,p4)*S14**(-1)*S23**(-1) * (  - 64*s12**3 - 40
     +    *s12**2*s13 - 56*s12**2*s24 - 56*s12**2*s34 - 32*s12*s13**2
     +     - 80*s12*s13*s24 - 56*s12*s13*s34 - 48*s12*s24**2 - 56*s12*
     +    s24*s34 - 24*s12*s34**2 - 16*s13**3 - 48*s13**2*s24 - 32*
     +    s13**2*s34 - 24*s13*s24**2 - 48*s13*s24*s34 - 24*s13*s34**2
     +     - 8*s24**3 - 16*s24**2*s34 - 24*s24*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p3,p1,p4)*S14**(-1)*S24**(-1) * (  - 64*s12**3 - 32
     +    *s12**2*s13 - 48*s12**2*s23 - 80*s12**2*s34 - 16*s12*s13**2
     +     + 24*s12*s13*s23 - 16*s12*s23**2 - 8*s12*s23*s34 + 8*s13**2*
     +    s23 + 8*s13**2*s34 + 8*s13*s23*s34 + 8*s13*s34**2 + 8*s23**3
     +     + 8*s23**2*s34 )

      LC = LC + Ld0(p3,p1,p4)*S14**(-1)*S34**(-1) * ( 24*s12**2*s13 - 
     +    24*s12*s13*s24 - 8*s13**3 - 16*s13**2*s24 )

      LC = LC + Ld0(p3,p1,p4)*S14**(-1)*S134**(-1) * ( 72*s12*s13*s23
     +     + 72*s12*s13*s24 + 72*s12*s13*s34 + 40*s12*s23*s34 + 40*s12*
     +    s24*s34 + 40*s12*s34**2 + 72*s13*s23**2 + 144*s13*s23*s24 + 
     +    72*s13*s23*s34 + 72*s13*s24**2 + 72*s13*s24*s34 + 40*s23**2*
     +    s34 + 80*s23*s24*s34 + 40*s23*s34**2 + 40*s24**2*s34 + 40*s24
     +    *s34**2 )

      LC = LC + Ld0(p3,p1,p4)*S14**(-1) * (  - 104*s12**2 - 8*s12*s13
     +     - 96*s12*s23 - 128*s12*s24 - 104*s12*s34 - 8*s13**2 + 32*s13
     +    *s23 + 16*s13*s24 + 24*s13*s34 - 32*s23**2 - 80*s23*s24 - 40*
     +    s23*s34 - 48*s24**2 - 56*s24*s34 - 8*s34**2 )

      LC = LC + Ld0(p3,p1,p4)*S23**(-1)*S24**(-1) * (  - 32*s12**3 - 32
     +    *s12**2*s13 - 32*s12**2*s14 - 64*s12**2*s34 - 8*s12*s13**2 - 
     +    16*s12*s13*s14 - 16*s12*s13*s34 - 8*s12*s14**2 - 16*s12*s14*
     +    s34 )

      LC = LC + Ld0(p3,p1,p4)*S23**(-1)*S34**(-1) * ( 24*s12**2*s24 + 8
     +    *s12*s13*s24 + 32*s12*s14*s24 - 40*s13**2*s24 - 8*s13*s14*s24
     +     - 16*s13*s24**2 + 8*s14**2*s24 )

      LC = LC + Ld0(p3,p1,p4)*S23**(-1) * (  - 72*s12**2 + 16*s12*s14
     +     + 32*s12*s24 + 8*s12*s34 - 16*s13**2 + 8*s13*s14 - 16*s13*
     +    s24 - 16*s13*s34 + 8*s14**2 + 24*s14*s24 + 16*s14*s34 + 8*
     +    s24**2 - 8*s34**2 )

      LC = LC + Ld0(p3,p1,p4)*S24**(-1)*S34**(-1) * ( 24*s12**2*s23 + 
     +    32*s12*s13*s23 + 8*s12*s14*s23 + 8*s13**2*s23 - 8*s13*s14*s23
     +     - 40*s14**2*s23 - 16*s14*s23**2 )

      LC = LC + Ld0(p3,p1,p4)*S24**(-1) * (  - 72*s12**2 + 16*s12*s13
     +     + 32*s12*s23 + 8*s12*s34 + 8*s13**2 + 8*s13*s14 + 24*s13*s23
     +     + 16*s13*s34 - 16*s14**2 - 16*s14*s23 - 16*s14*s34 + 8*
     +    s23**2 - 8*s34**2 )

      LC = LC + Ld0(p3,p1,p4)*S34**(-1) * ( 48*s12**2 + 112*s12*s13 + 
     +    112*s12*s14 + 48*s12*s23 + 48*s12*s24 + 32*s13**2 + 80*s13*
     +    s14 + 32*s13*s23 + 16*s13*s24 + 32*s14**2 + 16*s14*s23 + 32*
     +    s14*s24 )

      LC = LC + Ld0(p3,p1,p4)*S134**(-1) * ( 80*s12*s23 + 80*s12*s24 + 
     +    80*s12*s34 + 80*s23**2 + 160*s23*s24 + 80*s23*s34 + 80*s24**2
     +     + 80*s24*s34 )

      LC = LC + Ld0(p3,p1,p4) * ( 96*s12 + 40*s13 + 40*s14 + 16*s23 + 
     +    16*s24 )

      LC = LC + Ld0(p3,p1,p24)*S13**(-1)*S14**(-1)*S23**(-1)*S234 * ( 
     +     - 8*s12*s24*s34 - 8*s24**2*s34 )

      LC = LC + Ld0(p3,p1,p24)*S13**(-1)*S14**(-1)*S234 * ( 16*s12*s23
     +     - 8*s23**2 - 8*s23*s34 - 16*s24*s34 )

      LC = LC + Ld0(p3,p1,p24)*S13**(-1)*S23**(-1)*S234 * (  - 16*s12*
     +    s14 - 8*s12*s24 - 16*s12*s34 - 8*s14**2 - 8*s14*s34 - 8*
     +    s24**2 )

      LC = LC + Ld0(p3,p1,p24)*S13**(-1)*S234 * (  - 16*s12 - 8*s14 + 8
     +    *s23 - 8*s34 )

      LC = LC + Ld0(p3,p1,p24)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s13 + 16*s12**3*s34 )

      LC = LC + Ld0(p3,p1,p24)*S14**(-1)*S23**(-1)*S234 * (  - 8*s12*
     +    s24 - 8*s24**2 )

      LC = LC + Ld0(p3,p1,p24)*S14**(-1)*S23**(-1) * (  - 8*s12*s13*s24
     +     - 8*s12*s24*s34 - 8*s13*s24**2 - 8*s24**2*s34 )

      LC = LC + Ld0(p3,p1,p24)*S14**(-1)*S24**(-1)*S234 * (  - 8*s12*
     +    s13 - 8*s12*s34 )

      LC = LC + Ld0(p3,p1,p24)*S14**(-1)*S234 * ( 24*s12 + 16*s23 - 8*
     +    s24 + 16*s34 )

      LC = LC + Ld0(p3,p1,p24)*S23**(-1)*S24**(-1) * ( 16*s12**3 + 32*
     +    s12**2*s13 + 32*s12**2*s14 + 32*s12**2*s34 + 24*s12*s13*s14
     +     + 24*s12*s14**2 + 24*s12*s14*s34 + 8*s13*s14**2 + 8*s14**3
     +     + 8*s14**2*s34 )

      LC = LC + Ld0(p3,p1,p24)*S23**(-1)*S234 * (  - 16*s12 - 8*s14 )

      LC = LC + Ld0(p3,p1,p24)*S23**(-1) * (  - 16*s12*s13 - 16*s12*s14
     +     - 8*s12*s24 - 16*s12*s34 - 8*s13*s14 - 8*s14**2 - 8*s14*s34
     +     - 8*s24**2 )

      LC = LC + Ld0(p3,p1,p24)*S24**(-1)*S234 * (  - 8*s12 - 8*s13 - 8*
     +    s14 - 8*s34 )

      LC = LC + Ld0(p3,p1,p24)*S234 * ( 8 )

      LC = LC + Ld0(p3,p2,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * (  - 32*s12**3*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16*
     +    s12**3*s24 - 48*s12**3*s34 - 16*s12**2*s24*s34 - 16*s12**2*
     +    s34**2 - 8*s12*s24**2*s34 - 8*s12*s24*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s23 - 48*s12**3*s34 - 16*s12**2*s23*s34 - 16*s12**2*
     +    s34**2 - 8*s12*s23**2*s34 - 8*s12*s23*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S13**(-1)*S14**(-1) * (  - 32*s12**3 - 32
     +    *s12**2*s23 - 32*s12**2*s24 - 64*s12**2*s34 - 8*s12*s23**2 - 
     +    16*s12*s23*s24 - 16*s12*s23*s34 - 8*s12*s24**2 - 16*s12*s24*
     +    s34 )

      LC = LC + Ld0(p3,p2,p4)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 32*
     +    s12**3*s34 - 16*s12**2*s14*s34 - 16*s12**2*s34**2 + 8*s14**3*
     +    s34 + 8*s14**2*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S13**(-1)*S23**(-1) * (  - 64*s12**3 - 48
     +    *s12**2*s14 - 32*s12**2*s24 - 80*s12**2*s34 - 16*s12*s14**2
     +     + 24*s12*s14*s24 - 8*s12*s14*s34 - 16*s12*s24**2 + 8*s14**3
     +     + 8*s14**2*s34 + 8*s14*s24**2 + 8*s14*s24*s34 + 8*s24**2*s34
     +     + 8*s24*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S13**(-1)*S24**(-1)*S34**(-1) * ( 24*
     +    s12**2*s14*s23 - 24*s12*s14**2*s23 - 24*s12*s14*s23**2 - 16*
     +    s14**2*s23**2 - 24*s14*s23**3 )

      LC = LC + Ld0(p3,p2,p4)*S13**(-1)*S24**(-1) * (  - 64*s12**3 - 56
     +    *s12**2*s14 - 40*s12**2*s23 - 56*s12**2*s34 - 48*s12*s14**2
     +     - 80*s12*s14*s23 - 56*s12*s14*s34 - 32*s12*s23**2 - 56*s12*
     +    s23*s34 - 24*s12*s34**2 - 8*s14**3 - 24*s14**2*s23 - 16*
     +    s14**2*s34 - 48*s14*s23**2 - 48*s14*s23*s34 - 24*s14*s34**2
     +     - 16*s23**3 - 32*s23**2*s34 - 24*s23*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p3,p2,p4)*S13**(-1)*S34**(-1) * ( 24*s12**2*s14 + 8
     +    *s12*s14*s23 + 32*s12*s14*s24 - 16*s14**2*s23 - 40*s14*s23**2
     +     - 8*s14*s23*s24 + 8*s14*s24**2 )

      LC = LC + Ld0(p3,p2,p4)*S13**(-1) * (  - 72*s12**2 + 32*s12*s14
     +     + 16*s12*s24 + 8*s12*s34 + 8*s14**2 - 16*s14*s23 + 24*s14*
     +    s24 - 16*s23**2 + 8*s23*s24 - 16*s23*s34 + 8*s24**2 + 16*s24*
     +    s34 - 8*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 32*
     +    s12**3*s34 - 16*s12**2*s13*s34 - 16*s12**2*s34**2 + 8*s13**3*
     +    s34 + 8*s13**2*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S14**(-1)*S23**(-1)*S34**(-1) * ( 24*
     +    s12**2*s13*s24 - 24*s12*s13**2*s24 - 24*s12*s13*s24**2 - 16*
     +    s13**2*s24**2 - 24*s13*s24**3 )

      LC = LC + Ld0(p3,p2,p4)*S14**(-1)*S23**(-1) * (  - 64*s12**3 - 56
     +    *s12**2*s13 - 40*s12**2*s24 - 56*s12**2*s34 - 48*s12*s13**2
     +     - 80*s12*s13*s24 - 56*s12*s13*s34 - 32*s12*s24**2 - 56*s12*
     +    s24*s34 - 24*s12*s34**2 - 8*s13**3 - 24*s13**2*s24 - 16*
     +    s13**2*s34 - 48*s13*s24**2 - 48*s13*s24*s34 - 24*s13*s34**2
     +     - 16*s24**3 - 32*s24**2*s34 - 24*s24*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p3,p2,p4)*S14**(-1)*S24**(-1) * (  - 64*s12**3 - 48
     +    *s12**2*s13 - 32*s12**2*s23 - 80*s12**2*s34 - 16*s12*s13**2
     +     + 24*s12*s13*s23 - 8*s12*s13*s34 - 16*s12*s23**2 + 8*s13**3
     +     + 8*s13**2*s34 + 8*s13*s23**2 + 8*s13*s23*s34 + 8*s23**2*s34
     +     + 8*s23*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S14**(-1)*S34**(-1) * ( 24*s12**2*s13 + 
     +    32*s12*s13*s23 + 8*s12*s13*s24 - 16*s13**2*s24 + 8*s13*s23**2
     +     - 8*s13*s23*s24 - 40*s13*s24**2 )

      LC = LC + Ld0(p3,p2,p4)*S14**(-1) * (  - 72*s12**2 + 32*s12*s13
     +     + 16*s12*s23 + 8*s12*s34 + 8*s13**2 + 24*s13*s23 - 16*s13*
     +    s24 + 8*s23**2 + 8*s23*s24 + 16*s23*s34 - 16*s24**2 - 16*s24*
     +    s34 - 8*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S23**(-1)*S24**(-1) * (  - 32*s12**2*s34
     +     + 32*s13**2*s34 + 48*s13*s14*s34 + 24*s13*s34**2 + 32*s14**2
     +    *s34 + 24*s14*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S23**(-1)*S34**(-1) * ( 24*s12**2*s24 - 
     +    24*s12*s13*s24 - 16*s13*s24**2 - 8*s24**3 )

      LC = LC + Ld0(p3,p2,p4)*S23**(-1)*S234**(-1) * ( 72*s12*s13*s24
     +     + 40*s12*s13*s34 + 72*s12*s14*s24 + 40*s12*s14*s34 + 72*s12*
     +    s24*s34 + 40*s12*s34**2 + 72*s13**2*s24 + 40*s13**2*s34 + 144
     +    *s13*s14*s24 + 80*s13*s14*s34 + 72*s13*s24*s34 + 40*s13*
     +    s34**2 + 72*s14**2*s24 + 40*s14**2*s34 + 72*s14*s24*s34 + 40*
     +    s14*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S23**(-1) * (  - 104*s12**2 - 128*s12*s13
     +     - 96*s12*s14 - 8*s12*s24 - 104*s12*s34 - 48*s13**2 - 80*s13*
     +    s14 + 16*s13*s24 - 56*s13*s34 - 32*s14**2 + 32*s14*s24 - 40*
     +    s14*s34 - 8*s24**2 + 24*s24*s34 - 8*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S24**(-1)*S34**(-1) * ( 24*s12**2*s23 - 
     +    24*s12*s14*s23 - 16*s14*s23**2 - 8*s23**3 )

      LC = LC + Ld0(p3,p2,p4)*S24**(-1)*S234**(-1) * ( 72*s12*s13*s23
     +     + 40*s12*s13*s34 + 72*s12*s14*s23 + 40*s12*s14*s34 + 72*s12*
     +    s23*s34 + 40*s12*s34**2 + 72*s13**2*s23 + 40*s13**2*s34 + 144
     +    *s13*s14*s23 + 80*s13*s14*s34 + 72*s13*s23*s34 + 40*s13*
     +    s34**2 + 72*s14**2*s23 + 40*s14**2*s34 + 72*s14*s23*s34 + 40*
     +    s14*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S24**(-1) * (  - 104*s12**2 - 96*s12*s13
     +     - 128*s12*s14 - 8*s12*s23 - 104*s12*s34 - 32*s13**2 - 80*s13
     +    *s14 + 32*s13*s23 - 40*s13*s34 - 48*s14**2 + 16*s14*s23 - 56*
     +    s14*s34 - 8*s23**2 + 24*s23*s34 - 8*s34**2 )

      LC = LC + Ld0(p3,p2,p4)*S34**(-1) * ( 48*s12**2 + 48*s12*s13 + 48
     +    *s12*s14 + 112*s12*s23 + 112*s12*s24 + 32*s13*s23 + 16*s13*
     +    s24 + 16*s14*s23 + 32*s14*s24 + 32*s23**2 + 80*s23*s24 + 32*
     +    s24**2 )

      LC = LC + Ld0(p3,p2,p4)*S234**(-1) * ( 80*s12*s13 + 80*s12*s14 + 
     +    80*s12*s34 + 80*s13**2 + 160*s13*s14 + 80*s13*s34 + 80*s14**2
     +     + 80*s14*s34 )

      LC = LC + Ld0(p3,p2,p4) * ( 96*s12 + 16*s13 + 16*s14 + 40*s23 + 
     +    40*s24 )

      LC = LC + Ld0(p3,p2,p14)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s23 + 16*s12**3*s34 )

      LC = LC + Ld0(p3,p2,p14)*S13**(-1)*S14**(-1) * ( 16*s12**3 + 32*
     +    s12**2*s23 + 32*s12**2*s24 + 32*s12**2*s34 + 24*s12*s23*s24
     +     + 24*s12*s24**2 + 24*s12*s24*s34 + 8*s23*s24**2 + 8*s24**3
     +     + 8*s24**2*s34 )

      LC = LC + Ld0(p3,p2,p14)*S13**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +     - 8*s12*s14*s34 - 8*s14**2*s34 )

      LC = LC + Ld0(p3,p2,p14)*S13**(-1)*S23**(-1)*S134 * (  - 8*s12*
     +    s14 - 16*s12*s24 - 16*s12*s34 - 8*s14**2 - 8*s24**2 - 8*s24*
     +    s34 )

      LC = LC + Ld0(p3,p2,p14)*S13**(-1)*S24**(-1)*S134 * (  - 8*s12*
     +    s14 - 8*s14**2 )

      LC = LC + Ld0(p3,p2,p14)*S13**(-1)*S24**(-1) * (  - 8*s12*s14*s23
     +     - 8*s12*s14*s34 - 8*s14**2*s23 - 8*s14**2*s34 )

      LC = LC + Ld0(p3,p2,p14)*S13**(-1)*S134 * (  - 16*s12 - 8*s24 )

      LC = LC + Ld0(p3,p2,p14)*S13**(-1) * (  - 8*s12*s14 - 16*s12*s23
     +     - 16*s12*s24 - 16*s12*s34 - 8*s14**2 - 8*s23*s24 - 8*s24**2
     +     - 8*s24*s34 )

      LC = LC + Ld0(p3,p2,p14)*S14**(-1)*S24**(-1)*S134 * (  - 8*s12*
     +    s23 - 8*s12*s34 )

      LC = LC + Ld0(p3,p2,p14)*S14**(-1)*S134 * (  - 8*s12 - 8*s23 - 8*
     +    s24 - 8*s34 )

      LC = LC + Ld0(p3,p2,p14)*S23**(-1)*S24**(-1)*S134 * ( 16*s12*s13
     +     - 8*s13**2 - 8*s13*s34 - 16*s14*s34 )

      LC = LC + Ld0(p3,p2,p14)*S23**(-1)*S134 * (  - 16*s12 + 8*s13 - 8
     +    *s24 - 8*s34 )

      LC = LC + Ld0(p3,p2,p14)*S24**(-1)*S134 * ( 24*s12 + 16*s13 - 8*
     +    s14 + 16*s34 )

      LC = LC + Ld0(p3,p2,p14)*S134 * ( 8 )

      LC = LC + Ld0(p3,p4,p12)*S13**(-1)*S14**(-1) * ( 8*s12*s23*s34 + 
     +    8*s12*s24*s34 + 8*s12*s34**2 + 8*s23**2*s34 + 16*s23*s24*s34
     +     + 8*s23*s34**2 + 8*s24**2*s34 + 8*s24*s34**2 )

      LC = LC + Ld0(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 48*
     +    s12**3*s14 - 192*s12**3*s34 - 528*s12**2*s14**2 + 1312*s12**2
     +    *s14*s34 - 424*s12**2*s34**2 + 144*s12*s14**3 - 560*s12*
     +    s14**2*s34 + 248*s12*s14*s34**2 + 16*s12*s34**3 - 48*s14**3*
     +    s34 + 48*s14**2*s34**2 )

      LC = LC + Ld0(p3,p4,p12)*S13**(-1)*S23**(-1) * ( 32*s12**3 - 64*
     +    s12**2*s14 + 48*s12**2*s24 + 40*s12**2*s34 - 24*s12*s14**2 - 
     +    24*s12*s14*s24 + 136*s12*s14*s34 + 32*s12*s24**2 + 16*s12*s24
     +    *s34 - 96*s12*s34**2 + 8*s14**3 - 48*s14**2*s34 + 48*s14*
     +    s34**2 + 8*s24**3 )

      LC = LC + Ld0(p3,p4,p12)*S13**(-1)*S24**(-1)*S34**(-1) * ( 96*s12
     +    *s14**3 - 96*s12*s14**2*s23 )

      LC = LC + Ld0(p3,p4,p12)*S13**(-1)*S24**(-1) * ( 40*s12**3 + 312*
     +    s12**2*s14 + 80*s12**2*s23 - 96*s12**2*s34 - 488*s12*s14**2
     +     + 160*s12*s14*s23 + 456*s12*s14*s34 + 24*s12*s23**2 + 64*s12
     +    *s23*s34 + 56*s12*s34**2 + 56*s14**3 - 40*s14**2*s23 + 8*
     +    s14**2*s34 - 8*s14*s23**2 - 16*s14*s23*s34 - 8*s14*s34**2 + 8
     +    *s23**3 + 24*s23**2*s34 + 16*s23*s34**2 )

      LC = LC + Ld0(p3,p4,p12)*S13**(-1) * ( 104*s12**2 - 16*s12*s14 + 
     +    64*s12*s23 + 72*s12*s24 - 8*s12*s34 - 40*s14**2 + 40*s14*s23
     +     - 8*s14*s24 + 88*s14*s34 + 16*s23**2 + 16*s23*s24 + 40*s23*
     +    s34 + 16*s24**2 + 16*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 48*
     +    s12**3*s13 - 192*s12**3*s34 + 48*s12**2*s13**2 - 176*s12**2*
     +    s13*s34 + 56*s12**2*s34**2 + 32*s12*s13**2*s34 - 40*s12*s13*
     +    s34**2 - 16*s12*s34**3 )

      LC = LC + Ld0(p3,p4,p12)*S14**(-1)*S23**(-1) * ( 40*s12**3 - 112*
     +    s12**2*s13 + 72*s12**2*s24 + 112*s12**2*s34 + 48*s12*s13**2
     +     - 128*s12*s13*s24 - 112*s12*s13*s34 + 48*s12*s24**2 + 56*s12
     +    *s24*s34 - 8*s12*s34**2 + 16*s13**2*s34 - 16*s13*s24**2 - 32*
     +    s13*s24*s34 - 16*s13*s34**2 + 16*s24**3 + 16*s24**2*s34 - 8*
     +    s24*s34**2 - 16*s34**3 )

      LC = LC + Ld0(p3,p4,p12)*S14**(-1)*S24**(-1) * ( 32*s12**3 - 16*
     +    s12**2*s13 + 48*s12**2*s23 + 88*s12**2*s34 - 24*s12*s13*s23
     +     - 48*s12*s13*s34 + 8*s12*s23**2 + 8*s12*s23*s34 )

      LC = LC + Ld0(p3,p4,p12)*S14**(-1) * ( 112*s12**2 - 72*s12*s13 + 
     +    8*s12*s23 + 48*s12*s24 - 8*s12*s34 - 8*s13*s23 - 8*s13*s24 - 
     +    24*s13*s34 - 8*s23**2 - 16*s23*s24 - 8*s23*s34 + 8*s24**2 - 8
     +    *s24*s34 - 8*s34**2 )

      LC = LC + Ld0(p3,p4,p12)*S23**(-1)*S24**(-1)*S34**(-1) * ( 96*s12
     +    *s13*s14**2 + 96*s12*s14**3 )

      LC = LC + Ld0(p3,p4,p12)*S23**(-1)*S24**(-1) * (  - 96*s12**3 - 
     +    576*s12**2*s13 - 1152*s12**2*s14 + 1376*s12**2*s34 + 56*s12*
     +    s13**2 - 80*s12*s13*s14 + 32*s12*s13*s34 + 104*s12*s14**2 - 
     +    1568*s12*s14*s34 - 184*s12*s34**2 + 8*s13**3 + 8*s13**2*s14
     +     + 48*s13**2*s34 + 136*s13*s14**2 + 32*s13*s14*s34 + 40*s13*
     +    s34**2 + 136*s14**3 - 208*s14**2*s34 - 8*s14*s34**2 )

      LC = LC + Ld0(p3,p4,p12)*S23**(-1) * (  - 152*s12**2 - 280*s12*
     +    s13 - 256*s12*s14 - 40*s12*s24 + 64*s12*s34 + 8*s13**2 + 24*
     +    s13*s14 - 64*s13*s24 - 8*s13*s34 + 48*s14**2 - 8*s14*s24 - 
     +    296*s14*s34 + 24*s24**2 - 8*s34**2 )

      LC = LC + Ld0(p3,p4,p12)*S24**(-1)*S34**(-1) * (  - 96*s12*s13*
     +    s14 - 96*s12*s14*s23 )

      LC = LC + Ld0(p3,p4,p12)*S24**(-1) * ( 336*s12**2 - 48*s12*s13 - 
     +    680*s12*s14 - 16*s12*s23 - 96*s12*s34 + 8*s13**2 - 8*s13*s14
     +     + 8*s13*s23 + 16*s13*s34 - 96*s14**2 - 16*s14*s23 - 24*s14*
     +    s34 + 16*s23**2 + 32*s23*s34 + 16*s34**2 )

      LC = LC + Ld0(p3,p4,p12) * ( 16*s12 + 8*s13 - 88*s14 + 16*s23 + 
     +    16*s24 + 16*s34 )

      LC = LC + Ld0(p3,p12,p4)*S13**(-1)*S14**(-1)*S23**(-1)*S24**(-1)
     +  * ( 32*s12**3*s34**2 )

      LC = LC + Ld0(p3,p12,p4)*S13**(-1)*S14**(-1)*S23**(-1) * ( 32*
     +    s12**3*s34 + 16*s12**2*s24*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s24**2*s34 + 8*s12*s24*s34**2 )

      LC = LC + Ld0(p3,p12,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 + 16*s12**2*s23*s34 + 16*s12**2*s34**2 + 8*s12*
     +    s23**2*s34 + 8*s12*s23*s34**2 )

      LC = LC + Ld0(p3,p12,p4)*S13**(-1)*S14**(-1) * ( 32*s12**2*s34 + 
     +    8*s12*s23*s34 + 8*s12*s24*s34 )

      LC = LC + Ld0(p3,p12,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 + 40*s12**2*s14**2 - 32*s12**2*s14*s34 + 16*s12**2
     +    *s34**2 + 8*s12*s14**2*s34 + 8*s12*s14*s34**2 )

      LC = LC + Ld0(p3,p12,p4)*S13**(-1)*S23**(-1) * ( 32*s12**3 + 32*
     +    s12**2*s14 - 8*s12**2*s24 - 16*s12**2*s34 + 8*s12*s14**2 + 8*
     +    s12*s14*s34 + 8*s12*s24**2 + 8*s12*s24*s34 )

      LC = LC + Ld0(p3,p12,p4)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 48*
     +    s12**2*s14**2 - 48*s12**2*s14*s23 - 80*s12*s14**2*s23 + 48*
     +    s12*s14*s23**2 + 8*s14**3*s23 - 16*s14**2*s23**2 + 24*s14*
     +    s23**3 )

      LC = LC + Ld0(p3,p12,p4)*S13**(-1)*S24**(-1) * ( 32*s12**3 - 16*
     +    s12**2*s14 - 56*s12**2*s23 - 40*s12**2*s34 - 24*s12*s14**2 + 
     +    48*s12*s14*s23 + 8*s12*s14*s34 + 8*s12*s23**2 + 8*s12*s23*s34
     +     + 8*s14**3 + 8*s14**2*s23 + 8*s14**2*s34 + 24*s14*s23**2 + 8
     +    *s23**3 + 8*s23**2*s34 )

      LC = LC + Ld0(p3,p12,p4)*S13**(-1)*S34**(-1) * (  - 48*s12**2*s14
     +     - 16*s12*s14**2 + 16*s12*s14*s23 - 32*s12*s14*s24 + 8*s14**3
     +     + 40*s14*s23**2 + 8*s14*s23*s24 - 8*s14*s24**2 )

      LC = LC + Ld0(p3,p12,p4)*S13**(-1) * (  - 16*s12**2 - 32*s12*s14
     +     - 24*s12*s23 - 24*s12*s24 - 32*s12*s34 + 8*s14**2 + 16*s14*
     +    s23 - 8*s14*s24 + 8*s23**2 - 8*s23*s24 - 8*s24**2 - 8*s24*s34
     +     )

      LC = LC + Ld0(p3,p12,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 32*
     +    s12**3*s34 + 40*s12**2*s13**2 - 32*s12**2*s13*s34 + 16*s12**2
     +    *s34**2 + 8*s12*s13**2*s34 + 8*s12*s13*s34**2 )

      LC = LC + Ld0(p3,p12,p4)*S14**(-1)*S23**(-1)*S34**(-1) * (  - 48*
     +    s12**2*s13**2 - 48*s12**2*s13*s24 - 80*s12*s13**2*s24 + 48*
     +    s12*s13*s24**2 + 8*s13**3*s24 - 16*s13**2*s24**2 + 24*s13*
     +    s24**3 )

      LC = LC + Ld0(p3,p12,p4)*S14**(-1)*S23**(-1) * ( 32*s12**3 - 16*
     +    s12**2*s13 - 56*s12**2*s24 - 40*s12**2*s34 - 24*s12*s13**2 + 
     +    48*s12*s13*s24 + 8*s12*s13*s34 + 8*s12*s24**2 + 8*s12*s24*s34
     +     + 8*s13**3 + 8*s13**2*s24 + 8*s13**2*s34 + 24*s13*s24**2 + 8
     +    *s24**3 + 8*s24**2*s34 )

      LC = LC + Ld0(p3,p12,p4)*S14**(-1)*S24**(-1) * ( 32*s12**3 + 32*
     +    s12**2*s13 - 8*s12**2*s23 - 16*s12**2*s34 + 8*s12*s13**2 + 8*
     +    s12*s13*s34 + 8*s12*s23**2 + 8*s12*s23*s34 )

      LC = LC + Ld0(p3,p12,p4)*S14**(-1)*S34**(-1) * (  - 48*s12**2*s13
     +     - 16*s12*s13**2 - 32*s12*s13*s23 + 16*s12*s13*s24 + 8*s13**3
     +     - 8*s13*s23**2 + 8*s13*s23*s24 + 40*s13*s24**2 )

      LC = LC + Ld0(p3,p12,p4)*S14**(-1) * (  - 16*s12**2 - 32*s12*s13
     +     - 24*s12*s23 - 24*s12*s24 - 32*s12*s34 + 8*s13**2 - 8*s13*
     +    s23 + 16*s13*s24 - 8*s23**2 - 8*s23*s24 - 8*s23*s34 + 8*
     +    s24**2 )

      LC = LC + Ld0(p3,p12,p4)*S23**(-1)*S24**(-1)*S34**(-1) * ( 48*
     +    s12**2*s13**2 + 96*s12**2*s13*s14 + 48*s12**2*s14**2 - 128*
     +    s12*s13**2*s14 - 128*s12*s13*s14**2 - 16*s13**3*s14 - 32*
     +    s13**2*s14**2 - 16*s13*s14**3 )

      LC = LC + Ld0(p3,p12,p4)*S23**(-1)*S24**(-1) * ( 72*s12**2*s13 + 
     +    72*s12**2*s14 - 16*s12**2*s34 + 16*s12*s13**2 + 192*s12*s13*
     +    s14 + 8*s12*s13*s34 + 16*s12*s14**2 + 8*s12*s14*s34 - 16*
     +    s13**2*s14 - 16*s13*s14**2 )

      LC = LC + Ld0(p3,p12,p4)*S23**(-1)*S34**(-1) * ( 48*s12**2*s13 + 
     +    96*s12**2*s14 - 48*s12**2*s24 - 64*s12*s13**2 + 16*s12*s13*
     +    s24 + 16*s12*s14**2 + 16*s13**3 - 32*s13**2*s14 - 24*s13**2*
     +    s24 - 32*s13*s14**2 + 8*s13*s14*s24 + 32*s13*s24**2 - 8*
     +    s14**2*s24 + 8*s24**3 )

      LC = LC + Ld0(p3,p12,p4)*S23**(-1) * ( 16*s12**2 + 72*s12*s13 + 
     +    24*s12*s14 - 32*s12*s24 - 32*s12*s34 + 24*s13**2 - 24*s13*s14
     +     + 32*s13*s24 - 8*s14**2 - 8*s14*s24 - 8*s14*s34 + 8*s24**2 )

      LC = LC + Ld0(p3,p12,p4)*S24**(-1)*S34**(-1) * ( 96*s12**2*s13 + 
     +    48*s12**2*s14 - 48*s12**2*s23 + 16*s12*s13**2 - 64*s12*s14**2
     +     + 16*s12*s14*s23 - 32*s13**2*s14 - 8*s13**2*s23 - 32*s13*
     +    s14**2 + 8*s13*s14*s23 + 16*s14**3 - 24*s14**2*s23 + 32*s14*
     +    s23**2 + 8*s23**3 )

      LC = LC + Ld0(p3,p12,p4)*S24**(-1) * ( 16*s12**2 + 24*s12*s13 + 
     +    72*s12*s14 - 32*s12*s23 - 32*s12*s34 - 8*s13**2 - 24*s13*s14
     +     - 8*s13*s23 - 8*s13*s34 + 24*s14**2 + 32*s14*s23 + 8*s23**2
     +     )

      LC = LC + Ld0(p3,p12,p4)*S34**(-1) * (  - 96*s12**2 + 32*s12*s13
     +     + 32*s12*s14 - 160*s12*s23 - 160*s12*s24 + 16*s13*s14 - 16*
     +    s13*s23 + 16*s13*s24 + 16*s14*s23 - 16*s14*s24 - 32*s23**2 - 
     +    80*s23*s24 - 32*s24**2 )

      LC = LC + Ld0(p3,p12,p4) * (  - 224*s12 - 24*s13 - 24*s14 - 40*
     +    s23 - 40*s24 )

      LC = LC + Ld0(p4,p1,p23)*S13**(-1)*S14**(-1)*S24**(-1)*S234 * ( 
     +     - 8*s12*s23*s34 - 8*s23**2*s34 )

      LC = LC + Ld0(p4,p1,p23)*S13**(-1)*S14**(-1)*S234 * ( 16*s12*s24
     +     - 16*s23*s34 - 8*s24**2 - 8*s24*s34 )

      LC = LC + Ld0(p4,p1,p23)*S13**(-1)*S23**(-1)*S24**(-1)*S234 * ( 8
     +    *s12*s14*s34 + 8*s12*s34**2 - 8*s14*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p4,p1,p23)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s14 + 16*s12**3*s34 - 8*s12*s14*s34**2 - 8*s12*s34**3
     +     + 8*s14*s34**3 + 8*s34**4 )

      LC = LC + Ld0(p4,p1,p23)*S13**(-1)*S23**(-1)*S234 * (  - 8*s14*
     +    s24 - 16*s14*s34 - 8*s24*s34 - 16*s34**2 )

      LC = LC + Ld0(p4,p1,p23)*S13**(-1)*S23**(-1) * (  - 8*s12*s14*s24
     +     - 16*s12*s14*s34 - 8*s12*s24*s34 - 16*s12*s34**2 + 8*s14*
     +    s24**2 + 24*s14*s24*s34 + 24*s14*s34**2 + 8*s24**2*s34 + 24*
     +    s24*s34**2 + 24*s34**3 )

      LC = LC + Ld0(p4,p1,p23)*S13**(-1)*S24**(-1)*S234 * (  - 8*s12*
     +    s14 - 8*s12*s23 - 8*s12*s34 - 8*s14*s23 + 8*s14*s34 - 8*
     +    s23**2 - 8*s23*s34 + 8*s34**2 )

      LC = LC + Ld0(p4,p1,p23)*S13**(-1)*S234 * ( 24*s12 + 8*s14 - 8*
     +    s23 + 16*s24 + 24*s34 )

      LC = LC + Ld0(p4,p1,p23)*S14**(-1)*S24**(-1)*S234 * (  - 16*s12*
     +    s13 - 8*s12*s23 - 16*s12*s34 - 8*s13**2 - 8*s13*s34 - 8*
     +    s23**2 )

      LC = LC + Ld0(p4,p1,p23)*S14**(-1)*S234 * (  - 16*s12 - 8*s13 + 8
     +    *s24 - 8*s34 )

      LC = LC + Ld0(p4,p1,p23)*S23**(-1)*S24**(-1)*S234 * (  - 16*s12*
     +    s13 - 16*s12*s14 - 8*s12*s34 - 8*s13**2 - 8*s13*s14 - 8*s13*
     +    s34 - 8*s34**2 )

      LC = LC + Ld0(p4,p1,p23)*S23**(-1)*S24**(-1) * ( 16*s12**3 + 32*
     +    s12**2*s13 + 32*s12**2*s14 + 32*s12**2*s34 + 24*s12*s13**2 + 
     +    24*s12*s13*s14 + 40*s12*s13*s34 + 16*s12*s14*s34 + 8*s12*
     +    s34**2 + 8*s13**3 + 8*s13**2*s14 + 16*s13**2*s34 + 8*s13*s14*
     +    s34 + 8*s13*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p4,p1,p23)*S23**(-1)*S234 * (  - 8*s13 - 8*s14 - 8*
     +    s24 - 24*s34 )

      LC = LC + Ld0(p4,p1,p23)*S23**(-1) * ( 16*s12*s13 + 16*s12*s14 - 
     +    8*s12*s24 + 8*s13**2 + 8*s13*s14 + 8*s13*s34 + 8*s24**2 + 24*
     +    s24*s34 + 24*s34**2 )

      LC = LC + Ld0(p4,p1,p23)*S24**(-1)*S234 * (  - 24*s12 - 8*s13 - 8
     +    *s23 + 8*s34 )

      LC = LC + Ld0(p4,p1,p23)*S234 * ( 16 )

      LC = LC + Ld0(p4,p2,p13)*S13**(-1)*S14**(-1)*S23**(-1)*S134 * ( 8
     +    *s12*s24*s34 + 8*s12*s34**2 - 8*s24*s34**2 - 8*s34**3 )

      LC = LC + Ld0(p4,p2,p13)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s24 + 16*s12**3*s34 - 8*s12*s24*s34**2 - 8*s12*s34**3
     +     + 8*s24*s34**3 + 8*s34**4 )

      LC = LC + Ld0(p4,p2,p13)*S13**(-1)*S14**(-1)*S134 * (  - 16*s12*
     +    s23 - 16*s12*s24 - 8*s12*s34 - 8*s23**2 - 8*s23*s24 - 8*s23*
     +    s34 - 8*s34**2 )

      LC = LC + Ld0(p4,p2,p13)*S13**(-1)*S14**(-1) * ( 16*s12**3 + 32*
     +    s12**2*s23 + 32*s12**2*s24 + 32*s12**2*s34 + 24*s12*s23**2 + 
     +    24*s12*s23*s24 + 40*s12*s23*s34 + 16*s12*s24*s34 + 8*s12*
     +    s34**2 + 8*s23**3 + 8*s23**2*s24 + 16*s23**2*s34 + 8*s23*s24*
     +    s34 + 8*s23*s34**2 + 8*s34**3 )

      LC = LC + Ld0(p4,p2,p13)*S13**(-1)*S23**(-1)*S134 * (  - 8*s14*
     +    s24 - 8*s14*s34 - 16*s24*s34 - 16*s34**2 )

      LC = LC + Ld0(p4,p2,p13)*S13**(-1)*S23**(-1) * (  - 8*s12*s14*s24
     +     - 8*s12*s14*s34 - 16*s12*s24*s34 - 16*s12*s34**2 + 8*s14**2*
     +    s24 + 8*s14**2*s34 + 24*s14*s24*s34 + 24*s14*s34**2 + 24*s24*
     +    s34**2 + 24*s34**3 )

      LC = LC + Ld0(p4,p2,p13)*S13**(-1)*S134 * (  - 8*s14 - 8*s23 - 8*
     +    s24 - 24*s34 )

      LC = LC + Ld0(p4,p2,p13)*S13**(-1) * (  - 8*s12*s14 + 16*s12*s23
     +     + 16*s12*s24 + 8*s14**2 + 24*s14*s34 + 8*s23**2 + 8*s23*s24
     +     + 8*s23*s34 + 24*s34**2 )

      LC = LC + Ld0(p4,p2,p13)*S14**(-1)*S23**(-1)*S24**(-1)*S134 * ( 
     +     - 8*s12*s13*s34 - 8*s13**2*s34 )

      LC = LC + Ld0(p4,p2,p13)*S14**(-1)*S23**(-1)*S134 * (  - 8*s12*
     +    s13 - 8*s12*s24 - 8*s12*s34 - 8*s13**2 - 8*s13*s24 - 8*s13*
     +    s34 + 8*s24*s34 + 8*s34**2 )

      LC = LC + Ld0(p4,p2,p13)*S14**(-1)*S24**(-1)*S134 * (  - 8*s12*
     +    s13 - 16*s12*s23 - 16*s12*s34 - 8*s13**2 - 8*s23**2 - 8*s23*
     +    s34 )

      LC = LC + Ld0(p4,p2,p13)*S14**(-1)*S134 * (  - 24*s12 - 8*s13 - 8
     +    *s23 + 8*s34 )

      LC = LC + Ld0(p4,p2,p13)*S23**(-1)*S24**(-1)*S134 * ( 16*s12*s14
     +     - 16*s13*s34 - 8*s14**2 - 8*s14*s34 )

      LC = LC + Ld0(p4,p2,p13)*S23**(-1)*S134 * ( 24*s12 - 8*s13 + 16*
     +    s14 + 8*s24 + 24*s34 )

      LC = LC + Ld0(p4,p2,p13)*S24**(-1)*S134 * (  - 16*s12 + 8*s14 - 8
     +    *s23 - 8*s34 )

      LC = LC + Ld0(p4,p2,p13)*S134 * ( 16 )

      LC = LC + Ld0(p4,p3,p12)*S13**(-1)*S14**(-1) * ( 8*s12*s23*s34 + 
     +    8*s12*s24*s34 + 8*s12*s34**2 + 8*s23**2*s34 + 16*s23*s24*s34
     +     + 8*s23*s34**2 + 8*s24**2*s34 + 8*s24*s34**2 )

      LC = LC + Ld0(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 48*
     +    s12**3*s14 - 192*s12**3*s34 + 48*s12**2*s14**2 - 176*s12**2*
     +    s14*s34 + 56*s12**2*s34**2 + 32*s12*s14**2*s34 - 40*s12*s14*
     +    s34**2 - 16*s12*s34**3 )

      LC = LC + Ld0(p4,p3,p12)*S13**(-1)*S23**(-1) * ( 32*s12**3 - 16*
     +    s12**2*s14 + 48*s12**2*s24 + 88*s12**2*s34 - 24*s12*s14*s24
     +     - 48*s12*s14*s34 + 8*s12*s24**2 + 8*s12*s24*s34 )

      LC = LC + Ld0(p4,p3,p12)*S13**(-1)*S24**(-1) * ( 40*s12**3 - 112*
     +    s12**2*s14 + 72*s12**2*s23 + 112*s12**2*s34 + 48*s12*s14**2
     +     - 128*s12*s14*s23 - 112*s12*s14*s34 + 48*s12*s23**2 + 56*s12
     +    *s23*s34 - 8*s12*s34**2 + 16*s14**2*s34 - 16*s14*s23**2 - 32*
     +    s14*s23*s34 - 16*s14*s34**2 + 16*s23**3 + 16*s23**2*s34 - 8*
     +    s23*s34**2 - 16*s34**3 )

      LC = LC + Ld0(p4,p3,p12)*S13**(-1) * ( 112*s12**2 - 72*s12*s14 + 
     +    48*s12*s23 + 8*s12*s24 - 8*s12*s34 - 8*s14*s23 - 8*s14*s24 - 
     +    24*s14*s34 + 8*s23**2 - 16*s23*s24 - 8*s23*s34 - 8*s24**2 - 8
     +    *s24*s34 - 8*s34**2 )

      LC = LC + Ld0(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 48*
     +    s12**3*s13 - 192*s12**3*s34 - 528*s12**2*s13**2 + 1312*s12**2
     +    *s13*s34 - 424*s12**2*s34**2 + 144*s12*s13**3 - 560*s12*
     +    s13**2*s34 + 248*s12*s13*s34**2 + 16*s12*s34**3 - 48*s13**3*
     +    s34 + 48*s13**2*s34**2 )

      LC = LC + Ld0(p4,p3,p12)*S14**(-1)*S23**(-1)*S34**(-1) * ( 96*s12
     +    *s13**3 - 96*s12*s13**2*s24 )

      LC = LC + Ld0(p4,p3,p12)*S14**(-1)*S23**(-1) * ( 40*s12**3 + 312*
     +    s12**2*s13 + 80*s12**2*s24 - 96*s12**2*s34 - 488*s12*s13**2
     +     + 160*s12*s13*s24 + 456*s12*s13*s34 + 24*s12*s24**2 + 64*s12
     +    *s24*s34 + 56*s12*s34**2 + 56*s13**3 - 40*s13**2*s24 + 8*
     +    s13**2*s34 - 8*s13*s24**2 - 16*s13*s24*s34 - 8*s13*s34**2 + 8
     +    *s24**3 + 24*s24**2*s34 + 16*s24*s34**2 )

      LC = LC + Ld0(p4,p3,p12)*S14**(-1)*S24**(-1) * ( 32*s12**3 - 64*
     +    s12**2*s13 + 48*s12**2*s23 + 40*s12**2*s34 - 24*s12*s13**2 - 
     +    24*s12*s13*s23 + 136*s12*s13*s34 + 32*s12*s23**2 + 16*s12*s23
     +    *s34 - 96*s12*s34**2 + 8*s13**3 - 48*s13**2*s34 + 48*s13*
     +    s34**2 + 8*s23**3 )

      LC = LC + Ld0(p4,p3,p12)*S14**(-1) * ( 104*s12**2 - 16*s12*s13 + 
     +    72*s12*s23 + 64*s12*s24 - 8*s12*s34 - 40*s13**2 - 8*s13*s23
     +     + 40*s13*s24 + 88*s13*s34 + 16*s23**2 + 16*s23*s24 + 16*s23*
     +    s34 + 16*s24**2 + 40*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p4,p3,p12)*S23**(-1)*S24**(-1)*S34**(-1) * ( 96*s12
     +    *s13**3 + 96*s12*s13**2*s14 )

      LC = LC + Ld0(p4,p3,p12)*S23**(-1)*S24**(-1) * (  - 96*s12**3 - 
     +    1152*s12**2*s13 - 576*s12**2*s14 + 1376*s12**2*s34 + 104*s12*
     +    s13**2 - 80*s12*s13*s14 - 1568*s12*s13*s34 + 56*s12*s14**2 + 
     +    32*s12*s14*s34 - 184*s12*s34**2 + 136*s13**3 + 136*s13**2*s14
     +     - 208*s13**2*s34 + 8*s13*s14**2 + 32*s13*s14*s34 - 8*s13*
     +    s34**2 + 8*s14**3 + 48*s14**2*s34 + 40*s14*s34**2 )

      LC = LC + Ld0(p4,p3,p12)*S23**(-1)*S34**(-1) * (  - 96*s12*s13*
     +    s14 - 96*s12*s13*s24 )

      LC = LC + Ld0(p4,p3,p12)*S23**(-1) * ( 336*s12**2 - 680*s12*s13
     +     - 48*s12*s14 - 16*s12*s24 - 96*s12*s34 - 96*s13**2 - 8*s13*
     +    s14 - 16*s13*s24 - 24*s13*s34 + 8*s14**2 + 8*s14*s24 + 16*s14
     +    *s34 + 16*s24**2 + 32*s24*s34 + 16*s34**2 )

      LC = LC + Ld0(p4,p3,p12)*S24**(-1) * (  - 152*s12**2 - 256*s12*
     +    s13 - 280*s12*s14 - 40*s12*s23 + 64*s12*s34 + 48*s13**2 + 24*
     +    s13*s14 - 8*s13*s23 - 296*s13*s34 + 8*s14**2 - 64*s14*s23 - 8
     +    *s14*s34 + 24*s23**2 - 8*s34**2 )

      LC = LC + Ld0(p4,p3,p12) * ( 16*s12 - 88*s13 + 8*s14 + 16*s23 + 
     +    16*s24 + 16*s34 )

      LCe=-LC/s134/s234
      
      return
      end
      
      function LCf(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LC=0d0

      LC = LC + Ld1(p1,p2,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 8*
     +    s12**2*s24*s34**2 + 8*s12**2*s34**3 )

      LC = LC + Ld1(p1,p2,p3)*S13**(-1)*S14**(-1) * ( 8*s12**2*s34**2 )

      LC = LC + Ld1(p1,p2,p3)*S13**(-1)*S23**(-1) * (  - 8*s12**2*s14*
     +    s34 + 8*s12**2*s24*s34 )

      LC = LC + Ld1(p1,p2,p3)*S13**(-1)*S24**(-1) * (  - 8*s12**2*s14*
     +    s34 - 8*s12**2*s34**2 + 8*s12*s14**2*s23 - 8*s12*s14**2*s34
     +     - 16*s12*s14*s34**2 - 8*s12*s23*s34**2 - 8*s12*s34**3 + 8*
     +    s14**3*s23 + 8*s14**2*s23**2 + 16*s14**2*s23*s34 + 8*s14*
     +    s23**2*s34 + 8*s14*s23*s34**2 )

      LC = LC + Ld1(p1,p2,p3)*S13**(-1) * ( 8*s12**2*s34 + 8*s12*s14**2
     +     - 8*s12*s14*s23 - 8*s12*s14*s24 - 8*s12*s14*s34 - 8*s12*s23*
     +    s34 - 8*s12*s24*s34 - 16*s12*s34**2 + 8*s14**2*s23 + 8*s14*
     +    s23*s34 )

      LC = LC + Ld1(p1,p2,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 8*
     +    s12**2*s23*s34**2 + 8*s12**2*s34**3 )

      LC = LC + Ld1(p1,p2,p4)*S13**(-1)*S14**(-1) * ( 8*s12**2*s34**2 )

      LC = LC + Ld1(p1,p2,p4)*S14**(-1)*S23**(-1) * (  - 8*s12**2*s13*
     +    s34 - 8*s12**2*s34**2 + 8*s12*s13**2*s24 - 8*s12*s13**2*s34
     +     - 16*s12*s13*s34**2 - 8*s12*s24*s34**2 - 8*s12*s34**3 + 8*
     +    s13**3*s24 + 8*s13**2*s24**2 + 16*s13**2*s24*s34 + 8*s13*
     +    s24**2*s34 + 8*s13*s24*s34**2 )

      LC = LC + Ld1(p1,p2,p4)*S14**(-1)*S24**(-1) * (  - 8*s12**2*s13*
     +    s34 + 8*s12**2*s23*s34 )

      LC = LC + Ld1(p1,p2,p4)*S14**(-1) * ( 8*s12**2*s34 + 8*s12*s13**2
     +     - 8*s12*s13*s23 - 8*s12*s13*s24 - 8*s12*s13*s34 - 8*s12*s23*
     +    s34 - 8*s12*s24*s34 - 16*s12*s34**2 + 8*s13**2*s24 + 8*s13*
     +    s24*s34 )

      LC = LC + Ld1(p1,p2,p34)*S13**(-1)*S14**(-1)*S134 * ( 8*s12*
     +    s34**2 + 8*s24*s34**2 )

      LC = LC + Ld1(p1,p2,p34)*S13**(-1)*S14**(-1) * (  - 8*s12*s34**3
     +     - 8*s24*s34**3 )

      LC = LC + Ld1(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * ( 16*s12*s14*
     +    s34 + 24*s12*s23*s34 + 16*s12*s34**2 - 16*s14**2*s23 - 24*s14
     +    *s23**2 - 16*s14*s23*s34 )

      LC = LC + Ld1(p1,p2,p34)*S13**(-1)*S134 * ( 16*s12*s14 + 8*s12*
     +    s34 - 24*s14*s23 - 16*s14*s24 - 24*s23*s34 - 16*s24*s34 )

      LC = LC + Ld1(p1,p2,p34)*S13**(-1) * ( 16*s14*s23*s34 + 16*s14*
     +    s24*s34 + 24*s23*s34**2 + 8*s24*s34**2 )

      LC = LC + Ld1(p1,p2,p34)*S14**(-1)*S23**(-1)*S134 * ( 16*s12*s13*
     +    s34 + 24*s12*s24*s34 + 16*s12*s34**2 - 16*s13**2*s24 - 24*s13
     +    *s24**2 - 16*s13*s24*s34 )

      LC = LC + Ld1(p1,p2,p34)*S14**(-1)*S134 * ( 16*s12*s13 + 8*s12*
     +    s34 - 16*s13*s23 - 24*s13*s24 - 8*s24*s34 )

      LC = LC + Ld1(p1,p2,p34)*S23**(-1)*S134 * (  - 16*s12*s24 - 32*
     +    s13*s24 - 48*s24**2 - 48*s24*s34 )

      LC = LC + Ld1(p1,p2,p34)*S24**(-1)*S134 * (  - 16*s12*s23 - 32*
     +    s14*s23 - 48*s23**2 - 48*s23*s34 )

      LC = LC + Ld1(p1,p2,p34)*S134 * (  - 16*s13 - 16*s14 - 48*s23 - 
     +    48*s24 - 32*s34 )

      LC = LC + Ld1(p1,p3,p4)*S14**(-1)*S23**(-1) * (  - 24*s12**3*s34
     +     + 24*s12**2*s13*s24 - 40*s12**2*s13*s34 - 48*s12**2*s24*s34
     +     - 40*s12**2*s34**2 + 40*s12*s13**2*s24 - 16*s12*s13**2*s34
     +     + 48*s12*s13*s24**2 - 32*s12*s13*s34**2 - 24*s12*s24**2*s34
     +     - 40*s12*s24*s34**2 - 16*s12*s34**3 + 16*s13**3*s24 + 40*
     +    s13**2*s24**2 + 32*s13**2*s24*s34 + 24*s13*s24**3 + 40*s13*
     +    s24**2*s34 + 16*s13*s24*s34**2 )

      LC = LC + Ld1(p1,p3,p4)*S14**(-1)*S24**(-1) * (  - 24*s12**3*s34
     +     - 16*s12**2*s13*s34 - 16*s12**2*s34**2 )

      LC = LC + Ld1(p1,p3,p4)*S14**(-1) * ( 24*s12**2*s13 - 48*s12**2*
     +    s34 + 16*s12*s13**2 + 48*s12*s13*s24 - 24*s12*s24*s34 - 16*
     +    s12*s34**2 + 16*s13**2*s24 + 24*s13*s24**2 + 16*s13*s24*s34 )

      LC = LC + Ld1(p1,p3,p24)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 16*
     +    s12**3*s34**2 + 8*s12**2*s34**3 )

      LC = LC + Ld1(p1,p3,p24)*S13**(-1)*S14**(-1) * (  - 32*s12**3*s23
     +     - 48*s12**3*s34 + 16*s12**2*s23**2 + 32*s12**2*s23*s24 + 48*
     +    s12**2*s23*s34 + 24*s12**2*s24*s34 + 40*s12**2*s34**2 )

      LC = LC + Ld1(p1,p3,p24)*S13**(-1)*S23**(-1)*S234**(-1) * (  - 2*
     +    s12**2*s14*s24**2 - 2*s12**2*s14*s24*s34 - 2*s12**2*s24**2*
     +    s34 - 2*s12**2*s24*s34**2 - 2*s12*s14**2*s24**2 - 2*s12*
     +    s14**2*s24*s34 - 2*s12*s14*s24**2*s34 - 2*s12*s14*s24*s34**2
     +     )

      LC = LC + Ld1(p1,p3,p24)*S13**(-1)*S23**(-1) * (  - 16*s12**3*s34
     +     + 2*s12**2*s14*s24 - 16*s12**2*s14*s34 + 2*s12**2*s24*s34 - 
     +    8*s12**2*s34**2 + 2*s12*s14**2*s24 - 6*s12*s14*s24*s34 - 8*
     +    s12*s24*s34**2 )

      LC = LC + Ld1(p1,p3,p24)*S13**(-1)*S234**(-1) * ( 2*s12**2*s14*
     +    s23 + 2*s12**2*s14*s34 + 2*s12**2*s23*s34 + 2*s12**2*s34**2
     +     + 4*s12*s14**2*s23 + 2*s12*s14**2*s24 + 4*s12*s14**2*s34 + 4
     +    *s12*s14*s23*s34 + 2*s12*s14*s24*s34 + 4*s12*s14*s34**2 + 2*
     +    s14**3*s23 + 2*s14**3*s24 + 2*s14**3*s34 + 2*s14**2*s23*s34
     +     + 2*s14**2*s24*s34 + 2*s14**2*s34**2 )

      LC = LC + Ld1(p1,p3,p24)*S13**(-1) * (  - 32*s12**3 - 50*s12**2*
     +    s14 - 16*s12**2*s23 + 16*s12**2*s24 - 26*s12**2*s34 - 20*s12*
     +    s14**2 + 8*s12*s14*s23 + 4*s12*s14*s34 + 24*s12*s23*s24 + 16*
     +    s12*s23*s34 + 16*s12*s34**2 - 2*s14**3 - 8*s14**2*s24 - 2*
     +    s14**2*s34 - 8*s14*s23**2 - 8*s14*s23*s34 - 8*s14*s24*s34 )

      LC = LC + Ld1(p1,p3,p24)*S14**(-1)*S23**(-1) * (  - 16*s12**3*s34
     +     + 16*s12**2*s13*s24 - 16*s12**2*s13*s34 + 16*s12**2*s24*s34
     +     - 8*s12**2*s34**2 + 16*s12*s13**2*s24 + 8*s12*s13*s24*s34 - 
     +    8*s12*s24*s34**2 )

      LC = LC + Ld1(p1,p3,p24)*S14**(-1) * (  - 32*s12**3 - 32*s12**2*
     +    s13 + 32*s12**2*s23 + 32*s12**2*s24 + 8*s12**2*s34 - 8*s12*
     +    s13*s24 + 48*s12*s23*s24 - 8*s12*s24**2 + 16*s12*s24*s34 - 24
     +    *s13*s24**2 )

      LC = LC + Ld1(p1,p3,p24)*S23**(-1)*S234**(-1) * (  - 2*s12**2*
     +    s24**2 - 2*s12**2*s24*s34 + 2*s12*s13*s24**2 + 2*s12*s13*s24*
     +    s34 + 2*s12*s24**2*s34 + 2*s12*s24*s34**2 + 4*s13**2*s24**2
     +     + 4*s13**2*s24*s34 + 2*s13*s14*s24**2 + 2*s13*s14*s24*s34 + 
     +    4*s13*s24**2*s34 + 4*s13*s24*s34**2 - 2*s14**2*s24**2 - 2*
     +    s14**2*s24*s34 - 2*s14*s24**2*s34 - 2*s14*s24*s34**2 )

      LC = LC + Ld1(p1,p3,p24)*S23**(-1) * ( 18*s12**2*s24 - 32*s12**2*
     +    s34 + 30*s12*s13*s24 - 16*s12*s13*s34 + 16*s12*s14*s24 - 16*
     +    s12*s14*s34 - 2*s12*s24*s34 - 16*s12*s34**2 + 12*s13**2*s24
     +     + 14*s13*s14*s24 + 8*s13*s24**2 + 12*s13*s24*s34 + 2*s14**2*
     +    s24 + 8*s14*s24**2 + 2*s14*s24*s34 + 8*s24**2*s34 )

      LC = LC + Ld1(p1,p3,p24)*S234**(-1) * ( 2*s12**2*s23 + 2*s12**2*
     +    s34 - 4*s12*s13*s23 - 2*s12*s13*s24 - 4*s12*s13*s34 - 4*s12*
     +    s23*s34 - 2*s12*s24*s34 - 4*s12*s34**2 + 4*s13**2*s24 - 4*s13
     +    *s14*s23 - 2*s13*s14*s24 - 4*s13*s14*s34 + 4*s13*s24*s34 - 2*
     +    s14**2*s23 - 4*s14**2*s24 - 2*s14**2*s34 - 4*s14*s23*s34 - 6*
     +    s14*s24*s34 - 4*s14*s34**2 )

      LC = LC + Ld1(p1,p3,p24) * (  - 82*s12**2 - 44*s12*s13 - 64*s12*
     +    s14 + 24*s12*s23 + 8*s12*s24 - 20*s12*s34 - 12*s13*s14 - 14*
     +    s14**2 - 8*s14*s24 - 12*s14*s34 + 32*s23*s24 + 8*s24*s34 )

      LC = LC + Ld1(p1,p4,p3)*S13**(-1)*S23**(-1) * (  - 24*s12**3*s34
     +     - 16*s12**2*s14*s34 - 16*s12**2*s34**2 )

      LC = LC + Ld1(p1,p4,p3)*S13**(-1)*S24**(-1) * (  - 24*s12**3*s34
     +     + 24*s12**2*s14*s23 - 40*s12**2*s14*s34 - 48*s12**2*s23*s34
     +     - 40*s12**2*s34**2 + 40*s12*s14**2*s23 - 16*s12*s14**2*s34
     +     + 48*s12*s14*s23**2 - 32*s12*s14*s34**2 - 24*s12*s23**2*s34
     +     - 40*s12*s23*s34**2 - 16*s12*s34**3 + 16*s14**3*s23 + 40*
     +    s14**2*s23**2 + 32*s14**2*s23*s34 + 24*s14*s23**3 + 40*s14*
     +    s23**2*s34 + 16*s14*s23*s34**2 )

      LC = LC + Ld1(p1,p4,p3)*S13**(-1) * ( 24*s12**2*s14 - 48*s12**2*
     +    s34 + 16*s12*s14**2 + 48*s12*s14*s23 - 24*s12*s23*s34 - 16*
     +    s12*s34**2 + 16*s14**2*s23 + 24*s14*s23**2 + 16*s14*s23*s34 )

      LC = LC + Ld1(p1,p4,p23)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34**2 + 8*s12**2*s34**3 )

      LC = LC + Ld1(p1,p4,p23)*S13**(-1)*S14**(-1) * (  - 32*s12**3*s24
     +     - 48*s12**3*s34 + 32*s12**2*s23*s24 + 24*s12**2*s23*s34 + 16
     +    *s12**2*s24**2 + 48*s12**2*s24*s34 + 40*s12**2*s34**2 )

      LC = LC + Ld1(p1,p4,p23)*S13**(-1)*S24**(-1) * (  - 16*s12**3*s34
     +     + 16*s12**2*s14*s23 - 16*s12**2*s14*s34 + 16*s12**2*s23*s34
     +     - 8*s12**2*s34**2 + 16*s12*s14**2*s23 + 8*s12*s14*s23*s34 - 
     +    8*s12*s23*s34**2 )

      LC = LC + Ld1(p1,p4,p23)*S13**(-1) * (  - 32*s12**3 - 32*s12**2*
     +    s14 + 32*s12**2*s23 + 32*s12**2*s24 + 8*s12**2*s34 - 8*s12*
     +    s14*s23 - 8*s12*s23**2 + 48*s12*s23*s24 + 16*s12*s23*s34 - 24
     +    *s14*s23**2 )

      LC = LC + Ld1(p1,p4,p23)*S14**(-1)*S24**(-1)*S234**(-1) * (  - 2*
     +    s12**2*s13*s23**2 - 2*s12**2*s13*s23*s34 - 2*s12**2*s23**2*
     +    s34 - 2*s12**2*s23*s34**2 - 2*s12*s13**2*s23**2 - 2*s12*
     +    s13**2*s23*s34 - 2*s12*s13*s23**2*s34 - 2*s12*s13*s23*s34**2
     +     )

      LC = LC + Ld1(p1,p4,p23)*S14**(-1)*S24**(-1) * (  - 16*s12**3*s34
     +     + 2*s12**2*s13*s23 - 16*s12**2*s13*s34 + 2*s12**2*s23*s34 - 
     +    8*s12**2*s34**2 + 2*s12*s13**2*s23 - 6*s12*s13*s23*s34 - 8*
     +    s12*s23*s34**2 )

      LC = LC + Ld1(p1,p4,p23)*S14**(-1)*S234**(-1) * ( 2*s12**2*s13*
     +    s24 + 2*s12**2*s13*s34 + 2*s12**2*s24*s34 + 2*s12**2*s34**2
     +     + 2*s12*s13**2*s23 + 4*s12*s13**2*s24 + 4*s12*s13**2*s34 + 2
     +    *s12*s13*s23*s34 + 4*s12*s13*s24*s34 + 4*s12*s13*s34**2 + 2*
     +    s13**3*s23 + 2*s13**3*s24 + 2*s13**3*s34 + 2*s13**2*s23*s34
     +     + 2*s13**2*s24*s34 + 2*s13**2*s34**2 )

      LC = LC + Ld1(p1,p4,p23)*S14**(-1) * (  - 32*s12**3 - 50*s12**2*
     +    s13 + 16*s12**2*s23 - 16*s12**2*s24 - 26*s12**2*s34 - 20*s12*
     +    s13**2 + 8*s12*s13*s24 + 4*s12*s13*s34 + 24*s12*s23*s24 + 16*
     +    s12*s24*s34 + 16*s12*s34**2 - 2*s13**3 - 8*s13**2*s23 - 2*
     +    s13**2*s34 - 8*s13*s23*s34 - 8*s13*s24**2 - 8*s13*s24*s34 )

      LC = LC + Ld1(p1,p4,p23)*S24**(-1)*S234**(-1) * (  - 2*s12**2*
     +    s23**2 - 2*s12**2*s23*s34 + 2*s12*s14*s23**2 + 2*s12*s14*s23*
     +    s34 + 2*s12*s23**2*s34 + 2*s12*s23*s34**2 - 2*s13**2*s23**2
     +     - 2*s13**2*s23*s34 + 2*s13*s14*s23**2 + 2*s13*s14*s23*s34 - 
     +    2*s13*s23**2*s34 - 2*s13*s23*s34**2 + 4*s14**2*s23**2 + 4*
     +    s14**2*s23*s34 + 4*s14*s23**2*s34 + 4*s14*s23*s34**2 )

      LC = LC + Ld1(p1,p4,p23)*S24**(-1) * ( 18*s12**2*s23 - 32*s12**2*
     +    s34 + 16*s12*s13*s23 - 16*s12*s13*s34 + 30*s12*s14*s23 - 16*
     +    s12*s14*s34 - 2*s12*s23*s34 - 16*s12*s34**2 + 2*s13**2*s23 + 
     +    14*s13*s14*s23 + 8*s13*s23**2 + 2*s13*s23*s34 + 12*s14**2*s23
     +     + 8*s14*s23**2 + 12*s14*s23*s34 + 8*s23**2*s34 )

      LC = LC + Ld1(p1,p4,p23)*S234**(-1) * ( 2*s12**2*s24 + 2*s12**2*
     +    s34 - 2*s12*s14*s23 - 4*s12*s14*s24 - 4*s12*s14*s34 - 2*s12*
     +    s23*s34 - 4*s12*s24*s34 - 4*s12*s34**2 - 4*s13**2*s23 - 2*
     +    s13**2*s24 - 2*s13**2*s34 - 2*s13*s14*s23 - 4*s13*s14*s24 - 4
     +    *s13*s14*s34 - 6*s13*s23*s34 - 4*s13*s24*s34 - 4*s13*s34**2
     +     + 4*s14**2*s23 + 4*s14*s23*s34 )

      LC = LC + Ld1(p1,p4,p23) * (  - 82*s12**2 - 64*s12*s13 - 44*s12*
     +    s14 + 8*s12*s23 + 24*s12*s24 - 20*s12*s34 - 14*s13**2 - 12*
     +    s13*s14 - 8*s13*s23 - 12*s13*s34 + 32*s23*s24 + 8*s23*s34 )

      LC = LC + Ld1(p1,p23,p4)*S14**(-1)*S24**(-1) * (  - 8*s12**2*s23*
     +    s34 - 16*s12*s13*s23*s34 - 8*s13**2*s23*s34 )

      LC = LC + Ld1(p1,p23,p4)*S14**(-1) * (  - 8*s12**2*s34 + 8*s12*
     +    s13*s23 + 8*s12*s13*s24 - 8*s12*s13*s34 - 8*s12*s23*s34 - 8*
     +    s12*s24*s34 - 8*s12*s34**2 + 8*s13**2*s23 + 8*s13**2*s24 + 8*
     +    s13*s23*s24 + 8*s13*s24**2 + 8*s13*s24*s34 )

      LC = LC + Ld1(p1,p24,p3)*S13**(-1)*S23**(-1) * (  - 8*s12**2*s24*
     +    s34 - 16*s12*s14*s24*s34 - 8*s14**2*s24*s34 )

      LC = LC + Ld1(p1,p24,p3)*S13**(-1) * (  - 8*s12**2*s34 + 8*s12*
     +    s14*s23 + 8*s12*s14*s24 - 8*s12*s14*s34 - 8*s12*s23*s34 - 8*
     +    s12*s24*s34 - 8*s12*s34**2 + 8*s14**2*s23 + 8*s14**2*s24 + 8*
     +    s14*s23**2 + 8*s14*s23*s24 + 8*s14*s23*s34 )

      LC = LC + Ld1(p2,p1,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**2*s14*s34**2 + 8*s12**2*s34**3 )

      LC = LC + Ld1(p2,p1,p3)*S13**(-1)*S23**(-1) * ( 8*s12**2*s14*s34
     +     - 8*s12**2*s24*s34 )

      LC = LC + Ld1(p2,p1,p3)*S14**(-1)*S23**(-1) * (  - 8*s12**2*s24*
     +    s34 - 8*s12**2*s34**2 + 8*s12*s13*s24**2 - 8*s12*s13*s34**2
     +     - 8*s12*s24**2*s34 - 16*s12*s24*s34**2 - 8*s12*s34**3 + 8*
     +    s13**2*s24**2 + 8*s13**2*s24*s34 + 8*s13*s24**3 + 16*s13*
     +    s24**2*s34 + 8*s13*s24*s34**2 )

      LC = LC + Ld1(p2,p1,p3)*S23**(-1)*S24**(-1) * ( 8*s12**2*s34**2 )

      LC = LC + Ld1(p2,p1,p3)*S23**(-1) * ( 8*s12**2*s34 - 8*s12*s13*
     +    s24 - 8*s12*s13*s34 - 8*s12*s14*s24 - 8*s12*s14*s34 + 8*s12*
     +    s24**2 - 8*s12*s24*s34 - 16*s12*s34**2 + 8*s13*s24**2 + 8*s13
     +    *s24*s34 )

      LC = LC + Ld1(p2,p1,p4)*S13**(-1)*S24**(-1) * (  - 8*s12**2*s23*
     +    s34 - 8*s12**2*s34**2 + 8*s12*s14*s23**2 - 8*s12*s14*s34**2
     +     - 8*s12*s23**2*s34 - 16*s12*s23*s34**2 - 8*s12*s34**3 + 8*
     +    s14**2*s23**2 + 8*s14**2*s23*s34 + 8*s14*s23**3 + 16*s14*
     +    s23**2*s34 + 8*s14*s23*s34**2 )

      LC = LC + Ld1(p2,p1,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**2*s13*s34**2 + 8*s12**2*s34**3 )

      LC = LC + Ld1(p2,p1,p4)*S14**(-1)*S24**(-1) * ( 8*s12**2*s13*s34
     +     - 8*s12**2*s23*s34 )

      LC = LC + Ld1(p2,p1,p4)*S23**(-1)*S24**(-1) * ( 8*s12**2*s34**2 )

      LC = LC + Ld1(p2,p1,p4)*S24**(-1) * ( 8*s12**2*s34 - 8*s12*s13*
     +    s23 - 8*s12*s13*s34 - 8*s12*s14*s23 - 8*s12*s14*s34 + 8*s12*
     +    s23**2 - 8*s12*s23*s34 - 16*s12*s34**2 + 8*s14*s23**2 + 8*s14
     +    *s23*s34 )

      LC = LC + Ld1(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * ( 24*s12*s14*
     +    s34 + 16*s12*s23*s34 + 16*s12*s34**2 - 24*s14**2*s23 - 16*s14
     +    *s23**2 - 16*s14*s23*s34 )

      LC = LC + Ld1(p2,p1,p34)*S13**(-1)*S234 * (  - 16*s12*s14 - 48*
     +    s14**2 - 32*s14*s23 - 48*s14*s34 )

      LC = LC + Ld1(p2,p1,p34)*S14**(-1)*S23**(-1)*S234 * ( 24*s12*s13*
     +    s34 + 16*s12*s24*s34 + 16*s12*s34**2 - 24*s13**2*s24 - 16*s13
     +    *s24**2 - 16*s13*s24*s34 )

      LC = LC + Ld1(p2,p1,p34)*S14**(-1)*S234 * (  - 16*s12*s13 - 48*
     +    s13**2 - 32*s13*s24 - 48*s13*s34 )

      LC = LC + Ld1(p2,p1,p34)*S23**(-1)*S24**(-1)*S234 * ( 8*s12*
     +    s34**2 + 8*s14*s34**2 )

      LC = LC + Ld1(p2,p1,p34)*S23**(-1)*S24**(-1) * (  - 8*s12*s34**3
     +     - 8*s14*s34**3 )

      LC = LC + Ld1(p2,p1,p34)*S23**(-1)*S234 * ( 16*s12*s24 + 8*s12*
     +    s34 - 24*s13*s24 - 24*s13*s34 - 16*s14*s24 - 16*s14*s34 )

      LC = LC + Ld1(p2,p1,p34)*S23**(-1) * ( 16*s13*s24*s34 + 24*s13*
     +    s34**2 + 16*s14*s24*s34 + 8*s14*s34**2 )

      LC = LC + Ld1(p2,p1,p34)*S24**(-1)*S234 * ( 16*s12*s23 + 8*s12*
     +    s34 - 16*s13*s23 - 24*s14*s23 - 8*s14*s34 )

      LC = LC + Ld1(p2,p1,p34)*S234 * (  - 48*s13 - 48*s14 - 16*s23 - 
     +    16*s24 - 32*s34 )

      LC = LC + Ld1(p2,p3,p4)*S13**(-1)*S24**(-1) * (  - 24*s12**3*s34
     +     + 24*s12**2*s14*s23 - 48*s12**2*s14*s34 - 40*s12**2*s23*s34
     +     - 40*s12**2*s34**2 + 48*s12*s14**2*s23 - 24*s12*s14**2*s34
     +     + 40*s12*s14*s23**2 - 40*s12*s14*s34**2 - 16*s12*s23**2*s34
     +     - 32*s12*s23*s34**2 - 16*s12*s34**3 + 24*s14**3*s23 + 40*
     +    s14**2*s23**2 + 40*s14**2*s23*s34 + 16*s14*s23**3 + 32*s14*
     +    s23**2*s34 + 16*s14*s23*s34**2 )

      LC = LC + Ld1(p2,p3,p4)*S14**(-1)*S24**(-1) * (  - 24*s12**3*s34
     +     - 16*s12**2*s23*s34 - 16*s12**2*s34**2 )

      LC = LC + Ld1(p2,p3,p4)*S24**(-1) * ( 24*s12**2*s23 - 48*s12**2*
     +    s34 + 48*s12*s14*s23 - 24*s12*s14*s34 + 16*s12*s23**2 - 16*
     +    s12*s34**2 + 24*s14**2*s23 + 16*s14*s23**2 + 16*s14*s23*s34 )

      LC = LC + Ld1(p2,p3,p14)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34**2 + 8*s12**2*s34**3 )

      LC = LC + Ld1(p2,p3,p14)*S13**(-1)*S23**(-1)*S134**(-1) * (  - 2*
     +    s12**2*s14**2*s24 - 2*s12**2*s14**2*s34 - 2*s12**2*s14*s24*
     +    s34 - 2*s12**2*s14*s34**2 - 2*s12*s14**2*s24**2 - 2*s12*
     +    s14**2*s24*s34 - 2*s12*s14*s24**2*s34 - 2*s12*s14*s24*s34**2
     +     )

      LC = LC + Ld1(p2,p3,p14)*S13**(-1)*S23**(-1) * (  - 16*s12**3*s34
     +     + 2*s12**2*s14*s24 + 2*s12**2*s14*s34 - 16*s12**2*s24*s34 - 
     +    8*s12**2*s34**2 + 2*s12*s14*s24**2 - 6*s12*s14*s24*s34 - 8*
     +    s12*s14*s34**2 )

      LC = LC + Ld1(p2,p3,p14)*S13**(-1)*S24**(-1) * (  - 16*s12**3*s34
     +     + 16*s12**2*s14*s23 + 16*s12**2*s14*s34 - 16*s12**2*s23*s34
     +     - 8*s12**2*s34**2 + 16*s12*s14*s23**2 + 8*s12*s14*s23*s34 - 
     +    8*s12*s14*s34**2 )

      LC = LC + Ld1(p2,p3,p14)*S13**(-1)*S134**(-1) * (  - 2*s12**2*
     +    s14**2 - 2*s12**2*s14*s34 + 2*s12*s14**2*s23 + 2*s12*s14**2*
     +    s34 + 2*s12*s14*s23*s34 + 2*s12*s14*s34**2 + 4*s14**2*s23**2
     +     + 2*s14**2*s23*s24 + 4*s14**2*s23*s34 - 2*s14**2*s24**2 - 2*
     +    s14**2*s24*s34 + 4*s14*s23**2*s34 + 2*s14*s23*s24*s34 + 4*s14
     +    *s23*s34**2 - 2*s14*s24**2*s34 - 2*s14*s24*s34**2 )

      LC = LC + Ld1(p2,p3,p14)*S13**(-1) * ( 18*s12**2*s14 - 32*s12**2*
     +    s34 + 30*s12*s14*s23 + 16*s12*s14*s24 - 2*s12*s14*s34 - 16*
     +    s12*s23*s34 - 16*s12*s24*s34 - 16*s12*s34**2 + 8*s14**2*s23
     +     + 8*s14**2*s24 + 8*s14**2*s34 + 12*s14*s23**2 + 14*s14*s23*
     +    s24 + 12*s14*s23*s34 + 2*s14*s24**2 + 2*s14*s24*s34 )

      LC = LC + Ld1(p2,p3,p14)*S23**(-1)*S24**(-1) * (  - 32*s12**3*s13
     +     - 48*s12**3*s34 + 16*s12**2*s13**2 + 32*s12**2*s13*s14 + 48*
     +    s12**2*s13*s34 + 24*s12**2*s14*s34 + 40*s12**2*s34**2 )

      LC = LC + Ld1(p2,p3,p14)*S23**(-1)*S134**(-1) * ( 2*s12**2*s13*
     +    s24 + 2*s12**2*s13*s34 + 2*s12**2*s24*s34 + 2*s12**2*s34**2
     +     + 4*s12*s13*s24**2 + 4*s12*s13*s24*s34 + 2*s12*s14*s24**2 + 
     +    2*s12*s14*s24*s34 + 4*s12*s24**2*s34 + 4*s12*s24*s34**2 + 2*
     +    s13*s24**3 + 2*s13*s24**2*s34 + 2*s14*s24**3 + 2*s14*s24**2*
     +    s34 + 2*s24**3*s34 + 2*s24**2*s34**2 )

      LC = LC + Ld1(p2,p3,p14)*S23**(-1) * (  - 32*s12**3 - 16*s12**2*
     +    s13 + 16*s12**2*s14 - 50*s12**2*s24 - 26*s12**2*s34 + 24*s12*
     +    s13*s14 + 8*s12*s13*s24 + 16*s12*s13*s34 - 20*s12*s24**2 + 4*
     +    s12*s24*s34 + 16*s12*s34**2 - 8*s13**2*s24 - 8*s13*s24*s34 - 
     +    8*s14*s24**2 - 8*s14*s24*s34 - 2*s24**3 - 2*s24**2*s34 )

      LC = LC + Ld1(p2,p3,p14)*S24**(-1) * (  - 32*s12**3 + 32*s12**2*
     +    s13 + 32*s12**2*s14 - 32*s12**2*s23 + 8*s12**2*s34 + 48*s12*
     +    s13*s14 - 8*s12*s14**2 - 8*s12*s14*s23 + 16*s12*s14*s34 - 24*
     +    s14**2*s23 )

      LC = LC + Ld1(p2,p3,p14)*S134**(-1) * ( 2*s12**2*s13 + 2*s12**2*
     +    s34 - 4*s12*s13*s23 - 4*s12*s13*s34 - 2*s12*s14*s23 - 2*s12*
     +    s14*s34 - 4*s12*s23*s34 - 4*s12*s34**2 - 4*s13*s23*s24 - 2*
     +    s13*s24**2 - 4*s13*s24*s34 + 4*s14*s23**2 - 2*s14*s23*s24 + 4
     +    *s14*s23*s34 - 4*s14*s24**2 - 6*s14*s24*s34 - 4*s23*s24*s34
     +     - 2*s24**2*s34 - 4*s24*s34**2 )

      LC = LC + Ld1(p2,p3,p14) * (  - 82*s12**2 + 24*s12*s13 + 8*s12*
     +    s14 - 44*s12*s23 - 64*s12*s24 - 20*s12*s34 + 32*s13*s14 - 8*
     +    s14*s24 + 8*s14*s34 - 12*s23*s24 - 14*s24**2 - 12*s24*s34 )

      LC = LC + Ld1(p2,p4,p3)*S13**(-1)*S23**(-1) * (  - 24*s12**3*s34
     +     - 16*s12**2*s24*s34 - 16*s12**2*s34**2 )

      LC = LC + Ld1(p2,p4,p3)*S14**(-1)*S23**(-1) * (  - 24*s12**3*s34
     +     + 24*s12**2*s13*s24 - 48*s12**2*s13*s34 - 40*s12**2*s24*s34
     +     - 40*s12**2*s34**2 + 48*s12*s13**2*s24 - 24*s12*s13**2*s34
     +     + 40*s12*s13*s24**2 - 40*s12*s13*s34**2 - 16*s12*s24**2*s34
     +     - 32*s12*s24*s34**2 - 16*s12*s34**3 + 24*s13**3*s24 + 40*
     +    s13**2*s24**2 + 40*s13**2*s24*s34 + 16*s13*s24**3 + 32*s13*
     +    s24**2*s34 + 16*s13*s24*s34**2 )

      LC = LC + Ld1(p2,p4,p3)*S23**(-1) * ( 24*s12**2*s24 - 48*s12**2*
     +    s34 + 48*s12*s13*s24 - 24*s12*s13*s34 + 16*s12*s24**2 - 16*
     +    s12*s34**2 + 24*s13**2*s24 + 16*s13*s24**2 + 16*s13*s24*s34 )

      LC = LC + Ld1(p2,p4,p13)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 16*
     +    s12**3*s34**2 + 8*s12**2*s34**3 )

      LC = LC + Ld1(p2,p4,p13)*S14**(-1)*S23**(-1) * (  - 16*s12**3*s34
     +     + 16*s12**2*s13*s24 + 16*s12**2*s13*s34 - 16*s12**2*s24*s34
     +     - 8*s12**2*s34**2 + 16*s12*s13*s24**2 + 8*s12*s13*s24*s34 - 
     +    8*s12*s13*s34**2 )

      LC = LC + Ld1(p2,p4,p13)*S14**(-1)*S24**(-1)*S134**(-1) * (  - 2*
     +    s12**2*s13**2*s23 - 2*s12**2*s13**2*s34 - 2*s12**2*s13*s23*
     +    s34 - 2*s12**2*s13*s34**2 - 2*s12*s13**2*s23**2 - 2*s12*
     +    s13**2*s23*s34 - 2*s12*s13*s23**2*s34 - 2*s12*s13*s23*s34**2
     +     )

      LC = LC + Ld1(p2,p4,p13)*S14**(-1)*S24**(-1) * (  - 16*s12**3*s34
     +     + 2*s12**2*s13*s23 + 2*s12**2*s13*s34 - 16*s12**2*s23*s34 - 
     +    8*s12**2*s34**2 + 2*s12*s13*s23**2 - 6*s12*s13*s23*s34 - 8*
     +    s12*s13*s34**2 )

      LC = LC + Ld1(p2,p4,p13)*S14**(-1)*S134**(-1) * (  - 2*s12**2*
     +    s13**2 - 2*s12**2*s13*s34 + 2*s12*s13**2*s24 + 2*s12*s13**2*
     +    s34 + 2*s12*s13*s24*s34 + 2*s12*s13*s34**2 - 2*s13**2*s23**2
     +     + 2*s13**2*s23*s24 - 2*s13**2*s23*s34 + 4*s13**2*s24**2 + 4*
     +    s13**2*s24*s34 - 2*s13*s23**2*s34 + 2*s13*s23*s24*s34 - 2*s13
     +    *s23*s34**2 + 4*s13*s24**2*s34 + 4*s13*s24*s34**2 )

      LC = LC + Ld1(p2,p4,p13)*S14**(-1) * ( 18*s12**2*s13 - 32*s12**2*
     +    s34 + 16*s12*s13*s23 + 30*s12*s13*s24 - 2*s12*s13*s34 - 16*
     +    s12*s23*s34 - 16*s12*s24*s34 - 16*s12*s34**2 + 8*s13**2*s23
     +     + 8*s13**2*s24 + 8*s13**2*s34 + 2*s13*s23**2 + 14*s13*s23*
     +    s24 + 2*s13*s23*s34 + 12*s13*s24**2 + 12*s13*s24*s34 )

      LC = LC + Ld1(p2,p4,p13)*S23**(-1)*S24**(-1) * (  - 32*s12**3*s14
     +     - 48*s12**3*s34 + 32*s12**2*s13*s14 + 24*s12**2*s13*s34 + 16
     +    *s12**2*s14**2 + 48*s12**2*s14*s34 + 40*s12**2*s34**2 )

      LC = LC + Ld1(p2,p4,p13)*S23**(-1) * (  - 32*s12**3 + 32*s12**2*
     +    s13 + 32*s12**2*s14 - 32*s12**2*s24 + 8*s12**2*s34 - 8*s12*
     +    s13**2 + 48*s12*s13*s14 - 8*s12*s13*s24 + 16*s12*s13*s34 - 24
     +    *s13**2*s24 )

      LC = LC + Ld1(p2,p4,p13)*S24**(-1)*S134**(-1) * ( 2*s12**2*s14*
     +    s23 + 2*s12**2*s14*s34 + 2*s12**2*s23*s34 + 2*s12**2*s34**2
     +     + 2*s12*s13*s23**2 + 2*s12*s13*s23*s34 + 4*s12*s14*s23**2 + 
     +    4*s12*s14*s23*s34 + 4*s12*s23**2*s34 + 4*s12*s23*s34**2 + 2*
     +    s13*s23**3 + 2*s13*s23**2*s34 + 2*s14*s23**3 + 2*s14*s23**2*
     +    s34 + 2*s23**3*s34 + 2*s23**2*s34**2 )

      LC = LC + Ld1(p2,p4,p13)*S24**(-1) * (  - 32*s12**3 + 16*s12**2*
     +    s13 - 16*s12**2*s14 - 50*s12**2*s23 - 26*s12**2*s34 + 24*s12*
     +    s13*s14 + 8*s12*s14*s23 + 16*s12*s14*s34 - 20*s12*s23**2 + 4*
     +    s12*s23*s34 + 16*s12*s34**2 - 8*s13*s23**2 - 8*s13*s23*s34 - 
     +    8*s14**2*s23 - 8*s14*s23*s34 - 2*s23**3 - 2*s23**2*s34 )

      LC = LC + Ld1(p2,p4,p13)*S134**(-1) * ( 2*s12**2*s14 + 2*s12**2*
     +    s34 - 2*s12*s13*s24 - 2*s12*s13*s34 - 4*s12*s14*s24 - 4*s12*
     +    s14*s34 - 4*s12*s24*s34 - 4*s12*s34**2 - 4*s13*s23**2 - 2*s13
     +    *s23*s24 - 6*s13*s23*s34 + 4*s13*s24**2 + 4*s13*s24*s34 - 2*
     +    s14*s23**2 - 4*s14*s23*s24 - 4*s14*s23*s34 - 2*s23**2*s34 - 4
     +    *s23*s24*s34 - 4*s23*s34**2 )

      LC = LC + Ld1(p2,p4,p13) * (  - 82*s12**2 + 8*s12*s13 + 24*s12*
     +    s14 - 64*s12*s23 - 44*s12*s24 - 20*s12*s34 + 32*s13*s14 - 8*
     +    s13*s23 + 8*s13*s34 - 14*s23**2 - 12*s23*s24 - 12*s23*s34 )

      LC = LC + Ld1(p2,p13,p4)*S14**(-1)*S24**(-1) * (  - 8*s12**2*s13*
     +    s34 - 16*s12*s13*s23*s34 - 8*s13*s23**2*s34 )

      LC = LC + Ld1(p2,p13,p4)*S24**(-1) * (  - 8*s12**2*s34 + 8*s12*
     +    s13*s23 - 8*s12*s13*s34 + 8*s12*s14*s23 - 8*s12*s14*s34 - 8*
     +    s12*s23*s34 - 8*s12*s34**2 + 8*s13*s14*s23 + 8*s13*s23**2 + 8
     +    *s14**2*s23 + 8*s14*s23**2 + 8*s14*s23*s34 )

      LC = LC + Ld1(p2,p14,p3)*S13**(-1)*S23**(-1) * (  - 8*s12**2*s14*
     +    s34 - 16*s12*s14*s24*s34 - 8*s14*s24**2*s34 )

      LC = LC + Ld1(p2,p14,p3)*S23**(-1) * (  - 8*s12**2*s34 + 8*s12*
     +    s13*s24 - 8*s12*s13*s34 + 8*s12*s14*s24 - 8*s12*s14*s34 - 8*
     +    s12*s24*s34 - 8*s12*s34**2 + 8*s13**2*s24 + 8*s13*s14*s24 + 8
     +    *s13*s24**2 + 8*s13*s24*s34 + 8*s14*s24**2 )

      LC = LC + Ld1(p3,p1,p4)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 24*
     +    s12*s14**2*s23**2 - 16*s14**3*s23**2 )

      LC = LC + Ld1(p3,p1,p4)*S13**(-1)*S34**(-1) * (  - 24*s12*s14**2*
     +    s23 - 16*s14**3*s23 )

      LC = LC + Ld1(p3,p1,p4)*S14**(-1)*S23**(-1)*S34**(-1) * (  - 24*
     +    s12*s13**2*s24**2 - 16*s13**3*s24**2 )

      LC = LC + Ld1(p3,p1,p4)*S14**(-1)*S34**(-1) * (  - 24*s12*s13**2*
     +    s24 - 16*s13**3*s24 )

      LC = LC + Ld1(p3,p1,p4)*S23**(-1)*S34**(-1) * (  - 24*s12*s13*
     +    s24**2 - 32*s13**2*s24**2 - 16*s13*s14*s24**2 )

      LC = LC + Ld1(p3,p1,p4)*S24**(-1)*S34**(-1) * (  - 24*s12*s14*
     +    s23**2 - 16*s13*s14*s23**2 - 32*s14**2*s23**2 )

      LC = LC + Ld1(p3,p1,p4)*S34**(-1) * ( 48*s12*s13*s23 + 24*s12*s13
     +    *s24 + 24*s12*s14*s23 + 48*s12*s14*s24 + 32*s13**2*s23 + 48*
     +    s13*s14*s23 + 48*s13*s14*s24 + 32*s14**2*s24 )

      LC = LC + Ld1(p3,p1,p24)*S13**(-1)*S14**(-1)*S23**(-1)*S234*
     + S124**(-1) * (  - 8*s12**3*s34**2 )

      LC = LC + Ld1(p3,p1,p24)*S13**(-1)*S14**(-1)*S234*S124**(-1) * ( 
     +    16*s12**3*s23 - 32*s12**2*s23**2 + 32*s12**2*s23*s24 - 48*
     +    s12**2*s23*s34 + 24*s12**2*s24*s34 - 16*s12**2*s34**2 )

      LC = LC + Ld1(p3,p1,p24)*S13**(-1)*S23**(-1)*S234*S124**(-1) * ( 
     +     - 8*s12**3*s34 - 8*s12**2*s14*s34 - 8*s12**2*s34**2 - 8*s12*
     +    s14*s24*s34 - 8*s12*s24*s34**2 )

      LC = LC + Ld1(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * ( 8*s12**2*
     +    s14 + 32*s12**2*s23 + 16*s12**2*s24 + 8*s12**2*s34 + 8*s12*
     +    s14**2 + 16*s12*s14*s23 + 8*s12*s14*s34 - 48*s12*s23**2 + 24*
     +    s12*s23*s24 - 64*s12*s23*s34 - 16*s12*s34**2 - 8*s14**2*s24
     +     - 16*s14*s23**2 - 16*s14*s23*s34 - 8*s14*s24*s34 )

      LC = LC + Ld1(p3,p1,p24)*S14**(-1)*S23**(-1)*S234*S124**(-1) * ( 
     +     - 8*s12**3*s34 + 8*s12**2*s13*s24 + 8*s12**2*s24*s34 )

      LC = LC + Ld1(p3,p1,p24)*S14**(-1)*S234*S124**(-1) * ( 16*s12**2*
     +    s24 + 48*s12*s23*s24 - 8*s12*s24**2 + 32*s12*s24*s34 - 16*s13
     +    *s24**2 )

      LC = LC + Ld1(p3,p1,p24)*S23**(-1)*S234*S124**(-1) * ( 8*s12**2*
     +    s24 - 8*s12**2*s34 - 8*s12*s13*s24 - 8*s12*s14*s24 - 16*s12*
     +    s24*s34 - 8*s13*s14*s24 + 8*s13*s24**2 - 8*s14**2*s24 + 8*s14
     +    *s24**2 - 8*s14*s24*s34 + 8*s24**2*s34 )

      LC = LC + Ld1(p3,p1,p24)*S23**(-1)*S124**(-1) * ( 16*s12*s13*
     +    s24**2 + 8*s12*s13*s24*s34 + 16*s12*s14*s24**2 + 8*s12*s14*
     +    s24*s34 + 16*s12*s24**2*s34 + 8*s12*s24*s34**2 + 8*s13**2*
     +    s24**2 + 16*s13*s14*s24**2 + 8*s13*s14*s24*s34 + 8*s13*s24**2
     +    *s34 + 8*s14**2*s24**2 + 8*s14**2*s24*s34 + 8*s14*s24**2*s34
     +     + 8*s14*s24*s34**2 )

      LC = LC + Ld1(p3,p1,p24)*S234*S124**(-1) * ( 8*s12**2 + 8*s12*s14
     +     - 8*s14*s24 + 32*s23*s24 + 16*s24*s34 )

      LC = LC + Ld1(p3,p2,p4)*S13**(-1)*S24**(-1)*S34**(-1) * (  - 24*
     +    s12*s14**2*s23**2 - 16*s14**2*s23**3 )

      LC = LC + Ld1(p3,p2,p4)*S13**(-1)*S34**(-1) * (  - 24*s12*s14**2*
     +    s23 - 32*s14**2*s23**2 - 16*s14**2*s23*s24 )

      LC = LC + Ld1(p3,p2,p4)*S14**(-1)*S23**(-1)*S34**(-1) * (  - 24*
     +    s12*s13**2*s24**2 - 16*s13**2*s24**3 )

      LC = LC + Ld1(p3,p2,p4)*S14**(-1)*S34**(-1) * (  - 24*s12*s13**2*
     +    s24 - 16*s13**2*s23*s24 - 32*s13**2*s24**2 )

      LC = LC + Ld1(p3,p2,p4)*S23**(-1)*S34**(-1) * (  - 24*s12*s13*
     +    s24**2 - 16*s13*s24**3 )

      LC = LC + Ld1(p3,p2,p4)*S24**(-1)*S34**(-1) * (  - 24*s12*s14*
     +    s23**2 - 16*s14*s23**3 )

      LC = LC + Ld1(p3,p2,p4)*S34**(-1) * ( 48*s12*s13*s23 + 24*s12*s13
     +    *s24 + 24*s12*s14*s23 + 48*s12*s14*s24 + 32*s13*s23**2 + 48*
     +    s13*s23*s24 + 48*s14*s23*s24 + 32*s14*s24**2 )

      LC = LC + Ld1(p3,p2,p14)*S13**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * (  - 8*s12**3*s34**2 )

      LC = LC + Ld1(p3,p2,p14)*S13**(-1)*S23**(-1)*S134*S124**(-1) * ( 
     +     - 8*s12**3*s34 - 8*s12**2*s24*s34 - 8*s12**2*s34**2 - 8*s12*
     +    s14*s24*s34 - 8*s12*s14*s34**2 )

      LC = LC + Ld1(p3,p2,p14)*S13**(-1)*S24**(-1)*S134*S124**(-1) * ( 
     +     - 8*s12**3*s34 + 8*s12**2*s14*s23 + 8*s12**2*s14*s34 )

      LC = LC + Ld1(p3,p2,p14)*S13**(-1)*S134*S124**(-1) * ( 8*s12**2*
     +    s14 - 8*s12**2*s34 - 8*s12*s14*s23 - 8*s12*s14*s24 - 16*s12*
     +    s14*s34 + 8*s14**2*s23 + 8*s14**2*s24 + 8*s14**2*s34 - 8*s14*
     +    s23*s24 - 8*s14*s24**2 - 8*s14*s24*s34 )

      LC = LC + Ld1(p3,p2,p14)*S13**(-1)*S124**(-1) * ( 16*s12*s14**2*
     +    s23 + 16*s12*s14**2*s24 + 16*s12*s14**2*s34 + 8*s12*s14*s23*
     +    s34 + 8*s12*s14*s24*s34 + 8*s12*s14*s34**2 + 8*s14**2*s23**2
     +     + 16*s14**2*s23*s24 + 8*s14**2*s23*s34 + 8*s14**2*s24**2 + 8
     +    *s14**2*s24*s34 + 8*s14*s23*s24*s34 + 8*s14*s24**2*s34 + 8*
     +    s14*s24*s34**2 )

      LC = LC + Ld1(p3,p2,p14)*S23**(-1)*S24**(-1)*S134*S124**(-1) * ( 
     +    16*s12**3*s13 - 32*s12**2*s13**2 + 32*s12**2*s13*s14 - 48*
     +    s12**2*s13*s34 + 24*s12**2*s14*s34 - 16*s12**2*s34**2 )

      LC = LC + Ld1(p3,p2,p14)*S23**(-1)*S134*S124**(-1) * ( 32*s12**2*
     +    s13 + 16*s12**2*s14 + 8*s12**2*s24 + 8*s12**2*s34 - 48*s12*
     +    s13**2 + 24*s12*s13*s14 + 16*s12*s13*s24 - 64*s12*s13*s34 + 8
     +    *s12*s24**2 + 8*s12*s24*s34 - 16*s12*s34**2 - 16*s13**2*s24
     +     - 16*s13*s24*s34 - 8*s14*s24**2 - 8*s14*s24*s34 )

      LC = LC + Ld1(p3,p2,p14)*S24**(-1)*S134*S124**(-1) * ( 16*s12**2*
     +    s14 + 48*s12*s13*s14 - 8*s12*s14**2 + 32*s12*s14*s34 - 16*
     +    s14**2*s23 )

      LC = LC + Ld1(p3,p2,p14)*S134*S124**(-1) * ( 8*s12**2 + 8*s12*s24
     +     + 32*s13*s14 - 8*s14*s24 + 16*s14*s34 )

      LC = LC + Ld1(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1)*S124**(-1)
     +  * ( 16*s12**4*s14*s34 - 336*s12**4*s34**2 - 528*s12**3*s14**2*
     +    s34 + 1376*s12**3*s14*s34**2 - 488*s12**3*s34**3 + 128*s12**2
     +    *s14**3*s34 - 368*s12**2*s14**2*s34**2 + 168*s12**2*s14*
     +    s34**3 + 16*s12**2*s34**4 + 48*s12*s14**4*s34 - 64*s12*s14**3
     +    *s34**2 + 32*s12*s14**2*s34**3 )

      LC = LC + Ld1(p3,p4,p12)*S13**(-1)*S23**(-1)*S124**(-1) * ( 32*
     +    s12**4*s34 + 64*s12**3*s14*s34 + 80*s12**3*s24*s34 - 168*
     +    s12**3*s34**2 - 64*s12**2*s14**2*s34 + 40*s12**2*s14*s24*s34
     +     + 328*s12**2*s14*s34**2 + 72*s12**2*s24**2*s34 + 16*s12**2*
     +    s24*s34**2 - 176*s12**2*s34**3 + 32*s12*s14**3*s34 - 48*s12*
     +    s14**2*s24*s34 - 16*s12*s14**2*s34**2 + 112*s12*s14*s24*
     +    s34**2 + 16*s12*s14*s34**3 + 32*s12*s24**3*s34 + 64*s12*
     +    s24**2*s34**2 - 16*s12*s24*s34**3 )

      LC = LC + Ld1(p3,p4,p12)*S13**(-1)*S24**(-1)*S34**(-1)*S124**(-1)
     +  * (  - 96*s12*s14**4*s23 + 96*s12*s14**3*s23**2 )

      LC = LC + Ld1(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1) * (  - 16
     +    *s12**4*s34 + 48*s12**3*s14**2 + 576*s12**3*s14*s34 + 16*
     +    s12**3*s23*s34 - 232*s12**3*s34**2 + 672*s12**2*s14**3 - 384*
     +    s12**2*s14**2*s23 - 1872*s12**2*s14**2*s34 - 32*s12**2*s14*
     +    s23**2 + 368*s12**2*s14*s23*s34 + 824*s12**2*s14*s34**2 + 40*
     +    s12**2*s23**2*s34 + 96*s12**2*s23*s34**2 + 72*s12**2*s34**3
     +     - 96*s12*s14**4 + 528*s12*s14**3*s23 + 368*s12*s14**3*s34 - 
     +    184*s12*s14**2*s23**2 - 368*s12*s14**2*s23*s34 - 136*s12*
     +    s14**2*s34**2 - 40*s12*s14*s23**3 - 88*s12*s14*s23**2*s34 - 
     +    56*s12*s14*s23*s34**2 - 8*s12*s14*s34**3 + 8*s12*s23**3*s34
     +     + 24*s12*s23**2*s34**2 + 24*s12*s23*s34**3 + 8*s12*s34**4 + 
     +    16*s14**3*s23**2 + 16*s14**3*s23*s34 - 8*s14**2*s23**3 - 16*
     +    s14**2*s23**2*s34 - 8*s14**2*s23*s34**2 - 8*s14*s23**4 - 24*
     +    s14*s23**3*s34 - 24*s14*s23**2*s34**2 - 8*s14*s23*s34**3 )

      LC = LC + Ld1(p3,p4,p12)*S13**(-1)*S34**(-1)*S124**(-1) * (  - 96
     +    *s12*s14**3*s23 + 96*s12*s14**2*s23**2 )

      LC = LC + Ld1(p3,p4,p12)*S13**(-1)*S124**(-1) * ( 224*s12**3*s34
     +     + 528*s12**2*s14**2 - 336*s12**2*s14*s23 - 1088*s12**2*s14*
     +    s34 + 128*s12**2*s23*s34 + 208*s12**2*s34**2 - 96*s12*s14**3
     +     + 432*s12*s14**2*s23 + 288*s12*s14**2*s34 - 144*s12*s14*
     +    s23**2 - 240*s12*s14*s23*s34 - 48*s12*s14*s34**2 )

      LC = LC + Ld1(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1)*S124**(-1)
     +  * ( 64*s12**4*s13*s34 - 336*s12**4*s34**2 + 64*s12**3*s13**2*
     +    s34 - 256*s12**3*s13*s34**2 + 104*s12**3*s34**3 + 32*s12**2*
     +    s13**2*s34**2 - 40*s12**2*s13*s34**3 - 16*s12**2*s34**4 )

      LC = LC + Ld1(p3,p4,p12)*S14**(-1)*S23**(-1)*S124**(-1) * ( 32*
     +    s12**4*s34 + 48*s12**3*s13**2 + 224*s12**3*s13*s34 + 112*
     +    s12**3*s24*s34 - 88*s12**3*s34**2 - 48*s12**2*s13**3 + 144*
     +    s12**2*s13**2*s24 + 272*s12**2*s13**2*s34 + 16*s12**2*s13*
     +    s24**2 - 160*s12**2*s13*s24*s34 - 312*s12**2*s13*s34**2 + 152
     +    *s12**2*s24**2*s34 + 128*s12**2*s24*s34**2 + 56*s12**2*s34**3
     +     - 48*s12*s13**3*s24 - 32*s12*s13**3*s34 + 88*s12*s13**2*
     +    s24**2 + 160*s12*s13**2*s24*s34 + 56*s12*s13**2*s34**2 + 40*
     +    s12*s13*s24**3 - 104*s12*s13*s24**2*s34 - 104*s12*s13*s24*
     +    s34**2 + 8*s12*s13*s34**3 + 104*s12*s24**3*s34 + 152*s12*
     +    s24**2*s34**2 + 8*s12*s24*s34**3 - 8*s12*s34**4 - 16*s13**3*
     +    s24*s34 - 8*s13**2*s24**3 + 48*s13**2*s24**2*s34 + 8*s13**2*
     +    s24*s34**2 + 24*s13*s24**4 - 24*s13*s24**3*s34 - 8*s13*s24**2
     +    *s34**2 + 8*s13*s24*s34**3 + 32*s24**4*s34 + 32*s24**3*s34**2
     +     )

      LC = LC + Ld1(p3,p4,p12)*S14**(-1)*S24**(-1)*S124**(-1) * (  - 16
     +    *s12**4*s34 - 64*s12**3*s13*s34 + 32*s12**3*s23*s34 + 88*
     +    s12**3*s34**2 - 8*s12**2*s13*s23*s34 - 40*s12**2*s13*s34**2
     +     + 8*s12**2*s23**2*s34 + 16*s12**2*s23*s34**2 )

      LC = LC + Ld1(p3,p4,p12)*S14**(-1)*S124**(-1) * ( 224*s12**3*s34
     +     )

      LC = LC + Ld1(p3,p4,p12)*S23**(-1)*S24**(-1)*S34**(-1)*S124**(-1)
     +  * (  - 96*s12*s13**2*s14**3 - 96*s12*s13*s14**4 )

      LC = LC + Ld1(p3,p4,p12)*S23**(-1)*S24**(-1)*S124**(-1) * ( 80*
     +    s12**4*s34 + 144*s12**3*s13**2 + 288*s12**3*s13*s14 - 768*
     +    s12**3*s13*s34 + 144*s12**3*s14**2 - 1264*s12**3*s14*s34 + 
     +    1728*s12**3*s34**2 - 48*s12**2*s13**3 + 944*s12**2*s13**2*s14
     +     + 280*s12**2*s13**2*s34 + 1856*s12**2*s13*s14**2 - 2320*
     +    s12**2*s13*s14*s34 - 80*s12**2*s13*s34**2 + 864*s12**2*s14**3
     +     - 2072*s12**2*s14**2*s34 - 672*s12**2*s14*s34**2 - 208*
     +    s12**2*s34**3 - 40*s12*s13**3*s14 - 24*s12*s13**3*s34 + 576*
     +    s12*s13**2*s14**2 + 64*s12*s13**2*s14*s34 + 80*s12*s13**2*
     +    s34**2 + 520*s12*s13*s14**3 + 1600*s12*s13*s14**2*s34 + 272*
     +    s12*s13*s14*s34**2 + 48*s12*s13*s34**3 + 328*s12*s14**3*s34
     +     - 464*s12*s14**2*s34**2 - 96*s12*s14*s34**3 - 8*s13**4*s14
     +     + 8*s13**3*s14**2 - 40*s13**3*s14*s34 + 88*s13**2*s14**3 + 
     +    32*s13**2*s14**2*s34 - 32*s13**2*s14*s34**2 + 72*s13*s14**4
     +     + 472*s13*s14**3*s34 + 48*s13*s14**2*s34**2 + 64*s14**4*s34
     +     - 32*s14**3*s34**2 )

      LC = LC + Ld1(p3,p4,p12)*S23**(-1)*S34**(-1)*S124**(-1) * (  - 96
     +    *s12*s13**2*s14**2 - 96*s12*s13*s14**3 )

      LC = LC + Ld1(p3,p4,p12)*S23**(-1)*S124**(-1) * (  - 48*s12**3*
     +    s13 - 96*s12**3*s14 + 272*s12**3*s34 + 928*s12**2*s13**2 + 
     +    1408*s12**2*s13*s14 - 128*s12**2*s13*s24 - 2840*s12**2*s13*
     +    s34 + 576*s12**2*s14**2 - 128*s12**2*s14*s24 - 2472*s12**2*
     +    s14*s34 + 16*s12**2*s24**2 - 40*s12**2*s24*s34 + 1176*s12**2*
     +    s34**2 - 96*s12*s13**3 + 888*s12*s13**2*s14 + 504*s12*s13**2*
     +    s24 + 192*s12*s13**2*s34 + 672*s12*s13*s14**2 + 64*s12*s13*
     +    s14*s24 + 568*s12*s13*s14*s34 - 144*s12*s13*s24**2 - 944*s12*
     +    s13*s24*s34 + 128*s12*s13*s34**2 + 40*s12*s14**3 + 8*s12*
     +    s14**2*s24 - 264*s12*s14**2*s34 - 8*s12*s14*s24**2 - 672*s12*
     +    s14*s24*s34 - 336*s12*s14*s34**2 + 24*s12*s24**3 - 56*s12*
     +    s24**2*s34 + 368*s12*s24*s34**2 - 88*s12*s34**3 - 32*s13**3*
     +    s34 + 208*s13**2*s14**2 + 192*s13**2*s14*s24 + 80*s13**2*s14*
     +    s34 + 48*s13**2*s24**2 + 112*s13**2*s24*s34 + 120*s13*s14**3
     +     - 48*s13*s14**2*s24 + 848*s13*s14**2*s34 - 144*s13*s14*
     +    s24**2 + 304*s13*s14*s24*s34 + 56*s13*s14*s34**2 - 24*s13*
     +    s24**3 )

      LC = LC + Ld1(p3,p4,p12)*S23**(-1)*S124**(-1) * (  - 112*s13*
     +    s24**2*s34 + 8*s13*s24*s34**2 + 16*s13*s34**3 + 192*s14**3*
     +    s34 + 128*s14**2*s24*s34 - 160*s14**2*s34**2 - 32*s14*s24**2*
     +    s34 - 192*s14*s24*s34**2 - 32*s24**2*s34**2 )

      LC = LC + Ld1(p3,p4,p12)*S24**(-1)*S34**(-1)*S124**(-1) * ( 96*
     +    s12*s13**2*s14**2 - 96*s12*s13*s14**3 + 192*s12*s13*s14**2*
     +    s23 - 192*s12*s14**4 + 96*s12*s14**3*s23 + 96*s12*s14**2*
     +    s23**2 )

      LC = LC + Ld1(p3,p4,p12)*S24**(-1)*S124**(-1) * (  - 96*s12**3*
     +    s13 - 48*s12**3*s14 + 544*s12**3*s34 - 80*s12**2*s13*s14 - 32
     +    *s12**2*s13*s23 - 24*s12**2*s13*s34 + 736*s12**2*s14**2 - 560
     +    *s12**2*s14*s23 - 2232*s12**2*s14*s34 - 32*s12**2*s23**2 - 
     +    120*s12**2*s23*s34 - 248*s12**2*s34**2 + 8*s12*s13**3 + 16*
     +    s12*s13**2*s14 + 8*s12*s13**2*s23 + 40*s12*s13**2*s34 + 696*
     +    s12*s13*s14**2 - 32*s12*s13*s14*s23 - 24*s12*s13*s14*s34 - 8*
     +    s12*s13*s23**2 + 16*s12*s13*s23*s34 + 64*s12*s13*s34**2 + 576
     +    *s12*s14**3 + 264*s12*s14**2*s23 + 448*s12*s14**2*s34 - 80*
     +    s12*s14*s23**2 - 144*s12*s14*s23*s34 - 64*s12*s14*s34**2 - 8*
     +    s12*s23**3 - 8*s12*s23**2*s34 + 16*s12*s23*s34**2 + 24*s12*
     +    s34**3 - 24*s13**3*s14 + 16*s13**2*s14**2 - 32*s13**2*s14*s23
     +     - 64*s13**2*s14*s34 + 48*s13*s14**3 + 16*s13*s14**2*s34 - 32
     +    *s13*s14*s23**2 - 80*s13*s14*s23*s34 - 56*s13*s14*s34**2 + 48
     +    *s14**3*s23 + 32*s14**3*s34 - 16*s14**2*s23**2 - 16*s14**2*
     +    s23*s34 - 24*s14*s23**3 - 64*s14*s23**2*s34 - 56*s14*s23*
     +    s34**2 )

      LC = LC + Ld1(p3,p4,p12)*S24**(-1)*S124**(-1) * (  - 16*s14*
     +    s34**3 )

      LC = LC + Ld1(p3,p4,p12)*S34**(-1)*S124**(-1) * ( 96*s12*s13**2*
     +    s14 - 96*s12*s13*s14**2 + 192*s12*s13*s14*s23 - 192*s12*
     +    s14**3 + 96*s12*s14**2*s23 + 96*s12*s14*s23**2 )

      LC = LC + Ld1(p3,p4,p12)*S124**(-1) * (  - 48*s12**2*s13 + 480*
     +    s12**2*s14 - 336*s12**2*s23 - 1200*s12**2*s34 + 528*s12*s13*
     +    s14 + 384*s12*s14**2 + 240*s12*s14*s23 + 384*s12*s14*s34 )

      LC = LC + Ld1(p4,p1,p23)*S13**(-1)*S14**(-1)*S24**(-1)*S123**(-1)
     + *S234 * (  - 8*s12**3*s34**2 )

      LC = LC + Ld1(p4,p1,p23)*S13**(-1)*S14**(-1)*S123**(-1)*S234 * ( 
     +    16*s12**3*s24 + 32*s12**2*s23*s24 + 24*s12**2*s23*s34 - 32*
     +    s12**2*s24**2 - 48*s12**2*s24*s34 - 16*s12**2*s34**2 )

      LC = LC + Ld1(p4,p1,p23)*S13**(-1)*S24**(-1)*S123**(-1)*S234 * ( 
     +     - 8*s12**3*s34 + 8*s12**2*s14*s23 + 8*s12**2*s23*s34 )

      LC = LC + Ld1(p4,p1,p23)*S13**(-1)*S123**(-1)*S234 * ( 16*s12**2*
     +    s23 - 8*s12*s23**2 + 48*s12*s23*s24 + 32*s12*s23*s34 - 16*s14
     +    *s23**2 )

      LC = LC + Ld1(p4,p1,p23)*S14**(-1)*S24**(-1)*S123**(-1)*S234 * ( 
     +     - 8*s12**3*s34 - 8*s12**2*s13*s34 - 8*s12**2*s34**2 - 8*s12*
     +    s13*s23*s34 - 8*s12*s23*s34**2 )

      LC = LC + Ld1(p4,p1,p23)*S14**(-1)*S123**(-1)*S234 * ( 8*s12**2*
     +    s13 + 16*s12**2*s23 + 32*s12**2*s24 + 8*s12**2*s34 + 8*s12*
     +    s13**2 + 16*s12*s13*s24 + 8*s12*s13*s34 + 24*s12*s23*s24 - 48
     +    *s12*s24**2 - 64*s12*s24*s34 - 16*s12*s34**2 - 8*s13**2*s23
     +     - 8*s13*s23*s34 - 16*s13*s24**2 - 16*s13*s24*s34 )

      LC = LC + Ld1(p4,p1,p23)*S23**(-1)*S24**(-1)*S123**(-1)*S234 * ( 
     +    8*s12*s13*s34**2 + 8*s12*s14*s34**2 + 8*s12*s34**3 + 8*s13*
     +    s14*s34**2 + 8*s14**2*s34**2 + 8*s14*s34**3 )

      LC = LC + Ld1(p4,p1,p23)*S23**(-1)*S24**(-1)*S123**(-1) * (  - 8*
     +    s12*s13*s34**3 - 8*s12*s14*s34**3 - 8*s12*s34**4 - 8*s13*s14*
     +    s34**3 - 8*s14**2*s34**3 - 8*s14*s34**4 )

      LC = LC + Ld1(p4,p1,p23)*S23**(-1)*S123**(-1)*S234 * ( 16*s12*s13
     +    *s24 + 24*s12*s13*s34 + 16*s12*s14*s24 + 24*s12*s14*s34 + 16*
     +    s12*s24*s34 + 24*s12*s34**2 + 8*s13**2*s24 + 8*s13**2*s34 + 
     +    16*s13*s14*s24 + 24*s13*s14*s34 + 8*s13*s24*s34 + 8*s13*
     +    s34**2 + 8*s14**2*s24 + 16*s14**2*s34 + 8*s14*s24*s34 + 16*
     +    s14*s34**2 )

      LC = LC + Ld1(p4,p1,p23)*S23**(-1)*S123**(-1) * (  - 16*s12*s13*
     +    s24**2 - 40*s12*s13*s24*s34 - 32*s12*s13*s34**2 - 16*s12*s14*
     +    s24**2 - 40*s12*s14*s24*s34 - 32*s12*s14*s34**2 - 16*s12*
     +    s24**2*s34 - 40*s12*s24*s34**2 - 32*s12*s34**3 - 8*s13**2*
     +    s24**2 - 16*s13**2*s24*s34 - 8*s13**2*s34**2 - 16*s13*s14*
     +    s24**2 - 40*s13*s14*s24*s34 - 32*s13*s14*s34**2 - 8*s13*
     +    s24**2*s34 - 16*s13*s24*s34**2 - 8*s13*s34**3 - 8*s14**2*
     +    s24**2 - 24*s14**2*s24*s34 - 24*s14**2*s34**2 - 8*s14*s24**2*
     +    s34 - 24*s14*s24*s34**2 - 24*s14*s34**3 )

      LC = LC + Ld1(p4,p1,p23)*S24**(-1)*S123**(-1)*S234 * ( 8*s12**2*
     +    s23 - 8*s12**2*s34 + 8*s12*s13*s23 - 8*s12*s13*s34 + 8*s12*
     +    s14*s23 - 8*s12*s14*s34 - 8*s12*s34**2 + 8*s13*s14*s23 - 8*
     +    s13*s14*s34 + 8*s13*s23**2 + 8*s14**2*s23 - 8*s14**2*s34 + 8*
     +    s14*s23**2 + 8*s14*s23*s34 - 8*s14*s34**2 + 8*s23**2*s34 )

      LC = LC + Ld1(p4,p1,p23)*S123**(-1)*S234 * ( 8*s12**2 - 8*s12*s13
     +     - 16*s12*s14 - 16*s12*s34 - 8*s13**2 - 16*s13*s14 - 8*s13*
     +    s23 - 8*s13*s34 - 8*s14**2 - 8*s14*s34 + 32*s23*s24 + 16*s23*
     +    s34 )

      LC = LC + Ld1(p4,p2,p13)*S13**(-1)*S14**(-1)*S123**(-1)*S134 * ( 
     +    8*s12*s23*s34**2 + 8*s12*s24*s34**2 + 8*s12*s34**3 + 8*s23*
     +    s24*s34**2 + 8*s24**2*s34**2 + 8*s24*s34**3 )

      LC = LC + Ld1(p4,p2,p13)*S13**(-1)*S14**(-1)*S123**(-1) * (  - 8*
     +    s12*s23*s34**3 - 8*s12*s24*s34**3 - 8*s12*s34**4 - 8*s23*s24*
     +    s34**3 - 8*s24**2*s34**3 - 8*s24*s34**4 )

      LC = LC + Ld1(p4,p2,p13)*S13**(-1)*S123**(-1)*S134 * ( 16*s12*s14
     +    *s23 + 16*s12*s14*s24 + 16*s12*s14*s34 + 24*s12*s23*s34 + 24*
     +    s12*s24*s34 + 24*s12*s34**2 + 8*s14*s23**2 + 16*s14*s23*s24
     +     + 8*s14*s23*s34 + 8*s14*s24**2 + 8*s14*s24*s34 + 8*s23**2*
     +    s34 + 24*s23*s24*s34 + 8*s23*s34**2 + 16*s24**2*s34 + 16*s24*
     +    s34**2 )

      LC = LC + Ld1(p4,p2,p13)*S13**(-1)*S123**(-1) * (  - 16*s12*
     +    s14**2*s23 - 16*s12*s14**2*s24 - 16*s12*s14**2*s34 - 40*s12*
     +    s14*s23*s34 - 40*s12*s14*s24*s34 - 40*s12*s14*s34**2 - 32*s12
     +    *s23*s34**2 - 32*s12*s24*s34**2 - 32*s12*s34**3 - 8*s14**2*
     +    s23**2 - 16*s14**2*s23*s24 - 8*s14**2*s23*s34 - 8*s14**2*
     +    s24**2 - 8*s14**2*s24*s34 - 16*s14*s23**2*s34 - 40*s14*s23*
     +    s24*s34 - 16*s14*s23*s34**2 - 24*s14*s24**2*s34 - 24*s14*s24*
     +    s34**2 - 8*s23**2*s34**2 - 32*s23*s24*s34**2 - 8*s23*s34**3
     +     - 24*s24**2*s34**2 - 24*s24*s34**3 )

      LC = LC + Ld1(p4,p2,p13)*S14**(-1)*S23**(-1)*S24**(-1)*S123**(-1)
     + *S134 * (  - 8*s12**3*s34**2 )

      LC = LC + Ld1(p4,p2,p13)*S14**(-1)*S23**(-1)*S123**(-1)*S134 * ( 
     +     - 8*s12**3*s34 + 8*s12**2*s13*s24 + 8*s12**2*s13*s34 )

      LC = LC + Ld1(p4,p2,p13)*S14**(-1)*S24**(-1)*S123**(-1)*S134 * ( 
     +     - 8*s12**3*s34 - 8*s12**2*s23*s34 - 8*s12**2*s34**2 - 8*s12*
     +    s13*s23*s34 - 8*s12*s13*s34**2 )

      LC = LC + Ld1(p4,p2,p13)*S14**(-1)*S123**(-1)*S134 * ( 8*s12**2*
     +    s13 - 8*s12**2*s34 + 8*s12*s13*s23 + 8*s12*s13*s24 - 8*s12*
     +    s23*s34 - 8*s12*s24*s34 - 8*s12*s34**2 + 8*s13**2*s23 + 8*
     +    s13**2*s24 + 8*s13**2*s34 + 8*s13*s23*s24 + 8*s13*s24**2 + 8*
     +    s13*s24*s34 - 8*s23*s24*s34 - 8*s24**2*s34 - 8*s24*s34**2 )

      LC = LC + Ld1(p4,p2,p13)*S23**(-1)*S24**(-1)*S123**(-1)*S134 * ( 
     +    16*s12**3*s14 + 32*s12**2*s13*s14 + 24*s12**2*s13*s34 - 32*
     +    s12**2*s14**2 - 48*s12**2*s14*s34 - 16*s12**2*s34**2 )

      LC = LC + Ld1(p4,p2,p13)*S23**(-1)*S123**(-1)*S134 * ( 16*s12**2*
     +    s13 - 8*s12*s13**2 + 48*s12*s13*s14 + 32*s12*s13*s34 - 16*
     +    s13**2*s24 )

      LC = LC + Ld1(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * ( 16*s12**2*
     +    s13 + 32*s12**2*s14 + 8*s12**2*s23 + 8*s12**2*s34 + 24*s12*
     +    s13*s14 - 48*s12*s14**2 + 16*s12*s14*s23 - 64*s12*s14*s34 + 8
     +    *s12*s23**2 + 8*s12*s23*s34 - 16*s12*s34**2 - 8*s13*s23**2 - 
     +    8*s13*s23*s34 - 16*s14**2*s23 - 16*s14*s23*s34 )

      LC = LC + Ld1(p4,p2,p13)*S123**(-1)*S134 * ( 8*s12**2 - 8*s12*s23
     +     - 16*s12*s24 - 16*s12*s34 + 32*s13*s14 - 8*s13*s23 + 16*s13*
     +    s34 - 8*s23**2 - 16*s23*s24 - 8*s23*s34 - 8*s24**2 - 8*s24*
     +    s34 )

      LC = LC + Ld1(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1)*S123**(-1)
     +  * ( 64*s12**4*s14*s34 - 336*s12**4*s34**2 + 64*s12**3*s14**2*
     +    s34 - 256*s12**3*s14*s34**2 + 104*s12**3*s34**3 + 32*s12**2*
     +    s14**2*s34**2 - 40*s12**2*s14*s34**3 - 16*s12**2*s34**4 )

      LC = LC + Ld1(p4,p3,p12)*S13**(-1)*S23**(-1)*S123**(-1) * (  - 16
     +    *s12**4*s34 - 64*s12**3*s14*s34 + 32*s12**3*s24*s34 + 88*
     +    s12**3*s34**2 - 8*s12**2*s14*s24*s34 - 40*s12**2*s14*s34**2
     +     + 8*s12**2*s24**2*s34 + 16*s12**2*s24*s34**2 )

      LC = LC + Ld1(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 32*
     +    s12**4*s34 + 48*s12**3*s14**2 + 224*s12**3*s14*s34 + 112*
     +    s12**3*s23*s34 - 88*s12**3*s34**2 - 48*s12**2*s14**3 + 144*
     +    s12**2*s14**2*s23 + 272*s12**2*s14**2*s34 + 16*s12**2*s14*
     +    s23**2 - 160*s12**2*s14*s23*s34 - 312*s12**2*s14*s34**2 + 152
     +    *s12**2*s23**2*s34 + 128*s12**2*s23*s34**2 + 56*s12**2*s34**3
     +     - 48*s12*s14**3*s23 - 32*s12*s14**3*s34 + 88*s12*s14**2*
     +    s23**2 + 160*s12*s14**2*s23*s34 + 56*s12*s14**2*s34**2 + 40*
     +    s12*s14*s23**3 - 104*s12*s14*s23**2*s34 - 104*s12*s14*s23*
     +    s34**2 + 8*s12*s14*s34**3 + 104*s12*s23**3*s34 + 152*s12*
     +    s23**2*s34**2 + 8*s12*s23*s34**3 - 8*s12*s34**4 - 16*s14**3*
     +    s23*s34 - 8*s14**2*s23**3 + 48*s14**2*s23**2*s34 + 8*s14**2*
     +    s23*s34**2 + 24*s14*s23**4 - 24*s14*s23**3*s34 - 8*s14*s23**2
     +    *s34**2 + 8*s14*s23*s34**3 + 32*s23**4*s34 + 32*s23**3*s34**2
     +     )

      LC = LC + Ld1(p4,p3,p12)*S13**(-1)*S123**(-1) * ( 224*s12**3*s34
     +     )

      LC = LC + Ld1(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1)*S123**(-1)
     +  * ( 16*s12**4*s13*s34 - 336*s12**4*s34**2 - 528*s12**3*s13**2*
     +    s34 + 1376*s12**3*s13*s34**2 - 488*s12**3*s34**3 + 128*s12**2
     +    *s13**3*s34 - 368*s12**2*s13**2*s34**2 + 168*s12**2*s13*
     +    s34**3 + 16*s12**2*s34**4 + 48*s12*s13**4*s34 - 64*s12*s13**3
     +    *s34**2 + 32*s12*s13**2*s34**3 )

      LC = LC + Ld1(p4,p3,p12)*S14**(-1)*S23**(-1)*S34**(-1)*S123**(-1)
     +  * (  - 96*s12*s13**4*s24 + 96*s12*s13**3*s24**2 )

      LC = LC + Ld1(p4,p3,p12)*S14**(-1)*S23**(-1)*S123**(-1) * (  - 16
     +    *s12**4*s34 + 48*s12**3*s13**2 + 576*s12**3*s13*s34 + 16*
     +    s12**3*s24*s34 - 232*s12**3*s34**2 + 672*s12**2*s13**3 - 384*
     +    s12**2*s13**2*s24 - 1872*s12**2*s13**2*s34 - 32*s12**2*s13*
     +    s24**2 + 368*s12**2*s13*s24*s34 + 824*s12**2*s13*s34**2 + 40*
     +    s12**2*s24**2*s34 + 96*s12**2*s24*s34**2 + 72*s12**2*s34**3
     +     - 96*s12*s13**4 + 528*s12*s13**3*s24 + 368*s12*s13**3*s34 - 
     +    184*s12*s13**2*s24**2 - 368*s12*s13**2*s24*s34 - 136*s12*
     +    s13**2*s34**2 - 40*s12*s13*s24**3 - 88*s12*s13*s24**2*s34 - 
     +    56*s12*s13*s24*s34**2 - 8*s12*s13*s34**3 + 8*s12*s24**3*s34
     +     + 24*s12*s24**2*s34**2 + 24*s12*s24*s34**3 + 8*s12*s34**4 + 
     +    16*s13**3*s24**2 + 16*s13**3*s24*s34 - 8*s13**2*s24**3 - 16*
     +    s13**2*s24**2*s34 - 8*s13**2*s24*s34**2 - 8*s13*s24**4 - 24*
     +    s13*s24**3*s34 - 24*s13*s24**2*s34**2 - 8*s13*s24*s34**3 )

      LC = LC + Ld1(p4,p3,p12)*S14**(-1)*S24**(-1)*S123**(-1) * ( 32*
     +    s12**4*s34 + 64*s12**3*s13*s34 + 80*s12**3*s23*s34 - 168*
     +    s12**3*s34**2 - 64*s12**2*s13**2*s34 + 40*s12**2*s13*s23*s34
     +     + 328*s12**2*s13*s34**2 + 72*s12**2*s23**2*s34 + 16*s12**2*
     +    s23*s34**2 - 176*s12**2*s34**3 + 32*s12*s13**3*s34 - 48*s12*
     +    s13**2*s23*s34 - 16*s12*s13**2*s34**2 + 112*s12*s13*s23*
     +    s34**2 + 16*s12*s13*s34**3 + 32*s12*s23**3*s34 + 64*s12*
     +    s23**2*s34**2 - 16*s12*s23*s34**3 )

      LC = LC + Ld1(p4,p3,p12)*S14**(-1)*S34**(-1)*S123**(-1) * (  - 96
     +    *s12*s13**3*s24 + 96*s12*s13**2*s24**2 )

      LC = LC + Ld1(p4,p3,p12)*S14**(-1)*S123**(-1) * ( 224*s12**3*s34
     +     + 528*s12**2*s13**2 - 336*s12**2*s13*s24 - 1088*s12**2*s13*
     +    s34 + 128*s12**2*s24*s34 + 208*s12**2*s34**2 - 96*s12*s13**3
     +     + 432*s12*s13**2*s24 + 288*s12*s13**2*s34 - 144*s12*s13*
     +    s24**2 - 240*s12*s13*s24*s34 - 48*s12*s13*s34**2 )

      LC = LC + Ld1(p4,p3,p12)*S23**(-1)*S24**(-1)*S34**(-1)*S123**(-1)
     +  * (  - 96*s12*s13**4*s14 - 96*s12*s13**3*s14**2 )

      LC = LC + Ld1(p4,p3,p12)*S23**(-1)*S24**(-1)*S123**(-1) * ( 80*
     +    s12**4*s34 + 144*s12**3*s13**2 + 288*s12**3*s13*s14 - 1264*
     +    s12**3*s13*s34 + 144*s12**3*s14**2 - 768*s12**3*s14*s34 + 
     +    1728*s12**3*s34**2 + 864*s12**2*s13**3 + 1856*s12**2*s13**2*
     +    s14 - 2072*s12**2*s13**2*s34 + 944*s12**2*s13*s14**2 - 2320*
     +    s12**2*s13*s14*s34 - 672*s12**2*s13*s34**2 - 48*s12**2*s14**3
     +     + 280*s12**2*s14**2*s34 - 80*s12**2*s14*s34**2 - 208*s12**2*
     +    s34**3 + 520*s12*s13**3*s14 + 328*s12*s13**3*s34 + 576*s12*
     +    s13**2*s14**2 + 1600*s12*s13**2*s14*s34 - 464*s12*s13**2*
     +    s34**2 - 40*s12*s13*s14**3 + 64*s12*s13*s14**2*s34 + 272*s12*
     +    s13*s14*s34**2 - 96*s12*s13*s34**3 - 24*s12*s14**3*s34 + 80*
     +    s12*s14**2*s34**2 + 48*s12*s14*s34**3 + 72*s13**4*s14 + 64*
     +    s13**4*s34 + 88*s13**3*s14**2 + 472*s13**3*s14*s34 - 32*
     +    s13**3*s34**2 + 8*s13**2*s14**3 + 32*s13**2*s14**2*s34 + 48*
     +    s13**2*s14*s34**2 - 8*s13*s14**4 - 40*s13*s14**3*s34 - 32*s13
     +    *s14**2*s34**2 )

      LC = LC + Ld1(p4,p3,p12)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    192*s12*s13**4 - 96*s12*s13**3*s14 + 96*s12*s13**3*s24 + 96*
     +    s12*s13**2*s14**2 + 192*s12*s13**2*s14*s24 + 96*s12*s13**2*
     +    s24**2 )

      LC = LC + Ld1(p4,p3,p12)*S23**(-1)*S123**(-1) * (  - 48*s12**3*
     +    s13 - 96*s12**3*s14 + 544*s12**3*s34 + 736*s12**2*s13**2 - 80
     +    *s12**2*s13*s14 - 560*s12**2*s13*s24 - 2232*s12**2*s13*s34 - 
     +    32*s12**2*s14*s24 - 24*s12**2*s14*s34 - 32*s12**2*s24**2 - 
     +    120*s12**2*s24*s34 - 248*s12**2*s34**2 + 576*s12*s13**3 + 696
     +    *s12*s13**2*s14 + 264*s12*s13**2*s24 + 448*s12*s13**2*s34 + 
     +    16*s12*s13*s14**2 - 32*s12*s13*s14*s24 - 24*s12*s13*s14*s34
     +     - 80*s12*s13*s24**2 - 144*s12*s13*s24*s34 - 64*s12*s13*
     +    s34**2 + 8*s12*s14**3 + 8*s12*s14**2*s24 + 40*s12*s14**2*s34
     +     - 8*s12*s14*s24**2 + 16*s12*s14*s24*s34 + 64*s12*s14*s34**2
     +     - 8*s12*s24**3 - 8*s12*s24**2*s34 + 16*s12*s24*s34**2 + 24*
     +    s12*s34**3 + 48*s13**3*s14 + 48*s13**3*s24 + 32*s13**3*s34 + 
     +    16*s13**2*s14**2 + 16*s13**2*s14*s34 - 16*s13**2*s24**2 - 16*
     +    s13**2*s24*s34 - 24*s13*s14**3 - 32*s13*s14**2*s24 - 64*s13*
     +    s14**2*s34 - 32*s13*s14*s24**2 - 80*s13*s14*s24*s34 - 56*s13*
     +    s14*s34**2 - 24*s13*s24**3 - 64*s13*s24**2*s34 - 56*s13*s24*
     +    s34**2 )

      LC = LC + Ld1(p4,p3,p12)*S23**(-1)*S123**(-1) * (  - 16*s13*
     +    s34**3 )

      LC = LC + Ld1(p4,p3,p12)*S24**(-1)*S34**(-1)*S123**(-1) * (  - 96
     +    *s12*s13**3*s14 - 96*s12*s13**2*s14**2 )

      LC = LC + Ld1(p4,p3,p12)*S24**(-1)*S123**(-1) * (  - 96*s12**3*
     +    s13 - 48*s12**3*s14 + 272*s12**3*s34 + 576*s12**2*s13**2 + 
     +    1408*s12**2*s13*s14 - 128*s12**2*s13*s23 - 2472*s12**2*s13*
     +    s34 + 928*s12**2*s14**2 - 128*s12**2*s14*s23 - 2840*s12**2*
     +    s14*s34 + 16*s12**2*s23**2 - 40*s12**2*s23*s34 + 1176*s12**2*
     +    s34**2 + 40*s12*s13**3 + 672*s12*s13**2*s14 + 8*s12*s13**2*
     +    s23 - 264*s12*s13**2*s34 + 888*s12*s13*s14**2 + 64*s12*s13*
     +    s14*s23 + 568*s12*s13*s14*s34 - 8*s12*s13*s23**2 - 672*s12*
     +    s13*s23*s34 - 336*s12*s13*s34**2 - 96*s12*s14**3 + 504*s12*
     +    s14**2*s23 + 192*s12*s14**2*s34 - 144*s12*s14*s23**2 - 944*
     +    s12*s14*s23*s34 + 128*s12*s14*s34**2 + 24*s12*s23**3 - 56*s12
     +    *s23**2*s34 + 368*s12*s23*s34**2 - 88*s12*s34**3 + 120*s13**3
     +    *s14 + 192*s13**3*s34 + 208*s13**2*s14**2 - 48*s13**2*s14*s23
     +     + 848*s13**2*s14*s34 + 128*s13**2*s23*s34 - 160*s13**2*
     +    s34**2 + 192*s13*s14**2*s23 + 80*s13*s14**2*s34 - 144*s13*s14
     +    *s23**2 + 304*s13*s14*s23*s34 + 56*s13*s14*s34**2 - 32*s13*
     +    s23**2*s34 )

      LC = LC + Ld1(p4,p3,p12)*S24**(-1)*S123**(-1) * (  - 192*s13*s23*
     +    s34**2 - 32*s14**3*s34 + 48*s14**2*s23**2 + 112*s14**2*s23*
     +    s34 - 24*s14*s23**3 - 112*s14*s23**2*s34 + 8*s14*s23*s34**2
     +     + 16*s14*s34**3 - 32*s23**2*s34**2 )

      LC = LC + Ld1(p4,p3,p12)*S34**(-1)*S123**(-1) * (  - 192*s12*
     +    s13**3 - 96*s12*s13**2*s14 + 96*s12*s13**2*s24 + 96*s12*s13*
     +    s14**2 + 192*s12*s13*s14*s24 + 96*s12*s13*s24**2 )

      LC = LC + Ld1(p4,p3,p12)*S123**(-1) * ( 480*s12**2*s13 - 48*
     +    s12**2*s14 - 336*s12**2*s24 - 1200*s12**2*s34 + 384*s12*
     +    s13**2 + 528*s12*s13*s14 + 240*s12*s13*s24 + 384*s12*s13*s34
     +     )

      LCf=-LC/s134/s234
      
      return
      end
      
      function LCg(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LC=0d0

      LC = LC + Ld21(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * (  - 8*s12*
     +    s23**2 - 16*s12*s23*s34 - 8*s12*s34**2 )

      LC = LC + Ld21(p1,p2,p34)*S14**(-1)*S23**(-1)*S134 * (  - 8*s12*
     +    s24**2 - 16*s12*s24*s34 - 8*s12*s34**2 )

      LC = LC + Ld21(p1,p3,p24)*S14**(-1)*S23**(-1) * ( 8*s12*s13*
     +    s24**2 + 8*s12*s24**2*s34 )

      LC = LC + Ld21(p1,p3,p24)*S14**(-1) * ( 8*s12*s13*s23 + 16*s12*
     +    s13*s24 + 8*s12*s23**2 + 16*s12*s23*s24 + 8*s12*s23*s34 + 8*
     +    s12*s24**2 + 16*s12*s24*s34 )

      LC = LC + Ld21(p1,p3,p24)*S23**(-1) * ( 8*s12*s24**2 + 8*s13*
     +    s24**2 + 8*s14*s24**2 + 8*s24**2*s34 )

      LC = LC + Ld21(p1,p3,p24) * ( 8*s12*s23 + 16*s12*s24 + 8*s13*s23
     +     + 16*s13*s24 + 8*s14*s23 + 16*s14*s24 + 8*s23**2 + 16*s23*
     +    s24 + 8*s23*s34 + 8*s24**2 + 16*s24*s34 )

      LC = LC + Ld21(p1,p4,p23)*S13**(-1)*S24**(-1) * ( 8*s12*s14*
     +    s23**2 + 8*s12*s23**2*s34 )

      LC = LC + Ld21(p1,p4,p23)*S13**(-1) * ( 16*s12*s14*s23 + 8*s12*
     +    s14*s24 + 8*s12*s23**2 + 16*s12*s23*s24 + 16*s12*s23*s34 + 8*
     +    s12*s24**2 + 8*s12*s24*s34 )

      LC = LC + Ld21(p1,p4,p23)*S24**(-1) * ( 8*s12*s23**2 + 8*s13*
     +    s23**2 + 8*s14*s23**2 + 8*s23**2*s34 )

      LC = LC + Ld21(p1,p4,p23) * ( 16*s12*s23 + 8*s12*s24 + 16*s13*s23
     +     + 8*s13*s24 + 16*s14*s23 + 8*s14*s24 + 8*s23**2 + 16*s23*s24
     +     + 16*s23*s34 + 8*s24**2 + 8*s24*s34 )

      LC = LC + Ld21(p1,p23,p4)*S13**(-1)*S24**(-1) * (  - 16*s12**3*
     +    s23 - 8*s12**3*s34 + 24*s12**2*s14*s23 + 16*s12**2*s34**2 - 
     +    16*s12*s14**2*s23 - 16*s12*s14*s23**2 )

      LC = LC + Ld21(p1,p23,p4)*S13**(-1) * (  - 16*s12**3 + 8*s12**2*
     +    s14 + 8*s12**2*s23 + 8*s12**2*s24 + 16*s12**2*s34 - 16*s12*
     +    s14*s23 )

      LC = LC + Ld21(p1,p23,p4)*S24**(-1) * (  - 16*s12**2*s23 - 8*
     +    s12**2*s34 - 24*s12*s13*s34 - 24*s12*s14*s34 - 24*s12*s23*s34
     +     + 16*s12*s34**2 + 8*s13**2*s23 - 16*s13**2*s34 + 8*s13*s14*
     +    s23 - 16*s13*s14*s34 - 16*s13*s23*s34 + 8*s13*s34**2 )

      LC = LC + Ld21(p1,p23,p4) * (  - 16*s12**2 - 8*s12*s13 )

      LC = LC + Ld21(p1,p24,p3)*S14**(-1)*S23**(-1) * (  - 16*s12**3*
     +    s24 - 8*s12**3*s34 + 24*s12**2*s13*s24 + 16*s12**2*s34**2 - 
     +    16*s12*s13**2*s24 - 16*s12*s13*s24**2 )

      LC = LC + Ld21(p1,p24,p3)*S14**(-1) * (  - 16*s12**3 + 8*s12**2*
     +    s13 + 8*s12**2*s23 + 8*s12**2*s24 + 16*s12**2*s34 - 16*s12*
     +    s13*s24 )

      LC = LC + Ld21(p1,p24,p3)*S23**(-1) * (  - 16*s12**2*s24 - 8*
     +    s12**2*s34 - 24*s12*s13*s34 - 24*s12*s14*s34 - 24*s12*s24*s34
     +     + 16*s12*s34**2 + 8*s13*s14*s24 - 16*s13*s14*s34 + 8*s14**2*
     +    s24 - 16*s14**2*s34 - 16*s14*s24*s34 + 8*s14*s34**2 )

      LC = LC + Ld21(p1,p24,p3) * (  - 16*s12**2 - 8*s12*s14 )

      LC = LC + Ld21(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * (  - 8*s12*
     +    s14**2 - 16*s12*s14*s34 - 8*s12*s34**2 )

      LC = LC + Ld21(p2,p1,p34)*S14**(-1)*S23**(-1)*S234 * (  - 8*s12*
     +    s13**2 - 16*s12*s13*s34 - 8*s12*s34**2 )

      LC = LC + Ld21(p2,p3,p14)*S13**(-1)*S24**(-1) * ( 8*s12*s14**2*
     +    s23 + 8*s12*s14**2*s34 )

      LC = LC + Ld21(p2,p3,p14)*S13**(-1) * ( 8*s12*s14**2 + 8*s14**2*
     +    s23 + 8*s14**2*s24 + 8*s14**2*s34 )

      LC = LC + Ld21(p2,p3,p14)*S24**(-1) * ( 8*s12*s13**2 + 16*s12*s13
     +    *s14 + 8*s12*s13*s23 + 8*s12*s13*s34 + 8*s12*s14**2 + 16*s12*
     +    s14*s23 + 16*s12*s14*s34 )

      LC = LC + Ld21(p2,p3,p14) * ( 8*s12*s13 + 16*s12*s14 + 8*s13**2
     +     + 16*s13*s14 + 8*s13*s23 + 8*s13*s24 + 8*s13*s34 + 8*s14**2
     +     + 16*s14*s23 + 16*s14*s24 + 16*s14*s34 )

      LC = LC + Ld21(p2,p4,p13)*S14**(-1)*S23**(-1) * ( 8*s12*s13**2*
     +    s24 + 8*s12*s13**2*s34 )

      LC = LC + Ld21(p2,p4,p13)*S14**(-1) * ( 8*s12*s13**2 + 8*s13**2*
     +    s23 + 8*s13**2*s24 + 8*s13**2*s34 )

      LC = LC + Ld21(p2,p4,p13)*S23**(-1) * ( 8*s12*s13**2 + 16*s12*s13
     +    *s14 + 16*s12*s13*s24 + 16*s12*s13*s34 + 8*s12*s14**2 + 8*s12
     +    *s14*s24 + 8*s12*s14*s34 )

      LC = LC + Ld21(p2,p4,p13) * ( 16*s12*s13 + 8*s12*s14 + 8*s13**2
     +     + 16*s13*s14 + 16*s13*s23 + 16*s13*s24 + 16*s13*s34 + 8*
     +    s14**2 + 8*s14*s23 + 8*s14*s24 + 8*s14*s34 )

      LC = LC + Ld21(p2,p13,p4)*S14**(-1)*S23**(-1) * (  - 16*s12**3*
     +    s13 - 8*s12**3*s34 + 24*s12**2*s13*s24 + 16*s12**2*s34**2 - 
     +    16*s12*s13**2*s24 - 16*s12*s13*s24**2 )

      LC = LC + Ld21(p2,p13,p4)*S14**(-1) * (  - 16*s12**2*s13 - 8*
     +    s12**2*s34 - 24*s12*s13*s34 - 24*s12*s23*s34 - 24*s12*s24*s34
     +     + 16*s12*s34**2 + 8*s13*s23**2 + 8*s13*s23*s24 - 16*s13*s23*
     +    s34 - 16*s23**2*s34 - 16*s23*s24*s34 + 8*s23*s34**2 )

      LC = LC + Ld21(p2,p13,p4)*S23**(-1) * (  - 16*s12**3 + 8*s12**2*
     +    s13 + 8*s12**2*s14 + 8*s12**2*s24 + 16*s12**2*s34 - 16*s12*
     +    s13*s24 )

      LC = LC + Ld21(p2,p13,p4) * (  - 16*s12**2 - 8*s12*s23 )

      LC = LC + Ld21(p2,p14,p3)*S13**(-1)*S24**(-1) * (  - 16*s12**3*
     +    s14 - 8*s12**3*s34 + 24*s12**2*s14*s23 + 16*s12**2*s34**2 - 
     +    16*s12*s14**2*s23 - 16*s12*s14*s23**2 )

      LC = LC + Ld21(p2,p14,p3)*S13**(-1) * (  - 16*s12**2*s14 - 8*
     +    s12**2*s34 - 24*s12*s14*s34 - 24*s12*s23*s34 - 24*s12*s24*s34
     +     + 16*s12*s34**2 + 8*s14*s23*s24 + 8*s14*s24**2 - 16*s14*s24*
     +    s34 - 16*s23*s24*s34 - 16*s24**2*s34 + 8*s24*s34**2 )

      LC = LC + Ld21(p2,p14,p3)*S24**(-1) * (  - 16*s12**3 + 8*s12**2*
     +    s13 + 8*s12**2*s14 + 8*s12**2*s23 + 16*s12**2*s34 - 16*s12*
     +    s14*s23 )

      LC = LC + Ld21(p2,p14,p3) * (  - 16*s12**2 - 8*s12*s24 )

      LC = LC + Ld21(p3,p1,p4)*S14**(-1)*S34**(-1) * ( 24*s13**2*s23*
     +    s24 + 24*s13**2*s24**2 )

      LC = LC + Ld21(p3,p1,p4)*S34**(-1) * (  - 24*s13*s23**2 + 24*s13*
     +    s24**2 - 24*s14*s23**2 - 24*s14*s23*s24 )

      LC = LC + Ld21(p3,p1,p24)*S14**(-1)*S23**(-1)*S234*S124**(-1)
     +  * ( 8*s12**3*s13 + 8*s12**3*s34 + 16*s12**2*s13*s24 + 16*s12**2
     +    *s24*s34 + 8*s12*s13*s24**2 + 8*s12*s24**2*s34 )

      LC = LC + Ld21(p3,p1,p24)*S14**(-1)*S234*S124**(-1) * ( 8*s12**3
     +     + 16*s12**2*s24 + 8*s12*s24**2 )

      LC = LC + Ld21(p3,p1,p24)*S23**(-1)*S234*S124**(-1) * ( 8*s12**3
     +     + 8*s12**2*s13 + 8*s12**2*s14 + 16*s12**2*s24 + 8*s12**2*s34
     +     + 16*s12*s13*s24 + 16*s12*s14*s24 + 8*s12*s24**2 + 16*s12*
     +    s24*s34 + 8*s13*s24**2 + 8*s14*s24**2 + 8*s24**2*s34 )

      LC = LC + Ld21(p3,p1,p24)*S234*S124**(-1) * ( 8*s12**2 + 16*s12*
     +    s24 + 8*s24**2 )

      LC = LC + Ld21(p3,p2,p4)*S24**(-1)*S34**(-1) * ( 24*s13*s14*
     +    s23**2 + 24*s14**2*s23**2 )

      LC = LC + Ld21(p3,p2,p4)*S34**(-1) * (  - 24*s13**2*s23 - 24*
     +    s13**2*s24 - 24*s13*s14*s24 + 24*s14**2*s23 )

      LC = LC + Ld21(p3,p2,p14)*S13**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 8*s12**3*s23 + 8*s12**3*s34 + 16*s12**2*s14*s23 + 16*s12**2
     +    *s14*s34 + 8*s12*s14**2*s23 + 8*s12*s14**2*s34 )

      LC = LC + Ld21(p3,p2,p14)*S13**(-1)*S134*S124**(-1) * ( 8*s12**3
     +     + 16*s12**2*s14 + 8*s12**2*s23 + 8*s12**2*s24 + 8*s12**2*s34
     +     + 8*s12*s14**2 + 16*s12*s14*s23 + 16*s12*s14*s24 + 16*s12*
     +    s14*s34 + 8*s14**2*s23 + 8*s14**2*s24 + 8*s14**2*s34 )

      LC = LC + Ld21(p3,p2,p14)*S24**(-1)*S134*S124**(-1) * ( 8*s12**3
     +     + 16*s12**2*s14 + 8*s12*s14**2 )

      LC = LC + Ld21(p3,p2,p14)*S134*S124**(-1) * ( 8*s12**2 + 16*s12*
     +    s14 + 8*s14**2 )

      LC = LC + Ld21(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * (  - 16*s12**4*s14*s34 + 16*s12**4*s34**2 - 64*
     +    s12**3*s14**2*s34 + 272*s12**3*s14*s34**2 - 128*s12**3*s34**3
     +     - 112*s12**2*s14**3*s34 - 112*s12**2*s14**2*s34**2 - 32*
     +    s12**2*s14*s34**3 + 144*s12*s14**4*s34 - 560*s12*s14**3*
     +    s34**2 + 96*s12*s14**2*s34**3 - 48*s14**4*s34**2 )

      LC = LC + Ld21(p3,p4,p12)*S13**(-1)*S23**(-1)*S124**(-1) * ( 128*
     +    s12**3*s14*s34 - 96*s12**3*s34**2 - 288*s12**2*s14**2*s34 + 
     +    464*s12**2*s14*s34**2 - 128*s12**2*s34**3 + 144*s12*s14**3*
     +    s34 - 480*s12*s14**2*s34**2 + 96*s12*s14*s34**3 - 48*s14**3*
     +    s34**2 )

      LC = LC + Ld21(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * (  - 112*s12**4*s13*s34 + 16*s12**4*s34**2 - 48*
     +    s12**3*s13**2*s34 + 80*s12**3*s13*s34**2 - 16*s12**3*s34**3 )

      LC = LC + Ld21(p3,p4,p12)*S14**(-1)*S23**(-1)*S124**(-1) * ( 32*
     +    s12**3*s13*s34 - 96*s12**3*s34**2 )

      LC = LC + Ld21(p3,p4,p12)*S23**(-1)*S24**(-1)*S124**(-1) * (  - 
     +    128*s12**4*s34 - 96*s12**3*s13**2 - 192*s12**3*s13*s14 + 576*
     +    s12**3*s13*s34 - 96*s12**3*s14**2 + 368*s12**3*s14*s34 + 64*
     +    s12**3*s34**2 + 64*s12**2*s13**2*s34 - 288*s12**2*s13*s14*s34
     +     - 112*s12**2*s13*s34**2 - 64*s12**2*s14**2*s34 - 592*s12**2*
     +    s14*s34**2 - 48*s12*s13*s14**2*s34 + 480*s12*s14**3*s34 - 912
     +    *s12*s14**2*s34**2 + 192*s14**3*s34**2 )

      LC = LC + Ld21(p3,p4,p12)*S23**(-1)*S124**(-1) * ( 160*s12**3*s34
     +     - 480*s12**2*s14*s34 + 512*s12**2*s34**2 - 48*s12*s13*s14*
     +    s34 + 480*s12*s14**2*s34 - 1104*s12*s14*s34**2 + 192*s14**2*
     +    s34**2 )

      LC = LC + Ld21(p3,p12,p4)*S13**(-1)*S23**(-1)*S24**(-1) * ( 40*
     +    s12**2*s14*s34**2 - 48*s12**2*s34**3 )

      LC = LC + Ld21(p3,p12,p4)*S13**(-1)*S23**(-1) * (  - 24*s12**2*
     +    s34**2 )

      LC = LC + Ld21(p3,p12,p4)*S13**(-1)*S24**(-1) * (  - 24*s12**2*
     +    s14*s34 - 72*s12*s14**2*s23 - 24*s12*s14**2*s34 - 16*s12*s14*
     +    s23*s34 + 56*s12*s14*s34**2 + 24*s12*s23**2*s34 + 24*s12*s23*
     +    s34**2 - 24*s12*s34**3 - 8*s14**3*s23 - 48*s14**2*s23**2 + 24
     +    *s14**2*s23*s34 + 24*s14*s23**3 + 24*s14*s23**2*s34 - 24*s14*
     +    s23*s34**2 )

      LC = LC + Ld21(p3,p12,p4)*S13**(-1) * (  - 24*s12*s14*s23 + 16*
     +    s12*s14*s34 - 24*s12*s24*s34 - 48*s12*s34**2 - 8*s14**2*s23
     +     - 16*s14*s23**2 - 8*s14*s23*s24 + 8*s14*s23*s34 + 24*s23**3
     +     + 24*s23**2*s34 - 24*s23*s24**2 - 48*s23*s24*s34 - 24*s23*
     +    s34**2 )

      LC = LC + Ld21(p3,p12,p4)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 24
     +    *s12**2*s13**2*s34 + 16*s12**2*s13*s34**2 - 24*s12**2*s34**3
     +     + 24*s12*s13**3*s34 - 88*s12*s13**2*s34**2 + 24*s12*s13*
     +    s34**3 )

      LC = LC + Ld21(p3,p12,p4)*S14**(-1)*S23**(-1) * (  - 24*s12**2*
     +    s34**2 + 72*s12*s13**3 - 48*s12*s13**2*s24 - 112*s12*s13**2*
     +    s34 - 24*s12*s13*s24*s34 - 24*s12*s13*s34**2 + 8*s13**4 + 32*
     +    s13**3*s24 - 40*s13**3*s34 - 40*s13**2*s24**2 - 72*s13**2*s24
     +    *s34 + 8*s13**2*s34**2 )

      LC = LC + Ld21(p3,p12,p4)*S14**(-1)*S24**(-1) * ( 24*s12**2*s13*
     +    s34 - 8*s12*s13**2*s34 + 8*s12*s13*s23*s34 - 8*s12*s13*s34**2
     +     + 24*s12*s23**2*s34 + 48*s12*s23*s34**2 + 24*s12*s34**3 )

      LC = LC + Ld21(p3,p12,p4)*S14**(-1) * ( 48*s12*s13**2 + 24*s12*
     +    s13*s23 + 16*s12*s13*s34 - 24*s12*s24*s34 - 24*s12*s34**2 + 
     +    32*s13**2*s24 - 64*s13**2*s34 + 32*s13*s23**2 + 16*s13*s23*
     +    s24 + 40*s13*s23*s34 - 48*s13*s24**2 - 48*s13*s24*s34 + 48*
     +    s13*s34**2 + 24*s23**3 + 48*s23**2*s34 - 24*s23*s24**2 - 24*
     +    s23*s24*s34 + 24*s23*s34**2 )

      LC = LC + Ld21(p3,p12,p4)*S23**(-1)*S24**(-1) * ( 48*s12**2*s13*
     +    s34 + 72*s12**2*s14*s34 + 56*s12**2*s34**2 + 120*s12*s13**3
     +     + 32*s12*s13**2*s34 - 120*s12*s13*s14**2 - 160*s12*s13*s14*
     +    s34 + 96*s12*s13*s34**2 - 24*s12*s14**2*s34 + 104*s12*s14*
     +    s34**2 - 24*s12*s34**3 + 8*s13**4 + 8*s13**3*s14 + 88*s13**3*
     +    s34 - 8*s13**2*s14**2 - 16*s13**2*s14*s34 - 96*s13**2*s34**2
     +     - 8*s13*s14**3 - 104*s13*s14**2*s34 + 80*s13*s14*s34**2 )

      LC = LC + Ld21(p3,p12,p4)*S23**(-1) * (  - 72*s12*s13*s14 - 48*
     +    s12*s13*s24 + 32*s12*s13*s34 + 48*s12*s14*s34 - 24*s12*s24*
     +    s34 - 48*s12*s34**2 + 88*s13**3 + 56*s13**2*s14 - 8*s13**2*
     +    s24 - 88*s13**2*s34 - 24*s13*s14**2 - 40*s13*s14*s24 - 40*s13
     +    *s14*s34 - 40*s13*s24**2 - 48*s13*s24*s34 - 8*s13*s34**2 )

      LC = LC + Ld21(p3,p12,p4)*S24**(-1) * ( 192*s12*s13**2 + 120*s12*
     +    s13*s23 + 128*s12*s13*s34 - 192*s12*s14**2 + 48*s12*s14*s23
     +     + 16*s12*s14*s34 - 8*s12*s23*s34 + 24*s12*s34**2 + 32*s13**3
     +     - 48*s13**2*s14 + 64*s13**2*s23 + 112*s13**2*s34 - 96*s13*
     +    s14**2 - 48*s13*s14*s23 + 72*s13*s14*s34 + 64*s13*s23**2 + 88
     +    *s13*s23*s34 - 88*s13*s34**2 - 16*s14**3 - 120*s14**2*s23 - 
     +    32*s14**2*s34 + 16*s14*s23**2 + 96*s14*s23*s34 + 104*s14*
     +    s34**2 + 24*s23**3 + 48*s23**2*s34 + 24*s23*s34**2 )

      LC = LC + Ld21(p3,p12,p4) * (  - 48*s12*s14 + 32*s12*s34 + 80*
     +    s13**2 + 64*s13*s14 + 16*s13*s23 + 16*s13*s24 - 24*s13*s34 - 
     +    16*s14**2 + 8*s14*s23 - 16*s14*s24 + 16*s14*s34 + 16*s23**2
     +     + 8*s23*s24 + 24*s23*s34 - 48*s24**2 - 96*s24*s34 - 48*
     +    s34**2 )

      LC = LC + Ld21(p3,p14,p2)*S13**(-1)*S24**(-1) * ( 16*s12**2*s14*
     +    s34 + 8*s12**2*s34**2 - 16*s12*s14**2*s23 + 8*s12*s14*s34**2
     +     + 8*s12*s23*s34**2 - 8*s12*s34**3 + 16*s14**2*s23**2 - 8*
     +    s14**2*s23*s34 - 8*s14*s23**2*s34 )

      LC = LC + Ld21(p3,p14,p2)*S13**(-1) * ( 8*s12*s34**2 + 8*s14**2*
     +    s23 - 24*s14*s23*s34 - 16*s14*s24*s34 + 16*s14*s34**2 + 16*
     +    s23*s34**2 + 16*s24*s34**2 - 8*s34**3 )

      LC = LC + Ld21(p3,p14,p2)*S24**(-1) * ( 16*s12**2*s13 + 16*s12**2
     +    *s14 + 24*s12**2*s34 - 8*s12*s13**2 - 8*s12*s13*s14 - 8*s12*
     +    s13*s23 - 24*s12*s13*s34 - 16*s12*s14*s23 - 8*s12*s14*s34 - 8
     +    *s12*s23*s34 - 24*s12*s34**2 + 8*s13*s14*s23 + 8*s14**2*s23
     +     + 8*s14*s23**2 )

      LC = LC + Ld21(p3,p14,p2) * ( 8*s13**2 + 8*s13*s14 + 8*s13*s23 + 
     +    8*s13*s24 + 8*s13*s34 + 8*s14*s23 + 16*s14*s34 + 16*s23*s34
     +     + 16*s24*s34 - 8*s34**2 )

      LC = LC + Ld21(p3,p24,p1)*S14**(-1)*S23**(-1) * ( 16*s12**2*s24*
     +    s34 + 8*s12**2*s34**2 - 16*s12*s13*s24**2 + 8*s12*s13*s34**2
     +     + 8*s12*s24*s34**2 - 8*s12*s34**3 + 16*s13**2*s24**2 - 8*
     +    s13**2*s24*s34 - 8*s13*s24**2*s34 )

      LC = LC + Ld21(p3,p24,p1)*S14**(-1) * ( 16*s12**2*s23 + 16*s12**2
     +    *s24 + 24*s12**2*s34 - 8*s12*s13*s23 - 16*s12*s13*s24 - 8*s12
     +    *s13*s34 - 8*s12*s23**2 - 8*s12*s23*s24 - 24*s12*s23*s34 - 8*
     +    s12*s24*s34 - 24*s12*s34**2 + 8*s13**2*s24 + 8*s13*s23*s24 + 
     +    8*s13*s24**2 )

      LC = LC + Ld21(p3,p24,p1)*S23**(-1) * ( 8*s12*s34**2 + 8*s13*
     +    s24**2 - 24*s13*s24*s34 + 16*s13*s34**2 - 16*s14*s24*s34 + 16
     +    *s14*s34**2 + 16*s24*s34**2 - 8*s34**3 )

      LC = LC + Ld21(p3,p24,p1) * ( 8*s13*s23 + 8*s13*s24 + 16*s13*s34
     +     + 8*s14*s23 + 16*s14*s34 + 8*s23**2 + 8*s23*s24 + 8*s23*s34
     +     + 16*s24*s34 - 8*s34**2 )

      LC = LC + Ld21(p4,p1,p3)*S13**(-1)*S34**(-1) * ( 24*s14**2*s23**2
     +     + 24*s14**2*s23*s24 )

      LC = LC + Ld21(p4,p1,p3)*S34**(-1) * (  - 24*s13*s23*s24 - 24*s13
     +    *s24**2 + 24*s14*s23**2 - 24*s14*s24**2 )

      LC = LC + Ld21(p4,p1,p23)*S13**(-1)*S24**(-1)*S123**(-1)*S234
     +  * ( 8*s12**3*s14 + 8*s12**3*s34 + 16*s12**2*s14*s23 + 16*s12**2
     +    *s23*s34 + 8*s12*s14*s23**2 + 8*s12*s23**2*s34 )

      LC = LC + Ld21(p4,p1,p23)*S13**(-1)*S123**(-1)*S234 * ( 8*s12**3
     +     + 16*s12**2*s23 + 8*s12*s23**2 )

      LC = LC + Ld21(p4,p1,p23)*S24**(-1)*S123**(-1)*S234 * ( 8*s12**3
     +     + 8*s12**2*s13 + 8*s12**2*s14 + 16*s12**2*s23 + 8*s12**2*s34
     +     + 16*s12*s13*s23 + 16*s12*s14*s23 + 8*s12*s23**2 + 16*s12*
     +    s23*s34 + 8*s13*s23**2 + 8*s14*s23**2 + 8*s23**2*s34 )

      LC = LC + Ld21(p4,p1,p23)*S123**(-1)*S234 * ( 8*s12**2 + 16*s12*
     +    s23 + 8*s23**2 )

      LC = LC + Ld21(p4,p2,p3)*S23**(-1)*S34**(-1) * ( 24*s13**2*s24**2
     +     + 24*s13*s14*s24**2 )

      LC = LC + Ld21(p4,p2,p3)*S34**(-1) * ( 24*s13**2*s24 - 24*s13*s14
     +    *s23 - 24*s14**2*s23 - 24*s14**2*s24 )

      LC = LC + Ld21(p4,p2,p13)*S14**(-1)*S23**(-1)*S123**(-1)*S134
     +  * ( 8*s12**3*s24 + 8*s12**3*s34 + 16*s12**2*s13*s24 + 16*s12**2
     +    *s13*s34 + 8*s12*s13**2*s24 + 8*s12*s13**2*s34 )

      LC = LC + Ld21(p4,p2,p13)*S14**(-1)*S123**(-1)*S134 * ( 8*s12**3
     +     + 16*s12**2*s13 + 8*s12**2*s23 + 8*s12**2*s24 + 8*s12**2*s34
     +     + 8*s12*s13**2 + 16*s12*s13*s23 + 16*s12*s13*s24 + 16*s12*
     +    s13*s34 + 8*s13**2*s23 + 8*s13**2*s24 + 8*s13**2*s34 )

      LC = LC + Ld21(p4,p2,p13)*S23**(-1)*S123**(-1)*S134 * ( 8*s12**3
     +     + 16*s12**2*s13 + 8*s12*s13**2 )

      LC = LC + Ld21(p4,p2,p13)*S123**(-1)*S134 * ( 8*s12**2 + 16*s12*
     +    s13 + 8*s13**2 )

      LC = LC + Ld21(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * (  - 112*s12**4*s14*s34 + 16*s12**4*s34**2 - 48*
     +    s12**3*s14**2*s34 + 80*s12**3*s14*s34**2 - 16*s12**3*s34**3 )

      LC = LC + Ld21(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 32*
     +    s12**3*s14*s34 - 96*s12**3*s34**2 )

      LC = LC + Ld21(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * (  - 16*s12**4*s13*s34 + 16*s12**4*s34**2 - 64*
     +    s12**3*s13**2*s34 + 272*s12**3*s13*s34**2 - 128*s12**3*s34**3
     +     - 112*s12**2*s13**3*s34 - 112*s12**2*s13**2*s34**2 - 32*
     +    s12**2*s13*s34**3 + 144*s12*s13**4*s34 - 560*s12*s13**3*
     +    s34**2 + 96*s12*s13**2*s34**3 - 48*s13**4*s34**2 )

      LC = LC + Ld21(p4,p3,p12)*S14**(-1)*S24**(-1)*S123**(-1) * ( 128*
     +    s12**3*s13*s34 - 96*s12**3*s34**2 - 288*s12**2*s13**2*s34 + 
     +    464*s12**2*s13*s34**2 - 128*s12**2*s34**3 + 144*s12*s13**3*
     +    s34 - 480*s12*s13**2*s34**2 + 96*s12*s13*s34**3 - 48*s13**3*
     +    s34**2 )

      LC = LC + Ld21(p4,p3,p12)*S23**(-1)*S24**(-1)*S123**(-1) * (  - 
     +    128*s12**4*s34 - 96*s12**3*s13**2 - 192*s12**3*s13*s14 + 368*
     +    s12**3*s13*s34 - 96*s12**3*s14**2 + 576*s12**3*s14*s34 + 64*
     +    s12**3*s34**2 - 64*s12**2*s13**2*s34 - 288*s12**2*s13*s14*s34
     +     - 592*s12**2*s13*s34**2 + 64*s12**2*s14**2*s34 - 112*s12**2*
     +    s14*s34**2 + 480*s12*s13**3*s34 - 48*s12*s13**2*s14*s34 - 912
     +    *s12*s13**2*s34**2 + 192*s13**3*s34**2 )

      LC = LC + Ld21(p4,p3,p12)*S24**(-1)*S123**(-1) * ( 160*s12**3*s34
     +     - 480*s12**2*s13*s34 + 512*s12**2*s34**2 + 480*s12*s13**2*
     +    s34 - 48*s12*s13*s14*s34 - 1104*s12*s13*s34**2 + 192*s13**2*
     +    s34**2 )

      LC = LC + Ld21(p4,p12,p3)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 24
     +    *s12**2*s14**2*s34 + 16*s12**2*s14*s34**2 - 24*s12**2*s34**3
     +     + 24*s12*s14**3*s34 - 88*s12*s14**2*s34**2 + 24*s12*s14*
     +    s34**3 )

      LC = LC + Ld21(p4,p12,p3)*S13**(-1)*S23**(-1) * ( 24*s12**2*s14*
     +    s34 - 8*s12*s14**2*s34 + 8*s12*s14*s24*s34 - 8*s12*s14*s34**2
     +     + 24*s12*s24**2*s34 + 48*s12*s24*s34**2 + 24*s12*s34**3 )

      LC = LC + Ld21(p4,p12,p3)*S13**(-1)*S24**(-1) * (  - 24*s12**2*
     +    s34**2 + 72*s12*s14**3 - 48*s12*s14**2*s23 - 112*s12*s14**2*
     +    s34 - 24*s12*s14*s23*s34 - 24*s12*s14*s34**2 + 8*s14**4 + 32*
     +    s14**3*s23 - 40*s14**3*s34 - 40*s14**2*s23**2 - 72*s14**2*s23
     +    *s34 + 8*s14**2*s34**2 )

      LC = LC + Ld21(p4,p12,p3)*S13**(-1) * ( 48*s12*s14**2 + 24*s12*
     +    s14*s24 + 16*s12*s14*s34 - 24*s12*s23*s34 - 24*s12*s34**2 + 
     +    32*s14**2*s23 - 64*s14**2*s34 - 48*s14*s23**2 + 16*s14*s23*
     +    s24 - 48*s14*s23*s34 + 32*s14*s24**2 + 40*s14*s24*s34 + 48*
     +    s14*s34**2 - 24*s23**2*s24 - 24*s23*s24*s34 + 24*s24**3 + 48*
     +    s24**2*s34 + 24*s24*s34**2 )

      LC = LC + Ld21(p4,p12,p3)*S14**(-1)*S23**(-1)*S24**(-1) * ( 40*
     +    s12**2*s13*s34**2 - 48*s12**2*s34**3 )

      LC = LC + Ld21(p4,p12,p3)*S14**(-1)*S23**(-1) * (  - 24*s12**2*
     +    s13*s34 - 72*s12*s13**2*s24 - 24*s12*s13**2*s34 - 16*s12*s13*
     +    s24*s34 + 56*s12*s13*s34**2 + 24*s12*s24**2*s34 + 24*s12*s24*
     +    s34**2 - 24*s12*s34**3 - 8*s13**3*s24 - 48*s13**2*s24**2 + 24
     +    *s13**2*s24*s34 + 24*s13*s24**3 + 24*s13*s24**2*s34 - 24*s13*
     +    s24*s34**2 )

      LC = LC + Ld21(p4,p12,p3)*S14**(-1)*S24**(-1) * (  - 24*s12**2*
     +    s34**2 )

      LC = LC + Ld21(p4,p12,p3)*S14**(-1) * (  - 24*s12*s13*s24 + 16*
     +    s12*s13*s34 - 24*s12*s23*s34 - 48*s12*s34**2 - 8*s13**2*s24
     +     - 8*s13*s23*s24 - 16*s13*s24**2 + 8*s13*s24*s34 - 24*s23**2*
     +    s24 - 48*s23*s24*s34 + 24*s24**3 + 24*s24**2*s34 - 24*s24*
     +    s34**2 )

      LC = LC + Ld21(p4,p12,p3)*S23**(-1)*S24**(-1) * ( 72*s12**2*s13*
     +    s34 + 48*s12**2*s14*s34 + 56*s12**2*s34**2 - 120*s12*s13**2*
     +    s14 - 24*s12*s13**2*s34 - 160*s12*s13*s14*s34 + 104*s12*s13*
     +    s34**2 + 120*s12*s14**3 + 32*s12*s14**2*s34 + 96*s12*s14*
     +    s34**2 - 24*s12*s34**3 - 8*s13**3*s14 - 8*s13**2*s14**2 - 104
     +    *s13**2*s14*s34 + 8*s13*s14**3 - 16*s13*s14**2*s34 + 80*s13*
     +    s14*s34**2 + 8*s14**4 + 88*s14**3*s34 - 96*s14**2*s34**2 )

      LC = LC + Ld21(p4,p12,p3)*S23**(-1) * (  - 192*s12*s13**2 + 48*
     +    s12*s13*s24 + 16*s12*s13*s34 + 192*s12*s14**2 + 120*s12*s14*
     +    s24 + 128*s12*s14*s34 - 8*s12*s24*s34 + 24*s12*s34**2 - 16*
     +    s13**3 - 96*s13**2*s14 - 120*s13**2*s24 - 32*s13**2*s34 - 48*
     +    s13*s14**2 - 48*s13*s14*s24 + 72*s13*s14*s34 + 16*s13*s24**2
     +     + 96*s13*s24*s34 + 104*s13*s34**2 + 32*s14**3 + 64*s14**2*
     +    s24 + 112*s14**2*s34 + 64*s14*s24**2 + 88*s14*s24*s34 - 88*
     +    s14*s34**2 + 24*s24**3 + 48*s24**2*s34 + 24*s24*s34**2 )

      LC = LC + Ld21(p4,p12,p3)*S24**(-1) * (  - 72*s12*s13*s14 + 48*
     +    s12*s13*s34 - 48*s12*s14*s23 + 32*s12*s14*s34 - 24*s12*s23*
     +    s34 - 48*s12*s34**2 - 24*s13**2*s14 + 56*s13*s14**2 - 40*s13*
     +    s14*s23 - 40*s13*s14*s34 + 88*s14**3 - 8*s14**2*s23 - 88*
     +    s14**2*s34 - 40*s14*s23**2 - 48*s14*s23*s34 - 8*s14*s34**2 )

      LC = LC + Ld21(p4,p12,p3) * (  - 48*s12*s13 + 32*s12*s34 - 16*
     +    s13**2 + 64*s13*s14 - 16*s13*s23 + 8*s13*s24 + 16*s13*s34 + 
     +    80*s14**2 + 16*s14*s23 + 16*s14*s24 - 24*s14*s34 - 48*s23**2
     +     + 8*s23*s24 - 96*s23*s34 + 16*s24**2 + 24*s24*s34 - 48*
     +    s34**2 )

      LC = LC + Ld21(p4,p13,p2)*S14**(-1)*S23**(-1) * ( 16*s12**2*s13*
     +    s34 + 8*s12**2*s34**2 - 16*s12*s13**2*s24 + 8*s12*s13*s34**2
     +     + 8*s12*s24*s34**2 - 8*s12*s34**3 + 16*s13**2*s24**2 - 8*
     +    s13**2*s24*s34 - 8*s13*s24**2*s34 )

      LC = LC + Ld21(p4,p13,p2)*S14**(-1) * ( 8*s12*s34**2 + 8*s13**2*
     +    s24 - 16*s13*s23*s34 - 24*s13*s24*s34 + 16*s13*s34**2 + 16*
     +    s23*s34**2 + 16*s24*s34**2 - 8*s34**3 )

      LC = LC + Ld21(p4,p13,p2)*S23**(-1) * ( 16*s12**2*s13 + 16*s12**2
     +    *s14 + 24*s12**2*s34 - 8*s12*s13*s14 - 16*s12*s13*s24 - 8*s12
     +    *s13*s34 - 8*s12*s14**2 - 8*s12*s14*s24 - 24*s12*s14*s34 - 8*
     +    s12*s24*s34 - 24*s12*s34**2 + 8*s13**2*s24 + 8*s13*s14*s24 + 
     +    8*s13*s24**2 )

      LC = LC + Ld21(p4,p13,p2) * ( 8*s13*s14 + 8*s13*s24 + 16*s13*s34
     +     + 8*s14**2 + 8*s14*s23 + 8*s14*s24 + 8*s14*s34 + 16*s23*s34
     +     + 16*s24*s34 - 8*s34**2 )

      LC = LC + Ld21(p4,p23,p1)*S13**(-1)*S24**(-1) * ( 16*s12**2*s23*
     +    s34 + 8*s12**2*s34**2 - 16*s12*s14*s23**2 + 8*s12*s14*s34**2
     +     + 8*s12*s23*s34**2 - 8*s12*s34**3 + 16*s14**2*s23**2 - 8*
     +    s14**2*s23*s34 - 8*s14*s23**2*s34 )

      LC = LC + Ld21(p4,p23,p1)*S13**(-1) * ( 16*s12**2*s23 + 16*s12**2
     +    *s24 + 24*s12**2*s34 - 16*s12*s14*s23 - 8*s12*s14*s24 - 8*s12
     +    *s14*s34 - 8*s12*s23*s24 - 8*s12*s23*s34 - 8*s12*s24**2 - 24*
     +    s12*s24*s34 - 24*s12*s34**2 + 8*s14**2*s23 + 8*s14*s23**2 + 8
     +    *s14*s23*s24 )

      LC = LC + Ld21(p4,p23,p1)*S24**(-1) * ( 8*s12*s34**2 - 16*s13*s23
     +    *s34 + 16*s13*s34**2 + 8*s14*s23**2 - 24*s14*s23*s34 + 16*s14
     +    *s34**2 + 16*s23*s34**2 - 8*s34**3 )

      LC = LC + Ld21(p4,p23,p1) * ( 8*s13*s24 + 16*s13*s34 + 8*s14*s23
     +     + 8*s14*s24 + 16*s14*s34 + 8*s23*s24 + 16*s23*s34 + 8*s24**2
     +     + 8*s24*s34 - 8*s34**2 )

      LC = LC + Ld22(p1,p2,p34)*S13**(-1)*S24**(-1)*S134 * (  - 8*s12*
     +    s23**2 - 16*s12*s23*s34 + 8*s14*s23**2 )

      LC = LC + Ld22(p1,p2,p34)*S14**(-1)*S23**(-1)*S134 * (  - 8*s12*
     +    s24**2 - 16*s12*s24*s34 + 8*s13*s24**2 )

      LC = LC + Ld22(p1,p2,p34)*S23**(-1)*S134 * ( 8*s24**2 )

      LC = LC + Ld22(p1,p2,p34)*S24**(-1)*S134 * ( 8*s23**2 )

      LC = LC + Ld22(p1,p3,p24)*S13**(-1)*S14**(-1) * (  - 8*s12**2*
     +    s23**2 - 8*s12**2*s23*s34 )

      LC = LC + Ld22(p1,p3,p24)*S13**(-1) * (  - 8*s12**2*s23 - 16*s12*
     +    s14*s23 - 16*s12*s23**2 - 16*s12*s23*s34 - 8*s14**2*s23 - 8*
     +    s14*s23**2 - 8*s14*s23*s34 )

      LC = LC + Ld22(p1,p3,p24)*S14**(-1) * (  - 8*s12**2*s23 + 8*s12*
     +    s13*s23 + 16*s12*s13*s24 + 8*s12*s23**2 + 16*s12*s23*s24 + 8*
     +    s12*s23*s34 + 16*s12*s24*s34 )

      LC = LC + Ld22(p1,p3,p24) * (  - 8*s12*s23 + 16*s12*s24 + 8*s13*
     +    s23 + 16*s13*s24 + 16*s14*s24 + 8*s23**2 + 16*s23*s24 + 8*s23
     +    *s34 + 16*s24*s34 )

      LC = LC + Ld22(p1,p4,p23)*S13**(-1)*S14**(-1) * (  - 8*s12**2*
     +    s24**2 - 8*s12**2*s24*s34 )

      LC = LC + Ld22(p1,p4,p23)*S13**(-1) * (  - 8*s12**2*s24 + 16*s12*
     +    s14*s23 + 8*s12*s14*s24 + 16*s12*s23*s24 + 16*s12*s23*s34 + 8
     +    *s12*s24**2 + 8*s12*s24*s34 )

      LC = LC + Ld22(p1,p4,p23)*S14**(-1) * (  - 8*s12**2*s24 - 16*s12*
     +    s13*s24 - 16*s12*s24**2 - 16*s12*s24*s34 - 8*s13**2*s24 - 8*
     +    s13*s24**2 - 8*s13*s24*s34 )

      LC = LC + Ld22(p1,p4,p23) * ( 16*s12*s23 - 8*s12*s24 + 16*s13*s23
     +     + 16*s14*s23 + 8*s14*s24 + 16*s23*s24 + 16*s23*s34 + 8*
     +    s24**2 + 8*s24*s34 )

      LC = LC + Ld22(p2,p1,p34)*S13**(-1)*S24**(-1)*S234 * (  - 8*s12*
     +    s14**2 - 16*s12*s14*s34 + 8*s14**2*s23 )

      LC = LC + Ld22(p2,p1,p34)*S13**(-1)*S234 * ( 8*s14**2 )

      LC = LC + Ld22(p2,p1,p34)*S14**(-1)*S23**(-1)*S234 * (  - 8*s12*
     +    s13**2 - 16*s12*s13*s34 + 8*s13**2*s24 )

      LC = LC + Ld22(p2,p1,p34)*S14**(-1)*S234 * ( 8*s13**2 )

      LC = LC + Ld22(p2,p3,p14)*S23**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s13**2 - 8*s12**2*s13*s34 )

      LC = LC + Ld22(p2,p3,p14)*S23**(-1) * (  - 8*s12**2*s13 - 16*s12*
     +    s13**2 - 16*s12*s13*s24 - 16*s12*s13*s34 - 8*s13**2*s24 - 8*
     +    s13*s24**2 - 8*s13*s24*s34 )

      LC = LC + Ld22(p2,p3,p14)*S24**(-1) * (  - 8*s12**2*s13 + 8*s12*
     +    s13**2 + 16*s12*s13*s14 + 8*s12*s13*s23 + 8*s12*s13*s34 + 16*
     +    s12*s14*s23 + 16*s12*s14*s34 )

      LC = LC + Ld22(p2,p3,p14) * (  - 8*s12*s13 + 16*s12*s14 + 8*
     +    s13**2 + 16*s13*s14 + 8*s13*s23 + 8*s13*s34 + 16*s14*s23 + 16
     +    *s14*s24 + 16*s14*s34 )

      LC = LC + Ld22(p2,p4,p13)*S23**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s14**2 - 8*s12**2*s14*s34 )

      LC = LC + Ld22(p2,p4,p13)*S23**(-1) * (  - 8*s12**2*s14 + 16*s12*
     +    s13*s14 + 16*s12*s13*s24 + 16*s12*s13*s34 + 8*s12*s14**2 + 8*
     +    s12*s14*s24 + 8*s12*s14*s34 )

      LC = LC + Ld22(p2,p4,p13)*S24**(-1) * (  - 8*s12**2*s14 - 16*s12*
     +    s14**2 - 16*s12*s14*s23 - 16*s12*s14*s34 - 8*s14**2*s23 - 8*
     +    s14*s23**2 - 8*s14*s23*s34 )

      LC = LC + Ld22(p2,p4,p13) * ( 16*s12*s13 - 8*s12*s14 + 16*s13*s14
     +     + 16*s13*s23 + 16*s13*s24 + 16*s13*s34 + 8*s14**2 + 8*s14*
     +    s24 + 8*s14*s34 )

      LC = LC + Ld22(p3,p1,p24)*S13**(-1)*S14**(-1)*S23**(-1)*S234*
     + S124**(-1) * (  - 8*s12**3*s34**2 )

      LC = LC + Ld22(p3,p1,p24)*S13**(-1)*S14**(-1)*S234*S124**(-1)
     +  * (  - 8*s12**3*s23 - 16*s12**3*s34 )

      LC = LC + Ld22(p3,p1,p24)*S13**(-1)*S23**(-1)*S234*S124**(-1)
     +  * (  - 8*s12**3*s34 - 8*s12**2*s14*s34 - 8*s12**2*s34**2 )

      LC = LC + Ld22(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * (  - 8*
     +    s12**3 - 8*s12**2*s14 - 8*s12**2*s23 - 16*s12**2*s34 )

      LC = LC + Ld22(p3,p1,p24)*S14**(-1)*S23**(-1)*S234*S124**(-1)
     +  * ( 8*s12**3*s13 + 16*s12**2*s13*s24 + 16*s12**2*s24*s34 )

      LC = LC + Ld22(p3,p1,p24)*S14**(-1)*S234*S124**(-1) * ( 16*s12**2
     +    *s24 )

      LC = LC + Ld22(p3,p1,p24)*S23**(-1)*S234*S124**(-1) * ( 8*s12**3
     +     + 8*s12**2*s13 + 8*s12**2*s14 + 16*s12**2*s24 + 16*s12*s13*
     +    s24 + 16*s12*s14*s24 + 16*s12*s24*s34 )

      LC = LC + Ld22(p3,p1,p24)*S234*S124**(-1) * ( 16*s12*s24 )

      LC = LC + Ld22(p3,p2,p14)*S13**(-1)*S23**(-1)*S24**(-1)*S134*
     + S124**(-1) * (  - 8*s12**3*s34**2 )

      LC = LC + Ld22(p3,p2,p14)*S13**(-1)*S23**(-1)*S134*S124**(-1)
     +  * (  - 8*s12**3*s34 - 8*s12**2*s24*s34 - 8*s12**2*s34**2 )

      LC = LC + Ld22(p3,p2,p14)*S13**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 8*s12**3*s23 + 16*s12**2*s14*s23 + 16*s12**2*s14*s34 )

      LC = LC + Ld22(p3,p2,p14)*S13**(-1)*S134*S124**(-1) * ( 8*s12**3
     +     + 16*s12**2*s14 + 8*s12**2*s23 + 8*s12**2*s24 + 16*s12*s14*
     +    s23 + 16*s12*s14*s24 + 16*s12*s14*s34 )

      LC = LC + Ld22(p3,p2,p14)*S23**(-1)*S24**(-1)*S134*S124**(-1)
     +  * (  - 8*s12**3*s13 - 16*s12**3*s34 )

      LC = LC + Ld22(p3,p2,p14)*S23**(-1)*S134*S124**(-1) * (  - 8*
     +    s12**3 - 8*s12**2*s13 - 8*s12**2*s24 - 16*s12**2*s34 )

      LC = LC + Ld22(p3,p2,p14)*S24**(-1)*S134*S124**(-1) * ( 16*s12**2
     +    *s14 )

      LC = LC + Ld22(p3,p2,p14)*S134*S124**(-1) * ( 16*s12*s14 )

      LC = LC + Ld22(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * ( 96*s12**3*s14**2*s34 - 80*s12**3*s14*s34**2 + 16*
     +    s12**3*s34**3 + 176*s12**2*s14**3*s34 - 192*s12**2*s14**2*
     +    s34**2 - 128*s12**2*s14*s34**3 - 96*s12*s14**4*s34 + 208*s12*
     +    s14**3*s34**2 - 192*s12*s14**2*s34**3 - 48*s14**4*s34**2 )

      LC = LC + Ld22(p3,p4,p12)*S13**(-1)*S23**(-1)*S124**(-1) * ( 48*
     +    s12**3*s34**2 + 240*s12**2*s14**2*s34 - 384*s12**2*s14*s34**2
     +     + 64*s12**2*s34**3 - 96*s12*s14**3*s34 + 288*s12*s14**2*
     +    s34**2 - 192*s12*s14*s34**3 - 48*s14**3*s34**2 )

      LC = LC + Ld22(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1) * (  - 
     +    96*s12**3*s14*s34 + 32*s12**3*s34**2 - 48*s12**2*s14**3 + 48*
     +    s12**2*s14**2*s23 + 16*s12**2*s14**2*s34 - 128*s12**2*s14*s23
     +    *s34 + 16*s12**2*s23*s34**2 + 16*s12**2*s34**3 - 96*s12*
     +    s14**4 + 32*s12*s14**3*s23 + 416*s12*s14**3*s34 + 64*s12*
     +    s14**2*s23**2 - 112*s12*s14**2*s23*s34 - 96*s12*s14**2*s34**2
     +     - 32*s12*s14*s23**2*s34 - 32*s12*s14*s23*s34**2 - 96*s14**4*
     +    s23 + 80*s14**3*s23**2 + 96*s14**3*s23*s34 + 48*s14**3*s34**2
     +     + 16*s14**2*s23**3 + 16*s14**2*s23**2*s34 )

      LC = LC + Ld22(p3,p4,p12)*S13**(-1)*S124**(-1) * (  - 192*s12**2*
     +    s14*s34 + 64*s12**2*s34**2 - 96*s12*s14**3 + 96*s12*s14**2*
     +    s23 + 384*s12*s14**2*s34 - 192*s12*s14*s23*s34 - 144*s12*s14*
     +    s34**2 - 96*s14**3*s23 + 96*s14**2*s23**2 + 96*s14**2*s23*s34
     +     + 48*s14**2*s34**2 )

      LC = LC + Ld22(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * (  - 32*s12**3*s13*s34**2 + 32*s12**3*s34**3 )

      LC = LC + Ld22(p3,p4,p12)*S14**(-1)*S23**(-1)*S124**(-1) * ( 48*
     +    s12**3*s34**2 )

      LC = LC + Ld22(p3,p4,p12)*S14**(-1)*S24**(-1)*S124**(-1) * ( 16*
     +    s12**3*s34**2 )

      LC = LC + Ld22(p3,p4,p12)*S23**(-1)*S24**(-1)*S124**(-1) * (  - 
     +    48*s12**3*s13*s34 + 48*s12**3*s14*s34 - 48*s12**3*s34**2 - 48
     +    *s12**2*s13*s14**2 + 208*s12**2*s13*s14*s34 + 64*s12**2*s13*
     +    s34**2 - 48*s12**2*s14**3 + 240*s12**2*s14**2*s34 - 144*
     +    s12**2*s14*s34**2 - 80*s12**2*s34**3 - 64*s12*s13**2*s14**2
     +     + 16*s12*s13**2*s14*s34 - 160*s12*s13*s14**3 + 176*s12*s13*
     +    s14**2*s34 + 16*s12*s13*s14*s34**2 - 96*s12*s14**4 - 64*s12*
     +    s14**3*s34 + 336*s12*s14**2*s34**2 - 16*s13**3*s14**2 - 112*
     +    s13**2*s14**3 - 16*s13**2*s14**2*s34 - 96*s13*s14**4 - 96*s13
     +    *s14**3*s34 - 240*s14**3*s34**2 )

      LC = LC + Ld22(p3,p4,p12)*S23**(-1)*S124**(-1) * ( 48*s12**2*s13*
     +    s34 + 288*s12**2*s14*s34 - 416*s12**2*s34**2 - 96*s12*s13*
     +    s14**2 + 192*s12*s13*s14*s34 - 96*s12*s14**3 - 96*s12*s14**2*
     +    s34 + 576*s12*s14*s34**2 - 96*s13**2*s14**2 - 96*s13*s14**3
     +     - 96*s13*s14**2*s34 - 240*s14**2*s34**2 )

      LC = LC + Ld22(p3,p4,p12)*S24**(-1)*S124**(-1) * (  - 96*s12**3*
     +    s34 + 48*s12**2*s13*s14 + 48*s12**2*s14*s23 + 16*s12**2*s14*
     +    s34 - 32*s12**2*s23*s34 - 96*s12**2*s34**2 + 16*s12*s13**2*
     +    s14 + 32*s12*s13*s14**2 + 32*s12*s13*s14*s23 + 80*s12*s13*s14
     +    *s34 - 128*s12*s14**3 + 160*s12*s14**2*s23 + 448*s12*s14**2*
     +    s34 + 16*s12*s14*s23**2 + 32*s12*s14*s23*s34 + 48*s12*s14*
     +    s34**2 - 32*s13**2*s14**2 - 144*s13*s14**3 - 16*s13*s14**2*
     +    s34 - 192*s14**4 + 48*s14**3*s23 + 32*s14**2*s23**2 + 16*
     +    s14**2*s23*s34 )

      LC = LC + Ld22(p3,p4,p12)*S124**(-1) * (  - 192*s12**2*s34 + 96*
     +    s12*s13*s14 + 96*s12*s14*s23 + 384*s12*s14*s34 - 96*s13*
     +    s14**2 - 192*s14**3 + 96*s14**2*s23 )

      LC = LC + Ld22(p4,p1,p23)*S13**(-1)*S14**(-1)*S24**(-1)*
     + S123**(-1)*S234 * (  - 8*s12**3*s34**2 )

      LC = LC + Ld22(p4,p1,p23)*S13**(-1)*S14**(-1)*S123**(-1)*S234
     +  * (  - 8*s12**3*s24 - 16*s12**3*s34 )

      LC = LC + Ld22(p4,p1,p23)*S13**(-1)*S24**(-1)*S123**(-1)*S234
     +  * ( 8*s12**3*s14 + 16*s12**2*s14*s23 + 16*s12**2*s23*s34 )

      LC = LC + Ld22(p4,p1,p23)*S13**(-1)*S123**(-1)*S234 * ( 16*s12**2
     +    *s23 )

      LC = LC + Ld22(p4,p1,p23)*S14**(-1)*S24**(-1)*S123**(-1)*S234
     +  * (  - 8*s12**3*s34 - 8*s12**2*s13*s34 - 8*s12**2*s34**2 )

      LC = LC + Ld22(p4,p1,p23)*S14**(-1)*S123**(-1)*S234 * (  - 8*
     +    s12**3 - 8*s12**2*s13 - 8*s12**2*s24 - 16*s12**2*s34 )

      LC = LC + Ld22(p4,p1,p23)*S24**(-1)*S123**(-1)*S234 * ( 8*s12**3
     +     + 8*s12**2*s13 + 8*s12**2*s14 + 16*s12**2*s23 + 16*s12*s13*
     +    s23 + 16*s12*s14*s23 + 16*s12*s23*s34 )

      LC = LC + Ld22(p4,p1,p23)*S123**(-1)*S234 * ( 16*s12*s23 )

      LC = LC + Ld22(p4,p2,p13)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1)*S134 * (  - 8*s12**3*s34**2 )

      LC = LC + Ld22(p4,p2,p13)*S14**(-1)*S23**(-1)*S123**(-1)*S134
     +  * ( 8*s12**3*s24 + 16*s12**2*s13*s24 + 16*s12**2*s13*s34 )

      LC = LC + Ld22(p4,p2,p13)*S14**(-1)*S24**(-1)*S123**(-1)*S134
     +  * (  - 8*s12**3*s34 - 8*s12**2*s23*s34 - 8*s12**2*s34**2 )

      LC = LC + Ld22(p4,p2,p13)*S14**(-1)*S123**(-1)*S134 * ( 8*s12**3
     +     + 16*s12**2*s13 + 8*s12**2*s23 + 8*s12**2*s24 + 16*s12*s13*
     +    s23 + 16*s12*s13*s24 + 16*s12*s13*s34 )

      LC = LC + Ld22(p4,p2,p13)*S23**(-1)*S24**(-1)*S123**(-1)*S134
     +  * (  - 8*s12**3*s14 - 16*s12**3*s34 )

      LC = LC + Ld22(p4,p2,p13)*S23**(-1)*S123**(-1)*S134 * ( 16*s12**2
     +    *s13 )

      LC = LC + Ld22(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * (  - 8*
     +    s12**3 - 8*s12**2*s14 - 8*s12**2*s23 - 16*s12**2*s34 )

      LC = LC + Ld22(p4,p2,p13)*S123**(-1)*S134 * ( 16*s12*s13 )

      LC = LC + Ld22(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * (  - 32*s12**3*s14*s34**2 + 32*s12**3*s34**3 )

      LC = LC + Ld22(p4,p3,p12)*S13**(-1)*S23**(-1)*S123**(-1) * ( 16*
     +    s12**3*s34**2 )

      LC = LC + Ld22(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 48*
     +    s12**3*s34**2 )

      LC = LC + Ld22(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * ( 96*s12**3*s13**2*s34 - 80*s12**3*s13*s34**2 + 16*
     +    s12**3*s34**3 + 176*s12**2*s13**3*s34 - 192*s12**2*s13**2*
     +    s34**2 - 128*s12**2*s13*s34**3 - 96*s12*s13**4*s34 + 208*s12*
     +    s13**3*s34**2 - 192*s12*s13**2*s34**3 - 48*s13**4*s34**2 )

      LC = LC + Ld22(p4,p3,p12)*S14**(-1)*S23**(-1)*S123**(-1) * (  - 
     +    96*s12**3*s13*s34 + 32*s12**3*s34**2 - 48*s12**2*s13**3 + 48*
     +    s12**2*s13**2*s24 + 16*s12**2*s13**2*s34 - 128*s12**2*s13*s24
     +    *s34 + 16*s12**2*s24*s34**2 + 16*s12**2*s34**3 - 96*s12*
     +    s13**4 + 32*s12*s13**3*s24 + 416*s12*s13**3*s34 + 64*s12*
     +    s13**2*s24**2 - 112*s12*s13**2*s24*s34 - 96*s12*s13**2*s34**2
     +     - 32*s12*s13*s24**2*s34 - 32*s12*s13*s24*s34**2 - 96*s13**4*
     +    s24 + 80*s13**3*s24**2 + 96*s13**3*s24*s34 + 48*s13**3*s34**2
     +     + 16*s13**2*s24**3 + 16*s13**2*s24**2*s34 )

      LC = LC + Ld22(p4,p3,p12)*S14**(-1)*S24**(-1)*S123**(-1) * ( 48*
     +    s12**3*s34**2 + 240*s12**2*s13**2*s34 - 384*s12**2*s13*s34**2
     +     + 64*s12**2*s34**3 - 96*s12*s13**3*s34 + 288*s12*s13**2*
     +    s34**2 - 192*s12*s13*s34**3 - 48*s13**3*s34**2 )

      LC = LC + Ld22(p4,p3,p12)*S14**(-1)*S123**(-1) * (  - 192*s12**2*
     +    s13*s34 + 64*s12**2*s34**2 - 96*s12*s13**3 + 96*s12*s13**2*
     +    s24 + 384*s12*s13**2*s34 - 192*s12*s13*s24*s34 - 144*s12*s13*
     +    s34**2 - 96*s13**3*s24 + 96*s13**2*s24**2 + 96*s13**2*s24*s34
     +     + 48*s13**2*s34**2 )

      LC = LC + Ld22(p4,p3,p12)*S23**(-1)*S24**(-1)*S123**(-1) * ( 48*
     +    s12**3*s13*s34 - 48*s12**3*s14*s34 - 48*s12**3*s34**2 - 48*
     +    s12**2*s13**3 - 48*s12**2*s13**2*s14 + 240*s12**2*s13**2*s34
     +     + 208*s12**2*s13*s14*s34 - 144*s12**2*s13*s34**2 + 64*s12**2
     +    *s14*s34**2 - 80*s12**2*s34**3 - 96*s12*s13**4 - 160*s12*
     +    s13**3*s14 - 64*s12*s13**3*s34 - 64*s12*s13**2*s14**2 + 176*
     +    s12*s13**2*s14*s34 + 336*s12*s13**2*s34**2 + 16*s12*s13*
     +    s14**2*s34 + 16*s12*s13*s14*s34**2 - 96*s13**4*s14 - 112*
     +    s13**3*s14**2 - 96*s13**3*s14*s34 - 240*s13**3*s34**2 - 16*
     +    s13**2*s14**3 - 16*s13**2*s14**2*s34 )

      LC = LC + Ld22(p4,p3,p12)*S23**(-1)*S123**(-1) * (  - 96*s12**3*
     +    s34 + 48*s12**2*s13*s14 + 48*s12**2*s13*s24 + 16*s12**2*s13*
     +    s34 - 32*s12**2*s24*s34 - 96*s12**2*s34**2 - 128*s12*s13**3
     +     + 32*s12*s13**2*s14 + 160*s12*s13**2*s24 + 448*s12*s13**2*
     +    s34 + 16*s12*s13*s14**2 + 32*s12*s13*s14*s24 + 80*s12*s13*s14
     +    *s34 + 16*s12*s13*s24**2 + 32*s12*s13*s24*s34 + 48*s12*s13*
     +    s34**2 - 192*s13**4 - 144*s13**3*s14 + 48*s13**3*s24 - 32*
     +    s13**2*s14**2 - 16*s13**2*s14*s34 + 32*s13**2*s24**2 + 16*
     +    s13**2*s24*s34 )

      LC = LC + Ld22(p4,p3,p12)*S24**(-1)*S123**(-1) * ( 288*s12**2*s13
     +    *s34 + 48*s12**2*s14*s34 - 416*s12**2*s34**2 - 96*s12*s13**3
     +     - 96*s12*s13**2*s14 - 96*s12*s13**2*s34 + 192*s12*s13*s14*
     +    s34 + 576*s12*s13*s34**2 - 96*s13**3*s14 - 96*s13**2*s14**2
     +     - 96*s13**2*s14*s34 - 240*s13**2*s34**2 )

      LC = LC + Ld22(p4,p3,p12)*S123**(-1) * (  - 192*s12**2*s34 + 96*
     +    s12*s13*s14 + 96*s12*s13*s24 + 384*s12*s13*s34 - 192*s13**3
     +     - 96*s13**2*s14 + 96*s13**2*s24 )

      LC = LC + Ld24(p1,p2,p34)*S23**(-1)*S134 * ( 16*s12*s34 - 16*s13*
     +    s24 - 24*s14*s24 )

      LC = LC + Ld24(p1,p2,p34)*S24**(-1)*S134 * ( 16*s12*s34 - 24*s13*
     +    s23 - 16*s14*s23 )

      LC = LC + Ld24(p1,p2,p34)*S134 * (  - 8*s13 - 8*s14 )

      LC = LC + Ld24(p1,p3,p24)*S13**(-1)*S14**(-1)*S23**(-1) * ( 8*
     +    s12**3*s34**2 )

      LC = LC + Ld24(p1,p3,p24)*S13**(-1)*S14**(-1) * ( 24*s12**3*s23
     +     + 32*s12**3*s34 )

      LC = LC + Ld24(p1,p3,p24)*S13**(-1)*S23**(-1) * ( 8*s12**3*s34 + 
     +    8*s12**2*s14*s34 + 8*s12**2*s34**2 )

      LC = LC + Ld24(p1,p3,p24)*S13**(-1) * ( 24*s12**3 + 40*s12**2*s14
     +     + 40*s12**2*s23 + 48*s12**2*s34 + 16*s12*s14**2 + 16*s12*s14
     +    *s23 + 16*s12*s14*s34 )

      LC = LC + Ld24(p1,p3,p24)*S14**(-1)*S23**(-1) * ( 8*s12**3*s34 - 
     +    16*s12**2*s13*s24 - 16*s12**2*s24*s34 )

      LC = LC + Ld24(p1,p3,p24)*S14**(-1) * ( 24*s12**3 - 16*s12**2*s24
     +     )

      LC = LC + Ld24(p1,p3,p24)*S23**(-1) * (  - 16*s12**2*s24 + 8*
     +    s12**2*s34 - 16*s12*s13*s24 - 16*s12*s14*s24 - 16*s12*s24*s34
     +     )

      LC = LC + Ld24(p1,p3,p24) * ( 40*s12**2 + 16*s12*s14 - 16*s12*s24
     +     )

      LC = LC + Ld24(p1,p4,p23)*S13**(-1)*S14**(-1)*S24**(-1) * ( 8*
     +    s12**3*s34**2 )

      LC = LC + Ld24(p1,p4,p23)*S13**(-1)*S14**(-1) * ( 24*s12**3*s24
     +     + 32*s12**3*s34 )

      LC = LC + Ld24(p1,p4,p23)*S13**(-1)*S24**(-1) * ( 8*s12**3*s34 - 
     +    16*s12**2*s14*s23 - 16*s12**2*s23*s34 )

      LC = LC + Ld24(p1,p4,p23)*S13**(-1) * ( 24*s12**3 - 16*s12**2*s23
     +     )

      LC = LC + Ld24(p1,p4,p23)*S14**(-1)*S24**(-1) * ( 8*s12**3*s34 + 
     +    8*s12**2*s13*s34 + 8*s12**2*s34**2 )

      LC = LC + Ld24(p1,p4,p23)*S14**(-1) * ( 24*s12**3 + 40*s12**2*s13
     +     + 40*s12**2*s24 + 48*s12**2*s34 + 16*s12*s13**2 + 16*s12*s13
     +    *s24 + 16*s12*s13*s34 )

      LC = LC + Ld24(p1,p4,p23)*S24**(-1) * (  - 16*s12**2*s23 + 8*
     +    s12**2*s34 - 16*s12*s13*s23 - 16*s12*s14*s23 - 16*s12*s23*s34
     +     )

      LC = LC + Ld24(p1,p4,p23) * ( 40*s12**2 + 16*s12*s13 - 16*s12*s23
     +     )

      LC = LC + Ld24(p2,p1,p34)*S13**(-1)*S234 * ( 16*s12*s34 - 16*s14*
     +    s23 - 24*s14*s24 )

      LC = LC + Ld24(p2,p1,p34)*S14**(-1)*S234 * ( 16*s12*s34 - 24*s13*
     +    s23 - 16*s13*s24 )

      LC = LC + Ld24(p2,p1,p34)*S234 * (  - 8*s23 - 8*s24 )

      LC = LC + Ld24(p2,p3,p14)*S13**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**3*s34**2 )

      LC = LC + Ld24(p2,p3,p14)*S13**(-1)*S23**(-1) * ( 8*s12**3*s34 + 
     +    8*s12**2*s24*s34 + 8*s12**2*s34**2 )

      LC = LC + Ld24(p2,p3,p14)*S13**(-1)*S24**(-1) * ( 8*s12**3*s34 - 
     +    16*s12**2*s14*s23 - 16*s12**2*s14*s34 )

      LC = LC + Ld24(p2,p3,p14)*S13**(-1) * (  - 16*s12**2*s14 + 8*
     +    s12**2*s34 - 16*s12*s14*s23 - 16*s12*s14*s24 - 16*s12*s14*s34
     +     )

      LC = LC + Ld24(p2,p3,p14)*S23**(-1)*S24**(-1) * ( 24*s12**3*s13
     +     + 32*s12**3*s34 )

      LC = LC + Ld24(p2,p3,p14)*S23**(-1) * ( 24*s12**3 + 40*s12**2*s13
     +     + 40*s12**2*s24 + 48*s12**2*s34 + 16*s12*s13*s24 + 16*s12*
     +    s24**2 + 16*s12*s24*s34 )

      LC = LC + Ld24(p2,p3,p14)*S24**(-1) * ( 24*s12**3 - 16*s12**2*s14
     +     )

      LC = LC + Ld24(p2,p3,p14) * ( 40*s12**2 - 16*s12*s14 + 16*s12*s24
     +     )

      LC = LC + Ld24(p2,p4,p13)*S14**(-1)*S23**(-1)*S24**(-1) * ( 8*
     +    s12**3*s34**2 )

      LC = LC + Ld24(p2,p4,p13)*S14**(-1)*S23**(-1) * ( 8*s12**3*s34 - 
     +    16*s12**2*s13*s24 - 16*s12**2*s13*s34 )

      LC = LC + Ld24(p2,p4,p13)*S14**(-1)*S24**(-1) * ( 8*s12**3*s34 + 
     +    8*s12**2*s23*s34 + 8*s12**2*s34**2 )

      LC = LC + Ld24(p2,p4,p13)*S14**(-1) * (  - 16*s12**2*s13 + 8*
     +    s12**2*s34 - 16*s12*s13*s23 - 16*s12*s13*s24 - 16*s12*s13*s34
     +     )

      LC = LC + Ld24(p2,p4,p13)*S23**(-1)*S24**(-1) * ( 24*s12**3*s14
     +     + 32*s12**3*s34 )

      LC = LC + Ld24(p2,p4,p13)*S23**(-1) * ( 24*s12**3 - 16*s12**2*s13
     +     )

      LC = LC + Ld24(p2,p4,p13)*S24**(-1) * ( 24*s12**3 + 40*s12**2*s14
     +     + 40*s12**2*s23 + 48*s12**2*s34 + 16*s12*s14*s23 + 16*s12*
     +    s23**2 + 16*s12*s23*s34 )

      LC = LC + Ld24(p2,p4,p13) * ( 40*s12**2 - 16*s12*s13 + 16*s12*s23
     +     )

      LC = LC + Ld24(p3,p1,p24)*S13**(-1)*S14**(-1)*S234*S124**(-1)
     +  * ( 24*s12**2*s23**2 + 40*s12**2*s23*s34 + 16*s12**2*s34**2 )

      LC = LC + Ld24(p3,p1,p24)*S13**(-1)*S234*S124**(-1) * ( 24*s12**2
     +    *s23 + 16*s12**2*s34 + 32*s12*s14*s23 + 16*s12*s14*s34 + 32*
     +    s12*s23**2 + 48*s12*s23*s34 + 16*s12*s34**2 + 8*s14**2*s23 + 
     +    8*s14*s23**2 + 8*s14*s23*s34 )

      LC = LC + Ld24(p3,p1,p24)*S14**(-1)*S234*S124**(-1) * ( 24*s12**2
     +    *s23 + 16*s12**2*s34 - 16*s12*s13*s24 - 16*s12*s23*s24 - 16*
     +    s12*s24*s34 )

      LC = LC + Ld24(p3,p1,p24)*S234*S124**(-1) * ( 32*s12*s23 - 16*s12
     +    *s24 + 16*s12*s34 - 16*s13*s24 + 8*s14*s23 - 16*s14*s24 - 16*
     +    s23*s24 - 16*s24*s34 )

      LC = LC + Ld24(p3,p2,p14)*S23**(-1)*S24**(-1)*S134*S124**(-1)
     +  * ( 24*s12**2*s13**2 + 40*s12**2*s13*s34 + 16*s12**2*s34**2 )

      LC = LC + Ld24(p3,p2,p14)*S23**(-1)*S134*S124**(-1) * ( 24*s12**2
     +    *s13 + 16*s12**2*s34 + 32*s12*s13**2 + 32*s12*s13*s24 + 48*
     +    s12*s13*s34 + 16*s12*s24*s34 + 16*s12*s34**2 + 8*s13**2*s24
     +     + 8*s13*s24**2 + 8*s13*s24*s34 )

      LC = LC + Ld24(p3,p2,p14)*S24**(-1)*S134*S124**(-1) * ( 24*s12**2
     +    *s13 + 16*s12**2*s34 - 16*s12*s13*s14 - 16*s12*s14*s23 - 16*
     +    s12*s14*s34 )

      LC = LC + Ld24(p3,p2,p14)*S134*S124**(-1) * ( 32*s12*s13 - 16*s12
     +    *s14 + 16*s12*s34 - 16*s13*s14 + 8*s13*s24 - 16*s14*s23 - 16*
     +    s14*s24 - 16*s14*s34 )

      LC = LC + Ld24(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * ( 48*s12**4*s34**2 - 160*s12**3*s14*s34**2 + 112*
     +    s12**3*s34**3 - 192*s12**2*s14**2*s34**2 + 288*s12**2*s14*
     +    s34**3 - 64*s12**2*s34**4 - 192*s12*s14**3*s34**2 + 320*s12*
     +    s14**2*s34**3 - 64*s12*s14*s34**4 )

      LC = LC + Ld24(p3,p4,p12)*S13**(-1)*S23**(-1)*S124**(-1) * ( 48*
     +    s12**3*s34**2 + 96*s12**2*s14*s34**2 - 96*s12**2*s24*s34**2
     +     - 160*s12**2*s34**3 - 64*s12*s14**2*s34**2 + 64*s12*s14*s24*
     +    s34**2 + 192*s12*s14*s34**3 - 64*s12*s24**2*s34**2 - 128*s12*
     +    s24*s34**3 - 64*s12*s34**4 )

      LC = LC + Ld24(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * ( 48*s12**4*s34**2 + 192*s12**3*s13**2*s34 - 752*
     +    s12**3*s13*s34**2 + 144*s12**3*s34**3 + 16*s12**2*s13**3*s34
     +     - 112*s12**2*s13**2*s34**2 + 112*s12**2*s13*s34**3 - 16*
     +    s12**2*s34**4 )

      LC = LC + Ld24(p3,p4,p12)*S14**(-1)*S23**(-1)*S124**(-1) * ( 32*
     +    s12**3*s34**2 + 48*s12**2*s13**3 - 48*s12**2*s13**2*s24 + 272
     +    *s12**2*s13**2*s34 - 160*s12**2*s13*s24*s34 - 736*s12**2*s13*
     +    s34**2 - 112*s12**2*s24*s34**2 - 128*s12**2*s34**3 + 64*s12*
     +    s13**3*s24 + 32*s12*s13**3*s34 - 64*s12*s13**2*s24**2 + 144*
     +    s12*s13**2*s24*s34 - 80*s12*s13**2*s34**2 - 256*s12*s13*
     +    s24**2*s34 - 160*s12*s13*s24*s34**2 + 32*s12*s13*s34**3 - 160
     +    *s12*s24**2*s34**2 - 224*s12*s24*s34**3 + 16*s13**3*s24**2 + 
     +    16*s13**3*s24*s34 - 16*s13**2*s24**3 + 64*s13**2*s24**2*s34
     +     - 16*s13**2*s24*s34**2 - 96*s13*s24**3*s34 - 32*s13*s24**2*
     +    s34**2 - 64*s24**3*s34**2 - 64*s24**2*s34**3 )

      LC = LC + Ld24(p3,p4,p12)*S23**(-1)*S24**(-1)*S124**(-1) * ( 528*
     +    s12**3*s13*s34 + 336*s12**3*s14*s34 - 1024*s12**3*s34**2 + 48
     +    *s12**2*s13**3 + 48*s12**2*s13**2*s14 - 432*s12**2*s13**2*s34
     +     - 352*s12**2*s13*s14*s34 + 1200*s12**2*s13*s34**2 + 144*
     +    s12**2*s14**2*s34 + 64*s12**2*s14*s34**2 - 144*s12**2*s34**3
     +     + 64*s12*s13**3*s14 + 32*s12*s13**3*s34 + 64*s12*s13**2*
     +    s14**2 - 592*s12*s13**2*s14*s34 + 16*s12*s13**2*s34**2 - 784*
     +    s12*s13*s14**2*s34 + 800*s12*s13*s14*s34**2 - 80*s12*s13*
     +    s34**3 - 96*s12*s14**3*s34 + 160*s12*s14**2*s34**2 - 144*s12*
     +    s14*s34**3 + 16*s13**3*s14**2 + 16*s13**3*s14*s34 + 16*s13**2
     +    *s14**3 - 64*s13**2*s14**2*s34 + 16*s13**2*s14*s34**2 - 96*
     +    s13*s14**3*s34 - 224*s13*s14**2*s34**2 + 64*s14**3*s34**2 - 
     +    320*s14**2*s34**3 )

      LC = LC + Ld24(p3,p4,p12)*S23**(-1)*S124**(-1) * (  - 48*s12**2*
     +    s13*s14 - 48*s12**2*s13*s24 + 800*s12**2*s13*s34 + 432*s12**2
     +    *s14*s34 - 160*s12**2*s24*s34 - 768*s12**2*s34**2 + 128*s12*
     +    s13**3 + 64*s12*s13**2*s14 - 64*s12*s13**2*s24 - 448*s12*
     +    s13**2*s34 - 16*s12*s13*s14**2 - 32*s12*s13*s14*s24 - 288*s12
     +    *s13*s14*s34 - 16*s12*s13*s24**2 + 240*s12*s13*s24*s34 + 1264
     +    *s12*s13*s34**2 + 64*s12*s14*s34**2 - 96*s12*s24**2*s34 + 128
     +    *s12*s24*s34**2 + 208*s12*s34**3 + 48*s13**3*s14 + 48*s13**3*
     +    s24 + 32*s13**3*s34 + 32*s13**2*s14**2 - 64*s13**2*s14*s34 - 
     +    32*s13**2*s24**2 + 64*s13**2*s24*s34 + 192*s13*s14*s24*s34 - 
     +    96*s13*s14*s34**2 + 96*s13*s24*s34**2 - 64*s14**2*s34**2 - 
     +    128*s14*s34**3 + 64*s24**2*s34**2 + 128*s24*s34**3 )

      LC = LC + Ld24(p4,p1,p23)*S13**(-1)*S14**(-1)*S123**(-1)*S234
     +  * ( 24*s12**2*s24**2 + 40*s12**2*s24*s34 + 16*s12**2*s34**2 )

      LC = LC + Ld24(p4,p1,p23)*S13**(-1)*S123**(-1)*S234 * ( 24*s12**2
     +    *s24 + 16*s12**2*s34 - 16*s12*s14*s23 - 16*s12*s23*s24 - 16*
     +    s12*s23*s34 )

      LC = LC + Ld24(p4,p1,p23)*S14**(-1)*S123**(-1)*S234 * ( 24*s12**2
     +    *s24 + 16*s12**2*s34 + 32*s12*s13*s24 + 16*s12*s13*s34 + 32*
     +    s12*s24**2 + 48*s12*s24*s34 + 16*s12*s34**2 + 8*s13**2*s24 + 
     +    8*s13*s24**2 + 8*s13*s24*s34 )

      LC = LC + Ld24(p4,p1,p23)*S123**(-1)*S234 * (  - 16*s12*s23 + 32*
     +    s12*s24 + 16*s12*s34 - 16*s13*s23 + 8*s13*s24 - 16*s14*s23 - 
     +    16*s23*s24 - 16*s23*s34 )

      LC = LC + Ld24(p4,p2,p13)*S23**(-1)*S24**(-1)*S123**(-1)*S134
     +  * ( 24*s12**2*s14**2 + 40*s12**2*s14*s34 + 16*s12**2*s34**2 )

      LC = LC + Ld24(p4,p2,p13)*S23**(-1)*S123**(-1)*S134 * ( 24*s12**2
     +    *s14 + 16*s12**2*s34 - 16*s12*s13*s14 - 16*s12*s13*s24 - 16*
     +    s12*s13*s34 )

      LC = LC + Ld24(p4,p2,p13)*S24**(-1)*S123**(-1)*S134 * ( 24*s12**2
     +    *s14 + 16*s12**2*s34 + 32*s12*s14**2 + 32*s12*s14*s23 + 48*
     +    s12*s14*s34 + 16*s12*s23*s34 + 16*s12*s34**2 + 8*s14**2*s23
     +     + 8*s14*s23**2 + 8*s14*s23*s34 )

      LC = LC + Ld24(p4,p2,p13)*S123**(-1)*S134 * (  - 16*s12*s13 + 32*
     +    s12*s14 + 16*s12*s34 - 16*s13*s14 - 16*s13*s23 - 16*s13*s24
     +     - 16*s13*s34 + 8*s14*s23 )

      LC = LC + Ld24(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * ( 48*s12**4*s34**2 + 192*s12**3*s14**2*s34 - 752*
     +    s12**3*s14*s34**2 + 144*s12**3*s34**3 + 16*s12**2*s14**3*s34
     +     - 112*s12**2*s14**2*s34**2 + 112*s12**2*s14*s34**3 - 16*
     +    s12**2*s34**4 )

      LC = LC + Ld24(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 32*
     +    s12**3*s34**2 + 48*s12**2*s14**3 - 48*s12**2*s14**2*s23 + 272
     +    *s12**2*s14**2*s34 - 160*s12**2*s14*s23*s34 - 736*s12**2*s14*
     +    s34**2 - 112*s12**2*s23*s34**2 - 128*s12**2*s34**3 + 64*s12*
     +    s14**3*s23 + 32*s12*s14**3*s34 - 64*s12*s14**2*s23**2 + 144*
     +    s12*s14**2*s23*s34 - 80*s12*s14**2*s34**2 - 256*s12*s14*
     +    s23**2*s34 - 160*s12*s14*s23*s34**2 + 32*s12*s14*s34**3 - 160
     +    *s12*s23**2*s34**2 - 224*s12*s23*s34**3 + 16*s14**3*s23**2 + 
     +    16*s14**3*s23*s34 - 16*s14**2*s23**3 + 64*s14**2*s23**2*s34
     +     - 16*s14**2*s23*s34**2 - 96*s14*s23**3*s34 - 32*s14*s23**2*
     +    s34**2 - 64*s23**3*s34**2 - 64*s23**2*s34**3 )

      LC = LC + Ld24(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * ( 48*s12**4*s34**2 - 160*s12**3*s13*s34**2 + 112*
     +    s12**3*s34**3 - 192*s12**2*s13**2*s34**2 + 288*s12**2*s13*
     +    s34**3 - 64*s12**2*s34**4 - 192*s12*s13**3*s34**2 + 320*s12*
     +    s13**2*s34**3 - 64*s12*s13*s34**4 )

      LC = LC + Ld24(p4,p3,p12)*S14**(-1)*S24**(-1)*S123**(-1) * ( 48*
     +    s12**3*s34**2 + 96*s12**2*s13*s34**2 - 96*s12**2*s23*s34**2
     +     - 160*s12**2*s34**3 - 64*s12*s13**2*s34**2 + 64*s12*s13*s23*
     +    s34**2 + 192*s12*s13*s34**3 - 64*s12*s23**2*s34**2 - 128*s12*
     +    s23*s34**3 - 64*s12*s34**4 )

      LC = LC + Ld24(p4,p3,p12)*S23**(-1)*S24**(-1)*S123**(-1) * ( 336*
     +    s12**3*s13*s34 + 528*s12**3*s14*s34 - 1024*s12**3*s34**2 + 
     +    144*s12**2*s13**2*s34 + 48*s12**2*s13*s14**2 - 352*s12**2*s13
     +    *s14*s34 + 64*s12**2*s13*s34**2 + 48*s12**2*s14**3 - 432*
     +    s12**2*s14**2*s34 + 1200*s12**2*s14*s34**2 - 144*s12**2*
     +    s34**3 - 96*s12*s13**3*s34 + 64*s12*s13**2*s14**2 - 784*s12*
     +    s13**2*s14*s34 + 160*s12*s13**2*s34**2 + 64*s12*s13*s14**3 - 
     +    592*s12*s13*s14**2*s34 + 800*s12*s13*s14*s34**2 - 144*s12*s13
     +    *s34**3 + 32*s12*s14**3*s34 + 16*s12*s14**2*s34**2 - 80*s12*
     +    s14*s34**3 + 16*s13**3*s14**2 - 96*s13**3*s14*s34 + 64*s13**3
     +    *s34**2 + 16*s13**2*s14**3 - 64*s13**2*s14**2*s34 - 224*
     +    s13**2*s14*s34**2 - 320*s13**2*s34**3 + 16*s13*s14**3*s34 + 
     +    16*s13*s14**2*s34**2 )

      LC = LC + Ld24(p4,p3,p12)*S24**(-1)*S123**(-1) * (  - 48*s12**2*
     +    s13*s14 + 432*s12**2*s13*s34 - 48*s12**2*s14*s23 + 800*s12**2
     +    *s14*s34 - 160*s12**2*s23*s34 - 768*s12**2*s34**2 - 16*s12*
     +    s13**2*s14 + 64*s12*s13*s14**2 - 32*s12*s13*s14*s23 - 288*s12
     +    *s13*s14*s34 + 64*s12*s13*s34**2 + 128*s12*s14**3 - 64*s12*
     +    s14**2*s23 - 448*s12*s14**2*s34 - 16*s12*s14*s23**2 + 240*s12
     +    *s14*s23*s34 + 1264*s12*s14*s34**2 - 96*s12*s23**2*s34 + 128*
     +    s12*s23*s34**2 + 208*s12*s34**3 + 32*s13**2*s14**2 - 64*
     +    s13**2*s34**2 + 48*s13*s14**3 - 64*s13*s14**2*s34 + 192*s13*
     +    s14*s23*s34 - 96*s13*s14*s34**2 - 128*s13*s34**3 + 48*s14**3*
     +    s23 + 32*s14**3*s34 - 32*s14**2*s23**2 + 64*s14**2*s23*s34 + 
     +    96*s14*s23*s34**2 + 64*s23**2*s34**2 + 128*s23*s34**3 )

      LCg=-LC/s134/s234
      
      return
      end
      
      function LCh(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LC=0d0

      LC = LC + Ld311(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * ( 128*s12**4*s34**2 + 192*s12**3*s14**2*s34 - 432*
     +    s12**3*s14*s34**2 + 192*s12**3*s34**3 + 368*s12**2*s14**2*
     +    s34**2 - 208*s12**2*s14*s34**3 + 32*s12*s14**3*s34**2 + 32*
     +    s12*s14**2*s34**3 )

      LC = LC + Ld311(p3,p4,p12)*S13**(-1)*S23**(-1)*S124**(-1) * ( 16*
     +    s12**4*s34 - 96*s12**3*s14*s34 + 96*s12**3*s24*s34 + 288*
     +    s12**3*s34**2 + 96*s12**2*s14**2*s34 - 48*s12**2*s14*s24*s34
     +     - 224*s12**2*s14*s34**2 + 96*s12**2*s24**2*s34 + 224*s12**2*
     +    s24*s34**2 + 128*s12**2*s34**3 + 32*s12*s14**3*s34 + 32*s12*
     +    s14**2*s34**2 - 32*s12*s14*s24*s34**2 - 32*s12*s14*s34**3 + 
     +    32*s12*s24**3*s34 + 64*s12*s24**2*s34**2 + 32*s12*s24*s34**3
     +     )

      LC = LC + Ld311(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1) * ( 16*
     +    s12**4*s34 - 208*s12**3*s14*s34 + 16*s12**3*s23*s34 + 112*
     +    s12**3*s34**2 - 192*s12**2*s14**3 + 192*s12**2*s14**2*s23 + 
     +    816*s12**2*s14**2*s34 - 192*s12**2*s14*s23*s34 - 432*s12**2*
     +    s14*s34**2 - 192*s12*s14**3*s23 - 240*s12*s14**3*s34 + 192*
     +    s12*s14**2*s23**2 + 432*s12*s14**2*s23*s34 + 336*s12*s14**2*
     +    s34**2 )

      LC = LC + Ld311(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * ( 128*s12**4*s34**2 )

      LC = LC + Ld311(p3,p4,p12)*S14**(-1)*S23**(-1)*S124**(-1) * ( 16*
     +    s12**4*s34 - 112*s12**3*s13*s34 + 112*s12**3*s24*s34 + 304*
     +    s12**3*s34**2 - 192*s12**2*s13*s24*s34 + 192*s12**2*s24**2*
     +    s34 + 320*s12**2*s24*s34**2 - 128*s12*s13*s24**2*s34 + 128*
     +    s12*s24**3*s34 + 160*s12*s24**2*s34**2 - 32*s13*s24**3*s34 + 
     +    32*s24**4*s34 + 32*s24**3*s34**2 )

      LC = LC + Ld311(p3,p4,p12)*S14**(-1)*S24**(-1)*S124**(-1) * ( 16*
     +    s12**4*s34 )

      LC = LC + Ld311(p3,p4,p12)*S23**(-1)*S24**(-1)*S124**(-1) * (  - 
     +    128*s12**3*s13*s34 + 64*s12**3*s14*s34 - 432*s12**3*s34**2 - 
     +    192*s12**2*s13*s14**2 + 624*s12**2*s13*s14*s34 - 192*s12**2*
     +    s14**3 + 624*s12**2*s14**2*s34 + 368*s12**2*s14*s34**2 - 192*
     +    s12*s13**2*s14**2 - 192*s12*s13*s14**3 - 560*s12*s13*s14**2*
     +    s34 - 368*s12*s14**3*s34 + 240*s12*s14**2*s34**2 - 32*s13*
     +    s14**3*s34 - 32*s14**4*s34 - 32*s14**3*s34**2 )

      LC = LC + Ld311(p3,p4,p12)*S23**(-1)*S124**(-1) * (  - 192*s12**3
     +    *s34 + 48*s12**2*s13*s34 + 240*s12**2*s14*s34 - 240*s12**2*
     +    s24*s34 - 512*s12**2*s34**2 - 48*s12*s13*s14*s34 - 48*s12*s13
     +    *s24*s34 + 80*s12*s14**2*s34 + 208*s12*s14*s34**2 - 80*s12*
     +    s24**2*s34 - 208*s12*s24*s34**2 - 32*s13*s14**2*s34 - 32*s13*
     +    s24**2*s34 + 32*s14**2*s24*s34 + 32*s14**2*s34**2 - 32*s14*
     +    s24**2*s34 - 32*s24**2*s34**2 )

      LC = LC + Ld311(p3,p4,p12)*S24**(-1)*S124**(-1) * (  - 192*s12**3
     +    *s34 + 192*s12**2*s13*s14 + 192*s12**2*s14*s23 + 624*s12**2*
     +    s14*s34 - 192*s12*s13*s14**2 - 384*s12*s14**3 + 192*s12*
     +    s14**2*s23 )

      LC = LC + Ld311(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * ( 128*s12**4*s34**2 )

      LC = LC + Ld311(p4,p3,p12)*S13**(-1)*S23**(-1)*S123**(-1) * ( 16*
     +    s12**4*s34 )

      LC = LC + Ld311(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 16*
     +    s12**4*s34 - 112*s12**3*s14*s34 + 112*s12**3*s23*s34 + 304*
     +    s12**3*s34**2 - 192*s12**2*s14*s23*s34 + 192*s12**2*s23**2*
     +    s34 + 320*s12**2*s23*s34**2 - 128*s12*s14*s23**2*s34 + 128*
     +    s12*s23**3*s34 + 160*s12*s23**2*s34**2 - 32*s14*s23**3*s34 + 
     +    32*s23**4*s34 + 32*s23**3*s34**2 )

      LC = LC + Ld311(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * ( 128*s12**4*s34**2 + 192*s12**3*s13**2*s34 - 432*
     +    s12**3*s13*s34**2 + 192*s12**3*s34**3 + 368*s12**2*s13**2*
     +    s34**2 - 208*s12**2*s13*s34**3 + 32*s12*s13**3*s34**2 + 32*
     +    s12*s13**2*s34**3 )

      LC = LC + Ld311(p4,p3,p12)*S14**(-1)*S23**(-1)*S123**(-1) * ( 16*
     +    s12**4*s34 - 208*s12**3*s13*s34 + 16*s12**3*s24*s34 + 112*
     +    s12**3*s34**2 - 192*s12**2*s13**3 + 192*s12**2*s13**2*s24 + 
     +    816*s12**2*s13**2*s34 - 192*s12**2*s13*s24*s34 - 432*s12**2*
     +    s13*s34**2 - 192*s12*s13**3*s24 - 240*s12*s13**3*s34 + 192*
     +    s12*s13**2*s24**2 + 432*s12*s13**2*s24*s34 + 336*s12*s13**2*
     +    s34**2 )

      LC = LC + Ld311(p4,p3,p12)*S14**(-1)*S24**(-1)*S123**(-1) * ( 16*
     +    s12**4*s34 - 96*s12**3*s13*s34 + 96*s12**3*s23*s34 + 288*
     +    s12**3*s34**2 + 96*s12**2*s13**2*s34 - 48*s12**2*s13*s23*s34
     +     - 224*s12**2*s13*s34**2 + 96*s12**2*s23**2*s34 + 224*s12**2*
     +    s23*s34**2 + 128*s12**2*s34**3 + 32*s12*s13**3*s34 + 32*s12*
     +    s13**2*s34**2 - 32*s12*s13*s23*s34**2 - 32*s12*s13*s34**3 + 
     +    32*s12*s23**3*s34 + 64*s12*s23**2*s34**2 + 32*s12*s23*s34**3
     +     )

      LC = LC + Ld311(p4,p3,p12)*S23**(-1)*S24**(-1)*S123**(-1) * ( 64*
     +    s12**3*s13*s34 - 128*s12**3*s14*s34 - 432*s12**3*s34**2 - 192
     +    *s12**2*s13**3 - 192*s12**2*s13**2*s14 + 624*s12**2*s13**2*
     +    s34 + 624*s12**2*s13*s14*s34 + 368*s12**2*s13*s34**2 - 192*
     +    s12*s13**3*s14 - 368*s12*s13**3*s34 - 192*s12*s13**2*s14**2
     +     - 560*s12*s13**2*s14*s34 + 240*s12*s13**2*s34**2 - 32*s13**4
     +    *s34 - 32*s13**3*s14*s34 - 32*s13**3*s34**2 )

      LC = LC + Ld311(p4,p3,p12)*S23**(-1)*S123**(-1) * (  - 192*s12**3
     +    *s34 + 192*s12**2*s13*s14 + 192*s12**2*s13*s24 + 624*s12**2*
     +    s13*s34 - 384*s12*s13**3 - 192*s12*s13**2*s14 + 192*s12*
     +    s13**2*s24 )

      LC = LC + Ld311(p4,p3,p12)*S24**(-1)*S123**(-1) * (  - 192*s12**3
     +    *s34 + 240*s12**2*s13*s34 + 48*s12**2*s14*s34 - 240*s12**2*
     +    s23*s34 - 512*s12**2*s34**2 + 80*s12*s13**2*s34 - 48*s12*s13*
     +    s14*s34 + 208*s12*s13*s34**2 - 48*s12*s14*s23*s34 - 80*s12*
     +    s23**2*s34 - 208*s12*s23*s34**2 - 32*s13**2*s14*s34 + 32*
     +    s13**2*s23*s34 + 32*s13**2*s34**2 - 32*s13*s23**2*s34 - 32*
     +    s14*s23**2*s34 - 32*s23**2*s34**2 )

      LC = LC + Ld314(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * (  - 96*s12**4*s34**2 + 240*s12**3*s14*s34**2 - 336
     +    *s12**3*s34**3 - 48*s12**2*s14**2*s34**2 + 144*s12**2*s14*
     +    s34**3 - 48*s12**2*s34**4 )

      LC = LC + Ld314(p3,p4,p12)*S13**(-1)*S23**(-1)*S124**(-1) * (  - 
     +    144*s12**3*s34**2 + 48*s12**2*s14*s34**2 - 48*s12**2*s24*
     +    s34**2 - 96*s12**2*s34**3 )

      LC = LC + Ld314(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1) * ( 192
     +    *s12**3*s14*s34 - 96*s12**3*s23*s34 - 336*s12**3*s34**2 - 96*
     +    s12**2*s14**2*s23 - 336*s12**2*s14**2*s34 + 96*s12**2*s14*
     +    s23**2 + 528*s12**2*s14*s23*s34 + 720*s12**2*s14*s34**2 - 96*
     +    s12**2*s23**2*s34 - 240*s12**2*s23*s34**2 - 192*s12**2*s34**3
     +     + 96*s12*s14**3*s23 + 48*s12*s14**3*s34 - 192*s12*s14**2*
     +    s23**2 - 480*s12*s14**2*s23*s34 - 192*s12*s14**2*s34**2 + 96*
     +    s12*s14*s23**3 + 336*s12*s14*s23**2*s34 + 336*s12*s14*s23*
     +    s34**2 + 96*s12*s14*s34**3 + 96*s14**3*s23**2 + 48*s14**3*s23
     +    *s34 - 96*s14**2*s23**3 - 144*s14**2*s23**2*s34 - 48*s14**2*
     +    s23*s34**2 )

      LC = LC + Ld314(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * (  - 96*s12**4*s34**2 - 96*s12**3*s13**2*s34 + 480*
     +    s12**3*s13*s34**2 - 432*s12**3*s34**3 )

      LC = LC + Ld314(p3,p4,p12)*S14**(-1)*S23**(-1)*S124**(-1) * ( 192
     +    *s12**3*s13*s34 - 240*s12**3*s34**2 + 96*s12**2*s13**3 - 96*
     +    s12**2*s13**2*s24 - 624*s12**2*s13**2*s34 + 384*s12**2*s13*
     +    s24*s34 + 816*s12**2*s13*s34**2 - 192*s12**2*s24*s34**2 - 240
     +    *s12**2*s34**3 + 144*s12*s13**3*s24 - 144*s12*s13**2*s24**2
     +     - 432*s12*s13**2*s24*s34 + 240*s12*s13*s24**2*s34 + 336*s12*
     +    s13*s24*s34**2 - 48*s12*s24**2*s34**2 - 48*s12*s24*s34**3 + 
     +    48*s13**3*s24**2 - 48*s13**2*s24**3 - 96*s13**2*s24**2*s34 + 
     +    48*s13*s24**3*s34 + 48*s13*s24**2*s34**2 )

      LC = LC + Ld314(p3,p4,p12)*S14**(-1)*S24**(-1)*S124**(-1) * ( 96*
     +    s12**3*s13*s34 - 96*s12**3*s23*s34 - 336*s12**3*s34**2 )

      LC = LC + Ld314(p3,p4,p12)*S23**(-1)*S24**(-1)*S124**(-1) * (  - 
     +    96*s12**3*s13*s34 + 816*s12**3*s34**2 + 96*s12**2*s13**3 + 
     +    192*s12**2*s13**2*s14 - 720*s12**2*s13**2*s34 + 96*s12**2*s13
     +    *s14**2 - 1152*s12**2*s13*s14*s34 - 336*s12**2*s14**2*s34 + 
     +    624*s12**2*s34**3 + 240*s12*s13**3*s14 + 336*s12*s13**2*
     +    s14**2 + 288*s12*s13**2*s14*s34 + 96*s12*s13*s14**3 + 192*s12
     +    *s13*s14**2*s34 - 864*s12*s13*s14*s34**2 + 48*s12*s14**3*s34
     +     - 240*s12*s14**2*s34**2 - 48*s12*s14*s34**3 + 144*s13**3*
     +    s14**2 + 144*s13**2*s14**3 + 240*s13**2*s14**2*s34 + 96*s13*
     +    s14**3*s34 + 96*s13*s14**2*s34**2 )

      LC = LC + Ld314(p3,p4,p12)*S23**(-1)*S124**(-1) * ( 192*s12**3*
     +    s34 - 96*s12**2*s13*s14 - 96*s12**2*s13*s24 - 720*s12**2*s13*
     +    s34 - 96*s12**2*s14*s34 + 192*s12**2*s24*s34 + 768*s12**2*
     +    s34**2 + 288*s12*s13**3 + 144*s12*s13**2*s14 - 144*s12*s13**2
     +    *s24 - 192*s12*s13**2*s34 - 48*s12*s13*s14**2 - 96*s12*s13*
     +    s14*s24 - 384*s12*s13*s14*s34 - 48*s12*s13*s24**2 - 240*s12*
     +    s13*s24*s34 - 432*s12*s13*s34**2 - 48*s12*s14**2*s34 - 48*s12
     +    *s14*s34**2 + 48*s12*s24**2*s34 + 144*s12*s24*s34**2 + 144*
     +    s12*s34**3 + 144*s13**3*s14 + 144*s13**3*s24 + 96*s13**2*
     +    s14**2 + 96*s13**2*s14*s34 - 96*s13**2*s24**2 - 96*s13**2*s24
     +    *s34 - 96*s13*s14*s24*s34 - 48*s13*s14*s34**2 - 48*s13*s24*
     +    s34**2 )

      LC = LC + Ld314(p3,p4,p12)*S24**(-1)*S124**(-1) * ( 288*s12**3*
     +    s34 - 96*s12**2*s13**2 - 96*s12**2*s13*s14 - 144*s12**2*s13*
     +    s34 - 96*s12**2*s14*s23 - 576*s12**2*s14*s34 + 96*s12**2*
     +    s23**2 + 528*s12**2*s23*s34 + 1056*s12**2*s34**2 - 96*s12*
     +    s13**2*s14 + 192*s12*s13*s14**2 - 384*s12*s13*s14*s23 - 672*
     +    s12*s13*s14*s34 + 192*s12*s14**3 - 192*s12*s14**2*s23 - 384*
     +    s12*s14**2*s34 - 96*s12*s14*s23**2 - 384*s12*s14*s23*s34 - 
     +    576*s12*s14*s34**2 + 192*s13**2*s14**2 + 288*s13*s14**3 + 144
     +    *s13*s14**2*s34 + 288*s14**3*s23 + 96*s14**3*s34 - 192*s14**2
     +    *s23**2 - 144*s14**2*s23*s34 )

      LC = LC + Ld314(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * (  - 96*s12**4*s34**2 - 96*s12**3*s14**2*s34 + 480*
     +    s12**3*s14*s34**2 - 432*s12**3*s34**3 )

      LC = LC + Ld314(p4,p3,p12)*S13**(-1)*S23**(-1)*S123**(-1) * ( 96*
     +    s12**3*s14*s34 - 96*s12**3*s24*s34 - 336*s12**3*s34**2 )

      LC = LC + Ld314(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 192
     +    *s12**3*s14*s34 - 240*s12**3*s34**2 + 96*s12**2*s14**3 - 96*
     +    s12**2*s14**2*s23 - 624*s12**2*s14**2*s34 + 384*s12**2*s14*
     +    s23*s34 + 816*s12**2*s14*s34**2 - 192*s12**2*s23*s34**2 - 240
     +    *s12**2*s34**3 + 144*s12*s14**3*s23 - 144*s12*s14**2*s23**2
     +     - 432*s12*s14**2*s23*s34 + 240*s12*s14*s23**2*s34 + 336*s12*
     +    s14*s23*s34**2 - 48*s12*s23**2*s34**2 - 48*s12*s23*s34**3 + 
     +    48*s14**3*s23**2 - 48*s14**2*s23**3 - 96*s14**2*s23**2*s34 + 
     +    48*s14*s23**3*s34 + 48*s14*s23**2*s34**2 )

      LC = LC + Ld314(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * (  - 96*s12**4*s34**2 + 240*s12**3*s13*s34**2 - 336
     +    *s12**3*s34**3 - 48*s12**2*s13**2*s34**2 + 144*s12**2*s13*
     +    s34**3 - 48*s12**2*s34**4 )

      LC = LC + Ld314(p4,p3,p12)*S14**(-1)*S23**(-1)*S123**(-1) * ( 192
     +    *s12**3*s13*s34 - 96*s12**3*s24*s34 - 336*s12**3*s34**2 - 96*
     +    s12**2*s13**2*s24 - 336*s12**2*s13**2*s34 + 96*s12**2*s13*
     +    s24**2 + 528*s12**2*s13*s24*s34 + 720*s12**2*s13*s34**2 - 96*
     +    s12**2*s24**2*s34 - 240*s12**2*s24*s34**2 - 192*s12**2*s34**3
     +     + 96*s12*s13**3*s24 + 48*s12*s13**3*s34 - 192*s12*s13**2*
     +    s24**2 - 480*s12*s13**2*s24*s34 - 192*s12*s13**2*s34**2 + 96*
     +    s12*s13*s24**3 + 336*s12*s13*s24**2*s34 + 336*s12*s13*s24*
     +    s34**2 + 96*s12*s13*s34**3 + 96*s13**3*s24**2 + 48*s13**3*s24
     +    *s34 - 96*s13**2*s24**3 - 144*s13**2*s24**2*s34 - 48*s13**2*
     +    s24*s34**2 )

      LC = LC + Ld314(p4,p3,p12)*S14**(-1)*S24**(-1)*S123**(-1) * (  - 
     +    144*s12**3*s34**2 + 48*s12**2*s13*s34**2 - 48*s12**2*s23*
     +    s34**2 - 96*s12**2*s34**3 )

      LC = LC + Ld314(p4,p3,p12)*S23**(-1)*S24**(-1)*S123**(-1) * (  - 
     +    96*s12**3*s14*s34 + 816*s12**3*s34**2 + 96*s12**2*s13**2*s14
     +     - 336*s12**2*s13**2*s34 + 192*s12**2*s13*s14**2 - 1152*
     +    s12**2*s13*s14*s34 + 96*s12**2*s14**3 - 720*s12**2*s14**2*s34
     +     + 624*s12**2*s34**3 + 96*s12*s13**3*s14 + 48*s12*s13**3*s34
     +     + 336*s12*s13**2*s14**2 + 192*s12*s13**2*s14*s34 - 240*s12*
     +    s13**2*s34**2 + 240*s12*s13*s14**3 + 288*s12*s13*s14**2*s34
     +     - 864*s12*s13*s14*s34**2 - 48*s12*s13*s34**3 + 144*s13**3*
     +    s14**2 + 96*s13**3*s14*s34 + 144*s13**2*s14**3 + 240*s13**2*
     +    s14**2*s34 + 96*s13**2*s14*s34**2 )

      LC = LC + Ld314(p4,p3,p12)*S23**(-1)*S123**(-1) * ( 288*s12**3*
     +    s34 - 96*s12**2*s13*s14 - 96*s12**2*s13*s24 - 576*s12**2*s13*
     +    s34 - 96*s12**2*s14**2 - 144*s12**2*s14*s34 + 96*s12**2*
     +    s24**2 + 528*s12**2*s24*s34 + 1056*s12**2*s34**2 + 192*s12*
     +    s13**3 + 192*s12*s13**2*s14 - 192*s12*s13**2*s24 - 384*s12*
     +    s13**2*s34 - 96*s12*s13*s14**2 - 384*s12*s13*s14*s24 - 672*
     +    s12*s13*s14*s34 - 96*s12*s13*s24**2 - 384*s12*s13*s24*s34 - 
     +    576*s12*s13*s34**2 + 288*s13**3*s14 + 288*s13**3*s24 + 96*
     +    s13**3*s34 + 192*s13**2*s14**2 + 144*s13**2*s14*s34 - 192*
     +    s13**2*s24**2 - 144*s13**2*s24*s34 )

      LC = LC + Ld314(p4,p3,p12)*S24**(-1)*S123**(-1) * ( 192*s12**3*
     +    s34 - 96*s12**2*s13*s14 - 96*s12**2*s13*s34 - 96*s12**2*s14*
     +    s23 - 720*s12**2*s14*s34 + 192*s12**2*s23*s34 + 768*s12**2*
     +    s34**2 - 48*s12*s13**2*s14 - 48*s12*s13**2*s34 + 144*s12*s13*
     +    s14**2 - 96*s12*s13*s14*s23 - 384*s12*s13*s14*s34 - 48*s12*
     +    s13*s34**2 + 288*s12*s14**3 - 144*s12*s14**2*s23 - 192*s12*
     +    s14**2*s34 - 48*s12*s14*s23**2 - 240*s12*s14*s23*s34 - 432*
     +    s12*s14*s34**2 + 48*s12*s23**2*s34 + 144*s12*s23*s34**2 + 144
     +    *s12*s34**3 + 96*s13**2*s14**2 + 144*s13*s14**3 + 96*s13*
     +    s14**2*s34 - 96*s13*s14*s23*s34 - 48*s13*s14*s34**2 + 144*
     +    s14**3*s23 - 96*s14**2*s23**2 - 96*s14**2*s23*s34 - 48*s14*
     +    s23*s34**2 )

      LC = LC + Ld322(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * (  - 32*s12**3*s14*s34**2 + 16*s12**3*s34**3 - 64*
     +    s12**2*s14**2*s34**2 + 32*s12**2*s14*s34**3 - 32*s12*s14**3*
     +    s34**2 - 32*s12*s14**2*s34**3 )

      LC = LC + Ld322(p3,p4,p12)*S13**(-1)*S23**(-1)*S124**(-1) * ( 16*
     +    s12**3*s34**2 - 32*s12**2*s14**2*s34 - 16*s12**2*s14*s24*s34
     +     - 16*s12**2*s14*s34**2 + 16*s12**2*s24**2*s34 - 16*s12**2*
     +    s34**3 - 32*s12*s14**3*s34 - 32*s12*s14**2*s34**2 + 32*s12*
     +    s14*s24*s34**2 + 32*s12*s14*s34**3 - 32*s12*s24**3*s34 - 64*
     +    s12*s24**2*s34**2 - 32*s12*s24*s34**3 )

      LC = LC + Ld322(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1) * (  - 
     +    48*s12**2*s14*s34**2 - 96*s12*s14**2*s34**2 )

      LC = LC + Ld322(p3,p4,p12)*S14**(-1)*S23**(-1)*S124**(-1) * ( 16*
     +    s12**3*s34**2 - 64*s12**2*s13*s24*s34 + 16*s12**2*s24**2*s34
     +     + 48*s12*s13**2*s24**2 - 48*s12*s13*s24**3 - 80*s12*s13*
     +    s24**2*s34 - 16*s12*s24**3*s34 - 48*s12*s24**2*s34**2 + 48*
     +    s13**2*s24**3 - 48*s13*s24**4 - 16*s13*s24**3*s34 - 32*s24**4
     +    *s34 - 32*s24**3*s34**2 )

      LC = LC + Ld322(p3,p4,p12)*S23**(-1)*S24**(-1)*S124**(-1) * (  - 
     +    32*s12**3*s34**2 + 80*s12**2*s13*s14*s34 + 80*s12**2*s14**2*
     +    s34 - 32*s12**2*s14*s34**2 - 48*s12*s13**2*s14**2 - 48*s12*
     +    s13*s14**3 + 64*s12*s13*s14**2*s34 + 112*s12*s14**3*s34 - 16*
     +    s12*s14**2*s34**2 - 48*s13**2*s14**3 - 48*s13*s14**4 - 16*s13
     +    *s14**3*s34 + 32*s14**4*s34 + 32*s14**3*s34**2 )

      LC = LC + Ld322(p3,p4,p12)*S23**(-1)*S124**(-1) * ( 16*s12**2*s13
     +    *s34 - 16*s12**2*s14*s34 - 80*s12**2*s24*s34 - 80*s12**2*
     +    s34**2 - 48*s12*s13**2*s14 + 48*s12*s13**2*s24 + 96*s12*s13*
     +    s14*s24 + 144*s12*s13*s14*s34 + 48*s12*s14**3 + 48*s12*s14**2
     +    *s24 + 80*s12*s14**2*s34 - 48*s12*s14*s24**2 - 96*s12*s14*s24
     +    *s34 - 80*s12*s14*s34**2 - 48*s12*s24**3 - 80*s12*s24**2*s34
     +     - 16*s12*s24*s34**2 - 96*s13**2*s14**2 + 96*s13**2*s24**2 - 
     +    48*s13*s14**3 + 96*s13*s14**2*s24 + 32*s13*s14**2*s34 + 96*
     +    s13*s14*s24**2 + 96*s13*s14*s24*s34 - 48*s13*s24**3 + 32*s13*
     +    s24**2*s34 - 32*s14**2*s24*s34 - 32*s14**2*s34**2 + 32*s14*
     +    s24**2*s34 + 32*s24**2*s34**2 )

      LC = LC + Ld322(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 16*
     +    s12**3*s34**2 - 64*s12**2*s14*s23*s34 + 16*s12**2*s23**2*s34
     +     + 48*s12*s14**2*s23**2 - 48*s12*s14*s23**3 - 80*s12*s14*
     +    s23**2*s34 - 16*s12*s23**3*s34 - 48*s12*s23**2*s34**2 + 48*
     +    s14**2*s23**3 - 48*s14*s23**4 - 16*s14*s23**3*s34 - 32*s23**4
     +    *s34 - 32*s23**3*s34**2 )

      LC = LC + Ld322(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * (  - 32*s12**3*s13*s34**2 + 16*s12**3*s34**3 - 64*
     +    s12**2*s13**2*s34**2 + 32*s12**2*s13*s34**3 - 32*s12*s13**3*
     +    s34**2 - 32*s12*s13**2*s34**3 )

      LC = LC + Ld322(p4,p3,p12)*S14**(-1)*S23**(-1)*S123**(-1) * (  - 
     +    48*s12**2*s13*s34**2 - 96*s12*s13**2*s34**2 )

      LC = LC + Ld322(p4,p3,p12)*S14**(-1)*S24**(-1)*S123**(-1) * ( 16*
     +    s12**3*s34**2 - 32*s12**2*s13**2*s34 - 16*s12**2*s13*s23*s34
     +     - 16*s12**2*s13*s34**2 + 16*s12**2*s23**2*s34 - 16*s12**2*
     +    s34**3 - 32*s12*s13**3*s34 - 32*s12*s13**2*s34**2 + 32*s12*
     +    s13*s23*s34**2 + 32*s12*s13*s34**3 - 32*s12*s23**3*s34 - 64*
     +    s12*s23**2*s34**2 - 32*s12*s23*s34**3 )

      LC = LC + Ld322(p4,p3,p12)*S23**(-1)*S24**(-1)*S123**(-1) * (  - 
     +    32*s12**3*s34**2 + 80*s12**2*s13**2*s34 + 80*s12**2*s13*s14*
     +    s34 - 32*s12**2*s13*s34**2 - 48*s12*s13**3*s14 + 112*s12*
     +    s13**3*s34 - 48*s12*s13**2*s14**2 + 64*s12*s13**2*s14*s34 - 
     +    16*s12*s13**2*s34**2 - 48*s13**4*s14 + 32*s13**4*s34 - 48*
     +    s13**3*s14**2 - 16*s13**3*s14*s34 + 32*s13**3*s34**2 )

      LC = LC + Ld322(p4,p3,p12)*S24**(-1)*S123**(-1) * (  - 16*s12**2*
     +    s13*s34 + 16*s12**2*s14*s34 - 80*s12**2*s23*s34 - 80*s12**2*
     +    s34**2 + 48*s12*s13**3 + 48*s12*s13**2*s23 + 80*s12*s13**2*
     +    s34 - 48*s12*s13*s14**2 + 96*s12*s13*s14*s23 + 144*s12*s13*
     +    s14*s34 - 48*s12*s13*s23**2 - 96*s12*s13*s23*s34 - 80*s12*s13
     +    *s34**2 + 48*s12*s14**2*s23 - 48*s12*s23**3 - 80*s12*s23**2*
     +    s34 - 16*s12*s23*s34**2 - 48*s13**3*s14 - 96*s13**2*s14**2 + 
     +    96*s13**2*s14*s23 + 32*s13**2*s14*s34 - 32*s13**2*s23*s34 - 
     +    32*s13**2*s34**2 + 96*s13*s14*s23**2 + 96*s13*s14*s23*s34 + 
     +    32*s13*s23**2*s34 + 96*s14**2*s23**2 - 48*s14*s23**3 + 32*s14
     +    *s23**2*s34 + 32*s23**2*s34**2 )

      LC = LC + Ld344(p3,p4,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * ( 48*s12**3*s34**3 )

      LC = LC + Ld344(p3,p4,p12)*S13**(-1)*S24**(-1)*S124**(-1) * ( 64*
     +    s12**3*s34**2 - 112*s12**2*s14*s23*s34 - 96*s12**2*s14*s34**2
     +     + 64*s12**2*s23**2*s34 + 176*s12**2*s23*s34**2 + 96*s12**2*
     +    s34**3 + 48*s12*s14**2*s23**2 + 48*s12*s14**2*s23*s34 - 48*
     +    s12*s14*s23**3 - 208*s12*s14*s23**2*s34 - 144*s12*s14*s23*
     +    s34**2 + 64*s12*s23**3*s34 + 112*s12*s23**2*s34**2 + 48*s12*
     +    s23*s34**3 + 48*s14**2*s23**3 + 48*s14**2*s23**2*s34 - 48*s14
     +    *s23**4 - 96*s14*s23**3*s34 - 48*s14*s23**2*s34**2 )

      LC = LC + Ld344(p3,p4,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S124**(-1) * (  - 80*s12**3*s13*s34**2 + 112*s12**3*s34**3 + 160
     +    *s12**2*s13**2*s34**2 - 224*s12**2*s13*s34**3 + 48*s12**2*
     +    s34**4 )

      LC = LC + Ld344(p3,p4,p12)*S14**(-1)*S23**(-1)*S124**(-1) * ( 96*
     +    s12**2*s13**2*s34 - 240*s12**2*s13*s34**2 + 48*s12**2*s34**3
     +     - 144*s12*s13**3*s34 + 144*s12*s13**2*s24*s34 + 288*s12*
     +    s13**2*s34**2 - 96*s12*s13*s24*s34**2 - 96*s12*s13*s34**3 - 
     +    48*s13**3*s24*s34 + 48*s13**2*s24**2*s34 + 48*s13**2*s24*
     +    s34**2 )

      LC = LC + Ld344(p3,p4,p12)*S14**(-1)*S24**(-1)*S124**(-1) * ( 64*
     +    s12**3*s34**2 + 16*s12**2*s13**2*s34 - 16*s12**2*s13*s23*s34
     +     - 144*s12**2*s13*s34**2 + 64*s12**2*s23**2*s34 + 176*s12**2*
     +    s23*s34**2 + 160*s12**2*s34**3 )

      LC = LC + Ld344(p3,p4,p12)*S23**(-1)*S24**(-1)*S124**(-1) * (  - 
     +    80*s12**3*s34**2 + 128*s12**2*s13**2*s34 + 128*s12**2*s13*s14
     +    *s34 + 144*s12**2*s13*s34**2 - 192*s12**2*s34**3 - 48*s12*
     +    s13**3*s14 - 112*s12*s13**3*s34 - 48*s12*s13**2*s14**2 - 208*
     +    s12*s13**2*s14*s34 + 368*s12*s13**2*s34**2 - 48*s12*s13*
     +    s14**2*s34 + 288*s12*s13*s14*s34**2 + 48*s12*s13*s34**3 - 48*
     +    s13**4*s14 - 48*s13**3*s14**2 - 144*s13**3*s14*s34 - 96*
     +    s13**2*s14**2*s34 - 96*s13**2*s14*s34**2 )

      LC = LC + Ld344(p3,p4,p12)*S23**(-1)*S124**(-1) * ( 96*s12**2*s13
     +    *s34 - 96*s12**2*s34**2 + 48*s12*s13*s14*s34 + 48*s12*s13*s24
     +    *s34 + 192*s12*s13*s34**2 - 96*s13**3*s34 - 48*s13**2*s14*s34
     +     + 48*s13**2*s24*s34 )

      LC = LC + Ld344(p3,p4,p12)*S24**(-1)*S124**(-1) * ( 32*s12**2*s13
     +    *s34 + 16*s12**2*s14*s34 - 128*s12**2*s23*s34 - 352*s12**2*
     +    s34**2 + 48*s12*s13**3 + 48*s12*s13**2*s23 + 160*s12*s13**2*
     +    s34 - 48*s12*s13*s14**2 + 96*s12*s13*s14*s23 + 144*s12*s13*
     +    s14*s34 - 48*s12*s13*s23**2 - 96*s12*s13*s23*s34 + 80*s12*s13
     +    *s34**2 + 48*s12*s14**2*s23 + 96*s12*s14*s34**2 - 48*s12*
     +    s23**3 - 160*s12*s23**2*s34 - 272*s12*s23*s34**2 - 144*s12*
     +    s34**3 - 48*s13**3*s14 - 96*s13**2*s14**2 + 96*s13**2*s14*s23
     +     - 48*s13*s14**2*s34 + 96*s13*s14*s23**2 + 192*s13*s14*s23*
     +    s34 + 48*s13*s14*s34**2 + 96*s14**2*s23**2 + 48*s14**2*s23*
     +    s34 - 48*s14*s23**3 + 48*s14*s23*s34**2 )

      LC = LC + Ld344(p4,p3,p12)*S13**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * (  - 80*s12**3*s14*s34**2 + 112*s12**3*s34**3 + 160
     +    *s12**2*s14**2*s34**2 - 224*s12**2*s14*s34**3 + 48*s12**2*
     +    s34**4 )

      LC = LC + Ld344(p4,p3,p12)*S13**(-1)*S23**(-1)*S123**(-1) * ( 64*
     +    s12**3*s34**2 + 16*s12**2*s14**2*s34 - 16*s12**2*s14*s24*s34
     +     - 144*s12**2*s14*s34**2 + 64*s12**2*s24**2*s34 + 176*s12**2*
     +    s24*s34**2 + 160*s12**2*s34**3 )

      LC = LC + Ld344(p4,p3,p12)*S13**(-1)*S24**(-1)*S123**(-1) * ( 96*
     +    s12**2*s14**2*s34 - 240*s12**2*s14*s34**2 + 48*s12**2*s34**3
     +     - 144*s12*s14**3*s34 + 144*s12*s14**2*s23*s34 + 288*s12*
     +    s14**2*s34**2 - 96*s12*s14*s23*s34**2 - 96*s12*s14*s34**3 - 
     +    48*s14**3*s23*s34 + 48*s14**2*s23**2*s34 + 48*s14**2*s23*
     +    s34**2 )

      LC = LC + Ld344(p4,p3,p12)*S14**(-1)*S23**(-1)*S24**(-1)*
     + S123**(-1) * ( 48*s12**3*s34**3 )

      LC = LC + Ld344(p4,p3,p12)*S14**(-1)*S23**(-1)*S123**(-1) * ( 64*
     +    s12**3*s34**2 - 112*s12**2*s13*s24*s34 - 96*s12**2*s13*s34**2
     +     + 64*s12**2*s24**2*s34 + 176*s12**2*s24*s34**2 + 96*s12**2*
     +    s34**3 + 48*s12*s13**2*s24**2 + 48*s12*s13**2*s24*s34 - 48*
     +    s12*s13*s24**3 - 208*s12*s13*s24**2*s34 - 144*s12*s13*s24*
     +    s34**2 + 64*s12*s24**3*s34 + 112*s12*s24**2*s34**2 + 48*s12*
     +    s24*s34**3 + 48*s13**2*s24**3 + 48*s13**2*s24**2*s34 - 48*s13
     +    *s24**4 - 96*s13*s24**3*s34 - 48*s13*s24**2*s34**2 )

      LC = LC + Ld344(p4,p3,p12)*S23**(-1)*S24**(-1)*S123**(-1) * (  - 
     +    80*s12**3*s34**2 + 128*s12**2*s13*s14*s34 + 128*s12**2*s14**2
     +    *s34 + 144*s12**2*s14*s34**2 - 192*s12**2*s34**3 - 48*s12*
     +    s13**2*s14**2 - 48*s12*s13**2*s14*s34 - 48*s12*s13*s14**3 - 
     +    208*s12*s13*s14**2*s34 + 288*s12*s13*s14*s34**2 - 112*s12*
     +    s14**3*s34 + 368*s12*s14**2*s34**2 + 48*s12*s14*s34**3 - 48*
     +    s13**2*s14**3 - 96*s13**2*s14**2*s34 - 48*s13*s14**4 - 144*
     +    s13*s14**3*s34 - 96*s13*s14**2*s34**2 )

      LC = LC + Ld344(p4,p3,p12)*S23**(-1)*S123**(-1) * ( 16*s12**2*s13
     +    *s34 + 32*s12**2*s14*s34 - 128*s12**2*s24*s34 - 352*s12**2*
     +    s34**2 - 48*s12*s13**2*s14 + 48*s12*s13**2*s24 + 96*s12*s13*
     +    s14*s24 + 144*s12*s13*s14*s34 + 96*s12*s13*s34**2 + 48*s12*
     +    s14**3 + 48*s12*s14**2*s24 + 160*s12*s14**2*s34 - 48*s12*s14*
     +    s24**2 - 96*s12*s14*s24*s34 + 80*s12*s14*s34**2 - 48*s12*
     +    s24**3 - 160*s12*s24**2*s34 - 272*s12*s24*s34**2 - 144*s12*
     +    s34**3 - 96*s13**2*s14**2 - 48*s13**2*s14*s34 + 96*s13**2*
     +    s24**2 + 48*s13**2*s24*s34 - 48*s13*s14**3 + 96*s13*s14**2*
     +    s24 + 96*s13*s14*s24**2 + 192*s13*s14*s24*s34 + 48*s13*s14*
     +    s34**2 - 48*s13*s24**3 + 48*s13*s24*s34**2 )

      LC = LC + Ld344(p4,p3,p12)*S24**(-1)*S123**(-1) * ( 96*s12**2*s14
     +    *s34 - 96*s12**2*s34**2 + 48*s12*s13*s14*s34 + 48*s12*s14*s23
     +    *s34 + 192*s12*s14*s34**2 - 48*s13*s14**2*s34 - 96*s14**3*s34
     +     + 48*s14**2*s23*s34 )

      LCh=-LC/s134/s234
      
      return
      end
      
      function LCi(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      LC=0d0

      LC = LC + Le1(p1,p2,p3,p4)*S13**(-1)*S23**(-1) * (  - 8*s12**3*
     +    s14*s24 - 8*s12**3*s14*s34 - 8*s12**3*s24**2 - 16*s12**3*s24*
     +    s34 - 8*s12**3*s34**2 + 8*s12**2*s14**2*s24 + 8*s12**2*s14**2
     +    *s34 + 8*s12**2*s14*s24**2 + 24*s12**2*s14*s24*s34 + 16*
     +    s12**2*s14*s34**2 + 8*s12**2*s24**2*s34 + 16*s12**2*s24*
     +    s34**2 + 8*s12**2*s34**3 )

      LC = LC + Le1(p1,p2,p3,p4)*S13**(-1)*S24**(-1) * (  - 24*s12**4*
     +    s34 + 24*s12**3*s14*s23 - 48*s12**3*s14*s34 - 24*s12**3*s23*
     +    s34 - 24*s12**3*s34**2 + 48*s12**2*s14**2*s23 + 24*s12**2*s14
     +    *s23**2 + 16*s12**2*s14*s23*s34 - 8*s12**2*s23*s34**2 + 8*s12
     +    *s14**2*s23**2 + 8*s12*s14*s23**2*s34 + 8*s12*s14*s34**3 + 8*
     +    s12*s34**4 - 8*s14**2*s23*s34**2 - 8*s14*s23*s34**3 )

      LC = LC + Le1(p1,p2,p3,p4)*S13**(-1) * (  - 8*s12**4 - 16*s12**3*
     +    s14 - 8*s12**3*s23 - 16*s12**3*s24 - 24*s12**3*s34 + 32*
     +    s12**2*s14**2 + 40*s12**2*s14*s23 + 32*s12**2*s14*s24 + 64*
     +    s12**2*s14*s34 + 8*s12**2*s23*s34 + 16*s12**2*s24*s34 + 24*
     +    s12**2*s34**2 + 8*s12*s14**2*s34 + 16*s12*s14*s23*s34 + 8*s12
     +    *s14*s24*s34 + 24*s12*s14*s34**2 + 8*s12*s23*s34**2 + 8*s12*
     +    s24*s34**2 + 16*s12*s34**3 )

      LC = LC + Le1(p1,p2,p3,p4)*S14**(-1)*S24**(-1) * (  - 16*s12**4*
     +    s34 - 48*s12**3*s13*s34 - 56*s12**2*s13**2*s34 - 32*s12*
     +    s13**3*s34 - 8*s13**4*s34 )

      LC = LC + Le1(p1,p2,p3,p4)*S23**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s13*s34**2 - 8*s12**2*s14*s34**2 - 8*s12**2*s34**3 - 16*s12*
     +    s13**2*s34**2 - 24*s12*s13*s14*s34**2 - 16*s12*s13*s34**3 - 8
     +    *s12*s14**2*s34**2 - 8*s12*s14*s34**3 - 8*s13**3*s34**2 - 16*
     +    s13**2*s14*s34**2 - 8*s13**2*s34**3 - 8*s13*s14**2*s34**2 - 8
     +    *s13*s14*s34**3 )

      LC = LC + Le1(p1,p2,p3,p4)*S24**(-1) * ( 16*s12**3*s23 - 80*
     +    s12**3*s34 + 16*s12**2*s13*s23 - 120*s12**2*s13*s34 + 40*
     +    s12**2*s14*s23 - 88*s12**2*s14*s34 - 48*s12**2*s23*s34 - 40*
     +    s12**2*s34**2 + 8*s12*s13**2*s23 - 72*s12*s13**2*s34 + 16*s12
     +    *s13*s14*s23 - 56*s12*s13*s14*s34 - 40*s12*s13*s23*s34 - 40*
     +    s12*s13*s34**2 + 8*s12*s14**2*s23 - 16*s12*s14**2*s34 + 8*s12
     +    *s14*s23**2 - 40*s12*s14*s23*s34 - 48*s12*s14*s34**2 - 24*s12
     +    *s23*s34**2 - 24*s12*s34**3 - 16*s13**3*s34 - 8*s13**2*s14*
     +    s34 - 8*s13**2*s23*s34 - 16*s13**2*s34**2 - 8*s13*s14*s23*s34
     +     - 32*s13*s14*s34**2 - 8*s13*s23*s34**2 - 16*s13*s34**3 - 16*
     +    s14**2*s34**2 - 16*s14*s23*s34**2 - 16*s14*s34**3 - 8*s23*
     +    s34**3 )

      LC = LC + Le1(p1,p2,p4,p3)*S13**(-1)*S23**(-1) * (  - 16*s12**4*
     +    s34 - 48*s12**3*s14*s34 - 56*s12**2*s14**2*s34 - 32*s12*
     +    s14**3*s34 - 8*s14**4*s34 )

      LC = LC + Le1(p1,p2,p4,p3)*S14**(-1)*S23**(-1) * (  - 24*s12**4*
     +    s34 + 24*s12**3*s13*s24 - 48*s12**3*s13*s34 - 24*s12**3*s24*
     +    s34 - 24*s12**3*s34**2 + 48*s12**2*s13**2*s24 + 24*s12**2*s13
     +    *s24**2 + 16*s12**2*s13*s24*s34 - 8*s12**2*s24*s34**2 + 8*s12
     +    *s13**2*s24**2 + 8*s12*s13*s24**2*s34 + 8*s12*s13*s34**3 + 8*
     +    s12*s34**4 - 8*s13**2*s24*s34**2 - 8*s13*s24*s34**3 )

      LC = LC + Le1(p1,p2,p4,p3)*S14**(-1)*S24**(-1) * (  - 8*s12**3*
     +    s13*s23 - 8*s12**3*s13*s34 - 8*s12**3*s23**2 - 16*s12**3*s23*
     +    s34 - 8*s12**3*s34**2 + 8*s12**2*s13**2*s23 + 8*s12**2*s13**2
     +    *s34 + 8*s12**2*s13*s23**2 + 24*s12**2*s13*s23*s34 + 16*
     +    s12**2*s13*s34**2 + 8*s12**2*s23**2*s34 + 16*s12**2*s23*
     +    s34**2 + 8*s12**2*s34**3 )

      LC = LC + Le1(p1,p2,p4,p3)*S14**(-1) * (  - 8*s12**4 - 16*s12**3*
     +    s13 - 16*s12**3*s23 - 8*s12**3*s24 - 24*s12**3*s34 + 32*
     +    s12**2*s13**2 + 32*s12**2*s13*s23 + 40*s12**2*s13*s24 + 64*
     +    s12**2*s13*s34 + 16*s12**2*s23*s34 + 8*s12**2*s24*s34 + 24*
     +    s12**2*s34**2 + 8*s12*s13**2*s34 + 8*s12*s13*s23*s34 + 16*s12
     +    *s13*s24*s34 + 24*s12*s13*s34**2 + 8*s12*s23*s34**2 + 8*s12*
     +    s24*s34**2 + 16*s12*s34**3 )

      LC = LC + Le1(p1,p2,p4,p3)*S23**(-1)*S24**(-1) * (  - 8*s12**2*
     +    s13*s34**2 - 8*s12**2*s14*s34**2 - 8*s12**2*s34**3 - 8*s12*
     +    s13**2*s34**2 - 24*s12*s13*s14*s34**2 - 8*s12*s13*s34**3 - 16
     +    *s12*s14**2*s34**2 - 16*s12*s14*s34**3 - 8*s13**2*s14*s34**2
     +     - 16*s13*s14**2*s34**2 - 8*s13*s14*s34**3 - 8*s14**3*s34**2
     +     - 8*s14**2*s34**3 )

      LC = LC + Le1(p1,p2,p4,p3)*S23**(-1) * ( 16*s12**3*s24 - 80*
     +    s12**3*s34 + 40*s12**2*s13*s24 - 88*s12**2*s13*s34 + 16*
     +    s12**2*s14*s24 - 120*s12**2*s14*s34 - 48*s12**2*s24*s34 - 40*
     +    s12**2*s34**2 + 8*s12*s13**2*s24 - 16*s12*s13**2*s34 + 16*s12
     +    *s13*s14*s24 - 56*s12*s13*s14*s34 + 8*s12*s13*s24**2 - 40*s12
     +    *s13*s24*s34 - 48*s12*s13*s34**2 + 8*s12*s14**2*s24 - 72*s12*
     +    s14**2*s34 - 40*s12*s14*s24*s34 - 40*s12*s14*s34**2 - 24*s12*
     +    s24*s34**2 - 24*s12*s34**3 - 16*s13**2*s34**2 - 8*s13*s14**2*
     +    s34 - 8*s13*s14*s24*s34 - 32*s13*s14*s34**2 - 16*s13*s24*
     +    s34**2 - 16*s13*s34**3 - 16*s14**3*s34 - 8*s14**2*s24*s34 - 
     +    16*s14**2*s34**2 - 8*s14*s24*s34**2 - 16*s14*s34**3 - 8*s24*
     +    s34**3 )

      LC = LC + Le1(p1,p3,p2,p4)*S13**(-1)*S14**(-1)*S23**(-1) * (  - 
     +    16*s12**4*s24**2 - 32*s12**4*s24*s34 - 16*s12**4*s34**2 )

      LC = LC + Le1(p1,p3,p2,p4)*S13**(-1)*S14**(-1) * (  - 16*s12**4*
     +    s24 - 16*s12**4*s34 - 16*s12**3*s23*s24 - 16*s12**3*s23*s34
     +     - 16*s12**3*s24**2 - 32*s12**3*s24*s34 - 16*s12**3*s34**2 - 
     +    8*s12**2*s23**2*s24 - 8*s12**2*s23**2*s34 - 8*s12**2*s23*
     +    s24**2 - 16*s12**2*s23*s24*s34 - 8*s12**2*s23*s34**2 )

      LC = LC + Le1(p1,p3,p2,p4)*S13**(-1)*S23**(-1) * (  - 16*s12**4*
     +    s24 - 16*s12**4*s34 - 16*s12**3*s14*s24 - 16*s12**3*s14*s34
     +     - 16*s12**3*s24*s34 - 16*s12**3*s34**2 - 8*s12**2*s14**2*s24
     +     - 8*s12**2*s14**2*s34 + 8*s12**2*s14*s24**2 - 8*s12**2*s14*
     +    s34**2 + 8*s12**2*s24**2*s34 + 8*s12**2*s24*s34**2 )

      LC = LC + Le1(p1,p3,p2,p4)*S13**(-1) * (  - 16*s12**4 - 16*s12**3
     +    *s14 - 16*s12**3*s23 - 16*s12**3*s24 - 32*s12**3*s34 - 8*
     +    s12**2*s14**2 - 32*s12**2*s14*s23 - 24*s12**2*s14*s24 - 40*
     +    s12**2*s14*s34 - 8*s12**2*s23**2 - 8*s12**2*s23*s24 - 40*
     +    s12**2*s23*s34 - 24*s12**2*s24*s34 - 32*s12**2*s34**2 - 16*
     +    s12*s14**2*s23 - 16*s12*s14**2*s24 - 16*s12*s14**2*s34 - 16*
     +    s12*s14*s23**2 - 16*s12*s14*s23*s24 - 40*s12*s14*s23*s34 - 24
     +    *s12*s14*s24*s34 - 24*s12*s14*s34**2 - 16*s12*s23**2*s34 - 16
     +    *s12*s23*s24*s34 - 24*s12*s23*s34**2 - 8*s12*s24*s34**2 - 8*
     +    s12*s34**3 )

      LC = LC + Le1(p1,p3,p2,p4)*S14**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s13*s34**2 + 16*s12**3*s34**3 + 32*s12**2*s13**2*
     +    s34**2 + 32*s12**2*s13*s34**3 + 24*s12*s13**3*s34**2 + 24*s12
     +    *s13**2*s34**3 + 8*s13**4*s34**2 + 8*s13**3*s34**3 )

      LC = LC + Le1(p1,p3,p2,p4)*S14**(-1)*S23**(-1) * (  - 16*s12**4*
     +    s24 - 16*s12**4*s34 - 32*s12**3*s13*s24 - 16*s12**3*s13*s34
     +     - 32*s12**3*s24**2 - 48*s12**3*s24*s34 - 24*s12**2*s13**2*
     +    s24 + 8*s12**2*s13**2*s34 - 24*s12**2*s13*s24**2 - 16*s12**2*
     +    s13*s24*s34 + 40*s12**2*s13*s34**2 - 8*s12*s13**3*s24 + 16*
     +    s12*s13**3*s34 - 8*s12*s13**2*s24**2 + 8*s12*s13**2*s24*s34
     +     + 40*s12*s13**2*s34**2 + 8*s13**4*s34 + 8*s13**3*s24*s34 + 
     +    16*s13**3*s34**2 )

      LC = LC + Le1(p1,p3,p2,p4)*S14**(-1)*S24**(-1) * ( 16*s12**3*s13*
     +    s34 + 16*s12**3*s34**2 + 32*s12**2*s13**2*s34 + 16*s12**2*s13
     +    *s23*s34 + 48*s12**2*s13*s34**2 + 16*s12**2*s23*s34**2 + 16*
     +    s12**2*s34**3 + 24*s12*s13**3*s34 + 16*s12*s13**2*s23*s34 + 
     +    40*s12*s13**2*s34**2 + 8*s12*s13*s23**2*s34 + 24*s12*s13*s23*
     +    s34**2 + 16*s12*s13*s34**3 + 8*s12*s23**2*s34**2 + 8*s12*s23*
     +    s34**3 + 8*s13**4*s34 + 8*s13**3*s34**2 + 8*s13**2*s23**2*s34
     +     + 8*s13**2*s23*s34**2 + 8*s13*s23**2*s34**2 + 8*s13*s23*
     +    s34**3 )

      LC = LC + Le1(p1,p3,p2,p4)*S14**(-1) * (  - 16*s12**4 - 32*s12**3
     +    *s13 - 16*s12**3*s23 - 48*s12**3*s24 - 32*s12**3*s34 - 24*
     +    s12**2*s13**2 - 16*s12**2*s13*s23 - 40*s12**2*s13*s24 + 8*
     +    s12**2*s13*s34 - 8*s12**2*s23**2 - 24*s12**2*s23*s24 - 8*
     +    s12**2*s23*s34 - 16*s12**2*s24**2 - 16*s12**2*s24*s34 + 16*
     +    s12**2*s34**2 - 8*s12*s13**3 - 8*s12*s13**2*s24 + 32*s12*
     +    s13**2*s34 - 8*s12*s13*s23**2 - 8*s12*s13*s23*s24 + 16*s12*
     +    s13*s23*s34 + 16*s12*s13*s24*s34 + 32*s12*s13*s34**2 - 8*s12*
     +    s23**2*s24 - 8*s12*s23*s24**2 - 8*s12*s23*s24*s34 + 8*s12*s23
     +    *s34**2 + 8*s13**3*s34 + 8*s13**2*s23*s34 + 8*s13*s23**2*s34
     +     + 8*s13*s23*s24*s34 + 16*s13*s23*s34**2 )

      LC = LC + Le1(p1,p3,p2,p4)*S23**(-1)*S24**(-1) * ( 16*s12**3*
     +    s34**2 + 48*s12**2*s13*s34**2 + 16*s12**2*s14*s34**2 + 16*
     +    s12**2*s34**3 + 56*s12*s13**2*s34**2 + 40*s12*s13*s14*s34**2
     +     + 32*s12*s13*s34**3 + 8*s12*s14**2*s34**2 + 8*s12*s14*s34**3
     +     + 24*s13**3*s34**2 + 24*s13**2*s14*s34**2 + 16*s13**2*s34**3
     +     + 8*s13*s14**2*s34**2 + 8*s13*s14*s34**3 )

      LC = LC + Le1(p1,p3,p2,p4)*S23**(-1) * (  - 48*s12**3*s24 - 32*
     +    s12**3*s34 - 48*s12**2*s13*s24 - 8*s12**2*s13*s34 - 32*s12**2
     +    *s14*s24 - 24*s12**2*s14*s34 + 8*s12**2*s24**2 - 16*s12**2*
     +    s24*s34 - 16*s12**2*s34**2 - 16*s12*s13**2*s24 + 24*s12*
     +    s13**2*s34 - 8*s12*s13*s14*s24 + 8*s12*s13*s14*s34 + 16*s12*
     +    s13*s24**2 + 16*s12*s14*s24**2 + 8*s12*s14*s24*s34 - 8*s12*
     +    s14*s34**2 + 16*s12*s24**2*s34 + 8*s12*s24*s34**2 - 8*s12*
     +    s34**3 + 16*s13**3*s34 + 8*s13**2*s14*s34 - 16*s13**2*s24*s34
     +     - 8*s13**2*s34**2 - 16*s13*s14*s24*s34 - 16*s13*s14*s34**2
     +     - 16*s13*s24*s34**2 - 16*s13*s34**3 )

      LC = LC + Le1(p1,p3,p2,p4)*S24**(-1) * ( 16*s12**3*s34 + 48*
     +    s12**2*s13*s34 + 16*s12**2*s14*s34 + 16*s12**2*s23*s34 + 32*
     +    s12**2*s34**2 + 40*s12*s13**2*s34 + 24*s12*s13*s14*s34 + 48*
     +    s12*s13*s23*s34 + 64*s12*s13*s34**2 + 8*s12*s14**2*s34 + 32*
     +    s12*s14*s23*s34 + 40*s12*s14*s34**2 + 8*s12*s23**2*s34 + 40*
     +    s12*s23*s34**2 + 32*s12*s34**3 + 8*s13**3*s34 - 8*s13**2*s14*
     +    s34 + 16*s13**2*s23*s34 + 16*s13**2*s34**2 - 8*s13*s14**2*s34
     +     + 32*s13*s14*s23*s34 + 24*s13*s14*s34**2 + 24*s13*s23**2*s34
     +     + 48*s13*s23*s34**2 + 24*s13*s34**3 + 16*s14**2*s23*s34 + 16
     +    *s14**2*s34**2 + 16*s14*s23**2*s34 + 40*s14*s23*s34**2 + 24*
     +    s14*s34**3 + 16*s23**2*s34**2 + 24*s23*s34**3 + 8*s34**4 )

      LC = LC + Le1(p1,p3,p2,p4) * (  - 48*s12**3 - 40*s12**2*s13 - 24*
     +    s12**2*s14 - 48*s12**2*s23 - 40*s12**2*s24 - 48*s12**2*s34 - 
     +    8*s12*s13**2 + 8*s12*s13*s14 - 16*s12*s13*s23 + 24*s12*s13*
     +    s34 + 8*s12*s14**2 - 32*s12*s14*s23 - 16*s12*s14*s24 - 24*s12
     +    *s23**2 - 24*s12*s23*s24 - 40*s12*s23*s34 - 8*s12*s24*s34 + 
     +    16*s13*s14*s34 + 24*s13*s23*s34 + 8*s13*s34**2 + 16*s14**2*
     +    s34 + 16*s14*s23*s34 + 24*s14*s34**2 + 16*s23*s34**2 + 8*
     +    s34**3 )

      LC = LC + Le1(p1,p3,p4,p2)*S13**(-1)*S14**(-1)*S23**(-1) * ( 32*
     +    s12**4*s34**2 - 32*s12**3*s24*s34**2 + 72*s12**3*s34**3 + 8*
     +    s12**2*s24**2*s34**2 - 32*s12**2*s24*s34**3 + 24*s12**2*
     +    s34**4 )

      LC = LC + Le1(p1,p3,p4,p2)*S13**(-1)*S14**(-1) * ( 24*s12**3*
     +    s34**2 + 8*s12**2*s23*s34**2 - 8*s12**2*s24*s34**2 + 24*
     +    s12**2*s34**3 )

      LC = LC + Le1(p1,p3,p4,p2)*S13**(-1)*S23**(-1) * ( 16*s12**4*s34
     +     - 16*s12**3*s14*s24 + 32*s12**3*s14*s34 - 48*s12**3*s24*s34
     +     + 80*s12**3*s34**2 - 32*s12**2*s14**2*s24 + 24*s12**2*s14**2
     +    *s34 + 16*s12**2*s14*s24**2 - 112*s12**2*s14*s24*s34 + 72*
     +    s12**2*s14*s34**2 + 40*s12**2*s24**2*s34 - 136*s12**2*s24*
     +    s34**2 + 72*s12**2*s34**3 - 24*s12*s14**3*s24 + 8*s12*s14**3*
     +    s34 + 32*s12*s14**2*s24**2 - 88*s12*s14**2*s24*s34 + 24*s12*
     +    s14**2*s34**2 - 8*s12*s14*s24**3 + 72*s12*s14*s24**2*s34 - 
     +    104*s12*s14*s24*s34**2 + 24*s12*s14*s34**3 - 8*s12*s24**3*s34
     +     + 40*s12*s24**2*s34**2 - 40*s12*s24*s34**3 + 8*s12*s34**4 - 
     +    8*s14**4*s24 + 16*s14**3*s24**2 - 24*s14**3*s24*s34 - 8*
     +    s14**2*s24**3 + 32*s14**2*s24**2*s34 - 24*s14**2*s24*s34**2
     +     - 8*s14*s24**3*s34 + 16*s14*s24**2*s34**2 - 8*s14*s24*s34**3
     +     )

      LC = LC + Le1(p1,p3,p4,p2)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 
     +    32*s12**4*s34**2 + 32*s12**3*s13*s34**2 - 72*s12**3*s34**3 - 
     +    8*s12**2*s13**2*s34**2 + 32*s12**2*s13*s34**3 - 24*s12**2*
     +    s34**4 )

      LC = LC + Le1(p1,p3,p4,p2)*S14**(-1)*S23**(-1) * (  - 16*s12**3*
     +    s13*s34 + 16*s12**3*s24*s34 + 48*s12**2*s13**2*s24 - 48*
     +    s12**2*s13**2*s34 - 48*s12**2*s13*s24**2 + 48*s12**2*s24**2*
     +    s34 + 16*s12*s13**3*s24 + 64*s12*s13**2*s24*s34 - 32*s12*
     +    s13**2*s34**2 - 16*s12*s13*s24**3 - 64*s12*s13*s24**2*s34 + 
     +    24*s12*s13*s34**3 + 32*s12*s24**2*s34**2 - 24*s12*s24*s34**3
     +     + 8*s13**4*s24 + 8*s13**3*s24**2 - 8*s13**2*s24**3 - 8*s13*
     +    s24**4 )

      LC = LC + Le1(p1,p3,p4,p2)*S14**(-1)*S24**(-1) * (  - 16*s12**4*
     +    s34 + 16*s12**3*s13*s23 + 48*s12**3*s13*s34 - 32*s12**3*s23*
     +    s34 - 80*s12**3*s34**2 - 16*s12**2*s13**2*s23 - 40*s12**2*
     +    s13**2*s34 + 32*s12**2*s13*s23**2 + 112*s12**2*s13*s23*s34 + 
     +    136*s12**2*s13*s34**2 - 24*s12**2*s23**2*s34 - 72*s12**2*s23*
     +    s34**2 - 72*s12**2*s34**3 + 8*s12*s13**3*s23 + 8*s12*s13**3*
     +    s34 - 32*s12*s13**2*s23**2 - 72*s12*s13**2*s23*s34 - 40*s12*
     +    s13**2*s34**2 + 24*s12*s13*s23**3 + 88*s12*s13*s23**2*s34 + 
     +    104*s12*s13*s23*s34**2 + 40*s12*s13*s34**3 - 8*s12*s23**3*s34
     +     - 24*s12*s23**2*s34**2 - 24*s12*s23*s34**3 - 8*s12*s34**4 + 
     +    8*s13**3*s23**2 + 8*s13**3*s23*s34 - 16*s13**2*s23**3 - 32*
     +    s13**2*s23**2*s34 - 16*s13**2*s23*s34**2 + 8*s13*s23**4 + 24*
     +    s13*s23**3*s34 + 24*s13*s23**2*s34**2 + 8*s13*s23*s34**3 )

      LC = LC + Le1(p1,p3,p4,p2)*S14**(-1)*S34**(-1) * ( 32*s12*s13**2*
     +    s23**2 + 64*s12*s13**2*s23*s24 + 32*s12*s13**2*s24**2 + 32*
     +    s13**2*s23**3 + 96*s13**2*s23**2*s24 + 96*s13**2*s23*s24**2
     +     + 32*s13**2*s24**3 )

      LC = LC + Le1(p1,p3,p4,p2)*S14**(-1) * (  - 48*s12**3*s34 - 96*
     +    s12**2*s13*s24 - 16*s12**2*s13*s34 - 40*s12**2*s23*s34 + 40*
     +    s12**2*s24*s34 - 96*s12**2*s34**2 + 32*s12*s13**2*s23 + 32*
     +    s12*s13**2*s24 - 16*s12*s13**2*s34 + 8*s12*s13*s23**2 - 96*
     +    s12*s13*s23*s24 + 48*s12*s13*s23*s34 - 104*s12*s13*s24**2 - 
     +    128*s12*s13*s24*s34 + 56*s12*s13*s34**2 - 16*s12*s23**2*s34
     +     - 40*s12*s23*s34**2 + 8*s12*s24*s34**2 - 32*s12*s34**3 + 8*
     +    s13**3*s23 - 8*s13**3*s24 + 32*s13**2*s23**2 + 96*s13**2*s23*
     +    s24 - 16*s13**2*s23*s34 + 32*s13**2*s24**2 - 16*s13**2*s34**2
     +     + 16*s13*s23**3 + 8*s13*s23**2*s24 + 40*s13*s23**2*s34 - 8*
     +    s13*s23*s24**2 + 16*s13*s23*s24*s34 + 32*s13*s23*s34**2 - 16*
     +    s13*s24**3 - 8*s13*s24**2*s34 + 8*s13*s24*s34**2 + 8*s13*
     +    s34**3 )

      LC = LC + Le1(p1,p3,p4,p2)*S23**(-1)*S24**(-1) * (  - 24*s12**3*
     +    s34**2 + 8*s12**2*s13*s34**2 - 8*s12**2*s14*s34**2 - 24*
     +    s12**2*s34**3 )

      LC = LC + Le1(p1,p3,p4,p2)*S23**(-1)*S34**(-1) * (  - 32*s12*
     +    s13**2*s24**2 - 64*s12*s13*s14*s24**2 - 32*s12*s14**2*s24**2
     +     - 32*s13**3*s24**2 - 96*s13**2*s14*s24**2 - 96*s13*s14**2*
     +    s24**2 - 32*s14**3*s24**2 )

      LC = LC + Le1(p1,p3,p4,p2)*S23**(-1) * ( 48*s12**3*s34 + 96*
     +    s12**2*s13*s24 - 40*s12**2*s13*s34 + 40*s12**2*s14*s34 + 16*
     +    s12**2*s24*s34 + 96*s12**2*s34**2 + 104*s12*s13**2*s24 + 96*
     +    s12*s13*s14*s24 - 32*s12*s13*s24**2 + 128*s12*s13*s24*s34 - 8
     +    *s12*s13*s34**2 - 8*s12*s14**2*s24 + 16*s12*s14**2*s34 - 32*
     +    s12*s14*s24**2 - 48*s12*s14*s24*s34 + 40*s12*s14*s34**2 + 16*
     +    s12*s24**2*s34 - 56*s12*s24*s34**2 + 32*s12*s34**3 + 16*
     +    s13**3*s24 + 8*s13**2*s14*s24 - 32*s13**2*s24**2 + 8*s13**2*
     +    s24*s34 - 8*s13*s14**2*s24 - 96*s13*s14*s24**2 - 16*s13*s14*
     +    s24*s34 + 8*s13*s24**3 - 8*s13*s24*s34**2 - 16*s14**3*s24 - 
     +    32*s14**2*s24**2 - 40*s14**2*s24*s34 - 8*s14*s24**3 + 16*s14*
     +    s24**2*s34 - 32*s14*s24*s34**2 + 16*s24**2*s34**2 - 8*s24*
     +    s34**3 )

      LC = LC + Le1(p1,p4,p2,p3)*S13**(-1)*S14**(-1)*S24**(-1) * (  - 
     +    16*s12**4*s23**2 - 32*s12**4*s23*s34 - 16*s12**4*s34**2 )

      LC = LC + Le1(p1,p4,p2,p3)*S13**(-1)*S14**(-1) * (  - 16*s12**4*
     +    s23 - 16*s12**4*s34 - 16*s12**3*s23**2 - 16*s12**3*s23*s24 - 
     +    32*s12**3*s23*s34 - 16*s12**3*s24*s34 - 16*s12**3*s34**2 - 8*
     +    s12**2*s23**2*s24 - 8*s12**2*s23*s24**2 - 16*s12**2*s23*s24*
     +    s34 - 8*s12**2*s24**2*s34 - 8*s12**2*s24*s34**2 )

      LC = LC + Le1(p1,p4,p2,p3)*S13**(-1)*S23**(-1)*S24**(-1) * ( 16*
     +    s12**3*s14*s34**2 + 16*s12**3*s34**3 + 32*s12**2*s14**2*
     +    s34**2 + 32*s12**2*s14*s34**3 + 24*s12*s14**3*s34**2 + 24*s12
     +    *s14**2*s34**3 + 8*s14**4*s34**2 + 8*s14**3*s34**3 )

      LC = LC + Le1(p1,p4,p2,p3)*S13**(-1)*S23**(-1) * ( 16*s12**3*s14*
     +    s34 + 16*s12**3*s34**2 + 32*s12**2*s14**2*s34 + 16*s12**2*s14
     +    *s24*s34 + 48*s12**2*s14*s34**2 + 16*s12**2*s24*s34**2 + 16*
     +    s12**2*s34**3 + 24*s12*s14**3*s34 + 16*s12*s14**2*s24*s34 + 
     +    40*s12*s14**2*s34**2 + 8*s12*s14*s24**2*s34 + 24*s12*s14*s24*
     +    s34**2 + 16*s12*s14*s34**3 + 8*s12*s24**2*s34**2 + 8*s12*s24*
     +    s34**3 + 8*s14**4*s34 + 8*s14**3*s34**2 + 8*s14**2*s24**2*s34
     +     + 8*s14**2*s24*s34**2 + 8*s14*s24**2*s34**2 + 8*s14*s24*
     +    s34**3 )

      LC = LC + Le1(p1,p4,p2,p3)*S13**(-1)*S24**(-1) * (  - 16*s12**4*
     +    s23 - 16*s12**4*s34 - 32*s12**3*s14*s23 - 16*s12**3*s14*s34
     +     - 32*s12**3*s23**2 - 48*s12**3*s23*s34 - 24*s12**2*s14**2*
     +    s23 + 8*s12**2*s14**2*s34 - 24*s12**2*s14*s23**2 - 16*s12**2*
     +    s14*s23*s34 + 40*s12**2*s14*s34**2 - 8*s12*s14**3*s23 + 16*
     +    s12*s14**3*s34 - 8*s12*s14**2*s23**2 + 8*s12*s14**2*s23*s34
     +     + 40*s12*s14**2*s34**2 + 8*s14**4*s34 + 8*s14**3*s23*s34 + 
     +    16*s14**3*s34**2 )

      LC = LC + Le1(p1,p4,p2,p3)*S13**(-1) * (  - 16*s12**4 - 32*s12**3
     +    *s14 - 48*s12**3*s23 - 16*s12**3*s24 - 32*s12**3*s34 - 24*
     +    s12**2*s14**2 - 40*s12**2*s14*s23 - 16*s12**2*s14*s24 + 8*
     +    s12**2*s14*s34 - 16*s12**2*s23**2 - 24*s12**2*s23*s24 - 16*
     +    s12**2*s23*s34 - 8*s12**2*s24**2 - 8*s12**2*s24*s34 + 16*
     +    s12**2*s34**2 - 8*s12*s14**3 - 8*s12*s14**2*s23 + 32*s12*
     +    s14**2*s34 - 8*s12*s14*s23*s24 + 16*s12*s14*s23*s34 - 8*s12*
     +    s14*s24**2 + 16*s12*s14*s24*s34 + 32*s12*s14*s34**2 - 8*s12*
     +    s23**2*s24 - 8*s12*s23*s24**2 - 8*s12*s23*s24*s34 + 8*s12*s24
     +    *s34**2 + 8*s14**3*s34 + 8*s14**2*s24*s34 + 8*s14*s23*s24*s34
     +     + 8*s14*s24**2*s34 + 16*s14*s24*s34**2 )

      LC = LC + Le1(p1,p4,p2,p3)*S14**(-1)*S24**(-1) * (  - 16*s12**4*
     +    s23 - 16*s12**4*s34 - 16*s12**3*s13*s23 - 16*s12**3*s13*s34
     +     - 16*s12**3*s23*s34 - 16*s12**3*s34**2 - 8*s12**2*s13**2*s23
     +     - 8*s12**2*s13**2*s34 + 8*s12**2*s13*s23**2 - 8*s12**2*s13*
     +    s34**2 + 8*s12**2*s23**2*s34 + 8*s12**2*s23*s34**2 )

      LC = LC + Le1(p1,p4,p2,p3)*S14**(-1) * (  - 16*s12**4 - 16*s12**3
     +    *s13 - 16*s12**3*s23 - 16*s12**3*s24 - 32*s12**3*s34 - 8*
     +    s12**2*s13**2 - 24*s12**2*s13*s23 - 32*s12**2*s13*s24 - 40*
     +    s12**2*s13*s34 - 8*s12**2*s23*s24 - 24*s12**2*s23*s34 - 8*
     +    s12**2*s24**2 - 40*s12**2*s24*s34 - 32*s12**2*s34**2 - 16*s12
     +    *s13**2*s23 - 16*s12*s13**2*s24 - 16*s12*s13**2*s34 - 16*s12*
     +    s13*s23*s24 - 24*s12*s13*s23*s34 - 16*s12*s13*s24**2 - 40*s12
     +    *s13*s24*s34 - 24*s12*s13*s34**2 - 16*s12*s23*s24*s34 - 8*s12
     +    *s23*s34**2 - 16*s12*s24**2*s34 - 24*s12*s24*s34**2 - 8*s12*
     +    s34**3 )

      LC = LC + Le1(p1,p4,p2,p3)*S23**(-1)*S24**(-1) * ( 16*s12**3*
     +    s34**2 + 16*s12**2*s13*s34**2 + 48*s12**2*s14*s34**2 + 16*
     +    s12**2*s34**3 + 8*s12*s13**2*s34**2 + 40*s12*s13*s14*s34**2
     +     + 8*s12*s13*s34**3 + 56*s12*s14**2*s34**2 + 32*s12*s14*
     +    s34**3 + 8*s13**2*s14*s34**2 + 24*s13*s14**2*s34**2 + 8*s13*
     +    s14*s34**3 + 24*s14**3*s34**2 + 16*s14**2*s34**3 )

      LC = LC + Le1(p1,p4,p2,p3)*S23**(-1) * ( 16*s12**3*s34 + 16*
     +    s12**2*s13*s34 + 48*s12**2*s14*s34 + 16*s12**2*s24*s34 + 32*
     +    s12**2*s34**2 + 8*s12*s13**2*s34 + 24*s12*s13*s14*s34 + 32*
     +    s12*s13*s24*s34 + 40*s12*s13*s34**2 + 40*s12*s14**2*s34 + 48*
     +    s12*s14*s24*s34 + 64*s12*s14*s34**2 + 8*s12*s24**2*s34 + 40*
     +    s12*s24*s34**2 + 32*s12*s34**3 - 8*s13**2*s14*s34 + 16*s13**2
     +    *s24*s34 + 16*s13**2*s34**2 - 8*s13*s14**2*s34 + 32*s13*s14*
     +    s24*s34 + 24*s13*s14*s34**2 + 16*s13*s24**2*s34 + 40*s13*s24*
     +    s34**2 + 24*s13*s34**3 + 8*s14**3*s34 + 16*s14**2*s24*s34 + 
     +    16*s14**2*s34**2 + 24*s14*s24**2*s34 + 48*s14*s24*s34**2 + 24
     +    *s14*s34**3 + 16*s24**2*s34**2 + 24*s24*s34**3 + 8*s34**4 )

      LC = LC + Le1(p1,p4,p2,p3)*S24**(-1) * (  - 48*s12**3*s23 - 32*
     +    s12**3*s34 - 32*s12**2*s13*s23 - 24*s12**2*s13*s34 - 48*
     +    s12**2*s14*s23 - 8*s12**2*s14*s34 + 8*s12**2*s23**2 - 16*
     +    s12**2*s23*s34 - 16*s12**2*s34**2 - 8*s12*s13*s14*s23 + 8*s12
     +    *s13*s14*s34 + 16*s12*s13*s23**2 + 8*s12*s13*s23*s34 - 8*s12*
     +    s13*s34**2 - 16*s12*s14**2*s23 + 24*s12*s14**2*s34 + 16*s12*
     +    s14*s23**2 + 16*s12*s23**2*s34 + 8*s12*s23*s34**2 - 8*s12*
     +    s34**3 + 8*s13*s14**2*s34 - 16*s13*s14*s23*s34 - 16*s13*s14*
     +    s34**2 + 16*s14**3*s34 - 16*s14**2*s23*s34 - 8*s14**2*s34**2
     +     - 16*s14*s23*s34**2 - 16*s14*s34**3 )

      LC = LC + Le1(p1,p4,p2,p3) * (  - 48*s12**3 - 24*s12**2*s13 - 40*
     +    s12**2*s14 - 40*s12**2*s23 - 48*s12**2*s24 - 48*s12**2*s34 + 
     +    8*s12*s13**2 + 8*s12*s13*s14 - 16*s12*s13*s23 - 32*s12*s13*
     +    s24 - 8*s12*s14**2 - 16*s12*s14*s24 + 24*s12*s14*s34 - 24*s12
     +    *s23*s24 - 8*s12*s23*s34 - 24*s12*s24**2 - 40*s12*s24*s34 + 
     +    16*s13**2*s34 + 16*s13*s14*s34 + 16*s13*s24*s34 + 24*s13*
     +    s34**2 + 24*s14*s24*s34 + 8*s14*s34**2 + 16*s24*s34**2 + 8*
     +    s34**3 )

      LC = LC + Le1(p1,p4,p3,p2)*S13**(-1)*S14**(-1)*S24**(-1) * ( 32*
     +    s12**4*s34**2 - 32*s12**3*s23*s34**2 + 72*s12**3*s34**3 + 8*
     +    s12**2*s23**2*s34**2 - 32*s12**2*s23*s34**3 + 24*s12**2*
     +    s34**4 )

      LC = LC + Le1(p1,p4,p3,p2)*S13**(-1)*S14**(-1) * ( 24*s12**3*
     +    s34**2 - 8*s12**2*s23*s34**2 + 8*s12**2*s24*s34**2 + 24*
     +    s12**2*s34**3 )

      LC = LC + Le1(p1,p4,p3,p2)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 
     +    32*s12**4*s34**2 + 32*s12**3*s14*s34**2 - 72*s12**3*s34**3 - 
     +    8*s12**2*s14**2*s34**2 + 32*s12**2*s14*s34**3 - 24*s12**2*
     +    s34**4 )

      LC = LC + Le1(p1,p4,p3,p2)*S13**(-1)*S23**(-1) * (  - 16*s12**4*
     +    s34 + 16*s12**3*s14*s24 + 48*s12**3*s14*s34 - 32*s12**3*s24*
     +    s34 - 80*s12**3*s34**2 - 16*s12**2*s14**2*s24 - 40*s12**2*
     +    s14**2*s34 + 32*s12**2*s14*s24**2 + 112*s12**2*s14*s24*s34 + 
     +    136*s12**2*s14*s34**2 - 24*s12**2*s24**2*s34 - 72*s12**2*s24*
     +    s34**2 - 72*s12**2*s34**3 + 8*s12*s14**3*s24 + 8*s12*s14**3*
     +    s34 - 32*s12*s14**2*s24**2 - 72*s12*s14**2*s24*s34 - 40*s12*
     +    s14**2*s34**2 + 24*s12*s14*s24**3 + 88*s12*s14*s24**2*s34 + 
     +    104*s12*s14*s24*s34**2 + 40*s12*s14*s34**3 - 8*s12*s24**3*s34
     +     - 24*s12*s24**2*s34**2 - 24*s12*s24*s34**3 - 8*s12*s34**4 + 
     +    8*s14**3*s24**2 + 8*s14**3*s24*s34 - 16*s14**2*s24**3 - 32*
     +    s14**2*s24**2*s34 - 16*s14**2*s24*s34**2 + 8*s14*s24**4 + 24*
     +    s14*s24**3*s34 + 24*s14*s24**2*s34**2 + 8*s14*s24*s34**3 )

      LC = LC + Le1(p1,p4,p3,p2)*S13**(-1)*S24**(-1) * (  - 16*s12**3*
     +    s14*s34 + 16*s12**3*s23*s34 + 48*s12**2*s14**2*s23 - 48*
     +    s12**2*s14**2*s34 - 48*s12**2*s14*s23**2 + 48*s12**2*s23**2*
     +    s34 + 16*s12*s14**3*s23 + 64*s12*s14**2*s23*s34 - 32*s12*
     +    s14**2*s34**2 - 16*s12*s14*s23**3 - 64*s12*s14*s23**2*s34 + 
     +    24*s12*s14*s34**3 + 32*s12*s23**2*s34**2 - 24*s12*s23*s34**3
     +     + 8*s14**4*s23 + 8*s14**3*s23**2 - 8*s14**2*s23**3 - 8*s14*
     +    s23**4 )

      LC = LC + Le1(p1,p4,p3,p2)*S13**(-1)*S34**(-1) * ( 32*s12*s14**2*
     +    s23**2 + 64*s12*s14**2*s23*s24 + 32*s12*s14**2*s24**2 + 32*
     +    s14**2*s23**3 + 96*s14**2*s23**2*s24 + 96*s14**2*s23*s24**2
     +     + 32*s14**2*s24**3 )

      LC = LC + Le1(p1,p4,p3,p2)*S13**(-1) * (  - 48*s12**3*s34 - 96*
     +    s12**2*s14*s23 - 16*s12**2*s14*s34 + 40*s12**2*s23*s34 - 40*
     +    s12**2*s24*s34 - 96*s12**2*s34**2 + 32*s12*s14**2*s23 + 32*
     +    s12*s14**2*s24 - 16*s12*s14**2*s34 - 104*s12*s14*s23**2 - 96*
     +    s12*s14*s23*s24 - 128*s12*s14*s23*s34 + 8*s12*s14*s24**2 + 48
     +    *s12*s14*s24*s34 + 56*s12*s14*s34**2 + 8*s12*s23*s34**2 - 16*
     +    s12*s24**2*s34 - 40*s12*s24*s34**2 - 32*s12*s34**3 - 8*s14**3
     +    *s23 + 8*s14**3*s24 + 32*s14**2*s23**2 + 96*s14**2*s23*s24 + 
     +    32*s14**2*s24**2 - 16*s14**2*s24*s34 - 16*s14**2*s34**2 - 16*
     +    s14*s23**3 - 8*s14*s23**2*s24 - 8*s14*s23**2*s34 + 8*s14*s23*
     +    s24**2 + 16*s14*s23*s24*s34 + 8*s14*s23*s34**2 + 16*s14*
     +    s24**3 + 40*s14*s24**2*s34 + 32*s14*s24*s34**2 + 8*s14*s34**3
     +     )

      LC = LC + Le1(p1,p4,p3,p2)*S14**(-1)*S24**(-1) * ( 16*s12**4*s34
     +     - 16*s12**3*s13*s23 + 32*s12**3*s13*s34 - 48*s12**3*s23*s34
     +     + 80*s12**3*s34**2 - 32*s12**2*s13**2*s23 + 24*s12**2*s13**2
     +    *s34 + 16*s12**2*s13*s23**2 - 112*s12**2*s13*s23*s34 + 72*
     +    s12**2*s13*s34**2 + 40*s12**2*s23**2*s34 - 136*s12**2*s23*
     +    s34**2 + 72*s12**2*s34**3 - 24*s12*s13**3*s23 + 8*s12*s13**3*
     +    s34 + 32*s12*s13**2*s23**2 - 88*s12*s13**2*s23*s34 + 24*s12*
     +    s13**2*s34**2 - 8*s12*s13*s23**3 + 72*s12*s13*s23**2*s34 - 
     +    104*s12*s13*s23*s34**2 + 24*s12*s13*s34**3 - 8*s12*s23**3*s34
     +     + 40*s12*s23**2*s34**2 - 40*s12*s23*s34**3 + 8*s12*s34**4 - 
     +    8*s13**4*s23 + 16*s13**3*s23**2 - 24*s13**3*s23*s34 - 8*
     +    s13**2*s23**3 + 32*s13**2*s23**2*s34 - 24*s13**2*s23*s34**2
     +     - 8*s13*s23**3*s34 + 16*s13*s23**2*s34**2 - 8*s13*s23*s34**3
     +     )

      LC = LC + Le1(p1,p4,p3,p2)*S23**(-1)*S24**(-1) * (  - 24*s12**3*
     +    s34**2 - 8*s12**2*s13*s34**2 + 8*s12**2*s14*s34**2 - 24*
     +    s12**2*s34**3 )

      LC = LC + Le1(p1,p4,p3,p2)*S24**(-1)*S34**(-1) * (  - 32*s12*
     +    s13**2*s23**2 - 64*s12*s13*s14*s23**2 - 32*s12*s14**2*s23**2
     +     - 32*s13**3*s23**2 - 96*s13**2*s14*s23**2 - 96*s13*s14**2*
     +    s23**2 - 32*s14**3*s23**2 )

      LC = LC + Le1(p1,p4,p3,p2)*S24**(-1) * ( 48*s12**3*s34 + 40*
     +    s12**2*s13*s34 + 96*s12**2*s14*s23 - 40*s12**2*s14*s34 + 16*
     +    s12**2*s23*s34 + 96*s12**2*s34**2 - 8*s12*s13**2*s23 + 16*s12
     +    *s13**2*s34 + 96*s12*s13*s14*s23 - 32*s12*s13*s23**2 - 48*s12
     +    *s13*s23*s34 + 40*s12*s13*s34**2 + 104*s12*s14**2*s23 - 32*
     +    s12*s14*s23**2 + 128*s12*s14*s23*s34 - 8*s12*s14*s34**2 + 16*
     +    s12*s23**2*s34 - 56*s12*s23*s34**2 + 32*s12*s34**3 - 16*
     +    s13**3*s23 - 8*s13**2*s14*s23 - 32*s13**2*s23**2 - 40*s13**2*
     +    s23*s34 + 8*s13*s14**2*s23 - 96*s13*s14*s23**2 - 16*s13*s14*
     +    s23*s34 - 8*s13*s23**3 + 16*s13*s23**2*s34 - 32*s13*s23*
     +    s34**2 + 16*s14**3*s23 - 32*s14**2*s23**2 + 8*s14**2*s23*s34
     +     + 8*s14*s23**3 - 8*s14*s23*s34**2 + 16*s23**2*s34**2 - 8*s23
     +    *s34**3 )

      LC = LC + Le1(p2,p1,p3,p4)*S13**(-1)*S14**(-1) * (  - 8*s12**2*
     +    s23*s34**2 - 8*s12**2*s24*s34**2 - 8*s12**2*s34**3 - 16*s12*
     +    s23**2*s34**2 - 24*s12*s23*s24*s34**2 - 16*s12*s23*s34**3 - 8
     +    *s12*s24**2*s34**2 - 8*s12*s24*s34**3 - 8*s23**3*s34**2 - 16*
     +    s23**2*s24*s34**2 - 8*s23**2*s34**3 - 8*s23*s24**2*s34**2 - 8
     +    *s23*s24*s34**3 )

      LC = LC + Le1(p2,p1,p3,p4)*S13**(-1)*S23**(-1) * (  - 8*s12**3*
     +    s14**2 - 8*s12**3*s14*s24 - 16*s12**3*s14*s34 - 8*s12**3*s24*
     +    s34 - 8*s12**3*s34**2 + 8*s12**2*s14**2*s24 + 8*s12**2*s14**2
     +    *s34 + 8*s12**2*s14*s24**2 + 24*s12**2*s14*s24*s34 + 16*
     +    s12**2*s14*s34**2 + 8*s12**2*s24**2*s34 + 16*s12**2*s24*
     +    s34**2 + 8*s12**2*s34**3 )

      LC = LC + Le1(p2,p1,p3,p4)*S14**(-1)*S23**(-1) * (  - 24*s12**4*
     +    s34 + 24*s12**3*s13*s24 - 24*s12**3*s13*s34 - 48*s12**3*s24*
     +    s34 - 24*s12**3*s34**2 + 24*s12**2*s13**2*s24 + 48*s12**2*s13
     +    *s24**2 + 16*s12**2*s13*s24*s34 - 8*s12**2*s13*s34**2 + 8*s12
     +    *s13**2*s24**2 + 8*s12*s13**2*s24*s34 + 8*s12*s24*s34**3 + 8*
     +    s12*s34**4 - 8*s13*s24**2*s34**2 - 8*s13*s24*s34**3 )

      LC = LC + Le1(p2,p1,p3,p4)*S14**(-1)*S24**(-1) * (  - 16*s12**4*
     +    s34 - 48*s12**3*s23*s34 - 56*s12**2*s23**2*s34 - 32*s12*
     +    s23**3*s34 - 8*s23**4*s34 )

      LC = LC + Le1(p2,p1,p3,p4)*S14**(-1) * ( 16*s12**3*s13 - 80*
     +    s12**3*s34 + 16*s12**2*s13*s23 + 40*s12**2*s13*s24 - 48*
     +    s12**2*s13*s34 - 120*s12**2*s23*s34 - 88*s12**2*s24*s34 - 40*
     +    s12**2*s34**2 + 8*s12*s13**2*s24 + 8*s12*s13*s23**2 + 16*s12*
     +    s13*s23*s24 - 40*s12*s13*s23*s34 + 8*s12*s13*s24**2 - 40*s12*
     +    s13*s24*s34 - 24*s12*s13*s34**2 - 72*s12*s23**2*s34 - 56*s12*
     +    s23*s24*s34 - 40*s12*s23*s34**2 - 16*s12*s24**2*s34 - 48*s12*
     +    s24*s34**2 - 24*s12*s34**3 - 8*s13*s23**2*s34 - 8*s13*s23*s24
     +    *s34 - 8*s13*s23*s34**2 - 16*s13*s24*s34**2 - 8*s13*s34**3 - 
     +    16*s23**3*s34 - 8*s23**2*s24*s34 - 16*s23**2*s34**2 - 32*s23*
     +    s24*s34**2 - 16*s23*s34**3 - 16*s24**2*s34**2 - 16*s24*s34**3
     +     )

      LC = LC + Le1(p2,p1,p3,p4)*S23**(-1) * (  - 8*s12**4 - 8*s12**3*
     +    s13 - 16*s12**3*s14 - 16*s12**3*s24 - 24*s12**3*s34 + 40*
     +    s12**2*s13*s24 + 8*s12**2*s13*s34 + 32*s12**2*s14*s24 + 16*
     +    s12**2*s14*s34 + 32*s12**2*s24**2 + 64*s12**2*s24*s34 + 24*
     +    s12**2*s34**2 + 16*s12*s13*s24*s34 + 8*s12*s13*s34**2 + 8*s12
     +    *s14*s24*s34 + 8*s12*s14*s34**2 + 8*s12*s24**2*s34 + 24*s12*
     +    s24*s34**2 + 16*s12*s34**3 )

      LC = LC + Le1(p2,p1,p4,p3)*S13**(-1)*S14**(-1) * (  - 8*s12**2*
     +    s23*s34**2 - 8*s12**2*s24*s34**2 - 8*s12**2*s34**3 - 8*s12*
     +    s23**2*s34**2 - 24*s12*s23*s24*s34**2 - 8*s12*s23*s34**3 - 16
     +    *s12*s24**2*s34**2 - 16*s12*s24*s34**3 - 8*s23**2*s24*s34**2
     +     - 16*s23*s24**2*s34**2 - 8*s23*s24*s34**3 - 8*s24**3*s34**2
     +     - 8*s24**2*s34**3 )

      LC = LC + Le1(p2,p1,p4,p3)*S13**(-1)*S23**(-1) * (  - 16*s12**4*
     +    s34 - 48*s12**3*s24*s34 - 56*s12**2*s24**2*s34 - 32*s12*
     +    s24**3*s34 - 8*s24**4*s34 )

      LC = LC + Le1(p2,p1,p4,p3)*S13**(-1)*S24**(-1) * (  - 24*s12**4*
     +    s34 + 24*s12**3*s14*s23 - 24*s12**3*s14*s34 - 48*s12**3*s23*
     +    s34 - 24*s12**3*s34**2 + 24*s12**2*s14**2*s23 + 48*s12**2*s14
     +    *s23**2 + 16*s12**2*s14*s23*s34 - 8*s12**2*s14*s34**2 + 8*s12
     +    *s14**2*s23**2 + 8*s12*s14**2*s23*s34 + 8*s12*s23*s34**3 + 8*
     +    s12*s34**4 - 8*s14*s23**2*s34**2 - 8*s14*s23*s34**3 )

      LC = LC + Le1(p2,p1,p4,p3)*S13**(-1) * ( 16*s12**3*s14 - 80*
     +    s12**3*s34 + 40*s12**2*s14*s23 + 16*s12**2*s14*s24 - 48*
     +    s12**2*s14*s34 - 88*s12**2*s23*s34 - 120*s12**2*s24*s34 - 40*
     +    s12**2*s34**2 + 8*s12*s14**2*s23 + 8*s12*s14*s23**2 + 16*s12*
     +    s14*s23*s24 - 40*s12*s14*s23*s34 + 8*s12*s14*s24**2 - 40*s12*
     +    s14*s24*s34 - 24*s12*s14*s34**2 - 16*s12*s23**2*s34 - 56*s12*
     +    s23*s24*s34 - 48*s12*s23*s34**2 - 72*s12*s24**2*s34 - 40*s12*
     +    s24*s34**2 - 24*s12*s34**3 - 8*s14*s23*s24*s34 - 16*s14*s23*
     +    s34**2 - 8*s14*s24**2*s34 - 8*s14*s24*s34**2 - 8*s14*s34**3
     +     - 16*s23**2*s34**2 - 8*s23*s24**2*s34 - 32*s23*s24*s34**2 - 
     +    16*s23*s34**3 - 16*s24**3*s34 - 16*s24**2*s34**2 - 16*s24*
     +    s34**3 )

      LC = LC + Le1(p2,p1,p4,p3)*S14**(-1)*S24**(-1) * (  - 8*s12**3*
     +    s13**2 - 8*s12**3*s13*s23 - 16*s12**3*s13*s34 - 8*s12**3*s23*
     +    s34 - 8*s12**3*s34**2 + 8*s12**2*s13**2*s23 + 8*s12**2*s13**2
     +    *s34 + 8*s12**2*s13*s23**2 + 24*s12**2*s13*s23*s34 + 16*
     +    s12**2*s13*s34**2 + 8*s12**2*s23**2*s34 + 16*s12**2*s23*
     +    s34**2 + 8*s12**2*s34**3 )

      LC = LC + Le1(p2,p1,p4,p3)*S24**(-1) * (  - 8*s12**4 - 16*s12**3*
     +    s13 - 8*s12**3*s14 - 16*s12**3*s23 - 24*s12**3*s34 + 32*
     +    s12**2*s13*s23 + 16*s12**2*s13*s34 + 40*s12**2*s14*s23 + 8*
     +    s12**2*s14*s34 + 32*s12**2*s23**2 + 64*s12**2*s23*s34 + 24*
     +    s12**2*s34**2 + 8*s12*s13*s23*s34 + 8*s12*s13*s34**2 + 16*s12
     +    *s14*s23*s34 + 8*s12*s14*s34**2 + 8*s12*s23**2*s34 + 24*s12*
     +    s23*s34**2 + 16*s12*s34**3 )

      LC = LC + Le1(p2,p3,p1,p4)*S13**(-1)*S14**(-1)*S24**(-1) * ( 16*
     +    s12**3*s23*s34**2 + 16*s12**3*s34**3 + 32*s12**2*s23**2*
     +    s34**2 + 32*s12**2*s23*s34**3 + 24*s12*s23**3*s34**2 + 24*s12
     +    *s23**2*s34**3 + 8*s23**4*s34**2 + 8*s23**3*s34**3 )

      LC = LC + Le1(p2,p3,p1,p4)*S13**(-1)*S14**(-1) * ( 16*s12**3*
     +    s34**2 + 48*s12**2*s23*s34**2 + 16*s12**2*s24*s34**2 + 16*
     +    s12**2*s34**3 + 56*s12*s23**2*s34**2 + 40*s12*s23*s24*s34**2
     +     + 32*s12*s23*s34**3 + 8*s12*s24**2*s34**2 + 8*s12*s24*s34**3
     +     + 24*s23**3*s34**2 + 24*s23**2*s24*s34**2 + 16*s23**2*s34**3
     +     + 8*s23*s24**2*s34**2 + 8*s23*s24*s34**3 )

      LC = LC + Le1(p2,p3,p1,p4)*S13**(-1)*S23**(-1)*S24**(-1) * (  - 
     +    16*s12**4*s14**2 - 32*s12**4*s14*s34 - 16*s12**4*s34**2 )

      LC = LC + Le1(p2,p3,p1,p4)*S13**(-1)*S23**(-1) * (  - 16*s12**4*
     +    s14 - 16*s12**4*s34 - 16*s12**3*s14*s24 - 16*s12**3*s14*s34
     +     - 16*s12**3*s24*s34 - 16*s12**3*s34**2 + 8*s12**2*s14**2*s24
     +     + 8*s12**2*s14**2*s34 - 8*s12**2*s14*s24**2 + 8*s12**2*s14*
     +    s34**2 - 8*s12**2*s24**2*s34 - 8*s12**2*s24*s34**2 )

      LC = LC + Le1(p2,p3,p1,p4)*S13**(-1)*S24**(-1) * (  - 16*s12**4*
     +    s14 - 16*s12**4*s34 - 32*s12**3*s14**2 - 32*s12**3*s14*s23 - 
     +    48*s12**3*s14*s34 - 16*s12**3*s23*s34 - 24*s12**2*s14**2*s23
     +     - 24*s12**2*s14*s23**2 - 16*s12**2*s14*s23*s34 + 8*s12**2*
     +    s23**2*s34 + 40*s12**2*s23*s34**2 - 8*s12*s14**2*s23**2 - 8*
     +    s12*s14*s23**3 + 8*s12*s14*s23**2*s34 + 16*s12*s23**3*s34 + 
     +    40*s12*s23**2*s34**2 + 8*s14*s23**3*s34 + 8*s23**4*s34 + 16*
     +    s23**3*s34**2 )

      LC = LC + Le1(p2,p3,p1,p4)*S13**(-1) * (  - 48*s12**3*s14 - 32*
     +    s12**3*s34 + 8*s12**2*s14**2 - 48*s12**2*s14*s23 - 32*s12**2*
     +    s14*s24 - 16*s12**2*s14*s34 - 8*s12**2*s23*s34 - 24*s12**2*
     +    s24*s34 - 16*s12**2*s34**2 + 16*s12*s14**2*s23 + 16*s12*
     +    s14**2*s24 + 16*s12*s14**2*s34 - 16*s12*s14*s23**2 - 8*s12*
     +    s14*s23*s24 + 8*s12*s14*s24*s34 + 8*s12*s14*s34**2 + 24*s12*
     +    s23**2*s34 + 8*s12*s23*s24*s34 - 8*s12*s24*s34**2 - 8*s12*
     +    s34**3 - 16*s14*s23**2*s34 - 16*s14*s23*s24*s34 - 16*s14*s23*
     +    s34**2 + 16*s23**3*s34 + 8*s23**2*s24*s34 - 8*s23**2*s34**2
     +     - 16*s23*s24*s34**2 - 16*s23*s34**3 )

      LC = LC + Le1(p2,p3,p1,p4)*S14**(-1)*S24**(-1) * ( 16*s12**3*s23*
     +    s34 + 16*s12**3*s34**2 + 16*s12**2*s13*s23*s34 + 16*s12**2*
     +    s13*s34**2 + 32*s12**2*s23**2*s34 + 48*s12**2*s23*s34**2 + 16
     +    *s12**2*s34**3 + 8*s12*s13**2*s23*s34 + 8*s12*s13**2*s34**2
     +     + 16*s12*s13*s23**2*s34 + 24*s12*s13*s23*s34**2 + 8*s12*s13*
     +    s34**3 + 24*s12*s23**3*s34 + 40*s12*s23**2*s34**2 + 16*s12*
     +    s23*s34**3 + 8*s13**2*s23**2*s34 + 8*s13**2*s23*s34**2 + 8*
     +    s13*s23**2*s34**2 + 8*s13*s23*s34**3 + 8*s23**4*s34 + 8*
     +    s23**3*s34**2 )

      LC = LC + Le1(p2,p3,p1,p4)*S14**(-1) * ( 16*s12**3*s34 + 16*
     +    s12**2*s13*s34 + 48*s12**2*s23*s34 + 16*s12**2*s24*s34 + 32*
     +    s12**2*s34**2 + 8*s12*s13**2*s34 + 48*s12*s13*s23*s34 + 32*
     +    s12*s13*s24*s34 + 40*s12*s13*s34**2 + 40*s12*s23**2*s34 + 24*
     +    s12*s23*s24*s34 + 64*s12*s23*s34**2 + 8*s12*s24**2*s34 + 40*
     +    s12*s24*s34**2 + 32*s12*s34**3 + 24*s13**2*s23*s34 + 16*
     +    s13**2*s24*s34 + 16*s13**2*s34**2 + 16*s13*s23**2*s34 + 32*
     +    s13*s23*s24*s34 + 48*s13*s23*s34**2 + 16*s13*s24**2*s34 + 40*
     +    s13*s24*s34**2 + 24*s13*s34**3 + 8*s23**3*s34 - 8*s23**2*s24*
     +    s34 + 16*s23**2*s34**2 - 8*s23*s24**2*s34 + 24*s23*s24*s34**2
     +     + 24*s23*s34**3 + 16*s24**2*s34**2 + 24*s24*s34**3 + 8*
     +    s34**4 )

      LC = LC + Le1(p2,p3,p1,p4)*S23**(-1)*S24**(-1) * (  - 16*s12**4*
     +    s14 - 16*s12**4*s34 - 16*s12**3*s13*s14 - 16*s12**3*s13*s34
     +     - 16*s12**3*s14**2 - 32*s12**3*s14*s34 - 16*s12**3*s34**2 - 
     +    8*s12**2*s13**2*s14 - 8*s12**2*s13**2*s34 - 8*s12**2*s13*
     +    s14**2 - 16*s12**2*s13*s14*s34 - 8*s12**2*s13*s34**2 )

      LC = LC + Le1(p2,p3,p1,p4)*S23**(-1) * (  - 16*s12**4 - 16*s12**3
     +    *s13 - 16*s12**3*s14 - 16*s12**3*s24 - 32*s12**3*s34 - 8*
     +    s12**2*s13**2 - 8*s12**2*s13*s14 - 32*s12**2*s13*s24 - 40*
     +    s12**2*s13*s34 - 24*s12**2*s14*s24 - 24*s12**2*s14*s34 - 8*
     +    s12**2*s24**2 - 40*s12**2*s24*s34 - 32*s12**2*s34**2 - 16*s12
     +    *s13**2*s24 - 16*s12*s13**2*s34 - 16*s12*s13*s14*s24 - 16*s12
     +    *s13*s14*s34 - 16*s12*s13*s24**2 - 40*s12*s13*s24*s34 - 24*
     +    s12*s13*s34**2 - 16*s12*s14*s24**2 - 24*s12*s14*s24*s34 - 8*
     +    s12*s14*s34**2 - 16*s12*s24**2*s34 - 24*s12*s24*s34**2 - 8*
     +    s12*s34**3 )

      LC = LC + Le1(p2,p3,p1,p4)*S24**(-1) * (  - 16*s12**4 - 16*s12**3
     +    *s13 - 48*s12**3*s14 - 32*s12**3*s23 - 32*s12**3*s34 - 8*
     +    s12**2*s13**2 - 24*s12**2*s13*s14 - 16*s12**2*s13*s23 - 8*
     +    s12**2*s13*s34 - 16*s12**2*s14**2 - 40*s12**2*s14*s23 - 16*
     +    s12**2*s14*s34 - 24*s12**2*s23**2 + 8*s12**2*s23*s34 + 16*
     +    s12**2*s34**2 - 8*s12*s13**2*s14 - 8*s12*s13**2*s23 - 8*s12*
     +    s13*s14**2 - 8*s12*s13*s14*s23 - 8*s12*s13*s14*s34 + 16*s12*
     +    s13*s23*s34 + 8*s12*s13*s34**2 - 8*s12*s14*s23**2 + 16*s12*
     +    s14*s23*s34 - 8*s12*s23**3 + 32*s12*s23**2*s34 + 32*s12*s23*
     +    s34**2 + 8*s13**2*s23*s34 + 8*s13*s14*s23*s34 + 8*s13*s23**2*
     +    s34 + 16*s13*s23*s34**2 + 8*s23**3*s34 )

      LC = LC + Le1(p2,p3,p1,p4) * (  - 48*s12**3 - 48*s12**2*s13 - 40*
     +    s12**2*s14 - 40*s12**2*s23 - 24*s12**2*s24 - 48*s12**2*s34 - 
     +    24*s12*s13**2 - 24*s12*s13*s14 - 16*s12*s13*s23 - 32*s12*s13*
     +    s24 - 40*s12*s13*s34 - 16*s12*s14*s24 - 8*s12*s14*s34 - 8*s12
     +    *s23**2 + 8*s12*s23*s24 + 24*s12*s23*s34 + 8*s12*s24**2 + 24*
     +    s13*s23*s34 + 16*s13*s24*s34 + 16*s13*s34**2 + 16*s23*s24*s34
     +     + 8*s23*s34**2 + 16*s24**2*s34 + 24*s24*s34**2 + 8*s34**3 )

      LC = LC + Le1(p2,p4,p1,p3)*S13**(-1)*S14**(-1)*S23**(-1) * ( 16*
     +    s12**3*s24*s34**2 + 16*s12**3*s34**3 + 32*s12**2*s24**2*
     +    s34**2 + 32*s12**2*s24*s34**3 + 24*s12*s24**3*s34**2 + 24*s12
     +    *s24**2*s34**3 + 8*s24**4*s34**2 + 8*s24**3*s34**3 )

      LC = LC + Le1(p2,p4,p1,p3)*S13**(-1)*S14**(-1) * ( 16*s12**3*
     +    s34**2 + 16*s12**2*s23*s34**2 + 48*s12**2*s24*s34**2 + 16*
     +    s12**2*s34**3 + 8*s12*s23**2*s34**2 + 40*s12*s23*s24*s34**2
     +     + 8*s12*s23*s34**3 + 56*s12*s24**2*s34**2 + 32*s12*s24*
     +    s34**3 + 8*s23**2*s24*s34**2 + 24*s23*s24**2*s34**2 + 8*s23*
     +    s24*s34**3 + 24*s24**3*s34**2 + 16*s24**2*s34**3 )

      LC = LC + Le1(p2,p4,p1,p3)*S13**(-1)*S23**(-1) * ( 16*s12**3*s24*
     +    s34 + 16*s12**3*s34**2 + 16*s12**2*s14*s24*s34 + 16*s12**2*
     +    s14*s34**2 + 32*s12**2*s24**2*s34 + 48*s12**2*s24*s34**2 + 16
     +    *s12**2*s34**3 + 8*s12*s14**2*s24*s34 + 8*s12*s14**2*s34**2
     +     + 16*s12*s14*s24**2*s34 + 24*s12*s14*s24*s34**2 + 8*s12*s14*
     +    s34**3 + 24*s12*s24**3*s34 + 40*s12*s24**2*s34**2 + 16*s12*
     +    s24*s34**3 + 8*s14**2*s24**2*s34 + 8*s14**2*s24*s34**2 + 8*
     +    s14*s24**2*s34**2 + 8*s14*s24*s34**3 + 8*s24**4*s34 + 8*
     +    s24**3*s34**2 )

      LC = LC + Le1(p2,p4,p1,p3)*S13**(-1) * ( 16*s12**3*s34 + 16*
     +    s12**2*s14*s34 + 16*s12**2*s23*s34 + 48*s12**2*s24*s34 + 32*
     +    s12**2*s34**2 + 8*s12*s14**2*s34 + 32*s12*s14*s23*s34 + 48*
     +    s12*s14*s24*s34 + 40*s12*s14*s34**2 + 8*s12*s23**2*s34 + 24*
     +    s12*s23*s24*s34 + 40*s12*s23*s34**2 + 40*s12*s24**2*s34 + 64*
     +    s12*s24*s34**2 + 32*s12*s34**3 + 16*s14**2*s23*s34 + 24*
     +    s14**2*s24*s34 + 16*s14**2*s34**2 + 16*s14*s23**2*s34 + 32*
     +    s14*s23*s24*s34 + 40*s14*s23*s34**2 + 16*s14*s24**2*s34 + 48*
     +    s14*s24*s34**2 + 24*s14*s34**3 - 8*s23**2*s24*s34 + 16*s23**2
     +    *s34**2 - 8*s23*s24**2*s34 + 24*s23*s24*s34**2 + 24*s23*
     +    s34**3 + 8*s24**3*s34 + 16*s24**2*s34**2 + 24*s24*s34**3 + 8*
     +    s34**4 )

      LC = LC + Le1(p2,p4,p1,p3)*S14**(-1)*S23**(-1)*S24**(-1) * (  - 
     +    16*s12**4*s13**2 - 32*s12**4*s13*s34 - 16*s12**4*s34**2 )

      LC = LC + Le1(p2,p4,p1,p3)*S14**(-1)*S23**(-1) * (  - 16*s12**4*
     +    s13 - 16*s12**4*s34 - 32*s12**3*s13**2 - 32*s12**3*s13*s24 - 
     +    48*s12**3*s13*s34 - 16*s12**3*s24*s34 - 24*s12**2*s13**2*s24
     +     - 24*s12**2*s13*s24**2 - 16*s12**2*s13*s24*s34 + 8*s12**2*
     +    s24**2*s34 + 40*s12**2*s24*s34**2 - 8*s12*s13**2*s24**2 - 8*
     +    s12*s13*s24**3 + 8*s12*s13*s24**2*s34 + 16*s12*s24**3*s34 + 
     +    40*s12*s24**2*s34**2 + 8*s13*s24**3*s34 + 8*s24**4*s34 + 16*
     +    s24**3*s34**2 )

      LC = LC + Le1(p2,p4,p1,p3)*S14**(-1)*S24**(-1) * (  - 16*s12**4*
     +    s13 - 16*s12**4*s34 - 16*s12**3*s13*s23 - 16*s12**3*s13*s34
     +     - 16*s12**3*s23*s34 - 16*s12**3*s34**2 + 8*s12**2*s13**2*s23
     +     + 8*s12**2*s13**2*s34 - 8*s12**2*s13*s23**2 + 8*s12**2*s13*
     +    s34**2 - 8*s12**2*s23**2*s34 - 8*s12**2*s23*s34**2 )

      LC = LC + Le1(p2,p4,p1,p3)*S14**(-1) * (  - 48*s12**3*s13 - 32*
     +    s12**3*s34 + 8*s12**2*s13**2 - 32*s12**2*s13*s23 - 48*s12**2*
     +    s13*s24 - 16*s12**2*s13*s34 - 24*s12**2*s23*s34 - 8*s12**2*
     +    s24*s34 - 16*s12**2*s34**2 + 16*s12*s13**2*s23 + 16*s12*
     +    s13**2*s24 + 16*s12*s13**2*s34 - 8*s12*s13*s23*s24 + 8*s12*
     +    s13*s23*s34 - 16*s12*s13*s24**2 + 8*s12*s13*s34**2 + 8*s12*
     +    s23*s24*s34 - 8*s12*s23*s34**2 + 24*s12*s24**2*s34 - 8*s12*
     +    s34**3 - 16*s13*s23*s24*s34 - 16*s13*s24**2*s34 - 16*s13*s24*
     +    s34**2 + 8*s23*s24**2*s34 - 16*s23*s24*s34**2 + 16*s24**3*s34
     +     - 8*s24**2*s34**2 - 16*s24*s34**3 )

      LC = LC + Le1(p2,p4,p1,p3)*S23**(-1)*S24**(-1) * (  - 16*s12**4*
     +    s13 - 16*s12**4*s34 - 16*s12**3*s13**2 - 16*s12**3*s13*s14 - 
     +    32*s12**3*s13*s34 - 16*s12**3*s14*s34 - 16*s12**3*s34**2 - 8*
     +    s12**2*s13**2*s14 - 8*s12**2*s13*s14**2 - 16*s12**2*s13*s14*
     +    s34 - 8*s12**2*s14**2*s34 - 8*s12**2*s14*s34**2 )

      LC = LC + Le1(p2,p4,p1,p3)*S23**(-1) * (  - 16*s12**4 - 48*s12**3
     +    *s13 - 16*s12**3*s14 - 32*s12**3*s24 - 32*s12**3*s34 - 16*
     +    s12**2*s13**2 - 24*s12**2*s13*s14 - 40*s12**2*s13*s24 - 16*
     +    s12**2*s13*s34 - 8*s12**2*s14**2 - 16*s12**2*s14*s24 - 8*
     +    s12**2*s14*s34 - 24*s12**2*s24**2 + 8*s12**2*s24*s34 + 16*
     +    s12**2*s34**2 - 8*s12*s13**2*s14 - 8*s12*s13*s14**2 - 8*s12*
     +    s13*s14*s24 - 8*s12*s13*s14*s34 - 8*s12*s13*s24**2 + 16*s12*
     +    s13*s24*s34 - 8*s12*s14**2*s24 + 16*s12*s14*s24*s34 + 8*s12*
     +    s14*s34**2 - 8*s12*s24**3 + 32*s12*s24**2*s34 + 32*s12*s24*
     +    s34**2 + 8*s13*s14*s24*s34 + 8*s14**2*s24*s34 + 8*s14*s24**2*
     +    s34 + 16*s14*s24*s34**2 + 8*s24**3*s34 )

      LC = LC + Le1(p2,p4,p1,p3)*S24**(-1) * (  - 16*s12**4 - 16*s12**3
     +    *s13 - 16*s12**3*s14 - 16*s12**3*s23 - 32*s12**3*s34 - 8*
     +    s12**2*s13*s14 - 24*s12**2*s13*s23 - 24*s12**2*s13*s34 - 8*
     +    s12**2*s14**2 - 32*s12**2*s14*s23 - 40*s12**2*s14*s34 - 8*
     +    s12**2*s23**2 - 40*s12**2*s23*s34 - 32*s12**2*s34**2 - 16*s12
     +    *s13*s14*s23 - 16*s12*s13*s14*s34 - 16*s12*s13*s23**2 - 24*
     +    s12*s13*s23*s34 - 8*s12*s13*s34**2 - 16*s12*s14**2*s23 - 16*
     +    s12*s14**2*s34 - 16*s12*s14*s23**2 - 40*s12*s14*s23*s34 - 24*
     +    s12*s14*s34**2 - 16*s12*s23**2*s34 - 24*s12*s23*s34**2 - 8*
     +    s12*s34**3 )

      LC = LC + Le1(p2,p4,p1,p3) * (  - 48*s12**3 - 40*s12**2*s13 - 48*
     +    s12**2*s14 - 24*s12**2*s23 - 40*s12**2*s24 - 48*s12**2*s34 - 
     +    24*s12*s13*s14 - 16*s12*s13*s23 - 8*s12*s13*s34 - 24*s12*
     +    s14**2 - 32*s12*s14*s23 - 16*s12*s14*s24 - 40*s12*s14*s34 + 8
     +    *s12*s23**2 + 8*s12*s23*s24 - 8*s12*s24**2 + 24*s12*s24*s34
     +     + 16*s14*s23*s34 + 24*s14*s24*s34 + 16*s14*s34**2 + 16*
     +    s23**2*s34 + 16*s23*s24*s34 + 24*s23*s34**2 + 8*s24*s34**2 + 
     +    8*s34**3 )

      LC = LC + Le1(p3,p1,p2,p4)*S13**(-1)*S14**(-1) * ( 16*s12**3*s23*
     +    s34 + 16*s12**3*s24*s34 + 16*s12**3*s34**2 - 16*s12**2*s23**2
     +    *s24 + 16*s12**2*s23**2*s34 - 16*s12**2*s23*s24**2 + 16*
     +    s12**2*s23*s34**2 - 16*s12*s23**3*s24 + 8*s12*s23**3*s34 - 16
     +    *s12*s23**2*s24**2 - 8*s12*s23**2*s24*s34 + 8*s12*s23**2*
     +    s34**2 - 8*s23**4*s24 - 8*s23**3*s24**2 - 8*s23**3*s24*s34 )

      LC = LC + Le1(p3,p1,p2,p4)*S13**(-1) * ( 16*s12**3*s23 + 16*
     +    s12**3*s24 + 16*s12**3*s34 + 16*s12**2*s14*s23 + 16*s12**2*
     +    s14*s24 + 16*s12**2*s14*s34 + 16*s12**2*s23**2 + 16*s12**2*
     +    s23*s24 + 32*s12**2*s23*s34 + 16*s12**2*s24*s34 + 16*s12**2*
     +    s34**2 + 8*s12*s14**2*s23 + 8*s12*s14**2*s24 + 8*s12*s14**2*
     +    s34 + 32*s12*s14*s23**2 + 32*s12*s14*s23*s24 + 40*s12*s14*s23
     +    *s34 + 8*s12*s14*s24*s34 + 8*s12*s14*s34**2 + 8*s12*s23**3 + 
     +    8*s12*s23**2*s24 + 40*s12*s23**2*s34 + 32*s12*s23*s24*s34 + 
     +    32*s12*s23*s34**2 + 16*s14**2*s23**2 + 16*s14**2*s23*s24 + 16
     +    *s14**2*s23*s34 + 16*s14*s23**3 + 24*s14*s23**2*s24 + 40*s14*
     +    s23**2*s34 + 8*s14*s23*s24**2 + 32*s14*s23*s24*s34 + 24*s14*
     +    s23*s34**2 + 16*s23**3*s34 + 24*s23**2*s24*s34 + 24*s23**2*
     +    s34**2 + 8*s23*s24**2*s34 + 16*s23*s24*s34**2 + 8*s23*s34**3
     +     )

      LC = LC + Le1(p3,p1,p2,p4)*S14**(-1) * ( 16*s12**3*s23 + 16*
     +    s12**3*s24 + 16*s12**3*s34 + 16*s12**2*s23**2 + 16*s12**2*s23
     +    *s24 + 16*s12**2*s23*s34 + 8*s12*s23**3 + 8*s12*s23**2*s24 + 
     +    8*s12*s23**2*s34 )

      LC = LC + Le1(p3,p1,p2,p4)*S23**(-1)*S24**(-1) * (  - 16*s12**3*
     +    s13*s34 - 16*s12**3*s14*s34 - 16*s12**3*s34**2 + 16*s12**2*
     +    s13**2*s14 + 16*s12**2*s13*s14**2 - 16*s12**2*s14**2*s34 - 16
     +    *s12**2*s14*s34**2 + 16*s12*s13**2*s14**2 + 16*s12*s13*s14**3
     +     + 8*s12*s13*s14**2*s34 - 8*s12*s14**3*s34 - 8*s12*s14**2*
     +    s34**2 + 8*s13**2*s14**3 + 8*s13*s14**4 + 8*s13*s14**3*s34 )

      LC = LC + Le1(p3,p1,p2,p4)*S23**(-1) * (  - 16*s12**3*s13 - 16*
     +    s12**3*s14 - 16*s12**3*s34 - 16*s12**2*s13*s14 - 16*s12**2*
     +    s14**2 - 16*s12**2*s14*s34 - 8*s12*s13*s14**2 - 8*s12*s14**3
     +     - 8*s12*s14**2*s34 )

      LC = LC + Le1(p3,p1,p2,p4)*S24**(-1) * (  - 16*s12**3*s13 - 16*
     +    s12**3*s14 - 16*s12**3*s34 - 16*s12**2*s13*s14 - 16*s12**2*
     +    s13*s23 - 16*s12**2*s13*s34 - 16*s12**2*s14**2 - 16*s12**2*
     +    s14*s23 - 32*s12**2*s14*s34 - 16*s12**2*s23*s34 - 16*s12**2*
     +    s34**2 - 8*s12*s13*s14**2 - 32*s12*s13*s14*s23 - 32*s12*s13*
     +    s14*s34 - 8*s12*s13*s23**2 - 8*s12*s13*s23*s34 - 8*s12*s14**3
     +     - 32*s12*s14**2*s23 - 40*s12*s14**2*s34 - 8*s12*s14*s23**2
     +     - 40*s12*s14*s23*s34 - 32*s12*s14*s34**2 - 8*s12*s23**2*s34
     +     - 8*s12*s23*s34**2 - 8*s13**2*s14*s23 - 8*s13**2*s14*s34 - 
     +    24*s13*s14**2*s23 - 24*s13*s14**2*s34 - 16*s13*s14*s23**2 - 
     +    32*s13*s14*s23*s34 - 16*s13*s14*s34**2 - 16*s14**3*s23 - 16*
     +    s14**3*s34 - 16*s14**2*s23**2 - 40*s14**2*s23*s34 - 24*s14**2
     +    *s34**2 - 16*s14*s23**2*s34 - 24*s14*s23*s34**2 - 8*s14*
     +    s34**3 )

      LC = LC + Le1(p3,p1,p2,p4) * (  - 32*s12**2*s13 - 32*s12**2*s14
     +     + 32*s12**2*s23 + 32*s12**2*s24 - 48*s12*s13*s14 - 8*s12*s13
     +    *s23 - 48*s12*s14**2 + 8*s12*s14*s24 - 40*s12*s14*s34 + 48*
     +    s12*s23**2 + 48*s12*s23*s24 + 40*s12*s23*s34 - 8*s13**2*s14
     +     - 32*s13*s14**2 - 24*s13*s14*s23 - 8*s13*s14*s24 - 24*s13*
     +    s14*s34 + 8*s13*s23**2 + 8*s13*s23*s24 + 8*s13*s23*s34 - 24*
     +    s14**3 - 24*s14**2*s23 - 8*s14**2*s24 - 40*s14**2*s34 + 24*
     +    s14*s23**2 + 24*s14*s23*s24 - 8*s14*s24*s34 - 16*s14*s34**2
     +     + 24*s23**3 + 32*s23**2*s24 + 40*s23**2*s34 + 8*s23*s24**2
     +     + 24*s23*s24*s34 + 16*s23*s34**2 )

      LC = LC + Le1(p3,p2,p1,p4)*S13**(-1)*S14**(-1) * (  - 16*s12**3*
     +    s23*s34 - 16*s12**3*s24*s34 - 16*s12**3*s34**2 + 16*s12**2*
     +    s23**2*s24 + 16*s12**2*s23*s24**2 - 16*s12**2*s24**2*s34 - 16
     +    *s12**2*s24*s34**2 + 16*s12*s23**2*s24**2 + 16*s12*s23*s24**3
     +     + 8*s12*s23*s24**2*s34 - 8*s12*s24**3*s34 - 8*s12*s24**2*
     +    s34**2 + 8*s23**2*s24**3 + 8*s23*s24**4 + 8*s23*s24**3*s34 )

      LC = LC + Le1(p3,p2,p1,p4)*S13**(-1) * (  - 16*s12**3*s23 - 16*
     +    s12**3*s24 - 16*s12**3*s34 - 16*s12**2*s23*s24 - 16*s12**2*
     +    s24**2 - 16*s12**2*s24*s34 - 8*s12*s23*s24**2 - 8*s12*s24**3
     +     - 8*s12*s24**2*s34 )

      LC = LC + Le1(p3,p2,p1,p4)*S14**(-1) * (  - 16*s12**3*s23 - 16*
     +    s12**3*s24 - 16*s12**3*s34 - 16*s12**2*s13*s23 - 16*s12**2*
     +    s13*s24 - 16*s12**2*s13*s34 - 16*s12**2*s23*s24 - 16*s12**2*
     +    s23*s34 - 16*s12**2*s24**2 - 32*s12**2*s24*s34 - 16*s12**2*
     +    s34**2 - 8*s12*s13**2*s23 - 8*s12*s13**2*s24 - 8*s12*s13**2*
     +    s34 - 32*s12*s13*s23*s24 - 8*s12*s13*s23*s34 - 32*s12*s13*
     +    s24**2 - 40*s12*s13*s24*s34 - 8*s12*s13*s34**2 - 8*s12*s23*
     +    s24**2 - 32*s12*s23*s24*s34 - 8*s12*s24**3 - 40*s12*s24**2*
     +    s34 - 32*s12*s24*s34**2 - 16*s13**2*s23*s24 - 16*s13**2*
     +    s24**2 - 16*s13**2*s24*s34 - 8*s13*s23**2*s24 - 24*s13*s23*
     +    s24**2 - 32*s13*s23*s24*s34 - 16*s13*s24**3 - 40*s13*s24**2*
     +    s34 - 24*s13*s24*s34**2 - 8*s23**2*s24*s34 - 24*s23*s24**2*
     +    s34 - 16*s23*s24*s34**2 - 16*s24**3*s34 - 24*s24**2*s34**2 - 
     +    8*s24*s34**3 )

      LC = LC + Le1(p3,p2,p1,p4)*S23**(-1)*S24**(-1) * ( 16*s12**3*s13*
     +    s34 + 16*s12**3*s14*s34 + 16*s12**3*s34**2 - 16*s12**2*s13**2
     +    *s14 + 16*s12**2*s13**2*s34 - 16*s12**2*s13*s14**2 + 16*
     +    s12**2*s13*s34**2 - 16*s12*s13**3*s14 + 8*s12*s13**3*s34 - 16
     +    *s12*s13**2*s14**2 - 8*s12*s13**2*s14*s34 + 8*s12*s13**2*
     +    s34**2 - 8*s13**4*s14 - 8*s13**3*s14**2 - 8*s13**3*s14*s34 )

      LC = LC + Le1(p3,p2,p1,p4)*S23**(-1) * ( 16*s12**3*s13 + 16*
     +    s12**3*s14 + 16*s12**3*s34 + 16*s12**2*s13**2 + 16*s12**2*s13
     +    *s14 + 16*s12**2*s13*s24 + 32*s12**2*s13*s34 + 16*s12**2*s14*
     +    s24 + 16*s12**2*s14*s34 + 16*s12**2*s24*s34 + 16*s12**2*
     +    s34**2 + 8*s12*s13**3 + 8*s12*s13**2*s14 + 32*s12*s13**2*s24
     +     + 40*s12*s13**2*s34 + 32*s12*s13*s14*s24 + 32*s12*s13*s14*
     +    s34 + 8*s12*s13*s24**2 + 40*s12*s13*s24*s34 + 32*s12*s13*
     +    s34**2 + 8*s12*s14*s24**2 + 8*s12*s14*s24*s34 + 8*s12*s24**2*
     +    s34 + 8*s12*s24*s34**2 + 16*s13**3*s24 + 16*s13**3*s34 + 24*
     +    s13**2*s14*s24 + 24*s13**2*s14*s34 + 16*s13**2*s24**2 + 40*
     +    s13**2*s24*s34 + 24*s13**2*s34**2 + 8*s13*s14**2*s24 + 8*s13*
     +    s14**2*s34 + 16*s13*s14*s24**2 + 32*s13*s14*s24*s34 + 16*s13*
     +    s14*s34**2 + 16*s13*s24**2*s34 + 24*s13*s24*s34**2 + 8*s13*
     +    s34**3 )

      LC = LC + Le1(p3,p2,p1,p4)*S24**(-1) * ( 16*s12**3*s13 + 16*
     +    s12**3*s14 + 16*s12**3*s34 + 16*s12**2*s13**2 + 16*s12**2*s13
     +    *s14 + 16*s12**2*s13*s34 + 8*s12*s13**3 + 8*s12*s13**2*s14 + 
     +    8*s12*s13**2*s34 )

      LC = LC + Le1(p3,p2,p1,p4) * ( 32*s12**2*s13 + 32*s12**2*s14 - 32
     +    *s12**2*s23 - 32*s12**2*s24 + 48*s12*s13**2 + 48*s12*s13*s14
     +     - 8*s12*s13*s23 + 40*s12*s13*s34 + 8*s12*s14*s24 - 48*s12*
     +    s23*s24 - 48*s12*s24**2 - 40*s12*s24*s34 + 24*s13**3 + 32*
     +    s13**2*s14 + 8*s13**2*s23 + 24*s13**2*s24 + 40*s13**2*s34 + 8
     +    *s13*s14**2 + 8*s13*s14*s23 + 24*s13*s14*s24 + 24*s13*s14*s34
     +     - 24*s13*s23*s24 + 8*s13*s23*s34 - 24*s13*s24**2 + 16*s13*
     +    s34**2 - 8*s14*s23*s24 - 8*s14*s24**2 - 8*s14*s24*s34 - 8*
     +    s23**2*s24 - 32*s23*s24**2 - 24*s23*s24*s34 - 24*s24**3 - 40*
     +    s24**2*s34 - 16*s24*s34**2 )

      LC = LC + 48*s12 + 120*s13 - 96*s14 - 120*s23 - 288*s24 - 192*s34

      LCi=-LC/s134/s234
      
      return
      end
      
      
      function LNF(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      s134=s13+s14+s34
      s234=s23+s24+s34

      LNF = 0d0

      LNF = LNF + S13**(-1)*S24**(-1)*S34**(-2)*S234**(-2)*S134**(-2)
     +  * (  - 2*s12**2*s13**2*s23*s24*s34 - s12**2*s13**2*s23*s34**2
     +     - 2*s12**2*s13**2*s24**2*s34 - 3*s12**2*s13**2*s24*s34**2 - 
     +    s12**2*s13**2*s34**3 + 2*s12**2*s13*s14*s23**2*s34 + 2*s12**2
     +    *s13*s14*s23*s34**2 - 2*s12**2*s13*s14*s24**2*s34 - 2*s12**2*
     +    s13*s14*s24*s34**2 + s12**2*s13*s23**2*s34**2 - 2*s12**2*s13*
     +    s23*s24*s34**2 - 3*s12**2*s13*s24**2*s34**2 - 4*s12**2*s13*
     +    s24*s34**3 - s12**2*s13*s34**4 + 2*s12**2*s14**2*s23**2*s34
     +     + 2*s12**2*s14**2*s23*s24*s34 + 3*s12**2*s14**2*s23*s34**2
     +     + s12**2*s14**2*s24*s34**2 + s12**2*s14**2*s34**3 + 3*s12**2
     +    *s14*s23**2*s34**2 + 2*s12**2*s14*s23*s24*s34**2 + 4*s12**2*
     +    s14*s23*s34**3 - s12**2*s14*s24**2*s34**2 + s12**2*s14*s34**4
     +     + s12**2*s23**2*s34**3 + s12**2*s23*s34**4 - s12**2*s24**2*
     +    s34**3 - s12**2*s24*s34**4 - 2*s12*s13**3*s23*s24**2 - 3*s12*
     +    s13**3*s23*s24*s34 - 2*s12*s13**3*s24**3 - 5*s12*s13**3*
     +    s24**2*s34 - 3*s12*s13**3*s24*s34**2 + 4*s12*s13**2*s14*
     +    s23**2*s24 )

      LNF = LNF + S13**(-1)*S24**(-1)*S34**(-2)*S234**(-2)*S134**(-2)
     +  * ( 3*s12*s13**2*s14*s23**2*s34 + 2*s12*s13**2*s14*s23*s24**2
     +     + 3*s12*s13**2*s14*s23*s24*s34 + 4*s12*s13**2*s14*s23*s34**2
     +     - 2*s12*s13**2*s14*s24**3 - 6*s12*s13**2*s14*s24**2*s34 - 3*
     +    s12*s13**2*s14*s24*s34**2 + s12*s13**2*s14*s34**3 - s12*
     +    s13**2*s23**2*s24*s34 - 6*s12*s13**2*s23*s24**2*s34 - 8*s12*
     +    s13**2*s23*s24*s34**2 - 5*s12*s13**2*s24**3*s34 - 12*s12*
     +    s13**2*s24**2*s34**2 - 7*s12*s13**2*s24*s34**3 - 2*s12*s13*
     +    s14**2*s23**3 + 2*s12*s13*s14**2*s23**2*s24 + 2*s12*s13*
     +    s14**2*s23**2*s34 + 4*s12*s13*s14**2*s23*s24**2 + 7*s12*s13*
     +    s14**2*s23*s24*s34 + 6*s12*s13*s14**2*s23*s34**2 - s12*s13*
     +    s14**2*s24**2*s34 + s12*s13*s14**2*s24*s34**2 + 2*s12*s13*
     +    s14**2*s34**3 + s12*s13*s14*s23**3*s34 + 7*s12*s13*s14*s23**2
     +    *s24*s34 + 8*s12*s13*s14*s23**2*s34**2 + 3*s12*s13*s14*s23*
     +    s24**2*s34 + 8*s12*s13*s14*s23*s24*s34**2 + 9*s12*s13*s14*s23
     +    *s34**3 - 3*s12*s13*s14*s24**3*s34 - 8*s12*s13*s14*s24**2*
     +    s34**2 )

      LNF = LNF + S13**(-1)*S24**(-1)*S34**(-2)*S234**(-2)*S134**(-2)
     +  * (  - 3*s12*s13*s14*s24*s34**3 + 2*s12*s13*s14*s34**4 + s12*
     +    s13*s23**3*s34**2 + s12*s13*s23**2*s24*s34**2 + 2*s12*s13*
     +    s23**2*s34**3 - 3*s12*s13*s23*s24**2*s34**2 - 3*s12*s13*s23*
     +    s24*s34**3 + s12*s13*s23*s34**4 - 3*s12*s13*s24**3*s34**2 - 7
     +    *s12*s13*s24**2*s34**3 - 4*s12*s13*s24*s34**4 - 2*s12*s14**3*
     +    s23**3 - 2*s12*s14**3*s23**2*s24 - s12*s14**3*s23**2*s34 + 
     +    s12*s14**3*s23*s24*s34 + 2*s12*s14**3*s23*s34**2 + s12*s14**3
     +    *s24*s34**2 + s12*s14**3*s34**3 - s12*s14**2*s23**3*s34 + 2*
     +    s12*s14**2*s23**2*s24*s34 + 4*s12*s14**2*s23**2*s34**2 + 3*
     +    s12*s14**2*s23*s24**2*s34 + 8*s12*s14**2*s23*s24*s34**2 + 7*
     +    s12*s14**2*s23*s34**3 + 2*s12*s14**2*s24*s34**3 + 2*s12*
     +    s14**2*s34**4 + 2*s12*s14*s23**3*s34**2 + 6*s12*s14*s23**2*
     +    s24*s34**2 + 7**s12*s14*s23**2*s34**3 + 4*s12*s14*s23*s24**2*
     +    s34**2 + 9*s12*s14*s23*s24*s34**3 + 6*s12*s14*s23*s34**4 + 
     +    s12*s14*s24*s34**4 + s12*s14*s34**5 + s12*s23**3*s34**3 + 2*
     +    s12*s23**2*s24*s34**3 )

      LNF = LNF + S13**(-1)*S24**(-1)*S34**(-2)*S234**(-2)*S134**(-2)
     +  * ( 2*s12*s23**2*s34**4 + s12*s23*s24**2*s34**3 + 2*s12*s23*s24
     +    *s34**4 + s12*s23*s34**5 - 2*s13**4*s23*s24**2 - 2*s13**4*s23
     +    *s24*s34 - 2*s13**4*s24**3 - 4*s13**4*s24**2*s34 - 2*s13**4*
     +    s24*s34**2 + 4*s13**3*s14*s23**2*s24 - s13**3*s14*s23*s24*s34
     +     - 4*s13**3*s14*s24**3 - 9*s13**3*s14*s24**2*s34 - 5*s13**3*
     +    s14*s24*s34**2 - 2*s13**3*s23**2*s24**2 - 4*s13**3*s23*s24**3
     +     - 8*s13**3*s23*s24**2*s34 - 4*s13**3*s23*s24*s34**2 - 2*
     +    s13**3*s24**4 - 8*s13**3*s24**3*s34 - 10*s13**3*s24**2*s34**2
     +     - 4*s13**3*s24*s34**3 - 2*s13**2*s14**2*s23**3 + 6*s13**2*
     +    s14**2*s23**2*s24 - 3*s13**2*s14**2*s23**2*s34 + 6*s13**2*
     +    s14**2*s23*s24**2 + 3*s13**2*s14**2*s23*s24*s34 - s13**2*
     +    s14**2*s23*s34**2 - 2*s13**2*s14**2*s24**3 - 6*s13**2*s14**2*
     +    s24**2*s34 - 4*s13**2*s14**2*s24*s34**2 + 4*s13**2*s14*s23**3
     +    *s24 + 6*s13**2*s14*s23**2*s24**2 + 16*s13**2*s14*s23**2*s24*
     +    s34 + 8*s13**2*s14*s23*s24**2*s34 + 6*s13**2*s14*s23*s24*
     +    s34**2 )

      LNF = LNF + S13**(-1)*S24**(-1)*S34**(-2)*S234**(-2)*S134**(-2)
     +  * (  - 2*s13**2*s14*s24**4 - 8*s13**2*s14*s24**3*s34 - 12*
     +    s13**2*s14*s24**2*s34**2 - 6*s13**2*s14*s24*s34**3 - s13**2*
     +    s23**3*s24*s34 - 6*s13**2*s23**2*s24**2*s34 - 2*s13**2*s23**2
     +    *s24*s34**2 - 9*s13**2*s23*s24**3*s34 - 12*s13**2*s23*s24**2*
     +    s34**2 - 3*s13**2*s23*s24*s34**3 - 4*s13**2*s24**4*s34 - 10*
     +    s13**2*s24**3*s34**2 - 8*s13**2*s24**2*s34**3 - 2*s13**2*s24*
     +    s34**4 - 4*s13*s14**3*s23**3 - 6*s13*s14**3*s23**2*s34 + 4*
     +    s13*s14**3*s23*s24**2 + s13*s14**3*s23*s24*s34 - 2*s13*s14**3
     +    *s23*s34**2 - s13*s14**3*s24**2*s34 - s13*s14**3*s24*s34**2
     +     - 2*s13*s14**2*s23**4 - 8*s13*s14**2*s23**3*s34 + 6*s13*
     +    s14**2*s23**2*s24**2 + 8*s13*s14**2*s23**2*s24*s34 - 8*s13*
     +    s14**2*s23**2*s34**2 + 4*s13*s14**2*s23*s24**3 + 16*s13*
     +    s14**2*s23*s24**2*s34 + 8*s13*s14**2*s23*s24*s34**2 - 2*s13*
     +    s14**2*s23*s34**3 - 2*s13*s14**2*s24**2*s34**2 - 2*s13*s14**2
     +    *s24*s34**3 - s13*s14*s23**4*s34 + s13*s14*s23**3*s24*s34 - 2
     +    *s13*s14*s23**3*s34**2 )

      LNF = LNF + S13**(-1)*S24**(-1)*S34**(-2)*S234**(-2)*S134**(-2)
     +  * ( 3*s13*s14*s23**2*s24**2*s34 + 8*s13*s14*s23**2*s24*s34**2
     +     - s13*s14*s23**2*s34**3 - s13*s14*s23*s24**3*s34 + 6*s13*s14
     +    *s23*s24**2*s34**2 + 6*s13*s14*s23*s24*s34**3 - 2*s13*s14*
     +    s24**4*s34 - 4*s13*s14*s24**3*s34**2 - 3*s13*s14*s24**2*
     +    s34**3 - s13*s14*s24*s34**4 - s13*s23**3*s24*s34**2 - 4*s13*
     +    s23**2*s24**2*s34**2 - 2*s13*s23**2*s24*s34**3 - 5*s13*s23*
     +    s24**3*s34**2 - 6*s13*s23*s24**2*s34**3 - s13*s23*s24*s34**4
     +     - 2*s13*s24**4*s34**2 - 4*s13*s24**3*s34**3 - 2*s13*s24**2*
     +    s34**4 - 2*s14**4*s23**3 - 2*s14**4*s23**2*s24 - 3*s14**4*
     +    s23**2*s34 - s14**4*s23*s24*s34 - s14**4*s23*s34**2 - 2*
     +    s14**3*s23**4 - 4*s14**3*s23**3*s24 - 8*s14**3*s23**3*s34 - 2
     +    *s14**3*s23**2*s24**2 - 8*s14**3*s23**2*s24*s34 - 8*s14**3*
     +    s23**2*s34**2 - 2*s14**3*s23*s24*s34**2 - 2*s14**3*s23*s34**3
     +     - 3*s14**2*s23**4*s34 - 6*s14**2*s23**3*s24*s34 - 8*s14**2*
     +    s23**3*s34**2 - 3*s14**2*s23**2*s24**2*s34 - 8*s14**2*s23**2*
     +    s24*s34**2 )

      LNF = LNF + S13**(-1)*S24**(-1)*S34**(-2)*S234**(-2)*S134**(-2)
     +  * (  - 6*s14**2*s23**2*s34**3 - s14**2*s23*s24*s34**3 - s14**2*
     +    s23*s34**4 - s14*s23**4*s34**2 - 2*s14*s23**3*s24*s34**2 - 2*
     +    s14*s23**3*s34**3 - s14*s23**2*s24**2*s34**2 - 2*s14*s23**2*
     +    s24*s34**3 - s14*s23**2*s34**4 )

      LNF = LNF*8d0/3d0

      return
      end
      function ua12(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)
      common/Lsa/Lc0a(12,12),Lc1a(12,14),Lc2a(12,14),Lc3a(12,14),
     . Lcd0a(8,12,8),Lcd1a(8,12,8),Lcd2a(8,12,8),Lcd3a(8,12,8),
     . Ld0a(8,12,12),Ld1sa(8,12,12),Ld2sa(8,12,12),Ld3sa(8,12,12),
     . Ld1a(8,12,12),Ld21a(8,12,12),Ld22a(8,12,12),
     . Ld24a(8,12,12),Ld311a(8,12,12),Ld314a(8,12,12),Ld322a(8,12,12),
     . Ld344a(8,12,12),Le1a(8,8,8,8)

      common/newas12/Ld21as12(8,12,12),Ld22as12(8,12,12),
     .Ld24as12(8,12,12),Ld311as12(8,12,12),
     .Ld314as12(8,12,12),Ld322as12(8,12,12)
      common/newas23/Ld21as23(8,12,12),Ld22as23(8,12,12),
     .Ld24as23(8,12,12),Ld311as23(8,12,12),
     .Ld314as23(8,12,12),Ld322as23(8,12,12)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      ua12=0d0

      ua12 = ua12 + log(s13**(-1)*s134)*S34**(-2)*S134**(-2) * (  - 32*
     +    s12*s13*s34 - 32*s12*s34**2 - 32*s13*s23*s34 - 32*s13*s24*s34
     +     - 32*s23*s34**2 - 32*s24*s34**2 )

      ua12 = ua12 + log(s13**(-1)*s1234)*S34**(-2)*S134**(-1) * ( 16*
     +    s12*s34 - 16*s13*s34 )

      ua12 = ua12 + log(s14**(-1)*s1234)*S34**(-2)*S134**(-1) * ( 16*
     +    s12*s34 + 16*s14*s34 + 32*s23*s34 + 32*s24*s34 )

      ua12 = ua12 + log(s14**(-1)*s1234)*S34**(-2)*S134**(-2) * (  - 32
     +    *s12*s13*s34 - 32*s13*s23*s34 - 32*s13*s24*s34 )

      ua12 = ua12 + log(s23**(-1)*s1234)*S34**(-2)*S234**(-1)*
     + S134**(-1) * (  - 16*s12*s13*s34 + 16*s12*s14*s34 - 16*s12*
     +    s34**2 + 16*s13*s14*s34 + 16*s13*s23*s34 + 16*s13*s34**2 + 16
     +    *s14*s23*s34 )

      ua12 = ua12 + log(s23**(-1)*s1234)*S34**(-2)*S134**(-1) * ( 32*
     +    s23*s34 + 16*s24*s34 - 16*s34**2 )

      ua12 = ua12 + log(s24**(-1)*s234)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12*s13*s34 + 16*s12*s14*s34 + 16*s12*s34**2 - 16*s13
     +    *s14*s34 + 16*s13*s23*s34 + 16*s13*s34**2 + 16*s14*s23*s34 )

      ua12 = ua12 + log(s24**(-1)*s1234)*S34**(-2)*S134**(-1) * (  - 16
     +    *s13*s34 - 16*s14*s34 - 16*s23*s34 - 32*s24*s34 + 16*s34**2 )

      ua12 = ua12 + log(s34**(-1)*s234)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * ( 32*s12*s13*s34 - 32*s12*s14*s34 - 32*s13*s23*s34 - 32*s13*
     +    s34**2 - 32*s14*s23*s34 )

      ua12 = ua12 + log(s34**(-1)*s134)*S34**(-2)*S134**(-2) * ( 64*s12
     +    *s13*s34 + 32*s12*s34**2 + 64*s13*s23*s34 + 64*s13*s24*s34 + 
     +    32*s23*s34**2 + 32*s24*s34**2 )

      ua12 = ua12 + log(s34**(-1)*s1234)*S34**(-2)*S134**(-1) * (  - 32
     +    *s23*s34 + 32*s34**2 )

      ua12 = ua12 + log(s234**(-1)*s1234)*S34**(-2)*S234**(-1)*
     + S134**(-1) * ( 16*s12*s13*s34 - 16*s12*s14*s34 + 16*s12*s34**2
     +     - 16*s13*s14*s34 - 16*s13*s23*s34 - 16*s13*s34**2 - 16*s14*
     +    s23*s34 )

      ua12 = ua12 + log(s234**(-1)*s1234)*S34**(-2)*S134**(-1) * ( 32*
     +    s13*s34 )

      ua12 = ua12 + log(s134**(-1)*s1234)*S34**(-2)*S134**(-1) * (  - 
     +    32*s12*s34 + 32*s13*s34 - 32*s14*s34 - 16*s23*s34 - 16*s24*
     +    s34 - 32*s34**2 )

      ua12 = ua12 + log(s134**(-1)*s1234)*S34**(-2)*S134**(-2) * ( 32*
     +    s12*s13*s34 + 32*s13*s23*s34 + 32*s13*s24*s34 )

      ua12 = ua12 + Lc0(p13,p24)*S34**(-2)*S134**(-1) * ( 32*s12**2*s34
     +     + 16*s12*s13*s34 + 16*s12*s14*s34 - 96*s12*s23*s34 - 48*s12*
     +    s34**2 - 16*s13*s23*s34 - 16*s13*s24*s34 - 16*s13*s34**2 + 16
     +    *s14**2*s34 + 16*s14*s23*s34 + 16*s14*s24*s34 + 16*s14*s34**2
     +     + 16*s23**2*s34 + 16*s23*s34**2 - 16*s24*s34**2 )

      ua12 = ua12 + Lc0(p14,p23)*S34**(-2)*S134**(-1) * (  - 32*s12**2*
     +    s34 - 16*s12*s13*s34 - 16*s12*s14*s34 + 96*s12*s24*s34 + 48*
     +    s12*s34**2 - 16*s13**2*s34 - 16*s13*s23*s34 - 16*s13*s24*s34
     +     - 16*s13*s34**2 + 16*s14*s23*s34 + 16*s14*s24*s34 + 16*s14*
     +    s34**2 + 16*s23*s34**2 - 16*s24**2*s34 - 16*s24*s34**2 )

      ua12 = ua12 + Lc1(p1,p34)*S34**(-2)*S134**(-1) * (  - 64*s12*s13*
     +    s34 - 32*s13*s23*s34 - 32*s13*s24*s34 - 64*s13*s34**2 )

      ua12 = ua12 + Lc1(p1,p234)*S34**(-2)*S134**(-1) * (  - 32*s13*s23
     +    *s34 + 32*s13*s34**2 - 32*s14*s23*s34 - 32*s14*s34**2 )

      ua12 = ua12 + Lc1(p2,p34)*S34**(-2)*S134**(-1) * (  - 32*s12*s13*
     +    s34 + 32*s12*s14*s34 + 32*s13*s23*s34 + 32*s14*s23*s34 )

      ua12 = ua12 + Lc1(p2,p134)*S34**(-2)*S134**(-1) * ( 32*s13*s23*
     +    s34 + 32*s14*s23*s34 )

      ua12 = ua12 + Lc1(p3,p14)*S34**(-2)*S134**(-1) * (  - 16*s12*
     +    s34**2 - 16*s14*s23*s34 - 32*s14*s34**2 - 32*s23*s34**2 - 16*
     +    s24*s34**2 )

      ua12 = ua12 + Lc1(p3,p24)*S34**(-2)*S134**(-1) * ( 16*s12*s13*s34
     +     - 32*s12*s34**2 + 16*s13*s14*s34 + 32*s13*s24*s34 + 48*s24*
     +    s34**2 - 16*s34**3 )

      ua12 = ua12 + Lc1(p4,p13)*S34**(-2)*S134**(-1) * ( 16*s12*s34**2
     +     + 16*s13*s24*s34 + 32*s13*s34**2 + 16*s23*s34**2 + 32*s24*
     +    s34**2 )

      ua12 = ua12 + Lc1(p4,p23)*S34**(-2)*S134**(-1) * (  - 16*s12*s14*
     +    s34 + 32*s12*s34**2 - 16*s13*s14*s34 - 32*s14*s23*s34 - 48*
     +    s23*s34**2 + 16*s34**3 )

      ua12 = ua12 + Lc1(p13,p24)*S34**(-2)*S134**(-1) * ( 16*s12*s14*
     +    s34 + 16*s12*s34**2 + 16*s13*s24*s34 + 16*s14**2*s34 + 16*s14
     +    *s24*s34 + 16*s14*s34**2 + 16*s23**2*s34 - 16*s24*s34**2 )

      ua12 = ua12 + Lc1(p14,p23)*S34**(-2)*S134**(-1) * (  - 16*s12*s13
     +    *s34 - 16*s12*s34**2 - 16*s13**2*s34 - 16*s13*s23*s34 - 16*
     +    s13*s34**2 - 16*s14*s23*s34 + 16*s23*s34**2 - 16*s24**2*s34 )

      ua12 = ua12 + Lc1(p23,p14)*S34**(-2)*S134**(-1) * ( 16*s12**2*s34
     +     + 16*s12*s13*s34 + 16*s12*s14*s34 - 32*s12*s24*s34 - 16*s12*
     +    s34**2 + 16*s13*s14*s34 + 16*s13*s24*s34 + 16*s14*s24*s34 + 
     +    16*s14*s34**2 - 16*s24**2*s34 - 16*s24*s34**2 )

      ua12 = ua12 + Lc1(p24,p13)*S34**(-2)*S134**(-1) * (  - 16*s12**2*
     +    s34 - 16*s12*s13*s34 - 16*s12*s14*s34 + 32*s12*s23*s34 + 16*
     +    s12*s34**2 - 16*s13*s14*s34 - 16*s13*s23*s34 - 16*s13*s34**2
     +     - 16*s14*s23*s34 + 16*s23**2*s34 + 16*s23*s34**2 )

      ua12 = ua12 + Lcd0(p1,p34,p2)*S34**(-2)*S134**(-1) * ( 32*s13*s24
     +    *s34**2 - 32*s14*s23*s34**2 )

      ua12 = ua12 + Lcd1(p1,p34,p2)*S34**(-2)*S134**(-1) * (  - 32*s13*
     +    s23**2*s34 - 32*s13*s23*s24*s34 - 32*s14*s23**2*s34 - 32*s14*
     +    s23*s24*s34 )

      ua12 = ua12 + Lcd1(p2,p34,p1)*S34**(-2)*S134**(-1) * ( 32*s13**2*
     +    s23*s34 + 32*s13**2*s24*s34 + 32*s13*s14*s23*s34 + 32*s13*s14
     +    *s24*s34 )

      ua12 = ua12 + Ld0(p1,p3,p4)*S34**(-2)*S134**(-1) * (  - 64*s12*
     +    s13 - 32*s12*s14 - 32*s12*s34 + 16*s13*s14 - 64*s13*s23 - 80*
     +    s13*s24 - 16*s14**2 - 48*s14*s23 + 32*s14*s24 - 32*s14*s34 - 
     +    64*s23*s34 - 16*s34**2 )

      ua12 = ua12 + Ld0(p1,p3,p4)*S34**(-2)*S134**(-2) * ( 128*s12*s13*
     +    s14 + 128*s12*s13*s34 + 64*s12*s14*s34 + 32*s12*s34**2 + 128*
     +    s13*s14*s23 + 128*s13*s14*s24 + 128*s13*s23*s34 + 128*s13*s24
     +    *s34 + 64*s14*s23*s34 + 64*s14*s24*s34 + 32*s23*s34**2 + 32*
     +    s24*s34**2 )

      ua12 = ua12 + Ld0(p1,p3,p24)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +    64*s12**2*s34 - 64*s12*s13*s24 + 32*s12*s13*s34 + 64*s12*s14*
     +    s24 + 96*s12*s14*s34 + 32*s12*s34**2 - 32*s13**2*s24 - 32*s13
     +    *s14*s34 - 32*s13*s23*s24 - 32*s13*s23*s34 - 96*s13*s24**2 - 
     +    96*s13*s24*s34 - 32*s13*s34**2 + 32*s14**2*s24 + 32*s14**2*
     +    s34 + 96*s14*s23*s24 + 96*s14*s23*s34 + 32*s14*s24**2 + 96*
     +    s14*s24*s34 + 64*s14*s34**2 + 64*s23**2*s34 + 32*s23*s24*s34
     +     + 96*s23*s34**2 - 32*s24**2*s34 + 32*s34**3 )

      ua12 = ua12 + Ld0(p1,p3,p24)*S34**(-2)*S134**(-1) * ( 64*s12*s13
     +     - 32*s12*s14 + 16*s13*s14 + 64*s13*s23 + 80*s13*s24 + 32*s13
     +    *s34 - 16*s14**2 - 48*s14*s23 - 64*s14*s24 - 32*s14*s34 - 16*
     +    s23*s34 - 16*s34**2 )

      ua12 = ua12 + Ld0(p1,p4,p3)*S34**(-2)*S134**(-1) * ( 32*s12*s13
     +     + 64*s12*s14 + 32*s12*s34 + 16*s13**2 - 16*s13*s14 - 32*s13*
     +    s23 + 48*s13*s24 + 32*s13*s34 + 80*s14*s23 + 64*s14*s24 + 64*
     +    s24*s34 + 16*s34**2 )

      ua12 = ua12 + Ld0(p1,p4,p3)*S34**(-2)*S134**(-2) * (  - 128*s12*
     +    s13*s14 - 64*s12*s13*s34 - 128*s12*s14*s34 - 32*s12*s34**2 - 
     +    128*s13*s14*s23 - 128*s13*s14*s24 - 64*s13*s23*s34 - 64*s13*
     +    s24*s34 - 128*s14*s23*s34 - 128*s14*s24*s34 - 32*s23*s34**2
     +     - 32*s24*s34**2 )

      ua12 = ua12 + Ld0(p1,p4,p23)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 64*s12**2*s34 - 64*s12*s13*s23 - 96*s12*s13*s34 + 64*s12*
     +    s14*s23 - 32*s12*s14*s34 - 32*s12*s34**2 - 32*s13**2*s23 - 32
     +    *s13**2*s34 + 32*s13*s14*s34 - 32*s13*s23**2 - 96*s13*s23*s24
     +     - 96*s13*s23*s34 - 96*s13*s24*s34 - 64*s13*s34**2 + 32*
     +    s14**2*s23 + 96*s14*s23**2 + 32*s14*s23*s24 + 96*s14*s23*s34
     +     + 32*s14*s24*s34 + 32*s14*s34**2 + 32*s23**2*s34 - 32*s23*
     +    s24*s34 - 64*s24**2*s34 - 96*s24*s34**2 - 32*s34**3 )

      ua12 = ua12 + Ld0(p1,p4,p23)*S34**(-2)*S134**(-1) * ( 32*s12*s13
     +     - 64*s12*s14 + 16*s13**2 - 16*s13*s14 + 64*s13*s23 + 48*s13*
     +    s24 + 32*s13*s34 - 80*s14*s23 - 64*s14*s24 - 32*s14*s34 + 16*
     +    s24*s34 + 16*s34**2 )

      ua12 = ua12 + Ld0(p2,p3,p4)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 64*s12**2*s34 + 64*s12*s13*s24 + 64*s12*s14*s23 - 16*s12*
     +    s14*s34 - 32*s12*s23*s34 - 32*s12*s24*s34 - 48*s12*s34**2 + 
     +    32*s13**2*s24 - 16*s13*s14*s23 - 16*s13*s14*s24 - 32*s13*s23*
     +    s24 - 16*s13*s23*s34 + 32*s13*s24**2 + 16*s13*s24*s34 + 16*
     +    s14**2*s23 + 32*s14*s23**2 - 32*s14*s23*s24 - 16*s14*s23*s34
     +     )

      ua12 = ua12 + Ld0(p2,p3,p4)*S34**(-2)*S134**(-1) * (  - 32*s12*
     +    s13 - 64*s12*s14 - 32*s12*s34 - 16*s13**2 + 32*s13*s23 + 16*
     +    s13*s24 - 16*s13*s34 - 16*s14*s23 - 64*s14*s24 - 32*s14*s34
     +     - 16*s24*s34 - 16*s34**2 )

      ua12 = ua12 + Ld0(p2,p3,p14)*S34**(-2)*S134**(-1) * ( 32*s12*s13
     +     + 16*s13**2 + 16*s13*s14 - 32*s13*s23 + 48*s13*s24 + 32*s13*
     +    s34 - 32*s14**2 - 16*s14*s23 + 32*s14*s24 + 32*s14*s34 - 32*
     +    s23*s34 + 16*s24*s34 + 16*s34**2 )

      ua12 = ua12 + Ld0(p2,p3,p14)*S34**(-2)*S134**(-2) * (  - 64*s12*
     +    s13*s14 - 32*s12*s13*s34 + 64*s12*s14**2 + 32*s12*s14*s34 + 
     +    32*s12*s34**2 - 32*s13**2*s14 - 32*s13**2*s34 - 32*s13*s14*
     +    s23 - 96*s13*s14*s24 - 64*s13*s14*s34 - 32*s13*s23*s34 - 64*
     +    s13*s24*s34 - 32*s13*s34**2 + 32*s14**3 + 96*s14**2*s23 + 32*
     +    s14**2*s24 + 32*s14**2*s34 + 64*s14*s23*s34 - 32*s14*s24*s34
     +     + 32*s23*s34**2 )

      ua12 = ua12 + Ld0(p2,p4,p3)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +    64*s12**2*s34 - 64*s12*s13*s24 + 16*s12*s13*s34 - 64*s12*s14*
     +    s23 + 32*s12*s23*s34 + 32*s12*s24*s34 + 48*s12*s34**2 - 16*
     +    s13**2*s24 + 16*s13*s14*s23 + 16*s13*s14*s24 + 32*s13*s23*s24
     +     - 32*s13*s24**2 + 16*s13*s24*s34 - 32*s14**2*s23 - 32*s14*
     +    s23**2 + 32*s14*s23*s24 - 16*s14*s23*s34 + 16*s14*s24*s34 )

      ua12 = ua12 + Ld0(p2,p4,p3)*S34**(-2)*S134**(-1) * ( 64*s12*s13
     +     + 32*s12*s14 + 32*s12*s34 + 64*s13*s23 + 16*s13*s24 + 32*s13
     +    *s34 + 16*s14**2 - 16*s14*s23 - 32*s14*s24 + 16*s14*s34 + 16*
     +    s23*s34 + 16*s34**2 )

      ua12 = ua12 + Ld0(p2,p4,p13)*S34**(-2)*S134**(-1) * (  - 32*s12*
     +    s14 + 32*s13**2 - 16*s13*s14 - 32*s13*s23 + 16*s13*s24 - 32*
     +    s13*s34 - 16*s14**2 - 48*s14*s23 + 32*s14*s24 - 32*s14*s34 - 
     +    16*s23*s34 + 32*s24*s34 - 16*s34**2 )

      ua12 = ua12 + Ld0(p2,p4,p13)*S34**(-2)*S134**(-2) * (  - 64*s12*
     +    s13**2 + 64*s12*s13*s14 - 32*s12*s13*s34 + 32*s12*s14*s34 - 
     +    32*s12*s34**2 - 32*s13**3 - 32*s13**2*s23 - 96*s13**2*s24 - 
     +    32*s13**2*s34 + 32*s13*s14**2 + 96*s13*s14*s23 + 32*s13*s14*
     +    s24 + 64*s13*s14*s34 + 32*s13*s23*s34 - 64*s13*s24*s34 + 32*
     +    s14**2*s34 + 64*s14*s23*s34 + 32*s14*s24*s34 + 32*s14*s34**2
     +     - 32*s24*s34**2 )

      ua12 = ua12 + Ld1(p1,p3,p4)*S34**(-2)*S134**(-1) * ( 16*s12*
     +    s34**2 - 16*s13*s24*s34 )

      ua12 = ua12 + Ld1(p1,p3,p24)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +    32*s12**2*s23*s34 - 32*s12**2*s24*s34 + 16*s12*s13*s23*s34 - 
     +    48*s12*s13*s24*s34 + 48*s12*s14*s23*s34 - 16*s12*s14*s24*s34
     +     - 64*s12*s23**2*s34 - 32*s12*s23*s24*s34 - 48*s12*s23*s34**2
     +     - 32*s12*s24**2*s34 - 16*s12*s24*s34**2 - 16*s13**2*s24*s34
     +     + 16*s13*s14*s23*s34 - 16*s13*s14*s24*s34 + 32*s13*s23*s24*
     +    s34 + 16*s13*s24*s34**2 + 16*s14**2*s23*s34 - 32*s14*s23**2*
     +    s34 - 16*s14*s23*s34**2 )

      ua12 = ua12 + Ld1(p1,p3,p24)*S34**(-2)*S134**(-1) * ( 32*s12**2*
     +    s34 + 16*s12*s13*s34 + 16*s12*s14*s34 - 32*s12*s23*s34 + 32*
     +    s12*s24*s34 - 16*s12*s34**2 )

      ua12 = ua12 + Ld1(p1,p4,p3)*S34**(-2)*S134**(-1) * (  - 16*s12*
     +    s34**2 + 16*s14*s23*s34 )

      ua12 = ua12 + Ld1(p1,p4,p23)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +    32*s12**2*s23*s34 - 32*s12**2*s24*s34 + 16*s12*s13*s23*s34 - 
     +    48*s12*s13*s24*s34 + 48*s12*s14*s23*s34 - 16*s12*s14*s24*s34
     +     + 32*s12*s23**2*s34 + 32*s12*s23*s24*s34 + 16*s12*s23*s34**2
     +     + 64*s12*s24**2*s34 + 48*s12*s24*s34**2 - 16*s13**2*s24*s34
     +     + 16*s13*s14*s23*s34 - 16*s13*s14*s24*s34 + 32*s13*s24**2*
     +    s34 + 16*s13*s24*s34**2 + 16*s14**2*s23*s34 - 32*s14*s23*s24*
     +    s34 - 16*s14*s23*s34**2 )

      ua12 = ua12 + Ld1(p1,p4,p23)*S34**(-2)*S134**(-1) * (  - 32*
     +    s12**2*s34 - 16*s12*s13*s34 - 16*s12*s14*s34 - 32*s12*s23*s34
     +     + 32*s12*s24*s34 + 16*s12*s34**2 )

      ua12 = ua12 + Ld1(p2,p3,p4)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 32*s12**2*s34**2 + 16*s12*s13*s34**2 + 48*s12*s14*s23*s34
     +     - 16*s12*s23*s34**2 + 16*s13*s14*s23*s34 - 16*s14**2*s23**2
     +     + 16*s14*s23**2*s34 )

      ua12 = ua12 + Ld1(p2,p3,p4)*S34**(-2)*S134**(-1) * (  - 16*s12*
     +    s14*s34 - 16*s12*s34**2 + 16*s14**2*s23 + 16*s14*s23*s34 )

      ua12 = ua12 + Ld1(p2,p3,p14)*S34**(-2)*S134**(-1) * ( 16*s12*s13*
     +    s34 + 16*s12*s14*s34 + 16*s12*s34**2 )

      ua12 = ua12 + Ld1(p2,p3,p14)*S34**(-2)*S134**(-2) * ( 16*s12*
     +    s13**2*s34 + 16*s12*s13*s34**2 - 16*s12*s14**2*s34 - 16*s12*
     +    s14*s34**2 + 16*s13**2*s24*s34 - 16*s13*s14*s23*s34 + 16*s13*
     +    s14*s24*s34 + 16*s13*s24*s34**2 - 16*s14**2*s23*s34 - 16*s14*
     +    s23*s34**2 )

      ua12 = ua12 + Ld1(p2,p4,p3)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +    32*s12**2*s34**2 - 48*s12*s13*s24*s34 - 16*s12*s14*s34**2 + 
     +    16*s12*s24*s34**2 + 16*s13**2*s24**2 - 16*s13*s14*s24*s34 - 
     +    16*s13*s24**2*s34 )

      ua12 = ua12 + Ld1(p2,p4,p3)*S34**(-2)*S134**(-1) * ( 16*s12*s13*
     +    s34 + 16*s12*s34**2 - 16*s13**2*s24 - 16*s13*s24*s34 )

      ua12 = ua12 + Ld1(p2,p4,p13)*S34**(-2)*S134**(-1) * (  - 16*s12*
     +    s13*s34 - 16*s12*s14*s34 - 16*s12*s34**2 )

      ua12 = ua12 + Ld1(p2,p4,p13)*S34**(-2)*S134**(-2) * ( 16*s12*
     +    s13**2*s34 + 16*s12*s13*s34**2 - 16*s12*s14**2*s34 - 16*s12*
     +    s14*s34**2 + 16*s13**2*s24*s34 - 16*s13*s14*s23*s34 + 16*s13*
     +    s14*s24*s34 + 16*s13*s24*s34**2 - 16*s14**2*s23*s34 - 16*s14*
     +    s23*s34**2 )

      ua12 = ua12 + Ld21(p1,p3,p24)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * (  - 16*s13*s23**2*s34 - 32*s13*s23*s24*s34 - 16*s13*s24**2*
     +    s34 )

      ua12 = ua12 + Ld21(p1,p4,p23)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * ( 16*s14*s23**2*s34 + 32*s14*s23*s24*s34 + 16*s14*s24**2*s34
     +     )

      ua12 = ua12 + Ld21(p2,p3,p4)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +    16*s12**2*s34**2 )

      ua12 = ua12 + Ld21(p2,p4,p3)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 16*s12**2*s34**2 )

      ua12 = ua12 + Ld21(p3,p4,p2)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +    32*s12*s13*s34**2 - 16*s13**2*s24*s34 )

      ua12 = ua12 + Ld21(p4,p3,p2)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 32*s12*s14*s34**2 + 16*s14**2*s23*s34 )

      ua12 = ua12 + Ld22(p1,p3,p24)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * ( 16*s12*s23**2*s34 - 16*s13*s23**2*s34 - 32*s13*s23*s24*s34
     +     + 16*s14*s23**2*s34 )

      ua12 = ua12 + Ld22(p1,p4,p23)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12*s24**2*s34 - 16*s13*s24**2*s34 + 32*s14*s23*s24*
     +    s34 + 16*s14*s24**2*s34 )

      ua12 = ua12 + Ld24(p1,p3,p24)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * (  - 48*s12**2*s23*s34 - 16*s12**2*s34**2 + 32*s12*s13*s24*
     +    s34 - 32*s12*s14*s23*s34 )

      ua12 = ua12 + Ld24(p1,p4,p23)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * ( 48*s12**2*s24*s34 + 16*s12**2*s34**2 + 32*s12*s13*s24*s34
     +     - 32*s12*s14*s23*s34 )

      ua12 = ua12 + Le1(p1,p3,p4,p2)*S34**(-2)*S134**(-1) * (  - 32*
     +    s12**2*s13*s34 + 64*s12*s13**2*s23 + 32*s12*s13**2*s24 + 16*
     +    s12*s13**2*s34 - 16*s12*s13*s14*s34 - 48*s12*s13*s23*s34 - 32
     +    *s12*s13*s24*s34 - 32*s12*s13*s34**2 + 32*s12*s14**2*s24 + 48
     +    *s12*s14*s24*s34 + 16*s12*s24*s34**2 - 16*s13**3*s24 - 16*
     +    s13**2*s14*s24 + 64*s13**2*s23**2 + 128*s13**2*s23*s24 + 32*
     +    s13**2*s23*s34 + 32*s13**2*s24**2 + 32*s13**2*s24*s34 + 16*
     +    s13*s14**2*s24 - 64*s13*s14*s24**2 + 32*s13*s14*s24*s34 - 16*
     +    s13*s23**2*s34 - 16*s13*s23*s34**2 - 16*s13*s24**2*s34 + 16*
     +    s14**3*s24 - 32*s14**2*s24**2 + 32*s14**2*s24*s34 - 32*s14*
     +    s24**2*s34 + 16*s14*s24*s34**2 )

      ua12 = ua12 + Le1(p1,p4,p3,p2)*S34**(-2)*S134**(-1) * ( 32*s12**2
     +    *s14*s34 - 32*s12*s13**2*s23 + 16*s12*s13*s14*s34 - 48*s12*
     +    s13*s23*s34 - 32*s12*s14**2*s23 - 64*s12*s14**2*s24 - 16*s12*
     +    s14**2*s34 + 32*s12*s14*s23*s34 + 48*s12*s14*s24*s34 + 32*s12
     +    *s14*s34**2 - 16*s12*s23*s34**2 - 16*s13**3*s23 - 16*s13**2*
     +    s14*s23 + 32*s13**2*s23**2 - 32*s13**2*s23*s34 + 16*s13*
     +    s14**2*s23 + 64*s13*s14*s23**2 - 32*s13*s14*s23*s34 + 32*s13*
     +    s23**2*s34 - 16*s13*s23*s34**2 + 16*s14**3*s23 - 32*s14**2*
     +    s23**2 - 128*s14**2*s23*s24 - 32*s14**2*s23*s34 - 64*s14**2*
     +    s24**2 - 32*s14**2*s24*s34 + 16*s14*s23**2*s34 + 16*s14*
     +    s24**2*s34 + 16*s14*s24*s34**2 )

      return
      end
      
            function ub12(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)
      common/Lsa/Lc0a(12,12),Lc1a(12,14),Lc2a(12,14),Lc3a(12,14),
     . Lcd0a(8,12,8),Lcd1a(8,12,8),Lcd2a(8,12,8),Lcd3a(8,12,8),
     . Ld0a(8,12,12),Ld1sa(8,12,12),Ld2sa(8,12,12),Ld3sa(8,12,12),
     . Ld1a(8,12,12),Ld21a(8,12,12),Ld22a(8,12,12),
     . Ld24a(8,12,12),Ld311a(8,12,12),Ld314a(8,12,12),Ld322a(8,12,12),
     . Ld344a(8,12,12),Le1a(8,8,8,8)

      common/newas12/Ld21as12(8,12,12),Ld22as12(8,12,12),
     .Ld24as12(8,12,12),Ld311as12(8,12,12),
     .Ld314as12(8,12,12),Ld322as12(8,12,12)
      common/newas23/Ld21as23(8,12,12),Ld22as23(8,12,12),
     .Ld24as23(8,12,12),Ld311as23(8,12,12),
     .Ld314as23(8,12,12),Ld322as23(8,12,12)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      ub12=0d0

      ub12 = ub12 + S34**(-2)*S234**(-1)*S134**(-1) * (  - 272*s12**2*
     +    s34 - 272*s12*s13*s23 - 408*s12*s13*s34 + 272*s12*s14*s23 - 
     +    136*s12*s14*s34 - 136*s12*s34**2 - 136*s13**2*s23 - 136*
     +    s13**2*s34 + 136*s13*s14*s34 + 272*s13*s23**2 + 408*s13*s23*
     +    s34 + 136*s13*s34**2 + 136*s14**2*s23 + 272*s14*s23**2 + 136*
     +    s14*s23*s34 )

      ub12 = ub12 + S34**(-2)*S134**(-1) * (  - 256*s12*s13 - 392*s12*
     +    s34 + 104*s13**2 - 104*s13*s14 - 784*s13*s23 - 136*s13*s24 - 
     +    88*s13*s34 + 136*s14*s23 + 16*s14*s34 - 272*s23*s34 - 272*s24
     +    *s34 )

      ub12 = ub12 + S34**(-2)*S134**(-2) * ( 544*s12*s13**2 + 544*s12*
     +    s13*s34 + 272*s12*s34**2 + 544*s13**2*s23 + 544*s13**2*s24 + 
     +    544*s13*s23*s34 + 544*s13*s24*s34 + 272*s23*s34**2 + 272*s24*
     +    s34**2 )

      ub12 = ub12 + log(s12**(-1)*s1234)*S34**(-2)*S134**(-1) * ( 128*
     +    s12*s13 - 192*s12*s14 - 160*s12*s23 - 192*s12*s24 + 128*s12*
     +    s34 - 32*s13**2 + 96*s13*s23 + 64*s13*s24 + 64*s13*s34 - 64*
     +    s14*s23 - 96*s14*s24 - 64*s14*s34 - 128*s23**2 - 160*s23*s24
     +     + 64*s23*s34 - 64*s24**2 - 128*s24*s34 )

      ub12 = ub12 + log(s34**(-1)*s1234)*S34**(-2)*S134**(-1) * ( 48*
     +    s12*s13 + 56*s12*s34 - 24*s13**2 + 24*s13*s14 + 112*s13*s23
     +     - 8*s13*s24 + 168*s13*s34 - 96*s14**2 - 184*s14*s23 - 192*
     +    s14*s24 + 96*s14*s34 - 80*s23**2 - 176*s23*s24 + 72*s23*s34
     +     - 96*s24**2 + 112*s24*s34 + 32*s34**2 )

      ub12 = ub12 + log(s234**(-1)*s1234)*S34**(-2)*S234**(-1)*
     + S134**(-1) * ( 48*s12**2*s34 + 48*s12*s13*s23 + 72*s12*s13*s34
     +     - 48*s12*s14*s23 + 24*s12*s14*s34 + 24*s12*s34**2 + 24*
     +    s13**2*s23 + 24*s13**2*s34 - 24*s13*s14*s34 - 48*s13*s23**2
     +     - 72*s13*s23*s34 - 24*s13*s34**2 - 24*s14**2*s23 - 48*s14*
     +    s23**2 - 24*s14*s23*s34 )

      ub12 = ub12 + log(s234**(-1)*s1234)*S34**(-2)*S134**(-1) * (  - 
     +    64*s13*s34 - 48*s14*s34 )

      ub12 = ub12 + log(s134**(-1)*s1234)*S34**(-2)*S134**(-1) * ( 32*
     +    s13**2 - 16*s13*s34 - 16*s14*s34 + 40*s23*s34 - 64*s34**2 )

      ub12 = ub12 + log(s134**(-1)*s1234)*S34**(-2)*S134**(-2) * (  - 
     +    96*s12*s13**2 - 96*s12*s13*s34 - 48*s12*s34**2 - 96*s13**2*
     +    s23 - 96*s13**2*s24 - 96*s13*s23*s34 - 96*s13*s24*s34 - 48*
     +    s23*s34**2 - 48*s24*s34**2 )

      ub12 = ub12 + Lc0(p12,p34)*S34**(-2)*S134**(-1) * (  - 48*s12**2*
     +    s34 + 32*s12*s13**2 - 64*s12*s13*s14 - 32*s12*s13*s23 + 32*
     +    s12*s13*s24 - 256*s12*s13*s34 + 96*s12*s14**2 + 224*s12*s14*
     +    s23 + 192*s12*s14*s24 + 64*s12*s14*s34 + 80*s12*s23**2 + 176*
     +    s12*s23*s24 + 64*s12*s23*s34 + 96*s12*s24**2 + 96*s12*s24*s34
     +     - 176*s12*s34**2 + 48*s13**3 + 32*s13**2*s14 - 256*s13**2*
     +    s23 + 48*s13**2*s24 + 16*s13**2*s34 - 16*s13*s14**2 - 304*s13
     +    *s14*s23 - 16*s13*s14*s24 + 16*s13*s14*s34 + 16*s13*s23**2 - 
     +    48*s13*s23*s24 - 272*s13*s23*s34 - 32*s13*s24*s34 - 48*s13*
     +    s34**2 + 16*s14**2*s23 + 80*s14*s23**2 + 16*s14*s23*s24 + 32*
     +    s14*s23*s34 + 80*s14*s24*s34 + 80*s14*s34**2 + 128*s23**2*s34
     +     + 144*s23*s24*s34 - 80*s23*s34**2 + 48*s24**2*s34 + 112*s24*
     +    s34**2 )

      ub12 = ub12 + Lc1(p1,p34)*S34**(-2)*S134**(-1) * (  - 96*s12*
     +    s13**2 - 32*s12*s13*s34 - 8*s12*s34**2 - 96*s13**2*s23 - 96*
     +    s13**2*s24 - 96*s13**2*s34 + 24*s13*s23*s34 - 56*s13*s24*s34
     +     - 96*s13*s34**2 )

      ub12 = ub12 + Lc1(p1,p234)*S34**(-2)*S134**(-1) * ( 96*s13**2*s23
     +     + 48*s13**2*s24 + 112*s13**2*s34 + 48*s13*s14*s23 - 16*s13*
     +    s14*s24 + 32*s13*s14*s34 - 32*s13*s23*s34 - 32*s13*s34**2 + 
     +    16*s14**2*s23 + 48*s14**2*s34 - 32*s14*s24*s34 - 32*s14*
     +    s34**2 )

      ub12 = ub12 + Lc1(p2,p34)*S34**(-2)*S134**(-1) * ( 48*s12**2*s34
     +     + 48*s12*s13*s23 + 40*s12*s13*s34 - 48*s12*s14*s23 + 24*s12*
     +    s14*s34 + 8*s12*s34**2 + 24*s13**2*s23 - 80*s13*s23**2 - 120*
     +    s13*s23*s34 - 24*s14**2*s23 - 80*s14*s23**2 - 40*s14*s23*s34
     +     )

      ub12 = ub12 + Lc1(p2,p134)*S34**(-2)*S134**(-1) * ( 96*s13**2*s23
     +     - 16*s13**2*s24 + 112*s13*s14*s23 - 16*s13*s14*s24 + 176*s13
     +    *s23*s34 + 16*s14**2*s23 + 96*s14*s23*s34 + 16*s14*s24*s34 + 
     +    80*s23*s34**2 + 16*s24*s34**2 )

      ub12 = ub12 + Lc1(p12,p34)*S34**(-2)*S134**(-1) * ( 208*s12*s13*
     +    s34 - 368*s12*s14*s34 - 304*s12*s23*s34 - 368*s12*s24*s34 + 
     +    320*s12*s34**2 + 96*s13*s14**2 + 192*s13*s14*s23 + 224*s13*
     +    s14*s24 - 128*s13*s14*s34 + 144*s13*s23**2 + 240*s13*s23*s24
     +     + 64*s13*s23*s34 + 128*s13*s24**2 - 128*s13*s24*s34 + 144*
     +    s13*s34**2 + 96*s14**3 + 256*s14**2*s23 + 288*s14**2*s24 - 96
     +    *s14**2*s34 + 272*s14*s23**2 + 528*s14*s23*s24 - 288*s14*s23*
     +    s34 + 288*s14*s24**2 - 352*s14*s24*s34 - 176*s14*s34**2 + 80*
     +    s23**3 + 256*s23**2*s24 - 320*s23**2*s34 + 272*s23*s24**2 - 
     +    448*s23*s24*s34 + 80*s23*s34**2 + 96*s24**3 - 192*s24**2*s34
     +     - 240*s24*s34**2 )

      ub12 = ub12 + Lc1(p34,p12)*S34**(-2)*S134**(-1) * ( 96*s14**2*s23
     +     + 96*s14**2*s24 + 64*s14**2*s34 + 160*s14*s23**2 + 320*s14*
     +    s23*s24 + 64*s14*s23*s34 + 160*s14*s24**2 + 192*s14*s24*s34
     +     + 128*s23**3 + 288*s23**2*s24 - 64*s23**2*s34 + 224*s23*
     +    s24**2 + 64*s23*s24*s34 + 64*s24**3 + 128*s24**2*s34 )

      ub12 = ub12 + Lc2(p1,p34)*S34**(-2)*S134**(-1) * (  - 32*s12*
     +    s13**2 - 16*s13**2*s23 - 16*s13**2*s24 - 32*s13**2*s34 )

      ub12 = ub12 + Lc2(p1,p234)*S34**(-2)*S134**(-1) * (  - 16*s13**2*
     +    s34 - 16*s14**2*s34 )

      ub12 = ub12 + Lc2(p2,p34)*S34**(-2)*S134**(-1) * ( 16*s12**2*s34
     +     + 16*s12*s13*s23 - 16*s12*s14*s23 - 16*s13*s23**2 - 16*s14*
     +    s23**2 )

      ub12 = ub12 + Lc2(p12,p34)*S34**(-2)*S134**(-1) * ( 192*s12*s13*
     +    s34 + 64*s12*s14*s34 + 64*s13**3 + 64*s13**2*s23 - 128*s13**2
     +    *s34 - 64*s13*s14**2 - 128*s13*s14*s34 - 128*s13*s23*s34 - 64
     +    *s14**2*s23 - 128*s14*s23*s34 )

      ub12 = ub12 + Lc3(p12,p34)*S34**(-2)*S134**(-1) * (  - 128*s13**2
     +    *s34 - 128*s13*s14*s34 + 64*s13*s34**2 + 64*s14*s34**2 )

      ub12 = ub12 + Lc3(p34,p12)*S34**(-2)*S134**(-1) * (  - 64*s12**2*
     +    s34 - 64*s12*s13**2 + 64*s12*s13*s14 - 64*s12*s13*s23 + 64*
     +    s12*s14*s23 + 64*s13**3 + 64*s13**2*s14 + 128*s13**2*s23 + 
     +    128*s13*s14*s23 + 64*s13*s23**2 + 64*s14*s23**2 )

      ub12 = ub12 + Ld0(p1,p2,p34)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 64*s12**2*s34 - 64*s12*s13*s23 - 96*s12*s13*s34 + 64*s12*
     +    s14*s23 - 32*s12*s14*s34 - 32*s12*s34**2 - 32*s13**2*s23 - 32
     +    *s13**2*s34 + 32*s13*s14*s34 + 64*s13*s23**2 + 96*s13*s23*s34
     +     + 32*s13*s34**2 + 32*s14**2*s23 + 64*s14*s23**2 + 32*s14*s23
     +    *s34 )

      ub12 = ub12 + Ld0(p2,p1,p34)*S34**(-2)*S134**(-2) * ( 64*s12*
     +    s13**2 - 64*s12*s13*s14 + 32*s12*s13*s34 - 32*s12*s14*s34 + 
     +    32*s12*s34**2 + 64*s13**3 + 64*s13**2*s14 + 32*s13**2*s23 + 
     +    96*s13**2*s24 + 128*s13**2*s34 - 96*s13*s14*s23 - 32*s13*s14*
     +    s24 + 64*s13*s14*s34 - 32*s13*s23*s34 + 64*s13*s24*s34 + 96*
     +    s13*s34**2 - 64*s14*s23*s34 - 32*s14*s24*s34 + 32*s14*s34**2
     +     + 32*s24*s34**2 + 32*s34**3 )

      ub12 = ub12 + Ld1(p1,p2,p34)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 32*s12**2*s13*s34 + 32*s12**2*s14*s34 + 32*s12*s13**2*s23
     +     - 48*s12*s13**2*s34 + 32*s12*s13*s14*s34 + 64*s12*s13*s23*
     +    s34 + 48*s12*s13*s34**2 - 32*s12*s14**2*s23 + 16*s12*s14**2*
     +    s34 + 64*s12*s14*s23*s34 + 16*s12*s14*s34**2 + 16*s13**3*s23
     +     - 16*s13**3*s34 + 16*s13**2*s14*s23 - 128*s13**2*s23**2 - 64
     +    *s13**2*s23*s24 - 112*s13**2*s23*s34 - 64*s13**2*s24*s34 - 16
     +    *s13**2*s34**2 - 16*s13*s14**2*s23 + 16*s13*s14**2*s34 - 192*
     +    s13*s14*s23**2 - 64*s13*s14*s23*s24 - 128*s13*s14*s23*s34 - 
     +    64*s13*s14*s24*s34 - 48*s13*s14*s34**2 - 16*s14**3*s23 - 64*
     +    s14**2*s23**2 - 16*s14**2*s23*s34 )

      ub12 = ub12 + Ld1(p1,p2,p34)*S34**(-2)*S134**(-1) * ( 32*s12*
     +    s13**2 - 32*s12*s13*s14 + 16*s13**3 - 64*s13**2*s23 + 16*
     +    s13**2*s34 - 16*s13*s14**2 - 64*s13*s14*s23 + 48*s13*s14*s34
     +     )

      ub12 = ub12 + Ld1(p2,p1,p34)*S34**(-2)*S134**(-1) * (  - 32*s12*
     +    s13*s23 + 32*s12*s14*s23 - 64*s13**2*s23 - 64*s13*s14*s23 - 
     +    16*s13*s23**2 - 48*s13*s23*s24 - 32*s13*s23*s34 + 48*s14*
     +    s23**2 + 16*s14*s23*s24 + 32*s14*s23*s34 + 16*s23**2*s34 - 16
     +    *s23*s24*s34 + 32*s23*s34**2 )

      ub12 = ub12 + Ld1(p2,p1,p34)*S34**(-2)*S134**(-2) * ( 32*s12**2*
     +    s13*s34 - 32*s12**2*s14*s34 - 32*s12*s13**2*s23 - 32*s12*
     +    s13**2*s24 + 64*s12*s13**2*s34 + 32*s12*s13*s14*s23 + 32*s12*
     +    s13*s14*s24 + 64*s12*s13*s14*s34 + 48*s12*s13*s23*s34 + 48*
     +    s12*s13*s24*s34 + 96*s12*s13*s34**2 - 80*s12*s14*s23*s34 - 16
     +    *s12*s14*s24*s34 + 32*s12*s14*s34**2 - 16*s12*s23*s34**2 + 16
     +    *s12*s24*s34**2 + 32*s12*s34**3 - 128*s13**3*s23 - 64*s13**3*
     +    s24 - 192*s13**2*s14*s23 - 64*s13**2*s14*s24 - 16*s13**2*
     +    s23**2 - 64*s13**2*s23*s24 - 224*s13**2*s23*s34 - 48*s13**2*
     +    s24**2 - 96*s13**2*s24*s34 - 64*s13*s14**2*s23 + 48*s13*s14*
     +    s23**2 + 64*s13*s14*s23*s24 - 224*s13*s14*s23*s34 + 16*s13*
     +    s14*s24**2 - 32*s13*s14*s24*s34 + 32*s13*s23**2*s34 + 48*s13*
     +    s23*s24*s34 - 128*s13*s23*s34**2 - 16*s13*s24**2*s34 - 32*s13
     +    *s24*s34**2 - 64*s14**2*s23*s34 - 48*s14*s23**2*s34 - 16*s14*
     +    s23*s24*s34 - 96*s14*s23*s34**2 - 16*s23**2*s34**2 + 16*s23*
     +    s24*s34**2 - 32*s23*s34**3 )

      ub12 = ub12 + Ld21(p1,p2,p34)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * (  - 32*s12*s13*s23**2 - 64*s12*s13*s23*s34 - 32*s12*s13*
     +    s34**2 - 32*s12*s14*s23**2 - 64*s12*s14*s23*s34 - 32*s12*s14*
     +    s34**2 )

      ub12 = ub12 + Ld21(p2,p1,p34)*S34**(-2)*S134**(-2) * (  - 32*s12*
     +    s13**3 - 32*s12*s13**2*s14 - 96*s12*s13**2*s34 - 64*s12*s13*
     +    s14*s34 - 96*s12*s13*s34**2 - 32*s12*s14*s34**2 - 32*s12*
     +    s34**3 )

      ub12 = ub12 + Ld22(p1,p2,p34)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * (  - 32*s12*s13*s23**2 - 64*s12*s13*s23*s34 - 32*s12*s14*
     +    s23**2 - 64*s12*s14*s23*s34 + 32*s13**2*s23**2 + 64*s13*s14*
     +    s23**2 + 32*s14**2*s23**2 )

      ub12 = ub12 + Ld22(p2,p1,p34)*S34**(-2)*S134**(-2) * (  - 32*s12*
     +    s13**3 - 32*s12*s13**2*s14 - 96*s12*s13**2*s34 - 64*s12*s13*
     +    s14*s34 - 64*s12*s13*s34**2 + 32*s13**3*s23 + 32*s13**3*s24
     +     + 32*s13**2*s14*s23 + 32*s13**2*s14*s24 + 32*s13**2*s23*s34
     +     + 32*s13**2*s24*s34 )

      ub12 = ub12 + Ld24(p1,p2,p34)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * ( 64*s12*s13**2*s34 + 64*s12*s13*s14*s34 - 96*s13**3*s23 - 32
     +    *s13**3*s24 - 160*s13**2*s14*s23 - 32*s13**2*s14*s24 - 64*s13
     +    *s14**2*s23 )

      ub12 = ub12 + Ld24(p2,p1,p34)*S34**(-2)*S134**(-2) * ( 64*s12*s13
     +    *s23*s34 + 64*s12*s14*s23*s34 + 64*s12*s23*s34**2 - 96*s13**2
     +    *s23**2 - 64*s13**2*s23*s24 - 128*s13*s14*s23**2 - 64*s13*s14
     +    *s23*s24 - 96*s13*s23**2*s34 - 64*s13*s23*s24*s34 - 32*s14**2
     +    *s23**2 - 32*s14*s23**2*s34 )

      return
      end
      
            function uc12(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)
      common/Lsa/Lc0a(12,12),Lc1a(12,14),Lc2a(12,14),Lc3a(12,14),
     . Lcd0a(8,12,8),Lcd1a(8,12,8),Lcd2a(8,12,8),Lcd3a(8,12,8),
     . Ld0a(8,12,12),Ld1sa(8,12,12),Ld2sa(8,12,12),Ld3sa(8,12,12),
     . Ld1a(8,12,12),Ld21a(8,12,12),Ld22a(8,12,12),
     . Ld24a(8,12,12),Ld311a(8,12,12),Ld314a(8,12,12),Ld322a(8,12,12),
     . Ld344a(8,12,12),Le1a(8,8,8,8)

      common/newas12/Ld21as12(8,12,12),Ld22as12(8,12,12),
     .Ld24as12(8,12,12),Ld311as12(8,12,12),
     .Ld314as12(8,12,12),Ld322as12(8,12,12)
      common/newas23/Ld21as23(8,12,12),Ld22as23(8,12,12),
     .Ld24as23(8,12,12),Ld311as23(8,12,12),
     .Ld314as23(8,12,12),Ld322as23(8,12,12)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      uc12=0d0

      uc12 = uc12 + S34**(-2)*S234**(-1)*S134**(-1) * (  - 80*s12**2*
     +    s34 - 80*s12*s13*s23 - 120*s12*s13*s34 + 80*s12*s14*s23 - 40*
     +    s12*s14*s34 - 40*s12*s34**2 - 40*s13**2*s23 - 40*s13**2*s34
     +     + 40*s13*s14*s34 + 80*s13*s23**2 + 120*s13*s23*s34 + 40*s13*
     +    s34**2 + 40*s14**2*s23 + 80*s14*s23**2 + 40*s14*s23*s34 )

      uc12 = uc12 + S34**(-2)*S134**(-1) * (  - 96*s12*s13 - 136*s12*
     +    s34 + 40*s13**2 - 40*s13*s14 - 272*s13*s23 - 40*s13*s24 - 56*
     +    s13*s34 + 40*s14*s23 + 16*s14*s34 - 80*s23*s34 - 80*s24*s34 )

      uc12 = uc12 + S34**(-2)*S134**(-2) * ( 160*s12*s13**2 + 160*s12*
     +    s13*s34 + 80*s12*s34**2 + 160*s13**2*s23 + 160*s13**2*s24 + 
     +    160*s13*s23*s34 + 160*s13*s24*s34 + 80*s23*s34**2 + 80*s24*
     +    s34**2 )

      uc12 = uc12 + log(s14**(-1)*s1234)*S34**(-2)*S134**(-1) * ( 16*
     +    s12*s34 + 16*s14*s34 + 32*s23*s34 + 32*s24*s34 )

      uc12 = uc12 + log(s14**(-1)*s1234)*S34**(-2)*S134**(-2) * (  - 32
     +    *s12*s13*s34 - 32*s13*s23*s34 - 32*s13*s24*s34 )

      uc12 = uc12 + log(s23**(-1)*s1234)*S34**(-2)*S234**(-1)*
     + S134**(-1) * (  - 16*s12*s13*s34 + 16*s12*s14*s34 - 16*s12*
     +    s34**2 + 16*s13*s14*s34 + 16*s13*s23*s34 + 16*s13*s34**2 + 16
     +    *s14*s23*s34 )

      uc12 = uc12 + log(s23**(-1)*s1234)*S34**(-2)*S134**(-1) * ( 32*
     +    s23*s34 + 16*s24*s34 - 16*s34**2 )

      uc12 = uc12 + log(s34**(-1)*s234)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * ( 16*s12*s13*s34 - 16*s12*s14*s34 + 16*s12*s34**2 - 16*s13*
     +    s14*s34 - 16*s13*s23*s34 - 16*s13*s34**2 - 16*s14*s23*s34 )

      uc12 = uc12 + log(s34**(-1)*s134)*S34**(-2)*S134**(-2) * ( 32*s12
     +    *s13*s34 + 32*s13*s23*s34 + 32*s13*s24*s34 )

      uc12 = uc12 + log(s34**(-1)*s1234)*S34**(-2)*S134**(-1) * ( 48*
     +    s12*s13 + 72*s12*s34 - 24*s13**2 + 24*s13*s14 + 144*s13*s23
     +     + 24*s13*s24 + 40*s13*s34 - 24*s14*s23 - 24*s23*s34 + 48*s24
     +    *s34 + 48*s34**2 )

      uc12 = uc12 + log(s234**(-1)*s1234)*S34**(-2)*S234**(-1)*
     + S134**(-1) * ( 48*s12**2*s34 + 48*s12*s13*s23 + 88*s12*s13*s34
     +     - 48*s12*s14*s23 + 8*s12*s14*s34 + 40*s12*s34**2 + 24*s13**2
     +    *s23 + 24*s13**2*s34 - 40*s13*s14*s34 - 48*s13*s23**2 - 88*
     +    s13*s23*s34 - 40*s13*s34**2 - 24*s14**2*s23 - 48*s14*s23**2
     +     - 40*s14*s23*s34 )

      uc12 = uc12 + log(s234**(-1)*s1234)*S34**(-2)*S134**(-1) * ( 80*
     +    s13*s34 - 48*s14*s34 - 64*s23*s34 - 64*s24*s34 - 16*s34**2 )

      uc12 = uc12 + log(s134**(-1)*s1234)*S34**(-2)*S134**(-1) * (  - 
     +    32*s12*s34 - 64*s13*s34 - 48*s14*s34 + 40*s23*s34 - 16*s24*
     +    s34 - 64*s34**2 )

      uc12 = uc12 + log(s134**(-1)*s1234)*S34**(-2)*S134**(-2) * (  - 
     +    96*s12*s13**2 - 64*s12*s13*s34 - 48*s12*s34**2 - 96*s13**2*
     +    s23 - 96*s13**2*s24 - 64*s13*s23*s34 - 64*s13*s24*s34 - 48*
     +    s23*s34**2 - 48*s24*s34**2 )

      uc12 = uc12 + Lc0(p14,p23)*S34**(-2)*S134**(-1) * (  - 32*s12**2*
     +    s34 - 16*s12*s13*s34 - 16*s12*s14*s34 + 96*s12*s24*s34 + 48*
     +    s12*s34**2 - 16*s13**2*s34 - 16*s13*s23*s34 - 16*s13*s24*s34
     +     - 16*s13*s34**2 + 16*s14*s23*s34 + 16*s14*s24*s34 + 16*s14*
     +    s34**2 + 16*s23*s34**2 - 16*s24**2*s34 - 16*s24*s34**2 )

      uc12 = uc12 + Lc1(p1,p34)*S34**(-2)*S134**(-1) * (  - 96*s12*
     +    s13**2 + 24*s12*s34**2 - 96*s13**2*s23 - 96*s13**2*s24 - 128*
     +    s13**2*s34 + 56*s13*s23*s34 - 56*s13*s24*s34 )

      uc12 = uc12 + Lc1(p1,p234)*S34**(-2)*S134**(-1) * ( 16*s13**2*s23
     +     + 32*s13**2*s24 + 48*s13**2*s34 - 32*s13*s14*s34 + 32*s13*
     +    s23*s34 + 96*s13*s24*s34 + 16*s14**2*s23 + 48*s14**2*s34 + 16
     +    *s14*s23*s34 - 16*s14*s24*s34 - 32*s14*s34**2 )

      uc12 = uc12 + Lc1(p2,p34)*S34**(-2)*S134**(-1) * ( 48*s12**2*s34
     +     + 48*s12*s13*s23 - 8*s12*s13*s34 - 48*s12*s14*s23 + 40*s12*
     +    s14*s34 + 40*s12*s34**2 + 24*s13**2*s23 - 48*s13*s23**2 + 40*
     +    s13*s23*s34 - 24*s14**2*s23 - 48*s14*s23**2 + 24*s14*s23*s34
     +     )

      uc12 = uc12 + Lc1(p2,p134)*S34**(-2)*S134**(-1) * ( 112*s13**2*
     +    s23 - 16*s13**2*s24 + 112*s13*s14*s23 - 16*s13*s14*s24 + 160*
     +    s13*s23*s34 + 80*s14*s23*s34 + 16*s14*s24*s34 + 16*s23*s34**2
     +     + 16*s24*s34**2 )

      uc12 = uc12 + Lc1(p3,p14)*S34**(-2)*S134**(-1) * (  - 16*s12*
     +    s34**2 - 16*s14*s23*s34 - 32*s14*s34**2 - 32*s23*s34**2 - 16*
     +    s24*s34**2 )

      uc12 = uc12 + Lc1(p4,p23)*S34**(-2)*S134**(-1) * (  - 16*s12*s14*
     +    s34 + 32*s12*s34**2 - 16*s13*s14*s34 - 32*s14*s23*s34 - 48*
     +    s23*s34**2 + 16*s34**3 )

      uc12 = uc12 + Lc1(p14,p23)*S34**(-2)*S134**(-1) * (  - 16*s12*s13
     +    *s34 - 16*s12*s34**2 - 16*s13**2*s34 - 16*s13*s23*s34 - 16*
     +    s13*s34**2 - 16*s14*s23*s34 + 16*s23*s34**2 - 16*s24**2*s34 )

      uc12 = uc12 + Lc1(p23,p14)*S34**(-2)*S134**(-1) * ( 16*s12**2*s34
     +     + 16*s12*s13*s34 + 16*s12*s14*s34 - 32*s12*s24*s34 - 16*s12*
     +    s34**2 + 16*s13*s14*s34 + 16*s13*s24*s34 + 16*s14*s24*s34 + 
     +    16*s14*s34**2 - 16*s24**2*s34 - 16*s24*s34**2 )

      uc12 = uc12 + Lc2(p1,p34)*S34**(-2)*S134**(-1) * ( 32*s12*s13**2
     +     + 16*s13**2*s23 + 16*s13**2*s24 + 32*s13**2*s34 )

      uc12 = uc12 + Lc2(p1,p234)*S34**(-2)*S134**(-1) * ( 32*s13**2*s23
     +     + 32*s13**2*s24 - 16*s13**2*s34 - 16*s14**2*s34 )

      uc12 = uc12 + Lc2(p2,p34)*S34**(-2)*S134**(-1) * (  - 16*s12**2*
     +    s34 - 16*s12*s13*s23 + 16*s12*s14*s23 + 16*s13*s23**2 + 16*
     +    s14*s23**2 )

      uc12 = uc12 + Lc2(p2,p134)*S34**(-2)*S134**(-1) * ( 32*s13*s23**2
     +     + 32*s14*s23**2 )

      uc12 = uc12 + Lcd0(p1,p34,p2)*S34**(-2)*S134**(-1) * (  - 48*s12*
     +    s13*s34**2 + 32*s12*s14*s34**2 + 32*s12*s34**3 - 48*s13**2*
     +    s23*s34 + 32*s13**2*s24*s34 - 128*s13*s14*s23*s34 - 192*s13*
     +    s23*s34**2 - 80*s13*s24*s34**2 - 48*s14**2*s23*s34 - 112*s14*
     +    s23*s34**2 )

      uc12 = uc12 + Lcd1(p1,p34,p2)*S34**(-2)*S134**(-1) * (  - 112*
     +    s13**2*s23**2 - 80*s13**2*s23*s24 - 128*s13*s14*s23**2 - 64*
     +    s13*s14*s23*s24 - 176*s13*s23**2*s34 - 112*s13*s23*s24*s34 - 
     +    16*s14**2*s23**2 + 16*s14**2*s23*s24 - 112*s14*s23**2*s34 - 
     +    48*s14*s23*s24*s34 )

      uc12 = uc12 + Lcd1(p2,p34,p1)*S34**(-2)*S134**(-1) * (  - 16*
     +    s13**3*s23 - 16*s13**3*s24 - 32*s13**2*s14*s23 - 32*s13**2*
     +    s14*s24 - 80*s13**2*s23*s34 - 80*s13**2*s24*s34 - 16*s13*
     +    s14**2*s23 - 16*s13*s14**2*s24 - 16*s13*s14*s23*s34 - 16*s13*
     +    s14*s24*s34 )

      uc12 = uc12 + Lcd2(p1,p34,p2)*S34**(-2)*S134**(-1) * (  - 32*s13*
     +    s23**3 - 32*s13*s23**2*s24 - 32*s14*s23**3 - 32*s14*s23**2*
     +    s24 )

      uc12 = uc12 + Lcd2(p2,p34,p1)*S34**(-2)*S134**(-1) * (  - 32*
     +    s13**3*s23 - 32*s13**3*s24 - 32*s13**2*s14*s23 - 32*s13**2*
     +    s14*s24 )

      uc12 = uc12 + Ld0(p1,p4,p3)*S34**(-2)*S134**(-1) * ( 32*s12*s13
     +     + 64*s12*s14 + 32*s12*s34 + 16*s13**2 - 16*s13*s14 - 32*s13*
     +    s23 + 48*s13*s24 + 32*s13*s34 + 80*s14*s23 + 64*s14*s24 + 64*
     +    s24*s34 + 16*s34**2 )

      uc12 = uc12 + Ld0(p1,p4,p3)*S34**(-2)*S134**(-2) * (  - 128*s12*
     +    s13*s14 - 64*s12*s13*s34 - 128*s12*s14*s34 - 32*s12*s34**2 - 
     +    128*s13*s14*s23 - 128*s13*s14*s24 - 64*s13*s23*s34 - 64*s13*
     +    s24*s34 - 128*s14*s23*s34 - 128*s14*s24*s34 - 32*s23*s34**2
     +     - 32*s24*s34**2 )

      uc12 = uc12 + Ld0(p1,p4,p23)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 64*s12**2*s34 - 64*s12*s13*s23 - 96*s12*s13*s34 + 64*s12*
     +    s14*s23 - 32*s12*s14*s34 - 32*s12*s34**2 - 32*s13**2*s23 - 32
     +    *s13**2*s34 + 32*s13*s14*s34 - 32*s13*s23**2 - 96*s13*s23*s24
     +     - 96*s13*s23*s34 - 96*s13*s24*s34 - 64*s13*s34**2 + 32*
     +    s14**2*s23 + 96*s14*s23**2 + 32*s14*s23*s24 + 96*s14*s23*s34
     +     + 32*s14*s24*s34 + 32*s14*s34**2 + 32*s23**2*s34 - 32*s23*
     +    s24*s34 - 64*s24**2*s34 - 96*s24*s34**2 - 32*s34**3 )

      uc12 = uc12 + Ld0(p1,p4,p23)*S34**(-2)*S134**(-1) * ( 32*s12*s13
     +     - 64*s12*s14 + 16*s13**2 - 16*s13*s14 + 64*s13*s23 + 48*s13*
     +    s24 + 32*s13*s34 - 80*s14*s23 - 64*s14*s24 - 32*s14*s34 + 16*
     +    s24*s34 + 16*s34**2 )

      uc12 = uc12 + Ld0(p2,p3,p4)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 64*s12**2*s34 + 64*s12*s13*s24 + 64*s12*s14*s23 - 16*s12*
     +    s14*s34 - 32*s12*s23*s34 - 32*s12*s24*s34 - 48*s12*s34**2 + 
     +    32*s13**2*s24 - 16*s13*s14*s23 - 16*s13*s14*s24 - 32*s13*s23*
     +    s24 - 16*s13*s23*s34 + 32*s13*s24**2 + 16*s13*s24*s34 + 16*
     +    s14**2*s23 + 32*s14*s23**2 - 32*s14*s23*s24 - 16*s14*s23*s34
     +     )

      uc12 = uc12 + Ld0(p2,p3,p4)*S34**(-2)*S134**(-1) * (  - 32*s12*
     +    s13 - 64*s12*s14 - 32*s12*s34 - 16*s13**2 + 32*s13*s23 + 16*
     +    s13*s24 - 16*s13*s34 - 16*s14*s23 - 64*s14*s24 - 32*s14*s34
     +     - 16*s24*s34 - 16*s34**2 )

      uc12 = uc12 + Ld0(p2,p3,p14)*S34**(-2)*S134**(-1) * ( 32*s12*s13
     +     + 16*s13**2 + 16*s13*s14 - 32*s13*s23 + 48*s13*s24 + 32*s13*
     +    s34 - 32*s14**2 - 16*s14*s23 + 32*s14*s24 + 32*s14*s34 - 32*
     +    s23*s34 + 16*s24*s34 + 16*s34**2 )

      uc12 = uc12 + Ld0(p2,p3,p14)*S34**(-2)*S134**(-2) * (  - 64*s12*
     +    s13*s14 - 32*s12*s13*s34 + 64*s12*s14**2 + 32*s12*s14*s34 + 
     +    32*s12*s34**2 - 32*s13**2*s14 - 32*s13**2*s34 - 32*s13*s14*
     +    s23 - 96*s13*s14*s24 - 64*s13*s14*s34 - 32*s13*s23*s34 - 64*
     +    s13*s24*s34 - 32*s13*s34**2 + 32*s14**3 + 96*s14**2*s23 + 32*
     +    s14**2*s24 + 32*s14**2*s34 + 64*s14*s23*s34 - 32*s14*s24*s34
     +     + 32*s23*s34**2 )

      uc12 = uc12 + Ld1(p1,p4,p3)*S34**(-2)*S134**(-1) * (  - 16*s12*
     +    s34**2 + 16*s14*s23*s34 )

      uc12 = uc12 + Ld1(p1,p4,p23)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +    32*s12**2*s23*s34 - 32*s12**2*s24*s34 + 16*s12*s13*s23*s34 - 
     +    48*s12*s13*s24*s34 + 48*s12*s14*s23*s34 - 16*s12*s14*s24*s34
     +     + 32*s12*s23**2*s34 + 32*s12*s23*s24*s34 + 16*s12*s23*s34**2
     +     + 64*s12*s24**2*s34 + 48*s12*s24*s34**2 - 16*s13**2*s24*s34
     +     + 16*s13*s14*s23*s34 - 16*s13*s14*s24*s34 + 32*s13*s24**2*
     +    s34 + 16*s13*s24*s34**2 + 16*s14**2*s23*s34 - 32*s14*s23*s24*
     +    s34 - 16*s14*s23*s34**2 )

      uc12 = uc12 + Ld1(p1,p4,p23)*S34**(-2)*S134**(-1) * (  - 32*
     +    s12**2*s34 - 16*s12*s13*s34 - 16*s12*s14*s34 - 32*s12*s23*s34
     +     + 32*s12*s24*s34 + 16*s12*s34**2 )

      uc12 = uc12 + Ld1(p2,p3,p4)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 32*s12**2*s34**2 + 16*s12*s13*s34**2 + 48*s12*s14*s23*s34
     +     - 16*s12*s23*s34**2 + 16*s13*s14*s23*s34 - 16*s14**2*s23**2
     +     + 16*s14*s23**2*s34 )

      uc12 = uc12 + Ld1(p2,p3,p4)*S34**(-2)*S134**(-1) * (  - 16*s12*
     +    s14*s34 - 16*s12*s34**2 + 16*s14**2*s23 + 16*s14*s23*s34 )

      uc12 = uc12 + Ld1(p2,p3,p14)*S34**(-2)*S134**(-1) * ( 16*s12*s13*
     +    s34 + 16*s12*s14*s34 + 16*s12*s34**2 )

      uc12 = uc12 + Ld1(p2,p3,p14)*S34**(-2)*S134**(-2) * ( 16*s12*
     +    s13**2*s34 + 16*s12*s13*s34**2 - 16*s12*s14**2*s34 - 16*s12*
     +    s14*s34**2 + 16*s13**2*s24*s34 - 16*s13*s14*s23*s34 + 16*s13*
     +    s14*s24*s34 + 16*s13*s24*s34**2 - 16*s14**2*s23*s34 - 16*s14*
     +    s23*s34**2 )

      uc12 = uc12 + Ld21(p1,p4,p23)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * ( 16*s14*s23**2*s34 + 32*s14*s23*s24*s34 + 16*s14*s24**2*s34
     +     )

      uc12 = uc12 + Ld21(p2,p3,p4)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +    16*s12**2*s34**2 )

      uc12 = uc12 + Ld21(p4,p3,p2)*S34**(-2)*S234**(-1)*S134**(-1) * ( 
     +     - 32*s12*s14*s34**2 + 16*s14**2*s23*s34 )

      uc12 = uc12 + Ld22(p1,p4,p23)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * (  - 16*s12*s24**2*s34 - 16*s13*s24**2*s34 + 32*s14*s23*s24*
     +    s34 + 16*s14*s24**2*s34 )

      uc12 = uc12 + Ld24(p1,p4,p23)*S34**(-2)*S234**(-1)*S134**(-1)
     +  * ( 48*s12**2*s24*s34 + 16*s12**2*s34**2 + 32*s12*s13*s24*s34
     +     - 32*s12*s14*s23*s34 )

      uc12 = uc12 + Le1(p1,p4,p3,p2)*S34**(-2)*S134**(-1) * ( 32*s12**2
     +    *s14*s34 - 32*s12*s13**2*s23 + 16*s12*s13*s14*s34 - 48*s12*
     +    s13*s23*s34 - 32*s12*s14**2*s23 - 64*s12*s14**2*s24 - 16*s12*
     +    s14**2*s34 + 32*s12*s14*s23*s34 + 48*s12*s14*s24*s34 + 32*s12
     +    *s14*s34**2 - 16*s12*s23*s34**2 - 16*s13**3*s23 - 16*s13**2*
     +    s14*s23 + 32*s13**2*s23**2 - 32*s13**2*s23*s34 + 16*s13*
     +    s14**2*s23 + 64*s13*s14*s23**2 - 32*s13*s14*s23*s34 + 32*s13*
     +    s23**2*s34 - 16*s13*s23*s34**2 + 16*s14**3*s23 - 32*s14**2*
     +    s23**2 - 128*s14**2*s23*s24 - 32*s14**2*s23*s34 - 64*s14**2*
     +    s24**2 - 32*s14**2*s24*s34 + 16*s14*s23**2*s34 + 16*s14*
     +    s24**2*s34 + 16*s14*s24*s34**2 )

      return
      end
      
            function ua14(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)
      common/Lsa/Lc0a(12,12),Lc1a(12,14),Lc2a(12,14),Lc3a(12,14),
     . Lcd0a(8,12,8),Lcd1a(8,12,8),Lcd2a(8,12,8),Lcd3a(8,12,8),
     . Ld0a(8,12,12),Ld1sa(8,12,12),Ld2sa(8,12,12),Ld3sa(8,12,12),
     . Ld1a(8,12,12),Ld21a(8,12,12),Ld22a(8,12,12),
     . Ld24a(8,12,12),Ld311a(8,12,12),Ld314a(8,12,12),Ld322a(8,12,12),
     . Ld344a(8,12,12),Le1a(8,8,8,8)

      common/newas12/Ld21as12(8,12,12),Ld22as12(8,12,12),
     .Ld24as12(8,12,12),Ld311as12(8,12,12),
     .Ld314as12(8,12,12),Ld322as12(8,12,12)
      common/newas23/Ld21as23(8,12,12),Ld22as23(8,12,12),
     .Ld24as23(8,12,12),Ld311as23(8,12,12),
     .Ld314as23(8,12,12),Ld322as23(8,12,12)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      ua14=0d0

      ua14 = ua14 + S23**(-1)*S34**(-1)*S123**(-1)*S134**(-1) * (  - 48
     +    *s12**2*s13 + 112*s12**2*s24 + 48*s12**2*s34 - 48*s12*s13**2
     +     - 48*s12*s13*s23 + 112*s12*s13*s24 + 48*s12*s13*s34 + 160*
     +    s12*s23*s24 + 48*s12*s23*s34 + 48*s13*s23*s24 + 48*s23**2*s24
     +     )

      ua14 = ua14 + S23**(-1)*S34**(-1)*S134**(-1) * ( 48*s12*s13 - 112
     +    *s12*s24 - 48*s12*s34 - 48*s23*s24 )

      ua14 = ua14 + log(s14**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     + *S234**(-1) * ( 16*s12*s13*s34 + 32*s12*s14*s34 - 32*s12*s34**2
     +     + 16*s13**2*s34 + 32*s13*s14*s34 + 16*s13*s23*s34 - 32*s13*
     +    s34**2 + 32*s14*s23*s34 - 32*s23*s34**2 )

      ua14 = ua14 + log(s14**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     + *S134**(-1) * (  - 16*s12**2*s34 + 32*s12*s34**2 - 16*s13**2*s34
     +     + 32*s13*s23*s34 + 16*s23**2*s34 + 32*s23*s34**2 )

      ua14 = ua14 + log(s14**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     +  * ( 32*s13*s34 + 16*s14*s34 - 16*s23*s34 - 16*s34**2 )

      ua14 = ua14 + log(s14**(-1)*s1234)*S23**(-1)*S34**(-1)*S234**(-1)
     + *S134**(-1) * ( 16*s13*s34**2 - 16*s23**2*s34 - 32*s23*s34**2 )

      ua14 = ua14 + log(s23**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     + *S234**(-1) * (  - 16*s12**2*s34 + 48*s12*s34**2 + 32*s13*s23*
     +    s34 + 48*s13*s34**2 + 16*s23**2*s34 + 32*s23*s34**2 )

      ua14 = ua14 + log(s23**(-1)*s1234)*S23**(-1)*S34**(-1)*S234**(-2)
     +  * ( 32*s12*s23*s34 + 32*s12*s34**2 + 32*s13*s23*s34 + 32*s13*
     +    s34**2 + 32*s14*s23*s34 + 32*s14*s34**2 )

      ua14 = ua14 + log(s34**(-1)*s234)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 32*s12**2*s23 - 16*s12**2*s34 - 48*s12*s13*s23
     +     - 16*s12*s13*s34 - 16*s12*s14*s23 + 16*s12*s14*s34 - 32*s12*
     +    s23**2 - 48*s12*s23*s34 - 48*s12*s34**2 - 16*s13**2*s23 + 16*
     +    s13**2*s34 - 16*s13*s14*s23 + 16*s13*s14*s34 - 16*s13*s23**2
     +     - 32*s13*s23*s34 - 48*s13*s34**2 - 16*s14*s23**2 + 16*s14*
     +    s23*s34 - 32*s23**2*s34 - 32*s23*s34**2 )

      ua14 = ua14 + log(s34**(-1)*s234)*S23**(-1)*S34**(-1)*S234**(-2)
     +  * (  - 32*s12*s23*s34 - 32*s12*s34**2 - 32*s13*s23*s34 - 32*s13
     +    *s34**2 - 32*s14*s23*s34 - 32*s14*s34**2 )

      ua14 = ua14 + log(s34**(-1)*s134)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 16*s12**2*s34 + 16*s13**2*s34 - 32*s13*s23*s34 - 
     +    16*s23**2*s34 )

      ua14 = ua14 + log(s34**(-1)*s134)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s13*s34**2 + 16*s23**2*s34 + 32*s23*s34**2
     +     )

      ua14 = ua14 + log(s34**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     +  * ( 16*s13*s34 )

      ua14 = ua14 + log(s234**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1)*S234**(-1) * (  - 32*s12*s23*s34 - 48*s12*s34**2 + 16
     +    *s13**2*s34 - 32*s13*s23*s34 - 48*s13*s34**2 - 32*s23**2*s34
     +     - 32*s23*s34**2 )

      ua14 = ua14 + log(s234**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1) * (  - 16*s13*s34 - 48*s24*s34 + 16*s34**2 )

      ua14 = ua14 + log(s234**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S234**(-2) * (  - 32*s12*s23*s34 - 32*s12*s34**2 - 32*s13*s23*
     +    s34 - 32*s13*s34**2 - 32*s14*s23*s34 - 32*s14*s34**2 )

      ua14 = ua14 + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1)*S234**(-1) * (  - 64*s12*s13*s34 - 64*s12*s14*s34 - 
     +    16*s12*s23*s34 - 64*s13**2*s34 - 64*s13*s14*s34 - 80*s13*s23*
     +    s34 - 64*s14*s23*s34 - 16*s23**2*s34 )

      ua14 = ua14 + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1)*S134**(-1) * ( 16*s12**2*s34 - 32*s12*s34**2 + 16*
     +    s13**2*s34 - 32*s13*s23*s34 - 16*s23**2*s34 - 32*s23*s34**2 )

      ua14 = ua14 + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1) * ( 32*s12*s34 - 64*s13*s34 - 32*s14*s34 + 16*s23*s34
     +     - 48*s24*s34 - 16*s34**2 )

      ua14 = ua14 + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S234**(-1)*S134**(-1) * (  - 16*s13*s34**2 + 16*s23**2*s34 + 32*
     +    s23*s34**2 )

      ua14 = ua14 + Lc0(p14,p23)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16*
     +    s12**2*s34 + 96*s12*s13*s34 - 16*s12*s23*s34 - 16*s12*s24*s34
     +     + 32*s13*s23*s34 - 16*s13*s24*s34 - 16*s14*s23*s34 )

      ua14 = ua14 + Lc0(p14,p23)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    32*s12**2*s34 + 96*s12*s13*s34 - 16*s12*s23*s34 - 16*s12*s24*
     +    s34 + 48*s12*s34**2 - 16*s13**2*s34 + 16*s13*s23*s34 - 16*s13
     +    *s24*s34 - 16*s13*s34**2 + 16*s14*s23*s34 - 16*s14*s24*s34 + 
     +    16*s14*s34**2 + 16*s23*s34**2 - 16*s24**2*s34 - 16*s24*s34**2
     +     )

      ua14 = ua14 + Lc1(p1,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 32*
     +    s12*s13*s34 + 32*s13*s23*s34 + 16*s13*s34**2 )

      ua14 = ua14 + Lc1(p1,p34)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s14*s23**2*s34 )

      ua14 = ua14 + Lc1(p1,p34)*S23**(-1)*S34**(-1)*S234**(-1) * ( 16*
     +    s13*s34**2 )

      ua14 = ua14 + Lc1(p1,p34)*S23**(-1)*S34**(-1) * (  - 16*s12*s34
     +     - 16*s13*s34 )

      ua14 = ua14 + Lc1(p1,p234)*S23**(-1)*S34**(-1)*S123**(-1) * ( 48*
     +    s13*s24*s34 - 16*s13*s34**2 + 48*s14*s24*s34 - 16*s14*s34**2
     +     - 48*s23*s24*s34 + 16*s23*s34**2 )

      ua14 = ua14 + Lc1(p1,p234)*S23**(-1)*S34**(-1)*S234**(-1) * ( 16*
     +    s13*s34**2 )

      ua14 = ua14 + Lc1(p1,p234)*S23**(-1)*S34**(-1) * (  - 16*s13*s34
     +     + 48*s24*s34 - 16*s34**2 )

      ua14 = ua14 + Lc1(p2,p34)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    16*s12**2*s34 - 16*s12*s14*s34 - 16*s12*s23*s34 + 32*s12*
     +    s34**2 - 32*s14*s23*s34 + 16*s23*s34**2 )

      ua14 = ua14 + Lc1(p2,p34)*S23**(-1)*S34**(-1) * ( 32*s12*s23 + 32
     +    *s12*s34 + 16*s13*s23 + 16*s14*s23 + 32*s23*s34 )

      ua14 = ua14 + Lc1(p2,p134)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16*
     +    s14*s24*s34 + 16*s23*s24*s34 + 16*s23*s34**2 + 48*s24**2*s34
     +     + 32*s24*s34**2 )

      ua14 = ua14 + Lc1(p2,p134)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    64*s13*s34**2 - 48*s14*s34**2 - 32*s23*s34**2 - 48*s34**3 )

      ua14 = ua14 + Lc1(p2,p134)*S23**(-1)*S34**(-1) * ( 64*s13*s34 + 
     +    48*s14*s34 + 16*s23*s34 + 48*s24*s34 + 48*s34**2 )

      ua14 = ua14 + Lc1(p3,p14)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 32*s12**2*s34**2 + 64*s12*s23*s34**2 - 32*s12*
     +    s34**3 + 32*s23**2*s34**2 - 32*s23*s34**3 )

      ua14 = ua14 + Lc1(p3,p14)*S23**(-1)*S34**(-1)*S123**(-1) * ( 32*
     +    s12*s34**2 - 16*s14*s34**2 + 32*s23*s34**2 + 16*s34**3 )

      ua14 = ua14 + Lc1(p3,p14)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s14**2*s23**2 )

      ua14 = ua14 + Lc1(p3,p14)*S23**(-1)*S34**(-1)*S234**(-1) * ( 16*
     +    s12*s23*s34 + 32*s12*s34**2 - 32*s14*s23*s34 - 48*s14*s34**2
     +     + 16*s23**2*s34 + 16*s23*s34**2 + 16*s34**3 )

      ua14 = ua14 + Lc1(p3,p14)*S23**(-1)*S34**(-1)*S134**(-1) * (  - 
     +    32*s12*s34**2 - 32*s23*s34**2 )

      ua14 = ua14 + Lc1(p3,p14)*S23**(-1)*S34**(-1) * (  - 16*s23*s34 )

      ua14 = ua14 + Lc1(p4,p23)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16*
     +    s23*s34**2 )

      ua14 = ua14 + Lc1(p4,p23)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    16*s12*s34**2 - 16*s13*s34**2 - 32*s14*s34**2 )

      ua14 = ua14 + Lc1(p4,p23)*S23**(-1)*S34**(-1) * (  - 48*s34**2 )

      ua14 = ua14 + Lc1(p14,p23)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    32*s12*s13*s34 + 32*s12*s23*s34 + 32*s13*s23*s34 )

      ua14 = ua14 + Lc1(p14,p23)*S23**(-1)*S34**(-1)*S234**(-1) * ( 16*
     +    s12**2*s34 - 32*s12*s13*s34 + 16*s12*s23*s34 + 16*s12*s24*s34
     +     - 16*s12*s34**2 - 16*s13**2*s34 + 16*s13*s23*s34 + 16*s13*
     +    s24*s34 - 16*s13*s34**2 + 16*s23*s24*s34 + 16*s23*s34**2 )

      ua14 = ua14 + Lc1(p23,p14)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    16*s12**2*s34 - 16*s12*s13*s34 + 16*s12*s14*s34 - 16*s12*s24*
     +    s34 - 16*s13**2*s34 - 16*s13*s14*s34 - 16*s13*s24*s34 - 16*
     +    s14*s23*s34 )

      ua14 = ua14 + Lc1(p23,p14)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    16*s12*s24*s34 - 16*s12*s34**2 - 16*s13**2*s34 - 16*s14*s23*
     +    s34 - 16*s14*s24*s34 + 16*s14*s34**2 - 16*s24**2*s34 - 16*s24
     +    *s34**2 )

      ua14 = ua14 + Lcd0(p1,p34,p2)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +    16*s12*s34**3 - 80*s13*s24*s34**2 + 16*s14*s23*s34**2 )

      ua14 = ua14 + Lcd0(p1,p34,p2)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +    16*s13*s24*s34**2 - 16*s14*s23*s34**2 )

      ua14 = ua14 + Lcd1(p1,p34,p2)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +    32*s13*s23**2*s34 + 48*s13*s23*s24*s34 + 32*s14*s23**2*s34 + 
     +    48*s14*s23*s24*s34 )

      ua14 = ua14 + Lcd1(p1,p34,p2)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 16*s13*s23**2*s34 - 16*s13*s23*s24*s34 - 16*s14*s23**2*s34
     +     - 16*s14*s23*s24*s34 )

      ua14 = ua14 + Lcd1(p2,p34,p1)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 32*s13**2*s23*s34 - 64*s13**2*s24*s34 - 16*s13*s14*s23*s34
     +     - 48*s13*s14*s24*s34 )

      ua14 = ua14 + Lcd1(p2,p34,p1)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +    16*s13**2*s23*s34 + 16*s13**2*s24*s34 + 16*s13*s14*s23*s34 + 
     +    16*s13*s14*s24*s34 )

      ua14 = ua14 + Ld0(p1,p3,p4)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * (  - 64*s12*s13*s14 - 64*s12*s13*s34 - 64*s13*s14*
     +    s23 - 64*s13*s23*s34 )

      ua14 = ua14 + Ld0(p1,p3,p4)*S23**(-1)*S34**(-1)*S123**(-1) * ( 32
     +    *s12*s13 + 16*s12*s14 + 16*s12*s34 + 32*s13*s23 + 16*s13*s24
     +     + 16*s13*s34 + 16*s14**2 + 16*s14*s23 - 16*s14*s24 + 32*s14*
     +    s34 + 16*s23*s34 - 16*s24*s34 + 16*s34**2 )

      ua14 = ua14 + Ld0(p1,p3,p4)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 32*s12**2*s34 - 32*s12*s13*s24 - 32*s12*s14*s23
     +     + 32*s12*s14*s34 + 32*s12*s23*s34 + 32*s12*s34**2 + 32*s13*
     +    s14*s24 + 32*s13*s23*s24 + 32*s13*s24*s34 - 32*s14**2*s23 - 
     +    32*s14*s23**2 - 32*s14*s23*s34 )

      ua14 = ua14 + Ld0(p1,p3,p4)*S23**(-1)*S34**(-1)*S234**(-1) * ( 16
     +    *s12*s23 + 32*s12*s24 + 16*s12*s34 - 16*s13*s23 - 16*s13*s24
     +     - 16*s13*s34 + 16*s14*s23 + 32*s14*s24 + 16*s14*s34 + 16*
     +    s23**2 + 32*s23*s34 + 16*s24*s34 + 16*s34**2 )

      ua14 = ua14 + Ld0(p1,p3,p24)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 32*s12**2*s34 + 32*s12*s13*s24 - 32*s12*s14*
     +    s24 - 64*s12*s14*s34 - 64*s12*s23*s34 - 32*s12*s24*s34 - 64*
     +    s12*s34**2 - 32*s13*s14*s24 + 32*s13*s23*s24 + 32*s13*s24*s34
     +     - 32*s14**2*s24 - 32*s14**2*s34 - 32*s14*s23*s24 - 64*s14*
     +    s23*s34 - 64*s14*s24*s34 - 64*s14*s34**2 - 32*s23**2*s34 - 32
     +    *s23*s24*s34 - 64*s23*s34**2 - 32*s24*s34**2 - 32*s34**3 )

      ua14 = ua14 + Ld0(p1,p3,p24)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 32*s12*s13 + 16*s12*s14 + 16*s12*s34 - 32*s13*s23 - 16*s13
     +    *s24 - 16*s13*s34 + 16*s14**2 + 16*s14*s23 + 16*s14*s24 + 32*
     +    s14*s34 + 16*s23*s34 + 16*s24*s34 + 16*s34**2 )

      ua14 = ua14 + Ld0(p1,p3,p24)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 16*s12*s23 - 16*s12*s34 + 16*s13*s23 + 16*s13*s24 + 16*s13
     +    *s34 - 16*s14*s23 - 16*s14*s34 - 16*s23**2 - 32*s23*s24 - 32*
     +    s23*s34 - 48*s24*s34 - 16*s34**2 )

      ua14 = ua14 + Ld0(p1,p3,p24)*S23**(-1)*S34**(-1)*S234**(-2) * ( 
     +    32*s12*s23*s24 - 32*s12*s24**2 + 32*s12*s24*s34 - 64*s13*
     +    s24**2 + 32*s14*s23*s24 - 32*s14*s24**2 + 32*s14*s24*s34 + 32
     +    *s23**2*s24 + 32*s23*s24**2 + 64*s23*s24*s34 + 32*s24**2*s34
     +     + 32*s24*s34**2 )

      ua14 = ua14 + Ld0(p1,p4,p3)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 64*s12*s13*s14 + 64*s12*s13*s34 + 64*s12*s14*s34
     +     + 32*s12*s34**2 + 64*s13*s14*s23 + 64*s13*s23*s34 + 64*s14*
     +    s23*s34 + 32*s23*s34**2 )

      ua14 = ua14 + Ld0(p1,p4,p3)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 16*s12*s13 - 32*s12*s14 - 32*s12*s34 + 16*s13*s14 - 16*s13
     +    *s23 - 32*s14*s23 - 32*s23*s34 )

      ua14 = ua14 + Ld0(p1,p4,p3)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s34 + 32*s12*s13*s24 + 32*s12*s14*
     +    s23 - 32*s12*s14*s34 - 32*s12*s23*s34 + 32*s12*s24*s34 - 32*
     +    s12*s34**2 - 32*s13*s14*s24 - 16*s13*s23*s24 - 32*s13*s24*s34
     +     + 32*s14**2*s23 + 32*s14*s23**2 + 16*s14*s23*s24 + 32*s14*
     +    s23*s34 - 32*s14*s24*s34 - 16*s24*s34**2 )

      ua14 = ua14 + Ld0(p1,p4,p3)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 32*s12*s23 - 16*s12*s24 - 16*s12*s34 - 32*s13*s23 + 32*s13
     +    *s24 - 32*s14*s23 + 16*s14*s24 - 16*s14*s34 - 16*s23*s34 + 32
     +    *s24*s34 )

      ua14 = ua14 + Ld0(p1,p4,p23)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 32*s12**2*s34 + 32*s12*s13*s23 + 32*s12*s13*s34
     +     - 32*s12*s14*s23 + 32*s12*s14*s34 - 32*s12*s24*s34 - 32*s13*
     +    s14*s23 - 32*s13*s14*s34 + 32*s13*s23**2 + 32*s13*s23*s34 - 
     +    32*s13*s24*s34 - 32*s14**2*s23 - 32*s14*s23**2 - 32*s14*s23*
     +    s34 )

      ua14 = ua14 + Ld0(p1,p4,p23)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 16*s12*s13 + 32*s12*s14 + 16*s13*s14 - 16*s13*s23 + 32*s14
     +    *s23 )

      ua14 = ua14 + Ld0(p1,p4,p23)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +    16*s12*s24 - 16*s12*s34 + 32*s13*s23 + 32*s13*s24 - 16*s14*
     +    s24 - 16*s14*s34 - 32*s23**2 - 16*s23*s24 - 16*s23*s34 )

      ua14 = ua14 + Ld0(p1,p4,p23)*S23**(-1)*S34**(-1)*S234**(-2) * ( 
     +    32*s12*s23**2 - 32*s12*s23*s24 + 64*s12*s23*s34 - 32*s12*s24*
     +    s34 + 32*s12*s34**2 - 64*s13*s23*s24 - 64*s13*s24*s34 + 32*
     +    s14*s23**2 - 32*s14*s23*s24 + 64*s14*s23*s34 - 32*s14*s24*s34
     +     + 32*s14*s34**2 + 32*s23**3 + 32*s23**2*s24 + 64*s23**2*s34
     +     + 32*s23*s34**2 - 32*s24**2*s34 - 32*s24*s34**2 )

      ua14 = ua14 + Ld0(p2,p3,p4)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 32*s12**2*s34 - 32*s12*s13*s24 - 32*s12*s13*s34
     +     - 32*s12*s14*s23 + 16*s12*s14*s34 + 32*s12*s23*s34 + 16*s12*
     +    s34**2 - 16*s13*s14*s23 + 16*s13*s14*s24 - 32*s13*s23*s24 - 
     +    16*s13*s23*s34 - 16*s13*s24*s34 - 16*s14**2*s23 - 32*s14*
     +    s23**2 - 16*s14*s23*s34 )

      ua14 = ua14 + Ld0(p2,p3,p4)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16
     +    *s12*s13 + 32*s12*s14 + 16*s13*s23 + 32*s14*s23 )

      ua14 = ua14 + Ld0(p2,p3,p4)*S23**(-1)*S34**(-1)*S234**(-1) * ( 32
     +    *s12*s23 + 16*s12*s24 - 16*s12*s34 + 32*s13*s23 + 32*s13*s24
     +     + 16*s13*s34 + 32*s14*s23 - 16*s14*s24 - 16*s14*s34 - 16*s23
     +    *s24 - 16*s23*s34 )

      ua14 = ua14 + Ld0(p2,p3,p4)*S23**(-1)*S34**(-1)*S234**(-2) * ( 
     +     - 64*s12*s23*s24 - 32*s12*s23*s34 - 32*s12*s24*s34 - 64*s13*
     +    s23*s24 - 32*s13*s23*s34 - 32*s13*s24*s34 - 64*s14*s23*s24 - 
     +    32*s14*s23*s34 - 32*s14*s24*s34 )

      ua14 = ua14 + Ld0(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 32*s12*s13*s14 + 64*s12*s13*s34 - 32*s12*s14**2
     +     - 32*s12*s14*s34 - 32*s13*s14**2 + 32*s13*s14*s23 + 64*s13*
     +    s23*s34 - 32*s14**3 - 32*s14**2*s23 - 32*s14**2*s34 - 32*s14*
     +    s23*s34 )

      ua14 = ua14 + Ld0(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 16*s12*s13 + 16*s13*s14 - 16*s13*s23 + 32*s14**2 )

      ua14 = ua14 + Ld0(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s34 + 64*s12*s13*s34 + 32*s12*s14*
     +    s23 - 32*s12*s14*s24 + 32*s12*s14*s34 - 32*s12*s23*s34 - 32*
     +    s12*s24*s34 + 32*s12*s34**2 - 32*s13**2*s34 - 64*s13*s14*s24
     +     + 32*s13*s23*s34 - 32*s13*s24*s34 - 32*s13*s34**2 + 32*
     +    s14**2*s23 - 32*s14**2*s24 + 32*s14**2*s34 + 32*s14*s23**2 + 
     +    32*s14*s23*s24 + 64*s14*s23*s34 - 32*s14*s24*s34 + 32*s14*
     +    s34**2 + 32*s23*s24*s34 + 32*s23*s34**2 )

      ua14 = ua14 + Ld0(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 32*s12*s23 + 16*s12*s24 - 16*s12*s34 - 32*s13*s23 + 32*s13
     +    *s24 - 32*s14*s23 + 48*s14*s24 - 16*s14*s34 - 16*s23*s24 - 16
     +    *s23*s34 )

      ua14 = ua14 + Ld0(p2,p4,p3)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 32*s12**2*s34 + 32*s12*s13*s24 + 32*s12*s14*
     +    s23 - 32*s12*s14*s34 - 32*s12*s23*s34 - 32*s12*s34**2 - 32*
     +    s13*s14*s24 + 32*s13*s23*s24 + 32*s13*s24*s34 + 32*s14**2*s23
     +     + 32*s14*s23**2 + 32*s14*s23*s34 )

      ua14 = ua14 + Ld0(p2,p4,p3)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 32*s12*s13 - 16*s12*s14 - 16*s12*s34 - 32*s13*s23 - 16*s13
     +    *s24 - 16*s13*s34 - 16*s14**2 - 16*s14*s23 + 16*s14*s24 - 32*
     +    s14*s34 - 16*s23*s34 + 16*s24*s34 - 16*s34**2 )

      ua14 = ua14 + Ld0(p2,p4,p3)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 16*s12*s23 - 32*s12*s24 - 16*s12*s34 + 16*s13*s23 - 48*s13
     +    *s24 + 16*s13*s34 - 16*s14*s23 - 32*s14*s24 - 16*s14*s34 - 16
     +    *s23**2 - 32*s23*s34 - 16*s24*s34 - 16*s34**2 )

      ua14 = ua14 + Ld0(p2,p4,p3)*S23**(-1)*S34**(-1)*S234**(-2) * ( 64
     +    *s12*s23*s24 + 64*s12*s24*s34 + 64*s13*s23*s24 + 64*s13*s24*
     +    s34 + 64*s14*s23*s24 + 64*s14*s24*s34 )

      ua14 = ua14 + Ld0(p2,p4,p13)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 32*s12*s13**2 - 32*s12*s13*s14 - 32*s12*s13*s34
     +     - 32*s13**2*s14 + 32*s13**2*s23 - 32*s13**2*s34 - 32*s13*
     +    s14**2 - 32*s13*s14*s23 - 64*s13*s14*s34 - 32*s13*s23*s34 - 
     +    32*s13*s34**2 )

      ua14 = ua14 + Ld0(p2,p4,p13)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +    16*s12*s14 + 16*s12*s34 + 32*s13*s14 + 16*s13*s24 + 48*s13*
     +    s34 + 16*s14**2 + 16*s14*s23 - 16*s14*s24 + 32*s14*s34 + 16*
     +    s23*s34 - 16*s24*s34 + 16*s34**2 )

      ua14 = ua14 + Ld0(p2,p4,p13)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 32*s12**2*s34 + 32*s12*s13*s23 - 32*s12*s13*s24
     +     + 32*s12*s13*s34 + 64*s12*s14*s34 + 64*s12*s23*s34 + 64*s12*
     +    s34**2 - 64*s13**2*s24 + 32*s13*s14*s23 - 32*s13*s14*s24 + 32
     +    *s13*s14*s34 + 32*s13*s23**2 + 32*s13*s23*s24 + 64*s13*s23*
     +    s34 - 32*s13*s24*s34 + 32*s13*s34**2 + 32*s14**2*s34 + 64*s14
     +    *s23*s34 + 64*s14*s34**2 + 32*s23**2*s34 + 64*s23*s34**2 + 32
     +    *s34**3 )

      ua14 = ua14 + Ld0(p2,p4,p13)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 16*s12*s23 + 32*s12*s24 - 16*s12*s34 - 16*s13*s23 + 48*s13
     +    *s24 - 16*s13*s34 - 16*s14*s23 + 32*s14*s24 - 16*s14*s34 - 16
     +    *s23**2 - 32*s23*s34 + 16*s24*s34 - 16*s34**2 )

      ua14 = ua14 + Ld1(p1,p4,p3)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s34**2 + 32*s12*s14*s23*s34 - 32*s12
     +    *s14*s34**2 - 16*s12*s23*s34**2 + 16*s12*s24*s34**2 - 16*s12*
     +    s34**3 + 32*s14**2*s23*s34 + 16*s14*s23**2*s34 + 16*s14*s23*
     +    s24*s34 + 16*s14*s23*s34**2 )

      ua14 = ua14 + Ld1(p1,p4,p23)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 16*s12**2*s23*s34 + 16*s12**2*s24*s34 - 16*s12
     +    *s13*s23*s34 + 32*s12*s13*s24*s34 - 16*s12*s14*s23*s34 + 16*
     +    s13**2*s24*s34 - 16*s13*s14*s23*s34 )

      ua14 = ua14 + Ld1(p1,p4,p23)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +    16*s12**2*s34 + 16*s12*s13*s34 )

      ua14 = ua14 + Ld1(p1,p4,p23)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +    16*s12*s23*s34 + 16*s12*s24*s34 + 16*s12*s34**2 )

      ua14 = ua14 + Ld1(p1,p4,p23)*S23**(-1)*S34**(-1)*S234**(-2) * ( 
     +     - 16*s12*s23**2*s34 - 16*s12*s23*s34**2 + 16*s12*s24**2*s34
     +     + 16*s12*s24*s34**2 + 16*s13*s23*s24*s34 + 16*s13*s24**2*s34
     +     + 16*s13*s24*s34**2 - 16*s14*s23**2*s34 - 16*s14*s23*s24*s34
     +     - 16*s14*s23*s34**2 )

      ua14 = ua14 + Ld1(p2,p3,p4)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 32*s12**2*s34**2 - 16*s12*s13*s34**2 - 48*s12*s14
     +    *s23*s34 + 16*s12*s23*s34**2 - 16*s13*s14*s23*s34 + 16*s14**2
     +    *s23**2 - 16*s14*s23**2*s34 )

      ua14 = ua14 + Ld1(p2,p3,p4)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16
     +    *s12*s14*s34 - 16*s14**2*s23 )

      ua14 = ua14 + Ld1(p2,p3,p4)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 16*s12*s34**2 + 16*s14*s23*s34 )

      ua14 = ua14 + Ld1(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * (  - 16*s12**2*s13*s34 + 16*s12**2*s14*s34 + 48*s12
     +    *s13**2*s34 + 32*s12*s13*s14*s34 - 16*s12*s13*s23*s34 - 16*
     +    s12*s13*s24*s34 + 32*s12*s13*s34**2 + 48*s12*s14**2*s34 + 32*
     +    s12*s14*s23*s34 + 32*s12*s14*s34**2 + 16*s13**2*s24*s34 - 16*
     +    s13*s14*s23*s34 - 16*s13*s14*s24*s34 - 16*s13*s23*s24*s34 + 
     +    16*s14**2*s23*s34 + 16*s14*s23**2*s34 )

      ua14 = ua14 + Ld1(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 16*s12**2*s34 + 16*s12*s13*s34 - 48*s12*s14*s34 - 16*s12*
     +    s23*s34 )

      ua14 = ua14 + Ld1(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s13*s34 + 32*s12**2*s14*s34 + 64*s12
     +    *s13**2*s34 + 32*s12*s13*s14*s34 - 16*s12*s13*s23*s34 - 48*
     +    s12*s13*s24*s34 + 48*s12*s13*s34**2 + 32*s12*s14**2*s34 + 48*
     +    s12*s14*s23*s34 + 16*s12*s14*s24*s34 + 16*s12*s14*s34**2 + 32
     +    *s13**2*s24*s34 - 32*s13*s14*s23*s34 - 16*s13*s23*s24*s34 - 
     +    16*s13*s24**2*s34 + 16*s13*s24*s34**2 + 16*s14*s23**2*s34 + 
     +    16*s14*s23*s24*s34 - 16*s14*s23*s34**2 )

      ua14 = ua14 + Ld1(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 32*s12**2*s34 + 32*s12*s13*s34 - 32*s12*s14*s34 - 16*s12*
     +    s23*s34 - 16*s12*s24*s34 + 16*s12*s34**2 )

      ua14 = ua14 + Ld21(p1,p4,p3)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s12**2*s34**2 - 32*s12*s14*s23*s34 + 16*s14**2
     +    *s23**2 )

      ua14 = ua14 + Ld21(p2,p3,p4)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 16*s12**2*s34**2 )

      ua14 = ua14 + Ld21(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 16*s13**2*s23*s34 + 32*s13*s14*s23*s34 + 16*
     +    s14**2*s23*s34 )

      ua14 = ua14 + Ld21(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s13**2*s23*s34 + 32*s13*s14*s23*s34 + 16*
     +    s14**2*s23*s34 )

      ua14 = ua14 + Ld21(p4,p3,p2)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 32*s12*s14*s34**2 - 16*s14**2*s23*s34 )

      ua14 = ua14 + Ld22(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * (  - 16*s12*s13**2*s34 + 16*s13**2*s23*s34 - 16*
     +    s13**2*s24*s34 + 32*s13*s14*s23*s34 )

      ua14 = ua14 + Ld22(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12*s13**2*s34 + 16*s13**2*s23*s34 - 16*
     +    s13**2*s24*s34 + 32*s13*s14*s23*s34 )

      ua14 = ua14 + Ld24(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 48*s12**2*s13*s34 + 16*s12**2*s34**2 + 32*s12*s13
     +    *s24*s34 - 32*s12*s14*s23*s34 )

      ua14 = ua14 + Ld24(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 48*s12**2*s13*s34 + 16*s12**2*s34**2 + 32*s12*s13
     +    *s24*s34 - 32*s12*s14*s23*s34 )

      ua14 = ua14 + Le1(p1,p3,p4,p2)*S23**(-1)*S34**(-1)*S123**(-1)
     +  * ( 16*s12**2*s13*s34 - 32*s12*s13**2*s23 - 16*s12*s13**2*s24
     +     + 16*s12*s13*s14*s34 + 32*s12*s13*s23*s34 + 16*s12*s13*s24*
     +    s34 + 32*s12*s13*s34**2 - 16*s12*s14**2*s24 - 32*s12*s14*s24*
     +    s34 - 16*s12*s24*s34**2 - 16*s13**2*s14*s24 - 32*s13**2*
     +    s23**2 - 32*s13**2*s23*s24 - 16*s13**2*s23*s34 - 16*s13**2*
     +    s24**2 - 32*s13**2*s24*s34 - 32*s13*s14**2*s24 - 48*s13*s14*
     +    s24*s34 + 16*s13*s23**2*s34 + 16*s13*s23*s24*s34 + 16*s13*s23
     +    *s34**2 + 16*s13*s24**2*s34 - 16*s14**3*s24 + 16*s14**2*
     +    s24**2 - 32*s14**2*s24*s34 + 16*s14*s24**2*s34 - 16*s14*s24*
     +    s34**2 )

      ua14 = ua14 + Le1(p1,p3,p4,p2)*S23**(-1)*S34**(-1)*S234**(-1)
     +  * ( 16*s12**2*s24*s34 - 16*s12*s13*s23**2 - 32*s12*s13*s23*s34
     +     - 16*s12*s13*s24**2 + 16*s12*s13*s24*s34 - 16*s12*s13*s34**2
     +     - 32*s12*s14*s24**2 + 32*s12*s14*s24*s34 + 16*s12*s23*s24*
     +    s34 + 32*s12*s24*s34**2 + 16*s13**2*s23**2 + 32*s13**2*s23*
     +    s24 + 16*s13**2*s23*s34 - 16*s13**2*s24**2 + 16*s13**2*s24*
     +    s34 - 64*s13*s14*s24**2 + 16*s13*s14*s24*s34 - 16*s13*s23**3
     +     - 32*s13*s23**2*s24 - 32*s13*s23**2*s34 - 16*s13*s23*s24**2
     +     - 48*s13*s23*s24*s34 - 16*s13*s23*s34**2 - 32*s13*s24**2*s34
     +     - 32*s14**2*s24**2 + 16*s14**2*s24*s34 - 16*s14*s24**2*s34
     +     + 16*s14*s24*s34**2 )

      ua14 = ua14 + Le1(p1,p4,p3,p2)*S23**(-1)*S34**(-1)*S123**(-1)
     +  * (  - 16*s12**2*s14*s34 + 16*s12*s13**2*s23 + 16*s12*s14**2*
     +    s23 + 32*s12*s14**2*s24 + 16*s12*s14**2*s34 - 16*s12*s14*s23*
     +    s34 - 16*s13**2*s14*s23 + 16*s13**2*s23**2 - 32*s13*s14**2*
     +    s23 - 16*s14**3*s23 + 16*s14**2*s23**2 + 32*s14**2*s23*s24 )

      ua14 = ua14 + Le1(p1,p4,p3,p2)*S23**(-1)*S34**(-1)*S234**(-1)
     +  * (  - 16*s12**2*s23*s34 + 32*s12*s13*s23**2 - 16*s12*s13*s23*
     +    s34 + 16*s12*s14*s23**2 - 16*s12*s14*s23*s34 + 16*s12*s14*
     +    s24**2 + 16*s12*s14*s24*s34 + 16*s12*s23**2*s34 + 32*s13**2*
     +    s23**2 + 64*s13*s14*s23**2 + 16*s13*s14*s23*s34 + 16*s13*
     +    s23**2*s34 + 16*s14**2*s23**2 - 32*s14**2*s23*s24 - 16*s14**2
     +    *s24**2 - 16*s14**2*s24*s34 - 16*s14*s23**3 - 32*s14*s23**2*
     +    s24 - 16*s14*s23*s24**2 - 16*s14*s23*s24*s34 )

      return
      end
      
            function ub14(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)
      common/Lsa/Lc0a(12,12),Lc1a(12,14),Lc2a(12,14),Lc3a(12,14),
     . Lcd0a(8,12,8),Lcd1a(8,12,8),Lcd2a(8,12,8),Lcd3a(8,12,8),
     . Ld0a(8,12,12),Ld1sa(8,12,12),Ld2sa(8,12,12),Ld3sa(8,12,12),
     . Ld1a(8,12,12),Ld21a(8,12,12),Ld22a(8,12,12),
     . Ld24a(8,12,12),Ld311a(8,12,12),Ld314a(8,12,12),Ld322a(8,12,12),
     . Ld344a(8,12,12),Le1a(8,8,8,8)

      common/newas12/Ld21as12(8,12,12),Ld22as12(8,12,12),
     .Ld24as12(8,12,12),Ld311as12(8,12,12),
     .Ld314as12(8,12,12),Ld322as12(8,12,12)
      common/newas23/Ld21as23(8,12,12),Ld22as23(8,12,12),
     .Ld24as23(8,12,12),Ld311as23(8,12,12),
     .Ld314as23(8,12,12),Ld322as23(8,12,12)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      ub14=0d0

      ub14 = ub14 + S23**(-1)*S34**(-1)*S123**(-1)*S234**(-1) * (  - 
     +    128*s12**2*s23 - 24*s12**2*s34 - 16*s12*s13*s34 + 8*s12*s14*
     +    s23 + 272*s12*s14*s34 - 264*s12*s23**2 - 320*s12*s23*s34 + 16
     +    *s12*s24*s34 - 16*s13*s23*s34 + 16*s13*s24*s34 - 136*s14**2*
     +    s23 + 16*s14*s23**2 - 120*s23**3 - 272*s23**2*s34 + 16*s23*
     +    s24*s34 - 136*s23*s34**2 - 16*s24**2*s34 )

      ub14 = ub14 + S23**(-1)*S34**(-1)*S123**(-1)*S134**(-1) * (  - 
     +    272*s12**3 - 816*s12**2*s23 - 816*s12*s23**2 - 272*s23**3 )

      ub14 = ub14 + S23**(-1)*S34**(-1)*S123**(-1) * (  - 120*s12**2 + 
     +    8*s12*s13 - 152*s12*s14 - 232*s12*s23 + 136*s12*s34 + 16*
     +    s13**2 - 16*s13*s14 + 24*s13*s23 - 8*s13*s24 + 8*s13*s34 - 
     +    144*s14*s23 - 112*s23**2 + 136*s23*s34 + 8*s24*s34 )

      ub14 = ub14 + S23**(-1)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 
     +    136*s12**2*s34 - 272*s12*s13*s23 - 272*s12*s23*s34 - 136*
     +    s13**2*s34 + 272*s13*s23*s34 - 136*s23**2*s34 )

      ub14 = ub14 + S23**(-1)*S34**(-1)*S234**(-1) * (  - 240*s12*s34
     +     - 496*s13*s23 - 408*s13*s34 - 272*s14*s23 - 408*s14*s34 + 
     +    272*s23**2 + 304*s23*s34 + 136*s34**2 )

      ub14 = ub14 + S23**(-1)*S34**(-1)*S234**(-2) * ( 272*s12*s23**2
     +     + 544*s12*s23*s34 + 272*s12*s34**2 + 272*s13*s23**2 + 544*
     +    s13*s23*s34 + 272*s13*s34**2 + 272*s14*s23**2 + 544*s14*s23*
     +    s34 + 272*s14*s34**2 )

      ub14 = ub14 + S23**(-1)*S34**(-1)*S134**(-1) * ( 272*s12**2 - 136
     +    *s12*s13 + 544*s12*s23 + 136*s13**2 - 408*s13*s23 + 272*
     +    s23**2 )

      ub14 = ub14 + S23**(-1)*S34**(-1) * ( 120*s12 + 120*s13 + 152*s14
     +     + 112*s23 - 144*s34 )

      ub14 = ub14 + log(s12**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     + *S234**(-1) * (  - 64*s12**2*s23 - 32*s12**2*s34 - 64*s12*s13*
     +    s23 - 16*s12*s13*s34 - 16*s12*s14*s34 - 32*s12*s23**2 - 16*
     +    s12*s34**2 + 16*s13**2*s34 - 16*s13*s14*s34 + 32*s13*s23**2
     +     + 48*s13*s23*s34 - 16*s13*s34**2 - 16*s14*s23*s34 + 32*
     +    s23**3 + 32*s23**2*s34 - 16*s23*s34**2 )

      ub14 = ub14 + log(s12**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     +  * ( 32*s12**2 + 32*s12*s13 + 32*s12*s14 + 176*s12*s23 + 64*s12*
     +    s24 + 32*s12*s34 - 16*s13**2 + 16*s13*s14 + 160*s13*s23 - 16*
     +    s13*s24 + 16*s13*s34 - 160*s14*s23 + 48*s14*s24 - 368*s23**2
     +     - 64*s23*s24 - 48*s23*s34 + 48*s24**2 )

      ub14 = ub14 + log(s34**(-1)*s234)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 24*s12**2*s23 + 40*s12**2*s34 + 96*s12*s13*s23 + 
     +    88*s12*s13*s34 + 16*s12*s14*s23 + 24*s12*s14*s34 + 16*s12*
     +    s23**2 + 72*s12*s23*s34 + 16*s12*s34**2 + 96*s13**2*s23 + 32*
     +    s13**2*s34 + 16*s13*s14*s23 + 48*s13*s14*s34 + 64*s13*s23**2
     +     + 96*s13*s23*s34 + 32*s13*s34**2 + 24*s14**2*s23 + 48*s14*
     +    s23**2 + 96*s14*s23*s34 + 8*s23**3 + 96*s23**2*s34 + 80*s23*
     +    s34**2 )

      ub14 = ub14 + log(s34**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     +  * (  - 48*s12*s13 + 16*s12*s14 - 24*s12*s23 + 16*s12*s24 - 8*
     +    s13**2 + 8*s13*s14 + 40*s13*s23 + 32*s13*s24 - 8*s13*s34 + 8*
     +    s14**2 + 96*s14*s23 + 24*s14*s24 + 8*s14*s34 + 40*s23**2 + 96
     +    *s23*s24 + 8*s23*s34 + 16*s24**2 + 8*s24*s34 )

      ub14 = ub14 + log(s234**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1)*S234**(-1) * ( 24*s12**2*s23 + 40*s12**2*s34 + 96*s12
     +    *s13*s23 + 112*s12*s13*s34 + 16*s12*s14*s23 + 24*s12*s14*s34
     +     + 16*s12*s23**2 + 40*s12*s23*s34 - 40*s12*s34**2 + 96*s13**2
     +    *s23 + 72*s13**2*s34 + 16*s13*s14*s23 + 72*s13*s14*s34 + 64*
     +    s13*s23**2 + 24*s13*s23*s34 - 40*s13*s34**2 + 24*s14**2*s23
     +     + 16*s14*s23**2 + 72*s14*s23*s34 - 8*s23**3 - 16*s23*s34**2
     +     )

      ub14 = ub14 + log(s234**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1) * (  - 48*s13*s23 + 40*s13*s34 )

      ub14 = ub14 + log(s234**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S234**(-2) * (  - 48*s12*s23**2 - 96*s12*s23*s34 - 48*s12*s34**2
     +     - 48*s13*s23**2 - 96*s13*s23*s34 - 48*s13*s34**2 - 48*s14*
     +    s23**2 - 96*s14*s23*s34 - 48*s14*s34**2 )

      ub14 = ub14 + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1)*S234**(-1) * (  - 16*s12*s13*s23 - 16*s12*s13*s24 - 
     +    16*s12*s13*s34 - 16*s12*s23*s34 - 48*s12*s24*s34 - 16*s13**2*
     +    s23 - 16*s13**2*s24 - 16*s13**2*s34 + 32*s13*s23**2 + 16*s13*
     +    s23*s24 - 32*s13*s23*s34 + 16*s13*s24**2 - 48*s13*s24*s34 + 
     +    16*s14*s23**2 - 16*s14*s23*s24 - 32*s14*s24*s34 + 16*s23**2*
     +    s34 - 32*s23*s24*s34 + 48*s24**2*s34 - 32*s24*s34**2 )

      ub14 = ub14 + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1)*S134**(-1) * (  - 24*s12**2*s13 - 24*s13**3 + 48*
     +    s13**2*s23 + 24*s13*s23**2 )

      ub14 = ub14 + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1) * ( 16*s12*s13 + 16*s12*s34 + 16*s13**2 - 32*s13*s23
     +     + 16*s13*s24 - 16*s14*s23 + 16*s14*s34 - 16*s23*s34 - 16*s24
     +    *s34 + 24*s34**2 )

      ub14 = ub14 + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S234**(-1)*S134**(-1) * ( 24*s12**2*s34 + 48*s12*s13*s23 + 48*
     +    s12*s23*s34 + 24*s13**2*s34 - 48*s13*s23*s34 + 24*s23**2*s34
     +     )

      ub14 = ub14 + Lc0(p12,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16*
     +    s12**2*s13 + 16*s12**2*s14 + 16*s12**2*s23 + 16*s12**2*s24 + 
     +    56*s12**2*s34 - 48*s12*s13**2 + 16*s12*s13*s14 + 64*s12*s13*
     +    s23 + 48*s12*s13*s34 - 8*s12*s14**2 - 80*s12*s14*s23 - 24*s12
     +    *s14*s24 - 8*s12*s14*s34 - 48*s12*s23**2 - 64*s12*s23*s24 - 
     +    80*s12*s23*s34 - 16*s12*s24**2 - 40*s12*s24*s34 + 16*s13**2*
     +    s14 - 48*s13**2*s23 + 32*s13**2*s24 + 16*s13**2*s34 + 16*s13*
     +    s14**2 + 96*s13*s14*s23 + 16*s13*s14*s34 + 144*s13*s23**2 - 
     +    32*s13*s23*s24 - 48*s13*s23*s34 + 16*s13*s24*s34 - 16*s14**2*
     +    s23 - 16*s14*s23**2 + 160*s14*s23*s34 - 48*s14*s24*s34 + 384*
     +    s23**2*s34 + 96*s23*s24*s34 + 64*s23*s34**2 - 48*s24**2*s34 )

      ub14 = ub14 + Lc0(p12,p34)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    24*s12**2*s34 - 48*s12*s13*s23 + 16*s12*s13*s24 - 32*s12*s14*
     +    s24 - 48*s12*s14*s34 + 24*s12*s23**2 - 56*s12*s23*s24 - 32*
     +    s12*s23*s34 - 32*s12*s24**2 - 120*s12*s24*s34 - 56*s12*s34**2
     +     + 16*s13**2*s23 + 48*s13**2*s24 - 16*s13*s14*s23 + 16*s13*
     +    s14*s24 - 16*s13*s14*s34 - 144*s13*s23**2 - 176*s13*s23*s24
     +     - 80*s13*s23*s34 - 32*s13*s24*s34 - 16*s13*s34**2 - 16*
     +    s14**2*s34 + 16*s14*s23**2 - 16*s14*s23*s24 + 16*s14*s23*s34
     +     - 32*s14*s24*s34 - 16*s14*s34**2 + 32*s23**3 + 32*s23**2*s24
     +     - 32*s23**2*s34 - 16*s23*s24*s34 - 48*s23*s34**2 - 32*s24**2
     +    *s34 - 32*s24*s34**2 )

      ub14 = ub14 + Lc1(p1,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16*
     +    s12**3 + 48*s12**2*s23 - 32*s12**2*s24 + 16*s12**2*s34 + 48*
     +    s12*s13**2 + 16*s12*s13*s23 - 16*s12*s13*s24 + 32*s12*s13*s34
     +     + 16*s12*s23**2 - 96*s12*s23*s24 + 16*s12*s23*s34 - 32*s12*
     +    s24**2 - 32*s13**3 + 64*s13**2*s23 + 16*s13**2*s24 - 48*
     +    s13**2*s34 - 16*s13*s23**2 - 48*s13*s23*s24 + 16*s13*s23*s34
     +     - 32*s13*s24**2 - 16*s13*s34**2 - 16*s23**3 - 64*s23**2*s24
     +     - 32*s23*s24**2 )

      ub14 = ub14 + Lc1(p1,p34)*S23**(-1)*S34**(-1)*S234**(-1) * ( 24*
     +    s12**2*s34 + 48*s12*s13*s23 + 32*s12*s23*s34 + 40*s13**2*s34
     +     - 64*s13*s23*s34 + 16*s13*s34**2 )

      ub14 = ub14 + Lc1(p1,p34)*S23**(-1)*S34**(-1) * (  - 16*s12**2 - 
     +    8*s12*s13 - 32*s12*s23 + 32*s12*s24 - 16*s12*s34 - 40*s13**2
     +     + 24*s13*s23 - 16*s13*s24 - 16*s13*s34 + 16*s23**2 + 64*s23*
     +    s24 + 32*s24**2 )

      ub14 = ub14 + Lc1(p1,p234)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    32*s13**2*s24 - 32*s13**2*s34 - 16*s13*s14*s23 - 16*s13*s14*
     +    s34 - 56*s13*s23**2 - 80*s13*s23*s34 - 24*s13*s34**2 )

      ub14 = ub14 + Lc1(p1,p234)*S23**(-1)*S34**(-1) * ( 48*s13*s23 + 
     +    48*s13*s34 )

      ub14 = ub14 + Lc1(p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 16*s12**2*s23*s34 - 8*s12**2*s34**2 - 8*s12*s14*
     +    s23*s34 - 24*s12*s14*s34**2 + 40*s12*s23**2*s34 - 32*s12*s23*
     +    s34**2 - 16*s12*s34**3 + 24*s14**2*s23*s34 + 16*s14*s23**2*
     +    s34 + 48*s14*s23*s34**2 + 24*s23**3*s34 + 16*s23**2*s34**2 + 
     +    48*s23*s34**3 )

      ub14 = ub14 + Lc1(p2,p34)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    48*s12*s23**2 - 80*s12*s23*s34 - 16*s12*s34**2 - 48*s13*
     +    s23**2 - 16*s13*s23*s34 - 48*s14*s23**2 - 32*s14*s23*s34 - 56
     +    *s23**2*s34 - 32*s23*s34**2 )

      ub14 = ub14 + Lc1(p2,p134)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 48*s13**2*s23**2 + 32*s13**2*s23*s24 + 16*s13**2*
     +    s24**2 + 16*s13*s14*s23**2 - 16*s13*s14*s23*s24 - 32*s13*s14*
     +    s24*s34 - 48*s13*s23**2*s24 + 32*s13*s23**2*s34 - 32*s13*s23*
     +    s24**2 + 16*s13*s23*s24*s34 - 16*s13*s24**3 + 64*s13*s24**2*
     +    s34 - 32*s13*s24*s34**2 - 16*s14*s23**2*s24 + 16*s14*s23*
     +    s24**2 + 48*s14*s24**2*s34 - 32*s23**2*s24*s34 - 16*s23*
     +    s24**2*s34 - 48*s24**3*s34 + 48*s24**2*s34**2 )

      ub14 = ub14 + Lc1(p2,p134)*S23**(-1)*S34**(-1)*S123**(-1) * ( 56*
     +    s13**2*s23 + 16*s13*s14*s24 + 48*s13*s23*s24 + 8*s13*s23*s34
     +     - 16*s13*s24**2 - 16*s14**2*s23 + 16*s14*s23*s24 - 32*s14*
     +    s23*s34 - 24*s14*s24*s34 + 32*s23*s24*s34 - 24*s23*s34**2 + 
     +    16*s24**2*s34 - 32*s24*s34**2 )

      ub14 = ub14 + Lc1(p12,p34)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    64*s12**2*s34 + 32*s12*s13*s14 + 32*s12*s13*s23 + 32*s12*s13*
     +    s24 - 56*s12*s13*s34 + 16*s12*s14**2 + 32*s12*s14*s23 + 32*
     +    s12*s14*s24 + 40*s12*s14*s34 + 32*s12*s23*s24 + 200*s12*s23*
     +    s34 + 16*s12*s24**2 + 72*s12*s24*s34 + 32*s12*s34**2 - 8*s13*
     +    s14**2 - 144*s13*s14*s23 - 24*s13*s14*s24 - 8*s13*s14*s34 - 
     +    240*s13*s23**2 - 144*s13*s23*s24 + 208*s13*s23*s34 - 16*s13*
     +    s24**2 - 72*s13*s24*s34 + 32*s13*s34**2 - 8*s14**3 - 72*
     +    s14**2*s23 - 32*s14**2*s24 - 8*s14**2*s34 - 144*s14*s23**2 - 
     +    152*s14*s23*s24 - 392*s14*s23*s34 - 40*s14*s24**2 + 80*s14*
     +    s24*s34 - 48*s23**3 - 112*s23**2*s24 - 784*s23**2*s34 - 80*
     +    s23*s24**2 - 200*s23*s24*s34 - 160*s23*s34**2 - 16*s24**3 + 
     +    88*s24**2*s34 )

      ub14 = ub14 + Lc1(p12,p34)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    24*s12*s13*s34 - 24*s12*s14*s34 + 40*s12*s23*s34 + 136*s12*
     +    s24*s34 + 80*s12*s34**2 - 16*s13*s14*s23 - 48*s13*s14*s24 - 
     +    16*s13*s14*s34 - 24*s13*s23**2 - 56*s13*s23*s24 - 48*s13*s23*
     +    s34 - 48*s13*s24**2 - 40*s13*s24*s34 - 8*s13*s34**2 - 32*
     +    s14**2*s24 - 16*s14**2*s34 - 8*s14*s23**2 - 56*s14*s23*s24 - 
     +    64*s14*s23*s34 - 64*s14*s24**2 - 24*s14*s24*s34 + 24*s14*
     +    s34**2 + 8*s23**3 - 16*s23**2*s24 + 144*s23**2*s34 - 56*s23*
     +    s24**2 + 88*s23*s24*s34 + 136*s23*s34**2 - 32*s24**3 + 24*
     +    s24**2*s34 + 56*s24*s34**2 )

      ub14 = ub14 + Lc1(p34,p12)*S23**(-1)*S34**(-1)*S123**(-1) * ( 176
     +    *s14**2*s23 - 48*s14**2*s24 + 544*s14*s23**2 + 224*s14*s23*
     +    s24 + 64*s14*s23*s34 - 96*s14*s24**2 + 384*s23**3 + 480*
     +    s23**2*s24 + 64*s23**2*s34 + 48*s23*s24**2 + 64*s23*s24*s34
     +     - 48*s24**3 )

      ub14 = ub14 + Lc1(p34,p12)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    16*s14**2*s23 - 16*s14**2*s24 - 48*s14*s23**2 - 96*s14*s23*
     +    s24 - 112*s14*s23*s34 - 48*s14*s24**2 - 48*s14*s24*s34 - 64*
     +    s23**3 - 112*s23**2*s24 - 32*s23**2*s34 - 80*s23*s24**2 - 112
     +    *s23*s24*s34 - 32*s24**3 - 48*s24**2*s34 )

      ub14 = ub14 + Lc2(p1,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16*
     +    s12**3 + 48*s12**2*s23 - 16*s12**2*s34 - 16*s12*s13*s34 + 48*
     +    s12*s23**2 - 32*s12*s23*s34 - 16*s13**3 - 16*s13**2*s34 - 16*
     +    s13*s23*s34 + 16*s23**3 - 16*s23**2*s34 )

      ub14 = ub14 + Lc2(p1,p34)*S23**(-1)*S34**(-1)*S234**(-1) * ( 8*
     +    s12**2*s34 + 16*s12*s13*s23 + 8*s13**2*s34 )

      ub14 = ub14 + Lc2(p1,p34)*S23**(-1)*S34**(-1) * (  - 16*s12**2 + 
     +    8*s12*s13 - 32*s12*s23 + 16*s12*s34 - 8*s13**2 + 16*s13*s23
     +     - 16*s23**2 + 16*s23*s34 )

      ub14 = ub14 + Lc2(p1,p234)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    8*s13**2*s23 + 8*s13**2*s34 )

      ub14 = ub14 + Lc2(p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 8*s12**2*s23*s34 - 8*s12**2*s34**2 + 8*s12*s14*
     +    s23*s34 + 8*s12*s23**2*s34 - 16*s12*s23*s34**2 + 16*s14*
     +    s23**2*s34 + 16*s23**3*s34 + 16*s23**2*s34**2 )

      ub14 = ub14 + Lc2(p2,p34)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    16*s12*s23**2 - 16*s12*s23*s34 - 8*s13*s23**2 - 8*s14*s23**2
     +     - 16*s23**2*s34 )

      ub14 = ub14 + Lc2(p2,p134)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 16*s13*s24**2*s34 + 16*s24**3*s34 )

      ub14 = ub14 + Lc2(p2,p134)*S23**(-1)*S34**(-1)*S123**(-1) * ( 8*
     +    s13*s23**2 - 8*s13*s23*s24 + 8*s13*s24**2 + 8*s14*s23**2 - 8*
     +    s14*s23*s24 - 8*s24**2*s34 )

      ub14 = ub14 + Lc2(p12,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 32*
     +    s12*s13*s34 + 32*s12*s23*s34 - 32*s13**2*s14 - 304*s13**2*s23
     +     + 16*s13**2*s34 - 64*s13*s14*s23 + 208*s13*s23**2 - 32*s14*
     +    s23**2 - 32*s23**3 - 16*s23**2*s34 )

      ub14 = ub14 + Lc2(p12,p34)*S23**(-1)*S34**(-1)*S234**(-1) * ( 64*
     +    s12*s13*s34 + 64*s12*s14*s34 - 32*s12*s23*s34 + 32*s12*s24*
     +    s34 + 32*s12*s34**2 - 32*s13**2*s23 + 32*s13**2*s24 + 32*
     +    s13**2*s34 - 32*s13*s14*s23 + 32*s13*s14*s24 + 32*s13*s14*s34
     +     - 32*s13*s23**2 + 32*s13*s23*s24 - 32*s13*s23*s34 - 64*s13*
     +    s24*s34 - 32*s14*s23**2 + 32*s14*s23*s24 + 32*s14*s23*s34 - 
     +    64*s23**2*s34 - 64*s23*s24*s34 )

      ub14 = ub14 + Lc3(p12,p34)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    32*s12*s34**2 + 64*s13**3 - 48*s13**2*s23 + 128*s13**2*s34 + 
     +    32*s13*s14*s34 + 48*s13*s23**2 + 32*s13*s23*s34 + 16*s13*
     +    s34**2 + 32*s14*s23*s34 - 64*s23**3 - 96*s23**2*s34 - 16*s23*
     +    s34**2 )

      ub14 = ub14 + Lc3(p12,p34)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    32*s13**2*s34 - 64*s13*s14*s34 + 32*s13*s23*s34 - 32*s13*s24*
     +    s34 - 32*s13*s34**2 - 32*s14**2*s34 + 32*s14*s23*s34 - 32*s14
     +    *s24*s34 - 32*s14*s34**2 + 32*s23*s34**2 + 32*s24*s34**2 )

      ub14 = ub14 + Lc3(p34,p12)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    128*s13**2*s23 + 128*s13*s23**2 )

      ub14 = ub14 + Lc3(p34,p12)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    32*s12**2*s34 + 32*s12*s13*s23 - 32*s12*s13*s24 - 32*s12*s13*
     +    s34 + 32*s12*s23**2 - 32*s12*s23*s24 - 32*s12*s23*s34 + 32*
     +    s13**2*s23 + 32*s13**2*s24 + 64*s13*s23**2 + 64*s13*s23*s24
     +     + 32*s23**3 + 32*s23**2*s24 )

      ub14 = ub14 + Ld0(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 32*s12**2*s34 + 32*s12*s13*s23 + 32*s12*s13*s34
     +     - 32*s12*s14*s23 + 32*s12*s14*s34 + 32*s12*s23*s34 + 32*s12*
     +    s34**2 - 32*s13*s14*s23 - 32*s13*s14*s34 - 32*s13*s23**2 - 64
     +    *s13*s23*s24 - 64*s13*s23*s34 - 64*s13*s24*s34 - 32*s13*
     +    s34**2 - 32*s14**2*s23 - 32*s14*s23**2 - 32*s14*s23*s34 )

      ub14 = ub14 + Ld0(p1,p2,p34)*S23**(-1)*S34**(-1)*S234**(-2) * ( 
     +    32*s12*s23**2 - 32*s12*s23*s24 + 64*s12*s23*s34 - 32*s12*s24*
     +    s34 + 32*s12*s34**2 - 64*s13*s23*s24 - 64*s13*s24*s34 + 32*
     +    s14*s23**2 - 32*s14*s23*s24 + 64*s14*s23*s34 - 32*s14*s24*s34
     +     + 32*s14*s34**2 + 32*s23**3 + 32*s23**2*s24 + 96*s23**2*s34
     +     + 64*s23*s24*s34 + 96*s23*s34**2 + 32*s24*s34**2 + 32*s34**3
     +     )

      ub14 = ub14 + Ld0(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * (  - 64*s12*s13**2 - 64*s13**2*s23 )

      ub14 = ub14 + Ld0(p2,p1,p34)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s34 - 32*s12*s13*s23 + 32*s12*s13*
     +    s24 + 32*s12*s13*s34 - 64*s12*s23*s34 + 32*s13**2*s23 + 32*
     +    s13**2*s24 - 32*s13*s23**2 - 32*s13*s23*s24 + 32*s13*s23*s34
     +     - 32*s23**2*s34 )

      ub14 = ub14 + Ld1(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 16*s12**2*s13*s34 - 16*s12**2*s14*s34 - 16*s12**2
     +    *s23*s34 - 16*s12*s13**2*s23 + 16*s12*s13**2*s34 - 32*s12*s13
     +    *s14*s34 + 48*s12*s13*s23**2 + 32*s12*s13*s23*s24 + 16*s12*
     +    s13*s23*s34 + 16*s12*s14**2*s23 - 16*s12*s14**2*s34 + 16*s12*
     +    s14*s23**2 - 48*s12*s14*s23*s34 - 32*s12*s14*s34**2 - 16*s12*
     +    s23**2*s34 - 32*s12*s23*s34**2 - 16*s12*s34**3 + 16*s13**2*
     +    s14*s23 - 16*s13**2*s14*s34 + 64*s13**2*s23**2 + 64*s13**2*
     +    s23*s24 + 64*s13**2*s23*s34 + 32*s13*s14**2*s23 - 16*s13*
     +    s14**2*s34 + 144*s13*s14*s23**2 + 96*s13*s14*s23*s24 + 144*
     +    s13*s14*s23*s34 + 64*s13*s14*s24*s34 + 32*s13*s14*s34**2 + 32
     +    *s13*s23**3 + 16*s13*s23**2*s24 + 64*s13*s23**2*s34 + 32*s13*
     +    s23*s24*s34 + 32*s13*s23*s34**2 + 16*s13*s24*s34**2 + 16*
     +    s14**3*s23 + 48*s14**2*s23**2 + 32*s14**2*s23*s34 + 16*s14*
     +    s23**3 + 32*s14*s23**2*s34 + 16*s14*s23*s34**2 )

      ub14 = ub14 + Ld1(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 16*s12*s13**2 + 16*s12*s13*s14 + 16*s12*s13*s23 - 32*s12*
     +    s13*s34 + 16*s13**2*s14 + 32*s13**2*s23 + 32*s13**2*s24 + 16*
     +    s13*s14**2 + 48*s13*s14*s23 - 32*s13*s14*s34 + 64*s13*s23**2
     +     + 64*s13*s23*s34 )

      ub14 = ub14 + Ld1(p1,p2,p34)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 16*s12*s13*s23 + 16*s12*s13*s24 - 16*s12*s13*s34 + 32*
     +    s13**2*s24 - 16*s13*s14*s23 + 16*s13*s14*s24 - 16*s13*s14*s34
     +     - 32*s13*s23**2 - 32*s13*s23*s24 - 32*s13*s23*s34 )

      ub14 = ub14 + Ld1(p1,p2,p34)*S23**(-1)*S34**(-1)*S234**(-2) * ( 
     +    16*s12**2*s23*s34 - 16*s12**2*s24*s34 + 16*s12**2*s34**2 - 16
     +    *s12*s13*s23**2 + 16*s12*s13*s23*s24 - 48*s12*s13*s24*s34 + 
     +    16*s12*s13*s34**2 - 16*s12*s14*s23**2 + 16*s12*s14*s23*s24 - 
     +    16*s12*s14*s24*s34 + 16*s12*s14*s34**2 + 32*s12*s23**2*s34 + 
     +    32*s12*s23*s24*s34 + 64*s12*s23*s34**2 + 32*s12*s24*s34**2 + 
     +    32*s12*s34**3 + 32*s13**2*s23*s24 - 32*s13**2*s24*s34 - 16*
     +    s13*s14*s23**2 + 48*s13*s14*s23*s24 - 16*s13*s14*s24*s34 + 16
     +    *s13*s14*s34**2 - 64*s13*s23**3 - 96*s13*s23**2*s24 - 128*s13
     +    *s23**2*s34 - 32*s13*s23*s24**2 - 128*s13*s23*s24*s34 - 64*
     +    s13*s23*s34**2 - 32*s13*s24**2*s34 - 32*s13*s24*s34**2 - 16*
     +    s14**2*s23**2 + 16*s14**2*s23*s24 - 16*s14**2*s23*s34 - 32*
     +    s14*s23**3 - 32*s14*s23**2*s24 - 64*s14*s23**2*s34 - 32*s14*
     +    s23*s24*s34 - 32*s14*s23*s34**2 )

      ub14 = ub14 + Ld1(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * (  - 48*s12**2*s13*s34 + 80*s12*s13**2*s23 + 48*s12
     +    *s13**2*s24 + 16*s12*s13**2*s34 + 32*s12*s13*s14*s23 - 32*s12
     +    *s13*s23*s34 + 32*s12*s14*s23*s34 + 32*s12*s23*s34**2 - 32*
     +    s13**3*s23 - 16*s13**3*s24 - 16*s13**2*s14*s23 + 80*s13**2*
     +    s23**2 + 48*s13**2*s23*s24 + 32*s13**2*s23*s34 + 32*s13*s14*
     +    s23**2 + 32*s13*s14*s23*s34 + 16*s13*s23**2*s34 + 80*s13*s23*
     +    s34**2 + 32*s14*s23**2*s34 + 48*s14*s23*s34**2 + 32*s23**2*
     +    s34**2 + 48*s23*s34**3 )

      ub14 = ub14 + Ld1(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +    48*s12*s13*s23 - 32*s12*s23*s34 - 64*s13**2*s23 + 48*s13*
     +    s23**2 - 32*s13*s23*s34 - 32*s23**2*s34 - 48*s23*s34**2 )

      ub14 = ub14 + Ld1(p2,p1,p34)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12**2*s23*s34 + 16*s12**2*s24*s34 + 16*
     +    s12**2*s34**2 + 16*s12*s13*s23**2 + 16*s12*s13*s23*s34 - 16*
     +    s12*s13*s24**2 + 16*s12*s13*s24*s34 - 32*s12*s23**2*s34 + 32*
     +    s12*s23*s34**2 - 64*s13**2*s23**2 - 96*s13**2*s23*s24 - 32*
     +    s13**2*s24**2 - 32*s13*s14*s23**2 - 32*s13*s14*s23*s24 + 16*
     +    s13*s23**3 + 32*s13*s23**2*s24 - 48*s13*s23**2*s34 + 16*s13*
     +    s23*s24**2 - 48*s13*s23*s24*s34 - 32*s14*s23**2*s34 - 32*s14*
     +    s23*s24*s34 - 16*s23**3*s34 - 16*s23**2*s24*s34 - 16*s23**2*
     +    s34**2 - 32*s23*s24*s34**2 )

      ub14 = ub14 + Ld1(p2,p1,p34)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +    16*s12*s23**2 - 16*s12*s23*s24 - 16*s12*s23*s34 - 32*s13*
     +    s23**2 - 32*s13*s23*s24 + 16*s23**3 + 16*s23**2*s24 + 16*
     +    s23**2*s34 + 32*s23*s24*s34 )

      ub14 = ub14 + Ld21(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 16*s12**2*s23**2 + 32*s12**2*s23*s34 + 16*s12**2*
     +    s34**2 + 16*s12*s13*s23**2 + 32*s12*s13*s23*s34 + 16*s12*s13*
     +    s34**2 + 32*s12*s14*s23**2 + 64*s12*s14*s23*s34 + 32*s12*s14*
     +    s34**2 + 32*s12*s23**3 + 96*s12*s23**2*s34 + 96*s12*s23*
     +    s34**2 + 32*s12*s34**3 )

      ub14 = ub14 + Ld21(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 48*s13*s23**2 - 48*s13*s23*s34 )

      ub14 = ub14 + Ld21(p1,p2,p34)*S23**(-1)*S34**(-1)*S234**(-2) * ( 
     +     - 16*s12*s23**3 - 16*s12*s23**2*s24 - 48*s12*s23**2*s34 - 32
     +    *s12*s23*s24*s34 - 48*s12*s23*s34**2 - 16*s12*s24*s34**2 - 16
     +    *s12*s34**3 )

      ub14 = ub14 + Ld21(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 16*s12**2*s13**2 + 32*s12**2*s13*s34 + 16*s12**2*
     +    s34**2 - 32*s12*s13**3 + 16*s12*s13**2*s23 - 64*s12*s13**2*
     +    s34 + 32*s12*s13*s23*s34 - 32*s12*s13*s34**2 + 16*s12*s23*
     +    s34**2 )

      ub14 = ub14 + Ld21(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +    48*s13**2*s23 + 48*s13*s23*s34 )

      ub14 = ub14 + Ld21(p2,p1,p34)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12*s13**2*s23 - 16*s12*s13**2*s24 - 32*s12
     +    *s13*s23*s34 - 32*s12*s13*s24*s34 - 16*s12*s23*s34**2 - 16*
     +    s12*s24*s34**2 )

      ub14 = ub14 + Ld22(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 16*s12**2*s23**2 + 32*s12**2*s23*s34 + 32*s12*s13
     +    *s23*s34 + 16*s12*s14*s23**2 + 64*s12*s14*s23*s34 + 32*s12*
     +    s23**3 + 96*s12*s23**2*s34 + 64*s12*s23*s34**2 - 16*s13**2*
     +    s23**2 - 48*s13*s14*s23**2 - 32*s13*s23**3 - 32*s13*s23**2*
     +    s34 - 32*s14**2*s23**2 - 32*s14*s23**3 - 32*s14*s23**2*s34 )

      ub14 = ub14 + Ld22(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 48*s13*s23**2 )

      ub14 = ub14 + Ld22(p1,p2,p34)*S23**(-1)*S34**(-1)*S234**(-2) * ( 
     +     - 16*s12*s23**3 - 16*s12*s23**2*s24 - 48*s12*s23**2*s34 - 32
     +    *s12*s23*s24*s34 - 32*s12*s23*s34**2 + 16*s13*s23**3 + 16*s13
     +    *s23**2*s24 + 16*s13*s23**2*s34 + 16*s14*s23**3 + 16*s14*
     +    s23**2*s24 + 16*s14*s23**2*s34 )

      ub14 = ub14 + Ld22(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 16*s12**2*s13**2 + 32*s12**2*s13*s34 - 32*s12*
     +    s13**3 - 16*s12*s13**2*s24 - 64*s12*s13**2*s34 + 32*s12*s13*
     +    s23*s34 + 32*s13**3*s23 + 32*s13**3*s24 - 16*s13**2*s23**2 - 
     +    16*s13**2*s23*s24 )

      ub14 = ub14 + Ld22(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +    48*s13**2*s23 )

      ub14 = ub14 + Ld22(p2,p1,p34)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12*s13**2*s23 - 16*s12*s13**2*s24 - 32*s12
     +    *s13*s23*s34 - 32*s12*s13*s24*s34 + 16*s13**2*s23**2 + 32*
     +    s13**2*s23*s24 + 16*s13**2*s24**2 )

      ub14 = ub14 + Ld24(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 32*s12**2*s13*s34 + 48*s12*s13**2*s23 + 16*s12
     +    *s13**2*s24 - 32*s12*s13**2*s34 + 32*s12*s13*s14*s23 - 64*s12
     +    *s13*s14*s34 - 64*s12*s13*s23*s34 - 64*s12*s13*s34**2 + 48*
     +    s13**3*s23 + 16*s13**3*s24 + 128*s13**2*s14*s23 + 32*s13**2*
     +    s14*s24 + 96*s13**2*s23**2 + 32*s13**2*s23*s24 + 96*s13**2*
     +    s23*s34 + 32*s13**2*s24*s34 + 64*s13*s14**2*s23 + 64*s13*s14*
     +    s23**2 + 64*s13*s14*s23*s34 )

      ub14 = ub14 + Ld24(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +    48*s13**2*s23 )

      ub14 = ub14 + Ld24(p1,p2,p34)*S23**(-1)*S34**(-1)*S234**(-2) * ( 
     +    32*s12*s13*s23*s34 + 32*s12*s13*s24*s34 + 32*s12*s13*s34**2
     +     - 48*s13**2*s23**2 - 64*s13**2*s23*s24 - 48*s13**2*s23*s34
     +     - 16*s13**2*s24**2 - 16*s13**2*s24*s34 - 32*s13*s14*s23**2
     +     - 32*s13*s14*s23*s24 - 32*s13*s14*s23*s34 )

      ub14 = ub14 + Ld24(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * (  - 32*s12**2*s23*s34 + 48*s12*s13*s23**2 + 32*s12
     +    *s13*s23*s24 + 64*s12*s13*s23*s34 + 16*s12*s14*s23**2 - 32*
     +    s12*s23**2*s34 - 96*s13**2*s23**2 - 64*s13**2*s23*s24 - 32*
     +    s13*s14*s23**2 + 48*s13*s23**3 + 32*s13*s23**2*s24 + 16*s14*
     +    s23**3 )

      ub14 = ub14 + Ld24(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 48*s13*s23**2 )

      ub14 = ub14 + Ld24(p2,p1,p34)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 32*s12*s23**2*s34 + 32*s12*s23*s24*s34 - 48*s13*
     +    s23**3 - 80*s13*s23**2*s24 - 32*s13*s23*s24**2 - 16*s14*
     +    s23**3 - 16*s14*s23**2*s24 )

      ub14 = ub14 + Ld311(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 32*s12*s23**3 + 48*s12*s23**2*s34 - 16*s12*s34**3
     +     + 48*s13*s23**3 + 96*s13*s23**2*s34 + 48*s13*s23*s34**2 + 48
     +    *s14*s23**3 + 96*s14*s23**2*s34 + 48*s14*s23*s34**2 )

      ub14 = ub14 + Ld311(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * (  - 32*s12*s13**3 - 48*s12*s13**2*s34 + 16*s12*
     +    s34**3 - 48*s13**3*s23 - 48*s13**3*s24 - 96*s13**2*s23*s34 - 
     +    96*s13**2*s24*s34 - 48*s13*s23*s34**2 - 48*s13*s24*s34**2 )

      ub14 = ub14 + Ld314(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 48*s12*s13*s23**2 + 48*s12*s13*s34**2 - 144*
     +    s13**2*s23**2 - 48*s13**2*s23*s24 - 144*s13**2*s23*s34 - 48*
     +    s13**2*s24*s34 - 96*s13*s14*s23**2 - 96*s13*s14*s23*s34 )

      ub14 = ub14 + Ld314(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 48*s12*s13**2*s23 - 48*s12*s23*s34**2 + 144*
     +    s13**2*s23**2 + 96*s13**2*s23*s24 + 48*s13*s14*s23**2 + 144*
     +    s13*s23**2*s34 + 96*s13*s23*s24*s34 + 48*s14*s23**2*s34 )

      ub14 = ub14 + Ld322(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 32*s12*s23**3 - 48*s12*s23**2*s34 + 64*s13*
     +    s23**3 + 48*s13*s23**2*s24 + 16*s14*s23**3 )

      ub14 = ub14 + Ld322(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 32*s12*s13**3 + 48*s12*s13**2*s34 - 64*s13**3*s23
     +     - 16*s13**3*s24 - 48*s13**2*s14*s23 )

      ub14 = ub14 + Ld344(p1,p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 48*s12*s13**2*s23 + 64*s13**3*s23 + 16*s13**3*s24
     +     + 48*s13**2*s14*s23 )

      ub14 = ub14 + Ld344(p2,p1,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * (  - 48*s12*s13*s23**2 - 64*s13*s23**3 - 48*s13*
     +    s23**2*s24 - 16*s14*s23**3 )

      return
      end
      
      function uc14(p1,p2,p3,p4)
      implicit real*8(a-o,q-z)
      implicit integer(p)
      common/ss/s(8,8)
      common/Ls/Lc0(12,12),Lc1(12,14),Lc2(12,14),Lc3(12,14),Lc4(12,14),
     . Lc1s(12,14),Lc2s(12,14),Lc3s(12,14),Lc4s(12,14),
     . Lcd0(8,12,8),Lcd1(8,12,8),Lcd2(8,12,8),Lcd3(8,12,8),
     . Ld0(8,12,12),Ld1s(8,12,12),Ld2s(8,12,12),Ld3s(8,12,12),
     . Ld1(8,12,12),Ld21(8,12,12),Ld22(8,12,12),Ld24(8,12,12),
     . Ld311(8,12,12),Ld314(8,12,12),Ld322(8,12,12),Ld344(8,12,12),
     . Le1(8,8,8,8)
      common/Lsa/Lc0a(12,12),Lc1a(12,14),Lc2a(12,14),Lc3a(12,14),
     . Lcd0a(8,12,8),Lcd1a(8,12,8),Lcd2a(8,12,8),Lcd3a(8,12,8),
     . Ld0a(8,12,12),Ld1sa(8,12,12),Ld2sa(8,12,12),Ld3sa(8,12,12),
     . Ld1a(8,12,12),Ld21a(8,12,12),Ld22a(8,12,12),
     . Ld24a(8,12,12),Ld311a(8,12,12),Ld314a(8,12,12),Ld322a(8,12,12),
     . Ld344a(8,12,12),Le1a(8,8,8,8)

      common/newas12/Ld21as12(8,12,12),Ld22as12(8,12,12),
     .Ld24as12(8,12,12),Ld311as12(8,12,12),
     .Ld314as12(8,12,12),Ld322as12(8,12,12)
      common/newas23/Ld21as23(8,12,12),Ld22as23(8,12,12),
     .Ld24as23(8,12,12),Ld311as23(8,12,12),
     .Ld314as23(8,12,12),Ld322as23(8,12,12)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      p12=p1+p2
      p13=p1+p3
      p14=p1+p4
      p23=p2+p3
      p24=p2+p4
      p34=p3+p4
      p123=p1+p2+p3
      p124=p1+p2+p4
      p134=p1+p3+p4
      p234=p2+p3+p4
      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34
      s1234=s12+s13+s14+s23+s24+s34

      uc14=0d0

      uc14 = uc14 + S23**(-1)*S34**(-1)*S123**(-1)*S234**(-1) * (  - 48
     +    *s12**2*s23 - 8*s12**2*s34 - 16*s12*s13*s34 - 8*s12*s14*s23
     +     + 80*s12*s14*s34 - 120*s12*s23**2 - 80*s12*s23*s24 - 120*s12
     +    *s23*s34 - 48*s12*s24**2 - 24*s12*s24*s34 + 8*s12*s34**2 + 48
     +    *s13*s23**2 + 80*s13*s23*s24 + 8*s13*s23*s34 + 48*s13*s24**2
     +     + 56*s13*s24*s34 - 8*s13*s34**2 - 40*s14**2*s23 - 32*s14*
     +    s23**2 - 80*s14*s23*s24 - 24*s14*s23*s34 - 48*s14*s24**2 - 40
     +    *s14*s24*s34 + 8*s14*s34**2 - 40*s23**3 - 88*s23**2*s34 + 16*
     +    s23*s24*s34 - 40*s23*s34**2 - 16*s24**2*s34 )

      uc14 = uc14 + S23**(-1)*S34**(-1)*S123**(-1)*S134**(-1) * (  - 80
     +    *s12**3 - 48*s12**2*s13 - 240*s12**2*s23 + 112*s12**2*s24 + 
     +    48*s12**2*s34 - 48*s12*s13**2 - 48*s12*s13*s23 + 112*s12*s13*
     +    s24 + 48*s12*s13*s34 - 240*s12*s23**2 + 160*s12*s23*s24 + 48*
     +    s12*s23*s34 + 48*s13*s23*s24 - 80*s23**3 + 48*s23**2*s24 )

      uc14 = uc14 + S23**(-1)*S34**(-1)*S123**(-1) * (  - 8*s12**2 + 40
     +    *s12*s13 - 40*s12*s14 + 48*s12*s23 + 96*s12*s24 + 24*s12*s34
     +     + 48*s13*s23 - 8*s13*s24 + 8*s13*s34 + 48*s14*s24 - 8*s14*
     +    s34 + 24*s23**2 + 48*s23*s24 + 32*s23*s34 + 8*s24*s34 )

      uc14 = uc14 + S23**(-1)*S34**(-1)*S234**(-1)*S134**(-1) * (  - 40
     +    *s12**2*s34 - 80*s12*s13*s23 - 80*s12*s23*s34 - 40*s13**2*s34
     +     + 80*s13*s23*s34 - 40*s23**2*s34 )

      uc14 = uc14 + S23**(-1)*S34**(-1)*S234**(-1) * ( 16*s12*s23 + 16*
     +    s12*s24 - 64*s12*s34 - 192*s13*s23 - 16*s13*s24 - 136*s13*s34
     +     - 64*s14*s23 + 16*s14*s24 - 104*s14*s34 + 80*s23**2 + 80*s23
     +    *s34 + 40*s34**2 )

      uc14 = uc14 + S23**(-1)*S34**(-1)*S234**(-2) * ( 80*s12*s23**2 + 
     +    160*s12*s23*s34 + 80*s12*s34**2 + 80*s13*s23**2 + 160*s13*s23
     +    *s34 + 80*s13*s34**2 + 80*s14*s23**2 + 160*s14*s23*s34 + 80*
     +    s14*s34**2 )

      uc14 = uc14 + S23**(-1)*S34**(-1)*S134**(-1) * ( 80*s12**2 + 8*
     +    s12*s13 + 160*s12*s23 - 112*s12*s24 - 48*s12*s34 + 40*s13**2
     +     - 120*s13*s23 + 80*s23**2 - 48*s23*s24 )

      uc14 = uc14 + S23**(-1)*S34**(-1) * (  - 8*s12 + 56*s13 + 24*s14
     +     - 24*s23 - 48*s24 - 40*s34 )

      uc14 = uc14 + log(s14**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     + *S234**(-1) * ( 16*s12*s13*s34 + 32*s12*s14*s34 - 32*s12*s34**2
     +     + 16*s13**2*s34 + 32*s13*s14*s34 + 16*s13*s23*s34 - 32*s13*
     +    s34**2 + 32*s14*s23*s34 - 32*s23*s34**2 )

      uc14 = uc14 + log(s14**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     + *S134**(-1) * (  - 16*s12**2*s34 + 32*s12*s34**2 - 16*s13**2*s34
     +     + 32*s13*s23*s34 + 16*s23**2*s34 + 32*s23*s34**2 )

      uc14 = uc14 + log(s14**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     +  * ( 32*s13*s34 + 16*s14*s34 - 16*s23*s34 - 16*s34**2 )

      uc14 = uc14 + log(s14**(-1)*s1234)*S23**(-1)*S34**(-1)*S234**(-1)
     + *S134**(-1) * ( 16*s13*s34**2 - 16*s23**2*s34 - 32*s23*s34**2 )

      uc14 = uc14 + log(s23**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     + *S234**(-1) * (  - 16*s12**2*s34 + 48*s12*s34**2 + 32*s13*s23*
     +    s34 + 48*s13*s34**2 + 16*s23**2*s34 + 32*s23*s34**2 )

      uc14 = uc14 + log(s23**(-1)*s1234)*S23**(-1)*S34**(-1)*S234**(-2)
     +  * ( 32*s12*s23*s34 + 32*s12*s34**2 + 32*s13*s23*s34 + 32*s13*
     +    s34**2 + 32*s14*s23*s34 + 32*s14*s34**2 )

      uc14 = uc14 + log(s34**(-1)*s234)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 24*s12**2*s23 + 48*s12**2*s34 + 96*s12*s13*s23 + 
     +    112*s12*s13*s34 + 48*s12*s14*s23 + 24*s12*s14*s34 + 64*s12*
     +    s23*s34 + 16*s12*s34**2 + 96*s13**2*s23 + 32*s13**2*s34 + 48*
     +    s13*s14*s23 + 64*s13*s14*s34 + 64*s13*s23**2 + 64*s13*s23*s34
     +     + 24*s14**2*s23 + 64*s14*s23**2 + 16*s14*s23*s34 - 24*s23**3
     +     + 16*s23**2*s34 + 16*s23*s34**2 )

      uc14 = uc14 + log(s34**(-1)*s234)*S23**(-1)*S34**(-1)*S234**(-2)
     +  * (  - 32*s12*s23*s34 - 32*s12*s34**2 - 32*s13*s23*s34 - 32*s13
     +    *s34**2 - 32*s14*s23*s34 - 32*s14*s34**2 )

      uc14 = uc14 + log(s34**(-1)*s134)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 16*s12**2*s34 + 16*s13**2*s34 - 32*s13*s23*s34 - 
     +    16*s23**2*s34 )

      uc14 = uc14 + log(s34**(-1)*s134)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s13*s34**2 + 16*s23**2*s34 + 32*s23*s34**2
     +     )

      uc14 = uc14 + log(s34**(-1)*s1234)*S23**(-1)*S34**(-1)*S123**(-1)
     +  * (  - 48*s12*s13 - 24*s13**2 - 24*s13*s14 - 48*s13*s23 + 16*
     +    s13*s34 + 48*s23*s34 )

      uc14 = uc14 + log(s234**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1)*S234**(-1) * ( 24*s12**2*s23 + 48*s12**2*s34 + 96*s12
     +    *s13*s23 + 120*s12*s13*s34 + 48*s12*s14*s23 + 24*s12*s14*s34
     +     - 16*s12*s23**2 - 32*s12*s23*s24 - 80*s12*s23*s34 - 16*s12*
     +    s24**2 - 64*s12*s24*s34 - 120*s12*s34**2 + 96*s13**2*s23 + 88
     +    *s13**2*s34 + 48*s13*s14*s23 + 72*s13*s14*s34 + 32*s13*s23**2
     +     - 40*s13*s23*s34 + 16*s13*s24**2 + 32*s13*s24*s34 - 56*s13*
     +    s34**2 + 24*s14**2*s23 + 32*s14*s23**2 - 32*s14*s23*s24 + 8*
     +    s14*s23*s34 - 16*s14*s24**2 - 64*s14*s24*s34 - 48*s14*s34**2
     +     - 72*s23**3 - 176*s23**2*s24 - 40*s23**2*s34 - 224*s23*
     +    s24**2 - 48*s23*s24*s34 + 32*s23*s34**2 - 96*s24**3 - 88*
     +    s24**2*s34 - 8*s34**3 )

      uc14 = uc14 + log(s234**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1) * ( 16*s12*s23 + 16*s12*s24 + 48*s12*s34 - 16*s13*s24
     +     - 24*s13*s34 + 16*s14*s23 + 16*s14*s24 + 48*s14*s34 + 48*
     +    s23**2 + 128*s23*s24 - 120*s23*s34 + 96*s24**2 - 8*s24*s34 + 
     +    8*s34**2 )

      uc14 = uc14 + log(s234**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S234**(-2) * (  - 48*s12*s23**2 - 128*s12*s23*s34 - 80*s12*
     +    s34**2 - 48*s13*s23**2 - 128*s13*s23*s34 - 80*s13*s34**2 - 48
     +    *s14*s23**2 - 128*s14*s23*s34 - 80*s14*s34**2 )

      uc14 = uc14 + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1)*S234**(-1) * (  - 16*s12*s13*s23 - 16*s12*s13*s24 - 
     +    80*s12*s13*s34 - 64*s12*s14*s34 + 16*s12*s23*s34 - 48*s12*s24
     +    *s34 - 16*s12*s34**2 - 16*s13**2*s23 - 16*s13**2*s24 - 80*
     +    s13**2*s34 - 64*s13*s14*s34 - 16*s13*s23**2 - 16*s13*s23*s24
     +     + 32*s13*s23*s34 + 16*s13*s24**2 - 16*s13*s34**2 - 16*s14*
     +    s23**2 - 32*s14*s23*s24 - 16*s14*s24*s34 + 16*s23**2*s34 - 64
     +    *s23*s24*s34 + 48*s24**2*s34 )

      uc14 = uc14 + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1)*S134**(-1) * (  - 24*s12**2*s13 + 16*s12**2*s34 - 32*
     +    s12*s34**2 - 24*s13**3 + 48*s13**2*s23 + 16*s13**2*s34 + 24*
     +    s13*s23**2 - 32*s13*s23*s34 - 16*s23**2*s34 - 32*s23*s34**2 )

      uc14 = uc14 + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S123**(-1) * ( 16*s12*s13 + 48*s12*s34 + 16*s13**2 + 16*s13*s24
     +     - 80*s13*s34 - 16*s14*s23 - 16*s24*s34 + 8*s34**2 )

      uc14 = uc14 + log(s134**(-1)*s1234)*S23**(-1)*S34**(-1)*
     + S234**(-1)*S134**(-1) * ( 24*s12**2*s34 + 48*s12*s13*s23 + 48*
     +    s12*s23*s34 + 24*s13**2*s34 - 48*s13*s23*s34 - 16*s13*s34**2
     +     + 40*s23**2*s34 + 32*s23*s34**2 )

      uc14 = uc14 + Lc0(p14,p23)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16*
     +    s12**2*s34 + 96*s12*s13*s34 - 16*s12*s23*s34 - 16*s12*s24*s34
     +     + 32*s13*s23*s34 - 16*s13*s24*s34 - 16*s14*s23*s34 )

      uc14 = uc14 + Lc0(p14,p23)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    32*s12**2*s34 + 96*s12*s13*s34 - 16*s12*s23*s34 - 16*s12*s24*
     +    s34 + 48*s12*s34**2 - 16*s13**2*s34 + 16*s13*s23*s34 - 16*s13
     +    *s24*s34 - 16*s13*s34**2 + 16*s14*s23*s34 - 16*s14*s24*s34 + 
     +    16*s14*s34**2 + 16*s23*s34**2 - 16*s24**2*s34 - 16*s24*s34**2
     +     )

      uc14 = uc14 + Lc1(p1,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 64*
     +    s12**3 + 208*s12**2*s23 + 32*s12**2*s24 + 8*s12**2*s34 - 16*
     +    s12*s13**2 - 8*s12*s13*s23 + 8*s12*s13*s24 - 8*s12*s13*s34 + 
     +    208*s12*s23**2 + 32*s12*s23*s24 + 24*s12*s23*s34 - 16*s12*s24
     +    *s34 - 24*s13**2*s23 - 8*s13**2*s24 + 48*s13**2*s34 - 24*s13*
     +    s23**2 - 24*s13*s23*s24 - 16*s13*s24*s34 - 16*s13*s34**2 + 64
     +    *s23**3 + 16*s23**2*s34 - 16*s23*s24*s34 )

      uc14 = uc14 + Lc1(p1,p34)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s14*s23**2*s34 )

      uc14 = uc14 + Lc1(p1,p34)*S23**(-1)*S34**(-1)*S234**(-1) * ( 24*
     +    s12**2*s34 + 48*s12*s13*s23 + 16*s12*s23*s34 + 32*s12*s34**2
     +     + 24*s13**2*s34 - 16*s13*s23*s34 - 16*s13*s34**2 )

      uc14 = uc14 + Lc1(p1,p34)*S23**(-1)*S34**(-1) * (  - 64*s12**2 + 
     +    40*s12*s13 - 144*s12*s23 - 32*s12*s24 - 24*s12*s34 - 24*
     +    s13**2 + 112*s13*s23 + 24*s13*s24 - 64*s23**2 - 16*s23*s34 + 
     +    16*s24*s34 )

      uc14 = uc14 + Lc1(p1,p234)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 16*s13**2*s23*s24 - 32*s13**2*s23*s34 - 16*
     +    s13**2*s24**2 - 48*s13**2*s24*s34 - 32*s13**2*s34**2 + 16*s13
     +    *s14*s23**2 + 16*s13*s14*s23*s24 + 32*s13*s14*s23*s34 + 16*
     +    s13*s14*s24*s34 + 16*s13*s14*s34**2 + 48*s13*s23**2*s24 - 112
     +    *s13*s23**2*s34 + 96*s13*s23*s24**2 - 112*s13*s23*s24*s34 - 
     +    96*s13*s23*s34**2 + 48*s13*s24**3 - 32*s13*s24*s34**2 + 16*
     +    s13*s34**3 )

      uc14 = uc14 + Lc1(p1,p234)*S23**(-1)*S34**(-1)*S234**(-1) * ( 32*
     +    s13*s23**2 + 48*s13*s23*s24 + 32*s13*s23*s34 + 16*s13*s24**2
     +     + 32*s13*s24*s34 + 16*s13*s34**2 )

      uc14 = uc14 + Lc1(p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 32*s12**2*s23*s34 - 56*s12**2*s34**2 + 8*s12*s14*
     +    s23*s34 - 40*s12*s14*s34**2 + 40*s12*s23**2*s34 - 96*s12*s23*
     +    s34**2 + 16*s12*s34**3 + 24*s14**2*s23*s34 + 32*s14*s23**2*
     +    s34 - 48*s14*s23*s34**2 + 8*s23**3*s34 - 40*s23**2*s34**2 )

      uc14 = uc14 + Lc1(p2,p34)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    48*s12*s23**2 - 32*s12*s23*s34 + 48*s12*s34**2 - 48*s13*
     +    s23**2 + 32*s13*s23*s34 - 48*s14*s23**2 - 72*s23**2*s34 + 32*
     +    s23*s34**2 )

      uc14 = uc14 + Lc1(p2,p134)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 16*s13**2*s23**2 + 96*s13**2*s23*s34 + 16*
     +    s13**2*s24**2 + 48*s13**2*s24*s34 - 48*s13*s14*s23**2 - 32*
     +    s13*s14*s23*s24 + 64*s13*s14*s23*s34 - 16*s13*s14*s24*s34 - 
     +    16*s13*s23**2*s34 - 112*s13*s23*s24*s34 + 16*s13*s23*s34**2
     +     - 16*s13*s24**3 + 16*s13*s24**2*s34 - 16*s14**2*s23**2 + 16*
     +    s14*s23**2*s24 - 16*s14*s23**2*s34 + 32*s14*s23*s24**2 - 64*
     +    s14*s23*s24*s34 + 32*s14*s24**2*s34 + 16*s23*s24**2*s34 - 16*
     +    s23*s24*s34**2 - 48*s24**3*s34 + 16*s24**2*s34**2 )

      uc14 = uc14 + Lc1(p2,p134)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    96*s13**2*s23 + 16*s13**2*s24 - 144*s13*s14*s23 + 32*s13*s14*
     +    s24 - 96*s13*s23**2 - 64*s13*s23*s24 - 56*s13*s23*s34 - 16*
     +    s13*s24**2 + 64*s13*s24*s34 - 32*s14**2*s23 - 48*s14*s23**2
     +     - 32*s14*s23*s24 - 16*s14*s23*s34 - 24*s14*s24*s34 + 16*s23*
     +    s34**2 + 16*s24**2*s34 )

      uc14 = uc14 + Lc1(p3,p14)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 32*s12**2*s34**2 + 64*s12*s23*s34**2 - 32*s12*
     +    s34**3 + 32*s23**2*s34**2 - 32*s23*s34**3 )

      uc14 = uc14 + Lc1(p3,p14)*S23**(-1)*S34**(-1)*S123**(-1) * ( 32*
     +    s12*s34**2 - 16*s14*s34**2 + 32*s23*s34**2 + 16*s34**3 )

      uc14 = uc14 + Lc1(p3,p14)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s14**2*s23**2 )

      uc14 = uc14 + Lc1(p3,p14)*S23**(-1)*S34**(-1)*S234**(-1) * ( 16*
     +    s12*s23*s34 + 32*s12*s34**2 - 32*s14*s23*s34 - 48*s14*s34**2
     +     + 16*s23**2*s34 + 16*s23*s34**2 + 16*s34**3 )

      uc14 = uc14 + Lc1(p3,p14)*S23**(-1)*S34**(-1)*S134**(-1) * (  - 
     +    32*s12*s34**2 - 32*s23*s34**2 )

      uc14 = uc14 + Lc1(p3,p14)*S23**(-1)*S34**(-1) * (  - 16*s23*s34 )

      uc14 = uc14 + Lc1(p4,p23)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16*
     +    s23*s34**2 )

      uc14 = uc14 + Lc1(p4,p23)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    16*s12*s34**2 - 16*s13*s34**2 - 32*s14*s34**2 )

      uc14 = uc14 + Lc1(p4,p23)*S23**(-1)*S34**(-1) * (  - 48*s34**2 )

      uc14 = uc14 + Lc1(p14,p23)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    32*s12*s13*s34 + 32*s12*s23*s34 + 32*s13*s23*s34 )

      uc14 = uc14 + Lc1(p14,p23)*S23**(-1)*S34**(-1)*S234**(-1) * ( 16*
     +    s12**2*s34 - 32*s12*s13*s34 + 16*s12*s23*s34 + 16*s12*s24*s34
     +     - 16*s12*s34**2 - 16*s13**2*s34 + 16*s13*s23*s34 + 16*s13*
     +    s24*s34 - 16*s13*s34**2 + 16*s23*s24*s34 + 16*s23*s34**2 )

      uc14 = uc14 + Lc1(p23,p14)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    16*s12**2*s34 - 16*s12*s13*s34 + 16*s12*s14*s34 - 16*s12*s24*
     +    s34 - 16*s13**2*s34 - 16*s13*s14*s34 - 16*s13*s24*s34 - 16*
     +    s14*s23*s34 )

      uc14 = uc14 + Lc1(p23,p14)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 
     +    16*s12*s24*s34 - 16*s12*s34**2 - 16*s13**2*s34 - 16*s14*s23*
     +    s34 - 16*s14*s24*s34 + 16*s14*s34**2 - 16*s24**2*s34 - 16*s24
     +    *s34**2 )

      uc14 = uc14 + Lc2(p1,p34)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16*
     +    s12**3 + 48*s12**2*s23 - 16*s12**2*s34 - 32*s12*s13**2 - 16*
     +    s12*s13*s34 + 48*s12*s23**2 - 32*s12*s23*s34 - 32*s13**2*s23
     +     - 8*s13**2*s34 - 16*s13*s23*s34 + 16*s23**3 - 16*s23**2*s34
     +     )

      uc14 = uc14 + Lc2(p1,p34)*S23**(-1)*S34**(-1)*S234**(-1) * (  - 8
     +    *s12**2*s34 - 16*s12*s13*s23 - 8*s13**2*s34 )

      uc14 = uc14 + Lc2(p1,p34)*S23**(-1)*S34**(-1) * (  - 16*s12**2 + 
     +    24*s12*s13 - 32*s12*s23 + 16*s12*s34 + 8*s13**2 + 16*s13*s23
     +     - 16*s23**2 + 16*s23*s34 )

      uc14 = uc14 + Lc2(p1,p234)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 32*s13**2*s23**2 - 80*s13**2*s23*s24 - 24*
     +    s13**2*s23*s34 - 48*s13**2*s24**2 - 40*s13**2*s24*s34 + 8*
     +    s13**2*s34**2 )

      uc14 = uc14 + Lc2(p1,p234)*S23**(-1)*S34**(-1)*S234**(-1) * ( 16*
     +    s13**2*s23 + 16*s13**2*s24 )

      uc14 = uc14 + Lc2(p2,p34)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 8*s12**2*s23*s34 + 8*s12**2*s34**2 - 8*s12*s14
     +    *s23*s34 - 8*s12*s23**2*s34 + 16*s12*s23*s34**2 - 16*s14*
     +    s23**2*s34 + 8*s23**2*s34**2 )

      uc14 = uc14 + Lc2(p2,p34)*S23**(-1)*S34**(-1)*S234**(-1) * ( 16*
     +    s12*s23**2 + 16*s12*s23*s34 + 8*s13*s23**2 + 8*s14*s23**2 + 
     +    16*s23**2*s34 )

      uc14 = uc14 + Lc2(p2,p134)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 16*s13**2*s23**2 + 16*s13*s14*s23**2 - 16*s13*
     +    s23**2*s24 - 16*s13*s24**2*s34 - 16*s14*s23**2*s24 + 16*
     +    s24**3*s34 )

      uc14 = uc14 + Lc2(p2,p134)*S23**(-1)*S34**(-1)*S123**(-1) * (  - 
     +    16*s13*s23**2 - 8*s13*s23*s24 + 8*s13*s24**2 - 40*s14*s23**2
     +     - 8*s14*s23*s24 - 8*s24**2*s34 )

      uc14 = uc14 + Lcd0(p1,p34,p2)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 16*s12**2*s34**2 + 32*s12*s13*s23*s34 + 32*s12*s13*s24*s34
     +     + 48*s12*s13*s34**2 + 32*s12*s14*s23*s34 - 32*s12*s14*s34**2
     +     + 32*s12*s23*s34**2 - 8*s12*s34**3 - 32*s13**2*s23**2 - 32*
     +    s13**2*s23*s24 + 32*s13**2*s23*s34 - 16*s13**2*s24**2 - 64*
     +    s13**2*s24*s34 - 32*s13*s14*s23**2 + 128*s13*s14*s23*s34 + 48
     +    *s13*s23**2*s34 + 16*s13*s23*s24*s34 + 224*s13*s23*s34**2 - 
     +    48*s13*s24**2*s34 + 72*s13*s24*s34**2 - 16*s14**2*s23**2 + 64
     +    *s14**2*s23*s34 + 16*s14*s23**2*s34 + 56*s14*s23*s34**2 )

      uc14 = uc14 + Lcd0(p1,p34,p2)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +    16*s12*s24*s34**2 + 16*s12*s34**3 - 16*s13*s23**2*s34 - 80*
     +    s13*s23*s24*s34 - 64*s13*s23*s34**2 - 48*s13*s24**2*s34 - 48*
     +    s13*s24*s34**2 + 16*s14*s23**2*s34 - 48*s14*s23*s34**2 )

      uc14 = uc14 + Lcd1(p1,p34,p2)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +    96*s13**2*s23**2 + 80*s13**2*s23*s24 + 144*s13*s14*s23**2 + 
     +    96*s13*s14*s23*s24 + 96*s13*s23**3 + 160*s13*s23**2*s24 + 120
     +    *s13*s23**2*s34 + 80*s13*s23*s24**2 + 96*s13*s23*s24*s34 + 32
     +    *s14**2*s23**2 + 48*s14*s23**3 + 80*s14*s23**2*s24 + 88*s14*
     +    s23**2*s34 + 48*s14*s23*s24**2 + 48*s14*s23*s24*s34 )

      uc14 = uc14 + Lcd1(p1,p34,p2)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 64*s13*s23**2*s34 - 32*s13*s23*s24*s34 + 16*s14*s23**3 + 
     +    32*s14*s23**2*s24 - 48*s14*s23**2*s34 + 16*s14*s23*s24**2 - 
     +    16*s14*s23*s24*s34 )

      uc14 = uc14 + Lcd1(p2,p34,p1)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 16*s13**3*s24 + 16*s13**2*s14*s23 - 32*s13**2*s23*s24 + 
     +    152*s13**2*s23*s34 - 48*s13**2*s24**2 + 120*s13**2*s24*s34 - 
     +    16*s13*s14*s23**2 - 48*s13*s14*s23*s24 + 112*s13*s14*s23*s34
     +     - 48*s13*s14*s24**2 + 48*s13*s14*s24*s34 )

      uc14 = uc14 + Lcd1(p2,p34,p1)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 32*s13**2*s23**2 - 64*s13**2*s23*s24 - 32*s13**2*s23*s34
     +     - 32*s13**2*s24**2 - 48*s13**2*s24*s34 - 16*s13*s14*s23**2
     +     - 32*s13*s14*s23*s24 - 16*s13*s14*s24**2 - 16*s13*s14*s24*
     +    s34 )

      uc14 = uc14 + Lcd2(p1,p34,p2)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +    16*s13*s23**3 + 24*s13*s23**2*s24 + 40*s14*s23**3 + 48*s14*
     +    s23**2*s24 )

      uc14 = uc14 + Lcd2(p1,p34,p2)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 16*s13*s23**3 - 16*s13*s23**2*s24 - 16*s14*s23**3 - 16*s14
     +    *s23**2*s24 )

      uc14 = uc14 + Lcd2(p2,p34,p1)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +    32*s13**3*s23 + 56*s13**3*s24 + 24*s13**2*s14*s23 + 48*s13**2
     +    *s14*s24 )

      uc14 = uc14 + Lcd2(p2,p34,p1)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 16*s13**3*s23 - 16*s13**3*s24 - 16*s13**2*s14*s23 - 16*
     +    s13**2*s14*s24 )

      uc14 = uc14 + Ld0(p1,p4,p3)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 64*s12*s13*s14 + 64*s12*s13*s34 + 64*s12*s14*s34
     +     + 32*s12*s34**2 + 64*s13*s14*s23 + 64*s13*s23*s34 + 64*s14*
     +    s23*s34 + 32*s23*s34**2 )

      uc14 = uc14 + Ld0(p1,p4,p3)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 16*s12*s13 - 32*s12*s14 - 32*s12*s34 + 16*s13*s14 - 16*s13
     +    *s23 - 32*s14*s23 - 32*s23*s34 )

      uc14 = uc14 + Ld0(p1,p4,p3)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s34 + 32*s12*s13*s24 + 32*s12*s14*
     +    s23 - 32*s12*s14*s34 - 32*s12*s23*s34 + 32*s12*s24*s34 - 32*
     +    s12*s34**2 - 32*s13*s14*s24 - 16*s13*s23*s24 - 32*s13*s24*s34
     +     + 32*s14**2*s23 + 32*s14*s23**2 + 16*s14*s23*s24 + 32*s14*
     +    s23*s34 - 32*s14*s24*s34 - 16*s24*s34**2 )

      uc14 = uc14 + Ld0(p1,p4,p3)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 32*s12*s23 - 16*s12*s24 - 16*s12*s34 - 32*s13*s23 + 32*s13
     +    *s24 - 32*s14*s23 + 16*s14*s24 - 16*s14*s34 - 16*s23*s34 + 32
     +    *s24*s34 )

      uc14 = uc14 + Ld0(p1,p4,p23)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 32*s12**2*s34 + 32*s12*s13*s23 + 32*s12*s13*s34
     +     - 32*s12*s14*s23 + 32*s12*s14*s34 - 32*s12*s24*s34 - 32*s13*
     +    s14*s23 - 32*s13*s14*s34 + 32*s13*s23**2 + 32*s13*s23*s34 - 
     +    32*s13*s24*s34 - 32*s14**2*s23 - 32*s14*s23**2 - 32*s14*s23*
     +    s34 )

      uc14 = uc14 + Ld0(p1,p4,p23)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 16*s12*s13 + 32*s12*s14 + 16*s13*s14 - 16*s13*s23 + 32*s14
     +    *s23 )

      uc14 = uc14 + Ld0(p1,p4,p23)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +    16*s12*s24 - 16*s12*s34 + 32*s13*s23 + 32*s13*s24 - 16*s14*
     +    s24 - 16*s14*s34 - 32*s23**2 - 16*s23*s24 - 16*s23*s34 )

      uc14 = uc14 + Ld0(p1,p4,p23)*S23**(-1)*S34**(-1)*S234**(-2) * ( 
     +    32*s12*s23**2 - 32*s12*s23*s24 + 64*s12*s23*s34 - 32*s12*s24*
     +    s34 + 32*s12*s34**2 - 64*s13*s23*s24 - 64*s13*s24*s34 + 32*
     +    s14*s23**2 - 32*s14*s23*s24 + 64*s14*s23*s34 - 32*s14*s24*s34
     +     + 32*s14*s34**2 + 32*s23**3 + 32*s23**2*s24 + 64*s23**2*s34
     +     + 32*s23*s34**2 - 32*s24**2*s34 - 32*s24*s34**2 )

      uc14 = uc14 + Ld0(p2,p3,p4)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 32*s12**2*s34 - 32*s12*s13*s24 - 32*s12*s13*s34
     +     - 32*s12*s14*s23 + 16*s12*s14*s34 + 32*s12*s23*s34 + 16*s12*
     +    s34**2 - 16*s13*s14*s23 + 16*s13*s14*s24 - 32*s13*s23*s24 - 
     +    16*s13*s23*s34 - 16*s13*s24*s34 - 16*s14**2*s23 - 32*s14*
     +    s23**2 - 16*s14*s23*s34 )

      uc14 = uc14 + Ld0(p2,p3,p4)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16
     +    *s12*s13 + 32*s12*s14 + 16*s13*s23 + 32*s14*s23 )

      uc14 = uc14 + Ld0(p2,p3,p4)*S23**(-1)*S34**(-1)*S234**(-1) * ( 32
     +    *s12*s23 + 16*s12*s24 - 16*s12*s34 + 32*s13*s23 + 32*s13*s24
     +     + 16*s13*s34 + 32*s14*s23 - 16*s14*s24 - 16*s14*s34 - 16*s23
     +    *s24 - 16*s23*s34 )

      uc14 = uc14 + Ld0(p2,p3,p4)*S23**(-1)*S34**(-1)*S234**(-2) * ( 
     +     - 64*s12*s23*s24 - 32*s12*s23*s34 - 32*s12*s24*s34 - 64*s13*
     +    s23*s24 - 32*s13*s23*s34 - 32*s13*s24*s34 - 64*s14*s23*s24 - 
     +    32*s14*s23*s34 - 32*s14*s24*s34 )

      uc14 = uc14 + Ld0(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 32*s12*s13*s14 + 64*s12*s13*s34 - 32*s12*s14**2
     +     - 32*s12*s14*s34 - 32*s13*s14**2 + 32*s13*s14*s23 + 64*s13*
     +    s23*s34 - 32*s14**3 - 32*s14**2*s23 - 32*s14**2*s34 - 32*s14*
     +    s23*s34 )

      uc14 = uc14 + Ld0(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 16*s12*s13 + 16*s13*s14 - 16*s13*s23 + 32*s14**2 )

      uc14 = uc14 + Ld0(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s34 + 64*s12*s13*s34 + 32*s12*s14*
     +    s23 - 32*s12*s14*s24 + 32*s12*s14*s34 - 32*s12*s23*s34 - 32*
     +    s12*s24*s34 + 32*s12*s34**2 - 32*s13**2*s34 - 64*s13*s14*s24
     +     + 32*s13*s23*s34 - 32*s13*s24*s34 - 32*s13*s34**2 + 32*
     +    s14**2*s23 - 32*s14**2*s24 + 32*s14**2*s34 + 32*s14*s23**2 + 
     +    32*s14*s23*s24 + 64*s14*s23*s34 - 32*s14*s24*s34 + 32*s14*
     +    s34**2 + 32*s23*s24*s34 + 32*s23*s34**2 )

      uc14 = uc14 + Ld0(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 32*s12*s23 + 16*s12*s24 - 16*s12*s34 - 32*s13*s23 + 32*s13
     +    *s24 - 32*s14*s23 + 48*s14*s24 - 16*s14*s34 - 16*s23*s24 - 16
     +    *s23*s34 )

      uc14 = uc14 + Ld1(p1,p4,p3)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s34**2 + 32*s12*s14*s23*s34 - 32*s12
     +    *s14*s34**2 - 16*s12*s23*s34**2 + 16*s12*s24*s34**2 - 16*s12*
     +    s34**3 + 32*s14**2*s23*s34 + 16*s14*s23**2*s34 + 16*s14*s23*
     +    s24*s34 + 16*s14*s23*s34**2 )

      uc14 = uc14 + Ld1(p1,p4,p23)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 16*s12**2*s23*s34 + 16*s12**2*s24*s34 - 16*s12
     +    *s13*s23*s34 + 32*s12*s13*s24*s34 - 16*s12*s14*s23*s34 + 16*
     +    s13**2*s24*s34 - 16*s13*s14*s23*s34 )

      uc14 = uc14 + Ld1(p1,p4,p23)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +    16*s12**2*s34 + 16*s12*s13*s34 )

      uc14 = uc14 + Ld1(p1,p4,p23)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +    16*s12*s23*s34 + 16*s12*s24*s34 + 16*s12*s34**2 )

      uc14 = uc14 + Ld1(p1,p4,p23)*S23**(-1)*S34**(-1)*S234**(-2) * ( 
     +     - 16*s12*s23**2*s34 - 16*s12*s23*s34**2 + 16*s12*s24**2*s34
     +     + 16*s12*s24*s34**2 + 16*s13*s23*s24*s34 + 16*s13*s24**2*s34
     +     + 16*s13*s24*s34**2 - 16*s14*s23**2*s34 - 16*s14*s23*s24*s34
     +     - 16*s14*s23*s34**2 )

      uc14 = uc14 + Ld1(p2,p3,p4)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 32*s12**2*s34**2 - 16*s12*s13*s34**2 - 48*s12*s14
     +    *s23*s34 + 16*s12*s23*s34**2 - 16*s13*s14*s23*s34 + 16*s14**2
     +    *s23**2 - 16*s14*s23**2*s34 )

      uc14 = uc14 + Ld1(p2,p3,p4)*S23**(-1)*S34**(-1)*S123**(-1) * ( 16
     +    *s12*s14*s34 - 16*s14**2*s23 )

      uc14 = uc14 + Ld1(p2,p3,p4)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 16*s12*s34**2 + 16*s14*s23*s34 )

      uc14 = uc14 + Ld1(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * (  - 16*s12**2*s13*s34 + 16*s12**2*s14*s34 + 48*s12
     +    *s13**2*s34 + 32*s12*s13*s14*s34 - 16*s12*s13*s23*s34 - 16*
     +    s12*s13*s24*s34 + 32*s12*s13*s34**2 + 48*s12*s14**2*s34 + 32*
     +    s12*s14*s23*s34 + 32*s12*s14*s34**2 + 16*s13**2*s24*s34 - 16*
     +    s13*s14*s23*s34 - 16*s13*s14*s24*s34 - 16*s13*s23*s24*s34 + 
     +    16*s14**2*s23*s34 + 16*s14*s23**2*s34 )

      uc14 = uc14 + Ld1(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1) * ( 
     +     - 16*s12**2*s34 + 16*s12*s13*s34 - 48*s12*s14*s34 - 16*s12*
     +    s23*s34 )

      uc14 = uc14 + Ld1(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 32*s12**2*s13*s34 + 32*s12**2*s14*s34 + 64*s12
     +    *s13**2*s34 + 32*s12*s13*s14*s34 - 16*s12*s13*s23*s34 - 48*
     +    s12*s13*s24*s34 + 48*s12*s13*s34**2 + 32*s12*s14**2*s34 + 48*
     +    s12*s14*s23*s34 + 16*s12*s14*s24*s34 + 16*s12*s14*s34**2 + 32
     +    *s13**2*s24*s34 - 32*s13*s14*s23*s34 - 16*s13*s23*s24*s34 - 
     +    16*s13*s24**2*s34 + 16*s13*s24*s34**2 + 16*s14*s23**2*s34 + 
     +    16*s14*s23*s24*s34 - 16*s14*s23*s34**2 )

      uc14 = uc14 + Ld1(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1) * ( 
     +     - 32*s12**2*s34 + 32*s12*s13*s34 - 32*s12*s14*s34 - 16*s12*
     +    s23*s34 - 16*s12*s24*s34 + 16*s12*s34**2 )

      uc14 = uc14 + Ld21(p1,p4,p3)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s12**2*s34**2 - 32*s12*s14*s23*s34 + 16*s14**2
     +    *s23**2 )

      uc14 = uc14 + Ld21(p2,p3,p4)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * (  - 16*s12**2*s34**2 )

      uc14 = uc14 + Ld21(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 16*s13**2*s23*s34 + 32*s13*s14*s23*s34 + 16*
     +    s14**2*s23*s34 )

      uc14 = uc14 + Ld21(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 16*s13**2*s23*s34 + 32*s13*s14*s23*s34 + 16*
     +    s14**2*s23*s34 )

      uc14 = uc14 + Ld21(p4,p3,p2)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S234**(-1) * ( 32*s12*s14*s34**2 - 16*s14**2*s23*s34 )

      uc14 = uc14 + Ld22(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * (  - 16*s12*s13**2*s34 + 16*s13**2*s23*s34 - 16*
     +    s13**2*s24*s34 + 32*s13*s14*s23*s34 )

      uc14 = uc14 + Ld22(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * (  - 16*s12*s13**2*s34 + 16*s13**2*s23*s34 - 16*
     +    s13**2*s24*s34 + 32*s13*s14*s23*s34 )

      uc14 = uc14 + Ld24(p2,p3,p14)*S23**(-1)*S34**(-1)*S123**(-1)*
     + S134**(-1) * ( 48*s12**2*s13*s34 + 16*s12**2*s34**2 + 32*s12*s13
     +    *s24*s34 - 32*s12*s14*s23*s34 )

      uc14 = uc14 + Ld24(p2,p3,p14)*S23**(-1)*S34**(-1)*S234**(-1)*
     + S134**(-1) * ( 48*s12**2*s13*s34 + 16*s12**2*s34**2 + 32*s12*s13
     +    *s24*s34 - 32*s12*s14*s23*s34 )

      uc14 = uc14 + Le1(p1,p4,p3,p2)*S23**(-1)*S34**(-1)*S123**(-1)
     +  * (  - 16*s12**2*s14*s34 + 16*s12*s13**2*s23 + 16*s12*s14**2*
     +    s23 + 32*s12*s14**2*s24 + 16*s12*s14**2*s34 - 16*s12*s14*s23*
     +    s34 - 16*s13**2*s14*s23 + 16*s13**2*s23**2 - 32*s13*s14**2*
     +    s23 - 16*s14**3*s23 + 16*s14**2*s23**2 + 32*s14**2*s23*s24 )

      uc14 = uc14 + Le1(p1,p4,p3,p2)*S23**(-1)*S34**(-1)*S234**(-1)
     +  * (  - 16*s12**2*s23*s34 + 32*s12*s13*s23**2 - 16*s12*s13*s23*
     +    s34 + 16*s12*s14*s23**2 - 16*s12*s14*s23*s34 + 16*s12*s14*
     +    s24**2 + 16*s12*s14*s24*s34 + 16*s12*s23**2*s34 + 32*s13**2*
     +    s23**2 + 64*s13*s14*s23**2 + 16*s13*s14*s23*s34 + 16*s13*
     +    s23**2*s34 + 16*s14**2*s23**2 - 32*s14**2*s23*s24 - 16*s14**2
     +    *s24**2 - 16*s14**2*s24*s34 - 16*s14*s23**3 - 32*s14*s23**2*
     +    s24 - 16*s14*s23*s24**2 - 16*s14*s23*s24*s34 )

      return
      end
      
      
